/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var pe=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/network","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/types","vs/base/common/async","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/node/pfs","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWorkspace","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","child_process","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/range","vs/platform/files/common/files","vs/base/common/stopwatch","vs/editor/common/core/position","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/base/common/assert","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/json","vs/base/common/severity","vs/base/common/marshalling","fs","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostSearch","vs/base/common/collections","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/hash","vs/base/common/normalization","vs/base/common/labels","vs/editor/common/modes/languageSelector","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/codicons","vs/base/common/stream","vs/base/common/uint","vs/base/common/filters","vs/base/common/htmlContent","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/mime","vs/base/common/uriIpc","string_decoder","os","vs/base/node/extpath","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/log/node/spdlogLog","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/processes","vs/base/common/iconLabels","vs/base/node/decoder","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/tunnel","vs/platform/sign/node/signService","vs/platform/terminal/common/terminalDataBuffering","vs/platform/workspaces/common/workspaces","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostOutputService","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/textfile/common/encoding","vs/workbench/services/extensions/node/proxyResolver","http","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","vs/workbench/services/search/node/fileSearch","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","vs/workbench/services/extensions/node/extensionHostProcessSetup","util","vs/base/common/marked/marked","https","tls","vscode-proxy-agent","events","vscode-regexpp","graceful-fs","crypto","zlib","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],ve=function(X){for(var e=[],p=0,R=X.length;p<R;p++)e[p]=pe[X[p]];return e};define(pe[50],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(R,C){if(!R)throw new Error(C?`Assertion failed (${C})`:"Assertion Failed")}e.ok=p}),define(pe[68],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function R(r){const k=[];for(let l in r)p.call(r,l)&&k.push(r[l]);return k}e.values=R;function C(r,k){for(let l in r)if(p.call(r,l)&&k({key:l,value:r[l]},function(){delete r[l]})===!1)return}e.forEach=C;function S(r,k){const l=Object.create(null);for(const h of r){const c=k(h);let f=l[c];f||(f=l[c]=[]),f.push(h)}return l}e.groupBy=S;function A(r){const k=Object.create(null);return r&&r.forEach((l,h)=>{k[h]=l}),k}e.fromMap=A;function P(r,k){const l=[],h=[];for(let c of r)k.has(c)||l.push(c);for(let c of k)r.has(c)||h.push(c);return{removed:l,added:h}}e.diffSets=P;function _(r,k){const l=[],h=[];for(let[c,f]of r)k.has(c)||l.push(f);for(let[c,f]of k)r.has(c)||h.push(f);return{removed:l,added:h}}e.diffMaps=_;class D{constructor(){this.map=new Map}add(k,l){let h=this.map.get(k);h||(h=new Set,this.map.set(k,h)),h.add(l)}delete(k,l){const h=this.map.get(k);!h||(h.delete(l),h.size===0&&this.map.delete(k))}forEach(k,l){const h=this.map.get(k);!h||h.forEach(l)}}e.SetMap=D}),define(pe[51],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(A){return(P,_,D)=>{let r=null,k=null;if(typeof D.value=="function"?(r="value",k=D.value):typeof D.get=="function"&&(r="get",k=D.get),!k)throw new Error("not supported");D[r]=A(k,_)}}e.createDecorator=p;function R(A,P,_){let D=null,r=null;if(typeof _.value=="function"?(D="value",r=_.value,r.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(D="get",r=_.get),!r)throw new Error("not supported");const k=`$memoize$${P}`;_[D]=function(...l){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:r.apply(this,l)}),this[k]}}e.memoize=R;function C(A,P,_){return p((D,r)=>{const k=`$debounce$${r}`,l=`$debounce$result$${r}`;return function(...h){this[l]||(this[l]=_?_():void 0),clearTimeout(this[k]),P&&(this[l]=P(this[l],...h),h=[this[l]]),this[k]=setTimeout(()=>{D.apply(this,h),this[l]=_?_():void 0},A)}})}e.debounce=C;function S(A,P,_){return p((D,r)=>{const k=`$throttle$timer$${r}`,l=`$throttle$result$${r}`,h=`$throttle$lastRun$${r}`,c=`$throttle$pending$${r}`;return function(...f){if(this[l]||(this[l]=_?_():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),P&&(this[l]=P(this[l],...f)),this[c])return;const I=this[h]+A;I<=Date.now()?(this[h]=Date.now(),D.apply(this,[this[l]]),this[l]=_?_():void 0):(this[c]=!0,this[k]=setTimeout(()=>{this[c]=!1,this[h]=Date.now(),D.apply(this,[this[l]]),this[l]=_?_():void 0},I-Date.now()))}})}e.throttle=S}),define(pe[14],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function R(g){e.errorHandler.setUnexpectedErrorHandler(g)}e.setUnexpectedErrorHandler=R;function C(g){_(g)||e.errorHandler.onUnexpectedError(g)}e.onUnexpectedError=C;function S(g){_(g)||e.errorHandler.onUnexpectedExternalError(g)}e.onUnexpectedExternalError=S;function A(g){if(g instanceof Error){let{name:t,message:i}=g;const s=g.stacktrace||g.stack;return{$isError:!0,name:t,message:i,stack:s}}return g}e.transformErrorForSerialization=A;const P="Canceled";function _(g){return g instanceof Error&&g.name===P&&g.message===P}e.isPromiseCanceledError=_;class D extends Error{constructor(){super(P);this.name=this.message}}e.CancellationError=D;function r(){const g=new Error(P);return g.name=g.message,g}e.canceled=r;function k(g){return g?new Error(`Illegal argument: ${g}`):new Error("Illegal argument")}e.illegalArgument=k;function l(g){return g?new Error(`Illegal state: ${g}`):new Error("Illegal state")}e.illegalState=l;function h(g){return g?new Error(`readonly property '${g} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function c(g){const t=new Error(`${g} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function f(g){return g?g.message?g.message:g.stack?g.stack.split(`
`)[0]:String(g):"Error"}e.getErrorMessage=f;class I extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=I;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class w extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=w;function u(g){const t=g;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=u;function d(g,t=Object.create(null)){const i=new Error(g);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=d}),define(pe[18],ve([0,1,14]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function R(z,F=0){return z[z.length-(1+F)]}e.tail=R;function C(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=C;function S(z,F,M=(L,U)=>L===U){if(z===F)return!0;if(!z||!F||z.length!==F.length)return!1;for(let L=0,U=z.length;L<U;L++)if(!M(z[L],F[L]))return!1;return!0}e.equals=S;function A(z,F,M){let L=0,U=z.length-1;for(;L<=U;){const G=(L+U)/2|0,te=M(z[G],F);if(te<0)L=G+1;else if(te>0)U=G-1;else return G}return-(L+1)}e.binarySearch=A;function P(z,F){let M=0,L=z.length;if(L===0)return 0;for(;M<L;){const U=Math.floor((M+L)/2);F(z[U])?L=U:M=U+1}return M}e.findFirstInSorted=P;function _(z,F,M){if(z=z|0,z>=F.length)throw new TypeError("invalid index");let L=F[Math.floor(F.length*Math.random())],U=[],G=[],te=[];for(let me of F){const Se=M(me,L);Se<0?U.push(me):Se>0?G.push(me):te.push(me)}return z<U.length?_(z,U,M):z<U.length+te.length?te[0]:_(z-(U.length+te.length),G,M)}e.quickSelect=_;function D(z,F){const M=[];let L;for(const U of z.slice(0).sort(F))!L||F(L[0],U)!==0?(L=[U],M.push(L)):L.push(U);return M}e.groupBy=D;function r(z,F,M){const L=[];function U(me,Se,ye){if(Se===0&&ye.length===0)return;const Le=L[L.length-1];Le&&Le.start+Le.deleteCount===me?(Le.deleteCount+=Se,Le.toInsert.push(...ye)):L.push({start:me,deleteCount:Se,toInsert:ye})}let G=0,te=0;for(;;){if(G===z.length){U(G,0,F.slice(te));break}if(te===F.length){U(G,z.length-G,[]);break}const me=z[G],Se=F[te],ye=M(me,Se);ye===0?(G+=1,te+=1):ye<0?(U(G,1,[]),G+=1):ye>0&&(U(G,0,[Se]),te+=1)}return L}e.sortedDiff=r;function k(z,F,M){const L=r(z,F,M),U=[],G=[];for(const te of L)U.push(...z.slice(te.start,te.start+te.deleteCount)),G.push(...te.toInsert);return{removed:U,added:G}}e.delta=k;function l(z,F,M){if(M===0)return[];const L=z.slice(0,M).sort(F);return c(z,F,L,M,z.length),L}e.top=l;function h(z,F,M,L,U){return M===0?Promise.resolve([]):new Promise((G,te)=>{(async()=>{const me=z.length,Se=z.slice(0,M).sort(F);for(let ye=M,Le=Math.min(M+L,me);ye<me;ye=Le,Le=Math.min(Le+L,me)){if(ye>M&&await new Promise(je=>setTimeout(je)),U&&U.isCancellationRequested)throw p.canceled();c(z,F,Se,ye,Le)}return Se})().then(G,te)})}e.topAsync=h;function c(z,F,M,L,U){for(const G=M.length;L<U;L++){const te=z[L];if(F(te,M[G-1])<0){M.pop();const me=P(M,Se=>F(te,Se)<0);M.splice(me,0,te)}}}function f(z){return z.filter(F=>!!F)}e.coalesce=f;function I(z){let F=0;for(let M=0;M<z.length;M++)z[M]&&(z[F]=z[M],F+=1);z.length=F}e.coalesceInPlace=I;function b(z,F,M){z.splice(M,0,z.splice(F,1)[0])}e.move=b;function w(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=w;function u(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=u;function d(z,F){if(!F)return z.filter((L,U)=>z.indexOf(L)===U);const M=Object.create(null);return z.filter(L=>{const U=F(L);return M[U]?!1:(M[U]=!0,!0)})}e.distinct=d;function g(z){const F=new Set;return z.filter(M=>F.has(M)?!1:(F.add(M),!0))}e.distinctES6=g;function t(z){const F=Object.create(null);return M=>{const L=z(M);return F[L]?!1:(F[L]=!0,!0)}}e.uniqueFilter=t;function i(z,F){for(let M=z.length-1;M>=0;M--){const L=z[M];if(F(L))return M}return-1}e.lastIndex=i;function s(z,F){return z.length>0?z[0]:F}e.firstOrDefault=s;function n(z,F,M=(L,U)=>L===U){let L=0;for(let U=0,G=Math.min(z.length,F.length);U<G&&M(z[U],F[U]);U++)L++;return L}e.commonPrefixLength=n;function o(z){return[].concat(...z)}e.flatten=o;function v(z,F){let M=typeof F=="number"?z:0;typeof F=="number"?M=z:(M=0,F=z);const L=[];if(M<=F)for(let U=M;U<F;U++)L.push(U);else for(let U=M;U>F;U--)L.push(U);return L}e.range=v;function m(z,F,M){return z.reduce((L,U)=>(L[F(U)]=M?M(U):U,L),Object.create(null))}e.index=m;function E(z,F){return z.push(F),()=>y(z,F)}e.insert=E;function y(z,F){const M=z.indexOf(F);if(M>-1)return z.splice(M,1),F}e.remove=y;function a(z,F,M){const L=z.slice(0,F),U=z.slice(F);return L.concat(M,U)}e.arrayInsert=a;function T(z,F){let M;if(typeof F=="number"){let L=F;M=()=>{const U=Math.sin(L++)*179426549;return U-Math.floor(U)}}else M=Math.random;for(let L=z.length-1;L>0;L-=1){const U=Math.floor(M()*(L+1)),G=z[L];z[L]=z[U],z[U]=G}}e.shuffle=T;function O(z,F){const M=z.indexOf(F);M>-1&&(z.splice(M,1),z.unshift(F))}e.pushToStart=O;function $(z,F){const M=z.indexOf(F);M>-1&&(z.splice(M,1),z.push(F))}e.pushToEnd=$;function Z(z,F){return Array.isArray(z)?z.map(F):F(z)}e.mapArrayOrNot=Z;function le(z){return Array.isArray(z)?z:[z]}e.asArray=le;function q(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=q;function x(z,F){for(const M of z){const L=F(M);if(L!==void 0)return L}}e.mapFind=x;function H(z,F){let M=Number.MAX_SAFE_INTEGER,L=0;return z.forEach((U,G)=>{const te=F(U);te<M&&(M=te,L=G)}),L}e.minIndex=H;function N(z,F){let M=Number.MIN_SAFE_INTEGER,L=0;return z.forEach((U,G)=>{const te=F(U);te>M&&(M=te,L=G)}),L}e.maxIndex=N}),define(pe[69],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(R){const C=this;let S=!1,A;return function(){return S||(S=!0,A=R.apply(C,arguments)),A}}e.once=p}),define(pe[70],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class p{constructor(C){this._prefix=C,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=p,e.defaultGenerator=new p("id#")}),define(pe[52],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(R){function C(g){return g&&typeof g=="object"&&typeof g[Symbol.iterator]=="function"}R.is=C;const S=Object.freeze([]);function A(){return S}R.empty=A;function*P(g){yield g}R.single=P;function _(g){return g||S}R.from=_;function D(g){return!g||g[Symbol.iterator]().next().done===!0}R.isEmpty=D;function r(g){return g[Symbol.iterator]().next().value}R.first=r;function k(g,t){for(const i of g)if(t(i))return!0;return!1}R.some=k;function l(g,t){for(const i of g)if(t(i))return i}R.find=l;function*h(g,t){for(const i of g)t(i)&&(yield i)}R.filter=h;function*c(g,t){let i=0;for(const s of g)yield t(s,i++)}R.map=c;function*f(...g){for(const t of g)for(const i of t)yield i}R.concat=f;function*I(g){for(const t of g)for(const i of t)yield i}R.concatNested=I;function b(g,t,i){let s=i;for(const n of g)s=t(s,n);return s}R.reduce=b;function*w(g,t,i=g.length){for(t<0&&(t+=g.length),i<0?i+=g.length:i>g.length&&(i=g.length);t<i;t++)yield g[t]}R.slice=w;function u(g,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,g];const s=g[Symbol.iterator]();for(let n=0;n<t;n++){const o=s.next();if(o.done)return[i,R.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return s}}]}R.consume=u;function d(g,t,i=(s,n)=>s===n){const s=g[Symbol.iterator](),n=t[Symbol.iterator]();for(;;){const o=s.next(),v=n.next();if(o.done!==v.done)return!1;if(o.done)return!0;if(!i(o.value,v.value))return!1}}R.equals=d})(p=e.Iterable||(e.Iterable={}))}),define(pe[53],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R=e.SyntaxKind||(e.SyntaxKind={}));var C;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(C=e.ParseErrorCode||(e.ParseErrorCode={}));var S;(function(t){t.DEFAULT={allowTrailingComma:!0}})(S=e.ParseOptions||(e.ParseOptions={}));function A(t,i=!1){let s=0,n=t.length,o="",v=0,m=16,E=0;function y(q){let x=0,H=0;for(;x<q;){const N=t.charCodeAt(s);if(N>=48&&N<=57)H=H*16+N-48;else if(N>=65&&N<=70)H=H*16+N-65+10;else if(N>=97&&N<=102)H=H*16+N-97+10;else break;s++,x++}return x<q&&(H=-1),H}function a(q){s=q,o="",v=0,m=16,E=0}function T(){const q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&D(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&D(t.charCodeAt(s)))for(s++;s<t.length&&D(t.charCodeAt(s));)s++;else return E=3,t.substring(q,s);let x=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&D(t.charCodeAt(s))){for(s++;s<t.length&&D(t.charCodeAt(s));)s++;x=s}else E=3;return t.substring(q,x)}function O(){let q="",x=s;for(;;){if(s>=n){q+=t.substring(x,s),E=2;break}const H=t.charCodeAt(s);if(H===34){q+=t.substring(x,s),s++;break}if(H===92){if(q+=t.substring(x,s),s++,s>=n){E=2;break}switch(t.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:const z=y(4);z>=0?q+=String.fromCharCode(z):E=4;break;default:E=5}x=s;continue}if(H>=0&&H<=31)if(_(H)){q+=t.substring(x,s),E=2;break}else E=6;s++}return q}function $(){if(o="",E=0,v=s,s>=n)return v=n,m=17;let q=t.charCodeAt(s);if(P(q)){do s++,o+=String.fromCharCode(q),q=t.charCodeAt(s);while(P(q));return m=15}if(_(q))return s++,o+=String.fromCharCode(q),q===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),m=14;switch(q){case 123:return s++,m=1;case 125:return s++,m=2;case 91:return s++,m=3;case 93:return s++,m=4;case 58:return s++,m=6;case 44:return s++,m=5;case 34:return s++,o=O(),m=10;case 47:const x=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<n&&!_(t.charCodeAt(s));)s++;return o=t.substring(x,s),m=12}if(t.charCodeAt(s+1)===42){s+=2;const H=n-1;let N=!1;for(;s<H;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,N=!0;break}s++}return N||(s++,E=1),o=t.substring(x,s),m=13}return o+=String.fromCharCode(q),s++,m=16;case 45:if(o+=String.fromCharCode(q),s++,s===n||!D(t.charCodeAt(s)))return m=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),m=11;default:for(;s<n&&Z(q);)s++,q=t.charCodeAt(s);if(v!==s){switch(o=t.substring(v,s),o){case"true":return m=8;case"false":return m=9;case"null":return m=7}return m=16}return o+=String.fromCharCode(q),s++,m=16}}function Z(q){if(P(q)||_(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function le(){let q;do q=$();while(q>=12&&q<=15);return q}return{setPosition:a,getPosition:()=>s,scan:i?le:$,getToken:()=>m,getTokenValue:()=>o,getTokenOffset:()=>v,getTokenLength:()=>s-v,getTokenError:()=>E}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function D(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function k(t,i){const s=[],n=new Object;let o;const v={value:{},offset:0,length:0,type:"object",parent:void 0};let m=!1;function E(y,a,T,O){v.value=y,v.offset=a,v.length=T,v.type=O,v.colonOffset=void 0,o=v}try{u(t,{onObjectBegin:(y,a)=>{if(i<=y)throw n;o=void 0,m=i>y,s.push("")},onObjectProperty:(y,a,T)=>{if(i<a||(E(y,a,T,"property"),s[s.length-1]=y,i<=a+T))throw n},onObjectEnd:(y,a)=>{if(i<=y)throw n;o=void 0,s.pop()},onArrayBegin:(y,a)=>{if(i<=y)throw n;o=void 0,s.push(0)},onArrayEnd:(y,a)=>{if(i<=y)throw n;o=void 0,s.pop()},onLiteralValue:(y,a,T)=>{if(i<a||(E(y,a,T,g(y)),i<=a+T))throw n},onSeparator:(y,a,T)=>{if(i<=a)throw n;if(y===":"&&o&&o.type==="property")o.colonOffset=a,m=!1,o=void 0;else if(y===","){const O=s[s.length-1];typeof O=="number"?s[s.length-1]=O+1:(m=!0,s[s.length-1]=""),o=void 0}}})}catch(y){if(y!==n)throw y}return{path:s,previousNode:o,isAtPropertyKey:m,matches:y=>{let a=0;for(let T=0;a<y.length&&T<s.length;T++)if(y[a]===s[T]||y[a]==="*")a++;else if(y[a]!=="**")return!1;return a===y.length}}}e.getLocation=k;function l(t,i=[],s=S.DEFAULT){let n=null,o=[];const v=[];function m(y){Array.isArray(o)?o.push(y):n!==null&&(o[n]=y)}return u(t,{onObjectBegin:()=>{const y={};m(y),v.push(o),o=y,n=null},onObjectProperty:y=>{n=y},onObjectEnd:()=>{o=v.pop()},onArrayBegin:()=>{const y=[];m(y),v.push(o),o=y,n=null},onArrayEnd:()=>{o=v.pop()},onLiteralValue:m,onError:(y,a,T)=>{i.push({error:y,offset:a,length:T})}},s),o[0]}e.parse=l;function h(t,i=[],s=S.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(y){n.type==="property"&&(n.length=y-n.offset,n=n.parent)}function v(y){return n.children.push(y),y}u(t,{onObjectBegin:y=>{n=v({type:"object",offset:y,length:-1,parent:n,children:[]})},onObjectProperty:(y,a,T)=>{n=v({type:"property",offset:a,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:y,offset:a,length:T,parent:n})},onObjectEnd:(y,a)=>{n.length=y+a-n.offset,n=n.parent,o(y+a)},onArrayBegin:(y,a)=>{n=v({type:"array",offset:y,length:-1,parent:n,children:[]})},onArrayEnd:(y,a)=>{n.length=y+a-n.offset,n=n.parent,o(y+a)},onLiteralValue:(y,a,T)=>{v({type:g(y),offset:a,length:T,parent:n,value:y}),o(a+T)},onSeparator:(y,a,T)=>{n.type==="property"&&(y===":"?n.colonOffset=a:y===","&&o(a))},onError:(y,a,T)=>{i.push({error:y,offset:a,length:T})}},s);const E=n.children[0];return E&&delete E.parent,E}e.parseTree=h;function c(t,i){if(!t)return;let s=t;for(let n of i)if(typeof n=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const v of s.children)if(Array.isArray(v.children)&&v.children[0].value===n){s=v.children[1],o=!0;break}if(!o)return}else{const o=n;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}e.findNodeAtLocation=c;function f(t){if(!t.parent||!t.parent.children)return[];const i=f(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;i.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&i.push(s)}return i}e.getNodePath=f;function I(t){switch(t.type){case"array":return t.children.map(I);case"object":const i=Object.create(null);for(let s of t.children){const n=s.children[1];n&&(i[s.children[0].value]=I(n))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=I;function b(t,i,s=!1){return i>=t.offset&&i<t.offset+t.length||s&&i===t.offset+t.length}e.contains=b;function w(t,i,s=!1){if(b(t,i,s)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=i;o++){const v=w(n[o],i,s);if(v)return v}return t}}e.findNodeAtOffset=w;function u(t,i,s=S.DEFAULT){const n=A(t,!1);function o(te){return te?()=>te(n.getTokenOffset(),n.getTokenLength()):()=>!0}function v(te){return te?me=>te(me,n.getTokenOffset(),n.getTokenLength()):()=>!0}const m=o(i.onObjectBegin),E=v(i.onObjectProperty),y=o(i.onObjectEnd),a=o(i.onArrayBegin),T=o(i.onArrayEnd),O=v(i.onLiteralValue),$=v(i.onSeparator),Z=o(i.onComment),le=v(i.onError),q=s&&s.disallowComments,x=s&&s.allowTrailingComma;function H(){for(;;){const te=n.scan();switch(n.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:q||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(te){case 12:case 13:q?N(10):Z();break;case 16:N(1);break;case 15:case 14:break;default:return te}}}function N(te,me=[],Se=[]){if(le(te),me.length+Se.length>0){let ye=n.getToken();for(;ye!==17;){if(me.indexOf(ye)!==-1){H();break}else if(Se.indexOf(ye)!==-1)break;ye=H()}}}function z(te){const me=n.getTokenValue();return te?O(me):E(me),H(),!0}function F(){switch(n.getToken()){case 11:let te=0;try{te=JSON.parse(n.getTokenValue()),typeof te!="number"&&(N(2),te=0)}catch(me){N(2)}O(te);break;case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return H(),!0}function M(){return n.getToken()!==10?(N(3,[],[2,5]),!1):(z(!1),n.getToken()===6?($(":"),H(),G()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function L(){m(),H();let te=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(te||N(4,[],[]),$(","),H(),n.getToken()===2&&x)break}else te&&N(6,[],[]);M()||N(4,[],[2,5]),te=!0}return y(),n.getToken()!==2?N(7,[2],[]):H(),!0}function U(){a(),H();let te=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(te||N(4,[],[]),$(","),H(),n.getToken()===4&&x)break}else te&&N(6,[],[]);G()||N(4,[],[4,5]),te=!0}return T(),n.getToken()!==4?N(8,[4],[]):H(),!0}function G(){switch(n.getToken()){case 3:return U();case 1:return L();case 10:return z(!0);default:return F()}}return H(),n.getToken()===17?s.allowEmptyContent?!0:(N(4,[],[]),!1):G()?(n.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}e.visit=u;function d(t,i){let s=A(t),n=[],o,v=0,m;do switch(m=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:v!==m&&n.push(t.substring(v,m)),i!==void 0&&n.push(s.getTokenValue().replace(/[^\r\n]/g,i)),v=s.getPosition();break}while(o!==17);return n.join("")}e.stripComments=d;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(pe[132],ve([0,1,53]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function R(_,D,r){let k,l,h,c,f;if(D){for(c=D.offset,f=c+D.length,h=c;h>0&&!P(_,h-1);)h--;let v=f;for(;v<_.length&&!P(_,v);)v++;l=_.substring(h,v),k=S(l,r)}else l=_,k=0,h=0,c=0,f=_.length;const I=A(r,_);let b=!1,w=0,u;r.insertSpaces?u=C(" ",r.tabSize||4):u="	";const d=p.createScanner(l,!1);let g=!1;function t(){return I+C(u,k+w)}function i(){let v=d.scan();for(b=!1;v===15||v===14;)b=b||v===14,v=d.scan();return g=v===16||d.getTokenError()!==0,v}const s=[];function n(v,m,E){!g&&m<f&&E>c&&_.substring(m,E)!==v&&s.push({offset:m,length:E-m,content:v})}let o=i();if(o!==17){const v=d.getTokenOffset()+h,m=C(u,k);n(m,h,v)}for(;o!==17;){let v=d.getTokenOffset()+d.getTokenLength()+h,m=i(),E="";for(;!b&&(m===12||m===13);){const a=d.getTokenOffset()+h;n(" ",v,a),v=d.getTokenOffset()+d.getTokenLength()+h,E=m===12?t():"",m=i()}if(m===2)o!==1&&(w--,E=t());else if(m===4)o!==3&&(w--,E=t());else{switch(o){case 3:case 1:w++,E=t();break;case 5:case 12:E=t();break;case 13:b?E=t():E=" ";break;case 6:E=" ";break;case 10:if(m===6){E="";break}case 7:case 8:case 9:case 11:case 2:case 4:m===12||m===13?E=" ":m!==5&&m!==17&&(g=!0);break;case 16:g=!0;break}b&&(m===12||m===13)&&(E=t())}const y=d.getTokenOffset()+h;n(E,v,y),o=m}return s}e.format=R;function C(_,D){let r="";for(let k=0;k<D;k++)r+=_;return r}function S(_,D){let r=0,k=0;const l=D.tabSize||4;for(;r<_.length;){const h=_.charAt(r);if(h===" ")k++;else if(h==="	")k+=l;else break;r++}return Math.floor(k/l)}function A(_,D){for(let r=0;r<D.length;r++){const k=D.charAt(r);if(k==="\r")return r+1<D.length&&D.charAt(r+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return _&&_.eol||`
`}e.getEOL=A;function P(_,D){return`\r
`.indexOf(_.charAt(D))!==-1}e.isEOL=P}),define(pe[133],ve([0,1,53,132]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function C(D,r,k){return S(D,r,void 0,k)}e.removeProperty=C;function S(D,r,k,l,h){const c=r.slice(),f=[],I=p.parseTree(D,f);let b,w;for(;c.length>0&&(w=c.pop(),b=p.findNodeAtLocation(I,c),b===void 0&&k!==void 0);)typeof w=="string"?k={[w]:k}:k=[k];if(b)if(b.type==="object"&&typeof w=="string"&&Array.isArray(b.children)){const u=p.findNodeAtLocation(b,[w]);if(u!==void 0)if(k===void 0){if(!u.parent)throw new Error("Malformed AST");const d=b.children.indexOf(u.parent);let g,t=u.parent.offset+u.parent.length;if(d>0){const i=b.children[d-1];g=i.offset+i.length}else g=b.offset+1,b.children.length>1&&(t=b.children[1].offset);return A(D,{offset:g,length:t-g,content:""},l)}else return A(D,{offset:u.offset,length:u.length,content:JSON.stringify(k)},l);else{if(k===void 0)return[];const d=`${JSON.stringify(w)}: ${JSON.stringify(k)}`,g=h?h(b.children.map(i=>i.children[0].value)):b.children.length;let t;if(g>0){const i=b.children[g-1];t={offset:i.offset+i.length,length:0,content:","+d}}else b.children.length===0?t={offset:b.offset+1,length:0,content:d}:t={offset:b.offset+1,length:0,content:d+","};return A(D,t,l)}}else if(b.type==="array"&&typeof w=="number"&&Array.isArray(b.children))if(k!==void 0){const u=`${JSON.stringify(k)}`;let d;if(b.children.length===0||w===0)d={offset:b.offset+1,length:0,content:b.children.length===0?u:u+","};else{const g=w===-1||w>b.children.length?b.children.length:w,t=b.children[g-1];d={offset:t.offset+t.length,length:0,content:","+u}}return A(D,d,l)}else{const u=w,d=b.children[u];let g;if(b.children.length===1)g={offset:b.offset+1,length:b.length-2,content:""};else if(b.children.length-1===u){const t=b.children[u-1],i=t.offset+t.length,s=b.offset+b.length;g={offset:i,length:s-2-i,content:""}}else g={offset:d.offset,length:b.children[u+1].offset-d.offset,content:""};return A(D,g,l)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${b.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return A(D,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(k)},l)}}e.setProperty=S;function A(D,r,k){let l=P(D,r),h=r.offset,c=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;h>0&&!R.isEOL(l,h-1);)h--;for(;c<l.length&&!R.isEOL(l,c);)c++}const f=R.format(l,{offset:h,length:c-h},k);for(let b=f.length-1;b>=0;b--){const w=f[b];l=P(l,w),h=Math.min(h,w.offset),c=Math.max(c,w.offset+w.length),c+=w.content.length-w.length}const I=D.length-(l.length-c)-h;return[{offset:h,length:I,content:l.substring(h,c)}]}e.withFormatting=A;function P(D,r){return D.substring(0,r.offset)+r.content+D.substring(r.offset+r.length)}e.applyEdit=P;function _(D,r){let k=r.slice(0).sort((h,c)=>{const f=h.offset-c.offset;return f===0?h.length-c.length:f}),l=D.length;for(let h=k.length-1;h>=0;h--){let c=k[h];if(c.offset+c.length<=l)D=P(D,c);else throw new Error("Overlapping edit");l=c.offset}return D}e.applyEdits=_}),define(pe[134],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class p{constructor(C){this.executor=C,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(C){this._error=C}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(C){return new p(()=>C(this.getValue()))}}e.Lazy=p}),define(pe[6],ve([0,1,69,52]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const C=!1;let S=null;function A(d){S=d}if(e.setDisposableTracker=A,C){const d="__is_disposable_tracked__";S=new class{trackDisposable(g){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{g[d]||console.log(t)},3e3)}markTracked(g){if(g&&g!==f.None)try{g[d]=!0}catch(t){}}}}function P(d){!S||S.markTracked(d)}function _(d){return S&&S.trackDisposable(d),d}e.trackDisposable=_;class D extends Error{constructor(g){super(`Encountered errors while disposing of store. Errors: [${g.join(", ")}]`);this.errors=g}}e.MultiDisposeError=D;function r(d){return typeof d.dispose=="function"&&d.dispose.length===0}e.isDisposable=r;function k(d){if(R.Iterable.is(d)){let g=[];for(const t of d)if(t){P(t);try{t.dispose()}catch(i){g.push(i)}}if(g.length===1)throw g[0];if(g.length>1)throw new D(g);return Array.isArray(d)?[]:d}else if(d)return P(d),d.dispose(),d}e.dispose=k;function l(...d){return d.forEach(P),h(()=>k(d))}e.combinedDisposable=l;function h(d){const g=_({dispose:()=>{P(g),d()}});return g}e.toDisposable=h;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(g){if(!g)return g;if(g===this)throw new Error("Cannot register a disposable on itself!");return P(g),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(g),g}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class f{constructor(){this._store=new c,_(this)}dispose(){P(this),this._store.dispose()}_register(g){if(g===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(g)}}e.Disposable=f,f.None=Object.freeze({dispose(){}});class I{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(g){var t;this._isDisposed||g===this._value||((t=this._value)===null||t===void 0||t.dispose(),g&&P(g),this._value=g)}clear(){this.value=void 0}dispose(){var g;this._isDisposed=!0,P(this),(g=this._value)===null||g===void 0||g.dispose(),this._value=void 0}}e.MutableDisposable=I;class b{constructor(){this.references=new Map}acquire(g,...t){let i=this.references.get(g);i||(i={counter:0,object:this.createReferencedObject(g,...t)},this.references.set(g,i));const{object:s}=i,n=p.once(()=>{--i.counter==0&&(this.destroyReferencedObject(g,i.object),this.references.delete(g))});return i.counter++,{object:s,dispose:n}}}e.ReferenceCollection=b;class w{constructor(g){this.referenceCollection=g}async acquire(g,...t){const i=this.referenceCollection.acquire(g,...t);try{return{object:await i.object,dispose:()=>i.dispose()}}catch(s){throw i.dispose(),s}}}e.AsyncReferenceCollection=w;class u{constructor(g){this.object=g}dispose(){}}e.ImmortalReference=u}),define(pe[71],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(S){this.element=S,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class R{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let S=this._first;for(;S!==p.Undefined;){const A=S.next;S.prev=p.Undefined,S.next=p.Undefined,S=A}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(S){return this._insert(S,!1)}push(S){return this._insert(S,!0)}_insert(S,A){const P=new p(S);if(this._first===p.Undefined)this._first=P,this._last=P;else if(A){const D=this._last;this._last=P,P.prev=D,D.next=P}else{const D=this._first;this._first=P,P.next=D,D.prev=P}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(P))}}shift(){if(this._first!==p.Undefined){const S=this._first.element;return this._remove(this._first),S}}pop(){if(this._last!==p.Undefined){const S=this._last.element;return this._remove(this._last),S}}_remove(S){if(S.prev!==p.Undefined&&S.next!==p.Undefined){const A=S.prev;A.next=S.next,S.next.prev=A}else S.prev===p.Undefined&&S.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):S.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):S.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let S=this._first;for(;S!==p.Undefined;)yield S.element,S=S.next}}e.LinkedList=R}),function(X,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(X=typeof globalThis!="undefined"?globalThis:X||self,X.marked=e())}(this,function(){"use strict";function X(De,_e){for(var Pe=0;Pe<_e.length;Pe++){var ae=_e[Pe];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(De,ae.key,ae)}}function e(De,_e,Pe){return _e&&X(De.prototype,_e),Pe&&X(De,Pe),De}function p(De,_e){if(!!De){if(typeof De=="string")return R(De,_e);var Pe=Object.prototype.toString.call(De).slice(8,-1);if(Pe==="Object"&&De.constructor&&(Pe=De.constructor.name),Pe==="Map"||Pe==="Set")return Array.from(De);if(Pe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Pe))return R(De,_e)}}function R(De,_e){(_e==null||_e>De.length)&&(_e=De.length);for(var Pe=0,ae=new Array(_e);Pe<_e;Pe++)ae[Pe]=De[Pe];return ae}function C(De,_e){var Pe;if(typeof Symbol=="undefined"||De[Symbol.iterator]==null){if(Array.isArray(De)||(Pe=p(De))||_e&&De&&typeof De.length=="number"){Pe&&(De=Pe);var ae=0;return function(){return ae>=De.length?{done:!0}:{done:!1,value:De[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Pe=De[Symbol.iterator](),Pe.next.bind(Pe)}function S(De){var _e={exports:{}};return De(_e,_e.exports),_e.exports}var A=S(function(De){function _e(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Pe(ae){De.exports.defaults=ae}De.exports={defaults:_e(),getDefaults:_e,changeDefaults:Pe}}),P=/[&<>"']/,_=/[&<>"']/g,D=/[<>"']|&(?!#?\w+;)/,r=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(_e){return k[_e]};function h(De,_e){if(_e){if(P.test(De))return De.replace(_,l)}else if(D.test(De))return De.replace(r,l);return De}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function f(De){return De.replace(c,function(_e,Pe){return Pe=Pe.toLowerCase(),Pe==="colon"?":":Pe.charAt(0)==="#"?Pe.charAt(1)==="x"?String.fromCharCode(parseInt(Pe.substring(2),16)):String.fromCharCode(+Pe.substring(1)):""})}var I=/(^|[^\[])\^/g;function b(De,_e){De=De.source||De,_e=_e||"";var Pe={replace:function(fe,W){return W=W.source||W,W=W.replace(I,"$1"),De=De.replace(fe,W),Pe},getRegex:function(){return new RegExp(De,_e)}};return Pe}var w=/[^\w:]/g,u=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function d(De,_e,Pe){if(De){var ae;try{ae=decodeURIComponent(f(Pe)).replace(w,"").toLowerCase()}catch(fe){return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}_e&&!u.test(Pe)&&(Pe=n(_e,Pe));try{Pe=encodeURI(Pe).replace(/%25/g,"%")}catch(fe){return null}return Pe}var g={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(De,_e){g[" "+De]||(t.test(De)?g[" "+De]=De+"/":g[" "+De]=E(De,"/",!0)),De=g[" "+De];var Pe=De.indexOf(":")===-1;return _e.substring(0,2)==="//"?Pe?_e:De.replace(i,"$1")+_e:_e.charAt(0)==="/"?Pe?_e:De.replace(s,"$1")+_e:De+_e}var o={exec:function(){}};function v(De){for(var _e=1,Pe,ae;_e<arguments.length;_e++){Pe=arguments[_e];for(ae in Pe)Object.prototype.hasOwnProperty.call(Pe,ae)&&(De[ae]=Pe[ae])}return De}function m(De,_e){var Pe=De.replace(/\|/g,function(W,ee,de){for(var Ie=!1,Te=ee;--Te>=0&&de[Te]==="\\";)Ie=!Ie;return Ie?"|":" |"}),ae=Pe.split(/ \|/),fe=0;if(ae.length>_e)ae.splice(_e);else for(;ae.length<_e;)ae.push("");for(;fe<ae.length;fe++)ae[fe]=ae[fe].trim().replace(/\\\|/g,"|");return ae}function E(De,_e,Pe){var ae=De.length;if(ae===0)return"";for(var fe=0;fe<ae;){var W=De.charAt(ae-fe-1);if(W===_e&&!Pe)fe++;else if(W!==_e&&Pe)fe++;else break}return De.substr(0,ae-fe)}function y(De,_e){if(De.indexOf(_e[1])===-1)return-1;for(var Pe=De.length,ae=0,fe=0;fe<Pe;fe++)if(De[fe]==="\\")fe++;else if(De[fe]===_e[0])ae++;else if(De[fe]===_e[1]&&(ae--,ae<0))return fe;return-1}function a(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function T(De,_e){if(_e<1)return"";for(var Pe="";_e>1;)_e&1&&(Pe+=De),_e>>=1,De+=De;return Pe+De}var O={escape:h,unescape:f,edit:b,cleanUrl:d,resolveUrl:n,noopTest:o,merge:v,splitCells:m,rtrim:E,findClosingBracket:y,checkSanitizeDeprecation:a,repeatString:T},$=A.defaults,Z=O.rtrim,le=O.splitCells,q=O.escape,x=O.findClosingBracket;function H(De,_e,Pe){var ae=_e.href,fe=_e.title?q(_e.title):null,W=De[1].replace(/\\([\[\]])/g,"$1");return De[0].charAt(0)!=="!"?{type:"link",raw:Pe,href:ae,title:fe,text:W}:{type:"image",raw:Pe,href:ae,title:fe,text:q(W)}}function N(De,_e){var Pe=De.match(/^(\s+)(?:```)/);if(Pe===null)return _e;var ae=Pe[1];return _e.split(`
`).map(function(fe){var W=fe.match(/^\s+/);if(W===null)return fe;var ee=W[0];return ee.length>=ae.length?fe.slice(ae.length):fe}).join(`
`)}var z=function(){function De(Pe){this.options=Pe||$}var _e=De.prototype;return _e.space=function(ae){var fe=this.rules.block.newline.exec(ae);if(fe)return fe[0].length>1?{type:"space",raw:fe[0]}:{raw:`
`}},_e.code=function(ae){var fe=this.rules.block.code.exec(ae);if(fe){var W=fe[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:fe[0],codeBlockStyle:"indented",text:this.options.pedantic?W:Z(W,`
`)}}},_e.fences=function(ae){var fe=this.rules.block.fences.exec(ae);if(fe){var W=fe[0],ee=N(W,fe[3]||"");return{type:"code",raw:W,lang:fe[2]?fe[2].trim():fe[2],text:ee}}},_e.heading=function(ae){var fe=this.rules.block.heading.exec(ae);if(fe){var W=fe[2].trim();if(/#$/.test(W)){var ee=Z(W,"#");(this.options.pedantic||!ee||/ $/.test(ee))&&(W=ee.trim())}return{type:"heading",raw:fe[0],depth:fe[1].length,text:W}}},_e.nptable=function(ae){var fe=this.rules.block.nptable.exec(ae);if(fe){var W={type:"table",header:le(fe[1].replace(/^ *| *\| *$/g,"")),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:fe[3]?fe[3].replace(/\n$/,"").split(`
`):[],raw:fe[0]};if(W.header.length===W.align.length){var ee=W.align.length,de;for(de=0;de<ee;de++)/^ *-+: *$/.test(W.align[de])?W.align[de]="right":/^ *:-+: *$/.test(W.align[de])?W.align[de]="center":/^ *:-+ *$/.test(W.align[de])?W.align[de]="left":W.align[de]=null;for(ee=W.cells.length,de=0;de<ee;de++)W.cells[de]=le(W.cells[de],W.header.length);return W}}},_e.hr=function(ae){var fe=this.rules.block.hr.exec(ae);if(fe)return{type:"hr",raw:fe[0]}},_e.blockquote=function(ae){var fe=this.rules.block.blockquote.exec(ae);if(fe){var W=fe[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:fe[0],text:W}}},_e.list=function(ae){var fe=this.rules.block.list.exec(ae);if(fe){var W=fe[0],ee=fe[2],de=ee.length>1,Ie={type:"list",raw:W,ordered:de,start:de?+ee.slice(0,-1):"",loose:!1,items:[]},Te=fe[0].match(this.rules.block.item),xe=!1,Ve,Ze,rt,Xe,Je,ft,Ee,Ce,ue=Te.length;rt=this.rules.block.listItemStart.exec(Te[0]);for(var K=0;K<ue;K++){if(Ve=Te[K],W=Ve,K!==ue-1){if(Xe=this.rules.block.listItemStart.exec(Te[K+1]),this.options.pedantic?Xe[1].length>rt[1].length:Xe[1].length>rt[0].length||Xe[1].length>3){Te.splice(K,2,Te[K]+`
`+Te[K+1]),K--,ue--;continue}else(!this.options.pedantic||this.options.smartLists?Xe[2][Xe[2].length-1]!==ee[ee.length-1]:de===(Xe[2].length===1))&&(Je=Te.slice(K+1).join(`
`),Ie.raw=Ie.raw.substring(0,Ie.raw.length-Je.length),K=ue-1);rt=Xe}Ze=Ve.length,Ve=Ve.replace(/^ *([*+-]|\d+[.)]) ?/,""),~Ve.indexOf(`
 `)&&(Ze-=Ve.length,Ve=this.options.pedantic?Ve.replace(/^ {1,4}/gm,""):Ve.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),ft=xe||/\n\n(?!\s*$)/.test(Ve),K!==ue-1&&(xe=Ve.charAt(Ve.length-1)===`
`,ft||(ft=xe)),ft&&(Ie.loose=!0),this.options.gfm&&(Ee=/^\[[ xX]\] /.test(Ve),Ce=void 0,Ee&&(Ce=Ve[1]!==" ",Ve=Ve.replace(/^\[[ xX]\] +/,""))),Ie.items.push({type:"list_item",raw:W,task:Ee,checked:Ce,loose:ft,text:Ve})}return Ie}},_e.html=function(ae){var fe=this.rules.block.html.exec(ae);if(fe)return{type:this.options.sanitize?"paragraph":"html",raw:fe[0],pre:!this.options.sanitizer&&(fe[1]==="pre"||fe[1]==="script"||fe[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(fe[0]):q(fe[0]):fe[0]}},_e.def=function(ae){var fe=this.rules.block.def.exec(ae);if(fe){fe[3]&&(fe[3]=fe[3].substring(1,fe[3].length-1));var W=fe[1].toLowerCase().replace(/\s+/g," ");return{tag:W,raw:fe[0],href:fe[2],title:fe[3]}}},_e.table=function(ae){var fe=this.rules.block.table.exec(ae);if(fe){var W={type:"table",header:le(fe[1].replace(/^ *| *\| *$/g,"")),align:fe[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:fe[3]?fe[3].replace(/\n$/,"").split(`
`):[]};if(W.header.length===W.align.length){W.raw=fe[0];var ee=W.align.length,de;for(de=0;de<ee;de++)/^ *-+: *$/.test(W.align[de])?W.align[de]="right":/^ *:-+: *$/.test(W.align[de])?W.align[de]="center":/^ *:-+ *$/.test(W.align[de])?W.align[de]="left":W.align[de]=null;for(ee=W.cells.length,de=0;de<ee;de++)W.cells[de]=le(W.cells[de].replace(/^ *\| *| *\| *$/g,""),W.header.length);return W}}},_e.lheading=function(ae){var fe=this.rules.block.lheading.exec(ae);if(fe)return{type:"heading",raw:fe[0],depth:fe[2].charAt(0)==="="?1:2,text:fe[1]}},_e.paragraph=function(ae){var fe=this.rules.block.paragraph.exec(ae);if(fe)return{type:"paragraph",raw:fe[0],text:fe[1].charAt(fe[1].length-1)===`
`?fe[1].slice(0,-1):fe[1]}},_e.text=function(ae){var fe=this.rules.block.text.exec(ae);if(fe)return{type:"text",raw:fe[0],text:fe[0]}},_e.escape=function(ae){var fe=this.rules.inline.escape.exec(ae);if(fe)return{type:"escape",raw:fe[0],text:q(fe[1])}},_e.tag=function(ae,fe,W){var ee=this.rules.inline.tag.exec(ae);if(ee)return!fe&&/^<a /i.test(ee[0])?fe=!0:fe&&/^<\/a>/i.test(ee[0])&&(fe=!1),!W&&/^<(pre|code|kbd|script)(\s|>)/i.test(ee[0])?W=!0:W&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ee[0])&&(W=!1),{type:this.options.sanitize?"text":"html",raw:ee[0],inLink:fe,inRawBlock:W,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):q(ee[0]):ee[0]}},_e.link=function(ae){var fe=this.rules.inline.link.exec(ae);if(fe){var W=fe[2].trim();if(!this.options.pedantic&&/^</.test(W)){if(!/>$/.test(W))return;var ee=Z(W.slice(0,-1),"\\");if((W.length-ee.length)%2==0)return}else{var de=x(fe[2],"()");if(de>-1){var Ie=fe[0].indexOf("!")===0?5:4,Te=Ie+fe[1].length+de;fe[2]=fe[2].substring(0,de),fe[0]=fe[0].substring(0,Te).trim(),fe[3]=""}}var xe=fe[2],Ve="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(xe);Ze&&(xe=Ze[1],Ve=Ze[3])}else Ve=fe[3]?fe[3].slice(1,-1):"";return xe=xe.trim(),/^</.test(xe)&&(this.options.pedantic&&!/>$/.test(W)?xe=xe.slice(1):xe=xe.slice(1,-1)),H(fe,{href:xe&&xe.replace(this.rules.inline._escapes,"$1"),title:Ve&&Ve.replace(this.rules.inline._escapes,"$1")},fe[0])}},_e.reflink=function(ae,fe){var W;if((W=this.rules.inline.reflink.exec(ae))||(W=this.rules.inline.nolink.exec(ae))){var ee=(W[2]||W[1]).replace(/\s+/g," ");if(ee=fe[ee.toLowerCase()],!ee||!ee.href){var de=W[0].charAt(0);return{type:"text",raw:de,text:de}}return H(W,ee,W[0])}},_e.emStrong=function(ae,fe,W){W===void 0&&(W="");var ee=this.rules.inline.emStrong.lDelim.exec(ae);if(!!ee&&!(ee[3]&&W.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var de=ee[1]||ee[2]||"";if(!de||de&&(W===""||this.rules.inline.punctuation.exec(W))){var Ie=ee[0].length-1,Te,xe,Ve=Ie,Ze=0,rt=ee[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,fe=fe.slice(-1*ae.length+Ie);(ee=rt.exec(fe))!=null;)if(Te=ee[1]||ee[2]||ee[3]||ee[4]||ee[5]||ee[6],!!Te){if(xe=Te.length,ee[3]||ee[4]){Ve+=xe;continue}else if((ee[5]||ee[6])&&Ie%3&&!((Ie+xe)%3)){Ze+=xe;continue}if(Ve-=xe,!(Ve>0)){if(Ve+Ze-xe<=0&&!fe.slice(rt.lastIndex).match(rt)&&(xe=Math.min(xe,xe+Ve+Ze)),Math.min(Ie,xe)%2)return{type:"em",raw:ae.slice(0,Ie+ee.index+xe+1),text:ae.slice(1,Ie+ee.index+xe)};if(Math.min(Ie,xe)%2==0)return{type:"strong",raw:ae.slice(0,Ie+ee.index+xe+1),text:ae.slice(2,Ie+ee.index+xe-1)}}}}}},_e.codespan=function(ae){var fe=this.rules.inline.code.exec(ae);if(fe){var W=fe[2].replace(/\n/g," "),ee=/[^ ]/.test(W),de=/^ /.test(W)&&/ $/.test(W);return ee&&de&&(W=W.substring(1,W.length-1)),W=q(W,!0),{type:"codespan",raw:fe[0],text:W}}},_e.br=function(ae){var fe=this.rules.inline.br.exec(ae);if(fe)return{type:"br",raw:fe[0]}},_e.del=function(ae){var fe=this.rules.inline.del.exec(ae);if(fe)return{type:"del",raw:fe[0],text:fe[2]}},_e.autolink=function(ae,fe){var W=this.rules.inline.autolink.exec(ae);if(W){var ee,de;return W[2]==="@"?(ee=q(this.options.mangle?fe(W[1]):W[1]),de="mailto:"+ee):(ee=q(W[1]),de=ee),{type:"link",raw:W[0],text:ee,href:de,tokens:[{type:"text",raw:ee,text:ee}]}}},_e.url=function(ae,fe){var W;if(W=this.rules.inline.url.exec(ae)){var ee,de;if(W[2]==="@")ee=q(this.options.mangle?fe(W[0]):W[0]),de="mailto:"+ee;else{var Ie;do Ie=W[0],W[0]=this.rules.inline._backpedal.exec(W[0])[0];while(Ie!==W[0]);ee=q(W[0]),W[1]==="www."?de="http://"+ee:de=ee}return{type:"link",raw:W[0],text:ee,href:de,tokens:[{type:"text",raw:ee,text:ee}]}}},_e.inlineText=function(ae,fe,W){var ee=this.rules.inline.text.exec(ae);if(ee){var de;return fe?de=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ee[0]):q(ee[0]):ee[0]:de=q(this.options.smartypants?W(ee[0]):ee[0]),{type:"text",raw:ee[0],text:de}}},De}(),F=O.noopTest,M=O.edit,L=O.merge,U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:F,table:F,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=M(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,U.item=M(U.item,"gm").replace(/bull/g,U.bullet).getRegex(),U.listItemStart=M(/^( *)(bull)/).replace("bull",U.bullet).getRegex(),U.list=M(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=M(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=M(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",U._tag).getRegex(),U.blockquote=M(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=L({},U),U.gfm=L({},U.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.nptable=M(U.gfm.nptable).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",U._tag).getRegex(),U.gfm.table=M(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",U._tag).getRegex(),U.pedantic=L({},U.normal,{html:M(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:F,paragraph:M(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var G={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:F,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:F,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};G._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",G.punctuation=M(G.punctuation).replace(/punctuation/g,G._punctuation).getRegex(),G.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,G.escapedEmSt=/\\\*|\\_/g,G._comment=M(U._comment).replace("(?:-->|$)","-->").getRegex(),G.emStrong.lDelim=M(G.emStrong.lDelim).replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimAst=M(G.emStrong.rDelimAst,"g").replace(/punct/g,G._punctuation).getRegex(),G.emStrong.rDelimUnd=M(G.emStrong.rDelimUnd,"g").replace(/punct/g,G._punctuation).getRegex(),G._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,G._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,G._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,G.autolink=M(G.autolink).replace("scheme",G._scheme).replace("email",G._email).getRegex(),G._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,G.tag=M(G.tag).replace("comment",G._comment).replace("attribute",G._attribute).getRegex(),G._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,G._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,G._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,G.link=M(G.link).replace("label",G._label).replace("href",G._href).replace("title",G._title).getRegex(),G.reflink=M(G.reflink).replace("label",G._label).getRegex(),G.reflinkSearch=M(G.reflinkSearch,"g").replace("reflink",G.reflink).replace("nolink",G.nolink).getRegex(),G.normal=L({},G),G.pedantic=L({},G.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:M(/^!?\[(label)\]\((.*?)\)/).replace("label",G._label).getRegex(),reflink:M(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",G._label).getRegex()}),G.gfm=L({},G.normal,{escape:M(G.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),G.gfm.url=M(G.gfm.url,"i").replace("email",G.gfm._extended_email).getRegex(),G.breaks=L({},G.gfm,{br:M(G.br).replace("{2,}","*").getRegex(),text:M(G.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var te={block:U,inline:G},me=A.defaults,Se=te.block,ye=te.inline,Le=O.repeatString;function je(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ze(De){var _e="",Pe,ae,fe=De.length;for(Pe=0;Pe<fe;Pe++)ae=De.charCodeAt(Pe),Math.random()>.5&&(ae="x"+ae.toString(16)),_e+="&#"+ae+";";return _e}var Ge=function(){function De(Pe){this.tokens=[],this.tokens.links=Object.create(null),this.options=Pe||me,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var ae={block:Se.normal,inline:ye.normal};this.options.pedantic?(ae.block=Se.pedantic,ae.inline=ye.pedantic):this.options.gfm&&(ae.block=Se.gfm,this.options.breaks?ae.inline=ye.breaks:ae.inline=ye.gfm),this.tokenizer.rules=ae}De.lex=function(ae,fe){var W=new De(fe);return W.lex(ae)},De.lexInline=function(ae,fe){var W=new De(fe);return W.inlineTokens(ae)};var _e=De.prototype;return _e.lex=function(ae){return ae=ae.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(ae,this.tokens,!0),this.inline(this.tokens),this.tokens},_e.blockTokens=function(ae,fe,W){fe===void 0&&(fe=[]),W===void 0&&(W=!0),this.options.pedantic&&(ae=ae.replace(/^ +$/gm,""));for(var ee,de,Ie,Te;ae;){if(ee=this.tokenizer.space(ae)){ae=ae.substring(ee.raw.length),ee.type&&fe.push(ee);continue}if(ee=this.tokenizer.code(ae)){ae=ae.substring(ee.raw.length),Te=fe[fe.length-1],Te&&Te.type==="paragraph"?(Te.raw+=`
`+ee.raw,Te.text+=`
`+ee.text):fe.push(ee);continue}if(ee=this.tokenizer.fences(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.heading(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.nptable(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.hr(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.blockquote(ae)){ae=ae.substring(ee.raw.length),ee.tokens=this.blockTokens(ee.text,[],W),fe.push(ee);continue}if(ee=this.tokenizer.list(ae)){for(ae=ae.substring(ee.raw.length),Ie=ee.items.length,de=0;de<Ie;de++)ee.items[de].tokens=this.blockTokens(ee.items[de].text,[],!1);fe.push(ee);continue}if(ee=this.tokenizer.html(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(W&&(ee=this.tokenizer.def(ae))){ae=ae.substring(ee.raw.length),this.tokens.links[ee.tag]||(this.tokens.links[ee.tag]={href:ee.href,title:ee.title});continue}if(ee=this.tokenizer.table(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.lheading(ae)){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(W&&(ee=this.tokenizer.paragraph(ae))){ae=ae.substring(ee.raw.length),fe.push(ee);continue}if(ee=this.tokenizer.text(ae)){ae=ae.substring(ee.raw.length),Te=fe[fe.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+ee.raw,Te.text+=`
`+ee.text):fe.push(ee);continue}if(ae){var xe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(xe);break}else throw new Error(xe)}}return fe},_e.inline=function(ae){var fe,W,ee,de,Ie,Te,xe=ae.length;for(fe=0;fe<xe;fe++)switch(Te=ae[fe],Te.type){case"paragraph":case"text":case"heading":{Te.tokens=[],this.inlineTokens(Te.text,Te.tokens);break}case"table":{for(Te.tokens={header:[],cells:[]},de=Te.header.length,W=0;W<de;W++)Te.tokens.header[W]=[],this.inlineTokens(Te.header[W],Te.tokens.header[W]);for(de=Te.cells.length,W=0;W<de;W++)for(Ie=Te.cells[W],Te.tokens.cells[W]=[],ee=0;ee<Ie.length;ee++)Te.tokens.cells[W][ee]=[],this.inlineTokens(Ie[ee],Te.tokens.cells[W][ee]);break}case"blockquote":{this.inline(Te.tokens);break}case"list":{for(de=Te.items.length,W=0;W<de;W++)this.inline(Te.items[W].tokens);break}}return ae},_e.inlineTokens=function(ae,fe,W,ee){fe===void 0&&(fe=[]),W===void 0&&(W=!1),ee===void 0&&(ee=!1);var de,Ie,Te=ae,xe,Ve,Ze;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(xe=this.tokenizer.rules.inline.reflinkSearch.exec(Te))!=null;)rt.includes(xe[0].slice(xe[0].lastIndexOf("[")+1,-1))&&(Te=Te.slice(0,xe.index)+"["+Le("a",xe[0].length-2)+"]"+Te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(xe=this.tokenizer.rules.inline.blockSkip.exec(Te))!=null;)Te=Te.slice(0,xe.index)+"["+Le("a",xe[0].length-2)+"]"+Te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(xe=this.tokenizer.rules.inline.escapedEmSt.exec(Te))!=null;)Te=Te.slice(0,xe.index)+"++"+Te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;){if(Ve||(Ze=""),Ve=!1,de=this.tokenizer.escape(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.tag(ae,W,ee)){ae=ae.substring(de.raw.length),W=de.inLink,ee=de.inRawBlock;var Xe=fe[fe.length-1];Xe&&de.type==="text"&&Xe.type==="text"?(Xe.raw+=de.raw,Xe.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.link(ae)){ae=ae.substring(de.raw.length),de.type==="link"&&(de.tokens=this.inlineTokens(de.text,[],!0,ee)),fe.push(de);continue}if(de=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(de.raw.length);var Je=fe[fe.length-1];de.type==="link"?(de.tokens=this.inlineTokens(de.text,[],!0,ee),fe.push(de)):Je&&de.type==="text"&&Je.type==="text"?(Je.raw+=de.raw,Je.text+=de.text):fe.push(de);continue}if(de=this.tokenizer.emStrong(ae,Te,Ze)){ae=ae.substring(de.raw.length),de.tokens=this.inlineTokens(de.text,[],W,ee),fe.push(de);continue}if(de=this.tokenizer.codespan(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.br(ae)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.del(ae)){ae=ae.substring(de.raw.length),de.tokens=this.inlineTokens(de.text,[],W,ee),fe.push(de);continue}if(de=this.tokenizer.autolink(ae,ze)){ae=ae.substring(de.raw.length),fe.push(de);continue}if(!W&&(de=this.tokenizer.url(ae,ze))){ae=ae.substring(de.raw.length),fe.push(de);continue}if(de=this.tokenizer.inlineText(ae,ee,je)){ae=ae.substring(de.raw.length),de.raw.slice(-1)!=="_"&&(Ze=de.raw.slice(-1)),Ve=!0,Ie=fe[fe.length-1],Ie&&Ie.type==="text"?(Ie.raw+=de.raw,Ie.text+=de.text):fe.push(de);continue}if(ae){var ft="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(ft);break}else throw new Error(ft)}}return fe},e(De,null,[{key:"rules",get:function(){return{block:Se,inline:ye}}}]),De}(),j=A.defaults,Y=O.cleanUrl,ie=O.escape,re=function(){function De(Pe){this.options=Pe||j}var _e=De.prototype;return _e.code=function(ae,fe,W){var ee=(fe||"").match(/\S*/)[0];if(this.options.highlight){var de=this.options.highlight(ae,ee);de!=null&&de!==ae&&(W=!0,ae=de)}return ae=ae.replace(/\n$/,"")+`
`,ee?'<pre><code class="'+this.options.langPrefix+ie(ee,!0)+'">'+(W?ae:ie(ae,!0))+`</code></pre>
`:"<pre><code>"+(W?ae:ie(ae,!0))+`</code></pre>
`},_e.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},_e.html=function(ae){return ae},_e.heading=function(ae,fe,W,ee){return this.options.headerIds?"<h"+fe+' id="'+this.options.headerPrefix+ee.slug(W)+'">'+ae+"</h"+fe+`>
`:"<h"+fe+">"+ae+"</h"+fe+`>
`},_e.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_e.list=function(ae,fe,W){var ee=fe?"ol":"ul",de=fe&&W!==1?' start="'+W+'"':"";return"<"+ee+de+`>
`+ae+"</"+ee+`>
`},_e.listitem=function(ae){return"<li>"+ae+`</li>
`},_e.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_e.paragraph=function(ae){return"<p>"+ae+`</p>
`},_e.table=function(ae,fe){return fe&&(fe="<tbody>"+fe+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+fe+`</table>
`},_e.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},_e.tablecell=function(ae,fe){var W=fe.header?"th":"td",ee=fe.align?"<"+W+' align="'+fe.align+'">':"<"+W+">";return ee+ae+"</"+W+`>
`},_e.strong=function(ae){return"<strong>"+ae+"</strong>"},_e.em=function(ae){return"<em>"+ae+"</em>"},_e.codespan=function(ae){return"<code>"+ae+"</code>"},_e.br=function(){return this.options.xhtml?"<br/>":"<br>"},_e.del=function(ae){return"<del>"+ae+"</del>"},_e.link=function(ae,fe,W){if(ae=Y(this.options.sanitize,this.options.baseUrl,ae),ae===null)return W;var ee='<a href="'+ie(ae)+'"';return fe&&(ee+=' title="'+fe+'"'),ee+=">"+W+"</a>",ee},_e.image=function(ae,fe,W){if(ae=Y(this.options.sanitize,this.options.baseUrl,ae),ae===null)return W;var ee='<img src="'+ae+'" alt="'+W+'"';return fe&&(ee+=' title="'+fe+'"'),ee+=this.options.xhtml?"/>":">",ee},_e.text=function(ae){return ae},De}(),J=function(){function De(){}var _e=De.prototype;return _e.strong=function(ae){return ae},_e.em=function(ae){return ae},_e.codespan=function(ae){return ae},_e.del=function(ae){return ae},_e.html=function(ae){return ae},_e.text=function(ae){return ae},_e.link=function(ae,fe,W){return""+W},_e.image=function(ae,fe,W){return""+W},_e.br=function(){return""},De}(),ce=function(){function De(){this.seen={}}var _e=De.prototype;return _e.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_e.getNextSafeSlug=function(ae,fe){var W=ae,ee=0;if(this.seen.hasOwnProperty(W)){ee=this.seen[ae];do ee++,W=ae+"-"+ee;while(this.seen.hasOwnProperty(W))}return fe||(this.seen[ae]=ee,this.seen[W]=0),W},_e.slug=function(ae,fe){fe===void 0&&(fe={});var W=this.serialize(ae);return this.getNextSafeSlug(W,fe.dryrun)},De}(),ge=A.defaults,Re=O.unescape,He=function(){function De(Pe){this.options=Pe||ge,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new J,this.slugger=new ce}De.parse=function(ae,fe){var W=new De(fe);return W.parse(ae)},De.parseInline=function(ae,fe){var W=new De(fe);return W.parseInline(ae)};var _e=De.prototype;return _e.parse=function(ae,fe){fe===void 0&&(fe=!0);var W="",ee,de,Ie,Te,xe,Ve,Ze,rt,Xe,Je,ft,Ee,Ce,ue,K,Be,Fe,Me,nt=ae.length;for(ee=0;ee<nt;ee++)switch(Je=ae[ee],Je.type){case"space":continue;case"hr":{W+=this.renderer.hr();continue}case"heading":{W+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,Re(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{W+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(rt="",Ze="",Te=Je.header.length,de=0;de<Te;de++)Ze+=this.renderer.tablecell(this.parseInline(Je.tokens.header[de]),{header:!0,align:Je.align[de]});for(rt+=this.renderer.tablerow(Ze),Xe="",Te=Je.cells.length,de=0;de<Te;de++){for(Ve=Je.tokens.cells[de],Ze="",xe=Ve.length,Ie=0;Ie<xe;Ie++)Ze+=this.renderer.tablecell(this.parseInline(Ve[Ie]),{header:!1,align:Je.align[Ie]});Xe+=this.renderer.tablerow(Ze)}W+=this.renderer.table(rt,Xe);continue}case"blockquote":{Xe=this.parse(Je.tokens),W+=this.renderer.blockquote(Xe);continue}case"list":{for(ft=Je.ordered,Ee=Je.start,Ce=Je.loose,Te=Je.items.length,Xe="",de=0;de<Te;de++)K=Je.items[de],Be=K.checked,Fe=K.task,ue="",K.task&&(Me=this.renderer.checkbox(Be),Ce?K.tokens.length>0&&K.tokens[0].type==="text"?(K.tokens[0].text=Me+" "+K.tokens[0].text,K.tokens[0].tokens&&K.tokens[0].tokens.length>0&&K.tokens[0].tokens[0].type==="text"&&(K.tokens[0].tokens[0].text=Me+" "+K.tokens[0].tokens[0].text)):K.tokens.unshift({type:"text",text:Me}):ue+=Me),ue+=this.parse(K.tokens,Ce),Xe+=this.renderer.listitem(ue,Fe,Be);W+=this.renderer.list(Xe,ft,Ee);continue}case"html":{W+=this.renderer.html(Je.text);continue}case"paragraph":{W+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(Xe=Je.tokens?this.parseInline(Je.tokens):Je.text;ee+1<nt&&ae[ee+1].type==="text";)Je=ae[++ee],Xe+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);W+=fe?this.renderer.paragraph(Xe):Xe;continue}default:{var ot='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}return W},_e.parseInline=function(ae,fe){fe=fe||this.renderer;var W="",ee,de,Ie=ae.length;for(ee=0;ee<Ie;ee++)switch(de=ae[ee],de.type){case"escape":{W+=fe.text(de.text);break}case"html":{W+=fe.html(de.text);break}case"link":{W+=fe.link(de.href,de.title,this.parseInline(de.tokens,fe));break}case"image":{W+=fe.image(de.href,de.title,de.text);break}case"strong":{W+=fe.strong(this.parseInline(de.tokens,fe));break}case"em":{W+=fe.em(this.parseInline(de.tokens,fe));break}case"codespan":{W+=fe.codespan(de.text);break}case"br":{W+=fe.br();break}case"del":{W+=fe.del(this.parseInline(de.tokens,fe));break}case"text":{W+=fe.text(de.text);break}default:{var Te='Token with "'+de.type+'" type was not found.';if(this.options.silent){console.error(Te);return}else throw new Error(Te)}}return W},De}(),be=O.merge,Qe=O.checkSanitizeDeprecation,Q=O.escape,se=A.getDefaults,we=A.changeDefaults,Oe=A.defaults;function Ue(De,_e,Pe){if(typeof De=="undefined"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof _e=="function"&&(Pe=_e,_e=null),_e=be({},Ue.defaults,_e||{}),Qe(_e),Pe){var ae=_e.highlight,fe;try{fe=Ge.lex(De,_e)}catch(Ie){return Pe(Ie)}var W=function(Te){var xe;if(!Te)try{xe=He.parse(fe,_e)}catch(Ve){Te=Ve}return _e.highlight=ae,Te?Pe(Te):Pe(null,xe)};if(!ae||ae.length<3||(delete _e.highlight,!fe.length))return W();var ee=0;Ue.walkTokens(fe,function(Ie){Ie.type==="code"&&(ee++,setTimeout(function(){ae(Ie.text,Ie.lang,function(Te,xe){if(Te)return W(Te);xe!=null&&xe!==Ie.text&&(Ie.text=xe,Ie.escaped=!0),ee--,ee===0&&W()})},0))}),ee===0&&W();return}try{var de=Ge.lex(De,_e);return _e.walkTokens&&Ue.walkTokens(de,_e.walkTokens),He.parse(de,_e)}catch(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+Q(Ie.message+"",!0)+"</pre>";throw Ie}}Ue.options=Ue.setOptions=function(De){return be(Ue.defaults,De),we(Ue.defaults),Ue},Ue.getDefaults=se,Ue.defaults=Oe,Ue.use=function(De){var _e=be({},De);if(De.renderer&&function(){var ae=Ue.defaults.renderer||new re,fe=function(de){var Ie=ae[de];ae[de]=function(){for(var Te=arguments.length,xe=new Array(Te),Ve=0;Ve<Te;Ve++)xe[Ve]=arguments[Ve];var Ze=De.renderer[de].apply(ae,xe);return Ze===!1&&(Ze=Ie.apply(ae,xe)),Ze}};for(var W in De.renderer)fe(W);_e.renderer=ae}(),De.tokenizer&&function(){var ae=Ue.defaults.tokenizer||new z,fe=function(de){var Ie=ae[de];ae[de]=function(){for(var Te=arguments.length,xe=new Array(Te),Ve=0;Ve<Te;Ve++)xe[Ve]=arguments[Ve];var Ze=De.tokenizer[de].apply(ae,xe);return Ze===!1&&(Ze=Ie.apply(ae,xe)),Ze}};for(var W in De.tokenizer)fe(W);_e.tokenizer=ae}(),De.walkTokens){var Pe=Ue.defaults.walkTokens;_e.walkTokens=function(ae){De.walkTokens(ae),Pe&&Pe(ae)}}Ue.setOptions(_e)},Ue.walkTokens=function(De,_e){for(var Pe=C(De),ae;!(ae=Pe()).done;){var fe=ae.value;switch(_e(fe),fe.type){case"table":{for(var W=C(fe.tokens.header),ee;!(ee=W()).done;){var de=ee.value;Ue.walkTokens(de,_e)}for(var Ie=C(fe.tokens.cells),Te;!(Te=Ie()).done;)for(var xe=Te.value,Ve=C(xe),Ze;!(Ze=Ve()).done;){var rt=Ze.value;Ue.walkTokens(rt,_e)}break}case"list":{Ue.walkTokens(fe.items,_e);break}default:fe.tokens&&Ue.walkTokens(fe.tokens,_e)}}},Ue.parseInline=function(De,_e){if(typeof De=="undefined"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");_e=be({},Ue.defaults,_e||{}),Qe(_e);try{var Pe=Ge.lexInline(De,_e);return _e.walkTokens&&Ue.walkTokens(Pe,_e.walkTokens),He.parseInline(Pe,_e)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,_e.silent)return"<p>An error occurred:</p><pre>"+Q(ae.message+"",!0)+"</pre>";throw ae}},Ue.Parser=He,Ue.parser=He.parse,Ue.Renderer=re,Ue.TextRenderer=J,Ue.Lexer=Ge,Ue.lexer=Ge.lex,Ue.Tokenizer=z,Ue.Slugger=ce,Ue.parse=Ue;var Ye=Ue;return Ye}),define(pe[72],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function p(A,P,_){return Math.min(Math.max(A,P),_)}e.clamp=p;function R(A,P){return(P+A%P)%P}e.rot=R;class C{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=C;class S{constructor(){this._n=1,this._val=0}update(P){return this._val=this._val+(P-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=S}),function(){function X(C){const S=[];typeof C=="number"&&S.push("code/timeOrigin",C);function A(_){S.push(_,Date.now())}function P(){const _=[];for(let D=0;D<S.length;D+=2)_.push({name:S[D],startTime:S[D+1]});return _}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(C){performance.mark(C)},getMarks(){let C=performance.timeOrigin;typeof C!="number"&&(C=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const S=[{name:"code/timeOrigin",startTime:Math.round(C)}];for(const A of performance.getEntriesByType("mark"))S.push({name:A.name,startTime:Math.round(C+A.startTime)});return S}};if(typeof process=="object"){const C=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(C)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function p(C){return C.MonacoPerformanceMarks||(C.MonacoPerformanceMarks=e()),C.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=p(R))}(),define(pe[11],ve([0,1]),function(X,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const R="en";let C=!1,S=!1,A=!1,P=!1,_=!1,D=!1,r=!1,k,l=R,h,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let f;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?f=e.globals.vscode.process:typeof process!="undefined"&&(f=process);const I=typeof((p=f==null?void 0:f.versions)===null||p===void 0?void 0:p.electron)=="string"&&f.type==="renderer";if(e.isElectronSandboxed=I&&(f==null?void 0:f.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const n=f==null?void 0:f.env.VSCODE_BROWSER_CODE_LOADING;if(typeof n=="string")return n==="none"||n==="code"||n==="bypassHeatCheck"||n==="bypassHeatCheckAndEagerCompile"?n:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!I)c=navigator.userAgent,C=c.indexOf("Windows")>=0,S=c.indexOf("Macintosh")>=0,r=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=c.indexOf("Linux")>=0,D=!0,k=navigator.language,l=k;else if(typeof f=="object"){C=f.platform==="win32",S=f.platform==="darwin",A=f.platform==="linux",P=A&&!!f.env.SNAP&&!!f.env.SNAP_REVISION,k=R,l=R;const n=f.env.VSCODE_NLS_CONFIG;if(n)try{const o=JSON.parse(n),v=o.availableLanguages["*"];k=o.locale,l=v||R,h=o._translationsConfigFile}catch(o){}_=!0}else console.error("Unable to resolve platform.");var b;(function(n){n[n.Web=0]="Web",n[n.Mac=1]="Mac",n[n.Linux=2]="Linux",n[n.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function w(n){switch(n){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=w;let u=0;S?u=1:C?u=3:A&&(u=2),e.isWindows=C,e.isMacintosh=S,e.isLinux=A,e.isLinuxSnap=P,e.isNative=_,e.isWeb=D,e.isIOS=r,e.platform=u,e.userAgent=c,e.language=l;var d;(function(n){function o(){return e.language}n.value=o;function v(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}n.isDefaultVariant=v;function m(){return e.language==="en"}n.isDefault=m})(d=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let v=[];e.globals.addEventListener("message",E=>{if(E.data&&E.data.vscodeSetImmediateId)for(let y=0,a=v.length;y<a;y++){const T=v[y];if(T.id===E.data.vscodeSetImmediateId){v.splice(y,1),T.callback();return}}});let m=0;return E=>{const y=++m;v.push({id:y,callback:E}),e.globals.postMessage({vscodeSetImmediateId:y},"*")}}if(typeof(f==null?void 0:f.nextTick)=="function")return f.nextTick.bind(f);const o=Promise.resolve();return v=>o.then(v)}();var g;(function(n){n[n.Windows=1]="Windows",n[n.Macintosh=2]="Macintosh",n[n.Linux=3]="Linux"})(g=e.OperatingSystem||(e.OperatingSystem={})),e.OS=S||r?2:C?1:3;let t=!0,i=!1;function s(){if(!i){i=!0;const n=new Uint8Array(2);n[0]=1,n[1]=2,t=new Uint16Array(n.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(pe[37],ve([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let R;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const C=p.globals.vscode.process;R={get platform(){return C.platform},get env(){return C.env},cwd(){return C.cwd()},nextTick(S){return p.setImmediate(S)}}}else typeof process!="undefined"?R={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(C){return process.nextTick(C)}}:R={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(C){return p.setImmediate(C)},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.nextTick=R.nextTick}),define(pe[9],ve([0,1,37]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,C=97,S=90,A=122,P=46,_=47,D=92,r=58,k=63;class l extends Error{constructor(d,g,t){let i;typeof g=="string"&&g.indexOf("not ")===0?(i="must not be",g=g.replace(/^not /,"")):i="must be";const s=d.indexOf(".")!==-1?"property":"argument";let n=`The "${d}" ${s} ${i} of type ${g}`;n+=`. Received type ${typeof t}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function h(u,d){if(typeof u!="string")throw new l(d,"string",u)}function c(u){return u===_||u===D}function f(u){return u===_}function I(u){return u>=R&&u<=S||u>=C&&u<=A}function b(u,d,g,t){let i="",s=0,n=-1,o=0,v=0;for(let m=0;m<=u.length;++m){if(m<u.length)v=u.charCodeAt(m);else{if(t(v))break;v=_}if(t(v)){if(!(n===m-1||o===1))if(o===2){if(i.length<2||s!==2||i.charCodeAt(i.length-1)!==P||i.charCodeAt(i.length-2)!==P){if(i.length>2){const E=i.lastIndexOf(g);E===-1?(i="",s=0):(i=i.slice(0,E),s=i.length-1-i.lastIndexOf(g)),n=m,o=0;continue}else if(i.length!==0){i="",s=0,n=m,o=0;continue}}d&&(i+=i.length>0?`${g}..`:"..",s=2)}else i.length>0?i+=`${g}${u.slice(n+1,m)}`:i=u.slice(n+1,m),s=m-n-1;n=m,o=0}else v===P&&o!==-1?++o:o=-1}return i}function w(u,d){if(d===null||typeof d!="object")throw new l("pathObject","Object",d);const g=d.dir||d.root,t=d.base||`${d.name||""}${d.ext||""}`;return g?g===d.root?`${g}${t}`:`${g}${u}${t}`:t}e.win32={resolve(...u){let d="",g="",t=!1;for(let i=u.length-1;i>=-1;i--){let s;if(i>=0){if(s=u[i],h(s,"path"),s.length===0)continue}else d.length===0?s=p.cwd():(s=p.env[`=${d}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==d.toLowerCase()&&s.charCodeAt(2)===D)&&(s=`${d}\\`));const n=s.length;let o=0,v="",m=!1;const E=s.charCodeAt(0);if(n===1)c(E)&&(o=1,m=!0);else if(c(E))if(m=!0,c(s.charCodeAt(1))){let y=2,a=y;for(;y<n&&!c(s.charCodeAt(y));)y++;if(y<n&&y!==a){const T=s.slice(a,y);for(a=y;y<n&&c(s.charCodeAt(y));)y++;if(y<n&&y!==a){for(a=y;y<n&&!c(s.charCodeAt(y));)y++;(y===n||y!==a)&&(v=`\\\\${T}\\${s.slice(a,y)}`,o=y)}}}else o=1;else I(E)&&s.charCodeAt(1)===r&&(v=s.slice(0,2),o=2,n>2&&c(s.charCodeAt(2))&&(m=!0,o=3));if(v.length>0)if(d.length>0){if(v.toLowerCase()!==d.toLowerCase())continue}else d=v;if(t){if(d.length>0)break}else if(g=`${s.slice(o)}\\${g}`,t=m,m&&d.length>0)break}return g=b(g,!t,"\\",c),t?`${d}\\${g}`:`${d}${g}`||"."},normalize(u){h(u,"path");const d=u.length;if(d===0)return".";let g=0,t,i=!1;const s=u.charCodeAt(0);if(d===1)return f(s)?"\\":u;if(c(s))if(i=!0,c(u.charCodeAt(1))){let o=2,v=o;for(;o<d&&!c(u.charCodeAt(o));)o++;if(o<d&&o!==v){const m=u.slice(v,o);for(v=o;o<d&&c(u.charCodeAt(o));)o++;if(o<d&&o!==v){for(v=o;o<d&&!c(u.charCodeAt(o));)o++;if(o===d)return`\\\\${m}\\${u.slice(v)}\\`;o!==v&&(t=`\\\\${m}\\${u.slice(v,o)}`,g=o)}}}else g=1;else I(s)&&u.charCodeAt(1)===r&&(t=u.slice(0,2),g=2,d>2&&c(u.charCodeAt(2))&&(i=!0,g=3));let n=g<d?b(u.slice(g),!i,"\\",c):"";return n.length===0&&!i&&(n="."),n.length>0&&c(u.charCodeAt(d-1))&&(n+="\\"),t===void 0?i?`\\${n}`:n:i?`${t}\\${n}`:`${t}${n}`},isAbsolute(u){h(u,"path");const d=u.length;if(d===0)return!1;const g=u.charCodeAt(0);return c(g)||d>2&&I(g)&&u.charCodeAt(1)===r&&c(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let d,g;for(let s=0;s<u.length;++s){const n=u[s];h(n,"path"),n.length>0&&(d===void 0?d=g=n:d+=`\\${n}`)}if(d===void 0)return".";let t=!0,i=0;if(typeof g=="string"&&c(g.charCodeAt(0))){++i;const s=g.length;s>1&&c(g.charCodeAt(1))&&(++i,s>2&&(c(g.charCodeAt(2))?++i:t=!1))}if(t){for(;i<d.length&&c(d.charCodeAt(i));)i++;i>=2&&(d=`\\${d.slice(i)}`)}return e.win32.normalize(d)},relative(u,d){if(h(u,"from"),h(d,"to"),u===d)return"";const g=e.win32.resolve(u),t=e.win32.resolve(d);if(g===t||(u=g.toLowerCase(),d=t.toLowerCase(),u===d))return"";let i=0;for(;i<u.length&&u.charCodeAt(i)===D;)i++;let s=u.length;for(;s-1>i&&u.charCodeAt(s-1)===D;)s--;const n=s-i;let o=0;for(;o<d.length&&d.charCodeAt(o)===D;)o++;let v=d.length;for(;v-1>o&&d.charCodeAt(v-1)===D;)v--;const m=v-o,E=n<m?n:m;let y=-1,a=0;for(;a<E;a++){const O=u.charCodeAt(i+a);if(O!==d.charCodeAt(o+a))break;O===D&&(y=a)}if(a!==E){if(y===-1)return t}else{if(m>E){if(d.charCodeAt(o+a)===D)return t.slice(o+a+1);if(a===2)return t.slice(o+a)}n>E&&(u.charCodeAt(i+a)===D?y=a:a===2&&(y=3)),y===-1&&(y=0)}let T="";for(a=i+y+1;a<=s;++a)(a===s||u.charCodeAt(a)===D)&&(T+=T.length===0?"..":"\\..");return o+=y,T.length>0?`${T}${t.slice(o,v)}`:(t.charCodeAt(o)===D&&++o,t.slice(o,v))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const d=e.win32.resolve(u);if(d.length<=2)return u;if(d.charCodeAt(0)===D){if(d.charCodeAt(1)===D){const g=d.charCodeAt(2);if(g!==k&&g!==P)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(I(d.charCodeAt(0))&&d.charCodeAt(1)===r&&d.charCodeAt(2)===D)return`\\\\?\\${d}`;return u},dirname(u){h(u,"path");const d=u.length;if(d===0)return".";let g=-1,t=0;const i=u.charCodeAt(0);if(d===1)return c(i)?u:".";if(c(i)){if(g=t=1,c(u.charCodeAt(1))){let o=2,v=o;for(;o<d&&!c(u.charCodeAt(o));)o++;if(o<d&&o!==v){for(v=o;o<d&&c(u.charCodeAt(o));)o++;if(o<d&&o!==v){for(v=o;o<d&&!c(u.charCodeAt(o));)o++;if(o===d)return u;o!==v&&(g=t=o+1)}}}}else I(i)&&u.charCodeAt(1)===r&&(g=d>2&&c(u.charCodeAt(2))?3:2,t=g);let s=-1,n=!0;for(let o=d-1;o>=t;--o)if(c(u.charCodeAt(o))){if(!n){s=o;break}}else n=!1;if(s===-1){if(g===-1)return".";s=g}return u.slice(0,s)},basename(u,d){d!==void 0&&h(d,"ext"),h(u,"path");let g=0,t=-1,i=!0,s;if(u.length>=2&&I(u.charCodeAt(0))&&u.charCodeAt(1)===r&&(g=2),d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let n=d.length-1,o=-1;for(s=u.length-1;s>=g;--s){const v=u.charCodeAt(s);if(c(v)){if(!i){g=s+1;break}}else o===-1&&(i=!1,o=s+1),n>=0&&(v===d.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=o))}return g===t?t=o:t===-1&&(t=u.length),u.slice(g,t)}for(s=u.length-1;s>=g;--s)if(c(u.charCodeAt(s))){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(g,t)},extname(u){h(u,"path");let d=0,g=-1,t=0,i=-1,s=!0,n=0;u.length>=2&&u.charCodeAt(1)===r&&I(u.charCodeAt(0))&&(d=t=2);for(let o=u.length-1;o>=d;--o){const v=u.charCodeAt(o);if(c(v)){if(!s){t=o+1;break}continue}i===-1&&(s=!1,i=o+1),v===P?g===-1?g=o:n!==1&&(n=1):g!==-1&&(n=-1)}return g===-1||i===-1||n===0||n===1&&g===i-1&&g===t+1?"":u.slice(g,i)},format:w.bind(null,"\\"),parse(u){h(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const g=u.length;let t=0,i=u.charCodeAt(0);if(g===1)return c(i)?(d.root=d.dir=u,d):(d.base=d.name=u,d);if(c(i)){if(t=1,c(u.charCodeAt(1))){let y=2,a=y;for(;y<g&&!c(u.charCodeAt(y));)y++;if(y<g&&y!==a){for(a=y;y<g&&c(u.charCodeAt(y));)y++;if(y<g&&y!==a){for(a=y;y<g&&!c(u.charCodeAt(y));)y++;y===g?t=y:y!==a&&(t=y+1)}}}}else if(I(i)&&u.charCodeAt(1)===r){if(g<=2)return d.root=d.dir=u,d;if(t=2,c(u.charCodeAt(2))){if(g===3)return d.root=d.dir=u,d;t=3}}t>0&&(d.root=u.slice(0,t));let s=-1,n=t,o=-1,v=!0,m=u.length-1,E=0;for(;m>=t;--m){if(i=u.charCodeAt(m),c(i)){if(!v){n=m+1;break}continue}o===-1&&(v=!1,o=m+1),i===P?s===-1?s=m:E!==1&&(E=1):s!==-1&&(E=-1)}return o!==-1&&(s===-1||E===0||E===1&&s===o-1&&s===n+1?d.base=d.name=u.slice(n,o):(d.name=u.slice(n,s),d.base=u.slice(n,o),d.ext=u.slice(s,o))),n>0&&n!==t?d.dir=u.slice(0,n-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let d="",g=!1;for(let t=u.length-1;t>=-1&&!g;t--){const i=t>=0?u[t]:p.cwd();h(i,"path"),i.length!==0&&(d=`${i}/${d}`,g=i.charCodeAt(0)===_)}return d=b(d,!g,"/",f),g?`/${d}`:d.length>0?d:"."},normalize(u){if(h(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===_,g=u.charCodeAt(u.length-1)===_;return u=b(u,!d,"/",f),u.length===0?d?"/":g?"./":".":(g&&(u+="/"),d?`/${u}`:u)},isAbsolute(u){return h(u,"path"),u.length>0&&u.charCodeAt(0)===_},join(...u){if(u.length===0)return".";let d;for(let g=0;g<u.length;++g){const t=u[g];h(t,"path"),t.length>0&&(d===void 0?d=t:d+=`/${t}`)}return d===void 0?".":e.posix.normalize(d)},relative(u,d){if(h(u,"from"),h(d,"to"),u===d||(u=e.posix.resolve(u),d=e.posix.resolve(d),u===d))return"";const g=1,t=u.length,i=t-g,s=1,n=d.length-s,o=i<n?i:n;let v=-1,m=0;for(;m<o;m++){const y=u.charCodeAt(g+m);if(y!==d.charCodeAt(s+m))break;y===_&&(v=m)}if(m===o)if(n>o){if(d.charCodeAt(s+m)===_)return d.slice(s+m+1);if(m===0)return d.slice(s+m)}else i>o&&(u.charCodeAt(g+m)===_?v=m:m===0&&(v=0));let E="";for(m=g+v+1;m<=t;++m)(m===t||u.charCodeAt(m)===_)&&(E+=E.length===0?"..":"/..");return`${E}${d.slice(s+v)}`},toNamespacedPath(u){return u},dirname(u){if(h(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===_;let g=-1,t=!0;for(let i=u.length-1;i>=1;--i)if(u.charCodeAt(i)===_){if(!t){g=i;break}}else t=!1;return g===-1?d?"/":".":d&&g===1?"//":u.slice(0,g)},basename(u,d){d!==void 0&&h(d,"ext"),h(u,"path");let g=0,t=-1,i=!0,s;if(d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let n=d.length-1,o=-1;for(s=u.length-1;s>=0;--s){const v=u.charCodeAt(s);if(v===_){if(!i){g=s+1;break}}else o===-1&&(i=!1,o=s+1),n>=0&&(v===d.charCodeAt(n)?--n==-1&&(t=s):(n=-1,t=o))}return g===t?t=o:t===-1&&(t=u.length),u.slice(g,t)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===_){if(!i){g=s+1;break}}else t===-1&&(i=!1,t=s+1);return t===-1?"":u.slice(g,t)},extname(u){h(u,"path");let d=-1,g=0,t=-1,i=!0,s=0;for(let n=u.length-1;n>=0;--n){const o=u.charCodeAt(n);if(o===_){if(!i){g=n+1;break}continue}t===-1&&(i=!1,t=n+1),o===P?d===-1?d=n:s!==1&&(s=1):d!==-1&&(s=-1)}return d===-1||t===-1||s===0||s===1&&d===t-1&&d===g+1?"":u.slice(d,t)},format:w.bind(null,"/"),parse(u){h(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const g=u.charCodeAt(0)===_;let t;g?(d.root="/",t=1):t=0;let i=-1,s=0,n=-1,o=!0,v=u.length-1,m=0;for(;v>=t;--v){const E=u.charCodeAt(v);if(E===_){if(!o){s=v+1;break}continue}n===-1&&(o=!1,n=v+1),E===P?i===-1?i=v:m!==1&&(m=1):i!==-1&&(m=-1)}if(n!==-1){const E=s===0&&g?1:s;i===-1||m===0||m===1&&i===n-1&&i===s+1?d.base=d.name=u.slice(E,n):(d.name=u.slice(E,i),d.base=u.slice(E,n),d.ext=u.slice(i,n))}return s>0?d.dir=u.slice(0,s-1):g&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(pe[135],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var R;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(R=e.TerminateResponseCode||(e.TerminateResponseCode={}));function C(S,...A){const P=A.reduce((r,k)=>(r[k]=!0,r),{}),_=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(r=>!P[r]).forEach(r=>{for(let k=0;k<_.length;k++)if(r.search(_[k])!==-1){delete S[r];break}})}e.sanitizeProcessEnvironment=C}),define(pe[43],ve([0,1,11]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=p.globals.performance&&typeof p.globals.performance.now=="function";class C{constructor(A){this._highResolution=R&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new C(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=C}),define(pe[3],ve([0,1,14,69,6,71,43]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var P;(function(b){b.None=()=>C.Disposable.None;function w(q){return(x,H=null,N)=>{let z=!1,F;return F=q(M=>{if(!z)return F?F.dispose():z=!0,x.call(H,M)},null,N),z&&F.dispose(),F}}b.once=w;function u(q,x){return n((H,N=null,z)=>q(F=>H.call(N,x(F)),null,z))}b.map=u;function d(q,x){return n((H,N=null,z)=>q(F=>{x(F),H.call(N,F)},null,z))}b.forEach=d;function g(q,x){return n((H,N=null,z)=>q(F=>x(F)&&H.call(N,F),null,z))}b.filter=g;function t(q){return q}b.signal=t;function i(...q){return(x,H=null,N)=>C.combinedDisposable(...q.map(z=>z(F=>x.call(H,F),null,N)))}b.any=i;function s(q,x,H){let N=H;return u(q,z=>(N=x(N,z),N))}b.reduce=s;function n(q){let x;const H=new l({onFirstListenerAdd(){x=q(H.fire,H)},onLastListenerRemove(){x.dispose()}});return H.event}b.snapshot=n;function o(q,x,H=100,N=!1,z){let F,M,L,U=0;const G=new l({leakWarningThreshold:z,onFirstListenerAdd(){F=q(te=>{U++,M=x(M,te),N&&!L&&(G.fire(M),M=void 0),clearTimeout(L),L=setTimeout(()=>{const me=M;M=void 0,L=void 0,(!N||U>1)&&G.fire(me),U=0},H)})},onLastListenerRemove(){F.dispose()}});return G.event}b.debounce=o;function v(q){const x=new Date().getTime();return u(w(q),H=>new Date().getTime()-x)}b.stopwatch=v;function m(q,x=(H,N)=>H===N){let H=!0,N;return g(q,z=>{const F=H||!x(z,N);return H=!1,N=z,F})}b.latch=m;function E(q,x){return[b.filter(q,x),b.filter(q,H=>!x(H))]}b.split=E;function y(q,x=!1,H=[]){let N=H.slice(),z=q(L=>{N?N.push(L):M.fire(L)});const F=()=>{N&&N.forEach(L=>M.fire(L)),N=null},M=new l({onFirstListenerAdd(){z||(z=q(L=>M.fire(L)))},onFirstListenerDidAdd(){N&&(x?setTimeout(F):F())},onLastListenerRemove(){z&&z.dispose(),z=null}});return M.event}b.buffer=y;class a{constructor(x){this.event=x}map(x){return new a(u(this.event,x))}forEach(x){return new a(d(this.event,x))}filter(x){return new a(g(this.event,x))}reduce(x,H){return new a(s(this.event,x,H))}latch(){return new a(m(this.event))}debounce(x,H=100,N=!1,z){return new a(o(this.event,x,H,N,z))}on(x,H,N){return this.event(x,H,N)}once(x,H,N){return w(this.event)(x,H,N)}}function T(q){return new a(q)}b.chain=T;function O(q,x,H=N=>N){const N=(...L)=>M.fire(H(...L)),z=()=>q.on(x,N),F=()=>q.removeListener(x,N),M=new l({onFirstListenerAdd:z,onLastListenerRemove:F});return M.event}b.fromNodeEventEmitter=O;function $(q,x,H=N=>N){const N=(...L)=>M.fire(H(...L)),z=()=>q.addEventListener(x,N),F=()=>q.removeEventListener(x,N),M=new l({onFirstListenerAdd:z,onLastListenerRemove:F});return M.event}b.fromDOMEventEmitter=$;function Z(q){const x=new l;let H=!1;return q.then(void 0,()=>null).then(()=>{H?x.fire(void 0):setTimeout(()=>x.fire(void 0),0)}),H=!0,x.event}b.fromPromise=Z;function le(q){return new Promise(x=>w(q)(x))}b.toPromise=le})(P=e.Event||(e.Event={}));class _{constructor(w){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${w}_${_._idPool++}`}start(w){this._stopWatch=new A.StopWatch(!0),this._listenerCount=w}stop(){if(this._stopWatch){const w=this._stopWatch.elapsed();this._elapsedOverall+=w,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${w.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let D=-1;function r(b){const w=D;return D=b,{dispose(){D=w}}}e.setGlobalLeakWarningThreshold=r;class k{constructor(w,u=Math.random().toString(18).slice(2,5)){this.customThreshold=w,this.name=u,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(w){let u=D;if(typeof this.customThreshold=="number"&&(u=this.customThreshold),u<=0||w<u)return;this._stacks||(this._stacks=new Map);const d=new Error().stack.split(`
`).slice(3).join(`
`),g=this._stacks.get(d)||0;if(this._stacks.set(d,g+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=u*.5;let t,i=0;for(const[s,n]of this._stacks)(!t||i<n)&&(t=s,i=n);console.warn(`[${this.name}] potential listener LEAK detected, having ${w} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(d)||0;this._stacks.set(d,t-1)}}}class l{constructor(w){var u;this._disposed=!1,this._options=w,this._leakageMon=D>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((u=this._options)===null||u===void 0?void 0:u._profName)?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(w,u,d)=>{var g;this._listeners||(this._listeners=new S.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(u?[w,u]:w);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,w,u);const s=(g=this._leakageMon)===null||g===void 0?void 0:g.check(this._listeners.size);let n;return n={dispose:()=>{s&&s(),n.dispose=l._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},d instanceof C.DisposableStore?d.add(n):Array.isArray(d)&&d.push(n),n}),this._event}fire(w){var u,d;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new S.LinkedList);for(let g of this._listeners)this._deliveryQueue.push([g,w]);for((u=this._perfMon)===null||u===void 0||u.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[g,t]=this._deliveryQueue.shift();try{typeof g=="function"?g.call(void 0,t):g[0].call(g[1],t)}catch(i){p.onUnexpectedError(i)}}(d=this._perfMon)===null||d===void 0||d.stop()}}dispose(){var w,u,d,g,t;this._disposed||(this._disposed=!0,(w=this._listeners)===null||w===void 0||w.clear(),(u=this._deliveryQueue)===null||u===void 0||u.clear(),(g=(d=this._options)===null||d===void 0?void 0:d.onLastListenerRemove)===null||g===void 0||g.call(d),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=l,l._noop=function(){};class h extends l{constructor(w){super(w);this._isPaused=0,this._eventQueue=new S.LinkedList,this._mergeFn=w==null?void 0:w.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const w=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(w))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(w){this._listeners&&(this._isPaused!==0?this._eventQueue.push(w):super.fire(w))}}e.PauseableEmitter=h;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(w){const u={event:w,listener:null};this.events.push(u),this.hasListeners&&this.hook(u);const d=()=>{this.hasListeners&&this.unhook(u);const g=this.events.indexOf(u);this.events.splice(g,1)};return C.toDisposable(R.once(d))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(w=>this.hook(w))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(w=>this.unhook(w))}hook(w){w.listener=w.event(u=>this.emitter.fire(u))}unhook(w){w.listener&&w.listener.dispose(),w.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class f{constructor(){this.buffers=[]}wrapEvent(w){return(u,d,g)=>w(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>u.call(d,t)):u.call(d,t)},void 0,g)}bufferEvents(w){const u=[];this.buffers.push(u);const d=w();return this.buffers.pop(),u.forEach(g=>g()),d}}e.EventBufferer=f;class I{constructor(){this.listening=!1,this.inputEvent=P.None,this.inputEventListener=C.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(w){this.inputEvent=w,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=w(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(pe[21],ve([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(P,_){const D=setTimeout(P.bind(_),0);return{dispose(){clearTimeout(D)}}});var C;(function(P){function _(D){return D===P.None||D===P.Cancelled||D instanceof S?!0:!D||typeof D!="object"?!1:typeof D.isCancellationRequested=="boolean"&&typeof D.onCancellationRequested=="function"}P.isCancellationToken=_,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(C=e.CancellationToken||(e.CancellationToken={}));class S{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?R:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new S),this._token}cancel(){this._token?this._token instanceof S&&this._token.cancel():this._token=C.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof S&&this._token.dispose():this._token=C.None}}e.CancellationTokenSource=A}),define(pe[91],ve([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class R{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(k){const l=this._icons.get(k.id);l?k.description?l.description=k.description:console.error(`Duplicate registration of codicon ${k.id}`):(this._icons.set(k.id,k),this._onDidRegister.fire(k))}get(k){return this._icons.get(k)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const C=new R;e.iconRegistry=C;function S(r,k){return new P(r,k)}e.registerCodicon=S;function A(r){return r?r.replace(/\$\((.*?)\)/g,(k,l)=>` ${l} `).trim():""}e.getCodiconAriaLabel=A;class P{constructor(k,l,h){this.id=k,this.definition=l,this.description=h,C.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=P;function _(r,k){const l=["codicon","codicon-"+r];return k&&l.push("codicon-modifier-"+k),l}e.getClassNamesArray=_;var D;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const k=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function l(f){if(f instanceof P)return["codicon","codicon-"+f.id];const I=k.exec(f.id);if(!I)return l(P.error);let[,b,w]=I;const u=["codicon","codicon-"+b];return w&&u.push("codicon-modifier-"+w.substr(1)),u}r.asClassNameArray=l;function h(f){return l(f).join(" ")}r.asClassName=h;function c(f){return"."+l(f).join(".")}r.asCSSSelector=c})(D=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(P=e.Codicon||(e.Codicon={}))}),define(pe[92],ve([0,1,14,6]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function C(u){const d=u;return d?[d.on,d.pause,d.resume,d.destroy].every(g=>typeof g=="function"):!1}e.isReadableStream=C;function S(u){const d=u;return d?C(d.stream)&&Array.isArray(d.buffer)&&typeof d.ended=="boolean":!1}e.isReadableBufferedStream=S;function A(u,d){return new P(u,d)}e.newWriteableStream=A;class P{constructor(d,g){this.reducer=d,this.options=g,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(d){var g;if(!this.state.destroyed){if(this.state.flowing)this.emitData(d);else if(this.buffer.data.push(d),typeof((g=this.options)===null||g===void 0?void 0:g.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(d){this.state.destroyed||(this.state.flowing?this.emitError(d):this.buffer.error.push(d))}end(d){this.state.destroyed||(typeof d!="undefined"&&this.write(d),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(d){this.listeners.data.slice(0).forEach(g=>g(d))}emitError(d){this.listeners.error.length===0?p.onUnexpectedError(d):this.listeners.error.slice(0).forEach(g=>g(d))}emitEnd(){this.listeners.end.slice(0).forEach(d=>d())}on(d,g){if(!this.state.destroyed)switch(d){case"data":this.listeners.data.push(g),this.resume();break;case"end":this.listeners.end.push(g),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(g),this.state.flowing&&this.flowErrors();break}}removeListener(d,g){if(this.state.destroyed)return;let t;switch(d){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(g);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const d=this.reducer(this.buffer.data);this.emitData(d),this.buffer.data.length=0;const g=[...this.pendingWritePromises];this.pendingWritePromises.length=0,g.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const d of this.buffer.error)this.emitError(d);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(u,d){const g=[];let t;for(;(t=u.read())!==null;)g.push(t);return d(g)}e.consumeReadable=_;function D(u,d,g){const t=[];let i;for(;(i=u.read())!==null&&t.length<g;)t.push(i);return i===null&&t.length>0?d(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const s=i;return i=void 0,s}return u.read()}}}e.peekReadable=D;function r(u,d){return new Promise((g,t)=>{const i=[];k(u,{onData:s=>{d&&i.push(s)},onError:s=>{d?t(s):g(void 0)},onEnd:()=>{g(d?d(i):void 0)}})})}e.consumeStream=r;function k(u,d){u.on("error",g=>d.onError(g)),u.on("end",()=>d.onEnd()),u.on("data",g=>d.onData(g))}e.listenStream=k;function l(u,d){return new Promise((g,t)=>{const i=new R.DisposableStore,s=[],n=m=>{if(s.push(m),s.length>d)return i.dispose(),u.pause(),g({stream:u,buffer:s,ended:!1})},o=m=>t(m),v=()=>g({stream:u,buffer:s,ended:!0});i.add(R.toDisposable(()=>u.removeListener("error",o))),u.on("error",o),i.add(R.toDisposable(()=>u.removeListener("end",v))),u.on("end",v),i.add(R.toDisposable(()=>u.removeListener("data",n))),u.on("data",n)})}e.peekStream=l;function h(u,d){const g=A(d);return g.end(u),g}e.toStream=h;function c(){const u=A(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=c;function f(u){let d=!1;return{read:()=>d?null:(d=!0,u)}}e.toReadable=f;function I(u,d,g){const t=A(g);return k(u,{onData:i=>t.write(d.data(i)),onError:i=>t.error(d.error?d.error(i):i),onEnd:()=>t.end()}),t}e.transform=I;function b(u,d,g){let t=!1;return{read:()=>{const i=d.read();return t?i:(t=!0,i!==null?g([u,i]):u)}}}e.prefixedReadable=b;function w(u,d,g){let t=!1;const i=A(g);return k(d,{onData:s=>t?i.write(s):(t=!0,i.write(g([u,s]))),onError:s=>i.error(s),onEnd:()=>{t||(t=!0,i.write(u)),i.end()}}),i}e.prefixedStream=w}),define(pe[8],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function p(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=p;const R=/{(\d+)}/g;function C(W,...ee){return ee.length===0?W:W.replace(R,function(de,Ie){const Te=parseInt(Ie,10);return isNaN(Te)||Te<0||Te>=ee.length?de:ee[Te]})}e.format=C;function S(W){return W.replace(/[<>&]/g,function(ee){switch(ee){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ee}})}e.escape=S;function A(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=A;function P(W,ee){let de=0;const Ie=ee.charCodeAt(0);for(let Te=W.length-1;Te>=0;Te--)W.charCodeAt(Te)===Ie&&de++;return de}e.count=P;function _(W,ee,de="\u2026"){return W.length<=ee?W:`${W.substr(0,ee)}${de}`}e.truncate=_;function D(W,ee=" "){const de=r(W,ee);return k(de,ee)}e.trim=D;function r(W,ee){if(!W||!ee)return W;const de=ee.length;if(de===0||W.length===0)return W;let Ie=0;for(;W.indexOf(ee,Ie)===Ie;)Ie=Ie+de;return W.substring(Ie)}e.ltrim=r;function k(W,ee){if(!W||!ee)return W;const de=ee.length,Ie=W.length;if(de===0||Ie===0)return W;let Te=Ie,xe=-1;for(;xe=W.lastIndexOf(ee,Te-1),!(xe===-1||xe+de!==Te);){if(xe===0)return"";Te=xe}return W.substring(0,Te)}e.rtrim=k;function l(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=l;function h(W){return W.replace(/\*/g,"")}e.stripWildcards=h;function c(W,ee,de={}){if(!W)throw new Error("Cannot create regex from empty string");ee||(W=A(W)),de.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let Ie="";return de.global&&(Ie+="g"),de.matchCase||(Ie+="i"),de.multiline&&(Ie+="m"),de.unicode&&(Ie+="u"),new RegExp(W,Ie)}e.createRegExp=c;function f(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function I(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function b(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=b;function w(W){return W.split(/\r\n|\r|\n/)}e.splitLines=w;function u(W){for(let ee=0,de=W.length;ee<de;ee++){const Ie=W.charCodeAt(ee);if(Ie!==32&&Ie!==9)return ee}return-1}e.firstNonWhitespaceIndex=u;function d(W,ee=0,de=W.length){for(let Ie=ee;Ie<de;Ie++){const Te=W.charCodeAt(Ie);if(Te!==32&&Te!==9)return W.substring(ee,Ie)}return W.substring(ee,de)}e.getLeadingWhitespace=d;function g(W,ee=W.length-1){for(let de=ee;de>=0;de--){const Ie=W.charCodeAt(de);if(Ie!==32&&Ie!==9)return de}return-1}e.lastNonWhitespaceIndex=g;function t(W,ee){return W<ee?-1:W>ee?1:0}e.compare=t;function i(W,ee,de=0,Ie=W.length,Te=0,xe=ee.length){for(;de<Ie&&Te<xe;de++,Te++){let rt=W.charCodeAt(de),Xe=ee.charCodeAt(Te);if(rt<Xe)return-1;if(rt>Xe)return 1}const Ve=Ie-de,Ze=xe-Te;return Ve<Ze?-1:Ve>Ze?1:0}e.compareSubstring=i;function s(W,ee){return n(W,ee,0,W.length,0,ee.length)}e.compareIgnoreCase=s;function n(W,ee,de=0,Ie=W.length,Te=0,xe=ee.length){for(;de<Ie&&Te<xe;de++,Te++){let rt=W.charCodeAt(de),Xe=ee.charCodeAt(Te);if(rt===Xe)continue;const Je=rt-Xe;if(!(Je===32&&v(Xe))&&!(Je===-32&&v(rt)))return o(rt)&&o(Xe)?Je:i(W.toLowerCase(),ee.toLowerCase(),de,Ie,Te,xe)}const Ve=Ie-de,Ze=xe-Te;return Ve<Ze?-1:Ve>Ze?1:0}e.compareSubstringIgnoreCase=n;function o(W){return W>=97&&W<=122}e.isLowerAsciiLetter=o;function v(W){return W>=65&&W<=90}e.isUpperAsciiLetter=v;function m(W){return o(W)||v(W)}function E(W,ee){return W.length===ee.length&&y(W,ee)}e.equalsIgnoreCase=E;function y(W,ee,de=W.length){for(let Ie=0;Ie<de;Ie++){const Te=W.charCodeAt(Ie),xe=ee.charCodeAt(Ie);if(Te!==xe){if(m(Te)&&m(xe)){const Ve=Math.abs(Te-xe);if(Ve!==0&&Ve!==32)return!1}else if(String.fromCharCode(Te).toLowerCase()!==String.fromCharCode(xe).toLowerCase())return!1}}return!0}function a(W,ee){const de=ee.length;return ee.length>W.length?!1:y(W,ee,de)}e.startsWithIgnoreCase=a;function T(W,ee){let de,Ie=Math.min(W.length,ee.length);for(de=0;de<Ie;de++)if(W.charCodeAt(de)!==ee.charCodeAt(de))return de;return Ie}e.commonPrefixLength=T;function O(W,ee){let de,Ie=Math.min(W.length,ee.length);const Te=W.length-1,xe=ee.length-1;for(de=0;de<Ie;de++)if(W.charCodeAt(Te-de)!==ee.charCodeAt(xe-de))return de;return Ie}e.commonSuffixLength=O;function $(W){return 55296<=W&&W<=56319}e.isHighSurrogate=$;function Z(W){return 56320<=W&&W<=57343}e.isLowSurrogate=Z;function le(W,ee){return(W-55296<<10)+(ee-56320)+65536}e.computeCodePoint=le;function q(W,ee,de){const Ie=W.charCodeAt(de);if($(Ie)&&de+1<ee){const Te=W.charCodeAt(de+1);if(Z(Te))return le(Ie,Te)}return Ie}e.getNextCodePoint=q;function x(W,ee){const de=W.charCodeAt(ee-1);if(Z(de)&&ee>1){const Ie=W.charCodeAt(ee-2);if($(Ie))return le(Ie,de)}return de}function H(W,ee){const de=Ue.getInstance(),Ie=ee,Te=W.length,xe=q(W,Te,ee);ee+=xe>=65536?2:1;let Ve=de.getGraphemeBreakType(xe);for(;ee<Te;){const Ze=q(W,Te,ee),rt=de.getGraphemeBreakType(Ze);if(we(Ve,rt))break;ee+=Ze>=65536?2:1,Ve=rt}return ee-Ie}e.nextCharLength=H;function N(W,ee){const de=Ue.getInstance(),Ie=ee,Te=x(W,ee);ee-=Te>=65536?2:1;let xe=de.getGraphemeBreakType(Te);for(;ee>0;){const Ve=x(W,ee),Ze=de.getGraphemeBreakType(Ve);if(we(Ze,xe))break;ee-=Ve>=65536?2:1,xe=Ze}return Ie-ee}e.prevCharLength=N;function z(W,ee){const de=Ue.getInstance(),Ie=W.length,Te=ee,xe=q(W,Ie,ee),Ve=de.getGraphemeBreakType(xe);ee+=xe>=65536?2:1;let Ze=Ve;for(;ee<Ie;){const Xe=q(W,Ie,ee),Je=de.getGraphemeBreakType(Xe);if(we(Ze,Je))break;ee+=Xe>=65536?2:1,Ze=Je}const rt=ee;for(ee=Te,Ze=Ve;ee>0;){const Xe=x(W,ee),Je=de.getGraphemeBreakType(Xe);if(we(Je,Ze))break;ee-=Xe>=65536?2:1,Ze=Je}return[ee,rt]}function F(W,ee){return ee>0&&Z(W.charCodeAt(ee))?z(W,ee-1):z(W,ee)}e.getCharContainingOffset=F;function M(W){const ee=W.length;let de=0,Ie=0;for(;Ie<ee;){const Ve=q(W,ee,Ie);Ie+=Ve>=65536?2:1,Ve<128?de+=1:Ve<2048?de+=2:Ve<65536?de+=3:de+=4}const Te=new Uint8Array(de);Ie=0;let xe=0;for(;Ie<ee;){const Ve=q(W,ee,Ie);Ie+=Ve>=65536?2:1,Ve<128?Te[xe++]=Ve:Ve<2048?(Te[xe++]=192|(Ve&1984)>>>6,Te[xe++]=128|(Ve&63)>>>0):Ve<65536?(Te[xe++]=224|(Ve&61440)>>>12,Te[xe++]=128|(Ve&4032)>>>6,Te[xe++]=128|(Ve&63)>>>0):(Te[xe++]=240|(Ve&1835008)>>>18,Te[xe++]=128|(Ve&258048)>>>12,Te[xe++]=128|(Ve&4032)>>>6,Te[xe++]=128|(Ve&63)>>>0)}return Te}e.encodeUTF8=M;function L(W){const ee=W.byteLength,de=[];let Ie=0;for(;Ie<ee;){const Te=W[Ie];let xe;if(Te>=240&&Ie+3<ee?xe=(W[Ie++]&7)<<18>>>0|(W[Ie++]&63)<<12>>>0|(W[Ie++]&63)<<6>>>0|(W[Ie++]&63)<<0>>>0:Te>=224&&Ie+2<ee?xe=(W[Ie++]&15)<<12>>>0|(W[Ie++]&63)<<6>>>0|(W[Ie++]&63)<<0>>>0:Te>=192&&Ie+1<ee?xe=(W[Ie++]&31)<<6>>>0|(W[Ie++]&63)<<0>>>0:xe=W[Ie++],xe>=0&&xe<=55295||xe>=57344&&xe<=65535)de.push(String.fromCharCode(xe));else if(xe>=65536&&xe<=1114111){const Ve=xe-65536,Ze=55296+((Ve&1047552)>>>10),rt=56320+((Ve&1023)>>>0);de.push(String.fromCharCode(Ze)),de.push(String.fromCharCode(rt))}else de.push(String.fromCharCode(65533))}return de.join("")}e.decodeUTF8=L;const U=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function G(W){return U.test(W)}e.containsRTL=G;const te=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function me(W){return te.test(W)}e.containsEmoji=me;const Se=/^[\t\n\r\x20-\x7E]*$/;function ye(W){return Se.test(W)}e.isBasicASCII=ye,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Le(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=Le;function je(W){for(let ee=0,de=W.length;ee<de;ee++)if(ze(W.charCodeAt(ee)))return!0;return!1}e.containsFullWidthCharacter=je;function ze(W){return W=+W,W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=ze;function Ge(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129003||W>=129280&&W<=129535||W>=129648&&W<=129750}e.isEmojiImprecise=Ge;function j(W,ee){if(W.length<ee)return W;const de=/\b/g;let Ie=0;for(;de.test(W)&&!(W.length-de.lastIndex<ee);)Ie=de.lastIndex,de.lastIndex+=1;return W.substring(Ie).replace(/^\s/,"")}e.lcut=j;const Y=/\x1B\x5B[12]?K/g,ie=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function J(W){return W&&(W=W.replace(Y,""),W=W.replace(ie,""),W=W.replace(re,"")),W}e.removeAnsiEscapeCodes=J,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ce(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ce;function ge(W){return ce(W)?W.substr(1):W}e.stripUTF8BOM=ge;function Re(W,ee){if(!W||!ee||W.length<ee.length)return!1;const de=ee.length,Ie=W.toLowerCase();let Te=0,xe=-1;for(;Te<de;){const Ve=Ie.indexOf(ee[Te],xe+1);if(Ve<0)return!1;xe=Ve,Te++}return!0}e.fuzzyContains=Re;function He(W,ee=!1){return W?(ee&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=He;function be(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=be;function Qe(W,ee=1){if(ee===0)return"";let de=-1;do de=W.indexOf(`
`,de+1),ee--;while(ee>0&&de>=0);return de===-1?W:(W[de-1]==="\r"&&de--,W.substr(0,de))}e.getNLines=Qe;function Q(W){const ee=90-65+1;return W=W%(2*ee),W<ee?String.fromCharCode(97+W):String.fromCharCode(65+W-ee)}e.singleLetterHash=Q;function se(W){return Ue.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=se;function we(W,ee){return W===0?ee!==5&&ee!==7:W===2&&ee===3?!1:W===4||W===2||W===3||ee===4||ee===2||ee===3?!0:!(W===8&&(ee===8||ee===9||ee===11||ee===12)||(W===11||W===9)&&(ee===9||ee===10)||(W===12||W===10)&&ee===10||ee===5||ee===13||ee===7||W===1||W===13&&ee===14||W===6&&ee===6)}e.breakBetweenGraphemeBreakType=we;var Oe;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})(Oe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ue{constructor(){this._data=Ye()}static getInstance(){return Ue._INSTANCE||(Ue._INSTANCE=new Ue),Ue._INSTANCE}getGraphemeBreakType(ee){if(ee<32)return ee===10?3:ee===13?2:4;if(ee<127)return 0;const de=this._data,Ie=de.length/3;let Te=1;for(;Te<=Ie;)if(ee<de[3*Te])Te=2*Te;else if(ee>de[3*Te+1])Te=2*Te+1;else return de[3*Te+2];return 0}}Ue._INSTANCE=null;function Ye(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function De(W,ee){if(W===0)return 0;const de=_e(W,ee);if(de!==void 0)return de;const Ie=x(ee,W);return W-=Pe(Ie),W}e.getLeftDeleteOffset=De;function _e(W,ee){let de=x(ee,W);for(W-=Pe(de);ae(de)||de===65039||de===8419;){if(W===0)return;de=x(ee,W),W-=Pe(de)}if(!!Ge(de)){if(W>=0){const Ie=x(ee,W);Ie===8205&&(W-=Pe(Ie))}return W}}function Pe(W){return W>=65536?2:1}function ae(W){return 127995<=W&&W<=127999}var fe;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(fe||(fe={}))}),define(pe[22],ve([0,1,8,92]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const C=typeof Buffer!="undefined",S=typeof TextEncoder!="undefined",A=typeof TextDecoder!="undefined";let P,_;class D{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return C?new D(Buffer.allocUnsafe(m)):new D(new Uint8Array(m))}static wrap(m){return C&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new D(m)}static fromString(m,E){return!((E==null?void 0:E.dontUseNodeBuffer)||!1)&&C?new D(Buffer.from(m)):S?(P||(P=new TextEncoder),new D(P.encode(m))):new D(p.encodeUTF8(m))}static concat(m,E){if(typeof E=="undefined"){E=0;for(let T=0,O=m.length;T<O;T++)E+=m[T].byteLength}const y=D.alloc(E);let a=0;for(let T=0,O=m.length;T<O;T++){const $=m[T];y.set($,a),a+=$.byteLength}return y}toString(){return C?this.buffer.toString():A?(_||(_=new TextDecoder),_.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(m,E){return new D(this.buffer.subarray(m,E))}set(m,E){m instanceof D?this.buffer.set(m.buffer,E):this.buffer.set(m,E)}readUInt32BE(m){return l(this.buffer,m)}writeUInt32BE(m,E){h(this.buffer,m,E)}readUInt32LE(m){return c(this.buffer,m)}writeUInt32LE(m,E){f(this.buffer,m,E)}readUInt8(m){return I(this.buffer,m)}writeUInt8(m,E){b(this.buffer,m,E)}}e.VSBuffer=D;function r(v,m){return v[m+0]<<0>>>0|v[m+1]<<8>>>0}e.readUInt16LE=r;function k(v,m,E){v[E+0]=m&255,m=m>>>8,v[E+1]=m&255}e.writeUInt16LE=k;function l(v,m){return v[m]*2**24+v[m+1]*2**16+v[m+2]*2**8+v[m+3]}e.readUInt32BE=l;function h(v,m,E){v[E+3]=m,m=m>>>8,v[E+2]=m,m=m>>>8,v[E+1]=m,m=m>>>8,v[E]=m}e.writeUInt32BE=h;function c(v,m){return v[m+0]<<0>>>0|v[m+1]<<8>>>0|v[m+2]<<16>>>0|v[m+3]<<24>>>0}e.readUInt32LE=c;function f(v,m,E){v[E+0]=m&255,m=m>>>8,v[E+1]=m&255,m=m>>>8,v[E+2]=m&255,m=m>>>8,v[E+3]=m&255}e.writeUInt32LE=f;function I(v,m){return v[m]}e.readUInt8=I;function b(v,m,E){v[E]=m}e.writeUInt8=b;function w(v){return R.consumeReadable(v,m=>D.concat(m))}e.readableToBuffer=w;function u(v){return R.toReadable(v)}e.bufferToReadable=u;function d(v){return R.consumeStream(v,m=>D.concat(m))}e.streamToBuffer=d;async function g(v){return v.ended?D.concat(v.buffer):D.concat([...v.buffer,await d(v.stream)])}e.bufferedStreamToBuffer=g;function t(v){return R.toStream(v,m=>D.concat(m))}e.bufferToStream=t;function i(v){return R.transform(v,{data:m=>typeof m=="string"?D.fromString(m):D.wrap(m)},m=>D.concat(m))}e.streamToBufferReadableStream=i;function s(v){return R.newWriteableStream(m=>D.concat(m),v)}e.newWriteableBufferStream=s;function n(v,m){return R.prefixedReadable(v,m,E=>D.concat(E))}e.prefixedBufferReadable=n;function o(v,m){return R.prefixedStream(v,m,E=>D.concat(E))}e.prefixedBufferStream=o}),define(pe[73],ve([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function R(b){return C(b,0)}e.hash=R;function C(b,w){switch(typeof b){case"object":return b===null?S(349,w):Array.isArray(b)?_(b,w):D(b,w);case"string":return P(b,w);case"boolean":return A(b,w);case"number":return S(b,w);case"undefined":return S(937,w);default:return S(617,w)}}e.doHash=C;function S(b,w){return(w<<5)-w+b|0}function A(b,w){return S(b?433:863,w)}function P(b,w){w=S(149417,w);for(let u=0,d=b.length;u<d;u++)w=S(b.charCodeAt(u),w);return w}e.stringHash=P;function _(b,w){return w=S(104579,w),b.reduce((u,d)=>C(d,u),w)}function D(b,w){return w=S(181387,w),Object.keys(b).sort().reduce((u,d)=>(u=P(d,u),C(b[d],u)),w)}class r{constructor(){this._value=0}get value(){return this._value}hash(w){return this._value=C(w,this._value),this._value}}e.Hasher=r;var k;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function l(b,w,u=32){const d=u-w,g=~((1<<d)-1);return(b<<w|(g&b)>>>d)>>>0}function h(b,w=0,u=b.byteLength,d=0){for(let g=0;g<u;g++)b[w+g]=d}function c(b,w,u="0"){for(;b.length<w;)b=u+b;return b}function f(b,w=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(u=>u.toString(16).padStart(2,"0")).join(""):c((b>>>0).toString(16),w/4)}e.toHexString=f;class I{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(w){const u=w.length;if(u===0)return;const d=this._buff;let g=this._buffLen,t=this._leftoverHighSurrogate,i,s;for(t!==0?(i=t,s=-1,t=0):(i=w.charCodeAt(0),s=0);;){let n=i;if(p.isHighSurrogate(i))if(s+1<u){const o=w.charCodeAt(s+1);p.isLowSurrogate(o)?(s++,n=p.computeCodePoint(i,o)):n=65533}else{t=i;break}else p.isLowSurrogate(i)&&(n=65533);if(g=this._push(d,g,n),s++,s<u)i=w.charCodeAt(s);else break}this._buffLen=g,this._leftoverHighSurrogate=t}_push(w,u,d){return d<128?w[u++]=d:d<2048?(w[u++]=192|(d&1984)>>>6,w[u++]=128|(d&63)>>>0):d<65536?(w[u++]=224|(d&61440)>>>12,w[u++]=128|(d&4032)>>>6,w[u++]=128|(d&63)>>>0):(w[u++]=240|(d&1835008)>>>18,w[u++]=128|(d&258048)>>>12,w[u++]=128|(d&4032)>>>6,w[u++]=128|(d&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),f(this._h0)+f(this._h1)+f(this._h2)+f(this._h3)+f(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const w=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(w/4294967296),!1),this._buffDV.setUint32(60,w%4294967296,!1),this._step()}_step(){const w=I._bigBlock32,u=this._buffDV;for(let m=0;m<64;m+=4)w.setUint32(m,u.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)w.setUint32(m,l(w.getUint32(m-12,!1)^w.getUint32(m-32,!1)^w.getUint32(m-56,!1)^w.getUint32(m-64,!1),1),!1);let d=this._h0,g=this._h1,t=this._h2,i=this._h3,s=this._h4,n,o,v;for(let m=0;m<80;m++)m<20?(n=g&t|~g&i,o=1518500249):m<40?(n=g^t^i,o=1859775393):m<60?(n=g&t|g&i|t&i,o=2400959708):(n=g^t^i,o=3395469782),v=l(d,5)+n+s+o+w.getUint32(m*4,!1)&4294967295,s=i,i=t,t=l(g,30),g=d,d=v;this._h0=this._h0+d&4294967295,this._h1=this._h1+g&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=I,I._bigBlock32=new DataView(new ArrayBuffer(320))}),define(pe[54],ve([0,1,8]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(C){C[C.Ignore=0]="Ignore",C[C.Info=1]="Info",C[C.Warning=2]="Warning",C[C.Error=3]="Error"})(R||(R={})),function(C){const S="error",A="warning",P="warn",_="info",D="ignore";function r(l){return l?p.equalsIgnoreCase(S,l)?C.Error:p.equalsIgnoreCase(A,l)||p.equalsIgnoreCase(P,l)?C.Warning:p.equalsIgnoreCase(_,l)?C.Info:C.Ignore:C.Ignore}C.fromValue=r;function k(l){switch(l){case C.Error:return S;case C.Warning:return A;case C.Info:return _;default:return D}}C.toString=k}(R||(R={})),e.default=R}),define(pe[15],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(m){return Array.isArray(m)}e.isArray=p;function R(m){return typeof m=="string"}e.isString=R;function C(m){return Array.isArray(m)&&m.every(E=>R(E))}e.isStringArray=C;function S(m){return typeof m=="object"&&m!==null&&!Array.isArray(m)&&!(m instanceof RegExp)&&!(m instanceof Date)}e.isObject=S;function A(m){return typeof m=="number"&&!isNaN(m)}e.isNumber=A;function P(m){return!!m&&typeof m[Symbol.iterator]=="function"}e.isIterable=P;function _(m){return m===!0||m===!1}e.isBoolean=_;function D(m){return typeof m=="undefined"}e.isUndefined=D;function r(m){return!k(m)}e.isDefined=r;function k(m){return D(m)||m===null}e.isUndefinedOrNull=k;function l(m,E){if(!m)throw new Error(E?`Unexpected type, expected '${E}'`:"Unexpected type")}e.assertType=l;function h(m){if(k(m))throw new Error("Assertion Failed: argument is undefined or null");return m}e.assertIsDefined=h;function c(...m){const E=[];for(let y=0;y<m.length;y++){const a=m[y];if(k(a))throw new Error(`Assertion Failed: argument at index ${y} is undefined or null`);E.push(a)}return E}e.assertAllDefined=c;const f=Object.prototype.hasOwnProperty;function I(m){if(!S(m))return!1;for(let E in m)if(f.call(m,E))return!1;return!0}e.isEmptyObject=I;function b(m){return typeof m=="function"}e.isFunction=b;function w(...m){return m.length>0&&m.every(b)}e.areFunctions=w;function u(m,E){const y=Math.min(m.length,E.length);for(let a=0;a<y;a++)d(m[a],E[a])}e.validateConstraints=u;function d(m,E){if(R(E)){if(typeof m!==E)throw new Error(`argument does not match constraint: typeof ${E}`)}else if(b(E)){try{if(m instanceof E)return}catch(y){}if(!k(m)&&m.constructor===E||E.length===1&&E.call(void 0,m)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function g(m){let E=[],y=Object.getPrototypeOf(m);for(;Object.prototype!==y;)E=E.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return E}e.getAllPropertyNames=g;function t(m){const E=[];for(const y of g(m))typeof m[y]=="function"&&E.push(y);return E}e.getAllMethodNames=t;function i(m,E){const y=T=>function(){const O=Array.prototype.slice.call(arguments,0);return E(T,O)};let a={};for(const T of m)a[T]=y(T);return a}e.createProxyObject=i;function s(m){return m===null?void 0:m}e.withNullAsUndefined=s;function n(m){return typeof m=="undefined"?null:m}e.withUndefinedAsNull=n;function o(m){return class{constructor(){return new Proxy({},{get(E,y){if(E[y])return E[y];throw new Error(`Not Implemented: ${m}->${String(y)}`)}})}}}e.NotImplementedProxy=o;function v(m){throw new Error("Unreachable")}e.assertNever=v}),define(pe[29],ve([0,1,11,8,9,15]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(s){return s===47||s===92}e.isPathSeparator=A;function P(s){return s.replace(/[\\/]/g,C.posix.sep)}e.toSlashes=P;function _(s){return s.indexOf("/")===-1&&(s=P(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=_;function D(s,n=C.posix.sep){if(!s)return"";const o=s.length,v=s.charCodeAt(0);if(A(v)){if(A(s.charCodeAt(1))&&!A(s.charCodeAt(2))){let E=3;const y=E;for(;E<o&&!A(s.charCodeAt(E));E++);if(y!==E&&!A(s.charCodeAt(E+1))){for(E+=1;E<o;E++)if(A(s.charCodeAt(E)))return s.slice(0,E+1).replace(/[\\/]/g,n)}}return n}else if(b(v)&&s.charCodeAt(1)===58)return A(s.charCodeAt(2))?s.slice(0,2)+n:s.slice(0,2);let m=s.indexOf("://");if(m!==-1){for(m+=3;m<o;m++)if(A(s.charCodeAt(m)))return s.slice(0,m+1)}return""}e.getRoot=D;function r(s){if(!p.isWindows||!s||s.length<5)return!1;let n=s.charCodeAt(0);if(n!==92||(n=s.charCodeAt(1),n!==92))return!1;let o=2;const v=o;for(;o<s.length&&(n=s.charCodeAt(o),n!==92);o++);return!(v===o||(n=s.charCodeAt(o+1),isNaN(n)||n===92))}e.isUNC=r;const k=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,n=p.isWindows){const o=n?k:l;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||n&&h.test(s)||s==="."||s===".."||n&&s[s.length-1]==="."||n&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function f(s,n,o){const v=s===n;return!o||v?v:!s||!n?!1:R.equalsIgnoreCase(s,n)}e.isEqual=f;function I(s,n,o,v=C.sep){if(s===n)return!0;if(!s||!n||n.length>s.length)return!1;if(o){if(!R.startsWithIgnoreCase(s,n))return!1;if(n.length===s.length)return!0;let E=n.length;return n.charAt(n.length-1)===v&&E--,s.charAt(E)===v}return n.charAt(n.length-1)!==v&&(n+=v),s.indexOf(n)===0}e.isEqualOrParent=I;function b(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=b;function w(s,n){return p.isWindows&&s.endsWith(":")&&(s+=C.sep),C.isAbsolute(s)||(s=C.join(n,s)),s=C.normalize(s),p.isWindows?(s=R.rtrim(s,C.sep),s.endsWith(":")&&(s+=C.sep)):(s=R.rtrim(s,C.sep),s||(s=C.sep)),s}e.sanitizeFilePath=w;function u(s){const n=C.normalize(s);return p.isWindows?s.length>3?!1:d(n)&&(s.length===2||n.charCodeAt(2)===92):n===C.posix.sep}e.isRootOrDriveLetter=u;function d(s){return p.isWindows?b(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function g(s){return d(s)?s[0]:void 0}e.getDriveLetter=g;function t(s,n,o){return n.length>s.length?-1:s===n?0:(o&&(s=s.toLowerCase(),n=n.toLowerCase()),s.indexOf(n))}e.indexOfPath=t;function i(s){const n=s.split(":");let o,v,m;if(n.forEach(E=>{const y=Number(E);S.isNumber(y)?v===void 0?v=y:m===void 0&&(m=y):o=o?[o,E].join(":"):E}),!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:v!==void 0?v:void 0,column:m!==void 0?m:v!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(pe[25],ve([0,1,15]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(f){if(!f||typeof f!="object"||f instanceof RegExp)return f;const I=Array.isArray(f)?[]:{};return Object.keys(f).forEach(b=>{f[b]&&typeof f[b]=="object"?I[b]=R(f[b]):I[b]=f[b]}),I}e.deepClone=R;function C(f){if(!f||typeof f!="object")return f;const I=[f];for(;I.length>0;){const b=I.shift();Object.freeze(b);for(const w in b)if(S.call(b,w)){const u=b[w];typeof u=="object"&&!Object.isFrozen(u)&&I.push(u)}}return f}e.deepFreeze=C;const S=Object.prototype.hasOwnProperty;function A(f,I){return P(f,I,new Set)}e.cloneAndChange=A;function P(f,I,b){if(p.isUndefinedOrNull(f))return f;const w=I(f);if(typeof w!="undefined")return w;if(p.isArray(f)){const u=[];for(const d of f)u.push(P(d,I,b));return u}if(p.isObject(f)){if(b.has(f))throw new Error("Cannot clone recursive data-structure");b.add(f);const u={};for(let d in f)S.call(f,d)&&(u[d]=P(f[d],I,b));return b.delete(f),u}return f}function _(f,I,b=!0){return p.isObject(f)?(p.isObject(I)&&Object.keys(I).forEach(w=>{w in f?b&&(p.isObject(f[w])&&p.isObject(I[w])?_(f[w],I[w],b):f[w]=I[w]):f[w]=I[w]}),f):I}e.mixin=_;function D(f,I){if(f===I)return!0;if(f==null||I===null||I===void 0||typeof f!=typeof I||typeof f!="object"||Array.isArray(f)!==Array.isArray(I))return!1;let b,w;if(Array.isArray(f)){if(f.length!==I.length)return!1;for(b=0;b<f.length;b++)if(!D(f[b],I[b]))return!1}else{const u=[];for(w in f)u.push(w);u.sort();const d=[];for(w in I)d.push(w);if(d.sort(),!D(u,d))return!1;for(b=0;b<u.length;b++)if(!D(f[u[b]],I[u[b]]))return!1}return!0}e.equals=D;function r(f){const I=new Set;return JSON.stringify(f,(b,w)=>{if(p.isObject(w)||Array.isArray(w)){if(I.has(w))return"[Circular]";I.add(w)}return w})}e.safeStringify=r;function k(f,I,b){const w=I(f);return typeof w=="undefined"?b:w}e.getOrDefault=k;function l(f,I){const b=Object.create(null);return!f||!I||Object.keys(I).forEach(u=>{const d=f[u],g=I[u];D(d,g)||(b[u]=g)}),b}e.distinct=l;function h(f,I){const b=I.toLowerCase(),w=Object.keys(f).find(u=>u.toLowerCase()===b);return w?f[w]:f[I]}e.getCaseInsensitive=h;function c(f,I){const b=Object.create(null);for(const w of Object.keys(f))I(w,f[w])&&(b[w]=f[w]);return b}e.filter=c}),define(pe[93],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var p;(function(S){S[S.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",S[S.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",S[S.MAX_UINT_8=255]="MAX_UINT_8",S[S.MAX_UINT_16=65535]="MAX_UINT_16",S[S.MAX_UINT_32=4294967295]="MAX_UINT_32",S[S.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(p=e.Constants||(e.Constants={}));function R(S){return S<0?0:S>255?255:S|0}e.toUint8=R;function C(S){return S<0?0:S>4294967295?4294967295:S|0}e.toUint32=C}),define(pe[2],ve([0,1,11,9]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const C=/^\w[\w\d+.-]*$/,S=/^\//,A=/^\/\//;function P(s,n){if(!s.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!C.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!S.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(s,n){return!s&&!n?"file":s}function D(s,n){switch(s){case"https":case"http":case"file":n?n[0]!==k&&(n=k+n):n=k;break}return n}const r="",k="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(n,o,v,m,E,y=!1){typeof n=="object"?(this.scheme=n.scheme||r,this.authority=n.authority||r,this.path=n.path||r,this.query=n.query||r,this.fragment=n.fragment||r):(this.scheme=_(n,y),this.authority=o||r,this.path=D(this.scheme,v||r),this.query=m||r,this.fragment=E||r,P(this,y))}static isUri(n){return n instanceof h?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return u(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:v,path:m,query:E,fragment:y}=n;return o===void 0?o=this.scheme:o===null&&(o=r),v===void 0?v=this.authority:v===null&&(v=r),m===void 0?m=this.path:m===null&&(m=r),E===void 0?E=this.query:E===null&&(E=r),y===void 0?y=this.fragment:y===null&&(y=r),o===this.scheme&&v===this.authority&&m===this.path&&E===this.query&&y===this.fragment?this:new f(o,v,m,E,y)}static parse(n,o=!1){const v=l.exec(n);return v?new f(v[2]||r,i(v[4]||r),i(v[5]||r),i(v[7]||r),i(v[9]||r),o):new f(r,r,r,r,r)}static file(n){let o=r;if(p.isWindows&&(n=n.replace(/\\/g,k)),n[0]===k&&n[1]===k){const v=n.indexOf(k,2);v===-1?(o=n.substring(2),n=k):(o=n.substring(2,v),n=n.substring(v)||k)}return new f("file",o,n,r,r)}static from(n){const o=new f(n.scheme,n.authority,n.path,n.query,n.fragment);return P(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let v;return p.isWindows&&n.scheme==="file"?v=h.file(R.win32.join(u(n,!0),...o)).path:v=R.posix.join(n.path,...o),n.with({path:v})}toString(n=!1){return d(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof h)return n;{const o=new f(n);return o._formatted=n.external,o._fsPath=n._sep===c?n.fsPath:null,o}}else return n}}e.URI=h;const c=p.isWindows?1:void 0;class f extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(n=!1){return n?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=c),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(s,n){let o,v=-1;for(let m=0;m<s.length;m++){const E=s.charCodeAt(m);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47)v!==-1&&(o+=encodeURIComponent(s.substring(v,m)),v=-1),o!==void 0&&(o+=s.charAt(m));else{o===void 0&&(o=s.substr(0,m));const y=I[E];y!==void 0?(v!==-1&&(o+=encodeURIComponent(s.substring(v,m)),v=-1),o+=y):v===-1&&(v=m)}}return v!==-1&&(o+=encodeURIComponent(s.substring(v))),o!==void 0?o:s}function w(s){let n;for(let o=0;o<s.length;o++){const v=s.charCodeAt(o);v===35||v===63?(n===void 0&&(n=s.substr(0,o)),n+=I[v]):n!==void 0&&(n+=s[o])}return n!==void 0?n:s}function u(s,n){let o;return s.authority&&s.path.length>1&&s.scheme==="file"?o=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?n?o=s.path.substr(1):o=s.path[1].toLowerCase()+s.path.substr(2):o=s.path,p.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=u;function d(s,n){const o=n?w:b;let v="",{scheme:m,authority:E,path:y,query:a,fragment:T}=s;if(m&&(v+=m,v+=":"),(E||m==="file")&&(v+=k,v+=k),E){let O=E.indexOf("@");if(O!==-1){const $=E.substr(0,O);E=E.substr(O+1),O=$.indexOf(":"),O===-1?v+=o($,!1):(v+=o($.substr(0,O),!1),v+=":",v+=o($.substr(O+1),!1)),v+="@"}E=E.toLowerCase(),O=E.indexOf(":"),O===-1?v+=o(E,!1):(v+=o(E.substr(0,O),!1),v+=E.substr(O))}if(y){if(y.length>=3&&y.charCodeAt(0)===47&&y.charCodeAt(2)===58){const O=y.charCodeAt(1);O>=65&&O<=90&&(y=`/${String.fromCharCode(O+32)}:${y.substr(3)}`)}else if(y.length>=2&&y.charCodeAt(1)===58){const O=y.charCodeAt(0);O>=65&&O<=90&&(y=`${String.fromCharCode(O+32)}:${y.substr(2)}`)}v+=o(y,!0)}return a&&(v+="?",v+=o(a,!1)),T&&(v+="#",v+=n?T:b(T,!1)),v}function g(s){try{return decodeURIComponent(s)}catch(n){return s.length>3?s.substr(0,3)+g(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(s){return s.match(t)?s.replace(t,n=>g(n)):s}});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(pe[23],ve([0,1,2,8]),function(X,e,p,R){"use strict";var C,S,A;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function P(t,i,s){let n=t.get(i);return n===void 0&&(n=s,t.set(i,n)),n}e.getOrSet=P;function _(t){const i=[];return t.forEach((s,n)=>{i.push(`${n} => ${s}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=_;function D(t){const i=[];return t.forEach(s=>{i.push(s)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=D;class r{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const s=i.charCodeAt(0),n=this._value.charCodeAt(this._pos);return s-n}value(){return this._value[this._pos]}}e.StringIterator=r;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?R.compareSubstring(i,this._value,0,i.length,this._from,this._to):R.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class l{constructor(i=!0,s=!0){this._splitOnBackslash=i,this._caseSensitive=s}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?R.compareSubstring(i,this._value,0,i.length,this._from,this._to):R.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=l;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class c{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return R.compareIgnoreCase(i,this._value.scheme);if(this._states[this._stateIdx]===2)return R.compareIgnoreCase(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return R.compare(i,this._value.query);if(this._states[this._stateIdx]===5)return R.compare(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class f{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(i){this._iter=i}static forUris(i=()=>!1){return new I(new c(i))}static forPaths(){return new I(new l)}static forStrings(){return new I(new r)}static forConfigKeys(){return new I(new k)}clear(){this._root=void 0}set(i,s){const n=this._iter.reset(i);let o;for(this._root||(this._root=new f,this._root.segment=n.value()),o=this._root;;){const m=n.cmp(o.segment);if(m>0)o.left||(o.left=new f,o.left.segment=n.value()),o=o.left;else if(m<0)o.right||(o.right=new f,o.right.segment=n.value()),o=o.right;else if(n.hasNext())n.next(),o.mid||(o.mid=new f,o.mid.segment=n.value()),o=o.mid;else break}const v=o.value;return o.value=s,o.key=i,v}get(i){var s;return(s=this._getNode(i))===null||s===void 0?void 0:s.value}_getNode(i){const s=this._iter.reset(i);let n=this._root;for(;n;){const o=s.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else break}return n}has(i){const s=this._getNode(i);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,s){const n=this._iter.reset(i),o=[];let v=this._root;for(;v;){const m=n.cmp(v.segment);if(m>0)o.push([1,v]),v=v.left;else if(m<0)o.push([-1,v]),v=v.right;else if(n.hasNext())n.next(),o.push([0,v]),v=v.mid;else{for(s?(v.left=void 0,v.mid=void 0,v.right=void 0):v.value=void 0;o.length>0&&v.isEmpty();){let[E,y]=o.pop();switch(E){case 1:y.left=void 0;break;case 0:y.mid=void 0;break;case-1:y.right=void 0;break}v=y}break}}}findSubstr(i){const s=this._iter.reset(i);let n=this._root,o;for(;n;){const v=s.cmp(n.segment);if(v>0)n=n.left;else if(v<0)n=n.right;else if(s.hasNext())s.next(),o=n.value||o,n=n.mid;else break}return n&&n.value||o}findSuperstr(i){const s=this._iter.reset(i);let n=this._root;for(;n;){const o=s.cmp(n.segment);if(o>0)n=n.left;else if(o<0)n=n.right;else if(s.hasNext())s.next(),n=n.mid;else return n.mid?this._entries(n.mid):void 0}}forEach(i){for(const[s,n]of this)i(n,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){if(!i)return;const s=[i];for(;s.length>0;){const n=s.pop();n&&(n.value&&(yield[n.key,n.value]),n.left&&s.push(n.left),n.mid&&s.push(n.mid),n.right&&s.push(n.right))}}}e.TernarySearchTree=I;class b{constructor(i,s){this[C]="ResourceMap",i instanceof b?(this.map=new Map(i.map),this.toKey=s??b.defaultToKey):(this.map=new Map,this.toKey=i??b.defaultToKey)}set(i,s){return this.map.set(this.toKey(i),s),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,s){typeof s!="undefined"&&(i=i.bind(s));for(let[n,o]of this.map)i(o,p.URI.parse(n),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield p.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[p.URI.parse(i[0]),i[1]]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[p.URI.parse(i[0]),i[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var w;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(w=e.Touch||(e.Touch={}));class u{constructor(){this[S]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,s=0){const n=this._map.get(i);if(!!n)return s!==0&&this.touch(n,s),n.value}set(i,s,n=0){let o=this._map.get(i);if(o)o.value=s,n!==0&&this.touch(o,n);else{switch(o={key:i,value:s,next:void 0,previous:void 0},n){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(i,o),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const s=this._map.get(i);if(!!s)return this._map.delete(i),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,s){const n=this._state;let o=this._head;for(;o;){if(s?i.bind(s)(o.value,o.key,this):i(o.value,o.key,this),this._state!==n)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.key,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}values(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:n.value,done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}entries(){const i=this,s=this._state;let n=this._head;const o={[Symbol.iterator](){return o},next(){if(i._state!==s)throw new Error("LinkedMap got modified during iteration.");if(n){const v={value:[n.key,n.value],done:!1};return n=n.next,v}else return{value:void 0,done:!0}}};return o}[(S=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let s=this._head,n=this.size;for(;s&&n>i;)this._map.delete(s.key),s=s.next,n--;this._head=s,this._size=n,s&&(s.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const s=i.next,n=i.previous;if(!s||!n)throw new Error("Invalid list");s.previous=n,n.next=s}i.next=void 0,i.previous=void 0,this._state++}touch(i,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(i===this._head)return;const n=i.next,o=i.previous;i===this._tail?(o.next=void 0,this._tail=o):(n.previous=o,o.next=n),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(s===2){if(i===this._tail)return;const n=i.next,o=i.previous;i===this._head?(n.previous=void 0,this._head=n):(n.previous=o,o.next=n),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((s,n)=>{i.push([n,s])}),i}fromJSON(i){this.clear();for(const[s,n]of i)this.set(s,n)}}e.LinkedMap=u;class d extends u{constructor(i,s=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,s=2){return super.get(i,s)}peek(i){return super.get(i,0)}set(i,s){return super.set(i,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=d;class g{constructor(i){A.set(this,void 0),it(this,A,i,"f")}get size(){return $e(this,A,"f").size}forEach(i,s){$e(this,A,"f").forEach(i,s)}get(i){return $e(this,A,"f").get(i)}has(i){return $e(this,A,"f").has(i)}entries(){return $e(this,A,"f").entries()}keys(){return $e(this,A,"f").keys()}values(){return $e(this,A,"f").values()}[(A=new WeakMap,Symbol.iterator)](){return $e(this,A,"f").entries()}}e.ReadonlyMapView=g}),define(pe[94],ve([0,1,23,8]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function C(...J){return function(ce,ge){for(let Re=0,He=J.length;Re<He;Re++){const be=J[Re](ce,ge);if(be)return be}return null}}e.or=C,e.matchesStrictPrefix=S.bind(void 0,!1),e.matchesPrefix=S.bind(void 0,!0);function S(J,ce,ge){if(!ge||ge.length<ce.length)return null;let Re;return J?Re=R.startsWithIgnoreCase(ge,ce):Re=ge.indexOf(ce)===0,Re?ce.length>0?[{start:0,end:ce.length}]:[]:null}function A(J,ce){const ge=ce.toLowerCase().indexOf(J.toLowerCase());return ge===-1?null:[{start:ge,end:ge+J.length}]}e.matchesContiguousSubString=A;function P(J,ce){return _(J.toLowerCase(),ce.toLowerCase(),0,0)}e.matchesSubString=P;function _(J,ce,ge,Re){if(ge===J.length)return[];if(Re===ce.length)return null;if(J[ge]===ce[Re]){let He=null;return(He=_(J,ce,ge+1,Re+1))?b({start:Re,end:Re+1},He):null}return _(J,ce,ge,Re+1)}function D(J){return 97<=J&&J<=122}function r(J){return 65<=J&&J<=90}e.isUpper=r;function k(J){return 48<=J&&J<=57}function l(J){return J===32||J===9||J===10||J===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(J=>h.add(J.charCodeAt(0)));function c(J){return l(J)||h.has(J)}function f(J,ce){return J===ce||c(J)&&c(ce)}function I(J){return D(J)||r(J)||k(J)}function b(J,ce){return ce.length===0?ce=[J]:J.end===ce[0].start?ce[0].start=J.start:ce.unshift(J),ce}function w(J,ce){for(let ge=ce;ge<J.length;ge++){const Re=J.charCodeAt(ge);if(r(Re)||k(Re)||ge>0&&!I(J.charCodeAt(ge-1)))return ge}return J.length}function u(J,ce,ge,Re){if(ge===J.length)return[];if(Re===ce.length)return null;if(J[ge]!==ce[Re].toLowerCase())return null;{let He=null,be=Re+1;for(He=u(J,ce,ge+1,Re+1);!He&&(be=w(ce,be))<ce.length;)He=u(J,ce,ge+1,be),be++;return He===null?null:b({start:Re,end:Re+1},He)}}function d(J){let ce=0,ge=0,Re=0,He=0,be=0;for(let Oe=0;Oe<J.length;Oe++)be=J.charCodeAt(Oe),r(be)&&ce++,D(be)&&ge++,I(be)&&Re++,k(be)&&He++;const Qe=ce/J.length,Q=ge/J.length,se=Re/J.length,we=He/J.length;return{upperPercent:Qe,lowerPercent:Q,alphaPercent:se,numericPercent:we}}function g(J){const{upperPercent:ce,lowerPercent:ge}=J;return ge===0&&ce>.6}function t(J){const{upperPercent:ce,lowerPercent:ge,alphaPercent:Re,numericPercent:He}=J;return ge>.2&&ce<.8&&Re>.6&&He<.2}function i(J){let ce=0,ge=0,Re=0,He=0;for(let be=0;be<J.length;be++)Re=J.charCodeAt(be),r(Re)&&ce++,D(Re)&&ge++,l(Re)&&He++;return(ce===0||ge===0)&&He===0?J.length<=30:ce<=5}function s(J,ce){if(!ce||(ce=ce.trim(),ce.length===0)||!i(J)||ce.length>60)return null;const ge=d(ce);if(!t(ge)){if(!g(ge))return null;ce=ce.toLowerCase()}let Re=null,He=0;for(J=J.toLowerCase();He<ce.length&&(Re=u(J,ce,0,He))===null;)He=w(ce,He+1);return Re}e.matchesCamelCase=s;function n(J,ce,ge=!1){if(!ce||ce.length===0)return null;let Re=null,He=0;for(J=J.toLowerCase(),ce=ce.toLowerCase();He<ce.length&&(Re=o(J,ce,0,He,ge))===null;)He=v(ce,He+1);return Re}e.matchesWords=n;function o(J,ce,ge,Re,He){if(ge===J.length)return[];if(Re===ce.length)return null;if(f(J.charCodeAt(ge),ce.charCodeAt(Re))){let be=null,Qe=Re+1;if(be=o(J,ce,ge+1,Re+1,He),!He)for(;!be&&(Qe=v(ce,Qe))<ce.length;)be=o(J,ce,ge+1,Qe,He),Qe++;return be===null?null:b({start:Re,end:Re+1},be)}else return null}function v(J,ce){for(let ge=ce;ge<J.length;ge++)if(c(J.charCodeAt(ge))||ge>0&&c(J.charCodeAt(ge-1)))return ge;return J.length}const m=C(e.matchesPrefix,s,A),E=C(e.matchesPrefix,s,P),y=new p.LRUCache(1e4);function a(J,ce,ge=!1){if(typeof J!="string"||typeof ce!="string")return null;let Re=y.get(J);Re||(Re=new RegExp(R.convertSimple2RegExpPattern(J),"i"),y.set(J,Re));const He=Re.exec(ce);return He?[{start:He.index,end:He.index+He[0].length}]:ge?E(J,ce):m(J,ce)}e.matchesFuzzy=a;function T(J,ce){const ge=je(J,J.toLowerCase(),0,ce,ce.toLowerCase(),0,!0);return ge?$(ge):null}e.matchesFuzzy2=T;function O(J,ce,ge,Re,He,be){const Qe=Math.min(13,J.length);for(;ge<Qe;ge++){const Q=je(J,ce,ge,Re,He,be,!1);if(Q)return Q}return[0,be]}e.anyScore=O;function $(J){if(typeof J=="undefined")return[];const ce=[],ge=J[1];for(let Re=J.length-1;Re>1;Re--){const He=J[Re]+ge,be=ce[ce.length-1];be&&be.end===He?be.end=He+1:ce.push({start:He,end:He+1})}return ce}e.createMatches=$;const Z=128;function le(){const J=[],ce=[];for(let ge=0;ge<=Z;ge++)ce[ge]=0;for(let ge=0;ge<=Z;ge++)J.push(ce.slice(0));return J}function q(J){const ce=[];for(let ge=0;ge<=J;ge++)ce[ge]=0;return ce}const x=q(2*Z),H=q(2*Z),N=le(),z=le(),F=le(),M=!1;function L(J,ce,ge,Re,He){function be(Q,se,we=" "){for(;Q.length<se;)Q=we+Q;return Q}let Qe=` |   |${Re.split("").map(Q=>be(Q,3)).join("|")}
`;for(let Q=0;Q<=ge;Q++)Q===0?Qe+=" |":Qe+=`${ce[Q-1]}|`,Qe+=J[Q].slice(0,He+1).map(se=>be(se.toString(),3)).join("|")+`
`;return Qe}function U(J,ce,ge,Re){J=J.substr(ce),ge=ge.substr(Re),console.log(L(z,J,J.length,ge,ge.length)),console.log(L(F,J,J.length,ge,ge.length)),console.log(L(N,J,J.length,ge,ge.length))}function G(J,ce){if(ce<0||ce>=J.length)return!1;const ge=J.codePointAt(ce);switch(ge){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(ge)}}function te(J,ce){if(ce<0||ce>=J.length)return!1;switch(J.charCodeAt(ce)){case 32:case 9:return!0;default:return!1}}function me(J,ce,ge){return ce[J]!==ge[J]}function Se(J,ce,ge,Re,He,be,Qe=!1){for(;ce<ge&&He<be;)J[ce]===Re[He]&&(Qe&&(x[ce]=He),ce+=1),He+=1;return ce===ge}e.isPatternInWord=Se;var ye;(function(J){J[J.Diag=1]="Diag",J[J.Left=2]="Left",J[J.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var Le;(function(J){J.Default=[-100,0];function ce(ge){return!ge||ge.length===2&&ge[0]===-100&&ge[1]===0}J.isDefault=ce})(Le=e.FuzzyScore||(e.FuzzyScore={}));function je(J,ce,ge,Re,He,be,Qe){const Q=J.length>Z?Z:J.length,se=Re.length>Z?Z:Re.length;if(ge>=Q||be>=se||Q-ge>se-be||!Se(ce,ge,Q,He,be,se,!0))return;ze(Q,se,ge,be,ce,He);let we=1,Oe=1,Ue=ge,Ye=be;const De=[!1];for(we=1,Ue=ge;Ue<Q;we++,Ue++){const W=x[Ue],ee=H[Ue],de=Ue+1<Q?H[Ue+1]:se;for(Oe=W-be+1,Ye=W;Ye<de;Oe++,Ye++){let Ie=Number.MIN_SAFE_INTEGER,Te=!1;Ye<=ee&&(Ie=Ge(J,ce,Ue,ge,Re,He,Ye,se,be,N[we-1][Oe-1]===0,De));let xe=0;Ie!==Number.MAX_SAFE_INTEGER&&(Te=!0,xe=Ie+z[we-1][Oe-1]);const Ve=Ye>W,Ze=Ve?z[we][Oe-1]+(N[we][Oe-1]>0?-5:0):0,rt=Ye>W+1&&N[we][Oe-1]>0,Xe=rt?z[we][Oe-2]+(N[we][Oe-2]>0?-5:0):0;if(rt&&(!Ve||Xe>=Ze)&&(!Te||Xe>=xe))z[we][Oe]=Xe,F[we][Oe]=3,N[we][Oe]=0;else if(Ve&&(!Te||Ze>=xe))z[we][Oe]=Ze,F[we][Oe]=2,N[we][Oe]=0;else if(Te)z[we][Oe]=xe,F[we][Oe]=1,N[we][Oe]=N[we-1][Oe-1]+1;else throw new Error("not possible")}}if(M&&U(J,ge,Re,be),!De[0]&&!Qe)return;we--,Oe--;const _e=[z[we][Oe],be];let Pe=0,ae=0;for(;we>=1;){let W=Oe;do{const ee=F[we][W];if(ee===3)W=W-2;else if(ee===2)W=W-1;else break}while(W>=1);Pe>1&&ce[ge+we-1]===He[be+Oe-1]&&!me(W+be-1,Re,He)&&Pe+1>N[we][W]&&(W=Oe),W===Oe?Pe++:Pe=1,ae||(ae=W),we--,Oe=W-1,_e.push(Oe)}se===Q&&(_e[0]+=2);const fe=ae-Q;return _e[0]-=fe,_e}e.fuzzyScore=je;function ze(J,ce,ge,Re,He,be){let Qe=J-1,Q=ce-1;for(;Qe>=ge&&Q>=Re;)He[Qe]===be[Q]&&(H[Qe]=Q,Qe--),Q--}function Ge(J,ce,ge,Re,He,be,Qe,Q,se,we,Oe){if(ce[ge]!==be[Qe])return Number.MIN_SAFE_INTEGER;let Ue=1,Ye=!1;return Qe===ge-Re?Ue=J[ge]===He[Qe]?7:5:me(Qe,He,be)&&(Qe===0||!me(Qe-1,He,be))?(Ue=J[ge]===He[Qe]?7:5,Ye=!0):G(be,Qe)&&(Qe===0||!G(be,Qe-1))?Ue=5:(G(be,Qe-1)||te(be,Qe-1))&&(Ue=5,Ye=!0),Ue>1&&ge===Re&&(Oe[0]=!0),Ye||(Ye=me(Qe,He,be)||G(be,Qe-1)||te(be,Qe-1)),ge===Re?Qe>se&&(Ue-=Ye?3:5):we?Ue+=Ye?2:0:Ue+=Ye?0:1,Qe+1===Q&&(Ue-=Ye?3:5),Ue}function j(J,ce,ge,Re,He,be,Qe){return ie(J,ce,ge,Re,He,be,!0,Qe)}e.fuzzyScoreGracefulAggressive=j;function Y(J,ce,ge,Re,He,be,Qe){return ie(J,ce,ge,Re,He,be,!1,Qe)}e.fuzzyScoreGraceful=Y;function ie(J,ce,ge,Re,He,be,Qe,Q){let se=je(J,ce,ge,Re,He,be,Q);if(se&&!Qe)return se;if(J.length>=3){const we=Math.min(7,J.length-1);for(let Oe=ge+1;Oe<we;Oe++){const Ue=re(J,Oe);if(Ue){const Ye=je(Ue,Ue.toLowerCase(),ge,Re,He,be,Q);Ye&&(Ye[0]-=3,(!se||Ye[0]>se[0])&&(se=Ye))}}}return se}function re(J,ce){if(ce+1>=J.length)return;const ge=J[ce],Re=J[ce+1];if(ge!==Re)return J.slice(0,ce)+Re+ge+J.slice(ce+2)}}),define(pe[136],ve([0,1,91,94,8]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const S=new RegExp(`\\$\\(${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${S.source}`,"g");function P(f){return f.replace(A,(I,b)=>b?I:`\\${I}`)}e.escapeIcons=P;const _=new RegExp(`\\\\${S.source}`,"g");function D(f){return f.replace(_,I=>`\\${I}`)}e.markdownEscapeEscapedIcons=D;const r=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function k(f){return f.indexOf(e.iconStartMarker)===-1?f:f.replace(r,(I,b,w,u)=>w?I:b||u||"")}e.stripIcons=k;function l(f){const I=f.indexOf(e.iconStartMarker);return I===-1?{text:f}:h(f,I)}e.parseLabelWithIcons=l;function h(f,I){const b=[];let w="";function u(v){if(v){w+=v;for(const m of v)b.push(t)}}let d=-1,g="",t=0,i,s,n=I;const o=f.length;for(u(f.substr(0,I));n<o;)i=f[n],s=f[n+1],i===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(d=n,u(g),g=e.iconStartMarker,n++):i===")"&&d!==-1?(t+=n-d+1,d=-1,g=""):d!==-1?/^[a-z0-9\-]$/i.test(i)?g+=i:(u(g),d=-1,g=""):u(i),n++;return u(g),{text:w,iconOffsets:b}}function c(f,I,b=!1){const{text:w,iconOffsets:u}=I;if(!u||u.length===0)return R.matchesFuzzy(f,w,b);const d=C.ltrim(w," "),g=w.length-d.length,t=R.matchesFuzzy(f,d,b);if(t)for(const i of t){const s=u[i.start+g]+g;i.start+=s,i.end+=s}return t}e.matchesFuzzyIconAware=c}),define(pe[95],ve([0,1,136,14]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var C;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(C=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class S{constructor(h="",c=!1){var f,I;if(this.value=h,typeof this.value!="string")throw R.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(f=c.isTrusted)!==null&&f!==void 0?f:void 0,this.supportThemeIcons=(I=c.supportThemeIcons)!==null&&I!==void 0?I:!1)}appendText(h,c=0){return this.value+=D(this.supportThemeIcons?p.escapeIcons(h):h).replace(/([ \t]+)/g,(f,I)=>"&nbsp;".repeat(I.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,c){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=S;function A(l){return P(l)?!l.value:Array.isArray(l)?l.every(A):!0}e.isEmptyMarkdownString=A;function P(l){return l instanceof S?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}e.isMarkdownString=P;function _(l,h){return l===h?!0:!l||!h?!1:l.value===h.value&&l.isTrusted===h.isTrusted&&l.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=_;function D(l){return l.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=D;function r(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=r;function k(l){const h=[],c=l.split("|").map(I=>I.trim());l=c[0];const f=c[1];if(f){const I=/height=(\d+)/.exec(f),b=/width=(\d+)/.exec(f),w=I?I[1]:"",u=b?b[1]:"",d=isFinite(parseInt(u)),g=isFinite(parseInt(w));d&&h.push(`width="${u}"`),g&&h.push(`height="${w}"`)}return{href:l,dimensions:h}}e.parseHrefAndDimensions=k}),define(pe[55],ve([0,1,22,8,2]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function S(D){return JSON.stringify(D,P)}e.stringify=S;function A(D){let r=JSON.parse(D);return r=_(r),r}e.parse=A;function P(D,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:R.regExpFlags(r)}:r}function _(D,r=0){if(!D||r>200)return D;if(typeof D=="object"){switch(D.$mid){case 1:return C.URI.revive(D);case 2:return new RegExp(D.source,D.flags)}if(D instanceof p.VSBuffer||D instanceof Uint8Array)return D;if(Array.isArray(D))for(let k=0;k<D.length;++k)D[k]=_(D[k],r+1);else for(const k in D)Object.hasOwnProperty.call(D,k)&&(D[k]=_(D[k],r+1))}return D}e.revive=_}),define(pe[10],ve([0,1,2,11]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var C;(function(P){P.inMemory="inmemory",P.vscode="vscode",P.internal="private",P.walkThrough="walkThrough",P.walkThroughSnippet="walkThroughSnippet",P.http="http",P.https="https",P.file="file",P.mailto="mailto",P.untitled="untitled",P.data="data",P.command="command",P.vscodeRemote="vscode-remote",P.vscodeRemoteResource="vscode-remote-resource",P.userData="vscode-userdata",P.vscodeCustomEditor="vscode-custom-editor",P.vscodeNotebook="vscode-notebook",P.vscodeNotebookCell="vscode-notebook-cell",P.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",P.vscodeNotebookCellOutput="vscode-notebook-cell-output",P.vscodeSettings="vscode-settings",P.vscodeWorkspaceTrust="vscode-workspace-trust",P.vscodeTerminal="vscode-terminal",P.webviewPanel="webview-panel",P.vscodeWebview="vscode-webview",P.extension="extension",P.vscodeFileResource="vscode-file",P.tmp="tmp"})(C=e.Schemas||(e.Schemas={}));class S{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,D,r){this._hosts[_]=D,this._ports[_]=r}setConnectionToken(_,D){this._connectionTokens[_]=D}rewrite(_){if(this._delegate)return this._delegate(_);const D=_.authority;let r=this._hosts[D];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const k=this._ports[D],l=this._connectionTokens[D];let h=`path=${encodeURIComponent(_.path)}`;return typeof l=="string"&&(h+=`&tkn=${encodeURIComponent(l)}`),p.URI.from({scheme:R.isWeb?this._preferredWebSchema:C.vscodeRemoteResource,authority:`${r}:${k}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new S;class A{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,D,r){const k=this.toUri(_,D);return k.scheme===C.vscodeRemote?e.RemoteAuthorities.rewrite(k):R.isNative&&(r||R.isPreferringBrowserCodeLoad)&&k.scheme===C.file?k.with({scheme:C.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(_,D){const r=this.toUri(_,D);return r.scheme===C.vscodeFileResource?r.with({scheme:C.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(_,D){return p.URI.isUri(_)?_:p.URI.parse(D.toUrl(_))}}e.FileAccess=new A}),define(pe[74],ve([0,1,23]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const R=new p.LRUCache(1e4);function C(D){return _(D,"NFC",R)}e.normalizeNFC=C;const S=new p.LRUCache(1e4);function A(D){return _(D,"NFD",S)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function _(D,r,k){if(!e.canNormalize||!D)return D;const l=k.get(D);if(l)return l;let h;return P.test(D)?h=D.normalize(r):h=D,k.set(D,h),h}e.removeAccents=function(){if(e.canNormalize){const D=/[\u0300-\u036f]/g;return function(r){return A(r).replace(D,"")}}else return function(D){return D}}()}),define(pe[24],ve([0,1,29,9,2,8,10,11]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(h){return C.uriToFsPath(h,!0)}e.originalFSPath=_;class D{constructor(c){this._ignorePathCasing=c}compare(c,f,I=!1){return c===f?0:S.compare(this.getComparisonKey(c,I),this.getComparisonKey(f,I))}isEqual(c,f,I=!1){return c===f?!0:!c||!f?!1:this.getComparisonKey(c,I)===this.getComparisonKey(f,I)}getComparisonKey(c,f=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,f,I=!1){if(c.scheme===f.scheme){if(c.scheme===A.Schemas.file)return p.isEqualOrParent(_(c),_(f),this._ignorePathCasing(c))&&c.query===f.query&&(I||c.fragment===f.fragment);if(e.isEqualAuthority(c.authority,f.authority))return p.isEqualOrParent(c.path,f.path,this._ignorePathCasing(c),"/")&&c.query===f.query&&(I||c.fragment===f.fragment)}return!1}joinPath(c,...f){return C.URI.joinPath(c,...f)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return R.posix.basename(c.path)}extname(c){return R.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let f;return c.scheme===A.Schemas.file?f=C.URI.file(R.dirname(_(c))).path:(f=R.posix.dirname(c.path),c.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),f="/")),c.with({path:f})}normalizePath(c){if(!c.path.length)return c;let f;return c.scheme===A.Schemas.file?f=C.URI.file(R.normalize(_(c))).path:f=R.posix.normalize(c.path),c.with({path:f})}relativePath(c,f){if(c.scheme!==f.scheme||!e.isEqualAuthority(c.authority,f.authority))return;if(c.scheme===A.Schemas.file){const w=R.relative(_(c),_(f));return P.isWindows?p.toSlashes(w):w}let I=c.path||"/",b=f.path||"/";if(this._ignorePathCasing(c)){let w=0;for(const u=Math.min(I.length,b.length);w<u&&!(I.charCodeAt(w)!==b.charCodeAt(w)&&I.charAt(w).toLowerCase()!==b.charAt(w).toLowerCase());w++);I=b.substr(0,w)+I.substr(w)}return R.posix.relative(I,b)}resolvePath(c,f){if(c.scheme===A.Schemas.file){const I=C.URI.file(R.resolve(_(c),f));return c.with({authority:I.authority,path:I.path})}return f=p.toPosixPath(f),c.with({path:R.posix.resolve(c.path,f)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,f){return c===f||S.equalsIgnoreCase(c,f)}hasTrailingPathSeparator(c,f=R.sep){if(c.scheme===A.Schemas.file){const I=_(c);return I.length>p.getRoot(I).length&&I[I.length-1]===f}else{const I=c.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,f=R.sep){return e.hasTrailingPathSeparator(c,f)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,f=R.sep){let I=!1;if(c.scheme===A.Schemas.file){const b=_(c);I=b!==void 0&&b.length===p.getRoot(b).length&&b[b.length-1]===f}else{f="/";const b=c.path;I=b.length===1&&b.charCodeAt(b.length-1)===47}return!I&&!e.hasTrailingPathSeparator(c,f)?c.with({path:c.path+"/"}):c}}e.ExtUri=D,e.extUri=new D(()=>!1),e.extUriBiasedIgnorePathCase=new D(h=>h.scheme===A.Schemas.file?!P.isLinux:!0),e.extUriIgnorePathCase=new D(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(h,c){const f=[];for(let I=0;I<h.length;I++){const b=c(h[I]);h.some((w,u)=>u===I?!1:e.isEqualOrParent(b,c(w)))||f.push(h[I])}return f}e.distinctParents=r;var k;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function c(f){const I=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(u=>{const[d,g]=u.split(":");d&&g&&I.set(d,g)});const w=f.path.substring(0,f.path.indexOf(";"));return w&&I.set(h.META_DATA_MIME,w),I}h.parseMetaData=c})(k=e.DataUri||(e.DataUri={}));function l(h,c,f){if(c){let I=h.path;return I&&I[0]!==R.posix.sep&&(I=R.posix.sep+I),h.with({scheme:f,authority:c,path:I})}return h.with({scheme:f})}e.toLocalResource=l}),define(pe[16],ve([0,1,21,14,3,6,71,24]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(z){return!!z&&typeof z.then=="function"}e.isThenable=_;function D(z){const F=new p.CancellationTokenSource,M=z(F.token),L=new Promise((U,G)=>{F.token.onCancellationRequested(()=>{G(R.canceled())}),Promise.resolve(M).then(te=>{F.dispose(),U(te)},te=>{F.dispose(),G(te)})});return new class{cancel(){F.cancel()}then(U,G){return L.then(U,G)}catch(U){return this.then(void 0,U)}finally(U){return L.finally(U)}}}e.createCancelablePromise=D;function r(z,F,M){return Promise.race([z,new Promise(L=>F.onCancellationRequested(()=>L(M)))])}e.raceCancellation=r;async function k(z){let F=-1;const M=z.map((U,G)=>U.then(te=>(F=G,te))),L=await Promise.race(M);return z.forEach((U,G)=>{G!==F&&U.cancel()}),L}e.raceCancellablePromises=k;function l(z,F,M){let L;const U=setTimeout(()=>{L==null||L(void 0),M==null||M()},F);return Promise.race([z.finally(()=>clearTimeout(U)),new Promise(G=>L=G)])}e.raceTimeout=l;function h(z){return new Promise((F,M)=>{const L=z();_(L)?L.then(F,M):F(L)})}e.asPromise=h;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(F){if(this.activePromise){if(this.queuedPromiseFactory=F,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const L=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,L};this.queuedPromise=new Promise(L=>{this.activePromise.then(M,M).then(L)})}return new Promise((M,L)=>{this.queuedPromise.then(M,L)})}return this.activePromise=F(),new Promise((M,L)=>{this.activePromise.then(U=>{this.activePromise=null,M(U)},U=>{this.activePromise=null,L(U)})})}}e.Throttler=c;class f{constructor(){this.current=Promise.resolve(null)}queue(F){return this.current=this.current.then(()=>F(),()=>F())}}e.Sequencer=f;class I{constructor(){this.promiseMap=new Map}queue(F,M){var L;const G=((L=this.promiseMap.get(F))!==null&&L!==void 0?L:Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(F)===G&&this.promiseMap.delete(F)});return this.promiseMap.set(F,G),G}}e.SequencerByKey=I;class b{constructor(F){this.defaultDelay=F,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(F,M=this.defaultDelay){return this.task=F,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((L,U)=>{this.doResolve=L,this.doReject=U}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const L=this.task;return this.task=null,L()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},M),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(R.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class w{constructor(F){this.delayer=new b(F),this.throttler=new c}trigger(F,M){return this.delayer.trigger(()=>this.throttler.queue(F),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=w;class u{constructor(){this._isOpen=!1,this._promise=new Promise((F,M)=>{this._completePromise=F})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=u;class d extends u{constructor(F){super();this._timeout=setTimeout(()=>this.open(),F)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=d;function g(z,F){return F?new Promise((M,L)=>{const U=setTimeout(M,z);F.onCancellationRequested(()=>{clearTimeout(U),L(R.canceled())})}):D(M=>g(z,M))}e.timeout=g;function t(z,F=0){const M=setTimeout(z,F);return S.toDisposable(()=>clearTimeout(M))}e.disposableTimeout=t;function i(z){return z.then(void 0,F=>{})}e.ignoreErrors=i;function s(z){const F=[];let M=0;const L=z.length;function U(){return M<L?z[M++]():null}function G(te){te!=null&&F.push(te);const me=U();return me?me.then(G):Promise.resolve(F)}return Promise.resolve(null).then(G)}e.sequence=s;function n(z,F=L=>!!L,M=null){let L=0;const U=z.length,G=()=>{if(L>=U)return Promise.resolve(M);const te=z[L++];return Promise.resolve(te()).then(Se=>F(Se)?Promise.resolve(Se):G())};return G()}e.first=n;function o(z,F=L=>!!L,M=null){if(z.length===0)return Promise.resolve(M);let L=z.length;const U=()=>{var G,te;L=-1;for(const me of z)(te=(G=me).cancel)===null||te===void 0||te.call(G)};return new Promise((G,te)=>{for(const me of z)me.then(Se=>{--L>=0&&F(Se)?(U(),G(Se)):L===0&&G(M)}).catch(Se=>{--L>=0&&(U(),te(Se))})})}e.firstParallel=o;class v{constructor(F){this._size=0,this.maxDegreeOfParalellism=F,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new C.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(F){return this._size++,new Promise((M,L)=>{this.outstandingPromises.push({factory:F,c:M,e:L}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const F=this.outstandingPromises.shift();this.runningPromises++;const M=F.factory();M.then(F.c,F.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=v;class m extends v{constructor(){super(1)}}e.Queue=m;class E{constructor(){this.queues=new Map}queueFor(F,M=P.extUri){const L=M.getComparisonKey(F);let U=this.queues.get(L);return U||(U=new m,C.Event.once(U.onFinished)(()=>{U==null||U.dispose(),this.queues.delete(L)}),this.queues.set(L,U)),U}dispose(){this.queues.forEach(F=>F.dispose()),this.queues.clear()}}e.ResourceQueue=E;class y{constructor(F,M){this._token=-1,typeof F=="function"&&typeof M=="number"&&this.setIfNotSet(F,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,F()},M)}setIfNotSet(F,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,F()},M))}}e.TimeoutTimer=y;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(F,M){this.cancel(),this._token=setInterval(()=>{F()},M)}}e.IntervalTimer=a;class T{constructor(F,M){this.timeoutToken=-1,this.runner=F,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(F=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,F)}get delay(){return this.timeout}set delay(F){this.timeout=F}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=T;class O extends T{constructor(F,M){super(F,M);this.units=[]}work(F){this.units.push(F),this.isScheduled()||this.schedule()}doRun(){const F=this.units;this.units=[],this.runner&&this.runner(F)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=F=>{const M=setTimeout(()=>F(z));let L=!1;return{dispose(){L||(L=!0,clearTimeout(M))}}}}else e.runWhenIdle=(z,F)=>{const M=requestIdleCallback(z,typeof F=="number"?{timeout:F}:void 0);let L=!1;return{dispose(){L||(L=!0,cancelIdleCallback(M))}}}}();class ${constructor(F){this._didRun=!1,this._executor=()=>{try{this._value=F()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=$;async function Z(z,F,M){let L;for(let U=0;U<M;U++)try{return await z()}catch(G){L=G,await g(F)}throw L}e.retry=Z;class le{hasPending(F){return this._pending?typeof F=="number"?this._pending.taskId===F:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var F;(F=this._pending)===null||F===void 0||F.cancel()}setPending(F,M,L){return this._pending={taskId:F,cancel:()=>L==null?void 0:L(),promise:M},M.then(()=>this.donePending(F),()=>this.donePending(F)),M}donePending(F){this._pending&&F===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const F=this._next;this._next=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this._next)this._next.run=F;else{let M,L;const U=new Promise((G,te)=>{M=G,L=te});this._next={run:F,promise:U,promiseResolve:M,promiseReject:L}}return this._next.promise}}e.TaskSequentializer=le;class q{constructor(F){this.interval=F,this.lastIncrementTime=0,this.value=0}increment(){const F=Date.now();return F-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=F,this.value=0),this.value++,this.value}}e.IntervalCounter=q;class x{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((F,M)=>{this.completeCallback=F,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(F){return new Promise(M=>{this.completeCallback(F),this.resolved=!0,M()})}error(F){return new Promise(M=>{this.errorCallback(F),this.rejected=!0,M()})}cancel(){new Promise(F=>{this.errorCallback(R.canceled()),this.rejected=!0,F()})}}e.DeferredPromise=x;class H extends C.Emitter{async fireAsync(F,M,L){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new A.LinkedList);for(const U of this._listeners)this._asyncDeliveryQueue.push([U,F]);for(;this._asyncDeliveryQueue.size>0&&!M.isCancellationRequested;){const[U,G]=this._asyncDeliveryQueue.shift(),te=[],me=Object.assign(Object.assign({},G),{waitUntil:Se=>{if(Object.isFrozen(te))throw new Error("waitUntil can NOT be called asynchronous");L&&(Se=L(Se,typeof U=="function"?U:U[0])),te.push(Se)}});try{typeof U=="function"?U.call(void 0,me):U[0].call(U[1],me)}catch(Se){R.onUnexpectedError(Se);continue}Object.freeze(te),await N.settled(te).catch(Se=>R.onUnexpectedError(Se))}}}}e.AsyncEmitter=H;var N;(function(z){async function F(G){return typeof Promise.allSettled=="function"?M(G):L(G)}z.allSettled=F;async function M(G){return Promise.allSettled(G)}async function L(G){return Promise.all(G.map(te=>te.then(me=>({status:"fulfilled",value:me}),me=>({status:"rejected",reason:me}))))}async function U(G){let te;const me=await Promise.all(G.map(Se=>Se.then(ye=>ye,ye=>{te||(te=ye)})));if(typeof te!="undefined")throw te;return me}z.settled=U})(N=e.Promises||(e.Promises={}))}),define(pe[96],ve([0,1,9,16]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const C=new R.IdleValue(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),S=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new R.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(y,a,T=!1){const O=y||"",$=a||"",Z=C.value.collator.compare(O,$);return C.value.collatorIsNumeric&&Z===0&&O!==$?O<$?-1:1:Z}e.compareFileNames=P;function _(y,a){const T=S.value.collator;return y=y||"",a=a||"",g(T,y,a)}e.compareFileNamesDefault=_;function D(y,a){const T=S.value.collator;return y=y||"",a=a||"",n(y,a)||g(T,y,a)}e.compareFileNamesUpper=D;function r(y,a){const T=S.value.collator;return y=y||"",a=a||"",s(y,a)||g(T,y,a)}e.compareFileNamesLower=r;function k(y,a){return y=y||"",a=a||"",y===a?0:y<a?-1:1}e.compareFileNamesUnicode=k;function l(y,a,T=!1){T||(y=y&&y.toLowerCase(),a=a&&a.toLowerCase());const[O,$]=u(y),[Z,le]=u(a);return O!==Z?O<Z?-1:1:$===le?0:$<le?-1:1}e.noIntlCompareFileNames=l;function h(y,a){const[T,O]=u(y),[$,Z]=u(a);let le=C.value.collator.compare(O,Z);if(le===0){if(C.value.collatorIsNumeric&&O!==Z)return O<Z?-1:1;if(le=C.value.collator.compare(T,$),C.value.collatorIsNumeric&&le===0&&T!==$)return T<$?-1:1}return le}e.compareFileExtensions=h;function c(y,a){y=y||"",a=a||"";const T=d(y),O=d(a),$=S.value.collator,Z=A.value.collator;return g(Z,T,O)||g($,y,a)}e.compareFileExtensionsDefault=c;function f(y,a){y=y||"",a=a||"";const T=d(y),O=d(a),$=S.value.collator,Z=A.value.collator;return g(Z,T,O)||n(y,a)||g($,y,a)}e.compareFileExtensionsUpper=f;function I(y,a){y=y||"",a=a||"";const T=d(y),O=d(a),$=S.value.collator,Z=A.value.collator;return g(Z,T,O)||s(y,a)||g($,y,a)}e.compareFileExtensionsLower=I;function b(y,a){y=y||"",a=a||"";const T=d(y).toLowerCase(),O=d(a).toLowerCase();return T!==O?T<O?-1:1:y!==a?y<a?-1:1:0}e.compareFileExtensionsUnicode=b;const w=/^(.*?)(\.([^.]*))?$/;function u(y,a=!1){const T=y?w.exec(y):[];let O=[T&&T[1]||"",T&&T[3]||""];return a&&(!O[0]&&O[1]||O[0]&&O[0].charAt(0)===".")&&(O=[O[0]+"."+O[1],""]),O}function d(y){const a=y?w.exec(y):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function g(y,a,T){let O=y.compare(a,T);return O!==0?O:a.length!==T.length?a.length<T.length?-1:1:0}function t(y){const a=y.charAt(0);return a.toLocaleUpperCase()!==a}function i(y){const a=y.charAt(0);return a.toLocaleLowerCase()!==a}function s(y,a){return t(y)&&i(a)?-1:i(y)&&t(a)?1:0}function n(y,a){return i(y)&&t(a)?-1:t(y)&&i(a)?1:0}function o(y,a,T=!1){return T||(y=y&&y.toLowerCase(),a=a&&a.toLowerCase()),y===a?0:y<a?-1:1}function v(y,a,T=!1){const O=y.split(p.sep),$=a.split(p.sep),Z=O.length-1,le=$.length-1;let q,x;for(let H=0;;H++){if(q=Z===H,x=le===H,q&&x)return P(O[H],$[H],T);if(q)return-1;if(x)return 1;const N=o(O[H],$[H],T);if(N!==0)return N}}e.comparePaths=v;function m(y,a,T){const O=y.toLowerCase(),$=a.toLowerCase(),Z=E(y,a,T);if(Z)return Z;const le=O.endsWith(T),q=$.endsWith(T);if(le!==q)return le?-1:1;const x=P(O,$);return x!==0?x:O.localeCompare($)}e.compareAnything=m;function E(y,a,T){const O=y.toLowerCase(),$=a.toLowerCase(),Z=O.startsWith(T),le=$.startsWith(T);if(Z!==le)return Z?-1:1;if(Z&&le){if(O.length<$.length)return-1;if(O.length>$.length)return 1}return 0}e.compareByPrefix=E}),define(pe[97],ve([0,1,96,94,9,11,8]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const P=0,_=[P,[]];function D(q,x,H,N){if(!q||!x)return _;const z=q.length,F=x.length;if(z<F)return _;const M=q.toLowerCase();return!N&&!M.includes(H)?_:r(x,H,F,q,M,z)}e.scoreFuzzy=D;function r(q,x,H,N,z,F){const M=[],L=[];for(let me=0;me<H;me++){const Se=me*F,ye=Se-F,Le=me>0,je=q[me],ze=x[me];for(let Ge=0;Ge<F;Ge++){const j=Ge>0,Y=Se+Ge,ie=Y-1,re=ye+Ge-1,J=j?M[ie]:0,ce=Le&&j?M[re]:0,ge=Le&&j?L[re]:0;let Re;!ce&&Le?Re=0:Re=k(je,ze,N,z,Ge,ge),Re&&ce+Re>=J?(L[Y]=ge+1,M[Y]=ce+Re):(L[Y]=P,M[Y]=J)}}const U=[];let G=H-1,te=F-1;for(;G>=0&&te>=0;){const me=G*F+te;L[me]===P||(U.push(te),G--),te--}return[M[H*F-1],U.reverse()]}function k(q,x,H,N,z,F){let M=0;if(!l(x,N[z]))return M;if(M+=1,F>0&&(M+=F*5),q===H[z]&&(M+=1),z===0)M+=8;else{const L=h(H.charCodeAt(z-1));L?M+=L:R.isUpper(H.charCodeAt(z))&&(M+=2)}return M}function l(q,x){return q===x?!0:q==="/"||q==="\\"?x==="/"||x==="\\":!1}function h(q){switch(q){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function f(q,x,H=0,N=0){const z=x;return z.values&&z.values.length>1?I(q,z.values,H,N):b(q,x,H,N)}e.scoreFuzzy2=f;function I(q,x,H,N){let z=0;const F=[];for(const M of x){const[L,U]=b(q,M,H,N);if(typeof L!="number")return c;z+=L,F.push(...U)}return[z,v(F)]}function b(q,x,H,N){const z=R.fuzzyScore(x.original,x.originalLowercase,H,q,q.toLowerCase(),N,!0);return z?[z[0],R.createMatches(z)]:c}const w=Object.freeze({score:0}),u=1<<18,d=1<<17,g=1<<16;function t(q,x,H,N,z){if(!q||!x.normalized)return w;const F=N.getItemLabel(q);if(!F)return w;const M=N.getItemDescription(q);let L;M?L=`${F}${M}${x.normalized}${Array.isArray(x.values)?x.values.length:""}${H}`:L=`${F}${x.normalized}${Array.isArray(x.values)?x.values.length:""}${H}`;const U=z[L];if(U)return U;const G=i(F,M,N.getItemPath(q),x,H);return z[L]=G,G}e.scoreItemFuzzy=t;function i(q,x,H,N,z){const F=!H||!N.containsPathSeparator;return H&&(S.isLinux?N.pathNormalized===H:A.equalsIgnoreCase(N.pathNormalized,H))?{score:u,labelMatch:[{start:0,end:q.length}],descriptionMatch:x?[{start:0,end:x.length}]:void 0}:N.values&&N.values.length>1?s(q,x,H,N.values,F,z):n(q,x,H,N,F,z)}function s(q,x,H,N,z,F){let M=0;const L=[],U=[];for(const G of N){const{score:te,labelMatch:me,descriptionMatch:Se}=n(q,x,H,G,z,F);if(te===P)return w;M+=te,me&&L.push(...me),Se&&U.push(...Se)}return{score:M,labelMatch:v(L),descriptionMatch:v(U)}}function n(q,x,H,N,z,F){if(z||!x){const[M,L]=D(q,N.normalized,N.normalizedLowercase,F);if(M){const U=R.matchesPrefix(N.normalized,q);let G;return U?(G=d,G+=Math.round(N.normalized.length/q.length*100)):G=g,{score:G+M,labelMatch:U||o(L)}}}if(x){let M=x;H&&(M=`${x}${C.sep}`);const L=M.length,U=`${M}${q}`,[G,te]=D(U,N.normalized,N.normalizedLowercase,F);if(G){const me=o(te),Se=[],ye=[];return me.forEach(Le=>{Le.start<L&&Le.end>L?(Se.push({start:0,end:Le.end-L}),ye.push({start:Le.start,end:L})):Le.start>=L?Se.push({start:Le.start-L,end:Le.end-L}):ye.push(Le)}),{score:G,labelMatch:Se,descriptionMatch:ye}}}return w}function o(q){const x=[];if(!q)return x;let H;for(const N of q)H&&H.end===N?H.end+=1:(H={start:N,end:N+1},x.push(H));return x}function v(q){const x=q.sort((z,F)=>z.start-F.start),H=[];let N;for(const z of x)!N||!m(N,z)?(N=z,H.push(z)):(N.start=Math.min(N.start,z.start),N.end=Math.max(N.end,z.end));return H}function m(q,x){return!(q.end<x.start||x.end<q.start)}function E(q,x,H,N,z,F){const M=t(q,H,N,z,F),L=t(x,H,N,z,F),U=M.score,G=L.score;if((U===u||G===u)&&U!==G)return U===u?-1:1;if(U>g||G>g){if(U!==G)return U>G?-1:1;if(U<d&&G<d){const ze=a(M.labelMatch,L.labelMatch);if(ze!==0)return ze}const Le=z.getItemLabel(q)||"",je=z.getItemLabel(x)||"";if(Le.length!==je.length)return Le.length-je.length}if(U!==G)return U>G?-1:1;const te=Array.isArray(M.labelMatch)&&M.labelMatch.length>0,me=Array.isArray(L.labelMatch)&&L.labelMatch.length>0;if(te&&!me)return-1;if(me&&!te)return 1;const Se=y(q,M,z),ye=y(x,L,z);return Se&&ye&&Se!==ye?ye>Se?-1:1:T(q,x,H,z)}e.compareItemsByFuzzyScore=E;function y(q,x,H){let N=-1,z=-1;if(x.descriptionMatch&&x.descriptionMatch.length?N=x.descriptionMatch[0].start:x.labelMatch&&x.labelMatch.length&&(N=x.labelMatch[0].start),x.labelMatch&&x.labelMatch.length){if(z=x.labelMatch[x.labelMatch.length-1].end,x.descriptionMatch&&x.descriptionMatch.length){const F=H.getItemDescription(q);F&&(z+=F.length)}}else x.descriptionMatch&&x.descriptionMatch.length&&(z=x.descriptionMatch[x.descriptionMatch.length-1].end);return z-N}function a(q,x){if(!q&&!x||(!q||!q.length)&&(!x||!x.length))return 0;if(!x||!x.length)return-1;if(!q||!q.length)return 1;const H=q[0].start,z=q[q.length-1].end-H,F=x[0].start,L=x[x.length-1].end-F;return z===L?0:L<z?1:-1}function T(q,x,H,N){const z=N.getItemLabel(q)||"",F=N.getItemLabel(x)||"",M=N.getItemDescription(q),L=N.getItemDescription(x),U=z.length+(M?M.length:0),G=F.length+(L?L.length:0);if(U!==G)return U-G;const te=N.getItemPath(q),me=N.getItemPath(x);return te&&me&&te.length!==me.length?te.length-me.length:z!==F?p.compareAnything(z,F,H.normalized):M&&L&&M!==L?p.compareAnything(M,L,H.normalized):te&&me&&te!==me?p.compareAnything(te,me,H.normalized):0}const O=" ";function $(q){typeof q!="string"&&(q="");const x=q.toLowerCase(),{pathNormalized:H,normalized:N,normalizedLowercase:z}=Z(q),F=H.indexOf(C.sep)>=0;let M;const L=q.split(O);if(L.length>1)for(const U of L){const{pathNormalized:G,normalized:te,normalizedLowercase:me}=Z(U);te&&(M||(M=[]),M.push({original:U,originalLowercase:U.toLowerCase(),pathNormalized:G,normalized:te,normalizedLowercase:me}))}return{original:q,originalLowercase:x,pathNormalized:H,normalized:N,normalizedLowercase:z,values:M,containsPathSeparator:F}}e.prepareQuery=$;function Z(q){let x;S.isWindows?x=q.replace(/\//g,C.sep):x=q.replace(/\\/g,C.sep);const H=A.stripWildcards(x).replace(/\s/g,"");return{pathNormalized:x,normalized:H,normalizedLowercase:H.toLowerCase()}}function le(q){return Array.isArray(q)?$(q.map(x=>x.original).join(O)):$(q.original)}e.pieceToQuery=le}),define(pe[30],ve([0,1,8,29,9,23,16]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P;const _="**",D="/",r="[/\\\\]",k="[^/\\\\]",l=/\//g;function h(M){switch(M){case 0:return"";case 1:return`${k}*?`;default:return`(?:${r}|${k}+${r}|${r}${k}+)*?`}}function c(M,L){if(!M)return[];const U=[];let G=!1,te=!1,me="";for(const Se of M){switch(Se){case L:if(!G&&!te){U.push(me),me="";continue}break;case"{":G=!0;break;case"}":G=!1;break;case"[":te=!0;break;case"]":te=!1;break}me+=Se}return me&&U.push(me),U}e.splitGlobAware=c;function f(M){if(!M)return"";let L="";const U=c(M,D);if(U.every(G=>G===_))L=".*";else{let G=!1;U.forEach((te,me)=>{if(te===_){G||(L+=h(2),G=!0);return}let Se=!1,ye="",Le=!1,je="";for(const ze of te){if(ze!=="}"&&Se){ye+=ze;continue}if(Le&&(ze!=="]"||!je)){let Ge;ze==="-"?Ge=ze:(ze==="^"||ze==="!")&&!je?Ge="^":ze===D?Ge="":Ge=p.escapeRegExpCharacters(ze),je+=Ge;continue}switch(ze){case"{":Se=!0;continue;case"[":Le=!0;continue;case"}":L+=`(?:${c(ye,",").map(Y=>f(Y)).join("|")})`,Se=!1,ye="";break;case"]":L+="["+je+"]",Le=!1,je="";break;case"?":L+=k;continue;case"*":L+=h(1);continue;default:L+=p.escapeRegExpCharacters(ze)}}me<U.length-1&&(U[me+1]!==_||me+2<U.length)&&(L+=r),G=!1})}return L}const I=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,w=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,u=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new S.LRUCache(1e4),i=function(){return!1},s=function(){return null};function n(M,L){if(!M)return s;let U;typeof M!="string"?U=M.pattern:U=M,U=U.trim();const G=`${U}_${!!L.trimForExclusions}`;let te=t.get(G);if(te)return o(te,M);let me;if(I.test(U)){const Se=U.substr(4);te=function(ye,Le){return typeof ye=="string"&&ye.endsWith(Se)?U:null}}else(me=b.exec(v(U,L)))?te=m(me[1],U):(L.trimForExclusions?u:w).test(U)?te=E(U,L):(me=d.exec(v(U,L)))?te=y(me[1].substr(1),U,!0):(me=g.exec(v(U,L)))?te=y(me[1],U,!1):te=a(U);return t.set(G,te),o(te,M)}function o(M,L){return typeof L=="string"?M:function(U,G){return R.isEqualOrParent(U,L.base)?M(C.relative(L.base,U),G):null}}function v(M,L){return L.trimForExclusions&&M.endsWith("/**")?M.substr(0,M.length-2):M}function m(M,L){const U=`/${M}`,G=`\\${M}`,te=function(Se,ye){return typeof Se!="string"?null:ye?ye===M?L:null:Se===M||Se.endsWith(U)||Se.endsWith(G)?L:null},me=[M];return te.basenames=me,te.patterns=[L],te.allBasenames=me,te}function E(M,L){const U=F(M.slice(1,-1).split(",").map(ye=>n(ye,L)).filter(ye=>ye!==s),M),G=U.length;if(!G)return s;if(G===1)return U[0];const te=function(ye,Le){for(let je=0,ze=U.length;je<ze;je++)if(U[je](ye,Le))return M;return null},me=U.find(ye=>!!ye.allBasenames);me&&(te.allBasenames=me.allBasenames);const Se=U.reduce((ye,Le)=>Le.allPaths?ye.concat(Le.allPaths):ye,[]);return Se.length&&(te.allPaths=Se),te}function y(M,L,U){const G=C.sep===C.posix.sep,te=G?M:M.replace(l,C.sep),me=C.sep+te,Se=C.posix.sep+M,ye=U?function(Le,je){return typeof Le=="string"&&(Le===te||Le.endsWith(me)||!G&&(Le===M||Le.endsWith(Se)))?L:null}:function(Le,je){return typeof Le=="string"&&(Le===te||!G&&Le===M)?L:null};return ye.allPaths=[(U?"*/":"./")+M],ye}function a(M){try{const L=new RegExp(`^${f(M)}$`);return function(U){return L.lastIndex=0,typeof U=="string"&&L.test(U)?M:null}}catch(L){return s}}function T(M,L,U){return!M||typeof L!="string"?!1:O(M)(L,void 0,U)}e.match=T;function O(M,L={}){if(!M)return i;if(typeof M=="string"||q(M)){const U=n(M,L);if(U===s)return i;const G=function(te,me){return!!U(te,me)};return U.allBasenames&&(G.allBasenames=U.allBasenames),U.allPaths&&(G.allPaths=U.allPaths),G}return N(M,L)}e.parse=O;function $(M){if(!M)return;let L;return U=>(L||(L=(M()||Promise.resolve([])).then(G=>G?le(G):{})),L.then(G=>!!G[U]))}e.hasSiblingPromiseFn=$;function Z(M){if(!M)return;let L;return U=>{if(!L){const G=M();L=G?le(G):{}}return!!L[U]}}e.hasSiblingFn=Z;function le(M){const L={};for(const U of M)L[U]=!0;return L}function q(M){const L=M;return L&&typeof L.base=="string"&&typeof L.pattern=="string"}e.isRelativePattern=q;function x(M){return M.allBasenames||[]}e.getBasenameTerms=x;function H(M){return M.allPaths||[]}e.getPathTerms=H;function N(M,L){const U=F(Object.getOwnPropertyNames(M).map(ye=>z(ye,M[ye],L)).filter(ye=>ye!==s)),G=U.length;if(!G)return s;if(!U.some(ye=>!!ye.requiresSiblings)){if(G===1)return U[0];const ye=function(ze,Ge){for(let j=0,Y=U.length;j<Y;j++){const ie=U[j](ze,Ge);if(ie)return ie}return null},Le=U.find(ze=>!!ze.allBasenames);Le&&(ye.allBasenames=Le.allBasenames);const je=U.reduce((ze,Ge)=>Ge.allPaths?ze.concat(Ge.allPaths):ze,[]);return je.length&&(ye.allPaths=je),ye}const te=function(ye,Le,je){let ze;for(let Ge=0,j=U.length;Ge<j;Ge++){const Y=U[Ge];Y.requiresSiblings&&je&&(Le||(Le=C.basename(ye)),ze||(ze=Le.substr(0,Le.length-C.extname(ye).length)));const ie=Y(ye,Le,ze,je);if(ie)return ie}return null},me=U.find(ye=>!!ye.allBasenames);me&&(te.allBasenames=me.allBasenames);const Se=U.reduce((ye,Le)=>Le.allPaths?ye.concat(Le.allPaths):ye,[]);return Se.length&&(te.allPaths=Se),te}function z(M,L,U){if(L===!1)return s;const G=n(M,U);if(G===s)return s;if(typeof L=="boolean")return G;if(L){const te=L.when;if(typeof te=="string"){const me=(Se,ye,Le,je)=>{if(!je||!G(Se,ye))return null;const ze=te.replace("$(basename)",Le),Ge=je(ze);return A.isThenable(Ge)?Ge.then(j=>j?M:null):Ge?M:null};return me.requiresSiblings=!0,me}}return G}function F(M,L){const U=M.filter(ye=>!!ye.basenames);if(U.length<2)return M;const G=U.reduce((ye,Le)=>{const je=Le.basenames;return je?ye.concat(je):ye},[]);let te;if(L){te=[];for(let ye=0,Le=G.length;ye<Le;ye++)te.push(L)}else te=U.reduce((ye,Le)=>{const je=Le.patterns;return je?ye.concat(je):ye},[]);const me=function(ye,Le){if(typeof ye!="string")return null;if(!Le){let ze;for(ze=ye.length;ze>0;ze--){const Ge=ye.charCodeAt(ze-1);if(Ge===47||Ge===92)break}Le=ye.substr(ze)}const je=G.indexOf(Le);return je!==-1?te[je]:null};me.basenames=G,me.patterns=te,me.allBasenames=G;const Se=M.filter(ye=>!ye.basenames);return Se.push(me),Se}}),define(pe[75],ve([0,1,2,9,8,10,11,24,29]),function(X,e,p,R,C,S,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function D(n,o,v){if(typeof n=="string"&&(n=p.URI.file(n)),v){const E=v.getWorkspaceFolder(n);if(E){const y=v.getWorkspace().folders.length>1;let a;if(P.isEqual(E.uri,n)?a="":a=P.relativePath(E.uri,n),y){const T=E.name?E.name:P.basename(E.uri);a=a?T+" \u2022 "+a:T}return a}}if(n.scheme!==S.Schemas.file&&n.scheme!==S.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if(_.hasDriveLetter(n.fsPath))return R.normalize(k(n.fsPath));let m=R.normalize(n.fsPath);return!A.isWindows&&(o==null?void 0:o.userHome)&&(m=h(m,o.userHome.fsPath)),m}e.getPathLabel=D;function r(n){if(!n)return;typeof n=="string"&&(n=p.URI.file(n));const o=P.basename(n)||(n.scheme===S.Schemas.file?n.fsPath:n.path);return A.isWindows&&_.isRootOrDriveLetter(o)?k(o):o}e.getBaseLabel=r;function k(n){return _.hasDriveLetter(n)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=k;let l=Object.create(null);function h(n,o){if(A.isWindows||!n||!o)return n;let v=l.original===o?l.normalized:void 0;return v||(v=`${C.rtrim(o,R.posix.sep)}${R.posix.sep}`,l={original:o,normalized:v}),(A.isLinux?n.startsWith(v):C.startsWithIgnoreCase(n,v))&&(n=`~/${n.substr(v.length)}`),n}e.tildify=h;function c(n,o){return n.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=c;const f="\u2026",I="\\\\",b="~";function w(n,o=R.sep){const v=new Array(n.length);let m=!1;for(let E=0;E<n.length;E++){let y=n[E];if(y===""){v[E]=`.${o}`;continue}if(!y){v[E]=y;continue}m=!0;let a="";y.indexOf(I)===0?(a=y.substr(0,y.indexOf(I)+I.length),y=y.substr(y.indexOf(I)+I.length)):y.indexOf(o)===0?(a=y.substr(0,y.indexOf(o)+o.length),y=y.substr(y.indexOf(o)+o.length)):y.indexOf(b)===0&&(a=y.substr(0,y.indexOf(b)+b.length),y=y.substr(y.indexOf(b)+b.length));const T=y.split(o);for(let O=1;m&&O<=T.length;O++)for(let $=T.length-O;m&&$>=0;$--){m=!1;let Z=T.slice($,$+O).join(o);for(let le=0;!m&&le<n.length;le++)if(le!==E&&n[le]&&n[le].indexOf(Z)>-1){const q=$+O===T.length,x=$>0&&n[le].indexOf(o)>-1?o+Z:Z,H=n[le].endsWith(x);m=!q||H}if(!m){let le="";(T[0].endsWith(":")||a!=="")&&($===1&&($=0,O++,Z=T[0]+o+Z),$>0&&(le=T[0]+o),le=a+le),$>0&&(le=le+f+o),le=le+Z,$+O<T.length&&(le=le+o+f),v[E]=le}}m&&(v[E]=y)}return v}e.shorten=w;var u;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function d(n,o=Object.create(null)){const v=[];let m=!1,E="";for(const y of n)if(y==="$"||m&&y==="{")E&&v.push({value:E,type:u.TEXT}),E="",m=!0;else if(y==="}"&&m){const a=o[E];if(typeof a=="string")a.length&&v.push({value:a,type:u.VARIABLE});else if(a){const T=v[v.length-1];(!T||T.type!==u.SEPARATOR)&&v.push({value:a.label,type:u.SEPARATOR})}E="",m=!1}else E+=y;return E&&!m&&v.push({value:E,type:u.TEXT}),v.filter((y,a)=>{if(y.type===u.SEPARATOR){const T=v[a-1],O=v[a+1];return[T,O].every($=>$&&($.type===u.VARIABLE||$.type===u.TEXT)&&$.value.length>0)}return!0}).map(y=>y.value).join("")}e.template=d;function g(n,o){return A.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):n.replace(/&&|&/g,v=>v==="&"?"&&":"&")}e.mnemonicMenuLabel=g;function t(n,o){return A.isMacintosh||o?n.replace(/\(&&\w\)|&&/g,""):A.isWindows?n.replace(/&&|&/g,v=>v==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(n){const o=n.indexOf("/")!==-1?R.posix:R.win32,v=o.basename(n),m=o.dirname(n);return v.length?{name:v,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(pe[98],ve([0,1,9,8,30,10,24]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var P;(function(i){i.text="text/plain",i.binary="application/octet-stream",i.unknown="application/unknown",i.markdown="text/markdown"})(P=e.Mimes||(e.Mimes={}));let _=[],D=[],r=[];function k(i,s=!1){const n=l(i);_.push(n),n.userConfigured?r.push(n):D.push(n),s&&!n.userConfigured&&_.forEach(o=>{o.mime===n.mime||o.userConfigured||(n.extension&&o.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&o.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&o.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&o.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=k;function l(i){return{id:i.id,mime:i.mime,filename:i.filename,extension:i.extension,filepattern:i.filepattern,firstline:i.firstline,userConfigured:i.userConfigured,filenameLowercase:i.filename?i.filename.toLowerCase():void 0,extensionLowercase:i.extension?i.extension.toLowerCase():void 0,filepatternLowercase:i.filepattern?i.filepattern.toLowerCase():void 0,filepatternOnPath:i.filepattern?i.filepattern.indexOf(p.posix.sep)>=0:!1}}function h(i){i?(_=_.filter(s=>!s.userConfigured),r=[]):(_=[],D=[],r=[])}e.clearTextMimes=h;function c(i,s){let n;if(i)switch(i.scheme){case S.Schemas.file:n=i.fsPath;break;case S.Schemas.data:n=A.DataUri.parseMetaData(i).get(A.DataUri.META_DATA_LABEL);break;default:n=i.path}if(!n)return[P.unknown];n=n.toLowerCase();const o=p.basename(n),v=f(n,o,r);if(v)return[v,P.text];const m=f(n,o,D);if(m)return[m,P.text];if(s){const E=I(s);if(E)return[E,P.text]}return[P.unknown]}e.guessMimeTypes=c;function f(i,s,n){let o=null,v=null,m=null;for(let E=n.length-1;E>=0;E--){const y=n[E];if(s===y.filenameLowercase){o=y;break}if(y.filepattern&&(!v||y.filepattern.length>v.filepattern.length)){const a=y.filepatternOnPath?i:s;C.match(y.filepatternLowercase,a)&&(v=y)}y.extension&&(!m||y.extension.length>m.extension.length)&&s.endsWith(y.extensionLowercase)&&(m=y)}return o?o.mime:v?v.mime:m?m.mime:null}function I(i){if(R.startsWithUTF8BOM(i)&&(i=i.substr(1)),i.length>0)for(let s=_.length-1;s>=0;s--){const n=_[s];if(!n.firstline)continue;const o=i.match(n.firstline);if(o&&o.length>0)return n.mime}return null}function b(i){return i?typeof i=="string"?i===P.binary||i===P.text||i===P.unknown:i.length===1&&b(i[0]):!0}e.isUnspecific=b;const w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function u(i){const s=p.extname(i);return w[s.toLowerCase()]}e.getMediaMime=u;function d(i){for(const s in w)if(w[s]===i)return s}e.getExtensionForMimeType=d;const g=/^(.+)\/(.+?)(;.+)?$/;function t(i,s){var n;const o=g.exec(i);return o?`${o[1].toLowerCase()}/${o[2].toLowerCase()}${(n=o[3])!==null&&n!==void 0?n:""}`:s?void 0:i}e.normalizeMimeType=t}),define(pe[99],ve([0,1,2]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function R(r){return r.toJSON()}class C{constructor(k){this._uriTransformer=k}transformIncoming(k){const l=this._uriTransformer.transformIncoming(k);return l===k?k:R(p.URI.from(l))}transformOutgoing(k){const l=this._uriTransformer.transformOutgoing(k);return l===k?k:R(p.URI.from(l))}transformOutgoingURI(k){const l=this._uriTransformer.transformOutgoing(k);return l===k?k:p.URI.from(l)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=C,e.DefaultURITransformer=new class{transformIncoming(r){return r}transformOutgoing(r){return r}transformOutgoingURI(r){return r}transformOutgoingScheme(r){return r}};function S(r,k,l){if(!r||l>200)return null;if(typeof r=="object"){if(r instanceof p.URI)return k.transformOutgoing(r);for(let h in r)if(Object.hasOwnProperty.call(r,h)){const c=S(r[h],k,l+1);c!==null&&(r[h]=c)}}return null}function A(r,k){const l=S(r,k,0);return l===null?r:l}e.transformOutgoingURIs=A;function P(r,k,l,h){if(!r||h>200)return null;if(typeof r=="object"){if(r.$mid===1)return l?p.URI.revive(k.transformIncoming(r)):k.transformIncoming(r);for(let c in r)if(Object.hasOwnProperty.call(r,c)){const f=P(r[c],k,l,h+1);f!==null&&(r[c]=f)}}return null}function _(r,k){const l=P(r,k,!1,0);return l===null?r:l}e.transformIncomingURIs=_;function D(r,k){const l=P(r,k,!0,0);return l===null?r:l}e.transformAndReviveIncomingURIs=D}),define(pe[32],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(_){return p.test(_)}e.isUUID=R;const C=new Uint8Array(16),S=[];for(let _=0;_<256;_++)S.push(_.toString(16).padStart(2,"0"));let A;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?A=crypto.getRandomValues.bind(crypto):A=function(_){for(let D=0;D<_.length;D++)_[D]=Math.floor(Math.random()*256);return _};function P(){A(C),C[6]=C[6]&15|64,C[8]=C[8]&63|128;let _=0,D="";return D+=S[C[_++]],D+=S[C[_++]],D+=S[C[_++]],D+=S[C[_++]],D+="-",D+=S[C[_++]],D+=S[C[_++]],D+="-",D+=S[C[_++]],D+=S[C[_++]],D+="-",D+=S[C[_++]],D+=S[C[_++]],D+="-",D+=S[C[_++]],D+=S[C[_++]],D+=S[C[_++]],D+=S[C[_++]],D+=S[C[_++]],D+=S[C[_++]],D}e.generateUuid=P}),define(pe[137],ve([0,1,100]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class R{constructor(S="utf8"){this.stringDecoder=new p.StringDecoder(S),this.remaining=null}write(S){const A=[],P=this.remaining?this.remaining+this.stringDecoder.write(S):this.stringDecoder.write(S);if(P.length<1)return A;let _=0,D,r=_;for(;r<P.length;)if(D=P.charCodeAt(r),D===13||D===10){if(A.push(P.substring(_,r)),r++,r<P.length){const k=D;D=P.charCodeAt(r),(k===13&&D===10||k===10&&D===13)&&r++}_=r}else r++;return this.remaining=_<P.length?P.substr(_):null,A}end(){return this.remaining}}e.LineDecoder=R}),define(pe[28],ve([0,1,56,101,277,9,16,11,29,32,74,24,2]),function(X,e,p,R,C,S,A,P,_,D,r,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var h;(function(x){x[x.UNLINK=0]="UNLINK",x[x.MOVE=1]="MOVE"})(h=e.RimRafMode||(e.RimRafMode={}));async function c(x,H=h.UNLINK){if(_.isRootOrDriveLetter(x))throw new Error("rimraf - will refuse to recursively delete root");return H===h.UNLINK?I(x):f(x)}async function f(x){try{const H=S.join(R.tmpdir(),D.generateUuid());try{await e.Promises.rename(x,H)}catch(N){return I(x)}I(H).catch(N=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function I(x){return e.Promises.rmdir(x,{recursive:!0,maxRetries:3})}function b(x){if(_.isRootOrDriveLetter(x))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(x,{recursive:!0})}e.rimrafSync=b;async function w(x,H){return g(await(H?u(x):C.promisify(p.readdir)(x)))}async function u(x){try{return await C.promisify(p.readdir)(x,{withFileTypes:!0})}catch(z){console.warn("[node.js fs] readdir with filetypes failed with error: ",z)}const H=[],N=await w(x);for(const z of N){let F=!1,M=!1,L=!1;try{const U=await e.Promises.lstat(S.join(x,z));F=U.isFile(),M=U.isDirectory(),L=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}H.push({name:z,isFile:()=>F,isDirectory:()=>M,isSymbolicLink:()=>L})}return H}function d(x){return g(p.readdirSync(x))}e.readdirSync=d;function g(x){return x.map(H=>typeof H=="string"?P.isMacintosh?r.normalizeNFC(H):H:(H.name=P.isMacintosh?r.normalizeNFC(H.name):H.name,H))}async function t(x){const H=await w(x),N=[];for(const z of H)await s.existsDirectory(S.join(x,z))&&N.push(z);return N}function i(x,H=1e3){return new Promise(N=>{let z=!1;const F=setInterval(()=>{z||(z=!0,p.access(x,M=>{z=!1,M&&(clearInterval(F),N(void 0))}))},H)})}e.whenDeleted=i;var s;(function(x){async function H(F){let M;try{if(M=await e.Promises.lstat(F),!M.isSymbolicLink())return{stat:M}}catch(L){}try{return{stat:await e.Promises.stat(F),symbolicLink:(M==null?void 0:M.isSymbolicLink())?{dangling:!1}:void 0}}catch(L){if(L.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(P.isWindows&&L.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(F)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw U}throw L}}x.stat=H;async function N(F){try{const{stat:M,symbolicLink:L}=await x.stat(F);return M.isFile()&&(L==null?void 0:L.dangling)!==!0}catch(M){}return!1}x.existsFile=N;async function z(F){try{const{stat:M,symbolicLink:L}=await x.stat(F);return M.isDirectory()&&(L==null?void 0:L.dangling)!==!0}catch(M){}return!1}x.existsDirectory=z})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new A.ResourceQueue;function o(x,H,N){return n.queueFor(l.URI.file(x),k.extUriBiasedIgnorePathCase).queue(()=>{const z=y(N);return new Promise((F,M)=>m(x,H,z,L=>L?M(L):F()))})}let v=!0;function m(x,H,N,z){if(!v)return p.writeFile(x,H,{mode:N.mode,flag:N.flag},z);p.open(x,N.flag,N.mode,(F,M)=>{if(F)return z(F);p.writeFile(M,H,L=>{if(L)return p.close(M,()=>z(L));p.fdatasync(M,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),v=!1),p.close(M,G=>z(G))))})})}function E(x,H,N){const z=y(N);if(!v)return p.writeFileSync(x,H,{mode:z.mode,flag:z.flag});const F=p.openSync(x,z.flag,z.mode);try{p.writeFileSync(F,H);try{p.fdatasyncSync(F)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),v=!1}}finally{p.closeSync(F)}}e.writeFileSync=E;function y(x){return x?{mode:typeof x.mode=="number"?x.mode:438,flag:typeof x.flag=="string"?x.flag:"w"}:{mode:438,flag:"w"}}async function a(x,H){if(x===H)return;async function N(z){try{const F=await e.Promises.lstat(z);if(F.isDirectory()||F.isSymbolicLink())return;await e.Promises.utimes(z,F.atime,new Date)}catch(F){}}try{await e.Promises.rename(x,H),await N(H)}catch(z){if(x.toLowerCase()!==H.toLowerCase()&&z.code==="EXDEV"||x.endsWith("."))await T(x,H,{preserveSymlinks:!1}),await c(x,h.MOVE),await N(H);else throw z}}async function T(x,H,N){return $(x,H,{root:{source:x,target:H},options:N,handledSourcePaths:new Set})}const O=511;async function $(x,H,N){if(N.handledSourcePaths.has(x))return;N.handledSourcePaths.add(x);const{stat:z,symbolicLink:F}=await s.stat(x);if(F){if(N.options.preserveSymlinks)try{return await q(x,H,N)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(F.dangling)return}return z.isDirectory()?Z(x,H,z.mode&O,N):le(x,H,z.mode&O)}async function Z(x,H,N,z){await e.Promises.mkdir(H,{recursive:!0,mode:N});const F=await w(x);for(const M of F)await $(S.join(x,M),S.join(H,M),z)}async function le(x,H,N){await e.Promises.copyFile(x,H),await e.Promises.chmod(H,N)}async function q(x,H,N){let z=await e.Promises.readlink(x);_.isEqualOrParent(z,N.root.source,!P.isLinux)&&(z=S.join(N.root.target,z.substr(N.root.source.length+1))),await e.Promises.symlink(z,H)}e.Promises=new class{get access(){return C.promisify(p.access)}get stat(){return C.promisify(p.stat)}get lstat(){return C.promisify(p.lstat)}get utimes(){return C.promisify(p.utimes)}get read(){return C.promisify(p.read)}get readFile(){return C.promisify(p.readFile)}get write(){return C.promisify(p.write)}get appendFile(){return C.promisify(p.appendFile)}get fdatasync(){return C.promisify(p.fdatasync)}get truncate(){return C.promisify(p.truncate)}get rename(){return C.promisify(p.rename)}get copyFile(){return C.promisify(p.copyFile)}get open(){return C.promisify(p.open)}get close(){return C.promisify(p.close)}get symlink(){return C.promisify(p.symlink)}get readlink(){return C.promisify(p.readlink)}get chmod(){return C.promisify(p.chmod)}get mkdir(){return C.promisify(p.mkdir)}get unlink(){return C.promisify(p.unlink)}get rmdir(){return C.promisify(p.rmdir)}get realpath(){return C.promisify(p.realpath)}async exists(x){try{return await e.Promises.access(x),!0}catch(H){return!1}}get readdir(){return w}get readDirsInDir(){return t}get writeFile(){return o}get rm(){return c}get move(){return a}get copy(){return T}}}),define(pe[102],ve([0,1,56,8,9,28]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(r){const k=C.dirname(r);if(r===k)return r;const l=(C.basename(r)||r).toLowerCase();try{const c=S.readdirSync(k).filter(f=>f.toLowerCase()===l);if(c.length===1){const f=A(k);if(f)return C.join(f,c[0])}else if(c.length>1){const f=c.indexOf(l);if(f>=0){const I=A(k);if(I)return C.join(I,c[f])}}}catch(h){}return null}e.realcaseSync=A;async function P(r){try{return await S.Promises.realpath(r)}catch(k){const l=D(r);return await S.Promises.access(l,p.constants.R_OK),l}}e.realpath=P;function _(r){try{return p.realpathSync(r)}catch(k){const l=D(r);return p.accessSync(l,p.constants.R_OK),l}}e.realpathSync=_;function D(r){return R.rtrim(C.normalize(r),C.sep)}});var qe=this&&this.__decorate||function(X,e,p,R){var C=arguments.length,S=C<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,p):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")S=Reflect.decorate(X,e,p,R);else for(var P=X.length-1;P>=0;P--)(A=X[P])&&(S=(C<3?A(S):C>3?A(e,p,S):A(e,p))||S);return C>3&&S&&Object.defineProperty(e,p,S),S};define(pe[103],ve([0,1,3,6,16,21,14,22,18,15,55,8,51]),function(X,e,p,R,C,S,A,P,_,D,r,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var h;(function(F){F[F.Promise=100]="Promise",F[F.PromiseCancel=101]="PromiseCancel",F[F.EventListen=102]="EventListen",F[F.EventDispose=103]="EventDispose"})(h=e.RequestType||(e.RequestType={}));function c(F){switch(F){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(F){F[F.Initialize=200]="Initialize",F[F.PromiseSuccess=201]="PromiseSuccess",F[F.PromiseError=202]="PromiseError",F[F.PromiseErrorObj=203]="PromiseErrorObj",F[F.EventFire=204]="EventFire"})(f=e.ResponseType||(e.ResponseType={}));function I(F){switch(F){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var b;(function(F){F[F.Uninitialized=0]="Uninitialized",F[F.Idle=1]="Idle"})(b||(b={}));class w{constructor(M){this.buffer=M,this.pos=0}read(M){const L=this.buffer.slice(this.pos,this.pos+M);return this.pos+=L.byteLength,L}}class u{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(M){this.buffers.push(M)}}var d;(function(F){F[F.Undefined=0]="Undefined",F[F.String=1]="String",F[F.Buffer=2]="Buffer",F[F.VSBuffer=3]="VSBuffer",F[F.Array=4]="Array",F[F.Object=5]="Object"})(d||(d={}));function g(F){const M=P.VSBuffer.alloc(4);return M.writeUInt32BE(F,0),M}function t(F){return F.read(4).readUInt32BE(0)}function i(F){const M=P.VSBuffer.alloc(1);return M.writeUInt8(F,0),M}const s={Undefined:i(d.Undefined),String:i(d.String),Buffer:i(d.Buffer),VSBuffer:i(d.VSBuffer),Array:i(d.Array),Object:i(d.Object)},n=typeof Buffer!="undefined";function o(F,M){if(typeof M=="undefined")F.write(s.Undefined);else if(typeof M=="string"){const L=P.VSBuffer.fromString(M);F.write(s.String),F.write(g(L.byteLength)),F.write(L)}else if(n&&Buffer.isBuffer(M)){const L=P.VSBuffer.wrap(M);F.write(s.Buffer),F.write(g(L.byteLength)),F.write(L)}else if(M instanceof P.VSBuffer)F.write(s.VSBuffer),F.write(g(M.byteLength)),F.write(M);else if(Array.isArray(M)){F.write(s.Array),F.write(g(M.length));for(const L of M)o(F,L)}else{const L=P.VSBuffer.fromString(JSON.stringify(M));F.write(s.Object),F.write(g(L.byteLength)),F.write(L)}}function v(F){switch(F.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return F.read(t(F)).toString();case d.Buffer:return F.read(t(F)).buffer;case d.VSBuffer:return F.read(t(F));case d.Array:{const L=t(F),U=[];for(let G=0;G<L;G++)U.push(v(F));return U}case d.Object:return JSON.parse(F.read(t(F)).toString())}}class m{constructor(M,L,U=null,G=1e3){this.protocol=M,this.ctx=L,this.logger=U,this.timeoutDelay=G,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(te=>this.onRawMessage(te)),this.sendResponse({type:200})}registerChannel(M,L){this.channels.set(M,L),setTimeout(()=>this.flushPendingRequests(M),0)}sendResponse(M){switch(M.type){case 200:{const L=this.send([M.type]);this.logger&&this.logger.logOutgoing(L,0,1,I(M.type));return}case 201:case 202:case 204:case 203:{const L=this.send([M.type,M.id],M.data);this.logger&&this.logger.logOutgoing(L,M.id,1,I(M.type),M.data);return}}}send(M,L=void 0){const U=new u;return o(U,M),o(U,L),this.sendBuffer(U.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(L){return 0}}onRawMessage(M){const L=new w(M),U=v(L),G=v(L),te=U[0];switch(te){case 100:return this.logger&&this.logger.logIncoming(M.byteLength,U[1],1,`${c(te)}: ${U[2]}.${U[3]}`,G),this.onPromise({type:te,id:U[1],channelName:U[2],name:U[3],arg:G});case 102:return this.logger&&this.logger.logIncoming(M.byteLength,U[1],1,`${c(te)}: ${U[2]}.${U[3]}`,G),this.onEventListen({type:te,id:U[1],channelName:U[2],name:U[3],arg:G});case 101:return this.logger&&this.logger.logIncoming(M.byteLength,U[1],1,`${c(te)}`),this.disposeActiveRequest({type:te,id:U[1]});case 103:return this.logger&&this.logger.logIncoming(M.byteLength,U[1],1,`${c(te)}`),this.disposeActiveRequest({type:te,id:U[1]})}}onPromise(M){const L=this.channels.get(M.channelName);if(!L){this.collectPendingRequest(M);return}const U=new S.CancellationTokenSource;let G;try{G=L.call(this.ctx,M.name,M.arg,U.token)}catch(Se){G=Promise.reject(Se)}const te=M.id;G.then(Se=>{this.sendResponse({id:te,data:Se,type:201}),this.activeRequests.delete(M.id)},Se=>{Se instanceof Error?this.sendResponse({id:te,data:{message:Se.message,name:Se.name,stack:Se.stack?Se.stack.split?Se.stack.split(`
`):Se.stack:void 0},type:202}):this.sendResponse({id:te,data:Se,type:203}),this.activeRequests.delete(M.id)});const me=R.toDisposable(()=>U.cancel());this.activeRequests.set(M.id,me)}onEventListen(M){const L=this.channels.get(M.channelName);if(!L){this.collectPendingRequest(M);return}const U=M.id,te=L.listen(this.ctx,M.name,M.arg)(me=>this.sendResponse({id:U,data:me,type:204}));this.activeRequests.set(M.id,te)}disposeActiveRequest(M){const L=this.activeRequests.get(M.id);L&&(L.dispose(),this.activeRequests.delete(M.id))}collectPendingRequest(M){let L=this.pendingRequests.get(M.channelName);L||(L=[],this.pendingRequests.set(M.channelName,L));const U=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.sendResponse({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);L.push({request:M,timeoutTimer:U})}flushPendingRequests(M){const L=this.pendingRequests.get(M);if(L){for(const U of L)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.onPromise(U.request);break;case 102:this.onEventListen(U.request);break}this.pendingRequests.delete(M)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}e.ChannelServer=m;var E;(function(F){F[F.LocalSide=0]="LocalSide",F[F.OtherSide=1]="OtherSide"})(E=e.RequestInitiator||(e.RequestInitiator={}));class y{constructor(M,L=null){this.protocol=M,this.isDisposed=!1,this.state=b.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(U=>this.onBuffer(U)),this.logger=L}getChannel(M){const L=this;return{call(U,G,te){return L.isDisposed?Promise.reject(A.canceled()):L.requestPromise(M,U,G,te)},listen(U,G){return L.isDisposed?Promise.reject(A.canceled()):L.requestEvent(M,U,G)}}}requestPromise(M,L,U,G=S.CancellationToken.None){const te=this.lastRequestId++,Se={id:te,type:100,channelName:M,name:L,arg:U};if(G.isCancellationRequested)return Promise.reject(A.canceled());let ye;return new Promise((je,ze)=>{if(G.isCancellationRequested)return ze(A.canceled());const Ge=()=>{const re=J=>{switch(J.type){case 201:this.handlers.delete(te),je(J.data);break;case 202:this.handlers.delete(te);const ce=new Error(J.data.message);ce.stack=J.data.stack,ce.name=J.data.name,ze(ce);break;case 203:this.handlers.delete(te),ze(J.data);break}};this.handlers.set(te,re),this.sendRequest(Se)};let j=null;this.state===b.Idle?Ge():(j=C.createCancelablePromise(re=>this.whenInitialized()),j.then(()=>{j=null,Ge()}));const Y=()=>{j?(j.cancel(),j=null):this.sendRequest({id:te,type:101}),ze(A.canceled())},ie=G.onCancellationRequested(Y);ye=R.combinedDisposable(R.toDisposable(Y),ie),this.activeRequests.add(ye)}).finally(()=>{this.activeRequests.delete(ye)})}requestEvent(M,L,U){const G=this.lastRequestId++,me={id:G,type:102,channelName:M,name:L,arg:U};let Se=null;const ye=new p.Emitter({onFirstListenerAdd:()=>{Se=C.createCancelablePromise(je=>this.whenInitialized()),Se.then(()=>{Se=null,this.activeRequests.add(ye),this.sendRequest(me)})},onLastListenerRemove:()=>{Se?(Se.cancel(),Se=null):(this.activeRequests.delete(ye),this.sendRequest({id:G,type:103}))}}),Le=je=>ye.fire(je.data);return this.handlers.set(G,Le),ye.event}sendRequest(M){switch(M.type){case 100:case 102:{const L=this.send([M.type,M.id,M.channelName,M.name],M.arg);this.logger&&this.logger.logOutgoing(L,M.id,0,`${c(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const L=this.send([M.type,M.id]);this.logger&&this.logger.logOutgoing(L,M.id,0,c(M.type));return}}}send(M,L=void 0){const U=new u;return o(U,M),o(U,L),this.sendBuffer(U.buffer)}sendBuffer(M){try{return this.protocol.send(M),M.byteLength}catch(L){return 0}}onBuffer(M){const L=new w(M),U=v(L),G=v(L),te=U[0];switch(te){case 200:return this.logger&&this.logger.logIncoming(M.byteLength,0,0,I(te)),this.onResponse({type:U[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(M.byteLength,U[1],0,I(te),G),this.onResponse({type:U[0],id:U[1],data:G})}}onResponse(M){if(M.type===200){this.state=b.Idle,this._onDidInitialize.fire();return}const L=this.handlers.get(M.id);L&&L(M)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===b.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(M=>M.dispose()),this.activeRequests.clear()}}qe([l.memoize],y.prototype,"onDidInitializePromise",null),e.ChannelClient=y;class a{constructor(M){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,M(({protocol:L,onDidClientDisconnect:U})=>{p.Event.once(L.onMessage)(te=>{const me=new w(te),Se=v(me),ye=new m(L,Se),Le=new y(L);this.channels.forEach((ze,Ge)=>ye.registerChannel(Ge,ze));const je={channelServer:ye,channelClient:Le,ctx:Se};this._connections.add(je),this._onDidAddConnection.fire(je),U(()=>{ye.dispose(),Le.dispose(),this._connections.delete(je),this._onDidRemoveConnection.fire(je)})})})}get connections(){const M=[];return this._connections.forEach(L=>M.push(L)),M}getChannel(M,L){const U=this;return{call(G,te,me){let Se;if(D.isFunction(L)){let Le=_.getRandomElement(U.connections.filter(L));Se=Le?Promise.resolve(Le):p.Event.toPromise(p.Event.filter(U.onDidAddConnection,L))}else Se=L.routeCall(U,G,te);const ye=Se.then(Le=>Le.channelClient.getChannel(M));return O(ye).call(G,te,me)},listen(G,te){if(D.isFunction(L))return U.getMulticastEvent(M,L,G,te);const me=L.routeEvent(U,G,te).then(Se=>Se.channelClient.getChannel(M));return O(me).listen(G,te)}}}getMulticastEvent(M,L,U,G){const te=this;let me=new R.DisposableStore;const Se=new p.Emitter({onFirstListenerAdd:()=>{me=new R.DisposableStore;const ye=new p.EventMultiplexer,Le=new Map,je=Ge=>{const Y=Ge.channelClient.getChannel(M).listen(U,G),ie=ye.add(Y);Le.set(Ge,ie)},ze=Ge=>{const j=Le.get(Ge);!j||(j.dispose(),Le.delete(Ge))};te.connections.filter(L).forEach(je),p.Event.filter(te.onDidAddConnection,L)(je,void 0,me),te.onDidRemoveConnection(ze,void 0,me),ye.event(Se.fire,Se,me),me.add(ye)},onLastListenerRemove:()=>{me.dispose()}});return Se.event}registerChannel(M,L){this.channels.set(M,L),this._connections.forEach(U=>{U.channelServer.registerChannel(M,L)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=a;class T{constructor(M,L,U=null){const G=new u;o(G,L),M.send(G.buffer),this.channelClient=new y(M,U),this.channelServer=new m(M,L,U)}getChannel(M){return this.channelClient.getChannel(M)}registerChannel(M,L){this.channelServer.registerChannel(M,L)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=T;function O(F){return{call(M,L,U){return F.then(G=>G.call(M,L,U))},listen(M,L){const U=new p.Relay;return F.then(G=>U.input=G.listen(M,L)),U.event}}}e.getDelayedChannel=O;function $(F){let M=!1;return{call(L,U,G){return M?F.call(L,U,G):C.timeout(0).then(()=>M=!0).then(()=>F.call(L,U,G))},listen(L,U){if(M)return F.listen(L,U);const G=new p.Relay;return C.timeout(0).then(()=>M=!0).then(()=>G.input=F.listen(L,U)),G.event}}}e.getNextTickChannel=$;class Z{constructor(M){this.fn=M}routeCall(M){return this.route(M)}routeEvent(M){return this.route(M)}async route(M){for(const L of M.connections)if(await Promise.resolve(this.fn(L.ctx)))return Promise.resolve(L);return await p.Event.toPromise(M.onDidAddConnection),await this.route(M)}}e.StaticRouter=Z;var le;(function(F){function M(G,te){const me=G,Se=te&&te.disableMarshalling,ye=new Map;for(const Le in me)U(Le)&&ye.set(Le,p.Event.buffer(me[Le],!0));return new class{listen(Le,je){const ze=ye.get(je);if(ze)return ze;throw new Error(`Event not found: ${je}`)}call(Le,je,ze){const Ge=me[je];if(typeof Ge=="function"){if(!Se&&Array.isArray(ze))for(let j=0;j<ze.length;j++)ze[j]=r.revive(ze[j]);return Ge.apply(me,ze)}throw new Error(`Method not found: ${je}`)}}}F.fromService=M;function L(G,te){const me=te&&te.disableMarshalling;return new Proxy({},{get(Se,ye){var Le;if(typeof ye=="string")return((Le=te==null?void 0:te.properties)===null||Le===void 0?void 0:Le.has(ye))?te.properties.get(ye):U(ye)?G.listen(ye):async function(...je){let ze;te&&!D.isUndefinedOrNull(te.context)?ze=[te.context,...je]:ze=je;const Ge=await G.call(ye,ze);return me?Ge:r.revive(Ge)};throw new Error(`Property not found: ${String(ye)}`)}})}F.toService=L;function U(G){return G[0]==="o"&&G[1]==="n"&&k.isUpperAsciiLetter(G.charCodeAt(2))}})(le=e.ProxyChannel||(e.ProxyChannel={}));const q=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function x(F){if(Array.isArray(F))return F;if(F&&typeof F=="object"&&typeof F.toString=="function"){let M=F.toString();if(M!=="[object Object]")return M}return F}function H(F){return Array.isArray(F)?F.map(x):x(F)}function N(F,M,L,U,G,te,me){me=H(me);const Se=q[G],ye=Se[U%Se.length];let Le=[`%c[${F}]%c[${String(M).padStart(7," ")}]%c[len: ${String(L).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${te}`,"color: darkgreen","color: grey","color: grey",`color: ${ye}`];/\($/.test(te)?(Le=Le.concat(me),Le.push(")")):Le.push(me),console.log.apply(console,Le)}e.logWithColors=N;class z{constructor(M,L){this._outgoingPrefix=M,this._incomingPrefix=L,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(M,L,U,G,te){this._totalOutgoing+=M,N(this._outgoingPrefix,this._totalOutgoing,M,L,U,G,te)}logIncoming(M,L,U,G,te){this._totalIncoming+=M,N(this._incomingPrefix,this._totalIncoming,M,L,U,G,te)}}e.IPCLogger=z}),define(pe[104],ve([0,1,3,103,6,22,11,37]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var _;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(_=e.SocketCloseEventType||(e.SocketCloseEventType={}));let D=null;function r(){return D||(D=S.VSBuffer.alloc(0)),D}class k{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,o){if(n===0)return r();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const y=this._chunks[0];return o&&(this._chunks.shift(),this._totalLength-=n),y}if(this._chunks[0].byteLength>n){const y=this._chunks[0].slice(0,n);return o&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),y}let v=S.VSBuffer.alloc(n),m=0,E=0;for(;n>0;){const y=this._chunks[E];if(y.byteLength>n){const a=y.slice(0,n);v.set(a,m),m+=n,o&&(this._chunks[E]=y.slice(n),this._totalLength-=n),n-=n}else v.set(y,m),m+=y.byteLength,o?(this._chunks.shift(),this._totalLength-=y.byteLength):E++,n-=y.byteLength}return v}}e.ChunkStream=k;var l;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(l||(l={}));var h;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(h=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(n,o,v,m){this.type=n,this.id=o,this.ack=v,this.data=m,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends C.Disposable{constructor(n){super();this._onMessage=this._register(new p.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new k,this._register(this._socket.onData(o=>this.acceptChunk(o))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const o=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=o.readUInt32BE(9),this._state.messageType=o.readUInt8(0),this._state.id=o.readUInt32BE(1),this._state.ack=o.readUInt32BE(5);else{const v=this._state.messageType,m=this._state.id,E=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new c(v,m,E,o)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class I{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const o=S.VSBuffer.alloc(13);o.writeUInt8(n.type,0),o.writeUInt32BE(n.id,1),o.writeUInt32BE(n.ack,5),o.writeUInt32BE(n.data.byteLength,9),this._writeSoon(o,n.data)}_bufferAdd(n,o){const v=this._totalLength===0;return this._data.push(n,o),this._totalLength+=n.byteLength+o.byteLength,v}_bufferTake(){const n=S.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,o){this._bufferAdd(n,o)&&A.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class b extends C.Disposable{constructor(n){super();this._onMessage=new p.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new I(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(o=>{o.type===1&&this._onMessage.fire(o.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new c(1,0,0,n))}}e.Protocol=b;class w extends R.IPCClient{constructor(n,o,v=null){super(n,o,v);this.protocol=n}static fromSocket(n,o){return new w(new b(n),o)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=w;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new p.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class d{constructor(n){this.data=n,this.next=null}}class g{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],o=0,v=this._first;for(;v;)n[o++]=v.data,v=v.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const o=new d(n);if(!this._first){this._first=o,this._last=o;return}this._last.next=o,this._last=o}}class t{constructor(){this.lastRuns=[];const n=Date.now();for(let o=0;o<t._HISTORY_LENGTH;o++)this.lastRuns[o]=n-1e3*o;setInterval(()=>{for(let o=t._HISTORY_LENGTH;o>=1;o--)this.lastRuns[o]=this.lastRuns[o-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return t._INSTANCE||(t._INSTANCE=new t),t._INSTANCE}load(){const n=Date.now(),o=(1+t._HISTORY_LENGTH)*1e3;let v=0;for(let m=0;m<t._HISTORY_LENGTH;m++)n-this.lastRuns[m]<=o&&v++;return 1-v/t._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}t._HISTORY_LENGTH=10,t._INSTANCE=null;class i{constructor(n,o=null){this._loadEstimator=t.getInstance(),this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new g,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),o&&this._socketReader.acceptChunk(o),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=C.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new c(5,0,0,r());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const o=new c(4,0,0,r());this._socketWriter.write(o),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,o){this._isReconnecting=!0,this._socketDisposables=C.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new I(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),this._socketReader.acceptChunk(o)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let o=0,v=n.length;o<v;o++)this._socketWriter.write(n[o]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const o=this._outgoingUnackMsg.peek();if(o&&o.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const o=Date.now();o-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=o,this._socketWriter.write(new c(6,0,0,r())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const o=this._outgoingUnackMsg.toArray();for(let v=0,m=o.length;v<m;v++)this._socketWriter.write(o[v]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const o=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const v=new c(1,o,this._incomingAckId,n);this._outgoingUnackMsg.push(v),this._isReconnecting||(this._socketWriter.write(v),this._recvAckCheck())}sendControl(n){const o=new c(2,0,0,n);this._socketWriter.write(o)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),o=Date.now()-n.writtenTime;if(o>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-o,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new c(3,0,this._incomingAckId,r());this._socketWriter.write(n)}}e.PersistentProtocol=i}),define(pe[105],ve([0,1,93]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(P){let _=p.toUint8(P);this._defaultValue=_,this._asciiMap=R._createAsciiMap(_),this._map=new Map}static _createAsciiMap(P){let _=new Uint8Array(256);for(let D=0;D<256;D++)_[D]=P;return _}set(P,_){let D=p.toUint8(_);P>=0&&P<256?this._asciiMap[P]=D:this._map.set(P,D)}get(P){return P>=0&&P<256?this._asciiMap[P]:this._map.get(P)||this._defaultValue}}e.CharacterClassifier=R;var C;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(C||(C={}));class S{constructor(){this._actual=new R(0)}add(P){this._actual.set(P,1)}has(P){return this._actual.get(P)===1}}e.CharacterSet=S}),define(pe[138],ve([0,1,105]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(R=e.WordCharacterClass||(e.WordCharacterClass={}));class C extends p.CharacterClassifier{constructor(P){super(0);for(let _=0,D=P.length;_<D;_++)this.set(P.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=C;function S(A){let P={};return _=>(P.hasOwnProperty(_)||(P[_]=A(_)),P[_])}e.getMapForWordSeparators=S(A=>new C(A))}),define(pe[44],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class p{constructor(C,S){this.lineNumber=C,this.column=S}with(C=this.lineNumber,S=this.column){return C===this.lineNumber&&S===this.column?this:new p(C,S)}delta(C=0,S=0){return this.with(this.lineNumber+C,this.column+S)}equals(C){return p.equals(this,C)}static equals(C,S){return!C&&!S?!0:!!C&&!!S&&C.lineNumber===S.lineNumber&&C.column===S.column}isBefore(C){return p.isBefore(this,C)}static isBefore(C,S){return C.lineNumber<S.lineNumber?!0:S.lineNumber<C.lineNumber?!1:C.column<S.column}isBeforeOrEqual(C){return p.isBeforeOrEqual(this,C)}static isBeforeOrEqual(C,S){return C.lineNumber<S.lineNumber?!0:S.lineNumber<C.lineNumber?!1:C.column<=S.column}static compare(C,S){let A=C.lineNumber|0,P=S.lineNumber|0;if(A===P){let _=C.column|0,D=S.column|0;return _-D}return A-P}clone(){return new p(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(C){return new p(C.lineNumber,C.column)}static isIPosition(C){return C&&typeof C.lineNumber=="number"&&typeof C.column=="number"}}e.Position=p}),define(pe[41],ve([0,1,44]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(S,A,P,_){S>P||S===P&&A>_?(this.startLineNumber=P,this.startColumn=_,this.endLineNumber=S,this.endColumn=A):(this.startLineNumber=S,this.startColumn=A,this.endLineNumber=P,this.endColumn=_)}isEmpty(){return R.isEmpty(this)}static isEmpty(S){return S.startLineNumber===S.endLineNumber&&S.startColumn===S.endColumn}containsPosition(S){return R.containsPosition(this,S)}static containsPosition(S,A){return!(A.lineNumber<S.startLineNumber||A.lineNumber>S.endLineNumber||A.lineNumber===S.startLineNumber&&A.column<S.startColumn||A.lineNumber===S.endLineNumber&&A.column>S.endColumn)}containsRange(S){return R.containsRange(this,S)}static containsRange(S,A){return!(A.startLineNumber<S.startLineNumber||A.endLineNumber<S.startLineNumber||A.startLineNumber>S.endLineNumber||A.endLineNumber>S.endLineNumber||A.startLineNumber===S.startLineNumber&&A.startColumn<S.startColumn||A.endLineNumber===S.endLineNumber&&A.endColumn>S.endColumn)}strictContainsRange(S){return R.strictContainsRange(this,S)}static strictContainsRange(S,A){return!(A.startLineNumber<S.startLineNumber||A.endLineNumber<S.startLineNumber||A.startLineNumber>S.endLineNumber||A.endLineNumber>S.endLineNumber||A.startLineNumber===S.startLineNumber&&A.startColumn<=S.startColumn||A.endLineNumber===S.endLineNumber&&A.endColumn>=S.endColumn)}plusRange(S){return R.plusRange(this,S)}static plusRange(S,A){let P,_,D,r;return A.startLineNumber<S.startLineNumber?(P=A.startLineNumber,_=A.startColumn):A.startLineNumber===S.startLineNumber?(P=A.startLineNumber,_=Math.min(A.startColumn,S.startColumn)):(P=S.startLineNumber,_=S.startColumn),A.endLineNumber>S.endLineNumber?(D=A.endLineNumber,r=A.endColumn):A.endLineNumber===S.endLineNumber?(D=A.endLineNumber,r=Math.max(A.endColumn,S.endColumn)):(D=S.endLineNumber,r=S.endColumn),new R(P,_,D,r)}intersectRanges(S){return R.intersectRanges(this,S)}static intersectRanges(S,A){let P=S.startLineNumber,_=S.startColumn,D=S.endLineNumber,r=S.endColumn,k=A.startLineNumber,l=A.startColumn,h=A.endLineNumber,c=A.endColumn;return P<k?(P=k,_=l):P===k&&(_=Math.max(_,l)),D>h?(D=h,r=c):D===h&&(r=Math.min(r,c)),P>D||P===D&&_>r?null:new R(P,_,D,r)}equalsRange(S){return R.equalsRange(this,S)}static equalsRange(S,A){return!!S&&!!A&&S.startLineNumber===A.startLineNumber&&S.startColumn===A.startColumn&&S.endLineNumber===A.endLineNumber&&S.endColumn===A.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(S){return new p.Position(S.endLineNumber,S.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(S){return new p.Position(S.startLineNumber,S.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(S,A){return new R(this.startLineNumber,this.startColumn,S,A)}setStartPosition(S,A){return new R(S,A,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(S){return new R(S.startLineNumber,S.startColumn,S.startLineNumber,S.startColumn)}static fromPositions(S,A=S){return new R(S.lineNumber,S.column,A.lineNumber,A.column)}static lift(S){return S?new R(S.startLineNumber,S.startColumn,S.endLineNumber,S.endColumn):null}static isIRange(S){return S&&typeof S.startLineNumber=="number"&&typeof S.startColumn=="number"&&typeof S.endLineNumber=="number"&&typeof S.endColumn=="number"}static areIntersectingOrTouching(S,A){return!(S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<A.startColumn||A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<S.startColumn)}static areIntersecting(S,A){return!(S.endLineNumber<A.startLineNumber||S.endLineNumber===A.startLineNumber&&S.endColumn<=A.startColumn||A.endLineNumber<S.startLineNumber||A.endLineNumber===S.startLineNumber&&A.endColumn<=S.startColumn)}static compareRangesUsingStarts(S,A){if(S&&A){const D=S.startLineNumber|0,r=A.startLineNumber|0;if(D===r){const k=S.startColumn|0,l=A.startColumn|0;if(k===l){const h=S.endLineNumber|0,c=A.endLineNumber|0;if(h===c){const f=S.endColumn|0,I=A.endColumn|0;return f-I}return h-c}return k-l}return D-r}return(S?1:0)-(A?1:0)}static compareRangesUsingEnds(S,A){return S.endLineNumber===A.endLineNumber?S.endColumn===A.endColumn?S.startLineNumber===A.startLineNumber?S.startColumn-A.startColumn:S.startLineNumber-A.startLineNumber:S.endColumn-A.endColumn:S.endLineNumber-A.endLineNumber}static spansMultipleLines(S){return S.endLineNumber>S.startLineNumber}}e.Range=R}),define(pe[139],ve([0,1,44,41]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var C;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(C=e.SelectionDirection||(e.SelectionDirection={}));class S extends R.Range{constructor(P,_,D,r){super(P,_,D,r);this.selectionStartLineNumber=P,this.selectionStartColumn=_,this.positionLineNumber=D,this.positionColumn=r}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return S.selectionsEqual(this,P)}static selectionsEqual(P,_){return P.selectionStartLineNumber===_.selectionStartLineNumber&&P.selectionStartColumn===_.selectionStartColumn&&P.positionLineNumber===_.positionLineNumber&&P.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,_){return this.getDirection()===0?new S(this.startLineNumber,this.startColumn,P,_):new S(P,_,this.startLineNumber,this.startColumn)}getPosition(){return new p.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(P,_){return this.getDirection()===0?new S(P,_,this.endLineNumber,this.endColumn):new S(this.endLineNumber,this.endColumn,P,_)}static fromPositions(P,_=P){return new S(P.lineNumber,P.column,_.lineNumber,_.column)}static liftSelection(P){return new S(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,_){if(P&&!_||!P&&_)return!1;if(!P&&!_)return!0;if(P.length!==_.length)return!1;for(let D=0,r=P.length;D<r;D++)if(!this.selectionsEqual(P[D],_[D]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,_,D,r,k){return k===0?new S(P,_,D,r):new S(D,r,P,_)}}e.Selection=S}),define(pe[106],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var p;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(p=e.OverviewRulerLane||(e.OverviewRulerLane={}));var R;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(R=e.MinimapPosition||(e.MinimapPosition={}));var C;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(C=e.EndOfLinePreference||(e.EndOfLinePreference={}));var S;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(S=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var A;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(A=e.EndOfLineSequence||(e.EndOfLineSequence={}));class P{constructor(f){this.tabSize=Math.max(1,f.tabSize|0),this.indentSize=f.tabSize|0,this.insertSpaces=Boolean(f.insertSpaces),this.defaultEOL=f.defaultEOL|0,this.trimAutoWhitespace=Boolean(f.trimAutoWhitespace)}equals(f){return this.tabSize===f.tabSize&&this.indentSize===f.indentSize&&this.insertSpaces===f.insertSpaces&&this.defaultEOL===f.defaultEOL&&this.trimAutoWhitespace===f.trimAutoWhitespace}createChangeEvent(f){return{tabSize:this.tabSize!==f.tabSize,indentSize:this.indentSize!==f.indentSize,insertSpaces:this.insertSpaces!==f.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==f.trimAutoWhitespace}}}e.TextModelResolvedOptions=P;class _{constructor(f,I){this.range=f,this.matches=I}}e.FindMatch=_;var D;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(D=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var r;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(r=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var k;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(k=e.ModelConstants||(e.ModelConstants={}));class l{constructor(f,I,b,w,u,d){this.identifier=f,this.range=I,this.text=b,this.forceMoveMarkers=w,this.isAutoWhitespaceEdit=u,this._isTracked=d}}e.ValidAnnotatedEditOperation=l;class h{constructor(f,I,b){this.reverseEdits=f,this.changes=I,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=h}),define(pe[140],ve([0,1,8,138,44,41,106]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class _{constructor(u,d,g,t){this.searchString=u,this.isRegex=d,this.matchCase=g,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let u;this.isRegex?u=D(this.searchString):u=this.searchString.indexOf(`
`)>=0;let d=null;try{d=p.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:u,global:!0,unicode:!0})}catch(t){return null}if(!d)return null;let g=!this.isRegex&&!u;return g&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(g=this.matchCase),new r(d,this.wordSeparators?R.getMapForWordSeparators(this.wordSeparators):null,g?this.searchString:null)}}e.SearchParams=_;function D(w){if(!w||w.length===0)return!1;for(let u=0,d=w.length;u<d;u++)if(w.charCodeAt(u)===92){if(u++,u>=d)break;const t=w.charCodeAt(u);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=D;class r{constructor(u,d,g){this.regex=u,this.wordSeparators=d,this.simpleSearch=g}}e.SearchData=r;function k(w,u,d){if(!d)return new A.FindMatch(w,null);let g=[];for(let t=0,i=u.length;t<i;t++)g[t]=u[t];return new A.FindMatch(w,g)}e.createFindMatch=k;class l{constructor(u){let d=[],g=0;for(let t=0,i=u.length;t<i;t++)u.charCodeAt(t)===10&&(d[g++]=t);this._lineFeedsOffsets=d}findLineFeedCountBeforeOffset(u){const d=this._lineFeedsOffsets;let g=0,t=d.length-1;if(t===-1||u<=d[0])return 0;for(;g<t;){const i=g+((t-g)/2>>0);d[i]>=u?t=i-1:d[i+1]>=u?(g=i,t=i):g=i+1}return g+1}}class h{static findMatches(u,d,g,t,i){const s=d.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(u,g,new b(s.wordSeparators,s.regex),t,i):this._doFindMatchesLineByLine(u,g,s,t,i):[]}static _getMultilineMatchRange(u,d,g,t,i,s){let n,o=0;t?(o=t.findLineFeedCountBeforeOffset(i),n=d+i+o):n=d+i;let v;if(t){let a=t.findLineFeedCountBeforeOffset(i+s.length)-o;v=n+s.length+a}else v=n+s.length;const m=u.getPositionAt(n),E=u.getPositionAt(v);return new S.Range(m.lineNumber,m.column,E.lineNumber,E.column)}static _doFindMatchesMultiline(u,d,g,t,i){const s=u.getOffsetAt(d.getStartPosition()),n=u.getValueInRange(d,1),o=u.getEOL()===`\r
`?new l(n):null,v=[];let m=0,E;for(g.reset(0);E=g.next(n);)if(v[m++]=k(this._getMultilineMatchRange(u,s,n,o,E.index,E[0]),E,t),m>=i)return v;return v}static _doFindMatchesLineByLine(u,d,g,t,i){const s=[];let n=0;if(d.startLineNumber===d.endLineNumber){const v=u.getLineContent(d.startLineNumber).substring(d.startColumn-1,d.endColumn-1);return n=this._findMatchesInLine(g,v,d.startLineNumber,d.startColumn-1,n,s,t,i),s}const o=u.getLineContent(d.startLineNumber).substring(d.startColumn-1);n=this._findMatchesInLine(g,o,d.startLineNumber,d.startColumn-1,n,s,t,i);for(let v=d.startLineNumber+1;v<d.endLineNumber&&n<i;v++)n=this._findMatchesInLine(g,u.getLineContent(v),v,0,n,s,t,i);if(n<i){const v=u.getLineContent(d.endLineNumber).substring(0,d.endColumn-1);n=this._findMatchesInLine(g,v,d.endLineNumber,0,n,s,t,i)}return s}static _findMatchesInLine(u,d,g,t,i,s,n,o){const v=u.wordSeparators;if(!n&&u.simpleSearch){const y=u.simpleSearch,a=y.length,T=d.length;let O=-a;for(;(O=d.indexOf(y,O+a))!==-1;)if((!v||I(v,d,T,O,a))&&(s[i++]=new A.FindMatch(new S.Range(g,O+1+t,g,O+1+a+t),null),i>=o))return i;return i}const m=new b(u.wordSeparators,u.regex);let E;m.reset(0);do if(E=m.next(d),E&&(s[i++]=k(new S.Range(g,E.index+1+t,g,E.index+1+E[0].length+t),E,n),i>=o))return i;while(E);return i}static findNextMatch(u,d,g,t){const i=d.parseSearchRequest();if(!i)return null;const s=new b(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindNextMatchMultiline(u,g,s,t):this._doFindNextMatchLineByLine(u,g,s,t)}static _doFindNextMatchMultiline(u,d,g,t){const i=new C.Position(d.lineNumber,1),s=u.getOffsetAt(i),n=u.getLineCount(),o=u.getValueInRange(new S.Range(i.lineNumber,i.column,n,u.getLineMaxColumn(n)),1),v=u.getEOL()===`\r
`?new l(o):null;g.reset(d.column-1);let m=g.next(o);return m?k(this._getMultilineMatchRange(u,s,o,v,m.index,m[0]),m,t):d.lineNumber!==1||d.column!==1?this._doFindNextMatchMultiline(u,new C.Position(1,1),g,t):null}static _doFindNextMatchLineByLine(u,d,g,t){const i=u.getLineCount(),s=d.lineNumber,n=u.getLineContent(s),o=this._findFirstMatchInLine(g,n,s,d.column,t);if(o)return o;for(let v=1;v<=i;v++){const m=(s+v-1)%i,E=u.getLineContent(m+1),y=this._findFirstMatchInLine(g,E,m+1,1,t);if(y)return y}return null}static _findFirstMatchInLine(u,d,g,t,i){u.reset(t-1);const s=u.next(d);return s?k(new S.Range(g,s.index+1,g,s.index+1+s[0].length),s,i):null}static findPreviousMatch(u,d,g,t){const i=d.parseSearchRequest();if(!i)return null;const s=new b(i.wordSeparators,i.regex);return i.regex.multiline?this._doFindPreviousMatchMultiline(u,g,s,t):this._doFindPreviousMatchLineByLine(u,g,s,t)}static _doFindPreviousMatchMultiline(u,d,g,t){const i=this._doFindMatchesMultiline(u,new S.Range(1,1,d.lineNumber,d.column),g,t,10*P);if(i.length>0)return i[i.length-1];const s=u.getLineCount();return d.lineNumber!==s||d.column!==u.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(u,new C.Position(s,u.getLineMaxColumn(s)),g,t):null}static _doFindPreviousMatchLineByLine(u,d,g,t){const i=u.getLineCount(),s=d.lineNumber,n=u.getLineContent(s).substring(0,d.column-1),o=this._findLastMatchInLine(g,n,s,t);if(o)return o;for(let v=1;v<=i;v++){const m=(i+s-v-1)%i,E=u.getLineContent(m+1),y=this._findLastMatchInLine(g,E,m+1,t);if(y)return y}return null}static _findLastMatchInLine(u,d,g,t){let i=null,s;for(u.reset(0);s=u.next(d);)i=k(new S.Range(g,s.index+1,g,s.index+1+s[0].length),s,t);return i}}e.TextModelSearch=h;function c(w,u,d,g,t){if(g===0)return!0;const i=u.charCodeAt(g-1);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=u.charCodeAt(g);if(w.get(s)!==0)return!0}return!1}function f(w,u,d,g,t){if(g+t===d)return!0;const i=u.charCodeAt(g+t);if(w.get(i)!==0||i===13||i===10)return!0;if(t>0){const s=u.charCodeAt(g+t-1);if(w.get(s)!==0)return!0}return!1}function I(w,u,d,g,t){return c(w,u,d,g,t)&&f(w,u,d,g,t)}e.isValidMatch=I;class b{constructor(u,d){this._wordSeparators=u,this._searchRegex=d,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(u){this._searchRegex.lastIndex=u,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(u){const d=u.length;let g;do{if(this._prevMatchStartIndex+this._prevMatchLength===d||(g=this._searchRegex.exec(u),!g))return null;const t=g.index,i=g[0].length;if(t===this._prevMatchStartIndex&&i===this._prevMatchLength){if(i===0){p.getNextCodePoint(u,d,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=i,!this._wordSeparators||I(this._wordSeparators,u,d,t,i))return g}while(g);return null}}e.Searcher=b}),define(pe[107],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function p(P=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const D of e.USUAL_WORD_SEPARATORS)P.indexOf(D)>=0||(_+="\\"+D);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=p();function R(P){let _=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)_=P;else{let D="g";P.ignoreCase&&(D+="i"),P.multiline&&(D+="m"),P.unicode&&(D+="u"),_=new RegExp(P.source,D)}return _.lastIndex=0,_}e.ensureValidWordDefinition=R;const C={maxLen:1e3,windowSize:15,timeBudget:150};function S(P,_,D,r,k=C){if(D.length>k.maxLen){let I=P-k.maxLen/2;return I<0?I=0:r+=I,D=D.substring(I,P+k.maxLen/2),S(P,_,D,r,k)}const l=Date.now(),h=P-1-r;let c=-1,f=null;for(let I=1;!(Date.now()-l>=k.timeBudget);I++){const b=h-k.windowSize*I;_.lastIndex=Math.max(0,b);const w=A(_,D,h,c);if(!w&&f||(f=w,b<=0))break;c=b}if(f){let I={word:f[0],startColumn:r+1+f.index,endColumn:r+1+f.index+f[0].length};return _.lastIndex=0,I}return null}e.getWordAtText=S;function A(P,_,D,r){let k;for(;k=P.exec(_);){const l=k.index||0;if(l<=D&&P.lastIndex>=D)return k;if(r>0&&l>r)return null}return null}}),define(pe[141],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var p;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(p=e.IndentAction||(e.IndentAction={}));class R{constructor(P){if(this.open=P.open,this.close=P.close,this._standardTokenMask=0,Array.isArray(P.notIn))for(let _=0,D=P.notIn.length;_<D;_++)switch(P.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(P){return(this._standardTokenMask&P)==0}}e.StandardAutoClosingPairConditional=R;class C{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of P)S(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),S(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),S(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),S(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&S(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=C;function S(A,P,_){A.has(P)?A.get(P).push(_):A.set(P,[_])}}),define(pe[76],ve([0,1,30,9]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function C(S,A,P,_){if(Array.isArray(S)){let D=0;for(const r of S){const k=C(r,A,P,_);if(k===10)return k;k>D&&(D=k)}return D}else{if(typeof S=="string")return _?S==="*"?5:S===P?10:0:0;if(S){const{language:D,pattern:r,scheme:k,hasAccessToAllModels:l}=S;if(!_&&!l)return 0;let h=0;if(k)if(k===A.scheme)h=10;else if(k==="*")h=5;else return 0;if(D)if(D===P)h=10;else if(D==="*")h=Math.max(h,5);else return 0;if(r){let c;if(typeof r=="string"?c=r:c=Object.assign(Object.assign({},r),{base:R.normalize(r.base)}),c===A.fsPath||p.match(c,A.fsPath))h=10;else return 0}return h}else return 0}}e.score=C}),define(pe[142],ve([0,1,105]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var R;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(R=e.State||(e.State={}));class C{constructor(c,f,I){const b=new Uint8Array(c*f);for(let w=0,u=c*f;w<u;w++)b[w]=I;this._data=b,this.rows=c,this.cols=f}get(c,f){return this._data[c*this.cols+f]}set(c,f,I){this._data[c*this.cols+f]=I}}e.Uint8Matrix=C;class S{constructor(c){let f=0,I=0;for(let w=0,u=c.length;w<u;w++){let[d,g,t]=c[w];g>f&&(f=g),d>I&&(I=d),t>I&&(I=t)}f++,I++;let b=new C(I,f,0);for(let w=0,u=c.length;w<u;w++){let[d,g,t]=c[w];b.set(d,g,t)}this._states=b,this._maxCharCode=f}nextState(c,f){return f<0||f>=this._maxCharCode?0:this._states.get(c,f)}}e.StateMachine=S;let A=null;function P(){return A===null&&(A=new S([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var _;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let D=null;function r(){if(D===null){D=new p.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<h.length;f++)D.set(h.charCodeAt(f),1);const c=".,;";for(let f=0;f<c.length;f++)D.set(c.charCodeAt(f),2)}return D}class k{static _createLink(c,f,I,b,w){let u=w-1;do{const d=f.charCodeAt(u);if(c.get(d)!==2)break;u--}while(u>b);if(b>0){const d=f.charCodeAt(b-1),g=f.charCodeAt(u);(d===40&&g===41||d===91&&g===93||d===123&&g===125)&&u--}return{range:{startLineNumber:I,startColumn:b+1,endLineNumber:I,endColumn:u+2},url:f.substring(b,u+1)}}static computeLinks(c,f=P()){const I=r();let b=[];for(let w=1,u=c.getLineCount();w<=u;w++){const d=c.getLineContent(w),g=d.length;let t=0,i=0,s=0,n=1,o=!1,v=!1,m=!1,E=!1;for(;t<g;){let y=!1;const a=d.charCodeAt(t);if(n===13){let T;switch(a){case 40:o=!0,T=0;break;case 41:T=o?0:1;break;case 91:m=!0,v=!0,T=0;break;case 93:m=!1,T=v?0:1;break;case 123:E=!0,T=0;break;case 125:T=E?0:1;break;case 39:T=s===34||s===96?0:1;break;case 34:T=s===39||s===96?0:1;break;case 96:T=s===39||s===34?0:1;break;case 42:T=s===42?1:0;break;case 124:T=s===124?1:0;break;case 32:T=m?0:1;break;default:T=I.get(a)}T===1&&(b.push(k._createLink(I,d,w,i,t)),y=!0)}else if(n===12){let T;a===91?(v=!0,T=0):T=I.get(a),T===1?y=!0:n=13}else n=f.nextState(n,a),n===0&&(y=!0);y&&(n=1,o=!1,v=!1,E=!1,i=t+1,s=a),t++}n===13&&b.push(k._createLink(I,d,w,i,g))}return b}}e.LinkComputer=k;function l(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:k.computeLinks(h)}e.computeLinks=l}),define(pe[143],ve([0,1,3,6]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class C{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(A){this._onDidChange.fire({changedLanguages:A,changedColorMap:!1})}register(A,P){return this._map.set(A,P),this.fire([A]),R.toDisposable(()=>{this._map.get(A)===P&&(this._map.delete(A),this.fire([A]))})}registerPromise(A,P){let _=null,D=!1;return this._promises.set(A,P.then(r=>{this._promises.delete(A),!(D||!r)&&(_=this.register(A,r))})),R.toDisposable(()=>{D=!0,_&&_.dispose()})}getPromise(A){const P=this.get(A);if(P)return Promise.resolve(P);const _=this._promises.get(A);return _?_.then(D=>this.get(A)):null}get(A){return this._map.get(A)||null}setColorMap(A){this._colorMap=A,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=C}),define(pe[108],ve([0,1,22,11]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var C;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(C||(C={}));function S(k){for(let l=0,h=k.length;l<h;l+=4){const c=k[l+0],f=k[l+1],I=k[l+2],b=k[l+3];k[l+0]=b,k[l+1]=I,k[l+2]=f,k[l+3]=c}}function A(k){const l=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return R.isLittleEndian()||S(l),p.VSBuffer.wrap(l)}function P(k){const l=k.buffer;if(R.isLittleEndian()||S(l),l.byteOffset%4==0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const h=new Uint8Array(l.byteLength);return h.set(l),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function _(k){const l=new Uint32Array(D(k));let h=0;if(l[h++]=k.id,k.type==="full")l[h++]=1,l[h++]=k.data.length,l.set(k.data,h),h+=k.data.length;else{l[h++]=2,l[h++]=k.deltas.length;for(const c of k.deltas)l[h++]=c.start,l[h++]=c.deleteCount,c.data?(l[h++]=c.data.length,l.set(c.data,h),h+=c.data.length):l[h++]=0}return A(l)}e.encodeSemanticTokensDto=_;function D(k){let l=0;if(l+=1+1,k.type==="full")l+=1+k.data.length;else{l+=1,l+=(1+1+1)*k.deltas.length;for(const h of k.deltas)h.data&&(l+=h.data.length)}return l}function r(k){const l=P(k);let h=0;const c=l[h++];if(l[h++]===1){const w=l[h++],u=l.subarray(h,h+w);return h+=w,{id:c,type:"full",data:u}}const I=l[h++];let b=[];for(let w=0;w<I;w++){const u=l[h++],d=l[h++],g=l[h++];let t;g>0&&(t=l.subarray(h,h+g),h+=g),b[w]={start:u,deleteCount:d,data:t}}return{id:c,type:"delta",deltas:b}}e.decodeSemanticTokensDto=r}),define(pe[109],ve([0,1,93]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class R{constructor(A,P){this.index=A,this.remainder=P}}e.PrefixSumIndexOfResult=R;class C{constructor(A){this.values=A,this.prefixSum=new Uint32Array(A.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(A,P){A=p.toUint32(A);const _=this.values,D=this.prefixSum,r=P.length;return r===0?!1:(this.values=new Uint32Array(_.length+r),this.values.set(_.subarray(0,A),0),this.values.set(_.subarray(A),A+r),this.values.set(P,A),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(A,P){return A=p.toUint32(A),P=p.toUint32(P),this.values[A]===P?!1:(this.values[A]=P,A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),!0)}removeValues(A,P){A=p.toUint32(A),P=p.toUint32(P);const _=this.values,D=this.prefixSum;if(A>=_.length)return!1;let r=_.length-A;return P>=r&&(P=r),P===0?!1:(this.values=new Uint32Array(_.length-P),this.values.set(_.subarray(0,A),0),this.values.set(_.subarray(A+P),A),this.prefixSum=new Uint32Array(this.values.length),A-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=A-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(D.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(A){return A<0?0:(A=p.toUint32(A),this._getPrefixSum(A))}_getPrefixSum(A){if(A<=this.prefixSumValidIndex[0])return this.prefixSum[A];let P=this.prefixSumValidIndex[0]+1;P===0&&(this.prefixSum[0]=this.values[0],P++),A>=this.values.length&&(A=this.values.length-1);for(let _=P;_<=A;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],A),this.prefixSum[A]}getIndexOf(A){A=Math.floor(A),this.getTotalSum();let P=0,_=this.values.length-1,D=0,r=0,k=0;for(;P<=_;)if(D=P+(_-P)/2|0,r=this.prefixSum[D],k=r-this.values[D],A<k)_=D-1;else if(A>=r)P=D+1;else break;return new R(D,A-k)}}e.PrefixSumComputer=C}),define(pe[144],ve([0,1,8,44,109]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class S{constructor(P,_,D,r){this._uri=P,this._lines=_,this._eol=D,this._versionId=r,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(P){P.eol&&P.eol!==this._eol&&(this._eol=P.eol,this._lineStarts=null);const _=P.changes;for(const D of _)this._acceptDeleteRange(D.range),this._acceptInsertText(new R.Position(D.range.startLineNumber,D.range.startColumn),D.text);this._versionId=P.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const P=this._eol.length,_=this._lines.length,D=new Uint32Array(_);for(let r=0;r<_;r++)D[r]=this._lines[r].length+P;this._lineStarts=new C.PrefixSumComputer(D)}}_setLineText(P,_){this._lines[P]=_,this._lineStarts&&this._lineStarts.changeValue(P,this._lines[P].length+this._eol.length)}_acceptDeleteRange(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.startLineNumber-1].substring(P.endColumn-1));return}this._setLineText(P.startLineNumber-1,this._lines[P.startLineNumber-1].substring(0,P.startColumn-1)+this._lines[P.endLineNumber-1].substring(P.endColumn-1)),this._lines.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}_acceptInsertText(P,_){if(_.length===0)return;let D=p.splitLines(_);if(D.length===1){this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+D[0]+this._lines[P.lineNumber-1].substring(P.column-1));return}D[D.length-1]+=this._lines[P.lineNumber-1].substring(P.column-1),this._setLineText(P.lineNumber-1,this._lines[P.lineNumber-1].substring(0,P.column-1)+D[0]);let r=new Uint32Array(D.length-1);for(let k=1;k<D.length;k++)this._lines.splice(P.lineNumber+k-1,0,D[k]),r[k-1]=D[k].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(P.lineNumber,r)}}e.MirrorTextModel=S}),define(pe[145],ve([19,20]),function(X,e){return X.create("vs/base/common/date",e)}),define(pe[146],ve([0,1,145]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,C=R*60,S=C*24,A=S*7,P=S*30,_=S*365;function D(k,l){typeof k!="number"&&(k=k.getTime());const h=Math.round((new Date().getTime()-k)/1e3);if(h<-30)return p.localize(0,null,D(new Date().getTime()+h*1e3,!1));if(h<30)return p.localize(1,null);let c;return h<R?(c=h,l?c===1?p.localize(2,null,c):p.localize(3,null,c):c===1?p.localize(4,null,c):p.localize(5,null,c)):h<C?(c=Math.floor(h/R),l?c===1?p.localize(6,null,c):p.localize(7,null,c):c===1?p.localize(8,null,c):p.localize(9,null,c)):h<S?(c=Math.floor(h/C),l?c===1?p.localize(10,null,c):p.localize(11,null,c):c===1?p.localize(12,null,c):p.localize(13,null,c)):h<A?(c=Math.floor(h/S),l?c===1?p.localize(14,null,c):p.localize(15,null,c):c===1?p.localize(16,null,c):p.localize(17,null,c)):h<P?(c=Math.floor(h/A),l?c===1?p.localize(18,null,c):p.localize(19,null,c):c===1?p.localize(20,null,c):p.localize(21,null,c)):h<_?(c=Math.floor(h/P),l?c===1?p.localize(22,null,c):p.localize(23,null,c):c===1?p.localize(24,null,c):p.localize(25,null,c)):(c=Math.floor(h/_),l?c===1?p.localize(26,null,c):p.localize(27,null,c):c===1?p.localize(28,null,c):p.localize(29,null,c))}e.fromNow=D;function r(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(pe[147],ve([19,20]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(pe[57],ve([0,1,147,15,18]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function S(D,r){return r&&(D.stack||D.stacktrace)?p.localize(0,null,P(D),A(D.stack)||A(D.stacktrace)):P(D)}function A(D){return Array.isArray(D)?D.join(`
`):D}function P(D){return typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?p.localize(1,null,D.message):D.message||p.localize(2,null)}function _(D=null,r=!1){if(!D)return p.localize(3,null);if(Array.isArray(D)){const k=C.coalesce(D),l=_(k[0],r);return k.length>1?p.localize(4,null,l,k.length):l}if(R.isString(D))return D;if(D.detail){const k=D.detail;if(k.error)return S(k.error,r);if(k.exception)return S(k.exception,r)}return D.stack?S(D,r):D.message?D.message:p.localize(5,null)}e.toErrorMessage=_}),define(pe[148],ve([19,20]),function(X,e){return X.create("vs/base/node/processes",e)}),define(pe[110],ve([0,1,9,28,38,148,37,15,25,29,11,137,10]),function(X,e,p,R,C,S,A,P,_,D,r,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function h(d){switch(d){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function c(d,g){if(r.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};g&&(t.cwd=g);const i=C.execFile("taskkill",["/T","/F","/PID",d.pid.toString()],t);return new Promise(s=>{i.once("error",n=>{s({success:!1,error:n})}),i.once("exit",(n,o)=>{s(n===0?{success:!0}:{success:!1,code:n!==null?n:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?h(t.status):1})}else if(r.isLinux||r.isMacintosh)try{const t=l.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(i=>{C.execFile(t,[d.pid.toString()],{encoding:"utf8",shell:!0},(s,n,o)=>{i(s?{success:!1,error:s}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else d.kill("SIGKILL");return Promise.resolve({success:!0})}function f(d=A.env){return d.comspec||"cmd.exe"}e.getWindowsShell=f;class I{constructor(g,t,i,s){if(t!==void 0&&i!==void 0&&s!==void 0)this.cmd=g,this.args=t,this.shell=i,this.options=s;else{const n=g;this.cmd=n.command,this.shell=n.isShellCommand,this.args=n.args.slice(0),this.options=n.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const n=Object.create(null);Object.keys(A.env).forEach(o=>{n[o]=A.env[o]}),Object.keys(this.options.env).forEach(o=>{n[o]=this.options.env[o]}),this.options.env=n}}getSanitizedCommand(){let g=this.cmd.toLowerCase();const t=g.lastIndexOf(p.sep);return t!==-1&&(g=g.substring(t+1)),I.WellKnowCommands[g]?g:"other"}start(g){return r.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(A.cwd()))?Promise.reject(new Error(S.localize(0,null))):this.useExec().then(t=>{let i,s;const n=new Promise((o,v)=>{i=o,s=v});if(t){let o=this.cmd;this.args&&(o=o+" "+this.args.join(" ")),this.childProcess=C.exec(o,this.options,(v,m,E)=>{this.childProcess=null;const y=v;y&&y.killed?s({killed:this.terminateRequested,stdout:m.toString(),stderr:E.toString()}):this.handleExec(i,g,v,m,E)})}else{let o=null;const v=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,i,g,s);const E={terminated:this.terminateRequested};P.isNumber(m)&&(E.cmdCode=m),i(E)};if(this.shell&&r.isWindows){const m=_.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let E=!1,y=!1;const a=[];let T=this.ensureQuotes(this.cmd);a.push(T.value),E=T.quoted,this.args&&this.args.forEach($=>{T=this.ensureQuotes($),a.push(T.value),y=y&&T.quoted});const O=["/s","/c"];E?y?O.push('"'+a.join(" ")+'"'):a.length>1?O.push('"'+a[0]+'" '+a.slice(1).join(" ")):O.push('"'+a[0]+'"'):O.push(a.join(" ")),o=C.spawn(f(),O,m)}else this.cmd&&(o=C.spawn(this.cmd,this.args,this.options));o&&(this.childProcess=o,this.childProcessPromise=Promise.resolve(o),this.pidResolve&&(this.pidResolve(P.isNumber(o.pid)?o.pid:-1),this.pidResolve=void 0),o.on("error",m=>{this.childProcess=null,s({terminated:this.terminateRequested,error:m})}),o.pid&&(this.childProcess.on("close",v),this.handleSpawn(o,i,g,s,!0)))}return n})}handleClose(g,t,i,s){}ensureQuotes(g){return I.regexp.test(g)?{value:'"'+g+'"',quoted:!0}:{value:g,quoted:g.length>0&&g[0]==='"'&&g[g.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(g=>g.pid,g=>-1):new Promise(g=>{this.pidResolve=g})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(g=>(this.terminateRequested=!0,c(g,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),g=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(g=>{if(!this.shell||!r.isWindows)return g(!1);const t=C.spawn(f(),["/s","/c"]);t.on("error",i=>g(!0)),t.on("exit",i=>g(!1))})}}e.AbstractProcess=I,I.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},I.regexp=/^[^"].* .*[^"]/;class b extends I{constructor(g,t,i,s){super(g,t,i,s);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(g,t,i,s,n){[s,n].forEach((o,v)=>{const m=new k.LineDecoder;m.write(o).forEach(a=>{t({line:a,source:v===0?0:1})});const y=m.end();y&&t({line:y,source:v===0?0:1})}),g({terminated:this.terminateRequested,error:i})}handleSpawn(g,t,i,s,n){const o=new k.LineDecoder,v=new k.LineDecoder;g.stdout.on("data",m=>{o.write(m).forEach(y=>i({line:y,source:0}))}),g.stderr.on("data",m=>{v.write(m).forEach(y=>i({line:y,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=v}handleClose(g,t,i,s){const n=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;n&&i({line:n,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&i({line:o,source:1})}}e.LineProcess=b;function w(d){let g=[],t=!1;const i=function(s){if(t){g.push(s);return}(!d.send(s,o=>{if(o&&console.error(o),t=!1,g.length>0){const v=g.slice(0);g=[],v.forEach(m=>i(m))}})||r.isWindows)&&(t=!0)};return{send:i}}e.createQueuedSender=w;var u;(function(d){async function g(t,i,s){if(p.isAbsolute(t))return t;if(i===void 0&&(i=A.cwd()),p.dirname(t)!=="."||(s===void 0&&P.isString(A.env.PATH)&&(s=A.env.PATH.split(p.delimiter)),s===void 0||s.length===0))return p.join(i,t);async function o(v){return await R.Promises.exists(v)?!(await R.Promises.stat(v)).isDirectory():!1}for(let v of s){let m;if(p.isAbsolute(v)?m=p.join(v,t):m=p.join(i,v,t),await o(m))return m;let E=m+".com";if(await o(E)||(E=m+".exe",await o(E)))return E}return p.join(i,t)}d.findExecutable=g})(u=e.win32||(e.win32={}))}),define(pe[149],ve([19,20]),function(X,e){return X.create("vs/editor/common/config/editorOptions",e)}),define(pe[150],ve([0,1,149,11,107]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var S;(function(Q){Q[Q.None=0]="None",Q[Q.Keep=1]="Keep",Q[Q.Brackets=2]="Brackets",Q[Q.Advanced=3]="Advanced",Q[Q.Full=4]="Full"})(S=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class A{constructor(se){this._values=se}hasChanged(se){return this._values[se]}}e.ConfigurationChangedEvent=A;class P{constructor(){this._values=[]}_read(se){return this._values[se]}get(se){return this._values[se]}_write(se,we){this._values[se]=we}}e.ValidatedEditorOptions=P;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class D{constructor(se,we,Oe,Ue){this.id=se,this.name=we,this.defaultValue=Oe,this.schema=Ue}compute(se,we,Oe){return Oe}}class r{constructor(se,we=null){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0,this.deps=we}validate(se){return this.defaultValue}}class k{constructor(se,we,Oe,Ue){this.id=se,this.name=we,this.defaultValue=Oe,this.schema=Ue}validate(se){return typeof se=="undefined"?this.defaultValue:se}compute(se,we,Oe){return Oe}}function l(Q,se){return typeof Q=="undefined"?se:Q==="false"?!1:Boolean(Q)}e.boolean=l;class h extends k{constructor(se,we,Oe,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="boolean",Ue.default=Oe),super(se,we,Oe,Ue)}validate(se){return l(se,this.defaultValue)}}class c extends k{constructor(se,we,Oe,Ue,Ye,De=void 0){typeof De!="undefined"&&(De.type="integer",De.default=Oe,De.minimum=Ue,De.maximum=Ye),super(se,we,Oe,De),this.minimum=Ue,this.maximum=Ye}static clampedInt(se,we,Oe,Ue){if(typeof se=="undefined")return we;let Ye=parseInt(se,10);return isNaN(Ye)?we:(Ye=Math.max(Oe,Ye),Ye=Math.min(Ue,Ye),Ye|0)}validate(se){return c.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}class f extends k{constructor(se,we,Oe,Ue,Ye){typeof Ye!="undefined"&&(Ye.type="number",Ye.default=Oe),super(se,we,Oe,Ye),this.validationFn=Ue}static clamp(se,we,Oe){return se<we?we:se>Oe?Oe:se}static float(se,we){if(typeof se=="number")return se;if(typeof se=="undefined")return we;const Oe=parseFloat(se);return isNaN(Oe)?we:Oe}validate(se){return this.validationFn(f.float(se,this.defaultValue))}}class I extends k{static string(se,we){return typeof se!="string"?we:se}constructor(se,we,Oe,Ue=void 0){typeof Ue!="undefined"&&(Ue.type="string",Ue.default=Oe),super(se,we,Oe,Ue)}validate(se){return I.string(se,this.defaultValue)}}function b(Q,se,we){return typeof Q!="string"||we.indexOf(Q)===-1?se:Q}e.stringSet=b;class w extends k{constructor(se,we,Oe,Ue,Ye=void 0){typeof Ye!="undefined"&&(Ye.type="string",Ye.enum=Ue,Ye.default=Oe),super(se,we,Oe,Ye),this._allowedValues=Ue}validate(se){return b(se,this.defaultValue,this._allowedValues)}}class u extends D{constructor(se,we,Oe,Ue,Ye,De,_e=void 0){typeof _e!="undefined"&&(_e.type="string",_e.enum=Ye,_e.default=Ue),super(se,we,Oe,_e),this._allowedValues=Ye,this._convert=De}validate(se){return typeof se!="string"?this.defaultValue:this._allowedValues.indexOf(se)===-1?this.defaultValue:this._convert(se)}}function d(Q){switch(Q){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class g extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",description:p.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,we,Oe){return Oe===0?se.accessibilitySupport:Oe}}class t extends D{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:p.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const we=se;return{insertSpace:l(we.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:l(we.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var i;(function(Q){Q[Q.Hidden=0]="Hidden",Q[Q.Blink=1]="Blink",Q[Q.Smooth=2]="Smooth",Q[Q.Phase=3]="Phase",Q[Q.Expand=4]="Expand",Q[Q.Solid=5]="Solid"})(i=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(Q){switch(Q){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var n;(function(Q){Q[Q.Line=1]="Line",Q[Q.Block=2]="Block",Q[Q.Underline=3]="Underline",Q[Q.LineThin=4]="LineThin",Q[Q.BlockOutline=5]="BlockOutline",Q[Q.UnderlineThin=6]="UnderlineThin"})(n=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function o(Q){switch(Q){case n.Line:return"line";case n.Block:return"block";case n.Underline:return"underline";case n.LineThin:return"line-thin";case n.BlockOutline:return"block-outline";case n.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=o;function v(Q){switch(Q){case"line":return n.Line;case"block":return n.Block;case"underline":return n.Underline;case"line-thin":return n.LineThin;case"block-outline":return n.BlockOutline;case"underline-thin":return n.UnderlineThin}}class m extends r{constructor(){super(125,[63,31])}compute(se,we,Oe){const Ue=["monaco-editor"];return we.get(31)&&Ue.push(we.get(31)),se.extraEditorClassName&&Ue.push(se.extraEditorClassName),we.get(63)==="default"?Ue.push("mouse-default"):we.get(63)==="copy"&&Ue.push("mouse-copy"),we.get(98)&&Ue.push("showUnused"),we.get(123)&&Ue.push("showDeprecated"),Ue.join(" ")}}class E extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(se,we,Oe){return Oe&&se.emptySelectionClipboard}}class y extends D{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:se.seedSearchStringFromSelection,description:p.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[p.localize(9,null),p.localize(10,null),p.localize(11,null)],description:p.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:p.localize(13,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:p.localize(14,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:p.localize(15,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const we=se;return{cursorMoveOnType:l(we.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:l(we.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":b(we.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:l(we.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:l(we.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:l(we.loop,this.defaultValue.loop)}}}class a extends D{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:p.localize(16,null)},{type:"string",description:p.localize(17,null)}],description:p.localize(18,null),default:!1})}validate(se){return typeof se=="undefined"?this.defaultValue:typeof se=="string"?se==="false"?a.OFF:se==="true"?a.ON:se:Boolean(se)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class T extends r{constructor(){super(40)}compute(se,we,Oe){return se.fontInfo}}class O extends k{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(19,null)})}validate(se){let we=f.float(se,this.defaultValue);return we===0?e.EDITOR_FONT_DEFAULTS.fontSize:f.clamp(we,6,100)}compute(se,we,Oe){return se.fontInfo.fontSize}}class $ extends D{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.MINIMUM_VALUE,maximum:$.MAXIMUM_VALUE,errorMessage:p.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(21,null)})}validate(se){return se==="normal"||se==="bold"?se:String(c.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,$.MINIMUM_VALUE,$.MAXIMUM_VALUE))}}$.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],$.MINIMUM_VALUE=1,$.MAXIMUM_VALUE=1e3;class Z extends D{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},we={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[p.localize(22,null),p.localize(23,null),p.localize(24,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:p.localize(26,null)},we),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:p.localize(27,null)},we),"editor.gotoLocation.multipleDeclarations":Object.assign({description:p.localize(28,null)},we),"editor.gotoLocation.multipleImplementations":Object.assign({description:p.localize(29,null)},we),"editor.gotoLocation.multipleReferences":Object.assign({description:p.localize(30,null)},we),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:Oe,description:p.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:Oe,description:p.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:Oe,description:p.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:Oe,description:p.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:Oe,description:p.localize(35,null)}})}validate(se){var we,Oe,Ue,Ye,De;if(!se||typeof se!="object")return this.defaultValue;const _e=se;return{multiple:b(_e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(we=_e.multipleDefinitions)!==null&&we!==void 0?we:b(_e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Oe=_e.multipleTypeDefinitions)!==null&&Oe!==void 0?Oe:b(_e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ue=_e.multipleDeclarations)!==null&&Ue!==void 0?Ue:b(_e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Ye=_e.multipleImplementations)!==null&&Ye!==void 0?Ye:b(_e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(De=_e.multipleReferences)!==null&&De!==void 0?De:b(_e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:I.string(_e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:I.string(_e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:I.string(_e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:I.string(_e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:I.string(_e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class le extends D{constructor(){const se={enabled:!0,delay:300,sticky:!0};super(50,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:p.localize(36,null)},"editor.hover.delay":{type:"number",default:se.delay,description:p.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:p.localize(38,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const we=se;return{enabled:l(we.enabled,this.defaultValue.enabled),delay:c.clampedInt(we.delay,this.defaultValue.delay,0,1e4),sticky:l(we.sticky,this.defaultValue.sticky)}}}var q;(function(Q){Q[Q.None=0]="None",Q[Q.Text=1]="Text",Q[Q.Blocks=2]="Blocks"})(q=e.RenderMinimap||(e.RenderMinimap={}));class x extends r{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(se,we,Oe){return x.computeLayout(we,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio})}static computeContainedMinimapLineCount(se){const we=se.height/se.lineHeight,Oe=se.scrollBeyondLastLine?we-1:0,Ue=(se.viewLineCount+Oe)/(se.pixelRatio*se.height),Ye=Math.floor(se.viewLineCount/Ue);return{typicalViewportLineCount:we,extraLinesBeyondLastLine:Oe,desiredRatio:Ue,minimapLineCount:Ye}}static _computeMinimapLayout(se,we){const Oe=se.outerWidth,Ue=se.outerHeight,Ye=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ye*Ue),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ue};const De=we.stableMinimapLayoutInput,_e=De&&se.outerHeight===De.outerHeight&&se.lineHeight===De.lineHeight&&se.typicalHalfwidthCharacterWidth===De.typicalHalfwidthCharacterWidth&&se.pixelRatio===De.pixelRatio&&se.scrollBeyondLastLine===De.scrollBeyondLastLine&&se.minimap.enabled===De.minimap.enabled&&se.minimap.side===De.minimap.side&&se.minimap.size===De.minimap.size&&se.minimap.showSlider===De.minimap.showSlider&&se.minimap.renderCharacters===De.minimap.renderCharacters&&se.minimap.maxColumn===De.minimap.maxColumn&&se.minimap.scale===De.minimap.scale&&se.verticalScrollbarWidth===De.verticalScrollbarWidth&&se.isViewportWrapping===De.isViewportWrapping,Pe=se.lineHeight,ae=se.typicalHalfwidthCharacterWidth,fe=se.scrollBeyondLastLine,W=se.minimap.renderCharacters;let ee=Ye>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const de=se.minimap.maxColumn,Ie=se.minimap.size,Te=se.minimap.side,xe=se.verticalScrollbarWidth,Ve=se.viewLineCount,Ze=se.remainingWidth,rt=se.isViewportWrapping,Xe=W?2:3;let Je=Math.floor(Ye*Ue);const ft=Je/Ye;let Ee=!1,Ce=!1,ue=Xe*ee,K=ee/Ye,Be=1;if(Ie==="fill"||Ie==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:pt,desiredRatio:bt,minimapLineCount:Tt}=x.computeContainedMinimapLineCount({viewLineCount:Ve,scrollBeyondLastLine:fe,height:Ue,lineHeight:Pe,pixelRatio:Ye});if(Ve/Tt>1)Ee=!0,Ce=!0,ee=1,ue=1,K=ee/Ye;else{let _t=!1,ct=ee+1;if(Ie==="fit"){const mt=Math.ceil((Ve+pt)*ue);rt&&_e&&Ze<=we.stableFitRemainingWidth?(_t=!0,ct=we.stableFitMaxMinimapScale):_t=mt>Je}if(Ie==="fill"||_t){Ee=!0;const mt=ee;ue=Math.min(Pe*Ye,Math.max(1,Math.floor(1/bt))),rt&&_e&&Ze<=we.stableFitRemainingWidth&&(ct=we.stableFitMaxMinimapScale),ee=Math.min(ct,Math.max(1,Math.floor(ue/Xe))),ee>mt&&(Be=Math.min(2,ee/mt)),K=ee/Ye/Be,Je=Math.ceil(Math.max(gt,Ve+pt)*ue),rt?(we.stableMinimapLayoutInput=se,we.stableFitRemainingWidth=Ze,we.stableFitMaxMinimapScale=ee):(we.stableMinimapLayoutInput=null,we.stableFitRemainingWidth=0)}}}const Fe=Math.floor(de*K),Me=Math.min(Fe,Math.max(0,Math.floor((Ze-xe-2)*K/(ae+K)))+e.MINIMAP_GUTTER_WIDTH);let nt=Math.floor(Ye*Me);const ot=nt/Ye;nt=Math.floor(nt*Be);const tt=W?1:2,vt=Te==="left"?0:Oe-Me-xe;return{renderMinimap:tt,minimapLeft:vt,minimapWidth:Me,minimapHeightIsEditorHeight:Ee,minimapIsSampling:Ce,minimapScale:ee,minimapLineHeight:ue,minimapCanvasInnerWidth:nt,minimapCanvasInnerHeight:Je,minimapCanvasOuterWidth:ot,minimapCanvasOuterHeight:ft}}static computeLayout(se,we){const Oe=we.outerWidth|0,Ue=we.outerHeight|0,Ye=we.lineHeight|0,De=we.lineNumbersDigitCount|0,_e=we.typicalHalfwidthCharacterWidth,Pe=we.maxDigitWidth,ae=we.pixelRatio,fe=we.viewLineCount,W=se.get(120),ee=W==="inherit"?se.get(119):W,de=ee==="inherit"?se.get(115):ee,Ie=se.get(118),Te=se.get(2),xe=we.isDominatedByLongLines,Ve=se.get(46),Ze=se.get(57).renderType!==0,rt=se.get(58),Xe=se.get(92),Je=se.get(62),ft=se.get(90),Ee=ft.verticalScrollbarSize,Ce=ft.verticalHasArrows,ue=ft.arrowSize,K=ft.horizontalScrollbarSize,Be=se.get(55),Fe=se.get(35);let Me;if(typeof Be=="string"&&/^\d+(\.\d+)?ch$/.test(Be)){const St=parseFloat(Be.substr(0,Be.length-2));Me=c.clampedInt(St*_e,0,0,1e3)}else Me=c.clampedInt(Be,0,0,1e3);Fe&&(Me+=16);let nt=0;if(Ze){const St=Math.max(De,rt);nt=Math.round(St*Pe)}let ot=0;Ve&&(ot=Ye);let tt=0,vt=tt+ot,gt=vt+nt,pt=gt+Me;const bt=Oe-ot-nt-Me;let Tt=!1,It=!1,_t=-1;Te!==2&&(ee==="inherit"&&xe?(Tt=!0,It=!0):de==="on"||de==="bounded"?It=!0:de==="wordWrapColumn"&&(_t=Ie));const ct=x._computeMinimapLayout({outerWidth:Oe,outerHeight:Ue,lineHeight:Ye,typicalHalfwidthCharacterWidth:_e,pixelRatio:ae,scrollBeyondLastLine:Xe,minimap:Je,verticalScrollbarWidth:Ee,viewLineCount:fe,remainingWidth:bt,isViewportWrapping:It},we.memory||new _);ct.renderMinimap!==0&&ct.minimapLeft===0&&(tt+=ct.minimapWidth,vt+=ct.minimapWidth,gt+=ct.minimapWidth,pt+=ct.minimapWidth);const mt=bt-ct.minimapWidth,Et=Math.max(1,Math.floor((mt-Ee-2)/_e)),Lt=Ce?ue:0;return It&&(_t=Math.max(1,Et),de==="bounded"&&(_t=Math.min(_t,Ie))),{width:Oe,height:Ue,glyphMarginLeft:tt,glyphMarginWidth:ot,lineNumbersLeft:vt,lineNumbersWidth:nt,decorationsLeft:gt,decorationsWidth:Me,contentLeft:pt,contentWidth:mt,minimap:ct,viewportColumn:Et,isWordWrapMinified:Tt,isViewportWrapping:It,wrappingColumn:_t,verticalScrollbarWidth:Ee,horizontalScrollbarHeight:K,overviewRuler:{top:Lt,width:Ee,height:Ue-2*Lt,right:0}}}}e.EditorLayoutInfoComputer=x;class H extends D{constructor(){const se={enabled:!0};super(54,"lightbulb",se,{"editor.lightbulb.enabled":{type:"boolean",default:se.enabled,description:p.localize(39,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:l(se.enabled,this.defaultValue.enabled)}}}class N extends D{constructor(){const se={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",se,{"editor.inlayHints.enabled":{type:"boolean",default:se.enabled,description:p.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:p.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,description:p.localize(42,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const we=se;return{enabled:l(we.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(we.fontSize,this.defaultValue.fontSize,0,100),fontFamily:I.string(we.fontFamily,this.defaultValue.fontFamily)}}}class z extends f{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>f.clamp(se,0,150),{markdownDescription:p.localize(43,null)})}compute(se,we,Oe){return se.fontInfo.lineHeight}}class F extends D{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:p.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(45,null),p.localize(46,null),p.localize(47,null)],default:se.size,description:p.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:p.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:p.localize(50,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:p.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:p.localize(53,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const we=se;return{enabled:l(we.enabled,this.defaultValue.enabled),size:b(we.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(we.side,this.defaultValue.side,["right","left"]),showSlider:b(we.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:l(we.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(we.scale,1,1,3),maxColumn:c.clampedInt(we.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function M(Q){return Q==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class L extends D{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(55,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const we=se;return{top:c.clampedInt(we.top,0,0,1e3),bottom:c.clampedInt(we.bottom,0,0,1e3)}}}class U extends D{constructor(){const se={enabled:!0,cycle:!1};super(73,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:p.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:p.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const we=se;return{enabled:l(we.enabled,this.defaultValue.enabled),cycle:l(we.cycle,this.defaultValue.cycle)}}}class G extends r{constructor(){super(126)}compute(se,we,Oe){return se.pixelRatio}}class te extends D{constructor(){const se={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",se,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:se.strings,description:p.localize(58,null)},comments:{type:"boolean",default:se.comments,description:p.localize(59,null)},other:{type:"boolean",default:se.other,description:p.localize(60,null)}}}],default:se,description:p.localize(61,null)});this.defaultValue=se}validate(se){if(typeof se=="boolean")return se;if(se&&typeof se=="object"){const we=se,Oe={other:l(we.other,this.defaultValue.other),comments:l(we.comments,this.defaultValue.comments),strings:l(we.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var me;(function(Q){Q[Q.Off=0]="Off",Q[Q.On=1]="On",Q[Q.Relative=2]="Relative",Q[Q.Interval=3]="Interval",Q[Q.Custom=4]="Custom"})(me=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Se extends D{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(62,null),p.localize(63,null),p.localize(64,null),p.localize(65,null)],default:"on",description:p.localize(66,null)})}validate(se){let we=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof se!="undefined"&&(typeof se=="function"?(we=4,Oe=se):se==="interval"?we=3:se==="relative"?we=2:se==="on"?we=1:we=0),{renderType:we,renderFn:Oe}}}function ye(Q){const se=Q.get(85);return se==="editable"?Q.get(78):se!=="on"}e.filterValidationDecorations=ye;class Le extends D{constructor(){const se=[],we={type:"number",description:p.localize(67,null)};super(89,"rulers",se,{type:"array",items:{anyOf:[we,{type:["object"],properties:{column:we,color:{type:"string",description:p.localize(68,null),format:"color-hex"}}}]},default:se,description:p.localize(69,null)})}validate(se){if(Array.isArray(se)){let we=[];for(let Oe of se)if(typeof Oe=="number")we.push({column:c.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const Ue=Oe;we.push({column:c.clampedInt(Ue.column,0,0,1e4),color:Ue.color})}return we.sort((Oe,Ue)=>Oe.column-Ue.column),we}return this.defaultValue}}function je(Q,se){if(typeof Q!="string")return se;switch(Q){case"hidden":return 2;case"visible":return 3;default:return 1}}class ze extends D{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const we=se,Oe=c.clampedInt(we.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ue=c.clampedInt(we.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(we.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:je(we.vertical,this.defaultValue.vertical),horizontal:je(we.horizontal,this.defaultValue.horizontal),useShadows:l(we.useShadows,this.defaultValue.useShadows),verticalHasArrows:l(we.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:l(we.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:l(we.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:l(we.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:c.clampedInt(we.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:Ue,verticalSliderSize:c.clampedInt(we.verticalSliderSize,Ue,0,1e3),scrollByPage:l(we.scrollByPage,this.defaultValue.scrollByPage)}}}class Ge extends D{constructor(){const se={enabled:!1};super(52,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:p.localize(70,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:l(se.enabled,this.defaultValue.enabled)}}}class j extends D{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(71,null),p.localize(72,null)],default:se.insertMode,description:p.localize(73,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:p.localize(74,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:p.localize(75,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:p.localize(76,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:p.localize(77,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:p.localize(78,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:p.localize(79,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:p.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:p.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(112,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const we=se;return{insertMode:b(we.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:l(we.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:l(we.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:l(we.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:l(we.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:l(we.showIcons,this.defaultValue.showIcons),showStatusBar:l(we.showStatusBar,this.defaultValue.showStatusBar),preview:l(we.preview,this.defaultValue.preview),showInlineDetails:l(we.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:l(we.showMethods,this.defaultValue.showMethods),showFunctions:l(we.showFunctions,this.defaultValue.showFunctions),showConstructors:l(we.showConstructors,this.defaultValue.showConstructors),showDeprecated:l(we.showDeprecated,this.defaultValue.showDeprecated),showFields:l(we.showFields,this.defaultValue.showFields),showVariables:l(we.showVariables,this.defaultValue.showVariables),showClasses:l(we.showClasses,this.defaultValue.showClasses),showStructs:l(we.showStructs,this.defaultValue.showStructs),showInterfaces:l(we.showInterfaces,this.defaultValue.showInterfaces),showModules:l(we.showModules,this.defaultValue.showModules),showProperties:l(we.showProperties,this.defaultValue.showProperties),showEvents:l(we.showEvents,this.defaultValue.showEvents),showOperators:l(we.showOperators,this.defaultValue.showOperators),showUnits:l(we.showUnits,this.defaultValue.showUnits),showValues:l(we.showValues,this.defaultValue.showValues),showConstants:l(we.showConstants,this.defaultValue.showConstants),showEnums:l(we.showEnums,this.defaultValue.showEnums),showEnumMembers:l(we.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:l(we.showKeywords,this.defaultValue.showKeywords),showWords:l(we.showWords,this.defaultValue.showWords),showColors:l(we.showColors,this.defaultValue.showColors),showFiles:l(we.showFiles,this.defaultValue.showFiles),showReferences:l(we.showReferences,this.defaultValue.showReferences),showFolders:l(we.showFolders,this.defaultValue.showFolders),showTypeParameters:l(we.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:l(we.showSnippets,this.defaultValue.showSnippets),showUsers:l(we.showUsers,this.defaultValue.showUsers),showIssues:l(we.showIssues,this.defaultValue.showIssues)}}}class Y extends D{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(113,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:l(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ie extends r{constructor(){super(127,[78])}compute(se,we,Oe){return we.get(78)?!0:se.tabFocusMode}}var re;(function(Q){Q[Q.None=0]="None",Q[Q.Same=1]="Same",Q[Q.Indent=2]="Indent",Q[Q.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function J(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ce extends r{constructor(){super(129,[128])}compute(se,we,Oe){const Ue=we.get(128);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ue.isWordWrapMinified,isViewportWrapping:Ue.isViewportWrapping,wrappingColumn:Ue.wrappingColumn}}}const ge="Consolas, 'Courier New', monospace",Re="Menlo, Monaco, 'Courier New', monospace",He="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?Re:R.isLinux?He:ge,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function be(Q){return e.editorOptionsRegistry[Q.id]=Q,Q}var Qe;(function(Q){Q[Q.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Q[Q.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Q[Q.accessibilitySupport=2]="accessibilitySupport",Q[Q.accessibilityPageSize=3]="accessibilityPageSize",Q[Q.ariaLabel=4]="ariaLabel",Q[Q.autoClosingBrackets=5]="autoClosingBrackets",Q[Q.autoClosingDelete=6]="autoClosingDelete",Q[Q.autoClosingOvertype=7]="autoClosingOvertype",Q[Q.autoClosingQuotes=8]="autoClosingQuotes",Q[Q.autoIndent=9]="autoIndent",Q[Q.automaticLayout=10]="automaticLayout",Q[Q.autoSurround=11]="autoSurround",Q[Q.codeLens=12]="codeLens",Q[Q.codeLensFontFamily=13]="codeLensFontFamily",Q[Q.codeLensFontSize=14]="codeLensFontSize",Q[Q.colorDecorators=15]="colorDecorators",Q[Q.columnSelection=16]="columnSelection",Q[Q.comments=17]="comments",Q[Q.contextmenu=18]="contextmenu",Q[Q.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",Q[Q.cursorBlinking=20]="cursorBlinking",Q[Q.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",Q[Q.cursorStyle=22]="cursorStyle",Q[Q.cursorSurroundingLines=23]="cursorSurroundingLines",Q[Q.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",Q[Q.cursorWidth=25]="cursorWidth",Q[Q.disableLayerHinting=26]="disableLayerHinting",Q[Q.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",Q[Q.domReadOnly=28]="domReadOnly",Q[Q.dragAndDrop=29]="dragAndDrop",Q[Q.emptySelectionClipboard=30]="emptySelectionClipboard",Q[Q.extraEditorClassName=31]="extraEditorClassName",Q[Q.fastScrollSensitivity=32]="fastScrollSensitivity",Q[Q.find=33]="find",Q[Q.fixedOverflowWidgets=34]="fixedOverflowWidgets",Q[Q.folding=35]="folding",Q[Q.foldingStrategy=36]="foldingStrategy",Q[Q.foldingHighlight=37]="foldingHighlight",Q[Q.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",Q[Q.fontFamily=39]="fontFamily",Q[Q.fontInfo=40]="fontInfo",Q[Q.fontLigatures=41]="fontLigatures",Q[Q.fontSize=42]="fontSize",Q[Q.fontWeight=43]="fontWeight",Q[Q.formatOnPaste=44]="formatOnPaste",Q[Q.formatOnType=45]="formatOnType",Q[Q.glyphMargin=46]="glyphMargin",Q[Q.gotoLocation=47]="gotoLocation",Q[Q.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",Q[Q.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",Q[Q.hover=50]="hover",Q[Q.inDiffEditor=51]="inDiffEditor",Q[Q.inlineSuggest=52]="inlineSuggest",Q[Q.letterSpacing=53]="letterSpacing",Q[Q.lightbulb=54]="lightbulb",Q[Q.lineDecorationsWidth=55]="lineDecorationsWidth",Q[Q.lineHeight=56]="lineHeight",Q[Q.lineNumbers=57]="lineNumbers",Q[Q.lineNumbersMinChars=58]="lineNumbersMinChars",Q[Q.linkedEditing=59]="linkedEditing",Q[Q.links=60]="links",Q[Q.matchBrackets=61]="matchBrackets",Q[Q.minimap=62]="minimap",Q[Q.mouseStyle=63]="mouseStyle",Q[Q.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",Q[Q.mouseWheelZoom=65]="mouseWheelZoom",Q[Q.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",Q[Q.multiCursorModifier=67]="multiCursorModifier",Q[Q.multiCursorPaste=68]="multiCursorPaste",Q[Q.occurrencesHighlight=69]="occurrencesHighlight",Q[Q.overviewRulerBorder=70]="overviewRulerBorder",Q[Q.overviewRulerLanes=71]="overviewRulerLanes",Q[Q.padding=72]="padding",Q[Q.parameterHints=73]="parameterHints",Q[Q.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",Q[Q.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",Q[Q.quickSuggestions=76]="quickSuggestions",Q[Q.quickSuggestionsDelay=77]="quickSuggestionsDelay",Q[Q.readOnly=78]="readOnly",Q[Q.renameOnType=79]="renameOnType",Q[Q.renderControlCharacters=80]="renderControlCharacters",Q[Q.renderIndentGuides=81]="renderIndentGuides",Q[Q.renderFinalNewline=82]="renderFinalNewline",Q[Q.renderLineHighlight=83]="renderLineHighlight",Q[Q.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",Q[Q.renderValidationDecorations=85]="renderValidationDecorations",Q[Q.renderWhitespace=86]="renderWhitespace",Q[Q.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",Q[Q.roundedSelection=88]="roundedSelection",Q[Q.rulers=89]="rulers",Q[Q.scrollbar=90]="scrollbar",Q[Q.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",Q[Q.scrollBeyondLastLine=92]="scrollBeyondLastLine",Q[Q.scrollPredominantAxis=93]="scrollPredominantAxis",Q[Q.selectionClipboard=94]="selectionClipboard",Q[Q.selectionHighlight=95]="selectionHighlight",Q[Q.selectOnLineNumbers=96]="selectOnLineNumbers",Q[Q.showFoldingControls=97]="showFoldingControls",Q[Q.showUnused=98]="showUnused",Q[Q.snippetSuggestions=99]="snippetSuggestions",Q[Q.smartSelect=100]="smartSelect",Q[Q.smoothScrolling=101]="smoothScrolling",Q[Q.stickyTabStops=102]="stickyTabStops",Q[Q.stopRenderingLineAfter=103]="stopRenderingLineAfter",Q[Q.suggest=104]="suggest",Q[Q.suggestFontSize=105]="suggestFontSize",Q[Q.suggestLineHeight=106]="suggestLineHeight",Q[Q.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",Q[Q.suggestSelection=108]="suggestSelection",Q[Q.tabCompletion=109]="tabCompletion",Q[Q.tabIndex=110]="tabIndex",Q[Q.unusualLineTerminators=111]="unusualLineTerminators",Q[Q.useShadowDOM=112]="useShadowDOM",Q[Q.useTabStops=113]="useTabStops",Q[Q.wordSeparators=114]="wordSeparators",Q[Q.wordWrap=115]="wordWrap",Q[Q.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",Q[Q.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",Q[Q.wordWrapColumn=118]="wordWrapColumn",Q[Q.wordWrapOverride1=119]="wordWrapOverride1",Q[Q.wordWrapOverride2=120]="wordWrapOverride2",Q[Q.wrappingIndent=121]="wrappingIndent",Q[Q.wrappingStrategy=122]="wrappingStrategy",Q[Q.showDeprecated=123]="showDeprecated",Q[Q.inlayHints=124]="inlayHints",Q[Q.editorClassName=125]="editorClassName",Q[Q.pixelRatio=126]="pixelRatio",Q[Q.tabFocusMode=127]="tabFocusMode",Q[Q.layoutInfo=128]="layoutInfo",Q[Q.wrappingInfo=129]="wrappingInfo"})(Qe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:be(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(114,null)})),acceptSuggestionOnEnter:be(new w(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(115,null),""],markdownDescription:p.localize(116,null)})),accessibilitySupport:be(new g),accessibilityPageSize:be(new c(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(117,null)})),ariaLabel:be(new I(4,"ariaLabel",p.localize(118,null))),autoClosingBrackets:be(new w(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(119,null),p.localize(120,null),""],description:p.localize(121,null)})),autoClosingDelete:be(new w(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(122,null),""],description:p.localize(123,null)})),autoClosingOvertype:be(new w(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(124,null),""],description:p.localize(125,null)})),autoClosingQuotes:be(new w(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(126,null),p.localize(127,null),""],description:p.localize(128,null)})),autoIndent:be(new u(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[p.localize(129,null),p.localize(130,null),p.localize(131,null),p.localize(132,null),p.localize(133,null)],description:p.localize(134,null)})),automaticLayout:be(new h(10,"automaticLayout",!1)),autoSurround:be(new w(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null),""],description:p.localize(138,null)})),stickyTabStops:be(new h(102,"stickyTabStops",!1,{description:p.localize(139,null)})),codeLens:be(new h(12,"codeLens",!0,{description:p.localize(140,null)})),codeLensFontFamily:be(new I(13,"codeLensFontFamily","",{description:p.localize(141,null)})),codeLensFontSize:be(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(142,null)})),colorDecorators:be(new h(15,"colorDecorators",!0,{description:p.localize(143,null)})),columnSelection:be(new h(16,"columnSelection",!1,{description:p.localize(144,null)})),comments:be(new t),contextmenu:be(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:be(new h(19,"copyWithSyntaxHighlighting",!0,{description:p.localize(145,null)})),cursorBlinking:be(new u(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:p.localize(146,null)})),cursorSmoothCaretAnimation:be(new h(21,"cursorSmoothCaretAnimation",!1,{description:p.localize(147,null)})),cursorStyle:be(new u(22,"cursorStyle",n.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],v,{description:p.localize(148,null)})),cursorSurroundingLines:be(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(149,null)})),cursorSurroundingLinesStyle:be(new w(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(150,null),p.localize(151,null)],description:p.localize(152,null)})),cursorWidth:be(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(153,null)})),disableLayerHinting:be(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:be(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:be(new h(28,"domReadOnly",!1)),dragAndDrop:be(new h(29,"dragAndDrop",!0,{description:p.localize(154,null)})),emptySelectionClipboard:be(new E),extraEditorClassName:be(new I(31,"extraEditorClassName","")),fastScrollSensitivity:be(new f(32,"fastScrollSensitivity",5,Q=>Q<=0?5:Q,{markdownDescription:p.localize(155,null)})),find:be(new y),fixedOverflowWidgets:be(new h(34,"fixedOverflowWidgets",!1)),folding:be(new h(35,"folding",!0,{description:p.localize(156,null)})),foldingStrategy:be(new w(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(157,null),p.localize(158,null)],description:p.localize(159,null)})),foldingHighlight:be(new h(37,"foldingHighlight",!0,{description:p.localize(160,null)})),unfoldOnClickAfterEndOfLine:be(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(161,null)})),fontFamily:be(new I(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(162,null)})),fontInfo:be(new T),fontLigatures2:be(new a),fontSize:be(new O),fontWeight:be(new $),formatOnPaste:be(new h(44,"formatOnPaste",!1,{description:p.localize(163,null)})),formatOnType:be(new h(45,"formatOnType",!1,{description:p.localize(164,null)})),glyphMargin:be(new h(46,"glyphMargin",!0,{description:p.localize(165,null)})),gotoLocation:be(new Z),hideCursorInOverviewRuler:be(new h(48,"hideCursorInOverviewRuler",!1,{description:p.localize(166,null)})),highlightActiveIndentGuide:be(new h(49,"highlightActiveIndentGuide",!0,{description:p.localize(167,null)})),hover:be(new le),inDiffEditor:be(new h(51,"inDiffEditor",!1)),letterSpacing:be(new f(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Q=>f.clamp(Q,-5,20),{description:p.localize(168,null)})),lightbulb:be(new H),lineDecorationsWidth:be(new k(55,"lineDecorationsWidth",10)),lineHeight:be(new z),lineNumbers:be(new Se),lineNumbersMinChars:be(new c(58,"lineNumbersMinChars",5,1,300)),linkedEditing:be(new h(59,"linkedEditing",!1,{description:p.localize(169,null)})),links:be(new h(60,"links",!0,{description:p.localize(170,null)})),matchBrackets:be(new w(61,"matchBrackets","always",["always","near","never"],{description:p.localize(171,null)})),minimap:be(new F),mouseStyle:be(new w(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:be(new f(64,"mouseWheelScrollSensitivity",1,Q=>Q===0?1:Q,{markdownDescription:p.localize(172,null)})),mouseWheelZoom:be(new h(65,"mouseWheelZoom",!1,{markdownDescription:p.localize(173,null)})),multiCursorMergeOverlapping:be(new h(66,"multiCursorMergeOverlapping",!0,{description:p.localize(174,null)})),multiCursorModifier:be(new u(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],M,{markdownEnumDescriptions:[p.localize(175,null),p.localize(176,null)],markdownDescription:p.localize(177,null)})),multiCursorPaste:be(new w(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(178,null),p.localize(179,null)],markdownDescription:p.localize(180,null)})),occurrencesHighlight:be(new h(69,"occurrencesHighlight",!0,{description:p.localize(181,null)})),overviewRulerBorder:be(new h(70,"overviewRulerBorder",!0,{description:p.localize(182,null)})),overviewRulerLanes:be(new c(71,"overviewRulerLanes",3,0,3)),padding:be(new L),parameterHints:be(new U),peekWidgetDefaultFocus:be(new w(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(183,null),p.localize(184,null)],description:p.localize(185,null)})),definitionLinkOpensInPeek:be(new h(75,"definitionLinkOpensInPeek",!1,{description:p.localize(186,null)})),quickSuggestions:be(new te),quickSuggestionsDelay:be(new c(77,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(187,null)})),readOnly:be(new h(78,"readOnly",!1)),renameOnType:be(new h(79,"renameOnType",!1,{description:p.localize(188,null),markdownDeprecationMessage:p.localize(189,null)})),renderControlCharacters:be(new h(80,"renderControlCharacters",!1,{description:p.localize(190,null)})),renderIndentGuides:be(new h(81,"renderIndentGuides",!0,{description:p.localize(191,null)})),renderFinalNewline:be(new h(82,"renderFinalNewline",!0,{description:p.localize(192,null)})),renderLineHighlight:be(new w(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(193,null)],description:p.localize(194,null)})),renderLineHighlightOnlyWhenFocus:be(new h(84,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(195,null)})),renderValidationDecorations:be(new w(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:be(new w(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(196,null),p.localize(197,null),p.localize(198,null),""],description:p.localize(199,null)})),revealHorizontalRightPadding:be(new c(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:be(new h(88,"roundedSelection",!0,{description:p.localize(200,null)})),rulers:be(new Le),scrollbar:be(new ze),scrollBeyondLastColumn:be(new c(91,"scrollBeyondLastColumn",5,0,1073741824,{description:p.localize(201,null)})),scrollBeyondLastLine:be(new h(92,"scrollBeyondLastLine",!0,{description:p.localize(202,null)})),scrollPredominantAxis:be(new h(93,"scrollPredominantAxis",!0,{description:p.localize(203,null)})),selectionClipboard:be(new h(94,"selectionClipboard",!0,{description:p.localize(204,null),included:R.isLinux})),selectionHighlight:be(new h(95,"selectionHighlight",!0,{description:p.localize(205,null)})),selectOnLineNumbers:be(new h(96,"selectOnLineNumbers",!0)),showFoldingControls:be(new w(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[p.localize(206,null),p.localize(207,null)],description:p.localize(208,null)})),showUnused:be(new h(98,"showUnused",!0,{description:p.localize(209,null)})),showDeprecated:be(new h(123,"showDeprecated",!0,{description:p.localize(210,null)})),inlayHints:be(new N),snippetSuggestions:be(new w(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(211,null),p.localize(212,null),p.localize(213,null),p.localize(214,null)],description:p.localize(215,null)})),smartSelect:be(new Y),smoothScrolling:be(new h(101,"smoothScrolling",!1,{description:p.localize(216,null)})),stopRenderingLineAfter:be(new c(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:be(new j),inlineSuggest:be(new Ge),suggestFontSize:be(new c(105,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(217,null)})),suggestLineHeight:be(new c(106,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(218,null)})),suggestOnTriggerCharacters:be(new h(107,"suggestOnTriggerCharacters",!0,{description:p.localize(219,null)})),suggestSelection:be(new w(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(220,null),p.localize(221,null),p.localize(222,null)],description:p.localize(223,null)})),tabCompletion:be(new w(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(224,null),p.localize(225,null),p.localize(226,null)],description:p.localize(227,null)})),tabIndex:be(new c(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:be(new w(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(228,null),p.localize(229,null),p.localize(230,null)],description:p.localize(231,null)})),useShadowDOM:be(new h(112,"useShadowDOM",!0)),useTabStops:be(new h(113,"useTabStops",!0,{description:p.localize(232,null)})),wordSeparators:be(new I(114,"wordSeparators",C.USUAL_WORD_SEPARATORS,{description:p.localize(233,null)})),wordWrap:be(new w(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),wordWrapBreakAfterCharacters:be(new I(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:be(new I(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:be(new c(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(239,null)})),wordWrapOverride1:be(new w(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:be(new w(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:be(new u(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],J,{enumDescriptions:[p.localize(240,null),p.localize(241,null),p.localize(242,null),p.localize(243,null)],description:p.localize(244,null)})),wrappingStrategy:be(new w(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[p.localize(245,null),p.localize(246,null)],description:p.localize(247,null)})),editorClassName:be(new m),pixelRatio:be(new G),tabFocusMode:be(new ie),layoutInfo:be(new x),wrappingInfo:be(new ce)}}),define(pe[151],ve([19,20]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(pe[152],ve([19,20]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(pe[153],ve([19,20]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(pe[154],ve([19,20]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(pe[155],ve([19,20]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(pe[156],ve([19,20]),function(X,e){return X.create("vs/platform/markers/common/markers",e)}),define(pe[157],ve([19,20]),function(X,e){return X.create("vs/platform/workspaces/common/workspaces",e)}),define(pe[158],ve([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(pe[159],ve([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostExtensionService",e)}),define(pe[160],ve([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostProgress",e)}),define(pe[161],ve([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostStatusBar",e)}),define(pe[162],ve([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTerminalService",e)}),define(pe[163],ve([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostTreeViews",e)}),define(pe[164],ve([19,20]),function(X,e){return X.create("vs/workbench/api/common/extHostWorkspace",e)}),define(pe[165],ve([19,20]),function(X,e){return X.create("vs/workbench/api/node/extHostDebugService",e)}),define(pe[166],ve([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(pe[167],ve([19,20]),function(X,e){return X.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(pe[168],ve([19,20]),function(X,e){return X.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(pe[169],ve([19,20]),function(X,e){return X.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(pe[170],ve([19,20]),function(X,e){return X.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(pe[171],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var p;(function(A){A[A.ACTIVATE=0]="ACTIVATE",A[A.RESTORE=1]="RESTORE",A[A.PRESERVE=2]="PRESERVE"})(p=e.EditorActivation||(e.EditorActivation={}));var R;(function(A){A[A.PICK=1]="PICK",A[A.DISABLED=2]="DISABLED"})(R=e.EditorOverride||(e.EditorOverride={}));var C;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(C=e.EditorOpenContext||(e.EditorOpenContext={}));var S;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(S=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(pe[172],ve([0,1,153]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function S(l){return l=l.trim(),l==="*"||R.test(l)}e.isValidVersionStr=S;function A(l){if(!S(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=l.match(R);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=A;function P(l){if(!l)return null;let h=l.majorBase,c=l.majorMustEqual,f=l.minorBase,I=l.minorMustEqual,b=l.patchBase,w=l.patchMustEqual;l.hasCaret&&(h===0||(I=!1),w=!1);let u=0;if(l.preRelease){const d=C.exec(l.preRelease);if(d){const[,g,t,i]=d;u=Date.UTC(Number(g),Number(t)-1,Number(i))}}return{majorBase:h,majorMustEqual:c,minorBase:f,minorMustEqual:I,patchBase:b,patchMustEqual:w,isMinimum:l.hasGreaterEquals,notBefore:u}}e.normalizeVersion=P;function _(l,h,c){let f;typeof l=="string"?f=P(A(l)):f=l;let I;h instanceof Date?I=h.getTime():typeof h=="string"&&(I=new Date(h).getTime());let b;if(typeof c=="string"?b=P(A(c)):b=c,!f||!b)return!1;let w=f.majorBase,u=f.minorBase,d=f.patchBase,g=b.majorBase,t=b.minorBase,i=b.patchBase,s=b.notBefore,n=b.majorMustEqual,o=b.minorMustEqual,v=b.patchMustEqual;return b.isMinimum?w>g?!0:w<g?!1:u>t?!0:u<t||I&&I<s?!1:d>=i:(w===1&&g===0&&(!n||!o||!v)&&(g=1,t=0,i=0,n=!0,o=!1,v=!1),w<g?!1:w>g?!n:u<t?!1:u>t?!o:d<i?!1:d>i?!v:!(I&&I<s))}e.isValidVersion=_;function D(l,h,c,f){return c.isBuiltin||typeof c.main=="undefined"?!0:k(l,h,c.engines.vscode,f)}e.isValidExtensionVersion=D;function r(l,h,c){return l==="*"||k(h,c,l)}e.isEngineValid=r;function k(l,h,c,f=[]){let I=P(A(c));if(!I)return f.push(p.localize(0,null,c)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return f.push(p.localize(1,null,c)),!1}else if(!I.majorMustEqual)return f.push(p.localize(2,null,c)),!1;return _(l,h,I)?!0:(f.push(p.localize(3,null,l,c)),!1)}}),define(pe[111],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(S,A=[],P=!1){this.ctor=S,this.staticArguments=A,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=p;const R=(C,...S)=>new p(C,S);e.createSyncDescriptor=R}),define(pe[77],ve([0,1,111]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const R=[];function C(A,P,_){P instanceof p.SyncDescriptor||(P=new p.SyncDescriptor(P,[],_)),R.push([A,P])}e.registerSingleton=C;function S(){return R}e.getSingletonServiceDescriptors=S}),define(pe[173],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(S){this.incoming=new Map,this.outgoing=new Map,this.data=S}}e.Node=p;class R{constructor(S){this._hashFn=S,this._nodes=new Map}roots(){const S=[];for(let A of this._nodes.values())A.outgoing.size===0&&S.push(A);return S}insertEdge(S,A){const P=this.lookupOrInsertNode(S),_=this.lookupOrInsertNode(A);P.outgoing.set(this._hashFn(A),_),_.incoming.set(this._hashFn(S),P)}removeNode(S){const A=this._hashFn(S);this._nodes.delete(A);for(let P of this._nodes.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(S){const A=this._hashFn(S);let P=this._nodes.get(A);return P||(P=new p(S),this._nodes.set(A,P)),P}lookup(S){return this._nodes.get(this._hashFn(S))}isEmpty(){return this._nodes.size===0}toString(){let S=[];for(let[A,P]of this._nodes)S.push(`${A}, (incoming)[${[...P.incoming.keys()].join(", ")}], (outgoing)[${[...P.outgoing.keys()].join(",")}]`);return S.join(`
`)}findCycleSlow(){for(let[S,A]of this._nodes){const P=new Set([S]),_=this._findCycle(A,P);if(_)return _}}_findCycle(S,A){for(let[P,_]of S.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const D=this._findCycle(_,A);if(D)return D;A.delete(P)}}}e.Graph=R}),define(pe[4],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(P){P.serviceIds=new Map,P.DI_TARGET="$di$target",P.DI_DEPENDENCIES="$di$dependencies";function _(D){return D[P.DI_DEPENDENCIES]||[]}P.getServiceDependencies=_})(p=e._util||(e._util={})),e.IInstantiationService=C("instantiationService");function R(P,_,D,r){_[p.DI_TARGET]===_?_[p.DI_DEPENDENCIES].push({id:P,index:D,optional:r}):(_[p.DI_DEPENDENCIES]=[{id:P,index:D,optional:r}],_[p.DI_TARGET]=_)}function C(P){if(p.serviceIds.has(P))return p.serviceIds.get(P);const _=function(D,r,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(_,D,k,!1)};return _.toString=()=>P,p.serviceIds.set(P,_),_}e.createDecorator=C;function S(P){return P}e.refineServiceDecorator=S;function A(P){return function(_,D,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");R(P,_,r,!0)}}e.optional=A}),define(pe[174],ve([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=p.createDecorator("modelService");function R(C){return!C.isTooLargeForSyncing()&&!C.isForSimpleWidget}e.shouldSynchronizeModel=R}),define(pe[175],ve([0,1,3,73,6,23,72,76,174]),function(X,e,p,R,C,S,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function D(l){return typeof l=="string"?!1:Array.isArray(l)?l.every(D):!!l.exclusive}class r{constructor(){this._clock=0,this._entries=[],this._onDidChange=new p.Emitter}get onDidChange(){return this._onDidChange.event}register(h,c){let f={selector:h,provider:c,_score:-1,_time:this._clock++};return this._entries.push(f),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),C.toDisposable(()=>{if(f){let I=this._entries.indexOf(f);I>=0&&(this._entries.splice(I,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),f=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const c=[];for(let f of this._entries)f._score>0&&c.push(f.provider);return c}ordered(h){const c=[];return this._orderedForEach(h,f=>c.push(f.provider)),c}orderedGroups(h){const c=[];let f,I;return this._orderedForEach(h,b=>{f&&I===b._score?f.push(b.provider):(I=b._score,f=[b.provider],c.push(f))}),c}_orderedForEach(h,c){if(!!h){this._updateScores(h);for(const f of this._entries)f._score>0&&c(f)}}_updateScores(h){let c={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let f of this._entries)if(f._score=P.score(f.selector,h.uri,h.getLanguageIdentifier().language,_.shouldSynchronizeModel(h)),D(f.selector)&&f._score>0){for(let I of this._entries)I._score=0;f._score=1e3;break}this._entries.sort(r._compareByScoreAndTime)}}static _compareByScoreAndTime(h,c){return h._score<c._score?1:h._score>c._score?-1:h._time<c._time?1:h._time>c._time?-1:0}}e.LanguageFeatureRegistry=r;class k{constructor(h,c,f=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=c,this.max=f,this._cache=new S.LRUCache(50,.7)}_key(h){return h.id+R.hash(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const c=this._key(h),f=this._cache.get(c);return this._clamp(f==null?void 0:f.value)}update(h,c){const f=this._key(h);let I=this._cache.get(f);return I||(I=new A.MovingAverage,this._cache.set(f,I)),I.update(c),this.get(h)}}e.LanguageFeatureRequestDelays=k}),define(pe[78],ve([0,1,2,41,175,143,91]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var P;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(P=e.LanguageId||(e.LanguageId={}));class _{constructor(T,O){this.language=T,this.id=O}}e.LanguageIdentifier=_;var D;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(D=e.FontStyle||(e.FontStyle={}));var r;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(r=e.ColorId||(e.ColorId={}));var k;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var l;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(l=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(T){return(T&255)>>>0}static getTokenType(T){return(T&1792)>>>8}static getFontStyle(T){return(T&14336)>>>11}static getForeground(T){return(T&8372224)>>>14}static getBackground(T){return(T&4286578688)>>>23}static getClassNameFromMetadata(T){let O=this.getForeground(T),$="mtk"+O,Z=this.getFontStyle(T);return Z&1&&($+=" mtki"),Z&2&&($+=" mtkb"),Z&4&&($+=" mtku"),$}static getInlineStyleFromMetadata(T,O){const $=this.getForeground(T),Z=this.getFontStyle(T);let le=`color: ${O[$]};`;return Z&1&&(le+="font-style: italic;"),Z&2&&(le+="font-weight: bold;"),Z&4&&(le+="text-decoration: underline;"),le}}e.TokenMetadata=h;var c;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(T){const O=a[T];let $=O&&A.iconRegistry.get(O);return $||(console.info("No codicon found for CompletionItemKind "+T),$=A.Codicon.symbolProperty),$.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(T,O){let $=a[T];return typeof $=="undefined"&&!O&&($=9),$}}();var f;(function(a){a[a.Deprecated=1]="Deprecated"})(f=e.CompletionItemTag||(e.CompletionItemTag={}));var I;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(I=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var w;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(w=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var u;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(u=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var d;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(d=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var g;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(g=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&p.URI.isUri(a.uri)&&R.Range.isIRange(a.range)&&(R.Range.isIRange(a.originSelectionRange)||R.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var i;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var s;(function(a){a[a.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var n;(function(a){const T=new Map;T.set("file",0),T.set("module",1),T.set("namespace",2),T.set("package",3),T.set("class",4),T.set("method",5),T.set("property",6),T.set("field",7),T.set("constructor",8),T.set("enum",9),T.set("interface",10),T.set("function",11),T.set("variable",12),T.set("constant",13),T.set("string",14),T.set("number",15),T.set("boolean",16),T.set("array",17),T.set("object",18),T.set("key",19),T.set("null",20),T.set("enum-member",21),T.set("struct",22),T.set("event",23),T.set("operator",24),T.set("type-parameter",25);const O=new Map;O.set(0,"file"),O.set(1,"module"),O.set(2,"namespace"),O.set(3,"package"),O.set(4,"class"),O.set(5,"method"),O.set(6,"property"),O.set(7,"field"),O.set(8,"constructor"),O.set(9,"enum"),O.set(10,"interface"),O.set(11,"function"),O.set(12,"variable"),O.set(13,"constant"),O.set(14,"string"),O.set(15,"number"),O.set(16,"boolean"),O.set(17,"array"),O.set(18,"object"),O.set(19,"key"),O.set(20,"null"),O.set(21,"enum-member"),O.set(22,"struct"),O.set(23,"event"),O.set(24,"operator"),O.set(25,"type-parameter");function $(q){return T.get(q)}a.fromString=$;function Z(q){return O.get(q)}a.toString=Z;function le(q,x){const H=O.get(q);let N=H&&A.iconRegistry.get("symbol-"+H);return N||(console.info("No codicon found for SymbolKind "+q),N=A.Codicon.symbolProperty),`${x?"inline":"block"} ${N.classNames}`}a.toCssClassName=le})(n=e.SymbolKinds||(e.SymbolKinds={}));class o{constructor(T){this.value=T}}e.FoldingRangeKind=o,o.Comment=new o("comment"),o.Imports=new o("imports"),o.Region=new o("region");var v;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(v=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var m;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(m=e.CommentMode||(e.CommentMode={}));var E;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(E=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new C.LanguageFeatureRegistry,e.RenameProviderRegistry=new C.LanguageFeatureRegistry,e.CompletionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new C.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new C.LanguageFeatureRegistry,e.HoverProviderRegistry=new C.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new C.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new C.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new C.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new C.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new C.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new C.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new C.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new C.LanguageFeatureRegistry,e.LinkProviderRegistry=new C.LanguageFeatureRegistry,e.ColorProviderRegistry=new C.LanguageFeatureRegistry,e.SelectionRangeRegistry=new C.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new C.LanguageFeatureRegistry,e.TokenizationRegistry=new S.TokenizationRegistryImpl;var y;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(y=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(pe[112],ve([0,1,8,4,11]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let S=C.userAgent||"";const A=new Map;A.set("false",!1),A.set("true",!0),A.set("isMac",C.isMacintosh),A.set("isLinux",C.isLinux),A.set("isWindows",C.isWindows),A.set("isWeb",C.isWeb),A.set("isMacNative",C.isMacintosh&&!C.isWeb),A.set("isEdge",S.indexOf("Edg/")>=0),A.set("isFirefox",S.indexOf("Firefox")>=0),A.set("isChrome",S.indexOf("Chrome")>=0),A.set("isSafari",S.indexOf("Safari")>=0);const P=Object.prototype.hasOwnProperty;var _;(function(y){y[y.False=0]="False",y[y.True=1]="True",y[y.Defined=2]="Defined",y[y.Not=3]="Not",y[y.Equals=4]="Equals",y[y.NotEquals=5]="NotEquals",y[y.And=6]="And",y[y.Regex=7]="Regex",y[y.NotRegex=8]="NotRegex",y[y.Or=9]="Or",y[y.In=10]="In",y[y.NotIn=11]="NotIn",y[y.Greater=12]="Greater",y[y.GreaterEquals=13]="GreaterEquals",y[y.Smaller=14]="Smaller",y[y.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return k.INSTANCE}static true(){return l.INSTANCE}static has(a){return h.create(a)}static equals(a,T){return c.create(a,T)}static notEquals(a,T){return b.create(a,T)}static regex(a,T){return i.create(a,T)}static in(a,T){return f.create(a,T)}static not(a){return w.create(a)}static and(...a){return n.create(a)}static or(...a){return o.create(a)}static greater(a,T){return u.create(a,T)}static less(a,T){return g.create(a,T)}static deserialize(a,T=!1){if(!!a)return this._deserializeOrExpression(a,T)}static _deserializeOrExpression(a,T){let O=a.split("||");return o.create(O.map($=>this._deserializeAndExpression($,T)))}static _deserializeAndExpression(a,T){let O=a.split("&&");return n.create(O.map($=>this._deserializeOne($,T)))}static _deserializeOne(a,T){if(a=a.trim(),a.indexOf("!=")>=0){let O=a.split("!=");return b.create(O[0].trim(),this._deserializeValue(O[1],T))}if(a.indexOf("==")>=0){let O=a.split("==");return c.create(O[0].trim(),this._deserializeValue(O[1],T))}if(a.indexOf("=~")>=0){let O=a.split("=~");return i.create(O[0].trim(),this._deserializeRegexValue(O[1],T))}if(a.indexOf(" in ")>=0){let O=a.split(" in ");return f.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const O=a.split(">=");return d.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const O=a.split(">");return u.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const O=a.split("<=");return t.create(O[0].trim(),O[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const O=a.split("<");return g.create(O[0].trim(),O[1].trim())}return/^\!\s*/.test(a)?w.create(a.substr(1).trim()):h.create(a)}static _deserializeValue(a,T){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let O=/^'([^']*)'$/.exec(a);return O?O[1].trim():a}static _deserializeRegexValue(a,T){if(p.isFalsyOrWhitespace(a)){if(T)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let O=a.indexOf("/"),$=a.lastIndexOf("/");if(O===$||O<0){if(T)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let Z=a.slice(O+1,$),le=a[$+1]==="i"?"i":"";try{return new RegExp(Z,le)}catch(q){if(T)throw new Error(`bad regexp-value '${a}', parse error: ${q}`);return console.warn(`bad regexp-value '${a}', parse error: ${q}`),null}}}e.ContextKeyExpr=D;function r(y,a){return y.cmp(a)}class k{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return l.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class l{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=l,l.INSTANCE=new l;class h{constructor(a){this.key=a,this.type=2}static create(a){const T=A.get(a);return typeof T=="boolean"?T?l.INSTANCE:k.INSTANCE:new h(a)}cmp(a){return a.type!==this.type?this.type-a.type:m(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return w.create(this.key)}}e.ContextKeyDefinedExpr=h;class c{constructor(a,T){this.key=a,this.value=T,this.type=4}static create(a,T){if(typeof T=="boolean")return T?h.create(a):w.create(a);const O=A.get(a);return typeof O=="boolean"?T===(O?"true":"false")?l.INSTANCE:k.INSTANCE:new c(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class f{constructor(a,T){this.key=a,this.valueKey=T,this.type=10}static create(a,T){return new f(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const T=a.getValue(this.valueKey),O=a.getValue(this.key);return Array.isArray(T)?T.indexOf(O)>=0:typeof O=="string"&&typeof T=="object"&&T!==null?P.call(T,O):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return I.create(this)}}e.ContextKeyInExpr=f;class I{constructor(a){this._actual=a,this.type=11}static create(a){return new I(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new I(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class b{constructor(a,T){this.key=a,this.value=T,this.type=5}static create(a,T){if(typeof T=="boolean")return T?w.create(a):h.create(a);const O=A.get(a);return typeof O=="boolean"?T===(O?"true":"false")?k.INSTANCE:l.INSTANCE:new b(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class w{constructor(a){this.key=a,this.type=3}static create(a){const T=A.get(a);return typeof T=="boolean"?T?k.INSTANCE:l.INSTANCE:new w(a)}cmp(a){return a.type!==this.type?this.type-a.type:m(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=w;class u{constructor(a,T){this.key=a,this.value=T,this.type=12}static create(a,T){return new u(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=u;class d{constructor(a,T){this.key=a,this.value=T,this.type=13}static create(a,T){return new d(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=d;class g{constructor(a,T){this.key=a,this.value=T,this.type=14}static create(a,T){return new g(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeySmallerExpr=g;class t{constructor(a,T){this.key=a,this.value=T,this.type=15}static create(a,T){return new t(a,T)}cmp(a){return a.type!==this.type?this.type-a.type:E(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return u.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(a,T){this.key=a,this.regexp=T,this.type=7}static create(a,T){return new i(a,T)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const T=this.regexp?this.regexp.source:"",O=a.regexp?a.regexp.source:"";return T<O?-1:T>O?1:0}equals(a){if(a.type===this.type){const T=this.regexp?this.regexp.source:"",O=a.regexp?a.regexp.source:"";return this.key===a.key&&T===O}return!1}evaluate(a){let T=a.getValue(this.key);return this.regexp?this.regexp.test(T):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=i;class s{constructor(a){this._actual=a,this.type=8}static create(a){return new s(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new s(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class n{constructor(a){this.expr=a,this.type=6}static create(a){return n._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const $=r(this.expr[T],a.expr[T]);if($!==0)return $}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(a.expr[T]))return!1;return!0}return!1}evaluate(a){for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].evaluate(a))return!1;return!0}static _normalizeArr(a){const T=[];let O=!1;for(const $ of a)if(!!$){if($.type===1){O=!0;continue}if($.type===0)return k.INSTANCE;if($.type===6){T.push(...$.expr);continue}T.push($)}if(T.length===0&&O)return l.INSTANCE;if(T.length!==0){if(T.length===1)return T[0];for(T.sort(r);T.length>1;){const $=T[T.length-1];if($.type!==9)break;T.pop();const Z=T.pop(),le=o.create($.expr.map(q=>n.create([q,Z])));le&&(T.push(le),T.sort(r))}return T.length===1?T[0]:new n(T)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let T of this.expr)a.push(...T.keys());return a}map(a){return new n(this.expr.map(T=>T.map(a)))}negate(){let a=[];for(let T of this.expr)a.push(T.negate());return o.create(a)}}e.ContextKeyAndExpr=n;class o{constructor(a){this.expr=a,this.type=9}static create(a){const T=o._normalizeArr(a);if(T.length!==0)return T.length===1?T[0]:new o(T)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let T=0,O=this.expr.length;T<O;T++){const $=r(this.expr[T],a.expr[T]);if($!==0)return $}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let T=0,O=this.expr.length;T<O;T++)if(!this.expr[T].equals(a.expr[T]))return!1;return!0}return!1}evaluate(a){for(let T=0,O=this.expr.length;T<O;T++)if(this.expr[T].evaluate(a))return!0;return!1}static _normalizeArr(a){let T=[],O=!1;if(a){for(let $=0,Z=a.length;$<Z;$++){const le=a[$];if(!!le){if(le.type===0){O=!0;continue}if(le.type===1)return[l.INSTANCE];if(le.type===9){T=T.concat(le.expr);continue}T.push(le)}}if(T.length===0&&O)return[k.INSTANCE];T.sort(r)}return T}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let T of this.expr)a.push(...T.keys());return a}map(a){return new o(this.expr.map(T=>T.map(a)))}negate(){let a=[];for(let O of this.expr)a.push(O.negate());const T=O=>O.type===9?O.expr:[O];for(;a.length>1;){const O=a.shift(),$=a.shift(),Z=[];for(const le of T(O))for(const q of T($))Z.push(D.and(le,q));a.unshift(D.or(...Z))}return a[0]}}e.ContextKeyOrExpr=o;class v extends h{constructor(a,T,O){super(a);this._defaultValue=T,typeof O=="object"?v._info.push(Object.assign(Object.assign({},O),{key:a})):O!==!0&&v._info.push({key:a,description:O,type:T!=null?typeof T:void 0})}static all(){return v._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return D.not(this.key)}isEqualTo(a){return D.equals(this.key,a)}notEqualsTo(a){return D.notEquals(this.key,a)}}e.RawContextKey=v,v._info=[],e.IContextKeyService=R.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(y,a){return y<a?-1:y>a?1:0}function E(y,a,T,O){return y<T?-1:y>T?1:a<O?-1:a>O?1:0}}),define(pe[176],ve([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=p.createDecorator("environmentService"),e.INativeEnvironmentService=p.refineServiceDecorator(e.IEnvironmentService)}),define(pe[177],ve([0,1,152,4,10]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function S(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=S;var A;(function(k){k[k.NoneOrRelevance=0]="NoneOrRelevance",k[k.LastUpdatedDate=1]="LastUpdatedDate",k[k.Title=2]="Title",k[k.PublisherName=3]="PublisherName",k[k.InstallCount=4]="InstallCount",k[k.PublishedDate=5]="PublishedDate",k[k.AverageRating=6]="AverageRating",k[k.WeightedRating=12]="WeightedRating"})(A=e.SortBy||(e.SortBy={}));var P;(function(k){k[k.Default=0]="Default",k[k.Ascending=1]="Ascending",k[k.Descending=2]="Descending"})(P=e.SortOrder||(e.SortOrder={}));var _;(function(k){k.Uninstall="uninstall"})(_=e.StatisticType||(e.StatisticType={}));var D;(function(k){k[k.None=0]="None",k[k.Install=1]="Install",k[k.Update=2]="Update"})(D=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=R.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(l,h){super(l);this.code=h}}e.ExtensionManagementError=r,e.IExtensionManagementService=R.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=R.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=R.createDecorator("IExtensionTipsService"),e.DefaultIconPath=C.FileAccess.asBrowserUri("./media/defaultIcon.png",X).toString(!0),e.ExtensionsLabel=p.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=p.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=R.createDecorator("IExtensionManagementCLIService")}),define(pe[26],ve([0,1,8,4]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function C(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.getWorkpaceSupportTypeMessage=C;function S(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=S,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class P{constructor(k){this.value=k,this._lower=k.toLowerCase()}static equals(k,l){if(typeof k=="undefined"||k===null)return typeof l=="undefined"||l===null;if(typeof l=="undefined"||l===null)return!1;if(typeof k=="string"||typeof l=="string"){let h=typeof k=="string"?k:k.value,c=typeof l=="string"?l:l.value;return p.equalsIgnoreCase(h,c)}return k._lower===l._lower}static toKey(k){return typeof k=="string"?k.toLowerCase():k._lower}}e.ExtensionIdentifier=P;function _(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function D(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=D,e.IBuiltinExtensionsScannerService=R.createDecorator("IBuiltinExtensionsScannerService")}),define(pe[178],ve([0,1,8,26]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function C(h,c){return h.uuid&&c.uuid?h.uuid===c.uuid:h.id===c.id?!0:p.compareIgnoreCase(h.id,c.id)===0}e.areSameExtensions=C;class S{constructor(c,f){this.version=f,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof S?C(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=S;function A(h,c){return`${h}.${c}`}e.getExtensionId=A;function P(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=P;function _(h,c){return P(A(h,c))}e.getGalleryExtensionId=_;function D(h,c){const f=[],I=b=>{for(const w of f)if(w.some(u=>C(c(u),c(b))))return w;return null};for(const b of h){const w=I(b);w?w.push(b):f.push([b])}return f}e.groupByExtension=D;function r(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function k(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new R.ExtensionIdentifier("pprice.better-merge");function l(h){const c=new Set;for(const f of h)f.malicious&&c.add(f.id.id);return c}e.getMaliciousExtensionsSet=l}),define(pe[179],ve([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=p.createDecorator("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=p.createDecorator("externalTerminal")}),define(pe[180],ve([0,1,38,9,110,154,28,11,179,10,135]),function(X,e,p,R,C,S,A,P,_,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=S.localize(0,null);class l{async getDefaultTerminalForPlatforms(){const d=await f.getDefaultTerminalLinuxReady();return{windows:h.getDefaultTerminalWindows(),linux:d,osx:"xterm"}}}class h extends l{openTerminal(d,g){return this.spawnTerminal(p,d,C.getWindowsShell(),g)}spawnTerminal(d,g,t,i){const s=g.windowsExec||h.getDefaultTerminalWindows();i&&i[1]===":"&&(i=i[0].toUpperCase()+i.substr(1));const n=R.basename(s).toLowerCase();if(n==="cmder"||n==="cmder.exe")return d.spawn(s,i?[i]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return s.indexOf(" ")>=0&&o.push('""'),o.push(s),(n==="wt"||n==="wt.exe")&&o.push("-d ."),new Promise((v,m)=>{const E=I(process),y=d.spawn(t,o,{cwd:i,env:E});y.on("error",m),y.on("exit",()=>v())})}runInTerminal(d,g,t,i,s){const n="windowsExec"in s&&s.windowsExec?s.windowsExec:h.getDefaultTerminalWindows();return new Promise((o,v)=>{const m=`"${g} - ${k}"`,E=`""${t.join('" "')}" & pause"`,y=["/c","start",m,"/wait",n,"/c",E],a=Object.assign({},I(process),i);Object.keys(a).filter($=>a[$]===null).forEach($=>delete a[$]);const T={cwd:g,env:a,windowsVerbatimArguments:!0};p.spawn(h.CMD,y,T).on("error",$=>{v(b($))}),o(void 0)})}static getDefaultTerminalWindows(){if(!h._DEFAULT_TERMINAL_WINDOWS){const d=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");h._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${d?"Sysnative":"System32"}\\cmd.exe`}return h._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=h,h.CMD="cmd.exe";class c extends l{openTerminal(d,g){return this.spawnTerminal(p,d,g)}runInTerminal(d,g,t,i,s){const n=s.osxExec||_.DEFAULT_TERMINAL_OSX;return new Promise((o,v)=>{if(n===_.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const m=n===_.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",y=[D.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${m}.scpt`,X).fsPath,"-t",d||k,"-w",g];for(let O of t)y.push("-a"),y.push(O);if(i)for(let O in i){const $=i[O];$===null?(y.push("-u"),y.push(O)):(y.push("-e"),y.push(`${O}=${$}`))}let a="";const T=p.spawn(c.OSASCRIPT,y);T.on("error",O=>{v(b(O))}),T.stderr.on("data",O=>{a+=O.toString()}),T.on("exit",O=>{if(O===0)o(void 0);else if(a){const $=a.split(`
`,1);v(new Error($[0]))}else v(new Error(S.localize(1,null,m,O)))})}else v(new Error(S.localize(2,null,n)))})}spawnTerminal(d,g,t){const i=g.osxExec||_.DEFAULT_TERMINAL_OSX;return new Promise((s,n)=>{const o=["-a",i];t&&o.push(t);const v=d.spawn("/usr/bin/open",o);v.on("error",n),v.on("exit",()=>s())})}}e.MacExternalTerminalService=c,c.OSASCRIPT="/usr/bin/osascript";class f extends l{openTerminal(d,g){return this.spawnTerminal(p,d,g)}runInTerminal(d,g,t,i,s){const n=s.linuxExec?Promise.resolve(s.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((o,v)=>{let m=[];n.then(E=>{E.indexOf("gnome-terminal")>=0?m.push("-x"):m.push("-e"),m.push("bash"),m.push("-c");const y=`${w(t)}; echo; read -p "${f.WAIT_MESSAGE}" -n1;`;m.push(`''${y}''`);const a=Object.assign({},process.env,i);Object.keys(a).filter(Z=>a[Z]===null).forEach(Z=>delete a[Z]);const T={cwd:g,env:a};let O="";const $=p.spawn(E,m,T);$.on("error",Z=>{v(b(Z))}),$.stderr.on("data",Z=>{O+=Z.toString()}),$.on("exit",Z=>{if(Z===0)o(void 0);else if(O){const le=O.split(`
`,1);v(new Error(le[0]))}else v(new Error(S.localize(4,null,E,Z)))})})})}static async getDefaultTerminalLinuxReady(){return f._DEFAULT_TERMINAL_LINUX_READY||(f._DEFAULT_TERMINAL_LINUX_READY=new Promise(async d=>{P.isLinux?await A.Promises.exists("/etc/debian_version")?d("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?d("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?d("konsole"):process.env.COLORTERM?d(process.env.COLORTERM):process.env.TERM?d(process.env.TERM):d("xterm"):d("xterm")})),f._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(d,g,t){const i=g.linuxExec?Promise.resolve(g.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((s,n)=>{i.then(o=>{const v=I(process),m=d.spawn(o,[],{cwd:t,env:v});m.on("error",n),m.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=f,f.WAIT_MESSAGE=S.localize(3,null);function I(u){const d=u.env;return r.sanitizeProcessEnvironment(d),d}function b(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(S.localize(5,null,u.path)):u}function w(u){let d="";for(let g of u)g.indexOf(" ")>=0?d+='"'+g+'"':d+=g,d+=" ";return d}}),define(pe[42],ve([0,1,155,9,2,4,8,15,23]),function(X,e,p,R,C,S,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=S.createDecorator("fileService");function D(x){return x.create===!0}e.isFileOpenForWriteOptions=D;var r;(function(x){x[x.Unknown=0]="Unknown",x[x.File=1]="File",x[x.Directory=2]="Directory",x[x.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var k;(function(x){x[x.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var l;(function(x){x[x.FileReadWrite=2]="FileReadWrite",x[x.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",x[x.FileReadStream=16]="FileReadStream",x[x.FileFolderCopy=8]="FileFolderCopy",x[x.PathCaseSensitive=1024]="PathCaseSensitive",x[x.Readonly=2048]="Readonly",x[x.Trash=4096]="Trash",x[x.FileWriteUnlock=8192]="FileWriteUnlock"})(l=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(x){return!!(x.capabilities&2)}e.hasReadWriteCapability=h;function c(x){return!!(x.capabilities&8)}e.hasFileFolderCopyCapability=c;function f(x){return!!(x.capabilities&4)}e.hasOpenReadWriteCloseCapability=f;function I(x){return!!(x.capabilities&16)}e.hasFileReadStreamCapability=I;var b;(function(x){x.FileExists="EntryExists",x.FileNotFound="EntryNotFound",x.FileNotADirectory="EntryNotADirectory",x.FileIsADirectory="EntryIsADirectory",x.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",x.FileTooLarge="EntryTooLarge",x.FileWriteLocked="EntryWriteLocked",x.NoPermissions="NoPermissions",x.Unavailable="Unavailable",x.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class w extends Error{constructor(H,N){super(H);this.code=N}}e.FileSystemProviderError=w;function u(x,H){const N=new w(x.toString(),H);return g(N,H),N}e.createFileSystemProviderError=u;function d(x){return x||u(p.localize(0,null),b.Unknown)}e.ensureFileSystemProviderError=d;function g(x,H){return x.name=H?`${H} (FileSystemError)`:"FileSystemError",x}e.markAsFileSystemProviderError=g;function t(x){if(!x)return b.Unknown;if(x instanceof w)return x.code;const H=/^(.+) \(FileSystemError\)$/.exec(x.name);if(!H)return b.Unknown;switch(H[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function i(x){if(x instanceof E)return x.fileOperationResult;switch(t(x)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var s;(function(x){x[x.CREATE=0]="CREATE",x[x.DELETE=1]="DELETE",x[x.MOVE=2]="MOVE",x[x.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class n{constructor(H,N,z){this.resource=H,this.operation=N,this.target=z}isOperation(H){return this.operation===H}}e.FileOperationEvent=n;var o;(function(x){x[x.UPDATED=0]="UPDATED",x[x.ADDED=1]="ADDED",x[x.DELETED=2]="DELETED"})(o=e.FileChangeType||(e.FileChangeType={}));class v{constructor(H,N){this.changes=H,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const z of H)switch(z.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>N)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>N)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>N)),this.deleted.set(z.resource,z);break}}contains(H,...N){return this.doContains(H,{includeChildren:!1},...N)}affects(H,...N){return this.doContains(H,{includeChildren:!0},...N)}doContains(H,N,...z){var F,M,L,U,G,te;if(!H)return!1;const me=z.length>0;return!!((!me||z.includes(1))&&(((F=this.added)===null||F===void 0?void 0:F.get(H))||N.includeChildren&&((M=this.added)===null||M===void 0?void 0:M.findSuperstr(H)))||(!me||z.includes(0))&&(((L=this.updated)===null||L===void 0?void 0:L.get(H))||N.includeChildren&&((U=this.updated)===null||U===void 0?void 0:U.findSuperstr(H)))||(!me||z.includes(2))&&(((G=this.deleted)===null||G===void 0?void 0:G.findSubstr(H))||N.includeChildren&&((te=this.deleted)===null||te===void 0?void 0:te.findSuperstr(H))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=v;function m(x,H,N){return!x||!H||x===H||H.length>x.length?!1:(H.charAt(H.length-1)!==R.sep&&(H+=R.sep),N?A.startsWithIgnoreCase(x,H):x.indexOf(H)===0)}e.isParent=m;class E extends Error{constructor(H,N,z){super(H);this.fileOperationResult=N,this.options=z}}e.FileOperationError=E;class y extends E{constructor(H,N,z){super(H,2,z);this.stat=N}}e.NotModifiedSinceFileOperationError=y;var a;(function(x){x[x.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",x[x.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",x[x.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",x[x.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",x[x.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",x[x.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",x[x.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",x[x.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",x[x.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",x[x.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",x[x.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",x[x.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var T;(function(x){x[x.FILE=0]="FILE",x[x.FOLDER=1]="FOLDER",x[x.ROOT_FOLDER=2]="ROOT_FOLDER"})(T=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function O(x){if(!(typeof x.size!="number"||typeof x.mtime!="number"))return x.mtime.toString(29)+x.size.toString(31)}e.etag=O;async function $(x,H){if(!H.canHandleResource(C.URI.from({scheme:x.scheme})))return new Promise(N=>{const z=H.onDidChangeFileSystemProviderRegistrations(F=>{F.scheme===x.scheme&&F.added&&(z.dispose(),N())})})}e.whenProviderRegistered=$,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class Z{static formatSize(H){return P.isNumber(H)||(H=0),H<Z.KB?p.localize(1,null,H.toFixed(0)):H<Z.MB?p.localize(2,null,(H/Z.KB).toFixed(2)):H<Z.GB?p.localize(3,null,(H/Z.MB).toFixed(2)):H<Z.TB?p.localize(4,null,(H/Z.GB).toFixed(2)):p.localize(5,null,(H/Z.TB).toFixed(2))}}e.ByteSize=Z,Z.KB=1024,Z.MB=Z.KB*Z.KB,Z.GB=Z.MB*Z.KB,Z.TB=Z.GB*Z.KB;var le;(function(x){x[x.IA32=0]="IA32",x[x.OTHER=1]="OTHER"})(le=e.Arch||(e.Arch={}));function q(x){return{maxFileSize:x===0?300*Z.MB:16*Z.GB,maxHeapSize:x===0?700*Z.MB:2*700*Z.MB}}e.getPlatformLimits=q}),define(pe[79],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...C){this._entries=new Map;for(let[S,A]of C)this.set(S,A)}set(C,S){const A=this._entries.get(C);return this._entries.set(C,S),A}has(C){return this._entries.has(C)}get(C){return this._entries.get(C)}}e.ServiceCollection=p}),define(pe[181],ve([0,1,14,173,111,4,79,16]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class D extends Error{constructor(c){var f;super("cyclic dependency between services");this.message=(f=c.findCycleSlow())!==null&&f!==void 0?f:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class r{constructor(c=new A.ServiceCollection,f=!1,I){this._activeInstantiations=new Set,this._services=c,this._strict=f,this._parent=I,this._services.set(S.IInstantiationService,this)}createChild(c){return new r(c,this._strict,this)}invokeFunction(c,...f){let I=l.traceInvocation(c),b=!1;try{return c({get:(u,d)=>{if(b)throw p.illegalState("service accessor is only valid during the invocation of its target method");const g=this._getOrCreateServiceInstance(u,I);if(!g&&d!==S.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return g}},...f)}finally{b=!0,I.stop()}}createInstance(c,...f){let I,b;return c instanceof C.SyncDescriptor?(I=l.traceCreation(c.ctor),b=this._createInstance(c.ctor,c.staticArguments.concat(f),I)):(I=l.traceCreation(c),b=this._createInstance(c,f,I)),I.stop(),b}_createInstance(c,f=[],I){let b=S._util.getServiceDependencies(c).sort((d,g)=>d.index-g.index),w=[];for(const d of b){let g=this._getOrCreateServiceInstance(d.id,I);if(!g&&this._strict&&!d.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${d.id}.`);w.push(g)}let u=b.length>0?b[0].index:f.length;if(f.length!==u){console.warn(`[createInstance] First service dependency of ${c.name} at position ${u+1} conflicts with ${f.length} static arguments`);let d=u-f.length;d>0?f=f.concat(new Array(d)):f=f.slice(0,u)}return new c(...[...f,...w])}_setServiceInstance(c,f){if(this._services.get(c)instanceof C.SyncDescriptor)this._services.set(c,f);else if(this._parent)this._parent._setServiceInstance(c,f);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let f=this._services.get(c);return!f&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):f}_getOrCreateServiceInstance(c,f){let I=this._getServiceInstanceOrDescriptor(c);return I instanceof C.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,I,f.branch(c,!0)):(f.branch(c,!1),I)}_safeCreateAndCacheServiceInstance(c,f,I){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,f,I)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,f,I){const b=new R.Graph(d=>d.id.toString());let w=0;const u=[{id:c,desc:f,_trace:I}];for(;u.length;){const d=u.pop();if(b.lookupOrInsertNode(d),w++>1e3)throw new D(b);for(let g of S._util.getServiceDependencies(d.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(g.id);if(!t&&!g.optional&&console.warn(`[createInstance] ${c} depends on ${g.id} which is NOT registered.`),t instanceof C.SyncDescriptor){const i={id:g.id,desc:t,_trace:d._trace.branch(g.id,!0)};b.insertEdge(d,i),u.push(i)}}}for(;;){const d=b.roots();if(d.length===0){if(!b.isEmpty())throw new D(b);break}for(const{data:g}of d){if(this._getServiceInstanceOrDescriptor(g.id)instanceof C.SyncDescriptor){const i=this._createServiceInstanceWithOwner(g.id,g.desc.ctor,g.desc.staticArguments,g.desc.supportsDelayedInstantiation,g._trace);this._setServiceInstance(g.id,i)}b.removeNode(g)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,f,I=[],b,w){if(this._services.get(c)instanceof C.SyncDescriptor)return this._createServiceInstance(f,I,b,w);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,f,I,b,w);throw new Error(`illegalState - creating UNKNOWN service instance ${f.name}`)}_createServiceInstance(c,f=[],I,b){if(I){const w=new P.IdleValue(()=>this._createInstance(c,f,b));return new Proxy(Object.create(null),{get(u,d){if(d in u)return u[d];let g=w.value,t=g[d];return typeof t!="function"||(t=t.bind(g),u[d]=t),t},set(u,d,g){return w.value[d]=g,!0}})}else return this._createInstance(c,f,b)}}e.InstantiationService=r;var k;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(k||(k={}));class l{constructor(c,f){this.type=c,this.name=f,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return _?new l(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):l._None}static traceCreation(c){return _?new l(0,c.name):l._None}branch(c,f){let I=new l(2,c.toString());return this._dep.push([c,f,I]),I}stop(){let c=Date.now()-this._start;l._totals+=c;let f=!1;function I(w,u){let d=[],g=new Array(w+1).join("	");for(const[t,i,s]of u._dep)if(i&&s){f=!0,d.push(`${g}CREATES -> ${t}`);let n=I(w+1,s);n&&d.push(n)}else d.push(`${g}uses -> ${t}`);return d.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${l._totals.toFixed(2)}ms)`];(c>2||f)&&console.log(b.join(`
`))}}l._None=new class extends l{constructor(){super(-1,null)}stop(){}branch(){return this}},l._totals=0}),define(pe[12],ve([0,1,4,6,11,3,57]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=p.createDecorator("logService"),e.ILoggerService=p.createDecorator("loggerService");function P(){return new Date().toISOString()}var _;(function(g){g[g.Trace=0]="Trace",g[g.Debug=1]="Debug",g[g.Info=2]="Info",g[g.Warning=3]="Warning",g[g.Error=4]="Error",g[g.Critical=5]="Critical",g[g.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class D extends R.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new S.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=D;class r extends D{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(_.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(_.Error,this.format(s))}else this.log(_.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let s=0;s<t.length;s++){let n=t[s];if(typeof n=="object")try{n=JSON.stringify(n)}catch(o){}i+=(s>0?" ":"")+n}return i}}e.AbstractMessageLogger=r;class k extends D{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!C.isWindows}trace(t,...i){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}debug(t,...i){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}info(t,...i){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${P()}][0m`,t,...i):console.log(`[main ${P()}]`,t,...i))}warn(t,...i){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${P()}][0m`,t,...i):console.warn(`[main ${P()}]`,t,...i))}error(t,...i){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${P()}][0m`,t,...i):console.error(`[main ${P()}]`,t,...i))}critical(t,...i){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${P()}][0m`,t,...i):console.error(`[main ${P()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class l extends D{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=l;class h extends D{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:A.toErrorMessage(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class c extends D{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const s of this.logServices)s.trace(t,...i)}debug(t,...i){for(const s of this.logServices)s.debug(t,...i)}info(t,...i){for(const s of this.logServices)s.info(t,...i)}warn(t,...i){for(const s of this.logServices)s.warn(t,...i)}error(t,...i){for(const s of this.logServices)s.error(t,...i)}critical(t,...i){for(const s of this.logServices)s.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class f extends R.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=f;class I extends R.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(n=>n.setLevel(s))}))}createLogger(t,i){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(i==null?void 0:i.always)?_.Trace:this.logLevel,i),this.loggers.set(t.toString(),s),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class b{constructor(){this.onDidChangeLogLevel=new S.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=b;function w(g){if(g.verbose)return _.Trace;if(typeof g.logLevel=="string"){const t=u(g.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=w;function u(g){switch(g){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=u;function d(g){switch(g){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=d}),define(pe[113],ve([0,1,12,42]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function C(_,D,r,k){try{const l=await new Promise((h,c)=>{X(["spdlog"],h,c)});return l.setFlushOn(p.LogLevel.Trace),l.createAsyncRotatingLogger(_,D,r,k)}catch(l){console.error(l)}return null}function S(_,D,r,k){const l=X.__$__nodeRequire("spdlog");return l.setFlushOn(p.LogLevel.Trace),l.createRotatingLogger(_,D,r,k)}e.createRotatingLogger=S;function A(_,D,r){switch(D){case p.LogLevel.Trace:_.trace(r);break;case p.LogLevel.Debug:_.debug(r);break;case p.LogLevel.Info:_.info(r);break;case p.LogLevel.Warning:_.warn(r);break;case p.LogLevel.Error:_.error(r);break;case p.LogLevel.Critical:_.critical(r);break;default:throw new Error("Invalid log level")}}class P extends p.AbstractMessageLogger{constructor(D,r,k,l){super();this.name=D,this.filepath=r,this.rotating=k,this.buffer=[],this.setLevel(l),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(h=>{this._logger&&this._logger.setLevel(h)}))}_createSpdLogLogger(){const D=this.rotating?6:1,r=30/D*R.ByteSize.MB;return C(this.name,this.filepath,r,D).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:l,message:h}of this.buffer)A(this._logger,l,h);this.buffer=[]}})}log(D,r){this._logger?A(this._logger,D,r):this.getLevel()<=D&&this.buffer.push({level:D,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=P}),define(pe[114],ve([0,1,4,156,54]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var S;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(S=e.MarkerTag||(e.MarkerTag={}));var A;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(A=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function D(c,f){return f-c}_.compare=D;const r=Object.create(null);r[_.Error]=R.localize(0,null),r[_.Warning]=R.localize(1,null),r[_.Info]=R.localize(2,null);function k(c){return r[c]||""}_.toString=k;function l(c){switch(c){case C.default.Error:return _.Error;case C.default.Warning:return _.Warning;case C.default.Info:return _.Info;case C.default.Ignore:return _.Hint}}_.fromSeverity=l;function h(c){switch(c){case _.Error:return C.default.Error;case _.Warning:return C.default.Warning;case _.Info:return C.default.Info;case _.Hint:return C.default.Ignore}}_.toSeverity=h}(A=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(_){const D="";function r(l){return k(l,!0)}_.makeKey=r;function k(l,h){let c=[D];return l.source?c.push(l.source.replace("\xA6","\\\xA6")):c.push(D),l.code?typeof l.code=="string"?c.push(l.code.replace("\xA6","\\\xA6")):c.push(l.code.value.replace("\xA6","\\\xA6")):c.push(D),l.severity!==void 0&&l.severity!==null?c.push(A.toString(l.severity)):c.push(D),l.message&&h?c.push(l.message.replace("\xA6","\\\xA6")):c.push(D),l.startLineNumber!==void 0&&l.startLineNumber!==null?c.push(l.startLineNumber.toString()):c.push(D),l.startColumn!==void 0&&l.startColumn!==null?c.push(l.startColumn.toString()):c.push(D),l.endLineNumber!==void 0&&l.endLineNumber!==null?c.push(l.endLineNumber.toString()):c.push(D),l.endColumn!==void 0&&l.endColumn!==null?c.push(l.endColumn.toString()):c.push(D),c.push(D),c.join("\xA6")}_.makeKeyOptionalMessage=k})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=p.createDecorator("markerService")}),define(pe[182],ve([0,1,54,4,3]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=R.createDecorator("notificationService");var S;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.GLOBAL=1]="GLOBAL"})(S=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var A;(function(D){D[D.OFF=0]="OFF",D[D.SILENT=1]="SILENT",D[D.ERROR=2]="ERROR"})(A=e.NotificationsFilter||(e.NotificationsFilter={}));class P{constructor(){this.progress=new _,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(r){}updateMessage(r){}updateActions(r){}close(){}}e.NoOpNotification=P;class _{infinite(){}done(){}total(r){}worked(r){}}e.NoOpProgress=_}),define(pe[183],ve([0,1,6,8,2,4]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=S.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return p.Disposable.None},registerValidator(){return p.Disposable.None},registerExternalUriResolver(){return p.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return p.Disposable.None},async open(){return!1},async resolveExternalUri(P){return{resolved:P,dispose(){}}}});function A(P,_){return C.URI.isUri(P)?R.equalsIgnoreCase(P.scheme,_):R.startsWithIgnoreCase(P,_+":")}e.matchesScheme=A}),define(pe[184],ve([0,1,10,11,37,24]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.context!="undefined"){const P=R.globals.vscode.context.configuration();if(P)A=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(X==null?void 0:X.__$__nodeRequire)=="function"){const P=S.dirname(p.FileAccess.asFileUri("",X));A=X.__$__nodeRequire(S.joinPath(P,"product.json").fsPath);const _=X.__$__nodeRequire(S.joinPath(P,"package.json").fsPath);C.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`}),Object.assign(A,{version:_.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.58.0-dev",nameShort:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:R.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=A});var We=this&&this.__param||function(X,e){return function(p,R){e(p,R,X)}};define(pe[115],ve([0,1,4,21,6,16]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=p.createDecorator("progressService");var A;(function(r){r[r.Explorer=1]="Explorer",r[r.Scm=3]="Scm",r[r.Extensions=5]="Extensions",r[r.Window=10]="Window",r[r.Notification=15]="Notification",r[r.Dialog=20]="Dialog"})(A=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{constructor(k){this.callback=k}get value(){return this._value}report(k){this._value=k,this.callback(this._value)}}e.Progress=P,P.None=Object.freeze({report(){}});let _=class extends C.Disposable{constructor(k,l){super();this.deferred=new S.DeferredPromise,l.withProgress(k,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register(C.toDisposable(()=>this.deferred.complete()))}report(k){this.reporter?this.reporter.report(k):this.lastStep=k}};_=qe([We(1,e.IProgressService)],_),e.UnmanagedProgress=_;class D extends C.Disposable{constructor(k){super();this.progressIndicator=k,this.currentOperationId=0,this.currentOperationDisposables=this._register(new C.DisposableStore)}start(k){this.stop();const l=++this.currentOperationId,h=new R.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{l===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},k),this.currentOperationDisposables.add(C.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(C.toDisposable(()=>h.cancel())),this.currentOperationDisposables.add(C.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:l,token:h.token,stop:()=>this.doStop(l),isCurrent:()=>this.currentOperationId===l}}stop(){this.doStop(this.currentOperationId)}doStop(k){this.currentOperationId===k&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=D,e.IEditorProgressService=p.createDecorator("editorProgressService")}),define(pe[58],ve([0,1,15,50]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class C{constructor(){this.data=new Map}add(A,P){R.ok(p.isString(A)),R.ok(p.isObject(P)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,P)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new C}),define(pe[185],ve([0,1,58,3]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function C(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class S{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,D){this.schemasById[C(_)]=D,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new S;p.Registry.add(e.Extensions.JSONContribution,A)}),define(pe[80],ve([0,1,151,3,58,15,185]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var P;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(P=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const _=C.Registry.as(A.Extensions.JSONContribution);class D{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new R.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new R.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,w=!0){this.registerConfigurations([b],w)}registerConfigurations(b,w=!0){const u=[];b.forEach(d=>{u.push(...this.validateAndRegisterProperties(d,w,d.extensionInfo)),this.configurationContributors.push(d),this.registerJSONConfiguration(d)}),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(u)}deregisterConfigurations(b){const w=[],u=d=>{if(d.properties)for(const g in d.properties)w.push(g),delete this.configurationProperties[g],this.removeFromSchema(g,d.properties[g]);d.allOf&&d.allOf.forEach(g=>u(g))};for(const d of b){u(d);const g=this.configurationContributors.indexOf(d);g!==-1&&this.configurationContributors.splice(g,1)}_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}registerDefaultConfigurations(b){const w=[],u=[];for(const d of b)for(const g in d)if(w.push(g),e.OVERRIDE_PROPERTY_PATTERN.test(g)){this.defaultValues[g]=Object.assign(Object.assign({},this.defaultValues[g]||{}),d[g]);const t={type:"object",default:this.defaultValues[g],description:p.localize(1,null,g),$ref:e.resourceLanguageSettingsSchemaId};u.push(k(g)),this.configurationProperties[g]=t,this.defaultLanguageConfigurationOverridesNode.properties[g]=t}else{this.defaultValues[g]=d[g];const t=this.configurationProperties[g];t&&(this.updatePropertyDefaultValue(g,t),this.updateSchema(g,t))}this.registerOverrideIdentifiers(u),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}deregisterDefaultConfigurations(b){const w=[];for(const u of b)for(const d in u)if(w.push(d),delete this.defaultValues[d],e.OVERRIDE_PROPERTY_PATTERN.test(d))delete this.configurationProperties[d],delete this.defaultLanguageConfigurationOverridesNode.properties[d];else{const g=this.configurationProperties[d];g&&(this.updatePropertyDefaultValue(d,g),this.updateSchema(d,g))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(w)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const w of b)this.overrideIdentifiers.add(w);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,w=!0,u,d=3){var g;d=S.isUndefinedOrNull(b.scope)?d:b.scope;let t=[],i=b.properties;if(i)for(let n in i){if(w&&c(n)){delete i[n];continue}const o=i[n];if(this.updatePropertyDefaultValue(n,o),e.OVERRIDE_PROPERTY_PATTERN.test(n)?o.scope=void 0:(o.scope=S.isUndefinedOrNull(o.scope)?d:o.scope,o.restricted=S.isUndefinedOrNull(o.restricted)?!!((g=u==null?void 0:u.restrictedConfigurations)===null||g===void 0?void 0:g.includes(n)):o.restricted),i[n].hasOwnProperty("included")&&!i[n].included){this.excludedConfigurationProperties[n]=i[n],delete i[n];continue}else this.configurationProperties[n]=i[n];!i[n].deprecationMessage&&i[n].markdownDeprecationMessage&&(i[n].deprecationMessage=i[n].markdownDeprecationMessage),t.push(n)}let s=b.allOf;if(s)for(let n of s)t.push(...this.validateAndRegisterProperties(n,w,u,d));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const w=u=>{let d=u.properties;if(d)for(const t in d)this.updateSchema(t,d[t]);let g=u.allOf;g&&g.forEach(w)};w(b)}updateSchema(b,w){switch(e.allSettings.properties[b]=w,w.scope){case 1:e.applicationSettings.properties[b]=w;break;case 2:e.machineSettings.properties[b]=w;break;case 6:e.machineOverridableSettings.properties[b]=w;break;case 3:e.windowSettings.properties[b]=w;break;case 4:e.resourceSettings.properties[b]=w;break;case 5:e.resourceSettings.properties[b]=w,this.resourceLanguageSettingsSchema.properties[b]=w;break}}removeFromSchema(b,w){switch(delete e.allSettings.properties[b],w.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const w=`[${b}]`,u={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(w,u),e.allSettings.properties[w]=u,e.applicationSettings.properties[w]=u,e.machineSettings.properties[w]=u,e.machineOverridableSettings.properties[w]=u,e.windowSettings.properties[w]=u,e.resourceSettings.properties[w]=u}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,w){let u=this.defaultValues[b];S.isUndefined(u)&&(u=w.default),S.isUndefined(u)&&(u=l(w.type)),w.default=u}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function k(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=k;function l(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=l;const h=new D;C.Registry.add(e.Extensions.Configuration,h);function c(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?p.localize(5,null,I):h.getConfigurationProperties()[I]!==void 0?p.localize(6,null,I):null:p.localize(4,null)}e.validateProperty=c;function f(){const I=[],b=h.getConfigurationProperties();for(const w of Object.keys(b))I.push([w,b[w].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=f}),define(pe[116],ve([0,1,25,15,2,58,4,80]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=A.createDecorator("configurationService");function _(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof C.URI)}e.isConfigurationOverrides=_;var D;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(D=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function k(i,s){const n=s?i?s.keys.filter(T=>i.keys.indexOf(T)===-1):[...s.keys]:[],o=i?s?i.keys.filter(T=>s.keys.indexOf(T)===-1):[...i.keys]:[],v=[];if(s&&i){for(const T of i.keys)if(s.keys.indexOf(T)!==-1){const O=b(i.contents,T),$=b(s.contents,T);p.equals(O,$)||v.push(T)}}const m=[],E=T=>{const O={};for(const $ of T)for(const Z of $.identifiers)O[g(Z)]=$;return O},y=s?E(s.overrides):{},a=i?E(i.overrides):{};if(Object.keys(y).length)for(const T of n){const O=y[T];O&&m.push([P.overrideIdentifierFromKey(T),O.keys])}if(Object.keys(a).length)for(const T of o){const O=a[T];O&&m.push([P.overrideIdentifierFromKey(T),O.keys])}if(Object.keys(y).length&&Object.keys(a).length)for(const T of v){const O=a[T],$=y[T];if(O&&$){const Z=k({contents:O.contents,keys:O.keys,overrides:[]},{contents:$.contents,keys:$.keys,overrides:[]});m.push([P.overrideIdentifierFromKey(T),[...Z.added,...Z.removed,...Z.updated]])}}return{added:n,removed:o,updated:v,overrides:m}}e.compare=k;function l(i,s){const n=[];for(const o of Object.keys(i))if(P.OVERRIDE_PROPERTY_PATTERN.test(o)){const v={};for(const m in i[o])v[m]=i[o][m];n.push({identifiers:[P.overrideIdentifierFromKey(o).trim()],keys:Object.keys(v),contents:h(v,s)})}return n}e.toOverrides=l;function h(i,s){const n=Object.create(null);for(let o in i)c(n,o,i[o],s);return n}e.toValuesTree=h;function c(i,s,n,o){const v=s.split("."),m=v.pop();let E=i;for(let y=0;y<v.length;y++){let a=v[y],T=E[a];switch(typeof T){case"undefined":T=E[a]=Object.create(null);break;case"object":break;default:o(`Ignoring ${s} as ${v.slice(0,y+1).join(".")} is ${JSON.stringify(T)}`);return}E=T}if(typeof E=="object"&&E!==null)try{E[m]=n}catch(y){o(`Ignoring ${s} as ${v.join(".")} is ${JSON.stringify(E)}`)}else o(`Ignoring ${s} as ${v.join(".")} is ${JSON.stringify(E)}`)}e.addToValueTree=c;function f(i,s){const n=s.split(".");I(i,n)}e.removeFromValueTree=f;function I(i,s){const n=s.shift();if(s.length===0){delete i[n];return}if(Object.keys(i).indexOf(n)!==-1){const o=i[n];typeof o=="object"&&!Array.isArray(o)&&(I(o,s),Object.keys(o).length===0&&delete i[n])}}function b(i,s,n){function o(E,y){let a=E;for(const T of y){if(typeof a!="object"||a===null)return;a=a[T]}return a}const v=s.split("."),m=o(i,v);return typeof m=="undefined"?n:m}e.getConfigurationValue=b;function w(i,s,n){Object.keys(s).forEach(o=>{o!=="__proto__"&&(o in i?R.isObject(i[o])&&R.isObject(s[o])?w(i[o],s[o],n):n&&(i[o]=s[o]):i[o]=s[o])})}e.merge=w;function u(){const i=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=u;function d(){const i=Object.create(null),s=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties();for(let n in s){let o=s[n].default;c(i,n,o,v=>console.error(`Conflict in default settings: ${v}`))}return i}e.getDefaultValues=d;function g(i){return`[${i}]`}e.keyFromOverrideIdentifier=g;function t(i,s,n){const o=i.inspect(s),v=i.inspect(n);return typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:typeof v.userValue!="undefined"||typeof v.workspaceValue!="undefined"||typeof v.workspaceFolderValue!="undefined"?v.value:o.defaultValue}e.getMigratedSettingValue=t}),define(pe[186],ve([0,1,53,23,18,15,25,2,80,116,58,6,3]),function(X,e,p,R,C,S,A,P,_,D,r,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},i=[],s=[]){this._contents=t,this._keys=i,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?D.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,i){const s=this.getContentsForOverrideIdentifer(i);return s?t?D.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let s={};for(const n of C.distinct([...Object.keys(this.contents),...Object.keys(i)])){let o=this.contents[n],v=i[n];v&&(typeof o=="object"&&typeof v=="object"?(o=A.deepClone(o),this.mergeContents(o,v)):o=v),s[n]=o}return new h(s,this.keys,this.overrides)}merge(...t){const i=A.deepClone(this.contents),s=A.deepClone(this.overrides),n=[...this.keys];for(const o of t){this.mergeContents(i,o.contents);for(const v of o.overrides){const[m]=s.filter(E=>C.equals(E.identifiers,v.identifiers));m?this.mergeContents(m.contents,v.contents):s.push(A.deepClone(v))}for(const v of o.keys)n.indexOf(v)===-1&&n.push(v)}return new h(i,n,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const s of Object.keys(i)){if(s in t&&S.isObject(t[s])&&S.isObject(i[s])){this.mergeContents(t[s],i[s]);continue}t[s]=A.deepClone(i[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?A.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),D.addToValueTree(this.contents,t,i,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&D.removeFromValueTree(this.contents,t)}addKey(t){let i=this.keys.length;for(let s=0;s<i;s++)t.indexOf(this.keys[s])===0&&(i=s);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=h;class c extends h{constructor(){const t=D.getDefaultValues(),i=D.getConfigurationKeys(),s=[];for(const n of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(n)&&s.push({identifiers:[_.overrideIdentifierFromKey(n).trim()],keys:Object.keys(t[n]),contents:D.toValuesTree(t[n],o=>console.error(`Conflict in default settings file: ${o}`))});super(t,i,s)}}e.DefaultConfigurationModel=c;class f{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!S.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:s,keys:n,overrides:o,restricted:v}=this.doParseRaw(t,i);this._configurationModel=new h(s,n,o),this._restrictedConfigurations=v||[]}doParseContent(t){let i={},s=null,n=[],o=[],v=[];function m(y){Array.isArray(n)?n.push(y):s&&(n[s]=y)}let E={onObjectBegin:()=>{let y={};m(y),o.push(n),n=y,s=null},onObjectProperty:y=>{s=y},onObjectEnd:()=>{n=o.pop()},onArrayBegin:()=>{let y=[];m(y),o.push(n),n=y,s=null},onArrayEnd:()=>{n=o.pop()},onLiteralValue:m,onError:(y,a,T)=>{v.push({error:y,offset:a,length:T})}};if(t)try{p.visit(t,E),i=n[0]||{}}catch(y){console.error(`Error while parsing settings file ${this._name}: ${y}`),this._parseErrors=[y]}return i}doParseRaw(t,i){const s=r.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),n=this.filter(t,s,!0,i);t=n.raw;const o=D.toValuesTree(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`)),v=Object.keys(t),m=D.toOverrides(t,E=>console.error(`Conflict in settings file ${this._name}: ${E}`));return{contents:o,keys:v,overrides:m,restricted:n.restricted}}filter(t,i,s,n){if(!(n==null?void 0:n.scopes)&&!(n==null?void 0:n.skipRestricted))return{raw:t,restricted:[]};const o={},v=[];for(let m in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(m)&&s){const E=this.filter(t[m],i,!1,n);o[m]=E.raw,v.push(...E.restricted)}else{const E=i[m],y=E?typeof E.scope!="undefined"?E.scope:3:void 0;(E==null?void 0:E.restricted)&&v.push(m),(y===void 0||n.scopes===void 0||n.scopes.includes(y))&&(n.skipRestricted&&(E==null?void 0:E.restricted)||(o[m]=t[m]))}return{raw:o,restricted:v}}}e.ConfigurationModelParser=f;class I extends k.Disposable{constructor(t,i,s,n){super();this.userSettingsResource=t,this.scopes=i,this.fileService=n,this._onDidChange=this._register(new l.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(l.Event.filter(this.fileService.onDidFilesChange,o=>o.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class b{constructor(t,i,s=new h,n=new h,o=new R.ResourceMap,v=new h,m=new R.ResourceMap,E=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=s,this._workspaceConfiguration=n,this._folderConfigurations=o,this._memoryConfiguration=v,this._memoryConfigurationByResource=m,this._freeze=E,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(t,i,s){return this.getConsolidateConfigurationModel(i,s).getValue(t)}updateValue(t,i,s={}){let n;s.resource?(n=this._memoryConfigurationByResource.get(s.resource),n||(n=new h,this._memoryConfigurationByResource.set(s.resource,n))):n=this._memoryConfiguration,i===void 0?n.removeValue(t):n.setValue(t,i),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,s){const n=this.getConsolidateConfigurationModel(i,s),o=this.getFolderConfigurationModelForResource(i.resource,s),v=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,m=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),E=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),y=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),T=s?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,O=o?i.overrideIdentifier?o.freeze().override(i.overrideIdentifier).getValue(t):o.freeze().getValue(t):void 0,$=i.overrideIdentifier?v.override(i.overrideIdentifier).getValue(t):v.getValue(t),Z=n.getValue(t),le=C.distinct(C.flatten(n.overrides.map(q=>q.identifiers))).filter(q=>n.getOverrideValue(t,q)!==void 0);return{defaultValue:m,userValue:E,userLocalValue:y,userRemoteValue:a,workspaceValue:T,workspaceFolderValue:O,memoryValue:$,value:Z,default:m!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:E!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:y!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:O!==void 0?{value:o==null?void 0:o.freeze().getValue(t),override:i.overrideIdentifier?o==null?void 0:o.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:v.getValue(t),override:i.overrideIdentifier?v.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:le.length?le:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=i.filter(n=>_.OVERRIDE_PROPERTY_PATTERN.test(n)).map(n=>{const o=_.overrideIdentifierFromKey(n),v=this._defaultConfiguration.getKeysForOverrideIdentifier(o),m=t.getKeysForOverrideIdentifier(o),E=[...m.filter(y=>v.indexOf(y)===-1),...v.filter(y=>m.indexOf(y)===-1),...v.filter(y=>!A.equals(this._defaultConfiguration.override(o).getValue(y),t.override(o).getValue(y)))];return[o,E]});return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=D.compare(this.localUserConfiguration,t),v=[...i,...s,...n];return v.length&&this.updateLocalUserConfiguration(t),{keys:v,overrides:o}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=D.compare(this.remoteUserConfiguration,t);let v=[...i,...s,...n];return v.length&&this.updateRemoteUserConfiguration(t),{keys:v,overrides:o}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:n,overrides:o}=D.compare(this.workspaceConfiguration,t);let v=[...i,...s,...n];return v.length&&this.updateWorkspaceConfiguration(t),{keys:v,overrides:o}}compareAndUpdateFolderConfiguration(t,i){const s=this.folderConfigurations.get(t),{added:n,updated:o,removed:v,overrides:m}=D.compare(s,i);let E=[...n,...o,...v];return(E.length||!s)&&this.updateFolderConfiguration(t,i),{keys:E,overrides:m}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:n,removed:o,overrides:v}=D.compare(i,void 0);return{keys:[...s,...n,...o],overrides:v}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let s=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},i){let s=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const n=i.getFolder(t);n&&(s=this.getFolderConsolidatedConfiguration(n.uri)||s);const o=this._memoryConfigurationByResource.get(t);o&&(s=s.merge(o))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const s=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(t);n?(i=s.merge(n),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=s}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:s,overrides:n,keys:o}=this._folderConfigurations.get(i);return t.push([i,{contents:s,overrides:n,keys:o}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),n=this.parseConfigurationModel(t.workspace),o=t.folders.reduce((v,m)=>(v.set(P.URI.revive(m[0]),this.parseConfigurationModel(m[1])),v),new R.ResourceMap);return new b(i,s,new h,n,o,new h,new R.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function w(...g){if(g.length===0)return{keys:[],overrides:[]};if(g.length===1)return g[0];const t=new Set,i=new Map;for(const n of g)n.keys.forEach(o=>t.add(o)),n.overrides.forEach(([o,v])=>{const m=R.getOrSet(i,o,new Set);v.forEach(E=>m.add(E))});const s=[];return i.forEach((n,o)=>s.push([o,[...n.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=w;class u{constructor(t,i,s,n){this.change=t,this.previous=i,this.currentConfiguraiton=s,this.currentWorkspace=n,this._previousConfiguration=void 0;const o=new Set;t.keys.forEach(m=>o.add(m)),t.overrides.forEach(([,m])=>m.forEach(E=>o.add(E))),this.affectedKeys=[...o.values()];const v=new h;this.affectedKeys.forEach(m=>v.setValue(m,{})),this.affectedKeysTree=v.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,o=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!A.equals(n,o)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let s=D.toValuesTree({[i]:!0},()=>{}),n;for(;typeof s=="object"&&(n=Object.keys(s)[0]);){if(t=t[n],!t)return!1;s=s[n]}return!0}}e.ConfigurationChangeEvent=u;class d extends u{constructor(t,i,s,n){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=s,this.sourceConfig=n}}e.AllKeysConfigurationChangeEvent=d}),define(pe[117],ve([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=p.createDecorator("remoteAuthorityResolverService");var R;(function(S){S.Unknown="Unknown",S.NotAvailable="NotAvailable",S.TemporarilyNotAvailable="TemporarilyNotAvailable",S.NoResolverFound="NoResolverFound"})(R=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class C extends Error{constructor(A,P=R.Unknown,_){super(A);this._message=A,this._code=P,this._detail=_,this.isHandled=P===R.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype)}static isTemporarilyNotAvailable(A){return A instanceof C&&A._code===R.TemporarilyNotAvailable}static isNoResolverFound(A){return A instanceof C&&A._code===R.NoResolverFound}static isHandled(A){return A instanceof C&&A.isHandled}}e.RemoteAuthorityResolverError=C}),define(pe[81],ve([0,1,10]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function R(D){return D.scheme===p.Schemas.vscodeRemote?D.authority:void 0}e.getRemoteAuthority=R;function C(D){if(!D)return;const r=D.indexOf("+");return r<0?D:D.substr(0,r)}e.getRemoteName=C;function S(D){return D.scheme!==p.Schemas.file&&D.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=S;function A(D){if(D.folders.length)return D.folders.every(r=>S(r.uri))?D.folders[0].uri:void 0;if(D.configuration&&S(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=A;function P(D){var r;return(r=A(D))===null||r===void 0?void 0:r.scheme}e.getVirtualWorkspaceScheme=P;function _(D){return A(D)!==void 0}e.isVirtualWorkspace=_}),define(pe[187],ve([0,1,3,11,4,12]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.ITunnelService=void 0,e.ITunnelService=C.createDecorator("tunnelService");var A;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore"})(A=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function _(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=_,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function D(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=D;function r(l,h){return h?h!==1&&l<1024:!R.isWindows&&l<1024}e.isPortPrivileged=r;let k=class{constructor(h){this.logService=h,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._canMakePublic=!1}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h,c){return this._tunnelProvider=h,h?(this._canElevate=c.elevation,this._canMakePublic=c.public,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._canMakePublic=!1}}):(this._canElevate=!1,this._canMakePublic=!1,this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canMakePublic(){return this._canMakePublic}get tunnels(){return new Promise(async h=>{const c=[],f=Array.from(this._tunnels.values());for(let I of f){const b=Array.from(I.values());for(let w of b){const u=await w.value;u&&c.push(u)}}h(c)})}async dispose(){for(const h of this._tunnels.values()){for(const{value:c}of h.values())await c.then(f=>f==null?void 0:f.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,c,f,I,b=!1,w=!1){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${f} on local port ${I}.`),!h)return;c||(c="localhost");const u=this.retainOrCreateTunnel(h,c,f,I,b,w);return u?u.then(d=>{if(!d){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(c,f);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const g=this.makeTunnel(d);return(d.tunnelRemoteHost!==c||d.tunnelRemotePort!==f)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(g),g}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,public:h.public,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const c=this._tunnels.get(h.tunnelRemoteHost);if(c){const f=c.get(h.tunnelRemotePort);f&&(f.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,f))}}}}async tryDisposeTunnel(h,c,f){if(f.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${c}.`);const I=f.value.then(async b=>{b&&(await b.dispose(!0),this._onTunnelClosed.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(c),I}}async closeTunnel(h,c){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${c} `);const f=this._tunnels.get(h);if(f&&f.has(c)){const I=f.get(c);I.refcount=0,await this.tryDisposeTunnel(h,c,I)}}addTunnelToMap(h,c,f){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(c,{refcount:1,value:f})}async removeEmptyTunnelFromMap(h,c){const f=this._tunnels.get(h);f&&(await f.get(c)||f.delete(c),f.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,c){let f=[h];_(h)?(f.push(...e.LOCALHOST_ADDRESSES),f.push(...e.ALL_INTERFACES_ADDRESSES)):D(h)&&f.push(...e.ALL_INTERFACES_ADDRESSES);const I=f.map(b=>this._tunnels.get(b));for(const b of I){const w=b==null?void 0:b.get(c);if(w)return w}}canTunnel(h){return!!P(h)}createWithProvider(h,c,f,I,b,w){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${f} on local port ${I}.`);const d={elevationRequired:b?r(I===void 0?f:I):!1},g={remoteAddress:{host:c,port:f},localAddressPort:I,public:w},t=h.forwardPort(g,d);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),t&&this.addTunnelToMap(c,f,t),t}};k=qe([We(0,S.ILogService)],k),e.AbstractTunnelService=k}),define(pe[188],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((C,S)=>X(["vsda"],C,S))}async sign(C){try{const S=await this.vsda(),A=new S.signer;if(A)return A.sign(C)}catch(S){}return C}}e.SignService=p}),define(pe[189],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class p{constructor(C){this._callback=C,this._terminalBufferMap=new Map}dispose(){for(const C of this._terminalBufferMap.values())C.dispose()}startBuffering(C,S,A=5){let P;return P=S(_=>{const D=typeof _=="string"?_:_.data;let r=this._terminalBufferMap.get(C);if(r){r.data.push(D);return}const k=setTimeout(()=>this.flushBuffer(C),A);r={data:[D],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(C),P.dispose()}},this._terminalBufferMap.set(C,r)}),P}stopBuffering(C){const S=this._terminalBufferMap.get(C);S&&S.dispose()}flushBuffer(C){const S=this._terminalBufferMap.get(C);S&&(this._terminalBufferMap.delete(C),this._callback(C,S.data.join("")))}}e.TerminalDataBufferer=p}),define(pe[45],ve([0,1,2,24,4,23]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=C.createDecorator("contextService");var A;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(A=e.WorkbenchState||(e.WorkbenchState={}));function P(l){const h=l;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=P;function _(l){const h=l;return!!(h&&typeof h=="object"&&p.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=_;class D{constructor(h,c,f,I){this._id=h,this._configuration=f,this._ignorePathCasing=I,this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=S.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=D;class r{constructor(h,c){this.raw=c,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return R.joinPath(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function k(l){return new r({uri:l,index:0,name:R.basenameOrAuthority(l)},{uri:l.toString()})}e.toWorkspaceFolder=k}),define(pe[190],ve([0,1,4,157,45,2,11,9,24,133,53,10,75,29,81]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const f=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:R.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function I(x){return(typeof x=="string"?P.extname(x):_.extname(x))===f}e.hasWorkspaceFileExtension=I,e.IWorkspacesService=p.createDecorator("workspacesService");function b(x){return x.hasOwnProperty("workspace")}e.isRecentWorkspace=b;function w(x){return x.hasOwnProperty("folderUri")}e.isRecentFolder=w;function u(x){return x.hasOwnProperty("fileUri")}e.isRecentFile=u;function d(x){const H=x;return typeof(H==null?void 0:H.id)=="string"&&S.URI.isUri(H.uri)}e.isSingleFolderWorkspaceIdentifier=d;function g(x){if(x.configuration)return{id:x.id,configPath:x.configuration};if(x.folders.length===1)return{id:x.id,uri:x.folders[0].uri}}e.toWorkspaceIdentifier=g;function t(x){const H=x;return typeof(H==null?void 0:H.id)=="string"&&S.URI.isUri(H.configPath)}e.isWorkspaceIdentifier=t;function i(x){const H=x;if(H==null?void 0:H.uri)return{id:H.id,uri:S.URI.revive(H.uri)};const N=x;if(N==null?void 0:N.configPath)return{id:N.id,configPath:S.URI.revive(N.configPath)};if(x==null?void 0:x.id)return{id:x.id}}e.reviveIdentifier=i;function s(x,H){return _.extUriBiasedIgnorePathCase.isEqualOrParent(x,H.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function n(x){return o(x)||v(x)}e.isStoredWorkspaceFolder=n;function o(x){const H=x;return typeof(H==null?void 0:H.path)=="string"&&(!H.name||typeof H.name=="string")}e.isRawFileWorkspaceFolder=o;function v(x){const H=x;return typeof(H==null?void 0:H.uri)=="string"&&(!H.name||typeof H.name=="string")}e.isRawUriWorkspaceFolder=v;function m(x,H,N,z,F=!A.isWindows,M){if(x.scheme!==z.scheme)return{name:N,uri:x.toString(!0)};let L=H?void 0:M.relativePath(z,x);if(L!==void 0)L.length===0?L=".":A.isWindows&&x.scheme===k.Schemas.file&&!F&&(L=L.replace(/\//g,"\\"));else if(x.scheme===k.Schemas.file)L=x.fsPath,A.isWindows&&(L=l.normalizeDriveLetter(L),F&&(L=h.toSlashes(L)));else{if(!M.isEqualAuthority(x.authority,z.authority))return{name:N,uri:x.toString(!0)};L=x.path}return{name:N,path:L}}e.getStoredWorkspaceFolder=m;function E(x,H,N){let z=[],F=new Set;const M=N.dirname(H);for(let L of x){let U;if(o(L))L.path&&(U=N.resolvePath(M,L.path));else if(v(L))try{U=S.URI.parse(L.uri),U.path[0]!=="/"&&(U=U.with({path:"/"+U.path}))}catch(G){console.warn(G)}if(U){let G=N.getComparisonKey(U);if(!F.has(G)){F.add(G);const te=L.name||N.basenameOrAuthority(U);z.push(new C.WorkspaceFolder({uri:U,name:te,index:z.length},L))}}}return z}e.toWorkspaceFolders=E;function y(x,H,N,z,F){let M=a(H,x);const L=F.dirname(H),U=F.dirname(z),G=[],te=T(M.folders);for(const Le of M.folders){const je=o(Le)?F.resolvePath(L,Le.path):S.URI.parse(Le.uri);let ze;N?ze=!1:ze=!o(Le)||P.isAbsolute(Le.path),G.push(m(je,ze,Le.name,U,te,F))}const me={insertSpaces:!1,tabSize:4,eol:A.isLinux||A.isMacintosh?`
`:`\r
`},Se=D.setProperty(x,["folders"],G,me);let ye=D.applyEdits(x,Se);return M.remoteAuthority===c.getRemoteAuthority(z)&&(ye=D.applyEdits(ye,D.removeProperty(ye,["remoteAuthority"],me))),ye}e.rewriteWorkspaceFileForNewLocation=y;function a(x,H){let N=r.parse(H);if(N&&Array.isArray(N.folders))N.folders=N.folders.filter(z=>n(z));else throw new Error(`${x} looks like an invalid workspace file.`);return N}function T(x){return A.isWindows?x.some(H=>o(H)&&H.path.indexOf("/")>=0):!0}e.useSlashForPath=T;function O(x){return x.workspace&&typeof x.workspace=="object"&&typeof x.workspace.id=="string"&&typeof x.workspace.configPath=="string"}function $(x){return typeof x.folderUri=="string"}function Z(x){return typeof x.fileUri=="string"}function le(x,H){const N={workspaces:[],files:[]};if(x){const z=function(M,L){for(let U=0;U<M.length;U++)try{L(M[U],U)}catch(G){H.warn(`Error restoring recent entry ${JSON.stringify(M[U])}: ${G.toString()}. Skip entry.`)}},F=x;if(Array.isArray(F.entries))z(F.entries,M=>{const L=M.label,U=M.remoteAuthority;O(M)?N.workspaces.push({label:L,remoteAuthority:U,workspace:{id:M.workspace.id,configPath:S.URI.parse(M.workspace.configPath)}}):$(M)?N.workspaces.push({label:L,remoteAuthority:U,folderUri:S.URI.parse(M.folderUri)}):Z(M)&&N.files.push({label:L,remoteAuthority:U,fileUri:S.URI.parse(M.fileUri)})});else{const M=x;Array.isArray(M.workspaces3)&&z(M.workspaces3,(L,U)=>{const G=Array.isArray(M.workspaceLabels)&&M.workspaceLabels[U]||void 0;typeof L=="object"&&typeof L.id=="string"&&typeof L.configURIPath=="string"?N.workspaces.push({label:G,workspace:{id:L.id,configPath:S.URI.parse(L.configURIPath)}}):typeof L=="string"&&N.workspaces.push({label:G,folderUri:S.URI.parse(L)})}),Array.isArray(M.files2)&&z(M.files2,(L,U)=>{const G=Array.isArray(M.fileLabels)&&M.fileLabels[U]||void 0;typeof L=="string"&&N.files.push({label:G,fileUri:S.URI.parse(L)})})}}return N}e.restoreRecentlyOpened=le;function q(x){const H={entries:[]};for(const N of x.workspaces)w(N)?H.entries.push({folderUri:N.folderUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority}):H.entries.push({workspace:{id:N.workspace.id,configPath:N.workspace.configPath.toString()},label:N.label,remoteAuthority:N.remoteAuthority});for(const N of x.files)H.entries.push({fileUri:N.fileUri.toString(),label:N.label,remoteAuthority:N.remoteAuthority});return H}e.toStoreData=q}),define(pe[82],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class p{constructor(C){this.id=C,this._data=new Map,this._idPool=1}add(C){const S=this._idPool++;return this._data.set(S,C),this.logDebugInfo(),S}get(C,S){return this._data.has(C)?this._data.get(C)[S]:void 0}delete(C){this._data.delete(C),this.logDebugInfo()}logDebugInfo(){!p.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=p,p.enableDebugLogging=!1}),define(pe[46],ve([0,1,2,3,4]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=C.createDecorator("IExtHostEditorTabs");class S{constructor(){this._onDidChangeTabs=new R.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(P){this._tabs=P.map(_=>({name:_.name,group:_.group,resource:p.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=S}),define(pe[59],ve([0,1,10,4]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class C{constructor(){this._systemSchemes=new Set(Object.keys(p.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(A,P){P===null?this._providerInfo.delete(A):this._providerInfo.set(A,P)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=C,e.IExtHostFileSystemInfo=R.createDecorator("IExtHostFileSystemInfo")}),define(pe[27],ve([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=p.createDecorator("IExtHostInitDataService")}),define(pe[191],ve([0,1,16]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,P,_){this._deferredPromises=new Map,this._id=A,this._shared=P,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(D=>(this._value=D,this)),this._storageListener=this._storage.onDidChangeStorage(D=>{D.shared===this._shared&&D.key===this._id&&(this._value=D.value)}),this._scheduler=new p.RunOnceScheduler(()=>{const D=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const r of D.values())r.complete()}catch(r){for(const k of D.values())k.error(r)}})()},0)}get keys(){var A;return Object.entries((A=this._value)!==null&&A!==void 0?A:{}).filter(([,P])=>P!==void 0).map(([P])=>P)}get whenReady(){return this._init}get(A,P){let _=this._value[A];return typeof _=="undefined"&&(_=P),_}update(A,P){this._value[A]=P;let _=this._deferredPromises.get(A);if(_!==void 0)return _.p;const D=new p.DeferredPromise;return this._deferredPromises.set(A,D),this._scheduler.isScheduled()||this._scheduler.schedule(),D.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=R;class C extends R{constructor(A,P){super(A.identifier.value,!0,P);this._extension=A}setKeysForSync(A){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},A)}}e.ExtensionGlobalMemento=C}),define(pe[192],ve([0,1,3,2,12]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let S=class{constructor(P,_){this._logService=P,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new p.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new p.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(P,_,D){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P)).acceptModelChanged(_,D)}$acceptDirtyStateChanged(P,_){this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P)).acceptDirty(_)}$acceptModelSaved(P){const _=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(P,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",P.path,_);const D=this._notebooksAndEditors.getNotebookDocument(R.URI.revive(P));D.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:D.apiNotebook})}};S=qe([We(0,C.ILogService)],S),e.ExtHostNotebookDocuments=S}),define(pe[13],ve([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=p.createDecorator("IExtHostRpcService");class R{constructor(S){this.getProxy=S.getProxy.bind(S),this.set=S.set.bind(S),this.assertRegistered=S.assertRegistered.bind(S),this.drain=S.drain.bind(S)}}e.ExtHostRpcService=R});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(pe[193],ve([0,1,26,3]),function(X,e,p,R){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class S{constructor(P,_){C.set(this,void 0),this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._id=p.ExtensionIdentifier.toKey(P.identifier),it(this,C,_,"f"),$e(this,C,"f").onDidChangePassword(D=>{D.extensionId===this._id&&this._onDidChange.fire({key:D.key})})}get(P){return $e(this,C,"f").get(this._id,P)}store(P,_){return $e(this,C,"f").store(this._id,P,_)}delete(P){return $e(this,C,"f").delete(this._id,P)}}e.ExtensionSecrets=S,C=new WeakMap}),define(pe[118],ve([0,1,4,3]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class C{constructor(){this._onDidChangeTelemetryEnabled=new R.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(A){this._enabled=A}$onDidChangeTelemetryEnabled(A){this._enabled=A,this._onDidChangeTelemetryEnabled.fire(A)}}e.ExtHostTelemetry=C,e.IExtHostTelemetry=p.createDecorator("IExtHostTelemetry")}),define(pe[83],ve([0,1,3]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var R;(function(A){A[A.NewChild=0]="NewChild",A[A.Disposed=1]="Disposed",A[A.Invalidated=2]="Invalidated",A[A.SetProp=3]="SetProp"})(R=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const C=new WeakMap,S=A=>{let P=C.get(A);return P||(P={children:new Map,bus:new p.Emitter},C.set(A,P)),P};e.getPrivateApiFor=S}),define(pe[47],ve([0,1,4,3,13]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var S;(function(P){function _(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public}}P.fromApiTunnel=_;function D(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.public}}P.fromServiceTunnel=D})(S=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=p.createDecorator("IExtHostTunnelService");let A=class{constructor(_){this.onDidChangeTunnels=new R.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,D){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,D){return{dispose:()=>{}}}async $providePortAttributes(_,D,r,k,l){return[]}async $forwardPort(_,D){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([We(0,C.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(pe[7],ve([0,1,18,14,95,23,98,15,2,32,42,117,83]),function(X,e,p,R,C,S,A,P,_,D,r,k,l){"use strict";var h,c,f,I,b,w,u,d,g,t,i,s,n,o,v,m,E,y;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(V){function B(){return Reflect.construct(V,arguments,this.constructor)}return Object.defineProperty(B,"name",Object.getOwnPropertyDescriptor(V,"name")),Object.setPrototypeOf(B,V),Object.setPrototypeOf(B.prototype,V.prototype),B}let T=b=class{constructor(B){h.set(this,void 0),it(this,h,B,"f")}static from(...B){let oe=B;return new b(function(){if(oe){for(const ke of oe)ke&&typeof ke.dispose=="function"&&ke.dispose();oe=void 0}})}dispose(){typeof $e(this,h,"f")=="function"&&($e(this,h,"f").call(this),it(this,h,void 0,"f"))}};h=new WeakMap,T=b=qe([a],T),e.Disposable=T;let O=w=class{constructor(B,oe){if(B<0)throw R.illegalArgument("line must be non-negative");if(oe<0)throw R.illegalArgument("character must be non-negative");this._line=B,this._character=oe}static Min(...B){if(B.length===0)throw new TypeError;let oe=B[0];for(let ke=1;ke<B.length;ke++){const Ke=B[ke];Ke.isBefore(oe)&&(oe=Ke)}return oe}static Max(...B){if(B.length===0)throw new TypeError;let oe=B[0];for(let ke=1;ke<B.length;ke++){const Ke=B[ke];Ke.isAfter(oe)&&(oe=Ke)}return oe}static isPosition(B){if(!B)return!1;if(B instanceof w)return!0;let{line:oe,character:ke}=B;return typeof oe=="number"&&typeof ke=="number"}get line(){return this._line}get character(){return this._character}isBefore(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<B._character}isBeforeOrEqual(B){return this._line<B._line?!0:B._line<this._line?!1:this._character<=B._character}isAfter(B){return!this.isBeforeOrEqual(B)}isAfterOrEqual(B){return!this.isBefore(B)}isEqual(B){return this._line===B._line&&this._character===B._character}compareTo(B){return this._line<B._line?-1:this._line>B.line?1:this._character<B._character?-1:this._character>B._character?1:0}translate(B,oe=0){if(B===null||oe===null)throw R.illegalArgument();let ke;return typeof B=="undefined"?ke=0:typeof B=="number"?ke=B:(ke=typeof B.lineDelta=="number"?B.lineDelta:0,oe=typeof B.characterDelta=="number"?B.characterDelta:0),ke===0&&oe===0?this:new w(this.line+ke,this.character+oe)}with(B,oe=this.character){if(B===null||oe===null)throw R.illegalArgument();let ke;return typeof B=="undefined"?ke=this.line:typeof B=="number"?ke=B:(ke=typeof B.line=="number"?B.line:this.line,oe=typeof B.character=="number"?B.character:this.character),ke===this.line&&oe===this.character?this:new w(ke,oe)}toJSON(){return{line:this.line,character:this.character}}};O=w=qe([a],O),e.Position=O;let $=u=class{constructor(B,oe,ke,Ke){let et,at;if(typeof B=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"?(et=new O(B,oe),at=new O(ke,Ke)):B instanceof O&&oe instanceof O&&(et=B,at=oe),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this._start=et,this._end=at):(this._start=at,this._end=et)}static isRange(B){return B instanceof u?!0:B?O.isPosition(B.start)&&O.isPosition(B.end):!1}get start(){return this._start}get end(){return this._end}contains(B){return B instanceof u?this.contains(B._start)&&this.contains(B._end):B instanceof O?!(B.isBefore(this._start)||this._end.isBefore(B)):!1}isEqual(B){return this._start.isEqual(B._start)&&this._end.isEqual(B._end)}intersection(B){const oe=O.Max(B.start,this._start),ke=O.Min(B.end,this._end);if(!oe.isAfter(ke))return new u(oe,ke)}union(B){if(this.contains(B))return this;if(B.contains(this))return B;const oe=O.Min(B.start,this._start),ke=O.Max(B.end,this.end);return new u(oe,ke)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(B,oe=this.end){if(B===null||oe===null)throw R.illegalArgument();let ke;return B?O.isPosition(B)?ke=B:(ke=B.start||this.start,oe=B.end||this.end):ke=this.start,ke.isEqual(this._start)&&oe.isEqual(this.end)?this:new u(ke,oe)}toJSON(){return[this.start,this.end]}};$=u=qe([a],$),e.Range=$;let Z=d=class extends ${constructor(B,oe,ke,Ke){let et,at;if(typeof B=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"?(et=new O(B,oe),at=new O(ke,Ke)):B instanceof O&&oe instanceof O&&(et=B,at=oe),!et||!at)throw new Error("Invalid arguments");super(et,at);this._anchor=et,this._active=at}static isSelection(B){return B instanceof d?!0:B?$.isRange(B)&&O.isPosition(B.anchor)&&O.isPosition(B.active)&&typeof B.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Z=d=qe([a],Z),e.Selection=Z;class le{constructor(B,oe,ke){if(typeof B!="string"||B.length===0)throw R.illegalArgument("host");if(typeof oe!="number"||oe===0||Math.round(oe)!==oe)throw R.illegalArgument("port");if(typeof ke!="undefined"&&(typeof ke!="string"||ke.length===0||!/^[0-9A-Za-z\-]+$/.test(ke)))throw R.illegalArgument("connectionToken");this.host=B,this.port=Math.round(oe),this.connectionToken=ke}}e.ResolvedAuthority=le;class q extends Error{constructor(B,oe=k.RemoteAuthorityResolverErrorCode.Unknown,ke){super(B);this._message=B,this._code=oe,this._detail=ke,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,q.prototype)}static NotAvailable(B,oe){return new q(B,k.RemoteAuthorityResolverErrorCode.NotAvailable,oe)}static TemporarilyNotAvailable(B){return new q(B,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=q;var x;(function(V){V[V.LF=1]="LF",V[V.CRLF=2]="CRLF"})(x=e.EndOfLine||(e.EndOfLine={}));var H;(function(V){V[V.Replace=1]="Replace",V[V.Append=2]="Append",V[V.Prepend=3]="Prepend"})(H=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let N=g=class{constructor(B,oe){this._range=B,this._newText=oe}static isTextEdit(B){return B instanceof g?!0:B?$.isRange(B)&&typeof B.newText=="string":!1}static replace(B,oe){return new g(B,oe)}static insert(B,oe){return g.replace(new $(B,B),oe)}static delete(B){return g.replace(B,"")}static setEndOfLine(B){const oe=new g(new $(new O(0,0),new O(0,0)),"");return oe.newEol=B,oe}get range(){return this._range}set range(B){if(B&&!$.isRange(B))throw R.illegalArgument("range");this._range=B}get newText(){return this._newText||""}set newText(B){if(B&&typeof B!="string")throw R.illegalArgument("newText");this._newText=B}get newEol(){return this._newEol}set newEol(B){if(B&&typeof B!="number")throw R.illegalArgument("newEol");this._newEol=B}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};N=g=qe([a],N),e.TextEdit=N;var z;(function(V){V[V.File=1]="File",V[V.Text=2]="Text",V[V.Cell=3]="Cell",V[V.CellReplace=5]="CellReplace"})(z=e.FileEditType||(e.FileEditType={}));let F=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(B,oe,ke,Ke){this._edits.push({_type:1,from:B,to:oe,options:ke,metadata:Ke})}createFile(B,oe,ke){this._edits.push({_type:1,from:void 0,to:B,options:oe,metadata:ke})}deleteFile(B,oe,ke){this._edits.push({_type:1,from:B,to:void 0,options:oe,metadata:ke})}replaceNotebookMetadata(B,oe,ke){this._edits.push({_type:3,metadata:ke,uri:B,edit:{editType:5,metadata:oe},notebookMetadata:oe})}replaceNotebookCells(B,oe,ke,Ke,et){let at,lt,Dt=[],kt;if(Ht.isNotebookRange(oe)&&Ot.isNotebookCellDataArray(ke)&&!Ot.isNotebookCellDataArray(Ke)?(at=oe.start,lt=oe.end,Dt=ke,kt=Ke):typeof oe=="number"&&typeof ke=="number"&&Ot.isNotebookCellDataArray(Ke)&&(at=oe,lt=ke,Dt=Ke,kt=et),at===void 0||lt===void 0)throw new Error("Invalid arguments");(at!==lt||Dt.length>0)&&this._edits.push({_type:5,uri:B,index:at,count:lt-at,cells:Dt,metadata:kt})}replaceNotebookCellMetadata(B,oe,ke,Ke){this._edits.push({_type:3,metadata:Ke,uri:B,edit:{editType:8,index:oe,metadata:ke}})}replace(B,oe,ke,Ke){this._edits.push({_type:2,uri:B,edit:new N(oe,ke),metadata:Ke})}insert(B,oe,ke,Ke){this.replace(B,new $(oe,oe),ke,Ke)}delete(B,oe,ke){this.replace(B,oe,"",ke)}has(B){return this._edits.some(oe=>oe._type===2&&oe.uri.toString()===B.toString())}set(B,oe){if(oe)for(const ke of oe)ke&&this._edits.push({_type:2,uri:B,edit:ke});else{for(let ke=0;ke<this._edits.length;ke++){const Ke=this._edits[ke];Ke._type===2&&Ke.uri.toString()===B.toString()&&(this._edits[ke]=void 0)}p.coalesceInPlace(this._edits)}}get(B){const oe=[];for(let ke of this._edits)ke._type===2&&ke.uri.toString()===B.toString()&&oe.push(ke.edit);return oe}entries(){const B=new S.ResourceMap;for(let oe of this._edits)if(oe._type===2){let ke=B.get(oe.uri);ke||(ke=[oe.uri,[]],B.set(oe.uri,ke)),ke[1].push(oe.edit)}return[...B.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};F=qe([a],F),e.WorkspaceEdit=F;let M=t=class{constructor(B){this._tabstop=1,this.value=B||""}static isSnippetString(B){return B instanceof t?!0:B?typeof B.value=="string":!1}static _escape(B){return B.replace(/\$|}|\\/g,"\\$&")}appendText(B){return this.value+=t._escape(B),this}appendTabstop(B=this._tabstop++){return this.value+="$",this.value+=B,this}appendPlaceholder(B,oe=this._tabstop++){if(typeof B=="function"){const ke=new t;ke._tabstop=this._tabstop,B(ke),this._tabstop=ke._tabstop,B=ke.value}else B=t._escape(B);return this.value+="${",this.value+=oe,this.value+=":",this.value+=B,this.value+="}",this}appendChoice(B,oe=this._tabstop++){const ke=B.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=oe,this.value+="|",this.value+=ke,this.value+="|}",this}appendVariable(B,oe){if(typeof oe=="function"){const ke=new t;ke._tabstop=this._tabstop,oe(ke),this._tabstop=ke._tabstop,oe=ke.value}else typeof oe=="string"&&(oe=oe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=B,oe&&(this.value+=":",this.value+=oe),this.value+="}",this}};M=t=qe([a],M),e.SnippetString=M;var L;(function(V){V[V.Unnecessary=1]="Unnecessary",V[V.Deprecated=2]="Deprecated"})(L=e.DiagnosticTag||(e.DiagnosticTag={}));var U;(function(V){V[V.Hint=3]="Hint",V[V.Information=2]="Information",V[V.Warning=1]="Warning",V[V.Error=0]="Error"})(U=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let G=i=class{constructor(B,oe){if(this.uri=B,oe)if(oe instanceof $)this.range=oe;else if(oe instanceof O)this.range=new $(oe,oe);else throw new Error("Illegal argument")}static isLocation(B){return B instanceof i?!0:B?$.isRange(B.range)&&_.URI.isUri(B.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};G=i=qe([a],G),e.Location=G;let te=class{constructor(B,oe){this.location=B,this.message=oe}static is(B){return B?typeof B.message=="string"&&B.location&&$.isRange(B.location.range)&&_.URI.isUri(B.location.uri):!1}static isEqual(B,oe){return B===oe?!0:!B||!oe?!1:B.message===oe.message&&B.location.range.isEqual(oe.location.range)&&B.location.uri.toString()===oe.location.uri.toString()}};te=qe([a],te),e.DiagnosticRelatedInformation=te;let me=class{constructor(B,oe,ke=U.Error){if(!$.isRange(B))throw new TypeError("range must be set");if(!oe)throw new TypeError("message must be set");this.range=B,this.message=oe,this.severity=ke}toJSON(){return{severity:U[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(B,oe){return B===oe?!0:!B||!oe?!1:B.message===oe.message&&B.severity===oe.severity&&B.code===oe.code&&B.severity===oe.severity&&B.source===oe.source&&B.range.isEqual(oe.range)&&p.equals(B.tags,oe.tags)&&p.equals(B.relatedInformation,oe.relatedInformation,te.isEqual)}};me=qe([a],me),e.Diagnostic=me;let Se=class{constructor(B,oe){if(!B)throw new Error("Illegal argument, contents must be defined");Array.isArray(B)?this.contents=B:C.isMarkdownString(B)?this.contents=[B]:this.contents=[B],this.range=oe}};Se=qe([a],Se),e.Hover=Se;var ye;(function(V){V[V.Text=0]="Text",V[V.Read=1]="Read",V[V.Write=2]="Write"})(ye=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Le=class{constructor(B,oe=ye.Text){this.range=B,this.kind=oe}toJSON(){return{range:this.range,kind:ye[this.kind]}}};Le=qe([a],Le),e.DocumentHighlight=Le;var je;(function(V){V[V.File=0]="File",V[V.Module=1]="Module",V[V.Namespace=2]="Namespace",V[V.Package=3]="Package",V[V.Class=4]="Class",V[V.Method=5]="Method",V[V.Property=6]="Property",V[V.Field=7]="Field",V[V.Constructor=8]="Constructor",V[V.Enum=9]="Enum",V[V.Interface=10]="Interface",V[V.Function=11]="Function",V[V.Variable=12]="Variable",V[V.Constant=13]="Constant",V[V.String=14]="String",V[V.Number=15]="Number",V[V.Boolean=16]="Boolean",V[V.Array=17]="Array",V[V.Object=18]="Object",V[V.Key=19]="Key",V[V.Null=20]="Null",V[V.EnumMember=21]="EnumMember",V[V.Struct=22]="Struct",V[V.Event=23]="Event",V[V.Operator=24]="Operator",V[V.TypeParameter=25]="TypeParameter"})(je=e.SymbolKind||(e.SymbolKind={}));var ze;(function(V){V[V.Deprecated=1]="Deprecated"})(ze=e.SymbolTag||(e.SymbolTag={}));let Ge=s=class{constructor(B,oe,ke,Ke,et){this.name=B,this.kind=oe,this.containerName=et,typeof ke=="string"&&(this.containerName=ke),Ke instanceof G?this.location=Ke:ke instanceof $&&(this.location=new G(Ke,ke)),s.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:je[this.kind],location:this.location,containerName:this.containerName}}};Ge=s=qe([a],Ge),e.SymbolInformation=Ge;let j=n=class{constructor(B,oe,ke,Ke,et){this.name=B,this.detail=oe,this.kind=ke,this.range=Ke,this.selectionRange=et,this.children=[],n.validate(this)}static validate(B){if(!B.name)throw new Error("name must not be falsy");if(!B.range.contains(B.selectionRange))throw new Error("selectionRange must be contained in fullRange");B.children&&B.children.forEach(n.validate)}};j=n=qe([a],j),e.DocumentSymbol=j;var Y;(function(V){V[V.Invoke=1]="Invoke",V[V.Automatic=2]="Automatic"})(Y=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ie=class{constructor(B,oe){this.title=B,this.kind=oe}};ie=qe([a],ie),e.CodeAction=ie;let re=o=class{constructor(B){this.value=B}append(B){return new o(this.value?this.value+o.sep+B:B)}intersects(B){return this.contains(B)||B.contains(this)}contains(B){return this.value===B.value||B.value.startsWith(this.value+o.sep)}};re.sep=".",re=o=qe([a],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let J=class{constructor(B,oe){if(this.range=B,this.parent=oe,oe&&!oe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};J=qe([a],J),e.SelectionRange=J;class ce{constructor(B,oe,ke,Ke,et,at){this.kind=B,this.name=oe,this.detail=ke,this.uri=Ke,this.range=et,this.selectionRange=at}}e.CallHierarchyItem=ce;class ge{constructor(B,oe){this.fromRanges=oe,this.from=B}}e.CallHierarchyIncomingCall=ge;class Re{constructor(B,oe){this.fromRanges=oe,this.to=B}}e.CallHierarchyOutgoingCall=Re;let He=class{constructor(B,oe){this.range=B,this.command=oe}get isResolved(){return!!this.command}};He=qe([a],He),e.CodeLens=He;let be=v=class{constructor(B,oe=!1){c.set(this,void 0),it(this,c,new C.MarkdownString(B,{supportThemeIcons:oe}),"f")}static isMarkdownString(B){return B instanceof v?!0:B&&B.appendCodeblock&&B.appendMarkdown&&B.appendText&&B.value!==void 0}get value(){return $e(this,c,"f").value}set value(B){$e(this,c,"f").value=B}get isTrusted(){return $e(this,c,"f").isTrusted}set isTrusted(B){$e(this,c,"f").isTrusted=B}get supportThemeIcons(){return $e(this,c,"f").supportThemeIcons}appendText(B){return $e(this,c,"f").appendText(B),this}appendMarkdown(B){return $e(this,c,"f").appendMarkdown(B),this}appendCodeblock(B,oe){return $e(this,c,"f").appendCodeblock(oe??"",B),this}};c=new WeakMap,be=v=qe([a],be),e.MarkdownString=be;let Qe=class{constructor(B,oe){this.label=B,this.documentation=oe}};Qe=qe([a],Qe),e.ParameterInformation=Qe;let Q=class{constructor(B,oe){this.label=B,this.documentation=oe,this.parameters=[]}};Q=qe([a],Q),e.SignatureInformation=Q;let se=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};se=qe([a],se),e.SignatureHelp=se;var we;(function(V){V[V.Invoke=1]="Invoke",V[V.TriggerCharacter=2]="TriggerCharacter",V[V.ContentChange=3]="ContentChange"})(we=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Oe;(function(V){V[V.Other=0]="Other",V[V.Type=1]="Type",V[V.Parameter=2]="Parameter"})(Oe=e.InlayHintKind||(e.InlayHintKind={}));let Ue=class{constructor(B,oe,ke){this.text=B,this.position=oe,this.kind=ke}};Ue=qe([a],Ue),e.InlayHint=Ue;var Ye;(function(V){V[V.Invoke=0]="Invoke",V[V.TriggerCharacter=1]="TriggerCharacter",V[V.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var De;(function(V){V[V.Text=0]="Text",V[V.Method=1]="Method",V[V.Function=2]="Function",V[V.Constructor=3]="Constructor",V[V.Field=4]="Field",V[V.Variable=5]="Variable",V[V.Class=6]="Class",V[V.Interface=7]="Interface",V[V.Module=8]="Module",V[V.Property=9]="Property",V[V.Unit=10]="Unit",V[V.Value=11]="Value",V[V.Enum=12]="Enum",V[V.Keyword=13]="Keyword",V[V.Snippet=14]="Snippet",V[V.Color=15]="Color",V[V.File=16]="File",V[V.Reference=17]="Reference",V[V.Folder=18]="Folder",V[V.EnumMember=19]="EnumMember",V[V.Constant=20]="Constant",V[V.Struct=21]="Struct",V[V.Event=22]="Event",V[V.Operator=23]="Operator",V[V.TypeParameter=24]="TypeParameter",V[V.User=25]="User",V[V.Issue=26]="Issue"})(De=e.CompletionItemKind||(e.CompletionItemKind={}));var _e;(function(V){V[V.Deprecated=1]="Deprecated"})(_e=e.CompletionItemTag||(e.CompletionItemTag={}));let Pe=class{constructor(B,oe){this.label=B,this.kind=oe}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&De[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pe=qe([a],Pe),e.CompletionItem=Pe;let ae=class{constructor(B=[],oe=!1){this.items=B,this.isIncomplete=oe}};ae=qe([a],ae),e.CompletionList=ae;let fe=class{constructor(B,oe,ke){this.text=B,this.range=oe,this.command=ke}};fe=qe([a],fe),e.InlineSuggestion=fe;let W=class{constructor(B){this.items=B}};W=qe([a],W),e.InlineSuggestions=W;var ee;(function(V){V[V.Active=-1]="Active",V[V.Beside=-2]="Beside",V[V.One=1]="One",V[V.Two=2]="Two",V[V.Three=3]="Three",V[V.Four=4]="Four",V[V.Five=5]="Five",V[V.Six=6]="Six",V[V.Seven=7]="Seven",V[V.Eight=8]="Eight",V[V.Nine=9]="Nine"})(ee=e.ViewColumn||(e.ViewColumn={}));var de;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(de=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ie;(function(V){V[V.Off=0]="Off",V[V.On=1]="On",V[V.Relative=2]="Relative"})(Ie=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Te;(function(V){V[V.Manual=1]="Manual",V[V.AfterDelay=2]="AfterDelay",V[V.FocusOut=3]="FocusOut"})(Te=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var xe;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(xe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ve;(function(V){V[V.Keyboard=1]="Keyboard",V[V.Mouse=2]="Mouse",V[V.Command=3]="Command"})(Ve=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ze;(function(V){V[V.OpenOpen=0]="OpenOpen",V[V.ClosedClosed=1]="ClosedClosed",V[V.OpenClosed=2]="OpenClosed",V[V.ClosedOpen=3]="ClosedOpen"})(Ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(V){function B(oe){switch(oe){case"keyboard":return V.Keyboard;case"mouse":return V.Mouse;case"api":return V.Command}}V.fromValue=B}(Ve=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(B,oe){if(oe&&!_.URI.isUri(oe))throw R.illegalArgument("target");if(!$.isRange(B)||B.isEmpty)throw R.illegalArgument("range");this.range=B,this.target=oe}};rt=qe([a],rt),e.DocumentLink=rt;let Xe=class{constructor(B,oe,ke,Ke){this.red=B,this.green=oe,this.blue=ke,this.alpha=Ke}};Xe=qe([a],Xe),e.Color=Xe;let Je=class{constructor(B,oe){if(oe&&!(oe instanceof Xe))throw R.illegalArgument("color");if(!$.isRange(B)||B.isEmpty)throw R.illegalArgument("range");this.range=B,this.color=oe}};Je=qe([a],Je),e.ColorInformation=Je;let ft=class{constructor(B){if(!B||typeof B!="string")throw R.illegalArgument("label");this.label=B}};ft=qe([a],ft),e.ColorPresentation=ft;var Ee;(function(V){V[V.RGB=0]="RGB",V[V.HEX=1]="HEX",V[V.HSL=2]="HSL"})(Ee=e.ColorFormat||(e.ColorFormat={}));var Ce;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information"})(Ce=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ue{constructor(B,oe,ke){if(this.startIndex=B,this.length=oe,this.tooltip=ke,typeof B!="number"||B<0)throw R.illegalArgument("startIndex");if(typeof oe!="number"||oe<1)throw R.illegalArgument("length");if(ke!==void 0&&typeof ke!="string")throw R.illegalArgument("tooltip")}}e.TerminalLink=ue;class K{constructor(B){this.options=B,typeof B!="object"&&R.illegalArgument("options")}}e.TerminalProfile=K;var Be;(function(V){V[V.Always=1]="Always",V[V.Silent=2]="Silent",V[V.Never=3]="Never"})(Be=e.TaskRevealKind||(e.TaskRevealKind={}));var Fe;(function(V){V[V.Shared=1]="Shared",V[V.Dedicated=2]="Dedicated",V[V.New=3]="New"})(Fe=e.TaskPanelKind||(e.TaskPanelKind={}));let Me=m=class{constructor(B,oe){if(typeof B!="string"||typeof oe!="string")throw R.illegalArgument("name");this._id=B}static from(B){switch(B){case"clean":return m.Clean;case"build":return m.Build;case"rebuild":return m.Rebuild;case"test":return m.Test;default:return}}get id(){return this._id}};Me.Clean=new m("clean","Clean"),Me.Build=new m("build","Build"),Me.Rebuild=new m("rebuild","Rebuild"),Me.Test=new m("test","Test"),Me=m=qe([a],Me),e.TaskGroup=Me;function nt(V){let B="";for(let oe=0;oe<V.length;oe++)B+=V[oe].replace(/,/g,",,")+",";return B}let ot=class{constructor(B,oe,ke){if(typeof B!="string")throw R.illegalArgument("process");this._args=[],this._process=B,oe!==void 0&&(Array.isArray(oe)?(this._args=oe,this._options=ke):this._options=oe)}get process(){return this._process}set process(B){if(typeof B!="string")throw R.illegalArgument("process");this._process=B}get args(){return this._args}set args(B){Array.isArray(B)||(B=[]),this._args=B}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("process"),this._process!==void 0&&B.push(this._process),this._args&&this._args.length>0)for(let oe of this._args)B.push(oe);return nt(B)}};ot=qe([a],ot),e.ProcessExecution=ot;let tt=class{constructor(B,oe,ke){if(this._args=[],Array.isArray(oe)){if(!B)throw R.illegalArgument("command can't be undefined or null");if(typeof B!="string"&&typeof B.value!="string")throw R.illegalArgument("command");this._command=B,this._args=oe,this._options=ke}else{if(typeof B!="string")throw R.illegalArgument("commandLine");this._commandLine=B,this._options=oe}}get commandLine(){return this._commandLine}set commandLine(B){if(typeof B!="string")throw R.illegalArgument("commandLine");this._commandLine=B}get command(){return this._command?this._command:""}set command(B){if(typeof B!="string"&&typeof B.value!="string")throw R.illegalArgument("command");this._command=B}get args(){return this._args}set args(B){this._args=B||[]}get options(){return this._options}set options(B){this._options=B}computeId(){const B=[];if(B.push("shell"),this._commandLine!==void 0&&B.push(this._commandLine),this._command!==void 0&&B.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let oe of this._args)B.push(typeof oe=="string"?oe:oe.value);return nt(B)}};tt=qe([a],tt),e.ShellExecution=tt;var vt;(function(V){V[V.Escape=1]="Escape",V[V.Strong=2]="Strong",V[V.Weak=3]="Weak"})(vt=e.ShellQuoting||(e.ShellQuoting={}));var gt;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace"})(gt=e.TaskScope||(e.TaskScope={}));class pt{constructor(B){this._callback=B}computeId(){return"customExecution"+D.generateUuid()}set callback(B){this._callback=B}get callback(){return this._callback}}e.CustomExecution=pt;let bt=E=class{constructor(B,oe,ke,Ke,et,at){this.__deprecated=!1,this._definition=this.definition=B;let lt;typeof oe=="string"?(this._name=this.name=oe,this._source=this.source=ke,this.execution=Ke,lt=et,this.__deprecated=!0):oe===gt.Global||oe===gt.Workspace?(this.target=oe,this._name=this.name=ke,this._source=this.source=Ke,this.execution=et,lt=at):(this.target=oe,this._name=this.name=ke,this._source=this.source=Ke,this.execution=et,lt=at),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(B){this.__id=B}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ot?this._definition={type:E.ProcessType,id:this._execution.computeId()}:this._execution instanceof tt?this._definition={type:E.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:E.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:E.EmptyType,id:D.generateUuid()}}get definition(){return this._definition}set definition(B){if(B==null)throw R.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=B}get scope(){return this._scope}set target(B){this.clear(),this._scope=B}get name(){return this._name}set name(B){if(typeof B!="string")throw R.illegalArgument("name");this.clear(),this._name=B}get execution(){return this._execution}set execution(B){B===null&&(B=void 0),this.clear(),this._execution=B;const oe=this._definition.type;(E.EmptyType===oe||E.ProcessType===oe||E.ShellType===oe||E.ExtensionCallbackType===oe)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(B){if(Array.isArray(B))this.clear(),this._problemMatchers=B,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(B){B!==!0&&B!==!1&&(B=!1),this.clear(),this._isBackground=B}get source(){return this._source}set source(B){if(typeof B!="string"||B.length===0)throw R.illegalArgument("source must be a string of length > 0");this.clear(),this._source=B}get group(){return this._group}set group(B){B===null&&(B=void 0),this.clear(),this._group=B}get detail(){return this._detail}set detail(B){B===null&&(B=void 0),this._detail=B}get presentationOptions(){return this._presentationOptions}set presentationOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._presentationOptions=B}get runOptions(){return this._runOptions}set runOptions(B){B==null&&(B=Object.create(null)),this.clear(),this._runOptions=B}};bt.ExtensionCallbackType="customExecution",bt.ProcessType="process",bt.ShellType="shell",bt.EmptyType="$empty",bt=E=qe([a],bt),e.Task=bt;var Tt;(function(V){V[V.SourceControl=1]="SourceControl",V[V.Window=10]="Window",V[V.Notification=15]="Notification"})(Tt=e.ProgressLocation||(e.ProgressLocation={}));let It=class{constructor(B,oe=_t.None){this.collapsibleState=oe,_.URI.isUri(B)?this.resourceUri=B:this.label=B}};It=qe([a],It),e.TreeItem=It;var _t;(function(V){V[V.None=0]="None",V[V.Collapsed=1]="Collapsed",V[V.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ct=class{constructor(B,oe){this.id=B,this.color=oe}};ct=qe([a],ct),e.ThemeIcon=ct,ct.File=new ct("file"),ct.Folder=new ct("folder");let mt=class{constructor(B){this.id=B}};mt=qe([a],mt),e.ThemeColor=mt;var Et;(function(V){V[V.Global=1]="Global",V[V.Workspace=2]="Workspace",V[V.WorkspaceFolder=3]="WorkspaceFolder"})(Et=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Lt=class{constructor(B,oe){if(typeof B!="string"&&(!B||!_.URI.isUri(B)&&!_.URI.isUri(B.uri)))throw R.illegalArgument("base");if(typeof oe!="string")throw R.illegalArgument("pattern");typeof B=="string"?(this.baseFolder=_.URI.file(B),this.base=B):_.URI.isUri(B)?(this.baseFolder=B,this.base=B.fsPath):(this.baseFolder=B.uri,this.base=B.uri.fsPath),this.pattern=oe}};Lt=qe([a],Lt),e.RelativePattern=Lt;let St=class{constructor(B,oe,ke,Ke){this.enabled=typeof B=="boolean"?B:!0,typeof oe=="string"&&(this.condition=oe),typeof ke=="string"&&(this.hitCondition=ke),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this._id||(this._id=D.generateUuid()),this._id}};St=qe([a],St),e.Breakpoint=St;let Zt=class extends St{constructor(B,oe,ke,Ke,et){super(oe,ke,Ke,et);if(B===null)throw R.illegalArgument("location");this.location=B}};Zt=qe([a],Zt),e.SourceBreakpoint=Zt;let qt=class extends St{constructor(B,oe,ke,Ke,et){super(oe,ke,Ke,et);this.functionName=B}};qt=qe([a],qt),e.FunctionBreakpoint=qt;let yt=class extends St{constructor(B,oe,ke,Ke,et,at,lt){super(Ke,et,at,lt);if(!oe)throw R.illegalArgument("dataId");this.label=B,this.dataId=oe,this.canPersist=ke}};yt=qe([a],yt),e.DataBreakpoint=yt;let en=class{constructor(B,oe,ke){this.command=B,this.args=oe||[],this.options=ke}};en=qe([a],en),e.DebugAdapterExecutable=en;let tn=class{constructor(B,oe){this.port=B,this.host=oe}};tn=qe([a],tn),e.DebugAdapterServer=tn;let ht=class{constructor(B){this.path=B}};ht=qe([a],ht),e.DebugAdapterNamedPipeServer=ht;let Gt=class{constructor(B){this.implementation=B}};Gt=qe([a],Gt),e.DebugAdapterInlineImplementation=Gt;let $t=class{constructor(B,oe){this.range=B,this.expression=oe}};$t=qe([a],$t),e.EvaluatableExpression=$t;var Cn;(function(V){V[V.Automatic=0]="Automatic",V[V.Explicit=1]="Explicit"})(Cn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let nn=class{constructor(B,oe){this.range=B,this.text=oe}};nn=qe([a],nn),e.InlineValueText=nn;let Ct=class{constructor(B,oe,ke=!0){this.range=B,this.variableName=oe,this.caseSensitiveLookup=ke}};Ct=qe([a],Ct),e.InlineValueVariableLookup=Ct;let Kt=class{constructor(B,oe){this.range=B,this.expression=oe}};Kt=qe([a],Kt),e.InlineValueEvaluatableExpression=Kt;let rn=class{constructor(B,oe){this.frameId=B,this.stoppedLocation=oe}};rn=qe([a],rn),e.InlineValueContext=rn;var Qt;(function(V){V[V.Changed=1]="Changed",V[V.Created=2]="Created",V[V.Deleted=3]="Deleted"})(Qt=e.FileChangeType||(e.FileChangeType={}));let ut=y=class extends Error{constructor(B,oe=r.FileSystemProviderErrorCode.Unknown,ke){var Ke;super(_.URI.isUri(B)?B.toString(!0):B);this.code=(Ke=ke==null?void 0:ke.name)!==null&&Ke!==void 0?Ke:"Unknown",r.markAsFileSystemProviderError(this,oe),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,y.prototype),typeof Error.captureStackTrace=="function"&&typeof ke=="function"&&Error.captureStackTrace(this,ke)}static FileExists(B){return new y(B,r.FileSystemProviderErrorCode.FileExists,y.FileExists)}static FileNotFound(B){return new y(B,r.FileSystemProviderErrorCode.FileNotFound,y.FileNotFound)}static FileNotADirectory(B){return new y(B,r.FileSystemProviderErrorCode.FileNotADirectory,y.FileNotADirectory)}static FileIsADirectory(B){return new y(B,r.FileSystemProviderErrorCode.FileIsADirectory,y.FileIsADirectory)}static NoPermissions(B){return new y(B,r.FileSystemProviderErrorCode.NoPermissions,y.NoPermissions)}static Unavailable(B){return new y(B,r.FileSystemProviderErrorCode.Unavailable,y.Unavailable)}};ut=y=qe([a],ut),e.FileSystemError=ut;let sn=class{constructor(B,oe,ke){this.start=B,this.end=oe,this.kind=ke}};sn=qe([a],sn),e.FoldingRange=sn;var Ft;(function(V){V[V.Comment=1]="Comment",V[V.Imports=2]="Imports",V[V.Region=3]="Region"})(Ft=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wt;(function(V){V[V.Collapsed=0]="Collapsed",V[V.Expanded=1]="Expanded"})(Wt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var pn;(function(V){V[V.Editing=0]="Editing",V[V.Preview=1]="Preview"})(pn=e.CommentMode||(e.CommentMode={}));class kn{constructor(B,oe=[]){this.tokenTypes=B,this.tokenModifiers=oe}}e.SemanticTokensLegend=kn;function vn(V){return typeof V=="undefined"||P.isStringArray(V)}class on{constructor(B){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,B){this._hasLegend=!0;for(let oe=0,ke=B.tokenTypes.length;oe<ke;oe++)this._tokenTypeStrToInt.set(B.tokenTypes[oe],oe);for(let oe=0,ke=B.tokenModifiers.length;oe<ke;oe++)this._tokenModifierStrToInt.set(B.tokenModifiers[oe],oe)}}push(B,oe,ke,Ke,et){if(typeof B=="number"&&typeof oe=="number"&&typeof ke=="number"&&typeof Ke=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(B,oe,ke,Ke,et);if($.isRange(B)&&typeof oe=="string"&&vn(ke))return this._push(B,oe,ke);throw R.illegalArgument()}_push(B,oe,ke){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(B.start.line!==B.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(oe))throw new Error("`tokenType` is not in the provided legend");const Ke=B.start.line,et=B.start.character,at=B.end.character-B.start.character,lt=this._tokenTypeStrToInt.get(oe);let Dt=0;if(ke)for(const kt of ke){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const At=this._tokenModifierStrToInt.get(kt);Dt|=1<<At>>>0}this._pushEncoded(Ke,et,at,lt,Dt)}_pushEncoded(B,oe,ke,Ke,et){if(this._dataIsSortedAndDeltaEncoded&&(B<this._prevLine||B===this._prevLine&&oe<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let kt=0,At=0;for(let Rt=0;Rt<Dt;Rt++){let Nt=this._data[5*Rt],mn=this._data[5*Rt+1];Nt===0?(Nt=kt,mn+=At):Nt+=kt,this._data[5*Rt]=Nt,this._data[5*Rt+1]=mn,kt=Nt,At=mn}}let at=B,lt=oe;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=ke,this._data[this._dataLen++]=Ke,this._data[this._dataLen++]=et,this._prevLine=B,this._prevChar=oe}static _sortAndDeltaEncode(B){let oe=[];const ke=B.length/5|0;for(let lt=0;lt<ke;lt++)oe[lt]=lt;oe.sort((lt,Dt)=>{const kt=B[5*lt],At=B[5*Dt];if(kt===At){const Rt=B[5*lt+1],Nt=B[5*Dt+1];return Rt-Nt}return kt-At});const Ke=new Uint32Array(B.length);let et=0,at=0;for(let lt=0;lt<ke;lt++){const Dt=5*oe[lt],kt=B[Dt+0],At=B[Dt+1],Rt=B[Dt+2],Nt=B[Dt+3],mn=B[Dt+4],Nn=kt-et,Wn=Nn===0?At-at:At,gn=5*lt;Ke[gn+0]=Nn,Ke[gn+1]=Wn,Ke[gn+2]=Rt,Ke[gn+3]=Nt,Ke[gn+4]=mn,et=kt,at=At}return Ke}build(B){return this._dataIsSortedAndDeltaEncoded?new Xt(new Uint32Array(this._data),B):new Xt(on._sortAndDeltaEncode(this._data),B)}}e.SemanticTokensBuilder=on;class Xt{constructor(B,oe){this.resultId=oe,this.data=B}}e.SemanticTokens=Xt;class xt{constructor(B,oe,ke){this.start=B,this.deleteCount=oe,this.data=ke}}e.SemanticTokensEdit=xt;class Pn{constructor(B,oe){this.resultId=oe,this.edits=B}}e.SemanticTokensEdits=Pn;var an;(function(V){V[V.Separate=0]="Separate",V[V.MergeWithParent=1]="MergeWithParent"})(an=e.DebugConsoleMode||(e.DebugConsoleMode={}));var ln;(function(V){V[V.Initial=1]="Initial",V[V.Dynamic=2]="Dynamic"})(ln=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Yt=class{constructor(){}};Yt.Back={iconPath:new ct("arrow-left")},Yt=qe([a],Yt),e.QuickInputButtons=Yt;var In;(function(V){V[V.UI=1]="UI",V[V.Workspace=2]="Workspace"})(In=e.ExtensionKind||(e.ExtensionKind={}));class Mt{constructor(B,oe,ke){this.badge=B,this.tooltip=oe,this.color=ke}static validate(B){if(B.badge&&B.badge.length!==1&&B.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!B.color&&!B.badge&&!B.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Mt;let cn=class{constructor(B){this.kind=B}};cn=qe([a],cn),e.ColorTheme=cn;var An;(function(V){V[V.Light=1]="Light",V[V.Dark=2]="Dark",V[V.HighContrast=3]="HighContrast"})(An=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(B,oe){if(B<0)throw R.illegalArgument("start must be positive");if(oe<0)throw R.illegalArgument("end must be positive");B<=oe?(this._start=B,this._end=oe):(this._start=oe,this._end=B)}static isNotebookRange(B){return B instanceof Ht?!0:B?typeof B.start=="number"&&typeof B.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(B){let oe=this._start,ke=this._end;return B.start!==void 0&&(oe=B.start),B.end!==void 0&&(ke=B.end),oe===this._start&&ke===this._end?this:new Ht(oe,ke)}}e.NotebookRange=Ht;class Ot{constructor(B,oe,ke,Ke,et,at,lt){this.kind=B,this.value=oe,this.languageId=ke,this.mime=Ke,this.outputs=et??[],this.metadata=at,this.executionSummary=lt,Ot.validate(this)}static validate(B){if(typeof B.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof B.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof B.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(B){return Array.isArray(B)&&B.every(oe=>Ot.isNotebookCellData(oe))}static isNotebookCellData(B){return!0}}e.NotebookCellData=Ot;class un{constructor(B){this.cells=B}}e.NotebookData=un;class Pt{constructor(B,oe){this.data=B,this.mime=oe;const ke=A.normalizeMimeType(oe,!0);if(!ke)throw new Error("INVALID mime type, must not be empty or falsy: "+oe);this.mime=ke}static isNotebookCellOutputItem(B){return B instanceof Pt?!0:B?typeof B.mime=="string"&&B.data instanceof Uint8Array:!1}static error(B){const oe={name:B.name,message:B.message,stack:B.stack};return Pt.json(oe,"application/vnd.code.notebook.error")}static stdout(B){return Pt.text(B,"application/vnd.code.notebook.stdout")}static stderr(B){return Pt.text(B,"application/vnd.code.notebook.stderr")}static bytes(B,oe="application/octet-stream"){return new Pt(B,oe)}static text(B,oe=A.Mimes.text){const ke=$e(Pt,f,"f",I).encode(String(B));return new Pt(ke,oe)}static json(B,oe="application/json"){const ke=JSON.stringify(B,void 0,"	");return Pt.text(ke,oe)}}e.NotebookCellOutputItem=Pt,f=Pt,I={value:new TextEncoder};class zt{constructor(B,oe,ke){this.items=zt.ensureUniqueMimeTypes(B,!0),typeof oe=="string"?(this.id=oe,this.metadata=ke):(this.id=D.generateUuid(),this.metadata=oe??ke)}static isNotebookCellOutput(B){return B instanceof zt?!0:!B||typeof B!="object"?!1:typeof B.id=="string"&&P.isArray(B.items)}static ensureUniqueMimeTypes(B,oe=!1){const ke=new Set,Ke=new Set;for(let et=0;et<B.length;et++){const at=B[et],lt=A.normalizeMimeType(at.mime);if(!ke.has(lt)){ke.add(lt);continue}Ke.add(et),oe&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return Ke.size===0?B:B.filter((et,at)=>!Ke.has(at))}}e.NotebookCellOutput=zt;var dn;(function(V){V[V.Markup=1]="Markup",V[V.Code=2]="Code"})(dn=e.NotebookCellKind||(e.NotebookCellKind={}));var Ne;(function(V){V[V.Idle=1]="Idle",V[V.Pending=2]="Pending",V[V.Executing=3]="Executing"})(Ne=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var hn;(function(V){V[V.Left=1]="Left",V[V.Right=2]="Right"})(hn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var wn;(function(V){V[V.Default=0]="Default",V[V.InCenter=1]="InCenter",V[V.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",V[V.AtTop=3]="AtTop"})(wn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class dt{constructor(B,oe){this.text=B,this.alignment=oe}}e.NotebookCellStatusBarItem=dt;var Tn;(function(V){V[V.Default=1]="Default",V[V.Preferred=2]="Preferred"})(Tn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Rn{constructor(B,oe=[]){this.uri=B,this.provides=p.asArray(oe)}}e.NotebookRendererScript=Rn;let Jt=class{constructor(B,oe){this.label=B,this.timestamp=oe}};Jt=qe([a],Jt),e.TimelineItem=Jt;var bn;(function(V){V[V.Production=1]="Production",V[V.Development=2]="Development",V[V.Test=3]="Test"})(bn=e.ExtensionMode||(e.ExtensionMode={}));var fn;(function(V){V[V.Node=1]="Node",V[V.Webworker=2]="Webworker"})(fn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ln;(function(V){V[V.Other=0]="Other",V[V.Comment=1]="Comment",V[V.String=2]="String",V[V.RegEx=4]="RegEx"})(Ln=e.StandardTokenType||(e.StandardTokenType={}));class Fn{constructor(B,oe){this.ranges=B,this.wordPattern=oe}}e.LinkedEditingRanges=Fn;class Mn{constructor(B,oe){this._port=B,this._autoForwardAction=oe}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Mn;var En;(function(V){V[V.Unset=0]="Unset",V[V.Queued=1]="Queued",V[V.Running=2]="Running",V[V.Passed=3]="Passed",V[V.Failed=4]="Failed",V[V.Skipped=5]="Skipped",V[V.Errored=6]="Errored"})(En=e.TestResultState||(e.TestResultState={}));var _n;(function(V){V[V.Error=0]="Error",V[V.Warning=1]="Warning",V[V.Information=2]="Information",V[V.Hint=3]="Hint"})(_n=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Sn;(function(V){V[V.Pending=0]="Pending",V[V.Resolved=1]="Resolved"})(Sn=e.TestItemStatus||(e.TestItemStatus={}));const Bt=(V,B,oe,ke)=>{let Ke=oe;return{enumerable:!0,configurable:!1,get(){return Ke},set(et){ke(Ke,et)||(Ke=et,V.bus.fire([3,B,et]))}}},Vt=(V,B)=>V===B,On=(V,B)=>V===B?!0:!V||!B?!1:V.isEqual(B);class ne{constructor(B,oe,ke,Ke){this.label=oe,this.data=Ke;const et=l.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:B,enumerable:!0,writable:!1},uri:{value:ke,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new S.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:Bt(et,"range",void 0,On),description:Bt(et,"description",void 0,Vt),runnable:Bt(et,"runnable",!0,Vt),debuggable:Bt(et,"debuggable",!1,Vt),status:Bt(et,"status",Sn.Resolved,Vt),error:Bt(et,"error",void 0,Vt)})}invalidate(){l.getPrivateApiFor(this).bus.fire([2])}dispose(){const B=l.getPrivateApiFor(this);B.parent&&l.getPrivateApiFor(B.parent).children.delete(this.id),B.bus.fire([1])}addChild(B){if(!(B instanceof ne))throw new Error("Test child must be created through vscode.test.createTestItem()");const oe=l.getPrivateApiFor(this);if(oe.children.has(B.id))throw new Error(`Attempted to insert a duplicate test item ID ${B.id}`);oe.children.set(B.id,B),l.getPrivateApiFor(B).parent=this,oe.bus.fire([0,B])}}e.TestItemImpl=ne;class he{constructor(B){this.message=B,this.severity=_n.Error}static diff(B,oe,ke){const Ke=new he(B);return Ke.expectedOutput=oe,Ke.actualOutput=ke,Ke}}e.TestMessage=he;var Ae;(function(V){V[V.None=0]="None",V[V.Option=1]="Option",V[V.Default=2]="Default",V[V.Preferred=3]="Preferred"})(Ae=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var st;(function(V){V[V.Untrusted=0]="Untrusted",V[V.Trusted=1]="Trusted",V[V.Unspecified=2]="Unspecified"})(st=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wt;(function(V){V[V.Notify=1]="Notify",V[V.OpenBrowser=2]="OpenBrowser",V[V.OpenPreview=3]="OpenPreview",V[V.Silent=4]="Silent",V[V.Ignore=5]="Ignore"})(wt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(pe[119],ve([0,1,50,10,8,144,107,7,18]),function(X,e,p,R,C,S,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const D=new Map;function r(c,f){f?D.set(c,f):D.delete(c)}e.setWordDefinitionFor=r;function k(c){return D.get(c)}e.getWordDefinitionFor=k;class l extends S.MirrorTextModel{constructor(f,I,b,w,u,d,g,t){super(I,b,w,u);this._proxy=f,this._languageId=d,this._isDirty=g,this._notebook=t,this._isDisposed=!1}dispose(){p.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(f){return _.equals(this._lines,f)}get document(){if(!this._document){const f=this;this._document={get uri(){return f._uri},get fileName(){return f._uri.fsPath},get isUntitled(){return f._uri.scheme===R.Schemas.untitled},get languageId(){return f._languageId},get version(){return f._versionId},get isClosed(){return f._isDisposed},get isDirty(){return f._isDirty},get notebook(){return f._notebook},save(){return f._save()},getText(I){return I?f._getTextInRange(I):f.getText()},get eol(){return f._eol===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return f._lines.length},lineAt(I){return f._lineAt(I)},offsetAt(I){return f._offsetAt(I)},positionAt(I){return f._positionAt(I)},validateRange(I){return f._validateRange(I)},validatePosition(I){return f._validatePosition(I)},getWordRangeAtPosition(I,b){return f._getWordRangeAtPosition(I,b)}}}return Object.freeze(this._document)}_acceptLanguageId(f){p.ok(!this._isDisposed),this._languageId=f}_acceptIsDirty(f){p.ok(!this._isDisposed),this._isDirty=f}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(f){const I=this._validateRange(f);if(I.isEmpty)return"";if(I.isSingleLine)return this._lines[I.start.line].substring(I.start.character,I.end.character);const b=this._eol,w=I.start.line,u=I.end.line,d=[];d.push(this._lines[w].substring(I.start.character));for(let g=w+1;g<u;g++)d.push(this._lines[g]);return d.push(this._lines[u].substring(0,I.end.character)),d.join(b)}_lineAt(f){let I;if(f instanceof P.Position?I=f.line:typeof f=="number"&&(I=f),typeof I!="number"||I<0||I>=this._lines.length||Math.floor(I)!==I)throw new Error("Illegal value for `line`");return new h(I,this._lines[I],I===this._lines.length-1)}_offsetAt(f){return f=this._validatePosition(f),this._ensureLineStarts(),this._lineStarts.getPrefixSum(f.line-1)+f.character}_positionAt(f){f=Math.floor(f),f=Math.max(0,f),this._ensureLineStarts();const I=this._lineStarts.getIndexOf(f),b=this._lines[I.index].length;return new P.Position(I.index,Math.min(I.remainder,b))}_validateRange(f){if(!(f instanceof P.Range))throw new Error("Invalid argument");const I=this._validatePosition(f.start),b=this._validatePosition(f.end);return I===f.start&&b===f.end?f:new P.Range(I.line,I.character,b.line,b.character)}_validatePosition(f){if(!(f instanceof P.Position))throw new Error("Invalid argument");if(this._lines.length===0)return f.with(0,0);let{line:I,character:b}=f,w=!1;if(I<0)I=0,b=0,w=!0;else if(I>=this._lines.length)I=this._lines.length-1,b=this._lines[I].length,w=!0;else{const u=this._lines[I].length;b<0?(b=0,w=!0):b>u&&(b=u,w=!0)}return w?new P.Position(I,b):f}_getWordRangeAtPosition(f,I){const b=this._validatePosition(f);if(!I)I=k(this._languageId);else if(C.regExpLeadsToEndlessLoop(I))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${I.source}' because it matches the empty string.`);const w=A.getWordAtText(b.character+1,A.ensureValidWordDefinition(I),this._lines[b.line],0);if(w)return new P.Range(b.line,w.startColumn-1,b.line,w.endColumn-1)}}e.ExtHostDocumentData=l;class h{constructor(f,I,b){this._line=f,this._text=I,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new P.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new P.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(pe[194],ve([0,1,7,3,109,6,76,23,2,32]),function(X,e,p,R,C,S,A,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class r{constructor(l,h,c,f){this._notebook=c,this._selector=f,this._disposables=new S.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:D.generateUuid()}),this._init(),this._disposables.add(h.onDidChangeDocument(b=>{const w=this._cellUris.get(b.document.uri);w!==void 0&&(this._cellLengths.changeValue(w,this._cells[w].document.getText().length+1),this._cellLines.changeValue(w,this._cells[w].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const I=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(l.onDidChangeNotebookCells(b=>I(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new P.ResourceMap;const l=[],h=[];for(const c of this._notebook.getCells())c.kind===p.NotebookCellKind.Code&&(!this._selector||A.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),l.push(c.document.getText().length+1),h.push(c.document.lineCount));this._cellLengths=new C.PrefixSumComputer(new Uint32Array(l)),this._cellLines=new C.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(l){var h,c;if(!l){let u="";for(const d of this._cells)u+=d.document.getText()+`
`;return u=u.slice(0,-1),u}if(l.isEmpty)return"";const f=this.locationAt(l.start),I=this.locationAt(l.end),b=this._cells[(h=this._cellUris.get(f.uri))!==null&&h!==void 0?h:-1],w=this._cells[(c=this._cellUris.get(I.uri))!==null&&c!==void 0?c:-1];if(!b||!w)return"";if(b===w)return b.document.getText(new p.Range(f.range.start,I.range.end));{const u=b.document.getText(new p.Range(f.range.start,new p.Position(b.document.lineCount,0))),d=w.document.getText(new p.Range(new p.Position(0,0),I.range.end));return u+`
`+d}}offsetAt(l){const h=this._cellLines.getIndexOf(l.line),c=this._cellLengths.getPrefixSum(h.index-1),f=this._cells[h.index].document.offsetAt(l.with(h.remainder));return c+f}positionAt(l){if(typeof l=="number"){const c=this._cellLengths.getIndexOf(l),f=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(f)}const h=this._cellUris.get(l.uri);if(h!==void 0){const c=this._cellLines.getPrefixSum(h-1);return new p.Position(c+l.range.start.line,l.range.start.character)}return new p.Position(0,0)}locationAt(l){p.Range.isRange(l)||(l=new p.Range(l,l));const h=this._cellLines.getIndexOf(l.start.line);let c=h;l.isEmpty||(c=this._cellLines.getIndexOf(l.end.line));const f=new p.Position(h.remainder,l.start.character),I=new p.Position(c.remainder,l.end.character),b=new p.Range(f,I),w=this._cells[h.index];return new p.Location(w.document.uri,w.document.validateRange(b))}contains(l){return this._cellUris.has(l)}validateRange(l){const h=this.validatePosition(l.start),c=this.validatePosition(l.end);return l.with(h,c)}validatePosition(l){const h=this._cellLines.getIndexOf(l.line),c=new p.Position(h.remainder,l.character),f=this._cells[h.index].document.validatePosition(c),I=this._cellLines.getPrefixSum(h.index-1);return new p.Position(I+f.line,f.character)}}e.ExtHostNotebookConcatDocument=r}),define(pe[195],ve([0,1,7,13,3]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let S=class{constructor(P){this._actual=new p.ColorTheme(p.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new C.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(P){let _=P==="light"?p.ColorThemeKind.Light:P==="dark"?p.ColorThemeKind.Dark:p.ColorThemeKind.HighContrast;this._actual=new p.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};S=qe([We(0,R.IExtHostRpcService)],S),e.ExtHostTheming=S}),define(pe[60],ve([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=p.createDecorator("IURITransformerService");class R{constructor(S){S?(this.transformIncoming=S.transformIncoming.bind(S),this.transformOutgoing=S.transformOutgoing.bind(S),this.transformOutgoingURI=S.transformOutgoingURI.bind(S),this.transformOutgoingScheme=S.transformOutgoingScheme.bind(S)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(pe[196],ve([0,1,22]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(_){let D=this.buffers.indexOf(_);return D<0&&(D=this.buffers.length,this.buffers.push(_)),D}}function C(P,_){if(_.serializeBuffersForPostMessage){const D=new R,r=(h,c)=>{if(c instanceof ArrayBuffer){const f=D.add(c);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(c)){const f=S(c);if(f){const I=D.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:I,view:{type:f,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},k=JSON.stringify(P,r),l=D.buffers.map(h=>{const c=new Uint8Array(h);return p.VSBuffer.wrap(c)});return{message:k,buffers:l}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=C;function S(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(P,_){const D=_.map(l=>{const h=new ArrayBuffer(l.byteLength);return new Uint8Array(h).set(l.buffer),h}),r=_.length?(l,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const c=h,{index:f}=c,I=D[f];if(c.view)switch(c.view.type){case 1:return new Int8Array(I,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(I,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(I,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(I,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(I,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(I,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(I,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(I,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(I,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(I,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(I,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return I}return h}:void 0;return{message:JSON.parse(P,r),arrayBuffers:D}}e.deserializeWebviewMessage=A}),define(pe[84],ve([0,1,10,2]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function C(S,A){return S.scheme===p.Schemas.http||S.scheme===p.Schemas.https?S:(A&&A.authority&&A.isRemote&&S.scheme===p.Schemas.file&&(S=R.URI.from({scheme:p.Schemas.vscodeRemote,authority:A.authority,path:S.path})),R.URI.from({scheme:p.Schemas.https,authority:`${S.scheme}+${S.authority}.${e.webviewRootResourceAuthority}`,path:S.path,fragment:S.fragment,query:S.query}))}e.asWebviewUri=C}),define(pe[197],ve([0,1,3,6,84]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class S{constructor(P,_,D){this._proxy=P,this._editors=_,this._initData=D,this._handlePool=0,this._disposables=new R.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const r=_.getVisibleTextEditors();for(const k of this._insets.values())r.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this._insets.forEach(P=>P.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(P,_,D,r,k){let l;for(const u of this._editors.getVisibleTextEditors(!0))if(u.value===P){l=u;break}if(!l)throw new Error("not a visible editor");const h=this,c=this._handlePool++,f=new p.Emitter,I=new p.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(u){return C.asWebviewUri(u,h._initData.remote)}get cspSource(){return C.webviewGenericCspSource}set options(u){this._options=u,h._proxy.$setOptions(c,u)}get options(){return this._options}set html(u){this._html=u,h._proxy.$setHtml(c,u)}get html(){return this._html}get onDidReceiveMessage(){return f.event}postMessage(u){return h._proxy.$postMessage(c,u)}},w=new class{constructor(){this.editor=P,this.line=_,this.height=D,this.webview=b,this.onDidDispose=I.event}dispose(){h._insets.has(c)&&(h._insets.delete(c),h._proxy.$disposeEditorInset(c),I.fire(),I.dispose(),f.dispose())}};return this._proxy.$createEditorInset(c,l.id,l.value.document.uri,_+1,D,r||{},k.identifier,k.extensionLocation),this._insets.set(c,{editor:P,inset:w,onDidReceiveMessage:f}),w}$onDidDispose(P){const _=this._insets.get(P);_&&_.inset.dispose()}$onDidReceiveMessage(P,_){const D=this._insets.get(P);D&&D.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=S}),define(pe[120],ve([0,1,3,16,166]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class S{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new p.Emitter,this._onExit=new p.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(P){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=P}onEvent(P){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=P}onRequest(P){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=P}sendResponse(P){P.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.internalSend("response",P)}sendRequest(P,_,D,r){const k={command:P};if(_&&Object.keys(_).length>0&&(k.arguments=_),this.internalSend("request",k),typeof r=="number"){const l=setTimeout(()=>{clearTimeout(l);const h=this.pendingRequests.get(k.seq);if(h){this.pendingRequests.delete(k.seq);const c={type:"response",seq:0,request_seq:k.seq,success:!1,command:P,message:C.localize(0,null,r,P)};h(c)}},r)}return D&&this.pendingRequests.set(k.seq,D),k.seq}acceptMessage(P){this.messageCallback?this.messageCallback(P):(this.queue.push(P),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(P,_){return P.type!=="event"||_.type!=="event"}async processQueue(){let P;for(;this.queue.length;){if((!P||this.needsTaskBoundaryBetween(this.queue[0],P))&&await R.timeout(0),P=this.queue.shift(),!P)return;switch(P.type){case"event":this.eventCallback&&this.eventCallback(P);break;case"request":this.requestCallback&&this.requestCallback(P);break;case"response":const _=P,D=this.pendingRequests.get(_.request_seq);D&&(this.pendingRequests.delete(_.request_seq),D(_));break}}}internalSend(P,_){_.type=P,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const P=new Map;this.pendingRequests.forEach((_,D)=>P.set(D,_)),await R.timeout(500),P.forEach((_,D)=>{_({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(D)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=S}),define(pe[198],ve([0,1,8,2,9,25,10]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const P=/{([^}]+)}/g;function _(i,s,n){return i.replace(P,function(o,v){return s&&v.length>0&&v[0]!=="_"?o:n&&n.hasOwnProperty(v)?n[v]:o})}e.formatPII=_;function D(i){const s={};for(const n of Object.keys(i))n.startsWith("!")||(s[n]=i[n]);return s}e.filterExceptionsFromTelemetry=D;function r(i){return i.configuration.request==="attach"&&!k(i)&&(!i.parentSession||r(i.parentSession))}e.isSessionAttach=r;function k(i){let s=i.configuration.type;if(!!s)return s==="vslsShare"&&(s=i.configuration.adapterProxy.configuration.type),p.equalsIgnoreCase(s,"extensionhost")||p.equalsIgnoreCase(s,"pwa-extensionhost")?i:i.parentSession?k(i.parentSession):void 0}e.getExtensionHostDebugSession=k;function l(i){return i.type&&(i.label||i.program||i.runtime)}e.isDebuggerMainContribution=l;function h(i,s,n){let o,v=0,m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,E=null;for(;E=m.exec(i);){let y=E.index+1,a=y+E[0].length;if(y<=s&&a>=n){o=E[0],v=y;break}}if(o){let y=/\w+/g,a=null;for(;(a=y.exec(o))&&!(a.index+1+v+a[0].length>=n););a&&(o=o.substring(0,y.lastIndex))}return o?{start:v,end:v+o.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function f(i){return!!(i&&i.match(c))}e.isUri=f;function I(i){if(typeof i.path=="string"&&!(typeof i.sourceReference=="number"&&i.sourceReference>0)){if(f(i.path))return R.URI.parse(i.path);if(C.isAbsolute(i.path))return R.URI.file(i.path)}return i.path}function b(i){if(typeof i.path=="object"){const s=R.URI.revive(i.path);if(s)return s.scheme===A.Schemas.file?s.fsPath:s.toString()}return i.path}function w(i,s){const n=s?I:b,o=S.deepClone(i);return d(o,(v,m)=>{v&&m&&(m.path=n(m))}),o}e.convertToDAPaths=w;function u(i,s){const n=s?I:b,o=S.deepClone(i);return d(o,(v,m)=>{!v&&m&&(m.path=n(m))}),o}e.convertToVSCPaths=u;function d(i,s){switch(i.type){case"event":const n=i;switch(n.event){case"output":s(!1,n.body.source);break;case"loadedSource":s(!1,n.body.source);break;case"breakpoint":s(!1,n.body.breakpoint.source);break;default:break}break;case"request":const o=i;switch(o.command){case"setBreakpoints":s(!0,o.arguments.source);break;case"breakpointLocations":s(!0,o.arguments.source);break;case"source":s(!0,o.arguments.source);break;case"gotoTargets":s(!0,o.arguments.source);break;case"launchVSCode":o.arguments.args.forEach(m=>s(!1,m));break;default:break}break;case"response":const v=i;if(v.success&&v.body)switch(v.command){case"stackTrace":v.body.stackFrames.forEach(m=>s(!1,m.source));break;case"loadedSources":v.body.sources.forEach(m=>s(!1,m));break;case"scopes":v.body.scopes.forEach(m=>s(!1,m.source));break;case"setFunctionBreakpoints":v.body.breakpoints.forEach(m=>s(!1,m.source));break;case"setBreakpoints":v.body.breakpoints.forEach(m=>s(!1,m.source));break;default:break}break}}function g(i){return i.filter(s=>{var n;return!((n=s.presentation)===null||n===void 0?void 0:n.hidden)}).sort((s,n)=>s.presentation?n.presentation?s.presentation.group?n.presentation.group?s.presentation.group!==n.presentation.group?s.presentation.group.localeCompare(n.presentation.group):t(s.presentation.order,n.presentation.order):-1:n.presentation.group?1:t(s.presentation.order,n.presentation.order):-1:n.presentation?1:0)}e.getVisibleAndSorted=g;function t(i,s){return typeof i!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:i-s}}),define(pe[199],ve([0,1,28,38,167,121,9,8,25,11,177,120]),function(X,e,p,R,C,S,A,P,_,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class l extends k.AbstractDebugAdapter{constructor(){super();this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(w,u){this.outputStream=u,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,w.on("data",d=>this.handleData(d))}sendMessage(w){if(this.outputStream){const u=JSON.stringify(w);this.outputStream.write(`Content-Length: ${Buffer.byteLength(u,"utf8")}${l.TWO_CRLF}${u}`,"utf8")}}handleData(w){for(this.rawData=Buffer.concat([this.rawData,w]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const u=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,u.length>0)try{this.acceptMessage(JSON.parse(u))}catch(d){this._onError.fire(new Error((d.message||d)+`
`+u))}continue}}else{const u=this.rawData.indexOf(l.TWO_CRLF);if(u!==-1){const g=this.rawData.toString("utf8",0,u).split(l.HEADER_LINESEPARATOR);for(const t of g){const i=t.split(l.HEADER_FIELDSEPARATOR);i[0]==="Content-Length"&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(u+l.TWO_CRLF.length);continue}}break}}}e.StreamDebugAdapter=l,l.TWO_CRLF=`\r
\r
`,l.HEADER_LINESEPARATOR=/\r?\n/,l.HEADER_FIELDSEPARATOR=/: */;class h extends l{startSession(){return new Promise((w,u)=>{let d=!1;this.socket=this.createConnection(()=>{this.connect(this.socket,this.socket),w(),d=!0}),this.socket.on("close",()=>{d?this._onError.fire(new Error("connection closed")):u(new Error("connection closed"))}),this.socket.on("error",g=>{d?this._onError.fire(g):u(g)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}}e.NetworkDebugAdapter=h;class c extends h{constructor(w){super();this.adapterServer=w}createConnection(w){return S.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",w)}}e.SocketDebugAdapter=c;class f extends h{constructor(w){super();this.adapterServer=w}createConnection(w){return S.createConnection(this.adapterServer.path,w)}}e.NamedPipeDebugAdapter=f;class I extends l{constructor(w,u,d){super();this.adapterExecutable=w,this.debugType=u,this.outputService=d}async startSession(){const w=this.adapterExecutable.command,u=this.adapterExecutable.args,d=this.adapterExecutable.options||{};try{if(w)if(A.isAbsolute(w)){if(!await p.Promises.exists(w))throw new Error(C.localize(0,null,w))}else w.indexOf("/")<0&&w.indexOf("\\")<0;else throw new Error(C.localize(1,null,this.debugType));let g=process.env;if(d.env&&Object.keys(d.env).length>0&&(g=_.mixin(_.deepClone(process.env),d.env)),w==="node")if(Array.isArray(u)&&u.length>0){const i=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,s={env:g,execArgv:i?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};d.cwd&&(s.cwd=d.cwd);const n=R.fork(u[0],u.slice(1),s);if(!n.pid)throw new Error(C.localize(2,null,u[0]));this.serverProcess=n}else throw new Error(C.localize(3,null));else{const i={env:g};d.cwd&&(i.cwd=d.cwd),this.serverProcess=R.spawn(w,u,i)}this.serverProcess.on("error",i=>{this._onError.fire(i)}),this.serverProcess.on("exit",(i,s)=>{this._onExit.fire(i)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",i=>{this._onError.fire(i)}),this.serverProcess.stdin.on("error",i=>{this._onError.fire(i)});const t=this.outputService;if(t){const i=s=>s.toString().replace(/\r?\n$/mg,"");this.serverProcess.stderr.on("data",s=>{const n=t.getChannel(r.ExtensionsChannelId);n&&n.append(i(s))})}else this.serverProcess.stderr.resume();this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(g){this._onError.fire(g)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),D.isWindows?new Promise((w,u)=>{const d=R.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,function(g,t,i){if(g)return u(g)});d.on("exit",w),d.on("error",u)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(w,u){if(!w)return;const d=Object.create(null);w.runtime&&(w.runtime.indexOf("./")===0?d.runtime=A.join(u,w.runtime):d.runtime=w.runtime),w.runtimeArgs&&(d.runtimeArgs=w.runtimeArgs),w.program&&(A.isAbsolute(w.program)?d.program=w.program:d.program=A.join(u,w.program)),w.args&&(d.args=w.args);const g=w;return g.win&&(d.win=I.extract(g.win,u)),g.winx86&&(d.winx86=I.extract(g.winx86,u)),g.windows&&(d.windows=I.extract(g.windows,u)),g.osx&&(d.osx=I.extract(g.osx,u)),g.linux&&(d.linux=I.extract(g.linux,u)),d}static platformAdapterExecutable(w,u){let d=Object.create(null);u=u.toLowerCase();for(const o of w)if(o.contributes){const v=o.contributes.debuggers;v&&v.length>0&&v.filter(m=>typeof m.type=="string"&&P.equalsIgnoreCase(m.type,u)).forEach(m=>{const E=I.extract(m,o.extensionLocation.fsPath);d=_.mixin(d,E,o.isBuiltin)})}let g;D.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?g=d.winx86||d.win||d.windows:D.isWindows?g=d.win||d.windows:D.isMacintosh?g=d.osx:D.isLinux&&(g=d.linux),g=g||d;let t=g.program||d.program;const i=g.args||d.args;let s=g.runtime||d.runtime;const n=g.runtimeArgs||d.runtimeArgs;if(s)return{type:"executable",command:s,args:(n||[]).concat(typeof t=="string"?[t]:[]).concat(i||[])};if(t)return{type:"executable",command:t,args:i||[]}}}e.ExecutableDebugAdapter=I}),define(pe[200],ve([0,1,38,11,29,180]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=e.runInExternalTerminal=void 0;function A(l,h){return new Promise((c,f)=>{let I="";const b=p.spawn(l,h);b.pid&&b.stdout.on("data",w=>{I+=w.toString()}),b.on("error",w=>{f(w)}),b.on("close",w=>{c(I)})})}let P;function _(l,h){if(!P)if(R.isWindows)P=new S.WindowsExternalTerminalService;else if(R.isMacintosh)P=new S.MacExternalTerminalService;else if(R.isLinux)P=new S.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const c=h.getConfiguration("terminal");return P.runInTerminal(l.title,l.cwd,l.args,l.env||{},c.external||{})}e.runInExternalTerminal=_;function D(l){return l?R.isWindows?new Promise(async h=>{(await new Promise((f,I)=>{X(["windows-process-tree"],f,I)})).getProcessTree(l,f=>{h(f.children.length>0)})}):A("/usr/bin/pgrep",["-lP",String(l)]).then(h=>{const c=h.trim();return!(c.length===0||c.indexOf(" tmux")>=0)},h=>!0):Promise.resolve(!0)}e.hasChildProcesses=D;var r;(function(l){l[l.cmd=0]="cmd",l[l.powershell=1]="powershell",l[l.bash=2]="bash"})(r||(r={}));function k(l,h,c,f){l=l.trim().toLowerCase();let I;l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0?I=1:l.indexOf("cmd.exe")>=0?I=0:l.indexOf("bash")>=0?I=2:R.isWindows?I=0:I=2;let b,w=" ";switch(I){case 1:if(b=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),c){const d=C.getDriveLetter(c);d&&(w+=`${d}:; `),w+=`cd ${b(c)}; `}if(f)for(let d in f){const g=f[d];g===null?w+=`Remove-Item env:${d}; `:w+=`\${env:${d}}='${g}'; `}if(h.length>0){const d=b(h.shift());w+=d[0]==="'"?`& ${d} `:`${d} `;for(let g of h)w+=`${b(g)} `}break;case 0:if(b=d=>(d=d.replace(/\"/g,'""'),d.indexOf(" ")>=0||d.indexOf('"')>=0||d.length===0?`"${d}"`:d),c){const d=C.getDriveLetter(c);d&&(w+=`${d}: && `),w+=`cd ${b(c)} && `}if(f){w+='cmd /C "';for(let d in f){let g=f[d];g===null?w+=`set "${d}=" && `:(g=g.replace(/[\^\&\|\<\>]/g,t=>`^${t}`),w+=`set "${d}=${g}" && `)}}for(let d of h)w+=`${b(d)} `;f&&(w+='"');break;case 2:b=d=>(d=d.replace(/(["'\\\$])/g,"\\$1"),d.indexOf(" ")>=0||d.indexOf(";")>=0||d.length===0?`"${d}"`:d);const u=d=>/[^\w@%\/+=,.:^-]/.test(d)?`'${d.replace(/'/g,"'\\''")}'`:d;if(c&&(w+=`cd ${b(c)} ; `),f){w+="/usr/bin/env";for(let d in f){const g=f[d];g===null?w+=` -u ${u(d)}`:w+=` ${u(`${d}=${g}`)}`}w+=" "}for(let d of h)w+=`${b(d)} `;break}return w}e.prepareCommand=k}),define(pe[85],ve([0,1,30,98,10,9,11,112]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var D;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(D=e.NotebookRunState||(e.NotebookRunState={}));var r;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(r=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var l;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(l=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));var I;(function(a){a.scheme=C.Schemas.vscodeNotebookCell;const T=/^ch(\d{7,})/;function O(x,H){return x.with({scheme:a.scheme,fragment:`ch${H.toString().padStart(7,"0")}${x.scheme!==C.Schemas.file?x.scheme:""}`})}a.generate=O;function $(x){if(x.scheme!==a.scheme)return;const H=T.exec(x.fragment);return H?{handle:Number(H[1]),notebook:x.with({scheme:x.fragment.substr(H[0].length)||C.Schemas.file,fragment:null})}:void 0}a.parse=$;function Z(x){if(x.scheme!==C.Schemas.vscodeNotebookCellMetadata)return;const H=T.exec(x.fragment);return H?{handle:Number(H[1]),notebook:x.with({scheme:x.fragment.substr(H[0].length)||C.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=Z;function le(x,H,N){return x.with({scheme:N,fragment:`ch${H.toString().padStart(7,"0")}${x.scheme!==C.Schemas.file?x.scheme:""}`})}a.generateCellUri=le;function q(x,H){if(x.scheme!==H)return;const N=T.exec(x.fragment);return N?{handle:Number(N[1]),notebook:x.with({scheme:x.fragment.substr(N[0].length)||C.Schemas.file,fragment:null})}:void 0}a.parseCellUri=q})(I=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[R.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function w(a){var T,O;return(O=(T=b.get(a))===null||T===void 0?void 0:T.alwaysSecure)!==null&&O!==void 0?O:!1}e.mimeTypeIsAlwaysSecure=w;function u(a){var T,O;return(O=(T=b.get(a))===null||T===void 0?void 0:T.supportedByCore)!==null&&O!==void 0?O:!1}e.mimeTypeSupportedByCore=u;function d(a){var T,O;return(O=(T=b.get(a))===null||T===void 0?void 0:T.mergeable)!==null&&O!==void 0?O:!1}e.mimeTypeIsMergeable=d;function g(a,T){return A.isWindows&&(a=a.replace(/\//g,"\\"),T=T.replace(/\//g,"\\")),p.match(a,T)}function t(a,T,O){let $=0;for(let Z=0;Z<T.length;Z++){if(g(T[Z],a))return $;$++}for(let Z=0;Z<O.length;Z++){if(g(O[Z],a))return $;$++}return $}function i(a,T,O){return a.sort(($,Z)=>t($,T,O)-t(Z,T,O))}e.sortMimeTypes=i;function s(a,T,O,$=(Z,le)=>Z===le){const Z=[];function le(H,N,z){if(N===0&&z.length===0)return;const F=Z[Z.length-1];F&&F.start+F.deleteCount===H?(F.deleteCount+=N,F.toInsert.push(...z)):Z.push({start:H,deleteCount:N,toInsert:z})}let q=0,x=0;for(;;){if(q===a.length){le(q,0,T.slice(x));break}if(x===T.length){le(q,a.length-q,[]);break}const H=a[q],N=T[x];if($(H,N)){q+=1,x+=1;continue}O(N)?(le(q,1,[]),q+=1):(le(q,0,[N]),x+=1)}return Z}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var n;(function(a){a.default="default",a.option="option"})(n=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function o(a){const T=a;return!!((typeof T.include=="string"||p.isRelativePattern(T.include))&&(typeof T.exclude=="string"||p.isRelativePattern(T.exclude)))}e.isDocumentExcludePattern=o;function v(a,T,O){if(Array.isArray(a.viewType)&&a.viewType.indexOf(T)>=0||a.viewType===T)return!0;if(a.filenamePattern){let $=o(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,Z=o(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(p.match($,S.basename(O.fsPath).toLowerCase()))return!(Z&&p.match(Z,S.basename(O.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=v;class m{constructor(T){this.textModel=T}getElements(){const T=new Int32Array(this.textModel.cells.length);for(let O=0;O<this.textModel.cells.length;O++)T[O]=this.textModel.cells[O].getHashValue();return T}}e.CellSequence=m,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var E;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(E=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class y{static create(T){return`${y._prefix}${T}`}static parse(T){if(T.startsWith(y._prefix))return T.substr(y._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=y,y._prefix="notebook/"}),define(pe[201],ve([0,1,169,4,112]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new C.RawContextKey("customExecutionSupported",!0,p.localize(0,null)),e.ShellExecutionSupportedContext=new C.RawContextKey("shellExecutionSupported",!1,p.localize(1,null)),e.ProcessExecutionSupportedContext=new C.RawContextKey("processExecutionSupported",!1,p.localize(2,null)),e.ITaskService=R.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(pe[202],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function p(C){return[...C.entries()]}e.serializeEnvironmentVariableCollection=p;function R(C){return new Map(C)}e.deserializeEnvironmentVariableCollection=R}),define(pe[122],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var p;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(p=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(_,D)=>{D.expand!==void 0&&(_.expand=D.expand),D.item!==void 0&&(_.item=_.item?Object.assign(_.item,D.item):D.item)};e.applyTestItemUpdate=R;var C;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire"})(C=e.TestDiffOpType||(e.TestDiffOpType={}));const S=(_,D)=>`${_}:${D.toString()}`;e.getTestSubscriptionKey=S;class A{add(D){}update(D){}remove(D,r){}complete(){}}e.IncrementalChangeCollector=A;class P{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(D){const r=this.createChangeCollector();for(const k of D)switch(k[0]){case 0:{const l=k[1];if(l.parent){if(this.items.has(l.parent)){const h=this.items.get(l.parent);h.children.add(l.item.extId);const c=this.createItem(l,h);this.items.set(l.item.extId,c),r.add(c)}}else{this.roots.add(l.item.extId);const h=this.createItem(l);this.items.set(l.item.extId,h),r.add(h)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=k[1],h=this.items.get(l.extId);if(!h)break;l.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(h,l),r.update(h);break}case 2:{const l=this.items.get(k[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l.item.extId);const h=[[k[1]]];for(;h.length;)for(const c of h.pop()){const f=this.items.get(c);f&&(h.push(f.children),this.items.delete(c),r.remove(f,f!==l),f.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(k[1]);break;case 3:this.updatePendingRoots(k[1]);break}r.complete()}retireTest(D){}updatePendingRoots(D){this.pendingRootCount+=D}createChangeCollector(){return new A}}e.AbstractIncrementalTestCollection=P}),define(pe[203],ve([0,1,9,37,15,25,11,75,170]),function(X,e,p,R,C,S,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class D{constructor(k,l,h){this._contributedVariables=new Map,this._context=k,this._labelService=l,h&&(this._envVariablesPromise=h.then(c=>this.prepareEnv(c)))}prepareEnv(k){if(A.isWindows){const l=Object.create(null);return Object.keys(k).forEach(h=>{l[h.toLowerCase()]=k[h]}),l}return k}resolveWithEnvironment(k,l,h){return this.recursiveResolve(this.prepareEnv(k),l?l.uri:void 0,h)}async resolveAsync(k,l){return this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,l)}async resolveAnyBase(k,l,h,c){const f=S.deepClone(l);return A.isWindows&&f.windows?Object.keys(f.windows).forEach(I=>f[I]=f.windows[I]):A.isMacintosh&&f.osx?Object.keys(f.osx).forEach(I=>f[I]=f.osx[I]):A.isLinux&&f.linux&&Object.keys(f.linux).forEach(I=>f[I]=f.linux[I]),delete f.windows,delete f.osx,delete f.linux,this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,f,h,c)}async resolveAnyAsync(k,l,h){return this.resolveAnyBase(k,l,h)}async resolveAnyMap(k,l,h){const c=new Map;return{newConfig:await this.resolveAnyBase(k,l,h,c),resolvedVariables:c}}resolveWithInteractionReplace(k,l,h,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,l,h,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,l){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,l)}recursiveResolve(k,l,h,c,f){if(C.isString(h))return this.resolveString(k,l,h,c,f);if(C.isArray(h))return h.map(I=>this.recursiveResolve(k,l,I,c,f));if(C.isObject(h)){let I=Object.create(null);return Object.keys(h).forEach(b=>{const w=this.resolveString(k,l,b,c,f);I[w]=this.recursiveResolve(k,l,h[b],c,f)}),I}return h}resolveString(k,l,h,c,f){return h.replace(D.VARIABLE_REGEXP,(b,w)=>{if(w.includes(D.VARIABLE_LHS))return b;let u=this.evaluateSingleVariable(k,b,w,l,c);return f&&f.set(w,u),u!==b&&C.isString(u)&&u.match(D.VARIABLE_REGEXP)&&(u=this.resolveString(k,l,u,c,f)),u})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,l,h,c,f){let I;const b=h.split(":");b.length>1&&(h=b[0],I=b[1]);const w=()=>{const g=this._context.getFilePath();if(g)return g;throw new Error(_.localize(0,null,l))},u=()=>{const g=w();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(_.localize(1,null,l,p.basename(g)))},d=()=>{if(I){const g=this._context.getFolderUri(I);if(g)return g;throw new Error(_.localize(2,null,l,I))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(_.localize(3,null,l)):new Error(_.localize(4,null,l))};switch(h){case"env":if(I){if(k){const g=k[A.isWindows?I.toLowerCase():I];if(C.isString(g))return g}return""}throw new Error(_.localize(5,null,l));case"config":if(I){const g=this._context.getConfigurationValue(c,I);if(C.isUndefinedOrNull(g))throw new Error(_.localize(6,null,l,I));if(C.isObject(g))throw new Error(_.localize(7,null,l,I));return g}throw new Error(_.localize(8,null,l));case"command":return this.resolveFromMap(l,I,f,"command");case"input":return this.resolveFromMap(l,I,f,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return P.normalizeDriveLetter(this.fsPath(d()));case"cwd":return c||I?P.normalizeDriveLetter(this.fsPath(d())):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return p.basename(this.fsPath(d()));case"lineNumber":const g=this._context.getLineNumber();if(g)return g;throw new Error(_.localize(9,null,l));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(_.localize(10,null,l));case"file":return w();case"fileWorkspaceFolder":return u();case"relativeFile":return c||I?p.relative(this.fsPath(d()),w()):w();case"relativeFileDirname":const i=p.dirname(w());if(c||I){const v=p.relative(this.fsPath(d()),i);return v.length===0?".":v}return i;case"fileDirname":return p.dirname(w());case"fileExtname":return p.extname(w());case"fileBasename":return p.basename(w());case"fileBasenameNoExtension":const s=p.basename(w());return s.slice(0,s.length-p.extname(s).length);case"fileDirnameBasename":return p.basename(p.dirname(w()));case"execPath":const n=this._context.getExecPath();return n||l;case"execInstallFolder":const o=this._context.getAppRoot();return o||l;case"pathSeparator":return p.sep;default:try{const v=I?`${h}:${I}`:h;return this.resolveFromMap(l,v,f,void 0)}catch(v){return l}}}}resolveFromMap(k,l,h,c){if(l&&h){const f=c===void 0?h[l]:h[c+":"+l];if(typeof f=="string")return f;throw new Error(_.localize(11,null,k))}return k}}e.AbstractVariableResolverService=D,D.VARIABLE_LHS="${",D.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(pe[204],ve([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=p.createDecorator("editorGroupsService");var R;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(R=e.GroupDirection||(e.GroupDirection={}));var C;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(C=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var A;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var P;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(P=e.MergeGroupMode||(e.MergeGroupMode={}));var _;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(_=e.GroupsOrder||(e.GroupsOrder={}));var D;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.EDITOR_OPEN=2]="EDITOR_OPEN",l[l.EDITOR_CLOSE=3]="EDITOR_CLOSE",l[l.EDITOR_MOVE=4]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=6]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=8]="EDITOR_PIN",l[l.EDITOR_STICKY=9]="EDITOR_STICKY",l[l.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(D=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function k(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(pe[205],ve([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=p.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(pe[17],ve([0,1,18,95,278,55,25,15,2,41,78,171,114,85,205,7]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var I;(function(Ee){function Ce(K){const{selectionStartLineNumber:Be,selectionStartColumn:Fe,positionLineNumber:Me,positionColumn:nt}=K,ot=new f.Position(Be-1,Fe-1),tt=new f.Position(Me-1,nt-1);return new f.Selection(ot,tt)}Ee.to=Ce;function ue(K){const{anchor:Be,active:Fe}=K;return{selectionStartLineNumber:Be.line+1,selectionStartColumn:Be.character+1,positionLineNumber:Fe.line+1,positionColumn:Fe.character+1}}Ee.from=ue})(I=e.Selection||(e.Selection={}));var b;(function(Ee){function Ce(K){if(!K)return;const{start:Be,end:Fe}=K;return{startLineNumber:Be.line+1,startColumn:Be.character+1,endLineNumber:Fe.line+1,endColumn:Fe.character+1}}Ee.from=Ce;function ue(K){if(!K)return;const{startLineNumber:Be,startColumn:Fe,endLineNumber:Me,endColumn:nt}=K;return new f.Range(Be-1,Fe-1,Me-1,nt-1)}Ee.to=ue})(b=e.Range||(e.Range={}));var w;(function(Ee){function Ce(ue){switch(ue){case 1:return f.StandardTokenType.Comment;case 0:return f.StandardTokenType.Other;case 4:return f.StandardTokenType.RegEx;case 2:return f.StandardTokenType.String}}Ee.to=Ce})(w=e.TokenType||(e.TokenType={}));var u;(function(Ee){function Ce(K){return new f.Position(K.lineNumber-1,K.column-1)}Ee.to=Ce;function ue(K){return{lineNumber:K.line+1,column:K.character+1}}Ee.from=ue})(u=e.Position||(e.Position={}));var d;(function(Ee){function Ce(K){switch(K){case f.DiagnosticTag.Unnecessary:return 1;case f.DiagnosticTag.Deprecated:return 2}}Ee.from=Ce;function ue(K){switch(K){case 1:return f.DiagnosticTag.Unnecessary;case 2:return f.DiagnosticTag.Deprecated;default:return}}Ee.to=ue})(d=e.DiagnosticTag||(e.DiagnosticTag={}));var g;(function(Ee){function Ce(K){let Be;return K.code&&(P.isString(K.code)||P.isNumber(K.code)?Be=String(K.code):Be={value:String(K.code.value),target:K.code.target}),Object.assign(Object.assign({},b.from(K.range)),{message:K.message,source:K.source,code:Be,severity:i.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(t.from),tags:Array.isArray(K.tags)?p.coalesce(K.tags.map(d.from)):void 0})}Ee.from=Ce;function ue(K){var Be;const Fe=new f.Diagnostic(b.to(K),K.message,i.to(K.severity));return Fe.source=K.source,Fe.code=P.isString(K.code)?K.code:(Be=K.code)===null||Be===void 0?void 0:Be.value,Fe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(t.to),Fe.tags=K.tags&&p.coalesce(K.tags.map(d.to)),Fe}Ee.to=ue})(g=e.Diagnostic||(e.Diagnostic={}));var t;(function(Ee){function Ce(K){return Object.assign(Object.assign({},b.from(K.location.range)),{message:K.message,resource:K.location.uri})}Ee.from=Ce;function ue(K){return new f.DiagnosticRelatedInformation(new f.Location(K.resource,b.to(K)),K.message)}Ee.to=ue})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(Ee){function Ce(K){switch(K){case f.DiagnosticSeverity.Error:return l.MarkerSeverity.Error;case f.DiagnosticSeverity.Warning:return l.MarkerSeverity.Warning;case f.DiagnosticSeverity.Information:return l.MarkerSeverity.Info;case f.DiagnosticSeverity.Hint:return l.MarkerSeverity.Hint}return l.MarkerSeverity.Error}Ee.from=Ce;function ue(K){switch(K){case l.MarkerSeverity.Info:return f.DiagnosticSeverity.Information;case l.MarkerSeverity.Warning:return f.DiagnosticSeverity.Warning;case l.MarkerSeverity.Error:return f.DiagnosticSeverity.Error;case l.MarkerSeverity.Hint:return f.DiagnosticSeverity.Hint;default:return f.DiagnosticSeverity.Error}}Ee.to=ue})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(Ee){function Ce(K){return typeof K=="number"&&K>=f.ViewColumn.One?K-1:K===f.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}Ee.from=Ce;function ue(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Ee.to=ue})(s=e.ViewColumn||(e.ViewColumn={}));function n(Ee){return typeof Ee.range!="undefined"}function o(Ee){return Ee.length===0?!0:!!n(Ee[0])}e.isDecorationOptionsArr=o;var v;(function(Ee){function Ce(nt){return nt.map(Ee.from)}Ee.fromMany=Ce;function ue(nt){return nt&&typeof nt=="object"&&typeof nt.language=="string"&&typeof nt.value=="string"}function K(nt){let ot;if(ue(nt)){const{language:pt,value:bt}=nt;ot={value:"```"+pt+`
`+bt+"\n```\n"}}else f.MarkdownString.isMarkdownString(nt)?ot={value:nt.value,isTrusted:nt.isTrusted,supportThemeIcons:nt.supportThemeIcons}:typeof nt=="string"?ot={value:nt}:ot={value:""};const tt=Object.create(null);ot.uris=tt;const vt=pt=>{try{let bt=_.URI.parse(pt,!0);bt=bt.with({query:Be(bt.query,tt)}),tt[pt]=bt}catch(bt){}return""},gt=new C.Renderer;return gt.link=vt,gt.image=pt=>vt(R.parseHrefAndDimensions(pt).href),C(ot.value,{renderer:gt}),ot}Ee.from=K;function Be(nt,ot){if(!nt)return nt;let tt;try{tt=S.parse(nt)}catch(gt){}if(!tt)return nt;let vt=!1;return tt=A.cloneAndChange(tt,gt=>{if(_.URI.isUri(gt)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[pt]=gt,vt=!0,pt}else return}),vt?JSON.stringify(tt):nt}function Fe(nt){const ot=new f.MarkdownString(nt.value,nt.supportThemeIcons);return ot.isTrusted=nt.isTrusted,ot}Ee.to=Fe;function Me(nt){if(!!nt)return typeof nt=="string"?nt:Ee.from(nt)}Ee.fromStrict=Me})(v=e.MarkdownString||(e.MarkdownString={}));function m(Ee){return o(Ee)?Ee.map(Ce=>({range:b.from(Ce.range),hoverMessage:Array.isArray(Ce.hoverMessage)?v.fromMany(Ce.hoverMessage):Ce.hoverMessage?v.from(Ce.hoverMessage):void 0,renderOptions:Ce.renderOptions})):Ee.map(Ce=>({range:b.from(Ce)}))}e.fromRangeOrRangeWithMessage=m;function E(Ee){return typeof Ee=="undefined"?Ee:typeof Ee=="string"?_.URI.file(Ee):Ee}e.pathOrURIToURI=E;var y;(function(Ee){function Ce(ue){return typeof ue=="undefined"?ue:{contentText:ue.contentText,contentIconPath:ue.contentIconPath?E(ue.contentIconPath):void 0,border:ue.border,borderColor:ue.borderColor,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,color:ue.color,backgroundColor:ue.backgroundColor,margin:ue.margin,width:ue.width,height:ue.height}}Ee.from=Ce})(y=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(Ee){function Ce(ue){return typeof ue=="undefined"?ue:{backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?E(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?y.from(ue.before):void 0,after:ue.after?y.from(ue.after):void 0}}Ee.from=Ce})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var T;(function(Ee){function Ce(ue){if(typeof ue=="undefined")return ue;switch(ue){case f.DecorationRangeBehavior.OpenOpen:return 0;case f.DecorationRangeBehavior.ClosedClosed:return 1;case f.DecorationRangeBehavior.OpenClosed:return 2;case f.DecorationRangeBehavior.ClosedOpen:return 3}}Ee.from=Ce})(T=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var O;(function(Ee){function Ce(ue){return{isWholeLine:ue.isWholeLine,rangeBehavior:ue.rangeBehavior?T.from(ue.rangeBehavior):void 0,overviewRulerLane:ue.overviewRulerLane,light:ue.light?a.from(ue.light):void 0,dark:ue.dark?a.from(ue.dark):void 0,backgroundColor:ue.backgroundColor,outline:ue.outline,outlineColor:ue.outlineColor,outlineStyle:ue.outlineStyle,outlineWidth:ue.outlineWidth,border:ue.border,borderColor:ue.borderColor,borderRadius:ue.borderRadius,borderSpacing:ue.borderSpacing,borderStyle:ue.borderStyle,borderWidth:ue.borderWidth,fontStyle:ue.fontStyle,fontWeight:ue.fontWeight,textDecoration:ue.textDecoration,cursor:ue.cursor,color:ue.color,opacity:ue.opacity,letterSpacing:ue.letterSpacing,gutterIconPath:ue.gutterIconPath?E(ue.gutterIconPath):void 0,gutterIconSize:ue.gutterIconSize,overviewRulerColor:ue.overviewRulerColor,before:ue.before?y.from(ue.before):void 0,after:ue.after?y.from(ue.after):void 0}}Ee.from=Ce})(O=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var $;(function(Ee){function Ce(K){return{text:K.newText,eol:K.newEol&&Q.from(K.newEol),range:b.from(K.range)}}Ee.from=Ce;function ue(K){const Be=new f.TextEdit(b.to(K.range),K.text);return Be.newEol=typeof K.eol=="undefined"?void 0:Q.to(K.eol),Be}Ee.to=ue})($=e.TextEdit||(e.TextEdit={}));var Z;(function(Ee){function Ce(K,Be,Fe){var Me,nt;const ot={edits:[]};if(K instanceof f.WorkspaceEdit)for(let tt of K._allEntries())if(tt._type===1)ot.edits.push({_type:1,oldUri:tt.from,newUri:tt.to,options:tt.options,metadata:tt.metadata});else if(tt._type===2){const vt=Be==null?void 0:Be.getDocument(tt.uri);ot.edits.push({_type:2,resource:tt.uri,edit:$.from(tt.edit),modelVersionId:vt==null?void 0:vt.version,metadata:tt.metadata})}else tt._type===3?ot.edits.push({_type:3,metadata:tt.metadata,resource:tt.uri,edit:tt.edit,notebookMetadata:tt.notebookMetadata,notebookVersionId:(Me=Fe==null?void 0:Fe.getNotebookDocument(tt.uri,!0))===null||Me===void 0?void 0:Me.apiNotebook.version}):tt._type===5&&ot.edits.push({_type:3,metadata:tt.metadata,resource:tt.uri,notebookVersionId:(nt=Fe==null?void 0:Fe.getNotebookDocument(tt.uri,!0))===null||nt===void 0?void 0:nt.apiNotebook.version,edit:{editType:1,index:tt.index,count:tt.count,cells:tt.cells.map(W.from)}});return ot}Ee.from=Ce;function ue(K){const Be=new f.WorkspaceEdit;for(const Fe of K.edits)Fe.edit?Be.replace(_.URI.revive(Fe.resource),b.to(Fe.edit.range),Fe.edit.text):Be.renameFile(_.URI.revive(Fe.oldUri),_.URI.revive(Fe.newUri),Fe.options);return Be}Ee.to=ue})(Z=e.WorkspaceEdit||(e.WorkspaceEdit={}));var le;(function(Ee){const Ce=Object.create(null);Ce[f.SymbolKind.File]=0,Ce[f.SymbolKind.Module]=1,Ce[f.SymbolKind.Namespace]=2,Ce[f.SymbolKind.Package]=3,Ce[f.SymbolKind.Class]=4,Ce[f.SymbolKind.Method]=5,Ce[f.SymbolKind.Property]=6,Ce[f.SymbolKind.Field]=7,Ce[f.SymbolKind.Constructor]=8,Ce[f.SymbolKind.Enum]=9,Ce[f.SymbolKind.Interface]=10,Ce[f.SymbolKind.Function]=11,Ce[f.SymbolKind.Variable]=12,Ce[f.SymbolKind.Constant]=13,Ce[f.SymbolKind.String]=14,Ce[f.SymbolKind.Number]=15,Ce[f.SymbolKind.Boolean]=16,Ce[f.SymbolKind.Array]=17,Ce[f.SymbolKind.Object]=18,Ce[f.SymbolKind.Key]=19,Ce[f.SymbolKind.Null]=20,Ce[f.SymbolKind.EnumMember]=21,Ce[f.SymbolKind.Struct]=22,Ce[f.SymbolKind.Event]=23,Ce[f.SymbolKind.Operator]=24,Ce[f.SymbolKind.TypeParameter]=25;function ue(Be){return typeof Ce[Be]=="number"?Ce[Be]:6}Ee.from=ue;function K(Be){for(const Fe in Ce)if(Ce[Fe]===Be)return Number(Fe);return f.SymbolKind.Property}Ee.to=K})(le=e.SymbolKind||(e.SymbolKind={}));var q;(function(Ee){function Ce(K){switch(K){case f.SymbolTag.Deprecated:return 1}}Ee.from=Ce;function ue(K){switch(K){case 1:return f.SymbolTag.Deprecated}}Ee.to=ue})(q=e.SymbolTag||(e.SymbolTag={}));var x;(function(Ee){function Ce(K){return{name:K.name,kind:le.from(K.kind),tags:K.tags&&K.tags.map(q.from),containerName:K.containerName,location:M.from(K.location)}}Ee.from=Ce;function ue(K){const Be=new f.SymbolInformation(K.name,le.to(K.kind),K.containerName,M.to(K.location));return Be.tags=K.tags&&K.tags.map(q.to),Be}Ee.to=ue})(x=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var H;(function(Ee){function Ce(K){var Be,Fe;const Me={name:K.name||"!!MISSING: name!!",detail:K.detail,range:b.from(K.range),selectionRange:b.from(K.selectionRange),kind:le.from(K.kind),tags:(Fe=(Be=K.tags)===null||Be===void 0?void 0:Be.map(q.from))!==null&&Fe!==void 0?Fe:[]};return K.children&&(Me.children=K.children.map(Ce)),Me}Ee.from=Ce;function ue(K){const Be=new f.DocumentSymbol(K.name,K.detail,le.to(K.kind),b.to(K.range),b.to(K.selectionRange));return p.isNonEmptyArray(K.tags)&&(Be.tags=K.tags.map(q.to)),K.children&&(Be.children=K.children.map(ue)),Be}Ee.to=ue})(H=e.DocumentSymbol||(e.DocumentSymbol={}));var N;(function(Ee){function Ce(ue){const K=new f.CallHierarchyItem(le.to(ue.kind),ue.name,ue.detail||"",_.URI.revive(ue.uri),b.to(ue.range),b.to(ue.selectionRange));return K._sessionId=ue._sessionId,K._itemId=ue._itemId,K}Ee.to=Ce})(N=e.CallHierarchyItem||(e.CallHierarchyItem={}));var z;(function(Ee){function Ce(ue){return new f.CallHierarchyIncomingCall(N.to(ue.from),ue.fromRanges.map(K=>b.to(K)))}Ee.to=Ce})(z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var F;(function(Ee){function Ce(ue){return new f.CallHierarchyOutgoingCall(N.to(ue.to),ue.fromRanges.map(K=>b.to(K)))}Ee.to=Ce})(F=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var M;(function(Ee){function Ce(K){return{range:K.range&&b.from(K.range),uri:K.uri}}Ee.from=Ce;function ue(K){return new f.Location(_.URI.revive(K.uri),b.to(K.range))}Ee.to=ue})(M=e.location||(e.location={}));var L;(function(Ee){function Ce(K){const Be=K,Fe=K;return{originSelectionRange:Be.originSelectionRange?b.from(Be.originSelectionRange):void 0,uri:Be.targetUri?Be.targetUri:Fe.uri,range:b.from(Be.targetRange?Be.targetRange:Fe.range),targetSelectionRange:Be.targetSelectionRange?b.from(Be.targetSelectionRange):void 0}}Ee.from=Ce;function ue(K){return{targetUri:_.URI.revive(K.uri),targetRange:b.to(K.range),targetSelectionRange:K.targetSelectionRange?b.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?b.to(K.originSelectionRange):void 0}}Ee.to=ue})(L=e.DefinitionLink||(e.DefinitionLink={}));var U;(function(Ee){function Ce(K){return{range:b.from(K.range),contents:v.fromMany(K.contents)}}Ee.from=Ce;function ue(K){return new f.Hover(K.contents.map(v.to),b.to(K.range))}Ee.to=ue})(U=e.Hover||(e.Hover={}));var G;(function(Ee){function Ce(K){return{range:b.from(K.range),expression:K.expression}}Ee.from=Ce;function ue(K){return new f.EvaluatableExpression(b.to(K.range),K.expression)}Ee.to=ue})(G=e.EvaluatableExpression||(e.EvaluatableExpression={}));var te;(function(Ee){function Ce(K){if(K instanceof f.InlineValueText)return{type:"text",range:b.from(K.range),text:K.text};if(K instanceof f.InlineValueVariableLookup)return{type:"variable",range:b.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof f.InlineValueEvaluatableExpression)return{type:"expression",range:b.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Ee.from=Ce;function ue(K){switch(K.type){case"text":return{range:b.to(K.range),text:K.text};case"variable":return{range:b.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:b.to(K.range),expression:K.expression}}}Ee.to=ue})(te=e.InlineValue||(e.InlineValue={}));var me;(function(Ee){function Ce(K){return{frameId:K.frameId,stoppedLocation:b.from(K.stoppedLocation)}}Ee.from=Ce;function ue(K){return new f.InlineValueContext(K.frameId,b.to(K.stoppedLocation))}Ee.to=ue})(me=e.InlineValueContext||(e.InlineValueContext={}));var Se;(function(Ee){function Ce(K){return{range:b.from(K.range),kind:K.kind}}Ee.from=Ce;function ue(K){return new f.DocumentHighlight(b.to(K.range),K.kind)}Ee.to=ue})(Se=e.DocumentHighlight||(e.DocumentHighlight={}));var ye;(function(Ee){function Ce(ue){switch(ue){case 1:return f.CompletionTriggerKind.TriggerCharacter;case 2:return f.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return f.CompletionTriggerKind.Invoke}}Ee.to=Ce})(ye=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Le;(function(Ee){function Ce(ue){return{triggerKind:ye.to(ue.triggerKind),triggerCharacter:ue.triggerCharacter}}Ee.to=Ce})(Le=e.CompletionContext||(e.CompletionContext={}));var je;(function(Ee){function Ce(K){switch(K){case f.CompletionItemTag.Deprecated:return 1}}Ee.from=Ce;function ue(K){switch(K){case 1:return f.CompletionItemTag.Deprecated}}Ee.to=ue})(je=e.CompletionItemTag||(e.CompletionItemTag={}));var ze;(function(Ee){const Ce=new Map([[f.CompletionItemKind.Method,0],[f.CompletionItemKind.Function,1],[f.CompletionItemKind.Constructor,2],[f.CompletionItemKind.Field,3],[f.CompletionItemKind.Variable,4],[f.CompletionItemKind.Class,5],[f.CompletionItemKind.Interface,7],[f.CompletionItemKind.Struct,6],[f.CompletionItemKind.Module,8],[f.CompletionItemKind.Property,9],[f.CompletionItemKind.Unit,12],[f.CompletionItemKind.Value,13],[f.CompletionItemKind.Constant,14],[f.CompletionItemKind.Enum,15],[f.CompletionItemKind.EnumMember,16],[f.CompletionItemKind.Keyword,17],[f.CompletionItemKind.Snippet,27],[f.CompletionItemKind.Text,18],[f.CompletionItemKind.Color,19],[f.CompletionItemKind.File,20],[f.CompletionItemKind.Reference,21],[f.CompletionItemKind.Folder,23],[f.CompletionItemKind.Event,10],[f.CompletionItemKind.Operator,11],[f.CompletionItemKind.TypeParameter,24],[f.CompletionItemKind.Issue,26],[f.CompletionItemKind.User,25]]);function ue(Fe){var Me;return(Me=Ce.get(Fe))!==null&&Me!==void 0?Me:9}Ee.from=ue;const K=new Map([[0,f.CompletionItemKind.Method],[1,f.CompletionItemKind.Function],[2,f.CompletionItemKind.Constructor],[3,f.CompletionItemKind.Field],[4,f.CompletionItemKind.Variable],[5,f.CompletionItemKind.Class],[7,f.CompletionItemKind.Interface],[6,f.CompletionItemKind.Struct],[8,f.CompletionItemKind.Module],[9,f.CompletionItemKind.Property],[12,f.CompletionItemKind.Unit],[13,f.CompletionItemKind.Value],[14,f.CompletionItemKind.Constant],[15,f.CompletionItemKind.Enum],[16,f.CompletionItemKind.EnumMember],[17,f.CompletionItemKind.Keyword],[27,f.CompletionItemKind.Snippet],[18,f.CompletionItemKind.Text],[19,f.CompletionItemKind.Color],[20,f.CompletionItemKind.File],[21,f.CompletionItemKind.Reference],[23,f.CompletionItemKind.Folder],[10,f.CompletionItemKind.Event],[11,f.CompletionItemKind.Operator],[24,f.CompletionItemKind.TypeParameter],[25,f.CompletionItemKind.User],[26,f.CompletionItemKind.Issue]]);function Be(Fe){var Me;return(Me=K.get(Fe))!==null&&Me!==void 0?Me:f.CompletionItemKind.Property}Ee.to=Be})(ze=e.CompletionItemKind||(e.CompletionItemKind={}));var Ge;(function(Ee){function Ce(ue,K){var Be;const Fe=new f.CompletionItem(typeof ue.label=="string"?ue.label:ue.label.name);return typeof ue.label!="string"&&(Fe.label2=ue.label),Fe.insertText=ue.insertText,Fe.kind=ze.to(ue.kind),Fe.tags=(Be=ue.tags)===null||Be===void 0?void 0:Be.map(je.to),Fe.detail=ue.detail,Fe.documentation=R.isMarkdownString(ue.documentation)?v.to(ue.documentation):ue.documentation,Fe.sortText=ue.sortText,Fe.filterText=ue.filterText,Fe.preselect=ue.preselect,Fe.commitCharacters=ue.commitCharacters,D.Range.isIRange(ue.range)?Fe.range=b.to(ue.range):typeof ue.range=="object"&&(Fe.range={inserting:b.to(ue.range.insert),replacing:b.to(ue.range.replace)}),Fe.keepWhitespace=typeof ue.insertTextRules=="undefined"?!1:Boolean(ue.insertTextRules&1),typeof ue.insertTextRules!="undefined"&&ue.insertTextRules&4?Fe.insertText=new f.SnippetString(ue.insertText):(Fe.insertText=ue.insertText,Fe.textEdit=Fe.range instanceof f.Range?new f.TextEdit(Fe.range,Fe.insertText):void 0),ue.additionalTextEdits&&ue.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ue.additionalTextEdits.map(Me=>$.to(Me))),Fe.command=K&&ue.command?K.fromInternal(ue.command):void 0,Fe}Ee.to=Ce})(Ge=e.CompletionItem||(e.CompletionItem={}));var j;(function(Ee){function Ce(K){return{label:K.label,documentation:K.documentation?v.fromStrict(K.documentation):void 0}}Ee.from=Ce;function ue(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?v.to(K.documentation):K.documentation}}Ee.to=ue})(j=e.ParameterInformation||(e.ParameterInformation={}));var Y;(function(Ee){function Ce(K){return{label:K.label,documentation:K.documentation?v.fromStrict(K.documentation):void 0,parameters:Array.isArray(K.parameters)?K.parameters.map(j.from):[],activeParameter:K.activeParameter}}Ee.from=Ce;function ue(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?v.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(j.to):[],activeParameter:K.activeParameter}}Ee.to=ue})(Y=e.SignatureInformation||(e.SignatureInformation={}));var ie;(function(Ee){function Ce(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Y.from):[]}}Ee.from=Ce;function ue(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(Y.to):[]}}Ee.to=ue})(ie=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(Ee){function Ce(K){var Be;return{text:K.text,position:u.from(K.position),kind:J.from((Be=K.kind)!==null&&Be!==void 0?Be:f.InlayHintKind.Other),whitespaceBefore:K.whitespaceBefore,whitespaceAfter:K.whitespaceAfter}}Ee.from=Ce;function ue(K){const Be=new f.InlayHint(K.text,u.to(K.position),J.to(K.kind));return Be.whitespaceAfter=K.whitespaceAfter,Be.whitespaceBefore=K.whitespaceBefore,Be}Ee.to=ue})(re=e.InlayHint||(e.InlayHint={}));var J;(function(Ee){function Ce(K){return K}Ee.from=Ce;function ue(K){return K}Ee.to=ue})(J=e.InlayHintKind||(e.InlayHintKind={}));var ce;(function(Ee){function Ce(K){return{range:b.from(K.range),url:K.target,tooltip:K.tooltip}}Ee.from=Ce;function ue(K){let Be;if(K.url)try{Be=typeof K.url=="string"?_.URI.parse(K.url,!0):_.URI.revive(K.url)}catch(Fe){}return new f.DocumentLink(b.to(K.range),Be)}Ee.to=ue})(ce=e.DocumentLink||(e.DocumentLink={}));var ge;(function(Ee){function Ce(K){const Be=new f.ColorPresentation(K.label);return K.textEdit&&(Be.textEdit=$.to(K.textEdit)),K.additionalTextEdits&&(Be.additionalTextEdits=K.additionalTextEdits.map(Fe=>$.to(Fe))),Be}Ee.to=Ce;function ue(K){return{label:K.label,textEdit:K.textEdit?$.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Be=>$.from(Be)):void 0}}Ee.from=ue})(ge=e.ColorPresentation||(e.ColorPresentation={}));var Re;(function(Ee){function Ce(K){return new f.Color(K[0],K[1],K[2],K[3])}Ee.to=Ce;function ue(K){return[K.red,K.green,K.blue,K.alpha]}Ee.from=ue})(Re=e.Color||(e.Color={}));var He;(function(Ee){function Ce(K){return{range:b.from(K.range)}}Ee.from=Ce;function ue(K){return new f.SelectionRange(b.to(K.range))}Ee.to=ue})(He=e.SelectionRange||(e.SelectionRange={}));var be;(function(Ee){function Ce(ue){switch(ue){case 2:return f.TextDocumentSaveReason.AfterDelay;case 1:return f.TextDocumentSaveReason.Manual;case 3:case 4:return f.TextDocumentSaveReason.FocusOut}}Ee.to=Ce})(be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Qe;(function(Ee){function Ce(K){switch(K){case f.TextEditorLineNumbersStyle.Off:return 0;case f.TextEditorLineNumbersStyle.Relative:return 2;case f.TextEditorLineNumbersStyle.On:default:return 1}}Ee.from=Ce;function ue(K){switch(K){case 0:return f.TextEditorLineNumbersStyle.Off;case 2:return f.TextEditorLineNumbersStyle.Relative;case 1:default:return f.TextEditorLineNumbersStyle.On}}Ee.to=ue})(Qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Q;(function(Ee){function Ce(K){if(K===f.EndOfLine.CRLF)return 1;if(K===f.EndOfLine.LF)return 0}Ee.from=Ce;function ue(K){if(K===1)return f.EndOfLine.CRLF;if(K===0)return f.EndOfLine.LF}Ee.to=ue})(Q=e.EndOfLine||(e.EndOfLine={}));var se;(function(Ee){function Ce(ue){if(typeof ue=="object")return ue.viewId;switch(ue){case f.ProgressLocation.SourceControl:return 3;case f.ProgressLocation.Window:return 10;case f.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ee.from=Ce})(se=e.ProgressLocation||(e.ProgressLocation={}));var we;(function(Ee){function Ce(ue){const K={start:ue.start+1,end:ue.end+1};return ue.kind&&(K.kind=Oe.from(ue.kind)),K}Ee.from=Ce})(we=e.FoldingRange||(e.FoldingRange={}));var Oe;(function(Ee){function Ce(ue){if(ue)switch(ue){case f.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}Ee.from=Ce})(Oe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ue;(function(Ee){function Ce(ue){if(ue)return{pinned:typeof ue.preview=="boolean"?!ue.preview:void 0,inactive:ue.background,preserveFocus:ue.preserveFocus,selection:typeof ue.selection=="object"?b.from(ue.selection):void 0,override:typeof ue.override=="boolean"?k.EditorOverride.DISABLED:void 0}}Ee.from=Ce})(Ue=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ye;(function(Ee){function Ce(K){return K instanceof f.RelativePattern||typeof K=="string"?K:ue(K)?new f.RelativePattern(K.base,K.pattern):K}Ee.from=Ce;function ue(K){const Be=K;return Be&&typeof Be.base=="string"&&typeof Be.pattern=="string"}})(Ye=e.GlobPattern||(e.GlobPattern={}));var De;(function(Ee){function Ce(ue){if(ue){if(Array.isArray(ue))return ue.map(Ce);if(typeof ue=="string")return ue;{const K=ue;return{language:K.language,scheme:K.scheme,pattern:typeof K.pattern=="undefined"?void 0:Ye.from(K.pattern),exclusive:K.exclusive}}}else return}Ee.from=Ce})(De=e.LanguageSelector||(e.LanguageSelector={}));var _e;(function(Ee){function Ce(K){return{start:K.start,end:K.end}}Ee.from=Ce;function ue(K){return new f.NotebookRange(K.start,K.end)}Ee.to=ue})(_e=e.NotebookRange||(e.NotebookRange={}));var Pe;(function(Ee){function Ce(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Ee.to=Ce;function ue(K){var Be,Fe;return{lastRunSuccess:K.success,runStartTime:(Be=K.timing)===null||Be===void 0?void 0:Be.startTime,runEndTime:(Fe=K.timing)===null||Fe===void 0?void 0:Fe.endTime,executionOrder:K.executionOrder}}Ee.from=ue})(Pe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var ae;(function(Ee){function Ce(K){switch(K){case f.NotebookCellKind.Markup:return h.CellKind.Markup;case f.NotebookCellKind.Code:default:return h.CellKind.Code}}Ee.from=Ce;function ue(K){switch(K){case h.CellKind.Markup:return f.NotebookCellKind.Markup;case h.CellKind.Code:default:return f.NotebookCellKind.Code}}Ee.to=ue})(ae=e.NotebookCellKind||(e.NotebookCellKind={}));var fe;(function(Ee){function Ce(K){var Be;const Fe={metadata:(Be=K.metadata)!==null&&Be!==void 0?Be:Object.create(null),cells:[]};for(let Me of K.cells)f.NotebookCellData.validate(Me),Fe.cells.push(W.from(Me));return Fe}Ee.from=Ce;function ue(K){const Be=new f.NotebookData(K.cells.map(W.to));return P.isEmptyObject(K.metadata)||(Be.metadata=K.metadata),Be}Ee.to=ue})(fe=e.NotebookData||(e.NotebookData={}));var W;(function(Ee){function Ce(K){var Be;return{cellKind:ae.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:Pe.from((Be=K.executionSummary)!==null&&Be!==void 0?Be:{}),outputs:K.outputs?K.outputs.map(de.from):[]}}Ee.from=Ce;function ue(K){return new f.NotebookCellData(ae.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(de.to):void 0,K.metadata,K.internalMetadata?Pe.to(K.internalMetadata):void 0)}Ee.to=ue})(W=e.NotebookCellData||(e.NotebookCellData={}));var ee;(function(Ee){function Ce(K){return{mime:K.mime,valueBytes:Array.from(K.data)}}Ee.from=Ce;function ue(K){return new f.NotebookCellOutputItem(new Uint8Array(K.valueBytes),K.mime)}Ee.to=ue})(ee=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var de;(function(Ee){function Ce(K){return{outputId:K.id,items:K.items.map(ee.from),metadata:K.metadata}}Ee.from=Ce;function ue(K){const Be=K.items.map(ee.to);return new f.NotebookCellOutput(Be,K.outputId,K.metadata)}Ee.to=ue})(de=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Ie;(function(Ee){function Ce(Fe){if(Fe!=null){if(Fe instanceof f.RelativePattern||typeof Fe=="string")return Fe;if(Be(Fe))return new f.RelativePattern(Fe.base,Fe.pattern);if(K(Fe))return{include:Ye.from(Fe.include)||void 0,exclude:Ye.from(Fe.exclude)||void 0}}}Ee.from=Ce;function ue(Fe){return typeof Fe=="string"?Fe:Be(Fe)?{base:Fe.base,pattern:Fe.pattern}:{include:Fe.include,exclude:Fe.exclude}}Ee.to=ue;function K(Fe){const Me=Fe,nt=Ye.from(Me.include);if(!(nt&&nt instanceof f.RelativePattern||typeof nt=="string"))return!1;const ot=Ye.from(Me.exclude);return!!(ot&&ot instanceof f.RelativePattern||typeof ot=="string")}function Be(Fe){const Me=Fe;return Me&&typeof Me.base=="string"&&typeof Me.pattern=="string"}})(Ie=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Te;(function(Ee){function Ce(ue){return{backgroundColor:ue.backgroundColor,borderColor:ue.borderColor,top:ue.top?y.from(ue.top):void 0}}Ee.from=Ce})(Te=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var xe;(function(Ee){function Ce(ue,K,Be){const Fe=typeof ue.command=="string"?{title:"",command:ue.command}:ue.command;return{alignment:ue.alignment===f.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Fe,Be),text:ue.text,tooltip:ue.tooltip,accessibilityInformation:ue.accessibilityInformation,priority:ue.priority}}Ee.from=Ce})(xe=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ve;(function(Ee){function Ce(ue){var K,Be,Fe;return{transientOutputs:(K=ue==null?void 0:ue.transientOutputs)!==null&&K!==void 0?K:!1,transientCellMetadata:(Be=ue==null?void 0:ue.transientCellMetadata)!==null&&Be!==void 0?Be:{},transientDocumentMetadata:(Fe=ue==null?void 0:ue.transientDocumentMetadata)!==null&&Fe!==void 0?Fe:{}}}Ee.from=Ce})(Ve=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(Ee){function Ce(K){return{uri:K.uri,provides:K.provides}}Ee.from=Ce;function ue(K){return new f.NotebookRendererScript(_.URI.revive(K.uri),K.provides)}Ee.to=ue})(Ze=e.NotebookRendererScript||(e.NotebookRendererScript={}));var rt;(function(Ee){function Ce(K){return{message:v.fromStrict(K.message)||"",severity:K.severity,expectedOutput:K.expectedOutput,actualOutput:K.actualOutput,location:K.location?M.from(K.location):void 0}}Ee.from=Ce;function ue(K){const Be=new f.TestMessage(typeof K.message=="string"?K.message:v.to(K.message));return Be.severity=K.severity,Be.actualOutput=K.actualOutput,Be.expectedOutput=K.expectedOutput,Be}Ee.to=ue})(rt=e.TestMessage||(e.TestMessage={}));var Xe;(function(Ee){function Ce(Fe){var Me,nt;return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:b.from(Fe.range)||null,debuggable:(Me=Fe.debuggable)!==null&&Me!==void 0?Me:!1,description:Fe.description||null,runnable:(nt=Fe.runnable)!==null&&nt!==void 0?nt:!0,error:Fe.error&&v.fromStrict(Fe.error)||null}}Ee.from=Ce;function ue(Fe){return{extId:Fe.id,label:Fe.label,uri:Fe.uri,range:b.from(Fe.range)||null,debuggable:!1,description:Fe.description||null,error:null,runnable:!0}}Ee.fromResultSnapshot=ue;function K(Fe){return{id:Fe.extId,label:Fe.label,uri:_.URI.revive(Fe.uri),range:b.to(Fe.range||void 0),addChild:()=>{},dispose:()=>{},status:f.TestItemStatus.Pending,data:void 0,debuggable:Fe.debuggable,description:Fe.description||void 0,runnable:Fe.runnable}}Ee.toPlain=K;function Be(Fe){const Me=new f.TestItemImpl(Fe.extId,Fe.label,_.URI.revive(Fe.uri),void 0);return Me.range=b.to(Fe.range||void 0),Me.debuggable=Fe.debuggable,Me.description=Fe.description||void 0,Me.runnable=Fe.runnable,Me}Ee.to=Be})(Xe=e.TestItem||(e.TestItem={}));var Je;(function(Ee){const Ce=(K,Be)=>Object.assign(Object.assign({},Xe.toPlain(K.item)),{taskStates:K.tasks.map(Fe=>({state:Fe.state,duration:Fe.duration,messages:Fe.messages.map(rt.to)})),children:K.children.map(Fe=>Be.get(Fe)).filter(P.isDefined).map(Fe=>Ce(Fe,Be))});function ue(K){const Be=[],Fe=new Map;for(const Me of K.items)Fe.set(Me.item.extId,Me),Me.direct&&Be.push(Me);return{completedAt:K.completedAt,results:Be.map(Me=>Ce(Me,Fe))}}Ee.to=ue})(Je=e.TestResults||(e.TestResults={}));var ft;(function(Ee){function Ce(ue){switch(ue){case 1:return f.CodeActionTriggerKind.Invoke;case 2:return f.CodeActionTriggerKind.Automatic}}Ee.to=Ce})(ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(pe[206],ve([0,1,2,14,7,17,71]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(D,r,k,l={timeout:1500,errors:3}){this._logService=D,this._documents=r,this._mainThreadBulkEdits=k,this._thresholds=l,this._callbacks=new A.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(D){return(r,k,l)=>{const c={dispose:this._callbacks.push([r,k,D])};return Array.isArray(l)&&l.push(c),c}}async $participateInSave(D,r){const k=p.URI.revive(D);let l=!1;const h=setTimeout(()=>l=!0,this._thresholds.timeout),c=[];try{for(let f of[...this._callbacks]){if(l)break;const I=this._documents.getDocument(k),b=await this._deliverEventAsyncAndBlameBadListeners(f,{document:I,reason:S.TextDocumentSaveReason.to(r)});c.push(b)}}finally{clearTimeout(h)}return c}_deliverEventAsyncAndBlameBadListeners([D,r,k],l){const h=this._badListeners.get(D);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(k,D,r,l).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const f=this._badListeners.get(D);this._badListeners.set(D,f?f+1:1),typeof f=="number"&&f>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(D,r,k,l){const h=[],c=Date.now(),{document:f,reason:I}=l,{version:b}=f,w=Object.freeze({document:f,reason:I,waitUntil(u){if(Object.isFrozen(h))throw R.illegalState("waitUntil can not be called async");h.push(Promise.resolve(u))}});try{r.apply(k,[w])}catch(u){return Promise.reject(u)}return Object.freeze(h),new Promise((u,d)=>{const g=setTimeout(()=>d(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(g),u(t)}).catch(t=>{clearTimeout(g),d(t)})}).then(u=>{const d={edits:[]};for(const g of u)if(Array.isArray(g)&&g.every(t=>t instanceof C.TextEdit))for(const{newText:t,newEol:i,range:s}of g)d.edits.push({_type:2,resource:f.uri,edit:{range:s&&S.Range.from(s),text:t,eol:i&&S.EndOfLine.from(i)}});if(d.edits.length!==0)return b===f.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(d):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(pe[207],ve([0,1,3,16,30,2,17,7]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(k,l,h,c,f){this._onDidCreate=new p.Emitter,this._onDidChange=new p.Emitter,this._onDidDelete=new p.Emitter,this._config=0,h&&(this._config+=1),c&&(this._config+=2),f&&(this._config+=4);const I=C.parse(l),b=k(w=>{if(!h)for(let u of w.created){const d=S.URI.revive(u);I(d.fsPath)&&this._onDidCreate.fire(d)}if(!c)for(let u of w.changed){const d=S.URI.revive(u);I(d.fsPath)&&this._onDidChange.fire(d)}if(!f)for(let u of w.deleted){const d=S.URI.revive(u);I(d.fsPath)&&this._onDidDelete.fire(d)}});this._disposable=P.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class D{constructor(k,l,h){this._logService=l,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new p.Emitter,this._onDidRenameFile=new p.Emitter,this._onDidCreateFile=new p.Emitter,this._onDidDeleteFile=new p.Emitter,this._onWillRenameFile=new R.AsyncEmitter,this._onWillCreateFile=new R.AsyncEmitter,this._onWillDeleteFile=new R.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(k,l,h,c){return new _(this._onFileSystemEvent.event,k,l,h,c)}$onFileEvent(k){this._onFileSystemEvent.fire(k)}$onDidRunFileOperation(k,l){switch(k){case 2:this._onDidRenameFile.fire(Object.freeze({files:l.map(h=>({oldUri:S.URI.revive(h.source),newUri:S.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:l.map(h=>S.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:l.map(h=>S.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(k){return this._createWillExecuteEvent(k,this._onWillRenameFile)}getOnWillCreateFileEvent(k){return this._createWillExecuteEvent(k,this._onWillCreateFile)}getOnWillDeleteFileEvent(k){return this._createWillExecuteEvent(k,this._onWillDeleteFile)}_createWillExecuteEvent(k,l){return(h,c,f)=>{const I=function(w){h.call(c,w)};return I.extension=k,l.event(I,void 0,f)}}async $onWillRunFileOperation(k,l,h,c){switch(k){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:l.map(f=>({oldUri:S.URI.revive(f.source),newUri:S.URI.revive(f.target)}))},h,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:l.map(f=>S.URI.revive(f.target))},h,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:l.map(f=>S.URI.revive(f.target))},h,c)}}async _fireWillEvent(k,l,h,c){const f=new Set,I=[];if(await k.fireAsync(l,c,async(w,u)=>{var d;const g=Date.now(),t=await Promise.resolve(w);t instanceof P.WorkspaceEdit&&(I.push(t),f.add((d=u.extension.displayName)!==null&&d!==void 0?d:u.extension.identifier.value)),Date.now()-g>h&&this._logService.warn("SLOW file-participant",u.extension.identifier)}),c.isCancellationRequested||I.length===0)return;const b={edits:[]};for(let w of I){let{edits:u}=A.WorkspaceEdit.from(w,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(u)}return{edit:b,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=D}),define(pe[208],ve([0,1,10,25,2,17,7,85]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(l,h,c,f){this.start=l,this.deletedCount=h,this.deletedItems=c,this.items=f}static asApiEvents(l){return l.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(c=>c.apiCell)}))}}class D{constructor(l,h,c){var f,I,b;this.notebook=l,this._extHostDocument=h,this._cellData=c,this.handle=c.handle,this.uri=C.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(S.NotebookCellOutput.to),this._internalMetadata=(f=c.internalMetadata)!==null&&f!==void 0?f:{},this._metadata=(I=c.metadata)!==null&&I!==void 0?I:{},this._previousResult=S.NotebookCellExecutionSummary.to((b=c.internalMetadata)!==null&&b!==void 0?b:{})}static asModelAddData(l,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:l}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const l=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return l.notebook.getCellIndex(l)},notebook:l.notebook.apiNotebook,kind:S.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return l._mime},set mime(c){l._mime=c},get outputs(){return l._outputs.slice(0)},get metadata(){return l._metadata},get executionSummary(){return l._previousResult}})}return this._apiCell}setOutputs(l){this._outputs=l.map(S.NotebookCellOutput.to)}setOutputItems(l,h,c){const f=c.map(S.NotebookCellOutputItem.to),I=this._outputs.find(b=>b.id===l);I&&(h||(I.items.length=0),I.items.push(...f))}setMetadata(l){this._metadata=l}setInternalMetadata(l){this._internalMetadata=l,this._previousResult=S.NotebookCellExecutionSummary.to(l)}setMime(l){}}e.ExtHostCell=D;class r{constructor(l,h,c,f,I,b){var w;this._proxy=l,this._textDocumentsAndEditors=h,this._textDocuments=c,this._emitter=f,this.uri=I,this.handle=r._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=(w=b.metadata)!==null&&w!==void 0?w:Object.create(null),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const l=this;this._notebook={get uri(){return l.uri},get version(){return l._versionId},get notebookType(){return l._notebookType},get isDirty(){return l._isDirty},get isUntitled(){return l.uri.scheme===p.Schemas.untitled},get isClosed(){return l._disposed},get metadata(){return l._metadata},get cellCount(){return l._cells.length},cellAt(h){return h=l._validateIndex(h),l._cells[h].apiCell},getCells(h){return(h?l._getCells(h):l._cells).map(f=>f.apiCell)},save(){return l._save()}}}return this._notebook}updateBackup(l){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=l}disposeBackup(){var l;(l=this._backup)===null||l===void 0||l.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(l){l.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),l.metadata))}acceptDirty(l){this._isDirty=l}acceptModelChanged(l,h){this._versionId=l.versionId,this._isDirty=h;for(const c of l.rawEvents)c.kind===P.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===P.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===P.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===P.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===P.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===P.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===P.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===P.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(l){return l=l|0,l<0?0:l>=this._cells.length?this._cells.length-1:l}_validateRange(l){let h=l.start|0,c=l.end|0;return h<0&&(h=0),c>this._cells.length&&(c=this._cells.length),l.with({start:h,end:c})}_getCells(l){l=this._validateRange(l);const h=[];for(let c=l.start;c<l.end;c++)h.push(this._cells[c]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(l,h){if(this._disposed)return;const c=[],f=[],I=[];l.reverse().forEach(b=>{const u=b[2].map(t=>{const i=new D(this,this._textDocumentsAndEditors,t);return h||f.push(D.asModelAddData(this.apiNotebook,t)),i}),d=new _(b[0],b[1],[],u),g=this._cells.splice(b[0],b[1],...u);for(const t of g)I.push(t.uri),d.deletedItems.push(t.apiCell);c.push(d)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:I}),h||this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(c)}))}_moveCell(l,h){const c=this._cells.splice(l,1);this._cells.splice(h,0,...c);const f=[new _(l,1,c.map(I=>I.apiCell),[]),new _(h,0,[],c)];this._emitter.emitModelChange(R.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(f)}))}_setCellOutputs(l,h){const c=this._cells[l];c.setOutputs(h),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(l,h,c,f){const I=this._cells[l];I.setOutputItems(h,c,f),this._emitter.emitCellOutputsChange(R.deepFreeze({document:this.apiNotebook,cells:[I.apiCell]}))}_changeCellLanguage(l,h){const c=this._cells[l];c.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(c.uri,h)}_changeCellMime(l,h){const c=this._cells[l];c.apiCell.mime=h}_changeCellMetadata(l,h){const c=this._cells[l],f=c.apiCell.metadata;c.setMetadata(h);const I=c.apiCell.metadata;R.equals(f,I)||this._emitter.emitCellMetadataChange(R.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(l,h){var c;const f=this._cells[l],I=f.internalMetadata;if(f.setInternalMetadata(h),I.runState!==h.runState){const b=(c=h.runState)!==null&&c!==void 0?c:A.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(R.deepFreeze({document:this.apiNotebook,cell:f.apiCell,state:b}))}}getCellFromApiCell(l){return this._cells.find(h=>h.apiCell===l)}getCellFromIndex(l){return this._cells[l]}getCell(l){return this._cells.find(h=>h.handle===l)}getCellIndex(l){return this._cells.indexOf(l)}}e.ExtHostNotebookDocument=r,r._handlePool=0}),define(pe[123],ve([0,1,7,17,14]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class S{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,D){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:D})}replaceCells(_,D,r){this._throwIfFinalized(),!(_===D&&r.length===0)&&this._collectedEdits.push({editType:1,index:_,count:D-_,cells:r.map(R.NotebookCellData.from)})}}class A{constructor(_,D,r,k,l,h){this.id=_,this._proxy=D,this.notebookData=r,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=l,this._visibleRanges=k,this._viewColumn=h}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(D){if(!Array.isArray(D)||!D.every(p.NotebookRange.isNotebookRange))throw C.illegalArgument("selections");_._selections=D,_._trySetSelections(D)},get visibleRanges(){return _._visibleRanges},revealRange(D,r){_._proxy.$tryRevealRange(_.id,R.NotebookRange.from(D),r??p.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(D){const r=new S(this.document.version);return D(r),_._applyEdit(r.finalize())},setDecorations(D,r){return _.setDecorations(D,r)}},A.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(R.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const D=[];let r=-1;for(let k=0;k<_.cellEdits.length;k++){if(r<0){D.push(_.cellEdits[k]),r++;continue}const h=D[r],c=_.cellEdits[k];if(h.editType===1&&c.editType===1&&h.index===c.index){h.cells.push(..._.cellEdits[k].cells),h.count+=_.cellEdits[k].count;continue}D.push(_.cellEdits[k]),r++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,D)}setDecorations(_,D){if(!(D.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return D.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,R.NotebookRange.from(D),_.key)}}e.ExtHostNotebookEditor=A,A.apiEditorsToExtHost=new WeakMap}),define(pe[209],ve([0,1,17,115,160,21,51]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class P{constructor(k){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=k}withProgress(k,l,h){const c=this._handles++,{title:f,location:I,cancellable:b}=l,w={label:C.localize(0,null,k.displayName||k.name),id:k.identifier.value};return this._proxy.$startProgress(c,{location:p.ProgressLocation.from(I),title:f,source:w,cancellable:b},k),this._withProgress(c,h,!!b)}_withProgress(k,l,h){let c;h&&(c=new S.CancellationTokenSource,this._mapHandleToCancellationSource.set(k,c));const f=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),c&&c.dispose()};let I;try{I=l(new D(this._proxy,k),h&&c?c.token:S.CancellationToken.None)}catch(b){throw f(k),b}return I.then(b=>f(k),b=>f(k)),I}$acceptProgressCanceled(k){const l=this._mapHandleToCancellationSource.get(k);l&&(l.cancel(),this._mapHandleToCancellationSource.delete(k))}}e.ExtHostProgress=P;function _(r,k){return r.message=k.message,typeof k.increment=="number"&&(typeof r.increment=="number"?r.increment+=k.increment:r.increment=k.increment),r}class D extends R.Progress{constructor(k,l){super(h=>this.throttledReport(h));this._proxy=k,this._handle=l}throttledReport(k){this._proxy.$progressReport(this._handle,k)}}qe([A.throttle(100,(r,k)=>_(r,k),()=>Object.create(null))],D.prototype,"throttledReport",null)}),define(pe[124],ve([0,1,50,14,70,17,7]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class P{constructor(l,h,c){const f=P._Keys.nextId();l.$registerTextEditorDecorationType(h.identifier,f,S.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:f,dispose(){l.$removeTextEditorDecorationType(f)}})}}e.TextEditorDecorationType=P,P._Keys=new C.IdGenerator("TextEditorDecorationType");class _{constructor(l,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=l,this._documentVersionId=l.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(l,h){this._throwIfFinalized();let c=null;if(l instanceof A.Position)c=new A.Range(l,l);else if(l instanceof A.Range)c=l;else throw new Error("Unrecognized location");this._pushEdit(c,h,!1)}insert(l,h){this._throwIfFinalized(),this._pushEdit(new A.Range(l,l),h,!0)}delete(l){this._throwIfFinalized();let h=null;if(l instanceof A.Range)h=l;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(l,h,c){const f=this._document.validateRange(l);this._collectedEdits.push({range:f,text:h,forceMoveMarkers:c})}setEndOfLine(l){if(this._throwIfFinalized(),l!==A.EndOfLine.LF&&l!==A.EndOfLine.CRLF)throw R.illegalArgument("endOfLine");this._setEndOfLine=l}}e.TextEditorEdit=_;class D{constructor(l,h,c,f){this._proxy=l,this._id=h,this._accept(c),this._logService=f;const I=this;this.value={get tabSize(){return I._tabSize},set tabSize(b){I._setTabSize(b)},get insertSpaces(){return I._insertSpaces},set insertSpaces(b){I._setInsertSpaces(b)},get cursorStyle(){return I._cursorStyle},set cursorStyle(b){I._setCursorStyle(b)},get lineNumbers(){return I._lineNumbers},set lineNumbers(b){I._setLineNumbers(b)}}}_accept(l){this._tabSize=l.tabSize,this._insertSpaces=l.insertSpaces,this._cursorStyle=l.cursorStyle,this._lineNumbers=S.TextEditorLineNumbersStyle.to(l.lineNumbers)}_validateTabSize(l){if(l==="auto")return"auto";if(typeof l=="number"){const h=Math.floor(l);return h>0?h:null}if(typeof l=="string"){const h=parseInt(l,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(l){const h=this._validateTabSize(l);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(l){return l==="auto"?"auto":l==="false"?!1:Boolean(l)}_setInsertSpaces(l){const h=this._validateInsertSpaces(l);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(l){this._cursorStyle!==l&&(this._cursorStyle=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:l})))}_setLineNumbers(l){this._lineNumbers!==l&&(this._lineNumbers=l,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:S.TextEditorLineNumbersStyle.from(l)})))}assign(l){const h={};let c=!1;if(typeof l.tabSize!="undefined"){const f=this._validateTabSize(l.tabSize);f==="auto"?(c=!0,h.tabSize=f):typeof f=="number"&&this._tabSize!==f&&(this._tabSize=f,c=!0,h.tabSize=f)}if(typeof l.insertSpaces!="undefined"){const f=this._validateInsertSpaces(l.insertSpaces);f==="auto"?(c=!0,h.insertSpaces=f):this._insertSpaces!==f&&(this._insertSpaces=f,c=!0,h.insertSpaces=f)}typeof l.cursorStyle!="undefined"&&this._cursorStyle!==l.cursorStyle&&(this._cursorStyle=l.cursorStyle,c=!0,h.cursorStyle=l.cursorStyle),typeof l.lineNumbers!="undefined"&&this._lineNumbers!==l.lineNumbers&&(this._lineNumbers=l.lineNumbers,c=!0,h.lineNumbers=S.TextEditorLineNumbersStyle.from(l.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(l){l.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=D;class r{constructor(l,h,c,f,I,b,w,u){this.id=l,this._proxy=h,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=I,this._options=new D(this._proxy,this.id,b,c),this._visibleRanges=w,this._viewColumn=u;const d=this;this.value=Object.freeze({get document(){return f.getValue()},set document(g){throw R.readonly("document")},get selection(){return d._selections&&d._selections[0]},set selection(g){if(!(g instanceof A.Selection))throw R.illegalArgument("selection");d._selections=[g],d._trySetSelection()},get selections(){return d._selections},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof A.Selection)))throw R.illegalArgument("selections");d._selections=g,d._trySetSelection()},get visibleRanges(){return d._visibleRanges},set visibleRanges(g){throw R.readonly("visibleRanges")},get options(){return d._options.value},set options(g){d._disposed||d._options.assign(g)},get viewColumn(){return d._viewColumn},set viewColumn(g){throw R.readonly("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new _(f.getValue(),t);return g(i),d._applyEdit(i)},insertSnippet(g,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(d._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=d._selections.map(n=>S.Range.from(n));else if(t instanceof A.Position){const{lineNumber:n,column:o}=S.Position.from(t);s=[{startLineNumber:n,startColumn:o,endLineNumber:n,endColumn:o}]}else if(t instanceof A.Range)s=[S.Range.from(t)];else{s=[];for(const n of t)if(n instanceof A.Range)s.push(S.Range.from(n));else{const{lineNumber:o,column:v}=S.Position.from(n);s.push({startLineNumber:o,startColumn:v,endLineNumber:o,endColumn:v})}}return h.$tryInsertSnippet(l,g.value,s,i)},setDecorations(g,t){const i=t.length===0;i&&!d._hasDecorationsForKey.has(g.key)||(i?d._hasDecorationsForKey.delete(g.key):d._hasDecorationsForKey.add(g.key),d._runOnProxy(()=>{if(S.isDecorationOptionsArr(t))return h.$trySetDecorations(l,g.key,S.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let n=0,o=t.length;n<o;n++){const v=t[n];s[4*n]=v.start.line+1,s[4*n+1]=v.start.character+1,s[4*n+2]=v.end.line+1,s[4*n+3]=v.end.character+1}return h.$trySetDecorationsFast(l,g.key,s)}}))},revealRange(g,t){d._runOnProxy(()=>h.$tryRevealRange(l,S.Range.from(g),t||A.TextEditorRevealType.Default))},show(g){h.$tryShowEditor(l,S.ViewColumn.from(g))},hide(){h.$tryHideEditor(l)}})}dispose(){p.ok(!this._disposed),this._disposed=!0}_acceptOptions(l){p.ok(!this._disposed),this._options._accept(l)}_acceptVisibleRanges(l){p.ok(!this._disposed),this._visibleRanges=l}_acceptViewColumn(l){p.ok(!this._disposed),this._viewColumn=l}_acceptSelections(l){p.ok(!this._disposed),this._selections=l}async _trySetSelection(){const l=this._selections.map(S.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,l)),this.value}_applyEdit(l){const h=l.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const c=h.edits.map(I=>I.range);c.sort((I,b)=>I.end.line===b.end.line?I.end.character===b.end.character?I.start.line===b.start.line?I.start.character-b.start.character:I.start.line-b.start.line:I.end.character-b.end.character:I.end.line-b.end.line);for(let I=0,b=c.length-1;I<b;I++){const w=c[I].end;if(c[I+1].start.isBefore(w))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=h.edits.map(I=>({range:S.Range.from(I.range),text:I.text,forceMoveMarkers:I.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,f,{setEndOfLine:typeof h.setEndOfLine=="number"?S.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(l){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=r}),define(pe[210],ve([0,1,163,24,2,3,6,16,7,15,18,17,21]),function(X,e,p,R,C,S,A,P,_,D,r,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(I,b){if(D.isString(I))return{label:I};if(I&&typeof I=="object"&&typeof I.label=="string"){let w;return Array.isArray(I.highlights)&&(w=I.highlights.filter(u=>u.length===2&&typeof u[0]=="number"&&typeof u[1]=="number"),w=w.length?w:void 0),{label:I.label,highlights:w}}}class c{constructor(b,w,u){this._proxy=b,this.commands=w,this.logService=u,this.treeViews=new Map;function d(g){return g&&g.$treeViewId&&g.$treeItemHandle}w.registerArgumentProcessor({processArgument:g=>d(g)?this.convertArgument(g):Array.isArray(g)&&g.length>0?g.map(t=>d(t)?this.convertArgument(t):t):g})}registerTreeDataProvider(b,w,u){const d=this.createTreeView(b,{treeDataProvider:w},u);return{dispose:()=>d.dispose()}}createTreeView(b,w,u){if(!w||!w.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const d=w.dragAndDropController!==void 0,g=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!w.showCollapseAll,canSelectMany:!!w.canSelectMany,canDragAndDrop:d}),t=this.createExtHostTreeView(b,w,u);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(i){t.message=i},get title(){return t.title},set title(i){t.title=i},get description(){return t.description},set description(i){t.description=i},reveal:(i,s)=>t.reveal(i,s),dispose:async()=>{await g,this.treeViews.delete(b),t.dispose()}}}$getChildren(b,w){const u=this.treeViews.get(b);return u?u.getChildren(w):Promise.reject(new Error(p.localize(0,null,b)))}$onDrop(b,w,u){const d=this.treeViews.get(b);return d?d.onDrop(w,u):Promise.reject(new Error(p.localize(1,null,b)))}async $hasResolve(b){const w=this.treeViews.get(b);if(!w)throw new Error(p.localize(2,null,b));return w.hasResolve}$resolve(b,w,u){const d=this.treeViews.get(b);if(!d)throw new Error(p.localize(3,null,b));return d.resolveTreeItem(w,u)}$setExpanded(b,w,u){const d=this.treeViews.get(b);if(!d)throw new Error(p.localize(4,null,b));d.setExpanded(w,u)}$setSelection(b,w){const u=this.treeViews.get(b);if(!u)throw new Error(p.localize(5,null,b));u.setSelection(w)}$setVisible(b,w){const u=this.treeViews.get(b);if(!u)throw new Error(p.localize(6,null,b));u.setVisible(w)}createExtHostTreeView(b,w,u){const d=new f(b,w,this._proxy,this.commands.converter,this.logService,u);return this.treeViews.set(b,d),d}convertArgument(b){const w=this.treeViews.get(b.$treeViewId);return w?w.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=c;class f extends A.Disposable{constructor(b,w,u,d,g,t){super();if(this.viewId=b,this.proxy=u,this.commands=d,this.logService=g,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new S.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new S.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new S.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new S.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new S.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new l.CancellationTokenSource,t.contributes&&t.contributes.views)for(const n in t.contributes.views)for(const o of t.contributes.views[n])o.id===b&&(this._title=o.name);this.dataProvider=w.treeDataProvider,this.dndController=w.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(n=>this._onDidChangeData.fire({message:!1,element:n})));let i,s;this._register(S.Event.debounce(this._onDidChangeData.event,(n,o)=>(n||(n={message:!1,elements:[]}),o.element!==!1&&(i||(i=new Promise(v=>s=v),this.refreshPromise=this.refreshPromise.then(()=>i)),n.elements.push(o.element)),o.message&&(n.message=!0),n),200,!0)(({message:n,elements:o})=>{o.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const v=s;return i=null,this.refresh(o).then(()=>v())})),n&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!D.isUndefinedOrNull(b))}getChildren(b){const w=b?this.getExtensionElement(b):void 0;if(b&&!w)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);const u=this.getChildrenNodes(b);return(u?Promise.resolve(u):this.fetchChildrenNodes(w)).then(d=>d.map(g=>g.item))}getExtensionElement(b){return this.elements.get(b)}reveal(b,w){w=w||{select:!0,focus:!1};const u=D.isUndefinedOrNull(w.select)?!0:w.select,d=D.isUndefinedOrNull(w.focus)?!1:w.focus,g=D.isUndefinedOrNull(w.expand)?!1:w.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(t=>this.resolveTreeNode(b,t[t.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:t.map(s=>s.item)},{select:u,focus:d,expand:g})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:u,focus:d,expand:g})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,w){const u=this.getExtensionElement(b);u&&(w?this._onDidExpandElement.fire(Object.freeze({element:u})):this._onDidCollapseElement.fire(Object.freeze({element:u})))}setSelection(b){r.equals(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(b,w){const u=b.map(g=>this.getExtensionElement(g)).filter(g=>!D.isUndefinedOrNull(g)),d=this.getExtensionElement(w);return u&&d?P.asPromise(()=>{var g;return(g=this.dndController)===null||g===void 0?void 0:g.onDrop(u,d)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,w){var u;if(!this.dataProvider.resolveTreeItem)return;const d=this.elements.get(b);if(d){const g=this.nodes.get(d);if(g){const t=(u=await this.dataProvider.resolveTreeItem(g.extensionItem,d,w))!==null&&u!==void 0?u:g.extensionItem;return g.item.tooltip=this.getTooltip(t.tooltip),g.item.command=this.getCommand(g.disposableStore,t.command),g.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(w=>w?this.resolveUnknownParentChain(w).then(u=>this.resolveTreeNode(w,u[u.length-1]).then(d=>(u.push(d),u))):Promise.resolve([]))}resolveParent(b){const w=this.nodes.get(b);return w?Promise.resolve(w.parent?this.elements.get(w.parent.item.handle):void 0):P.asPromise(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,w){const u=this.nodes.get(b);return u?Promise.resolve(u):P.asPromise(()=>this.dataProvider.getTreeItem(b)).then(d=>this.createHandle(b,d,w,!0)).then(d=>this.getChildren(w?w.item.handle:void 0).then(()=>{const g=this.getExtensionElement(d);if(g){const t=this.nodes.get(g);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${d}`)}))}getChildrenNodes(b){if(b){let w;if(typeof b=="string"){const u=this.getExtensionElement(b);w=u?this.nodes.get(u):void 0}else w=b;return w&&w.children||null}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const w=new l.CancellationTokenSource(this._refreshCancellationSource.token);try{const u=b?this.nodes.get(b):void 0,d=await this.dataProvider.getChildren(b);if(w.token.isCancellationRequested)return[];const g=await Promise.all(r.coalesce(d||[]).map(async t=>{const i=await this.dataProvider.getTreeItem(t);return i&&!w.token.isCancellationRequested?this.createAndRegisterTreeNode(t,i,u):null}));return w.token.isCancellationRequested?[]:r.coalesce(g)}finally{w.dispose()}}refresh(b){if(b.some(u=>!u))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new l.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const u=this.getHandlesToRefresh(b);if(u.length)return this.refreshHandles(u)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const w=new Set,u=b.map(g=>this.nodes.get(g));for(const g of u)if(g&&!w.has(g.item.handle)){let t=g;for(;t&&t.parent&&u.findIndex(i=>t&&t.parent&&i&&i.item.handle===t.parent.item.handle)===-1;){const i=this.elements.get(t.parent.item.handle);t=i?this.nodes.get(i):void 0}t&&!t.parent&&w.add(g.item.handle)}const d=[];return w.forEach(g=>{const t=this.elements.get(g);if(t){const i=this.nodes.get(t);i&&(!i.parent||!w.has(i.parent.item.handle))&&d.push(g)}}),d}refreshHandles(b){const w={};return Promise.all(b.map(u=>this.refreshNode(u).then(d=>{d&&(w[u]=d.item)}))).then(()=>Object.keys(w).length?this.proxy.$refresh(this.viewId,w):void 0)}refreshNode(b){const w=this.getExtensionElement(b);if(w){const u=this.nodes.get(w);if(u)return this.clearChildren(w),P.asPromise(()=>this.dataProvider.getTreeItem(w)).then(d=>{if(d){const g=this.createTreeNode(w,d,u.parent);return this.updateNodeCache(w,g,u,u.parent),u.dispose(),g}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,w,u){const d=this.createTreeNode(b,w,u);if(w.id&&this.elements.has(d.item.handle))throw new Error(p.localize(7,null,w.id));return this.addNodeToCache(b,d),this.addNodeToParentCache(d,u),d}getTooltip(b){return _.MarkdownString.isMarkdownString(b)?k.MarkdownString.from(b):b}getCommand(b,w){return w?this.commands.toInternal(w,b):void 0}createTreeNode(b,w,u){const d=new A.DisposableStore,g=this.createHandle(b,w,u),t=this.getLightIconPath(w);return{item:{handle:g,parentHandle:u?u.item.handle:void 0,label:h(w.label,this.extension),description:w.description,resourceUri:w.resourceUri,tooltip:this.getTooltip(w.tooltip),command:this.getCommand(d,w.command),contextValue:w.contextValue,icon:t,iconDark:this.getDarkIconPath(w)||t,themeIcon:this.getThemeIcon(w),collapsibleState:D.isUndefinedOrNull(w.collapsibleState)?_.TreeItemCollapsibleState.None:w.collapsibleState,accessibilityInformation:w.accessibilityInformation},extensionItem:w,parent:u,children:void 0,disposableStore:d,dispose(){d.dispose()}}}getThemeIcon(b){return b.iconPath instanceof _.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:w,label:u,resourceUri:d},g,t){if(w)return`${f.ID_HANDLE_PREFIX}/${w}`;const i=h(u,this.extension),s=g?g.item.handle:f.LABEL_HANDLE_PREFIX;let n=i?i.label:d?R.basename(d):"";n=n.indexOf("/")!==-1?n.replace("/","//"):n;const o=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,v=this.getChildrenNodes(g)||[];let m,E=0;do{if(m=`${s}/${E}:${n}`,t||!this.elements.has(m)||o===m)break;E++}while(E<=v.length);return m}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof _.ThemeIcon))return typeof b.iconPath=="string"||C.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof _.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return C.URI.isUri(b)?b:C.URI.file(b)}addNodeToCache(b,w){this.elements.set(w.item.handle,b),this.nodes.set(b,w)}updateNodeCache(b,w,u,d){this.elements.delete(w.item.handle),this.nodes.delete(b),w.item.handle!==u.item.handle&&this.elements.delete(u.item.handle),this.addNodeToCache(b,w);const g=this.getChildrenNodes(d)||[],t=g.filter(i=>i.item.handle===u.item.handle)[0];t&&g.splice(g.indexOf(t),1,w)}addNodeToParentCache(b,w){w?(w.children||(w.children=[]),w.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const w=this.nodes.get(b);if(w){if(w.children)for(const u of w.children){const d=this.elements.get(u.item.handle);d&&this.clear(d)}w.children=void 0}}else this.clearAll()}clear(b){const w=this.nodes.get(b);if(w){if(w.children)for(const u of w.children){const d=this.elements.get(u.item.handle);d&&this.clear(d)}this.nodes.delete(b),this.elements.delete(w.item.handle),w.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}f.LABEL_HANDLE_PREFIX="0",f.ID_HANDLE_PREFIX="1"}),define(pe[211],ve([0,1,18,16,21,3,52,15,83,17,7,122]),function(X,e,p,R,C,S,A,P,_,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class l{constructor(){this.testIdsToInternal=new Map}getTestById(w,u){if(u!==void 0){const d=this.testIdsToInternal.get(u),g=d==null?void 0:d.get(w);if(g)return[d,g]}return p.mapFind(this.testIdsToInternal.values(),d=>{const g=d.get(w);return g&&[d,g]})}createForHierarchy(){return new I(this.createIdMap(c++))}createIdMap(w){const u=new f(w);return this.testIdsToInternal.set(u.id,u),{object:u,dispose:()=>this.testIdsToInternal.delete(u.id)}}}e.OwnedTestCollection=l;var h;(function(b){b[b.Disconnected=0]="Disconnected",b[b.IsChild=1]="IsChild",b[b.IsParent=2]="IsParent",b[b.IsSame=3]="IsSame"})(h=e.TestPosition||(e.TestPosition={}));let c=0;class f{constructor(w){this.id=w,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(w){if(this.map.has(w.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${w.item.extId}`);this.map.set(w.item.extId,w),w.parent||this._roots.add(w)}has(w){return this.map.has(w)}delete(w){const u=this.map.get(w);return u?(this.map.delete(w),this._roots.delete(u),!0):!1}get(w){return this.map.get(w)}comparePositions(w,u){const d=typeof w=="string"?this.map.get(w):w,g=typeof u=="string"?this.map.get(u):u;if(!d||!g)return 0;if(d===g)return 3;for(let t=this.map.get(g.parent);t;t=this.map.get(t.parent))if(t===d)return 1;for(let t=this.map.get(d.parent);t;t=this.map.get(t.parent))if(t===g)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=f;class I{constructor(w){this.testIdToInternal=w,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new R.RunOnceScheduler(()=>this.flushDiff(),200),this.diffOpEmitter=new S.Emitter,this.onDidGenerateDiff=this.diffOpEmitter.event}get treeId(){return this.testIdToInternal.object.id}get roots(){return A.Iterable.filter(this.testItemToInternal.values(),w=>w.parent===null)}addRoot(w,u){this.addItem(w,u,null)}getTestByReference(w){return this.testItemToInternal.get(w)}collectDiff(){const w=this.diff;return this.diff=[],w}pushDiff(w){const u=this.diff[this.diff.length-1];if(u&&w[0]===1){if(u[0]===1&&u[1].extId===w[1].extId){k.applyTestItemUpdate(u[1],w[1]);return}if(u[0]===0&&u[1].item.extId===w[1].extId){k.applyTestItemUpdate(u[1],w[1]);return}}this.diff.push(w),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(w,u){var d;const g=this.testIdToInternal.object.get(w);if(!!g){if((g.expandLevels===void 0||u>g.expandLevels)&&(g.expandLevels=u),g.expand===1){const t=this.refreshChildren(g);return t.isSettled?this.expandChildren(g,u-1):t.p.then(()=>this.expandChildren(g,u-1))}else if(g.expand===3)return((d=g.initialExpand)===null||d===void 0?void 0:d.isSettled)===!1?g.initialExpand.p.then(()=>this.expandChildren(g,u-1)):this.expandChildren(g,u-1)}}dispose(){var w;for(const u of this.testItemToInternal.values())(w=u.discoverCts)===null||w===void 0||w.dispose(!0),_.getPrivateApiFor(u.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(w,u){const d=w==null?void 0:w.actual.id;switch(u[0]){case 2:this.pushDiff([4,d]);break;case 1:this.removeItem(w);break;case 0:this.addItem(u[1],w.src.controller,w);break;case 3:const[g,t,i]=u;switch(t){case"status":this.updateExpandability(w);break;case"range":this.pushDiff([1,{extId:d,item:{range:D.Range.from(i)}}]);break;case"error":this.pushDiff([1,{extId:d,item:{error:D.MarkdownString.fromStrict(i)||null}}]);break;default:this.pushDiff([1,{extId:d,item:{[t]:i??null}}]);break}break;default:P.assertNever(u[0])}}addItem(w,u,d){if(!(w instanceof r.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${w.id} did not`);if(this.testItemToInternal.has(w))throw new Error(`Attempted to add a single TestItem ${w.id} multiple times to the tree`);if(this.testIdToInternal.object.has(w.id))throw new Error(`Attempted to insert a duplicate test item ID ${w.id}`);const g=d?d.item.extId:null,t=w.resolveHandler?1:0,i=d?d.expandLevels:1,s={controller:u,tree:this.testIdToInternal.object.id},n={actual:w,parent:g,item:D.TestItem.from(w),expandLevels:i?i-1:void 0,expand:0,src:s};this.testIdToInternal.object.add(n),this.testItemToInternal.set(w,n),this.pushDiff([0,{parent:g,src:s,expand:t,item:n.item}]);const o=_.getPrivateApiFor(w);o.bus.event(this.onTestItemEvent.bind(this,n)),this.updateExpandability(n);for(const v of o.children.values())this.testItemToInternal.has(v)||this.addItem(v,u,n)}updateExpandability(w){var u;let d;w.actual.resolveHandler?w.actual.status===r.TestItemStatus.Pending?d=w.discoverCts?2:1:((u=w.initialExpand)===null||u===void 0||u.complete(),d=3):d=0,d!==w.expand&&(w.expand=d,this.pushDiff([1,{extId:w.actual.id,expand:d}]),d===1&&w.expandLevels!==void 0&&this.refreshChildren(w))}expandChildren(w,u){if(u<0)return;const d=[...w.actual.children.values()].map(g=>this.expand(g.id,u)).filter(R.isThenable);if(d.length)return Promise.all(d).then(()=>{})}refreshChildren(w){if(w.discoverCts&&w.discoverCts.dispose(!0),!w.actual.resolveHandler){const u=new R.DeferredPromise;return u.complete(),u}return w.expand=2,w.discoverCts=new C.CancellationTokenSource,this.pushExpandStateUpdate(w),w.initialExpand=new R.DeferredPromise,w.actual.resolveHandler(w.discoverCts.token),w.initialExpand}pushExpandStateUpdate(w){this.pushDiff([1,{extId:w.actual.id,expand:w.expand}])}removeItem(w){var u;this.pushDiff([2,w.actual.id]);const d=[w];for(;d.length;){const g=d.pop();if(!!g){(u=g.discoverCts)===null||u===void 0||u.dispose(!0),this.testIdToInternal.object.delete(g.item.extId),this.testItemToInternal.delete(g.actual);for(const t of g.actual.children.values())d.push(this.testIdToInternal.object.get(t.id))}}}flushDiff(){const w=this.collectDiff();w.length&&this.diffOpEmitter.fire(w)}reviveDiff(){this.flushDiff();const w=[];for(const{parent:u,src:d,expand:g,item:t}of this.testItemToInternal.values())w.push([0,{parent:u,src:d,expand:g,item:t}]);return w}}e.SingleUseTestCollection=I}),define(pe[212],ve([0,1,4,176]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=p.refineServiceDecorator(R.IEnvironmentService)}),define(pe[213],ve([0,1,26,3,9]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class S{constructor(r){this.removedDueToLooping=r}}e.DeltaExtensionsResult=S;class A{constructor(r){this._onDidChange=new R.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=r,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const r of this._extensionDescriptions){if(this._extensionsMap.has(p.ExtensionIdentifier.toKey(r.identifier))){console.error("Extension `"+r.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(p.ExtensionIdentifier.toKey(r.identifier),r),this._extensionsArr.push(r),Array.isArray(r.activationEvents))for(let k of r.activationEvents)k==="onUri"&&(k=`onUri:${p.ExtensionIdentifier.toKey(r.identifier)}`),this._activationMap.has(k)||this._activationMap.set(k,[]),this._activationMap.get(k).push(r)}}keepOnly(r){const k=new Set;r.forEach(l=>k.add(p.ExtensionIdentifier.toKey(l))),this._extensionDescriptions=this._extensionDescriptions.filter(l=>k.has(p.ExtensionIdentifier.toKey(l.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(r,k){r.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(r));const l=A._findLoopingExtensions(this._extensionDescriptions);if(k=k.concat(l.map(h=>h.identifier)),k.length>0){const h=new Set;k.forEach(c=>h.add(p.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!h.has(p.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new S(l)}static _findLoopingExtensions(r){const k=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(I){this._nodesSet.has(I)||(this._nodesSet.add(I),this._nodesArr.push(I))}addArc(I,b){this.addNode(I),this.addNode(b),this._arcs.has(I)?this._arcs.get(I).push(b):this._arcs.set(I,[b])}getArcs(I){return this._arcs.has(I)?this._arcs.get(I):[]}hasOnlyGoodArcs(I,b){const w=k.getArcs(I);for(let u=0;u<w.length;u++)if(!b.has(w[u]))return!1;return!0}getNodes(){return this._nodesArr}};let l=new Map;for(let I of r){const b=p.ExtensionIdentifier.toKey(I.identifier);if(l.set(b,I),I.extensionDependencies)for(let w of I.extensionDependencies){const u=p.ExtensionIdentifier.toKey(w);k.addArc(b,u)}}let h=new Set;k.getNodes().filter(I=>k.getArcs(I).length===0).forEach(I=>h.add(I));let c=k.getNodes().filter(I=>!h.has(I)),f;do{f=!1;for(let I=0;I<c.length;I++){const b=c[I];k.hasOnlyGoodArcs(b,h)&&(c.splice(I,1),I--,h.add(b),f=!0)}}while(f);return c.map(I=>l.get(I))}containsActivationEvent(r){return this._activationMap.has(r)}containsExtension(r){return this._extensionsMap.has(p.ExtensionIdentifier.toKey(r))}getExtensionDescriptionsForActivationEvent(r){const k=this._activationMap.get(r);return k?k.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(r){const k=this._extensionsMap.get(p.ExtensionIdentifier.toKey(r));return k||void 0}}e.ExtensionDescriptionRegistry=A;var P;(function(D){D[D.Builtin=0]="Builtin",D[D.User=1]="User",D[D.Dev=2]="Dev"})(P||(P={}));function _(D,r){const k=D.isBuiltin?0:D.isUnderDevelopment?2:1,l=r.isBuiltin?0:r.isUnderDevelopment?2:1;if(k!==l)return k-l;const h=C.posix.basename(D.extensionLocation.path),c=C.posix.basename(r.extensionLocation.path);return h<c?-1:h>c?1:0}}),define(pe[214],ve([0,1,22]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var R;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(R=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var C;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(C=e.MessageType||(e.MessageType={}));function S(P){const _=p.VSBuffer.alloc(1);switch(P){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=S;function A(P,_){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=A}),define(pe[35],ve([0,1,3,2,4,26,178]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new S.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=C.createDecorator("extensionService");class P{constructor(w){this.dependency=w}}e.MissingExtensionDependency=P;var _;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class D{constructor(w,u,d,g){this.codeLoadingTime=w,this.activateCallTime=u,this.activateResolvedTime=d,this.activationReason=g}}e.ActivationTimes=D;class r{constructor(w,u){this.description=w,this.value=u}}e.ExtensionPointContribution=r,e.ExtensionHostLogFileName="exthost";var k;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(k=e.ActivationKind||(e.ActivationKind={}));function l(b){b.enableProposedApi||h(b)}e.checkProposedApiEnabled=l;function h(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=h;function c(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:A.getGalleryExtensionId(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=c;function f(b){return Object.assign(Object.assign({identifier:new S.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!1,extensionLocation:b.location},b.manifest),{uuid:b.identifier.uuid})}e.toExtensionDescription=f;class I{constructor(){this.onDidRegisterExtensions=p.Event.None,this.onDidChangeExtensionsStatus=p.Event.None,this.onDidChangeExtensions=p.Event.None,this.onWillActivateByEvent=p.Event.None,this.onDidChangeResponsiveChange=p.Event.None}activateByEvent(w){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(w){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(w){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(w){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(w,u){return Promise.resolve()}_onWillActivateExtension(w){}_onDidActivateExtension(w,u,d,g,t){}_onDidActivateExtensionError(w,u){}_onExtensionRuntimeError(w,u){}_onExtensionHostExit(w){}}e.NullExtensionService=I}),define(pe[215],ve([0,1,26,35,12]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const S=Promise.resolve(void 0);class A{constructor(c,f,I,b){this.startup=c,this.codeLoadingTime=f,this.activateCallTime=I,this.activateResolvedTime=b}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class P{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,f){return c===-1||f===-1?-1:f-c}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=P;class _{constructor(c,f,I,b,w,u){this.activationFailed=c,this.activationFailedError=f,this.activationTimes=I,this.module=b,this.exports=w,this.subscriptions=u}}e.ActivatedExtension=_;class D extends _{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=D;class r extends _{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=r;class k extends _{constructor(c){super(!0,c,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=k;let l=class{constructor(c,f,I,b,w){this._logService=w,this._registry=c,this._resolvedExtensionsSet=new Set,f.forEach(u=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(u))),this._hostExtensionsMap=new Map,I.forEach(u=>this._hostExtensionsMap.set(p.ExtensionIdentifier.toKey(u),u)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const f=p.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(f)}getActivatedExtension(c){const f=p.ExtensionIdentifier.toKey(c),I=this._activatedExtensions.get(f);if(!I)throw new Error("Extension `"+c.value+"` is not known or not activated");return I}activateByEvent(c,f){if(this._alreadyActivatedEvents[c])return S;const I=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(I.map(b=>({id:b.identifier,reason:{startup:f,extensionId:b.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,f){const I=this._registry.getExtensionDescription(c);if(!I)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:I.identifier,reason:f}])}_handleActivateRequest(c,f,I){if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(c.id))){f[p.ExtensionIdentifier.toKey(c.id)]=c;return}const b=this._registry.getExtensionDescription(c.id);if(!b){const d=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,d,new R.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(c.id),new k(d));return}const w=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let u=!0;for(let d=0,g=w.length;d<g;d++){const t=w[d];if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(t)))continue;const i=this._activatedExtensions.get(p.ExtensionIdentifier.toKey(t));if(i&&!i.activationFailed)continue;if(i&&i.activationFailed){const v=b.displayName||b.identifier.value,m=this._registry.getExtensionDescription(t),E=m&&m.displayName||t,y=new Error(`Cannot activate the '${v}' extension because its dependency '${E}' failed to activate`);y.detail=i.activationFailedError,this._host.onExtensionActivationError(b.identifier,y,null),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(b.identifier),new k(y));return}if(this._hostExtensionsMap.has(p.ExtensionIdentifier.toKey(t))){u=!1,f[p.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(p.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){u=!1,f[p.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const n=b.displayName||b.identifier.value,o=new Error(`Cannot activate the '${n}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,o,new R.MissingExtensionDependency(t)),this._activatedExtensions.set(p.ExtensionIdentifier.toKey(b.identifier),new k(o));return}u?f[p.ExtensionIdentifier.toKey(b.identifier)]=c:I.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(w=>!this._activatedExtensions.has(p.ExtensionIdentifier.toKey(w.id))),c.length===0))return Promise.resolve(void 0);const f=Object.create(null),I=[];for(let w=0,u=c.length;w<u;w++)this._handleActivateRequest(c[w],f,I);for(let w=0,u=I.length;w<u;w++){const d=p.ExtensionIdentifier.toKey(I[w].id);f[d]&&delete f[d]}const b=Object.keys(f).map(w=>f[w]);return I.length===0?Promise.all(b.map(w=>this._activateExtension(w.id,w.reason))).then(w=>{}):this._activateExtensions(b).then(w=>this._activateExtensions(I))}_activateExtension(c,f){const I=p.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(I))return Promise.resolve(void 0);const b=this._activatingExtensions.get(I);if(b)return b;const w=this._host.actualActivateExtension(c,f).then(void 0,u=>{const d=new Error;return u&&u.name&&(d.name=u.name),u&&u.message?d.message=`Activating extension '${c.value}' failed: ${u.message}.`:d.message=`Activating extension '${c.value}' failed: ${u}.`,u&&u.stack&&(d.stack=u.stack),this._host.onExtensionActivationError(c,d,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(u),new k(u)}).then(u=>{this._activatedExtensions.set(I,u),this._activatingExtensions.delete(I)});return this._activatingExtensions.set(I,w),w}};l=qe([We(4,C.ILogService)],l),e.ExtensionsActivator=l}),define(pe[216],ve([0,1,12,35,27,10,113]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let P=class extends p.LogService{constructor(D){if(D.logFile.scheme!==S.Schemas.file)throw new Error("Only file-logging supported");super(new A.SpdLogLogger(R.ExtensionHostLogFileName,D.logFile.fsPath,!0,D.logLevel))}$setLevel(D){this.setLevel(D)}};P=qe([We(0,C.IExtHostInitDataService)],P),e.ExtHostLogService=P}),define(pe[217],ve([0,1,14]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class R{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((S,A)=>{this._actualOk=S,this._actualErr=A,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(S){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=S,this._actual&&this._actualOk(S))}resolveErr(S){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=S,this._actual?this._actualErr(S):p.onUnexpectedError(S))}then(S,A){return this._ensureActual().then(S,A)}catch(S){return this._ensureActual().then(void 0,S)}finally(S){return this._ensureActual().finally(S)}}e.LazyPromise=R}),define(pe[125],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class p{constructor(_,D){this.isMain=_,this.sid=D,this.nid=++p.count}}e.ProxyIdentifier=p,p.count=0;const R=[];function C(P){const _=new p(!0,P);return R[_.nid]=_,_}e.createMainContextProxyIdentifier=C;function S(P){const _=new p(!1,P);return R[_.nid]=_,_}e.createExtHostContextProxyIdentifier=S;function A(P){return R[P].sid}e.getStringIdentifierForProxy=A}),define(pe[5],ve([0,1,55,2,125]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var S;(function(u){u[u.Desktop=1]="Desktop",u[u.Web=2]="Web"})(S=e.UIKind||(e.UIKind={}));var A;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var P;(function(u){u[u.Editable=0]="Editable",u[u.SupportsHotExit=1]="SupportsHotExit"})(P=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(u){u[u.Int8Array=1]="Int8Array",u[u.Uint8Array=2]="Uint8Array",u[u.Uint8ClampedArray=3]="Uint8ClampedArray",u[u.Int16Array=4]="Int16Array",u[u.Uint16Array=5]="Uint16Array",u[u.Int32Array=6]="Int32Array",u[u.Uint32Array=7]="Uint32Array",u[u.Float32Array=8]="Float32Array",u[u.Float64Array=9]="Float64Array",u[u.BigInt64Array=10]="BigInt64Array",u[u.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var D;(function(u){u[u.Text=1]="Text",u[u.Error=2]="Error",u[u.Rich=3]="Rich"})(D=e.CellOutputKind||(e.CellOutputKind={}));var r;(function(u){u[u.Default=0]="Default",u[u.InCenter=1]="InCenter",u[u.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",u[u.AtTop=3]="AtTop"})(r=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(u){u[u.None=0]="None",u[u.Process=1]="Process",u[u.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var l;(function(u){u.name="$ident";function d(t,i){return Object.defineProperty(t,u.name,{value:i,enumerable:!0}),t}u.mixin=d;function g(t){return t[u.name]}u.of=g})(l=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(d){return d._id=h._n++,d}}e.IdObject=h,h._n=0;var c;(function(u){u.label="a",u.kind="b",u.detail="c",u.documentation="d",u.sortText="e",u.filterText="f",u.preselect="g",u.insertText="h",u.insertTextRules="i",u.range="j",u.commitCharacters="k",u.additionalTextEdits="l",u.command="m",u.kindModifier="n",u.label2="o"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(u){u.defaultRanges="a",u.completions="b",u.isIncomplete="c",u.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var I;(function(u){u[u.File=1]="File",u[u.Text=2]="Text",u[u.Cell=3]="Cell"})(I=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(u){if(u&&u.edits)for(const d of u.edits)typeof d.resource=="object"?d.resource=R.URI.revive(d.resource):(d.newUri=R.URI.revive(d.newUri),d.oldUri=R.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=p.revive(d.metadata));return u}e.reviveWorkspaceEditDto=b;var w;(function(u){u[u.Workspace=0]="Workspace",u[u.TextDocument=1]="TextDocument"})(w=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:C.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:C.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:C.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:C.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:C.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:C.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:C.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:C.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:C.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:C.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:C.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:C.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:C.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:C.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:C.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:C.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:C.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:C.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:C.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:C.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:C.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:C.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:C.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:C.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:C.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:C.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:C.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:C.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:C.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:C.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:C.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:C.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:C.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:C.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:C.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:C.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:C.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:C.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:C.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:C.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:C.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:C.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:C.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:C.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:C.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:C.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:C.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:C.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:C.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:C.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:C.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:C.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:C.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:C.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:C.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:C.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:C.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:C.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:C.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:C.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:C.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:C.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:C.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:C.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:C.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:C.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:C.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:C.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:C.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:C.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:C.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:C.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:C.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:C.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:C.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:C.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:C.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:C.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:C.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:C.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:C.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:C.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:C.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:C.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:C.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:C.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:C.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:C.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:C.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:C.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:C.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:C.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:C.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:C.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:C.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:C.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:C.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:C.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:C.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:C.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:C.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:C.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:C.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:C.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(pe[86],ve([0,1,5,3,4]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class S{constructor(P){this._onDidChangePassword=new R.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=P.getProxy(p.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this._onDidChangePassword.fire(P)}get(P,_){return this._proxy.$getPassword(P,_)}store(P,_,D){return this._proxy.$setPassword(P,_,D)}delete(P,_){return this._proxy.$deletePassword(P,_)}}e.ExtHostSecretState=S,e.IExtHostSecretState=C.createDecorator("IExtHostSecretState")}),define(pe[61],ve([0,1,4,12,5,13]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=p.createDecorator("IExtHostApiDeprecationService");let A=class{constructor(_,D){this._extHostLogService=D,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(C.MainContext.MainThreadTelemetry)}report(_,D,r){const k=this.getUsageKey(_,D);this._reportedUsages.has(k)||(this._reportedUsages.add(k),D.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${r}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:_}))}getUsageKey(_,D){return`${_}-${D.identifier.value}`}};A=qe([We(0,S.IExtHostRpcService),We(1,R.ILogService)],A),e.ExtHostApiDeprecationService=A,e.NullApiDeprecationService=Object.freeze(new class{report(P,_,D){}})}),define(pe[218],ve([0,1,3,5,7,26]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new p.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new p.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(_,D,r,k={}){const l=S.ExtensionIdentifier.toKey(_.identifier),h=this._inFlightRequests.get(l)||[],c=[...r].sort().join(" ");let f=h.find(I=>I.scopes===c);if(f)return f.result;{const I=this._getSession(_,l,D,r,k);f={scopes:c,result:I},h.push(f),this._inFlightRequests.set(l,h);try{await I}finally{const b=h.findIndex(w=>w.scopes===c);b>-1&&(h.splice(b),this._inFlightRequests.set(l,h))}return I}}async _getSession(_,D,r,k,l={}){await this._proxy.$ensureProvider(r);const h=_.displayName||_.name;return this._proxy.$getSession(r,k,D,h,l)}async removeSession(_,D){const r=this._authenticationProviders.get(_);return r?r.provider.removeSession(D):this._proxy.$removeSession(_,D)}registerAuthenticationProvider(_,D,r,k){var l;if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:D,provider:r,options:k??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===_)||this._providers.push({id:_,label:D});const h=r.onDidChangeSessions(c=>{var f,I,b;this._proxy.$sendDidChangeSessions(_,{added:(f=c.added)!==null&&f!==void 0?f:[],changed:(I=c.changed)!==null&&I!==void 0?I:[],removed:(b=c.removed)!==null&&b!==void 0?b:[]})});return this._proxy.$registerAuthenticationProvider(_,D,(l=k==null?void 0:k.supportsMultipleAccounts)!==null&&l!==void 0?l:!1),new C.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(_);const c=this._providers.findIndex(f=>f.id===_);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,D){const r=this._authenticationProviders.get(_);if(r)return Promise.resolve(r.provider.createSession(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,D){const r=this._authenticationProviders.get(_);if(r)return Promise.resolve(r.provider.removeSession(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,D){const r=this._authenticationProviders.get(_);if(r)return Promise.resolve(r.provider.getSessions(D));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,D){return this._onDidChangeSessions.fire({provider:{id:_,label:D}}),Promise.resolve()}$onDidChangeAuthenticationProviders(_,D){return _.forEach(r=>{this._providers.some(k=>k.id===r.id)||this._providers.push(r)}),D.forEach(r=>{const k=this._providers.findIndex(l=>l.id===r.id);k>-1&&this._providers.splice(k)}),this._onDidChangeAuthenticationProviders.fire({added:_,removed:D}),Promise.resolve()}}e.ExtHostAuthentication=A}),define(pe[219],ve([0,1,5,13,17]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let S=class{constructor(P,_){this._extHostDocumentsAndEditors=_,this._proxy=P.getProxy(p.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(P){const _=C.WorkspaceEdit.from(P,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};S=qe([We(0,R.IExtHostRpcService)],S),e.ExtHostBulkEdits=S}),define(pe[220],ve([0,1,5]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(S){const A=S.getProxy(p.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(P){return A.$writeText(P)}})}}e.ExtHostClipboard=R}),define(pe[48],ve([0,1,15,7,17,25,5,18,12,55,41,44,2,6,4,13]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let I=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(A.MainContext.MainThreadCommands),this._logService=i,this.converter=new b(this,s=>{const n=this._apiCommands.get(s);return(n==null?void 0:n.result)===u.Void?n:void 0},i),this._argumentProcessors=[{processArgument(s){return D.revive(s)}},{processArgument(s){return S.cloneAndChange(s,function(n){if(r.Range.isIRange(n))return C.Range.to(n);if(k.Position.isIPosition(n))return C.Position.to(n);if(r.Range.isIRange(n.range)&&l.URI.isUri(n.uri))return C.location.to(n);if(!Array.isArray(n))return n})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...s)=>{const n=t.args.map((v,m)=>{if(!v.validate(s[m]))throw new Error(`Invalid argument '${v.name}' when running '${t.id}', received: ${s[m]}`);return v.convert(s[m])}),o=await this.executeCommand(t.internalId,...n);return t.result.convert(o,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new R.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,s,n,o){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:s,thisArg:n,description:o}),t&&this._proxy.$registerCommand(i),new R.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,s){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const n=S.cloneAndChange(i,function(o){if(o instanceof R.Position)return C.Position.from(o);if(o instanceof R.Range)return C.Range.from(o);if(o instanceof R.Location)return C.location.from(o);if(R.NotebookRange.isNotebookRange(o))return C.NotebookRange.from(o);if(!Array.isArray(o))return o});try{const o=await this._proxy.$executeCommand(t,n,s);return D.revive(o)}catch(o){if(o instanceof Error&&o.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw o}}}async _executeContributedCommand(t,i){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:n,thisArg:o,description:v}=s;if(v)for(let m=0;m<v.args.length;m++)try{p.validateConstraint(i[m],v.args[m].constraint)}catch(E){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${v.args[m].name}' - ${v.args[m].description}`)}try{return await n.apply(o,i)}catch(m){if(t===this.converter.delegatingCommandId){const E=this.converter.getActualCommand(...i);E&&(t=E.command)}throw this._logService.error(m,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(s=>this._argumentProcessors.reduce((n,o)=>o.processArgument(n),s)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(s=>s[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,s]of this._commands){let{description:n}=s;n&&(t[i]=n)}return Promise.resolve(t)}};I=qe([We(0,f.IExtHostRpcService),We(1,_.ILogService)],I),e.ExtHostCommands=I,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class b{constructor(t,i,s){this._commands=t,this._lookupApiCommand=i,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const n=this._lookupApiCommand(t.command);if(n)s.id=n.internalId,s.arguments=n.args.map((o,v)=>o.convert(t.arguments&&t.arguments[v]));else if(P.isNonEmptyArray(t.arguments)){const o=++this._cachIdPool;this._cache.set(o,t),i.add(h.toDisposable(()=>{this._cache.delete(o),this._logService.trace("CommandsConverter#DISPOSE",o)})),s.$ident=o,s.id=this.delegatingCommandId,s.arguments=[o],this._logService.trace("CommandsConverter#CREATE",t.command,o)}return s}fromInternal(t){const i=A.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class w{constructor(t,i,s,n){this.name=t,this.description=i,this.validate=s,this.convert=n}optional(){return new w(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new w(t??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=w,w.Uri=new w("uri","Uri of a text document",g=>l.URI.isUri(g),g=>g),w.Position=new w("position","A position in a text document",g=>R.Position.isPosition(g),C.Position.from),w.Range=new w("range","A range in a text document",g=>R.Range.isRange(g),C.Range.from),w.Selection=new w("selection","A selection in a text document",g=>R.Selection.isSelection(g),C.Selection.from),w.Number=new w("number","",g=>typeof g=="number",g=>g),w.String=new w("string","",g=>typeof g=="string",g=>g),w.CallHierarchyItem=new w("item","A call hierarchy item",g=>g instanceof R.CallHierarchyItem,C.CallHierarchyItem.to);class u{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=u,u.Void=new u("no result",g=>g);class d{constructor(t,i,s,n,o){this.id=t,this.internalId=i,this.description=s,this.args=n,this.result=o}}e.ApiCommand=d}),define(pe[221],ve([0,1,17,7,78,48,18,108]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",r(p.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(l,h)=>{if(A.isFalsyOrEmpty(l))return;class c extends R.SymbolInformation{static to(I){const b=new c(I.name,p.SymbolKind.to(I.kind),I.containerName||"",new R.Location(h[0],p.Range.to(I.range)));return b.detail=I.detail,b.range=b.location.range,b.selectionRange=p.Range.to(I.selectionRange),b.children=I.children?I.children.map(c.to):[],b}}return l.map(c.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",l=>typeof l=="string",l=>l),new S.ApiCommandArgument("options","Formatting options",l=>!0,l=>l)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",r(p.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",k)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",r(p.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",r(p.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",l=>Array.isArray(l)&&l.every(h=>R.Position.isPosition(h)),l=>l.map(p.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",l=>l.map(h=>{let c;for(const f of h.reverse())c=new R.SelectionRange(p.Range.to(f),c);return c}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",l=>{const h=[];if(Array.isArray(l))for(let c of l)h.push(...c[1].map(p.WorkspaceSymbol.to));return h})),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A CallHierarchyItem or undefined",l=>l.map(p.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",l=>{if(!!l){if(l.rejectReason)throw new Error(l.rejectReason);return p.WorkspaceEdit.to(l)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",l=>l.map(p.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=P.decodeSemanticTokensDto(l);if(h.type==="full")return new R.SemanticTokens(h.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",l=>{if(!!l)return new R.SemanticTokensLegend(l.tokenTypes,l.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",l=>{if(!l)return;const h=P.decodeSemanticTokensDto(l);if(h.type==="full")return new R.SemanticTokens(h.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(l,h,c)=>{if(!l)return new R.CompletionList([]);const f=l.suggestions.map(I=>p.CompletionItem.to(I,c));return new R.CompletionList(f,l.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",l=>{if(l)return p.SignatureHelp.to(l)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(l,h,c)=>r(f=>new R.CodeLens(p.Range.to(f.range),f.command&&c.fromInternal(f.command)))(l))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",l=>R.Range.isRange(l),l=>R.Selection.isSelection(l)?p.Selection.from(l):p.Range.from(l)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(l,h,c)=>r(f=>{if(f._isSynthetic){if(!f.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(f.command)}else{const I=new R.CodeAction(f.title,f.kind?new R.CodeActionKind(f.kind):void 0);return f.edit&&(I.edit=p.WorkspaceEdit.to(f.edit)),f.command&&(I.command=c.fromInternal(f.command)),I.isPreferred=f.isPreferred,I}})(l))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",l=>l?l.map(h=>new R.ColorInformation(p.Range.to(h.range),p.Color.to(h.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",l=>l instanceof R.Color,p.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",l=>!0,l=>({uri:l.uri,range:p.Range.from(l.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",l=>l?l.map(p.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",l=>l.map(p.InlayHint.to))),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",r(l=>({viewType:l.viewType,displayName:l.displayName,options:{transientOutputs:l.options.transientOutputs,transientCellMetadata:l.options.transientCellMetadata,transientDocumentMetadata:l.options.transientDocumentMetadata},filenamePattern:l.filenamePattern.map(h=>p.NotebookExclusiveDocumentPattern.to(h))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",l=>l.map(p.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="number"||typeof l=="object",l=>l&&(typeof l=="number"?[l,void 0]:[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",l=>l===void 0||typeof l=="object",l=>l&&[p.ViewColumn.from(l.viewColumn),p.TextEditorOpenOptions.from(l)]).optional()],S.ApiCommandResult.Void)];class D{static register(h){_.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=D;function r(l){return h=>{if(Array.isArray(h))return h.map(l)}}function k(l){if(!Array.isArray(l))return;const h=[];for(const c of l)C.isLocationLink(c)?h.push(p.DefinitionLink.to(c)):h.push(p.location.to(c));return h}}),define(pe[222],ve([0,1,16,51,3,6,2,78,26,17,7,5]),function(X,e,p,R,C,S,A,P,_,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class l{constructor(d,g,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=d.getProxy(k.MainContext.MainThreadComments),g.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const s=this._commentControllers.get(i.handle);return s||i}else if(i&&i.$mid===7){const s=this._commentControllers.get(i.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.commentThreadHandle);return n||i}else if(i&&i.$mid===8){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);return n?{thread:n,text:i.text}:i}else if(i&&i.$mid===9){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);if(!n)return i;let o=i.commentUniqueId,v=n.getCommentByUniqueId(o);return v||i}else if(i&&i.$mid===10){const s=this._commentControllers.get(i.thread.commentControlHandle);if(!s)return i;const n=s.getCommentThread(i.thread.commentThreadHandle);if(!n)return i;let o=i.text,v=i.commentUniqueId,m=n.getCommentByUniqueId(v);return m?(m.body=o,m):i}return i}})}createCommentController(d,g,t){const i=l.handlePool++,s=new c(d,i,this._proxy,g,t);this._commentControllers.set(s.handle,s);const n=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(d.identifier))||[];return n.push(s),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(d.identifier),n),s}$createCommentThreadTemplate(d,g,t){const i=this._commentControllers.get(d);!i||i.$createCommentThreadTemplate(g,t)}async $updateCommentThreadTemplate(d,g,t){const i=this._commentControllers.get(d);!i||i.$updateCommentThreadTemplate(g,t)}$deleteCommentThread(d,g){const t=this._commentControllers.get(d);t&&t.$deleteCommentThread(g)}$provideCommentingRanges(d,g,t){const i=this._commentControllers.get(d);if(!i||!i.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(A.URI.revive(g));return p.asPromise(()=>i.commentingRangeProvider.provideCommentingRanges(s,t)).then(n=>n?n.map(o=>D.Range.from(o)):void 0)}$toggleReaction(d,g,t,i,s){const n=this._commentControllers.get(d);return!n||!n.reactionHandler?Promise.resolve(void 0):p.asPromise(()=>{const o=n.getCommentThread(g);if(o){const v=o.getCommentByUniqueId(i.uniqueIdInThread);if(n!==void 0&&v&&n.reactionHandler)return n.reactionHandler(v,b(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=l,l.handlePool=0;class h{constructor(d,g,t,i,s,n,o){this._proxy=d,this._commentController=g,this._id=t,this._uri=i,this._range=s,this._comments=n,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new C.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputDisposables.value=new S.DisposableStore,this._id===void 0&&(this._id=`${g.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,D.Range.from(this._range),o),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=n}set threadId(d){this._id=d}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(d){d.isEqual(this._range)||(this._range=d,this.modifications.range=d,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(d){this._canReply!==d&&(this._canReply=d,this.modifications.canReply=d,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(d){this._label=d,this.modifications.label=d,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(d){this._contextValue=d,this.modifications.contextValue=d,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(d){this._comments=d,this.modifications.comments=d,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(d){this._collapseState=d,this.modifications.collapsibleState=d,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new S.DisposableStore);const d=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),g={};d("range")&&(g.range=D.Range.from(this._range)),d("label")&&(g.label=this.label),d("contextValue")&&(g.contextValue=this.contextValue),d("comments")&&(g.comments=this._comments.map(t=>f(this,this._commentController,t,this._commentsMap))),d("collapsibleState")&&(g.collapseState=w(this._collapseState)),d("canReply")&&(g.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,g)}getCommentByUniqueId(d){for(let g of this._commentsMap){let t=g[0],i=g[1];if(d===i)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(d=>d.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,qe([R.debounce(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class c{constructor(d,g,t,i,s){this._extension=d,this._handle=g,this._proxy=t,this._id=i,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,i,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(d){this._reactionHandler=d,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!d})}get options(){return this._options}set options(d){this._options=d,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(d,g,t,i){if(typeof d=="string"){const s=new h(this._proxy,this,d,g,t,i,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new h(this._proxy,this,void 0,d,g,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(d,g){const t=new h(this._proxy,this,void 0,A.URI.revive(d),D.Range.to(g),[],this._extension.identifier);return t.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(d,g){let t=this._threads.get(d);t&&(t.range=D.Range.to(g))}$deleteCommentThread(d){let g=this._threads.get(d);g&&g.dispose(),this._threads.delete(d)}getCommentThread(d){return this._threads.get(d)}dispose(){this._threads.forEach(d=>{d.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function f(u,d,g,t){let i=t.get(g);i||(i=++u.commentHandle,t.set(g,i));const s=g.author&&g.author.iconPath?g.author.iconPath.toString():void 0;return{mode:g.mode,contextValue:g.contextValue,uniqueIdInThread:i,body:D.MarkdownString.from(g.body),userName:g.author.name,userIconPath:s,label:g.label,commentReactions:g.reactions?g.reactions.map(n=>I(n)):void 0}}function I(u){return{label:u.label,iconPath:u.iconPath?D.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function b(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?A.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function w(u){if(u!==void 0)switch(u){case r.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case r.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}}),define(pe[126],ve([0,1,2,5,7,4,13,12,18,8,9]),function(X,e,p,R,C,S,A,P,_,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let k=class yn{constructor(h,c){this._logService=c,this._provider=new Map,this._proxy=h.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,c){const f=yn._handlePool++;this._provider.set(f,{provider:h,extensionId:c}),this._proxy.$registerDecorationProvider(f,c.value);const I=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(f,null);return}let w=_.asArray(b);if(w.length<=yn._maxEventSize){this._proxy.$onDidChange(f,w);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,w.length);const u=w.map(t=>({uri:t,rank:D.count(t.path,"/")})),d=_.groupBy(u,(t,i)=>t.rank-i.rank||D.compare(t.uri.path,i.uri.path));let g=[];e:for(let t of d){let i;for(let s of t){let n=r.dirname(s.uri.path);if(i!==n&&(i=n,g.push(s.uri)>=yn._maxEventSize))break e}}this._proxy.$onDidChange(f,g)});return new C.Disposable(()=>{I==null||I.dispose(),this._proxy.$unregisterDecorationProvider(f),this._provider.delete(f)})}async $provideDecorations(h,c,f){if(!this._provider.has(h))return Object.create(null);const I=Object.create(null),{provider:b,extensionId:w}=this._provider.get(h);return await Promise.all(c.map(async u=>{try{const{uri:d,id:g}=u,t=await Promise.resolve(b.provideFileDecoration(p.URI.revive(d),f));if(!t)return;try{C.FileDecoration.validate(t),I[g]=[t.propagate,t.tooltip,t.badge,t.color]}catch(i){this._logService.warn(`INVALID decoration from extension '${w.value}': ${i}`)}}catch(d){this._logService.error(d)}})),I}};k._handlePool=0,k._maxEventSize=250,k=qe([We(0,A.IExtHostRpcService),We(1,P.ILogService)],k),e.ExtHostDecorations=k,e.IExtHostDecorations=S.createDecorator("IExtHostDecorations")}),define(pe[223],ve([0,1,158,114,2,5,7,17,3,12,23]),function(X,e,p,R,C,S,A,P,_,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class k{constructor(c,f,I,b,w){this._name=c,this._owner=f,this._maxDiagnosticsPerFile=I,this._proxy=b,this._onDidChangeDiagnostics=w,this._isDisposed=!1,this._data=new r.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,f){if(!c){this.clear();return}this._checkDisposed();let I=[];if(C.URI.isUri(c)){if(!f){this.delete(c);return}this._data.set(c,f.slice()),I=[c]}else if(Array.isArray(c)){I=[];let w;c=[...c].sort(k._compareIndexedTuplesByUri);for(const u of c){const[d,g]=u;if((!w||d.toString()!==w.toString())&&(w&&this._data.get(w).length===0&&this._data.delete(w),w=d,I.push(d),this._data.set(d,[])),g){const t=this._data.get(d);t&&t.push(...g)}else{const t=this._data.get(d);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(I),!this._proxy)return;const b=[];for(let w of I){let u=[];const d=this._data.get(w);if(d)if(d.length>this._maxDiagnosticsPerFile){u=[];const g=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let i of d)if(i.severity===g[t]&&u.push(P.Diagnostic.from(i))===this._maxDiagnosticsPerFile)break e;u.push({severity:R.MarkerSeverity.Info,message:p.localize(0,null,d.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=d.map(g=>P.Diagnostic.from(g));b.push([w,u])}this._proxy.$changeMany(this._owner,b)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,f){this._checkDisposed();for(let I of this._data.keys())c.apply(f,[I,this.get(I),this])}get(c){this._checkDisposed();const f=this._data.get(c);return Array.isArray(f)?Object.freeze(f.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,f){return c[0].toString()<f[0].toString()?-1:c[0].toString()>f[0].toString()?1:0}}e.DiagnosticCollection=k;let l=class jt{constructor(c,f){this._logService=f,this._collections=new Map,this._onDidChangeDiagnostics=new _.Emitter,this.onDidChangeDiagnostics=_.Event.map(_.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=c.getProxy(S.MainContext.MainThreadDiagnostics)}static _debouncer(c,f){return c?c.concat(f):f}static _mapper(c){const f=new r.ResourceMap;for(const I of c)f.set(I,I);return{uris:Object.freeze(Array.from(f.values()))}}createDiagnosticCollection(c,f){const{_collections:I,_proxy:b,_onDidChangeDiagnostics:w,_logService:u}=this,d=new class{$changeMany(i,s){b.$changeMany(i,s),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,i,s.length===0?"CLEARING":s)}$clear(i){b.$clear(i),u.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,i)}dispose(){b.dispose()}};let g;if(!f)f="_generated_diagnostic_collection_name_#"+jt._idPool++,g=f;else if(!I.has(f))g=f;else{this._logService.warn(`DiagnosticCollection with name '${f}' does already exist.`);do g=f+jt._idPool++;while(I.has(g))}return new class extends k{constructor(){super(f,g,jt._maxDiagnosticsPerFile,d,w);I.set(g,this)}dispose(){super.dispose(),I.delete(g)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const f=new Map,I=[];for(const b of this._collections.values())b.forEach((w,u)=>{let d=f.get(w.toString());typeof d=="undefined"&&(d=I.length,f.set(w.toString(),d),I.push([w,[]])),I[d][1]=I[d][1].concat(...u)});return I}}_getDiagnostics(c){let f=[];for(let I of this._collections.values())I.has(c)&&(f=f.concat(I.get(c)));return f}$acceptMarkersChange(c){if(!this._mirrorCollection){const f="_generated_mirror",I=new k(f,f,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(f,I),this._mirrorCollection=I}for(const[f,I]of c)this._mirrorCollection.set(C.URI.revive(f),I.map(P.Diagnostic.to))}};l._idPool=0,l._maxDiagnosticsPerFile=1e3,l=qe([We(1,D.ILogService)],l),e.ExtHostDiagnostics=l}),define(pe[224],ve([0,1,2,5]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class C{constructor(A){this._proxy=A.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(A){return this._proxy.$showOpenDialog(A).then(P=>P?P.map(_=>p.URI.revive(_)):void 0)}showSaveDialog(A){return this._proxy.$showSaveDialog(A).then(P=>P?p.URI.revive(P):void 0)}}e.ExtHostDialogs=C}),define(pe[225],ve([0,1,14,2,7,5,10,21,8]),function(X,e,p,R,C,S,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class D{constructor(k,l,h){this._documentsAndEditors=l,this._logService=h,this._documentContentProviders=new Map,this._proxy=k.getProxy(S.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,l){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const h=D._handlePool++;this._documentContentProviders.set(h,l),this._proxy.$registerTextContentProvider(h,k);let c;return typeof l.onDidChange=="function"&&(c=l.onDidChange(f=>{if(f.scheme!==k){this._logService.warn(`Provider for scheme '${k}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(f)&&this.$provideTextDocumentContent(h,f).then(I=>{if(!I&&typeof I!="string")return;const b=this._documentsAndEditors.getDocument(f);if(!b)return;const w=_.splitLines(I);if(!b.equalLines(w))return this._proxy.$onVirtualDocumentChange(f,I)},p.onUnexpectedError)})),new C.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(k,l){const h=this._documentContentProviders.get(k);return h?Promise.resolve(h.provideTextDocumentContent(R.URI.revive(l),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.ExtHostDocumentContentProvider=D,D._handlePool=0}),define(pe[226],ve([0,1,3,6,2,5,119,17,15,25]),function(X,e,p,R,C,S,A,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class r{constructor(l,h){this._onDidAddDocument=new p.Emitter,this._onDidRemoveDocument=new p.Emitter,this._onDidChangeDocument=new p.Emitter,this._onDidSaveDocument=new p.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new R.DisposableStore,this._documentLoader=new Map,this._proxy=l.getProxy(S.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const f of c)this._onDidRemoveDocument.fire(f.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const f of c)this._onDidAddDocument.fire(f.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(l){if(!l)return;const h=this._documentsAndEditors.getDocument(l);if(h)return h}getDocument(l){const h=this.getDocumentData(l);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${l}'`);return h.document}ensureDocumentData(l){const h=this._documentsAndEditors.getDocument(l);if(h)return Promise.resolve(h);let c=this._documentLoader.get(l.toString());return c||(c=this._proxy.$tryOpenDocument(l).then(f=>{this._documentLoader.delete(l.toString());const I=C.URI.revive(f);return _.assertIsDefined(this._documentsAndEditors.getDocument(I))},f=>(this._documentLoader.delete(l.toString()),Promise.reject(f))),this._documentLoader.set(l.toString(),c)),c}createDocumentData(l){return this._proxy.$tryCreateDocument(l).then(h=>C.URI.revive(h))}$acceptModelModeChanged(l,h){const c=C.URI.revive(l),f=this._documentsAndEditors.getDocument(c);if(!f)throw new Error("unknown document");this._onDidRemoveDocument.fire(f.document),f._acceptLanguageId(h),this._onDidAddDocument.fire(f.document)}$acceptModelSaved(l){const h=C.URI.revive(l),c=this._documentsAndEditors.getDocument(h);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(l,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(l,h){const c=C.URI.revive(l),f=this._documentsAndEditors.getDocument(c);if(!f)throw new Error("unknown document");f._acceptIsDirty(h),this._onDidChangeDocument.fire({document:f.document,contentChanges:[]})}$acceptModelChanged(l,h,c){const f=C.URI.revive(l),I=this._documentsAndEditors.getDocument(f);if(!I)throw new Error("unknown document");I._acceptIsDirty(c),I.onEvents(h),this._onDidChangeDocument.fire(D.deepFreeze({document:I.document,contentChanges:h.changes.map(b=>({range:P.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text}))}))}setWordDefinitionFor(l,h){A.setWordDefinitionFor(l,h)}}e.ExtHostDocuments=r}),define(pe[39],ve([0,1,50,3,6,2,4,5,119,13,124,17,12,23,10,52,134]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(d){this.value=d,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let w=class{constructor(d,g){this._extHostRpc=d,this._logService=g,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new R.Emitter,this._onDidRemoveDocuments=new R.Emitter,this._onDidChangeVisibleTextEditors=new R.Emitter,this._onDidChangeActiveTextEditor=new R.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(d){this.acceptDocumentsAndEditorsDelta(d)}acceptDocumentsAndEditorsDelta(d){const g=[],t=[],i=[];if(d.removedDocuments)for(const s of d.removedDocuments){const n=S.URI.revive(s),o=this._documents.get(n);(o==null?void 0:o.unref())&&(this._documents.delete(n),g.push(o.value))}if(d.addedDocuments)for(const s of d.addedDocuments){const n=S.URI.revive(s.uri);let o=this._documents.get(n);if(o&&n.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${n} already exists!'`);o||(o=new b(new _.ExtHostDocumentData(this._extHostRpc.getProxy(P.MainContext.MainThreadDocuments),n,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(n,o),t.push(o.value)),o.ref()}if(d.removedEditors)for(const s of d.removedEditors){const n=this._editors.get(s);this._editors.delete(s),n&&i.push(n)}if(d.addedEditors)for(const s of d.addedEditors){const n=S.URI.revive(s.documentUri);p.ok(this._documents.has(n),`document '${n}' does not exist`),p.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const o=this._documents.get(n).value,v=new r.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(P.MainContext.MainThreadTextEditors),this._logService,new I.Lazy(()=>o.document),s.selections.map(k.Selection.to),s.options,s.visibleRanges.map(m=>k.Range.to(m)),typeof s.editorPosition=="number"?k.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,v)}d.newActiveEditor!==void 0&&(p.ok(d.newActiveEditor===null||this._editors.has(d.newActiveEditor),`active editor '${d.newActiveEditor}' does not exist`),this._activeEditorId=d.newActiveEditor),C.dispose(g),C.dispose(i),d.removedDocuments&&this._onDidRemoveDocuments.fire(g),d.addedDocuments&&this._onDidAddDocuments.fire(t),(d.removedEditors||d.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),d.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(d){var g;return(g=this._documents.get(d))===null||g===void 0?void 0:g.value}allDocuments(){return f.Iterable.map(this._documents.values(),d=>d.value)}getEditor(d){return this._editors.get(d)}activeEditor(d){if(!this._activeEditorId)return;const g=this._editors.get(this._activeEditorId);return d?g:g==null?void 0:g.value}allEditors(){return[...this._editors.values()]}};w=qe([We(0,D.IExtHostRpcService),We(1,l.ILogService)],w),e.ExtHostDocumentsAndEditors=w,e.IExtHostDocumentsAndEditors=A.createDecorator("IExtHostDocumentsAndEditors")}),define(pe[227],ve([0,1,2,5,6,7,17,142,8,22]),function(X,e,p,R,C,S,A,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class r{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const c=this._schemes.indexOf(h);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),c=[];let f,I,b=14,w=14;for(const u of h){let d=f?_.commonPrefixLength(f,u):0;for(d===0?I=1:I=w;d<u.length;d++)d+1===u.length?(b=w,w=9):w+=1,c.push([I,u.toUpperCase().charCodeAt(d),w]),c.push([I,u.toLowerCase().charCodeAt(d),w]),I=w;f=u,w=b}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new P.StateMachine(c)}}provideDocumentLinks(h){this._initStateMachine();const c=[],f=P.LinkComputer.computeLinks({getLineContent(I){return h.lineAt(I-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const I of f){const b=A.DocumentLink.to(I);b.target&&c.push(b)}return c}}class k{constructor(h,c){this._extHostLanguageFeatures=c,this._linkProvider=new r,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,c,f,I={},b){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const w=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(w,f),this._enableProposedApi.set(w,b??!1);let u=2;I.isCaseSensitive&&(u+=1024),I.isReadonly&&(u+=2048),typeof f.copy=="function"&&(u+=8),typeof f.open=="function"&&typeof f.close=="function"&&typeof f.read=="function"&&typeof f.write=="function"&&(u+=4),this._proxy.$registerFileSystemProvider(w,c,u).catch(g=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${c}`),console.error(g)});const d=f.onDidChangeFile(g=>{const t=[];for(const i of g){let{uri:s,type:n}=i;if(s.scheme!==c)continue;let o;switch(n){case S.FileChangeType.Changed:o=0;break;case S.FileChangeType.Created:o=1;break;case S.FileChangeType.Deleted:o=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:o})}this._proxy.$onFileSystemChange(w,t)});return C.toDisposable(()=>{d.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(w),this._enableProposedApi.delete(w),this._proxy.$unregisterProvider(w)})}static _asIStat(h,c){const{type:f,ctime:I,mtime:b,size:w,permissions:u}=h;return c?{type:f,ctime:I,mtime:b,size:w,permissions:u}:{type:f,ctime:I,mtime:b,size:w}}$stat(h,c){return Promise.resolve(this._getFsProvider(h).stat(p.URI.revive(c))).then(f=>{var I;return k._asIStat(f,(I=this._enableProposedApi.get(h))!==null&&I!==void 0?I:!1)})}$readdir(h,c){return Promise.resolve(this._getFsProvider(h).readDirectory(p.URI.revive(c)))}$readFile(h,c){return Promise.resolve(this._getFsProvider(h).readFile(p.URI.revive(c))).then(f=>D.VSBuffer.wrap(f))}$writeFile(h,c,f,I){return Promise.resolve(this._getFsProvider(h).writeFile(p.URI.revive(c),f.buffer,I))}$delete(h,c,f){return Promise.resolve(this._getFsProvider(h).delete(p.URI.revive(c),f))}$rename(h,c,f,I){return Promise.resolve(this._getFsProvider(h).rename(p.URI.revive(c),p.URI.revive(f),I))}$copy(h,c,f,I){const b=this._getFsProvider(h);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(p.URI.revive(c),p.URI.revive(f),I))}$mkdir(h,c){return Promise.resolve(this._getFsProvider(h).createDirectory(p.URI.revive(c)))}$watch(h,c,f,I){const b=this._getFsProvider(h).watch(p.URI.revive(f),I);this._watches.set(c,b)}$unwatch(h,c){const f=this._watches.get(c);f&&(f.dispose(),this._watches.delete(c))}$open(h,c,f){const I=this._getFsProvider(h);if(!I.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(I.open(p.URI.revive(c),f))}$close(h,c){const f=this._getFsProvider(h);if(!f.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(f.close(c))}$read(h,c,f,I){const b=this._getFsProvider(h);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const w=D.VSBuffer.alloc(I);return Promise.resolve(b.read(c,f,w.buffer,0,I)).then(u=>w.slice(0,u))}$write(h,c,f,I){const b=this._getFsProvider(h);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(c,f,I.buffer,0,I.byteLength))}_getFsProvider(h){const c=this._fsProvider.get(h);if(!c){const f=new Error;throw f.name="ENOPRO",f.message="no provider",f}return c}}e.ExtHostFileSystem=k}),define(pe[87],ve([0,1,5,42,7,22,4,13,59]),function(X,e,p,R,C,S,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let D=class Ut{constructor(k,l){const h=k.getProxy(p.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return h.$stat(c).catch(Ut._handleError)},readDirectory(c){return h.$readdir(c).catch(Ut._handleError)},createDirectory(c){return h.$mkdir(c).catch(Ut._handleError)},async readFile(c){return h.$readFile(c).then(f=>f.buffer).catch(Ut._handleError)},writeFile(c,f){return h.$writeFile(c,S.VSBuffer.wrap(f)).catch(Ut._handleError)},delete(c,f){return h.$delete(c,Object.assign({recursive:!1,useTrash:!1},f)).catch(Ut._handleError)},rename(c,f,I){return h.$rename(c,f,Object.assign({overwrite:!1},I)).catch(Ut._handleError)},copy(c,f,I){return h.$copy(c,f,Object.assign({overwrite:!1},I)).catch(Ut._handleError)},isWritableFileSystem(c){const f=l.getCapabilities(c);if(typeof f=="number")return!(f&2048)}})}static _handleError(k){if(!(k instanceof Error))throw new C.FileSystemError(String(k));if(k.name==="ENOPRO")throw C.FileSystemError.Unavailable(k.message);switch(k.name){case R.FileSystemProviderErrorCode.FileExists:throw C.FileSystemError.FileExists(k.message);case R.FileSystemProviderErrorCode.FileNotFound:throw C.FileSystemError.FileNotFound(k.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw C.FileSystemError.FileNotADirectory(k.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw C.FileSystemError.FileIsADirectory(k.message);case R.FileSystemProviderErrorCode.NoPermissions:throw C.FileSystemError.NoPermissions(k.message);case R.FileSystemProviderErrorCode.Unavailable:throw C.FileSystemError.Unavailable(k.message);default:throw new C.FileSystemError(k.message,k.name)}}};D=qe([We(0,P.IExtHostRpcService),We(1,_.IExtHostFileSystemInfo)],D),e.ExtHostConsumerFileSystem=D,e.IExtHostConsumerFileSystem=A.createDecorator("IExtHostConsumerFileSystem")}),define(pe[228],ve([0,1,6,5]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class C{constructor(A){this._handlePool=0,this._proxy=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const P=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(P,A),p.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=C}),define(pe[229],ve([0,1,2,25,17,7,16,5,8,41,18,15,139,6,108,70,82,43,14,3]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class d{constructor(j,Y){this._documents=j,this._provider=Y}provideDocumentSymbols(j,Y){const ie=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentSymbols(ie,Y)).then(re=>{if(!r.isFalsyOrEmpty(re))return re[0]instanceof S.DocumentSymbol?re.map(C.DocumentSymbol.from):d._asDocumentSymbolTree(re)})}static _asDocumentSymbolTree(j){var Y;j=j.slice(0).sort((J,ce)=>{let ge=J.location.range.start.compareTo(ce.location.range.start);return ge===0&&(ge=ce.location.range.end.compareTo(J.location.range.end)),ge});const ie=[],re=[];for(const J of j){const ce={name:J.name||"!!MISSING: name!!",kind:C.SymbolKind.from(J.kind),tags:((Y=J.tags)===null||Y===void 0?void 0:Y.map(C.SymbolTag.from))||[],detail:"",containerName:J.containerName,range:C.Range.from(J.location.range),selectionRange:C.Range.from(J.location.range),children:[]};for(;;){if(re.length===0){re.push(ce),ie.push(ce);break}const ge=re[re.length-1];if(D.Range.containsRange(ge.range,ce.range)&&!D.Range.equalsRange(ge.range,ce.range)){ge.children&&ge.children.push(ce),re.push(ce);break}re.pop()}}return ie}}class g{constructor(j,Y,ie){this._documents=j,this._commands=Y,this._provider=ie,this._cache=new I.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(j,Y){const ie=this._documents.getDocument(j),re=await this._provider.provideCodeLenses(ie,Y);if(!re||Y.isCancellationRequested)return;const J=this._cache.add(re),ce=new h.DisposableStore;this._disposables.set(J,ce);const ge={cacheId:J,lenses:[]};for(let Re=0;Re<re.length;Re++)ge.lenses.push({cacheId:[J,Re],range:C.Range.from(re[Re].range),command:this._commands.toInternal(re[Re].command,ce)});return ge}async resolveCodeLens(j,Y){var ie;const re=j.cacheId&&this._cache.get(...j.cacheId);if(!re)return;let J;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?J=re:J=await this._provider.resolveCodeLens(re,Y),J||(J=re),Y.isCancellationRequested)return;const ce=j.cacheId&&this._disposables.get(j.cacheId[0]);if(!!ce)return j.command=this._commands.toInternal((ie=J.command)!==null&&ie!==void 0?ie:g._badCmd,ce),j}releaseCodeLenses(j){var Y;(Y=this._disposables.get(j))===null||Y===void 0||Y.dispose(),this._disposables.delete(j),this._cache.delete(j)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Ge){return Array.isArray(Ge)?Ge.map(C.DefinitionLink.from):Ge?[C.DefinitionLink.from(Ge)]:[]}class i{constructor(j,Y){this._documents=j,this._provider=Y}provideDefinition(j,Y,ie){const re=this._documents.getDocument(j),J=C.Position.to(Y);return A.asPromise(()=>this._provider.provideDefinition(re,J,ie)).then(t)}}class s{constructor(j,Y){this._documents=j,this._provider=Y}provideDeclaration(j,Y,ie){const re=this._documents.getDocument(j),J=C.Position.to(Y);return A.asPromise(()=>this._provider.provideDeclaration(re,J,ie)).then(t)}}class n{constructor(j,Y){this._documents=j,this._provider=Y}provideImplementation(j,Y,ie){const re=this._documents.getDocument(j),J=C.Position.to(Y);return A.asPromise(()=>this._provider.provideImplementation(re,J,ie)).then(t)}}class o{constructor(j,Y){this._documents=j,this._provider=Y}provideTypeDefinition(j,Y,ie){const re=this._documents.getDocument(j),J=C.Position.to(Y);return A.asPromise(()=>this._provider.provideTypeDefinition(re,J,ie)).then(t)}}class v{constructor(j,Y){this._documents=j,this._provider=Y}provideHover(j,Y,ie){const re=this._documents.getDocument(j),J=C.Position.to(Y);return A.asPromise(()=>this._provider.provideHover(re,J,ie)).then(ce=>{if(!(!ce||r.isFalsyOrEmpty(ce.contents)))return ce.range||(ce.range=re.getWordRangeAtPosition(J)),ce.range||(ce.range=new S.Range(J,J)),C.Hover.from(ce)})}}class m{constructor(j,Y){this._documents=j,this._provider=Y}provideEvaluatableExpression(j,Y,ie){const re=this._documents.getDocument(j),J=C.Position.to(Y);return A.asPromise(()=>this._provider.provideEvaluatableExpression(re,J,ie)).then(ce=>{if(ce)return C.EvaluatableExpression.from(ce)})}}class E{constructor(j,Y){this._documents=j,this._provider=Y}provideInlineValues(j,Y,ie,re){const J=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlineValues(J,C.Range.to(Y),C.InlineValueContext.to(ie),re)).then(ce=>{if(Array.isArray(ce))return ce.map(ge=>C.InlineValue.from(ge))})}}class y{constructor(j,Y){this._documents=j,this._provider=Y}provideDocumentHighlights(j,Y,ie){const re=this._documents.getDocument(j),J=C.Position.to(Y);return A.asPromise(()=>this._provider.provideDocumentHighlights(re,J,ie)).then(ce=>{if(Array.isArray(ce))return ce.map(C.DocumentHighlight.from)})}}class a{constructor(j,Y){this._documents=j,this._provider=Y}provideLinkedEditingRanges(j,Y,ie){const re=this._documents.getDocument(j),J=C.Position.to(Y);return A.asPromise(()=>this._provider.provideLinkedEditingRanges(re,J,ie)).then(ce=>{if(ce&&Array.isArray(ce.ranges))return{ranges:r.coalesce(ce.ranges.map(C.Range.from)),wordPattern:ce.wordPattern}})}}class T{constructor(j,Y){this._documents=j,this._provider=Y}provideReferences(j,Y,ie,re){const J=this._documents.getDocument(j),ce=C.Position.to(Y);return A.asPromise(()=>this._provider.provideReferences(J,ce,ie,re)).then(ge=>{if(Array.isArray(ge))return ge.map(C.location.from)})}}class O{constructor(j,Y,ie,re,J,ce,ge){this._documents=j,this._commands=Y,this._diagnostics=ie,this._provider=re,this._logService=J,this._extension=ce,this._apiDeprecation=ge,this._cache=new I.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(j,Y,ie,re){const J=this._documents.getDocument(j),ce=l.Selection.isISelection(Y)?C.Selection.to(Y):C.Range.to(Y),ge=[];for(const He of this._diagnostics.getDiagnostics(j))if(ce.intersection(He.range)&&ge.push(He)>O._maxCodeActionsPerFile)break;const Re={diagnostics:ge,only:ie.only?new S.CodeActionKind(ie.only):void 0,triggerKind:C.CodeActionTriggerKind.to(ie.trigger)};return A.asPromise(()=>this._provider.provideCodeActions(J,ce,Re,re)).then(He=>{var be;if(!r.isNonEmptyArray(He)||re.isCancellationRequested)return;const Qe=this._cache.add(He),Q=new h.DisposableStore;this._disposables.set(Qe,Q);const se=[];for(let we=0;we<He.length;we++){const Oe=He[we];!Oe||(O._isCommand(Oe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),se.push({_isSynthetic:!0,title:Oe.title,command:this._commands.toInternal(Oe,Q)})):(Re.only&&(Oe.kind?Re.only.contains(Oe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action is of kind '${Oe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Re.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),se.push({cacheId:[Qe,we],title:Oe.title,command:Oe.command&&this._commands.toInternal(Oe.command,Q),diagnostics:Oe.diagnostics&&Oe.diagnostics.map(C.Diagnostic.from),edit:Oe.edit&&C.WorkspaceEdit.from(Oe.edit),kind:Oe.kind&&Oe.kind.value,isPreferred:Oe.isPreferred,disabled:(be=Oe.disabled)===null||be===void 0?void 0:be.reason})))}return{cacheId:Qe,actions:se}})}async resolveCodeAction(j,Y){var ie;const[re,J]=j,ce=this._cache.get(re,J);if(!ce||O._isCommand(ce)||!this._provider.resolveCodeAction)return;const ge=(ie=await this._provider.resolveCodeAction(ce,Y))!==null&&ie!==void 0?ie:ce;return(ge==null?void 0:ge.edit)?C.WorkspaceEdit.from(ge.edit):void 0}releaseCodeActions(j){var Y;(Y=this._disposables.get(j))===null||Y===void 0||Y.dispose(),this._disposables.delete(j),this._cache.delete(j)}static _isCommand(j){return typeof j.command=="string"&&typeof j.title=="string"}}O._maxCodeActionsPerFile=1e3;class ${constructor(j,Y){this._documents=j,this._provider=Y}provideDocumentFormattingEdits(j,Y,ie){const re=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentFormattingEdits(re,Y,ie)).then(J=>{if(Array.isArray(J))return J.map(C.TextEdit.from)})}}class Z{constructor(j,Y){this._documents=j,this._provider=Y}provideDocumentRangeFormattingEdits(j,Y,ie,re){const J=this._documents.getDocument(j),ce=C.Range.to(Y);return A.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(J,ce,ie,re)).then(ge=>{if(Array.isArray(ge))return ge.map(C.TextEdit.from)})}}class le{constructor(j,Y){this._documents=j,this._provider=Y,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(j,Y,ie,re,J){const ce=this._documents.getDocument(j),ge=C.Position.to(Y);return A.asPromise(()=>this._provider.provideOnTypeFormattingEdits(ce,ge,ie,re,J)).then(Re=>{if(Array.isArray(Re))return Re.map(C.TextEdit.from)})}}class q{constructor(j,Y){this._provider=j,this._logService=Y,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(j,Y){const ie=P.IdObject.mixin({symbols:[]});return A.asPromise(()=>this._provider.provideWorkspaceSymbols(j,Y)).then(re=>{if(r.isNonEmptyArray(re))for(const J of re){if(!J)continue;if(!J.name){this._logService.warn("INVALID SymbolInformation, lacks name",J);continue}const ce=P.IdObject.mixin(C.WorkspaceSymbol.from(J));this._symbolCache.set(ce._id,J),ie.symbols.push(ce)}}).then(()=>(ie.symbols.length>0&&this._resultCache.set(ie._id,[ie.symbols[0]._id,ie.symbols[ie.symbols.length-1]._id]),ie))}async resolveWorkspaceSymbol(j,Y){if(typeof this._provider.resolveWorkspaceSymbol!="function")return j;const ie=this._symbolCache.get(j._id);if(ie){const re=await A.asPromise(()=>this._provider.resolveWorkspaceSymbol(ie,Y));return re&&R.mixin(j,C.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols(j){const Y=this._resultCache.get(j);if(Y){for(let[ie,re]=Y;ie<=re;ie++)this._symbolCache.delete(ie);this._resultCache.delete(j)}}}class x{constructor(j,Y,ie){this._documents=j,this._provider=Y,this._logService=ie}static supportsResolving(j){return typeof j.prepareRename=="function"}provideRenameEdits(j,Y,ie,re){const J=this._documents.getDocument(j),ce=C.Position.to(Y);return A.asPromise(()=>this._provider.provideRenameEdits(J,ce,ie,re)).then(ge=>{if(!!ge)return C.WorkspaceEdit.from(ge)},ge=>{const Re=x._asMessage(ge);return Re?{rejectReason:Re,edits:void 0}:Promise.reject(ge)})}resolveRenameLocation(j,Y,ie){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument(j),J=C.Position.to(Y);return A.asPromise(()=>this._provider.prepareRename(re,J,ie)).then(ce=>{let ge,Re;if(S.Range.isRange(ce)?(ge=ce,Re=re.getText(ce)):k.isObject(ce)&&(ge=ce.range,Re=ce.placeholder),!!ge){if(ge.start.line>J.line||ge.end.line<J.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:C.Range.from(ge),text:Re}}},ce=>{const ge=x._asMessage(ce);return ge?{rejectReason:ge,range:void 0,text:void 0}:Promise.reject(ce)})}static _asMessage(j){return typeof j=="string"?j:j instanceof Error&&typeof j.message=="string"?j.message:void 0}}class H{constructor(j,Y){this.resultId=j,this.tokens=Y}}class N{constructor(j,Y){this._documents=j,this._provider=Y,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(j,Y,ie){const re=this._documents.getDocument(j),J=Y!==0?this._previousResults.get(Y):null;return A.asPromise(()=>J&&typeof J.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(re,J.resultId,ie):this._provider.provideDocumentSemanticTokens(re,ie)).then(ce=>(J&&this._previousResults.delete(Y),ce?(ce=N._fixProvidedSemanticTokens(ce),this._send(N._convertToEdits(J,ce),ce)):null))}async releaseDocumentSemanticColoring(j){this._previousResults.delete(j)}static _fixProvidedSemanticTokens(j){return N._isSemanticTokens(j)?N._isCorrectSemanticTokens(j)?j:new S.SemanticTokens(new Uint32Array(j.data),j.resultId):N._isSemanticTokensEdits(j)?N._isCorrectSemanticTokensEdits(j)?j:new S.SemanticTokensEdits(j.edits.map(Y=>new S.SemanticTokensEdit(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),j.resultId):j}static _isSemanticTokens(j){return j&&!!j.data}static _isCorrectSemanticTokens(j){return j.data instanceof Uint32Array}static _isSemanticTokensEdits(j){return j&&Array.isArray(j.edits)}static _isCorrectSemanticTokensEdits(j){for(const Y of j.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(j,Y){if(!N._isSemanticTokens(Y)||!j||!j.tokens)return Y;const ie=j.tokens,re=ie.length,J=Y.data,ce=J.length;let ge=0;const Re=Math.min(re,ce);for(;ge<Re&&ie[ge]===J[ge];)ge++;if(ge===re&&ge===ce)return new S.SemanticTokensEdits([],Y.resultId);let He=0;const be=Re-ge;for(;He<be&&ie[re-He-1]===J[ce-He-1];)He++;return new S.SemanticTokensEdits([{start:ge,deleteCount:re-ge-He,data:J.subarray(ge,ce-He)}],Y.resultId)}_send(j,Y){if(N._isSemanticTokens(j)){const ie=this._nextResultId++;return this._previousResults.set(ie,new H(j.resultId,j.data)),c.encodeSemanticTokensDto({id:ie,type:"full",data:j.data})}if(N._isSemanticTokensEdits(j)){const ie=this._nextResultId++;return N._isSemanticTokens(Y)?this._previousResults.set(ie,new H(Y.resultId,Y.data)):this._previousResults.set(ie,new H(j.resultId)),c.encodeSemanticTokensDto({id:ie,type:"delta",deltas:(j.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=N;class z{constructor(j,Y){this._documents=j,this._provider=Y}provideDocumentRangeSemanticTokens(j,Y,ie){const re=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(re,C.Range.to(Y),ie)).then(J=>J?this._send(J):null)}_send(j){return c.encodeSemanticTokensDto({id:0,type:"full",data:j.data})}}e.DocumentRangeSemanticTokensAdapter=z;class F{constructor(j,Y,ie,re,J){this._documents=j,this._commands=Y,this._provider=ie,this._apiDeprecation=re,this._extension=J,this._cache=new I.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(j){return typeof j.resolveCompletionItem=="function"}async provideCompletionItems(j,Y,ie,re){const J=this._documents.getDocument(j),ce=C.Position.to(Y),ge=J.getWordRangeAtPosition(ce)||new S.Range(ce,ce),Re=ge.with({end:ce}),He=new b.StopWatch(!0),be=await A.asPromise(()=>this._provider.provideCompletionItems(J,ce,re,C.CompletionContext.to(ie)));if(!be||re.isCancellationRequested)return;const Qe=Array.isArray(be)?new S.CompletionList(be):be,Q=F.supportsResolving(this._provider)?this._cache.add(Qe.items):this._cache.add([]),se=new h.DisposableStore;this._disposables.set(Q,se);const we=[],Oe={x:Q,b:we,a:{replace:C.Range.from(ge),insert:C.Range.from(Re)},c:Qe.isIncomplete||void 0,d:He.elapsed()};for(let Ue=0;Ue<Qe.items.length;Ue++){const Ye=Qe.items[Ue],De=this._convertCompletionItem(Ye,[Q,Ue],Re,ge);we.push(De)}return Oe}async resolveCompletionItem(j,Y){if(typeof this._provider.resolveCompletionItem!="function")return;const ie=this._cache.get(...j);if(!ie)return;const re=await A.asPromise(()=>this._provider.resolveCompletionItem(ie,Y));if(!!re)return this._convertCompletionItem(re,j)}releaseCompletionItems(j){var Y;(Y=this._disposables.get(j))===null||Y===void 0||Y.dispose(),this._disposables.delete(j),this._cache.delete(j)}_convertCompletionItem(j,Y,ie,re){var J;const ce=this._disposables.get(Y[0]);if(!ce)throw Error("DisposableStore is missing...");const ge={x:Y,a:(J=j.label)!==null&&J!==void 0?J:"",o:j.label2,b:j.kind!==void 0?C.CompletionItemKind.from(j.kind):void 0,n:j.tags&&j.tags.map(C.CompletionItemTag.from),c:j.detail,d:typeof j.documentation=="undefined"?void 0:C.MarkdownString.fromStrict(j.documentation),e:j.sortText!==j.label?j.sortText:void 0,f:j.filterText!==j.label?j.filterText:void 0,g:j.preselect||void 0,i:j.keepWhitespace?1:0,k:j.commitCharacters,l:j.additionalTextEdits&&j.additionalTextEdits.map(C.TextEdit.from),m:this._commands.toInternal(j.command,ce)};j.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ge.h=j.textEdit.newText):typeof j.insertText=="string"?ge.h=j.insertText:j.insertText instanceof S.SnippetString&&(ge.h=j.insertText.value,ge.i|=4);let Re;return j.textEdit?Re=j.textEdit.range:j.range&&(Re=j.range),S.Range.isRange(Re)?ge.j=C.Range.from(Re):Re&&(!(ie==null?void 0:ie.isEqual(Re.inserting))||!(re==null?void 0:re.isEqual(Re.replacing)))&&(ge.j={insert:C.Range.from(Re.inserting),replace:C.Range.from(Re.replacing)}),ge}}class M{constructor(j,Y,ie){this._documents=j,this._provider=Y,this._commands=ie,this._cache=new I.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(j,Y,ie,re){const J=this._documents.getDocument(j),ce=C.Position.to(Y),ge=await A.asPromise(()=>this._provider.provideInlineCompletionItems(J,ce,ie,re));if(!ge||re.isCancellationRequested)return;const Re=k.isArray(ge)?{items:ge}:ge,He=this._cache.add(Re.items);let be;return{pid:He,items:Re.items.map((Qe,Q)=>{let se;return Qe.command&&(be||(be=new h.DisposableStore,this._disposables.set(He,be)),se=this._commands.toInternal(Qe.command,be)),{text:Qe.text,range:Qe.range?C.Range.from(Qe.range):void 0,command:se,idx:Q}})}}disposeCompletions(j){this._cache.delete(j);const Y=this._disposables.get(j);Y&&Y.clear(),this._disposables.delete(j)}handleDidShowCompletionItem(j,Y){const ie=this._cache.get(j,Y);ie&&L.get(this._provider).fireOnDidShowCompletionItem({completionItem:ie})}}class L{constructor(){this._onDidShowCompletionItemEmitter=new u.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(j){let Y=L.map.get(j);return Y||(Y=new L,L.map.set(j,Y)),Y}fireOnDidShowCompletionItem(j){this._onDidShowCompletionItemEmitter.fire(j)}}e.InlineCompletionController=L,L.map=new WeakMap;class U{constructor(j,Y){this._documents=j,this._provider=Y,this._cache=new I.Cache("SignatureHelp")}provideSignatureHelp(j,Y,ie,re){const J=this._documents.getDocument(j),ce=C.Position.to(Y),ge=this.reviveContext(ie);return A.asPromise(()=>this._provider.provideSignatureHelp(J,ce,re,ge)).then(Re=>{if(Re){const He=this._cache.add([Re]);return Object.assign(Object.assign({},C.SignatureHelp.from(Re)),{id:He})}})}reviveContext(j){let Y;if(j.activeSignatureHelp){const ie=C.SignatureHelp.to(j.activeSignatureHelp),re=this._cache.get(j.activeSignatureHelp.id,0);re?(Y=re,Y.activeSignature=ie.activeSignature,Y.activeParameter=ie.activeParameter):Y=ie}return Object.assign(Object.assign({},j),{activeSignatureHelp:Y})}releaseSignatureHelp(j){this._cache.delete(j)}}class G{constructor(j,Y){this._documents=j,this._provider=Y}provideInlayHints(j,Y,ie){const re=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideInlayHints(re,C.Range.to(Y),ie)).then(J=>J?{hints:J.map(C.InlayHint.from)}:void 0)}}class te{constructor(j,Y){this._documents=j,this._provider=Y,this._cache=new I.Cache("DocumentLink")}async provideLinks(j,Y){const ie=this._documents.getDocument(j),re=await A.asPromise(()=>this._provider.provideDocumentLinks(ie,Y));if(!(!Array.isArray(re)||re.length===0)&&!Y.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.filter(te._validateLink).map(C.DocumentLink.from)};{const J=this._cache.add(re),ce={links:[],id:J};for(let ge=0;ge<re.length;ge++){if(!te._validateLink(re[ge]))continue;const Re=C.DocumentLink.from(re[ge]);Re.cacheId=[J,ge],ce.links.push(Re)}return ce}}}static _validateLink(j){return j.target&&j.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(j,Y){if(typeof this._provider.resolveDocumentLink!="function")return;const ie=this._cache.get(...j);if(!ie)return;const re=await A.asPromise(()=>this._provider.resolveDocumentLink(ie,Y));if(!(!re||!te._validateLink(re)))return C.DocumentLink.from(re)}releaseLinks(j){this._cache.delete(j)}}class me{constructor(j,Y){this._documents=j,this._provider=Y}provideColors(j,Y){const ie=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideDocumentColors(ie,Y)).then(re=>Array.isArray(re)?re.map(ce=>({color:C.Color.from(ce.color),range:C.Range.from(ce.range)})):[])}provideColorPresentations(j,Y,ie){const re=this._documents.getDocument(j),J=C.Range.to(Y.range),ce=C.Color.to(Y.color);return A.asPromise(()=>this._provider.provideColorPresentations(ce,{document:re,range:J},ie)).then(ge=>{if(!!Array.isArray(ge))return ge.map(C.ColorPresentation.from)})}}class Se{constructor(j,Y){this._documents=j,this._provider=Y}provideFoldingRanges(j,Y,ie){const re=this._documents.getDocument(j);return A.asPromise(()=>this._provider.provideFoldingRanges(re,Y,ie)).then(J=>{if(!!Array.isArray(J))return J.map(C.FoldingRange.from)})}}class ye{constructor(j,Y,ie){this._documents=j,this._provider=Y,this._logService=ie}provideSelectionRanges(j,Y,ie){const re=this._documents.getDocument(j),J=Y.map(C.Position.to);return A.asPromise(()=>this._provider.provideSelectionRanges(re,J,ie)).then(ce=>{if(!r.isNonEmptyArray(ce))return[];if(ce.length!==J.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ge=[];for(let Re=0;Re<J.length;Re++){const He=[];ge.push(He);let be=J[Re],Qe=ce[Re];for(;;){if(!Qe.range.contains(be))throw new Error("INVALID selection range, must contain the previous range");if(He.push(C.SelectionRange.from(Qe)),!Qe.parent)break;be=Qe.range,Qe=Qe.parent}}return ge})}}class Le{constructor(j,Y){this._documents=j,this._provider=Y,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(j,Y,ie){const re=this._documents.getDocument(j),J=C.Position.to(Y),ce=await this._provider.prepareCallHierarchy(re,J,ie);if(!ce)return;const ge=this._idPool.nextId();return this._cache.set(ge,new Map),Array.isArray(ce)?ce.map(Re=>this._cacheAndConvertItem(ge,Re)):[this._cacheAndConvertItem(ge,ce)]}async provideCallsTo(j,Y,ie){const re=this._itemFromCache(j,Y);if(!re)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyIncomingCalls(re,ie);if(!!J)return J.map(ce=>({from:this._cacheAndConvertItem(j,ce.from),fromRanges:ce.fromRanges.map(ge=>C.Range.from(ge))}))}async provideCallsFrom(j,Y,ie){const re=this._itemFromCache(j,Y);if(!re)throw new Error("missing call hierarchy item");const J=await this._provider.provideCallHierarchyOutgoingCalls(re,ie);if(!!J)return J.map(ce=>({to:this._cacheAndConvertItem(j,ce.to),fromRanges:ce.fromRanges.map(ge=>C.Range.from(ge))}))}releaseSession(j){this._cache.delete(j)}_cacheAndConvertItem(j,Y){var ie;const re=this._cache.get(j),J={_sessionId:j,_itemId:re.size.toString(36),name:Y.name,detail:Y.detail,kind:C.SymbolKind.from(Y.kind),uri:Y.uri,range:C.Range.from(Y.range),selectionRange:C.Range.from(Y.selectionRange),tags:(ie=Y.tags)===null||ie===void 0?void 0:ie.map(C.SymbolTag.from)};return re.set(J._itemId,Y),J}_itemFromCache(j,Y){const ie=this._cache.get(j);return ie==null?void 0:ie.get(Y)}}class je{constructor(j,Y){this.adapter=j,this.extension=Y}}class ze{constructor(j,Y,ie,re,J,ce,ge){this._adapter=new Map,this._uriTransformer=Y,this._proxy=j.getProxy(P.MainContext.MainThreadLanguageFeatures),this._documents=ie,this._commands=re,this._diagnostics=J,this._logService=ce,this._apiDeprecation=ge}_transformDocumentSelector(j){return r.coalesce(r.asArray(j).map(Y=>this._doTransformDocumentSelector(Y)))}_doTransformDocumentSelector(j){if(typeof j=="string")return{$serialized:!0,language:j};if(j)return{$serialized:!0,language:j.language,scheme:this._transformScheme(j.scheme),pattern:typeof j.pattern=="undefined"?void 0:C.GlobPattern.from(j.pattern),exclusive:j.exclusive}}_transformScheme(j){return this._uriTransformer&&typeof j=="string"?this._uriTransformer.transformOutgoingScheme(j):j}_createDisposable(j){return new S.Disposable(()=>{this._adapter.delete(j),this._proxy.$unregister(j)})}_nextHandle(){return ze._handlePool++}_withAdapter(j,Y,ie,re,J=!1){const ce=this._adapter.get(j);if(!ce)return Promise.resolve(re);if(ce.adapter instanceof Y){let ge;ce.extension&&(ge=Date.now(),this._logService.trace(`[${ce.extension.identifier.value}] INVOKE provider '${Y.name}'`));const Re=ie(ce.adapter,ce.extension),He=ce.extension;return He&&Promise.resolve(Re).then(()=>this._logService.trace(`[${He.identifier.value}] provider DONE after ${Date.now()-ge}ms`),be=>{J&&be instanceof w.CancellationError||(this._logService.error(`[${He.identifier.value}] provider FAILED`),this._logService.error(be))}),Re}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(j,Y){const ie=this._nextHandle();return this._adapter.set(ie,new je(j,Y)),ie}static _extLabel(j){return j.displayName||j.name}registerDocumentSymbolProvider(j,Y,ie,re){const J=this._addNewAdapter(new d(this._documents,ie),j),ce=re&&re.label||ze._extLabel(j);return this._proxy.$registerDocumentSymbolProvider(J,this._transformDocumentSelector(Y),ce),this._createDisposable(J)}$provideDocumentSymbols(j,Y,ie){return this._withAdapter(j,d,re=>re.provideDocumentSymbols(p.URI.revive(Y),ie),void 0)}registerCodeLensProvider(j,Y,ie){const re=this._nextHandle(),J=typeof ie.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new je(new g(this._documents,this._commands.converter,ie),j)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(Y),J);let ce=this._createDisposable(re);if(J!==void 0){const ge=ie.onDidChangeCodeLenses(Re=>this._proxy.$emitCodeLensEvent(J));ce=S.Disposable.from(ce,ge)}return ce}$provideCodeLenses(j,Y,ie){return this._withAdapter(j,g,re=>re.provideCodeLenses(p.URI.revive(Y),ie),void 0)}$resolveCodeLens(j,Y,ie){return this._withAdapter(j,g,re=>re.resolveCodeLens(Y,ie),void 0)}$releaseCodeLenses(j,Y){this._withAdapter(j,g,ie=>Promise.resolve(ie.releaseCodeLenses(Y)),void 0)}registerDefinitionProvider(j,Y,ie){const re=this._addNewAdapter(new i(this._documents,ie),j);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideDefinition(j,Y,ie,re){return this._withAdapter(j,i,J=>J.provideDefinition(p.URI.revive(Y),ie,re),[])}registerDeclarationProvider(j,Y,ie){const re=this._addNewAdapter(new s(this._documents,ie),j);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideDeclaration(j,Y,ie,re){return this._withAdapter(j,s,J=>J.provideDeclaration(p.URI.revive(Y),ie,re),[])}registerImplementationProvider(j,Y,ie){const re=this._addNewAdapter(new n(this._documents,ie),j);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideImplementation(j,Y,ie,re){return this._withAdapter(j,n,J=>J.provideImplementation(p.URI.revive(Y),ie,re),[])}registerTypeDefinitionProvider(j,Y,ie){const re=this._addNewAdapter(new o(this._documents,ie),j);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideTypeDefinition(j,Y,ie,re){return this._withAdapter(j,o,J=>J.provideTypeDefinition(p.URI.revive(Y),ie,re),[])}registerHoverProvider(j,Y,ie,re){const J=this._addNewAdapter(new v(this._documents,ie),j);return this._proxy.$registerHoverProvider(J,this._transformDocumentSelector(Y)),this._createDisposable(J)}$provideHover(j,Y,ie,re){return this._withAdapter(j,v,J=>J.provideHover(p.URI.revive(Y),ie,re),void 0)}registerEvaluatableExpressionProvider(j,Y,ie,re){const J=this._addNewAdapter(new m(this._documents,ie),j);return this._proxy.$registerEvaluatableExpressionProvider(J,this._transformDocumentSelector(Y)),this._createDisposable(J)}$provideEvaluatableExpression(j,Y,ie,re){return this._withAdapter(j,m,J=>J.provideEvaluatableExpression(p.URI.revive(Y),ie,re),void 0)}registerInlineValuesProvider(j,Y,ie,re){const J=typeof ie.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ce=this._addNewAdapter(new E(this._documents,ie),j);this._proxy.$registerInlineValuesProvider(ce,this._transformDocumentSelector(Y),J);let ge=this._createDisposable(ce);if(J!==void 0){const Re=ie.onDidChangeInlineValues(He=>this._proxy.$emitInlineValuesEvent(J));ge=S.Disposable.from(ge,Re)}return ge}$provideInlineValues(j,Y,ie,re,J){return this._withAdapter(j,E,ce=>ce.provideInlineValues(p.URI.revive(Y),ie,re,J),void 0)}registerDocumentHighlightProvider(j,Y,ie){const re=this._addNewAdapter(new y(this._documents,ie),j);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideDocumentHighlights(j,Y,ie,re){return this._withAdapter(j,y,J=>J.provideDocumentHighlights(p.URI.revive(Y),ie,re),void 0)}registerLinkedEditingRangeProvider(j,Y,ie){const re=this._addNewAdapter(new a(this._documents,ie),j);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideLinkedEditingRanges(j,Y,ie,re){return this._withAdapter(j,a,async J=>{const ce=await J.provideLinkedEditingRanges(p.URI.revive(Y),ie,re);if(ce)return{ranges:ce.ranges,wordPattern:ce.wordPattern?ze._serializeRegExp(ce.wordPattern):void 0}},void 0)}registerReferenceProvider(j,Y,ie){const re=this._addNewAdapter(new T(this._documents,ie),j);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideReferences(j,Y,ie,re,J){return this._withAdapter(j,T,ce=>ce.provideReferences(p.URI.revive(Y),ie,re,J),void 0)}registerCodeActionProvider(j,Y,ie,re){var J,ce;const ge=new h.DisposableStore,Re=this._addNewAdapter(new O(this._documents,this._commands.converter,this._diagnostics,ie,this._logService,j,this._apiDeprecation),j);return this._proxy.$registerQuickFixSupport(Re,this._transformDocumentSelector(Y),{providedKinds:(J=re==null?void 0:re.providedCodeActionKinds)===null||J===void 0?void 0:J.map(He=>He.value),documentation:(ce=re==null?void 0:re.documentation)===null||ce===void 0?void 0:ce.map(He=>({kind:He.kind.value,command:this._commands.converter.toInternal(He.command,ge)}))},ze._extLabel(j),Boolean(ie.resolveCodeAction)),ge.add(this._createDisposable(Re)),ge}$provideCodeActions(j,Y,ie,re,J){return this._withAdapter(j,O,ce=>ce.provideCodeActions(p.URI.revive(Y),ie,re,J),void 0)}$resolveCodeAction(j,Y,ie){return this._withAdapter(j,O,re=>re.resolveCodeAction(Y,ie),void 0)}$releaseCodeActions(j,Y){this._withAdapter(j,O,ie=>Promise.resolve(ie.releaseCodeActions(Y)),void 0)}registerDocumentFormattingEditProvider(j,Y,ie){const re=this._addNewAdapter(new $(this._documents,ie),j);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(Y),j.identifier,j.displayName||j.name),this._createDisposable(re)}$provideDocumentFormattingEdits(j,Y,ie,re){return this._withAdapter(j,$,J=>J.provideDocumentFormattingEdits(p.URI.revive(Y),ie,re),void 0)}registerDocumentRangeFormattingEditProvider(j,Y,ie){const re=this._addNewAdapter(new Z(this._documents,ie),j);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(Y),j.identifier,j.displayName||j.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits(j,Y,ie,re,J){return this._withAdapter(j,Z,ce=>ce.provideDocumentRangeFormattingEdits(p.URI.revive(Y),ie,re,J),void 0)}registerOnTypeFormattingEditProvider(j,Y,ie,re){const J=this._addNewAdapter(new le(this._documents,ie),j);return this._proxy.$registerOnTypeFormattingSupport(J,this._transformDocumentSelector(Y),re,j.identifier),this._createDisposable(J)}$provideOnTypeFormattingEdits(j,Y,ie,re,J,ce){return this._withAdapter(j,le,ge=>ge.provideOnTypeFormattingEdits(p.URI.revive(Y),ie,re,J,ce),void 0)}registerWorkspaceSymbolProvider(j,Y){const ie=this._addNewAdapter(new q(Y,this._logService),j);return this._proxy.$registerNavigateTypeSupport(ie),this._createDisposable(ie)}$provideWorkspaceSymbols(j,Y,ie){return this._withAdapter(j,q,re=>re.provideWorkspaceSymbols(Y,ie),{symbols:[]})}$resolveWorkspaceSymbol(j,Y,ie){return this._withAdapter(j,q,re=>re.resolveWorkspaceSymbol(Y,ie),void 0)}$releaseWorkspaceSymbols(j,Y){this._withAdapter(j,q,ie=>ie.releaseWorkspaceSymbols(Y),void 0)}registerRenameProvider(j,Y,ie){const re=this._addNewAdapter(new x(this._documents,ie,this._logService),j);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(Y),x.supportsResolving(ie)),this._createDisposable(re)}$provideRenameEdits(j,Y,ie,re,J){return this._withAdapter(j,x,ce=>ce.provideRenameEdits(p.URI.revive(Y),ie,re,J),void 0)}$resolveRenameLocation(j,Y,ie,re){return this._withAdapter(j,x,J=>J.resolveRenameLocation(p.URI.revive(Y),ie,re),void 0)}registerDocumentSemanticTokensProvider(j,Y,ie,re){const J=this._nextHandle(),ce=typeof ie.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(J,new je(new N(this._documents,ie),j)),this._proxy.$registerDocumentSemanticTokensProvider(J,this._transformDocumentSelector(Y),re,ce);let ge=this._createDisposable(J);if(ce){const Re=ie.onDidChangeSemanticTokens(He=>this._proxy.$emitDocumentSemanticTokensEvent(ce));ge=S.Disposable.from(ge,Re)}return ge}$provideDocumentSemanticTokens(j,Y,ie,re){return this._withAdapter(j,N,J=>J.provideDocumentSemanticTokens(p.URI.revive(Y),ie,re),null,!0)}$releaseDocumentSemanticTokens(j,Y){this._withAdapter(j,N,ie=>ie.releaseDocumentSemanticColoring(Y),void 0)}registerDocumentRangeSemanticTokensProvider(j,Y,ie,re){const J=this._addNewAdapter(new z(this._documents,ie),j);return this._proxy.$registerDocumentRangeSemanticTokensProvider(J,this._transformDocumentSelector(Y),re),this._createDisposable(J)}$provideDocumentRangeSemanticTokens(j,Y,ie,re){return this._withAdapter(j,z,J=>J.provideDocumentRangeSemanticTokens(p.URI.revive(Y),ie,re),null,!0)}registerCompletionItemProvider(j,Y,ie,re){const J=this._addNewAdapter(new F(this._documents,this._commands.converter,ie,this._apiDeprecation,j),j);return this._proxy.$registerSuggestSupport(J,this._transformDocumentSelector(Y),re,F.supportsResolving(ie),`${j.identifier.value}(${re.join("")})`),this._createDisposable(J)}$provideCompletionItems(j,Y,ie,re,J){return this._withAdapter(j,F,ce=>ce.provideCompletionItems(p.URI.revive(Y),ie,re,J),void 0)}$resolveCompletionItem(j,Y,ie){return this._withAdapter(j,F,re=>re.resolveCompletionItem(Y,ie),void 0)}$releaseCompletionItems(j,Y){this._withAdapter(j,F,ie=>ie.releaseCompletionItems(Y),void 0)}registerInlineCompletionsProvider(j,Y,ie){const re=this._addNewAdapter(new M(this._documents,ie,this._commands.converter),j);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideInlineCompletions(j,Y,ie,re,J){return this._withAdapter(j,M,ce=>ce.provideInlineCompletions(p.URI.revive(Y),ie,re,J),void 0)}$handleInlineCompletionDidShow(j,Y,ie){this._withAdapter(j,M,async re=>{re.handleDidShowCompletionItem(Y,ie)},void 0)}$freeInlineCompletionsList(j,Y){this._withAdapter(j,M,async ie=>{ie.disposeCompletions(Y)},void 0)}registerSignatureHelpProvider(j,Y,ie,re){const J=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,ce=this._addNewAdapter(new U(this._documents,ie),j);return this._proxy.$registerSignatureHelpProvider(ce,this._transformDocumentSelector(Y),J),this._createDisposable(ce)}$provideSignatureHelp(j,Y,ie,re,J){return this._withAdapter(j,U,ce=>ce.provideSignatureHelp(p.URI.revive(Y),ie,re,J),void 0)}$releaseSignatureHelp(j,Y){this._withAdapter(j,U,ie=>ie.releaseSignatureHelp(Y),void 0)}registerInlayHintsProvider(j,Y,ie){const re=typeof ie.onDidChangeInlayHints=="function"?this._nextHandle():void 0,J=this._addNewAdapter(new G(this._documents,ie),j);this._proxy.$registerInlayHintsProvider(J,this._transformDocumentSelector(Y),re);let ce=this._createDisposable(J);if(re!==void 0){const ge=ie.onDidChangeInlayHints(Re=>this._proxy.$emitInlayHintsEvent(re));ce=S.Disposable.from(ce,ge)}return ce}$provideInlayHints(j,Y,ie,re){return this._withAdapter(j,G,J=>J.provideInlayHints(p.URI.revive(Y),ie,re),void 0)}registerDocumentLinkProvider(j,Y,ie){const re=this._addNewAdapter(new te(this._documents,ie),j);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(Y),typeof ie.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks(j,Y,ie){return this._withAdapter(j,te,re=>re.provideLinks(p.URI.revive(Y),ie),void 0)}$resolveDocumentLink(j,Y,ie){return this._withAdapter(j,te,re=>re.resolveLink(Y,ie),void 0)}$releaseDocumentLinks(j,Y){this._withAdapter(j,te,ie=>ie.releaseLinks(Y),void 0)}registerColorProvider(j,Y,ie){const re=this._addNewAdapter(new me(this._documents,ie),j);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideDocumentColors(j,Y,ie){return this._withAdapter(j,me,re=>re.provideColors(p.URI.revive(Y),ie),[])}$provideColorPresentations(j,Y,ie,re){return this._withAdapter(j,me,J=>J.provideColorPresentations(p.URI.revive(Y),ie,re),void 0)}registerFoldingRangeProvider(j,Y,ie){const re=this._nextHandle(),J=typeof ie.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new je(new Se(this._documents,ie),j)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(Y),J);let ce=this._createDisposable(re);if(J!==void 0){const ge=ie.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(J));ce=S.Disposable.from(ce,ge)}return ce}$provideFoldingRanges(j,Y,ie,re){return this._withAdapter(j,Se,J=>J.provideFoldingRanges(p.URI.revive(Y),ie,re),void 0)}registerSelectionRangeProvider(j,Y,ie){const re=this._addNewAdapter(new ye(this._documents,ie,this._logService),j);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$provideSelectionRanges(j,Y,ie,re){return this._withAdapter(j,ye,J=>J.provideSelectionRanges(p.URI.revive(Y),ie,re),[])}registerCallHierarchyProvider(j,Y,ie){const re=this._addNewAdapter(new Le(this._documents,ie),j);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(Y)),this._createDisposable(re)}$prepareCallHierarchy(j,Y,ie,re){return this._withAdapter(j,Le,J=>Promise.resolve(J.prepareSession(p.URI.revive(Y),ie,re)),void 0)}$provideCallHierarchyIncomingCalls(j,Y,ie,re){return this._withAdapter(j,Le,J=>J.provideCallsTo(Y,ie,re),void 0)}$provideCallHierarchyOutgoingCalls(j,Y,ie,re){return this._withAdapter(j,Le,J=>J.provideCallsFrom(Y,ie,re),void 0)}$releaseCallHierarchy(j,Y){this._withAdapter(j,Le,ie=>Promise.resolve(ie.releaseSession(Y)),void 0)}static _serializeRegExp(j){return{pattern:j.source,flags:_.regExpFlags(j)}}static _serializeIndentationRule(j){return{decreaseIndentPattern:ze._serializeRegExp(j.decreaseIndentPattern),increaseIndentPattern:ze._serializeRegExp(j.increaseIndentPattern),indentNextLinePattern:j.indentNextLinePattern?ze._serializeRegExp(j.indentNextLinePattern):void 0,unIndentedLinePattern:j.unIndentedLinePattern?ze._serializeRegExp(j.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(j){return{beforeText:ze._serializeRegExp(j.beforeText),afterText:j.afterText?ze._serializeRegExp(j.afterText):void 0,previousLineText:j.previousLineText?ze._serializeRegExp(j.previousLineText):void 0,action:j.action}}static _serializeOnEnterRules(j){return j.map(ze._serializeOnEnterRule)}setLanguageConfiguration(j,Y,ie){let{wordPattern:re}=ie;if(re&&_.regExpLeadsToEndlessLoop(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(Y,re):this._documents.setWordDefinitionFor(Y,void 0),ie.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",j,"Do not use."),ie.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",j,"Do not use.");const J=this._nextHandle(),ce={comments:ie.comments,brackets:ie.brackets,wordPattern:ie.wordPattern?ze._serializeRegExp(ie.wordPattern):void 0,indentationRules:ie.indentationRules?ze._serializeIndentationRule(ie.indentationRules):void 0,onEnterRules:ie.onEnterRules?ze._serializeOnEnterRules(ie.onEnterRules):void 0,__electricCharacterSupport:ie.__electricCharacterSupport,__characterPairSupport:ie.__characterPairSupport};return this._proxy.$setLanguageConfiguration(J,Y,ce),this._createDisposable(J)}$setWordDefinitions(j){for(const Y of j)this._documents.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.ExtHostLanguageFeatures=ze,ze._handlePool=0}),define(pe[230],ve([0,1,5,17,7]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class S{constructor(P,_){this._proxy=P.getProxy(p.MainContext.MainThreadLanguages),this._documents=_}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(P,_){await this._proxy.$changeLanguage(P,_);const D=this._documents.getDocumentData(P);if(!D)throw new Error(`document '${P.toString}' NOT found`);return D.document}async tokenAtPosition(P,_){var D;const r=P.version,k=R.Position.from(_),l=await this._proxy.$tokensAtPosition(P.uri,k),h={type:C.StandardTokenType.Other,range:(D=P.getWordRangeAtPosition(_))!==null&&D!==void 0?D:new C.Range(_.line,_.character,_.line,_.character)};if(!l)return h;const c={range:R.Range.to(l.range),type:R.TokenType.to(l.type)};return!c.range.contains(_)||r!==P.version?h:c}}e.ExtHostLanguages=S}),define(pe[231],ve([0,1,5,12,35]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function S(P){return P&&P.title}let A=class{constructor(_,D){this._logService=D,this._proxy=_.getProxy(p.MainContext.MainThreadMessageService)}showMessage(_,D,r,k,l){const h={extension:_};let c;typeof k=="string"||S(k)?c=[k,...l]:(h.modal=k==null?void 0:k.modal,h.useCustom=k==null?void 0:k.useCustom,h.detail=k==null?void 0:k.detail,c=l),h.useCustom&&C.checkProposedApiEnabled(_);const f=[];for(let I=0;I<c.length;I++){const b=c[I];if(typeof b=="string")f.push({title:b,handle:I,isCloseAffordance:!1});else if(typeof b=="object"){let{title:w,isCloseAffordance:u}=b;f.push({title:w,isCloseAffordance:!!u,handle:I})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(D,r,h,f).then(I=>{if(typeof I=="number")return c[I]})}};A=qe([We(1,R.ILogService)],A),e.ExtHostMessageService=A}),define(pe[232],ve([0,1,22,3,73,6,23,8,15,2,82,5,17,7,208,123]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class I{constructor(w,u,d,g,t){this._textDocumentsAndEditors=d,this._textDocuments=g,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new A.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new R.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new R.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new R.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new R.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new R.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new R.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new R.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new r.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=w.getProxy(k.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=w.getProxy(k.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=w.getProxy(k.MainContext.MainThreadNotebookEditors),this._commandsConverter=u.converter,u.registerArgumentProcessor({processArgument:i=>{var s;if(i&&i.$mid===12){const n=(s=i.notebookEditor)===null||s===void 0?void 0:s.notebookUri,o=i.cell.handle,v=this._documents.get(n),m=v==null?void 0:v.getCell(o);if(m)return m.apiCell}return i}})}get activeNotebookEditor(){var w;return(w=this._activeNotebookEditor)===null||w===void 0?void 0:w.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(w=>w.apiEditor)}getEditorById(w){const u=this._editors.get(w);if(!u)throw new Error(`unknown text editor: ${w}. known editors: ${[...this._editors.keys()]} `);return u}getIdByEditor(w){for(const[u,d]of this._editors)if(d.apiEditor===w)return u}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(w,u){const d=this._documents.get(w);if(!d&&!u)throw new Error(`NO notebook document for '${w}'`);return d}_getProviderData(w){const u=this._notebookContentProviders.get(w);if(!u)throw new Error(`NO provider for '${w}'`);return u}registerNotebookContentProvider(w,u,d,g,t){if(P.isFalsyOrWhitespace(u))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(u))throw new Error(`Notebook provider for '${u}' already registered`);this._notebookContentProviders.set(u,{extension:w,provider:d});let i;return d.onDidChangeNotebookContentOptions&&(i=d.onDidChangeNotebookContentOptions(()=>{const s=l.NotebookDocumentContentOptions.from(d.options);this._notebookProxy.$updateNotebookProviderOptions(u,s)})),this._notebookProxy.$registerNotebookProvider({id:w.identifier,location:w.extensionLocation},u,l.NotebookDocumentContentOptions.from(g),I._convertNotebookRegistrationData(w,t)),new h.Disposable(()=>{i==null||i.dispose(),this._notebookContentProviders.delete(u),this._notebookProxy.$unregisterNotebookProvider(u)})}static _convertNotebookRegistrationData(w,u){if(!u)return;const d=u.filenamePattern.map(g=>l.NotebookExclusiveDocumentPattern.from(g)).filter(g=>g!==void 0);if(u.filenamePattern&&!d){console.warn(`Notebook content provider view options file name pattern is invalid ${u.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:u.displayName,filenamePattern:d,exclusive:u.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,u,d){const g=I._notebookStatusBarItemProviderHandlePool++,t=typeof d.onDidChangeCellStatusBarItems=="function"?I._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(g,d),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(g,t,u);let i;return t!==void 0&&(i=d.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(g),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(g,t),i&&i.dispose()})}async createNotebookDocument(w){const u=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:w.viewType,content:w.content&&l.NotebookData.from(w.content)});return D.URI.revive(u)}async openNotebookDocument(w){const u=this._documents.get(w);if(u)return u.apiNotebook;const d=await this._notebookDocumentsProxy.$tryOpenNotebook(w),g=this._documents.get(D.URI.revive(d));return _.assertIsDefined(g==null?void 0:g.apiNotebook)}async showNotebookDocument(w,u){var d;D.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let g;typeof u=="object"?g={position:l.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus,selections:u.selections&&u.selections.map(l.NotebookRange.from),pinned:typeof u.preview=="boolean"?!u.preview:void 0}:g={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(w.uri,w.notebookType,g),i=t&&((d=this._editors.get(t))===null||d===void 0?void 0:d.apiEditor);if(i)return i;throw t?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,u,d,g){const t=this._notebookStatusBarItemProviders.get(w),i=D.URI.revive(u),s=this._documents.get(i);if(!s||!t)return;const n=s.getCellFromIndex(d);if(!n)return;const o=await t.provideCellStatusBarItems(n.apiCell,g);if(!o)return;const v=new S.DisposableStore,m=this._statusBarCache.add([v]),y=(Array.isArray(o)?o:[o]).map(a=>l.NotebookStatusBarItem.from(a,this._commandsConverter,v));return{cacheId:m,items:y}}$releaseNotebookCellStatusBarItems(w){this._statusBarCache.delete(w)}registerNotebookSerializer(w,u,d,g,t){if(P.isFalsyOrWhitespace(u))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,d),this._notebookProxy.$registerNotebookSerializer(i,{id:w.identifier,location:w.extensionLocation},u,l.NotebookDocumentContentOptions.from(g),I._convertNotebookRegistrationData(w,t)),S.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(w,u,d){const g=this._notebookSerializer.get(w);if(!g)throw new Error("NO serializer found");const t=await g.deserializeNotebook(u.buffer,d);return l.NotebookData.from(t)}async $notebookToData(w,u,d){const g=this._notebookSerializer.get(w);if(!g)throw new Error("NO serializer found");const t=await g.serializeNotebook(l.NotebookData.to(u),d);return p.VSBuffer.wrap(t)}async $openNotebook(w,u,d,g,t){var i;const{provider:s}=this._getProviderData(w),n=await s.openNotebook(D.URI.revive(u),{backupId:d,untitledDocumentData:g==null?void 0:g.buffer},t);return{metadata:(i=n.metadata)!==null&&i!==void 0?i:Object.create(null),cells:n.cells.map(l.NotebookCellData.from)}}async $saveNotebook(w,u,d){const g=this.getNotebookDocument(D.URI.revive(u)),{provider:t}=this._getProviderData(w);return await t.saveNotebook(g.apiNotebook,d),!0}async $saveNotebookAs(w,u,d,g){const t=this.getNotebookDocument(D.URI.revive(u)),{provider:i}=this._getProviderData(w);return await i.saveNotebookAs(D.URI.revive(d),t.apiNotebook,g),!0}async $backupNotebook(w,u,d){var g;const t=this.getNotebookDocument(D.URI.revive(u)),i=this._getProviderData(w),s=(g=this._extensionStoragePaths.workspaceValue(i.extension))!==null&&g!==void 0?g:this._extensionStoragePaths.globalValue(i.extension),n=String(C.hash([t.uri.toString(),this._backupIdPool++])),o=D.URI.joinPath(s,n),v=await i.provider.backupNotebook(t.apiNotebook,{destination:o},d);return t.updateBackup(v),v.id}_createExtHostEditor(w,u,d){if(this._editors.has(u))throw new Error(`editor with id ALREADY EXSIST: ${u}`);const g=new f.ExtHostNotebookEditor(u,this._notebookEditorsProxy,w,d.visibleRanges.map(l.NotebookRange.to),d.selections.map(l.NotebookRange.to),typeof d.viewColumn=="number"?l.ViewColumn.to(d.viewColumn):void 0);this._editors.set(u,g)}$acceptDocumentAndEditorsDelta(w){var u,d,g;if(w.removedDocuments)for(const i of w.removedDocuments){const s=D.URI.revive(i),n=this._documents.get(s);n&&(n.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:n.apiNotebook.getCells().map(o=>o.document.uri)}),this._onDidCloseNotebookDocument.fire(n.apiNotebook));for(const o of this._editors.values())o.notebookData.uri.toString()===s.toString()&&this._editors.delete(o.id)}if(w.addedDocuments){const i=[];for(const s of w.addedDocuments){const n=D.URI.revive(s.uri);if(this._documents.has(n))throw new Error(`adding EXISTING notebook ${n} `);const o=this,v=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(m){o._onDidChangeNotebookCells.fire(m)},emitCellOutputsChange(m){o._onDidChangeCellOutputs.fire(m)},emitCellMetadataChange(m){o._onDidChangeCellMetadata.fire(m)},emitCellExecutionStateChange(m){o._onDidChangeCellExecutionState.fire(m)}},n,s);i.push(...s.cells.map(m=>c.ExtHostCell.asModelAddData(v.apiNotebook,m))),(u=this._documents.get(n))===null||u===void 0||u.dispose(),this._documents.set(n,v),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this._onDidOpenNotebookDocument.fire(v.apiNotebook)}}if(w.addedEditors)for(const i of w.addedEditors){if(this._editors.has(i.id))return;const s=D.URI.revive(i.documentUri),n=this._documents.get(s);n&&this._createExtHostEditor(n,i.id,i)}const t=[];if(w.removedEditors)for(const i of w.removedEditors){const s=this._editors.get(i);s&&(this._editors.delete(i),((d=this._activeNotebookEditor)===null||d===void 0?void 0:d.id)===s.id&&(this._activeNotebookEditor=void 0),t.push(s))}if(w.visibleEditors){this._visibleNotebookEditors=w.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const i=new Set;this._visibleNotebookEditors.forEach(s=>i.add(s.id));for(const s of this._editors.values()){const n=i.has(s.id);s._acceptVisibility(n)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}w.newActiveEditor===null?this._activeNotebookEditor=void 0:w.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(w.newActiveEditor)),w.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((g=this._activeNotebookEditor)===null||g===void 0?void 0:g.apiEditor)}}e.ExtHostNotebookController=I,I._notebookStatusBarItemProviderHandlePool=0}),define(pe[233],ve([0,1,3,70,12,5,13,17]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(k,l){const h=_._Keys.nextId();k.$registerNotebookEditorDecorationType(h,P.NotebookDecorationRenderOptions.from(l)),this.value={key:h,dispose(){k.$removeNotebookEditorDecorationType(h)}}}}_._Keys=new R.IdGenerator("NotebookEditorDecorationType");let D=class{constructor(k,l,h){this._logService=k,this._extHostRpc=l,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new p.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new p.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(k){return new _(this._extHostRpc.getProxy(S.MainContext.MainThreadNotebookEditors),k).value}$acceptEditorPropertiesChanged(k,l){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",k,l);const h=this._notebooksAndEditors.getEditorById(k);l.visibleRanges&&h._acceptVisibleRanges(l.visibleRanges.ranges.map(P.NotebookRange.to)),l.selections&&h._acceptSelections(l.selections.selections.map(P.NotebookRange.to)),l.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),l.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(k){for(const l in k)this._notebooksAndEditors.getEditorById(l)._acceptViewColumn(P.ViewColumn.to(k[l]))}};D=qe([We(0,C.ILogService),We(1,A.IExtHostRpcService)],D),e.ExtHostNotebookEditors=D}),define(pe[234],ve([0,1,3,6,5,26,2,17,84,23,16,85,21,18,12,7,35]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(t,i,s,n){this._initData=i,this._extHostNotebook=s,this._logService=n,this._activeExecutions=new D.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(C.MainContext.MainThreadNotebookKernels)}createNotebookController(t,i,s,n,o,v){for(let F of this._kernelData.values())if(F.controller.id===i&&S.ExtensionIdentifier.equals(t.identifier,F.extensionId))throw new Error(`notebook controller with id '${i}' ALREADY exist`);const m=this._handlePool++,E=this;this._logService.trace(`NotebookController[${m}], CREATED by ${t.identifier.value}, ${i}`);const y=()=>console.warn(`NO execute handler from notebook controller '${Z.id}' of extension: '${t.identifier}'`);let a=!1;const T=new R.DisposableStore,O=new p.Emitter,$=new p.Emitter,Z={id:`${t.identifier.value}/${i}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:n||t.identifier.value,preloads:v?v.map(P.NotebookRendererScript.from):[]};let le=o??y,q;this._proxy.$addKernel(m,Z).catch(F=>{console.log(F),a=!0});let x=0;const H=()=>{if(a)return;const F=++x;Promise.resolve().then(()=>{F===x&&this._proxy.$updateKernel(m,Z)})},N=new D.ResourceMap,z={get id(){return i},get notebookType(){return Z.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return Z.label},set label(F){var M;Z.label=(M=F??t.displayName)!==null&&M!==void 0?M:t.name,H()},get detail(){var F;return(F=Z.detail)!==null&&F!==void 0?F:""},set detail(F){Z.detail=F,H()},get description(){var F;return(F=Z.description)!==null&&F!==void 0?F:""},set description(F){Z.description=F,H()},get supportedLanguages(){return Z.supportedLanguages},set supportedLanguages(F){Z.supportedLanguages=F,H()},get supportsExecutionOrder(){var F;return(F=Z.supportsExecutionOrder)!==null&&F!==void 0?F:!1},set supportsExecutionOrder(F){Z.supportsExecutionOrder=F,H()},get rendererScripts(){return Z.preloads?Z.preloads.map(P.NotebookRendererScript.to):[]},get executeHandler(){return le},set executeHandler(F){le=F??y},get interruptHandler(){return q},set interruptHandler(F){q=F,Z.supportsInterrupt=Boolean(F),H()},createNotebookCellExecution(F){if(a)throw new Error("notebook controller is DISPOSED");if(!N.has(F.notebook.uri))throw E._logService.trace(`NotebookController[${m}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(N.keys()).map(M=>M.toString())),new Error(`notebook controller is NOT associated to notebook: ${F.notebook.uri.toString()}`);return E._createNotebookCellExecution(F)},dispose:()=>{a||(this._logService.trace(`NotebookController[${m}], DISPOSED`),a=!0,this._kernelData.delete(m),T.dispose(),O.dispose(),$.dispose(),this._proxy.$removeKernel(m))},updateNotebookAffinity(F,M){E._proxy.$updateNotebookPriority(m,F.uri,M)},onDidReceiveMessage:$.event,postMessage(F,M){return I.checkProposedApiEnabled(t),E._proxy.$postMessage(m,M&&E._extHostNotebook.getIdByEditor(M),F)},asWebviewUri(F){return I.checkProposedApiEnabled(t),_.asWebviewUri(F,E._initData.remote)}};return this._kernelData.set(m,{extensionId:t.identifier,controller:z,onDidReceiveMessage:$,onDidChangeSelection:O,associatedNotebooks:N}),z}$acceptNotebookAssociation(t,i,s){const n=this._kernelData.get(t);if(n){const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(i));s?n.associatedNotebooks.set(o.uri,!0):n.associatedNotebooks.delete(o.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,o.uri.toString(),s),n.onDidChangeSelection.fire({selected:s,notebook:o.apiNotebook})}}async $executeCells(t,i,s){const n=this._kernelData.get(t);if(!n)return;const o=this._extHostNotebook.getNotebookDocument(A.URI.revive(i)),v=[];for(let m of s){const E=o.getCell(m);E&&v.push(E.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,o.uri.toString(),v.length),await n.controller.executeHandler.call(n.controller,v,o.apiNotebook,n.controller)}catch(m){this._logService.error(`NotebookController[${t}] execute cells FAILED`,m),console.error(m)}}async $cancelCells(t,i,s){var n;const o=this._kernelData.get(t);if(!o)return;const v=this._extHostNotebook.getNotebookDocument(A.URI.revive(i));if(o.controller.interruptHandler)await o.controller.interruptHandler.call(o.controller,v.apiNotebook);else for(let m of s){const E=v.getCell(m);E&&((n=this._activeExecutions.get(E.uri))===null||n===void 0||n.cancel())}}$acceptKernelMessageFromRenderer(t,i,s){const n=this._kernelData.get(t);if(!n)return;const o=this._extHostNotebook.getEditorById(i);n.onDidReceiveMessage.fire(Object.freeze({editor:o.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const n=new u(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,n);const o=n.onDidChangeState(()=>{n.state===w.Resolved&&(n.dispose(),o.dispose(),this._activeExecutions.delete(s.uri))});return n.asApiObject()}};b=qe([We(3,c.ILogService)],b),e.ExtHostNotebookKernels=b;var w;(function(g){g[g.Init=0]="Init",g[g.Started=1]="Started",g[g.Resolved=2]="Resolved"})(w||(w={}));class u extends R.Disposable{constructor(t,i,s){super();this._document=t,this._cell=i,this._proxy=s,this._onDidChangeState=new p.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=w.Init,this._tokenSource=this._register(new l.CancellationTokenSource),this._collector=new d(10,n=>this.applyEdits(n)),this._executionOrder=i.internalMetadata.executionOrder,this.mixinMetadata({runState:k.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===w.Init)throw new Error("Must call start before modifying cell output");if(this._state===w.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let i=this._cell;if(t&&(i=this._document.getCellFromApiCell(t)),!i)throw new Error("INVALID cell");return i.handle}validateAndConvertOutputs(t){return t.map(i=>{const s=f.NotebookCellOutput.ensureUniqueMimeTypes(i.items,!0);return s===i.items?P.NotebookCellOutput.from(i):P.NotebookCellOutput.from({items:s,id:i.id,metadata:i.metadata})})}async updateOutputs(t,i,s){const n=this.cellIndexToHandle(i),o=this.validateAndConvertOutputs(h.asArray(t));return this.applyEditSoon({editType:2,handle:n,append:s,outputs:o})}async updateOutputItems(t,i,s){return t=f.NotebookCellOutput.ensureUniqueMimeTypes(h.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(P.NotebookCellOutputItem.from),outputId:i.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===w.Resolved||t._state===w.Started)throw new Error("Cannot call start again");t._state=w.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:k.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,n){if(t._state===w.Resolved)throw new Error("Cannot call resolve twice");t._state=w.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:n??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!0)},replaceOutput(s,n){return t.verifyStateForOutput(),t.updateOutputs(s,n,!1)},appendOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!0)},replaceOutputItems(s,n){return t.verifyStateForOutput(),t.updateOutputItems(s,n,!1)}})}}class d{constructor(t,i){this.delay=t,this.callback=i,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=r.timeout(this.delay).then(()=>{this.waitPromise=void 0;const i=this.batch;return this.batch=[],this.callback(i)})),this.waitPromise}}}),define(pe[235],ve([0,1,3,5,123]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class S{constructor(P,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=P.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,_,D){var r;const k=this._extHostNotebook.getEditorById(P);(r=this._rendererMessageEmitters.get(_))===null||r===void 0||r.fire({editor:k.apiEditor,message:D})}createRendererMessaging(P){return{onDidReceiveMessage:(...D)=>this.getOrCreateEmitterFor(P).event(...D),postMessage:(D,r)=>{const k=C.ExtHostNotebookEditor.apiEditorsToExtHost.get(D);if(!k)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(k.id,P,r)}}}getOrCreateEmitterFor(P){let _=this._rendererMessageEmitters.get(P);return _||(_=new p.Emitter({onLastListenerRemove:()=>{_==null||_.dispose(),this._rendererMessageEmitters.delete(P)}}),this._rendererMessageEmitters.set(P,_),_)}}e.ExtHostNotebookRenderers=S}),define(pe[62],ve([0,1,5,3,6,22,4,13]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends C.Disposable{constructor(c,f,I,b){super();this._onDidAppend=this._register(new R.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=b,this._id=b.$register(this.name,f,I),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?S.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(f=>this._proxy.$clear(f,c))}show(c,f){this.validate(),this._id.then(I=>this._proxy.$reveal(I,!!(typeof c=="boolean"?c:f)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class D extends _{constructor(c,f){super(c,!1,void 0,f)}append(c){super.append(c),this._id.then(f=>this._proxy.$append(f,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=D;class r extends _{constructor(c,f,I){super(c,!0,f,I)}append(c){throw new Error("Not supported")}}class k{constructor(c,f){this.name=c,this._channel=f}append(c){this._channel.then(f=>f.append(c))}appendLine(c){this._channel.then(f=>f.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,f){this._channel.then(I=>I.show(c,f))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=k;let l=class{constructor(c){this._proxy=c.getProxy(p.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new D(c,this._proxy)}createOutputChannelFromLogFile(c,f){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!f)throw new Error("illegal argument `file`. must not be falsy");return new r(c,f,this._proxy)}};l=qe([We(0,P.IExtHostRpcService)],l),e.ExtHostOutputService=l,e.IExtHostOutputService=A.createDecorator("IExtHostOutputService")}),define(pe[236],ve([0,1,16,21,3,6,5,2,7,14,18,54]),function(X,e,p,R,C,S,A,P,_,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function l(h,c,f){const I=h.getProxy(A.MainContext.MainThreadQuickOpen);class b{constructor(n,o){this._sessions=new Map,this._instances=0,this._workspace=n,this._commands=o}showQuickPick(n,o,v,m=R.CancellationToken.None){this._onDidSelectItem=void 0;const E=Promise.resolve(n),y=++this._instances,a=I.$show(y,{title:v==null?void 0:v.title,placeHolder:v==null?void 0:v.placeHolder,matchOnDescription:v==null?void 0:v.matchOnDescription,matchOnDetail:v==null?void 0:v.matchOnDetail,ignoreFocusLost:v==null?void 0:v.ignoreFocusOut,canPickMany:v==null?void 0:v.canPickMany},m),T={},O=a.then(()=>T);return Promise.race([O,E]).then($=>{if($!==T)return E.then(Z=>{const le=[];for(let q=0;q<Z.length;q++){const x=Z[q];let H,N,z,F,M;typeof x=="string"?H=x:(H=x.label,N=x.description,z=x.detail,F=x.picked,M=x.alwaysShow),le.push({label:H,description:N,handle:q,detail:z,picked:F,alwaysShow:M})}return v&&typeof v.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{v.onDidSelectItem(Z[q])}),I.$setItems(y,le),a.then(q=>{if(typeof q=="number")return Z[q];if(Array.isArray(q))return q.map(x=>Z[x])})})}).then(void 0,$=>{if(!D.isPromiseCanceledError($))return I.$setError(y,$),Promise.reject($)})}$onItemSelected(n){this._onDidSelectItem&&this._onDidSelectItem(n)}showInput(n,o=R.CancellationToken.None){return this._validateInput=n?n.validateInput:void 0,I.$input(n,typeof this._validateInput=="function",o).then(void 0,v=>{if(!D.isPromiseCanceledError(v))return Promise.reject(v)})}$validateInput(n){return this._validateInput?p.asPromise(()=>this._validateInput(n)):Promise.resolve(void 0)}async showWorkspaceFolderPick(n,o=R.CancellationToken.None){const v=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!v)return;const m=await this._workspace.getWorkspaceFolders2();if(!!m)return m.find(E=>E.uri.toString()===v.uri.toString())}createQuickPick(n,o){const v=new t(n,o,()=>this._sessions.delete(v._id));return this._sessions.set(v._id,v),v}createInputBox(n){const o=new i(n,()=>this._sessions.delete(o._id));return this._sessions.set(o._id,o),o}$onDidChangeValue(n,o){const v=this._sessions.get(n);v&&v._fireDidChangeValue(o)}$onDidAccept(n){const o=this._sessions.get(n);o&&o._fireDidAccept()}$onDidChangeActive(n,o){const v=this._sessions.get(n);v instanceof t&&v._fireDidChangeActive(o)}$onDidChangeSelection(n,o){const v=this._sessions.get(n);v instanceof t&&v._fireDidChangeSelection(o)}$onDidTriggerButton(n,o){const v=this._sessions.get(n);v&&v._fireDidTriggerButton(o)}$onDidHide(n){const o=this._sessions.get(n);o&&o._fireDidHide()}}class w{constructor(n,o){this._extensionId=n,this._onDidDispose=o,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new C.Emitter,this._onDidChangeValueEmitter=new C.Emitter,this._onDidTriggerButtonEmitter=new C.Emitter,this._onDidHideEmitter=new C.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(n){this._title=n,this.update({title:n})}get step(){return this._steps}set step(n){this._steps=n,this.update({step:n})}get totalSteps(){return this._totalSteps}set totalSteps(n){this._totalSteps=n,this.update({totalSteps:n})}get enabled(){return this._enabled}set enabled(n){this._enabled=n,this.update({enabled:n})}get busy(){return this._busy}set busy(n){this._busy=n,this.update({busy:n})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(n){this._ignoreFocusOut=n,this.update({ignoreFocusOut:n})}get value(){return this._value}set value(n){this._value=n,this.update({value:n})}get placeholder(){return this._placeholder}set placeholder(n){this._placeholder=n,this.update({placeholder:n})}get buttons(){return this._buttons}set buttons(n){this._buttons=n.slice(),this._handlesToButtons.clear(),n.forEach((o,v)=>{const m=o===_.QuickInputButtons.Back?-1:v;this._handlesToButtons.set(m,o)}),this.update({buttons:n.map((o,v)=>({iconPath:u(o.iconPath),tooltip:o.tooltip,handle:o===_.QuickInputButtons.Back?-1:v}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(n){this._value=n,this._onDidChangeValueEmitter.fire(n)}_fireDidTriggerButton(n){const o=this._handlesToButtons.get(n);o&&this._onDidTriggerButtonEmitter.fire(o)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=S.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),I.$dispose(this._id))}update(n){if(!this._disposed){for(const o of Object.keys(n)){const v=n[o];this._pendingUpdate[o]=v===void 0?null:v}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){I.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}w._nextId=1;function u(s){if(s instanceof _.ThemeIcon)return{id:s.id};const n=g(s),o=d(s);return{dark:typeof n=="string"?P.URI.file(n):n,light:typeof o=="string"?P.URI.file(o):o}}function d(s){return typeof s=="object"&&"light"in s?s.light:s}function g(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends w{constructor(n,o,v){super(n,v);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new C.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new C.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(n){this._items=n.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),n.forEach((o,v)=>{this._handlesToItems.set(v,o),this._itemsToHandles.set(o,v)}),this.update({items:n.map((o,v)=>({label:o.label,description:o.description,handle:v,detail:o.detail,picked:o.picked,alwaysShow:o.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(n){this._canSelectMany=n,this.update({canSelectMany:n})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(n){this._matchOnDescription=n,this.update({matchOnDescription:n})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(n){this._matchOnDetail=n,this.update({matchOnDetail:n})}get sortByLabel(){return this._sortByLabel}set sortByLabel(n){this._sortByLabel=n,this.update({sortByLabel:n})}get activeItems(){return this._activeItems}set activeItems(n){this._activeItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({activeItems:this._activeItems.map(o=>this._itemsToHandles.get(o))})}get selectedItems(){return this._selectedItems}set selectedItems(n){this._selectedItems=n.filter(o=>this._itemsToHandles.has(o)),this.update({selectedItems:this._selectedItems.map(o=>this._itemsToHandles.get(o))})}_fireDidChangeActive(n){const o=r.coalesce(n.map(v=>this._handlesToItems.get(v)));this._activeItems=o,this._onDidChangeActiveEmitter.fire(o)}_fireDidChangeSelection(n){const o=r.coalesce(n.map(v=>this._handlesToItems.get(v)));this._selectedItems=o,this._onDidChangeSelectionEmitter.fire(o)}}class i extends w{constructor(n,o){super(n,o);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(n){this._password=n,this.update({password:n})}get prompt(){return this._prompt}set prompt(n){this._prompt=n,this.update({prompt:n})}get validationMessage(){return this._validationMessage}set validationMessage(n){this._validationMessage=n,this.update({validationMessage:n,severity:n?k.default.Error:k.default.Ignore})}}return new b(c,f)}e.createExtHostQuickOpen=l}),define(pe[237],ve([0,1,2,3,51,6,16,5,18,96,12,26,35]),function(X,e,p,R,C,S,A,P,_,D,r,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(n){if(n)return typeof n.iconPath=="string"?p.URI.file(n.iconPath):n.iconPath}function c(n,o){if(!n.iconPath&&!o.iconPath)return 0;if(n.iconPath){if(!o.iconPath)return 1}else return-1;const v=typeof n.iconPath=="string"?n.iconPath:n.iconPath.fsPath,m=typeof o.iconPath=="string"?o.iconPath:o.iconPath.fsPath;return D.comparePaths(v,m)}function f(n,o){let v=0;if(n.strikeThrough!==o.strikeThrough)return n.strikeThrough?1:-1;if(n.faded!==o.faded)return n.faded?1:-1;if(n.tooltip!==o.tooltip)return(n.tooltip||"").localeCompare(o.tooltip||"");if(v=c(n,o),v!==0)return v;if(n.light&&o.light)v=c(n.light,o.light);else{if(n.light)return 1;if(o.light)return-1}if(v!==0)return v;if(n.dark&&o.dark)v=c(n.dark,o.dark);else{if(n.dark)return 1;if(o.dark)return-1}return v}function I(n,o){if(n.command!==o.command)return n.command<o.command?-1:1;if(n.title!==o.title)return n.title<o.title?-1:1;if(n.tooltip!==o.tooltip){if(n.tooltip!==void 0&&o.tooltip!==void 0)return n.tooltip<o.tooltip?-1:1;if(n.tooltip!==void 0)return 1;if(o.tooltip!==void 0)return-1}if(n.arguments===o.arguments)return 0;if(n.arguments)if(o.arguments){if(n.arguments.length!==o.arguments.length)return n.arguments.length-o.arguments.length}else return 1;else return-1;for(let v=0;v<n.arguments.length;v++){const m=n.arguments[v],E=o.arguments[v];if(m!==E)return m<E?-1:1}return 0}function b(n,o){let v=D.comparePaths(n.resourceUri.fsPath,o.resourceUri.fsPath,!0);if(v!==0)return v;if(n.command&&o.command)v=I(n.command,o.command);else{if(n.command)return 1;if(o.command)return-1}if(v!==0)return v;if(n.decorations&&o.decorations)v=f(n.decorations,o.decorations);else{if(n.decorations)return 1;if(o.decorations)return-1}return v}function w(n,o){for(let v=0;v<n.length;v++)if(n[v]!==o[v])return!1;return!0}function u(n,o){return n.command===o.command&&n.title===o.title&&n.tooltip===o.tooltip&&(n.arguments&&o.arguments?w(n.arguments,o.arguments):n.arguments===o.arguments)}function d(n,o){return _.equals(n,o,u)}class g{constructor(o,v,m){this._extension=o,this._proxy=v,this._sourceControlHandle=m,this._value="",this._onDidChange=new R.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(o){this._proxy.$setInputBoxValue(this._sourceControlHandle,o),this.updateValue(o)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(o){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,o),this._placeholder=o}get validateInput(){return l.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(o){if(l.checkProposedApiEnabled(this._extension),o&&typeof o!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=o,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!o)}get visible(){return this._visible}set visible(o){o=!!o,this._visible!==o&&(this._visible=o,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,o))}focus(){l.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(o,v){l.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,o,v)}$onInputBoxValueChange(o){this.updateValue(o)}updateValue(o){this._value=o,this._onDidChange.fire(o)}}e.ExtHostSCMInputBox=g;class t{constructor(o,v,m,E,y){this._proxy=o,this._commands=v,this._sourceControlHandle=m,this._id=E,this._label=y,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new R.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new R.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(o){this._label=o,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,o)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(o){this._hideWhenEmpty=o,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(o){this._resourceStates=[...o],this._onDidUpdateResourceStates.fire()}getResourceState(o){return this._resourceStatesMap.get(o)}$executeResourceCommand(o,v){const m=this._resourceStatesCommandsMap.get(o);return m?A.asPromise(()=>this._commands.executeCommand(m.command,...m.arguments||[],v)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var o;const v=[...this._resourceStates].sort(b),E=_.sortedDiff(this._resourceSnapshot,v,b).map(T=>{const O=T.toInsert.map($=>{const Z=this._resourceHandlePool++;this._resourceStatesMap.set(Z,$);const le=$.resourceUri,q=h($.decorations),x=$.decorations&&h($.decorations.light)||q,H=$.decorations&&h($.decorations.dark)||q,N=[];let z;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const te=new S.DisposableStore;z=this._commands.converter.toInternal($.command,te),this._resourceStatesDisposablesMap.set(Z,te)}else this._resourceStatesCommandsMap.set(Z,$.command);x&&N.push(x),H&&H.toString()!==(x==null?void 0:x.toString())&&N.push(H);const F=$.decorations&&$.decorations.tooltip||"",M=$.decorations&&!!$.decorations.strikeThrough,L=$.decorations&&!!$.decorations.faded,U=$.contextValue||"";return{rawResource:[Z,le,N,F,M,L,U,z],handle:Z}});return{start:T.start,deleteCount:T.deleteCount,toInsert:O}}),y=E.map(({start:T,deleteCount:O,toInsert:$})=>[T,O,$.map(Z=>Z.rawResource)]),a=E.reverse();for(const{start:T,deleteCount:O,toInsert:$}of a){const Z=$.map(q=>q.handle),le=this._handlesSnapshot.splice(T,O,...Z);for(const q of le)this._resourceStatesMap.delete(q),this._resourceStatesCommandsMap.delete(q),(o=this._resourceStatesDisposablesMap.get(q))===null||o===void 0||o.dispose(),this._resourceStatesDisposablesMap.delete(q)}return this._resourceSnapshot=v,y}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class i{constructor(o,v,m,E,y,a){this._proxy=v,this._commands=m,this._id=E,this._label=y,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new S.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new S.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new R.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=i._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new g(o,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,E,y,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(o){this._count!==o&&(this._count=o,this._proxy.$updateSourceControl(this.handle,{count:o}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(o){this._quickDiffProvider=o,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!o})}get commitTemplate(){return this._commitTemplate}set commitTemplate(o){o!==this._commitTemplate&&(this._commitTemplate=o,this._proxy.$updateSourceControl(this.handle,{commitTemplate:o}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(o){this._acceptInputDisposables.value=new S.DisposableStore,this._acceptInputCommand=o;const v=this._commands.converter.toInternal(o,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:v})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(o){if(this._statusBarCommands&&o&&d(this._statusBarCommands,o))return;this._statusBarDisposables.value=new S.DisposableStore,this._statusBarCommands=o;const v=(o||[]).map(m=>this._commands.converter.toInternal(m,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:v})}get selected(){return this._selected}createResourceGroup(o,v){const m=new t(this._proxy,this._commands,this.handle,o,v),E=R.Event.once(m.onDidDispose)(()=>this.createdResourceGroups.delete(m));return this.createdResourceGroups.set(m,E),this.eventuallyAddResourceGroups(),m}eventuallyAddResourceGroups(){const o=[],v=[];for(const[m,E]of this.createdResourceGroups){E.dispose();const y=m.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(m),this.eventuallyUpdateResourceStates()});R.Event.once(m.onDidDispose)(()=>{this.updatedResourceGroups.delete(m),y.dispose(),this._groups.delete(m.handle),this._proxy.$unregisterGroup(this.handle,m.handle)}),o.push([m.handle,m.id,m.label,m.features]);const a=m._takeResourceStateSnapshot();a.length>0&&v.push([m.handle,a]),this._groups.set(m.handle,m)}this._proxy.$registerGroups(this.handle,o,v),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const o=[];this.updatedResourceGroups.forEach(v=>{const m=v._takeResourceStateSnapshot();m.length!==0&&o.push([v.handle,m])}),o.length>0&&this._proxy.$spliceResourceStates(this.handle,o),this.updatedResourceGroups.clear()}getResourceGroup(o){return this._groups.get(o)}setSelectionState(o){this._selected=o,this._onDidChangeSelection.fire(o)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(o=>o.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}i._handlePool=0,qe([C.debounce(100)],i.prototype,"eventuallyAddResourceGroups",null),qe([C.debounce(100)],i.prototype,"eventuallyUpdateResourceStates",null);let s=class Un{constructor(o,v,m){this._commands=v,this.logService=m,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new R.Emitter,this._proxy=o.getProxy(P.MainContext.MainThreadSCM),this._telemetry=o.getProxy(P.MainContext.MainThreadTelemetry),v.registerArgumentProcessor({processArgument:E=>{if(E&&E.$mid===3){const y=this._sourceControls.get(E.sourceControlHandle);if(!y)return E;const a=y.getResourceGroup(E.groupHandle);return a?a.getResourceState(E.handle):E}else if(E&&E.$mid===4){const y=this._sourceControls.get(E.sourceControlHandle);return y?y.getResourceGroup(E.groupHandle):E}else if(E&&E.$mid===5){const y=this._sourceControls.get(E.handle);return y||E}return E}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(o,v,m,E){this.logService.trace("ExtHostSCM#createSourceControl",o.identifier.value,v,m,E),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:o.identifier.value});const y=Un._handlePool++,a=new i(o,this._proxy,this._commands,v,m,E);this._sourceControls.set(y,a);const T=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(o.identifier))||[];return T.push(a),this._sourceControlsByExtension.set(k.ExtensionIdentifier.toKey(o.identifier),T),a}getLastInputBox(o){this.logService.trace("ExtHostSCM#getLastInputBox",o.identifier.value);const v=this._sourceControlsByExtension.get(k.ExtensionIdentifier.toKey(o.identifier)),m=v&&v[v.length-1];return m&&m.inputBox}$provideOriginalResource(o,v,m){const E=p.URI.revive(v);this.logService.trace("ExtHostSCM#$provideOriginalResource",o,E.toString());const y=this._sourceControls.get(o);return!y||!y.quickDiffProvider||!y.quickDiffProvider.provideOriginalResource?Promise.resolve(null):A.asPromise(()=>y.quickDiffProvider.provideOriginalResource(E,m)).then(a=>a||null)}$onInputBoxValueChange(o,v){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",o);const m=this._sourceControls.get(o);return m&&m.inputBox.$onInputBoxValueChange(v),Promise.resolve(void 0)}$executeResourceCommand(o,v,m,E){this.logService.trace("ExtHostSCM#$executeResourceCommand",o,v,m);const y=this._sourceControls.get(o);if(!y)return Promise.resolve(void 0);const a=y.getResourceGroup(v);return a?a.$executeResourceCommand(m,E):Promise.resolve(void 0)}$validateInput(o,v,m){this.logService.trace("ExtHostSCM#$validateInput",o);const E=this._sourceControls.get(o);return!E||!E.inputBox.validateInput?Promise.resolve(void 0):A.asPromise(()=>E.inputBox.validateInput(v,m)).then(y=>y?Promise.resolve([y.message,y.type]):Promise.resolve(void 0))}$setSelectedSourceControl(o){var v,m;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",o),o!==void 0&&((v=this._sourceControls.get(o))===null||v===void 0||v.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((m=this._sourceControls.get(this._selectedSourceControlHandle))===null||m===void 0||m.setSelectionState(!1)),this._selectedSourceControlHandle=o,Promise.resolve(void 0)}};s._handlePool=0,s=qe([We(2,r.ILogService)],s),e.ExtHostSCM=s});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(pe[238],ve([0,1,7,5,161,6,17]),function(X,e,p,R,C,S,A){"use strict";var P,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class D{constructor(h,c,f,I,b=p.StatusBarAlignment.Left,w){P.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new S.DisposableStore,it(this,P,h,"f"),it(this,_,c,"f"),this._entryId=D.ID_GEN++,this._extension=f,this._id=I,this._alignment=b,this._priority=w}get id(){var h;return(h=this._id)!==null&&h!==void 0?h:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get tooltip2(){return this._tooltip2}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var h;return(h=this._command)===null||h===void 0?void 0:h.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set tooltip2(h){this._tooltip2=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!D.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){var c;((c=this._command)===null||c===void 0?void 0:c.fromApi)!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:$e(this,_,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:$e(this,_,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,$e(this,P,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var h;this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let f;this._name?f=this._name:f=C.localize(0,null,this._extension.displayName||this._extension.name);let I=this._color;this._backgroundColor&&(I=D.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const b=this._tooltip2!==void 0?A.MarkdownString.fromStrict(this._tooltip2):this.tooltip;$e(this,P,"f").$setEntry(this._entryId,c,f,this._text,b,(h=this._command)===null||h===void 0?void 0:h.internal,I,this._backgroundColor,this._alignment===p.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=D,P=new WeakMap,_=new WeakMap,D.ID_GEN=0,D.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new p.ThemeColor("statusBarItem.errorForeground")]]);class r{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",p.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=C.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const c={message:h};return this._messages.unshift(c),this._update(),new p.Disposable(()=>{const f=this._messages.indexOf(c);f>=0&&(this._messages.splice(f,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class k{constructor(h,c){this._proxy=h.getProxy(R.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new r(this)}createStatusBarEntry(h,c,f,I){return new D(this._proxy,this._commands,h,c,f,I)}setStatusBarMessage(h,c){const f=this._statusMessage.setMessage(h);let I;return typeof c=="number"?I=setTimeout(()=>f.dispose(),c):typeof c!="undefined"&&c.then(()=>f.dispose(),()=>f.dispose()),new p.Disposable(()=>{f.dispose(),clearTimeout(I)})}}e.ExtHostStatusBar=k}),define(pe[88],ve([0,1,5,3,4]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class S{constructor(P){this._onDidChangeStorage=new R.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=P.getProxy(p.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,_){this._proxy.$registerExtensionStorageKeysToSync(P,_)}getValue(P,_,D){return this._proxy.$getValue(P,_).then(r=>r||D)}setValue(P,_,D){return this._proxy.$setValue(P,_,D)}$acceptValue(P,_,D){this._onDidChangeStorage.fire({shared:P,key:_,value:D})}}e.ExtHostStorage=S,e.IExtHostStorage=C.createDecorator("IExtHostStorage")}),define(pe[89],ve([0,1,4,27,12,87,2]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=p.createDecorator("IExtensionStoragePaths");let P=class{constructor(D,r,k){var l;this._logService=r,this._extHostFileSystem=k,this._workspace=(l=D.workspace)!==null&&l!==void 0?l:void 0,this._environment=D.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var D;if(!this._workspace)return Promise.resolve(void 0);const r=this._workspace.id,k=A.URI.joinPath(this._environment.workspaceStorageHome,r);try{return await this._extHostFileSystem.value.stat(k),this._logService.trace("[ExtHostStorage] storage dir already exists",k),k}catch(l){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",k),await this._extHostFileSystem.value.createDirectory(k),await this._extHostFileSystem.value.writeFile(A.URI.joinPath(k,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(D=A.URI.revive(this._workspace.configuration))===null||D===void 0?void 0:D.toString(),name:this._workspace.name},void 0,2))),k}catch(l){this._logService.error("[ExtHostStorage]",l);return}}workspaceValue(D){if(this._value)return A.URI.joinPath(this._value,D.identifier.value)}globalValue(D){return A.URI.joinPath(this._environment.globalStorageHome,D.identifier.value.toLowerCase())}};P=qe([We(0,R.IExtHostInitDataService),We(1,C.ILogService),We(2,S.IExtHostConsumerFileSystem)],P),e.ExtensionStoragePaths=P}),define(pe[33],ve([0,1,3,5,4,2,13,6,7,162,14,202,21,32,189,15]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=C.createDecorator("IExtHostTerminalService");class I{constructor(s,n,o,v){this._proxy=s,this._id=n,this._creationOptions=o,this._name=v,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(E=>this._pidPromiseComplete=E);const m=this;this.value={get name(){return m._name||""},get processId(){return m._pidPromise},get creationOptions(){return m._creationOptions},get exitStatus(){return m._exitStatus},sendText(E,y=!0){m._checkDisposed(),m._proxy.$sendText(m._id,E,y)},show(E){m._checkDisposed(),m._proxy.$show(m._id,E)},hide(){m._checkDisposed(),m._proxy.$hide(m._id)},dispose(){m._disposed||(m._disposed=!0,m._proxy.$dispose(m._id))},get dimensions(){if(!(m._cols===void 0||m._rows===void 0))return{columns:m._cols,rows:m._rows}}}}async create(s,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:f.withNullAsUndefined(s.shellPath),shellArgs:f.withNullAsUndefined(s.shellArgs),cwd:f.withNullAsUndefined(s.cwd),env:f.withNullAsUndefined(s.env),icon:f.withNullAsUndefined(t(s.iconPath)),initialText:f.withNullAsUndefined(s.message),strictEnv:f.withNullAsUndefined(s.strictEnv),hideFromUser:f.withNullAsUndefined(s.hideFromUser),isFeatureTerminal:f.withNullAsUndefined(n==null?void 0:n.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:f.withNullAsUndefined(n==null?void 0:n.useShellEnvironment),isSplitTerminal:f.withNullAsUndefined(n==null?void 0:n.isSplitTerminal)})}async createExtensionTerminal(s,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:n,isSplitTerminal:s}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,n){return s===this._cols&&n===this._rows||s===0||n===0?!1:(this._cols=s,this._rows=n,!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(n=>{n!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=I;class b{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new p.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new p.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new p.Emitter,this._onProcessTitleChanged=new p.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new p.Emitter,this._onProcessShellTypeChanged=new p.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,n){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:n})}async processBinary(s){}acknowledgeDataEvent(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(n=>this._onProcessData.fire(n)),this._pty.onDidClose&&this._pty.onDidClose((n=void 0)=>{this._onProcessExit.fire(n===void 0?void 0:n)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(n=>this._onProcessOverrideDimensions.fire(n&&{cols:n.columns,rows:n.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(n=>this._onProcessTitleChanged.fire(n)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let w=1,u=class extends P.Disposable{constructor(s,n){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new p.Emitter,this._onDidOpenTerminal=new p.Emitter,this._onDidChangeActiveTerminal=new p.Emitter,this._onDidChangeTerminalDimensions=new p.Emitter,this._proxy=n.getProxy(R.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new p.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[o,v]of this._terminalProcesses)v.shutdown(!0)}})}get activeTerminal(){var s;return(s=this._activeTerminal)===null||s===void 0?void 0:s.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(s){const n=s?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.path)||""}getDefaultShellArgs(s){const n=s?this._defaultAutomationProfile:this._defaultProfile;return(n==null?void 0:n.args)||[]}createExtensionTerminal(s,n){const o=new I(this._proxy,h.generateUuid(),s,s.name),v=new b(s.pty);return o.createExtensionTerminal(n==null?void 0:n.isSplitTerminal,t(s.iconPath)).then(m=>{const E=this._setupExtHostProcessListeners(m,v);this._terminalProcessDisposables[m]=E}),this._terminals.push(o),o.value}attachPtyToTerminal(s,n){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const v=new b(n),m=this._setupExtHostProcessListeners(s,v);this._terminalProcessDisposables[s]=m}async $acceptActiveTerminalChanged(s){const n=this._activeTerminal;if(s===null){this._activeTerminal=void 0,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const o=this._getTerminalById(s);o&&(this._activeTerminal=o,n!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,n){const o=this._getTerminalById(s);o&&this._onDidWriteTerminalData.fire({terminal:o.value,data:n})}async $acceptTerminalDimensions(s,n,o){const v=this._getTerminalById(s);v&&v.setDimensions(n,o)&&this._onDidChangeTerminalDimensions.fire({terminal:v.value,dimensions:v.value.dimensions})}async $acceptTerminalMaximumDimensions(s,n,o){var v;(v=this._terminalProcesses.get(s))===null||v===void 0||v.resize(n,o)}async $acceptTerminalTitleChange(s,n){const o=this._getTerminalById(s);o&&(o.name=n)}async $acceptTerminalClosed(s,n){const o=this._getTerminalObjectIndexById(this._terminals,s);if(o!==null){const v=this._terminals.splice(o,1)[0];v.setExitCode(n),this._onDidCloseTerminal.fire(v.value)}}$acceptTerminalOpened(s,n,o,v){if(n){const y=this._getTerminalObjectIndexById(this._terminals,n);if(y!==null){this._terminals[y]._id=s,this._onDidOpenTerminal.fire(this.terminals[y]),this._terminals[y].isOpen=!0;return}}const m={name:v.name,shellPath:v.executable,shellArgs:v.args,cwd:typeof v.cwd=="string"?v.cwd:S.URI.revive(v.cwd),env:v.env,hideFromUser:v.hideFromUser},E=new I(this._proxy,s,m,o);this._terminals.push(E),this._onDidOpenTerminal.fire(E.value),E.isOpen=!0}async $acceptTerminalProcessId(s,n){const o=this._getTerminalById(s);o&&o._setProcessId(n)}async $startExtensionTerminal(s,n){const o=this._getTerminalById(s);if(!o)return{message:D.localize(0,null,s)};o.isOpen||await new Promise(m=>{const E=this.onDidOpenTerminal(async y=>{y===o.value&&(E.dispose(),m())})});const v=this._terminalProcesses.get(s);v?v.startSendingEvents(n):this._extensionTerminalAwaitingStart[s]={initialDimensions:n}}_setupExtHostProcessListeners(s,n){const o=new P.DisposableStore;o.add(n.onProcessReady(m=>this._proxy.$sendProcessReady(s,m.pid,m.cwd))),o.add(n.onProcessTitleChanged(m=>this._proxy.$sendProcessTitle(s,m))),this._bufferer.startBuffering(s,n.onProcessData),o.add(n.onProcessExit(m=>this._onProcessExit(s,m))),n.onProcessOverrideDimensions&&o.add(n.onProcessOverrideDimensions(m=>this._proxy.$sendOverrideDimensions(s,m))),this._terminalProcesses.set(s,n);const v=this._extensionTerminalAwaitingStart[s];return v&&n instanceof b&&(n.startSendingEvents(v.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),o}$acceptProcessAckDataEvent(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.acknowledgeDataEvent(n)}$acceptProcessInput(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.input(n)}$acceptProcessResize(s,n,o){var v;try{(v=this._terminalProcesses.get(s))===null||v===void 0||v.resize(n,o)}catch(m){if(m.code!=="EPIPE"&&m.code!=="ERR_IPC_CHANNEL_CLOSED")throw m}}$acceptProcessShutdown(s,n){var o;(o=this._terminalProcesses.get(s))===null||o===void 0||o.shutdown(n)}$acceptProcessRequestInitialCwd(s){var n;(n=this._terminalProcesses.get(s))===null||n===void 0||n.getInitialCwd().then(o=>this._proxy.$sendProcessInitialCwd(s,o))}$acceptProcessRequestCwd(s){var n;(n=this._terminalProcesses.get(s))===null||n===void 0||n.getCwd().then(o=>this._proxy.$sendProcessCwd(s,o))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,n,o){if(this._profileProviders.has(n))throw new Error(`Terminal profile provider "${n}" already registered`);return this._profileProviders.set(n,o),this._proxy.$registerProfileProvider(n,s.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(n),this._proxy.$unregisterProfileProvider(n)})}async $createContributedProfileTerminal(s,n){var o;const v=new l.CancellationTokenSource().token,m=await((o=this._profileProviders.get(s))===null||o===void 0?void 0:o.provideTerminalProfile(v));if(!v.isCancellationRequested){if(!m||!("options"in m))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in m.options){this.createExtensionTerminal(m.options,{isSplitTerminal:n});return}this.createTerminalFromOptions(m.options,{isSplitTerminal:n})}}async $provideLinks(s,n){const o=this._getTerminalById(s);if(!o)return[];this._terminalLinkCache.delete(s);const v=this._terminalLinkCancellationSource.get(s);v&&v.dispose(!0);const m=new l.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,m);const E=[],y={terminal:o.value,line:n},a=[];for(const $ of this._linkProviders)a.push(new Promise(async Z=>{m.token.onCancellationRequested(()=>Z({provider:$,links:[]}));const le=await $.provideTerminalLinks(y,m.token)||[];m.token.isCancellationRequested||Z({provider:$,links:le})}));const T=await Promise.all(a);if(m.token.isCancellationRequested)return[];const O=new Map;for(const $ of T)$&&$.links.length>0&&E.push(...$.links.map(Z=>{const le={id:w++,startIndex:Z.startIndex,length:Z.length,label:Z.tooltip};return O.set(le.id,{provider:$.provider,link:Z}),le}));return this._terminalLinkCache.set(s,O),E}$activateLink(s,n){var o;const v=(o=this._terminalLinkCache.get(s))===null||o===void 0?void 0:o.get(n);!v||v.provider.handleTerminalLink(v.link)}_onProcessExit(s,n){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const o=this._terminalProcessDisposables[s];o&&(o.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,n)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,n){const o=this._getTerminalObjectIndexById(s,n);return o!==null?s[o]:null}_getTerminalObjectIndexById(s,n){let o=null;return s.some((v,m)=>v._id===n?(o=m,!0):!1),o}getEnvironmentVariableCollection(s){let n=this._environmentVariableCollections.get(s.identifier.value);return n||(n=new d,this._setEnvironmentVariableCollection(s.identifier.value,n)),n}_syncEnvironmentVariableCollection(s,n){const o=k.serializeEnvironmentVariableCollection(n.map);this._proxy.$setEnvironmentVariableCollection(s,n.persistent,o.length===0?void 0:o)}$initEnvironmentVariableCollections(s){s.forEach(n=>{const o=n[0],v=new d(n[1]);this._setEnvironmentVariableCollection(o,v)})}$acceptDefaultProfile(s,n){this._defaultProfile=s,this._defaultAutomationProfile=n}_setEnvironmentVariableCollection(s,n){this._environmentVariableCollections.set(s,n),n.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,n)})}};u=qe([We(1,A.IExtHostRpcService)],u),e.BaseExtHostTerminalService=u;class d{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new p.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,n){this._setIfDiffers(s,{value:n,type:_.EnvironmentVariableMutatorType.Replace})}append(s,n){this._setIfDiffers(s,{value:n,type:_.EnvironmentVariableMutatorType.Append})}prepend(s,n){this._setIfDiffers(s,{value:n,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,n){const o=this.map.get(s);(!o||o.value!==n.value||o.type!==n.type)&&(this.map.set(s,n),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,n){this.map.forEach((o,v)=>s.call(n,v,o,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=d;let g=class extends u{constructor(s){super(!1,s)}createTerminal(s,n,o){throw new r.NotSupportedError}createTerminalFromOptions(s,n){throw new r.NotSupportedError}};g=qe([We(0,A.IExtHostRpcService)],g),e.WorkerExtHostTerminalService=g;function t(i){if(!!i)return"id"in i?{id:i.id,color:i.color}:i}}),define(pe[239],ve([0,1,3,18,5,124,17,7]),function(X,e,p,R,C,S,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(r,k){this._extHostDocumentsAndEditors=k,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=r.getProxy(C.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(l=>this._onDidChangeVisibleTextEditors.fire(l)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(l=>this._onDidChangeActiveTextEditor.fire(l))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(r){const k=this._extHostDocumentsAndEditors.allEditors();return r?k:k.map(l=>l.value)}async showTextDocument(r,k,l){let h;typeof k=="number"?h={position:A.ViewColumn.from(k),preserveFocus:l}:typeof k=="object"?h={position:A.ViewColumn.from(k.viewColumn),preserveFocus:k.preserveFocus,selection:typeof k.selection=="object"?A.Range.from(k.selection):void 0,pinned:typeof k.preview=="boolean"?!k.preview:void 0}:h={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(r.uri,h),f=c&&this._extHostDocumentsAndEditors.getEditor(c);if(f)return f.value;throw c?new Error(`Could NOT open editor for "${r.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${r.uri.toString()}".`)}createTextEditorDecorationType(r,k){return new S.TextEditorDecorationType(this._proxy,r,k).value}$acceptEditorPropertiesChanged(r,k){const l=this._extHostDocumentsAndEditors.getEditor(r);if(!l)throw new Error("unknown text editor");if(k.options&&l._acceptOptions(k.options),k.selections){const h=k.selections.selections.map(A.Selection.to);l._acceptSelections(h)}if(k.visibleRanges){const h=R.coalesce(k.visibleRanges.map(A.Range.to));l._acceptVisibleRanges(h)}if(k.options&&this._onDidChangeTextEditorOptions.fire({textEditor:l.value,options:Object.assign(Object.assign({},k.options),{lineNumbers:A.TextEditorLineNumbersStyle.to(k.options.lineNumbers)})}),k.selections){const h=P.TextEditorSelectionChangeKind.fromValue(k.selections.source),c=k.selections.selections.map(A.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:l.value,selections:c,kind:h})}if(k.visibleRanges){const h=R.coalesce(k.visibleRanges.map(A.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:l.value,visibleRanges:h})}}$acceptEditorPositionData(r){for(const k in r){const l=this._extHostDocumentsAndEditors.getEditor(k);if(!l)throw new Error("Unknown text editor");const h=A.ViewColumn.to(r[k]);l.value.viewColumn!==h&&(l._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:l.value,viewColumn:h}))}}getDiffInformation(r){return Promise.resolve(this._proxy.$getDiffInformation(r))}}e.ExtHostEditors=_});var Dn=this&&this.__rest||function(X,e){var p={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(p[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(X);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(X,R[C])&&(p[R[C]]=X[R[C]]);return p};define(pe[240],ve([0,1,2,4,5,6,7]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=R.createDecorator("IExtHostTimeline");class P{constructor(r,k){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=r.getProxy(C.MainContext.MainThreadTimeline),k.registerArgumentProcessor({processArgument:l=>{var h,c;if(l&&l.$mid===11){const f=l.uri===void 0?void 0:p.URI.revive(l.uri);return(c=(h=this._itemsBySourceAndUriMap.get(l.source))===null||h===void 0?void 0:h.get(_(f)))===null||c===void 0?void 0:c.get(l.handle)}return l}})}async $getTimeline(r,k,l,h,c){const f=this._providers.get(r);return f==null?void 0:f.provideTimeline(p.URI.revive(k),l,h,c)}registerTimelineProvider(r,k,l,h){const c=new S.DisposableStore,f=this.convertTimelineItem(k.id,h,c).bind(this);let I;k.onDidChange&&(I=k.onDidChange(w=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},w),{id:k.id})),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},k),{scheme:r,onDidChange:void 0,async provideTimeline(w,u,d,g){var t;(g==null?void 0:g.resetCache)&&(c.clear(),(t=b.get(k.id))===null||t===void 0||t.clear());const i=await k.provideTimeline(w,u,d);if(i==null)return;const s=f(w,g);return Object.assign(Object.assign({},i),{source:k.id,items:i.items.map(s)})},dispose(){var w;for(const u of b.values())(w=u.get(k.id))===null||w===void 0||w.clear();I==null||I.dispose(),c.dispose()}}))}convertTimelineItem(r,k,l){return(h,c)=>{let f;if(c==null?void 0:c.cacheResults){let I=this._itemsBySourceAndUriMap.get(r);I===void 0&&(I=new Map,this._itemsBySourceAndUriMap.set(r,I));const b=_(h);f=I.get(b),f===void 0&&(f=new Map,I.set(b,f))}return I=>{var b,w;const{iconPath:u}=I,d=Dn(I,["iconPath"]),g=`${r}|${(b=I.id)!==null&&b!==void 0?b:I.timestamp}`;f==null||f.set(g,I);let t,i,s;return I.iconPath&&(u instanceof A.ThemeIcon?s={id:u.id}:p.URI.isUri(u)?(t=u,i=u):{light:t,dark:i}=u),Object.assign(Object.assign({},d),{id:(w=d.id)!==null&&w!==void 0?w:void 0,handle:g,source:r,command:I.command?k.toInternal(I.command,l):void 0,icon:t,iconDark:i,themeIcon:s,accessibilityInformation:I.accessibilityInformation})}}}registerTimelineProviderCore(r){if(this._providers.get(r.id))throw new Error(`Timeline Provider ${r.id} already exists.`);return this._proxy.$registerTimelineProvider({id:r.id,label:r.label,scheme:r.scheme}),this._providers.set(r.id,r),S.toDisposable(()=>{var l;for(const h of this._itemsBySourceAndUriMap.values())(l=h.get(r.id))===null||l===void 0||l.clear();this._providers.delete(r.id),this._proxy.$unregisterTimelineProvider(r.id),r.dispose()})}}e.ExtHostTimeline=P;function _(D){return D==null?void 0:D.toString()}}),define(pe[241],ve([0,1,6,10,2,5]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(_){this._openers=new Map,this._proxy=_.getProxy(S.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,D,r,k){if(this._openers.has(D))throw new Error(`Opener with id '${D}' already registered`);const l=k.schemes.find(h=>!A.supportedSchemes.has(h));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this._openers.set(D,r),this._proxy.$registerUriOpener(D,k.schemes,_,k.label),p.toDisposable(()=>{this._openers.delete(D),this._proxy.$unregisterUriOpener(D)})}async $canOpenUri(_,D,r){const k=this._openers.get(_);if(!k)throw new Error(`Unknown opener with id: ${_}`);const l=C.URI.revive(D);return k.canOpenExternalUri(l,r)}async $openUri(_,D,r){const k=this._openers.get(_);if(!k)throw new Error(`Unknown opener id: '${_}'`);return k.openExternalUri(C.URI.revive(D.resolvedUri),{sourceUri:C.URI.revive(D.sourceUri)},r)}}e.ExtHostUriOpeners=A,A.supportedSchemes=new Set([R.Schemas.http,R.Schemas.https])}),define(pe[242],ve([0,1,5,2,6,14,26]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(D){this.handles=new Set,this.handlers=new Map,this._proxy=D.getProxy(p.MainContext.MainThreadUrls)}registerUriHandler(D,r){if(this.handles.has(A.ExtensionIdentifier.toKey(D)))throw new Error(`Protocol handler already registered for extension ${D}`);const k=P.HandlePool++;return this.handles.add(A.ExtensionIdentifier.toKey(D)),this.handlers.set(k,r),this._proxy.$registerUriHandler(k,D),C.toDisposable(()=>{this.handles.delete(A.ExtensionIdentifier.toKey(D)),this.handlers.delete(k),this._proxy.$unregisterUriHandler(k)})}$handleExternalUri(D,r){const k=this.handlers.get(D);if(!k)return Promise.resolve(void 0);try{k.handleUri(R.URI.revive(r))}catch(l){S.onUnexpectedError(l)}return Promise.resolve(void 0)}async createAppUri(D){return R.URI.revive(await this._proxy.$createAppUri(D))}}e.ExtHostUrls=P,P.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(pe[63],ve([0,1,3,2,172,196,84,5]),function(X,e,p,R,C,S,A,P){"use strict";var _,D,r,k,l,h,c,f,I,b,w,u;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class d{constructor(m,E,y,a,T,O,$){_.set(this,void 0),D.set(this,void 0),r.set(this,void 0),k.set(this,void 0),l.set(this,void 0),h.set(this,void 0),c.set(this,""),f.set(this,void 0),I.set(this,!1),b.set(this,!1),w.set(this,!1),this._onMessageEmitter=new p.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,u.set(this,new p.Emitter),this._onDidDispose=$e(this,u,"f").event,it(this,_,m,"f"),it(this,D,E,"f"),it(this,f,y,"f"),it(this,k,a,"f"),it(this,l,T,"f"),it(this,h,O,"f"),it(this,w,g(O),"f"),it(this,r,$,"f")}dispose(){it(this,I,!0,"f"),$e(this,u,"f").fire(),$e(this,u,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return it(this,b,!0,"f"),A.asWebviewUri(m,$e(this,k,"f").remote)}get cspSource(){return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),$e(this,c,"f")}set html(m){this.assertNotDisposed(),$e(this,c,"f")!==m&&(it(this,c,m,"f"),!$e(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(it(this,b,!0,"f"),$e(this,r,"f").report("Webview vscode-resource: uris",$e(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),$e(this,D,"f").$setHtml($e(this,_,"f"),m))}get options(){return this.assertNotDisposed(),$e(this,f,"f")}set options(m){this.assertNotDisposed(),$e(this,D,"f").$setOptions($e(this,_,"f"),s($e(this,h,"f"),$e(this,l,"f"),m)),it(this,f,m,"f")}async postMessage(m){if($e(this,I,"f"))return!1;const E=S.serializeWebviewMessage(m,{serializeBuffersForPostMessage:$e(this,w,"f")});return $e(this,D,"f").$postMessage($e(this,_,"f"),E.message,...E.buffers)}assertNotDisposed(){if($e(this,I,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=d,_=new WeakMap,D=new WeakMap,r=new WeakMap,k=new WeakMap,l=new WeakMap,h=new WeakMap,c=new WeakMap,f=new WeakMap,I=new WeakMap,b=new WeakMap,w=new WeakMap,u=new WeakMap;function g(v){try{const m=C.normalizeVersion(C.parseVersion(v.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch(m){return!1}}e.shouldSerializeBuffersForPostMessage=g;class t{constructor(m,E,y,a,T){this.initData=E,this.workspace=y,this._logService=a,this._deprecationService=T,this._webviews=new Map,this._webviewProxy=m.getProxy(P.MainContext.MainThreadWebviews)}$onMessage(m,E,...y){const a=this.getWebview(m);if(a){const{message:T}=S.deserializeWebviewMessage(E,y);a._onMessageEmitter.fire(T)}}$onMissingCsp(m,E){this._logService.warn(`${E} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,E,y){const a=new d(m,this._webviewProxy,n(E),this.initData,this.workspace,y,this._deprecationService);return this._webviews.set(m,a),a._onDidDispose(()=>{this._webviews.delete(m)}),a}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=t;function i(v){return{id:v.identifier,location:v.extensionLocation}}e.toExtensionData=i;function s(v,m,E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots||o(v,m)}}e.serializeWebviewOptions=s;function n(v){var m;return{enableCommandUris:v.enableCommandUris,enableScripts:v.enableScripts,portMapping:v.portMapping,localResourceRoots:(m=v.localResourceRoots)===null||m===void 0?void 0:m.map(E=>R.URI.from(E))}}e.reviveOptions=n;function o(v,m){return[...((m==null?void 0:m.getWorkspaceFolders())||[]).map(E=>E.uri),v.extensionLocation]}}),define(pe[243],ve([0,1,21,73,6,10,24,2,17,63,82,5,7]),function(X,e,p,R,C,S,A,P,_,D,r,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,i){this.document=t,this._storagePath=i,this._backupCounter=1,this._edits=new r.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,i){await this.getEdit(t).undo(),i||this.disposeBackup()}async redo(t,i){await this.getEdit(t).redo(),i||this.disposeBackup()}disposeEdits(t){for(const i of t)this._edits.delete(i)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=d(this.document.uri)+this._backupCounter++;return A.joinPath(this._storagePath,t)}updateBackup(t){var i;(i=this._backup)===null||i===void 0||i.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const i=this._edits.get(t,0);if(!i)throw new Error("No edit found");return i}}class c{constructor(){this._documents=new Map}get(t,i){return this._documents.get(this.key(t,i))}add(t,i,s){const n=this.key(t,i.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${t} resource:${i.uri}`);const o=new h(i,s);return this._documents.set(n,o),o}delete(t,i){const s=this.key(t,i.uri);this._documents.delete(s)}key(t,i){return`${t}@@@${i}`}}var f;(function(g){g[g.Text=0]="Text",g[g.Custom=1]="Custom"})(f||(f={}));class I{constructor(){this._providers=new Map}addTextProvider(t,i,s){return this.add(0,t,i,s)}addCustomProvider(t,i,s){return this.add(1,t,i,s)}get(t){return this._providers.get(t)}add(t,i,s,n){if(this._providers.has(i))throw new Error(`Provider for viewType:${i} already registered`);return this._providers.set(i,{type:t,extension:s,provider:n}),new l.Disposable(()=>this._providers.delete(i))}}class b{constructor(t,i,s,n,o){this._extHostDocuments=i,this._extensionStoragePaths=s,this._extHostWebview=n,this._extHostWebviewPanels=o,this._editorProviders=new I,this._documents=new c,this._proxy=t.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,i,s,n){const o=new C.DisposableStore;return w(s)?(o.add(this._editorProviders.addTextProvider(i,t,s)),this._proxy.$registerTextEditorProvider(D.toExtensionData(t),i,n.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},D.shouldSerializeBuffersForPostMessage(t))):(o.add(this._editorProviders.addCustomProvider(i,t,s)),this.supportEditing(s)&&o.add(s.onDidChangeCustomDocument(v=>{const m=this.getCustomDocumentEntry(i,v.document.uri);if(u(v)){const E=m.addEdit(v);this._proxy.$onDidEdit(v.document.uri,i,E,v.label)}else this._proxy.$onContentChange(v.document.uri,i)})),this._proxy.$registerCustomEditorProvider(D.toExtensionData(t),i,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument,D.shouldSerializeBuffersForPostMessage(t))),l.Disposable.from(o,new l.Disposable(()=>{this._proxy.$unregisterEditorProvider(i)}))}async $createCustomDocument(t,i,s,n,o){var v;const m=this._editorProviders.get(i);if(!m)throw new Error(`No provider found for '${i}'`);if(m.type!==1)throw new Error(`Invalid provide type for '${i}'`);const E=P.URI.revive(t),y=await m.provider.openCustomDocument(E,{backupId:s,untitledDocumentData:n==null?void 0:n.buffer},o);let a;return this.supportEditing(m.provider)&&this._extensionStoragePaths&&(a=(v=this._extensionStoragePaths.workspaceValue(m.extension))!==null&&v!==void 0?v:this._extensionStoragePaths.globalValue(m.extension)),this._documents.add(i,y,a),{editable:this.supportEditing(m.provider)}}async $disposeCustomDocument(t,i){const s=this._editorProviders.get(i);if(!s)throw new Error(`No provider found for '${i}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${i}'`);const n=P.URI.revive(t),{document:o}=this.getCustomDocumentEntry(i,n);this._documents.delete(i,o),o.dispose()}async $resolveWebviewEditor(t,i,s,n,o,v){const m=this._editorProviders.get(s);if(!m)throw new Error(`No provider found for '${s}'`);const E=_.ViewColumn.to(o),y=this._extHostWebview.createNewWebview(i,n.webviewOptions,m.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(i,s,n.title,E,n.panelOptions,y),T=P.URI.revive(t);switch(m.type){case 1:{const{document:O}=this.getCustomDocumentEntry(s,T);return m.provider.resolveCustomEditor(O,a,v)}case 0:{const O=this._extHostDocuments.getDocument(T);return m.provider.resolveCustomTextEditor(O,a,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,i,s){this.getCustomDocumentEntry(i,t).disposeEdits(s)}async $onMoveCustomEditor(t,i,s){const n=this._editorProviders.get(s);if(!n)throw new Error(`No provider found for '${s}'`);if(!n.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const o=this._extHostWebviewPanels.getWebviewPanel(t);if(!o)throw new Error("No webview found");const v=P.URI.revive(i),m=this._extHostDocuments.getDocument(v);await n.provider.moveCustomTextEditor(m,o,p.CancellationToken.None)}async $undo(t,i,s,n){return this.getCustomDocumentEntry(i,t).undo(s,n)}async $redo(t,i,s,n){return this.getCustomDocumentEntry(i,t).redo(s,n)}async $revert(t,i,s){const n=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).revertCustomDocument(n.document,s),n.disposeBackup()}async $onSave(t,i,s){const n=this.getCustomDocumentEntry(i,t);await this.getCustomEditorProvider(i).saveCustomDocument(n.document,s),n.disposeBackup()}async $onSaveAs(t,i,s,n){const o=this.getCustomDocumentEntry(i,t);return this.getCustomEditorProvider(i).saveCustomDocumentAs(o.document,P.URI.revive(s),n)}async $backup(t,i,s){const n=this.getCustomDocumentEntry(i,t),v=await this.getCustomEditorProvider(i).backupCustomDocument(n.document,{destination:n.getNewBackupUri()},s);return n.updateBackup(v),v.id}getCustomDocumentEntry(t,i){const s=this._documents.get(t,P.URI.revive(i));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const i=this._editorProviders.get(t),s=i==null?void 0:i.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function w(g){return typeof g.resolveCustomTextEditor=="function"}function u(g){return typeof g.undo=="function"&&typeof g.redo=="function"}function d(g){const t=g.scheme===S.Schemas.file||g.scheme===S.Schemas.untitled?g.fsPath:g.toString();return R.hash(t)+""}});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(pe[244],ve([0,1,3,6,2,32,17,63,5,7]),function(X,e,p,R,C,S,A,P,_,D){"use strict";var r,k,l,h,c,f,I,b,w,u,d,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class i extends R.Disposable{constructor(v,m,E,y,a,T,O){super();r.set(this,void 0),k.set(this,void 0),l.set(this,void 0),h.set(this,void 0),c.set(this,void 0),f.set(this,void 0),I.set(this,void 0),b.set(this,void 0),w.set(this,!0),u.set(this,!0),d.set(this,!1),g.set(this,this._register(new p.Emitter)),this.onDidDispose=$e(this,g,"f").event,t.set(this,this._register(new p.Emitter)),this.onDidChangeViewState=$e(this,t,"f").event,it(this,r,v,"f"),it(this,k,m,"f"),it(this,l,E,"f"),it(this,c,T,"f"),it(this,b,a,"f"),it(this,f,y,"f"),it(this,h,O,"f")}dispose(){$e(this,d,"f")||(it(this,d,!0,"f"),$e(this,g,"f").fire(),$e(this,k,"f").$disposeWebview($e(this,r,"f")),$e(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),$e(this,h,"f")}get viewType(){return this.assertNotDisposed(),$e(this,l,"f")}get title(){return this.assertNotDisposed(),$e(this,f,"f")}set title(v){this.assertNotDisposed(),$e(this,f,"f")!==v&&(it(this,f,v,"f"),$e(this,k,"f").$setTitle($e(this,r,"f"),v))}get iconPath(){return this.assertNotDisposed(),$e(this,I,"f")}set iconPath(v){this.assertNotDisposed(),$e(this,I,"f")!==v&&(it(this,I,v,"f"),$e(this,k,"f").$setIconPath($e(this,r,"f"),C.URI.isUri(v)?{light:v,dark:v}:v))}get options(){return $e(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof $e(this,b,"f")=="number"&&$e(this,b,"f")<0))return $e(this,b,"f")}get active(){return this.assertNotDisposed(),$e(this,u,"f")}get visible(){return this.assertNotDisposed(),$e(this,w,"f")}_updateViewState(v){$e(this,d,"f")||(this.active!==v.active||this.visible!==v.visible||this.viewColumn!==v.viewColumn)&&(it(this,u,v.active,"f"),it(this,w,v.visible,"f"),it(this,b,v.viewColumn,"f"),$e(this,t,"f").fire({webviewPanel:this}))}reveal(v,m){this.assertNotDisposed(),$e(this,k,"f").$reveal($e(this,r,"f"),{viewColumn:v?A.ViewColumn.from(v):void 0,preserveFocus:!!m})}assertNotDisposed(){if($e(this,d,"f"))throw new Error("Webview is disposed")}}r=new WeakMap,k=new WeakMap,l=new WeakMap,h=new WeakMap,c=new WeakMap,f=new WeakMap,I=new WeakMap,b=new WeakMap,w=new WeakMap,u=new WeakMap,d=new WeakMap,g=new WeakMap,t=new WeakMap;class s{constructor(v,m,E){this.webviews=m,this.workspace=E,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=v.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return S.generateUuid()}createWebviewPanel(v,m,E,y,a={}){const T=typeof y=="object"?y.viewColumn:y,O={viewColumn:A.ViewColumn.from(T),preserveFocus:typeof y=="object"&&!!y.preserveFocus},$=P.shouldSerializeBuffersForPostMessage(v),Z=s.newHandle();this._proxy.$createWebviewPanel(P.toExtensionData(v),Z,m,{title:E,panelOptions:n(a),webviewOptions:P.serializeWebviewOptions(v,this.workspace,a),serializeBuffersForPostMessage:$},O);const le=this.webviews.createNewWebview(Z,a,v);return this.createNewWebviewPanel(Z,m,E,T,a,le)}$onDidChangeWebviewPanelViewStates(v){const m=Object.keys(v);m.sort((E,y)=>{const a=v[E],T=v[y];return a.active?1:T.active?-1:+a.visible-+T.visible});for(const E of m){const y=this.getWebviewPanel(E);if(!y)continue;const a=v[E];y._updateViewState({active:a.active,visible:a.visible,viewColumn:A.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(v){const m=this.getWebviewPanel(v);m==null||m.dispose(),this._webviewPanels.delete(v),this.webviews.deleteWebview(v)}registerWebviewPanelSerializer(v,m,E){if(this._serializers.has(m))throw new Error(`Serializer for '${m}' already registered`);return this._serializers.set(m,{serializer:E,extension:v}),this._proxy.$registerSerializer(m,{serializeBuffersForPostMessage:P.shouldSerializeBuffersForPostMessage(v)}),new D.Disposable(()=>{this._serializers.delete(m),this._proxy.$unregisterSerializer(m)})}async $deserializeWebviewPanel(v,m,E,y){const a=this._serializers.get(m);if(!a)throw new Error(`No serializer found for '${m}'`);const{serializer:T,extension:O}=a,$=this.webviews.createNewWebview(v,E.webviewOptions,O),Z=this.createNewWebviewPanel(v,m,E.title,y,E.panelOptions,$);await T.deserializeWebviewPanel(Z,E.state)}createNewWebviewPanel(v,m,E,y,a,T){const O=new i(v,this._proxy,m,E,y,a,T);return this._webviewPanels.set(v,O),O}getWebviewPanel(v){return this._webviewPanels.get(v)}}e.ExtHostWebviewPanels=s;function n(o){return{enableFindWidget:o.enableFindWidget,retainContextWhenHidden:o.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(pe[245],ve([0,1,3,6,63,5,7]),function(X,e,p,R,C,S,A){"use strict";var P,_,D,r,k,l,h,c,f,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends R.Disposable{constructor(d,g,t,i,s,n){super();P.set(this,void 0),_.set(this,void 0),D.set(this,void 0),r.set(this,void 0),k.set(this,!1),l.set(this,void 0),h.set(this,void 0),c.set(this,void 0),f.set(this,this._register(new p.Emitter)),this.onDidChangeVisibility=$e(this,f,"f").event,I.set(this,this._register(new p.Emitter)),this.onDidDispose=$e(this,I,"f").event,it(this,D,t,"f"),it(this,h,i,"f"),it(this,P,d,"f"),it(this,_,g,"f"),it(this,r,s,"f"),it(this,l,n,"f")}dispose(){$e(this,k,"f")||(it(this,k,!0,"f"),$e(this,I,"f").fire(),$e(this,r,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),$e(this,h,"f")}set title(d){this.assertNotDisposed(),$e(this,h,"f")!==d&&(it(this,h,d,"f"),$e(this,_,"f").$setWebviewViewTitle($e(this,P,"f"),d))}get description(){return this.assertNotDisposed(),$e(this,c,"f")}set description(d){this.assertNotDisposed(),$e(this,c,"f")!==d&&(it(this,c,d,"f"),$e(this,_,"f").$setWebviewViewDescription($e(this,P,"f"),d))}get visible(){return $e(this,l,"f")}get webview(){return $e(this,r,"f")}get viewType(){return $e(this,D,"f")}_setVisible(d){d===$e(this,l,"f")||$e(this,k,"f")||(it(this,l,d,"f"),$e(this,f,"f").fire())}show(d){this.assertNotDisposed(),$e(this,_,"f").$show($e(this,P,"f"),!!d)}assertNotDisposed(){if($e(this,k,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,_=new WeakMap,D=new WeakMap,r=new WeakMap,k=new WeakMap,l=new WeakMap,h=new WeakMap,c=new WeakMap,f=new WeakMap,I=new WeakMap;class w{constructor(d,g){this._extHostWebview=g,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=d.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(d,g,t,i){if(this._viewProviders.has(g))throw new Error(`View provider for '${g}' already registered`);return this._viewProviders.set(g,{provider:t,extension:d}),this._proxy.$registerWebviewViewProvider(C.toExtensionData(d),g,{retainContextWhenHidden:i==null?void 0:i.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new A.Disposable(()=>{this._viewProviders.delete(g),this._proxy.$unregisterWebviewViewProvider(g)})}async $resolveWebviewView(d,g,t,i,s){const n=this._viewProviders.get(g);if(!n)throw new Error(`No view provider found for '${g}'`);const{provider:o,extension:v}=n,m=this._extHostWebview.createNewWebview(d,{},v),E=new b(d,this._proxy,g,t,m,!0);this._webviewViews.set(d,E),await o.resolveWebviewView(E,{state:i},s)}async $onDidChangeWebviewViewVisibility(d,g){this.getWebviewView(d)._setVisible(g)}async $disposeWebviewView(d){const g=this.getWebviewView(d);this._webviewViews.delete(d),g.dispose(),this._extHostWebview.deleteWebview(d)}getWebviewView(d){const g=this._webviewViews.get(d);if(!g)throw new Error("No webview found");return g}}e.ExtHostWebviewViews=w}),define(pe[127],ve([0,1,3,5,2,10,8,4,13]),function(X,e,p,R,C,S,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let D=class xn{constructor(k){this._onDidChangeWindowState=new p.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=k.getProxy(R.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(l=>this.$onDidChangeWindowFocus(l))}get state(){return this._state}$onDidChangeWindowFocus(k){k!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:k}),this._onDidChangeWindowState.fire(this._state))}openUri(k,l){let h;if(typeof k=="string"){h=k;try{k=C.URI.parse(k)}catch(c){return Promise.reject(`Invalid uri - '${k}'`)}}return A.isFalsyOrWhitespace(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===S.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this._proxy.$openUri(k,h,l)}async asExternalUri(k,l){if(A.isFalsyOrWhitespace(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(k,l);return C.URI.from(h)}};D.InitialState={focused:!0},D=qe([We(0,_.IExtHostRpcService)],D),e.ExtHostWindow=D,e.IExtHostWindow=P.createDecorator("IExtHostWindow")}),define(pe[246],ve([0,1,9,101,32,48,6,5,2,13]),function(X,e,p,R,C,S,A,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let r=class extends A.Disposable{constructor(l,h){super();const c=l.getProxy(P.MainContext.MainThreadDownloadService);h.registerCommand(!1,"_workbench.downloadResource",async f=>{const I=_.URI.file(p.join(R.tmpdir(),C.generateUuid()));return await c.$download(f,I),I})}};r=qe([We(0,D.IExtHostRpcService),We(1,S.IExtHostCommands)],r),e.ExtHostDownloadService=r}),define(pe[247],ve([0,1,2,9,146,28,62,27,13,6,12,113,42]),function(X,e,p,R,C,S,A,P,_,D,r,k,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostOutputService2=void 0;class h{constructor(b,w,u){this.name=b,this.file=w,this.appender=u}static async create(b,w){const u=await k.createRotatingLogger(b,w,30*l.ByteSize.MB,1);return u.clearFormatters(),new h(b,w,u)}append(b){this.appender.critical(b)}flush(){this.appender.flush()}}class c extends A.AbstractExtHostOutputChannel{constructor(b,w,u){super(b,!1,p.URI.file(w.file),u);this._appender=w}append(b){super.append(b),this._appender.append(b),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(b,w){this._appender.flush(),super.show(b,w)}clear(){this._appender.flush(),super.clear()}}let f=class extends A.ExtHostOutputService{constructor(b,w,u){super(b);this.logService=w,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new D.MutableDisposable,this._logsLocation=u.logsLocation}$setVisibleChannel(b){if(b){const w=this._channels.get(b);w&&(this._visibleChannelDisposable.value=w.onDidAppend(()=>w.update()))}}createOutputChannel(b){if(b=b.trim(),!b)throw new Error("illegal argument `name`. must not be falsy");const w=this._doCreateOutChannel(b);return w.then(u=>u._id.then(d=>this._channels.set(d,u))),new A.LazyOutputChannel(b,w)}async _doCreateOutChannel(b){try{const w=R.join(this._logsLocation.fsPath,`output_logging_${C.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`);await S.SymlinkSupport.existsDirectory(w)||await S.Promises.mkdir(w,{recursive:!0});const d=`${this._namePool++}-${b.replace(/[\\/:\*\?"<>\|]/g,"")}`,g=p.URI.file(R.join(w,`${d}.log`)),t=await h.create(d,g.fsPath);return new c(b,t,this._proxy)}catch(w){return this.logService.error(w),new A.ExtHostPushOutputChannel(b,this._proxy)}}};f=qe([We(0,_.IExtHostRpcService),We(1,r.ILogService),We(2,P.IExtHostInitDataService)],f),e.ExtHostOutputService2=f}),define(pe[248],ve([0,1,32,13,33]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let S=class extends C.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,_,D){return this.createTerminalFromOptions({name:P,shellPath:_,shellArgs:D})}createTerminalFromOptions(P,_){const D=new C.ExtHostTerminal(this._proxy,p.generateUuid(),P,P.name);return this._terminals.push(D),D.create(P,_),D.value}};S=qe([We(0,R.IExtHostRpcService)],S),e.ExtHostTerminalService=S}),define(pe[249],ve([0,1,5,13,6,27,2,38,24,28,7,11,47,3,187,72,12]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class b{constructor(m,E,y){this.remoteAddress=m,this.localAddress=E,this._dispose=y,this._onDispose=new h.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}function w(v){const m=v.trim().split(`
`),E=[];return m.forEach(a=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(a);T&&T.length>=3&&E.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),E.reduce((a,T)=>(a[T.socket]=T,a),{})}e.getSockets=w;function u(...v){const m=[].concat(...v.map(g));return[...new Map(m.filter(E=>E.st==="0A").map(E=>{const y=E.local_address.split(":");return{socket:parseInt(E.inode,10),ip:d(y[0]),port:parseInt(y[1],16)}}).map(E=>[E.ip+":"+E.port,E])).values()]}e.loadListeningPorts=u;function d(v){let m="";if(v.length===8)for(let E=v.length-2;E>=0;E-=2)m+=parseInt(v.substr(E,2),16),E!==0&&(m+=".");else for(let E=v.length-4;E>=0;E-=4)m+=parseInt(v.substr(E,4),16).toString(16),E!==0&&(m+=":");return m}e.parseIpAddress=d;function g(v){const m=v.trim().split(`
`),E=m.shift().trim().split(/\s+/).filter(a=>a!=="rx_queue"&&a!=="tm->when");return m.map(a=>a.trim().split(/\s+/).reduce((T,O,$)=>(T[E[$]||$]=O,T),{}))}e.loadConnectionTable=g;function t(v){return!!v.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||v.indexOf("out/vs/server/main.js")!==-1||v.indexOf("_productName=VSCode")!==-1}function i(v){const m=v.trim().split(`
`),E=[];return m.forEach(y=>{const a=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(y);a&&a.length>=4&&E.push({pid:parseInt(a[1],10),ppid:parseInt(a[2]),cmd:a[3]})}),E}e.getRootProcesses=i;async function s(v,m,E){const y=E.reduce((T,O)=>(T[O.pid]=O,T),{}),a=[];return v.forEach(({socket:T,ip:O,port:$})=>{var Z;const le=m[T]?m[T].pid:void 0,q=le?(Z=y[le])===null||Z===void 0?void 0:Z.cmd:void 0;le&&q&&!t(q)&&a.push({host:O,port:$,detail:q,pid:le})}),a}e.findPorts=s;function n(v,m,E){const y=new Map,a=i(m);for(const T of v){const O=E.get(T.port);if(O){y.set(T.port,O);continue}const $=a.find(Z=>Z.cmd.includes(`${T.port}`));if($){let Z=$,le;do le=a.find(q=>q.ppid===Z.pid),le&&(Z=le);while(le);y.set(T.port,{host:T.ip,port:T.port,pid:Z.pid,detail:Z.cmd,ppid:Z.ppid})}else y.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return y}e.tryFindRootPorts=n;let o=class extends C.Disposable{constructor(m,E,y){super();this.logService=y,this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new h.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._candidateFindingEnabled=!1,this._foundRootPorts=new Map,this._providerHandleCounter=0,this._portAttributesProviders=new Map,this._proxy=m.getProxy(p.MainContext.MainThreadTunnelService),k.isLinux&&E.remote.isRemote&&E.remote.authority&&this._proxy.$setRemoteTunnelService(process.pid)}async openTunnel(m,E){this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) ${m.identifier.value} called openTunnel API for ${E.remoteAddress.host}:${E.remoteAddress.port}.`);const y=await this._proxy.$openTunnel(E,m.displayName);if(y){const a=new b(y.remoteAddress,y.localAddress,()=>this._proxy.$closeTunnel(y.remoteAddress));return this._register(a),a}}async getTunnels(){return this._proxy.$getTunnels()}calculateDelay(m){return Math.max(m*20,2e3)}nextPortAttributesProviderHandle(){return this._providerHandleCounter++}registerPortsAttributesProvider(m,E){const y=this.nextPortAttributesProviderHandle();return this._portAttributesProviders.set(y,{selector:m,provider:E}),this._proxy.$registerPortsAttributesProvider(m,y),new r.Disposable(()=>{this._portAttributesProviders.delete(y),this._proxy.$unregisterPortsAttributesProvider(y)})}async $providePortAttributes(m,E,y,a,T){const O=[];for(const Z of m){const le=this._portAttributesProviders.get(Z);if(!le)return[];O.push(...await Promise.all(E.map(async q=>le.provider.providePortAttributes(q,y,a,T))))}const $=O.filter(Z=>!!Z);return $.length>0?$.map(Z=>({autoForwardAction:Z.autoForwardAction,port:Z.port})):[]}async $registerCandidateFinder(m){if(m&&this._candidateFindingEnabled)return;this._candidateFindingEnabled=m;let E=new f.MovingAverage,y;for(;this._candidateFindingEnabled;){const a=new Date().getTime(),T=(await this.findCandidatePorts()).filter($=>c.isLocalhost($.host)||c.isAllInterfaces($.host));this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${T.map($=>$.port).join(", ")}`);const O=new Date().getTime()-a;E.update(O),(!y||JSON.stringify(y)!==JSON.stringify(T))&&(y=T,await this._proxy.$onFoundNewCandidates(y)),await new Promise($=>setTimeout(()=>$(),this.calculateDelay(E.value)))}}async setTunnelExtensionFunctions(m){var E;return m?(m.candidatePortSource!==void 0&&this._proxy.$setCandidatePortSource(m.candidatePortSource),m.showCandidatePort&&(this._showCandidatePort=m.showCandidatePort,this._proxy.$setCandidateFilter()),m.tunnelFactory&&(this._forwardPortProvider=m.tunnelFactory,this._proxy.$setTunnelProvider((E=m.tunnelFeatures)!==null&&E!==void 0?E:{elevation:!1,public:!1}))):this._forwardPortProvider=void 0,C.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(m,E){if(this._extensionTunnels.has(m.host)){const y=this._extensionTunnels.get(m.host);y.has(m.port)&&(E&&y.get(m.port).disposeListener.dispose(),await y.get(m.port).tunnel.dispose(),y.delete(m.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}async $forwardPort(m,E){if(this._forwardPortProvider)try{this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const y=this._forwardPortProvider(m,E);if(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),y!==void 0){const a=await y;this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this._extensionTunnels.has(m.remoteAddress.host)||this._extensionTunnels.set(m.remoteAddress.host,new Map);const T=this._register(a.onDidDispose(()=>(this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this._proxy.$closeTunnel(a.remoteAddress))));return this._extensionTunnels.get(m.remoteAddress.host).set(m.remoteAddress.port,{tunnel:a,disposeListener:T}),l.TunnelDto.fromApiTunnel(a)}else this.logService.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(y){this.logService.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(m){const E=await Promise.all(m.map(a=>{var T;return this._showCandidatePort(a.host,a.port,(T=a.detail)!==null&&T!==void 0?T:"")})),y=m.filter((a,T)=>E[T]);return this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${m.map(a=>a.port).join(", ")} to ${y.map(a=>a.port).join(", ")}`),y}async findCandidatePorts(){let m="",E="";try{m=await D.Promises.readFile("/proc/net/tcp","utf8"),E=await D.Promises.readFile("/proc/net/tcp6","utf8")}catch(H){}const y=u(m,E),a=await new Promise(H=>{P.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(N,z,F)=>{H(z)})}),T=w(a),O=await D.Promises.readdir("/proc"),$=[];for(let H of O)try{const N=Number(H),z=_.joinPath(A.URI.file("/proc"),H);if((await D.Promises.stat(z.fsPath)).isDirectory()&&!isNaN(N)){const M=await D.Promises.readlink(_.joinPath(z,"cwd").fsPath),L=await D.Promises.readFile(_.joinPath(z,"cmdline").fsPath,"utf8");$.push({pid:N,cwd:M,cmd:L})}}catch(N){}const Z=[],le=y.filter(H=>{const N=T[H.socket];return N||Z.push(H),N}),q=s(le,T,$);let x;if(this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${Z.length}`),Z.length>0){const H=await new Promise(N=>{P.exec("ps -F -A -l | grep root",(z,F,M)=>{N(F)})});this._foundRootPorts=n(Z,H,this._foundRootPorts),x=Array.from(this._foundRootPorts.values()),this.logService.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${x.join(", ")}`)}return q.then(H=>x?H.concat(x):H)}};o=qe([We(0,R.IExtHostRpcService),We(1,S.IExtHostInitDataService),We(2,I.ILogService)],o),e.ExtHostTunnelService=o}),define(pe[250],ve([0,1,16,21,14,3,6,99,217,125,22]),function(X,e,p,R,C,S,A,P,_,D,r){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function l(n,o){try{return JSON.stringify(n,o)}catch(v){return"null"}}function h(n,o){return JSON.stringify(n,o)}function c(n){return n?(o,v)=>v&&v.$mid===1?n.transformOutgoing(v):v:null}var f;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(f=e.RequestInitiator||(e.RequestInitiator={}));var I;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(I=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},w=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class d extends A.Disposable{constructor(o,v=null,m=null){super();this[k]=!0,this._onDidChangeResponsiveState=this._register(new S.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=o,this._logger=v,this._uriTransformer=m,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let E=0,y=D.ProxyIdentifier.count;E<y;E++)this._locals[E]=null,this._proxies[E]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new p.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(E=>this._receiveOneMessage(E))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(o=>{this._pendingRPCReplies[o].resolveErr(C.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(o){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(o){this._unresponsiveTime=Date.now()+d.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(o){this._responsiveState!==o&&(this._responsiveState=o,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(o){return this._uriTransformer?P.transformIncomingURIs(o,this._uriTransformer):o}getProxy(o){const{nid:v,sid:m}=o;return this._proxies[v]||(this._proxies[v]=this._createProxy(v,m)),this._proxies[v]}_createProxy(o,v){let m={get:(E,y)=>(typeof y=="string"&&!E[y]&&y.charCodeAt(0)===36&&(E[y]=(...a)=>this._remoteCall(o,y,a)),y===u?v:E[y])};return new Proxy(Object.create(null),m)}set(o,v){return this._locals[o.nid]=v,v}assertRegistered(o){for(let v=0,m=o.length;v<m;v++){const E=o[v];if(!this._locals[E.nid])throw new Error(`Missing actor ${E.sid} (isMain: ${E.isMain})`)}}_receiveOneMessage(o){if(this._isDisposed)return;const v=o.byteLength,m=g.read(o,0),E=m.readUInt8(),y=m.readUInt32();switch(E){case 1:case 2:{let{rpcId:a,method:T,args:O}=t.deserializeRequestJSONArgs(m);this._uriTransformer&&(O=P.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(v,y,a,T,O,E===2);break}case 3:case 4:{let{rpcId:a,method:T,args:O}=t.deserializeRequestMixedArgs(m);this._uriTransformer&&(O=P.transformIncomingURIs(O,this._uriTransformer)),this._receiveRequest(v,y,a,T,O,E===4);break}case 5:{this._logger&&this._logger.logIncoming(v,y,0,"ack"),this._onDidReceiveAcknowledge(y);break}case 6:{this._receiveCancel(v,y);break}case 7:{this._receiveReply(v,y,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(m);this._uriTransformer&&(a=P.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(v,y,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(m);this._receiveReply(v,y,a);break}case 10:{let a=t.deserializeReplyErrError(m);this._uriTransformer&&(a=P.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(v,y,a);break}case 11:{this._receiveReplyErr(v,y,void 0);break}default:console.error("received unexpected message"),console.error(o)}}_receiveRequest(o,v,m,E,y,a){this._logger&&this._logger.logIncoming(o,v,1,`receiveRequest ${D.getStringIdentifierForProxy(m)}.${E}(`,y);const T=String(v);let O,$;if(a){const le=new R.CancellationTokenSource;y.push(le.token),O=this._invokeHandler(m,E,y),$=()=>le.cancel()}else O=this._invokeHandler(m,E,y),$=b;this._cancelInvokedHandlers[T]=$;const Z=t.serializeAcknowledged(v);this._logger&&this._logger.logOutgoing(Z.byteLength,v,1,"ack"),this._protocol.send(Z),O.then(le=>{delete this._cancelInvokedHandlers[T];const q=t.serializeReplyOK(v,le,this._uriReplacer);this._logger&&this._logger.logOutgoing(q.byteLength,v,1,"reply:",le),this._protocol.send(q)},le=>{delete this._cancelInvokedHandlers[T];const q=t.serializeReplyErr(v,le);this._logger&&this._logger.logOutgoing(q.byteLength,v,1,"replyErr:",le),this._protocol.send(q)})}_receiveCancel(o,v){this._logger&&this._logger.logIncoming(o,v,1,"receiveCancel");const m=String(v);this._cancelInvokedHandlers[m]&&this._cancelInvokedHandlers[m]()}_receiveReply(o,v,m){this._logger&&this._logger.logIncoming(o,v,0,"receiveReply:",m);const E=String(v);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const y=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E],y.resolveOk(m)}_receiveReplyErr(o,v,m){this._logger&&this._logger.logIncoming(o,v,0,"receiveReplyErr:",m);const E=String(v);if(!this._pendingRPCReplies.hasOwnProperty(E))return;const y=this._pendingRPCReplies[E];delete this._pendingRPCReplies[E];let a;m&&(m.$isError?(a=new Error,a.name=m.name,a.message=m.message,a.stack=m.stack):a=m),y.resolveErr(a)}_invokeHandler(o,v,m){try{return Promise.resolve(this._doInvokeHandler(o,v,m))}catch(E){return Promise.reject(E)}}_doInvokeHandler(o,v,m){const E=this._locals[o];if(!E)throw new Error("Unknown actor "+D.getStringIdentifierForProxy(o));let y=E[v];if(typeof y!="function")throw new Error("Unknown method "+v+" on actor "+D.getStringIdentifierForProxy(o));return y.apply(E,m)}_remoteCall(o,v,m){if(this._isDisposed)return Promise.reject(C.canceled());let E=null;if(m.length>0&&R.CancellationToken.isCancellationToken(m[m.length-1])&&(E=m.pop()),E&&E.isCancellationRequested)return Promise.reject(C.canceled());const y=t.serializeRequestArguments(m,this._uriReplacer),a=++this._lastMessageId,T=String(a),O=new _.LazyPromise;E&&E.onCancellationRequested(()=>{const Z=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(Z.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[T]=O,this._onWillSendRequest(a);const $=t.serializeRequest(a,o,v,y,!!E);return this._logger&&this._logger.logOutgoing($.byteLength,a,0,`request: ${D.getStringIdentifierForProxy(o)}.${v}(`,m),this._protocol.send($),O}}e.RPCProtocol=d,k=w,d.UNRESPONSIVE_TIME=3*1e3;class g{constructor(o,v){this._buff=o,this._offset=v}static alloc(o,v,m){let E=new g(r.VSBuffer.alloc(m+1+4),0);return E.writeUInt8(o),E.writeUInt32(v),E}static read(o,v){return new g(o,v)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(o){this._buff.writeUInt8(o,this._offset),this._offset+=1}readUInt8(){const o=this._buff.readUInt8(this._offset);return this._offset+=1,o}writeUInt32(o){this._buff.writeUInt32BE(o,this._offset),this._offset+=4}readUInt32(){const o=this._buff.readUInt32BE(this._offset);return this._offset+=4,o}static sizeShortString(o){return 1+o.byteLength}writeShortString(o){this._buff.writeUInt8(o.byteLength,this._offset),this._offset+=1,this._buff.set(o,this._offset),this._offset+=o.byteLength}readShortString(){const o=this._buff.readUInt8(this._offset);this._offset+=1;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}static sizeLongString(o){return 4+o.byteLength}writeLongString(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readLongString(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const m=this._buff.slice(this._offset,this._offset+o).toString();return this._offset+=o,m}writeBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}static sizeVSBuffer(o){return 4+o.byteLength}writeVSBuffer(o){this._buff.writeUInt32BE(o.byteLength,this._offset),this._offset+=4,this._buff.set(o,this._offset),this._offset+=o.byteLength}readVSBuffer(){const o=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+o);return this._offset+=o,v}static sizeMixedArray(o,v){let m=0;m+=1;for(let E=0,y=o.length;E<y;E++){const a=o[E],T=v[E];switch(m+=1,T){case 1:m+=this.sizeLongString(a);break;case 2:m+=this.sizeVSBuffer(a);break;case 3:break}}return m}writeMixedArray(o,v){this._buff.writeUInt8(o.length,this._offset),this._offset+=1;for(let m=0,E=o.length;m<E;m++){const y=o[m];switch(v[m]){case 1:this.writeUInt8(1),this.writeLongString(y);break;case 2:this.writeUInt8(2),this.writeVSBuffer(y);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const o=this._buff.readUInt8(this._offset);this._offset+=1;let v=new Array(o);for(let m=0;m<o;m++)switch(this.readUInt8()){case 1:v[m]=this.readLongString();break;case 2:v[m]=this.readVSBuffer();break;case 3:v[m]=void 0;break}return v}}class t{static _arrayContainsBufferOrUndefined(o){for(let v=0,m=o.length;v<m;v++)if(o[v]instanceof r.VSBuffer||typeof o[v]=="undefined")return!0;return!1}static serializeRequestArguments(o,v){if(this._arrayContainsBufferOrUndefined(o)){let m=[],E=[];for(let y=0,a=o.length;y<a;y++){const T=o[y];T instanceof r.VSBuffer?(m[y]=T,E[y]=2):typeof T=="undefined"?(m[y]=r.VSBuffer.alloc(0),E[y]=3):(m[y]=r.VSBuffer.fromString(h(T,v)),E[y]=1)}return{type:"mixed",args:m,argsType:E}}return{type:"simple",args:h(o,v)}}static serializeRequest(o,v,m,E,y){return E.type==="mixed"?this._requestMixedArgs(o,v,m,E.args,E.argsType,y):this._requestJSONArgs(o,v,m,E.args,y)}static _requestJSONArgs(o,v,m,E,y){const a=r.VSBuffer.fromString(m),T=r.VSBuffer.fromString(E);let O=0;O+=g.sizeUInt8(),O+=g.sizeShortString(a),O+=g.sizeLongString(T);let $=g.alloc(y?2:1,o,O);return $.writeUInt8(v),$.writeShortString(a),$.writeLongString(T),$.buffer}static deserializeRequestJSONArgs(o){const v=o.readUInt8(),m=o.readShortString(),E=o.readLongString();return{rpcId:v,method:m,args:JSON.parse(E)}}static _requestMixedArgs(o,v,m,E,y,a){const T=r.VSBuffer.fromString(m);let O=0;O+=g.sizeUInt8(),O+=g.sizeShortString(T),O+=g.sizeMixedArray(E,y);let $=g.alloc(a?4:3,o,O);return $.writeUInt8(v),$.writeShortString(T),$.writeMixedArray(E,y),$.buffer}static deserializeRequestMixedArgs(o){const v=o.readUInt8(),m=o.readShortString(),E=o.readMixedArray(),y=new Array(E.length);for(let a=0,T=E.length;a<T;a++){const O=E[a];typeof O=="string"?y[a]=JSON.parse(O):y[a]=O}return{rpcId:v,method:m,args:y}}static serializeAcknowledged(o){return g.alloc(5,o,0).buffer}static serializeCancel(o){return g.alloc(6,o,0).buffer}static serializeReplyOK(o,v,m){return typeof v=="undefined"?this._serializeReplyOKEmpty(o):v instanceof r.VSBuffer?this._serializeReplyOKVSBuffer(o,v):this._serializeReplyOKJSON(o,l(v,m))}static _serializeReplyOKEmpty(o){return g.alloc(7,o,0).buffer}static _serializeReplyOKVSBuffer(o,v){let m=0;m+=g.sizeVSBuffer(v);let E=g.alloc(8,o,m);return E.writeVSBuffer(v),E.buffer}static deserializeReplyOKVSBuffer(o){return o.readVSBuffer()}static _serializeReplyOKJSON(o,v){const m=r.VSBuffer.fromString(v);let E=0;E+=g.sizeLongString(m);let y=g.alloc(9,o,E);return y.writeLongString(m),y.buffer}static deserializeReplyOKJSON(o){const v=o.readLongString();return JSON.parse(v)}static serializeReplyErr(o,v){return v?this._serializeReplyErrEror(o,v):this._serializeReplyErrEmpty(o)}static _serializeReplyErrEror(o,v){const m=r.VSBuffer.fromString(l(C.transformErrorForSerialization(v),null));let E=0;E+=g.sizeLongString(m);let y=g.alloc(10,o,E);return y.writeLongString(m),y.buffer}static deserializeReplyErrError(o){const v=o.readLongString();return JSON.parse(v)}static _serializeReplyErrEmpty(o){return g.alloc(11,o,0).buffer}}var i;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyErrError=10]="ReplyErrError",n[n.ReplyErrEmpty=11]="ReplyErrEmpty"})(i||(i={}));var s;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.Undefined=3]="Undefined"})(s||(s={}))}),define(pe[251],ve([0,1,4]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=p.createDecorator("remoteAgentService")}),define(pe[252],ve([0,1,10,9,11,2,4,81,45,212,251]),function(X,e,p,R,C,S,A,P,_,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=A.createDecorator("pathService");let k=class Bn{constructor(h,c,f,I){this.localUserHome=h,this.remoteAgentService=c,this.environmentService=f,this.contextService=I,this.resolveOS=(async()=>{const b=await this.remoteAgentService.getEnvironment();return(b==null?void 0:b.os)||C.OS})(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(b==null?void 0:b.userHome)||h})()}get defaultUriScheme(){return Bn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,c){if(h.remoteAuthority)return p.Schemas.vscodeRemote;const f=P.getVirtualWorkspaceScheme(c.getWorkspace());if(f)return f;const I=c.getWorkspace().folders[0];if(I)return I.uri.scheme;const b=c.getWorkspace().configuration;return b?b.scheme:p.Schemas.file}async userHome(h){return(h==null?void 0:h.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?R.win32:R.posix)}async fileURI(h){let c="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const I=h.indexOf("/",2);I===-1?(c=h.substring(2),h="/"):(c=h.substring(2,I),h=h.substring(I)||"/")}return S.URI.from({scheme:p.Schemas.file,authority:c,path:h,query:"",fragment:""})}};k=qe([We(1,r.IRemoteAgentService),We(2,D.IWorkbenchEnvironmentService),We(3,_.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(pe[64],ve([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class p{constructor(A,P){this.line=A,this.character=P}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,P){return new p(0,0)}with(A){return new p(0,0)}}e.Position=p;class R{constructor(A,P,_,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new p(A,P),this.end=new p(_,D)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var C;(function(S){S[S.Information=1]="Information",S[S.Warning=2]="Warning"})(C=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(pe[31],ve([0,1,18,30,25,29,8,4,9,14,64]),function(X,e,p,R,C,S,A,P,_,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return r.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const k="\u27EA ",l=" characters skipped \u27EB",h=(k.length+l.length+5)*2;e.ISearchService=P.createDecorator("searchService");var c;(function(N){N[N.file=0]="file",N[N.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var f;(function(N){N[N.File=1]="File",N[N.Text=2]="Text"})(f=e.QueryType||(e.QueryType={}));function I(N){return!!N.preview}e.resultIsMatch=I;function b(N){return!!N.resource}e.isFileMatch=b;function w(N){return!!N.message}e.isProgressMessage=w;var u;(function(N){N[N.Normal=0]="Normal",N[N.NewSearchStarted=1]="NewSearchStarted"})(u=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class d{constructor(z){this.resource=z,this.results=[]}}e.FileMatch=d;class g{constructor(z,F,M){this.ranges=F;const L=Array.isArray(F)?F:[F];if(M&&M.matchLines===1&&t(L)){z=A.getNLines(z,M.matchLines);let U="",G=0,te=0;const me=Math.floor(M.charsPerLine/5),Se=[];for(const ye of L){const Le=Math.max(ye.startColumn-me,0),je=ye.startColumn+M.charsPerLine;if(Le>te+me+h){const ze=k+(Le-te)+l;U+=ze+z.slice(Le,je),G+=Le-(te+ze.length)}else U+=z.slice(te,je);Se.push(new s(0,ye.startColumn-G,ye.endColumn-G)),te=je}this.preview={text:U,matches:Array.isArray(this.ranges)?Se:Se[0]}}else{const U=Array.isArray(F)?F[0].startLineNumber:F.startLineNumber;this.preview={text:z,matches:p.mapArrayOrNot(F,G=>new i(G.startLineNumber-U,G.startColumn,G.endLineNumber-U,G.endColumn))}}}}e.TextSearchMatch=g;function t(N){const z=N[0].startLineNumber;for(const F of N)if(F.startLineNumber!==z||F.endLineNumber!==z)return!1;return!0}class i{constructor(z,F,M,L){this.startLineNumber=z,this.startColumn=F,this.endLineNumber=M,this.endColumn=L}}e.SearchRange=i;class s extends i{constructor(z,F,M){super(z,F,z,M)}}e.OneLineRange=s;var n;(function(N){N.Default="default",N.FileNames="fileNames",N.Type="type",N.Modified="modified",N.CountDescending="countDescending",N.CountAscending="countAscending"})(n=e.SearchSortOrder||(e.SearchSortOrder={}));function o(N,z=!0){const F=N&&N.files&&N.files.exclude,M=z&&N&&N.search&&N.search.exclude;if(!F&&!M)return;if(!F||!M)return F||M;let L=Object.create(null);return L=C.mixin(L,C.deepClone(F)),L=C.mixin(L,C.deepClone(M),!0),L}e.getExcludes=o;function v(N,z){return N.excludePattern&&R.match(N.excludePattern,z)?!1:N.includePattern||N.usingSearchPaths?N.includePattern&&R.match(N.includePattern,z)?!0:N.usingSearchPaths?!!N.folderQueries&&N.folderQueries.some(F=>{const M=F.folder.fsPath;if(S.isEqualOrParent(z,M)){const L=_.relative(M,z);return!F.includePattern||!!R.match(F.includePattern,L)}else return!1}):!1:!0}e.pathIncludedInQuery=v;var m;(function(N){N[N.unknownEncoding=1]="unknownEncoding",N[N.regexParseError=2]="regexParseError",N[N.globParseError=3]="globParseError",N[N.invalidLiteral=4]="invalidLiteral",N[N.rgProcessError=5]="rgProcessError",N[N.other=6]="other",N[N.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(z,F){super(z);this.code=F}}e.SearchError=E;function y(N){const z=N.message;if(D.isPromiseCanceledError(N))return new E(z,m.canceled);try{const F=JSON.parse(z);return new E(F.message,F.code)}catch(F){return new E(z,m.other)}}e.deserializeSearchError=y;function a(N){const z={message:N.message,code:N.code};return new Error(JSON.stringify(z))}e.serializeSearchError=a;function T(N){return N.type==="error"?!0:N.type==="success"}e.isSerializedSearchComplete=T;function O(N){return N.type==="success"}e.isSerializedSearchSuccess=O;function $(N){return!!N.path}e.isSerializedFileMatch=$;function Z(N,z){const F=N.searchPath?N.searchPath:N.relativePath;return A.fuzzyContains(F,z)}e.isFilePatternMatch=Z;class le{constructor(z){this.path=z,this.results=[]}addMatch(z){this.results.push(z)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=le;function q(N,z){const F=Object.assign(Object.assign({},N||{}),z||{});return Object.keys(F).filter(M=>{const L=F[M];return typeof L=="boolean"&&L})}e.resolvePatternsForProvider=q;class x{constructor(z,F){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},z.excludePattern||{}),F.excludePattern||{}),this._parsedExcludeExpression=R.parse(this._excludeExpression);let M=z.includePattern;F.includePattern&&(M?M=Object.assign(Object.assign({},M),F.includePattern):M=F.includePattern),M&&(this._parsedIncludeExpression=R.parse(M))}includedInQuerySync(z,F,M){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(z,F,M)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(z,F,M))}includedInQuery(z,F,M){return Promise.resolve(this._parsedExcludeExpression(z,F,M)).then(U=>!!U).then(U=>U?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(z,F,M)).then(G=>!!G):Promise.resolve(!0)).then(U=>U)}hasSiblingExcludeClauses(){return H(this._excludeExpression)}}e.QueryGlobTester=x;function H(N){for(const z in N)if(typeof N[z]!="boolean")return!0;return!1}}),define(pe[34],ve([0,1,18,16,21,3,23,10,72,24,8,15,2,164,4,12,182,45,59,27,13,7,31,5]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w,u,d,g,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(T,O,$){return new D.ExtUri(Z=>m(Z,$)).isEqual(T,O)}function n(T,O,$){return s(T.uri,O.uri,$)?0:r.compare(T.uri.toString(),O.uri.toString())}function o(T,O,$){return T.index!==O.index?T.index<O.index?-1:1:s(T.uri,O.uri,$)?r.compare(T.name,O.name):r.compare(T.uri.toString(),O.uri.toString())}function v(T,O,$,Z){const le=T.slice(0).sort((x,H)=>$(x,H,Z)),q=O.slice(0).sort((x,H)=>$(x,H,Z));return p.delta(le,q,(x,H)=>$(x,H,Z))}function m(T,O){const $=O.getCapabilities(T.scheme);return!($&&$&1024)}class E extends b.Workspace{constructor(O,$,Z,le,q,x){super(O,Z.map(H=>new b.WorkspaceFolder(H)),le,x);this._name=$,this._isUntitled=q,this._workspaceFolders=[],this._structure=A.TernarySearchTree.forUris(x),Z.forEach(H=>{this._workspaceFolders.push(H),this._structure.set(H.uri,H)})}static toExtHostWorkspace(O,$,Z,le){if(!O)return{workspace:null,added:[],removed:[]};const{id:q,name:x,folders:H,configuration:N,isUntitled:z}=O,F=[],M=$;$?H.forEach((te,me)=>{const Se=l.URI.revive(te.uri),ye=E._findFolder(Z||$,Se,le);ye?(ye.name=te.name,ye.index=te.index,F.push(ye)):F.push({uri:Se,name:te.name,index:me})}):F.push(...H.map(({uri:te,name:me,index:Se})=>({uri:l.URI.revive(te),name:me,index:Se}))),F.sort((te,me)=>te.index<me.index?-1:1);const L=new E(q,x,F,N?l.URI.revive(N):null,!!z,te=>m(te,le)),{added:U,removed:G}=v(M?M.workspaceFolders:[],L.workspaceFolders,n,le);return{workspace:L,added:U,removed:G}}static _findFolder(O,$,Z){for(let le=0;le<O.folders.length;le++){const q=O.workspaceFolders[le];if(s(q.uri,$,Z))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(O,$){return $&&this._structure.get(O)&&(O=D.dirname(O)),this._structure.findSubstr(O)}resolveWorkspaceFolder(O){return this._structure.get(O)}}let y=class{constructor(O,$,Z,le){this._onDidChangeWorkspace=new S.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new S.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=le,this._extHostFileSystemInfo=Z,this._requestIdProvider=new _.Counter,this._barrier=new R.Barrier,this._proxy=O.getProxy(i.MainContext.MainThreadWorkspace),this._messageService=O.getProxy(i.MainContext.MainThreadMessageService);const q=$.workspace;this._confirmedWorkspace=q?new E(q.id,q.name,[],q.configuration?l.URI.revive(q.configuration):null,!!q.isUntitled,x=>m(x,Z)):void 0}$initializeWorkspace(O,$){this._trusted=$,this.$acceptWorkspaceData(O),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?l.URI.from({scheme:P.Schemas.untitled,path:D.basename(D.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(O,$,Z,...le){const q=[];if(Array.isArray(le)&&le.forEach(F=>{l.URI.isUri(F.uri)&&!q.some(M=>s(M.uri,F.uri,this._extHostFileSystemInfo))&&q.push({uri:F.uri,name:F.name||D.basenameOrAuthority(F.uri)})}),this._unconfirmedWorkspace||[$,Z].some(F=>typeof F!="number"||F<0)||Z===0&&q.length===0)return!1;const x=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if($+Z>x.length)return!1;const H=x.slice(0);H.splice($,Z,...q.map(F=>({uri:F.uri,name:F.name||D.basenameOrAuthority(F.uri),index:void 0})));for(let F=0;F<H.length;F++){const M=H[F];if(H.some((L,U)=>U!==F&&s(M.uri,L.uri,this._extHostFileSystemInfo)))return!1}H.forEach((F,M)=>F.index=M);const{added:N,removed:z}=v(x,H,o,this._extHostFileSystemInfo);if(N.length===0&&z.length===0)return!1;if(this._proxy){const F=O.displayName||O.name;this._proxy.$updateWorkspaceFolders(F,$,Z,q).then(void 0,M=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(I.Severity.Error,h.localize(0,null,F,M.toString()),{extension:O},[])})}return this.trySetWorkspaceFolders(H),!0}getWorkspaceFolder(O,$){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,$)}async getWorkspaceFolder2(O,$){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(O,$)}async resolveWorkspaceFolder(O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(O)}getPath(){if(!this._actualWorkspace)return;const{folders:O}=this._actualWorkspace;if(O.length!==0)return O[0].uri.fsPath}getRelativePath(O,$){let Z,le="";if(typeof O=="string"?(Z=l.URI.file(O),le=O):typeof O!="undefined"&&(Z=O,le=O.fsPath),!Z)return le;const q=this.getWorkspaceFolder(Z,!0);if(!q)return le;typeof $=="undefined"&&this._actualWorkspace&&($=this._actualWorkspace.folders.length>1);let x=D.relativePath(q.uri,Z);return $&&q.name&&(x=`${q.name}/${x}`),x}trySetWorkspaceFolders(O){this._actualWorkspace&&(this._unconfirmedWorkspace=E.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:O,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(O){const{workspace:$,added:Z,removed:le}=E.toExtHostWorkspace(O,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=$||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:Z,removed:le}))}findFiles(O,$,Z,le,q=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${le.value}, entryPoint: findFiles`);let x;if($===null?x=!1:$&&(typeof $=="string"?x=$:x=$.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:H,folder:N}=a(O);return this._proxy.$startFileSearch(k.withUndefinedAsNull(H),k.withUndefinedAsNull(N),k.withUndefinedAsNull(x),k.withUndefinedAsNull(Z),q).then(z=>Array.isArray(z)?z.map(F=>l.URI.revive(F)):[])}async findTextInFiles(O,$,Z,le,q=C.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${le.value}, entryPoint: findTextInFiles`);const x=this._requestIdProvider.getNext(),H=typeof $.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:N,folder:z}=a($.include),F=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,M={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:H,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:N,excludePattern:F},L=!1;if(this._activeSearchCallbacks[x]=U=>{if(L)return;const G=l.URI.revive(U.resource);U.results.forEach(te=>{t.resultIsMatch(te)?Z({uri:G,preview:{text:te.preview.text,matches:p.mapArrayOrNot(te.preview.matches,me=>new g.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))},ranges:p.mapArrayOrNot(te.ranges,me=>new g.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))}):Z({uri:G,text:te.text,lineNumber:te.lineNumber})})},q.isCancellationRequested)return{};try{const U=await this._proxy.$startTextSearch(O,k.withUndefinedAsNull(z),M,x,q);return delete this._activeSearchCallbacks[x],U||{}}catch(U){throw delete this._activeSearchCallbacks[x],U}}$handleTextSearchResult(O,$){this._activeSearchCallbacks[$]&&this._activeSearchCallbacks[$](O)}saveAll(O){return this._proxy.$saveAll(O)}resolveProxy(O){return this._proxy.$resolveProxy(O)}get trusted(){return this._trusted}requestWorkspaceTrust(O){return this._proxy.$requestWorkspaceTrust(O)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};y=qe([We(0,d.IExtHostRpcService),We(1,u.IExtHostInitDataService),We(2,w.IExtHostFileSystemInfo),We(3,f.ILogService)],y),e.ExtHostWorkspace=y,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function a(T){let O,$;return T&&(typeof T=="string"?O=T:(O=T.pattern,$=T.baseFolder||l.URI.file(T.base))),{includePattern:O,folder:$}}}),define(pe[36],ve([0,1,25,3,34,5,7,186,80,15,16,4,13,12,2]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(i,s){if(s){const n=s.split(".");let o=i;for(let v=0;o&&v<n.length;v++)o=o[n[v]];return o}}function I(i){return i instanceof c.URI}function b(i){return i&&i.uri instanceof c.URI&&i.languageId&&typeof i.languageId=="string"}function w(i){return i&&!i.uri&&i.languageId&&typeof i.languageId=="string"}function u(i){return i&&i.uri instanceof c.URI&&(!i.name||typeof i.name=="string")&&(!i.index||typeof i.index=="number")}function d(i){if(I(i))return{resource:i};if(b(i))return{resource:i.uri,overrideIdentifier:i.languageId};if(w(i))return{overrideIdentifier:i.languageId};if(u(i))return{resource:i.uri};if(i===null)return{resource:null}}let g=class{constructor(s,n,o){this._proxy=s.getProxy(S.MainContext.MainThreadConfiguration),this._extHostWorkspace=n,this._logService=o,this._barrier=new r.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,n){this.getConfigProvider().then(o=>o.$acceptConfigurationChanged(s,n))}};g=qe([We(0,l.IExtHostRpcService),We(1,C.IExtHostWorkspace),We(2,h.ILogService)],g),e.ExtHostConfiguration=g;class t{constructor(s,n,o,v){this._onDidChangeConfiguration=new R.Emitter,this._proxy=s,this._logService=v,this._extHostWorkspace=n,this._configuration=P.Configuration.parse(o),this._configurationScopes=this._toMap(o.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,n){const o={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=P.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(n,o))}getConfiguration(s,n,o){const v=d(n)||{},m=this._toReadonlyValue(s?f(this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,v,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,v,o==null?void 0:o.identifier);function E(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case A.ConfigurationTarget.Global:return 1;case A.ConfigurationTarget.Workspace:return 4;case A.ConfigurationTarget.WorkspaceFolder:return 5}}const y={has(a){return typeof f(m,a)!="undefined"},get:(a,T)=>{this._validateConfigurationAccess(s?`${s}.${a}`:a,v,o==null?void 0:o.identifier);let O=f(m,a);if(typeof O=="undefined")O=T;else{let $;const Z=(le,q)=>{let x;const H=()=>{$=$||p.deepClone(m),x=x||f($,q)};return D.isObject(le)?new Proxy(le,{get:(N,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return H(),()=>x;if($)return x=x||f($,q),x[z];const F=N[z];return typeof z=="string"?Z(F,`${q}.${z}`):F},set:(N,z,F)=>(H(),x&&(x[z]=F),!0),deleteProperty:(N,z)=>(H(),x&&delete x[z],!0),defineProperty:(N,z,F)=>(H(),x&&Object.defineProperty(x,z,F),!0)}):le};O=Z(O,a)}return O},update:(a,T,O,$)=>{a=s?`${s}.${a}`:a;const Z=E(O);return T!==void 0?this._proxy.$updateConfigurationOption(Z,a,T,v,$):this._proxy.$removeConfigurationOption(Z,a,v,$)},inspect:a=>{var T,O,$,Z,le,q,x,H;a=s?`${s}.${a}`:a;const N=p.deepClone(this._configuration.inspect(a,v,this._extHostWorkspace.workspace));if(N)return{key:a,defaultValue:(T=N.default)===null||T===void 0?void 0:T.value,globalValue:(O=N.user)===null||O===void 0?void 0:O.value,workspaceValue:($=N.workspace)===null||$===void 0?void 0:$.value,workspaceFolderValue:(Z=N.workspaceFolder)===null||Z===void 0?void 0:Z.value,defaultLanguageValue:(le=N.default)===null||le===void 0?void 0:le.override,globalLanguageValue:(q=N.user)===null||q===void 0?void 0:q.override,workspaceLanguageValue:(x=N.workspace)===null||x===void 0?void 0:x.override,workspaceFolderLanguageValue:(H=N.workspaceFolder)===null||H===void 0?void 0:H.override,languageIds:N.overrideIdentifiers}}};return typeof m=="object"&&p.mixin(y,m,!1),Object.freeze(y)}_toReadonlyValue(s){const n=o=>D.isObject(o)?new Proxy(o,{get:(v,m)=>n(v[m]),set:(v,m,E)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(m)}' of object`)},deleteProperty:(v,m)=>{throw new Error(`TypeError: Cannot delete read only property '${String(m)}' of object`)},defineProperty:(v,m)=>{throw new Error(`TypeError: Cannot define property '${String(m)}' for a readonly object`)},setPrototypeOf:v=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):o;return n(s)}_validateConfigurationAccess(s,n,o){const v=_.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),m=o?`[${o.value}] `:"";if(v===4){typeof(n==null?void 0:n.resource)=="undefined"&&this._logService.warn(`${m}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(v===3){(n==null?void 0:n.resource)&&this._logService.warn(`${m}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,n){const o=new P.ConfigurationChangeEvent(s,n,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(v,m)=>o.affectsConfiguration(v,d(m))})}_toMap(s){return s.reduce((n,o)=>(n.set(o[0],o[1]),n),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=k.createDecorator("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(pe[65],ve([0,1,2,16,3,5,7,34,39,36,21,33,13,27,4,10,11,12,61,201,14]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w,u,d){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(le){function q(H){if(H!=null)return H}le.from=q;function x(H){if(H!=null)return H}le.to=x})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var i;(function(le){function q(H){if(H!=null)return H}le.from=q;function x(H){if(H!=null)return H}le.to=x})(i=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(le){function q(H){if(H!=null)return H}le.from=q;function x(H){if(H!=null)return H}le.to=x})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var n;(function(le){function q(N){if(N){const z=N;return z&&!!z.process}else return!1}le.is=q;function x(N){if(N==null)return;const z={process:N.process,args:N.args};return N.options&&(z.options=s.from(N.options)),z}le.from=x;function H(N){if(N!=null)return new A.ProcessExecution(N.process,N.args,N.options)}le.to=H})(n=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var o;(function(le){function q(H){if(H!=null)return H}le.from=q;function x(H){if(H!=null)return H}le.to=x})(o=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var v;(function(le){function q(N){if(N){const z=N;return z&&(!!z.commandLine||!!z.command)}else return!1}le.is=q;function x(N){if(N==null)return;const z={};return N.commandLine!==void 0?z.commandLine=N.commandLine:(z.command=N.command,z.args=N.args),N.options&&(z.options=o.from(N.options)),z}le.from=x;function H(N){if(!(N==null||N.command===void 0&&N.commandLine===void 0))return N.commandLine?new A.ShellExecution(N.commandLine,N.options):new A.ShellExecution(N.command,N.args?N.args:[],N.options)}le.to=H})(v=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var m;(function(le){function q(N){if(N){let z=N;return z&&z.customExecution==="customExecution"}else return!1}le.is=q;function x(N){return{customExecution:"customExecution"}}le.from=x;function H(N,z){return z.get(N)}le.to=H})(m=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var E;(function(le){function q(x,H){let N;return x.scope!==void 0&&typeof x.scope!="number"?N=x.scope.uri:x.scope!==void 0&&typeof x.scope=="number"&&(x.scope===A.TaskScope.Workspace&&H&&H.workspaceFile?N=H.workspaceFile:N=u.USER_TASKS_GROUP_KEY),{id:x._id,workspaceFolder:N}}le.from=q})(E=e.TaskHandleDTO||(e.TaskHandleDTO={}));var y;(function(le){function q(N,z){if(N==null)return[];const F=[];for(let M of N){const L=x(M,z);L&&F.push(L)}return F}le.fromMany=q;function x(N,z){if(N==null)return;let F;N.execution instanceof A.ProcessExecution?F=n.from(N.execution):N.execution instanceof A.ShellExecution?F=v.from(N.execution):N.execution&&N.execution instanceof A.CustomExecution&&(F=m.from(N.execution));const M=t.from(N.definition);let L;if(N.scope?typeof N.scope=="number"?L=N.scope:L=N.scope.uri:L=A.TaskScope.Workspace,!M||!L)return;const U=N.group?N.group.id:void 0;return{_id:N._id,definition:M,name:N.name,source:{extensionId:z.identifier.value,label:N.source,scope:L},execution:F,isBackground:N.isBackground,group:U,presentationOptions:i.from(N.presentationOptions),problemMatchers:N.problemMatchers,hasDefinedMatchers:N.hasDefinedMatchers,runOptions:N.runOptions?N.runOptions:{reevaluateOnRerun:!0},detail:N.detail}}le.from=x;async function H(N,z,F){if(N==null)return;let M;n.is(N.execution)?M=n.to(N.execution):v.is(N.execution)?M=v.to(N.execution):m.is(N.execution)&&(M=m.to(N._id,F));const L=t.to(N.definition);let U;if(N.source&&(N.source.scope!==void 0?typeof N.source.scope=="number"?U=N.source.scope:U=await z.resolveWorkspaceFolder(p.URI.revive(N.source.scope)):U=A.TaskScope.Workspace),!L||!U)return;const G=new A.Task(L,U,N.name,N.source.label,M,N.problemMatchers);return N.isBackground!==void 0&&(G.isBackground=N.isBackground),N.group!==void 0&&(G.group=A.TaskGroup.from(N.group)),N.presentationOptions&&(G.presentationOptions=i.to(N.presentationOptions)),N._id&&(G._id=N._id),N.detail&&(G.detail=N.detail),G}le.to=H})(y=e.TaskDTO||(e.TaskDTO={}));var a;(function(le){function q(H){return H}le.from=q;function x(H){if(!!H)return Object.assign(Object.create(null),H)}le.to=x})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class T{constructor(q,x,H){this._id=x,this._task=H,g.set(this,void 0),it(this,g,q,"f")}get task(){return this._task}terminate(){$e(this,g,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}g=new WeakMap;var O;(function(le){function q(x){return{id:x._id,task:void 0}}le.from=q})(O=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let $=class{constructor(q,x,H,N,z,F,M,L){this._onDidExecuteTask=new C.Emitter,this._onDidTerminateTask=new C.Emitter,this._onDidTaskProcessStarted=new C.Emitter,this._onDidTaskProcessEnded=new C.Emitter,this._proxy=q.getProxy(S.MainContext.MainThreadTask),this._workspaceProvider=H,this._editorService=N,this._configurationService=z,this._terminalService=F,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=M,this._deprecationService=L,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,x,H){if(!H)return new A.Disposable(()=>{});const N=this.nextHandle();return this._handlers.set(N,{type:x,provider:H,extension:q}),this._proxy.$registerTaskProvider(N,x),new A.Disposable(()=>{this._handlers.delete(N),this._proxy.$unregisterTaskProvider(N)})}registerTaskSystem(q,x){this._proxy.$registerTaskSystem(q,x)}fetchTasks(q){return this._proxy.$fetchTasks(a.from(q)).then(async x=>{const H=[];for(let N of x){const z=await y.to(N,this._workspaceProvider,this._providedCustomExecutions2);z&&H.push(z)}return H})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(x=>q.push(x)),q}terminateTask(q){if(!(q instanceof T))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,x,H){const N=this._providedCustomExecutions2.get(q.id);if(N){if(this._activeCustomExecutions2.get(q.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(q.id,N),this._terminalService.attachPtyToTerminal(x,await N.callback(H))}this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const x=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:x})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const x=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:x,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const x=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:x,exitCode:q.exitCode})}$provideTasks(q,x){const H=this._handlers.get(q);if(!H)return Promise.reject(new Error("no handler found"));const N=[],z=R.asPromise(()=>H.provider.provideTasks(r.CancellationToken.None)).then(F=>this.provideTasksInternal(x,N,H,F));return new Promise(F=>{z.then(M=>{Promise.all(N).then(()=>{F(M)})})})}async $resolveTask(q,x){const H=this._handlers.get(q);if(!H)return Promise.reject(new Error("no handler found"));if(x.definition.type!==H.type)throw new Error(`Unexpected: Task of type [${x.definition.type}] cannot be resolved by provider of type [${H.type}].`);const N=await y.to(x,this._workspaceProvider,this._providedCustomExecutions2);if(!N)throw new Error("Unexpected: Task cannot be resolved.");const z=await H.provider.resolveTask(N,r.CancellationToken.None);if(!z)return;this.checkDeprecation(z,H);const F=y.from(z,H.extension);if(!F)throw new Error("Unexpected: Task cannot be resolved.");if(z.definition!==N.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return m.is(F.execution)&&await this.addCustomExecution(F,z,!0),await this.resolveTaskInternal(F)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,x,H){const N=await this._proxy.$createTaskId(q);!H&&!this._providedCustomExecutions2.has(N)&&this._notProvidedCustomExecutions.add(N),this._providedCustomExecutions2.set(N,x.execution)}async getTaskExecution(q,x){if(typeof q=="string"){const z=this._taskExecutionPromises.get(q);if(!z)throw new Error("Unexpected: The specified task is missing an execution");return z}let H=this._taskExecutionPromises.get(q.id);if(H)return H;const N=new Promise(async(z,F)=>{const M=x||await y.to(q.task,this._workspaceProvider,this._providedCustomExecutions2);M?z(new T(this,q.id,M)):F("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(q.id,N),N.then(z=>(this._taskExecutions.set(q.id,z),z),z=>Promise.reject(z))}checkDeprecation(q,x){q._deprecated&&this._deprecationService.report("Task.constructor",x.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let H=this._notProvidedCustomExecutions.values(),N=H.next();for(;!N.done;)!this._activeCustomExecutions2.has(N.value)&&this._lastStartedTask!==N.value&&(this._providedCustomExecutions2.delete(N.value),this._notProvidedCustomExecutions.delete(N.value)),N=H.next()}};$=qe([We(0,l.IExtHostRpcService),We(1,h.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,_.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,b.ILogService),We(7,w.IExtHostApiDeprecationService)],$),e.ExtHostTaskBase=$;let Z=class extends ${constructor(q,x,H,N,z,F,M,L){super(q,x,H,N,z,F,M,L);this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:I.PlatformToString(0)})}async executeTask(q,x){if(!x.execution)throw new Error("Tasks to execute must include an execution");const H=y.from(x,q);if(H===void 0)throw new Error("Task is not valid");if(m.is(H.execution))await this.addCustomExecution(H,x,!1);else throw new d.NotSupportedError;const N=await this.getTaskExecution(await this._proxy.$getTaskExecution(H),x);return this._proxy.$executeTask(H).catch(z=>{throw new Error(z)}),N}provideTasksInternal(q,x,H,N){const z=[];if(N)for(let F of N){this.checkDeprecation(F,H),(!F.definition||!q[F.definition.type])&&this._logService.warn(`The task [${F.source}, ${F.name}] uses an undefined task type. The task will be ignored in the future.`);const M=y.from(F,H.extension);M&&m.is(M.execution)?(z.push(M),x.push(this.addCustomExecution(M,F,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:z,extension:H.extension}}async resolveTaskInternal(q){if(m.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,x){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,x,H){}};Z=qe([We(0,l.IExtHostRpcService),We(1,h.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,_.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,b.ILogService),We(7,w.IExtHostApiDeprecationService)],Z),e.WorkerExtHostTask=Z,e.IExtHostTask=c.createDecorator("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)},Dn=this&&this.__rest||function(X,e){var p={};for(var R in X)Object.prototype.hasOwnProperty.call(X,R)&&e.indexOf(R)<0&&(p[R]=X[R]);if(X!=null&&typeof Object.getOwnPropertySymbols=="function")for(var C=0,R=Object.getOwnPropertySymbols(X);C<R.length;C++)e.indexOf(R[C])<0&&Object.prototype.propertyIsEnumerable.call(X,R[C])&&(p[R[C]]=X[R[C]]);return p};define(pe[253],ve([0,1,18,16,22,21,3,69,52,6,25,15,2,32,4,5,39,13,83,17,7,34,211,122]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w,u,d,g,t,i){"use strict";var s,n,o,v,m;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let E=class{constructor(L,U,G){this.resultsChangedEmitter=new A.Emitter,this.controllers=new z,this.ownedTests=new t.OwnedTestCollection,this.mainThreadSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(f.MainContext.MainThreadTesting),this.subscriptions=U.createInstance(F,this.ownedTests,this.controllers),this.runTracker=new a(this.proxy),this.workspaceObservers=new x(this.proxy),this.textDocumentObservers=new H(this.proxy,G)}registerTestController(L,U){const G=h.generateUuid(),te=this.controllers.register(G,U);return this.proxy.$registerTestController(G),D.toDisposable(()=>{te.dispose(),this.proxy.$unregisterTestController(G)})}createTextDocumentTestObserver(L){return this.textDocumentObservers.checkout(L.uri)}createWorkspaceTestObserver(L){return this.workspaceObservers.checkout(L.uri)}async runTests(L,U=S.CancellationToken.None){const G=te=>te.map(this.getInternalTestForReference,this).filter(k.isDefined).map(me=>({src:me.src,testId:me.item.extId}));await this.proxy.$runTests({exclude:L.exclude?G(L.exclude).map(te=>te.testId):void 0,tests:G(L.tests),debug:L.debug},U)}createTestRun(L,U,G=!0){return this.runTracker.createTestRun(L,U,G)}$publishTestResults(L){this.results=Object.freeze(L.map(U=>r.deepFreeze(u.TestResults.to(U))).concat(this.results).sort((U,G)=>G.completedAt-U.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(L,U){const G=l.URI.revive(U),{disposable:te,info:me}=await this.subscriptions.subscribeToTests(L,G);this.mainThreadSubscriptions.set(N(L,G),te),me&&(this.proxy.$publishDiff(L,G,me.collection.reviveDiff()),me.collection.onDidGenerateDiff(Se=>this.proxy.$publishDiff(L,G,Se)),me.initialSubscribeP.then(()=>me.collection.pushDiff([3,-1])))}async $expandTest(L,U){const G=this.subscriptions.getCollectionById(L.src.tree);G&&(await G.expand(L.testId,U<0?Infinity:U),G.flushDiff())}$unsubscribeFromTests(L,U){var G;const te=l.URI.revive(U),me=N(L,te);(G=this.mainThreadSubscriptions.get(me))===null||G===void 0||G.dispose(),this.mainThreadSubscriptions.delete(me)}$acceptDiff(L,U,G){L===1?this.textDocumentObservers.acceptDiff(l.URI.revive(U),G):this.workspaceObservers.acceptDiff(l.URI.revive(U),G)}async $runTestsForProvider(L,U){const G=this.controllers.get(L.tests[0].src.controller);if(!G)return;const te=L.tests.map(({testId:Le,src:je})=>this.ownedTests.getTestById(Le,je==null?void 0:je.tree)).filter(k.isDefined).map(([Le,je])=>je),me=L.excludeExtIds.map(Le=>this.ownedTests.getTestById(Le)).filter(k.isDefined).filter(([Le,je])=>te.some(ze=>Le.comparePositions(ze,je)===1));if(!te.length)return;const Se={tests:te.map(Le=>$.unwrap(Le.actual)),exclude:me.map(([,Le])=>$.unwrap(Le.actual)),debug:L.debug},ye=this.runTracker.prepareForMainThreadTestRun(Se,T.fromInternal(L),U);try{await G.runTests(Se,U)}finally{ye.isRunning&&!U.isCancellationRequested&&await A.Event.toPromise(ye.onEnd),this.runTracker.cancelRunById(L.runId)}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}$lookupTest(L){const U=this.ownedTests.getTestById(L.testId);if(!U)return Promise.resolve(void 0);const G=U[1],{actual:te,discoverCts:me,expandLevels:Se}=G,ye=Dn(G,["actual","discoverCts","expandLevels"]);return Promise.resolve(ye)}getInternalTestForReference(L){var U,G;return(G=(U=this.workspaceObservers.getMirroredTestDataByReference(L))!==null&&U!==void 0?U:this.subscriptions.getCollectionTestByReference(L))!==null&&G!==void 0?G:this.textDocumentObservers.getMirroredTestDataByReference(L)}};E=qe([We(0,b.IExtHostRpcService),We(1,c.IInstantiationService),We(2,I.IExtHostDocumentsAndEditors)],E),e.ExtHostTesting=E;class y extends D.Disposable{constructor(L,U,G){super();this.dto=L,this.proxy=U,this.task=new Set,this.sharedTestIds=new Set,this.endEmitter=this._register(new A.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new S.CancellationTokenSource(G)),this._register(this.cts.token.onCancellationRequested(()=>{for(const te of this.task)te.end()}))}get isRunning(){return this.task.size>0}get id(){return this.dto.id}createRun(L){const U=new O(L,this.cts.token,this.dto,this.sharedTestIds,this.proxy,()=>{this.task.delete(U),this.isRunning||this.dispose()});return this.task.add(U),U}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class a{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,U,G){return this.getTracker(L,U,G)}cancelRunById(L){for(const U of this.tracked.values())if(U.id===L){U.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,U,G){var te,me;const Se=this.tracked.get(L);if(Se)return Se.createRun(U);const ye=T.fromPublic(L);this.proxy.$startedExtensionTestRun({debug:L.debug,exclude:(me=(te=L.exclude)===null||te===void 0?void 0:te.map(je=>je.id))!==null&&me!==void 0?me:[],id:ye.id,tests:L.tests.map(je=>je.id),persist:G});const Le=this.getTracker(L,ye);return Le.onEnd(()=>this.proxy.$finishedExtensionTestRun(ye.id)),Le.createRun(U)}getTracker(L,U,G){const te=new y(U,this.proxy,G);return this.tracked.set(L,te),te.onEnd(()=>this.tracked.delete(L)),te}}e.TestRunCoordinator=a;class T{constructor(L,U,G){this.id=L,this.include=U,this.exclude=G}static fromPublic(L){var U,G;return new T(h.generateUuid(),new Set(L.tests.map(te=>te.id)),new Set((G=(U=L.exclude)===null||U===void 0?void 0:U.map(te=>te.id))!==null&&G!==void 0?G:_.Iterable.empty()))}static fromInternal(L){return new T(L.runId,new Set(L.tests.map(U=>U.testId)),new Set(L.excludeExtIds))}isIncluded(L){for(let U=L;U;U=U.parent){if(this.include.has(U.id))return!0;if(this.exclude.has(U.id))return!1}return!0}}e.TestRunDto=T;class O{constructor(L,U,G,te,me,Se){this.name=L,this.token=U,s.set(this,void 0),n.set(this,void 0),o.set(this,void 0),v.set(this,void 0),m.set(this,!1),this.taskId=h.generateUuid(),it(this,v,Se,"f"),it(this,s,me,"f"),it(this,n,G,"f"),it(this,o,te,"f"),me.$startedTestRunTask(G.id,{id:this.taskId,name:L,running:!0})}setState(L,U,G){!$e(this,m,"f")&&$e(this,n,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),$e(this,s,"f").$updateTestStateInRun($e(this,n,"f").id,this.taskId,L.id,U,G))}appendMessage(L,U){!$e(this,m,"f")&&$e(this,n,"f").isIncluded(L)&&(this.ensureTestIsKnown(L),$e(this,s,"f").$appendTestMessageInRun($e(this,n,"f").id,this.taskId,L.id,u.TestMessage.from(U)))}appendOutput(L){$e(this,m,"f")||$e(this,s,"f").$appendOutputToRun($e(this,n,"f").id,this.taskId,C.VSBuffer.fromString(L))}end(){$e(this,m,"f")||(it(this,m,!0,"f"),$e(this,s,"f").$finishedTestRunTask($e(this,n,"f").id,this.taskId),$e(this,v,"f").call(this))}ensureTestIsKnown(L){const U=$e(this,o,"f");if(U.has(L.id))return;const G=[];for(;G.unshift(u.TestItem.from(L)),!(U.has(L.id)||(U.add(L.id),!L.parent));)L=L.parent;$e(this,s,"f").$addTestsToRun($e(this,n,"f").id,G)}}s=new WeakMap,n=new WeakMap,o=new WeakMap,v=new WeakMap,m=new WeakMap;class $ extends d.TestItemImpl{constructor(L,U,G){super(L.id,L.label,L.uri,void 0);if(this.actual=L,this.filterDocument=U,this.wrappedParent=G,this.disposable=new D.DisposableStore,!(L instanceof d.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${L.id} did not`);this.debuggable=L.debuggable,this.runnable=L.runnable,this.description=L.description,this.error=L.error,this.status=L.status,this.range=L.range;const te=w.getPrivateApiFor(this),me=w.getPrivateApiFor(L);this.disposable.add(me.bus.event(Se=>{switch(Se[0]){case 3:this[Se[1]]=Se[2];break;case 0:const ye=$.getWrapperForTestItem(Se[1],this.filterDocument,this);w.getPrivateApiFor(ye).parent=L,ye.refreshMatch();break;case 1:this.dispose();break;default:te.bus.fire(Se)}}))}static removeFilter(L){this.wrapperMap.delete(L)}static getWrapperForTestItem(L,U,G){let te=this.wrapperMap.get(U);if(te==null?void 0:te.has(L))return te.get(L);te||(te=new WeakMap,this.wrapperMap.set(U,te));const me=new $(L,U,G);return te.set(L,me),me}static unwrap(L){return L instanceof $?L.actual:L}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var L,U;if(this.disposed)return!1;const G=this._cachedMatchesFilter;for(const me of this.actual.children.values()){const Se=$.getWrapperForTestItem(me,this.filterDocument,this);Se.hasNodeMatchingFilter?this.children.has(Se.id)||this.addChild(Se):Se.hide()}const te=this.children.size>0||((L=this.actual.uri)===null||L===void 0?void 0:L.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=te,te!==G&&((U=this.wrappedParent)===null||U===void 0?void 0:U._cachedMatchesFilter)!==void 0&&this.wrappedParent.refreshMatch(),this._cachedMatchesFilter}hide(){this.wrappedParent&&w.getPrivateApiFor(this.wrappedParent).children.delete(this.id),w.getPrivateApiFor(this).bus.fire([1])}dispose(){var L;if(!this.disposed){this.disposed=!0,this.disposable.dispose(),this.hide(),(L=this.wrappedParent)===null||L===void 0||L.refreshMatch();for(const U of this.children.values())U.dispose()}}}e.TestItemFilteredWrapper=$,$.wrapperMap=new WeakMap;class Z extends i.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,u.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:U,removed:G}=this;return{get added(){return[...L].map(te=>te.revived)},get updated(){return[...U].map(te=>te.revived)},get removed(){return[...G].map(te=>te.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class le extends i.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new A.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(L){let U=[];for(const G of L){const te=this.items.get(G);te&&U.push(te.revived)}return U}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,U){return Object.assign(Object.assign({},L),{revived:u.TestItem.toPlain(L.item),depth:U?U.depth+1:0,children:new Set})}createChangeCollector(){return new Z(this.changeEmitter)}}e.MirroredTestCollection=le;class q{constructor(){this.resources=new Map}checkout(L){var U,G;const te=L.toString(),me=(U=this.resources.get(te))!==null&&U!==void 0?U:this.createObserverData(L);return(G=me.pendingDeletion)===null||G===void 0||G.dispose(),me.observers++,{onDidChangeTest:me.tests.onDidChangeTests,onDidDiscoverInitialTests:new A.Emitter().event,get tests(){return me.tests.rootTestItems},dispose:P.once(()=>{--me.observers||(me.pendingDeletion=this.eventuallyDispose(L))})}}getMirroredTestDataByReference(L){for(const{tests:U}of this.resources.values()){const G=U.getMirroredTestDataByReference(L);if(G)return G}}eventuallyDispose(L){return R.disposableTimeout(()=>this.unlisten(L),10*1e3)}createObserverData(L){const U=new le,G=this.listen(L,me=>U.apply(me)),te={observers:0,tests:U,listener:G};return this.resources.set(L.toString(),te),te}unlisten(L){var U;const G=L.toString(),te=this.resources.get(G);te&&(te.observers=-1,(U=te.pendingDeletion)===null||U===void 0||U.dispose(),te.listener.dispose(),this.resources.delete(G))}}class x extends q{constructor(L){super();this.proxy=L,this.diffListeners=new Map}acceptDiff(L,U){var G;(G=this.diffListeners.get(L.toString()))===null||G===void 0||G(U)}listen(L,U){this.proxy.$subscribeToDiffs(0,L);const G=L.toString();return this.diffListeners.set(G,U),D.toDisposable(()=>{this.proxy.$unsubscribeFromDiffs(0,L),this.diffListeners.delete(G)})}}class H extends q{constructor(L,U){super();this.proxy=L,this.documents=U,this.diffListeners=new Map}acceptDiff(L,U){var G;(G=this.diffListeners.get(L.toString()))===null||G===void 0||G(U)}listen(L,U){if(!this.documents.getDocument(L))return D.toDisposable(()=>{});const te=L.toString();return this.diffListeners.set(te,U),this.proxy.$subscribeToDiffs(1,L),D.toDisposable(()=>{this.proxy.$unsubscribeFromDiffs(1,L),this.diffListeners.delete(te)})}}const N=(M,L)=>`${M}:${L.toString()}`;class z extends D.Disposable{constructor(){super(...arguments);this.registeredEmitter=this._register(new A.Emitter),this.unregisteredEmitter=this._register(new A.Emitter),this.value=new Map,this.onRegistered=this.registeredEmitter.event}register(L,U){return this.value.set(L,U),this.registeredEmitter.fire({controller:U,controllerId:L}),D.toDisposable(()=>{this.value.delete(L),this.unregisteredEmitter.fire({controller:U,controllerId:L})})}get(L){return this.value.get(L)}[Symbol.iterator](){return this.value[Symbol.iterator]()}}let F=class extends D.Disposable{constructor(L,U,G,te){super();this.ownedTests=L,this.controllers=U,this.documents=G,this.workspace=te,this.subs=new Map,this._register(U.onRegistered(({controller:me,controllerId:Se})=>{const ye=[...this.subs.values()];setTimeout(()=>{for(const{subscribeFn:Le}of ye)Le(Se,me)},0)}))}getCollectionById(L){return p.mapFind(this.subs.values(),U=>U.collection.treeId===L?U.collection:void 0)}getCollectionTestByReference(L){return p.mapFind(this.subs.values(),U=>U.collection.getTestByReference(L))}async createDefaultDocumentTestRoot(L,U,G,te){if(!L)return;const{disposable:me,info:Se}=await this.subscribeToTests(0,L.uri);if(!Se)return;const ye=_.Iterable.find(Se.collection.roots,je=>je.src.controller===G);if(!ye)return;const Le=$.getWrapperForTestItem(ye.actual,U);return Se.collection.expand(ye.actual.id,Infinity),Le.refreshMatch(),te.onCancellationRequested(()=>{$.removeFilter(U),Le.dispose(),me.dispose()}),Le}async subscribeToTests(L,U){const G=N(L,U),te=this.subs.get(G);if(te)return te.listeners++,{disposable:this.getUnsubscriber(G),info:te};const me=new S.CancellationTokenSource;let Se;if(L===1){let Y=this.documents.getDocument(U);if(!Y){const ie=new D.DisposableStore;Y=await new Promise(re=>{ie.add(R.disposableTimeout(()=>re(void 0),5e3)),ie.add(this.documents.onDidAddDocuments(J=>{const ce=J.find(ge=>ge.document.uri.toString()===U.toString());ce&&re(ce)}))}).finally(()=>ie.dispose())}if(Y){const ie=await this.workspace.getWorkspaceFolder2(U,!1);Se=(re,J)=>re.createDocumentTestRoot?re.createDocumentTestRoot(Y.document,me.token):this.createDefaultDocumentTestRoot(ie,Y.document,J,me.token)}}else{const Y=await this.workspace.getWorkspaceFolder2(U,!1);Y&&(Se=ie=>ie.createWorkspaceTestRoot(Y,me.token))}if(!Se)return{disposable:D.toDisposable(()=>{}),info:void 0};const ye=async(Y,ie)=>{try{const re=await Se(ie,Y);re&&je.addRoot(re,Y)}catch(re){console.error(re)}},Le=new D.DisposableStore,je=Le.add(this.ownedTests.createForHierarchy());Le.add(D.toDisposable(()=>me.dispose(!0)));const ze=[];for(const[Y,ie]of this.controllers)ze.push(ye(Y,ie));const Ge=Promise.all(ze).then(()=>{}),j={store:Le,listeners:1,initialSubscribeP:Ge,collection:je,subscribeFn:ye};return this.subs.set(G,j),{disposable:this.getUnsubscriber(G),info:j}}getUnsubscriber(L){return D.toDisposable(()=>{const U=this.subs.get(L);U&&--U.listeners==0&&(U.store.dispose(),this.subs.delete(L))})}};F=qe([We(2,I.IExtHostDocumentsAndEditors),We(3,g.IExtHostWorkspace)],F)}),define(pe[254],ve([0,1,18,68,30,75,23,10,9,24,8,15,2,140,168,116,45,204,252,31]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let d=class{constructor(E,y,a,T){this.configurationService=E,this.workspaceContextService=y,this.editorGroupsService=a,this.pathService=T}text(E,y,a={}){E=this.getContentPattern(E,a);const T=this.configurationService.getValue(),O=y&&y.some(Z=>!this.configurationService.getValue({resource:Z}).search.useRipgrep),$=this.commonQuery(y==null?void 0:y.map(I.toWorkspaceFolder),a);return Object.assign(Object.assign({},$),{type:2,contentPattern:E,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:T.search.usePCRE2||O||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(E,y){const a=this.configurationService.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const T=Object.assign(Object.assign({},E),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(E,y)&&(T.isCaseSensitive=!0),this.isMultiline(E)&&(T.isMultiline=!0),T}file(E,y={}){const a=this.commonQuery(E,y);return Object.assign(Object.assign({},a),{type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey})}handleIncludeExclude(E,y){return E?(E=Array.isArray(E)?E.map(n):n(E),y?this.parseSearchPaths(E):{pattern:t(...Array.isArray(E)?E:[E])}):{}}commonQuery(E=[],y={}){const a=this.handleIncludeExclude(y.includePattern,y.expandPatterns),T=this.handleIncludeExclude(y.excludePattern,y.expandPatterns),O=E.length>1,$=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,y,T)):E.map(q=>this.getFolderQueryForRoot(q,y,T,O))).filter(q=>!!q),Z={_reason:y._reason,folderQueries:$,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:T.pattern,includePattern:a.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const x=p.coalesce(p.flatten(this.editorGroupsService.groups.map(N=>N.editors.map(z=>z.resource)))).filter(N=>u.pathIncludedInQuery(Z,N.fsPath)),H=this.commonQueryFromFileList(x);return Object.assign(Object.assign({},Z),H)}const le=y.extraFileResources&&y.extraFileResources.filter(q=>u.pathIncludedInQuery(Z,q.fsPath));return Z.extraFileResources=le&&le.length?le:void 0,Z}commonQueryFromFileList(E){const y=[],a=new A.ResourceMap,T={};let O=!1;return E.forEach($=>{var Z,le;if($.scheme===P.Schemas.walkThrough)return;if(D.isAbsolutePath($)){const x=(le=(Z=this.workspaceContextService.getWorkspaceFolder($))===null||Z===void 0?void 0:Z.uri)!==null&&le!==void 0?le:$.with({path:_.dirname($.fsPath)});let H=a.get(x);H||(O=!0,H={folder:x,includePattern:{}},y.push(H),a.set(x,H));const N=_.relative(x.fsPath,$.fsPath);k.assertIsDefined(H.includePattern)[N.replace(/\\/g,"/")]=!0}else $.fsPath&&(O=!0,T[$.fsPath]=!0)}),{folderQueries:y,includePattern:T,usingSearchPaths:!0,excludePattern:O?void 0:{"**/*":!0}}}isCaseSensitive(E,y){if(y.isSmartCase){if(E.isRegExp){if(r.containsUppercaseCharacter(E.pattern,!0))return!0}else if(r.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}isMultiline(E){return E.isMultiline||E.isRegExp&&h.isMultilineRegexSource(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const y=H=>_.isAbsolute(H)||/^\.\.?([\/\\]|$)/.test(H),T=(Array.isArray(E)?E:i(E)).map(H=>{const N=this.pathService.resolvedUserHome;return N?S.untildify(H,N.scheme===P.Schemas.file?N.fsPath:N.path):H}),O=R.groupBy(T,H=>y(H)?"searchPaths":"exprSegments"),$=(O.exprSegments||[]).map(H=>r.rtrim(H,"/")).map(H=>r.rtrim(H,"\\")).map(H=>(H[0]==="."&&(H="*"+H),s(H))),Z={},le=this.expandSearchPathPatterns(O.searchPaths||[]);le&&le.length&&(Z.searchPaths=le);const q=p.flatten($),x=t(...q);return x&&(Z.pattern=x),Z}getExcludesForFolder(E,y){return y.disregardExcludeSettings?void 0:u.getExcludes(E,!y.disregardSearchExcludeSettings)}expandSearchPathPatterns(E){if(!E||!E.length)return[];const y=p.flatten(E.map(T=>{let{pathPortion:O,globPortion:$}=g(T);$&&($=o($));const Z=this.expandOneSearchPath(O);return p.flatten(Z.map(le=>this.resolveOneSearchPathPattern(le,$)))})),a=new Map;return y.forEach(T=>{const O=T.searchPath.toString(),$=a.get(O);$?T.pattern&&($.pattern=$.pattern||{},$.pattern[T.pattern]=!0):a.set(O,{searchPath:T.searchPath,pattern:T.pattern?t(T.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(E){if(_.isAbsolute(E)){const y=this.workspaceContextService.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==P.Schemas.file?[{searchPath:y[0].uri.with({path:E})}]:[{searchPath:l.URI.file(_.normalize(E))}]}if(this.workspaceContextService.getWorkbenchState()===2){const y=this.workspaceContextService.getWorkspace().folders[0].uri;if(E=n(E),E.startsWith("../")||E===".."){const T=_.posix.resolve(y.path,E);return[{searchPath:y.with({path:T})}]}const a=o(E);return[{searchPath:y,pattern:a}]}else{if(E==="./"||E===".\\")return[];{const y=E.replace(/^\.[\/\\]/,""),T=this.workspaceContextService.getWorkspace().folders.map(O=>{const $=y.match(new RegExp(`^${r.escapeRegExpCharacters(O.name)}(?:/(.*)|$)`));return $?{match:$,folder:O}:null}).filter(k.isDefined);if(T.length)return T.map(O=>{const $=O.match[1];return{searchPath:O.folder.uri,pattern:$&&o($)}});{const O=E.match(/\.[\/\\](.+)[\/\\]?/),$=O?O[1]:E,Z=c.localize(0,null,$);throw new Error(Z)}}}}resolveOneSearchPathPattern(E,y){const a=E.pattern&&y?`${E.pattern}/${y}`:E.pattern||y,T=[{searchPath:E.searchPath,pattern:a}];return a&&!a.endsWith("**")&&T.push({searchPath:E.searchPath,pattern:a+"/**"}),T}getFolderQueryForSearchPath(E,y,a){const T=this.getFolderQueryForRoot(I.toWorkspaceFolder(E.searchPath),y,a,!1);return T?Object.assign(Object.assign({},T),{includePattern:E.pattern}):null}getFolderQueryForRoot(E,y,a,T){let O;const $=l.URI.isUri(E)?E:E.uri;if(a.searchPaths){const H=a.searchPaths.filter(N=>D.isEqual(N.searchPath,$))[0];if(H&&!H.pattern)return null;H&&(O=H.pattern)}const Z=this.configurationService.getValue({resource:$}),le=this.getExcludesForFolder(Z,y),q=Object.assign(Object.assign({},le||{}),O||{}),x=l.URI.isUri(E)?D.basename(E):E.name;return{folder:$,folderName:T?x:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:Z.files&&Z.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!Z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!Z.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!Z.search.followSymlinks}}};d=qe([We(0,f.IConfigurationService),We(1,I.IWorkspaceContextService),We(2,b.IEditorGroupsService),We(3,w.IPathService)],d),e.QueryBuilder=d;function g(m){const E=m.match(/[\*\{\}\(\)\[\]\?]/);if(E){const y=E.index,a=m.substr(0,y).match(/[/|\\][^/\\]*$/);if(a){let T=m.substr(0,a.index);return T.match(/[/\\]/)||(T+="/"),{pathPortion:T,globPortion:m.substr((a.index||0)+1)}}}return{pathPortion:m}}function t(...m){return m.length?m.reduce((E,y)=>(E[y]=!0,E),Object.create(null)):void 0}function i(m){return C.splitGlobAware(m,",").map(E=>E.trim()).filter(E=>!!E.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function n(m){return m.replace(/\\/g,"/")}function o(m){return n(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(m,E){m=p.distinct(m,T=>T.toString());const y=[],a=E.getWorkspace();return m&&m.forEach(T=>{let O;if(E.getWorkbenchState()===2)O=D.relativePath(a.folders[0].uri,T),O&&O!=="."&&(O="./"+O);else{const $=E.getWorkspaceFolder(T);if($){const Z=$.name;if(a.folders.filter(q=>q.name===Z).length===1){const q=D.relativePath($.uri,T);q===""?O=`./${$.name}`:O=`./${$.name}/${q}`}else O=T.fsPath}}O&&y.push(O)}),y}e.resolveResourcesForSearchIncludes=v}),define(pe[255],ve([0,1,24,2,21,14,4,254,31,45]),function(X,e,p,R,C,S,A,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const r=7e3;function k(f,I){const b=I.activationEvents;if(!b)return Promise.resolve(void 0);const w=[],u=[];for(const n of b)if(/^workspaceContains:/.test(n)){const o=n.substr("workspaceContains:".length);o.indexOf("*")>=0||o.indexOf("?")>=0||f.forceUsingSearch?u.push(o):w.push(o)}if(w.length===0&&u.length===0)return Promise.resolve(void 0);let d;const g=new Promise((n,o)=>{d=n}),t=n=>d({activationEvent:n}),i=Promise.all(w.map(n=>l(f,n,t))).then(()=>{}),s=h(f,I.identifier,u,t);return Promise.all([i,s]).then(()=>{d(void 0)}),g}e.checkActivateWorkspaceContainsExtension=k;async function l(f,I,b){for(const w of f.folders)if(await f.exists(p.joinPath(R.URI.revive(w),I))){b(`workspaceContains:${I}`);return}}async function h(f,I,b,w){if(b.length===0)return Promise.resolve(void 0);const u=new C.CancellationTokenSource,d=f.checkExists(f.folders,b,u.token),g=setTimeout(async()=>{u.cancel(),w(`workspaceContainsTimeout:${b.join(",")}`)},r);let t=!1;try{t=await d}catch(i){S.isPromiseCanceledError(i)||S.onUnexpectedError(i)}u.dispose(),clearTimeout(g),t&&w(`workspaceContains:${b.join(",")}`)}function c(f,I,b,w){const u=f.get(A.IInstantiationService),d=f.get(_.ISearchService),t=u.createInstance(P.QueryBuilder).file(I.map(i=>D.toWorkspaceFolder(R.URI.revive(i))),{_reason:"checkExists",includePattern:b,exists:!0});return d.fileSearch(t,w).then(i=>!!i.limitHit,i=>S.isPromiseCanceledError(i)?!1:Promise.reject(i))}e.checkGlobFileExists=c});var it=this&&this.__classPrivateFieldSet||function(X,e,p,R,C){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!C)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?X!==e||!C:!e.has(X))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?C.call(X,p):C?C.value=p:e.set(X,p),p},$e=this&&this.__classPrivateFieldGet||function(X,e,p,R){if(p==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?X!==e||!R:!e.has(X))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?R:p==="a"?R.call(X):R?R.value:e.get(X)};define(pe[40],ve([0,1,159,9,66,24,16,6,23,2,12,5,36,215,88,34,35,213,14,26,22,191,7,117,4,27,89,13,79,47,33,3,255,86,193]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w,u,d,g,t,i,s,n,o,v,m,E,y,a,T,O,$){"use strict";var Z,le,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=s.createDecorator("IHostUtils");let x=class $n extends P.Disposable{constructor(F,M,L,U,G,te,me,Se,ye,Le){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=M,this._extHostContext=L,this._initData=me,this._extHostWorkspace=U,this._extHostConfiguration=G,this._logService=te,this._extHostTunnelService=ye,this._extHostTerminalService=Le,this._disposables=new P.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(k.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(k.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(k.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new A.Barrier,this._readyToStartExtensionHost=new A.Barrier,this._readyToRunExtensions=new A.Barrier,this._eagerExtensionsActivated=new A.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new O.ExtHostSecretState(this._extHostContext),this._storagePath=Se,this._instaService=F.createChild(new m.ServiceCollection([c.IExtHostStorage,this._storage],[O.IExtHostSecretState,this._secretState]));const je=new Set;this._initData.hostExtensions.forEach(ze=>je.add(u.ExtensionIdentifier.toKey(ze))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ze,Ge,j)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ze,w.transformErrorForSerialization(Ge),j)},actualActivateExtension:async(ze,Ge)=>{if(je.has(u.ExtensionIdentifier.toKey(ze)))return await this._mainThreadExtensionsProxy.$activateExtension(ze,Ge),new h.HostExtension;const j=this._registry.getExtensionDescription(ze);return this._activateExtension(j,Ge)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),C.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(F){w.onUnexpectedError(F)}}async deactivateAll(){let F=[];try{F=this._registry.getAllExtensionDescriptions().map(G=>G.identifier).filter(G=>this.isActivated(G)).map(G=>this._deactivate(G))}catch(M){}await Promise.all(F)}isActivated(F){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(F):!1}_activateByEvent(F,M){return this._activator.activateByEvent(F,M)}_activateById(F,M){return this._activator.activateById(F,M)}activateByIdWithErrors(F,M){return this._activateById(F,M).then(()=>{const L=this._activator.getActivatedExtension(F);if(L.activationFailed)return Promise.reject(L.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(F=>this._registry)}getExtensionExports(F){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(F).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const F=_.TernarySearchTree.forPaths(),M=this._registry.getAllExtensionDescriptions().map(L=>{if(!!this._getEntryPoint(L))return this._hostUtils.realpath(L.extensionLocation.fsPath).then(U=>F.set(D.URI.file(U).fsPath,L))});this._extensionPathIndex=Promise.all(M).then(()=>F)}return this._extensionPathIndex}_deactivate(F){let M=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(F))return M;const L=this._activator.getActivatedExtension(F);if(!L)return M;try{typeof L.module.deactivate=="function"&&(M=Promise.resolve(L.module.deactivate()).then(void 0,U=>(this._logService.error(U),Promise.resolve(void 0))))}catch(U){this._logService.error(U)}try{P.dispose(L.subscriptions)}catch(U){this._logService.error(U)}return M}async _activateExtension(F,M){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(F.identifier),this._doActivateExtension(F,M).then(L=>{const U=L.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(F.identifier,U.codeLoadingTime,U.activateCallTime,U.activateResolvedTime,M),this._logExtensionActivationTimes(F,M,"success",U),L},L=>{throw this._logExtensionActivationTimes(F,M,"failure"),L})}_logExtensionActivationTimes(F,M,L,U){const G=H(F,M);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},G),U||{}),{outcome:L}))}_doActivateExtension(F,M){const L=H(F,M);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",L);const U=this._getEntryPoint(F);if(!U)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${F.identifier.value} ${JSON.stringify(M)}`),this._logService.flush();const G=new h.ExtensionActivationTimesBuilder(M.startup);return Promise.all([this._loadCommonJSModule(F.identifier,S.joinPath(F.extensionLocation,U),G),this._loadExtensionContext(F)]).then(te=>(C.mark(`code/extHost/willActivateExtension/${F.identifier.value}`),$n._callActivate(this._logService,F.identifier,te[0],te[1],G))).then(te=>(C.mark(`code/extHost/didActivateExtension/${F.identifier.value}`),te))}_loadExtensionContext(F){const M=new g.ExtensionGlobalMemento(F,this._storage),L=new g.ExtensionMemento(F.identifier.value,!1,this._storage),U=new $.ExtensionSecrets(F,this._secretState),G=F.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,te=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${F.identifier.value}`),Promise.all([M.whenReady,L.whenReady,this._storagePath.whenReady]).then(()=>{const me=this;let Se;return Object.freeze({globalState:M,workspaceState:L,secrets:U,subscriptions:[],get extensionUri(){return F.extensionLocation},get extensionPath(){return F.extensionLocation.fsPath},asAbsolutePath(ye){return R.join(F.extensionLocation.fsPath,ye)},get storagePath(){var ye;return(ye=me._storagePath.workspaceValue(F))===null||ye===void 0?void 0:ye.fsPath},get globalStoragePath(){return me._storagePath.globalValue(F).fsPath},get logPath(){return R.join(me._initData.logsLocation.fsPath,F.identifier.value)},get logUri(){return D.URI.joinPath(me._initData.logsLocation,F.identifier.value)},get storageUri(){return me._storagePath.workspaceValue(F)},get globalStorageUri(){return me._storagePath.globalValue(F)},get extensionMode(){return G},get extension(){return Se===void 0&&(Se=new N(me,F.identifier,F,te)),Se},get extensionRuntime(){return I.checkProposedApiEnabled(F),me.extensionRuntime},get environmentVariableCollection(){return me._extHostTerminalService.getEnvironmentVariableCollection(F)}})})}static _callActivate(F,M,L,U,G){return L=L||{activate:void 0,deactivate:void 0},this._callActivateOptional(F,M,L,U,G).then(te=>new h.ActivatedExtension(!1,null,G.build(),L,te,U.subscriptions))}static _callActivateOptional(F,M,L,U,G){if(typeof L.activate=="function")try{G.activateCallStart(),F.trace(`ExtensionService#_callActivateOptional ${M.value}`);const te=typeof global=="object"?global:self,me=L.activate.apply(te,[U]);return G.activateCallStop(),G.activateResolveStart(),Promise.resolve(me).then(Se=>(G.activateResolveStop(),Se))}catch(te){return Promise.reject(te)}else return Promise.resolve(L)}_activateOneStartupFinished(F,M){this._activateById(F.identifier,{startup:!1,extensionId:F.identifier,activationEvent:M}).then(void 0,L=>{this._logService.error(L)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(C.getMarks());for(const F of this._registry.getAllExtensionDescriptions())if(F.activationEvents)for(const M of F.activationEvents)M==="onStartupFinished"&&this._activateOneStartupFinished(F,M)}_handleEagerExtensions(){const F=this._activateByEvent("*",!0).then(void 0,G=>{this._logService.error(G)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(G=>this._handleWorkspaceContainsEagerExtensions(G.added)));const M=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],L=this._handleWorkspaceContainsEagerExtensions(M),U=Promise.all([F,L]).then(()=>{});return Promise.race([U,A.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),U}_handleWorkspaceContainsEagerExtensions(F){return F.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(M=>this._handleWorkspaceContainsEagerExtension(F,M))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(F,M){if(this.isActivated(M.identifier))return;const L=!this._initData.remote.isRemote&&!!this._initData.remote.authority,U={folders:F.map(te=>te.uri),forceUsingSearch:L,exists:te=>this._hostUtils.exists(te.fsPath),checkExists:(te,me,Se)=>this._mainThreadWorkspaceProxy.$checkExists(te,me,Se)},G=await T.checkActivateWorkspaceContainsExtension(U,M);if(!!G)return this._activateById(M.identifier,{startup:!0,extensionId:M.identifier,activationEvent:G.activationEvent}).then(void 0,te=>this._logService.error(te))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(F){throw console.error(F),F}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:F,extensionTestsLocationURI:M}=this._initData.environment;if(!F||!M)throw new Error(p.localize(0,null));const L=await this._loadCommonJSModule(null,M,new h.ExtensionActivationTimesBuilder(!1));if(!L||typeof L.run!="function")throw new Error(p.localize(1,null,M.toString()));return new Promise((U,G)=>{const te=(ye,Le)=>{ye?G(ye):U(typeof Le=="number"&&Le>0?1:0)},me=S.originalFSPath(M),Se=L.run(me,te);Se&&Se.then&&Se.then(()=>{U(0)}).catch(ye=>{G(ye.toString())})})}async $extensionTestsExit(F){this._logService.info(`extension host terminating: test runner requested exit with code ${F}`),this._logService.info(`exiting with code ${F}`),this._logService.flush(),this._hostUtils.exit(F)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(F,M){return this._resolvers[F]=M,P.toDisposable(()=>{delete this._resolvers[F]})}async _activateAndGetResolver(F){const M=F.indexOf("+");if(M===-1)throw new Error("Not an authority that can be resolved!");const L=F.substr(0,M);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${L}`,!1),{authorityPrefix:L,resolver:this._resolvers[L]}}async $resolveAuthority(F,M){const{authorityPrefix:L,resolver:U}=await this._activateAndGetResolver(F);if(!U)return{type:"error",error:{code:i.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${L}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(U)),C.mark(`code/extHost/willResolveAuthority/${L}`);const G=await U.resolve(F,{resolveAttempt:M});C.mark(`code/extHost/didResolveAuthorityOK/${L}`);const te={authority:F,host:G.host,port:G.port,connectionToken:G.connectionToken},me={extensionHostEnv:G.extensionHostEnv,isTrusted:G.isTrusted};return{type:"ok",value:{authority:te,options:me,tunnelInformation:{environmentTunnels:G.environmentTunnels}}}}catch(G){if(C.mark(`code/extHost/didResolveAuthorityError/${L}`),G instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:G._code,message:G._message,detail:G._detail}};throw G}}async $getCanonicalURI(F,M){const{authorityPrefix:L,resolver:U}=await this._activateAndGetResolver(F);if(!U)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${L}`);const G=D.URI.revive(M);if(typeof U.getCanonicalURI=="undefined")return G;const te=await A.asPromise(()=>U.getCanonicalURI(G));return te||G}$startExtensionHost(F){return this._registry.keepOnly(F),this._startExtensionHost()}$activateByEvent(F,M){return M===1?this._activateByEvent(F,!1):this._readyToRunExtensions.wait().then(L=>this._activateByEvent(F,!1))}async $activate(F,M){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(F)?(await this._activateById(F,M),!0):!1}async $deltaExtensions(F,M){F.forEach(U=>U.extensionLocation=D.URI.revive(U.extensionLocation));const L=await this.getExtensionPathIndex();return await Promise.all(M.map(async U=>{const G=this._registry.getExtensionDescription(U);if(!G)return;const te=await this._hostUtils.realpath(G.extensionLocation.fsPath);L.delete(D.URI.file(te).fsPath)})),await Promise.all(F.map(async U=>{const G=await this._hostUtils.realpath(U.extensionLocation.fsPath);L.set(D.URI.file(G).fsPath,U)})),this._registry.deltaExtensions(F,M),Promise.resolve(void 0)}async $test_latency(F){return F}async $test_up(F){return F.byteLength}async $test_down(F){let M=d.VSBuffer.alloc(F),L=Math.random()%256;for(let U=0;U<F;U++)M.writeUInt8(L,U);return M}async $updateRemoteConnectionData(F){this._remoteConnectionData=F,this._onDidChangeRemoteConnectionData.fire()}};x=qe([We(0,s.IInstantiationService),We(1,e.IHostUtils),We(2,v.IExtHostRpcService),We(3,f.IExtHostWorkspace),We(4,l.IExtHostConfiguration),We(5,r.ILogService),We(6,n.IExtHostInitDataService),We(7,o.IExtensionStoragePaths),We(8,E.IExtHostTunnelService),We(9,y.IExtHostTerminalService)],x),e.AbstractExtHostExtensionService=x;function H(z,F){return{id:z.identifier.value,name:z.name,extensionVersion:z.version,publisherDisplayName:z.publisher,activationEvents:z.activationEvents?z.activationEvents.join(","):null,isBuiltin:z.isBuiltin,reason:F.activationEvent,reasonId:F.extensionId.value}}e.IExtHostExtensionService=s.createDecorator("IExtHostExtensionService");class N{constructor(F,M,L,U){Z.set(this,void 0),le.set(this,void 0),q.set(this,void 0),it(this,Z,F,"f"),it(this,le,M,"f"),it(this,q,L.identifier,"f"),this.id=L.identifier.value,this.extensionUri=L.extensionLocation,this.extensionPath=R.normalize(S.originalFSPath(L.extensionLocation)),this.packageJSON=L,this.extensionKind=U}get isActive(){return $e(this,Z,"f").isActivated($e(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return $e(this,Z,"f").getExtensionExports($e(this,q,"f"))}activate(){return $e(this,Z,"f").activateByIdWithErrors($e(this,q,"f"),{startup:!1,extensionId:$e(this,le,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=N,Z=new WeakMap,le=new WeakMap,q=new WeakMap}),define(pe[49],ve([0,1,9,2,3,16,5,7,120,34,40,39,203,36,198,13,4,15,37,46]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=I.createDecorator("IExtHostDebugService");let d=class{constructor(m,E,y,a,T,O){this._workspaceService=E,this._extensionService=y,this._editorsService=a,this._configurationService=T,this._editorTabs=O,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new C.Emitter,this._onDidTerminateDebugSession=new C.Emitter,this._onDidChangeActiveDebugSession=new C.Emitter,this._onDidReceiveDebugSessionCustomEvent=new C.Emitter,this._debugServiceProxy=m.getProxy(A.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new C.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then($=>{$.onDidChange(Z=>{this.registerAllDebugTypes($)}),this.registerAllDebugTypes($)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(m,E){const y=m;if(typeof y.sourceReference=="number"&&y.sourceReference>0){let a=`debug:${encodeURIComponent(y.path||"")}`,T="?";return E&&(a+=`${T}session=${encodeURIComponent(E.id)}`,T="&"),a+=`${T}ref=${y.sourceReference}`,R.URI.parse(a)}else{if(y.path)return R.URI.file(y.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(m){const E=[];for(const y of m.getAllExtensionDescriptions())if(y.contributes){const a=y.contributes.debuggers;if(a&&a.length>0)for(const T of a)c.isDebuggerMainContribution(T)&&E.push(T.type)}this._debugServiceProxy.$registerDebugTypes(E)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const m=[];return this._breakpoints.forEach(E=>m.push(E)),m}addBreakpoints(m){this.startBreakpoints();const E=m.filter(T=>{const O=T.id;return this._breakpoints.has(O)?!1:(this._breakpoints.set(O,T),!0)});this.fireBreakpointChanges(E,[],[]);const y=[],a=new Map;for(const T of E)if(T instanceof P.SourceBreakpoint){let O=a.get(T.location.uri.toString());O||(O={type:"sourceMulti",uri:T.location.uri,lines:[]},a.set(T.location.uri.toString(),O),y.push(O)),O.lines.push({id:T.id,enabled:T.enabled,condition:T.condition,hitCondition:T.hitCondition,logMessage:T.logMessage,line:T.location.range.start.line,character:T.location.range.start.character})}else T instanceof P.FunctionBreakpoint&&y.push({type:"function",id:T.id,enabled:T.enabled,hitCondition:T.hitCondition,logMessage:T.logMessage,condition:T.condition,functionName:T.functionName});return this._debugServiceProxy.$registerBreakpoints(y)}removeBreakpoints(m){this.startBreakpoints();const E=m.filter(O=>this._breakpoints.delete(O.id));this.fireBreakpointChanges([],E,[]);const y=E.filter(O=>O instanceof P.SourceBreakpoint).map(O=>O.id),a=E.filter(O=>O instanceof P.FunctionBreakpoint).map(O=>O.id),T=E.filter(O=>O instanceof P.DataBreakpoint).map(O=>O.id);return this._debugServiceProxy.$unregisterBreakpoints(y,a,T)}startDebugging(m,E,y){return this._debugServiceProxy.$startDebugging(m?m.uri:void 0,E,{parentSessionID:y.parentSession?y.parentSession.id:void 0,repl:y.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:y.noDebug,compact:y.compact})}stopDebugging(m){return this._debugServiceProxy.$stopDebugging(m?m.id:void 0)}registerDebugConfigurationProvider(m,E,y){if(!E)return new P.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:m,handle:a,provider:E}),this._debugServiceProxy.$registerDebugConfigurationProvider(m,y,!!E.provideDebugConfigurations,!!E.resolveDebugConfiguration,!!E.resolveDebugConfigurationWithSubstitutedVariables,a),new P.Disposable(()=>{this._configProviders=this._configProviders.filter(T=>T.provider!==E),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(m,E,y){if(!y)return new P.Disposable(()=>{});if(!this.definesDebugType(m,E))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${E}' debugger.`);if(this.getAdapterDescriptorFactoryByType(E))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:E,handle:a,factory:y}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(E,a),new P.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(T=>T.factory!==y),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(m,E){if(!E)return new P.Disposable(()=>{});const y=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:m,handle:y,factory:E}),new P.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==E)})}async $runInTerminal(m,E){return Promise.resolve(void 0)}async $substituteVariables(m,E){if(!this._variableResolver){const[T,O]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(T||[],this._editorsService,O)}let y;const a=await this.getFolder(m);return a&&(y={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(y,E)}createDebugAdapter(m,E){if(m.type==="implementation")return new n(m.implementation)}createSignService(){}async $startDASession(m,E){const y=this,a=await this.getSession(E);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const O=this.convertToDto(T),$=this.createDebugAdapter(O,a);if(!$)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const Z=$;return this._debugAdapters.set(m,Z),this.getDebugAdapterTrackers(a).then(le=>(le&&this._debugAdaptersTrackers.set(m,le),Z.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const x=q,H={type:"response",seq:0,command:x.command,request_seq:x.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const N=await this._signService.sign(x.arguments.value);H.body={signature:N},Z.sendResponse(H)}else throw new Error("no signer")}catch(N){H.success=!1,H.message=N.message,Z.sendResponse(H)}}else le&&le.onDidSendMessage&&le.onDidSendMessage(q),q=c.convertToVSCPaths(q,!0),y._debugServiceProxy.$acceptDAMessage(m,q)}),Z.onError(q=>{le&&le.onError&&le.onError(q),this._debugServiceProxy.$acceptDAError(m,q.name,q.message,q.stack)}),Z.onExit(q=>{le&&le.onExit&&le.onExit(b.withNullAsUndefined(q),void 0),this._debugServiceProxy.$acceptDAExit(m,b.withNullAsUndefined(q),void 0)}),le&&le.onWillStartSession&&le.onWillStartSession(),Z.startSession()))})}$sendDAMessage(m,E){E=c.convertToDAPaths(E,!1);const y=this._debugAdaptersTrackers.get(m);y&&y.onWillReceiveMessage&&y.onWillReceiveMessage(E);const a=this._debugAdapters.get(m);a&&a.sendMessage(E)}$stopDASession(m){const E=this._debugAdaptersTrackers.get(m);this._debugAdaptersTrackers.delete(m),E&&E.onWillStopSession&&E.onWillStopSession();const y=this._debugAdapters.get(m);return this._debugAdapters.delete(m),y?y.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(m){const E=[],y=[],a=[];if(m.added)for(const T of m.added){const O=T.id;if(O&&!this._breakpoints.has(O)){let $;if(T.type==="function")$=new P.FunctionBreakpoint(T.functionName,T.enabled,T.condition,T.hitCondition,T.logMessage);else if(T.type==="data")$=new P.DataBreakpoint(T.label,T.dataId,T.canPersist,T.enabled,T.hitCondition,T.condition,T.logMessage);else{const Z=R.URI.revive(T.uri);$=new P.SourceBreakpoint(new P.Location(Z,new P.Position(T.line,T.character)),T.enabled,T.condition,T.hitCondition,T.logMessage)}$._id=O,this._breakpoints.set(O,$),E.push($)}}if(m.removed)for(const T of m.removed){const O=this._breakpoints.get(T);O&&(this._breakpoints.delete(T),y.push(O))}if(m.changed){for(const T of m.changed)if(T.id){const O=this._breakpoints.get(T.id);if(O){if(O instanceof P.FunctionBreakpoint&&T.type==="function"){const $=O;$.enabled=T.enabled,$.condition=T.condition,$.hitCondition=T.hitCondition,$.logMessage=T.logMessage,$.functionName=T.functionName}else if(O instanceof P.SourceBreakpoint&&T.type==="source"){const $=O;$.enabled=T.enabled,$.condition=T.condition,$.hitCondition=T.hitCondition,$.logMessage=T.logMessage,$.location=new P.Location(R.URI.revive(T.uri),new P.Position(T.line,T.character))}a.push(O)}}}this.fireBreakpointChanges(E,y,a)}$provideDebugConfigurations(m,E,y){return S.asPromise(async()=>{const a=this.getConfigProviderByHandle(m);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const T=await this.getFolder(E);return a.provideDebugConfigurations(T,y)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(m,E,y,a){return S.asPromise(async()=>{const T=this.getConfigProviderByHandle(m);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const O=await this.getFolder(E);return T.resolveDebugConfiguration(O,y,a)})}$resolveDebugConfigurationWithSubstitutedVariables(m,E,y,a){return S.asPromise(async()=>{const T=this.getConfigProviderByHandle(m);if(!T)throw new Error("no DebugConfigurationProvider found");if(!T.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const O=await this.getFolder(E);return T.resolveDebugConfigurationWithSubstitutedVariables(O,y,a)})}async $provideDebugAdapter(m,E){const y=this.getAdapterDescriptorFactoryByHandle(m);if(!y)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(E);return this.getAdapterDescriptor(y,a).then(T=>{if(!T)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(T)})}async $acceptDebugSessionStarted(m){const E=await this.getSession(m);this._onDidStartDebugSession.fire(E)}async $acceptDebugSessionTerminated(m){const E=await this.getSession(m);E&&(this._onDidTerminateDebugSession.fire(E),this._debugSessions.delete(E.id))}async $acceptDebugSessionActiveChanged(m){this._activeDebugSession=m?await this.getSession(m):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(m,E){const y=await this.getSession(m);y&&y._acceptNameChanged(E)}async $acceptDebugSessionCustomEvent(m,E){const a={session:await this.getSession(m),event:E.event,body:E.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(m){if(m instanceof P.DebugAdapterExecutable)return{type:"executable",command:m.command,args:m.args,options:m.options};if(m instanceof P.DebugAdapterServer)return{type:"server",port:m.port,host:m.host};if(m instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:m.path};if(m instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:m.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(m){const E=this._adapterFactories.filter(y=>y.type===m);if(E.length>0)return E[0].factory}getAdapterDescriptorFactoryByHandle(m){const E=this._adapterFactories.filter(y=>y.handle===m);if(E.length>0)return E[0].factory}getConfigProviderByHandle(m){const E=this._configProviders.filter(y=>y.handle===m);if(E.length>0)return E[0].provider}definesDebugType(m,E){if(m.contributes){const y=m.contributes.debuggers;if(y&&y.length>0){for(const a of y)if(a.label&&a.type&&a.type===E)return!0}}return!1}getDebugAdapterTrackers(m){const y=m.configuration.type,a=this._trackerFactories.filter(T=>T.type===y||T.type==="*").map(T=>S.asPromise(()=>T.factory.createDebugAdapterTracker(m)).then(O=>O,O=>null));return Promise.race([Promise.all(a).then(T=>{const O=T.filter($=>!!$);if(O.length>0)return new s(O)}),new Promise((T,O)=>{const $=setTimeout(()=>{clearTimeout($),O(new Error("timeout"))},1e3)})]).catch(T=>{})}async getAdapterDescriptor(m,E){const y=E.configuration.debugServer;if(typeof y=="number")return Promise.resolve(new P.DebugAdapterServer(y));if(m){const T=await this._extensionService.getExtensionRegistry();return S.asPromise(()=>m.createDebugAdapterDescriptor(E,this.daExecutableFromPackage(E,T))).then(O=>{if(O)return O})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(E,a))}daExecutableFromPackage(m,E){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(m,E,y){(m.length>0||E.length>0||y.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:m,removed:E,changed:y}))}async getSession(m){if(m)if(typeof m=="string"){const E=this._debugSessions.get(m);if(E)return E}else{let E=this._debugSessions.get(m.id);if(!E){const y=await this.getFolder(m.folderUri),a=m.parent?this._debugSessions.get(m.parent):void 0;E=new g(this._debugServiceProxy,m.id,m.type,m.name,y,m.configuration,a),this._debugSessions.set(E.id,E),this._debugServiceProxy.$sessionCached(E.id)}return E}throw new Error("cannot find session")}getFolder(m){if(m){const E=R.URI.revive(m);return this._workspaceService.resolveWorkspaceFolder(E)}return Promise.resolve(void 0)}};d=qe([We(0,f.IExtHostRpcService),We(1,D.IExtHostWorkspace),We(2,r.IExtHostExtensionService),We(3,k.IExtHostDocumentsAndEditors),We(4,h.IExtHostConfiguration),We(5,u.IExtHostEditorTabs)],d),e.ExtHostDebugServiceBase=d;class g{constructor(m,E,y,a,T,O,$){this._debugServiceProxy=m,this._id=E,this._type=y,this._name=a,this._workspaceFolder=T,this._configuration=O,this._parentSession=$}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(m){this._name=m,this._debugServiceProxy.$setDebugSessionName(this._id,m)}get parentSession(){return this._parentSession}_acceptNameChanged(m){this._name=m}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(m,E){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,m,E)}getDebugProtocolBreakpoint(m){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,m.id)}}e.ExtHostDebugSession=g;class t{constructor(m){this.value=Object.freeze({append(E){m.$appendDebugConsole(E)},appendLine(E){this.append(E+`
`)}})}}e.ExtHostDebugConsole=t;class i extends l.AbstractVariableResolverService{constructor(m,E,y,a,T){function O(){if(E){const $=E.activeEditor();if($)return $.document.uri;const Z=a.tabs.filter(le=>le.isActive);if(Z.length>0)return Z[0].resource}}super({getFolderUri:$=>{const Z=m.filter(le=>le.name===$);if(Z&&Z.length>0)return Z[0].uri},getWorkspaceFolderCount:()=>m.length,getConfigurationValue:($,Z)=>y.getConfiguration(void 0,$).get(Z),getAppRoot:()=>w.cwd(),getExecPath:()=>w.env.VSCODE_EXEC_PATH,getFilePath:()=>{const $=O();if($)return p.normalize($.fsPath)},getWorkspaceFolderPathForFile:()=>{if(T){const $=O();if($){const Z=T.getWorkspaceFolder($);if(Z)return p.normalize(Z.uri.fsPath)}}},getSelectedText:()=>{if(E){const $=E.activeEditor();if($&&!$.selection.isEmpty)return $.document.getText($.selection)}},getLineNumber:()=>{if(E){const $=E.activeEditor();if($)return String($.selection.end.line+1)}}},void 0,Promise.resolve(w.env))}}e.ExtHostVariableResolverService=i;class s{constructor(m){this.trackers=m}onWillStartSession(){this.trackers.forEach(m=>m.onWillStartSession?m.onWillStartSession():void 0)}onWillReceiveMessage(m){this.trackers.forEach(E=>E.onWillReceiveMessage?E.onWillReceiveMessage(m):void 0)}onDidSendMessage(m){this.trackers.forEach(E=>E.onDidSendMessage?E.onDidSendMessage(m):void 0)}onWillStopSession(){this.trackers.forEach(m=>m.onWillStopSession?m.onWillStopSession():void 0)}onError(m){this.trackers.forEach(E=>E.onError?E.onError(m):void 0)}onExit(m,E){this.trackers.forEach(y=>y.onExit?y.onExit(m,E):void 0)}}class n extends _.AbstractDebugAdapter{constructor(m){super();this.implementation=m,m.onDidSendMessage(E=>{this.acceptMessage(E)})}startSession(){return Promise.resolve(void 0)}sendMessage(m){this.implementation.handleMessage(m)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let o=class extends d{constructor(m,E,y,a,T,O){super(m,E,y,a,T,O)}createVariableResolver(m,E,y){return new i(m,E,y,this._editorTabs)}};o=qe([We(0,f.IExtHostRpcService),We(1,D.IExtHostWorkspace),We(2,r.IExtHostExtensionService),We(3,k.IExtHostDocumentsAndEditors),We(4,h.IExtHostConfiguration),We(5,u.IExtHostEditorTabs)],o),e.WorkerExtHostDebugService=o}),define(pe[256],ve([0,1,66,2,5,36,35,26,13,27,4,40,37,12]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(u,d,g,t,i,s,n){this._apiFactory=u,this._extensionRegistry=d,this._instaService=g,this._extHostConfiguration=t,this._extHostExtensionService=i,this._initData=s,this._logService=n,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),p.mark("code/extHost/willWaitForConfig");const u=await this._extHostConfiguration.getConfigProvider();p.mark("code/extHost/didWaitForConfig");const d=await this._extHostExtensionService.getExtensionPathIndex();this.register(new f(this._apiFactory,d,this._extensionRegistry,u,this._logService)),this.register(this._instaService.createInstance(I)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,d,this._initData.environment.appUriScheme))}register(u){if(Array.isArray(u.nodeModuleName))for(let d of u.nodeModuleName)this._factories.set(d,u);else this._factories.set(u.nodeModuleName,u);typeof u.alternativeModuleName=="function"&&this._alternatives.push(d=>u.alternativeModuleName(d))}};c=qe([We(2,r.IInstantiationService),We(3,S.IExtHostConfiguration),We(4,k.IExtHostExtensionService),We(5,D.IExtHostInitDataService),We(6,h.ILogService)],c),e.RequireInterceptor=c;class f{constructor(u,d,g,t,i){this._apiFactory=u,this._extensionPaths=d,this._extensionRegistry=g,this._configProvider=t,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(u,d){const g=this._extensionPaths.findSubstr(d.fsPath);if(g){let t=this._extApiImpl.get(P.ExtensionIdentifier.toKey(g.identifier));return t||(t=this._apiFactory(g,this._extensionRegistry,this._configProvider),this._extApiImpl.set(P.ExtensionIdentifier.toKey(g.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((i,s)=>t+=`	${s} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${d.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(A.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let I=class{constructor(u,d){this.nodeModuleName="keytar";const{environment:g}=d,t=u.getProxy(C.MainContext.MainThreadKeytar);if(g.appRoot){let i=g.appRoot.fsPath;l.platform==="win32"&&(i=i.replace(/\\/g,"/")),i[i.length-1]==="/"&&(i=i.substr(0,i.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${i}/node_modules.asar/keytar`),this.alternativeNames.add(`${i}/node_modules/keytar`)}this._impl={getPassword:(i,s)=>t.$getPassword(i,s),setPassword:(i,s,n)=>t.$setPassword(i,s,n),deletePassword:(i,s)=>t.$deletePassword(i,s),findPassword:i=>t.$findPassword(i),findCredentials(i){return t.$findCredentials(i)}}}load(u,d){return this._impl}alternativeModuleName(u){const d=u.length;if(d<=7||!this.alternativeNames)return;const g=d-7;if((u.charAt(g)==="/"||u.charAt(g)==="\\")&&u.endsWith("keytar")&&(u=u.replace(/\\/g,"/"),this.alternativeNames.has(u)))return"keytar"}};I=qe([We(0,_.IExtHostRpcService),We(1,D.IExtHostInitDataService)],I);let b=class{constructor(u,d,g){this._extensionPaths=u,this._appUriScheme=d,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=g.getProxy(C.MainContext.MainThreadTelemetry);const t=g.getProxy(C.MainContext.MainThreadWindow);this._impl=(i,s)=>{const n=R.URI.parse(i);return s?this.callOriginal(i,s):n.scheme==="http"||n.scheme==="https"?t.$openUri(n,i,{allowTunneling:!0}):n.scheme==="mailto"||n.scheme===this._appUriScheme?t.$openUri(n,i,{}):this.callOriginal(i,s)}}load(u,d,g){const t=this._extensionPaths.findSubstr(d.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=g(u),this._impl}callOriginal(u,d){return this.sendNoForwardTelemetry(),this._original(u,d)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=qe([We(2,_.IExtHostRpcService)],b)}),define(pe[257],ve([0,1,165,11,7,199,34,40,39,36,33,13,49,188,16,200,46]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let b=class extends l.ExtHostDebugServiceBase{constructor(d,g,t,i,s,n,o){super(d,g,t,i,s,o);this._terminalService=n,this._integratedTerminalInstances=new w}createDebugAdapter(d,g){switch(d.type){case"server":return new S.SocketDebugAdapter(d);case"pipeServer":return new S.NamedPipeDebugAdapter(d);case"executable":return new S.ExecutableDebugAdapter(d,g.type)}return super.createDebugAdapter(d,g)}daExecutableFromPackage(d,g){const t=S.ExecutableDebugAdapter.platformAdapterExecutable(g.getAllExtensionDescriptions(),d.type);if(t)return new C.DebugAdapterExecutable(t.command,t.args,t.options)}createSignService(){return new h.SignService}async $runInTerminal(d,g){if(d.kind==="integrated"){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(O=>{this._integratedTerminalInstances.onTerminalClosed(O)}));const t=await this._configurationService.getConfigProvider(),i=this._terminalService.getDefaultShell(!0),s=this._terminalService.getDefaultShellArgs(!0),n=d.title||p.localize(0,null),o=JSON.stringify({shell:i,shellArgs:s});let v=await this._integratedTerminalInstances.checkout(o,n),m,E=!1;if(v)m=d.cwd;else{const O={shellPath:i,shellArgs:s,cwd:d.cwd,name:n};E=!0,v=this._terminalService.createTerminalFromOptions(O,{isFeatureTerminal:!0,useShellEnvironment:!0}),this._integratedTerminalInstances.insert(v,o)}v.show(!0);const y=await v.processId;E?await new Promise(O=>setTimeout(O,1e3)):t.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(i.indexOf("powershell")>=0||i.indexOf("pwsh")>=0||i.indexOf("cmd.exe")>=0?v.sendText("cls"):i.indexOf("bash")>=0?v.sendText("clear"):R.isWindows?v.sendText("cls"):v.sendText("clear"));const a=f.prepareCommand(i,d.args,m,d.env);v.sendText(a);const T=this.onDidTerminateDebugSession(O=>{O.id===g&&(this._integratedTerminalInstances.free(v),T.dispose())});return y}else if(d.kind==="external")return f.runInExternalTerminal(d,await this._configurationService.getConfigProvider());return super.$runInTerminal(d,g)}createVariableResolver(d,g,t){return new l.ExtHostVariableResolverService(d,g,t,this._editorTabs,this._workspaceService)}};b=qe([We(0,k.IExtHostRpcService),We(1,A.IExtHostWorkspace),We(2,P.IExtHostExtensionService),We(3,_.IExtHostDocumentsAndEditors),We(4,D.IExtHostConfiguration),We(5,r.IExtHostTerminalService),We(6,I.IExtHostEditorTabs)],b),e.ExtHostDebugService=b;class w{constructor(){this._terminalInstances=new Map}async checkout(d,g){const i=[...this._terminalInstances.entries()].map(([s,n])=>c.createCancelablePromise(async o=>{if(s.name!==g||n.lastUsedAt!==-1&&await f.hasChildProcesses(await s.processId))return null;const v=Date.now();return n.lastUsedAt+w.minUseDelay>v||o.isCancellationRequested||n.config!==d?null:(n.lastUsedAt=v,s)}));return await c.firstParallel(i,s=>!!s)}insert(d,g){this._terminalInstances.set(d,{lastUsedAt:Date.now(),config:g})}free(d){const g=this._terminalInstances.get(d);g&&(g.lastUsedAt=-1)}onTerminalClosed(d){this._terminalInstances.delete(d)}}w.minUseDelay=1e3}),define(pe[258],ve([0,1,9,2,110,34,49,39,36,33,13,27,65,10,12,61,46]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends l.ExtHostTaskBase{constructor(u,d,g,t,i,s,n,o,v){super(u,d,g,t,i,s,n,o);this.workspaceService=g,this.editorTabs=v,d.remote.isRemote&&d.remote.authority?this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:d.remote.authority,platform:process.platform}):this.registerTaskSystem(h.Schemas.file,{scheme:h.Schemas.file,authority:"",platform:process.platform}),this._proxy.$registerSupportedExecutions(!0,!0,!0)}async executeTask(u,d){const g=d;if(!d.execution&&g._id===void 0)throw new Error("Tasks to execute must include an execution");if(g._id!==void 0){const t=l.TaskHandleDTO.from(g,this.workspaceService),i=await this._proxy.$getTaskExecution(t);if(i.task===void 0)throw new Error("Task from execution DTO is undefined");const s=await this.getTaskExecution(i,d);return this._proxy.$executeTask(t).catch(()=>{}),s}else{const t=l.TaskDTO.from(d,u);if(t===void 0)return Promise.reject(new Error("Task is not valid"));l.CustomExecutionDTO.is(t.execution)&&await this.addCustomExecution(t,d,!1);const i=await this.getTaskExecution(await this._proxy.$getTaskExecution(t),d);return this._proxy.$executeTask(t).catch(()=>{}),i}}provideTasksInternal(u,d,g,t){const i=[];if(t)for(let s of t){this.checkDeprecation(s,g),(!s.definition||!u[s.definition.type])&&this._logService.warn(`The task [${s.source}, ${s.name}] uses an undefined task type. The task will be ignored in the future.`);const n=l.TaskDTO.from(s,g.extension);n&&(i.push(n),l.CustomExecutionDTO.is(n.execution)&&d.push(this.addCustomExecution(n,s,!0)))}return{tasks:i,extension:g.extension}}async resolveTaskInternal(u){return u}async getVariableResolver(u){if(this._variableResolver===void 0){const d=await this._configurationService.getConfigProvider();this._variableResolver=new A.ExtHostVariableResolverService(u,this._editorService,d,this.editorTabs,this.workspaceService)}return this._variableResolver}async $resolveVariables(u,d){const g=R.URI.revive(u),t={process:void 0,variables:Object.create(null)},i=await this._workspaceProvider.resolveWorkspaceFolder(g),s=await this._workspaceProvider.getWorkspaceFolders2();if(!s||!i)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const n=await this.getVariableResolver(s),o={uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}};for(let v of d.variables)t.variables[v]=await n.resolveAsync(o,v);if(d.process!==void 0){let v;if(d.process.path!==void 0){v=d.process.path.split(p.delimiter);for(let m=0;m<v.length;m++)v[m]=await n.resolveAsync(o,v[m])}t.process=await C.win32.findExecutable(await n.resolveAsync(o,d.process.name),d.process.cwd!==void 0?await n.resolveAsync(o,d.process.cwd):void 0,v)}return t}async $jsonTasksSupported(){return!0}async $findExecutable(u,d,g){return C.win32.findExecutable(u,d,g)}};b=qe([We(0,r.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,S.IExtHostWorkspace),We(3,P.IExtHostDocumentsAndEditors),We(4,_.IExtHostConfiguration),We(5,D.IExtHostTerminalService),We(6,c.ILogService),We(7,f.IExtHostApiDeprecationService),We(8,I.IExtHostEditorTabs)],b),e.ExtHostTask=b}),define(pe[259],ve([0,1,16,14,66,6,2,5,250,12,77,79,27,181,13,60,40,33]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class w{constructor(d,g,t,i){this._disposables=new S.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(d,null,i),g=w._transform(g,this._rpcProtocol);const s=new k.ServiceCollection(...r.getSingletonServiceDescriptors());s.set(l.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},g)),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(f.IURITransformerService,new f.URITransformerService(i)),s.set(I.IHostUtils,t);const n=new h.InstantiationService(s,!0),o=n.invokeFunction(y=>y.get(b.IExtHostTerminalService));this._disposables.add(o),this._logService=n.invokeFunction(y=>y.get(D.ILogService)),C.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",g),this._extensionService=n.invokeFunction(y=>y.get(I.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const v=new WeakMap;this._extensionService.getExtensionPathIndex().then(y=>{Error.prepareStackTrace=(a,T)=>{let O="",$,Z;for(const le of T)O+=`
	at ${le.toString()}`,Z=le.getFileName(),!$&&Z&&($=y.findSubstr(Z));return v.set(a,$),`${a.name||"Error"}: ${a.message||""}${O}`}});const m=this._rpcProtocol.getProxy(P.MainContext.MainThreadExtensionService),E=this._rpcProtocol.getProxy(P.MainContext.MainThreadErrors);R.setUnexpectedErrorHandler(y=>{const a=R.transformErrorForSerialization(y),T=v.get(y);T?m.$onExtensionRuntimeError(T.identifier,a):E.$onUnexpectedError(a)})}terminate(d){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${d}`),this._logService.flush(),this._disposables.dispose(),R.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const g=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([p.timeout(4e3),g]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(d,g){d.extensions.forEach(i=>i.extensionLocation=A.URI.revive(g.transformIncomingURIs(i.extensionLocation))),d.environment.appRoot=A.URI.revive(g.transformIncomingURIs(d.environment.appRoot));const t=d.environment.extensionDevelopmentLocationURI;return t&&(d.environment.extensionDevelopmentLocationURI=t.map(i=>A.URI.revive(g.transformIncomingURIs(i)))),d.environment.extensionTestsLocationURI=A.URI.revive(g.transformIncomingURIs(d.environment.extensionTestsLocationURI)),d.environment.globalStorageHome=A.URI.revive(g.transformIncomingURIs(d.environment.globalStorageHome)),d.environment.workspaceStorageHome=A.URI.revive(g.transformIncomingURIs(d.environment.workspaceStorageHome)),d.logsLocation=A.URI.revive(g.transformIncomingURIs(d.logsLocation)),d.logFile=A.URI.revive(g.transformIncomingURIs(d.logFile)),d.workspace=g.transformIncomingURIs(d.workspace),d}}e.ExtensionHostMain=w}),define(pe[260],ve([0,1,9,21,57,30,24,43,31]),function(X,e,p,R,C,S,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class D{constructor(l,h,c){this.config=l,this.provider=h,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=l.filePattern,this.includePattern=l.includePattern&&S.parse(l.includePattern),this.maxResults=l.maxResults||void 0,this.exists=l.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=l.excludePattern&&S.parse(l.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(l=>l.cancel()),this.activeCancellationTokens=new Set}search(l){const h=this.config.folderQueries||[];return new Promise((c,f)=>{const I=b=>{this.resultCount++,l(b)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const w=b.toString(),u=p.basename(w);this.globalExcludePattern&&this.globalExcludePattern(w,u)||this.matchFile(I,{base:b,basename:u})}),Promise.all(h.map(b=>this.searchInFolder(b,I))).then(b=>{c({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{f(new Error(C.toErrorMessage(b)))})})}async searchInFolder(l,h){const c=new R.CancellationTokenSource,f=this.getSearchOptionsForFolder(l),I=this.initDirectoryTree(),b=new _.QueryGlobTester(this.config,l),w=!b.hasSiblingExcludeClauses();let u;try{this.activeCancellationTokens.add(c),u=P.StopWatch.create();const d=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},f,c.token),g=u.elapsed(),t=P.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(d&&d.forEach(i=>{const s=p.posix.relative(l.folder.path,i.path);if(w){const n=p.basename(i.path);this.matchFile(h,{base:l.folder,relativePath:s,basename:n});return}this.addDirectoryEntries(I,l.folder,s,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(I,b,h),{providerTime:g,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(l){const h=_.resolvePatternsForProvider(this.config.includePattern,l.includePattern),c=_.resolvePatternsForProvider(this.config.excludePattern,l.excludePattern);return{folder:l.folder,excludes:c,includes:h,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}addDirectoryEntries({pathToEntries:l},h,c,f){if(c===this.filePattern){const b=p.basename(this.filePattern);this.matchFile(f,{base:h,relativePath:this.filePattern,basename:b})}function I(b){const w=p.basename(b),u=p.dirname(b);let d=l[u];d||(d=l[u]=[],I(u)),d.push({base:h,relativePath:b,basename:w})}I(c)}matchDirectoryTree({rootEntries:l,pathToEntries:h},c,f){const I=this,b=this.filePattern;function w(u){const d=S.hasSiblingFn(()=>u.map(g=>g.basename));for(let g=0,t=u.length;g<t;g++){const i=u[g],{relativePath:s,basename:n}=i;if(!c.includedInQuerySync(s,n,b!==n?d:void 0))continue;const o=h[s];if(o)w(o);else{if(s===b)continue;I.matchFile(f,i)}if(I.isLimitHit)break}}w(l)}matchFile(l,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||l(h))}}class r{constructor(){this.sessions=new Map}fileSearch(l,h,c,f){const I=this.getSessionTokenSource(l.cacheKey),b=new D(l,h,I&&I.token);let w=0;const u=d=>{w+=d.length,c(d.map(g=>this.rawMatchToSearchItem(g)))};return this.doSearch(b,r.BATCH_SIZE,u,f).then(d=>({limitHit:d.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:w,detailStats:d.stats}}))}clearCache(l){const h=this.getSessionTokenSource(l);h&&h.cancel()}getSessionTokenSource(l){if(!!l)return this.sessions.has(l)||this.sessions.set(l,new R.CancellationTokenSource),this.sessions.get(l)}rawMatchToSearchItem(l){return l.relativePath?{resource:A.joinPath(l.base,l.relativePath)}:{resource:l.base}}doSearch(l,h,c,f){f.onCancellationRequested(()=>{l.cancel()});const I=w=>{w&&(b.push(w),h>0&&b.length>=h&&(c(b),b=[]))};let b=[];return l.search(I).then(w=>(b.length&&c(b),w),w=>(b.length&&c(b),Promise.reject(w)))}}e.FileSearchManager=r,r.BATCH_SIZE=512}),define(pe[128],ve([0,1,9,18,21,57,24,30,2,31,10,15]),function(X,e,p,R,C,S,A,P,_,D,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class l{constructor(u,d,g){this.query=u,this.provider=d,this.fileUtils=g,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(u,d){const g=this.query.folderQueries||[],t=new C.CancellationTokenSource;return d.onCancellationRequested(()=>t.cancel()),new Promise((i,s)=>{this.collector=new c(u);let n=!1;const o=(v,m)=>{if(!n&&!this.isLimitHit){const E=this.resultSize(v);I(v)&&typeof this.query.maxResults=="number"&&this.resultCount+E>this.query.maxResults&&(this.isLimitHit=!0,n=!0,t.cancel(),v=this.trimResultToSize(v,this.query.maxResults-this.resultCount));const y=this.resultSize(v);this.resultCount+=y,(y>0||!I(v))&&this.collector.add(v,m)}};Promise.all(g.map((v,m)=>this.searchInFolder(v,E=>o(E,m),t.token))).then(v=>{t.dispose(),this.collector.flush();const m=v.some(E=>!!E&&!!E.limitHit);i({limitHit:this.isLimitHit||m,messages:R.flatten(v.map(E=>(E==null?void 0:E.message)?k.isArray(E.message)?E.message:[E.message]:[])),stats:{type:"textSearchProvider"}})},v=>{t.dispose();const m=S.toErrorMessage(v);s(new Error(m))})})}resultSize(u){return I(u)?Array.isArray(u.ranges)?u.ranges.length:1:0}trimResultToSize(u,d){const g=Array.isArray(u.ranges)?u.ranges:[u.ranges],t=Array.isArray(u.preview.matches)?u.preview.matches:[u.preview.matches];return{ranges:g.slice(0,d),preview:{matches:t.slice(0,d),text:u.preview.text},uri:u.uri}}async searchInFolder(u,d,g){const t=new D.QueryGlobTester(this.query,u),i=[],s={report:v=>{if(!this.validateProviderResult(v))return;const m=u.folder.scheme===r.Schemas.file?P.hasSiblingPromiseFn(()=>this.fileUtils.readdir(A.dirname(v.uri))):void 0,E=A.relativePath(u.folder,v.uri);E&&i.push(t.includedInQuery(E,p.basename(E),m).then(y=>{y&&d(v)}))}},n=this.getSearchOptionsForFolder(u),o=await this.provider.provideTextSearchResults(h(this.query.contentPattern),n,s,g);return await Promise.all(i),o}validateProviderResult(u){if(I(u)){if(Array.isArray(u.ranges)){if(!Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(u.preview.matches.length!==u.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(u.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(u){const d=D.resolvePatternsForProvider(this.query.includePattern,u.includePattern),g=D.resolvePatternsForProvider(this.query.excludePattern,u.excludePattern),t={folder:_.URI.from(u.folder),excludes:g,includes:d,useIgnoreFiles:!u.disregardIgnoreFiles,useGlobalIgnoreFiles:!u.disregardGlobalIgnoreFiles,followSymlinks:!u.ignoreSymlinks,encoding:u.fileEncoding&&this.fileUtils.toCanonicalName(u.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=l;function h(w){return{isCaseSensitive:w.isCaseSensitive||!1,isRegExp:w.isRegExp||!1,isWordMatch:w.isWordMatch||!1,isMultiline:w.isMultiline||!1,pattern:w.pattern}}class c{constructor(u){this._onResult=u,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,d=>this.sendItems(d))}add(u,d){this._currentFileMatch&&(this._currentFolderIdx!==d||!A.isEqual(this._currentUri,u.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=d,this._currentFileMatch={resource:u.uri,results:[]}),this._currentFileMatch.results.push(f(u))}pushToCollector(){const u=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,u)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(u){this._onResult(u)}}e.TextSearchResultsCollector=c;function f(w){return I(w)?{preview:{matches:R.mapArrayOrNot(w.preview.matches,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character})),text:w.preview.text},ranges:R.mapArrayOrNot(w.ranges,u=>({startLineNumber:u.start.line,startColumn:u.start.character,endLineNumber:u.end.line,endColumn:u.end.character}))}:{text:w.text,lineNumber:w.lineNumber}}function I(w){return!!w.preview}e.extensionResultIsMatch=I;class b{constructor(u,d){this.maxBatchSize=u,this.cb=d,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(u,d){!u||this.addItemToBatch(u,d)}addItems(u,d){!u||this.addItemsToBatch(u,d)}addItemToBatch(u,d){this.batch.push(u),this.batchSize+=d,this.onUpdate()}addItemsToBatch(u,d){this.batch=this.batch.concat(u),this.batchSize+=d,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(pe[67],ve([0,1,6,5,4,260,13,60,12,2,128]),function(X,e,p,R,C,S,A,P,_,D,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=C.createDecorator("IExtHostSearch");let k=class{constructor(f,I,b){this.extHostRpc=f,this._uriTransformer=I,this._logService=b,this._proxy=this.extHostRpc.getProxy(R.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new S.FileSearchManager}_transformScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}registerTextSearchProvider(f,I){if(this._textSearchUsedSchemes.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this._textSearchUsedSchemes.add(f);const b=this._handlePool++;return this._textSearchProvider.set(b,I),this._proxy.$registerTextSearchProvider(b,this._transformScheme(f)),p.toDisposable(()=>{this._textSearchUsedSchemes.delete(f),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(f,I){if(this._fileSearchUsedSchemes.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this._fileSearchUsedSchemes.add(f);const b=this._handlePool++;return this._fileSearchProvider.set(b,I),this._proxy.$registerFileSearchProvider(b,this._transformScheme(f)),p.toDisposable(()=>{this._fileSearchUsedSchemes.delete(f),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(f,I,b,w){const u=l(b),d=this._fileSearchProvider.get(f);if(d)return this._fileSearchManager.fileSearch(u,d,g=>{this._proxy.$handleFileMatch(f,I,g.map(t=>t.resource))},w);throw new Error("unknown provider: "+f)}$clearCache(f){return this._fileSearchManager.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,I,b,w){const u=this._textSearchProvider.get(f);if(!u||!u.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const d=l(b);return this.createTextSearchManager(d,u).search(t=>this._proxy.$handleTextMatch(f,I,t),w)}createTextSearchManager(f,I){return new r.TextSearchManager(f,I,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};k=qe([We(0,A.IExtHostRpcService),We(1,P.IURITransformerService),We(2,_.ILogService)],k),e.ExtHostSearch=k;function l(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(h),extraFileResources:c.extraFileResources&&c.extraFileResources.map(f=>D.URI.revive(f))})}e.reviveQuery=l;function h(c){return Object.assign(Object.assign({},c),{folder:D.URI.revive(c.folder)})}}),define(pe[261],ve([0,1,21,14,3,54,2,150,106,141,76,42,5,221,220,48,222,36,223,224,225,206,226,39,40,227,207,229,230,231,62,209,236,237,238,88,33,239,210,17,7,242,63,127,34,35,68,197,228,81,4,126,65,49,67,12,60,13,27,232,195,47,61,218,240,194,89,87,245,243,244,219,59,253,241,86,46,118,234,64,235,10,183,233,192]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w,u,d,g,t,i,s,n,o,v,m,E,y,a,T,O,$,Z,le,q,x,H,N,z,F,M,L,U,G,te,me,Se,ye,Le,je,ze,Ge,j,Y,ie,re,J,ce,ge,Re,He,be,Qe,Q,se,we,Oe,Ue,Ye,De,_e,Pe,ae,fe,W,ee,de,Ie,Te,xe,Ve,Ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function rt(Xe){const Je=Xe.get(re.IExtHostInitDataService),ft=Xe.get(De.IExtHostFileSystemInfo),Ee=Xe.get(se.IExtHostConsumerFileSystem),Ce=Xe.get(s.IExtHostExtensionService),ue=Xe.get(L.IExtHostWorkspace),K=Xe.get(W.IExtHostTelemetry),Be=Xe.get(b.IExtHostConfiguration),Fe=Xe.get(Y.IURITransformerService),Me=Xe.get(ie.IExtHostRpcService),nt=Xe.get(Z.IExtHostStorage),ot=Xe.get(Q.IExtensionStoragePaths),tt=Xe.get(j.ILogService),vt=Xe.get(ge.IExtHostTunnelService),gt=Xe.get(Re.IExtHostApiDeprecationService),pt=Xe.get(M.IExtHostWindow),bt=Xe.get(ae.IExtHostSecretState),Tt=Xe.get(fe.IExtHostEditorTabs);Me.set(l.ExtHostContext.ExtHostFileSystemInfo,ft),Me.set(l.ExtHostContext.ExtHostLogService,tt),Me.set(l.ExtHostContext.ExtHostWorkspace,ue),Me.set(l.ExtHostContext.ExtHostConfiguration,Be),Me.set(l.ExtHostContext.ExtHostExtensionService,Ce),Me.set(l.ExtHostContext.ExtHostStorage,nt),Me.set(l.ExtHostContext.ExtHostTunnelService,vt),Me.set(l.ExtHostContext.ExtHostWindow,pt),Me.set(l.ExtHostContext.ExtHostSecretState,bt),Me.set(l.ExtHostContext.ExtHostTelemetry,K),Me.set(l.ExtHostContext.ExtHostEditorTabs,Tt);const It=Me.set(l.ExtHostContext.ExtHostDecorations,Xe.get(Le.IExtHostDecorations)),_t=Me.set(l.ExtHostContext.ExtHostDocumentsAndEditors,Xe.get(i.IExtHostDocumentsAndEditors)),ct=Me.set(l.ExtHostContext.ExtHostCommands,Xe.get(f.IExtHostCommands)),mt=Me.set(l.ExtHostContext.ExtHostTerminalService,Xe.get(le.IExtHostTerminalService)),Et=Me.set(l.ExtHostContext.ExtHostDebugService,Xe.get(ze.IExtHostDebugService)),Lt=Me.set(l.ExtHostContext.ExtHostSearch,Xe.get(Ge.IExtHostSearch)),St=Me.set(l.ExtHostContext.ExtHostTask,Xe.get(je.IExtHostTask)),Zt=Me.set(l.ExtHostContext.ExtHostOutputService,Xe.get(y.IExtHostOutputService)),qt=Me.set(l.ExtHostContext.ExtHostUrls,new z.ExtHostUrls(Me)),yt=Me.set(l.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Me,_t)),en=Me.set(l.ExtHostContext.ExtHostDocumentContentProviders,new d.ExtHostDocumentContentProvider(Me,_t,tt)),tn=Me.set(l.ExtHostContext.ExtHostDocumentSaveParticipant,new g.ExtHostDocumentSaveParticipant(tt,yt,Me.getProxy(l.MainContext.MainThreadBulkEdits))),ht=Me.set(l.ExtHostContext.ExtHostNotebook,new J.ExtHostNotebookController(Me,ct,_t,yt,ot)),Gt=Me.set(l.ExtHostContext.ExtHostNotebookDocuments,new Ze.ExtHostNotebookDocuments(tt,ht)),$t=Me.set(l.ExtHostContext.ExtHostNotebookEditors,new Ve.ExtHostNotebookEditors(tt,Me,ht)),Cn=Me.set(l.ExtHostContext.ExtHostNotebookKernels,new ee.ExtHostNotebookKernels(Me,Je,ht,tt)),nn=Me.set(l.ExtHostContext.ExtHostNotebookRenderers,new Ie.ExtHostNotebookRenderers(Me,ht)),Ct=Me.set(l.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(Me,_t)),Kt=Me.set(l.ExtHostContext.ExtHostTreeViews,new x.ExtHostTreeViews(Me.getProxy(l.MainContext.MainThreadTreeViews),ct,tt)),rn=Me.set(l.ExtHostContext.ExtHostEditorInsets,new te.ExtHostEditorInsets(Me.getProxy(l.MainContext.MainThreadEditorInsets),Ct,Je)),Qt=Me.set(l.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(Me,tt)),ut=Me.set(l.ExtHostContext.ExtHostLanguageFeatures,new v.ExtHostLanguageFeatures(Me,Fe,yt,ct,Qt,tt,gt)),sn=Me.set(l.ExtHostContext.ExtHostFileSystem,new n.ExtHostFileSystem(Me,ut)),Ft=Me.set(l.ExtHostContext.ExtHostFileSystemEventService,new o.ExtHostFileSystemEventService(Me,tt,_t)),Wt=Me.set(l.ExtHostContext.ExtHostQuickOpen,T.createExtHostQuickOpen(Me,ue,ct)),pn=Me.set(l.ExtHostContext.ExtHostSCM,new O.ExtHostSCM(Me,ct,tt)),kn=Me.set(l.ExtHostContext.ExtHostComments,new I.ExtHostComments(Me,ct,yt)),vn=Me.set(l.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(Me.getProxy(l.MainContext.MainThreadProgress))),on=Me.set(l.ExtHostContext.ExtHosLabelService,new me.ExtHostLabelService(Me)),Xt=Me.set(l.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Me)),xt=Me.set(l.ExtHostContext.ExtHostAuthentication,new He.ExtHostAuthentication(Me)),Pn=Me.set(l.ExtHostContext.ExtHostTimeline,new be.ExtHostTimeline(Me,ct)),an=Me.set(l.ExtHostContext.ExtHostWebviews,new F.ExtHostWebviews(Me,{remote:Je.remote},ue,tt,gt)),ln=Me.set(l.ExtHostContext.ExtHostWebviewPanels,new Ue.ExtHostWebviewPanels(Me,an,ue)),Yt=Me.set(l.ExtHostContext.ExtHostCustomEditors,new Oe.ExtHostCustomEditors(Me,yt,ot,an,ln)),In=Me.set(l.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(Me,an)),Mt=Me.set(l.ExtHostContext.ExtHostTesting,new _e.ExtHostTesting(Me,Xe.get(ye.IInstantiationService),_t)),cn=Me.set(l.ExtHostContext.ExtHostUriOpeners,new Pe.ExtHostUriOpeners(Me)),An=G.values(l.ExtHostContext);Me.assertRegistered(An);const Ht=new Ye.ExtHostBulkEdits(Me,_t),Ot=new c.ExtHostClipboard(Me),un=new E.ExtHostMessageService(Me,tt),Pt=new u.ExtHostDialogs(Me),zt=new $.ExtHostStatusBar(Me,ct.converter),dn=new m.ExtHostLanguages(Me,yt);return h.ExtHostApiCommands.register(ct),function(Ne,hn,wn){const dt=function(){let ne=!Ne.isUnderDevelopment;function he(Ae){ne||(tt.info(`Extension '${Ne.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ne=!0)}return function Ae(st){if(Array.isArray(st))st.forEach(Ae);else if(typeof st=="string")he(st);else{const wt=st;typeof wt.scheme=="undefined"&&he(st),!Ne.enableProposedApi&&typeof wt.exclusive=="boolean"&&U.throwProposedApiError(Ne)}return st}}(),Tn={getSession(ne,he,Ae){return xt.getSession(Ne,ne,he,Ae)},get onDidChangeSessions(){return xt.onDidChangeSessions},registerAuthenticationProvider(ne,he,Ae,st){return xt.registerAuthenticationProvider(ne,he,Ae,st)},get onDidChangeAuthenticationProviders(){return U.checkProposedApiEnabled(Ne),xt.onDidChangeAuthenticationProviders},get providers(){return U.checkProposedApiEnabled(Ne),xt.providers},logout(ne,he){return U.checkProposedApiEnabled(Ne),xt.removeSession(ne,he)}},Rn={registerCommand(ne,he,Ae){return ct.registerCommand(!0,ne,he,Ae)},registerTextEditorCommand(ne,he,Ae){return ct.registerCommand(!0,ne,(...st)=>{const wt=Ct.getActiveTextEditor();if(!wt){tt.warn("Cannot execute "+ne+" because there is no active text editor.");return}return wt.edit(V=>{he.apply(Ae,[wt,V,...st])}).then(V=>{V||tt.warn("Edits from command "+ne+" were not applied.")},V=>{tt.warn("An error occurred while running command "+ne,V)})})},registerDiffInformationCommand:(ne,he,Ae)=>(U.checkProposedApiEnabled(Ne),ct.registerCommand(!0,ne,async(...st)=>{const wt=_t.activeEditor(!0);if(!wt){tt.warn("Cannot execute "+ne+" because there is no active text editor.");return}const V=await Ct.getDiffInformation(wt.id);he.apply(Ae,[V,...st])})),executeCommand(ne,...he){return ct.executeCommand(ne,...he)},getCommands(ne=!1){return ct.getCommands(ne)}},Jt={get machineId(){return Je.telemetryInfo.machineId},get sessionId(){return Je.telemetryInfo.sessionId},get language(){return Je.environment.appLanguage},get appName(){return Je.environment.appName},get appRoot(){var ne,he;return(he=(ne=Je.environment.appRoot)===null||ne===void 0?void 0:ne.fsPath)!==null&&he!==void 0?he:""},get uriScheme(){return Je.environment.appUriScheme},get clipboard(){return Ot.value},get shell(){return mt.getDefaultShell(!1)},get isTelemetryEnabled(){return K.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return K.onDidChangeTelemetryEnabled},get isNewAppInstall(){const ne=Date.now()-new Date(Je.telemetryInfo.firstSessionDate).getTime();return isNaN(ne)?!1:ne<1e3*60*60*24},openExternal(ne,he){return pt.openUri(ne,{allowTunneling:!!Je.remote.authority,allowContributedOpeners:he==null?void 0:he.allowContributedOpeners})},async asExternalUri(ne){if(ne.scheme===Je.environment.appUriScheme)return qt.createAppUri(ne);const he=xe.matchesScheme(ne,Te.Schemas.http)||xe.matchesScheme(ne,Te.Schemas.https);he||U.checkProposedApiEnabled(Ne);try{return await pt.asExternalUri(ne,{allowTunneling:!!Je.remote.authority})}catch(Ae){if(he)return ne;throw Ae}},get remoteName(){return Se.getRemoteName(Je.remote.authority)},get uiKind(){return Je.uiKind}};Je.environment.extensionTestsLocationURI||Object.freeze(Jt);const bn=Je.remote.isRemote?N.ExtensionKind.Workspace:N.ExtensionKind.UI,fn={registerTestController(ne){return U.checkProposedApiEnabled(Ne),Mt.registerTestController(Ne.identifier.value,ne)},createDocumentTestObserver(ne){return U.checkProposedApiEnabled(Ne),Mt.createTextDocumentTestObserver(ne)},createWorkspaceTestObserver(ne){return U.checkProposedApiEnabled(Ne),Mt.createWorkspaceTestObserver(ne)},runTests(ne){return U.checkProposedApiEnabled(Ne),Mt.runTests(ne)},createTestItem(ne,he){return new N.TestItemImpl(ne.id,ne.label,ne.uri,he)},createTestRun(ne,he,Ae){return U.checkProposedApiEnabled(Ne),Mt.createTestRun(ne,he,Ae)},get onDidChangeTestResults(){return U.checkProposedApiEnabled(Ne),Mt.onResultsChanged},get testResults(){return U.checkProposedApiEnabled(Ne),Mt.results}};fn.createTestRunTask=fn.createTestRun;const Ln={getExtension(ne){const he=hn.getExtensionDescription(ne);if(he)return new s.Extension(Ce,Ne.identifier,he,bn)},get all(){return hn.getAllExtensionDescriptions().map(ne=>new s.Extension(Ce,Ne.identifier,ne,bn))},get onDidChange(){return hn.onDidChange}},Fn={createDiagnosticCollection(ne){return Qt.createDiagnosticCollection(Ne.identifier,ne)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:ne=>Qt.getDiagnostics(ne),getLanguages(){return dn.getLanguages()},setTextDocumentLanguage(ne,he){return dn.changeLanguage(ne.uri,he)},match(ne,he){return r.score(H.LanguageSelector.from(ne),he.uri,he.languageId,!0)},registerCodeActionsProvider(ne,he,Ae){return ut.registerCodeActionProvider(Ne,dt(ne),he,Ae)},registerCodeLensProvider(ne,he){return ut.registerCodeLensProvider(Ne,dt(ne),he)},registerDefinitionProvider(ne,he){return ut.registerDefinitionProvider(Ne,dt(ne),he)},registerDeclarationProvider(ne,he){return ut.registerDeclarationProvider(Ne,dt(ne),he)},registerImplementationProvider(ne,he){return ut.registerImplementationProvider(Ne,dt(ne),he)},registerTypeDefinitionProvider(ne,he){return ut.registerTypeDefinitionProvider(Ne,dt(ne),he)},registerHoverProvider(ne,he){return ut.registerHoverProvider(Ne,dt(ne),he,Ne.identifier)},registerEvaluatableExpressionProvider(ne,he){return ut.registerEvaluatableExpressionProvider(Ne,dt(ne),he,Ne.identifier)},registerInlineValuesProvider(ne,he){return ut.registerInlineValuesProvider(Ne,dt(ne),he,Ne.identifier)},registerDocumentHighlightProvider(ne,he){return ut.registerDocumentHighlightProvider(Ne,dt(ne),he)},registerLinkedEditingRangeProvider(ne,he){return ut.registerLinkedEditingRangeProvider(Ne,dt(ne),he)},registerReferenceProvider(ne,he){return ut.registerReferenceProvider(Ne,dt(ne),he)},registerRenameProvider(ne,he){return ut.registerRenameProvider(Ne,dt(ne),he)},registerDocumentSymbolProvider(ne,he,Ae){return ut.registerDocumentSymbolProvider(Ne,dt(ne),he,Ae)},registerWorkspaceSymbolProvider(ne){return ut.registerWorkspaceSymbolProvider(Ne,ne)},registerDocumentFormattingEditProvider(ne,he){return ut.registerDocumentFormattingEditProvider(Ne,dt(ne),he)},registerDocumentRangeFormattingEditProvider(ne,he){return ut.registerDocumentRangeFormattingEditProvider(Ne,dt(ne),he)},registerOnTypeFormattingEditProvider(ne,he,Ae,...st){return ut.registerOnTypeFormattingEditProvider(Ne,dt(ne),he,[Ae].concat(st))},registerDocumentSemanticTokensProvider(ne,he,Ae){return ut.registerDocumentSemanticTokensProvider(Ne,dt(ne),he,Ae)},registerDocumentRangeSemanticTokensProvider(ne,he,Ae){return ut.registerDocumentRangeSemanticTokensProvider(Ne,dt(ne),he,Ae)},registerSignatureHelpProvider(ne,he,Ae,...st){return typeof Ae=="object"?ut.registerSignatureHelpProvider(Ne,dt(ne),he,Ae):ut.registerSignatureHelpProvider(Ne,dt(ne),he,typeof Ae=="undefined"?[]:[Ae,...st])},registerCompletionItemProvider(ne,he,...Ae){return ut.registerCompletionItemProvider(Ne,dt(ne),he,Ae)},registerInlineCompletionItemProvider(ne,he){return U.checkProposedApiEnabled(Ne),ut.registerInlineCompletionsProvider(Ne,dt(ne),he)},registerDocumentLinkProvider(ne,he){return ut.registerDocumentLinkProvider(Ne,dt(ne),he)},registerColorProvider(ne,he){return ut.registerColorProvider(Ne,dt(ne),he)},registerFoldingRangeProvider(ne,he){return ut.registerFoldingRangeProvider(Ne,dt(ne),he)},registerSelectionRangeProvider(ne,he){return ut.registerSelectionRangeProvider(Ne,ne,he)},registerCallHierarchyProvider(ne,he){return ut.registerCallHierarchyProvider(Ne,ne,he)},setLanguageConfiguration:(ne,he)=>ut.setLanguageConfiguration(Ne,ne,he),getTokenInformationAtPosition(ne,he){return U.checkProposedApiEnabled(Ne),dn.tokenAtPosition(ne,he)},registerInlayHintsProvider(ne,he){return U.checkProposedApiEnabled(Ne),ut.registerInlayHintsProvider(Ne,ne,he)}},Mn={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(ne,he,Ae){const st=await(A.URI.isUri(ne)?Promise.resolve(En.openTextDocument(ne)):Promise.resolve(ne));return Ct.showTextDocument(st,he,Ae)},createTextEditorDecorationType(ne){return Ct.createTextEditorDecorationType(Ne,ne)},onDidChangeActiveTextEditor(ne,he,Ae){return Ct.onDidChangeActiveTextEditor(ne,he,Ae)},onDidChangeVisibleTextEditors(ne,he,Ae){return Ct.onDidChangeVisibleTextEditors(ne,he,Ae)},onDidChangeTextEditorSelection(ne,he,Ae){return Ct.onDidChangeTextEditorSelection(ne,he,Ae)},onDidChangeTextEditorOptions(ne,he,Ae){return Ct.onDidChangeTextEditorOptions(ne,he,Ae)},onDidChangeTextEditorVisibleRanges(ne,he,Ae){return Ct.onDidChangeTextEditorVisibleRanges(ne,he,Ae)},onDidChangeTextEditorViewColumn(ne,he,Ae){return Ct.onDidChangeTextEditorViewColumn(ne,he,Ae)},onDidCloseTerminal(ne,he,Ae){return mt.onDidCloseTerminal(ne,he,Ae)},onDidOpenTerminal(ne,he,Ae){return mt.onDidOpenTerminal(ne,he,Ae)},onDidChangeActiveTerminal(ne,he,Ae){return mt.onDidChangeActiveTerminal(ne,he,Ae)},onDidChangeTerminalDimensions(ne,he,Ae){return U.checkProposedApiEnabled(Ne),mt.onDidChangeTerminalDimensions(ne,he,Ae)},onDidWriteTerminalData(ne,he,Ae){return U.checkProposedApiEnabled(Ne),mt.onDidWriteTerminalData(ne,he,Ae)},get state(){return pt.state},onDidChangeWindowState(ne,he,Ae){return pt.onDidChangeWindowState(ne,he,Ae)},showInformationMessage(ne,...he){return un.showMessage(Ne,S.default.Info,ne,he[0],he.slice(1))},showWarningMessage(ne,...he){return un.showMessage(Ne,S.default.Warning,ne,he[0],he.slice(1))},showErrorMessage(ne,...he){return un.showMessage(Ne,S.default.Error,ne,he[0],he.slice(1))},showQuickPick(ne,he,Ae){return Wt.showQuickPick(ne,!!Ne.enableProposedApi,he,Ae)},showWorkspaceFolderPick(ne){return Wt.showWorkspaceFolderPick(ne)},showInputBox(ne,he){return Wt.showInput(ne,he)},showOpenDialog(ne){return Pt.showOpenDialog(ne)},showSaveDialog(ne){return Pt.showSaveDialog(ne)},createStatusBarItem(ne,he,Ae){let st,wt,V;return typeof ne=="string"?(st=ne,wt=he,V=Ae):(wt=ne,V=he),zt.createStatusBarEntry(Ne,st,wt,V)},setStatusBarMessage(ne,he){return zt.setStatusBarMessage(ne,he)},withScmProgress(ne){return gt.report("window.withScmProgress",Ne,"Use 'withProgress' instead."),vn.withProgress(Ne,{location:N.ProgressLocation.SourceControl},(he,Ae)=>ne({report(st){}}))},withProgress(ne,he){return vn.withProgress(Ne,ne,he)},createOutputChannel(ne){return Zt.createOutputChannel(ne)},createWebviewPanel(ne,he,Ae,st){return ln.createWebviewPanel(Ne,ne,he,Ae,st)},createWebviewTextEditorInset(ne,he,Ae,st){return U.checkProposedApiEnabled(Ne),rn.createWebviewEditorInset(ne,he,Ae,st,Ne)},createTerminal(ne,he,Ae){return typeof ne=="object"?"pty"in ne?mt.createExtensionTerminal(ne):mt.createTerminalFromOptions(ne):mt.createTerminal(ne,he,Ae)},registerTerminalLinkProvider(ne){return mt.registerLinkProvider(ne)},registerTerminalProfileProvider(ne,he){return mt.registerProfileProvider(Ne,ne,he)},registerTreeDataProvider(ne,he){return Kt.registerTreeDataProvider(ne,he,Ne)},createTreeView(ne,he){return Kt.createTreeView(ne,he,Ne)},registerWebviewPanelSerializer:(ne,he)=>ln.registerWebviewPanelSerializer(Ne,ne,he),registerCustomEditorProvider:(ne,he,Ae={})=>Yt.registerCustomEditorProvider(Ne,ne,he,Ae),registerFileDecorationProvider(ne){return It.registerFileDecorationProvider(ne,Ne.identifier)},registerUriHandler(ne){return qt.registerUriHandler(Ne.identifier,ne)},createQuickPick(){return Wt.createQuickPick(Ne.identifier,!!Ne.enableProposedApi)},createInputBox(){return Wt.createInputBox(Ne.identifier)},get activeColorTheme(){return Xt.activeColorTheme},onDidChangeActiveColorTheme(ne,he,Ae){return Xt.onDidChangeActiveColorTheme(ne,he,Ae)},registerWebviewViewProvider(ne,he,Ae){return In.registerWebviewViewProvider(Ne,ne,he,Ae==null?void 0:Ae.webviewOptions)},get activeNotebookEditor(){return U.checkProposedApiEnabled(Ne),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(ne,he,Ae){return U.checkProposedApiEnabled(Ne),ht.onDidChangeActiveNotebookEditor(ne,he,Ae)},get visibleNotebookEditors(){return U.checkProposedApiEnabled(Ne),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return U.checkProposedApiEnabled(Ne),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ne,he,Ae){return U.checkProposedApiEnabled(Ne),$t.onDidChangeNotebookEditorSelection(ne,he,Ae)},onDidChangeNotebookEditorVisibleRanges(ne,he,Ae){return U.checkProposedApiEnabled(Ne),$t.onDidChangeNotebookEditorVisibleRanges(ne,he,Ae)},showNotebookDocument(ne,he){return U.checkProposedApiEnabled(Ne),ht.showNotebookDocument(ne,he)},registerExternalUriOpener(ne,he,Ae){return U.checkProposedApiEnabled(Ne),cn.registerExternalUriOpener(Ne.identifier,ne,he,Ae)},get openEditors(){return U.checkProposedApiEnabled(Ne),Tt.tabs},get onDidChangeOpenEditors(){return U.checkProposedApiEnabled(Ne),Tt.onDidChangeTabs},getInlineCompletionItemController(ne){return U.checkProposedApiEnabled(Ne),v.InlineCompletionController.get(ne)}},En={get rootPath(){return gt.report("workspace.rootPath",Ne,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ue.getPath()},set rootPath(ne){throw R.readonly()},getWorkspaceFolder(ne){return ue.getWorkspaceFolder(ne)},get workspaceFolders(){return ue.getWorkspaceFolders()},get name(){return ue.name},set name(ne){throw R.readonly()},get workspaceFile(){return ue.workspaceFile},set workspaceFile(ne){throw R.readonly()},updateWorkspaceFolders:(ne,he,...Ae)=>ue.updateWorkspaceFolders(Ne,ne,he||0,...Ae),onDidChangeWorkspaceFolders:function(ne,he,Ae){return ue.onDidChangeWorkspace(ne,he,Ae)},asRelativePath:(ne,he)=>ue.getRelativePath(ne,he),findFiles:(ne,he,Ae,st)=>ue.findFiles(H.GlobPattern.from(ne),H.GlobPattern.from(he),Ae,Ne.identifier,st),findTextInFiles:(ne,he,Ae,st)=>{let wt,V;return typeof he=="object"?(wt=he,V=Ae):(wt={},V=he,st=Ae),ue.findTextInFiles(ne,wt||{},V,Ne.identifier,st)},saveAll:ne=>ue.saveAll(ne),applyEdit(ne){return Ht.applyWorkspaceEdit(ne)},createFileSystemWatcher:(ne,he,Ae,st)=>Ft.createFileSystemWatcher(H.GlobPattern.from(ne),he,Ae,st),get textDocuments(){return yt.getAllDocumentData().map(ne=>ne.document)},set textDocuments(ne){throw R.readonly()},openTextDocument(ne){let he;const Ae=ne;if(typeof ne=="string")he=Promise.resolve(A.URI.file(ne));else if(A.URI.isUri(ne))he=Promise.resolve(ne);else if(!Ae||typeof Ae=="object")he=yt.createDocumentData(Ae);else throw new Error("illegal argument - uriOrFileNameOrOptions");return he.then(st=>yt.ensureDocumentData(st).then(wt=>wt.document))},onDidOpenTextDocument:(ne,he,Ae)=>yt.onDidAddDocument(ne,he,Ae),onDidCloseTextDocument:(ne,he,Ae)=>yt.onDidRemoveDocument(ne,he,Ae),onDidChangeTextDocument:(ne,he,Ae)=>yt.onDidChangeDocument(ne,he,Ae),onDidSaveTextDocument:(ne,he,Ae)=>yt.onDidSaveDocument(ne,he,Ae),onWillSaveTextDocument:(ne,he,Ae)=>tn.getOnWillSaveTextDocumentEvent(Ne)(ne,he,Ae),get notebookDocuments(){return ht.notebookDocuments.map(ne=>ne.apiNotebook)},async openNotebookDocument(ne,he){let Ae;if(A.URI.isUri(ne))Ae=ne,await ht.openNotebookDocument(ne);else if(typeof ne=="string")Ae=A.URI.revive(await ht.createNotebookDocument({viewType:ne,content:he}));else throw new Error("Invalid arguments");return ht.getNotebookDocument(Ae).apiNotebook},get onDidOpenNotebookDocument(){return ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ht.onDidCloseNotebookDocument},registerNotebookSerializer(ne,he,Ae,st){return ht.registerNotebookSerializer(Ne,ne,he,Ae,Ne.enableProposedApi?st:void 0)},registerNotebookContentProvider:(ne,he,Ae,st)=>(U.checkProposedApiEnabled(Ne),ht.registerNotebookContentProvider(Ne,ne,he,Ae,Ne.enableProposedApi?st:void 0)),onDidChangeConfiguration:(ne,he,Ae)=>wn.onDidChangeConfiguration(ne,he,Ae),getConfiguration(ne,he){return he=arguments.length===1?void 0:he,wn.getConfiguration(ne,he,Ne)},registerTextDocumentContentProvider(ne,he){return en.registerTextDocumentContentProvider(ne,he)},registerTaskProvider:(ne,he)=>(gt.report("window.registerTaskProvider",Ne,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider(Ne,ne,he)),registerFileSystemProvider(ne,he,Ae){return sn.registerFileSystemProvider(Ne.identifier,ne,he,Ae,Ne.enableProposedApi)},get fs(){return Ee.value},registerFileSearchProvider:(ne,he)=>(U.checkProposedApiEnabled(Ne),Lt.registerFileSearchProvider(ne,he)),registerTextSearchProvider:(ne,he)=>(U.checkProposedApiEnabled(Ne),Lt.registerTextSearchProvider(ne,he)),registerRemoteAuthorityResolver:(ne,he)=>(U.checkProposedApiEnabled(Ne),Ce.registerRemoteAuthorityResolver(ne,he)),registerResourceLabelFormatter:ne=>(U.checkProposedApiEnabled(Ne),on.$registerResourceLabelFormatter(ne)),onDidCreateFiles:(ne,he,Ae)=>Ft.onDidCreateFile(ne,he,Ae),onDidDeleteFiles:(ne,he,Ae)=>Ft.onDidDeleteFile(ne,he,Ae),onDidRenameFiles:(ne,he,Ae)=>Ft.onDidRenameFile(ne,he,Ae),onWillCreateFiles:(ne,he,Ae)=>Ft.getOnWillCreateFileEvent(Ne)(ne,he,Ae),onWillDeleteFiles:(ne,he,Ae)=>Ft.getOnWillDeleteFileEvent(Ne)(ne,he,Ae),onWillRenameFiles:(ne,he,Ae)=>Ft.getOnWillRenameFileEvent(Ne)(ne,he,Ae),openTunnel:ne=>(U.checkProposedApiEnabled(Ne),vt.openTunnel(Ne,ne).then(he=>{if(!he)throw new Error("cannot open tunnel");return he})),get tunnels(){return U.checkProposedApiEnabled(Ne),vt.getTunnels()},onDidChangeTunnels:(ne,he,Ae)=>(U.checkProposedApiEnabled(Ne),vt.onDidChangeTunnels(ne,he,Ae)),registerPortAttributesProvider:(ne,he)=>(U.checkProposedApiEnabled(Ne),vt.registerPortsAttributesProvider(ne,he)),registerTimelineProvider:(ne,he)=>(U.checkProposedApiEnabled(Ne),Pn.registerTimelineProvider(ne,he,Ne.identifier,ct.converter)),get isTrusted(){return ue.trusted},requestWorkspaceTrust:ne=>(U.checkProposedApiEnabled(Ne),ue.requestWorkspaceTrust(ne)),onDidGrantWorkspaceTrust:(ne,he,Ae)=>ue.onDidGrantWorkspaceTrust(ne,he,Ae)},_n={get inputBox(){return gt.report("scm.inputBox",Ne,"Use 'SourceControl.inputBox' instead"),pn.getLastInputBox(Ne)},createSourceControl(ne,he,Ae){return pn.createSourceControl(Ne,ne,he,Ae)}},Sn={createCommentController(ne,he){return kn.createCommentController(Ne,ne,he)}},Bt={get activeDebugSession(){return Et.activeDebugSession},get activeDebugConsole(){return Et.activeDebugConsole},get breakpoints(){return Et.breakpoints},onDidStartDebugSession(ne,he,Ae){return Et.onDidStartDebugSession(ne,he,Ae)},onDidTerminateDebugSession(ne,he,Ae){return Et.onDidTerminateDebugSession(ne,he,Ae)},onDidChangeActiveDebugSession(ne,he,Ae){return Et.onDidChangeActiveDebugSession(ne,he,Ae)},onDidReceiveDebugSessionCustomEvent(ne,he,Ae){return Et.onDidReceiveDebugSessionCustomEvent(ne,he,Ae)},onDidChangeBreakpoints(ne,he,Ae){return Et.onDidChangeBreakpoints(ne,he,Ae)},registerDebugConfigurationProvider(ne,he,Ae){return Et.registerDebugConfigurationProvider(ne,he,Ae||N.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ne,he){return Et.registerDebugAdapterDescriptorFactory(Ne,ne,he)},registerDebugAdapterTrackerFactory(ne,he){return Et.registerDebugAdapterTrackerFactory(ne,he)},startDebugging(ne,he,Ae){return!Ae||typeof Ae=="object"&&"configuration"in Ae?Et.startDebugging(ne,he,{parentSession:Ae}):Et.startDebugging(ne,he,Ae||{})},stopDebugging(ne){return Et.stopDebugging(ne)},addBreakpoints(ne){return Et.addBreakpoints(ne)},removeBreakpoints(ne){return Et.removeBreakpoints(ne)},asDebugSourceUri(ne,he){return Et.asDebugSourceUri(ne,he)}},Vt={registerTaskProvider:(ne,he)=>St.registerTaskProvider(Ne,ne,he),fetchTasks:ne=>St.fetchTasks(ne),executeTask:ne=>St.executeTask(Ne,ne),get taskExecutions(){return St.taskExecutions},onDidStartTask:(ne,he,Ae)=>St.onDidStartTask(ne,he,Ae),onDidEndTask:(ne,he,Ae)=>St.onDidEndTask(ne,he,Ae),onDidStartTaskProcess:(ne,he,Ae)=>St.onDidStartTaskProcess(ne,he,Ae),onDidEndTaskProcess:(ne,he,Ae)=>St.onDidEndTaskProcess(ne,he,Ae)},On={createNotebookController(ne,he,Ae,st,wt){return Cn.createNotebookController(Ne,ne,he,Ae,st,Ne.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(ne,he)=>ht.registerNotebookCellStatusBarItemProvider(Ne,ne,he),get onDidSaveNotebookDocument(){return U.checkProposedApiEnabled(Ne),Gt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ne){return U.checkProposedApiEnabled(Ne),$t.createNotebookEditorDecorationType(ne)},createRendererMessaging(ne){return U.checkProposedApiEnabled(Ne),nn.createRendererMessaging(ne)},onDidChangeNotebookDocumentMetadata(ne,he,Ae){return U.checkProposedApiEnabled(Ne),Gt.onDidChangeNotebookDocumentMetadata(ne,he,Ae)},onDidChangeNotebookCells(ne,he,Ae){return U.checkProposedApiEnabled(Ne),ht.onDidChangeNotebookCells(ne,he,Ae)},onDidChangeNotebookCellExecutionState(ne,he,Ae){return U.checkProposedApiEnabled(Ne),ht.onDidChangeNotebookCellExecutionState(ne,he,Ae)},onDidChangeCellOutputs(ne,he,Ae){return U.checkProposedApiEnabled(Ne),ht.onDidChangeCellOutputs(ne,he,Ae)},onDidChangeCellMetadata(ne,he,Ae){return U.checkProposedApiEnabled(Ne),ht.onDidChangeCellMetadata(ne,he,Ae)},createConcatTextDocument(ne,he){return U.checkProposedApiEnabled(Ne),new Qe.ExtHostNotebookConcatDocument(ht,yt,ne,he)}};return{version:Je.version,authentication:Tn,commands:Rn,comments:Sn,debug:Bt,env:Jt,extensions:Ln,languages:Fn,notebooks:On,scm:_n,tasks:Vt,test:fn,window:Mn,workspace:En,Breakpoint:N.Breakpoint,CallHierarchyIncomingCall:N.CallHierarchyIncomingCall,CallHierarchyItem:N.CallHierarchyItem,CallHierarchyOutgoingCall:N.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:p.CancellationTokenSource,CandidatePortSource:l.CandidatePortSource,CodeAction:N.CodeAction,CodeActionKind:N.CodeActionKind,CodeActionTriggerKind:N.CodeActionTriggerKind,CodeLens:N.CodeLens,Color:N.Color,ColorInformation:N.ColorInformation,ColorPresentation:N.ColorPresentation,ColorThemeKind:N.ColorThemeKind,CommentMode:N.CommentMode,CommentThreadCollapsibleState:N.CommentThreadCollapsibleState,CompletionItem:N.CompletionItem,CompletionItemKind:N.CompletionItemKind,CompletionItemTag:N.CompletionItemTag,CompletionList:N.CompletionList,CompletionTriggerKind:N.CompletionTriggerKind,ConfigurationTarget:N.ConfigurationTarget,CustomExecution:N.CustomExecution,DebugAdapterExecutable:N.DebugAdapterExecutable,DebugAdapterInlineImplementation:N.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:N.DebugAdapterNamedPipeServer,DebugAdapterServer:N.DebugAdapterServer,DebugConfigurationProviderTriggerKind:N.DebugConfigurationProviderTriggerKind,DebugConsoleMode:N.DebugConsoleMode,DecorationRangeBehavior:N.DecorationRangeBehavior,Diagnostic:N.Diagnostic,DiagnosticRelatedInformation:N.DiagnosticRelatedInformation,DiagnosticSeverity:N.DiagnosticSeverity,DiagnosticTag:N.DiagnosticTag,Disposable:N.Disposable,DocumentHighlight:N.DocumentHighlight,DocumentHighlightKind:N.DocumentHighlightKind,DocumentLink:N.DocumentLink,DocumentSymbol:N.DocumentSymbol,EndOfLine:N.EndOfLine,EnvironmentVariableMutatorType:N.EnvironmentVariableMutatorType,EvaluatableExpression:N.EvaluatableExpression,InlineValueText:N.InlineValueText,InlineValueVariableLookup:N.InlineValueVariableLookup,InlineValueEvaluatableExpression:N.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:N.InlineCompletionTriggerKind,EventEmitter:C.Emitter,ExtensionKind:N.ExtensionKind,ExtensionMode:N.ExtensionMode,ExternalUriOpenerPriority:N.ExternalUriOpenerPriority,FileChangeType:N.FileChangeType,FileDecoration:N.FileDecoration,FileSystemError:N.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:N.FoldingRange,FoldingRangeKind:N.FoldingRangeKind,FunctionBreakpoint:N.FunctionBreakpoint,InlineCompletionItem:N.InlineSuggestion,InlineCompletionList:N.InlineSuggestions,Hover:N.Hover,IndentAction:D.IndentAction,Location:N.Location,MarkdownString:N.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:N.ParameterInformation,PortAutoForwardAction:N.PortAutoForwardAction,Position:N.Position,ProcessExecution:N.ProcessExecution,ProgressLocation:N.ProgressLocation,QuickInputButtons:N.QuickInputButtons,Range:N.Range,RelativePattern:N.RelativePattern,Selection:N.Selection,SelectionRange:N.SelectionRange,SemanticTokens:N.SemanticTokens,SemanticTokensBuilder:N.SemanticTokensBuilder,SemanticTokensEdit:N.SemanticTokensEdit,SemanticTokensEdits:N.SemanticTokensEdits,SemanticTokensLegend:N.SemanticTokensLegend,ShellExecution:N.ShellExecution,ShellQuoting:N.ShellQuoting,SignatureHelp:N.SignatureHelp,SignatureHelpTriggerKind:N.SignatureHelpTriggerKind,SignatureInformation:N.SignatureInformation,SnippetString:N.SnippetString,SourceBreakpoint:N.SourceBreakpoint,StandardTokenType:N.StandardTokenType,StatusBarAlignment:N.StatusBarAlignment,SymbolInformation:N.SymbolInformation,SymbolKind:N.SymbolKind,SymbolTag:N.SymbolTag,Task:N.Task,TaskGroup:N.TaskGroup,TaskPanelKind:N.TaskPanelKind,TaskRevealKind:N.TaskRevealKind,TaskScope:N.TaskScope,TerminalLink:N.TerminalLink,TerminalProfile:N.TerminalProfile,TextDocumentSaveReason:N.TextDocumentSaveReason,TextEdit:N.TextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:N.TextEditorLineNumbersStyle,TextEditorRevealType:N.TextEditorRevealType,TextEditorSelectionChangeKind:N.TextEditorSelectionChangeKind,ThemeColor:N.ThemeColor,ThemeIcon:N.ThemeIcon,TreeItem:N.TreeItem,TreeItemCollapsibleState:N.TreeItemCollapsibleState,UIKind:l.UIKind,Uri:A.URI,ViewColumn:N.ViewColumn,WorkspaceEdit:N.WorkspaceEdit,InlayHint:N.InlayHint,InlayHintKind:N.InlayHintKind,RemoteAuthorityResolverError:N.RemoteAuthorityResolverError,ResolvedAuthority:N.ResolvedAuthority,SourceControlInputBoxValidationType:N.SourceControlInputBoxValidationType,ExtensionRuntime:N.ExtensionRuntime,TimelineItem:N.TimelineItem,NotebookRange:N.NotebookRange,NotebookCellKind:N.NotebookCellKind,NotebookCellExecutionState:N.NotebookCellExecutionState,NotebookCellData:N.NotebookCellData,NotebookData:N.NotebookData,NotebookRendererScript:N.NotebookRendererScript,NotebookCellStatusBarAlignment:N.NotebookCellStatusBarAlignment,NotebookEditorRevealType:N.NotebookEditorRevealType,NotebookCellOutput:N.NotebookCellOutput,NotebookCellOutputItem:N.NotebookCellOutputItem,NotebookCellStatusBarItem:N.NotebookCellStatusBarItem,NotebookControllerAffinity:N.NotebookControllerAffinity,PortAttributes:N.PortAttributes,LinkedEditingRanges:N.LinkedEditingRanges,TestItemStatus:N.TestItemStatus,TestResultState:N.TestResultState,TestMessage:N.TestMessage,TextSearchCompleteMessageType:de.TextSearchCompleteMessageType,TestMessageSeverity:N.TestMessageSeverity,WorkspaceTrustState:N.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=rt}),define(pe[262],ve([0,1,77,62,34,126,36,48,39,33,65,49,67,89,88,47,61,127,87,59,86,118,46]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w,u,d,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.registerSingleton(h.IExtensionStoragePaths,h.ExtensionStoragePaths),p.registerSingleton(I.IExtHostApiDeprecationService,I.ExtHostApiDeprecationService),p.registerSingleton(P.IExtHostCommands,P.ExtHostCommands),p.registerSingleton(A.IExtHostConfiguration,A.ExtHostConfiguration),p.registerSingleton(w.IExtHostConsumerFileSystem,w.ExtHostConsumerFileSystem),p.registerSingleton(k.IExtHostDebugService,k.WorkerExtHostDebugService),p.registerSingleton(S.IExtHostDecorations,S.ExtHostDecorations),p.registerSingleton(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),p.registerSingleton(u.IExtHostFileSystemInfo,u.ExtHostFileSystemInfo),p.registerSingleton(R.IExtHostOutputService,R.ExtHostOutputService),p.registerSingleton(l.IExtHostSearch,l.ExtHostSearch),p.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),p.registerSingleton(r.IExtHostTask,r.WorkerExtHostTask),p.registerSingleton(D.IExtHostTerminalService,D.WorkerExtHostTerminalService),p.registerSingleton(f.IExtHostTunnelService,f.ExtHostTunnelService),p.registerSingleton(b.IExtHostWindow,b.ExtHostWindow),p.registerSingleton(C.IExtHostWorkspace,C.ExtHostWorkspace),p.registerSingleton(d.IExtHostSecretState,d.ExtHostSecretState),p.registerSingleton(g.IExtHostTelemetry,g.ExtHostTelemetry),p.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(pe[90],ve([0,1,18,12,31,64]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=A;function P(k,l,h,c){const f=p.mapArrayOrNot(h,_),I=new C.TextSearchMatch(l,f,c),b=I.preview.matches;return{ranges:p.mapArrayOrNot(f,D),uri:k,preview:{text:I.preview.text,matches:p.mapArrayOrNot(b,D)}}}e.createTextSearchResult=P;function _(k){return new C.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function D(k){return new S.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let r=class{constructor(l,h){this.prefix=l,this.logService=h}appendLine(l){this.logService.debug(`${this.prefix}#search`,l)}};r=qe([We(1,R.ILogService)],r),e.OutputChannel=r}),define(pe[263],ve([0,1,92,22]),function(X,e,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function C(t){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(i=>i===t)}e.isUTFEncoding=C,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const S=512,A=512,P=512*8,_=512*128;class D{constructor(i){this.iconvLiteDecoder=i}static async create(i){let s;if(i!==e.UTF8)s=(await new Promise((o,v)=>{X(["iconv-lite-umd"],o,v)})).getDecoder(h(i));else{const n=new TextDecoder;s={write(o){return n.decode(o,{stream:!0})},end(){return n.decode()}}}return new D(s)}write(i){return this.iconvLiteDecoder.write(i)}end(){return this.iconvLiteDecoder.end()}}function r(t,i){var s;const n=((s=i.minBytesRequiredForDetection)!==null&&s!==void 0?s:i.guessEncoding)?P:A;return new Promise((o,v)=>{const m=p.newWriteableStream(O=>O.join("")),E=[];let y=0,a;const T=async()=>{try{const O=await g({buffer:R.VSBuffer.concat(E),bytesRead:y},i.guessEncoding);O.encoding=await i.overwriteEncoding(O.encoding),a=await D.create(O.encoding);const $=a.write(R.VSBuffer.concat(E).buffer);m.write($),E.length=0,y=0,o({stream:m,detected:O})}catch(O){v(O)}};p.listenStream(t,{onData:async O=>{a?m.write(a.write(O.buffer)):(E.push(O),y+=O.byteLength,y>=n&&(t.pause(),await T(),setTimeout(()=>t.resume())))},onError:O=>m.error(O),onEnd:async()=>{a||await T(),m.end(a==null?void 0:a.end())}})})}e.toDecodeStream=r;async function k(t,i,s){const o=(await new Promise((E,y)=>{X(["iconv-lite-umd"],E,y)})).getEncoder(h(i),s);let v=!1,m=!1;return{read(){if(m)return null;const E=t.read();if(typeof E!="string"){if(m=!0,!v&&(s==null?void 0:s.addBOM))switch(i){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const y=o.end();return y&&y.length>0?(v=!0,R.VSBuffer.wrap(y)):null}return v=!0,R.VSBuffer.wrap(o.write(E))}}}e.toEncodeReadable=k;async function l(t){return(await new Promise((s,n)=>{X(["iconv-lite-umd"],s,n)})).encodingExists(h(t))}e.encodingExists=l;function h(t){return t===e.UTF8_with_bom||t===null?e.UTF8:t}e.toNodeEncoding=h;function c(t,i){if(!t||i<e.UTF16be_BOM.length)return null;const s=t.readUInt8(0),n=t.readUInt8(1);if(s===e.UTF16be_BOM[0]&&n===e.UTF16be_BOM[1])return e.UTF16be;if(s===e.UTF16le_BOM[0]&&n===e.UTF16le_BOM[1])return e.UTF16le;if(i<e.UTF8_BOM.length)return null;const o=t.readUInt8(2);return s===e.UTF8_BOM[0]&&n===e.UTF8_BOM[1]&&o===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=c;const f=["ascii","utf-16","utf-32"];async function I(t){const i=await new Promise((m,E)=>{X(["jschardet"],m,E)}),s=t.slice(0,_),n=u(s.buffer),o=i.detect(n);if(!o||!o.encoding)return null;const v=o.encoding.toLowerCase();return 0<=f.indexOf(v)?null:w(o.encoding)}const b={ibm866:"cp866",big5:"cp950"};function w(t){const i=t.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[i]||i}function u(t){let i="";for(let s=0;s<t.length;s++)i+=String.fromCharCode(t[s]);return i}function d(t){switch(t){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const i=t.match(/windows(\d+)/);return i?"windows-"+i[1]:t}}e.toCanonicalName=d;function g({buffer:t,bytesRead:i},s){let n=c(t,i),o=!1;if(n!==e.UTF16be&&n!==e.UTF16le&&t){let v=!0,m=!0,E=!1;for(let y=0;y<i&&y<S;y++){const a=y%2==1,T=t.readUInt8(y)===0;if(T&&(E=!0),v&&(a&&!T||!a&&T)&&(v=!1),m&&(a&&T||!a&&!T)&&(m=!1),T&&!v&&!m)break}E&&(v?n=e.UTF16le:m?n=e.UTF16be:o=!0)}return s&&!o&&!n&&t?I(t.slice(0,i)).then(v=>({seemsBinary:!1,encoding:v})):{seemsBinary:o,encoding:n}}e.detectEncodingFromBuffer=g,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(pe[129],ve([0,1,263,28,128]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class S extends C.TextSearchManager{constructor(P,_,D=R){super(P,_,{readdir:r=>D.Promises.readdir(r.fsPath),toCanonicalName:r=>p.toCanonicalName(r)})}}e.NativeTextSearchManager=S}),define(pe[264],ve([0,1,265,279,280,2,281]),function(X,e,p,R,C,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(k,l,h,c,f,I){const b=I.environment.useHostProxy,w=typeof b=="boolean"?b:!I.remote.isRemote,u=A.createProxyResolver({resolveProxy:g=>k.resolveProxy(g),getHttpProxySetting:()=>l.getConfiguration("http").get("proxy"),log:(g,t,...i)=>{switch(g){case A.LogLevel.Trace:c.trace(t,...i);break;case A.LogLevel.Debug:c.debug(t,...i);break;case A.LogLevel.Info:c.info(t,...i);break;case A.LogLevel.Warning:c.warn(t,...i);break;case A.LogLevel.Error:c.error(t,...i);break;case A.LogLevel.Critical:c.critical(t,...i);break;case A.LogLevel.Off:break;default:s(g,t,i);break}function s(n,o,...v){c.error("Unknown log level",n),c.error(o,...v)}},getLogLevel:()=>c.getLevel(),proxyResolveTelemetry:g=>{f.$publicLog2("resolveProxy",g)},useHostProxy:w,env:process.env}),d=_(l,u);return r(h,d)}e.connectProxyResolver=P;function _(k,l){const h={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(f=>{h.config=k.getConfiguration("http").get("proxySupport")||"off"});const c={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(f=>{c.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},p,A.createHttpPatch(p,l,{config:"off"},c,!0)),on:Object.assign({},p,A.createHttpPatch(p,l,{config:"on"},c,!0)),override:Object.assign({},p,A.createHttpPatch(p,l,{config:"override"},c,!0)),onRequest:Object.assign({},p,A.createHttpPatch(p,l,h,c,!0)),default:Object.assign(p,A.createHttpPatch(p,l,h,c,!1))},https:{off:Object.assign({},R,A.createHttpPatch(R,l,{config:"off"},c,!0)),on:Object.assign({},R,A.createHttpPatch(R,l,{config:"on"},c,!0)),override:Object.assign({},R,A.createHttpPatch(R,l,{config:"override"},c,!0)),onRequest:Object.assign({},R,A.createHttpPatch(R,l,h,c,!0)),default:Object.assign(R,A.createHttpPatch(R,l,h,c,!1))},tls:Object.assign(C,A.createTlsPatch(C))}}const D=new Map;function r(k,l){return k.getExtensionPathIndex().then(h=>{const c=X.__$__nodeRequire("module"),f=c._load;c._load=function(b,w,u){if(b==="tls")return l.tls;if(b!=="http"&&b!=="https")return f.apply(this,arguments);const d=l[b],g=h.findSubstr(S.URI.file(w.filename).fsPath);let t=D.get(g);if(t||D.set(g,t={}),!t[b]){let i=d.default;g&&g.enableProposedApi&&(i=d[g.proxySupport]||d.onRequest),t[b]=Object.assign({},i)}return t[b]}})}}),define(pe[266],ve([0,1,38,9,74,29,11,8,90,267]),function(X,e,p,R,C,S,A,P,_,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.foldersToIncludeGlobs=e.foldersToRgExcludeGlobs=e.spawnRipgrepCmd=void 0;const r=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(u,d,g,t){const i=l(u,d,g,t),s=d.folder.fsPath;return{cmd:p.spawn(r,i.args,{cwd:s}),rgDiskPath:r,siblingClauses:i.siblingClauses,rgArgs:i,cwd:s}}e.spawnRipgrepCmd=k;function l(u,d,g,t){const i=["--files","--hidden","--case-sensitive"];c([d],g,!1).forEach(n=>{const o=_.anchorGlob(n);if(i.push("-g",o),A.isMacintosh){const v=C.normalizeNFD(o);v!==o&&i.push("-g",v)}});const s=h([d],t,void 0,!1);return s.globArgs.forEach(n=>{const o=`!${_.anchorGlob(n)}`;if(i.push("-g",o),A.isMacintosh){const v=C.normalizeNFD(o);v!==o&&i.push("-g",v)}}),d.disregardIgnoreFiles!==!1?i.push("--no-ignore"):i.push("--no-ignore-parent"),d.ignoreSymlinks||i.push("--follow"),u.exists&&i.push("--quiet"),i.push("--no-config"),d.disregardGlobalIgnoreFiles&&i.push("--no-ignore-global"),{args:i,siblingClauses:s.siblingClauses}}function h(u,d,g,t=!0){const i=[];let s={};return u.forEach(n=>{const o=Object.assign({},n.excludePattern||{},d||{}),v=f(o,t?n.folder.fsPath:void 0,g);i.push(...v.globArgs),v.siblingClauses&&(s=Object.assign(s,v.siblingClauses))}),{globArgs:i,siblingClauses:s}}e.foldersToRgExcludeGlobs=h;function c(u,d,g=!0){const t=[];return u.forEach(i=>{const s=Object.assign({},d||{},i.includePattern||{}),n=f(s,g?i.folder.fsPath:void 0);t.push(...n.globArgs)}),t}e.foldersToIncludeGlobs=c;function f(u,d,g){const t=[],i={};return Object.keys(u).forEach(s=>{if(g&&g.has(s)||!s)return;const n=u[s];s=b(d?I(d,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof n=="boolean"&&n?(s.startsWith("\\\\")&&(s+="**"),t.push(w(s))):n&&n.when&&(i[s]=n)}),{globArgs:t,siblingClauses:i}}function I(u,d){return R.isAbsolute(d)?d:R.join(u,d)}e.getAbsoluteGlob=I;function b(u){return u=P.rtrim(u,"\\"),P.rtrim(u,"/")}function w(u){return S.getRoot(u).toLowerCase()==="c:/"?u.replace(/^c:[/\\]/i,"/"):u}e.fixDriveC=w}),define(pe[268],ve([0,1,38,56,9,100,18,57,30,74,29,11,43,8,15,28,31,266,97]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.rgErrorMsgForDisplay=e.Engine=e.FileWalker=void 0;const u=new Set;process.on("exit",()=>{u.forEach(s=>s())});class d{constructor(n){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=n,this.filePattern=n.filePattern||"",this.includePattern=n.includePattern&&_.parse(n.includePattern),this.maxResults=n.maxResults||null,this.exists=!!n.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=w.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=n.excludePattern&&_.parse(n.excludePattern),this.folderExcludePatterns=new Map,n.folderQueries.forEach(o=>{const v=Object.assign({},o.excludePattern||{},this.config.excludePattern||{}),m=o.folder.fsPath;n.folderQueries.map(E=>E.folder.fsPath).filter(E=>E!==m).forEach(E=>{r.isEqualOrParent(E,m)&&(v[C.relative(m,E)]=!0)}),this.folderExcludePatterns.set(m,new t(v,m))})}cancel(){this.isCanceled=!0}walk(n,o,v,m,E){if(this.fileWalkSW=l.StopWatch.create(!1),this.isCanceled)return E(null,this.isLimitHit);o.forEach(y=>{const a=C.basename(y.fsPath);this.globalExcludePattern&&this.globalExcludePattern(y.fsPath,a)||this.matchFile(v,{relativePath:y.fsPath,searchPath:void 0})}),this.cmdSW=l.StopWatch.create(!1),this.parallel(n,(y,a)=>{this.call(this.cmdTraversal,this,y,v,m,T=>{if(T){const O=P.toErrorMessage(T);console.error(O),this.errors.push(O),a(T,void 0)}else a(null,void 0)})},(y,a)=>{this.fileWalkSW.stop();const T=y?A.coalesce(y)[0]:null;E(T,this.isLimitHit)})}parallel(n,o,v){const m=new Array(n.length),E=new Array(n.length);let y=!1,a=0;if(n.length===0)return v(null,[]);n.forEach((T,O)=>{o(T,($,Z)=>{if($?(y=!0,m[O]=null,E[O]=$):(m[O]=Z,E[O]=null),++a===n.length)return v(y?E:null,m)})})}call(n,o,...v){try{n.apply(o,v)}catch(m){v[v.length-1](m)}}cmdTraversal(n,o,v,m){const E=n.folder.fsPath,y=k.isMacintosh;let a;const T=()=>a&&a.kill();u.add(T);let O=N=>{u.delete(T),O=()=>{},m(N)},$="";const Z=this.initDirectoryTree();let le;const q=b.spawnRipgrepCmd(this.config,n,this.config.includePattern,this.folderExcludePatterns.get(n.folder.fsPath).expression);a=q.cmd,le=!Object.keys(q.siblingClauses).length;const x=q.rgArgs.args.map(N=>N.match(/^-/)?N:`'${N}'`).join(" ");let H=`${q.rgDiskPath} ${x}
 - cwd: ${q.cwd}`;q.rgArgs.siblingClauses&&(H+=`
 - Sibling clauses: ${JSON.stringify(q.rgArgs.siblingClauses)}`),v({message:H}),this.cmdResultCount=0,this.collectStdout(a,"utf8",v,(N,z,F)=>{if(N){O(N);return}if(this.isLimitHit){O();return}const L=($+(y?D.normalizeNFC(z||""):z)).split(`
`);if(F){const U=L.length;L[U-1]=L[U-1].trim(),L[U-1]||L.pop()}else $=L.pop()||"";if(L.length&&L[0].indexOf(`
`)!==-1){O(new Error("Splitting up files failed"));return}if(this.cmdResultCount+=L.length,le){for(const U of L)if(this.matchFile(o,{base:E,relativePath:U,searchPath:this.getSearchPath(n,U)}),this.isLimitHit){T();break}(F||this.isLimitHit)&&O();return}this.addDirectoryEntries(n,Z,E,L,o),F&&(this.matchDirectoryTree(Z,E,o),O())})}spawnFindCmd(n){const o=this.folderExcludePatterns.get(n.folder.fsPath),v=o.getBasenameTerms(),m=o.getPathTerms(),E=["-L","."];if(v.length||m.length){E.push("-not","(","(");for(const y of v)E.push("-name",y),E.push("-o");for(const y of m)E.push("-path",y),E.push("-o");E.pop(),E.push(")","-prune",")")}return E.push("-type","f"),p.spawn("find",E,{cwd:n.folder.fsPath})}readStdout(n,o,v){let m="";this.collectStdout(n,o,()=>{},(E,y,a)=>{if(E){v(E);return}m+=y,a&&v(null,m)})}collectStdout(n,o,v,m){let E=(T,O,$)=>{(T||$)&&(E=()=>{},this.cmdSW&&this.cmdSW.stop()),m(T,O,$)},y=!1;n.stdout?(this.forwardData(n.stdout,o,E),n.stdout.once("data",()=>y=!0)):v({message:"stdout is null"});let a;n.stderr?a=this.collectData(n.stderr):v({message:"stderr is null"}),n.on("error",T=>{E(T)}),n.on("close",T=>{let O;!y&&(O=this.decodeData(a,o))&&i(O)?E(new Error(`command failed with error code ${T}: ${this.decodeData(a,o)}`)):(this.exists&&T===0&&(this.isLimitHit=!0),E(null,"",!0))})}forwardData(n,o,v){const m=new S.StringDecoder(o);return n.on("data",E=>{v(null,m.write(E))}),m}collectData(n){const o=[];return n.on("data",v=>{o.push(v)}),o}decodeData(n,o){const v=new S.StringDecoder(o);return n.map(m=>v.write(m)).join("")}initDirectoryTree(){const n={rootEntries:[],pathToEntries:Object.create(null)};return n.pathToEntries["."]=n.rootEntries,n}addDirectoryEntries(n,{pathToEntries:o},v,m,E){m.indexOf(this.filePattern)!==-1&&this.matchFile(E,{base:v,relativePath:this.filePattern,searchPath:this.getSearchPath(n,this.filePattern)});const y=a=>{const T=C.basename(a),O=C.dirname(a);let $=o[O];$||($=o[O]=[],y(O)),$.push({base:v,relativePath:a,basename:T,searchPath:this.getSearchPath(n,a)})};m.forEach(y)}matchDirectoryTree({rootEntries:n,pathToEntries:o},v,m){const E=this,y=this.folderExcludePatterns.get(v),a=this.filePattern;function T(O){E.directoriesWalked++;const $=_.hasSiblingFn(()=>O.map(Z=>Z.basename));for(let Z=0,le=O.length;Z<le;Z++){const q=O[Z],{relativePath:x,basename:H}=q;if(y.test(x,H,a!==H?$:void 0))continue;const N=o[x];if(N)T(N);else{if(E.filesWalked++,x===a)continue;E.matchFile(m,q)}if(E.isLimitHit)break}}T(n)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(n,o,v,m,E){const y=n.folder,a=_.hasSiblingFn(()=>v);this.parallel(v,(T,O)=>{if(this.isCanceled||this.isLimitHit)return O(null);const $=o?[o,T].join(C.sep):T;if(this.folderExcludePatterns.get(n.folder.fsPath).test($,T,this.config.filePattern!==T?a:void 0))return O(null);const Z=[y.fsPath,$].join(C.sep);R.lstat(Z,(le,q)=>{if(le||this.isCanceled||this.isLimitHit)return O(null);this.statLinkIfNeeded(Z,q,(x,H)=>x||this.isCanceled||this.isLimitHit?O(null):H.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(Z,q,(N,z)=>N||this.isCanceled||this.isLimitHit||(z=z||"",this.walkedPaths[z])?O(null):(this.walkedPaths[z]=!0,f.Promises.readdir(Z).then(F=>{if(this.isCanceled||this.isLimitHit)return O(null);this.doWalk(n,$,F,m,M=>O(M||null))},F=>{O(null)})))):(this.filesWalked++,$===this.filePattern||this.maxFilesize&&c.isNumber(H.size)&&H.size>this.maxFilesize||this.matchFile(m,{base:y.fsPath,relativePath:$,searchPath:this.getSearchPath(n,$)}),O(null,void 0)))})},T=>{const O=T&&A.coalesce(T);return E(O&&O.length>0?O[0]:void 0)})}matchFile(n,o){this.isFileMatch(o)&&(!this.includePattern||this.includePattern(o.relativePath,C.basename(o.relativePath)))&&(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||n(o))}isFileMatch(n){if(this.filePattern){if(this.filePattern==="*")return!0;if(this.normalizedFilePatternLowercase)return I.isFilePatternMatch(n,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(n,o,v){return o.isSymbolicLink()?R.stat(n,v):v(null,o)}realPathIfNeeded(n,o,v){return o.isSymbolicLink()?R.realpath(n,(m,E)=>m?v(m):v(null,E)):v(null,n)}getSearchPath(n,o){return n.folderName?C.join(n.folderName,o):o}}e.FileWalker=d;class g{constructor(n){this.folderQueries=n.folderQueries,this.extraFiles=n.extraFileResources||[],this.walker=new d(n)}search(n,o,v){this.walker.walk(this.folderQueries,this.extraFiles,n,o,(m,E)=>{v(m,{limitHit:E,stats:this.walker.getStats(),messages:[]})})}cancel(){this.walker.cancel()}}e.Engine=g;class t{constructor(n,o){this.expression=n,this.root=o,this.init(n)}init(n){let o,v;Object.keys(n).filter(m=>n[m]).forEach(m=>{C.isAbsolute(m)?(o=o||_.getEmptyExpression(),o[m]=n[m]):(v=v||_.getEmptyExpression(),v[m]=n[m])}),this.absoluteParsedExpr=o&&_.parse(o,{trimForExclusions:!0}),this.relativeParsedExpr=v&&_.parse(v,{trimForExclusions:!0})}test(n,o,v){return this.relativeParsedExpr&&this.relativeParsedExpr(n,o,v)||this.absoluteParsedExpr&&this.absoluteParsedExpr(C.join(this.root,n),o,v)}getBasenameTerms(){const n=[];return this.absoluteParsedExpr&&n.push(..._.getBasenameTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(..._.getBasenameTerms(this.relativeParsedExpr)),n}getPathTerms(){const n=[];return this.absoluteParsedExpr&&n.push(..._.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&n.push(..._.getPathTerms(this.relativeParsedExpr)),n}}function i(s){const n=s.trim().split(`
`),o=n[0].trim();if(o.startsWith("Error parsing regex"))return o;if(o.startsWith("regex parse error"))return h.uppercaseFirstLetter(n[n.length-1].trim());if(o.startsWith("error parsing glob")||o.startsWith("unsupported encoding"))return o.charAt(0).toUpperCase()+o.substr(1);if(o==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(o.startsWith("Literal "))return o}e.rgErrorMsgForDisplay=i}),define(pe[130],ve([0,1,38,282,100,18,68,30,9,8,2,31,64,283,267,90]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.spreadGlobComponents=e.RipgrepParser=e.buildRegexParseError=e.rgErrorMsgForDisplay=e.RipgrepTextSearchEngine=void 0;const I=c.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class b{constructor(y){this.outputChannel=y}provideTextSearchResults(y,a,T,O){return this.outputChannel.appendLine(`provideTextSearchResults ${y.pattern}, ${JSON.stringify(Object.assign(Object.assign({},a),{folder:a.folder.toString()}))}`),new Promise(($,Z)=>{O.onCancellationRequested(()=>M());const le=i(y,a),q=a.folder.fsPath,x=le.map(me=>me.match(/^-/)?me:`'${me}'`).join(" ");this.outputChannel.appendLine(`${I} ${x}
 - cwd: ${q}`);let H=p.spawn(I,le,{cwd:q});H.on("error",me=>{console.error(me),this.outputChannel.appendLine("Error: "+(me&&me.message)),Z(k.serializeSearchError(new k.SearchError(me&&me.message,k.SearchErrorCode.rgProcessError)))});let N=!1;const z=new d(a.maxResults,q,a.previewOptions);z.on("result",me=>{N=!0,U="",T.report(me)});let F=!1;const M=()=>{F=!0,H&&H.kill(),z&&z.cancel()};let L=!1;z.on("hitLimit",()=>{L=!0,M()});let U="";H.stdout.on("data",me=>{z.handleData(me),N||(U+=me)});let G=!1;H.stdout.once("data",()=>G=!0);let te="";H.stderr.on("data",me=>{const Se=me.toString();this.outputChannel.appendLine(Se),te+=Se}),H.on("close",()=>{if(this.outputChannel.appendLine(G?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(N?"Got result from parser":"No result from parser"),U&&this.outputChannel.appendLine(`Got data without result: ${U}`),this.outputChannel.appendLine(""),F)$({limitHit:L});else{z.flush(),H=null;let me;te&&!G&&(me=w(te))?Z(k.serializeSearchError(new k.SearchError(me.message,me.code))):$({limitHit:L})}})})}}e.RipgrepTextSearchEngine=b;function w(E){const y=E.split(`
`),a=y[0].trim();if(y.some(O=>O.startsWith("regex parse error")))return new k.SearchError(u(y),k.SearchErrorCode.regexParseError);const T=a.match(/grep config error: unknown encoding: (.*)/);if(T)return new k.SearchError(`Unknown encoding: ${T[1]}`,k.SearchErrorCode.unknownEncoding);if(a.startsWith("error parsing glob"))return new k.SearchError(a.charAt(0).toUpperCase()+a.substr(1),k.SearchErrorCode.globParseError);if(a.startsWith("the literal"))return new k.SearchError(a.charAt(0).toUpperCase()+a.substr(1),k.SearchErrorCode.invalidLiteral);if(a.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(a,k.SearchErrorCode.regexParseError)}e.rgErrorMsgForDisplay=w;function u(E){const y=["Regex parse error"],a=E.filter(T=>T.startsWith("PCRE2:"));if(a.length>=1){const T=a[0].replace("PCRE2:","");if(T.indexOf(":")!==-1&&T.split(":").length>=2){const O=T.split(":")[1];y.push(":"+O)}}return y.join("")}e.buildRegexParseError=u;class d extends R.EventEmitter{constructor(y,a,T){super();this.maxResults=y,this.rootFolder=a,this.previewOptions=T,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new C.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(y,a){return super.on(y,a),this}handleData(y){if(this.isDone)return;const a=typeof y=="string"?y:this.stringDecoder.write(y);this.handleDecodedData(a)}handleDecodedData(y){let a=y.indexOf(`
`);const T=this.remainder+y;if(a>=0)a+=this.remainder.length;else{this.remainder=T;return}let O=0;for(;a>=0;)this.handleLine(T.substring(O,a).trim()),O=a+1,a=T.indexOf(`
`,O);this.remainder=T.substring(O)}handleLine(y){if(this.isDone||!y)return;let a;try{a=JSON.parse(y)}catch(T){throw new Error(`malformed line from rg: ${y}`)}if(a.type==="match"){const T=g(a.data.path),O=r.URI.file(_.join(this.rootFolder,T)),$=this.createTextSearchMatch(a.data,O);this.onResult($),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if(a.type==="context"){const T=g(a.data.path),O=r.URI.file(_.join(this.rootFolder,T));this.createTextSearchContext(a.data,O).forEach(Z=>this.onResult(Z))}}createTextSearchMatch(y,a){const T=y.line_number-1;let O=!1,$=g(y.lines);T===0&&D.startsWithUTF8BOM($)&&(O=!0,$=D.stripUTF8BOM($));const Z=Buffer.from($);let le=0,q=0,x=T;y.submatches.length===0&&y.submatches.push($.length?{start:0,end:1,match:{text:$[0]}}:{start:0,end:0,match:{text:""}});const H=S.coalesce(y.submatches.map((N,z)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let F=g(N.match);T===0&&z===0&&O&&(F=D.stripUTF8BOM(F),N.start=N.start<=3?0:N.start-3,N.end=N.end<=3?0:N.end-3);const M=Z.slice(le,N.start).toString().length,L=q+M,U=t(F),G=x,te=U.numLines+G,me=U.numLines>0?U.lastLineLength:U.lastLineLength+L;return le=N.end,q=me,x=te,new l.Range(G,L,te,me)}));return f.createTextSearchResult(a,$,H,this.previewOptions)}createTextSearchContext(y,a){const T=g(y.lines),O=y.line_number;return T.replace(/\r?\n$/,"").split(`
`).map(($,Z)=>({text:$,uri:a,lineNumber:O+Z}))}onResult(y){this.emit("result",y)}}e.RipgrepParser=d;function g(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function t(E){const y=/\n/g;let a=0,T=-1,O;for(;O=y.exec(E);)a++,T=O.index;const $=T>=0?E.length-T-1:E.length;return{numLines:a,lastLineLength:$}}function i(E,y){const a=["--hidden"];a.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:T,otherIncludes:O}=A.groupBy(y.includes,Z=>Z.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(O&&O.length){const Z=new Set;O.forEach(le=>{Z.add(le)}),a.push("-g","!*"),Z.forEach(le=>{s(le).map(f.anchorGlob).forEach(q=>{a.push("-g",q)})})}T&&T.length&&T.forEach(Z=>{a.push("-g",Z)}),y.excludes.map(f.anchorGlob).forEach(Z=>a.push("-g",`!${Z}`)),y.maxFileSize&&a.push("--max-filesize",y.maxFileSize+""),y.useIgnoreFiles?a.push("--no-ignore-parent"):a.push("--no-ignore"),y.followSymlinks&&a.push("--follow"),y.encoding&&y.encoding!=="utf8"&&a.push("--encoding",y.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=D.escapeRegExpCharacters(E.pattern),E.isRegExp=!0),y.usePCRE2&&a.push("--pcre2"),a.push("--crlf"),E.isRegExp&&(E.pattern=n(E.pattern),a.push("--auto-hybrid-regex"));let $;if(E.isWordMatch){const le=D.createRegExp(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");a.push("--regexp",le)}else if(E.isRegExp){let Z=v(E.pattern);Z=m(Z),a.push("--regexp",Z)}else $=E.pattern,a.push("--fixed-strings");return a.push("--no-config"),y.useGlobalIgnoreFiles||a.push("--no-ignore-global"),a.push("--json"),E.isMultiline&&a.push("--multiline"),y.beforeContext&&a.push("--before-context",y.beforeContext+""),y.afterContext&&a.push("--after-context",y.afterContext+""),a.push("--"),$&&a.push($),a.push("."),a}function s(E){const y=P.splitGlobAware(E,"/");return y.map((a,T)=>y.slice(0,T+1).join("/"))}e.spreadGlobComponents=s;function n(E){const y=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(y);)E=E.replace(y,"$1\\x{$2}");const a=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(a);)E=E.replace(a,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=n;const o=E=>E.type==="Assertion"&&E.kind==="lookbehind";function v(E){let y;try{y=new h.RegExpParser().parsePattern(E)}catch(le){return E}let a="",T=0;const O=(le,q,x)=>{a+=E.slice(T,le)+x,T=q},$=[];return new h.RegExpVisitor({onCharacterEnter(le){if(le.raw!=="\\n")return;const q=$[0];if(!q)O(le.start,le.end,"\\r?\\n");else if(!$.some(o))if(q.type==="CharacterClass")if(q.negate){const x=E.slice(q.start+2,le.start)+E.slice(le.end,q.end-1);O(q.start,q.end,"(?!\\r?\\n"+(x?`|[${x}]`:"")+")")}else{const x=E.slice(q.start+1,le.start)+E.slice(le.end,q.end-1);O(q.start,q.end,x===""?"\\r?\\n":`(?:[${x}]|\\r?\\n)`)}else q.type==="Quantifier"&&O(le.start,le.end,"(?:\\r?\\n)")},onQuantifierEnter(le){$.unshift(le)},onQuantifierLeave(){$.shift()},onCharacterClassRangeEnter(le){$.unshift(le)},onCharacterClassRangeLeave(){$.shift()},onCharacterClassEnter(le){$.unshift(le)},onCharacterClassLeave(){$.shift()},onAssertionEnter(le){o(le)&&$.push(le)},onAssertionLeave(le){$[0]===le&&$.shift()}}).visit(y),a+=E.slice(T),a}e.fixRegexNewline=v;function m(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=m}),define(pe[269],ve([0,1,21,130,115,10]),function(X,e,p,R,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(D){this.outputChannel=D,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(D,r,k,l){const h=new R.RipgrepTextSearchEngine(this.outputChannel);if(r.folder.scheme===S.Schemas.userData){const c=Object.assign(Object.assign({},r),{folder:r.folder.with({scheme:S.Schemas.file})}),f=new C.Progress(I=>k.report(Object.assign(Object.assign({},I),{uri:I.uri.with({scheme:r.folder.scheme})})));return this.withToken(l,I=>h.provideTextSearchResults(D,c,f,I))}else return this.withToken(l,c=>h.provideTextSearchResults(D,r,k,c))}async withToken(D,r){const k=P(D);this.inProgress.add(k);const l=await r(k.token);return this.inProgress.delete(k),l}dispose(){this.inProgress.forEach(D=>D.cancel())}}e.RipgrepSearchProvider=A;function P(_){const D=new p.CancellationTokenSource;return _.onCancellationRequested(()=>D.cancel()),D}}),define(pe[270],ve([0,1,28,130,129]),function(X,e,p,R,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class S{constructor(_){this.query=_}search(_,D,r){if((!this.query.folderQueries||!this.query.folderQueries.length)&&(!this.query.extraFileResources||!this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(h){r({message:h})}},l=new C.NativeTextSearchManager(this.query,new R.RipgrepTextSearchEngine(k),p);return new Promise((h,c)=>l.search(f=>{D(f.map(A))},_).then(f=>h({limitHit:f.limitHit,type:"success"}),c))}}e.TextSearchEngineAdapter=S;function A(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((_,D)=>{if(D.ranges){const r=D;return _+(Array.isArray(r.ranges)?r.ranges.length:1)}else return _+1},0)}}}),define(pe[271],ve([0,1,56,284,18,16,14,3,97,9,43,2,42,31,268,270]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0,R.gracefulify(p);class I{constructor(){this.caches=Object.create(null)}fileSearch(t){let i;const s=u(t),n=new P.Emitter({onFirstListenerDidAdd:()=>{i=S.createCancelablePromise(o=>this.doFileSearchWithEngine(c.Engine,s,v=>n.fire(v),o)),i.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return n.event}textSearch(t){let i;const s=u(t),n=new P.Emitter({onFirstListenerDidAdd:()=>{i=S.createCancelablePromise(o=>this.ripgrepTextSearch(s,v=>n.fire(v),o)),i.then(o=>n.fire(o),o=>n.fire({type:"error",error:{message:o.message,stack:o.stack}}))},onLastListenerRemove:()=>{i.cancel()}});return n.event}ripgrepTextSearch(t,i,s){return t.maxFileSize=l.getPlatformLimits(process.arch==="ia32"?0:1).maxFileSize,new f.TextSearchEngineAdapter(t).search(s,i,i)}doFileSearch(t,i,s){return this.doFileSearchWithEngine(c.Engine,t,i,s)}doFileSearchWithEngine(t,i,s,n,o=I.BATCH_SIZE){let v=0;const m=y=>{Array.isArray(y)?(v+=y.length,s(y.map(a=>this.rawMatchToSearchItem(a)))):y.relativePath?(v++,s(this.rawMatchToSearchItem(y))):s(y)};if(i.sortByScore){let y=this.trySortedSearchFromCache(i,m,n);if(!y){const a=i.maxResults?Object.assign({},i,{maxResults:null}):i,T=new t(a);y=this.doSortedSearch(T,i,s,m,n)}return new Promise((a,T)=>{y.then(([O,$])=>{const Z=$.map(le=>this.rawMatchToSearchItem(le));this.sendProgress(Z,s,o),a(O)},T)})}const E=new t(i);return this.doSearch(E,m,o,n).then(y=>({limitHit:y.limitHit,type:"success",stats:{detailStats:y.stats,type:"searchProcess",fromCache:!1,resultCount:v,sortingTime:void 0}}))}rawMatchToSearchItem(t){return{path:t.base?D.join(t.base,t.relativePath):t.relativePath}}doSortedSearch(t,i,s,n,o){const v=new P.Emitter;let m=S.createCancelablePromise(y=>{let a=[];const T=O=>{Array.isArray(O)?a=O:(n(O),v.fire(O))};return this.doSearch(t,T,-1,y).then(O=>[O,a])}),E;if(i.cacheKey){E=this.getOrCreateCache(i.cacheKey);const y={promise:m,event:v.event,resolved:!1};E.resultsToSearchCache[i.filePattern||""]=y,m.then(()=>{y.resolved=!0},a=>{delete E.resultsToSearchCache[i.filePattern||""]}),m=this.preventCancellation(m)}return m.then(([y,a])=>{const T=E?E.scorerCache:Object.create(null),O=(typeof i.maxResults!="number"||i.maxResults>0)&&r.StopWatch.create(!1);return this.sortResults(i,a,T,o).then($=>{const Z=O?O.elapsed():-1;return[{type:"success",stats:{detailStats:y.stats,sortingTime:Z,fromCache:!1,type:"searchProcess",workspaceFolderCount:i.folderQueries.length,resultCount:$.length},messages:y.messages,limitHit:y.limitHit||typeof i.maxResults=="number"&&a.length>i.maxResults},$]})})}getOrCreateCache(t){const i=this.caches[t];return i||(this.caches[t]=new b)}trySortedSearchFromCache(t,i,s){const n=t.cacheKey&&this.caches[t.cacheKey];if(!n)return;const o=this.getResultsFromCache(n,t.filePattern||"",i,s);if(o)return o.then(([v,m,E])=>{const y=r.StopWatch.create(!1);return this.sortResults(t,m,n.scorerCache,s).then(a=>{const T=y.elapsed(),O={fromCache:!0,detailStats:E,type:"searchProcess",resultCount:m.length,sortingTime:T};return[{type:"success",limitHit:v.limitHit||typeof t.maxResults=="number"&&m.length>t.maxResults,stats:O},a]})})}sortResults(t,i,s,n){const o=_.prepareQuery(t.filePattern||""),v=(E,y)=>_.compareItemsByFuzzyScore(E,y,o,!0,w,s),m=typeof t.maxResults=="number"?t.maxResults:Number.MAX_VALUE;return C.topAsync(i,v,m,1e4,n)}sendProgress(t,i,s){if(s&&s>0)for(let n=0;n<t.length;n+=s)i(t.slice(n,n+s));else i(t)}getResultsFromCache(t,i,s,n){const o=r.StopWatch.create(!1),v=i.indexOf(D.sep)>=0;let m;for(const T in t.resultsToSearchCache)if(i.startsWith(T)){if(v&&T.indexOf(D.sep)<0&&T!=="")continue;const O=t.resultsToSearchCache[T];m={promise:this.preventCancellation(O.promise),event:O.event,resolved:O.resolved};break}if(!m)return null;const E=o.elapsed(),y=r.StopWatch.create(!1),a=m.event(s);return n&&n.onCancellationRequested(()=>{a.dispose()}),m.promise.then(([T,O])=>{if(n&&n.isCancellationRequested)throw A.canceled();const $=[],Z=_.prepareQuery(i).normalizedLowercase;for(const le of O)!h.isFilePatternMatch(le,Z)||$.push(le);return[T,$,{cacheWasResolved:m.resolved,cacheLookupTime:E,cacheFilterTime:y.elapsed(),cacheEntryCount:O.length}]})}doSearch(t,i,s,n){return new Promise((o,v)=>{let m=[];n&&n.onCancellationRequested(()=>t.cancel()),t.search(E=>{E&&(s?(m.push(E),s>0&&m.length>=s&&(i(m),m=[])):i(E))},E=>{i(E)},(E,y)=>{m.length&&i(m),E?v(E):o(y)})})}clearCache(t){return delete this.caches[t],Promise.resolve(void 0)}preventCancellation(t){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(i,s){return t.then(i,s)}catch(i){return this.then(void 0,i)}finally(i){return t.finally(i)}}}}e.SearchService=I,I.BATCH_SIZE=512;class b{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(g){return D.basename(g.relativePath)}getItemDescription(g){return D.dirname(g.relativePath)}getItemPath(g){return g.relativePath}};function u(g){return Object.assign(Object.assign({},g),{folderQueries:g.folderQueries&&g.folderQueries.map(d),extraFileResources:g.extraFileResources&&g.extraFileResources.map(t=>k.URI.revive(t))})}function d(g){return Object.assign(Object.assign({},g),{folder:k.URI.revive(g.folder)})}}),define(pe[272],ve([0,1,6,2,28,12,31,271,269,90,13,60,27,67,10,129]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let I=class extends h.ExtHostSearch{constructor(w,u,d,g){super(w,d,g);this._pfs=C,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null;const t=new D.OutputChannel("RipgrepSearchUD",this._logService);this.registerTextSearchProvider(c.Schemas.userData,new _.RipgrepSearchProvider(t)),u.remote.isRemote&&u.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const w=new D.OutputChannel("RipgrepSearchEH",this._logService);this.registerTextSearchProvider(c.Schemas.file,new _.RipgrepSearchProvider(w)),this.registerInternalFileSearchProvider(c.Schemas.file,new P.SearchService)}registerInternalFileSearchProvider(w,u){const d=this._handlePool++;return this._internalFileSearchProvider=u,this._internalFileSearchHandle=d,this._proxy.$registerFileSearchProvider(d,this._transformScheme(w)),p.toDisposable(()=>{this._internalFileSearchProvider=null,this._proxy.$unregisterProvider(d)})}$provideFileSearchResults(w,u,d,g){const t=h.reviveQuery(d);return w===this._internalFileSearchHandle?this.doInternalFileSearch(w,u,t,g):super.$provideFileSearchResults(w,u,d,g)}doInternalFileSearch(w,u,d,g){const t=i=>{if(A.isSerializedFileMatch(i)&&(i=[i]),Array.isArray(i)){this._proxy.$handleFileMatch(w,u,i.map(s=>R.URI.file(s.path)));return}i.message&&this._logService.debug("ExtHostSearch",i.message)};if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(d,t,g)}$clearCache(w){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(w),super.$clearCache(w)}createTextSearchManager(w,u){return new f.NativeTextSearchManager(w,u)}};I=qe([We(0,r.IExtHostRpcService),We(1,l.IExtHostInitDataService),We(2,k.IURITransformerService),We(3,S.ILogService)],I),e.NativeExtHostSearch=I}),define(pe[131],ve([0,1,285,121,286,3,103,9,101,32,6,22,104,14,11]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class f{constructor(m){this.socket=m,this._errorListener=E=>{if(E){if(E.code==="EPIPE")return;h.onUnexpectedError(E)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(m){const E=y=>m(k.VSBuffer.wrap(y));return this.socket.on("data",E),{dispose:()=>this.socket.off("data",E)}}onClose(m){const E=y=>{m({type:0,hadError:y,error:void 0})};return this.socket.on("close",E),{dispose:()=>this.socket.off("close",E)}}onEnd(m){return this.socket.on("end",m),{dispose:()=>this.socket.off("end",m)}}write(m){if(!this.socket.destroyed)try{this.socket.write(m.buffer,E=>{if(E){if(E.code==="EPIPE")return;h.onUnexpectedError(E)}})}catch(E){if(E.code==="EPIPE")return;h.onUnexpectedError(E)}}end(){this.socket.end()}drain(){return new Promise((m,E)=>{if(this.socket.bufferSize===0){m();return}const y=()=>{this.socket.off("close",y),this.socket.off("end",y),this.socket.off("error",y),this.socket.off("timeout",y),this.socket.off("drain",y),m()};this.socket.on("close",y),this.socket.on("end",y),this.socket.on("error",y),this.socket.on("timeout",y),this.socket.on("drain",y)})}}e.NodeSocket=f;var I;(function(v){v[v.MinHeaderByteSize=2]="MinHeaderByteSize"})(I||(I={}));var b;(function(v){v[v.PeekHeader=1]="PeekHeader",v[v.ReadHeader=2]="ReadHeader",v[v.ReadBody=3]="ReadBody",v[v.Fin=4]="Fin"})(b||(b={}));class w extends r.Disposable{constructor(m,E,y,a){super();this._onDidZlibFlush=this._register(new S.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new S.Emitter),this._onClose=this._register(new S.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=m,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=E,this._recordInflateBytes=a,E?(this._zlibInflate=C.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",T=>{console.error(T),h.onUnexpectedError(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibInflate.on("data",T=>{this._pendingInflateData.push(T)}),y&&(this._zlibInflate.write(y.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=C.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",T=>{console.error(T),h.onUnexpectedError(T),this._onClose.fire({type:0,hadError:!0,error:T})}),this._zlibDeflate.on("data",T=>{this._pendingDeflateData.push(T)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new l.ChunkStream,this._register(this.socket.onData(T=>this._acceptChunk(T))),this._register(this.socket.onClose(T=>this._onClose.fire(T)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this._onData.event(m)}onClose(m){return this._onClose.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){this._totalOutgoingDataBytes+=m.byteLength,this._zlibDeflate?(this._zlibDeflate.write(m.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let E=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,E=E.slice(0,E.length-4),this._isEnded||this._write(k.VSBuffer.wrap(E),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(m,!1)}_write(m,E){let y=2;m.byteLength<126?y+=0:m.byteLength<2**16?y+=2:y+=8;const a=k.VSBuffer.alloc(y);if(E?a.writeUInt8(194,0):a.writeUInt8(130,0),m.byteLength<126)a.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){a.writeUInt8(126,1);let T=1;a.writeUInt8(m.byteLength>>>8&255,++T),a.writeUInt8(m.byteLength>>>0&255,++T)}else{a.writeUInt8(127,1);let T=1;a.writeUInt8(0,++T),a.writeUInt8(0,++T),a.writeUInt8(0,++T),a.writeUInt8(0,++T),a.writeUInt8(m.byteLength>>>24&255,++T),a.writeUInt8(m.byteLength>>>16&255,++T),a.writeUInt8(m.byteLength>>>8&255,++T),a.writeUInt8(m.byteLength>>>0&255,++T)}this._totalOutgoingWireBytes+=a.byteLength+m.byteLength,this.socket.write(k.VSBuffer.concat([a,m]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(m){if(m.byteLength!==0){for(this._totalIncomingWireBytes+=m.byteLength,this._incomingData.acceptChunk(m);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const E=this._incomingData.peek(this._state.readLen),a=(E.readUInt8(0)&128)>>>7,T=E.readUInt8(1),O=(T&128)>>>7,$=T&127;this._state.state=2,this._state.readLen=2+(O?4:0)+($===126?2:0)+($===127?8:0),this._state.fin=a,this._state.mask=0}else if(this._state.state===2){const E=this._incomingData.read(this._state.readLen),y=E.readUInt8(1),a=(y&128)>>>7;let T=y&127,O=1;T===126?T=E.readUInt8(++O)*2**8+E.readUInt8(++O):T===127&&(T=E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*0+E.readUInt8(++O)*2**24+E.readUInt8(++O)*2**16+E.readUInt8(++O)*2**8+E.readUInt8(++O));let $=0;a&&($=E.readUInt8(++O)*2**24+E.readUInt8(++O)*2**16+E.readUInt8(++O)*2**8+E.readUInt8(++O)),this._state.state=3,this._state.readLen=T,this._state.mask=$}else if(this._state.state===3){const E=this._incomingData.read(this._state.readLen);u(E,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(E.buffer)),this._zlibInflate.write(E.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const y=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=y.length,this._onData.fire(k.VSBuffer.wrap(y))})):(this._totalIncomingDataBytes+=E.byteLength,this._onData.fire(E))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await S.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=w;function u(v,m){if(m===0)return;let E=v.byteLength>>>2;for(let Z=0;Z<E;Z++){const le=v.readUInt32BE(Z*4);v.writeUInt32BE(le^m,Z*4)}let y=E*4,a=v.byteLength-y;const T=m>>>24&255,O=m>>>16&255,$=m>>>8&255;a>=1&&v.writeUInt8(v.readUInt8(y)^T,y),a>=2&&v.writeUInt8(v.readUInt8(y+1)^O,y+1),a>=3&&v.writeUInt8(v.readUInt8(y+2)^$,y+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const d={[2]:107,[1]:103};function g(){const v=D.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${v}-sock`;let m;return e.XDG_RUNTIME_DIR?m=P.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${v}.sock`):m=P.join(_.tmpdir(),`vscode-ipc-${v}.sock`),i(m),m}e.createRandomIPCHandle=g;function t(v,m,E){const y=p.createHash("md5").update(v).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${y}-${E}-${m}-sock`;let a;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?a=P.join(e.XDG_RUNTIME_DIR,`vscode-${y.substr(0,8)}-${E}-${m}.sock`):a=P.join(v,`${E}-${m}.sock`),i(a),a}e.createStaticIPCHandle=t;function i(v){const m=d[c.platform];typeof m=="number"&&v.length>=m&&console.warn(`WARNING: IPC handle "${v}" is longer than ${m} chars, try a shorter --user-data-dir`)}class s extends A.IPCServer{constructor(m){super(s.toClientConnectionEvent(m));this.server=m}static toClientConnectionEvent(m){const E=S.Event.fromNodeEventEmitter(m,"connection");return S.Event.map(E,y=>({protocol:new l.Protocol(new f(y)),onDidClientDisconnect:S.Event.once(S.Event.fromNodeEventEmitter(y,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function n(v){return new Promise((m,E)=>{const y=R.createServer();y.on("error",E),y.listen(v,()=>{y.removeListener("error",E),m(new s(y))})})}e.serve=n;function o(v,m){return new Promise((E,y)=>{const a=R.createConnection(v,()=>{a.removeListener("error",y),E(l.Client.fromSocket(new f(a),m))});a.once("error",y)})}e.connect=o}),define(pe[273],ve([0,1,131,265,56,48,2,190,12]),function(X,e,p,R,C,S,A,P,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class D{constructor(l,h,c){this._commands=l,this.logService=h,this._ipcHandlePath=c,this._server=R.createServer((f,I)=>this.onRequest(f,I)),this.setup().catch(f=>(h.error(f),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",l=>this.logService.error(l))}catch(l){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(l,h){const c=[];l.setEncoding("utf8"),l.on("data",f=>c.push(f)),l.on("end",()=>{const f=JSON.parse(c.join(""));switch(f.type){case"open":this.open(f,h);break;case"openExternal":this.openExternal(f,h);break;case"status":this.getStatus(f,h);break;case"extensionManagement":this.manageExtensions(f,h).catch(this.logService.error);break;default:h.writeHead(404),h.write(`Unknown message type: ${f.type}`,I=>{I&&this.logService.error(I)}),h.end();break}})}open(l,h){let{fileURIs:c,folderURIs:f,forceNewWindow:I,diffMode:b,addMode:w,forceReuseWindow:u,gotoLineMode:d,waitMarkerFilePath:g}=l;const t=[];if(Array.isArray(f))for(const i of f)try{t.push({folderUri:A.URI.parse(i)})}catch(s){}if(Array.isArray(c))for(const i of c)try{P.hasWorkspaceFileExtension(i)?t.push({workspaceUri:A.URI.parse(i)}):t.push({fileUri:A.URI.parse(i)})}catch(s){}if(t.length){const i=g?A.URI.file(g):void 0,n={forceNewWindow:I,diffMode:b,addMode:w,gotoLineMode:d,forceReuseWindow:u,preferNewWindow:!u&&!i&&!w,waitMarkerFileURI:i};this._commands.executeCommand("_remoteCLI.windowOpen",t,n)}h.writeHead(200),h.end()}async openExternal(l,h){for(const c of l.uris){const f=A.URI.parse(c),I=f.scheme==="file"?f:c;await this._commands.executeCommand("_remoteCLI.openExternal",I)}h.writeHead(200),h.end()}async manageExtensions(l,h){try{const c=b=>b==null?void 0:b.map(w=>/\.vsix$/i.test(w)?A.URI.parse(w):w),f={list:l.list,install:c(l.install),uninstall:c(l.uninstall),force:l.force},I=await this._commands.executeCommand("_remoteCLI.manageExtensions",f);h.writeHead(200),h.write(I)}catch(c){h.writeHead(500),h.write(String(c),f=>{f&&this.logService.error(f)})}h.end()}async getStatus(l,h){try{const c=await this._commands.executeCommand("_remoteCLI.getSystemStatus");h.writeHead(200),h.write(c),h.end()}catch(c){h.writeHead(500),h.write(String(c),f=>{f&&this.logService.error(f)}),h.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&C.existsSync(this._ipcHandlePath)&&C.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=D;let r=class extends D{constructor(l,h){super(l,h,p.createRandomIPCHandle())}};r=qe([We(0,S.IExtHostCommands),We(1,_.ILogService)],r),e.CLIServer=r}),define(pe[274],ve([0,1,66,261,256,5,264,40,246,2,10,7,273,102]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class c extends C.RequireInterceptor{_installInterceptor(){const b=this,w=X.__$__nodeRequire("module"),u=w._load;w._load=function(g,t,i){for(let s of b._alternatives){let n=s(g);if(n){g=n;break}}return b._factories.has(g)?b._factories.get(g).load(g,D.URI.file(h.realpathSync(t.filename)),s=>u.apply(this,[s,t,i])):u.apply(this,arguments)}}}class f extends P.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=k.ExtensionRuntime.Node}async _beforeAlmostReadyToRunExtensions(){const b=this._instaService.invokeFunction(R.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(_.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const t=this._instaService.createInstance(l.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=t.ipcHandlePath}await this._instaService.createInstance(c,b,this._registry).install(),p.mark("code/extHost/didInitAPI");const u=await this._extHostConfiguration.getConfigProvider();await A.connectProxyResolver(this._extHostWorkspace,u,this,this._logService,this._mainThreadTelemetryProxy,this._initData),p.mark("code/extHost/didInitProxyResolver");const d=process.send,g=this._extHostContext.getProxy(S.MainContext.MainThreadConsole);process.send=(...t)=>t.length===0||!t[0]||t[0].type!=="__$console"?d.apply(process,t):(g.$logExtensionHostMessage(t[0]),!1)}_getEntryPoint(b){return b.main}_loadCommonJSModule(b,w,u){if(w.scheme!==r.Schemas.file)throw new Error(`Cannot load URI: '${w}', must be of file-scheme`);let d=null;u.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${w.toString(!0)}`),this._logService.flush();try{b&&p.mark(`code/extHost/willLoadExtensionCode/${b.value}`),d=X.__$__nodeRequire(w.fsPath)}catch(g){return Promise.reject(g)}finally{b&&p.mark(`code/extHost/didLoadExtensionCode/${b.value}`),u.codeLoadingStop()}return Promise.resolve(d)}async $setRemoteEnvironment(b){if(!!this._initData.remote.isRemote)for(const w in b){const u=b[w];u===null?delete process.env[w]:process.env[w]=u}}}e.ExtHostExtensionService=f}),define(pe[275],ve([0,1,77,247,248,258,257,272,274,216,249,49,40,62,67,65,33,47,12]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f,I,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.registerSingleton(l.IExtHostExtensionService,_.ExtHostExtensionService),p.registerSingleton(w.ILogService,D.ExtHostLogService),p.registerSingleton(k.IExtHostDebugService,A.ExtHostDebugService),p.registerSingleton(h.IExtHostOutputService,R.ExtHostOutputService2),p.registerSingleton(c.IExtHostSearch,P.NativeExtHostSearch),p.registerSingleton(f.IExtHostTask,S.ExtHostTask),p.registerSingleton(I.IExtHostTerminalService,C.ExtHostTerminalService),p.registerSingleton(b.IExtHostTunnelService,r.ExtHostTunnelService)}),define(pe[276],ve([0,1,121,287,66,14,104,131,184,214,259,22,99,28,102,16,262,275]),function(X,e,p,R,C,S,A,P,_,D,r,k,l,h,c,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.startExtensionHostProcess=void 0,function(){for(let n=0;n<process.execArgv.length;n++)process.execArgv[n]==="--inspect-port=0"&&(process.execArgv.splice(n,1),n--)}();const I=R(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});(function(){const s=X.__$__nodeRequire("module"),n=s._load;s._load=function(o){if(o==="natives")throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return n.apply(this,arguments)}})();const b=process.exit.bind(process);function w(s){process.exit=function(n){if(s)b(n);else{const o=new Error("An extension called process.exit() and this was prevented.");console.warn(o.stack)}},process.crash=function(){const n=new Error("An extension called process.crash() and this was prevented.");console.warn(n.stack)}}let u=function(s){b()};function d(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((s,n)=>{let o=null,v=setTimeout(()=>{u("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4);const m=108e5,E=3e5,y=new f.RunOnceScheduler(()=>u("renderer disconnected for too long (1)"),m),a=new f.RunOnceScheduler(()=>u("renderer disconnected for too long (2)"),E);process.on("message",(O,$)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){const Z=k.VSBuffer.wrap(Buffer.from(O.initialDataChunk,"base64"));let le;if(O.skipWebSocketFrames)le=new P.NodeSocket($);else{const q=k.VSBuffer.wrap(Buffer.from(O.inflateBytes,"base64"));le=new P.WebSocketNodeSocket(new P.NodeSocket($),O.permessageDeflate,q,!1)}o?(y.cancel(),a.cancel(),o.beginAcceptReconnection(le,Z),o.endAcceptReconnection()):(clearTimeout(v),o=new A.PersistentProtocol(le,Z),o.onDidDispose(()=>u("renderer disconnected")),s(o),o.onSocketClose(()=>{y.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(a.isScheduled())return;y.isScheduled()&&a.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(T)});{const s=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((n,o)=>{const v=p.createConnection(s,()=>{v.removeListener("error",o),n(new A.PersistentProtocol(new P.NodeSocket(v)))});v.once("error",o),v.on("close",()=>{u("renderer closed the socket")})})}}async function g(){const s=await d();return new class{constructor(){this._onMessage=new A.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,s.onMessage(n=>{D.isMessageOfType(n,2)?(this._terminating=!0,u("received terminate message from renderer")):this._onMessage.fire(n)})}send(n){this._terminating||s.send(n)}drain(){return s.drain()}}}function t(s){return new Promise(n=>{const o=s.onMessage(v=>{o.dispose();const m=JSON.parse(v.toString()),E=m.commit,y=_.default.commit;E&&y&&E!==y&&b(55);const a=[];process.on("unhandledRejection",($,Z)=>{a.push(Z),setTimeout(()=>{const le=a.indexOf(Z);le>=0&&Z.catch(q=>{a.splice(le,1),S.isPromiseCanceledError(q)||(console.warn(`rejected promise not handled within 1 second: ${q}`),q&&q.stack&&console.warn(`stack trace: ${q.stack}`),S.onUnexpectedError($))})},1e3)}),process.on("rejectionHandled",$=>{const Z=a.indexOf($);Z>=0&&a.splice(Z,1)}),process.on("uncaughtException",function($){S.onUnexpectedError($)});let T=0;setInterval(function(){try{process.kill(m.parentPid,0),T=0}catch($){$&&$.code==="EPERM"?(T++,T>=3&&u(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${$.message} (code: ${$.code}) (errno: ${$.errno})`)):u(`parent process ${m.parentPid} does not exist anymore: ${$.message} (code: ${$.code}) (errno: ${$.errno})`)}},1e3);let O;try{O=X.__$__nodeRequire("native-watchdog"),O.start(m.parentPid)}catch($){S.onUnexpectedError($)}s.send(D.createMessageOfType(0)),n({protocol:s,initData:m})});s.send(D.createMessageOfType(1))})}async function i(){C.mark("code/extHost/willConnectToRenderer");const s=await g();C.mark("code/extHost/didConnectToRenderer");const n=await t(s);C.mark("code/extHost/didWaitForInitData");const{initData:o}=n;w(!!o.environment.extensionTestsLocationURI),o.environment.useHostProxy=I.useHostProxy!==void 0?I.useHostProxy!=="false":void 0;const v=new class{exit(a){b(a)}exists(a){return h.Promises.exists(a)}realpath(a){return c.realpath(a)}};let m=null;if(o.remote.authority&&I.uriTransformerPath)try{const a=X.__$__nodeRequire(I.uriTransformerPath)(o.remote.authority);m=new l.URITransformer(a)}catch(y){console.error(y)}const E=new r.ExtensionHostMain(n.protocol,o,v,m);u=y=>E.terminate(y)}e.startExtensionHostProcess=i}),define(pe[288],ve([0,1,276]),function(X,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),p.startExtensionHostProcess().catch(R=>console.log(R))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3e0c442a8ee9fdc037d627d70fe291f72af04cfd/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
