/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/base/common/strings","vs/workbench/api/common/extHostTypeConverters","vs/base/common/types","vs/base/common/errors","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/cancellation","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/platform","vs/base/common/map","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/editor/common/core/range","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/editor/common/core/position","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/iterator","vs/base/common/process","vs/base/common/severity","vs/base/common/extpath","vs/platform/registry/common/platform","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/functional","vs/base/common/idGenerator","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/numbers","vs/base/common/codicons","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/core/characterClassifier","vs/editor/common/model","vs/editor/common/model/wordHelper","vs/editor/common/services/semanticTokensDto","vs/editor/common/viewModel/prefixSumComputer","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/markers/common/markers","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/testing/common/testCollection","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/linkComputer","vs/editor/common/modes/tokenizationRegistry","vs/editor/common/model/mirrorTextModel","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/api/common/extHostTesting","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/marked/marked","vs/workbench/services/extensions/worker/extensionHostWorker"],_e=function(ee){for(var e=[],g=0,T=ee.length;g<T;g++)e[g]=we[ee[g]];return e};define(we[39],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function g(T,S){if(!T)throw new Error(S?`Assertion failed (${S})`:"Assertion Failed")}e.ok=g}),define(we[76],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const g=Object.prototype.hasOwnProperty;function T(n){const I=[];for(let o in n)g.call(n,o)&&I.push(n[o]);return I}e.values=T;function S(n,I){for(let o in n)if(g.call(n,o)&&I({key:o,value:n[o]},function(){delete n[o]})===!1)return}e.forEach=S;function E(n,I){const o=Object.create(null);for(const h of n){const c=I(h);let d=o[c];d||(d=o[c]=[]),d.push(h)}return o}e.groupBy=E;function k(n){const I=Object.create(null);return n&&n.forEach((o,h)=>{I[h]=o}),I}e.fromMap=k;function D(n,I){const o=[],h=[];for(let c of n)I.has(c)||o.push(c);for(let c of I)n.has(c)||h.push(c);return{removed:o,added:h}}e.diffSets=D;function _(n,I){const o=[],h=[];for(let[c,d]of n)I.has(c)||o.push(d);for(let[c,d]of I)n.has(c)||h.push(d);return{removed:o,added:h}}e.diffMaps=_;class C{constructor(){this.map=new Map}add(I,o){let h=this.map.get(I);h||(h=new Set,this.map.set(I,h)),h.add(o)}delete(I,o){const h=this.map.get(I);!h||(h.delete(o),h.size===0&&this.map.delete(I))}forEach(I,o){const h=this.map.get(I);!h||h.forEach(o)}}e.SetMap=C}),define(we[48],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function g(k){return(D,_,C)=>{let n=null,I=null;if(typeof C.value=="function"?(n="value",I=C.value):typeof C.get=="function"&&(n="get",I=C.get),!I)throw new Error("not supported");C[n]=k(I,_)}}e.createDecorator=g;function T(k,D,_){let C=null,n=null;if(typeof _.value=="function"?(C="value",n=_.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof _.get=="function"&&(C="get",n=_.get),!n)throw new Error("not supported");const I=`$memoize$${D}`;_[C]=function(...o){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,o)}),this[I]}}e.memoize=T;function S(k,D,_){return g((C,n)=>{const I=`$debounce$${n}`,o=`$debounce$result$${n}`;return function(...h){this[o]||(this[o]=_?_():void 0),clearTimeout(this[I]),D&&(this[o]=D(this[o],...h),h=[this[o]]),this[I]=setTimeout(()=>{C.apply(this,h),this[o]=_?_():void 0},k)}})}e.debounce=S;function E(k,D,_){return g((C,n)=>{const I=`$throttle$timer$${n}`,o=`$throttle$result$${n}`,h=`$throttle$lastRun$${n}`,c=`$throttle$pending$${n}`;return function(...d){if(this[o]||(this[o]=_?_():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),D&&(this[o]=D(this[o],...d)),this[c])return;const y=this[h]+k;y<=Date.now()?(this[h]=Date.now(),C.apply(this,[this[o]]),this[o]=_?_():void 0):(this[c]=!0,this[I]=setTimeout(()=>{this[c]=!1,this[h]=Date.now(),C.apply(this,[this[o]]),this[o]=_?_():void 0},y-Date.now()))}})}e.throttle=E}),define(we[11],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class g{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(r=>{r(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=g,e.errorHandler=new g;function T(m){e.errorHandler.setUnexpectedErrorHandler(m)}e.setUnexpectedErrorHandler=T;function S(m){_(m)||e.errorHandler.onUnexpectedError(m)}e.onUnexpectedError=S;function E(m){_(m)||e.errorHandler.onUnexpectedExternalError(m)}e.onUnexpectedExternalError=E;function k(m){if(m instanceof Error){let{name:t,message:r}=m;const s=m.stacktrace||m.stack;return{$isError:!0,name:t,message:r,stack:s}}return m}e.transformErrorForSerialization=k;const D="Canceled";function _(m){return m instanceof Error&&m.name===D&&m.message===D}e.isPromiseCanceledError=_;class C extends Error{constructor(){super(D);this.name=this.message}}e.CancellationError=C;function n(){const m=new Error(D);return m.name=m.message,m}e.canceled=n;function I(m){return m?new Error(`Illegal argument: ${m}`):new Error("Illegal argument")}e.illegalArgument=I;function o(m){return m?new Error(`Illegal state: ${m}`):new Error("Illegal state")}e.illegalState=o;function h(m){return m?new Error(`readonly property '${m} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=h;function c(m){const t=new Error(`${m} has been disposed`);return t.name="DISPOSED",t}e.disposed=c;function d(m){return m?m.message?m.message:m.stack?m.stack.split(`
`)[0]:String(m):"Error"}e.getErrorMessage=d;class y extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=y;class b extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=b;class p extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=p;function l(m){const t=m;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=l;function f(m,t=Object.create(null)){const r=new Error(m);return t.actions&&(r.actions=t.actions),r}e.createErrorWithActions=f}),define(we[17],_e([0,1,11]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function T(q,N=0){return q[q.length-(1+N)]}e.tail=T;function S(q){if(q.length===0)throw new Error("Invalid tail call");return[q.slice(0,q.length-1),q[q.length-1]]}e.tail2=S;function E(q,N,W=(O,B)=>O===B){if(q===N)return!0;if(!q||!N||q.length!==N.length)return!1;for(let O=0,B=q.length;O<B;O++)if(!W(q[O],N[O]))return!1;return!0}e.equals=E;function k(q,N,W){let O=0,B=q.length-1;for(;O<=B;){const Y=(O+B)/2|0,he=W(q[Y],N);if(he<0)O=Y+1;else if(he>0)B=Y-1;else return Y}return-(O+1)}e.binarySearch=k;function D(q,N){let W=0,O=q.length;if(O===0)return 0;for(;W<O;){const B=Math.floor((W+O)/2);N(q[B])?O=B:W=B+1}return W}e.findFirstInSorted=D;function _(q,N,W){if(q=q|0,q>=N.length)throw new TypeError("invalid index");let O=N[Math.floor(N.length*Math.random())],B=[],Y=[],he=[];for(let De of N){const Oe=W(De,O);Oe<0?B.push(De):Oe>0?Y.push(De):he.push(De)}return q<B.length?_(q,B,W):q<B.length+he.length?he[0]:_(q-(B.length+he.length),Y,W)}e.quickSelect=_;function C(q,N){const W=[];let O;for(const B of q.slice(0).sort(N))!O||N(O[0],B)!==0?(O=[B],W.push(O)):O.push(B);return W}e.groupBy=C;function n(q,N,W){const O=[];function B(De,Oe,Me){if(Oe===0&&Me.length===0)return;const He=O[O.length-1];He&&He.start+He.deleteCount===De?(He.deleteCount+=Oe,He.toInsert.push(...Me)):O.push({start:De,deleteCount:Oe,toInsert:Me})}let Y=0,he=0;for(;;){if(Y===q.length){B(Y,0,N.slice(he));break}if(he===N.length){B(Y,q.length-Y,[]);break}const De=q[Y],Oe=N[he],Me=W(De,Oe);Me===0?(Y+=1,he+=1):Me<0?(B(Y,1,[]),Y+=1):Me>0&&(B(Y,0,[Oe]),he+=1)}return O}e.sortedDiff=n;function I(q,N,W){const O=n(q,N,W),B=[],Y=[];for(const he of O)B.push(...q.slice(he.start,he.start+he.deleteCount)),Y.push(...he.toInsert);return{removed:B,added:Y}}e.delta=I;function o(q,N,W){if(W===0)return[];const O=q.slice(0,W).sort(N);return c(q,N,O,W,q.length),O}e.top=o;function h(q,N,W,O,B){return W===0?Promise.resolve([]):new Promise((Y,he)=>{(async()=>{const De=q.length,Oe=q.slice(0,W).sort(N);for(let Me=W,He=Math.min(W+O,De);Me<De;Me=He,He=Math.min(He+O,De)){if(Me>W&&await new Promise(Ye=>setTimeout(Ye)),B&&B.isCancellationRequested)throw g.canceled();c(q,N,Oe,Me,He)}return Oe})().then(Y,he)})}e.topAsync=h;function c(q,N,W,O,B){for(const Y=W.length;O<B;O++){const he=q[O];if(N(he,W[Y-1])<0){W.pop();const De=D(W,Oe=>N(he,Oe)<0);W.splice(De,0,he)}}}function d(q){return q.filter(N=>!!N)}e.coalesce=d;function y(q){let N=0;for(let W=0;W<q.length;W++)q[W]&&(q[N]=q[W],N+=1);q.length=N}e.coalesceInPlace=y;function b(q,N,W){q.splice(W,0,q.splice(N,1)[0])}e.move=b;function p(q){return!Array.isArray(q)||q.length===0}e.isFalsyOrEmpty=p;function l(q){return Array.isArray(q)&&q.length>0}e.isNonEmptyArray=l;function f(q,N){if(!N)return q.filter((O,B)=>q.indexOf(O)===B);const W=Object.create(null);return q.filter(O=>{const B=N(O);return W[B]?!1:(W[B]=!0,!0)})}e.distinct=f;function m(q){const N=new Set;return q.filter(W=>N.has(W)?!1:(N.add(W),!0))}e.distinctES6=m;function t(q){const N=Object.create(null);return W=>{const O=q(W);return N[O]?!1:(N[O]=!0,!0)}}e.uniqueFilter=t;function r(q,N){for(let W=q.length-1;W>=0;W--){const O=q[W];if(N(O))return W}return-1}e.lastIndex=r;function s(q,N){return q.length>0?q[0]:N}e.firstOrDefault=s;function i(q,N,W=(O,B)=>O===B){let O=0;for(let B=0,Y=Math.min(q.length,N.length);B<Y&&W(q[B],N[B]);B++)O++;return O}e.commonPrefixLength=i;function u(q){return[].concat(...q)}e.flatten=u;function w(q,N){let W=typeof N=="number"?q:0;typeof N=="number"?W=q:(W=0,N=q);const O=[];if(W<=N)for(let B=W;B<N;B++)O.push(B);else for(let B=W;B>N;B--)O.push(B);return O}e.range=w;function v(q,N,W){return q.reduce((O,B)=>(O[N(B)]=W?W(B):B,O),Object.create(null))}e.index=v;function P(q,N){return q.push(N),()=>A(q,N)}e.insert=P;function A(q,N){const W=q.indexOf(N);if(W>-1)return q.splice(W,1),N}e.remove=A;function a(q,N,W){const O=q.slice(0,N),B=q.slice(N);return O.concat(W,B)}e.arrayInsert=a;function R(q,N){let W;if(typeof N=="number"){let O=N;W=()=>{const B=Math.sin(O++)*179426549;return B-Math.floor(B)}}else W=Math.random;for(let O=q.length-1;O>0;O-=1){const B=Math.floor(W()*(O+1)),Y=q[O];q[O]=q[B],q[B]=Y}}e.shuffle=R;function L(q,N){const W=q.indexOf(N);W>-1&&(q.splice(W,1),q.unshift(N))}e.pushToStart=L;function H(q,N){const W=q.indexOf(N);W>-1&&(q.splice(W,1),q.push(N))}e.pushToEnd=H;function ue(q,N){return Array.isArray(q)?q.map(N):N(q)}e.mapArrayOrNot=ue;function me(q){return Array.isArray(q)?q:[q]}e.asArray=me;function J(q){return q[Math.floor(Math.random()*q.length)]}e.getRandomElement=J;function z(q,N){for(const W of q){const O=N(W);if(O!==void 0)return O}}e.mapFind=z;function Z(q,N){let W=Number.MAX_SAFE_INTEGER,O=0;return q.forEach((B,Y)=>{const he=N(B);he<W&&(W=he,O=Y)}),O}e.minIndex=Z;function M(q,N){let W=Number.MIN_SAFE_INTEGER,O=0;return q.forEach((B,Y)=>{const he=N(B);he>W&&(W=he,O=Y)}),O}e.maxIndex=M}),define(we[49],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function g(T){const S=this;let E=!1,k;return function(){return E||(E=!0,k=T.apply(S,arguments)),k}}e.once=g}),define(we[50],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class g{constructor(S){this._prefix=S,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=g,e.defaultGenerator=new g("id#")}),define(we[40],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var g;(function(T){function S(m){return m&&typeof m=="object"&&typeof m[Symbol.iterator]=="function"}T.is=S;const E=Object.freeze([]);function k(){return E}T.empty=k;function*D(m){yield m}T.single=D;function _(m){return m||E}T.from=_;function C(m){return!m||m[Symbol.iterator]().next().done===!0}T.isEmpty=C;function n(m){return m[Symbol.iterator]().next().value}T.first=n;function I(m,t){for(const r of m)if(t(r))return!0;return!1}T.some=I;function o(m,t){for(const r of m)if(t(r))return r}T.find=o;function*h(m,t){for(const r of m)t(r)&&(yield r)}T.filter=h;function*c(m,t){let r=0;for(const s of m)yield t(s,r++)}T.map=c;function*d(...m){for(const t of m)for(const r of t)yield r}T.concat=d;function*y(m){for(const t of m)for(const r of t)yield r}T.concatNested=y;function b(m,t,r){let s=r;for(const i of m)s=t(s,i);return s}T.reduce=b;function*p(m,t,r=m.length){for(t<0&&(t+=m.length),r<0?r+=m.length:r>m.length&&(r=m.length);t<r;t++)yield m[t]}T.slice=p;function l(m,t=Number.POSITIVE_INFINITY){const r=[];if(t===0)return[r,m];const s=m[Symbol.iterator]();for(let i=0;i<t;i++){const u=s.next();if(u.done)return[r,T.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return s}}]}T.consume=l;function f(m,t,r=(s,i)=>s===i){const s=m[Symbol.iterator](),i=t[Symbol.iterator]();for(;;){const u=s.next(),w=i.next();if(u.done!==w.done)return!1;if(u.done)return!0;if(!r(u.value,w.value))return!1}}T.equals=f})(g=e.Iterable||(e.Iterable={}))}),define(we[107],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var g;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(g=e.ScanError||(e.ScanError={}));var T;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(T=e.SyntaxKind||(e.SyntaxKind={}));var S;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(S=e.ParseErrorCode||(e.ParseErrorCode={}));var E;(function(t){t.DEFAULT={allowTrailingComma:!0}})(E=e.ParseOptions||(e.ParseOptions={}));function k(t,r=!1){let s=0,i=t.length,u="",w=0,v=16,P=0;function A(J){let z=0,Z=0;for(;z<J;){const M=t.charCodeAt(s);if(M>=48&&M<=57)Z=Z*16+M-48;else if(M>=65&&M<=70)Z=Z*16+M-65+10;else if(M>=97&&M<=102)Z=Z*16+M-97+10;else break;s++,z++}return z<J&&(Z=-1),Z}function a(J){s=J,u="",w=0,v=16,P=0}function R(){const J=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&C(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&C(t.charCodeAt(s)))for(s++;s<t.length&&C(t.charCodeAt(s));)s++;else return P=3,t.substring(J,s);let z=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&C(t.charCodeAt(s))){for(s++;s<t.length&&C(t.charCodeAt(s));)s++;z=s}else P=3;return t.substring(J,z)}function L(){let J="",z=s;for(;;){if(s>=i){J+=t.substring(z,s),P=2;break}const Z=t.charCodeAt(s);if(Z===34){J+=t.substring(z,s),s++;break}if(Z===92){if(J+=t.substring(z,s),s++,s>=i){P=2;break}switch(t.charCodeAt(s++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:const q=A(4);q>=0?J+=String.fromCharCode(q):P=4;break;default:P=5}z=s;continue}if(Z>=0&&Z<=31)if(_(Z)){J+=t.substring(z,s),P=2;break}else P=6;s++}return J}function H(){if(u="",P=0,w=s,s>=i)return w=i,v=17;let J=t.charCodeAt(s);if(D(J)){do s++,u+=String.fromCharCode(J),J=t.charCodeAt(s);while(D(J));return v=15}if(_(J))return s++,u+=String.fromCharCode(J),J===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),v=14;switch(J){case 123:return s++,v=1;case 125:return s++,v=2;case 91:return s++,v=3;case 93:return s++,v=4;case 58:return s++,v=6;case 44:return s++,v=5;case 34:return s++,u=L(),v=10;case 47:const z=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!_(t.charCodeAt(s));)s++;return u=t.substring(z,s),v=12}if(t.charCodeAt(s+1)===42){s+=2;const Z=i-1;let M=!1;for(;s<Z;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,M=!0;break}s++}return M||(s++,P=1),u=t.substring(z,s),v=13}return u+=String.fromCharCode(J),s++,v=16;case 45:if(u+=String.fromCharCode(J),s++,s===i||!C(t.charCodeAt(s)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=R(),v=11;default:for(;s<i&&ue(J);)s++,J=t.charCodeAt(s);if(w!==s){switch(u=t.substring(w,s),u){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return u+=String.fromCharCode(J),s++,v=16}}function ue(J){if(D(J)||_(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function me(){let J;do J=H();while(J>=12&&J<=15);return J}return{setPosition:a,getPosition:()=>s,scan:r?me:H,getToken:()=>v,getTokenValue:()=>u,getTokenOffset:()=>w,getTokenLength:()=>s-w,getTokenError:()=>P}}e.createScanner=k;function D(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function _(t){return t===10||t===13||t===8232||t===8233}function C(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function I(t,r){const s=[],i=new Object;let u;const w={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function P(A,a,R,L){w.value=A,w.offset=a,w.length=R,w.type=L,w.colonOffset=void 0,u=w}try{l(t,{onObjectBegin:(A,a)=>{if(r<=A)throw i;u=void 0,v=r>A,s.push("")},onObjectProperty:(A,a,R)=>{if(r<a||(P(A,a,R,"property"),s[s.length-1]=A,r<=a+R))throw i},onObjectEnd:(A,a)=>{if(r<=A)throw i;u=void 0,s.pop()},onArrayBegin:(A,a)=>{if(r<=A)throw i;u=void 0,s.push(0)},onArrayEnd:(A,a)=>{if(r<=A)throw i;u=void 0,s.pop()},onLiteralValue:(A,a,R)=>{if(r<a||(P(A,a,R,m(A)),r<=a+R))throw i},onSeparator:(A,a,R)=>{if(r<=a)throw i;if(A===":"&&u&&u.type==="property")u.colonOffset=a,v=!1,u=void 0;else if(A===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(v=!0,s[s.length-1]=""),u=void 0}}})}catch(A){if(A!==i)throw A}return{path:s,previousNode:u,isAtPropertyKey:v,matches:A=>{let a=0;for(let R=0;a<A.length&&R<s.length;R++)if(A[a]===s[R]||A[a]==="*")a++;else if(A[a]!=="**")return!1;return a===A.length}}}e.getLocation=I;function o(t,r=[],s=E.DEFAULT){let i=null,u=[];const w=[];function v(A){Array.isArray(u)?u.push(A):i!==null&&(u[i]=A)}return l(t,{onObjectBegin:()=>{const A={};v(A),w.push(u),u=A,i=null},onObjectProperty:A=>{i=A},onObjectEnd:()=>{u=w.pop()},onArrayBegin:()=>{const A=[];v(A),w.push(u),u=A,i=null},onArrayEnd:()=>{u=w.pop()},onLiteralValue:v,onError:(A,a,R)=>{r.push({error:A,offset:a,length:R})}},s),u[0]}e.parse=o;function h(t,r=[],s=E.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(A){i.type==="property"&&(i.length=A-i.offset,i=i.parent)}function w(A){return i.children.push(A),A}l(t,{onObjectBegin:A=>{i=w({type:"object",offset:A,length:-1,parent:i,children:[]})},onObjectProperty:(A,a,R)=>{i=w({type:"property",offset:a,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:A,offset:a,length:R,parent:i})},onObjectEnd:(A,a)=>{i.length=A+a-i.offset,i=i.parent,u(A+a)},onArrayBegin:(A,a)=>{i=w({type:"array",offset:A,length:-1,parent:i,children:[]})},onArrayEnd:(A,a)=>{i.length=A+a-i.offset,i=i.parent,u(A+a)},onLiteralValue:(A,a,R)=>{w({type:m(A),offset:a,length:R,parent:i,value:A}),u(a+R)},onSeparator:(A,a,R)=>{i.type==="property"&&(A===":"?i.colonOffset=a:A===","&&u(a))},onError:(A,a,R)=>{r.push({error:A,offset:a,length:R})}},s);const P=i.children[0];return P&&delete P.parent,P}e.parseTree=h;function c(t,r){if(!t)return;let s=t;for(let i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const w of s.children)if(Array.isArray(w.children)&&w.children[0].value===i){s=w.children[1],u=!0;break}if(!u)return}else{const u=i;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.findNodeAtLocation=c;function d(t){if(!t.parent||!t.parent.children)return[];const r=d(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}e.getNodePath=d;function y(t){switch(t.type){case"array":return t.children.map(y);case"object":const r=Object.create(null);for(let s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=y(i))}return r;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=y;function b(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}e.contains=b;function p(t,r,s=!1){if(b(t,r,s)){const i=t.children;if(Array.isArray(i))for(let u=0;u<i.length&&i[u].offset<=r;u++){const w=p(i[u],r,s);if(w)return w}return t}}e.findNodeAtOffset=p;function l(t,r,s=E.DEFAULT){const i=k(t,!1);function u(he){return he?()=>he(i.getTokenOffset(),i.getTokenLength()):()=>!0}function w(he){return he?De=>he(De,i.getTokenOffset(),i.getTokenLength()):()=>!0}const v=u(r.onObjectBegin),P=w(r.onObjectProperty),A=u(r.onObjectEnd),a=u(r.onArrayBegin),R=u(r.onArrayEnd),L=w(r.onLiteralValue),H=w(r.onSeparator),ue=u(r.onComment),me=w(r.onError),J=s&&s.disallowComments,z=s&&s.allowTrailingComma;function Z(){for(;;){const he=i.scan();switch(i.getTokenError()){case 4:M(14);break;case 5:M(15);break;case 3:M(13);break;case 1:J||M(11);break;case 2:M(12);break;case 6:M(16);break}switch(he){case 12:case 13:J?M(10):ue();break;case 16:M(1);break;case 15:case 14:break;default:return he}}}function M(he,De=[],Oe=[]){if(me(he),De.length+Oe.length>0){let Me=i.getToken();for(;Me!==17;){if(De.indexOf(Me)!==-1){Z();break}else if(Oe.indexOf(Me)!==-1)break;Me=Z()}}}function q(he){const De=i.getTokenValue();return he?L(De):P(De),Z(),!0}function N(){switch(i.getToken()){case 11:let he=0;try{he=JSON.parse(i.getTokenValue()),typeof he!="number"&&(M(2),he=0)}catch(De){M(2)}L(he);break;case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return Z(),!0}function W(){return i.getToken()!==10?(M(3,[],[2,5]),!1):(q(!1),i.getToken()===6?(H(":"),Z(),Y()||M(4,[],[2,5])):M(5,[],[2,5]),!0)}function O(){v(),Z();let he=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(he||M(4,[],[]),H(","),Z(),i.getToken()===2&&z)break}else he&&M(6,[],[]);W()||M(4,[],[2,5]),he=!0}return A(),i.getToken()!==2?M(7,[2],[]):Z(),!0}function B(){a(),Z();let he=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(he||M(4,[],[]),H(","),Z(),i.getToken()===4&&z)break}else he&&M(6,[],[]);Y()||M(4,[],[4,5]),he=!0}return R(),i.getToken()!==4?M(8,[4],[]):Z(),!0}function Y(){switch(i.getToken()){case 3:return B();case 1:return O();case 10:return q(!0);default:return N()}}return Z(),i.getToken()===17?s.allowEmptyContent?!0:(M(4,[],[]),!1):Y()?(i.getToken()!==17&&M(9,[],[]),!0):(M(4,[],[]),!1)}e.visit=l;function f(t,r){let s=k(t),i=[],u,w=0,v;do switch(v=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:w!==v&&i.push(t.substring(w,v)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),w=s.getPosition();break}while(u!==17);return i.join("")}e.stripComments=f;function m(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=m}),define(we[108],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class g{constructor(S){this.executor=S,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(S){this._error=S}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(S){return new g(()=>S(this.getValue()))}}e.Lazy=g}),define(we[7],_e([0,1,49,40]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const S=!1;let E=null;function k(f){E=f}if(e.setDisposableTracker=k,S){const f="__is_disposable_tracked__";E=new class{trackDisposable(m){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[f]||console.log(t)},3e3)}markTracked(m){if(m&&m!==d.None)try{m[f]=!0}catch(t){}}}}function D(f){!E||E.markTracked(f)}function _(f){return E&&E.trackDisposable(f),f}e.trackDisposable=_;class C extends Error{constructor(m){super(`Encountered errors while disposing of store. Errors: [${m.join(", ")}]`);this.errors=m}}e.MultiDisposeError=C;function n(f){return typeof f.dispose=="function"&&f.dispose.length===0}e.isDisposable=n;function I(f){if(T.Iterable.is(f)){let m=[];for(const t of f)if(t){D(t);try{t.dispose()}catch(r){m.push(r)}}if(m.length===1)throw m[0];if(m.length>1)throw new C(m);return Array.isArray(f)?[]:f}else if(f)return D(f),f.dispose(),f}e.dispose=I;function o(...f){return f.forEach(D),h(()=>I(f))}e.combinedDisposable=o;function h(f){const m=_({dispose:()=>{D(m),f()}});return m}e.toDisposable=h;class c{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(D(this),this._isDisposed=!0,this.clear())}clear(){try{I(this._toDispose.values())}finally{this._toDispose.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return D(m),this._isDisposed?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(m),m}}e.DisposableStore=c,c.DISABLE_DISPOSED_WARNING=!1;class d{constructor(){this._store=new c,_(this)}dispose(){D(this),this._store.dispose()}_register(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(m)}}e.Disposable=d,d.None=Object.freeze({dispose(){}});class y{constructor(){this._isDisposed=!1,_(this)}get value(){return this._isDisposed?void 0:this._value}set value(m){var t;this._isDisposed||m===this._value||((t=this._value)===null||t===void 0||t.dispose(),m&&D(m),this._value=m)}clear(){this.value=void 0}dispose(){var m;this._isDisposed=!0,D(this),(m=this._value)===null||m===void 0||m.dispose(),this._value=void 0}}e.MutableDisposable=y;class b{constructor(){this.references=new Map}acquire(m,...t){let r=this.references.get(m);r||(r={counter:0,object:this.createReferencedObject(m,...t)},this.references.set(m,r));const{object:s}=r,i=g.once(()=>{--r.counter==0&&(this.destroyReferencedObject(m,r.object),this.references.delete(m))});return r.counter++,{object:s,dispose:i}}}e.ReferenceCollection=b;class p{constructor(m){this.referenceCollection=m}async acquire(m,...t){const r=this.referenceCollection.acquire(m,...t);try{return{object:await r.object,dispose:()=>r.dispose()}}catch(s){throw r.dispose(),s}}}e.AsyncReferenceCollection=p;class l{constructor(m){this.object=m}dispose(){}}e.ImmortalReference=l}),define(we[51],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class g{constructor(E){this.element=E,this.next=g.Undefined,this.prev=g.Undefined}}g.Undefined=new g(void 0);class T{constructor(){this._first=g.Undefined,this._last=g.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===g.Undefined}clear(){let E=this._first;for(;E!==g.Undefined;){const k=E.next;E.prev=g.Undefined,E.next=g.Undefined,E=k}this._first=g.Undefined,this._last=g.Undefined,this._size=0}unshift(E){return this._insert(E,!1)}push(E){return this._insert(E,!0)}_insert(E,k){const D=new g(E);if(this._first===g.Undefined)this._first=D,this._last=D;else if(k){const C=this._last;this._last=D,D.prev=C,C.next=D}else{const C=this._first;this._first=D,D.next=C,C.prev=D}this._size+=1;let _=!1;return()=>{_||(_=!0,this._remove(D))}}shift(){if(this._first!==g.Undefined){const E=this._first.element;return this._remove(this._first),E}}pop(){if(this._last!==g.Undefined){const E=this._last.element;return this._remove(this._last),E}}_remove(E){if(E.prev!==g.Undefined&&E.next!==g.Undefined){const k=E.prev;k.next=E.next,E.next.prev=k}else E.prev===g.Undefined&&E.next===g.Undefined?(this._first=g.Undefined,this._last=g.Undefined):E.next===g.Undefined?(this._last=this._last.prev,this._last.next=g.Undefined):E.prev===g.Undefined&&(this._first=this._first.next,this._first.prev=g.Undefined);this._size-=1}*[Symbol.iterator](){let E=this._first;for(;E!==g.Undefined;)yield E.element,E=E.next}}e.LinkedList=T}),function(ee,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(ee=typeof globalThis!="undefined"?globalThis:ee||self,ee.marked=e())}(this,function(){"use strict";function ee(Ee,be){for(var Ce=0;Ce<be.length;Ce++){var se=be[Ce];se.enumerable=se.enumerable||!1,se.configurable=!0,"value"in se&&(se.writable=!0),Object.defineProperty(Ee,se.key,se)}}function e(Ee,be,Ce){return be&&ee(Ee.prototype,be),Ce&&ee(Ee,Ce),Ee}function g(Ee,be){if(!!Ee){if(typeof Ee=="string")return T(Ee,be);var Ce=Object.prototype.toString.call(Ee).slice(8,-1);if(Ce==="Object"&&Ee.constructor&&(Ce=Ee.constructor.name),Ce==="Map"||Ce==="Set")return Array.from(Ee);if(Ce==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Ce))return T(Ee,be)}}function T(Ee,be){(be==null||be>Ee.length)&&(be=Ee.length);for(var Ce=0,se=new Array(be);Ce<be;Ce++)se[Ce]=Ee[Ce];return se}function S(Ee,be){var Ce;if(typeof Symbol=="undefined"||Ee[Symbol.iterator]==null){if(Array.isArray(Ee)||(Ce=g(Ee))||be&&Ee&&typeof Ee.length=="number"){Ce&&(Ee=Ce);var se=0;return function(){return se>=Ee.length?{done:!0}:{done:!1,value:Ee[se++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return Ce=Ee[Symbol.iterator](),Ce.next.bind(Ce)}function E(Ee){var be={exports:{}};return Ee(be,be.exports),be.exports}var k=E(function(Ee){function be(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function Ce(se){Ee.exports.defaults=se}Ee.exports={defaults:be(),getDefaults:be,changeDefaults:Ce}}),D=/[&<>"']/,_=/[&<>"']/g,C=/[<>"']|&(?!#?\w+;)/,n=/[<>"']|&(?!#?\w+;)/g,I={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},o=function(be){return I[be]};function h(Ee,be){if(be){if(D.test(Ee))return Ee.replace(_,o)}else if(C.test(Ee))return Ee.replace(n,o);return Ee}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Ee){return Ee.replace(c,function(be,Ce){return Ce=Ce.toLowerCase(),Ce==="colon"?":":Ce.charAt(0)==="#"?Ce.charAt(1)==="x"?String.fromCharCode(parseInt(Ce.substring(2),16)):String.fromCharCode(+Ce.substring(1)):""})}var y=/(^|[^\[])\^/g;function b(Ee,be){Ee=Ee.source||Ee,be=be||"";var Ce={replace:function(de,U){return U=U.source||U,U=U.replace(y,"$1"),Ee=Ee.replace(de,U),Ce},getRegex:function(){return new RegExp(Ee,be)}};return Ce}var p=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function f(Ee,be,Ce){if(Ee){var se;try{se=decodeURIComponent(d(Ce)).replace(p,"").toLowerCase()}catch(de){return null}if(se.indexOf("javascript:")===0||se.indexOf("vbscript:")===0||se.indexOf("data:")===0)return null}be&&!l.test(Ce)&&(Ce=i(be,Ce));try{Ce=encodeURI(Ce).replace(/%25/g,"%")}catch(de){return null}return Ce}var m={},t=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function i(Ee,be){m[" "+Ee]||(t.test(Ee)?m[" "+Ee]=Ee+"/":m[" "+Ee]=P(Ee,"/",!0)),Ee=m[" "+Ee];var Ce=Ee.indexOf(":")===-1;return be.substring(0,2)==="//"?Ce?be:Ee.replace(r,"$1")+be:be.charAt(0)==="/"?Ce?be:Ee.replace(s,"$1")+be:Ee+be}var u={exec:function(){}};function w(Ee){for(var be=1,Ce,se;be<arguments.length;be++){Ce=arguments[be];for(se in Ce)Object.prototype.hasOwnProperty.call(Ce,se)&&(Ee[se]=Ce[se])}return Ee}function v(Ee,be){var Ce=Ee.replace(/\|/g,function(U,Q,le){for(var ke=!1,Pe=Q;--Pe>=0&&le[Pe]==="\\";)ke=!ke;return ke?"|":" |"}),se=Ce.split(/ \|/),de=0;if(se.length>be)se.splice(be);else for(;se.length<be;)se.push("");for(;de<se.length;de++)se[de]=se[de].trim().replace(/\\\|/g,"|");return se}function P(Ee,be,Ce){var se=Ee.length;if(se===0)return"";for(var de=0;de<se;){var U=Ee.charAt(se-de-1);if(U===be&&!Ce)de++;else if(U!==be&&Ce)de++;else break}return Ee.substr(0,se-de)}function A(Ee,be){if(Ee.indexOf(be[1])===-1)return-1;for(var Ce=Ee.length,se=0,de=0;de<Ce;de++)if(Ee[de]==="\\")de++;else if(Ee[de]===be[0])se++;else if(Ee[de]===be[1]&&(se--,se<0))return de;return-1}function a(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function R(Ee,be){if(be<1)return"";for(var Ce="";be>1;)be&1&&(Ce+=Ee),be>>=1,Ee+=Ee;return Ce+Ee}var L={escape:h,unescape:d,edit:b,cleanUrl:f,resolveUrl:i,noopTest:u,merge:w,splitCells:v,rtrim:P,findClosingBracket:A,checkSanitizeDeprecation:a,repeatString:R},H=k.defaults,ue=L.rtrim,me=L.splitCells,J=L.escape,z=L.findClosingBracket;function Z(Ee,be,Ce){var se=be.href,de=be.title?J(be.title):null,U=Ee[1].replace(/\\([\[\]])/g,"$1");return Ee[0].charAt(0)!=="!"?{type:"link",raw:Ce,href:se,title:de,text:U}:{type:"image",raw:Ce,href:se,title:de,text:J(U)}}function M(Ee,be){var Ce=Ee.match(/^(\s+)(?:```)/);if(Ce===null)return be;var se=Ce[1];return be.split(`
`).map(function(de){var U=de.match(/^\s+/);if(U===null)return de;var Q=U[0];return Q.length>=se.length?de.slice(se.length):de}).join(`
`)}var q=function(){function Ee(Ce){this.options=Ce||H}var be=Ee.prototype;return be.space=function(se){var de=this.rules.block.newline.exec(se);if(de)return de[0].length>1?{type:"space",raw:de[0]}:{raw:`
`}},be.code=function(se){var de=this.rules.block.code.exec(se);if(de){var U=de[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:de[0],codeBlockStyle:"indented",text:this.options.pedantic?U:ue(U,`
`)}}},be.fences=function(se){var de=this.rules.block.fences.exec(se);if(de){var U=de[0],Q=M(U,de[3]||"");return{type:"code",raw:U,lang:de[2]?de[2].trim():de[2],text:Q}}},be.heading=function(se){var de=this.rules.block.heading.exec(se);if(de){var U=de[2].trim();if(/#$/.test(U)){var Q=ue(U,"#");(this.options.pedantic||!Q||/ $/.test(Q))&&(U=Q.trim())}return{type:"heading",raw:de[0],depth:de[1].length,text:U}}},be.nptable=function(se){var de=this.rules.block.nptable.exec(se);if(de){var U={type:"table",header:me(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[],raw:de[0]};if(U.header.length===U.align.length){var Q=U.align.length,le;for(le=0;le<Q;le++)/^ *-+: *$/.test(U.align[le])?U.align[le]="right":/^ *:-+: *$/.test(U.align[le])?U.align[le]="center":/^ *:-+ *$/.test(U.align[le])?U.align[le]="left":U.align[le]=null;for(Q=U.cells.length,le=0;le<Q;le++)U.cells[le]=me(U.cells[le],U.header.length);return U}}},be.hr=function(se){var de=this.rules.block.hr.exec(se);if(de)return{type:"hr",raw:de[0]}},be.blockquote=function(se){var de=this.rules.block.blockquote.exec(se);if(de){var U=de[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:de[0],text:U}}},be.list=function(se){var de=this.rules.block.list.exec(se);if(de){var U=de[0],Q=de[2],le=Q.length>1,ke={type:"list",raw:U,ordered:le,start:le?+Q.slice(0,-1):"",loose:!1,items:[]},Pe=de[0].match(this.rules.block.item),Ue=!1,We,Ze,rt,Ke,Je,ft,ve,ye,ae=Pe.length;rt=this.rules.block.listItemStart.exec(Pe[0]);for(var V=0;V<ae;V++){if(We=Pe[V],U=We,V!==ae-1){if(Ke=this.rules.block.listItemStart.exec(Pe[V+1]),this.options.pedantic?Ke[1].length>rt[1].length:Ke[1].length>rt[0].length||Ke[1].length>3){Pe.splice(V,2,Pe[V]+`
`+Pe[V+1]),V--,ae--;continue}else(!this.options.pedantic||this.options.smartLists?Ke[2][Ke[2].length-1]!==Q[Q.length-1]:le===(Ke[2].length===1))&&(Je=Pe.slice(V+1).join(`
`),ke.raw=ke.raw.substring(0,ke.raw.length-Je.length),V=ae-1);rt=Ke}Ze=We.length,We=We.replace(/^ *([*+-]|\d+[.)]) ?/,""),~We.indexOf(`
 `)&&(Ze-=We.length,We=this.options.pedantic?We.replace(/^ {1,4}/gm,""):We.replace(new RegExp("^ {1,"+Ze+"}","gm"),"")),ft=Ue||/\n\n(?!\s*$)/.test(We),V!==ae-1&&(Ue=We.charAt(We.length-1)===`
`,ft||(ft=Ue)),ft&&(ke.loose=!0),this.options.gfm&&(ve=/^\[[ xX]\] /.test(We),ye=void 0,ve&&(ye=We[1]!==" ",We=We.replace(/^\[[ xX]\] +/,""))),ke.items.push({type:"list_item",raw:U,task:ve,checked:ye,loose:ft,text:We})}return ke}},be.html=function(se){var de=this.rules.block.html.exec(se);if(de)return{type:this.options.sanitize?"paragraph":"html",raw:de[0],pre:!this.options.sanitizer&&(de[1]==="pre"||de[1]==="script"||de[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(de[0]):J(de[0]):de[0]}},be.def=function(se){var de=this.rules.block.def.exec(se);if(de){de[3]&&(de[3]=de[3].substring(1,de[3].length-1));var U=de[1].toLowerCase().replace(/\s+/g," ");return{tag:U,raw:de[0],href:de[2],title:de[3]}}},be.table=function(se){var de=this.rules.block.table.exec(se);if(de){var U={type:"table",header:me(de[1].replace(/^ *| *\| *$/g,"")),align:de[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:de[3]?de[3].replace(/\n$/,"").split(`
`):[]};if(U.header.length===U.align.length){U.raw=de[0];var Q=U.align.length,le;for(le=0;le<Q;le++)/^ *-+: *$/.test(U.align[le])?U.align[le]="right":/^ *:-+: *$/.test(U.align[le])?U.align[le]="center":/^ *:-+ *$/.test(U.align[le])?U.align[le]="left":U.align[le]=null;for(Q=U.cells.length,le=0;le<Q;le++)U.cells[le]=me(U.cells[le].replace(/^ *\| *| *\| *$/g,""),U.header.length);return U}}},be.lheading=function(se){var de=this.rules.block.lheading.exec(se);if(de)return{type:"heading",raw:de[0],depth:de[2].charAt(0)==="="?1:2,text:de[1]}},be.paragraph=function(se){var de=this.rules.block.paragraph.exec(se);if(de)return{type:"paragraph",raw:de[0],text:de[1].charAt(de[1].length-1)===`
`?de[1].slice(0,-1):de[1]}},be.text=function(se){var de=this.rules.block.text.exec(se);if(de)return{type:"text",raw:de[0],text:de[0]}},be.escape=function(se){var de=this.rules.inline.escape.exec(se);if(de)return{type:"escape",raw:de[0],text:J(de[1])}},be.tag=function(se,de,U){var Q=this.rules.inline.tag.exec(se);if(Q)return!de&&/^<a /i.test(Q[0])?de=!0:de&&/^<\/a>/i.test(Q[0])&&(de=!1),!U&&/^<(pre|code|kbd|script)(\s|>)/i.test(Q[0])?U=!0:U&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Q[0])&&(U=!1),{type:this.options.sanitize?"text":"html",raw:Q[0],inLink:de,inRawBlock:U,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):J(Q[0]):Q[0]}},be.link=function(se){var de=this.rules.inline.link.exec(se);if(de){var U=de[2].trim();if(!this.options.pedantic&&/^</.test(U)){if(!/>$/.test(U))return;var Q=ue(U.slice(0,-1),"\\");if((U.length-Q.length)%2==0)return}else{var le=z(de[2],"()");if(le>-1){var ke=de[0].indexOf("!")===0?5:4,Pe=ke+de[1].length+le;de[2]=de[2].substring(0,le),de[0]=de[0].substring(0,Pe).trim(),de[3]=""}}var Ue=de[2],We="";if(this.options.pedantic){var Ze=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ue);Ze&&(Ue=Ze[1],We=Ze[3])}else We=de[3]?de[3].slice(1,-1):"";return Ue=Ue.trim(),/^</.test(Ue)&&(this.options.pedantic&&!/>$/.test(U)?Ue=Ue.slice(1):Ue=Ue.slice(1,-1)),Z(de,{href:Ue&&Ue.replace(this.rules.inline._escapes,"$1"),title:We&&We.replace(this.rules.inline._escapes,"$1")},de[0])}},be.reflink=function(se,de){var U;if((U=this.rules.inline.reflink.exec(se))||(U=this.rules.inline.nolink.exec(se))){var Q=(U[2]||U[1]).replace(/\s+/g," ");if(Q=de[Q.toLowerCase()],!Q||!Q.href){var le=U[0].charAt(0);return{type:"text",raw:le,text:le}}return Z(U,Q,U[0])}},be.emStrong=function(se,de,U){U===void 0&&(U="");var Q=this.rules.inline.emStrong.lDelim.exec(se);if(!!Q&&!(Q[3]&&U.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var le=Q[1]||Q[2]||"";if(!le||le&&(U===""||this.rules.inline.punctuation.exec(U))){var ke=Q[0].length-1,Pe,Ue,We=ke,Ze=0,rt=Q[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(rt.lastIndex=0,de=de.slice(-1*se.length+ke);(Q=rt.exec(de))!=null;)if(Pe=Q[1]||Q[2]||Q[3]||Q[4]||Q[5]||Q[6],!!Pe){if(Ue=Pe.length,Q[3]||Q[4]){We+=Ue;continue}else if((Q[5]||Q[6])&&ke%3&&!((ke+Ue)%3)){Ze+=Ue;continue}if(We-=Ue,!(We>0)){if(We+Ze-Ue<=0&&!de.slice(rt.lastIndex).match(rt)&&(Ue=Math.min(Ue,Ue+We+Ze)),Math.min(ke,Ue)%2)return{type:"em",raw:se.slice(0,ke+Q.index+Ue+1),text:se.slice(1,ke+Q.index+Ue)};if(Math.min(ke,Ue)%2==0)return{type:"strong",raw:se.slice(0,ke+Q.index+Ue+1),text:se.slice(2,ke+Q.index+Ue-1)}}}}}},be.codespan=function(se){var de=this.rules.inline.code.exec(se);if(de){var U=de[2].replace(/\n/g," "),Q=/[^ ]/.test(U),le=/^ /.test(U)&&/ $/.test(U);return Q&&le&&(U=U.substring(1,U.length-1)),U=J(U,!0),{type:"codespan",raw:de[0],text:U}}},be.br=function(se){var de=this.rules.inline.br.exec(se);if(de)return{type:"br",raw:de[0]}},be.del=function(se){var de=this.rules.inline.del.exec(se);if(de)return{type:"del",raw:de[0],text:de[2]}},be.autolink=function(se,de){var U=this.rules.inline.autolink.exec(se);if(U){var Q,le;return U[2]==="@"?(Q=J(this.options.mangle?de(U[1]):U[1]),le="mailto:"+Q):(Q=J(U[1]),le=Q),{type:"link",raw:U[0],text:Q,href:le,tokens:[{type:"text",raw:Q,text:Q}]}}},be.url=function(se,de){var U;if(U=this.rules.inline.url.exec(se)){var Q,le;if(U[2]==="@")Q=J(this.options.mangle?de(U[0]):U[0]),le="mailto:"+Q;else{var ke;do ke=U[0],U[0]=this.rules.inline._backpedal.exec(U[0])[0];while(ke!==U[0]);Q=J(U[0]),U[1]==="www."?le="http://"+Q:le=Q}return{type:"link",raw:U[0],text:Q,href:le,tokens:[{type:"text",raw:Q,text:Q}]}}},be.inlineText=function(se,de,U){var Q=this.rules.inline.text.exec(se);if(Q){var le;return de?le=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):J(Q[0]):Q[0]:le=J(this.options.smartypants?U(Q[0]):Q[0]),{type:"text",raw:Q[0],text:le}}},Ee}(),N=L.noopTest,W=L.edit,O=L.merge,B={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:N,table:N,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};B._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,B._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,B.def=W(B.def).replace("label",B._label).replace("title",B._title).getRegex(),B.bullet=/(?:[*+-]|\d{1,9}[.)])/,B.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,B.item=W(B.item,"gm").replace(/bull/g,B.bullet).getRegex(),B.listItemStart=W(/^( *)(bull)/).replace("bull",B.bullet).getRegex(),B.list=W(B.list).replace(/bull/g,B.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+B.def.source+")").getRegex(),B._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",B._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,B.html=W(B.html,"i").replace("comment",B._comment).replace("tag",B._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),B.paragraph=W(B._paragraph).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.blockquote=W(B.blockquote).replace("paragraph",B.paragraph).getRegex(),B.normal=O({},B),B.gfm=O({},B.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),B.gfm.nptable=W(B.gfm.nptable).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.gfm.table=W(B.gfm.table).replace("hr",B.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",B._tag).getRegex(),B.pedantic=O({},B.normal,{html:W(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",B._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:N,paragraph:W(B.normal._paragraph).replace("hr",B.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",B.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var Y={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:N,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:N,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};Y._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",Y.punctuation=W(Y.punctuation).replace(/punctuation/g,Y._punctuation).getRegex(),Y.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,Y.escapedEmSt=/\\\*|\\_/g,Y._comment=W(B._comment).replace("(?:-->|$)","-->").getRegex(),Y.emStrong.lDelim=W(Y.emStrong.lDelim).replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimAst=W(Y.emStrong.rDelimAst,"g").replace(/punct/g,Y._punctuation).getRegex(),Y.emStrong.rDelimUnd=W(Y.emStrong.rDelimUnd,"g").replace(/punct/g,Y._punctuation).getRegex(),Y._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,Y._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,Y._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,Y.autolink=W(Y.autolink).replace("scheme",Y._scheme).replace("email",Y._email).getRegex(),Y._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,Y.tag=W(Y.tag).replace("comment",Y._comment).replace("attribute",Y._attribute).getRegex(),Y._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,Y._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,Y._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,Y.link=W(Y.link).replace("label",Y._label).replace("href",Y._href).replace("title",Y._title).getRegex(),Y.reflink=W(Y.reflink).replace("label",Y._label).getRegex(),Y.reflinkSearch=W(Y.reflinkSearch,"g").replace("reflink",Y.reflink).replace("nolink",Y.nolink).getRegex(),Y.normal=O({},Y),Y.pedantic=O({},Y.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:W(/^!?\[(label)\]\((.*?)\)/).replace("label",Y._label).getRegex(),reflink:W(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",Y._label).getRegex()}),Y.gfm=O({},Y.normal,{escape:W(Y.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),Y.gfm.url=W(Y.gfm.url,"i").replace("email",Y.gfm._extended_email).getRegex(),Y.breaks=O({},Y.gfm,{br:W(Y.br).replace("{2,}","*").getRegex(),text:W(Y.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var he={block:B,inline:Y},De=k.defaults,Oe=he.block,Me=he.inline,He=L.repeatString;function Ye(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function qe(Ee){var be="",Ce,se,de=Ee.length;for(Ce=0;Ce<de;Ce++)se=Ee.charCodeAt(Ce),Math.random()>.5&&(se="x"+se.toString(16)),be+="&#"+se+";";return be}var Xe=function(){function Ee(Ce){this.tokens=[],this.tokens.links=Object.create(null),this.options=Ce||De,this.options.tokenizer=this.options.tokenizer||new q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var se={block:Oe.normal,inline:Me.normal};this.options.pedantic?(se.block=Oe.pedantic,se.inline=Me.pedantic):this.options.gfm&&(se.block=Oe.gfm,this.options.breaks?se.inline=Me.breaks:se.inline=Me.gfm),this.tokenizer.rules=se}Ee.lex=function(se,de){var U=new Ee(de);return U.lex(se)},Ee.lexInline=function(se,de){var U=new Ee(de);return U.inlineTokens(se)};var be=Ee.prototype;return be.lex=function(se){return se=se.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(se,this.tokens,!0),this.inline(this.tokens),this.tokens},be.blockTokens=function(se,de,U){de===void 0&&(de=[]),U===void 0&&(U=!0),this.options.pedantic&&(se=se.replace(/^ +$/gm,""));for(var Q,le,ke,Pe;se;){if(Q=this.tokenizer.space(se)){se=se.substring(Q.raw.length),Q.type&&de.push(Q);continue}if(Q=this.tokenizer.code(se)){se=se.substring(Q.raw.length),Pe=de[de.length-1],Pe&&Pe.type==="paragraph"?(Pe.raw+=`
`+Q.raw,Pe.text+=`
`+Q.text):de.push(Q);continue}if(Q=this.tokenizer.fences(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.heading(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.nptable(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.hr(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.blockquote(se)){se=se.substring(Q.raw.length),Q.tokens=this.blockTokens(Q.text,[],U),de.push(Q);continue}if(Q=this.tokenizer.list(se)){for(se=se.substring(Q.raw.length),ke=Q.items.length,le=0;le<ke;le++)Q.items[le].tokens=this.blockTokens(Q.items[le].text,[],!1);de.push(Q);continue}if(Q=this.tokenizer.html(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(U&&(Q=this.tokenizer.def(se))){se=se.substring(Q.raw.length),this.tokens.links[Q.tag]||(this.tokens.links[Q.tag]={href:Q.href,title:Q.title});continue}if(Q=this.tokenizer.table(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.lheading(se)){se=se.substring(Q.raw.length),de.push(Q);continue}if(U&&(Q=this.tokenizer.paragraph(se))){se=se.substring(Q.raw.length),de.push(Q);continue}if(Q=this.tokenizer.text(se)){se=se.substring(Q.raw.length),Pe=de[de.length-1],Pe&&Pe.type==="text"?(Pe.raw+=`
`+Q.raw,Pe.text+=`
`+Q.text):de.push(Q);continue}if(se){var Ue="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(Ue);break}else throw new Error(Ue)}}return de},be.inline=function(se){var de,U,Q,le,ke,Pe,Ue=se.length;for(de=0;de<Ue;de++)switch(Pe=se[de],Pe.type){case"paragraph":case"text":case"heading":{Pe.tokens=[],this.inlineTokens(Pe.text,Pe.tokens);break}case"table":{for(Pe.tokens={header:[],cells:[]},le=Pe.header.length,U=0;U<le;U++)Pe.tokens.header[U]=[],this.inlineTokens(Pe.header[U],Pe.tokens.header[U]);for(le=Pe.cells.length,U=0;U<le;U++)for(ke=Pe.cells[U],Pe.tokens.cells[U]=[],Q=0;Q<ke.length;Q++)Pe.tokens.cells[U][Q]=[],this.inlineTokens(ke[Q],Pe.tokens.cells[U][Q]);break}case"blockquote":{this.inline(Pe.tokens);break}case"list":{for(le=Pe.items.length,U=0;U<le;U++)this.inline(Pe.items[U].tokens);break}}return se},be.inlineTokens=function(se,de,U,Q){de===void 0&&(de=[]),U===void 0&&(U=!1),Q===void 0&&(Q=!1);var le,ke,Pe=se,Ue,We,Ze;if(this.tokens.links){var rt=Object.keys(this.tokens.links);if(rt.length>0)for(;(Ue=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)rt.includes(Ue[0].slice(Ue[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ue.index)+"["+He("a",Ue[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ue=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ue.index)+"["+He("a",Ue[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ue=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ue.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;se;){if(We||(Ze=""),We=!1,le=this.tokenizer.escape(se)){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.tag(se,U,Q)){se=se.substring(le.raw.length),U=le.inLink,Q=le.inRawBlock;var Ke=de[de.length-1];Ke&&le.type==="text"&&Ke.type==="text"?(Ke.raw+=le.raw,Ke.text+=le.text):de.push(le);continue}if(le=this.tokenizer.link(se)){se=se.substring(le.raw.length),le.type==="link"&&(le.tokens=this.inlineTokens(le.text,[],!0,Q)),de.push(le);continue}if(le=this.tokenizer.reflink(se,this.tokens.links)){se=se.substring(le.raw.length);var Je=de[de.length-1];le.type==="link"?(le.tokens=this.inlineTokens(le.text,[],!0,Q),de.push(le)):Je&&le.type==="text"&&Je.type==="text"?(Je.raw+=le.raw,Je.text+=le.text):de.push(le);continue}if(le=this.tokenizer.emStrong(se,Pe,Ze)){se=se.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],U,Q),de.push(le);continue}if(le=this.tokenizer.codespan(se)){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.br(se)){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.del(se)){se=se.substring(le.raw.length),le.tokens=this.inlineTokens(le.text,[],U,Q),de.push(le);continue}if(le=this.tokenizer.autolink(se,qe)){se=se.substring(le.raw.length),de.push(le);continue}if(!U&&(le=this.tokenizer.url(se,qe))){se=se.substring(le.raw.length),de.push(le);continue}if(le=this.tokenizer.inlineText(se,Q,Ye)){se=se.substring(le.raw.length),le.raw.slice(-1)!=="_"&&(Ze=le.raw.slice(-1)),We=!0,ke=de[de.length-1],ke&&ke.type==="text"?(ke.raw+=le.raw,ke.text+=le.text):de.push(le);continue}if(se){var ft="Infinite loop on byte: "+se.charCodeAt(0);if(this.options.silent){console.error(ft);break}else throw new Error(ft)}}return de},e(Ee,null,[{key:"rules",get:function(){return{block:Oe,inline:Me}}}]),Ee}(),$=k.defaults,G=L.cleanUrl,te=L.escape,re=function(){function Ee(Ce){this.options=Ce||$}var be=Ee.prototype;return be.code=function(se,de,U){var Q=(de||"").match(/\S*/)[0];if(this.options.highlight){var le=this.options.highlight(se,Q);le!=null&&le!==se&&(U=!0,se=le)}return se=se.replace(/\n$/,"")+`
`,Q?'<pre><code class="'+this.options.langPrefix+te(Q,!0)+'">'+(U?se:te(se,!0))+`</code></pre>
`:"<pre><code>"+(U?se:te(se,!0))+`</code></pre>
`},be.blockquote=function(se){return`<blockquote>
`+se+`</blockquote>
`},be.html=function(se){return se},be.heading=function(se,de,U,Q){return this.options.headerIds?"<h"+de+' id="'+this.options.headerPrefix+Q.slug(U)+'">'+se+"</h"+de+`>
`:"<h"+de+">"+se+"</h"+de+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(se,de,U){var Q=de?"ol":"ul",le=de&&U!==1?' start="'+U+'"':"";return"<"+Q+le+`>
`+se+"</"+Q+`>
`},be.listitem=function(se){return"<li>"+se+`</li>
`},be.checkbox=function(se){return"<input "+(se?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(se){return"<p>"+se+`</p>
`},be.table=function(se,de){return de&&(de="<tbody>"+de+"</tbody>"),`<table>
<thead>
`+se+`</thead>
`+de+`</table>
`},be.tablerow=function(se){return`<tr>
`+se+`</tr>
`},be.tablecell=function(se,de){var U=de.header?"th":"td",Q=de.align?"<"+U+' align="'+de.align+'">':"<"+U+">";return Q+se+"</"+U+`>
`},be.strong=function(se){return"<strong>"+se+"</strong>"},be.em=function(se){return"<em>"+se+"</em>"},be.codespan=function(se){return"<code>"+se+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(se){return"<del>"+se+"</del>"},be.link=function(se,de,U){if(se=G(this.options.sanitize,this.options.baseUrl,se),se===null)return U;var Q='<a href="'+te(se)+'"';return de&&(Q+=' title="'+de+'"'),Q+=">"+U+"</a>",Q},be.image=function(se,de,U){if(se=G(this.options.sanitize,this.options.baseUrl,se),se===null)return U;var Q='<img src="'+se+'" alt="'+U+'"';return de&&(Q+=' title="'+de+'"'),Q+=this.options.xhtml?"/>":">",Q},be.text=function(se){return se},Ee}(),K=function(){function Ee(){}var be=Ee.prototype;return be.strong=function(se){return se},be.em=function(se){return se},be.codespan=function(se){return se},be.del=function(se){return se},be.html=function(se){return se},be.text=function(se){return se},be.link=function(se,de,U){return""+U},be.image=function(se,de,U){return""+U},be.br=function(){return""},Ee}(),oe=function(){function Ee(){this.seen={}}var be=Ee.prototype;return be.serialize=function(se){return se.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(se,de){var U=se,Q=0;if(this.seen.hasOwnProperty(U)){Q=this.seen[se];do Q++,U=se+"-"+Q;while(this.seen.hasOwnProperty(U))}return de||(this.seen[se]=Q,this.seen[U]=0),U},be.slug=function(se,de){de===void 0&&(de={});var U=this.serialize(se);return this.getNextSafeSlug(U,de.dryrun)},Ee}(),fe=k.defaults,Ae=L.unescape,$e=function(){function Ee(Ce){this.options=Ce||fe,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new K,this.slugger=new oe}Ee.parse=function(se,de){var U=new Ee(de);return U.parse(se)},Ee.parseInline=function(se,de){var U=new Ee(de);return U.parseInline(se)};var be=Ee.prototype;return be.parse=function(se,de){de===void 0&&(de=!0);var U="",Q,le,ke,Pe,Ue,We,Ze,rt,Ke,Je,ft,ve,ye,ae,V,xe,Te,Re,nt=se.length;for(Q=0;Q<nt;Q++)switch(Je=se[Q],Je.type){case"space":continue;case"hr":{U+=this.renderer.hr();continue}case"heading":{U+=this.renderer.heading(this.parseInline(Je.tokens),Je.depth,Ae(this.parseInline(Je.tokens,this.textRenderer)),this.slugger);continue}case"code":{U+=this.renderer.code(Je.text,Je.lang,Je.escaped);continue}case"table":{for(rt="",Ze="",Pe=Je.header.length,le=0;le<Pe;le++)Ze+=this.renderer.tablecell(this.parseInline(Je.tokens.header[le]),{header:!0,align:Je.align[le]});for(rt+=this.renderer.tablerow(Ze),Ke="",Pe=Je.cells.length,le=0;le<Pe;le++){for(We=Je.tokens.cells[le],Ze="",Ue=We.length,ke=0;ke<Ue;ke++)Ze+=this.renderer.tablecell(this.parseInline(We[ke]),{header:!1,align:Je.align[ke]});Ke+=this.renderer.tablerow(Ze)}U+=this.renderer.table(rt,Ke);continue}case"blockquote":{Ke=this.parse(Je.tokens),U+=this.renderer.blockquote(Ke);continue}case"list":{for(ft=Je.ordered,ve=Je.start,ye=Je.loose,Pe=Je.items.length,Ke="",le=0;le<Pe;le++)V=Je.items[le],xe=V.checked,Te=V.task,ae="",V.task&&(Re=this.renderer.checkbox(xe),ye?V.tokens.length>0&&V.tokens[0].type==="text"?(V.tokens[0].text=Re+" "+V.tokens[0].text,V.tokens[0].tokens&&V.tokens[0].tokens.length>0&&V.tokens[0].tokens[0].type==="text"&&(V.tokens[0].tokens[0].text=Re+" "+V.tokens[0].tokens[0].text)):V.tokens.unshift({type:"text",text:Re}):ae+=Re),ae+=this.parse(V.tokens,ye),Ke+=this.renderer.listitem(ae,Te,xe);U+=this.renderer.list(Ke,ft,ve);continue}case"html":{U+=this.renderer.html(Je.text);continue}case"paragraph":{U+=this.renderer.paragraph(this.parseInline(Je.tokens));continue}case"text":{for(Ke=Je.tokens?this.parseInline(Je.tokens):Je.text;Q+1<nt&&se[Q+1].type==="text";)Je=se[++Q],Ke+=`
`+(Je.tokens?this.parseInline(Je.tokens):Je.text);U+=de?this.renderer.paragraph(Ke):Ke;continue}default:{var ot='Token with "'+Je.type+'" type was not found.';if(this.options.silent){console.error(ot);return}else throw new Error(ot)}}return U},be.parseInline=function(se,de){de=de||this.renderer;var U="",Q,le,ke=se.length;for(Q=0;Q<ke;Q++)switch(le=se[Q],le.type){case"escape":{U+=de.text(le.text);break}case"html":{U+=de.html(le.text);break}case"link":{U+=de.link(le.href,le.title,this.parseInline(le.tokens,de));break}case"image":{U+=de.image(le.href,le.title,le.text);break}case"strong":{U+=de.strong(this.parseInline(le.tokens,de));break}case"em":{U+=de.em(this.parseInline(le.tokens,de));break}case"codespan":{U+=de.codespan(le.text);break}case"br":{U+=de.br();break}case"del":{U+=de.del(this.parseInline(le.tokens,de));break}case"text":{U+=de.text(le.text);break}default:{var Pe='Token with "'+le.type+'" type was not found.';if(this.options.silent){console.error(Pe);return}else throw new Error(Pe)}}return U},Ee}(),pe=L.merge,Ge=L.checkSanitizeDeprecation,j=L.escape,ne=k.getDefaults,ge=k.changeDefaults,Fe=k.defaults;function Ne(Ee,be,Ce){if(typeof Ee=="undefined"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof be=="function"&&(Ce=be,be=null),be=pe({},Ne.defaults,be||{}),Ge(be),Ce){var se=be.highlight,de;try{de=Xe.lex(Ee,be)}catch(ke){return Ce(ke)}var U=function(Pe){var Ue;if(!Pe)try{Ue=$e.parse(de,be)}catch(We){Pe=We}return be.highlight=se,Pe?Ce(Pe):Ce(null,Ue)};if(!se||se.length<3||(delete be.highlight,!de.length))return U();var Q=0;Ne.walkTokens(de,function(ke){ke.type==="code"&&(Q++,setTimeout(function(){se(ke.text,ke.lang,function(Pe,Ue){if(Pe)return U(Pe);Ue!=null&&Ue!==ke.text&&(ke.text=Ue,ke.escaped=!0),Q--,Q===0&&U()})},0))}),Q===0&&U();return}try{var le=Xe.lex(Ee,be);return be.walkTokens&&Ne.walkTokens(le,be.walkTokens),$e.parse(le,be)}catch(ke){if(ke.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+j(ke.message+"",!0)+"</pre>";throw ke}}Ne.options=Ne.setOptions=function(Ee){return pe(Ne.defaults,Ee),ge(Ne.defaults),Ne},Ne.getDefaults=ne,Ne.defaults=Fe,Ne.use=function(Ee){var be=pe({},Ee);if(Ee.renderer&&function(){var se=Ne.defaults.renderer||new re,de=function(le){var ke=se[le];se[le]=function(){for(var Pe=arguments.length,Ue=new Array(Pe),We=0;We<Pe;We++)Ue[We]=arguments[We];var Ze=Ee.renderer[le].apply(se,Ue);return Ze===!1&&(Ze=ke.apply(se,Ue)),Ze}};for(var U in Ee.renderer)de(U);be.renderer=se}(),Ee.tokenizer&&function(){var se=Ne.defaults.tokenizer||new q,de=function(le){var ke=se[le];se[le]=function(){for(var Pe=arguments.length,Ue=new Array(Pe),We=0;We<Pe;We++)Ue[We]=arguments[We];var Ze=Ee.tokenizer[le].apply(se,Ue);return Ze===!1&&(Ze=ke.apply(se,Ue)),Ze}};for(var U in Ee.tokenizer)de(U);be.tokenizer=se}(),Ee.walkTokens){var Ce=Ne.defaults.walkTokens;be.walkTokens=function(se){Ee.walkTokens(se),Ce&&Ce(se)}}Ne.setOptions(be)},Ne.walkTokens=function(Ee,be){for(var Ce=S(Ee),se;!(se=Ce()).done;){var de=se.value;switch(be(de),de.type){case"table":{for(var U=S(de.tokens.header),Q;!(Q=U()).done;){var le=Q.value;Ne.walkTokens(le,be)}for(var ke=S(de.tokens.cells),Pe;!(Pe=ke()).done;)for(var Ue=Pe.value,We=S(Ue),Ze;!(Ze=We()).done;){var rt=Ze.value;Ne.walkTokens(rt,be)}break}case"list":{Ne.walkTokens(de.items,be);break}default:de.tokens&&Ne.walkTokens(de.tokens,be)}}},Ne.parseInline=function(Ee,be){if(typeof Ee=="undefined"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");be=pe({},Ne.defaults,be||{}),Ge(be);try{var Ce=Xe.lexInline(Ee,be);return be.walkTokens&&Ne.walkTokens(Ce,be.walkTokens),$e.parseInline(Ce,be)}catch(se){if(se.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+j(se.message+"",!0)+"</pre>";throw se}},Ne.Parser=$e,Ne.parser=$e.parse,Ne.Renderer=re,Ne.TextRenderer=K,Ne.Lexer=Xe,Ne.lexer=Xe.lex,Ne.Tokenizer=q,Ne.Slugger=oe,Ne.parse=Ne;var Qe=Ne;return Qe}),define(we[77],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function g(k,D,_){return Math.min(Math.max(k,D),_)}e.clamp=g;function T(k,D){return(D+k%D)%D}e.rot=T;class S{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=S;class E{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=E}),function(){function ee(S){const E=[];typeof S=="number"&&E.push("code/timeOrigin",S);function k(_){E.push(_,Date.now())}function D(){const _=[];for(let C=0;C<E.length;C+=2)_.push({name:E[C],startTime:E[C+1]});return _}return{mark:k,getMarks:D}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?ee():{mark(S){performance.mark(S)},getMarks(){let S=performance.timeOrigin;typeof S!="number"&&(S=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const E=[{name:"code/timeOrigin",startTime:Math.round(S)}];for(const k of performance.getEntriesByType("mark"))E.push({name:k.name,startTime:Math.round(S+k.startTime)});return E}};if(typeof process=="object"){const S=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return ee(S)}else return console.trace("perf-util loaded in UNKNOWN environment"),ee()}function g(S){return S.MonacoPerformanceMarks||(S.MonacoPerformanceMarks=e()),S.MonacoPerformanceMarks}var T;typeof global=="object"?T=global:typeof self=="object"?T=self:T={},typeof define=="function"?define("vs/base/common/performance",[],function(){return g(T)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=g(T):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),T.perf=g(T))}(),define(we[21],_e([0,1]),function(ee,e){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const T="en";let S=!1,E=!1,k=!1,D=!1,_=!1,C=!1,n=!1,I,o=T,h,c;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let d;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?d=e.globals.vscode.process:typeof process!="undefined"&&(d=process);const y=typeof((g=d==null?void 0:d.versions)===null||g===void 0?void 0:g.electron)=="string"&&d.type==="renderer";if(e.isElectronSandboxed=y&&(d==null?void 0:d.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const i=d==null?void 0:d.env.VSCODE_BROWSER_CODE_LOADING;if(typeof i=="string")return i==="none"||i==="code"||i==="bypassHeatCheck"||i==="bypassHeatCheckAndEagerCompile"?i:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!y)c=navigator.userAgent,S=c.indexOf("Windows")>=0,E=c.indexOf("Macintosh")>=0,n=(c.indexOf("Macintosh")>=0||c.indexOf("iPad")>=0||c.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,k=c.indexOf("Linux")>=0,C=!0,I=navigator.language,o=I;else if(typeof d=="object"){S=d.platform==="win32",E=d.platform==="darwin",k=d.platform==="linux",D=k&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,I=T,o=T;const i=d.env.VSCODE_NLS_CONFIG;if(i)try{const u=JSON.parse(i),w=u.availableLanguages["*"];I=u.locale,o=w||T,h=u._translationsConfigFile}catch(u){}_=!0}else console.error("Unable to resolve platform.");var b;(function(i){i[i.Web=0]="Web",i[i.Mac=1]="Mac",i[i.Linux=2]="Linux",i[i.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function p(i){switch(i){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=p;let l=0;E?l=1:S?l=3:k&&(l=2),e.isWindows=S,e.isMacintosh=E,e.isLinux=k,e.isLinuxSnap=D,e.isNative=_,e.isWeb=C,e.isIOS=n,e.platform=l,e.userAgent=c,e.language=o;var f;(function(i){function u(){return e.language}i.value=u;function w(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}i.isDefaultVariant=w;function v(){return e.language==="en"}i.isDefault=v})(f=e.Language||(e.Language={})),e.locale=I,e.translationsConfigFile=h,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let w=[];e.globals.addEventListener("message",P=>{if(P.data&&P.data.vscodeSetImmediateId)for(let A=0,a=w.length;A<a;A++){const R=w[A];if(R.id===P.data.vscodeSetImmediateId){w.splice(A,1),R.callback();return}}});let v=0;return P=>{const A=++v;w.push({id:A,callback:P}),e.globals.postMessage({vscodeSetImmediateId:A},"*")}}if(typeof(d==null?void 0:d.nextTick)=="function")return d.nextTick.bind(d);const u=Promise.resolve();return w=>u.then(w)}();var m;(function(i){i[i.Windows=1]="Windows",i[i.Macintosh=2]="Macintosh",i[i.Linux=3]="Linux"})(m=e.OperatingSystem||(e.OperatingSystem={})),e.OS=E||n?2:S?1:3;let t=!0,r=!1;function s(){if(!r){r=!0;const i=new Uint8Array(2);i[0]=1,i[1]=2,t=new Uint16Array(i.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=s}),define(we[41],_e([0,1,21]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let T;if(typeof g.globals.vscode!="undefined"&&typeof g.globals.vscode.process!="undefined"){const S=g.globals.vscode.process;T={get platform(){return S.platform},get env(){return S.env},cwd(){return S.cwd()},nextTick(E){return g.setImmediate(E)}}}else typeof process!="undefined"?T={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(S){return process.nextTick(S)}}:T={get platform(){return g.isWindows?"win32":g.isMacintosh?"darwin":"linux"},nextTick(S){return g.setImmediate(S)},get env(){return{}},cwd(){return"/"}};e.cwd=T.cwd,e.env=T.env,e.platform=T.platform,e.nextTick=T.nextTick}),define(we[14],_e([0,1,41]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const T=65,S=97,E=90,k=122,D=46,_=47,C=92,n=58,I=63;class o extends Error{constructor(f,m,t){let r;typeof m=="string"&&m.indexOf("not ")===0?(r="must not be",m=m.replace(/^not /,"")):r="must be";const s=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${s} ${r} of type ${m}`;i+=`. Received type ${typeof t}`,super(i),this.code="ERR_INVALID_ARG_TYPE"}}function h(l,f){if(typeof l!="string")throw new o(f,"string",l)}function c(l){return l===_||l===C}function d(l){return l===_}function y(l){return l>=T&&l<=E||l>=S&&l<=k}function b(l,f,m,t){let r="",s=0,i=-1,u=0,w=0;for(let v=0;v<=l.length;++v){if(v<l.length)w=l.charCodeAt(v);else{if(t(w))break;w=_}if(t(w)){if(!(i===v-1||u===1))if(u===2){if(r.length<2||s!==2||r.charCodeAt(r.length-1)!==D||r.charCodeAt(r.length-2)!==D){if(r.length>2){const P=r.lastIndexOf(m);P===-1?(r="",s=0):(r=r.slice(0,P),s=r.length-1-r.lastIndexOf(m)),i=v,u=0;continue}else if(r.length!==0){r="",s=0,i=v,u=0;continue}}f&&(r+=r.length>0?`${m}..`:"..",s=2)}else r.length>0?r+=`${m}${l.slice(i+1,v)}`:r=l.slice(i+1,v),s=v-i-1;i=v,u=0}else w===D&&u!==-1?++u:u=-1}return r}function p(l,f){if(f===null||typeof f!="object")throw new o("pathObject","Object",f);const m=f.dir||f.root,t=f.base||`${f.name||""}${f.ext||""}`;return m?m===f.root?`${m}${t}`:`${m}${l}${t}`:t}e.win32={resolve(...l){let f="",m="",t=!1;for(let r=l.length-1;r>=-1;r--){let s;if(r>=0){if(s=l[r],h(s,"path"),s.length===0)continue}else f.length===0?s=g.cwd():(s=g.env[`=${f}`]||g.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==f.toLowerCase()&&s.charCodeAt(2)===C)&&(s=`${f}\\`));const i=s.length;let u=0,w="",v=!1;const P=s.charCodeAt(0);if(i===1)c(P)&&(u=1,v=!0);else if(c(P))if(v=!0,c(s.charCodeAt(1))){let A=2,a=A;for(;A<i&&!c(s.charCodeAt(A));)A++;if(A<i&&A!==a){const R=s.slice(a,A);for(a=A;A<i&&c(s.charCodeAt(A));)A++;if(A<i&&A!==a){for(a=A;A<i&&!c(s.charCodeAt(A));)A++;(A===i||A!==a)&&(w=`\\\\${R}\\${s.slice(a,A)}`,u=A)}}}else u=1;else y(P)&&s.charCodeAt(1)===n&&(w=s.slice(0,2),u=2,i>2&&c(s.charCodeAt(2))&&(v=!0,u=3));if(w.length>0)if(f.length>0){if(w.toLowerCase()!==f.toLowerCase())continue}else f=w;if(t){if(f.length>0)break}else if(m=`${s.slice(u)}\\${m}`,t=v,v&&f.length>0)break}return m=b(m,!t,"\\",c),t?`${f}\\${m}`:`${f}${m}`||"."},normalize(l){h(l,"path");const f=l.length;if(f===0)return".";let m=0,t,r=!1;const s=l.charCodeAt(0);if(f===1)return d(s)?"\\":l;if(c(s))if(r=!0,c(l.charCodeAt(1))){let u=2,w=u;for(;u<f&&!c(l.charCodeAt(u));)u++;if(u<f&&u!==w){const v=l.slice(w,u);for(w=u;u<f&&c(l.charCodeAt(u));)u++;if(u<f&&u!==w){for(w=u;u<f&&!c(l.charCodeAt(u));)u++;if(u===f)return`\\\\${v}\\${l.slice(w)}\\`;u!==w&&(t=`\\\\${v}\\${l.slice(w,u)}`,m=u)}}}else m=1;else y(s)&&l.charCodeAt(1)===n&&(t=l.slice(0,2),m=2,f>2&&c(l.charCodeAt(2))&&(r=!0,m=3));let i=m<f?b(l.slice(m),!r,"\\",c):"";return i.length===0&&!r&&(i="."),i.length>0&&c(l.charCodeAt(f-1))&&(i+="\\"),t===void 0?r?`\\${i}`:i:r?`${t}\\${i}`:`${t}${i}`},isAbsolute(l){h(l,"path");const f=l.length;if(f===0)return!1;const m=l.charCodeAt(0);return c(m)||f>2&&y(m)&&l.charCodeAt(1)===n&&c(l.charCodeAt(2))},join(...l){if(l.length===0)return".";let f,m;for(let s=0;s<l.length;++s){const i=l[s];h(i,"path"),i.length>0&&(f===void 0?f=m=i:f+=`\\${i}`)}if(f===void 0)return".";let t=!0,r=0;if(typeof m=="string"&&c(m.charCodeAt(0))){++r;const s=m.length;s>1&&c(m.charCodeAt(1))&&(++r,s>2&&(c(m.charCodeAt(2))?++r:t=!1))}if(t){for(;r<f.length&&c(f.charCodeAt(r));)r++;r>=2&&(f=`\\${f.slice(r)}`)}return e.win32.normalize(f)},relative(l,f){if(h(l,"from"),h(f,"to"),l===f)return"";const m=e.win32.resolve(l),t=e.win32.resolve(f);if(m===t||(l=m.toLowerCase(),f=t.toLowerCase(),l===f))return"";let r=0;for(;r<l.length&&l.charCodeAt(r)===C;)r++;let s=l.length;for(;s-1>r&&l.charCodeAt(s-1)===C;)s--;const i=s-r;let u=0;for(;u<f.length&&f.charCodeAt(u)===C;)u++;let w=f.length;for(;w-1>u&&f.charCodeAt(w-1)===C;)w--;const v=w-u,P=i<v?i:v;let A=-1,a=0;for(;a<P;a++){const L=l.charCodeAt(r+a);if(L!==f.charCodeAt(u+a))break;L===C&&(A=a)}if(a!==P){if(A===-1)return t}else{if(v>P){if(f.charCodeAt(u+a)===C)return t.slice(u+a+1);if(a===2)return t.slice(u+a)}i>P&&(l.charCodeAt(r+a)===C?A=a:a===2&&(A=3)),A===-1&&(A=0)}let R="";for(a=r+A+1;a<=s;++a)(a===s||l.charCodeAt(a)===C)&&(R+=R.length===0?"..":"\\..");return u+=A,R.length>0?`${R}${t.slice(u,w)}`:(t.charCodeAt(u)===C&&++u,t.slice(u,w))},toNamespacedPath(l){if(typeof l!="string")return l;if(l.length===0)return"";const f=e.win32.resolve(l);if(f.length<=2)return l;if(f.charCodeAt(0)===C){if(f.charCodeAt(1)===C){const m=f.charCodeAt(2);if(m!==I&&m!==D)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(y(f.charCodeAt(0))&&f.charCodeAt(1)===n&&f.charCodeAt(2)===C)return`\\\\?\\${f}`;return l},dirname(l){h(l,"path");const f=l.length;if(f===0)return".";let m=-1,t=0;const r=l.charCodeAt(0);if(f===1)return c(r)?l:".";if(c(r)){if(m=t=1,c(l.charCodeAt(1))){let u=2,w=u;for(;u<f&&!c(l.charCodeAt(u));)u++;if(u<f&&u!==w){for(w=u;u<f&&c(l.charCodeAt(u));)u++;if(u<f&&u!==w){for(w=u;u<f&&!c(l.charCodeAt(u));)u++;if(u===f)return l;u!==w&&(m=t=u+1)}}}}else y(r)&&l.charCodeAt(1)===n&&(m=f>2&&c(l.charCodeAt(2))?3:2,t=m);let s=-1,i=!0;for(let u=f-1;u>=t;--u)if(c(l.charCodeAt(u))){if(!i){s=u;break}}else i=!1;if(s===-1){if(m===-1)return".";s=m}return l.slice(0,s)},basename(l,f){f!==void 0&&h(f,"ext"),h(l,"path");let m=0,t=-1,r=!0,s;if(l.length>=2&&y(l.charCodeAt(0))&&l.charCodeAt(1)===n&&(m=2),f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let i=f.length-1,u=-1;for(s=l.length-1;s>=m;--s){const w=l.charCodeAt(s);if(c(w)){if(!r){m=s+1;break}}else u===-1&&(r=!1,u=s+1),i>=0&&(w===f.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=u))}return m===t?t=u:t===-1&&(t=l.length),l.slice(m,t)}for(s=l.length-1;s>=m;--s)if(c(l.charCodeAt(s))){if(!r){m=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":l.slice(m,t)},extname(l){h(l,"path");let f=0,m=-1,t=0,r=-1,s=!0,i=0;l.length>=2&&l.charCodeAt(1)===n&&y(l.charCodeAt(0))&&(f=t=2);for(let u=l.length-1;u>=f;--u){const w=l.charCodeAt(u);if(c(w)){if(!s){t=u+1;break}continue}r===-1&&(s=!1,r=u+1),w===D?m===-1?m=u:i!==1&&(i=1):m!==-1&&(i=-1)}return m===-1||r===-1||i===0||i===1&&m===r-1&&m===t+1?"":l.slice(m,r)},format:p.bind(null,"\\"),parse(l){h(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const m=l.length;let t=0,r=l.charCodeAt(0);if(m===1)return c(r)?(f.root=f.dir=l,f):(f.base=f.name=l,f);if(c(r)){if(t=1,c(l.charCodeAt(1))){let A=2,a=A;for(;A<m&&!c(l.charCodeAt(A));)A++;if(A<m&&A!==a){for(a=A;A<m&&c(l.charCodeAt(A));)A++;if(A<m&&A!==a){for(a=A;A<m&&!c(l.charCodeAt(A));)A++;A===m?t=A:A!==a&&(t=A+1)}}}}else if(y(r)&&l.charCodeAt(1)===n){if(m<=2)return f.root=f.dir=l,f;if(t=2,c(l.charCodeAt(2))){if(m===3)return f.root=f.dir=l,f;t=3}}t>0&&(f.root=l.slice(0,t));let s=-1,i=t,u=-1,w=!0,v=l.length-1,P=0;for(;v>=t;--v){if(r=l.charCodeAt(v),c(r)){if(!w){i=v+1;break}continue}u===-1&&(w=!1,u=v+1),r===D?s===-1?s=v:P!==1&&(P=1):s!==-1&&(P=-1)}return u!==-1&&(s===-1||P===0||P===1&&s===u-1&&s===i+1?f.base=f.name=l.slice(i,u):(f.name=l.slice(i,s),f.base=l.slice(i,u),f.ext=l.slice(s,u))),i>0&&i!==t?f.dir=l.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...l){let f="",m=!1;for(let t=l.length-1;t>=-1&&!m;t--){const r=t>=0?l[t]:g.cwd();h(r,"path"),r.length!==0&&(f=`${r}/${f}`,m=r.charCodeAt(0)===_)}return f=b(f,!m,"/",d),m?`/${f}`:f.length>0?f:"."},normalize(l){if(h(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===_,m=l.charCodeAt(l.length-1)===_;return l=b(l,!f,"/",d),l.length===0?f?"/":m?"./":".":(m&&(l+="/"),f?`/${l}`:l)},isAbsolute(l){return h(l,"path"),l.length>0&&l.charCodeAt(0)===_},join(...l){if(l.length===0)return".";let f;for(let m=0;m<l.length;++m){const t=l[m];h(t,"path"),t.length>0&&(f===void 0?f=t:f+=`/${t}`)}return f===void 0?".":e.posix.normalize(f)},relative(l,f){if(h(l,"from"),h(f,"to"),l===f||(l=e.posix.resolve(l),f=e.posix.resolve(f),l===f))return"";const m=1,t=l.length,r=t-m,s=1,i=f.length-s,u=r<i?r:i;let w=-1,v=0;for(;v<u;v++){const A=l.charCodeAt(m+v);if(A!==f.charCodeAt(s+v))break;A===_&&(w=v)}if(v===u)if(i>u){if(f.charCodeAt(s+v)===_)return f.slice(s+v+1);if(v===0)return f.slice(s+v)}else r>u&&(l.charCodeAt(m+v)===_?w=v:v===0&&(w=0));let P="";for(v=m+w+1;v<=t;++v)(v===t||l.charCodeAt(v)===_)&&(P+=P.length===0?"..":"/..");return`${P}${f.slice(s+w)}`},toNamespacedPath(l){return l},dirname(l){if(h(l,"path"),l.length===0)return".";const f=l.charCodeAt(0)===_;let m=-1,t=!0;for(let r=l.length-1;r>=1;--r)if(l.charCodeAt(r)===_){if(!t){m=r;break}}else t=!1;return m===-1?f?"/":".":f&&m===1?"//":l.slice(0,m)},basename(l,f){f!==void 0&&h(f,"ext"),h(l,"path");let m=0,t=-1,r=!0,s;if(f!==void 0&&f.length>0&&f.length<=l.length){if(f===l)return"";let i=f.length-1,u=-1;for(s=l.length-1;s>=0;--s){const w=l.charCodeAt(s);if(w===_){if(!r){m=s+1;break}}else u===-1&&(r=!1,u=s+1),i>=0&&(w===f.charCodeAt(i)?--i==-1&&(t=s):(i=-1,t=u))}return m===t?t=u:t===-1&&(t=l.length),l.slice(m,t)}for(s=l.length-1;s>=0;--s)if(l.charCodeAt(s)===_){if(!r){m=s+1;break}}else t===-1&&(r=!1,t=s+1);return t===-1?"":l.slice(m,t)},extname(l){h(l,"path");let f=-1,m=0,t=-1,r=!0,s=0;for(let i=l.length-1;i>=0;--i){const u=l.charCodeAt(i);if(u===_){if(!r){m=i+1;break}continue}t===-1&&(r=!1,t=i+1),u===D?f===-1?f=i:s!==1&&(s=1):f!==-1&&(s=-1)}return f===-1||t===-1||s===0||s===1&&f===t-1&&f===m+1?"":l.slice(f,t)},format:p.bind(null,"/"),parse(l){h(l,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(l.length===0)return f;const m=l.charCodeAt(0)===_;let t;m?(f.root="/",t=1):t=0;let r=-1,s=0,i=-1,u=!0,w=l.length-1,v=0;for(;w>=t;--w){const P=l.charCodeAt(w);if(P===_){if(!u){s=w+1;break}continue}i===-1&&(u=!1,i=w+1),P===D?r===-1?r=w:v!==1&&(v=1):r!==-1&&(v=-1)}if(i!==-1){const P=s===0&&m?1:s;r===-1||v===0||v===1&&r===i-1&&r===s+1?f.base=f.name=l.slice(P,i):(f.name=l.slice(P,r),f.base=l.slice(P,i),f.ext=l.slice(r,i))}return s>0?f.dir=l.slice(0,s-1):m&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=g.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=g.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=g.platform==="win32"?e.win32.join:e.posix.join,e.resolve=g.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=g.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=g.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=g.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=g.platform==="win32"?e.win32.extname:e.posix.extname,e.format=g.platform==="win32"?e.win32.format:e.posix.format,e.parse=g.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=g.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=g.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=g.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(we[52],_e([0,1,21]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const T=g.globals.performance&&typeof g.globals.performance.now=="function";class S{constructor(k){this._highResolution=T&&k,this._startTime=this._now(),this._stopTime=-1}static create(k=!0){return new S(k)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?g.globals.performance.now():Date.now()}}e.StopWatch=S}),define(we[3],_e([0,1,11,49,7,51,52]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var D;(function(b){b.None=()=>S.Disposable.None;function p(J){return(z,Z=null,M)=>{let q=!1,N;return N=J(W=>{if(!q)return N?N.dispose():q=!0,z.call(Z,W)},null,M),q&&N.dispose(),N}}b.once=p;function l(J,z){return i((Z,M=null,q)=>J(N=>Z.call(M,z(N)),null,q))}b.map=l;function f(J,z){return i((Z,M=null,q)=>J(N=>{z(N),Z.call(M,N)},null,q))}b.forEach=f;function m(J,z){return i((Z,M=null,q)=>J(N=>z(N)&&Z.call(M,N),null,q))}b.filter=m;function t(J){return J}b.signal=t;function r(...J){return(z,Z=null,M)=>S.combinedDisposable(...J.map(q=>q(N=>z.call(Z,N),null,M)))}b.any=r;function s(J,z,Z){let M=Z;return l(J,q=>(M=z(M,q),M))}b.reduce=s;function i(J){let z;const Z=new o({onFirstListenerAdd(){z=J(Z.fire,Z)},onLastListenerRemove(){z.dispose()}});return Z.event}b.snapshot=i;function u(J,z,Z=100,M=!1,q){let N,W,O,B=0;const Y=new o({leakWarningThreshold:q,onFirstListenerAdd(){N=J(he=>{B++,W=z(W,he),M&&!O&&(Y.fire(W),W=void 0),clearTimeout(O),O=setTimeout(()=>{const De=W;W=void 0,O=void 0,(!M||B>1)&&Y.fire(De),B=0},Z)})},onLastListenerRemove(){N.dispose()}});return Y.event}b.debounce=u;function w(J){const z=new Date().getTime();return l(p(J),Z=>new Date().getTime()-z)}b.stopwatch=w;function v(J,z=(Z,M)=>Z===M){let Z=!0,M;return m(J,q=>{const N=Z||!z(q,M);return Z=!1,M=q,N})}b.latch=v;function P(J,z){return[b.filter(J,z),b.filter(J,Z=>!z(Z))]}b.split=P;function A(J,z=!1,Z=[]){let M=Z.slice(),q=J(O=>{M?M.push(O):W.fire(O)});const N=()=>{M&&M.forEach(O=>W.fire(O)),M=null},W=new o({onFirstListenerAdd(){q||(q=J(O=>W.fire(O)))},onFirstListenerDidAdd(){M&&(z?setTimeout(N):N())},onLastListenerRemove(){q&&q.dispose(),q=null}});return W.event}b.buffer=A;class a{constructor(z){this.event=z}map(z){return new a(l(this.event,z))}forEach(z){return new a(f(this.event,z))}filter(z){return new a(m(this.event,z))}reduce(z,Z){return new a(s(this.event,z,Z))}latch(){return new a(v(this.event))}debounce(z,Z=100,M=!1,q){return new a(u(this.event,z,Z,M,q))}on(z,Z,M){return this.event(z,Z,M)}once(z,Z,M){return p(this.event)(z,Z,M)}}function R(J){return new a(J)}b.chain=R;function L(J,z,Z=M=>M){const M=(...O)=>W.fire(Z(...O)),q=()=>J.on(z,M),N=()=>J.removeListener(z,M),W=new o({onFirstListenerAdd:q,onLastListenerRemove:N});return W.event}b.fromNodeEventEmitter=L;function H(J,z,Z=M=>M){const M=(...O)=>W.fire(Z(...O)),q=()=>J.addEventListener(z,M),N=()=>J.removeEventListener(z,M),W=new o({onFirstListenerAdd:q,onLastListenerRemove:N});return W.event}b.fromDOMEventEmitter=H;function ue(J){const z=new o;let Z=!1;return J.then(void 0,()=>null).then(()=>{Z?z.fire(void 0):setTimeout(()=>z.fire(void 0),0)}),Z=!0,z.event}b.fromPromise=ue;function me(J){return new Promise(z=>p(J)(z))}b.toPromise=me})(D=e.Event||(e.Event={}));class _{constructor(p){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${p}_${_._idPool++}`}start(p){this._stopWatch=new k.StopWatch(!0),this._listenerCount=p}stop(){if(this._stopWatch){const p=this._stopWatch.elapsed();this._elapsedOverall+=p,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${p.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}_._idPool=0;let C=-1;function n(b){const p=C;return C=b,{dispose(){C=p}}}e.setGlobalLeakWarningThreshold=n;class I{constructor(p,l=Math.random().toString(18).slice(2,5)){this.customThreshold=p,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(p){let l=C;if(typeof this.customThreshold=="number"&&(l=this.customThreshold),l<=0||p<l)return;this._stacks||(this._stacks=new Map);const f=new Error().stack.split(`
`).slice(3).join(`
`),m=this._stacks.get(f)||0;if(this._stacks.set(f,m+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=l*.5;let t,r=0;for(const[s,i]of this._stacks)(!t||r<i)&&(t=s,r=i);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${r}):`),console.warn(t)}return()=>{const t=this._stacks.get(f)||0;this._stacks.set(f,t-1)}}}class o{constructor(p){var l;this._disposed=!1,this._options=p,this._leakageMon=C>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((l=this._options)===null||l===void 0?void 0:l._profName)?new _(this._options._profName):void 0}get event(){return this._event||(this._event=(p,l,f)=>{var m;this._listeners||(this._listeners=new E.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(l?[p,l]:p);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,p,l);const s=(m=this._leakageMon)===null||m===void 0?void 0:m.check(this._listeners.size);let i;return i={dispose:()=>{s&&s(),i.dispose=o._noop,this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},f instanceof S.DisposableStore?f.add(i):Array.isArray(f)&&f.push(i),i}),this._event}fire(p){var l,f;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new E.LinkedList);for(let m of this._listeners)this._deliveryQueue.push([m,p]);for((l=this._perfMon)===null||l===void 0||l.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[m,t]=this._deliveryQueue.shift();try{typeof m=="function"?m.call(void 0,t):m[0].call(m[1],t)}catch(r){g.onUnexpectedError(r)}}(f=this._perfMon)===null||f===void 0||f.stop()}}dispose(){var p,l,f,m,t;this._disposed||(this._disposed=!0,(p=this._listeners)===null||p===void 0||p.clear(),(l=this._deliveryQueue)===null||l===void 0||l.clear(),(m=(f=this._options)===null||f===void 0?void 0:f.onLastListenerRemove)===null||m===void 0||m.call(f),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=o,o._noop=function(){};class h extends o{constructor(p){super(p);this._isPaused=0,this._eventQueue=new E.LinkedList,this._mergeFn=p==null?void 0:p.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const p=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(p))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(p){this._listeners&&(this._isPaused!==0?this._eventQueue.push(p):super.fire(p))}}e.PauseableEmitter=h;class c{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new o({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(p){const l={event:p,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const f=()=>{this.hasListeners&&this.unhook(l);const m=this.events.indexOf(l);this.events.splice(m,1)};return S.toDisposable(T.once(f))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(p=>this.hook(p))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(p=>this.unhook(p))}hook(p){p.listener=p.event(l=>this.emitter.fire(l))}unhook(p){p.listener&&p.listener.dispose(),p.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=c;class d{constructor(){this.buffers=[]}wrapEvent(p){return(l,f,m)=>p(t=>{const r=this.buffers[this.buffers.length-1];r?r.push(()=>l.call(f,t)):l.call(f,t)},void 0,m)}bufferEvents(p){const l=[];this.buffers.push(l);const f=p();return this.buffers.pop(),l.forEach(m=>m()),f}}e.EventBufferer=d;class y{constructor(){this.listening=!1,this.inputEvent=D.None,this.inputEventListener=S.Disposable.None,this.emitter=new o({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(p){this.inputEvent=p,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=p(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=y}),define(we[18],_e([0,1,3]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const T=Object.freeze(function(D,_){const C=setTimeout(D.bind(_),0);return{dispose(){clearTimeout(C)}}});var S;(function(D){function _(C){return C===D.None||C===D.Cancelled||C instanceof E?!0:!C||typeof C!="object"?!1:typeof C.isCancellationRequested=="boolean"&&typeof C.onCancellationRequested=="function"}D.isCancellationToken=_,D.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:g.Event.None}),D.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:T})})(S=e.CancellationToken||(e.CancellationToken={}));class E{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?T:(this._emitter||(this._emitter=new g.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class k{constructor(_){this._token=void 0,this._parentListener=void 0,this._parentListener=_&&_.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new E),this._token}cancel(){this._token?this._token instanceof E&&this._token.cancel():this._token=S.Cancelled}dispose(_=!1){_&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof E&&this._token.dispose():this._token=S.None}}e.CancellationTokenSource=k}),define(we[78],_e([0,1,3]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class T{constructor(){this._icons=new Map,this._onDidRegister=new g.Emitter}add(I){const o=this._icons.get(I.id);o?I.description?o.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const S=new T;e.iconRegistry=S;function E(n,I){return new D(n,I)}e.registerCodicon=E;function k(n){return n?n.replace(/\$\((.*?)\)/g,(I,o)=>` ${o} `).trim():""}e.getCodiconAriaLabel=k;class D{constructor(I,o,h){this.id=I,this.definition=o,this.description=h,S.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=D;function _(n,I){const o=["codicon","codicon-"+n];return I&&o.push("codicon-modifier-"+I),o}e.getClassNamesArray=_;var C;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function o(d){if(d instanceof D)return["codicon","codicon-"+d.id];const y=I.exec(d.id);if(!y)return o(D.error);let[,b,p]=y;const l=["codicon","codicon-"+b];return p&&l.push("codicon-modifier-"+p.substr(1)),l}n.asClassNameArray=o;function h(d){return o(d).join(" ")}n.asClassName=h;function c(d){return"."+o(d).join(".")}n.asCSSSelector=c})(C=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(D=e.Codicon||(e.Codicon={}))}),define(we[109],_e([0,1,11,7]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function S(l){const f=l;return f?[f.on,f.pause,f.resume,f.destroy].every(m=>typeof m=="function"):!1}e.isReadableStream=S;function E(l){const f=l;return f?S(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}e.isReadableBufferedStream=E;function k(l,f){return new D(l,f)}e.newWriteableStream=k;class D{constructor(f,m){this.reducer=f,this.options=m,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(f){var m;if(!this.state.destroyed){if(this.state.flowing)this.emitData(f);else if(this.buffer.data.push(f),typeof((m=this.options)===null||m===void 0?void 0:m.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(f){this.state.destroyed||(this.state.flowing?this.emitError(f):this.buffer.error.push(f))}end(f){this.state.destroyed||(typeof f!="undefined"&&this.write(f),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(f){this.listeners.data.slice(0).forEach(m=>m(f))}emitError(f){this.listeners.error.length===0?g.onUnexpectedError(f):this.listeners.error.slice(0).forEach(m=>m(f))}emitEnd(){this.listeners.end.slice(0).forEach(f=>f())}on(f,m){if(!this.state.destroyed)switch(f){case"data":this.listeners.data.push(m),this.resume();break;case"end":this.listeners.end.push(m),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(m),this.state.flowing&&this.flowErrors();break}}removeListener(f,m){if(this.state.destroyed)return;let t;switch(f){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const r=t.indexOf(m);r>=0&&t.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const f=this.reducer(this.buffer.data);this.emitData(f),this.buffer.data.length=0;const m=[...this.pendingWritePromises];this.pendingWritePromises.length=0,m.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const f of this.buffer.error)this.emitError(f);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function _(l,f){const m=[];let t;for(;(t=l.read())!==null;)m.push(t);return f(m)}e.consumeReadable=_;function C(l,f,m){const t=[];let r;for(;(r=l.read())!==null&&t.length<m;)t.push(r);return r===null&&t.length>0?f(t):{read:()=>{if(t.length>0)return t.shift();if(typeof r!="undefined"){const s=r;return r=void 0,s}return l.read()}}}e.peekReadable=C;function n(l,f){return new Promise((m,t)=>{const r=[];I(l,{onData:s=>{f&&r.push(s)},onError:s=>{f?t(s):m(void 0)},onEnd:()=>{m(f?f(r):void 0)}})})}e.consumeStream=n;function I(l,f){l.on("error",m=>f.onError(m)),l.on("end",()=>f.onEnd()),l.on("data",m=>f.onData(m))}e.listenStream=I;function o(l,f){return new Promise((m,t)=>{const r=new T.DisposableStore,s=[],i=v=>{if(s.push(v),s.length>f)return r.dispose(),l.pause(),m({stream:l,buffer:s,ended:!1})},u=v=>t(v),w=()=>m({stream:l,buffer:s,ended:!0});r.add(T.toDisposable(()=>l.removeListener("error",u))),l.on("error",u),r.add(T.toDisposable(()=>l.removeListener("end",w))),l.on("end",w),r.add(T.toDisposable(()=>l.removeListener("data",i))),l.on("data",i)})}e.peekStream=o;function h(l,f){const m=k(f);return m.end(l),m}e.toStream=h;function c(){const l=k(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=c;function d(l){let f=!1;return{read:()=>f?null:(f=!0,l)}}e.toReadable=d;function y(l,f,m){const t=k(m);return I(l,{onData:r=>t.write(f.data(r)),onError:r=>t.error(f.error?f.error(r):r),onEnd:()=>t.end()}),t}e.transform=y;function b(l,f,m){let t=!1;return{read:()=>{const r=f.read();return t?r:(t=!0,r!==null?m([l,r]):l)}}}e.prefixedReadable=b;function p(l,f,m){let t=!1;const r=k(m);return I(f,{onData:s=>t?r.write(s):(t=!0,r.write(m([l,s]))),onError:s=>r.error(s),onEnd:()=>{t||(t=!0,r.write(l)),r.end()}}),r}e.prefixedStream=p}),define(we[8],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function g(U){return!U||typeof U!="string"?!0:U.trim().length===0}e.isFalsyOrWhitespace=g;const T=/{(\d+)}/g;function S(U,...Q){return Q.length===0?U:U.replace(T,function(le,ke){const Pe=parseInt(ke,10);return isNaN(Pe)||Pe<0||Pe>=Q.length?le:Q[Pe]})}e.format=S;function E(U){return U.replace(/[<>&]/g,function(Q){switch(Q){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Q}})}e.escape=E;function k(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function D(U,Q){let le=0;const ke=Q.charCodeAt(0);for(let Pe=U.length-1;Pe>=0;Pe--)U.charCodeAt(Pe)===ke&&le++;return le}e.count=D;function _(U,Q,le="\u2026"){return U.length<=Q?U:`${U.substr(0,Q)}${le}`}e.truncate=_;function C(U,Q=" "){const le=n(U,Q);return I(le,Q)}e.trim=C;function n(U,Q){if(!U||!Q)return U;const le=Q.length;if(le===0||U.length===0)return U;let ke=0;for(;U.indexOf(Q,ke)===ke;)ke=ke+le;return U.substring(ke)}e.ltrim=n;function I(U,Q){if(!U||!Q)return U;const le=Q.length,ke=U.length;if(le===0||ke===0)return U;let Pe=ke,Ue=-1;for(;Ue=U.lastIndexOf(Q,Pe-1),!(Ue===-1||Ue+le!==Pe);){if(Ue===0)return"";Pe=Ue}return U.substring(0,Pe)}e.rtrim=I;function o(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=o;function h(U){return U.replace(/\*/g,"")}e.stripWildcards=h;function c(U,Q,le={}){if(!U)throw new Error("Cannot create regex from empty string");Q||(U=k(U)),le.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let ke="";return le.global&&(ke+="g"),le.matchCase||(ke+="i"),le.multiline&&(ke+="m"),le.unicode&&(ke+="u"),new RegExp(U,ke)}e.createRegExp=c;function d(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function y(U){return!!U.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function b(U){return(U.global?"g":"")+(U.ignoreCase?"i":"")+(U.multiline?"m":"")+(U.unicode?"u":"")}e.regExpFlags=b;function p(U){return U.split(/\r\n|\r|\n/)}e.splitLines=p;function l(U){for(let Q=0,le=U.length;Q<le;Q++){const ke=U.charCodeAt(Q);if(ke!==32&&ke!==9)return Q}return-1}e.firstNonWhitespaceIndex=l;function f(U,Q=0,le=U.length){for(let ke=Q;ke<le;ke++){const Pe=U.charCodeAt(ke);if(Pe!==32&&Pe!==9)return U.substring(Q,ke)}return U.substring(Q,le)}e.getLeadingWhitespace=f;function m(U,Q=U.length-1){for(let le=Q;le>=0;le--){const ke=U.charCodeAt(le);if(ke!==32&&ke!==9)return le}return-1}e.lastNonWhitespaceIndex=m;function t(U,Q){return U<Q?-1:U>Q?1:0}e.compare=t;function r(U,Q,le=0,ke=U.length,Pe=0,Ue=Q.length){for(;le<ke&&Pe<Ue;le++,Pe++){let rt=U.charCodeAt(le),Ke=Q.charCodeAt(Pe);if(rt<Ke)return-1;if(rt>Ke)return 1}const We=ke-le,Ze=Ue-Pe;return We<Ze?-1:We>Ze?1:0}e.compareSubstring=r;function s(U,Q){return i(U,Q,0,U.length,0,Q.length)}e.compareIgnoreCase=s;function i(U,Q,le=0,ke=U.length,Pe=0,Ue=Q.length){for(;le<ke&&Pe<Ue;le++,Pe++){let rt=U.charCodeAt(le),Ke=Q.charCodeAt(Pe);if(rt===Ke)continue;const Je=rt-Ke;if(!(Je===32&&w(Ke))&&!(Je===-32&&w(rt)))return u(rt)&&u(Ke)?Je:r(U.toLowerCase(),Q.toLowerCase(),le,ke,Pe,Ue)}const We=ke-le,Ze=Ue-Pe;return We<Ze?-1:We>Ze?1:0}e.compareSubstringIgnoreCase=i;function u(U){return U>=97&&U<=122}e.isLowerAsciiLetter=u;function w(U){return U>=65&&U<=90}e.isUpperAsciiLetter=w;function v(U){return u(U)||w(U)}function P(U,Q){return U.length===Q.length&&A(U,Q)}e.equalsIgnoreCase=P;function A(U,Q,le=U.length){for(let ke=0;ke<le;ke++){const Pe=U.charCodeAt(ke),Ue=Q.charCodeAt(ke);if(Pe!==Ue){if(v(Pe)&&v(Ue)){const We=Math.abs(Pe-Ue);if(We!==0&&We!==32)return!1}else if(String.fromCharCode(Pe).toLowerCase()!==String.fromCharCode(Ue).toLowerCase())return!1}}return!0}function a(U,Q){const le=Q.length;return Q.length>U.length?!1:A(U,Q,le)}e.startsWithIgnoreCase=a;function R(U,Q){let le,ke=Math.min(U.length,Q.length);for(le=0;le<ke;le++)if(U.charCodeAt(le)!==Q.charCodeAt(le))return le;return ke}e.commonPrefixLength=R;function L(U,Q){let le,ke=Math.min(U.length,Q.length);const Pe=U.length-1,Ue=Q.length-1;for(le=0;le<ke;le++)if(U.charCodeAt(Pe-le)!==Q.charCodeAt(Ue-le))return le;return ke}e.commonSuffixLength=L;function H(U){return 55296<=U&&U<=56319}e.isHighSurrogate=H;function ue(U){return 56320<=U&&U<=57343}e.isLowSurrogate=ue;function me(U,Q){return(U-55296<<10)+(Q-56320)+65536}e.computeCodePoint=me;function J(U,Q,le){const ke=U.charCodeAt(le);if(H(ke)&&le+1<Q){const Pe=U.charCodeAt(le+1);if(ue(Pe))return me(ke,Pe)}return ke}e.getNextCodePoint=J;function z(U,Q){const le=U.charCodeAt(Q-1);if(ue(le)&&Q>1){const ke=U.charCodeAt(Q-2);if(H(ke))return me(ke,le)}return le}function Z(U,Q){const le=Ne.getInstance(),ke=Q,Pe=U.length,Ue=J(U,Pe,Q);Q+=Ue>=65536?2:1;let We=le.getGraphemeBreakType(Ue);for(;Q<Pe;){const Ze=J(U,Pe,Q),rt=le.getGraphemeBreakType(Ze);if(ge(We,rt))break;Q+=Ze>=65536?2:1,We=rt}return Q-ke}e.nextCharLength=Z;function M(U,Q){const le=Ne.getInstance(),ke=Q,Pe=z(U,Q);Q-=Pe>=65536?2:1;let Ue=le.getGraphemeBreakType(Pe);for(;Q>0;){const We=z(U,Q),Ze=le.getGraphemeBreakType(We);if(ge(Ze,Ue))break;Q-=We>=65536?2:1,Ue=Ze}return ke-Q}e.prevCharLength=M;function q(U,Q){const le=Ne.getInstance(),ke=U.length,Pe=Q,Ue=J(U,ke,Q),We=le.getGraphemeBreakType(Ue);Q+=Ue>=65536?2:1;let Ze=We;for(;Q<ke;){const Ke=J(U,ke,Q),Je=le.getGraphemeBreakType(Ke);if(ge(Ze,Je))break;Q+=Ke>=65536?2:1,Ze=Je}const rt=Q;for(Q=Pe,Ze=We;Q>0;){const Ke=z(U,Q),Je=le.getGraphemeBreakType(Ke);if(ge(Je,Ze))break;Q-=Ke>=65536?2:1,Ze=Je}return[Q,rt]}function N(U,Q){return Q>0&&ue(U.charCodeAt(Q))?q(U,Q-1):q(U,Q)}e.getCharContainingOffset=N;function W(U){const Q=U.length;let le=0,ke=0;for(;ke<Q;){const We=J(U,Q,ke);ke+=We>=65536?2:1,We<128?le+=1:We<2048?le+=2:We<65536?le+=3:le+=4}const Pe=new Uint8Array(le);ke=0;let Ue=0;for(;ke<Q;){const We=J(U,Q,ke);ke+=We>=65536?2:1,We<128?Pe[Ue++]=We:We<2048?(Pe[Ue++]=192|(We&1984)>>>6,Pe[Ue++]=128|(We&63)>>>0):We<65536?(Pe[Ue++]=224|(We&61440)>>>12,Pe[Ue++]=128|(We&4032)>>>6,Pe[Ue++]=128|(We&63)>>>0):(Pe[Ue++]=240|(We&1835008)>>>18,Pe[Ue++]=128|(We&258048)>>>12,Pe[Ue++]=128|(We&4032)>>>6,Pe[Ue++]=128|(We&63)>>>0)}return Pe}e.encodeUTF8=W;function O(U){const Q=U.byteLength,le=[];let ke=0;for(;ke<Q;){const Pe=U[ke];let Ue;if(Pe>=240&&ke+3<Q?Ue=(U[ke++]&7)<<18>>>0|(U[ke++]&63)<<12>>>0|(U[ke++]&63)<<6>>>0|(U[ke++]&63)<<0>>>0:Pe>=224&&ke+2<Q?Ue=(U[ke++]&15)<<12>>>0|(U[ke++]&63)<<6>>>0|(U[ke++]&63)<<0>>>0:Pe>=192&&ke+1<Q?Ue=(U[ke++]&31)<<6>>>0|(U[ke++]&63)<<0>>>0:Ue=U[ke++],Ue>=0&&Ue<=55295||Ue>=57344&&Ue<=65535)le.push(String.fromCharCode(Ue));else if(Ue>=65536&&Ue<=1114111){const We=Ue-65536,Ze=55296+((We&1047552)>>>10),rt=56320+((We&1023)>>>0);le.push(String.fromCharCode(Ze)),le.push(String.fromCharCode(rt))}else le.push(String.fromCharCode(65533))}return le.join("")}e.decodeUTF8=O;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function Y(U){return B.test(U)}e.containsRTL=Y;const he=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function De(U){return he.test(U)}e.containsEmoji=De;const Oe=/^[\t\n\r\x20-\x7E]*$/;function Me(U){return Oe.test(U)}e.isBasicASCII=Me,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function He(U){return e.UNUSUAL_LINE_TERMINATORS.test(U)}e.containsUnusualLineTerminators=He;function Ye(U){for(let Q=0,le=U.length;Q<le;Q++)if(qe(U.charCodeAt(Q)))return!0;return!1}e.containsFullWidthCharacter=Ye;function qe(U){return U=+U,U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}e.isFullWidthCharacter=qe;function Xe(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129003||U>=129280&&U<=129535||U>=129648&&U<=129750}e.isEmojiImprecise=Xe;function $(U,Q){if(U.length<Q)return U;const le=/\b/g;let ke=0;for(;le.test(U)&&!(U.length-le.lastIndex<Q);)ke=le.lastIndex,le.lastIndex+=1;return U.substring(ke).replace(/^\s/,"")}e.lcut=$;const G=/\x1B\x5B[12]?K/g,te=/\x1b\[\d+m/g,re=/\x1b\[0?m/g;function K(U){return U&&(U=U.replace(G,""),U=U.replace(te,""),U=U.replace(re,"")),U}e.removeAnsiEscapeCodes=K,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function oe(U){return!!(U&&U.length>0&&U.charCodeAt(0)===65279)}e.startsWithUTF8BOM=oe;function fe(U){return oe(U)?U.substr(1):U}e.stripUTF8BOM=fe;function Ae(U,Q){if(!U||!Q||U.length<Q.length)return!1;const le=Q.length,ke=U.toLowerCase();let Pe=0,Ue=-1;for(;Pe<le;){const We=ke.indexOf(Q[Pe],Ue+1);if(We<0)return!1;Ue=We,Pe++}return!0}e.fuzzyContains=Ae;function $e(U,Q=!1){return U?(Q&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}e.containsUppercaseCharacter=$e;function pe(U){return U.charAt(0).toUpperCase()+U.slice(1)}e.uppercaseFirstLetter=pe;function Ge(U,Q=1){if(Q===0)return"";let le=-1;do le=U.indexOf(`
`,le+1),Q--;while(Q>0&&le>=0);return le===-1?U:(U[le-1]==="\r"&&le--,U.substr(0,le))}e.getNLines=Ge;function j(U){const Q=90-65+1;return U=U%(2*Q),U<Q?String.fromCharCode(97+U):String.fromCharCode(65+U-Q)}e.singleLetterHash=j;function ne(U){return Ne.getInstance().getGraphemeBreakType(U)}e.getGraphemeBreakType=ne;function ge(U,Q){return U===0?Q!==5&&Q!==7:U===2&&Q===3?!1:U===4||U===2||U===3||Q===4||Q===2||Q===3?!0:!(U===8&&(Q===8||Q===9||Q===11||Q===12)||(U===11||U===9)&&(Q===9||Q===10)||(U===12||U===10)&&Q===10||Q===5||Q===13||Q===7||U===1||U===13&&Q===14||U===6&&Q===6)}e.breakBetweenGraphemeBreakType=ge;var Fe;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(Fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ne{constructor(){this._data=Qe()}static getInstance(){return Ne._INSTANCE||(Ne._INSTANCE=new Ne),Ne._INSTANCE}getGraphemeBreakType(Q){if(Q<32)return Q===10?3:Q===13?2:4;if(Q<127)return 0;const le=this._data,ke=le.length/3;let Pe=1;for(;Pe<=ke;)if(Q<le[3*Pe])Pe=2*Pe;else if(Q>le[3*Pe+1])Pe=2*Pe+1;else return le[3*Pe+2];return 0}}Ne._INSTANCE=null;function Qe(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Ee(U,Q){if(U===0)return 0;const le=be(U,Q);if(le!==void 0)return le;const ke=z(Q,U);return U-=Ce(ke),U}e.getLeftDeleteOffset=Ee;function be(U,Q){let le=z(Q,U);for(U-=Ce(le);se(le)||le===65039||le===8419;){if(U===0)return;le=z(Q,U),U-=Ce(le)}if(!!Xe(le)){if(U>=0){const ke=z(Q,U);ke===8205&&(U-=Ce(ke))}return U}}function Ce(U){return U>=65536?2:1}function se(U){return 127995<=U&&U<=127999}var de;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(de||(de={}))}),define(we[23],_e([0,1,8,109]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const S=typeof Buffer!="undefined",E=typeof TextEncoder!="undefined",k=typeof TextDecoder!="undefined";let D,_;class C{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return S?new C(Buffer.allocUnsafe(v)):new C(new Uint8Array(v))}static wrap(v){return S&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new C(v)}static fromString(v,P){return!((P==null?void 0:P.dontUseNodeBuffer)||!1)&&S?new C(Buffer.from(v)):E?(D||(D=new TextEncoder),new C(D.encode(v))):new C(g.encodeUTF8(v))}static concat(v,P){if(typeof P=="undefined"){P=0;for(let R=0,L=v.length;R<L;R++)P+=v[R].byteLength}const A=C.alloc(P);let a=0;for(let R=0,L=v.length;R<L;R++){const H=v[R];A.set(H,a),a+=H.byteLength}return A}toString(){return S?this.buffer.toString():k?(_||(_=new TextDecoder),_.decode(this.buffer)):g.decodeUTF8(this.buffer)}slice(v,P){return new C(this.buffer.subarray(v,P))}set(v,P){v instanceof C?this.buffer.set(v.buffer,P):this.buffer.set(v,P)}readUInt32BE(v){return o(this.buffer,v)}writeUInt32BE(v,P){h(this.buffer,v,P)}readUInt32LE(v){return c(this.buffer,v)}writeUInt32LE(v,P){d(this.buffer,v,P)}readUInt8(v){return y(this.buffer,v)}writeUInt8(v,P){b(this.buffer,v,P)}}e.VSBuffer=C;function n(w,v){return w[v+0]<<0>>>0|w[v+1]<<8>>>0}e.readUInt16LE=n;function I(w,v,P){w[P+0]=v&255,v=v>>>8,w[P+1]=v&255}e.writeUInt16LE=I;function o(w,v){return w[v]*2**24+w[v+1]*2**16+w[v+2]*2**8+w[v+3]}e.readUInt32BE=o;function h(w,v,P){w[P+3]=v,v=v>>>8,w[P+2]=v,v=v>>>8,w[P+1]=v,v=v>>>8,w[P]=v}e.writeUInt32BE=h;function c(w,v){return w[v+0]<<0>>>0|w[v+1]<<8>>>0|w[v+2]<<16>>>0|w[v+3]<<24>>>0}e.readUInt32LE=c;function d(w,v,P){w[P+0]=v&255,v=v>>>8,w[P+1]=v&255,v=v>>>8,w[P+2]=v&255,v=v>>>8,w[P+3]=v&255}e.writeUInt32LE=d;function y(w,v){return w[v]}e.readUInt8=y;function b(w,v,P){w[P]=v}e.writeUInt8=b;function p(w){return T.consumeReadable(w,v=>C.concat(v))}e.readableToBuffer=p;function l(w){return T.toReadable(w)}e.bufferToReadable=l;function f(w){return T.consumeStream(w,v=>C.concat(v))}e.streamToBuffer=f;async function m(w){return w.ended?C.concat(w.buffer):C.concat([...w.buffer,await f(w.stream)])}e.bufferedStreamToBuffer=m;function t(w){return T.toStream(w,v=>C.concat(v))}e.bufferToStream=t;function r(w){return T.transform(w,{data:v=>typeof v=="string"?C.fromString(v):C.wrap(v)},v=>C.concat(v))}e.streamToBufferReadableStream=r;function s(w){return T.newWriteableStream(v=>C.concat(v),w)}e.newWriteableBufferStream=s;function i(w,v){return T.prefixedReadable(w,v,P=>C.concat(P))}e.prefixedBufferReadable=i;function u(w,v){return T.prefixedStream(w,v,P=>C.concat(P))}e.prefixedBufferStream=u}),define(we[53],_e([0,1,8]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function T(b){return S(b,0)}e.hash=T;function S(b,p){switch(typeof b){case"object":return b===null?E(349,p):Array.isArray(b)?_(b,p):C(b,p);case"string":return D(b,p);case"boolean":return k(b,p);case"number":return E(b,p);case"undefined":return E(937,p);default:return E(617,p)}}e.doHash=S;function E(b,p){return(p<<5)-p+b|0}function k(b,p){return E(b?433:863,p)}function D(b,p){p=E(149417,p);for(let l=0,f=b.length;l<f;l++)p=E(b.charCodeAt(l),p);return p}e.stringHash=D;function _(b,p){return p=E(104579,p),b.reduce((l,f)=>S(f,l),p)}function C(b,p){return p=E(181387,p),Object.keys(b).sort().reduce((l,f)=>(l=D(f,l),S(b[f],l)),p)}class n{constructor(){this._value=0}get value(){return this._value}hash(p){return this._value=S(p,this._value),this._value}}e.Hasher=n;var I;(function(b){b[b.BLOCK_SIZE=64]="BLOCK_SIZE",b[b.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function o(b,p,l=32){const f=l-p,m=~((1<<f)-1);return(b<<p|(m&b)>>>f)>>>0}function h(b,p=0,l=b.byteLength,f=0){for(let m=0;m<l;m++)b[p+m]=f}function c(b,p,l="0"){for(;b.length<p;)b=l+b;return b}function d(b,p=32){return b instanceof ArrayBuffer?Array.from(new Uint8Array(b)).map(l=>l.toString(16).padStart(2,"0")).join(""):c((b>>>0).toString(16),p/4)}e.toHexString=d;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(p){const l=p.length;if(l===0)return;const f=this._buff;let m=this._buffLen,t=this._leftoverHighSurrogate,r,s;for(t!==0?(r=t,s=-1,t=0):(r=p.charCodeAt(0),s=0);;){let i=r;if(g.isHighSurrogate(r))if(s+1<l){const u=p.charCodeAt(s+1);g.isLowSurrogate(u)?(s++,i=g.computeCodePoint(r,u)):i=65533}else{t=r;break}else g.isLowSurrogate(r)&&(i=65533);if(m=this._push(f,m,i),s++,s<l)r=p.charCodeAt(s);else break}this._buffLen=m,this._leftoverHighSurrogate=t}_push(p,l,f){return f<128?p[l++]=f:f<2048?(p[l++]=192|(f&1984)>>>6,p[l++]=128|(f&63)>>>0):f<65536?(p[l++]=224|(f&61440)>>>12,p[l++]=128|(f&4032)>>>6,p[l++]=128|(f&63)>>>0):(p[l++]=240|(f&1835008)>>>18,p[l++]=128|(f&258048)>>>12,p[l++]=128|(f&4032)>>>6,p[l++]=128|(f&63)>>>0),l>=64&&(this._step(),l-=64,this._totalLen+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),l}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),d(this._h0)+d(this._h1)+d(this._h2)+d(this._h3)+d(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,h(this._buff,this._buffLen),this._buffLen>56&&(this._step(),h(this._buff));const p=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(p/4294967296),!1),this._buffDV.setUint32(60,p%4294967296,!1),this._step()}_step(){const p=y._bigBlock32,l=this._buffDV;for(let v=0;v<64;v+=4)p.setUint32(v,l.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)p.setUint32(v,o(p.getUint32(v-12,!1)^p.getUint32(v-32,!1)^p.getUint32(v-56,!1)^p.getUint32(v-64,!1),1),!1);let f=this._h0,m=this._h1,t=this._h2,r=this._h3,s=this._h4,i,u,w;for(let v=0;v<80;v++)v<20?(i=m&t|~m&r,u=1518500249):v<40?(i=m^t^r,u=1859775393):v<60?(i=m&t|m&r|t&r,u=2400959708):(i=m^t^r,u=3395469782),w=o(f,5)+i+s+u+p.getUint32(v*4,!1)&4294967295,s=r,r=t,t=o(m,30),m=f,f=w;this._h0=this._h0+f&4294967295,this._h1=this._h1+m&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(we[42],_e([0,1,8]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var T;(function(S){S[S.Ignore=0]="Ignore",S[S.Info=1]="Info",S[S.Warning=2]="Warning",S[S.Error=3]="Error"})(T||(T={})),function(S){const E="error",k="warning",D="warn",_="info",C="ignore";function n(o){return o?g.equalsIgnoreCase(E,o)?S.Error:g.equalsIgnoreCase(k,o)||g.equalsIgnoreCase(D,o)?S.Warning:g.equalsIgnoreCase(_,o)?S.Info:S.Ignore:S.Ignore}S.fromValue=n;function I(o){switch(o){case S.Error:return E;case S.Warning:return k;case S.Info:return _;default:return C}}S.toString=I}(T||(T={})),e.default=T}),define(we[10],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function g(v){return Array.isArray(v)}e.isArray=g;function T(v){return typeof v=="string"}e.isString=T;function S(v){return Array.isArray(v)&&v.every(P=>T(P))}e.isStringArray=S;function E(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=E;function k(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=k;function D(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=D;function _(v){return v===!0||v===!1}e.isBoolean=_;function C(v){return typeof v=="undefined"}e.isUndefined=C;function n(v){return!I(v)}e.isDefined=n;function I(v){return C(v)||v===null}e.isUndefinedOrNull=I;function o(v,P){if(!v)throw new Error(P?`Unexpected type, expected '${P}'`:"Unexpected type")}e.assertType=o;function h(v){if(I(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=h;function c(...v){const P=[];for(let A=0;A<v.length;A++){const a=v[A];if(I(a))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);P.push(a)}return P}e.assertAllDefined=c;const d=Object.prototype.hasOwnProperty;function y(v){if(!E(v))return!1;for(let P in v)if(d.call(v,P))return!1;return!0}e.isEmptyObject=y;function b(v){return typeof v=="function"}e.isFunction=b;function p(...v){return v.length>0&&v.every(b)}e.areFunctions=p;function l(v,P){const A=Math.min(v.length,P.length);for(let a=0;a<A;a++)f(v[a],P[a])}e.validateConstraints=l;function f(v,P){if(T(P)){if(typeof v!==P)throw new Error(`argument does not match constraint: typeof ${P}`)}else if(b(P)){try{if(v instanceof P)return}catch(A){}if(!I(v)&&v.constructor===P||P.length===1&&P.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function m(v){let P=[],A=Object.getPrototypeOf(v);for(;Object.prototype!==A;)P=P.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return P}e.getAllPropertyNames=m;function t(v){const P=[];for(const A of m(v))typeof v[A]=="function"&&P.push(A);return P}e.getAllMethodNames=t;function r(v,P){const A=R=>function(){const L=Array.prototype.slice.call(arguments,0);return P(R,L)};let a={};for(const R of v)a[R]=A(R);return a}e.createProxyObject=r;function s(v){return v===null?void 0:v}e.withNullAsUndefined=s;function i(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=i;function u(v){return class{constructor(){return new Proxy({},{get(P,A){if(P[A])return P[A];throw new Error(`Not Implemented: ${v}->${String(A)}`)}})}}}e.NotImplementedProxy=u;function w(v){throw new Error("Unreachable")}e.assertNever=w}),define(we[43],_e([0,1,21,8,14,10]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function k(s){return s===47||s===92}e.isPathSeparator=k;function D(s){return s.replace(/[\\/]/g,S.posix.sep)}e.toSlashes=D;function _(s){return s.indexOf("/")===-1&&(s=D(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=_;function C(s,i=S.posix.sep){if(!s)return"";const u=s.length,w=s.charCodeAt(0);if(k(w)){if(k(s.charCodeAt(1))&&!k(s.charCodeAt(2))){let P=3;const A=P;for(;P<u&&!k(s.charCodeAt(P));P++);if(A!==P&&!k(s.charCodeAt(P+1))){for(P+=1;P<u;P++)if(k(s.charCodeAt(P)))return s.slice(0,P+1).replace(/[\\/]/g,i)}}return i}else if(b(w)&&s.charCodeAt(1)===58)return k(s.charCodeAt(2))?s.slice(0,2)+i:s.slice(0,2);let v=s.indexOf("://");if(v!==-1){for(v+=3;v<u;v++)if(k(s.charCodeAt(v)))return s.slice(0,v+1)}return""}e.getRoot=C;function n(s){if(!g.isWindows||!s||s.length<5)return!1;let i=s.charCodeAt(0);if(i!==92||(i=s.charCodeAt(1),i!==92))return!1;let u=2;const w=u;for(;u<s.length&&(i=s.charCodeAt(u),i!==92);u++);return!(w===u||(i=s.charCodeAt(u+1),isNaN(i)||i===92))}e.isUNC=n;const I=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function c(s,i=g.isWindows){const u=i?I:o;return!(!s||s.length===0||/^\s+$/.test(s)||(u.lastIndex=0,u.test(s))||i&&h.test(s)||s==="."||s===".."||i&&s[s.length-1]==="."||i&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=c;function d(s,i,u){const w=s===i;return!u||w?w:!s||!i?!1:T.equalsIgnoreCase(s,i)}e.isEqual=d;function y(s,i,u,w=S.sep){if(s===i)return!0;if(!s||!i||i.length>s.length)return!1;if(u){if(!T.startsWithIgnoreCase(s,i))return!1;if(i.length===s.length)return!0;let P=i.length;return i.charAt(i.length-1)===w&&P--,s.charAt(P)===w}return i.charAt(i.length-1)!==w&&(i+=w),s.indexOf(i)===0}e.isEqualOrParent=y;function b(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=b;function p(s,i){return g.isWindows&&s.endsWith(":")&&(s+=S.sep),S.isAbsolute(s)||(s=S.join(i,s)),s=S.normalize(s),g.isWindows?(s=T.rtrim(s,S.sep),s.endsWith(":")&&(s+=S.sep)):(s=T.rtrim(s,S.sep),s||(s=S.sep)),s}e.sanitizeFilePath=p;function l(s){const i=S.normalize(s);return g.isWindows?s.length>3?!1:f(i)&&(s.length===2||i.charCodeAt(2)===92):i===S.posix.sep}e.isRootOrDriveLetter=l;function f(s){return g.isWindows?b(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function m(s){return f(s)?s[0]:void 0}e.getDriveLetter=m;function t(s,i,u){return i.length>s.length?-1:s===i?0:(u&&(s=s.toLowerCase(),i=i.toLowerCase()),s.indexOf(i))}e.indexOfPath=t;function r(s){const i=s.split(":");let u,w,v;if(i.forEach(P=>{const A=Number(P);E.isNumber(A)?w===void 0?w=A:v===void 0&&(v=A):u=u?[u,P].join(":"):P}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:w!==void 0?w:void 0,column:v!==void 0?v:w!==void 0?1:void 0}}e.parseLineAndColumnAware=r}),define(we[24],_e([0,1,10]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function T(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const y=Array.isArray(d)?[]:{};return Object.keys(d).forEach(b=>{d[b]&&typeof d[b]=="object"?y[b]=T(d[b]):y[b]=d[b]}),y}e.deepClone=T;function S(d){if(!d||typeof d!="object")return d;const y=[d];for(;y.length>0;){const b=y.shift();Object.freeze(b);for(const p in b)if(E.call(b,p)){const l=b[p];typeof l=="object"&&!Object.isFrozen(l)&&y.push(l)}}return d}e.deepFreeze=S;const E=Object.prototype.hasOwnProperty;function k(d,y){return D(d,y,new Set)}e.cloneAndChange=k;function D(d,y,b){if(g.isUndefinedOrNull(d))return d;const p=y(d);if(typeof p!="undefined")return p;if(g.isArray(d)){const l=[];for(const f of d)l.push(D(f,y,b));return l}if(g.isObject(d)){if(b.has(d))throw new Error("Cannot clone recursive data-structure");b.add(d);const l={};for(let f in d)E.call(d,f)&&(l[f]=D(d[f],y,b));return b.delete(d),l}return d}function _(d,y,b=!0){return g.isObject(d)?(g.isObject(y)&&Object.keys(y).forEach(p=>{p in d?b&&(g.isObject(d[p])&&g.isObject(y[p])?_(d[p],y[p],b):d[p]=y[p]):d[p]=y[p]}),d):y}e.mixin=_;function C(d,y){if(d===y)return!0;if(d==null||y===null||y===void 0||typeof d!=typeof y||typeof d!="object"||Array.isArray(d)!==Array.isArray(y))return!1;let b,p;if(Array.isArray(d)){if(d.length!==y.length)return!1;for(b=0;b<d.length;b++)if(!C(d[b],y[b]))return!1}else{const l=[];for(p in d)l.push(p);l.sort();const f=[];for(p in y)f.push(p);if(f.sort(),!C(l,f))return!1;for(b=0;b<l.length;b++)if(!C(d[l[b]],y[l[b]]))return!1}return!0}e.equals=C;function n(d){const y=new Set;return JSON.stringify(d,(b,p)=>{if(g.isObject(p)||Array.isArray(p)){if(y.has(p))return"[Circular]";y.add(p)}return p})}e.safeStringify=n;function I(d,y,b){const p=y(d);return typeof p=="undefined"?b:p}e.getOrDefault=I;function o(d,y){const b=Object.create(null);return!d||!y||Object.keys(y).forEach(l=>{const f=d[l],m=y[l];C(f,m)||(b[l]=m)}),b}e.distinct=o;function h(d,y){const b=y.toLowerCase(),p=Object.keys(d).find(l=>l.toLowerCase()===b);return p?d[p]:d[y]}e.getCaseInsensitive=h;function c(d,y){const b=Object.create(null);for(const p of Object.keys(d))y(p,d[p])&&(b[p]=d[p]);return b}e.filter=c}),define(we[79],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var g;(function(E){E[E.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",E[E.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",E[E.MAX_UINT_8=255]="MAX_UINT_8",E[E.MAX_UINT_16=65535]="MAX_UINT_16",E[E.MAX_UINT_32=4294967295]="MAX_UINT_32",E[E.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(g=e.Constants||(e.Constants={}));function T(E){return E<0?0:E>255?255:E|0}e.toUint8=T;function S(E){return E<0?0:E>4294967295?4294967295:E|0}e.toUint32=S}),define(we[2],_e([0,1,21,14]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const S=/^\w[\w\d+.-]*$/,E=/^\//,k=/^\/\//;function D(s,i){if(!s.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!S.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!E.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(k.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function _(s,i){return!s&&!i?"file":s}function C(s,i){switch(s){case"https":case"http":case"file":i?i[0]!==I&&(i=I+i):i=I;break}return i}const n="",I="/",o=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{constructor(i,u,w,v,P,A=!1){typeof i=="object"?(this.scheme=i.scheme||n,this.authority=i.authority||n,this.path=i.path||n,this.query=i.query||n,this.fragment=i.fragment||n):(this.scheme=_(i,A),this.authority=u||n,this.path=C(this.scheme,w||n),this.query=v||n,this.fragment=P||n,D(this,A))}static isUri(i){return i instanceof h?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return l(this,!1)}with(i){if(!i)return this;let{scheme:u,authority:w,path:v,query:P,fragment:A}=i;return u===void 0?u=this.scheme:u===null&&(u=n),w===void 0?w=this.authority:w===null&&(w=n),v===void 0?v=this.path:v===null&&(v=n),P===void 0?P=this.query:P===null&&(P=n),A===void 0?A=this.fragment:A===null&&(A=n),u===this.scheme&&w===this.authority&&v===this.path&&P===this.query&&A===this.fragment?this:new d(u,w,v,P,A)}static parse(i,u=!1){const w=o.exec(i);return w?new d(w[2]||n,r(w[4]||n),r(w[5]||n),r(w[7]||n),r(w[9]||n),u):new d(n,n,n,n,n)}static file(i){let u=n;if(g.isWindows&&(i=i.replace(/\\/g,I)),i[0]===I&&i[1]===I){const w=i.indexOf(I,2);w===-1?(u=i.substring(2),i=I):(u=i.substring(2,w),i=i.substring(w)||I)}return new d("file",u,i,n,n)}static from(i){const u=new d(i.scheme,i.authority,i.path,i.query,i.fragment);return D(u,!0),u}static joinPath(i,...u){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let w;return g.isWindows&&i.scheme==="file"?w=h.file(T.win32.join(l(i,!0),...u)).path:w=T.posix.join(i.path,...u),i.with({path:w})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof h)return i;{const u=new d(i);return u._formatted=i.external,u._fsPath=i._sep===c?i.fsPath:null,u}}else return i}}e.URI=h;const c=g.isWindows?1:void 0;class d extends h{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=l(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=c),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const y={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function b(s,i){let u,w=-1;for(let v=0;v<s.length;v++){const P=s.charCodeAt(v);if(P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57||P===45||P===46||P===95||P===126||i&&P===47)w!==-1&&(u+=encodeURIComponent(s.substring(w,v)),w=-1),u!==void 0&&(u+=s.charAt(v));else{u===void 0&&(u=s.substr(0,v));const A=y[P];A!==void 0?(w!==-1&&(u+=encodeURIComponent(s.substring(w,v)),w=-1),u+=A):w===-1&&(w=v)}}return w!==-1&&(u+=encodeURIComponent(s.substring(w))),u!==void 0?u:s}function p(s){let i;for(let u=0;u<s.length;u++){const w=s.charCodeAt(u);w===35||w===63?(i===void 0&&(i=s.substr(0,u)),i+=y[w]):i!==void 0&&(i+=s[u])}return i!==void 0?i:s}function l(s,i){let u;return s.authority&&s.path.length>1&&s.scheme==="file"?u=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?i?u=s.path.substr(1):u=s.path[1].toLowerCase()+s.path.substr(2):u=s.path,g.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=l;function f(s,i){const u=i?p:b;let w="",{scheme:v,authority:P,path:A,query:a,fragment:R}=s;if(v&&(w+=v,w+=":"),(P||v==="file")&&(w+=I,w+=I),P){let L=P.indexOf("@");if(L!==-1){const H=P.substr(0,L);P=P.substr(L+1),L=H.indexOf(":"),L===-1?w+=u(H,!1):(w+=u(H.substr(0,L),!1),w+=":",w+=u(H.substr(L+1),!1)),w+="@"}P=P.toLowerCase(),L=P.indexOf(":"),L===-1?w+=u(P,!1):(w+=u(P.substr(0,L),!1),w+=P.substr(L))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const L=A.charCodeAt(1);L>=65&&L<=90&&(A=`/${String.fromCharCode(L+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const L=A.charCodeAt(0);L>=65&&L<=90&&(A=`${String.fromCharCode(L+32)}:${A.substr(2)}`)}w+=u(A,!0)}return a&&(w+="?",w+=u(a,!1)),R&&(w+="#",w+=i?R:b(R,!1)),w}function m(s){try{return decodeURIComponent(s)}catch(i){return s.length>3?s.substr(0,3)+m(s.substr(3)):s}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(s){return s.match(t)?s.replace(t,i=>m(i)):s}});var it=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[22],_e([0,1,2,8]),function(ee,e,g,T){"use strict";var S,E,k;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function D(t,r,s){let i=t.get(r);return i===void 0&&(i=s,t.set(r,i)),i}e.getOrSet=D;function _(t){const r=[];return t.forEach((s,i)=>{r.push(`${i} => ${s}`)}),`Map(${t.size}) {${r.join(", ")}}`}e.mapToString=_;function C(t){const r=[];return t.forEach(s=>{r.push(s)}),`Set(${t.size}) {${r.join(", ")}}`}e.setToString=C;class n{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const s=r.charCodeAt(0),i=this._value.charCodeAt(this._pos);return s-i}value(){return this._value[this._pos]}}e.StringIterator=n;class I{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?T.compareSubstring(r,this._value,0,r.length,this._from,this._to):T.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=I;class o{constructor(r=!0,s=!0){this._splitOnBackslash=r,this._caseSensitive=s}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?T.compareSubstring(r,this._value,0,r.length,this._from,this._to):T.compareSubstringIgnoreCase(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=o;var h;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(h||(h={}));class c{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new o(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return T.compareIgnoreCase(r,this._value.scheme);if(this._states[this._stateIdx]===2)return T.compareIgnoreCase(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return T.compare(r,this._value.query);if(this._states[this._stateIdx]===5)return T.compare(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=c;class d{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class y{constructor(r){this._iter=r}static forUris(r=()=>!1){return new y(new c(r))}static forPaths(){return new y(new o)}static forStrings(){return new y(new n)}static forConfigKeys(){return new y(new I)}clear(){this._root=void 0}set(r,s){const i=this._iter.reset(r);let u;for(this._root||(this._root=new d,this._root.segment=i.value()),u=this._root;;){const v=i.cmp(u.segment);if(v>0)u.left||(u.left=new d,u.left.segment=i.value()),u=u.left;else if(v<0)u.right||(u.right=new d,u.right.segment=i.value()),u=u.right;else if(i.hasNext())i.next(),u.mid||(u.mid=new d,u.mid.segment=i.value()),u=u.mid;else break}const w=u.value;return u.value=s,u.key=r,w}get(r){var s;return(s=this._getNode(r))===null||s===void 0?void 0:s.value}_getNode(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const u=s.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else break}return i}has(r){const s=this._getNode(r);return!((s==null?void 0:s.value)===void 0&&(s==null?void 0:s.mid)===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,s){const i=this._iter.reset(r),u=[];let w=this._root;for(;w;){const v=i.cmp(w.segment);if(v>0)u.push([1,w]),w=w.left;else if(v<0)u.push([-1,w]),w=w.right;else if(i.hasNext())i.next(),u.push([0,w]),w=w.mid;else{for(s?(w.left=void 0,w.mid=void 0,w.right=void 0):w.value=void 0;u.length>0&&w.isEmpty();){let[P,A]=u.pop();switch(P){case 1:A.left=void 0;break;case 0:A.mid=void 0;break;case-1:A.right=void 0;break}w=A}break}}}findSubstr(r){const s=this._iter.reset(r);let i=this._root,u;for(;i;){const w=s.cmp(i.segment);if(w>0)i=i.left;else if(w<0)i=i.right;else if(s.hasNext())s.next(),u=i.value||u,i=i.mid;else break}return i&&i.value||u}findSuperstr(r){const s=this._iter.reset(r);let i=this._root;for(;i;){const u=s.cmp(i.segment);if(u>0)i=i.left;else if(u<0)i=i.right;else if(s.hasNext())s.next(),i=i.mid;else return i.mid?this._entries(i.mid):void 0}}forEach(r){for(const[s,i]of this)r(i,s)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){if(!r)return;const s=[r];for(;s.length>0;){const i=s.pop();i&&(i.value&&(yield[i.key,i.value]),i.left&&s.push(i.left),i.mid&&s.push(i.mid),i.right&&s.push(i.right))}}}e.TernarySearchTree=y;class b{constructor(r,s){this[S]="ResourceMap",r instanceof b?(this.map=new Map(r.map),this.toKey=s??b.defaultToKey):(this.map=new Map,this.toKey=r??b.defaultToKey)}set(r,s){return this.map.set(this.toKey(r),s),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,s){typeof s!="undefined"&&(r=r.bind(s));for(let[i,u]of this.map)r(u,g.URI.parse(i),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield g.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[g.URI.parse(r[0]),r[1]]}*[(S=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[g.URI.parse(r[0]),r[1]]}}e.ResourceMap=b,b.defaultToKey=t=>t.toString();var p;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class l{constructor(){this[E]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var r;return(r=this._head)===null||r===void 0?void 0:r.value}get last(){var r;return(r=this._tail)===null||r===void 0?void 0:r.value}has(r){return this._map.has(r)}get(r,s=0){const i=this._map.get(r);if(!!i)return s!==0&&this.touch(i,s),i.value}set(r,s,i=0){let u=this._map.get(r);if(u)u.value=s,i!==0&&this.touch(u,i);else{switch(u={key:r,value:s,next:void 0,previous:void 0},i){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const s=this._map.get(r);if(!!s)return this._map.delete(r),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,s){const i=this._state;let u=this._head;for(;u;){if(s?r.bind(s)(u.value,u.key,this):r(u.value,u.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,s=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const w={value:i.key,done:!1};return i=i.next,w}else return{value:void 0,done:!0}}};return u}values(){const r=this,s=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const w={value:i.value,done:!1};return i=i.next,w}else return{value:void 0,done:!0}}};return u}entries(){const r=this,s=this._state;let i=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==s)throw new Error("LinkedMap got modified during iteration.");if(i){const w={value:[i.key,i.value],done:!1};return i=i.next,w}else return{value:void 0,done:!0}}};return u}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let s=this._head,i=this.size;for(;s&&i>r;)this._map.delete(s.key),s=s.next,i--;this._head=s,this._size=i,s&&(s.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const s=r.next,i=r.previous;if(!s||!i)throw new Error("Invalid list");s.previous=i,i.next=s}r.next=void 0,r.previous=void 0,this._state++}touch(r,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(r===this._head)return;const i=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(i.previous=u,u.next=i),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(s===2){if(r===this._tail)return;const i=r.next,u=r.previous;r===this._head?(i.previous=void 0,this._head=i):(i.previous=u,u.next=i),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((s,i)=>{r.push([i,s])}),r}fromJSON(r){this.clear();for(const[s,i]of r)this.set(s,i)}}e.LinkedMap=l;class f extends l{constructor(r,s=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,s=2){return super.get(r,s)}peek(r){return super.get(r,0)}set(r,s){return super.set(r,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=f;class m{constructor(r){k.set(this,void 0),it(this,k,r,"f")}get size(){return Be(this,k,"f").size}forEach(r,s){Be(this,k,"f").forEach(r,s)}get(r){return Be(this,k,"f").get(r)}has(r){return Be(this,k,"f").has(r)}entries(){return Be(this,k,"f").entries()}keys(){return Be(this,k,"f").keys()}values(){return Be(this,k,"f").values()}[(k=new WeakMap,Symbol.iterator)](){return Be(this,k,"f").entries()}}e.ReadonlyMapView=m}),define(we[110],_e([0,1,22,8]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function S(...K){return function(oe,fe){for(let Ae=0,$e=K.length;Ae<$e;Ae++){const pe=K[Ae](oe,fe);if(pe)return pe}return null}}e.or=S,e.matchesStrictPrefix=E.bind(void 0,!1),e.matchesPrefix=E.bind(void 0,!0);function E(K,oe,fe){if(!fe||fe.length<oe.length)return null;let Ae;return K?Ae=T.startsWithIgnoreCase(fe,oe):Ae=fe.indexOf(oe)===0,Ae?oe.length>0?[{start:0,end:oe.length}]:[]:null}function k(K,oe){const fe=oe.toLowerCase().indexOf(K.toLowerCase());return fe===-1?null:[{start:fe,end:fe+K.length}]}e.matchesContiguousSubString=k;function D(K,oe){return _(K.toLowerCase(),oe.toLowerCase(),0,0)}e.matchesSubString=D;function _(K,oe,fe,Ae){if(fe===K.length)return[];if(Ae===oe.length)return null;if(K[fe]===oe[Ae]){let $e=null;return($e=_(K,oe,fe+1,Ae+1))?b({start:Ae,end:Ae+1},$e):null}return _(K,oe,fe,Ae+1)}function C(K){return 97<=K&&K<=122}function n(K){return 65<=K&&K<=90}e.isUpper=n;function I(K){return 48<=K&&K<=57}function o(K){return K===32||K===9||K===10||K===13}const h=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(K=>h.add(K.charCodeAt(0)));function c(K){return o(K)||h.has(K)}function d(K,oe){return K===oe||c(K)&&c(oe)}function y(K){return C(K)||n(K)||I(K)}function b(K,oe){return oe.length===0?oe=[K]:K.end===oe[0].start?oe[0].start=K.start:oe.unshift(K),oe}function p(K,oe){for(let fe=oe;fe<K.length;fe++){const Ae=K.charCodeAt(fe);if(n(Ae)||I(Ae)||fe>0&&!y(K.charCodeAt(fe-1)))return fe}return K.length}function l(K,oe,fe,Ae){if(fe===K.length)return[];if(Ae===oe.length)return null;if(K[fe]!==oe[Ae].toLowerCase())return null;{let $e=null,pe=Ae+1;for($e=l(K,oe,fe+1,Ae+1);!$e&&(pe=p(oe,pe))<oe.length;)$e=l(K,oe,fe+1,pe),pe++;return $e===null?null:b({start:Ae,end:Ae+1},$e)}}function f(K){let oe=0,fe=0,Ae=0,$e=0,pe=0;for(let Fe=0;Fe<K.length;Fe++)pe=K.charCodeAt(Fe),n(pe)&&oe++,C(pe)&&fe++,y(pe)&&Ae++,I(pe)&&$e++;const Ge=oe/K.length,j=fe/K.length,ne=Ae/K.length,ge=$e/K.length;return{upperPercent:Ge,lowerPercent:j,alphaPercent:ne,numericPercent:ge}}function m(K){const{upperPercent:oe,lowerPercent:fe}=K;return fe===0&&oe>.6}function t(K){const{upperPercent:oe,lowerPercent:fe,alphaPercent:Ae,numericPercent:$e}=K;return fe>.2&&oe<.8&&Ae>.6&&$e<.2}function r(K){let oe=0,fe=0,Ae=0,$e=0;for(let pe=0;pe<K.length;pe++)Ae=K.charCodeAt(pe),n(Ae)&&oe++,C(Ae)&&fe++,o(Ae)&&$e++;return(oe===0||fe===0)&&$e===0?K.length<=30:oe<=5}function s(K,oe){if(!oe||(oe=oe.trim(),oe.length===0)||!r(K)||oe.length>60)return null;const fe=f(oe);if(!t(fe)){if(!m(fe))return null;oe=oe.toLowerCase()}let Ae=null,$e=0;for(K=K.toLowerCase();$e<oe.length&&(Ae=l(K,oe,0,$e))===null;)$e=p(oe,$e+1);return Ae}e.matchesCamelCase=s;function i(K,oe,fe=!1){if(!oe||oe.length===0)return null;let Ae=null,$e=0;for(K=K.toLowerCase(),oe=oe.toLowerCase();$e<oe.length&&(Ae=u(K,oe,0,$e,fe))===null;)$e=w(oe,$e+1);return Ae}e.matchesWords=i;function u(K,oe,fe,Ae,$e){if(fe===K.length)return[];if(Ae===oe.length)return null;if(d(K.charCodeAt(fe),oe.charCodeAt(Ae))){let pe=null,Ge=Ae+1;if(pe=u(K,oe,fe+1,Ae+1,$e),!$e)for(;!pe&&(Ge=w(oe,Ge))<oe.length;)pe=u(K,oe,fe+1,Ge,$e),Ge++;return pe===null?null:b({start:Ae,end:Ae+1},pe)}else return null}function w(K,oe){for(let fe=oe;fe<K.length;fe++)if(c(K.charCodeAt(fe))||fe>0&&c(K.charCodeAt(fe-1)))return fe;return K.length}const v=S(e.matchesPrefix,s,k),P=S(e.matchesPrefix,s,D),A=new g.LRUCache(1e4);function a(K,oe,fe=!1){if(typeof K!="string"||typeof oe!="string")return null;let Ae=A.get(K);Ae||(Ae=new RegExp(T.convertSimple2RegExpPattern(K),"i"),A.set(K,Ae));const $e=Ae.exec(oe);return $e?[{start:$e.index,end:$e.index+$e[0].length}]:fe?P(K,oe):v(K,oe)}e.matchesFuzzy=a;function R(K,oe){const fe=Ye(K,K.toLowerCase(),0,oe,oe.toLowerCase(),0,!0);return fe?H(fe):null}e.matchesFuzzy2=R;function L(K,oe,fe,Ae,$e,pe){const Ge=Math.min(13,K.length);for(;fe<Ge;fe++){const j=Ye(K,oe,fe,Ae,$e,pe,!1);if(j)return j}return[0,pe]}e.anyScore=L;function H(K){if(typeof K=="undefined")return[];const oe=[],fe=K[1];for(let Ae=K.length-1;Ae>1;Ae--){const $e=K[Ae]+fe,pe=oe[oe.length-1];pe&&pe.end===$e?pe.end=$e+1:oe.push({start:$e,end:$e+1})}return oe}e.createMatches=H;const ue=128;function me(){const K=[],oe=[];for(let fe=0;fe<=ue;fe++)oe[fe]=0;for(let fe=0;fe<=ue;fe++)K.push(oe.slice(0));return K}function J(K){const oe=[];for(let fe=0;fe<=K;fe++)oe[fe]=0;return oe}const z=J(2*ue),Z=J(2*ue),M=me(),q=me(),N=me(),W=!1;function O(K,oe,fe,Ae,$e){function pe(j,ne,ge=" "){for(;j.length<ne;)j=ge+j;return j}let Ge=` |   |${Ae.split("").map(j=>pe(j,3)).join("|")}
`;for(let j=0;j<=fe;j++)j===0?Ge+=" |":Ge+=`${oe[j-1]}|`,Ge+=K[j].slice(0,$e+1).map(ne=>pe(ne.toString(),3)).join("|")+`
`;return Ge}function B(K,oe,fe,Ae){K=K.substr(oe),fe=fe.substr(Ae),console.log(O(q,K,K.length,fe,fe.length)),console.log(O(N,K,K.length,fe,fe.length)),console.log(O(M,K,K.length,fe,fe.length))}function Y(K,oe){if(oe<0||oe>=K.length)return!1;const fe=K.codePointAt(oe);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!T.isEmojiImprecise(fe)}}function he(K,oe){if(oe<0||oe>=K.length)return!1;switch(K.charCodeAt(oe)){case 32:case 9:return!0;default:return!1}}function De(K,oe,fe){return oe[K]!==fe[K]}function Oe(K,oe,fe,Ae,$e,pe,Ge=!1){for(;oe<fe&&$e<pe;)K[oe]===Ae[$e]&&(Ge&&(z[oe]=$e),oe+=1),$e+=1;return oe===fe}e.isPatternInWord=Oe;var Me;(function(K){K[K.Diag=1]="Diag",K[K.Left=2]="Left",K[K.LeftLeft=3]="LeftLeft"})(Me||(Me={}));var He;(function(K){K.Default=[-100,0];function oe(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}K.isDefault=oe})(He=e.FuzzyScore||(e.FuzzyScore={}));function Ye(K,oe,fe,Ae,$e,pe,Ge){const j=K.length>ue?ue:K.length,ne=Ae.length>ue?ue:Ae.length;if(fe>=j||pe>=ne||j-fe>ne-pe||!Oe(oe,fe,j,$e,pe,ne,!0))return;qe(j,ne,fe,pe,oe,$e);let ge=1,Fe=1,Ne=fe,Qe=pe;const Ee=[!1];for(ge=1,Ne=fe;Ne<j;ge++,Ne++){const U=z[Ne],Q=Z[Ne],le=Ne+1<j?Z[Ne+1]:ne;for(Fe=U-pe+1,Qe=U;Qe<le;Fe++,Qe++){let ke=Number.MIN_SAFE_INTEGER,Pe=!1;Qe<=Q&&(ke=Xe(K,oe,Ne,fe,Ae,$e,Qe,ne,pe,M[ge-1][Fe-1]===0,Ee));let Ue=0;ke!==Number.MAX_SAFE_INTEGER&&(Pe=!0,Ue=ke+q[ge-1][Fe-1]);const We=Qe>U,Ze=We?q[ge][Fe-1]+(M[ge][Fe-1]>0?-5:0):0,rt=Qe>U+1&&M[ge][Fe-1]>0,Ke=rt?q[ge][Fe-2]+(M[ge][Fe-2]>0?-5:0):0;if(rt&&(!We||Ke>=Ze)&&(!Pe||Ke>=Ue))q[ge][Fe]=Ke,N[ge][Fe]=3,M[ge][Fe]=0;else if(We&&(!Pe||Ze>=Ue))q[ge][Fe]=Ze,N[ge][Fe]=2,M[ge][Fe]=0;else if(Pe)q[ge][Fe]=Ue,N[ge][Fe]=1,M[ge][Fe]=M[ge-1][Fe-1]+1;else throw new Error("not possible")}}if(W&&B(K,fe,Ae,pe),!Ee[0]&&!Ge)return;ge--,Fe--;const be=[q[ge][Fe],pe];let Ce=0,se=0;for(;ge>=1;){let U=Fe;do{const Q=N[ge][U];if(Q===3)U=U-2;else if(Q===2)U=U-1;else break}while(U>=1);Ce>1&&oe[fe+ge-1]===$e[pe+Fe-1]&&!De(U+pe-1,Ae,$e)&&Ce+1>M[ge][U]&&(U=Fe),U===Fe?Ce++:Ce=1,se||(se=U),ge--,Fe=U-1,be.push(Fe)}ne===j&&(be[0]+=2);const de=se-j;return be[0]-=de,be}e.fuzzyScore=Ye;function qe(K,oe,fe,Ae,$e,pe){let Ge=K-1,j=oe-1;for(;Ge>=fe&&j>=Ae;)$e[Ge]===pe[j]&&(Z[Ge]=j,Ge--),j--}function Xe(K,oe,fe,Ae,$e,pe,Ge,j,ne,ge,Fe){if(oe[fe]!==pe[Ge])return Number.MIN_SAFE_INTEGER;let Ne=1,Qe=!1;return Ge===fe-Ae?Ne=K[fe]===$e[Ge]?7:5:De(Ge,$e,pe)&&(Ge===0||!De(Ge-1,$e,pe))?(Ne=K[fe]===$e[Ge]?7:5,Qe=!0):Y(pe,Ge)&&(Ge===0||!Y(pe,Ge-1))?Ne=5:(Y(pe,Ge-1)||he(pe,Ge-1))&&(Ne=5,Qe=!0),Ne>1&&fe===Ae&&(Fe[0]=!0),Qe||(Qe=De(Ge,$e,pe)||Y(pe,Ge-1)||he(pe,Ge-1)),fe===Ae?Ge>ne&&(Ne-=Qe?3:5):ge?Ne+=Qe?2:0:Ne+=Qe?0:1,Ge+1===j&&(Ne-=Qe?3:5),Ne}function $(K,oe,fe,Ae,$e,pe,Ge){return te(K,oe,fe,Ae,$e,pe,!0,Ge)}e.fuzzyScoreGracefulAggressive=$;function G(K,oe,fe,Ae,$e,pe,Ge){return te(K,oe,fe,Ae,$e,pe,!1,Ge)}e.fuzzyScoreGraceful=G;function te(K,oe,fe,Ae,$e,pe,Ge,j){let ne=Ye(K,oe,fe,Ae,$e,pe,j);if(ne&&!Ge)return ne;if(K.length>=3){const ge=Math.min(7,K.length-1);for(let Fe=fe+1;Fe<ge;Fe++){const Ne=re(K,Fe);if(Ne){const Qe=Ye(Ne,Ne.toLowerCase(),fe,Ae,$e,pe,j);Qe&&(Qe[0]-=3,(!ne||Qe[0]>ne[0])&&(ne=Qe))}}}return ne}function re(K,oe){if(oe+1>=K.length)return;const fe=K[oe],Ae=K[oe+1];if(fe!==Ae)return K.slice(0,oe)+Ae+fe+K.slice(oe+2)}}),define(we[111],_e([0,1,78,110,8]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const E=new RegExp(`\\$\\(${g.CSSIcon.iconNameExpression}(?:${g.CSSIcon.iconModifierExpression})?\\)`,"g"),k=new RegExp(`(\\\\)?${E.source}`,"g");function D(d){return d.replace(k,(y,b)=>b?y:`\\${y}`)}e.escapeIcons=D;const _=new RegExp(`\\\\${E.source}`,"g");function C(d){return d.replace(_,y=>`\\${y}`)}e.markdownEscapeEscapedIcons=C;const n=new RegExp(`(\\s)?(\\\\)?${E.source}(\\s)?`,"g");function I(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(n,(y,b,p,l)=>p?y:b||l||"")}e.stripIcons=I;function o(d){const y=d.indexOf(e.iconStartMarker);return y===-1?{text:d}:h(d,y)}e.parseLabelWithIcons=o;function h(d,y){const b=[];let p="";function l(w){if(w){p+=w;for(const v of w)b.push(t)}}let f=-1,m="",t=0,r,s,i=y;const u=d.length;for(l(d.substr(0,y));i<u;)r=d[i],s=d[i+1],r===e.iconStartMarker[0]&&s===e.iconStartMarker[1]?(f=i,l(m),m=e.iconStartMarker,i++):r===")"&&f!==-1?(t+=i-f+1,f=-1,m=""):f!==-1?/^[a-z0-9\-]$/i.test(r)?m+=r:(l(m),f=-1,m=""):l(r),i++;return l(m),{text:p,iconOffsets:b}}function c(d,y,b=!1){const{text:p,iconOffsets:l}=y;if(!l||l.length===0)return T.matchesFuzzy(d,p,b);const f=S.ltrim(p," "),m=p.length-f.length,t=T.matchesFuzzy(d,f,b);if(t)for(const r of t){const s=l[r.start+m]+m;r.start+=s,r.end+=s}return t}e.matchesFuzzyIconAware=c}),define(we[80],_e([0,1,111,11]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var S;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(S=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(h="",c=!1){var d,y;if(this.value=h,typeof this.value!="string")throw T.illegalArgument("value");typeof c=="boolean"?(this.isTrusted=c,this.supportThemeIcons=!1):(this.isTrusted=(d=c.isTrusted)!==null&&d!==void 0?d:void 0,this.supportThemeIcons=(y=c.supportThemeIcons)!==null&&y!==void 0?y:!1)}appendText(h,c=0){return this.value+=C(this.supportThemeIcons?g.escapeIcons(h):h).replace(/([ \t]+)/g,(d,y)=>"&nbsp;".repeat(y.length)).replace(/^>/gm,"\\>").replace(/\n/g,c===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,c){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=c,this.value+="\n```\n",this}}e.MarkdownString=E;function k(o){return D(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.isEmptyMarkdownString=k;function D(o){return o instanceof E?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.isMarkdownString=D;function _(o,h){return o===h?!0:!o||!h?!1:o.value===h.value&&o.isTrusted===h.isTrusted&&o.supportThemeIcons===h.supportThemeIcons}e.markdownStringEqual=_;function C(o){return o.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=C;function n(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=n;function I(o){const h=[],c=o.split("|").map(y=>y.trim());o=c[0];const d=c[1];if(d){const y=/height=(\d+)/.exec(d),b=/width=(\d+)/.exec(d),p=y?y[1]:"",l=b?b[1]:"",f=isFinite(parseInt(l)),m=isFinite(parseInt(p));f&&h.push(`width="${l}"`),m&&h.push(`height="${p}"`)}return{href:o,dimensions:h}}e.parseHrefAndDimensions=I}),define(we[54],_e([0,1,23,8,2]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function E(C){return JSON.stringify(C,D)}e.stringify=E;function k(C){let n=JSON.parse(C);return n=_(n),n}e.parse=k;function D(C,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:T.regExpFlags(n)}:n}function _(C,n=0){if(!C||n>200)return C;if(typeof C=="object"){switch(C.$mid){case 1:return S.URI.revive(C);case 2:return new RegExp(C.source,C.flags)}if(C instanceof g.VSBuffer||C instanceof Uint8Array)return C;if(Array.isArray(C))for(let I=0;I<C.length;++I)C[I]=_(C[I],n+1);else for(const I in C)Object.hasOwnProperty.call(C,I)&&(C[I]=_(C[I],n+1))}return C}e.revive=_}),define(we[16],_e([0,1,2,21]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var S;(function(D){D.inMemory="inmemory",D.vscode="vscode",D.internal="private",D.walkThrough="walkThrough",D.walkThroughSnippet="walkThroughSnippet",D.http="http",D.https="https",D.file="file",D.mailto="mailto",D.untitled="untitled",D.data="data",D.command="command",D.vscodeRemote="vscode-remote",D.vscodeRemoteResource="vscode-remote-resource",D.userData="vscode-userdata",D.vscodeCustomEditor="vscode-custom-editor",D.vscodeNotebook="vscode-notebook",D.vscodeNotebookCell="vscode-notebook-cell",D.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",D.vscodeNotebookCellOutput="vscode-notebook-cell-output",D.vscodeSettings="vscode-settings",D.vscodeWorkspaceTrust="vscode-workspace-trust",D.vscodeTerminal="vscode-terminal",D.webviewPanel="webview-panel",D.vscodeWebview="vscode-webview",D.extension="extension",D.vscodeFileResource="vscode-file",D.tmp="tmp"})(S=e.Schemas||(e.Schemas={}));class E{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(_){this._preferredWebSchema=_}setDelegate(_){this._delegate=_}set(_,C,n){this._hosts[_]=C,this._ports[_]=n}setConnectionToken(_,C){this._connectionTokens[_]=C}rewrite(_){if(this._delegate)return this._delegate(_);const C=_.authority;let n=this._hosts[C];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const I=this._ports[C],o=this._connectionTokens[C];let h=`path=${encodeURIComponent(_.path)}`;return typeof o=="string"&&(h+=`&tkn=${encodeURIComponent(o)}`),g.URI.from({scheme:T.isWeb?this._preferredWebSchema:S.vscodeRemoteResource,authority:`${n}:${I}`,path:"/vscode-remote-resource",query:h})}}e.RemoteAuthorities=new E;class k{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(_,C,n){const I=this.toUri(_,C);return I.scheme===S.vscodeRemote?e.RemoteAuthorities.rewrite(I):T.isNative&&(n||T.isPreferringBrowserCodeLoad)&&I.scheme===S.file?I.with({scheme:S.vscodeFileResource,authority:I.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):I}asFileUri(_,C){const n=this.toUri(_,C);return n.scheme===S.vscodeFileResource?n.with({scheme:S.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(_,C){return g.URI.isUri(_)?_:g.URI.parse(C.toUrl(_))}}e.FileAccess=new k}),define(we[25],_e([0,1,43,14,2,8,16,21]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function _(h){return S.uriToFsPath(h,!0)}e.originalFSPath=_;class C{constructor(c){this._ignorePathCasing=c}compare(c,d,y=!1){return c===d?0:E.compare(this.getComparisonKey(c,y),this.getComparisonKey(d,y))}isEqual(c,d,y=!1){return c===d?!0:!c||!d?!1:this.getComparisonKey(c,y)===this.getComparisonKey(d,y)}getComparisonKey(c,d=!1){return c.with({path:this._ignorePathCasing(c)?c.path.toLowerCase():void 0,fragment:d?null:void 0}).toString()}ignorePathCasing(c){return this._ignorePathCasing(c)}isEqualOrParent(c,d,y=!1){if(c.scheme===d.scheme){if(c.scheme===k.Schemas.file)return g.isEqualOrParent(_(c),_(d),this._ignorePathCasing(c))&&c.query===d.query&&(y||c.fragment===d.fragment);if(e.isEqualAuthority(c.authority,d.authority))return g.isEqualOrParent(c.path,d.path,this._ignorePathCasing(c),"/")&&c.query===d.query&&(y||c.fragment===d.fragment)}return!1}joinPath(c,...d){return S.URI.joinPath(c,...d)}basenameOrAuthority(c){return e.basename(c)||c.authority}basename(c){return T.posix.basename(c.path)}extname(c){return T.posix.extname(c.path)}dirname(c){if(c.path.length===0)return c;let d;return c.scheme===k.Schemas.file?d=S.URI.file(T.dirname(_(c))).path:(d=T.posix.dirname(c.path),c.authority&&d.length&&d.charCodeAt(0)!==47&&(console.error(`dirname("${c.toString})) resulted in a relative path`),d="/")),c.with({path:d})}normalizePath(c){if(!c.path.length)return c;let d;return c.scheme===k.Schemas.file?d=S.URI.file(T.normalize(_(c))).path:d=T.posix.normalize(c.path),c.with({path:d})}relativePath(c,d){if(c.scheme!==d.scheme||!e.isEqualAuthority(c.authority,d.authority))return;if(c.scheme===k.Schemas.file){const p=T.relative(_(c),_(d));return D.isWindows?g.toSlashes(p):p}let y=c.path||"/",b=d.path||"/";if(this._ignorePathCasing(c)){let p=0;for(const l=Math.min(y.length,b.length);p<l&&!(y.charCodeAt(p)!==b.charCodeAt(p)&&y.charAt(p).toLowerCase()!==b.charAt(p).toLowerCase());p++);y=b.substr(0,p)+y.substr(p)}return T.posix.relative(y,b)}resolvePath(c,d){if(c.scheme===k.Schemas.file){const y=S.URI.file(T.resolve(_(c),d));return c.with({authority:y.authority,path:y.path})}return d=g.toPosixPath(d),c.with({path:T.posix.resolve(c.path,d)})}isAbsolutePath(c){return!!c.path&&c.path[0]==="/"}isEqualAuthority(c,d){return c===d||E.equalsIgnoreCase(c,d)}hasTrailingPathSeparator(c,d=T.sep){if(c.scheme===k.Schemas.file){const y=_(c);return y.length>g.getRoot(y).length&&y[y.length-1]===d}else{const y=c.path;return y.length>1&&y.charCodeAt(y.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(c.fsPath)}}removeTrailingPathSeparator(c,d=T.sep){return e.hasTrailingPathSeparator(c,d)?c.with({path:c.path.substr(0,c.path.length-1)}):c}addTrailingPathSeparator(c,d=T.sep){let y=!1;if(c.scheme===k.Schemas.file){const b=_(c);y=b!==void 0&&b.length===g.getRoot(b).length&&b[b.length-1]===d}else{d="/";const b=c.path;y=b.length===1&&b.charCodeAt(b.length-1)===47}return!y&&!e.hasTrailingPathSeparator(c,d)?c.with({path:c.path+"/"}):c}}e.ExtUri=C,e.extUri=new C(()=>!1),e.extUriBiasedIgnorePathCase=new C(h=>h.scheme===k.Schemas.file?!D.isLinux:!0),e.extUriIgnorePathCase=new C(h=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(h,c){const d=[];for(let y=0;y<h.length;y++){const b=c(h[y]);h.some((p,l)=>l===y?!1:e.isEqualOrParent(b,c(p)))||d.push(h[y])}return d}e.distinctParents=n;var I;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function c(d){const y=new Map;d.path.substring(d.path.indexOf(";")+1,d.path.lastIndexOf(";")).split(";").forEach(l=>{const[f,m]=l.split(":");f&&m&&y.set(f,m)});const p=d.path.substring(0,d.path.indexOf(";"));return p&&y.set(h.META_DATA_MIME,p),y}h.parseMetaData=c})(I=e.DataUri||(e.DataUri={}));function o(h,c,d){if(c){let y=h.path;return y&&y[0]!==T.posix.sep&&(y=T.posix.sep+y),h.with({scheme:d,authority:c,path:y})}return h.with({scheme:d})}e.toLocalResource=o}),define(we[12],_e([0,1,18,11,3,7,51,25]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function _(q){return!!q&&typeof q.then=="function"}e.isThenable=_;function C(q){const N=new g.CancellationTokenSource,W=q(N.token),O=new Promise((B,Y)=>{N.token.onCancellationRequested(()=>{Y(T.canceled())}),Promise.resolve(W).then(he=>{N.dispose(),B(he)},he=>{N.dispose(),Y(he)})});return new class{cancel(){N.cancel()}then(B,Y){return O.then(B,Y)}catch(B){return this.then(void 0,B)}finally(B){return O.finally(B)}}}e.createCancelablePromise=C;function n(q,N,W){return Promise.race([q,new Promise(O=>N.onCancellationRequested(()=>O(W)))])}e.raceCancellation=n;async function I(q){let N=-1;const W=q.map((B,Y)=>B.then(he=>(N=Y,he))),O=await Promise.race(W);return q.forEach((B,Y)=>{Y!==N&&B.cancel()}),O}e.raceCancellablePromises=I;function o(q,N,W){let O;const B=setTimeout(()=>{O==null||O(void 0),W==null||W()},N);return Promise.race([q.finally(()=>clearTimeout(B)),new Promise(Y=>O=Y)])}e.raceTimeout=o;function h(q){return new Promise((N,W)=>{const O=q();_(O)?O.then(N,W):N(O)})}e.asPromise=h;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(N){if(this.activePromise){if(this.queuedPromiseFactory=N,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const O=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,O};this.queuedPromise=new Promise(O=>{this.activePromise.then(W,W).then(O)})}return new Promise((W,O)=>{this.queuedPromise.then(W,O)})}return this.activePromise=N(),new Promise((W,O)=>{this.activePromise.then(B=>{this.activePromise=null,W(B)},B=>{this.activePromise=null,O(B)})})}}e.Throttler=c;class d{constructor(){this.current=Promise.resolve(null)}queue(N){return this.current=this.current.then(()=>N(),()=>N())}}e.Sequencer=d;class y{constructor(){this.promiseMap=new Map}queue(N,W){var O;const Y=((O=this.promiseMap.get(N))!==null&&O!==void 0?O:Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(N)===Y&&this.promiseMap.delete(N)});return this.promiseMap.set(N,Y),Y}}e.SequencerByKey=y;class b{constructor(N){this.defaultDelay=N,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(N,W=this.defaultDelay){return this.task=N,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((O,B)=>{this.doResolve=O,this.doReject=B}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const O=this.task;return this.task=null,O()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},W),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(T.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=b;class p{constructor(N){this.delayer=new b(N),this.throttler=new c}trigger(N,W){return this.delayer.trigger(()=>this.throttler.queue(N),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=p;class l{constructor(){this._isOpen=!1,this._promise=new Promise((N,W)=>{this._completePromise=N})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=l;class f extends l{constructor(N){super();this._timeout=setTimeout(()=>this.open(),N)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=f;function m(q,N){return N?new Promise((W,O)=>{const B=setTimeout(W,q);N.onCancellationRequested(()=>{clearTimeout(B),O(T.canceled())})}):C(W=>m(q,W))}e.timeout=m;function t(q,N=0){const W=setTimeout(q,N);return E.toDisposable(()=>clearTimeout(W))}e.disposableTimeout=t;function r(q){return q.then(void 0,N=>{})}e.ignoreErrors=r;function s(q){const N=[];let W=0;const O=q.length;function B(){return W<O?q[W++]():null}function Y(he){he!=null&&N.push(he);const De=B();return De?De.then(Y):Promise.resolve(N)}return Promise.resolve(null).then(Y)}e.sequence=s;function i(q,N=O=>!!O,W=null){let O=0;const B=q.length,Y=()=>{if(O>=B)return Promise.resolve(W);const he=q[O++];return Promise.resolve(he()).then(Oe=>N(Oe)?Promise.resolve(Oe):Y())};return Y()}e.first=i;function u(q,N=O=>!!O,W=null){if(q.length===0)return Promise.resolve(W);let O=q.length;const B=()=>{var Y,he;O=-1;for(const De of q)(he=(Y=De).cancel)===null||he===void 0||he.call(Y)};return new Promise((Y,he)=>{for(const De of q)De.then(Oe=>{--O>=0&&N(Oe)?(B(),Y(Oe)):O===0&&Y(W)}).catch(Oe=>{--O>=0&&(B(),he(Oe))})})}e.firstParallel=u;class w{constructor(N){this._size=0,this.maxDegreeOfParalellism=N,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new S.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(N){return this._size++,new Promise((W,O)=>{this.outstandingPromises.push({factory:N,c:W,e:O}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const N=this.outstandingPromises.shift();this.runningPromises++;const W=N.factory();W.then(N.c,N.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=w;class v extends w{constructor(){super(1)}}e.Queue=v;class P{constructor(){this.queues=new Map}queueFor(N,W=D.extUri){const O=W.getComparisonKey(N);let B=this.queues.get(O);return B||(B=new v,S.Event.once(B.onFinished)(()=>{B==null||B.dispose(),this.queues.delete(O)}),this.queues.set(O,B)),B}dispose(){this.queues.forEach(N=>N.dispose()),this.queues.clear()}}e.ResourceQueue=P;class A{constructor(N,W){this._token=-1,typeof N=="function"&&typeof W=="number"&&this.setIfNotSet(N,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(N,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,N()},W)}setIfNotSet(N,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,N()},W))}}e.TimeoutTimer=A;class a{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(N,W){this.cancel(),this._token=setInterval(()=>{N()},W)}}e.IntervalTimer=a;class R{constructor(N,W){this.timeoutToken=-1,this.runner=N,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(N=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,N)}get delay(){return this.timeout}set delay(N){this.timeout=N}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class L extends R{constructor(N,W){super(N,W);this.units=[]}work(N){this.units.push(N),this.isScheduled()||this.schedule()}doRun(){const N=this.units;this.units=[],this.runner&&this.runner(N)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=L,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const q=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=N=>{const W=setTimeout(()=>N(q));let O=!1;return{dispose(){O||(O=!0,clearTimeout(W))}}}}else e.runWhenIdle=(q,N)=>{const W=requestIdleCallback(q,typeof N=="number"?{timeout:N}:void 0);let O=!1;return{dispose(){O||(O=!0,cancelIdleCallback(W))}}}}();class H{constructor(N){this._didRun=!1,this._executor=()=>{try{this._value=N()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=H;async function ue(q,N,W){let O;for(let B=0;B<W;B++)try{return await q()}catch(Y){O=Y,await m(N)}throw O}e.retry=ue;class me{hasPending(N){return this._pending?typeof N=="number"?this._pending.taskId===N:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var N;(N=this._pending)===null||N===void 0||N.cancel()}setPending(N,W,O){return this._pending={taskId:N,cancel:()=>O==null?void 0:O(),promise:W},W.then(()=>this.donePending(N),()=>this.donePending(N)),W}donePending(N){this._pending&&N===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const N=this._next;this._next=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this._next)this._next.run=N;else{let W,O;const B=new Promise((Y,he)=>{W=Y,O=he});this._next={run:N,promise:B,promiseResolve:W,promiseReject:O}}return this._next.promise}}e.TaskSequentializer=me;class J{constructor(N){this.interval=N,this.lastIncrementTime=0,this.value=0}increment(){const N=Date.now();return N-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=N,this.value=0),this.value++,this.value}}e.IntervalCounter=J;class z{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((N,W)=>{this.completeCallback=N,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(N){return new Promise(W=>{this.completeCallback(N),this.resolved=!0,W()})}error(N){return new Promise(W=>{this.errorCallback(N),this.rejected=!0,W()})}cancel(){new Promise(N=>{this.errorCallback(T.canceled()),this.rejected=!0,N()})}}e.DeferredPromise=z;class Z extends S.Emitter{async fireAsync(N,W,O){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new k.LinkedList);for(const B of this._listeners)this._asyncDeliveryQueue.push([B,N]);for(;this._asyncDeliveryQueue.size>0&&!W.isCancellationRequested;){const[B,Y]=this._asyncDeliveryQueue.shift(),he=[],De=Object.assign(Object.assign({},Y),{waitUntil:Oe=>{if(Object.isFrozen(he))throw new Error("waitUntil can NOT be called asynchronous");O&&(Oe=O(Oe,typeof B=="function"?B:B[0])),he.push(Oe)}});try{typeof B=="function"?B.call(void 0,De):B[0].call(B[1],De)}catch(Oe){T.onUnexpectedError(Oe);continue}Object.freeze(he),await M.settled(he).catch(Oe=>T.onUnexpectedError(Oe))}}}}e.AsyncEmitter=Z;var M;(function(q){async function N(Y){return typeof Promise.allSettled=="function"?W(Y):O(Y)}q.allSettled=N;async function W(Y){return Promise.allSettled(Y)}async function O(Y){return Promise.all(Y.map(he=>he.then(De=>({status:"fulfilled",value:De}),De=>({status:"rejected",reason:De}))))}async function B(Y){let he;const De=await Promise.all(Y.map(Oe=>Oe.then(Me=>Me,Me=>{he||(he=Me)})));if(typeof he!="undefined")throw he;return De}q.settled=B})(M=e.Promises||(e.Promises={}))}),define(we[112],_e([0,1,14,12]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const S=new T.IdleValue(()=>{const A=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:A,collatorIsNumeric:A.resolvedOptions().numeric}}),E=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),k=new T.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function D(A,a,R=!1){const L=A||"",H=a||"",ue=S.value.collator.compare(L,H);return S.value.collatorIsNumeric&&ue===0&&L!==H?L<H?-1:1:ue}e.compareFileNames=D;function _(A,a){const R=E.value.collator;return A=A||"",a=a||"",m(R,A,a)}e.compareFileNamesDefault=_;function C(A,a){const R=E.value.collator;return A=A||"",a=a||"",i(A,a)||m(R,A,a)}e.compareFileNamesUpper=C;function n(A,a){const R=E.value.collator;return A=A||"",a=a||"",s(A,a)||m(R,A,a)}e.compareFileNamesLower=n;function I(A,a){return A=A||"",a=a||"",A===a?0:A<a?-1:1}e.compareFileNamesUnicode=I;function o(A,a,R=!1){R||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase());const[L,H]=l(A),[ue,me]=l(a);return L!==ue?L<ue?-1:1:H===me?0:H<me?-1:1}e.noIntlCompareFileNames=o;function h(A,a){const[R,L]=l(A),[H,ue]=l(a);let me=S.value.collator.compare(L,ue);if(me===0){if(S.value.collatorIsNumeric&&L!==ue)return L<ue?-1:1;if(me=S.value.collator.compare(R,H),S.value.collatorIsNumeric&&me===0&&R!==H)return R<H?-1:1}return me}e.compareFileExtensions=h;function c(A,a){A=A||"",a=a||"";const R=f(A),L=f(a),H=E.value.collator,ue=k.value.collator;return m(ue,R,L)||m(H,A,a)}e.compareFileExtensionsDefault=c;function d(A,a){A=A||"",a=a||"";const R=f(A),L=f(a),H=E.value.collator,ue=k.value.collator;return m(ue,R,L)||i(A,a)||m(H,A,a)}e.compareFileExtensionsUpper=d;function y(A,a){A=A||"",a=a||"";const R=f(A),L=f(a),H=E.value.collator,ue=k.value.collator;return m(ue,R,L)||s(A,a)||m(H,A,a)}e.compareFileExtensionsLower=y;function b(A,a){A=A||"",a=a||"";const R=f(A).toLowerCase(),L=f(a).toLowerCase();return R!==L?R<L?-1:1:A!==a?A<a?-1:1:0}e.compareFileExtensionsUnicode=b;const p=/^(.*?)(\.([^.]*))?$/;function l(A,a=!1){const R=A?p.exec(A):[];let L=[R&&R[1]||"",R&&R[3]||""];return a&&(!L[0]&&L[1]||L[0]&&L[0].charAt(0)===".")&&(L=[L[0]+"."+L[1],""]),L}function f(A){const a=A?p.exec(A):[];return a&&a[1]&&a[1].charAt(0)!=="."&&a[3]||""}function m(A,a,R){let L=A.compare(a,R);return L!==0?L:a.length!==R.length?a.length<R.length?-1:1:0}function t(A){const a=A.charAt(0);return a.toLocaleUpperCase()!==a}function r(A){const a=A.charAt(0);return a.toLocaleLowerCase()!==a}function s(A,a){return t(A)&&r(a)?-1:r(A)&&t(a)?1:0}function i(A,a){return r(A)&&t(a)?-1:t(A)&&r(a)?1:0}function u(A,a,R=!1){return R||(A=A&&A.toLowerCase(),a=a&&a.toLowerCase()),A===a?0:A<a?-1:1}function w(A,a,R=!1){const L=A.split(g.sep),H=a.split(g.sep),ue=L.length-1,me=H.length-1;let J,z;for(let Z=0;;Z++){if(J=ue===Z,z=me===Z,J&&z)return D(L[Z],H[Z],R);if(J)return-1;if(z)return 1;const M=u(L[Z],H[Z],R);if(M!==0)return M}}e.comparePaths=w;function v(A,a,R){const L=A.toLowerCase(),H=a.toLowerCase(),ue=P(A,a,R);if(ue)return ue;const me=L.endsWith(R),J=H.endsWith(R);if(me!==J)return me?-1:1;const z=D(L,H);return z!==0?z:L.localeCompare(H)}e.compareAnything=v;function P(A,a,R){const L=A.toLowerCase(),H=a.toLowerCase(),ue=L.startsWith(R),me=H.startsWith(R);if(ue!==me)return ue?-1:1;if(ue&&me){if(L.length<H.length)return-1;if(L.length>H.length)return 1}return 0}e.compareByPrefix=P}),define(we[27],_e([0,1,8,43,14,22,12]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D;const _="**",C="/",n="[/\\\\]",I="[^/\\\\]",o=/\//g;function h(W){switch(W){case 0:return"";case 1:return`${I}*?`;default:return`(?:${n}|${I}+${n}|${n}${I}+)*?`}}function c(W,O){if(!W)return[];const B=[];let Y=!1,he=!1,De="";for(const Oe of W){switch(Oe){case O:if(!Y&&!he){B.push(De),De="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":he=!0;break;case"]":he=!1;break}De+=Oe}return De&&B.push(De),B}e.splitGlobAware=c;function d(W){if(!W)return"";let O="";const B=c(W,C);if(B.every(Y=>Y===_))O=".*";else{let Y=!1;B.forEach((he,De)=>{if(he===_){Y||(O+=h(2),Y=!0);return}let Oe=!1,Me="",He=!1,Ye="";for(const qe of he){if(qe!=="}"&&Oe){Me+=qe;continue}if(He&&(qe!=="]"||!Ye)){let Xe;qe==="-"?Xe=qe:(qe==="^"||qe==="!")&&!Ye?Xe="^":qe===C?Xe="":Xe=g.escapeRegExpCharacters(qe),Ye+=Xe;continue}switch(qe){case"{":Oe=!0;continue;case"[":He=!0;continue;case"}":O+=`(?:${c(Me,",").map(G=>d(G)).join("|")})`,Oe=!1,Me="";break;case"]":O+="["+Ye+"]",He=!1,Ye="";break;case"?":O+=I;continue;case"*":O+=h(1);continue;default:O+=g.escapeRegExpCharacters(qe)}}De<B.length-1&&(B[De+1]!==_||De+2<B.length)&&(O+=n),Y=!1})}return O}const y=/^\*\*\/\*\.[\w\.-]+$/,b=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,l=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,m=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new E.LRUCache(1e4),r=function(){return!1},s=function(){return null};function i(W,O){if(!W)return s;let B;typeof W!="string"?B=W.pattern:B=W,B=B.trim();const Y=`${B}_${!!O.trimForExclusions}`;let he=t.get(Y);if(he)return u(he,W);let De;if(y.test(B)){const Oe=B.substr(4);he=function(Me,He){return typeof Me=="string"&&Me.endsWith(Oe)?B:null}}else(De=b.exec(w(B,O)))?he=v(De[1],B):(O.trimForExclusions?l:p).test(B)?he=P(B,O):(De=f.exec(w(B,O)))?he=A(De[1].substr(1),B,!0):(De=m.exec(w(B,O)))?he=A(De[1],B,!1):he=a(B);return t.set(Y,he),u(he,W)}function u(W,O){return typeof O=="string"?W:function(B,Y){return T.isEqualOrParent(B,O.base)?W(S.relative(O.base,B),Y):null}}function w(W,O){return O.trimForExclusions&&W.endsWith("/**")?W.substr(0,W.length-2):W}function v(W,O){const B=`/${W}`,Y=`\\${W}`,he=function(Oe,Me){return typeof Oe!="string"?null:Me?Me===W?O:null:Oe===W||Oe.endsWith(B)||Oe.endsWith(Y)?O:null},De=[W];return he.basenames=De,he.patterns=[O],he.allBasenames=De,he}function P(W,O){const B=N(W.slice(1,-1).split(",").map(Me=>i(Me,O)).filter(Me=>Me!==s),W),Y=B.length;if(!Y)return s;if(Y===1)return B[0];const he=function(Me,He){for(let Ye=0,qe=B.length;Ye<qe;Ye++)if(B[Ye](Me,He))return W;return null},De=B.find(Me=>!!Me.allBasenames);De&&(he.allBasenames=De.allBasenames);const Oe=B.reduce((Me,He)=>He.allPaths?Me.concat(He.allPaths):Me,[]);return Oe.length&&(he.allPaths=Oe),he}function A(W,O,B){const Y=S.sep===S.posix.sep,he=Y?W:W.replace(o,S.sep),De=S.sep+he,Oe=S.posix.sep+W,Me=B?function(He,Ye){return typeof He=="string"&&(He===he||He.endsWith(De)||!Y&&(He===W||He.endsWith(Oe)))?O:null}:function(He,Ye){return typeof He=="string"&&(He===he||!Y&&He===W)?O:null};return Me.allPaths=[(B?"*/":"./")+W],Me}function a(W){try{const O=new RegExp(`^${d(W)}$`);return function(B){return O.lastIndex=0,typeof B=="string"&&O.test(B)?W:null}}catch(O){return s}}function R(W,O,B){return!W||typeof O!="string"?!1:L(W)(O,void 0,B)}e.match=R;function L(W,O={}){if(!W)return r;if(typeof W=="string"||J(W)){const B=i(W,O);if(B===s)return r;const Y=function(he,De){return!!B(he,De)};return B.allBasenames&&(Y.allBasenames=B.allBasenames),B.allPaths&&(Y.allPaths=B.allPaths),Y}return M(W,O)}e.parse=L;function H(W){if(!W)return;let O;return B=>(O||(O=(W()||Promise.resolve([])).then(Y=>Y?me(Y):{})),O.then(Y=>!!Y[B]))}e.hasSiblingPromiseFn=H;function ue(W){if(!W)return;let O;return B=>{if(!O){const Y=W();O=Y?me(Y):{}}return!!O[B]}}e.hasSiblingFn=ue;function me(W){const O={};for(const B of W)O[B]=!0;return O}function J(W){const O=W;return O&&typeof O.base=="string"&&typeof O.pattern=="string"}e.isRelativePattern=J;function z(W){return W.allBasenames||[]}e.getBasenameTerms=z;function Z(W){return W.allPaths||[]}e.getPathTerms=Z;function M(W,O){const B=N(Object.getOwnPropertyNames(W).map(Me=>q(Me,W[Me],O)).filter(Me=>Me!==s)),Y=B.length;if(!Y)return s;if(!B.some(Me=>!!Me.requiresSiblings)){if(Y===1)return B[0];const Me=function(qe,Xe){for(let $=0,G=B.length;$<G;$++){const te=B[$](qe,Xe);if(te)return te}return null},He=B.find(qe=>!!qe.allBasenames);He&&(Me.allBasenames=He.allBasenames);const Ye=B.reduce((qe,Xe)=>Xe.allPaths?qe.concat(Xe.allPaths):qe,[]);return Ye.length&&(Me.allPaths=Ye),Me}const he=function(Me,He,Ye){let qe;for(let Xe=0,$=B.length;Xe<$;Xe++){const G=B[Xe];G.requiresSiblings&&Ye&&(He||(He=S.basename(Me)),qe||(qe=He.substr(0,He.length-S.extname(Me).length)));const te=G(Me,He,qe,Ye);if(te)return te}return null},De=B.find(Me=>!!Me.allBasenames);De&&(he.allBasenames=De.allBasenames);const Oe=B.reduce((Me,He)=>He.allPaths?Me.concat(He.allPaths):Me,[]);return Oe.length&&(he.allPaths=Oe),he}function q(W,O,B){if(O===!1)return s;const Y=i(W,B);if(Y===s)return s;if(typeof O=="boolean")return Y;if(O){const he=O.when;if(typeof he=="string"){const De=(Oe,Me,He,Ye)=>{if(!Ye||!Y(Oe,Me))return null;const qe=he.replace("$(basename)",He),Xe=Ye(qe);return k.isThenable(Xe)?Xe.then($=>$?W:null):Xe?W:null};return De.requiresSiblings=!0,De}}return Y}function N(W,O){const B=W.filter(Me=>!!Me.basenames);if(B.length<2)return W;const Y=B.reduce((Me,He)=>{const Ye=He.basenames;return Ye?Me.concat(Ye):Me},[]);let he;if(O){he=[];for(let Me=0,He=Y.length;Me<He;Me++)he.push(O)}else he=B.reduce((Me,He)=>{const Ye=He.patterns;return Ye?Me.concat(Ye):Me},[]);const De=function(Me,He){if(typeof Me!="string")return null;if(!He){let qe;for(qe=Me.length;qe>0;qe--){const Xe=Me.charCodeAt(qe-1);if(Xe===47||Xe===92)break}He=Me.substr(qe)}const Ye=Y.indexOf(He);return Ye!==-1?he[Ye]:null};De.basenames=Y,De.patterns=he,De.allBasenames=Y;const Oe=W.filter(Me=>!Me.basenames);return Oe.push(De),Oe}}),define(we[81],_e([0,1,2,14,8,16,21,25,43]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function C(i,u,w){if(typeof i=="string"&&(i=g.URI.file(i)),w){const P=w.getWorkspaceFolder(i);if(P){const A=w.getWorkspace().folders.length>1;let a;if(D.isEqual(P.uri,i)?a="":a=D.relativePath(P.uri,i),A){const R=P.name?P.name:D.basename(P.uri);a=a?R+" \u2022 "+a:R}return a}}if(i.scheme!==E.Schemas.file&&i.scheme!==E.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if(_.hasDriveLetter(i.fsPath))return T.normalize(I(i.fsPath));let v=T.normalize(i.fsPath);return!k.isWindows&&(u==null?void 0:u.userHome)&&(v=h(v,u.userHome.fsPath)),v}e.getPathLabel=C;function n(i){if(!i)return;typeof i=="string"&&(i=g.URI.file(i));const u=D.basename(i)||(i.scheme===E.Schemas.file?i.fsPath:i.path);return k.isWindows&&_.isRootOrDriveLetter(u)?I(u):u}e.getBaseLabel=n;function I(i){return _.hasDriveLetter(i)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=I;let o=Object.create(null);function h(i,u){if(k.isWindows||!i||!u)return i;let w=o.original===u?o.normalized:void 0;return w||(w=`${S.rtrim(u,T.posix.sep)}${T.posix.sep}`,o={original:u,normalized:w}),(k.isLinux?i.startsWith(w):S.startsWithIgnoreCase(i,w))&&(i=`~/${i.substr(w.length)}`),i}e.tildify=h;function c(i,u){return i.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=c;const d="\u2026",y="\\\\",b="~";function p(i,u=T.sep){const w=new Array(i.length);let v=!1;for(let P=0;P<i.length;P++){let A=i[P];if(A===""){w[P]=`.${u}`;continue}if(!A){w[P]=A;continue}v=!0;let a="";A.indexOf(y)===0?(a=A.substr(0,A.indexOf(y)+y.length),A=A.substr(A.indexOf(y)+y.length)):A.indexOf(u)===0?(a=A.substr(0,A.indexOf(u)+u.length),A=A.substr(A.indexOf(u)+u.length)):A.indexOf(b)===0&&(a=A.substr(0,A.indexOf(b)+b.length),A=A.substr(A.indexOf(b)+b.length));const R=A.split(u);for(let L=1;v&&L<=R.length;L++)for(let H=R.length-L;v&&H>=0;H--){v=!1;let ue=R.slice(H,H+L).join(u);for(let me=0;!v&&me<i.length;me++)if(me!==P&&i[me]&&i[me].indexOf(ue)>-1){const J=H+L===R.length,z=H>0&&i[me].indexOf(u)>-1?u+ue:ue,Z=i[me].endsWith(z);v=!J||Z}if(!v){let me="";(R[0].endsWith(":")||a!=="")&&(H===1&&(H=0,L++,ue=R[0]+u+ue),H>0&&(me=R[0]+u),me=a+me),H>0&&(me=me+d+u),me=me+ue,H+L<R.length&&(me=me+u+d),w[P]=me}}v&&(w[P]=A)}return w}e.shorten=p;var l;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(l||(l={}));function f(i,u=Object.create(null)){const w=[];let v=!1,P="";for(const A of i)if(A==="$"||v&&A==="{")P&&w.push({value:P,type:l.TEXT}),P="",v=!0;else if(A==="}"&&v){const a=u[P];if(typeof a=="string")a.length&&w.push({value:a,type:l.VARIABLE});else if(a){const R=w[w.length-1];(!R||R.type!==l.SEPARATOR)&&w.push({value:a.label,type:l.SEPARATOR})}P="",v=!1}else P+=A;return P&&!v&&w.push({value:P,type:l.TEXT}),w.filter((A,a)=>{if(A.type===l.SEPARATOR){const R=w[a-1],L=w[a+1];return[R,L].every(H=>H&&(H.type===l.VARIABLE||H.type===l.TEXT)&&H.value.length>0)}return!0}).map(A=>A.value).join("")}e.template=f;function m(i,u){return k.isMacintosh||u?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,k.isMacintosh?"&":"&&"):i.replace(/&&|&/g,w=>w==="&"?"&&":"&")}e.mnemonicMenuLabel=m;function t(i,u){return k.isMacintosh||u?i.replace(/\(&&\w\)|&&/g,""):k.isWindows?i.replace(/&&|&/g,w=>w==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function r(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=r;function s(i){const u=i.indexOf("/")!==-1?T.posix:T.win32,w=u.basename(i),v=u.dirname(i);return w.length?{name:w,parentPath:v}:{name:v,parentPath:""}}e.splitName=s}),define(we[82],_e([0,1,14,8,27,16,25]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var D;(function(r){r.text="text/plain",r.binary="application/octet-stream",r.unknown="application/unknown",r.markdown="text/markdown"})(D=e.Mimes||(e.Mimes={}));let _=[],C=[],n=[];function I(r,s=!1){const i=o(r);_.push(i),i.userConfigured?n.push(i):C.push(i),s&&!i.userConfigured&&_.forEach(u=>{u.mime===i.mime||u.userConfigured||(i.extension&&u.extension===i.extension&&console.warn(`Overwriting extension <<${i.extension}>> to now point to mime <<${i.mime}>>`),i.filename&&u.filename===i.filename&&console.warn(`Overwriting filename <<${i.filename}>> to now point to mime <<${i.mime}>>`),i.filepattern&&u.filepattern===i.filepattern&&console.warn(`Overwriting filepattern <<${i.filepattern}>> to now point to mime <<${i.mime}>>`),i.firstline&&u.firstline===i.firstline&&console.warn(`Overwriting firstline <<${i.firstline}>> to now point to mime <<${i.mime}>>`))})}e.registerTextMime=I;function o(r){return{id:r.id,mime:r.mime,filename:r.filename,extension:r.extension,filepattern:r.filepattern,firstline:r.firstline,userConfigured:r.userConfigured,filenameLowercase:r.filename?r.filename.toLowerCase():void 0,extensionLowercase:r.extension?r.extension.toLowerCase():void 0,filepatternLowercase:r.filepattern?r.filepattern.toLowerCase():void 0,filepatternOnPath:r.filepattern?r.filepattern.indexOf(g.posix.sep)>=0:!1}}function h(r){r?(_=_.filter(s=>!s.userConfigured),n=[]):(_=[],C=[],n=[])}e.clearTextMimes=h;function c(r,s){let i;if(r)switch(r.scheme){case E.Schemas.file:i=r.fsPath;break;case E.Schemas.data:i=k.DataUri.parseMetaData(r).get(k.DataUri.META_DATA_LABEL);break;default:i=r.path}if(!i)return[D.unknown];i=i.toLowerCase();const u=g.basename(i),w=d(i,u,n);if(w)return[w,D.text];const v=d(i,u,C);if(v)return[v,D.text];if(s){const P=y(s);if(P)return[P,D.text]}return[D.unknown]}e.guessMimeTypes=c;function d(r,s,i){let u=null,w=null,v=null;for(let P=i.length-1;P>=0;P--){const A=i[P];if(s===A.filenameLowercase){u=A;break}if(A.filepattern&&(!w||A.filepattern.length>w.filepattern.length)){const a=A.filepatternOnPath?r:s;S.match(A.filepatternLowercase,a)&&(w=A)}A.extension&&(!v||A.extension.length>v.extension.length)&&s.endsWith(A.extensionLowercase)&&(v=A)}return u?u.mime:w?w.mime:v?v.mime:null}function y(r){if(T.startsWithUTF8BOM(r)&&(r=r.substr(1)),r.length>0)for(let s=_.length-1;s>=0;s--){const i=_[s];if(!i.firstline)continue;const u=r.match(i.firstline);if(u&&u.length>0)return i.mime}return null}function b(r){return r?typeof r=="string"?r===D.binary||r===D.text||r===D.unknown:r.length===1&&b(r[0]):!0}e.isUnspecific=b;const p={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function l(r){const s=g.extname(r);return p[s.toLowerCase()]}e.getMediaMime=l;function f(r){for(const s in p)if(p[s]===r)return s}e.getExtensionForMimeType=f;const m=/^(.+)\/(.+?)(;.+)?$/;function t(r,s){var i;const u=m.exec(r);return u?`${u[1].toLowerCase()}/${u[2].toLowerCase()}${(i=u[3])!==null&&i!==void 0?i:""}`:s?void 0:r}e.normalizeMimeType=t}),define(we[113],_e([0,1,2]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function T(n){return n.toJSON()}class S{constructor(I){this._uriTransformer=I}transformIncoming(I){const o=this._uriTransformer.transformIncoming(I);return o===I?I:T(g.URI.from(o))}transformOutgoing(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:T(g.URI.from(o))}transformOutgoingURI(I){const o=this._uriTransformer.transformOutgoing(I);return o===I?I:g.URI.from(o)}transformOutgoingScheme(I){return this._uriTransformer.transformOutgoingScheme(I)}}e.URITransformer=S,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function E(n,I,o){if(!n||o>200)return null;if(typeof n=="object"){if(n instanceof g.URI)return I.transformOutgoing(n);for(let h in n)if(Object.hasOwnProperty.call(n,h)){const c=E(n[h],I,o+1);c!==null&&(n[h]=c)}}return null}function k(n,I){const o=E(n,I,0);return o===null?n:o}e.transformOutgoingURIs=k;function D(n,I,o,h){if(!n||h>200)return null;if(typeof n=="object"){if(n.$mid===1)return o?g.URI.revive(I.transformIncoming(n)):I.transformIncoming(n);for(let c in n)if(Object.hasOwnProperty.call(n,c)){const d=D(n[c],I,o,h+1);d!==null&&(n[c]=d)}}return null}function _(n,I){const o=D(n,I,!1,0);return o===null?n:o}e.transformIncomingURIs=_;function C(n,I){const o=D(n,I,!0,0);return o===null?n:o}e.transformAndReviveIncomingURIs=C}),define(we[34],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const g=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function T(_){return g.test(_)}e.isUUID=T;const S=new Uint8Array(16),E=[];for(let _=0;_<256;_++)E.push(_.toString(16).padStart(2,"0"));let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(_){for(let C=0;C<_.length;C++)_[C]=Math.floor(Math.random()*256);return _};function D(){k(S),S[6]=S[6]&15|64,S[8]=S[8]&63|128;let _=0,C="";return C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+="-",C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C+=E[S[_++]],C}e.generateUuid=D}),define(we[83],_e([0,1,79]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class T{constructor(D){let _=g.toUint8(D);this._defaultValue=_,this._asciiMap=T._createAsciiMap(_),this._map=new Map}static _createAsciiMap(D){let _=new Uint8Array(256);for(let C=0;C<256;C++)_[C]=D;return _}set(D,_){let C=g.toUint8(_);D>=0&&D<256?this._asciiMap[D]=C:this._map.set(D,C)}get(D){return D>=0&&D<256?this._asciiMap[D]:this._map.get(D)||this._defaultValue}}e.CharacterClassifier=T;var S;(function(k){k[k.False=0]="False",k[k.True=1]="True"})(S||(S={}));class E{constructor(){this._actual=new T(0)}add(D){this._actual.set(D,1)}has(D){return this._actual.get(D)===1}}e.CharacterSet=E}),define(we[114],_e([0,1,83]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var T;(function(k){k[k.Regular=0]="Regular",k[k.Whitespace=1]="Whitespace",k[k.WordSeparator=2]="WordSeparator"})(T=e.WordCharacterClass||(e.WordCharacterClass={}));class S extends g.CharacterClassifier{constructor(D){super(0);for(let _=0,C=D.length;_<C;_++)this.set(D.charCodeAt(_),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=S;function E(k){let D={};return _=>(D.hasOwnProperty(_)||(D[_]=k(_)),D[_])}e.getMapForWordSeparators=E(k=>new S(k))}),define(we[35],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class g{constructor(S,E){this.lineNumber=S,this.column=E}with(S=this.lineNumber,E=this.column){return S===this.lineNumber&&E===this.column?this:new g(S,E)}delta(S=0,E=0){return this.with(this.lineNumber+S,this.column+E)}equals(S){return g.equals(this,S)}static equals(S,E){return!S&&!E?!0:!!S&&!!E&&S.lineNumber===E.lineNumber&&S.column===E.column}isBefore(S){return g.isBefore(this,S)}static isBefore(S,E){return S.lineNumber<E.lineNumber?!0:E.lineNumber<S.lineNumber?!1:S.column<E.column}isBeforeOrEqual(S){return g.isBeforeOrEqual(this,S)}static isBeforeOrEqual(S,E){return S.lineNumber<E.lineNumber?!0:E.lineNumber<S.lineNumber?!1:S.column<=E.column}static compare(S,E){let k=S.lineNumber|0,D=E.lineNumber|0;if(k===D){let _=S.column|0,C=E.column|0;return _-C}return k-D}clone(){return new g(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(S){return new g(S.lineNumber,S.column)}static isIPosition(S){return S&&typeof S.lineNumber=="number"&&typeof S.column=="number"}}e.Position=g}),define(we[31],_e([0,1,35]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class T{constructor(E,k,D,_){E>D||E===D&&k>_?(this.startLineNumber=D,this.startColumn=_,this.endLineNumber=E,this.endColumn=k):(this.startLineNumber=E,this.startColumn=k,this.endLineNumber=D,this.endColumn=_)}isEmpty(){return T.isEmpty(this)}static isEmpty(E){return E.startLineNumber===E.endLineNumber&&E.startColumn===E.endColumn}containsPosition(E){return T.containsPosition(this,E)}static containsPosition(E,k){return!(k.lineNumber<E.startLineNumber||k.lineNumber>E.endLineNumber||k.lineNumber===E.startLineNumber&&k.column<E.startColumn||k.lineNumber===E.endLineNumber&&k.column>E.endColumn)}containsRange(E){return T.containsRange(this,E)}static containsRange(E,k){return!(k.startLineNumber<E.startLineNumber||k.endLineNumber<E.startLineNumber||k.startLineNumber>E.endLineNumber||k.endLineNumber>E.endLineNumber||k.startLineNumber===E.startLineNumber&&k.startColumn<E.startColumn||k.endLineNumber===E.endLineNumber&&k.endColumn>E.endColumn)}strictContainsRange(E){return T.strictContainsRange(this,E)}static strictContainsRange(E,k){return!(k.startLineNumber<E.startLineNumber||k.endLineNumber<E.startLineNumber||k.startLineNumber>E.endLineNumber||k.endLineNumber>E.endLineNumber||k.startLineNumber===E.startLineNumber&&k.startColumn<=E.startColumn||k.endLineNumber===E.endLineNumber&&k.endColumn>=E.endColumn)}plusRange(E){return T.plusRange(this,E)}static plusRange(E,k){let D,_,C,n;return k.startLineNumber<E.startLineNumber?(D=k.startLineNumber,_=k.startColumn):k.startLineNumber===E.startLineNumber?(D=k.startLineNumber,_=Math.min(k.startColumn,E.startColumn)):(D=E.startLineNumber,_=E.startColumn),k.endLineNumber>E.endLineNumber?(C=k.endLineNumber,n=k.endColumn):k.endLineNumber===E.endLineNumber?(C=k.endLineNumber,n=Math.max(k.endColumn,E.endColumn)):(C=E.endLineNumber,n=E.endColumn),new T(D,_,C,n)}intersectRanges(E){return T.intersectRanges(this,E)}static intersectRanges(E,k){let D=E.startLineNumber,_=E.startColumn,C=E.endLineNumber,n=E.endColumn,I=k.startLineNumber,o=k.startColumn,h=k.endLineNumber,c=k.endColumn;return D<I?(D=I,_=o):D===I&&(_=Math.max(_,o)),C>h?(C=h,n=c):C===h&&(n=Math.min(n,c)),D>C||D===C&&_>n?null:new T(D,_,C,n)}equalsRange(E){return T.equalsRange(this,E)}static equalsRange(E,k){return!!E&&!!k&&E.startLineNumber===k.startLineNumber&&E.startColumn===k.startColumn&&E.endLineNumber===k.endLineNumber&&E.endColumn===k.endColumn}getEndPosition(){return T.getEndPosition(this)}static getEndPosition(E){return new g.Position(E.endLineNumber,E.endColumn)}getStartPosition(){return T.getStartPosition(this)}static getStartPosition(E){return new g.Position(E.startLineNumber,E.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(E,k){return new T(this.startLineNumber,this.startColumn,E,k)}setStartPosition(E,k){return new T(E,k,this.endLineNumber,this.endColumn)}collapseToStart(){return T.collapseToStart(this)}static collapseToStart(E){return new T(E.startLineNumber,E.startColumn,E.startLineNumber,E.startColumn)}static fromPositions(E,k=E){return new T(E.lineNumber,E.column,k.lineNumber,k.column)}static lift(E){return E?new T(E.startLineNumber,E.startColumn,E.endLineNumber,E.endColumn):null}static isIRange(E){return E&&typeof E.startLineNumber=="number"&&typeof E.startColumn=="number"&&typeof E.endLineNumber=="number"&&typeof E.endColumn=="number"}static areIntersectingOrTouching(E,k){return!(E.endLineNumber<k.startLineNumber||E.endLineNumber===k.startLineNumber&&E.endColumn<k.startColumn||k.endLineNumber<E.startLineNumber||k.endLineNumber===E.startLineNumber&&k.endColumn<E.startColumn)}static areIntersecting(E,k){return!(E.endLineNumber<k.startLineNumber||E.endLineNumber===k.startLineNumber&&E.endColumn<=k.startColumn||k.endLineNumber<E.startLineNumber||k.endLineNumber===E.startLineNumber&&k.endColumn<=E.startColumn)}static compareRangesUsingStarts(E,k){if(E&&k){const C=E.startLineNumber|0,n=k.startLineNumber|0;if(C===n){const I=E.startColumn|0,o=k.startColumn|0;if(I===o){const h=E.endLineNumber|0,c=k.endLineNumber|0;if(h===c){const d=E.endColumn|0,y=k.endColumn|0;return d-y}return h-c}return I-o}return C-n}return(E?1:0)-(k?1:0)}static compareRangesUsingEnds(E,k){return E.endLineNumber===k.endLineNumber?E.endColumn===k.endColumn?E.startLineNumber===k.startLineNumber?E.startColumn-k.startColumn:E.startLineNumber-k.startLineNumber:E.endColumn-k.endColumn:E.endLineNumber-k.endLineNumber}static spansMultipleLines(E){return E.endLineNumber>E.startLineNumber}}e.Range=T}),define(we[115],_e([0,1,35,31]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var S;(function(k){k[k.LTR=0]="LTR",k[k.RTL=1]="RTL"})(S=e.SelectionDirection||(e.SelectionDirection={}));class E extends T.Range{constructor(D,_,C,n){super(D,_,C,n);this.selectionStartLineNumber=D,this.selectionStartColumn=_,this.positionLineNumber=C,this.positionColumn=n}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(D){return E.selectionsEqual(this,D)}static selectionsEqual(D,_){return D.selectionStartLineNumber===_.selectionStartLineNumber&&D.selectionStartColumn===_.selectionStartColumn&&D.positionLineNumber===_.positionLineNumber&&D.positionColumn===_.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(D,_){return this.getDirection()===0?new E(this.startLineNumber,this.startColumn,D,_):new E(D,_,this.startLineNumber,this.startColumn)}getPosition(){return new g.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(D,_){return this.getDirection()===0?new E(D,_,this.endLineNumber,this.endColumn):new E(this.endLineNumber,this.endColumn,D,_)}static fromPositions(D,_=D){return new E(D.lineNumber,D.column,_.lineNumber,_.column)}static liftSelection(D){return new E(D.selectionStartLineNumber,D.selectionStartColumn,D.positionLineNumber,D.positionColumn)}static selectionsArrEqual(D,_){if(D&&!_||!D&&_)return!1;if(!D&&!_)return!0;if(D.length!==_.length)return!1;for(let C=0,n=D.length;C<n;C++)if(!this.selectionsEqual(D[C],_[C]))return!1;return!0}static isISelection(D){return D&&typeof D.selectionStartLineNumber=="number"&&typeof D.selectionStartColumn=="number"&&typeof D.positionLineNumber=="number"&&typeof D.positionColumn=="number"}static createWithDirection(D,_,C,n,I){return I===0?new E(D,_,C,n):new E(C,n,D,_)}}e.Selection=E}),define(we[84],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionNormalizationAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var g;(function(c){c[c.Left=1]="Left",c[c.Center=2]="Center",c[c.Right=4]="Right",c[c.Full=7]="Full"})(g=e.OverviewRulerLane||(e.OverviewRulerLane={}));var T;(function(c){c[c.Inline=1]="Inline",c[c.Gutter=2]="Gutter"})(T=e.MinimapPosition||(e.MinimapPosition={}));var S;(function(c){c[c.TextDefined=0]="TextDefined",c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var E;(function(c){c[c.LF=1]="LF",c[c.CRLF=2]="CRLF"})(E=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var k;(function(c){c[c.LF=0]="LF",c[c.CRLF=1]="CRLF"})(k=e.EndOfLineSequence||(e.EndOfLineSequence={}));class D{constructor(d){this.tabSize=Math.max(1,d.tabSize|0),this.indentSize=d.tabSize|0,this.insertSpaces=Boolean(d.insertSpaces),this.defaultEOL=d.defaultEOL|0,this.trimAutoWhitespace=Boolean(d.trimAutoWhitespace)}equals(d){return this.tabSize===d.tabSize&&this.indentSize===d.indentSize&&this.insertSpaces===d.insertSpaces&&this.defaultEOL===d.defaultEOL&&this.trimAutoWhitespace===d.trimAutoWhitespace}createChangeEvent(d){return{tabSize:this.tabSize!==d.tabSize,indentSize:this.indentSize!==d.indentSize,insertSpaces:this.insertSpaces!==d.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==d.trimAutoWhitespace}}}e.TextModelResolvedOptions=D;class _{constructor(d,y){this.range=d,this.matches=y}}e.FindMatch=_;var C;(function(c){c[c.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",c[c.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",c[c.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",c[c.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(C=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var n;(function(c){c[c.Left=0]="Left",c[c.Right=1]="Right"})(n=e.PositionNormalizationAffinity||(e.PositionNormalizationAffinity={}));var I;(function(c){c[c.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(I=e.ModelConstants||(e.ModelConstants={}));class o{constructor(d,y,b,p,l,f){this.identifier=d,this.range=y,this.text=b,this.forceMoveMarkers=p,this.isAutoWhitespaceEdit=l,this._isTracked=f}}e.ValidAnnotatedEditOperation=o;class h{constructor(d,y,b){this.reverseEdits=d,this.changes=y,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=h}),define(we[116],_e([0,1,8,114,35,31,84]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const D=999;class _{constructor(l,f,m,t){this.searchString=l,this.isRegex=f,this.matchCase=m,this.wordSeparators=t}parseSearchRequest(){if(this.searchString==="")return null;let l;this.isRegex?l=C(this.searchString):l=this.searchString.indexOf(`
`)>=0;let f=null;try{f=g.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:l,global:!0,unicode:!0})}catch(t){return null}if(!f)return null;let m=!this.isRegex&&!l;return m&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(m=this.matchCase),new n(f,this.wordSeparators?T.getMapForWordSeparators(this.wordSeparators):null,m?this.searchString:null)}}e.SearchParams=_;function C(p){if(!p||p.length===0)return!1;for(let l=0,f=p.length;l<f;l++)if(p.charCodeAt(l)===92){if(l++,l>=f)break;const t=p.charCodeAt(l);if(t===110||t===114||t===87||t===119)return!0}return!1}e.isMultilineRegexSource=C;class n{constructor(l,f,m){this.regex=l,this.wordSeparators=f,this.simpleSearch=m}}e.SearchData=n;function I(p,l,f){if(!f)return new k.FindMatch(p,null);let m=[];for(let t=0,r=l.length;t<r;t++)m[t]=l[t];return new k.FindMatch(p,m)}e.createFindMatch=I;class o{constructor(l){let f=[],m=0;for(let t=0,r=l.length;t<r;t++)l.charCodeAt(t)===10&&(f[m++]=t);this._lineFeedsOffsets=f}findLineFeedCountBeforeOffset(l){const f=this._lineFeedsOffsets;let m=0,t=f.length-1;if(t===-1||l<=f[0])return 0;for(;m<t;){const r=m+((t-m)/2>>0);f[r]>=l?t=r-1:f[r+1]>=l?(m=r,t=r):m=r+1}return m+1}}class h{static findMatches(l,f,m,t,r){const s=f.parseSearchRequest();return s?s.regex.multiline?this._doFindMatchesMultiline(l,m,new b(s.wordSeparators,s.regex),t,r):this._doFindMatchesLineByLine(l,m,s,t,r):[]}static _getMultilineMatchRange(l,f,m,t,r,s){let i,u=0;t?(u=t.findLineFeedCountBeforeOffset(r),i=f+r+u):i=f+r;let w;if(t){let a=t.findLineFeedCountBeforeOffset(r+s.length)-u;w=i+s.length+a}else w=i+s.length;const v=l.getPositionAt(i),P=l.getPositionAt(w);return new E.Range(v.lineNumber,v.column,P.lineNumber,P.column)}static _doFindMatchesMultiline(l,f,m,t,r){const s=l.getOffsetAt(f.getStartPosition()),i=l.getValueInRange(f,1),u=l.getEOL()===`\r
`?new o(i):null,w=[];let v=0,P;for(m.reset(0);P=m.next(i);)if(w[v++]=I(this._getMultilineMatchRange(l,s,i,u,P.index,P[0]),P,t),v>=r)return w;return w}static _doFindMatchesLineByLine(l,f,m,t,r){const s=[];let i=0;if(f.startLineNumber===f.endLineNumber){const w=l.getLineContent(f.startLineNumber).substring(f.startColumn-1,f.endColumn-1);return i=this._findMatchesInLine(m,w,f.startLineNumber,f.startColumn-1,i,s,t,r),s}const u=l.getLineContent(f.startLineNumber).substring(f.startColumn-1);i=this._findMatchesInLine(m,u,f.startLineNumber,f.startColumn-1,i,s,t,r);for(let w=f.startLineNumber+1;w<f.endLineNumber&&i<r;w++)i=this._findMatchesInLine(m,l.getLineContent(w),w,0,i,s,t,r);if(i<r){const w=l.getLineContent(f.endLineNumber).substring(0,f.endColumn-1);i=this._findMatchesInLine(m,w,f.endLineNumber,0,i,s,t,r)}return s}static _findMatchesInLine(l,f,m,t,r,s,i,u){const w=l.wordSeparators;if(!i&&l.simpleSearch){const A=l.simpleSearch,a=A.length,R=f.length;let L=-a;for(;(L=f.indexOf(A,L+a))!==-1;)if((!w||y(w,f,R,L,a))&&(s[r++]=new k.FindMatch(new E.Range(m,L+1+t,m,L+1+a+t),null),r>=u))return r;return r}const v=new b(l.wordSeparators,l.regex);let P;v.reset(0);do if(P=v.next(f),P&&(s[r++]=I(new E.Range(m,P.index+1+t,m,P.index+1+P[0].length+t),P,i),r>=u))return r;while(P);return r}static findNextMatch(l,f,m,t){const r=f.parseSearchRequest();if(!r)return null;const s=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindNextMatchMultiline(l,m,s,t):this._doFindNextMatchLineByLine(l,m,s,t)}static _doFindNextMatchMultiline(l,f,m,t){const r=new S.Position(f.lineNumber,1),s=l.getOffsetAt(r),i=l.getLineCount(),u=l.getValueInRange(new E.Range(r.lineNumber,r.column,i,l.getLineMaxColumn(i)),1),w=l.getEOL()===`\r
`?new o(u):null;m.reset(f.column-1);let v=m.next(u);return v?I(this._getMultilineMatchRange(l,s,u,w,v.index,v[0]),v,t):f.lineNumber!==1||f.column!==1?this._doFindNextMatchMultiline(l,new S.Position(1,1),m,t):null}static _doFindNextMatchLineByLine(l,f,m,t){const r=l.getLineCount(),s=f.lineNumber,i=l.getLineContent(s),u=this._findFirstMatchInLine(m,i,s,f.column,t);if(u)return u;for(let w=1;w<=r;w++){const v=(s+w-1)%r,P=l.getLineContent(v+1),A=this._findFirstMatchInLine(m,P,v+1,1,t);if(A)return A}return null}static _findFirstMatchInLine(l,f,m,t,r){l.reset(t-1);const s=l.next(f);return s?I(new E.Range(m,s.index+1,m,s.index+1+s[0].length),s,r):null}static findPreviousMatch(l,f,m,t){const r=f.parseSearchRequest();if(!r)return null;const s=new b(r.wordSeparators,r.regex);return r.regex.multiline?this._doFindPreviousMatchMultiline(l,m,s,t):this._doFindPreviousMatchLineByLine(l,m,s,t)}static _doFindPreviousMatchMultiline(l,f,m,t){const r=this._doFindMatchesMultiline(l,new E.Range(1,1,f.lineNumber,f.column),m,t,10*D);if(r.length>0)return r[r.length-1];const s=l.getLineCount();return f.lineNumber!==s||f.column!==l.getLineMaxColumn(s)?this._doFindPreviousMatchMultiline(l,new S.Position(s,l.getLineMaxColumn(s)),m,t):null}static _doFindPreviousMatchLineByLine(l,f,m,t){const r=l.getLineCount(),s=f.lineNumber,i=l.getLineContent(s).substring(0,f.column-1),u=this._findLastMatchInLine(m,i,s,t);if(u)return u;for(let w=1;w<=r;w++){const v=(r+s-w-1)%r,P=l.getLineContent(v+1),A=this._findLastMatchInLine(m,P,v+1,t);if(A)return A}return null}static _findLastMatchInLine(l,f,m,t){let r=null,s;for(l.reset(0);s=l.next(f);)r=I(new E.Range(m,s.index+1,m,s.index+1+s[0].length),s,t);return r}}e.TextModelSearch=h;function c(p,l,f,m,t){if(m===0)return!0;const r=l.charCodeAt(m-1);if(p.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=l.charCodeAt(m);if(p.get(s)!==0)return!0}return!1}function d(p,l,f,m,t){if(m+t===f)return!0;const r=l.charCodeAt(m+t);if(p.get(r)!==0||r===13||r===10)return!0;if(t>0){const s=l.charCodeAt(m+t-1);if(p.get(s)!==0)return!0}return!1}function y(p,l,f,m,t){return c(p,l,f,m,t)&&d(p,l,f,m,t)}e.isValidMatch=y;class b{constructor(l,f){this._wordSeparators=l,this._searchRegex=f,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(l){this._searchRegex.lastIndex=l,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(l){const f=l.length;let m;do{if(this._prevMatchStartIndex+this._prevMatchLength===f||(m=this._searchRegex.exec(l),!m))return null;const t=m.index,r=m[0].length;if(t===this._prevMatchStartIndex&&r===this._prevMatchLength){if(r===0){g.getNextCodePoint(l,f,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=t,this._prevMatchLength=r,!this._wordSeparators||y(this._wordSeparators,l,f,t,r))return m}while(m);return null}}e.Searcher=b}),define(we[85],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function g(D=""){let _="(-?\\d*\\.\\d\\w*)|([^";for(const C of e.USUAL_WORD_SEPARATORS)D.indexOf(C)>=0||(_+="\\"+C);return _+="\\s]+)",new RegExp(_,"g")}e.DEFAULT_WORD_REGEXP=g();function T(D){let _=e.DEFAULT_WORD_REGEXP;if(D&&D instanceof RegExp)if(D.global)_=D;else{let C="g";D.ignoreCase&&(C+="i"),D.multiline&&(C+="m"),D.unicode&&(C+="u"),_=new RegExp(D.source,C)}return _.lastIndex=0,_}e.ensureValidWordDefinition=T;const S={maxLen:1e3,windowSize:15,timeBudget:150};function E(D,_,C,n,I=S){if(C.length>I.maxLen){let y=D-I.maxLen/2;return y<0?y=0:n+=y,C=C.substring(y,D+I.maxLen/2),E(D,_,C,n,I)}const o=Date.now(),h=D-1-n;let c=-1,d=null;for(let y=1;!(Date.now()-o>=I.timeBudget);y++){const b=h-I.windowSize*y;_.lastIndex=Math.max(0,b);const p=k(_,C,h,c);if(!p&&d||(d=p,b<=0))break;c=b}if(d){let y={word:d[0],startColumn:n+1+d.index,endColumn:n+1+d.index+d[0].length};return _.lastIndex=0,y}return null}e.getWordAtText=E;function k(D,_,C,n){let I;for(;I=D.exec(_);){const o=I.index||0;if(o<=C&&D.lastIndex>=C)return I;if(n>0&&o>n)return null}return null}}),define(we[117],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var g;(function(k){k[k.None=0]="None",k[k.Indent=1]="Indent",k[k.IndentOutdent=2]="IndentOutdent",k[k.Outdent=3]="Outdent"})(g=e.IndentAction||(e.IndentAction={}));class T{constructor(D){if(this.open=D.open,this.close=D.close,this._standardTokenMask=0,Array.isArray(D.notIn))for(let _=0,C=D.notIn.length;_<C;_++)switch(D.notIn[_]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(D){return(this._standardTokenMask&D)==0}}e.StandardAutoClosingPairConditional=T;class S{constructor(D){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const _ of D)E(this.autoClosingPairsOpenByStart,_.open.charAt(0),_),E(this.autoClosingPairsOpenByEnd,_.open.charAt(_.open.length-1),_),E(this.autoClosingPairsCloseByStart,_.close.charAt(0),_),E(this.autoClosingPairsCloseByEnd,_.close.charAt(_.close.length-1),_),_.close.length===1&&_.open.length===1&&E(this.autoClosingPairsCloseSingleChar,_.close,_)}}e.AutoClosingPairs=S;function E(k,D,_){k.has(D)?k.get(D).push(_):k.set(D,[_])}}),define(we[55],_e([0,1,27,14]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function S(E,k,D,_){if(Array.isArray(E)){let C=0;for(const n of E){const I=S(n,k,D,_);if(I===10)return I;I>C&&(C=I)}return C}else{if(typeof E=="string")return _?E==="*"?5:E===D?10:0:0;if(E){const{language:C,pattern:n,scheme:I,hasAccessToAllModels:o}=E;if(!_&&!o)return 0;let h=0;if(I)if(I===k.scheme)h=10;else if(I==="*")h=5;else return 0;if(C)if(C===D)h=10;else if(C==="*")h=Math.max(h,5);else return 0;if(n){let c;if(typeof n=="string"?c=n:c=Object.assign(Object.assign({},n),{base:T.normalize(n.base)}),c===k.fsPath||g.match(c,k.fsPath))h=10;else return 0}return h}else return 0}}e.score=S}),define(we[118],_e([0,1,83]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.Uint8Matrix=e.State=void 0;var T;(function(h){h[h.Invalid=0]="Invalid",h[h.Start=1]="Start",h[h.H=2]="H",h[h.HT=3]="HT",h[h.HTT=4]="HTT",h[h.HTTP=5]="HTTP",h[h.F=6]="F",h[h.FI=7]="FI",h[h.FIL=8]="FIL",h[h.BeforeColon=9]="BeforeColon",h[h.AfterColon=10]="AfterColon",h[h.AlmostThere=11]="AlmostThere",h[h.End=12]="End",h[h.Accept=13]="Accept",h[h.LastKnownState=14]="LastKnownState"})(T=e.State||(e.State={}));class S{constructor(c,d,y){const b=new Uint8Array(c*d);for(let p=0,l=c*d;p<l;p++)b[p]=y;this._data=b,this.rows=c,this.cols=d}get(c,d){return this._data[c*this.cols+d]}set(c,d,y){this._data[c*this.cols+d]=y}}e.Uint8Matrix=S;class E{constructor(c){let d=0,y=0;for(let p=0,l=c.length;p<l;p++){let[f,m,t]=c[p];m>d&&(d=m),f>y&&(y=f),t>y&&(y=t)}d++,y++;let b=new S(y,d,0);for(let p=0,l=c.length;p<l;p++){let[f,m,t]=c[p];b.set(f,m,t)}this._states=b,this._maxCharCode=d}nextState(c,d){return d<0||d>=this._maxCharCode?0:this._states.get(c,d)}}e.StateMachine=E;let k=null;function D(){return k===null&&(k=new E([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),k}var _;(function(h){h[h.None=0]="None",h[h.ForceTermination=1]="ForceTermination",h[h.CannotEndIn=2]="CannotEndIn"})(_||(_={}));let C=null;function n(){if(C===null){C=new g.CharacterClassifier(0);const h=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let d=0;d<h.length;d++)C.set(h.charCodeAt(d),1);const c=".,;";for(let d=0;d<c.length;d++)C.set(c.charCodeAt(d),2)}return C}class I{static _createLink(c,d,y,b,p){let l=p-1;do{const f=d.charCodeAt(l);if(c.get(f)!==2)break;l--}while(l>b);if(b>0){const f=d.charCodeAt(b-1),m=d.charCodeAt(l);(f===40&&m===41||f===91&&m===93||f===123&&m===125)&&l--}return{range:{startLineNumber:y,startColumn:b+1,endLineNumber:y,endColumn:l+2},url:d.substring(b,l+1)}}static computeLinks(c,d=D()){const y=n();let b=[];for(let p=1,l=c.getLineCount();p<=l;p++){const f=c.getLineContent(p),m=f.length;let t=0,r=0,s=0,i=1,u=!1,w=!1,v=!1,P=!1;for(;t<m;){let A=!1;const a=f.charCodeAt(t);if(i===13){let R;switch(a){case 40:u=!0,R=0;break;case 41:R=u?0:1;break;case 91:v=!0,w=!0,R=0;break;case 93:v=!1,R=w?0:1;break;case 123:P=!0,R=0;break;case 125:R=P?0:1;break;case 39:R=s===34||s===96?0:1;break;case 34:R=s===39||s===96?0:1;break;case 96:R=s===39||s===34?0:1;break;case 42:R=s===42?1:0;break;case 124:R=s===124?1:0;break;case 32:R=v?0:1;break;default:R=y.get(a)}R===1&&(b.push(I._createLink(y,f,p,r,t)),A=!0)}else if(i===12){let R;a===91?(w=!0,R=0):R=y.get(a),R===1?A=!0:i=13}else i=d.nextState(i,a),i===0&&(A=!0);A&&(i=1,u=!1,w=!1,P=!1,r=t+1,s=a),t++}i===13&&b.push(I._createLink(y,f,p,r,m))}return b}}e.LinkComputer=I;function o(h){return!h||typeof h.getLineCount!="function"||typeof h.getLineContent!="function"?[]:I.computeLinks(h)}e.computeLinks=o}),define(we[119],_e([0,1,3,7]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class S{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new g.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(k){this._onDidChange.fire({changedLanguages:k,changedColorMap:!1})}register(k,D){return this._map.set(k,D),this.fire([k]),T.toDisposable(()=>{this._map.get(k)===D&&(this._map.delete(k),this.fire([k]))})}registerPromise(k,D){let _=null,C=!1;return this._promises.set(k,D.then(n=>{this._promises.delete(k),!(C||!n)&&(_=this.register(k,n))})),T.toDisposable(()=>{C=!0,_&&_.dispose()})}getPromise(k){const D=this.get(k);if(D)return Promise.resolve(D);const _=this._promises.get(k);return _?_.then(C=>this.get(k)):null}get(k){return this._map.get(k)||null}setColorMap(k){this._colorMap=k,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=S}),define(we[86],_e([0,1,23,21]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var S;(function(I){I[I.Full=1]="Full",I[I.Delta=2]="Delta"})(S||(S={}));function E(I){for(let o=0,h=I.length;o<h;o+=4){const c=I[o+0],d=I[o+1],y=I[o+2],b=I[o+3];I[o+0]=b,I[o+1]=y,I[o+2]=d,I[o+3]=c}}function k(I){const o=new Uint8Array(I.buffer,I.byteOffset,I.length*4);return T.isLittleEndian()||E(o),g.VSBuffer.wrap(o)}function D(I){const o=I.buffer;if(T.isLittleEndian()||E(o),o.byteOffset%4==0)return new Uint32Array(o.buffer,o.byteOffset,o.length/4);{const h=new Uint8Array(o.byteLength);return h.set(o),new Uint32Array(h.buffer,h.byteOffset,h.length/4)}}function _(I){const o=new Uint32Array(C(I));let h=0;if(o[h++]=I.id,I.type==="full")o[h++]=1,o[h++]=I.data.length,o.set(I.data,h),h+=I.data.length;else{o[h++]=2,o[h++]=I.deltas.length;for(const c of I.deltas)o[h++]=c.start,o[h++]=c.deleteCount,c.data?(o[h++]=c.data.length,o.set(c.data,h),h+=c.data.length):o[h++]=0}return k(o)}e.encodeSemanticTokensDto=_;function C(I){let o=0;if(o+=1+1,I.type==="full")o+=1+I.data.length;else{o+=1,o+=(1+1+1)*I.deltas.length;for(const h of I.deltas)h.data&&(o+=h.data.length)}return o}function n(I){const o=D(I);let h=0;const c=o[h++];if(o[h++]===1){const p=o[h++],l=o.subarray(h,h+p);return h+=p,{id:c,type:"full",data:l}}const y=o[h++];let b=[];for(let p=0;p<y;p++){const l=o[h++],f=o[h++],m=o[h++];let t;m>0&&(t=o.subarray(h,h+m),h+=m),b[p]={start:l,deleteCount:f,data:t}}return{id:c,type:"delta",deltas:b}}e.decodeSemanticTokensDto=n}),define(we[87],_e([0,1,79]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumComputer=e.PrefixSumIndexOfResult=void 0;class T{constructor(k,D){this.index=k,this.remainder=D}}e.PrefixSumIndexOfResult=T;class S{constructor(k){this.values=k,this.prefixSum=new Uint32Array(k.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){return this.values.length}insertValues(k,D){k=g.toUint32(k);const _=this.values,C=this.prefixSum,n=D.length;return n===0?!1:(this.values=new Uint32Array(_.length+n),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k),k+n),this.values.set(D,k),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(k,D){return k=g.toUint32(k),D=g.toUint32(D),this.values[k]===D?!1:(this.values[k]=D,k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),!0)}removeValues(k,D){k=g.toUint32(k),D=g.toUint32(D);const _=this.values,C=this.prefixSum;if(k>=_.length)return!1;let n=_.length-k;return D>=n&&(D=n),D===0?!1:(this.values=new Uint32Array(_.length-D),this.values.set(_.subarray(0,k),0),this.values.set(_.subarray(k+D),k),this.prefixSum=new Uint32Array(this.values.length),k-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=k-1),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(C.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalSum(){return this.values.length===0?0:this._getPrefixSum(this.values.length-1)}getPrefixSum(k){return k<0?0:(k=g.toUint32(k),this._getPrefixSum(k))}_getPrefixSum(k){if(k<=this.prefixSumValidIndex[0])return this.prefixSum[k];let D=this.prefixSumValidIndex[0]+1;D===0&&(this.prefixSum[0]=this.values[0],D++),k>=this.values.length&&(k=this.values.length-1);for(let _=D;_<=k;_++)this.prefixSum[_]=this.prefixSum[_-1]+this.values[_];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],k),this.prefixSum[k]}getIndexOf(k){k=Math.floor(k),this.getTotalSum();let D=0,_=this.values.length-1,C=0,n=0,I=0;for(;D<=_;)if(C=D+(_-D)/2|0,n=this.prefixSum[C],I=n-this.values[C],k<I)_=C-1;else if(k>=n)D=C+1;else break;return new T(C,k-I)}}e.PrefixSumComputer=S}),define(we[120],_e([0,1,8,35,87]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class E{constructor(D,_,C,n){this._uri=D,this._lines=_,this._eol=C,this._versionId=n,this._lineStarts=null,this._cachedTextValue=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._cachedTextValue===null&&(this._cachedTextValue=this._lines.join(this._eol)),this._cachedTextValue}onEvents(D){D.eol&&D.eol!==this._eol&&(this._eol=D.eol,this._lineStarts=null);const _=D.changes;for(const C of _)this._acceptDeleteRange(C.range),this._acceptInsertText(new T.Position(C.range.startLineNumber,C.range.startColumn),C.text);this._versionId=D.versionId,this._cachedTextValue=null}_ensureLineStarts(){if(!this._lineStarts){const D=this._eol.length,_=this._lines.length,C=new Uint32Array(_);for(let n=0;n<_;n++)C[n]=this._lines[n].length+D;this._lineStarts=new S.PrefixSumComputer(C)}}_setLineText(D,_){this._lines[D]=_,this._lineStarts&&this._lineStarts.changeValue(D,this._lines[D].length+this._eol.length)}_acceptDeleteRange(D){if(D.startLineNumber===D.endLineNumber){if(D.startColumn===D.endColumn)return;this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.startLineNumber-1].substring(D.endColumn-1));return}this._setLineText(D.startLineNumber-1,this._lines[D.startLineNumber-1].substring(0,D.startColumn-1)+this._lines[D.endLineNumber-1].substring(D.endColumn-1)),this._lines.splice(D.startLineNumber,D.endLineNumber-D.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(D.startLineNumber,D.endLineNumber-D.startLineNumber)}_acceptInsertText(D,_){if(_.length===0)return;let C=g.splitLines(_);if(C.length===1){this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]+this._lines[D.lineNumber-1].substring(D.column-1));return}C[C.length-1]+=this._lines[D.lineNumber-1].substring(D.column-1),this._setLineText(D.lineNumber-1,this._lines[D.lineNumber-1].substring(0,D.column-1)+C[0]);let n=new Uint32Array(C.length-1);for(let I=1;I<C.length;I++)this._lines.splice(D.lineNumber+I-1,0,C[I]),n[I-1]=C[I].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(D.lineNumber,n)}}e.MirrorTextModel=E}),define(we[121],_e([19,20]),function(ee,e){return ee.create("vs/base/common/errorMessage",e)}),define(we[56],_e([0,1,121,10,17]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function E(C,n){return n&&(C.stack||C.stacktrace)?g.localize(0,null,D(C),k(C.stack)||k(C.stacktrace)):D(C)}function k(C){return Array.isArray(C)?C.join(`
`):C}function D(C){return typeof C.code=="string"&&typeof C.errno=="number"&&typeof C.syscall=="string"?g.localize(1,null,C.message):C.message||g.localize(2,null)}function _(C=null,n=!1){if(!C)return g.localize(3,null);if(Array.isArray(C)){const I=S.coalesce(C),o=_(I[0],n);return I.length>1?g.localize(4,null,o,I.length):o}if(T.isString(C))return C;if(C.detail){const I=C.detail;if(I.error)return E(I.error,n);if(I.exception)return E(I.exception,n)}return C.stack?E(C,n):C.message?C.message:g.localize(5,null)}e.toErrorMessage=_}),define(we[122],_e([19,20]),function(ee,e){return ee.create("vs/editor/common/config/editorOptions",e)}),define(we[123],_e([0,1,122,21,85]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(j){j[j.None=0]="None",j[j.Keep=1]="Keep",j[j.Brackets=2]="Brackets",j[j.Advanced=3]="Advanced",j[j.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(ne){this._values=ne}hasChanged(ne){return this._values[ne]}}e.ConfigurationChangedEvent=k;class D{constructor(){this._values=[]}_read(ne){return this._values[ne]}get(ne){return this._values[ne]}_write(ne,ge){this._values[ne]=ge}}e.ValidatedEditorOptions=D;class _{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=_;class C{constructor(ne,ge,Fe,Ne){this.id=ne,this.name=ge,this.defaultValue=Fe,this.schema=Ne}compute(ne,ge,Fe){return Fe}}class n{constructor(ne,ge=null){this.schema=void 0,this.id=ne,this.name="_never_",this.defaultValue=void 0,this.deps=ge}validate(ne){return this.defaultValue}}class I{constructor(ne,ge,Fe,Ne){this.id=ne,this.name=ge,this.defaultValue=Fe,this.schema=Ne}validate(ne){return typeof ne=="undefined"?this.defaultValue:ne}compute(ne,ge,Fe){return Fe}}function o(j,ne){return typeof j=="undefined"?ne:j==="false"?!1:Boolean(j)}e.boolean=o;class h extends I{constructor(ne,ge,Fe,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="boolean",Ne.default=Fe),super(ne,ge,Fe,Ne)}validate(ne){return o(ne,this.defaultValue)}}class c extends I{constructor(ne,ge,Fe,Ne,Qe,Ee=void 0){typeof Ee!="undefined"&&(Ee.type="integer",Ee.default=Fe,Ee.minimum=Ne,Ee.maximum=Qe),super(ne,ge,Fe,Ee),this.minimum=Ne,this.maximum=Qe}static clampedInt(ne,ge,Fe,Ne){if(typeof ne=="undefined")return ge;let Qe=parseInt(ne,10);return isNaN(Qe)?ge:(Qe=Math.max(Fe,Qe),Qe=Math.min(Ne,Qe),Qe|0)}validate(ne){return c.clampedInt(ne,this.defaultValue,this.minimum,this.maximum)}}class d extends I{constructor(ne,ge,Fe,Ne,Qe){typeof Qe!="undefined"&&(Qe.type="number",Qe.default=Fe),super(ne,ge,Fe,Qe),this.validationFn=Ne}static clamp(ne,ge,Fe){return ne<ge?ge:ne>Fe?Fe:ne}static float(ne,ge){if(typeof ne=="number")return ne;if(typeof ne=="undefined")return ge;const Fe=parseFloat(ne);return isNaN(Fe)?ge:Fe}validate(ne){return this.validationFn(d.float(ne,this.defaultValue))}}class y extends I{static string(ne,ge){return typeof ne!="string"?ge:ne}constructor(ne,ge,Fe,Ne=void 0){typeof Ne!="undefined"&&(Ne.type="string",Ne.default=Fe),super(ne,ge,Fe,Ne)}validate(ne){return y.string(ne,this.defaultValue)}}function b(j,ne,ge){return typeof j!="string"||ge.indexOf(j)===-1?ne:j}e.stringSet=b;class p extends I{constructor(ne,ge,Fe,Ne,Qe=void 0){typeof Qe!="undefined"&&(Qe.type="string",Qe.enum=Ne,Qe.default=Fe),super(ne,ge,Fe,Qe),this._allowedValues=Ne}validate(ne){return b(ne,this.defaultValue,this._allowedValues)}}class l extends C{constructor(ne,ge,Fe,Ne,Qe,Ee,be=void 0){typeof be!="undefined"&&(be.type="string",be.enum=Qe,be.default=Ne),super(ne,ge,Fe,be),this._allowedValues=Qe,this._convert=Ee}validate(ne){return typeof ne!="string"?this.defaultValue:this._allowedValues.indexOf(ne)===-1?this.defaultValue:this._convert(ne)}}function f(j){switch(j){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class m extends C{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[g.localize(0,null),g.localize(1,null),g.localize(2,null)],default:"auto",description:g.localize(3,null)})}validate(ne){switch(ne){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(ne,ge,Fe){return Fe===0?ne.accessibilitySupport:Fe}}class t extends C{constructor(){const ne={insertSpace:!0,ignoreEmptyLines:!0};super(17,"comments",ne,{"editor.comments.insertSpace":{type:"boolean",default:ne.insertSpace,description:g.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:ne.ignoreEmptyLines,description:g.localize(5,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{insertSpace:o(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var r;(function(j){j[j.Hidden=0]="Hidden",j[j.Blink=1]="Blink",j[j.Smooth=2]="Smooth",j[j.Phase=3]="Phase",j[j.Expand=4]="Expand",j[j.Solid=5]="Solid"})(r=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function s(j){switch(j){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var i;(function(j){j[j.Line=1]="Line",j[j.Block=2]="Block",j[j.Underline=3]="Underline",j[j.LineThin=4]="LineThin",j[j.BlockOutline=5]="BlockOutline",j[j.UnderlineThin=6]="UnderlineThin"})(i=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function u(j){switch(j){case i.Line:return"line";case i.Block:return"block";case i.Underline:return"underline";case i.LineThin:return"line-thin";case i.BlockOutline:return"block-outline";case i.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=u;function w(j){switch(j){case"line":return i.Line;case"block":return i.Block;case"underline":return i.Underline;case"line-thin":return i.LineThin;case"block-outline":return i.BlockOutline;case"underline-thin":return i.UnderlineThin}}class v extends n{constructor(){super(125,[63,31])}compute(ne,ge,Fe){const Ne=["monaco-editor"];return ge.get(31)&&Ne.push(ge.get(31)),ne.extraEditorClassName&&Ne.push(ne.extraEditorClassName),ge.get(63)==="default"?Ne.push("mouse-default"):ge.get(63)==="copy"&&Ne.push("mouse-copy"),ge.get(98)&&Ne.push("showUnused"),ge.get(123)&&Ne.push("showDeprecated"),Ne.join(" ")}}class P extends h{constructor(){super(30,"emptySelectionClipboard",!0,{description:g.localize(6,null)})}compute(ne,ge,Fe){return Fe&&ne.emptySelectionClipboard}}class A extends C{constructor(){const ne={cursorMoveOnType:!0,seedSearchStringFromSelection:!0,autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(33,"find",ne,{"editor.find.cursorMoveOnType":{type:"boolean",default:ne.cursorMoveOnType,description:g.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"boolean",default:ne.seedSearchStringFromSelection,description:g.localize(8,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:ne.autoFindInSelection,enumDescriptions:[g.localize(9,null),g.localize(10,null),g.localize(11,null)],description:g.localize(12,null)},"editor.find.globalFindClipboard":{type:"boolean",default:ne.globalFindClipboard,description:g.localize(13,null),included:T.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:ne.addExtraSpaceOnTop,description:g.localize(14,null)},"editor.find.loop":{type:"boolean",default:ne.loop,description:g.localize(15,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{cursorMoveOnType:o(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:o(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),autoFindInSelection:typeof ne.autoFindInSelection=="boolean"?ne.autoFindInSelection?"always":"never":b(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o(ge.loop,this.defaultValue.loop)}}}class a extends C{constructor(){super(41,"fontLigatures",a.OFF,{anyOf:[{type:"boolean",description:g.localize(16,null)},{type:"string",description:g.localize(17,null)}],description:g.localize(18,null),default:!1})}validate(ne){return typeof ne=="undefined"?this.defaultValue:typeof ne=="string"?ne==="false"?a.OFF:ne==="true"?a.ON:ne:Boolean(ne)?a.ON:a.OFF}}e.EditorFontLigatures=a,a.OFF='"liga" off, "calt" off',a.ON='"liga" on, "calt" on';class R extends n{constructor(){super(40)}compute(ne,ge,Fe){return ne.fontInfo}}class L extends I{constructor(){super(42,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:g.localize(19,null)})}validate(ne){let ge=d.float(ne,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:d.clamp(ge,6,100)}compute(ne,ge,Fe){return ne.fontInfo.fontSize}}class H extends C{constructor(){super(43,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:H.MINIMUM_VALUE,maximum:H.MAXIMUM_VALUE,errorMessage:g.localize(20,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:H.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:g.localize(21,null)})}validate(ne){return ne==="normal"||ne==="bold"?ne:String(c.clampedInt(ne,e.EDITOR_FONT_DEFAULTS.fontWeight,H.MINIMUM_VALUE,H.MAXIMUM_VALUE))}}H.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],H.MINIMUM_VALUE=1,H.MAXIMUM_VALUE=1e3;class ue extends C{constructor(){const ne={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:ne.multiple,enumDescriptions:[g.localize(22,null),g.localize(23,null),g.localize(24,null)]},Fe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(47,"gotoLocation",ne,{"editor.gotoLocation.multiple":{deprecationMessage:g.localize(25,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:g.localize(26,null)},ge),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:g.localize(27,null)},ge),"editor.gotoLocation.multipleDeclarations":Object.assign({description:g.localize(28,null)},ge),"editor.gotoLocation.multipleImplementations":Object.assign({description:g.localize(29,null)},ge),"editor.gotoLocation.multipleReferences":Object.assign({description:g.localize(30,null)},ge),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:ne.alternativeDefinitionCommand,enum:Fe,description:g.localize(31,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:ne.alternativeTypeDefinitionCommand,enum:Fe,description:g.localize(32,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:ne.alternativeDeclarationCommand,enum:Fe,description:g.localize(33,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:ne.alternativeImplementationCommand,enum:Fe,description:g.localize(34,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:ne.alternativeReferenceCommand,enum:Fe,description:g.localize(35,null)}})}validate(ne){var ge,Fe,Ne,Qe,Ee;if(!ne||typeof ne!="object")return this.defaultValue;const be=ne;return{multiple:b(be.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:(ge=be.multipleDefinitions)!==null&&ge!==void 0?ge:b(be.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:(Fe=be.multipleTypeDefinitions)!==null&&Fe!==void 0?Fe:b(be.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:(Ne=be.multipleDeclarations)!==null&&Ne!==void 0?Ne:b(be.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:(Qe=be.multipleImplementations)!==null&&Qe!==void 0?Qe:b(be.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:(Ee=be.multipleReferences)!==null&&Ee!==void 0?Ee:b(be.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:y.string(be.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:y.string(be.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:y.string(be.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:y.string(be.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:y.string(be.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class me extends C{constructor(){const ne={enabled:!0,delay:300,sticky:!0};super(50,"hover",ne,{"editor.hover.enabled":{type:"boolean",default:ne.enabled,description:g.localize(36,null)},"editor.hover.delay":{type:"number",default:ne.delay,description:g.localize(37,null)},"editor.hover.sticky":{type:"boolean",default:ne.sticky,description:g.localize(38,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{enabled:o(ge.enabled,this.defaultValue.enabled),delay:c.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:o(ge.sticky,this.defaultValue.sticky)}}}var J;(function(j){j[j.None=0]="None",j[j.Text=1]="Text",j[j.Blocks=2]="Blocks"})(J=e.RenderMinimap||(e.RenderMinimap={}));class z extends n{constructor(){super(128,[46,55,35,62,90,57,58,92,115,118,119,120,2])}compute(ne,ge,Fe){return z.computeLayout(ge,{memory:ne.memory,outerWidth:ne.outerWidth,outerHeight:ne.outerHeight,isDominatedByLongLines:ne.isDominatedByLongLines,lineHeight:ne.fontInfo.lineHeight,viewLineCount:ne.viewLineCount,lineNumbersDigitCount:ne.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:ne.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:ne.fontInfo.maxDigitWidth,pixelRatio:ne.pixelRatio})}static computeContainedMinimapLineCount(ne){const ge=ne.height/ne.lineHeight,Fe=ne.scrollBeyondLastLine?ge-1:0,Ne=(ne.viewLineCount+Fe)/(ne.pixelRatio*ne.height),Qe=Math.floor(ne.viewLineCount/Ne);return{typicalViewportLineCount:ge,extraLinesBeyondLastLine:Fe,desiredRatio:Ne,minimapLineCount:Qe}}static _computeMinimapLayout(ne,ge){const Fe=ne.outerWidth,Ne=ne.outerHeight,Qe=ne.pixelRatio;if(!ne.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const Ee=ge.stableMinimapLayoutInput,be=Ee&&ne.outerHeight===Ee.outerHeight&&ne.lineHeight===Ee.lineHeight&&ne.typicalHalfwidthCharacterWidth===Ee.typicalHalfwidthCharacterWidth&&ne.pixelRatio===Ee.pixelRatio&&ne.scrollBeyondLastLine===Ee.scrollBeyondLastLine&&ne.minimap.enabled===Ee.minimap.enabled&&ne.minimap.side===Ee.minimap.side&&ne.minimap.size===Ee.minimap.size&&ne.minimap.showSlider===Ee.minimap.showSlider&&ne.minimap.renderCharacters===Ee.minimap.renderCharacters&&ne.minimap.maxColumn===Ee.minimap.maxColumn&&ne.minimap.scale===Ee.minimap.scale&&ne.verticalScrollbarWidth===Ee.verticalScrollbarWidth&&ne.isViewportWrapping===Ee.isViewportWrapping,Ce=ne.lineHeight,se=ne.typicalHalfwidthCharacterWidth,de=ne.scrollBeyondLastLine,U=ne.minimap.renderCharacters;let Q=Qe>=2?Math.round(ne.minimap.scale*2):ne.minimap.scale;const le=ne.minimap.maxColumn,ke=ne.minimap.size,Pe=ne.minimap.side,Ue=ne.verticalScrollbarWidth,We=ne.viewLineCount,Ze=ne.remainingWidth,rt=ne.isViewportWrapping,Ke=U?2:3;let Je=Math.floor(Qe*Ne);const ft=Je/Qe;let ve=!1,ye=!1,ae=Ke*Q,V=Q/Qe,xe=1;if(ke==="fill"||ke==="fit"){const{typicalViewportLineCount:gt,extraLinesBeyondLastLine:pt,desiredRatio:wt,minimapLineCount:Tt}=z.computeContainedMinimapLineCount({viewLineCount:We,scrollBeyondLastLine:de,height:Ne,lineHeight:Ce,pixelRatio:Qe});if(We/Tt>1)ve=!0,ye=!0,Q=1,ae=1,V=Q/Qe;else{let Et=!1,ut=Q+1;if(ke==="fit"){const mt=Math.ceil((We+pt)*ae);rt&&be&&Ze<=ge.stableFitRemainingWidth?(Et=!0,ut=ge.stableFitMaxMinimapScale):Et=mt>Je}if(ke==="fill"||Et){ve=!0;const mt=Q;ae=Math.min(Ce*Qe,Math.max(1,Math.floor(1/wt))),rt&&be&&Ze<=ge.stableFitRemainingWidth&&(ut=ge.stableFitMaxMinimapScale),Q=Math.min(ut,Math.max(1,Math.floor(ae/Ke))),Q>mt&&(xe=Math.min(2,Q/mt)),V=Q/Qe/xe,Je=Math.ceil(Math.max(gt,We+pt)*ae),rt?(ge.stableMinimapLayoutInput=ne,ge.stableFitRemainingWidth=Ze,ge.stableFitMaxMinimapScale=Q):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const Te=Math.floor(le*V),Re=Math.min(Te,Math.max(0,Math.floor((Ze-Ue-2)*V/(se+V)))+e.MINIMAP_GUTTER_WIDTH);let nt=Math.floor(Qe*Re);const ot=nt/Qe;nt=Math.floor(nt*xe);const tt=U?1:2,vt=Pe==="left"?0:Fe-Re-Ue;return{renderMinimap:tt,minimapLeft:vt,minimapWidth:Re,minimapHeightIsEditorHeight:ve,minimapIsSampling:ye,minimapScale:Q,minimapLineHeight:ae,minimapCanvasInnerWidth:nt,minimapCanvasInnerHeight:Je,minimapCanvasOuterWidth:ot,minimapCanvasOuterHeight:ft}}static computeLayout(ne,ge){const Fe=ge.outerWidth|0,Ne=ge.outerHeight|0,Qe=ge.lineHeight|0,Ee=ge.lineNumbersDigitCount|0,be=ge.typicalHalfwidthCharacterWidth,Ce=ge.maxDigitWidth,se=ge.pixelRatio,de=ge.viewLineCount,U=ne.get(120),Q=U==="inherit"?ne.get(119):U,le=Q==="inherit"?ne.get(115):Q,ke=ne.get(118),Pe=ne.get(2),Ue=ge.isDominatedByLongLines,We=ne.get(46),Ze=ne.get(57).renderType!==0,rt=ne.get(58),Ke=ne.get(92),Je=ne.get(62),ft=ne.get(90),ve=ft.verticalScrollbarSize,ye=ft.verticalHasArrows,ae=ft.arrowSize,V=ft.horizontalScrollbarSize,xe=ne.get(55),Te=ne.get(35);let Re;if(typeof xe=="string"&&/^\d+(\.\d+)?ch$/.test(xe)){const yt=parseFloat(xe.substr(0,xe.length-2));Re=c.clampedInt(yt*be,0,0,1e3)}else Re=c.clampedInt(xe,0,0,1e3);Te&&(Re+=16);let nt=0;if(Ze){const yt=Math.max(Ee,rt);nt=Math.round(yt*Ce)}let ot=0;We&&(ot=Qe);let tt=0,vt=tt+ot,gt=vt+nt,pt=gt+Re;const wt=Fe-ot-nt-Re;let Tt=!1,Pt=!1,Et=-1;Pe!==2&&(Q==="inherit"&&Ue?(Tt=!0,Pt=!0):le==="on"||le==="bounded"?Pt=!0:le==="wordWrapColumn"&&(Et=ke));const ut=z._computeMinimapLayout({outerWidth:Fe,outerHeight:Ne,lineHeight:Qe,typicalHalfwidthCharacterWidth:be,pixelRatio:se,scrollBeyondLastLine:Ke,minimap:Je,verticalScrollbarWidth:ve,viewLineCount:de,remainingWidth:wt,isViewportWrapping:Pt},ge.memory||new _);ut.renderMinimap!==0&&ut.minimapLeft===0&&(tt+=ut.minimapWidth,vt+=ut.minimapWidth,gt+=ut.minimapWidth,pt+=ut.minimapWidth);const mt=wt-ut.minimapWidth,_t=Math.max(1,Math.floor((mt-ve-2)/be)),Ft=ye?ae:0;return Pt&&(Et=Math.max(1,_t),le==="bounded"&&(Et=Math.min(Et,ke))),{width:Fe,height:Ne,glyphMarginLeft:tt,glyphMarginWidth:ot,lineNumbersLeft:vt,lineNumbersWidth:nt,decorationsLeft:gt,decorationsWidth:Re,contentLeft:pt,contentWidth:mt,minimap:ut,viewportColumn:_t,isWordWrapMinified:Tt,isViewportWrapping:Pt,wrappingColumn:Et,verticalScrollbarWidth:ve,horizontalScrollbarHeight:V,overviewRuler:{top:Ft,width:ve,height:Ne-2*Ft,right:0}}}}e.EditorLayoutInfoComputer=z;class Z extends C{constructor(){const ne={enabled:!0};super(54,"lightbulb",ne,{"editor.lightbulb.enabled":{type:"boolean",default:ne.enabled,description:g.localize(39,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:o(ne.enabled,this.defaultValue.enabled)}}}class M extends C{constructor(){const ne={enabled:!0,fontSize:0,fontFamily:e.EDITOR_FONT_DEFAULTS.fontFamily};super(124,"inlayHints",ne,{"editor.inlayHints.enabled":{type:"boolean",default:ne.enabled,description:g.localize(40,null)},"editor.inlayHints.fontSize":{type:"number",default:ne.fontSize,markdownDescription:g.localize(41,null)},"editor.inlayHints.fontFamily":{type:"string",default:ne.fontFamily,description:g.localize(42,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{enabled:o(ge.enabled,this.defaultValue.enabled),fontSize:c.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:y.string(ge.fontFamily,this.defaultValue.fontFamily)}}}class q extends d{constructor(){super(56,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,ne=>d.clamp(ne,0,150),{markdownDescription:g.localize(43,null)})}compute(ne,ge,Fe){return ne.fontInfo.lineHeight}}class N extends C{constructor(){const ne={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(62,"minimap",ne,{"editor.minimap.enabled":{type:"boolean",default:ne.enabled,description:g.localize(44,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[g.localize(45,null),g.localize(46,null),g.localize(47,null)],default:ne.size,description:g.localize(48,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:ne.side,description:g.localize(49,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:ne.showSlider,description:g.localize(50,null)},"editor.minimap.scale":{type:"number",default:ne.scale,minimum:1,maximum:3,enum:[1,2,3],description:g.localize(51,null)},"editor.minimap.renderCharacters":{type:"boolean",default:ne.renderCharacters,description:g.localize(52,null)},"editor.minimap.maxColumn":{type:"number",default:ne.maxColumn,description:g.localize(53,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{enabled:o(ge.enabled,this.defaultValue.enabled),size:b(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:b(ge.side,this.defaultValue.side,["right","left"]),showSlider:b(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o(ge.renderCharacters,this.defaultValue.renderCharacters),scale:c.clampedInt(ge.scale,1,1,3),maxColumn:c.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function W(j){return j==="ctrlCmd"?T.isMacintosh?"metaKey":"ctrlKey":"altKey"}class O extends C{constructor(){super(72,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(54,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:g.localize(55,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{top:c.clampedInt(ge.top,0,0,1e3),bottom:c.clampedInt(ge.bottom,0,0,1e3)}}}class B extends C{constructor(){const ne={enabled:!0,cycle:!1};super(73,"parameterHints",ne,{"editor.parameterHints.enabled":{type:"boolean",default:ne.enabled,description:g.localize(56,null)},"editor.parameterHints.cycle":{type:"boolean",default:ne.cycle,description:g.localize(57,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{enabled:o(ge.enabled,this.defaultValue.enabled),cycle:o(ge.cycle,this.defaultValue.cycle)}}}class Y extends n{constructor(){super(126)}compute(ne,ge,Fe){return ne.pixelRatio}}class he extends C{constructor(){const ne={other:!0,comments:!1,strings:!1};super(76,"quickSuggestions",ne,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:ne.strings,description:g.localize(58,null)},comments:{type:"boolean",default:ne.comments,description:g.localize(59,null)},other:{type:"boolean",default:ne.other,description:g.localize(60,null)}}}],default:ne,description:g.localize(61,null)});this.defaultValue=ne}validate(ne){if(typeof ne=="boolean")return ne;if(ne&&typeof ne=="object"){const ge=ne,Fe={other:o(ge.other,this.defaultValue.other),comments:o(ge.comments,this.defaultValue.comments),strings:o(ge.strings,this.defaultValue.strings)};return Fe.other&&Fe.comments&&Fe.strings?!0:!Fe.other&&!Fe.comments&&!Fe.strings?!1:Fe}return this.defaultValue}}var De;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval",j[j.Custom=4]="Custom"})(De=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Oe extends C{constructor(){super(57,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[g.localize(62,null),g.localize(63,null),g.localize(64,null),g.localize(65,null)],default:"on",description:g.localize(66,null)})}validate(ne){let ge=this.defaultValue.renderType,Fe=this.defaultValue.renderFn;return typeof ne!="undefined"&&(typeof ne=="function"?(ge=4,Fe=ne):ne==="interval"?ge=3:ne==="relative"?ge=2:ne==="on"?ge=1:ge=0),{renderType:ge,renderFn:Fe}}}function Me(j){const ne=j.get(85);return ne==="editable"?j.get(78):ne!=="on"}e.filterValidationDecorations=Me;class He extends C{constructor(){const ne=[],ge={type:"number",description:g.localize(67,null)};super(89,"rulers",ne,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:g.localize(68,null),format:"color-hex"}}}]},default:ne,description:g.localize(69,null)})}validate(ne){if(Array.isArray(ne)){let ge=[];for(let Fe of ne)if(typeof Fe=="number")ge.push({column:c.clampedInt(Fe,0,0,1e4),color:null});else if(Fe&&typeof Fe=="object"){const Ne=Fe;ge.push({column:c.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return ge.sort((Fe,Ne)=>Fe.column-Ne.column),ge}return this.defaultValue}}function Ye(j,ne){if(typeof j!="string")return ne;switch(j){case"hidden":return 2;case"visible":return 3;default:return 1}}class qe extends C{constructor(){super(90,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne,Fe=c.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=c.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:c.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ye(ge.vertical,this.defaultValue.vertical),horizontal:Ye(ge.horizontal,this.defaultValue.horizontal),useShadows:o(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:o(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Fe,horizontalSliderSize:c.clampedInt(ge.horizontalSliderSize,Fe,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:c.clampedInt(ge.verticalSliderSize,Ne,0,1e3),scrollByPage:o(ge.scrollByPage,this.defaultValue.scrollByPage)}}}class Xe extends C{constructor(){const ne={enabled:!1};super(52,"inlineSuggest",ne,{"editor.inlineSuggest.enabled":{type:"boolean",default:ne.enabled,description:g.localize(70,null)}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{enabled:o(ne.enabled,this.defaultValue.enabled)}}}class $ extends C{constructor(){const ne={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(104,"suggest",ne,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[g.localize(71,null),g.localize(72,null)],default:ne.insertMode,description:g.localize(73,null)},"editor.suggest.filterGraceful":{type:"boolean",default:ne.filterGraceful,description:g.localize(74,null)},"editor.suggest.localityBonus":{type:"boolean",default:ne.localityBonus,description:g.localize(75,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:ne.shareSuggestSelections,markdownDescription:g.localize(76,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:ne.snippetsPreventQuickSuggestions,description:g.localize(77,null)},"editor.suggest.showIcons":{type:"boolean",default:ne.showIcons,description:g.localize(78,null)},"editor.suggest.showStatusBar":{type:"boolean",default:ne.showStatusBar,description:g.localize(79,null)},"editor.suggest.preview":{type:"boolean",default:ne.preview,description:g.localize(80,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:ne.showInlineDetails,description:g.localize(81,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:g.localize(82,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:g.localize(83,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:g.localize(84,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:g.localize(85,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:g.localize(86,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:g.localize(87,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:g.localize(88,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:g.localize(89,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:g.localize(90,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:g.localize(91,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:g.localize(92,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:g.localize(93,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:g.localize(94,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:g.localize(95,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:g.localize(96,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:g.localize(97,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:g.localize(98,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:g.localize(99,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:g.localize(100,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:g.localize(101,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:g.localize(102,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:g.localize(103,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:g.localize(104,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:g.localize(105,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:g.localize(106,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:g.localize(107,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:g.localize(108,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:g.localize(109,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:g.localize(110,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:g.localize(111,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:g.localize(112,null)}})}validate(ne){if(!ne||typeof ne!="object")return this.defaultValue;const ge=ne;return{insertMode:b(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:o(ge.showIcons,this.defaultValue.showIcons),showStatusBar:o(ge.showStatusBar,this.defaultValue.showStatusBar),preview:o(ge.preview,this.defaultValue.preview),showInlineDetails:o(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o(ge.showMethods,this.defaultValue.showMethods),showFunctions:o(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:o(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:o(ge.showDeprecated,this.defaultValue.showDeprecated),showFields:o(ge.showFields,this.defaultValue.showFields),showVariables:o(ge.showVariables,this.defaultValue.showVariables),showClasses:o(ge.showClasses,this.defaultValue.showClasses),showStructs:o(ge.showStructs,this.defaultValue.showStructs),showInterfaces:o(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:o(ge.showModules,this.defaultValue.showModules),showProperties:o(ge.showProperties,this.defaultValue.showProperties),showEvents:o(ge.showEvents,this.defaultValue.showEvents),showOperators:o(ge.showOperators,this.defaultValue.showOperators),showUnits:o(ge.showUnits,this.defaultValue.showUnits),showValues:o(ge.showValues,this.defaultValue.showValues),showConstants:o(ge.showConstants,this.defaultValue.showConstants),showEnums:o(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:o(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o(ge.showKeywords,this.defaultValue.showKeywords),showWords:o(ge.showWords,this.defaultValue.showWords),showColors:o(ge.showColors,this.defaultValue.showColors),showFiles:o(ge.showFiles,this.defaultValue.showFiles),showReferences:o(ge.showReferences,this.defaultValue.showReferences),showFolders:o(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:o(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o(ge.showSnippets,this.defaultValue.showSnippets),showUsers:o(ge.showUsers,this.defaultValue.showUsers),showIssues:o(ge.showIssues,this.defaultValue.showIssues)}}}class G extends C{constructor(){super(100,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:g.localize(113,null),default:!0,type:"boolean"}})}validate(ne){return!ne||typeof ne!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(ne.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class te extends n{constructor(){super(127,[78])}compute(ne,ge,Fe){return ge.get(78)?!0:ne.tabFocusMode}}var re;(function(j){j[j.None=0]="None",j[j.Same=1]="Same",j[j.Indent=2]="Indent",j[j.DeepIndent=3]="DeepIndent"})(re=e.WrappingIndent||(e.WrappingIndent={}));function K(j){switch(j){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class oe extends n{constructor(){super(129,[128])}compute(ne,ge,Fe){const Ne=ge.get(128);return{isDominatedByLongLines:ne.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}const fe="Consolas, 'Courier New', monospace",Ae="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:T.isMacintosh?Ae:T.isLinux?$e:fe,fontWeight:"normal",fontSize:T.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},e.editorOptionsRegistry=[];function pe(j){return e.editorOptionsRegistry[j.id]=j,j}var Ge;(function(j){j[j.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",j[j.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",j[j.accessibilitySupport=2]="accessibilitySupport",j[j.accessibilityPageSize=3]="accessibilityPageSize",j[j.ariaLabel=4]="ariaLabel",j[j.autoClosingBrackets=5]="autoClosingBrackets",j[j.autoClosingDelete=6]="autoClosingDelete",j[j.autoClosingOvertype=7]="autoClosingOvertype",j[j.autoClosingQuotes=8]="autoClosingQuotes",j[j.autoIndent=9]="autoIndent",j[j.automaticLayout=10]="automaticLayout",j[j.autoSurround=11]="autoSurround",j[j.codeLens=12]="codeLens",j[j.codeLensFontFamily=13]="codeLensFontFamily",j[j.codeLensFontSize=14]="codeLensFontSize",j[j.colorDecorators=15]="colorDecorators",j[j.columnSelection=16]="columnSelection",j[j.comments=17]="comments",j[j.contextmenu=18]="contextmenu",j[j.copyWithSyntaxHighlighting=19]="copyWithSyntaxHighlighting",j[j.cursorBlinking=20]="cursorBlinking",j[j.cursorSmoothCaretAnimation=21]="cursorSmoothCaretAnimation",j[j.cursorStyle=22]="cursorStyle",j[j.cursorSurroundingLines=23]="cursorSurroundingLines",j[j.cursorSurroundingLinesStyle=24]="cursorSurroundingLinesStyle",j[j.cursorWidth=25]="cursorWidth",j[j.disableLayerHinting=26]="disableLayerHinting",j[j.disableMonospaceOptimizations=27]="disableMonospaceOptimizations",j[j.domReadOnly=28]="domReadOnly",j[j.dragAndDrop=29]="dragAndDrop",j[j.emptySelectionClipboard=30]="emptySelectionClipboard",j[j.extraEditorClassName=31]="extraEditorClassName",j[j.fastScrollSensitivity=32]="fastScrollSensitivity",j[j.find=33]="find",j[j.fixedOverflowWidgets=34]="fixedOverflowWidgets",j[j.folding=35]="folding",j[j.foldingStrategy=36]="foldingStrategy",j[j.foldingHighlight=37]="foldingHighlight",j[j.unfoldOnClickAfterEndOfLine=38]="unfoldOnClickAfterEndOfLine",j[j.fontFamily=39]="fontFamily",j[j.fontInfo=40]="fontInfo",j[j.fontLigatures=41]="fontLigatures",j[j.fontSize=42]="fontSize",j[j.fontWeight=43]="fontWeight",j[j.formatOnPaste=44]="formatOnPaste",j[j.formatOnType=45]="formatOnType",j[j.glyphMargin=46]="glyphMargin",j[j.gotoLocation=47]="gotoLocation",j[j.hideCursorInOverviewRuler=48]="hideCursorInOverviewRuler",j[j.highlightActiveIndentGuide=49]="highlightActiveIndentGuide",j[j.hover=50]="hover",j[j.inDiffEditor=51]="inDiffEditor",j[j.inlineSuggest=52]="inlineSuggest",j[j.letterSpacing=53]="letterSpacing",j[j.lightbulb=54]="lightbulb",j[j.lineDecorationsWidth=55]="lineDecorationsWidth",j[j.lineHeight=56]="lineHeight",j[j.lineNumbers=57]="lineNumbers",j[j.lineNumbersMinChars=58]="lineNumbersMinChars",j[j.linkedEditing=59]="linkedEditing",j[j.links=60]="links",j[j.matchBrackets=61]="matchBrackets",j[j.minimap=62]="minimap",j[j.mouseStyle=63]="mouseStyle",j[j.mouseWheelScrollSensitivity=64]="mouseWheelScrollSensitivity",j[j.mouseWheelZoom=65]="mouseWheelZoom",j[j.multiCursorMergeOverlapping=66]="multiCursorMergeOverlapping",j[j.multiCursorModifier=67]="multiCursorModifier",j[j.multiCursorPaste=68]="multiCursorPaste",j[j.occurrencesHighlight=69]="occurrencesHighlight",j[j.overviewRulerBorder=70]="overviewRulerBorder",j[j.overviewRulerLanes=71]="overviewRulerLanes",j[j.padding=72]="padding",j[j.parameterHints=73]="parameterHints",j[j.peekWidgetDefaultFocus=74]="peekWidgetDefaultFocus",j[j.definitionLinkOpensInPeek=75]="definitionLinkOpensInPeek",j[j.quickSuggestions=76]="quickSuggestions",j[j.quickSuggestionsDelay=77]="quickSuggestionsDelay",j[j.readOnly=78]="readOnly",j[j.renameOnType=79]="renameOnType",j[j.renderControlCharacters=80]="renderControlCharacters",j[j.renderIndentGuides=81]="renderIndentGuides",j[j.renderFinalNewline=82]="renderFinalNewline",j[j.renderLineHighlight=83]="renderLineHighlight",j[j.renderLineHighlightOnlyWhenFocus=84]="renderLineHighlightOnlyWhenFocus",j[j.renderValidationDecorations=85]="renderValidationDecorations",j[j.renderWhitespace=86]="renderWhitespace",j[j.revealHorizontalRightPadding=87]="revealHorizontalRightPadding",j[j.roundedSelection=88]="roundedSelection",j[j.rulers=89]="rulers",j[j.scrollbar=90]="scrollbar",j[j.scrollBeyondLastColumn=91]="scrollBeyondLastColumn",j[j.scrollBeyondLastLine=92]="scrollBeyondLastLine",j[j.scrollPredominantAxis=93]="scrollPredominantAxis",j[j.selectionClipboard=94]="selectionClipboard",j[j.selectionHighlight=95]="selectionHighlight",j[j.selectOnLineNumbers=96]="selectOnLineNumbers",j[j.showFoldingControls=97]="showFoldingControls",j[j.showUnused=98]="showUnused",j[j.snippetSuggestions=99]="snippetSuggestions",j[j.smartSelect=100]="smartSelect",j[j.smoothScrolling=101]="smoothScrolling",j[j.stickyTabStops=102]="stickyTabStops",j[j.stopRenderingLineAfter=103]="stopRenderingLineAfter",j[j.suggest=104]="suggest",j[j.suggestFontSize=105]="suggestFontSize",j[j.suggestLineHeight=106]="suggestLineHeight",j[j.suggestOnTriggerCharacters=107]="suggestOnTriggerCharacters",j[j.suggestSelection=108]="suggestSelection",j[j.tabCompletion=109]="tabCompletion",j[j.tabIndex=110]="tabIndex",j[j.unusualLineTerminators=111]="unusualLineTerminators",j[j.useShadowDOM=112]="useShadowDOM",j[j.useTabStops=113]="useTabStops",j[j.wordSeparators=114]="wordSeparators",j[j.wordWrap=115]="wordWrap",j[j.wordWrapBreakAfterCharacters=116]="wordWrapBreakAfterCharacters",j[j.wordWrapBreakBeforeCharacters=117]="wordWrapBreakBeforeCharacters",j[j.wordWrapColumn=118]="wordWrapColumn",j[j.wordWrapOverride1=119]="wordWrapOverride1",j[j.wordWrapOverride2=120]="wordWrapOverride2",j[j.wrappingIndent=121]="wrappingIndent",j[j.wrappingStrategy=122]="wrappingStrategy",j[j.showDeprecated=123]="showDeprecated",j[j.inlayHints=124]="inlayHints",j[j.editorClassName=125]="editorClassName",j[j.pixelRatio=126]="pixelRatio",j[j.tabFocusMode=127]="tabFocusMode",j[j.layoutInfo=128]="layoutInfo",j[j.wrappingInfo=129]="wrappingInfo"})(Ge=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:pe(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:g.localize(114,null)})),acceptSuggestionOnEnter:pe(new p(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",g.localize(115,null),""],markdownDescription:g.localize(116,null)})),accessibilitySupport:pe(new m),accessibilityPageSize:pe(new c(3,"accessibilityPageSize",10,1,1073741824,{description:g.localize(117,null)})),ariaLabel:pe(new y(4,"ariaLabel",g.localize(118,null))),autoClosingBrackets:pe(new p(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(119,null),g.localize(120,null),""],description:g.localize(121,null)})),autoClosingDelete:pe(new p(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",g.localize(122,null),""],description:g.localize(123,null)})),autoClosingOvertype:pe(new p(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",g.localize(124,null),""],description:g.localize(125,null)})),autoClosingQuotes:pe(new p(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",g.localize(126,null),g.localize(127,null),""],description:g.localize(128,null)})),autoIndent:pe(new l(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],f,{enumDescriptions:[g.localize(129,null),g.localize(130,null),g.localize(131,null),g.localize(132,null),g.localize(133,null)],description:g.localize(134,null)})),automaticLayout:pe(new h(10,"automaticLayout",!1)),autoSurround:pe(new p(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[g.localize(135,null),g.localize(136,null),g.localize(137,null),""],description:g.localize(138,null)})),stickyTabStops:pe(new h(102,"stickyTabStops",!1,{description:g.localize(139,null)})),codeLens:pe(new h(12,"codeLens",!0,{description:g.localize(140,null)})),codeLensFontFamily:pe(new y(13,"codeLensFontFamily","",{description:g.localize(141,null)})),codeLensFontSize:pe(new c(14,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:g.localize(142,null)})),colorDecorators:pe(new h(15,"colorDecorators",!0,{description:g.localize(143,null)})),columnSelection:pe(new h(16,"columnSelection",!1,{description:g.localize(144,null)})),comments:pe(new t),contextmenu:pe(new h(18,"contextmenu",!0)),copyWithSyntaxHighlighting:pe(new h(19,"copyWithSyntaxHighlighting",!0,{description:g.localize(145,null)})),cursorBlinking:pe(new l(20,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],s,{description:g.localize(146,null)})),cursorSmoothCaretAnimation:pe(new h(21,"cursorSmoothCaretAnimation",!1,{description:g.localize(147,null)})),cursorStyle:pe(new l(22,"cursorStyle",i.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:g.localize(148,null)})),cursorSurroundingLines:pe(new c(23,"cursorSurroundingLines",0,0,1073741824,{description:g.localize(149,null)})),cursorSurroundingLinesStyle:pe(new p(24,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[g.localize(150,null),g.localize(151,null)],description:g.localize(152,null)})),cursorWidth:pe(new c(25,"cursorWidth",0,0,1073741824,{markdownDescription:g.localize(153,null)})),disableLayerHinting:pe(new h(26,"disableLayerHinting",!1)),disableMonospaceOptimizations:pe(new h(27,"disableMonospaceOptimizations",!1)),domReadOnly:pe(new h(28,"domReadOnly",!1)),dragAndDrop:pe(new h(29,"dragAndDrop",!0,{description:g.localize(154,null)})),emptySelectionClipboard:pe(new P),extraEditorClassName:pe(new y(31,"extraEditorClassName","")),fastScrollSensitivity:pe(new d(32,"fastScrollSensitivity",5,j=>j<=0?5:j,{markdownDescription:g.localize(155,null)})),find:pe(new A),fixedOverflowWidgets:pe(new h(34,"fixedOverflowWidgets",!1)),folding:pe(new h(35,"folding",!0,{description:g.localize(156,null)})),foldingStrategy:pe(new p(36,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[g.localize(157,null),g.localize(158,null)],description:g.localize(159,null)})),foldingHighlight:pe(new h(37,"foldingHighlight",!0,{description:g.localize(160,null)})),unfoldOnClickAfterEndOfLine:pe(new h(38,"unfoldOnClickAfterEndOfLine",!1,{description:g.localize(161,null)})),fontFamily:pe(new y(39,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:g.localize(162,null)})),fontInfo:pe(new R),fontLigatures2:pe(new a),fontSize:pe(new L),fontWeight:pe(new H),formatOnPaste:pe(new h(44,"formatOnPaste",!1,{description:g.localize(163,null)})),formatOnType:pe(new h(45,"formatOnType",!1,{description:g.localize(164,null)})),glyphMargin:pe(new h(46,"glyphMargin",!0,{description:g.localize(165,null)})),gotoLocation:pe(new ue),hideCursorInOverviewRuler:pe(new h(48,"hideCursorInOverviewRuler",!1,{description:g.localize(166,null)})),highlightActiveIndentGuide:pe(new h(49,"highlightActiveIndentGuide",!0,{description:g.localize(167,null)})),hover:pe(new me),inDiffEditor:pe(new h(51,"inDiffEditor",!1)),letterSpacing:pe(new d(53,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,j=>d.clamp(j,-5,20),{description:g.localize(168,null)})),lightbulb:pe(new Z),lineDecorationsWidth:pe(new I(55,"lineDecorationsWidth",10)),lineHeight:pe(new q),lineNumbers:pe(new Oe),lineNumbersMinChars:pe(new c(58,"lineNumbersMinChars",5,1,300)),linkedEditing:pe(new h(59,"linkedEditing",!1,{description:g.localize(169,null)})),links:pe(new h(60,"links",!0,{description:g.localize(170,null)})),matchBrackets:pe(new p(61,"matchBrackets","always",["always","near","never"],{description:g.localize(171,null)})),minimap:pe(new N),mouseStyle:pe(new p(63,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:pe(new d(64,"mouseWheelScrollSensitivity",1,j=>j===0?1:j,{markdownDescription:g.localize(172,null)})),mouseWheelZoom:pe(new h(65,"mouseWheelZoom",!1,{markdownDescription:g.localize(173,null)})),multiCursorMergeOverlapping:pe(new h(66,"multiCursorMergeOverlapping",!0,{description:g.localize(174,null)})),multiCursorModifier:pe(new l(67,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],W,{markdownEnumDescriptions:[g.localize(175,null),g.localize(176,null)],markdownDescription:g.localize(177,null)})),multiCursorPaste:pe(new p(68,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[g.localize(178,null),g.localize(179,null)],markdownDescription:g.localize(180,null)})),occurrencesHighlight:pe(new h(69,"occurrencesHighlight",!0,{description:g.localize(181,null)})),overviewRulerBorder:pe(new h(70,"overviewRulerBorder",!0,{description:g.localize(182,null)})),overviewRulerLanes:pe(new c(71,"overviewRulerLanes",3,0,3)),padding:pe(new O),parameterHints:pe(new B),peekWidgetDefaultFocus:pe(new p(74,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[g.localize(183,null),g.localize(184,null)],description:g.localize(185,null)})),definitionLinkOpensInPeek:pe(new h(75,"definitionLinkOpensInPeek",!1,{description:g.localize(186,null)})),quickSuggestions:pe(new he),quickSuggestionsDelay:pe(new c(77,"quickSuggestionsDelay",10,0,1073741824,{description:g.localize(187,null)})),readOnly:pe(new h(78,"readOnly",!1)),renameOnType:pe(new h(79,"renameOnType",!1,{description:g.localize(188,null),markdownDeprecationMessage:g.localize(189,null)})),renderControlCharacters:pe(new h(80,"renderControlCharacters",!1,{description:g.localize(190,null)})),renderIndentGuides:pe(new h(81,"renderIndentGuides",!0,{description:g.localize(191,null)})),renderFinalNewline:pe(new h(82,"renderFinalNewline",!0,{description:g.localize(192,null)})),renderLineHighlight:pe(new p(83,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",g.localize(193,null)],description:g.localize(194,null)})),renderLineHighlightOnlyWhenFocus:pe(new h(84,"renderLineHighlightOnlyWhenFocus",!1,{description:g.localize(195,null)})),renderValidationDecorations:pe(new p(85,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:pe(new p(86,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",g.localize(196,null),g.localize(197,null),g.localize(198,null),""],description:g.localize(199,null)})),revealHorizontalRightPadding:pe(new c(87,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:pe(new h(88,"roundedSelection",!0,{description:g.localize(200,null)})),rulers:pe(new He),scrollbar:pe(new qe),scrollBeyondLastColumn:pe(new c(91,"scrollBeyondLastColumn",5,0,1073741824,{description:g.localize(201,null)})),scrollBeyondLastLine:pe(new h(92,"scrollBeyondLastLine",!0,{description:g.localize(202,null)})),scrollPredominantAxis:pe(new h(93,"scrollPredominantAxis",!0,{description:g.localize(203,null)})),selectionClipboard:pe(new h(94,"selectionClipboard",!0,{description:g.localize(204,null),included:T.isLinux})),selectionHighlight:pe(new h(95,"selectionHighlight",!0,{description:g.localize(205,null)})),selectOnLineNumbers:pe(new h(96,"selectOnLineNumbers",!0)),showFoldingControls:pe(new p(97,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[g.localize(206,null),g.localize(207,null)],description:g.localize(208,null)})),showUnused:pe(new h(98,"showUnused",!0,{description:g.localize(209,null)})),showDeprecated:pe(new h(123,"showDeprecated",!0,{description:g.localize(210,null)})),inlayHints:pe(new M),snippetSuggestions:pe(new p(99,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[g.localize(211,null),g.localize(212,null),g.localize(213,null),g.localize(214,null)],description:g.localize(215,null)})),smartSelect:pe(new G),smoothScrolling:pe(new h(101,"smoothScrolling",!1,{description:g.localize(216,null)})),stopRenderingLineAfter:pe(new c(103,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:pe(new $),inlineSuggest:pe(new Xe),suggestFontSize:pe(new c(105,"suggestFontSize",0,0,1e3,{markdownDescription:g.localize(217,null)})),suggestLineHeight:pe(new c(106,"suggestLineHeight",0,0,1e3,{markdownDescription:g.localize(218,null)})),suggestOnTriggerCharacters:pe(new h(107,"suggestOnTriggerCharacters",!0,{description:g.localize(219,null)})),suggestSelection:pe(new p(108,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[g.localize(220,null),g.localize(221,null),g.localize(222,null)],description:g.localize(223,null)})),tabCompletion:pe(new p(109,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[g.localize(224,null),g.localize(225,null),g.localize(226,null)],description:g.localize(227,null)})),tabIndex:pe(new c(110,"tabIndex",0,-1,1073741824)),unusualLineTerminators:pe(new p(111,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[g.localize(228,null),g.localize(229,null),g.localize(230,null)],description:g.localize(231,null)})),useShadowDOM:pe(new h(112,"useShadowDOM",!0)),useTabStops:pe(new h(113,"useTabStops",!0,{description:g.localize(232,null)})),wordSeparators:pe(new y(114,"wordSeparators",S.USUAL_WORD_SEPARATORS,{description:g.localize(233,null)})),wordWrap:pe(new p(115,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[g.localize(234,null),g.localize(235,null),g.localize(236,null),g.localize(237,null)],description:g.localize(238,null)})),wordWrapBreakAfterCharacters:pe(new y(116,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:pe(new y(117,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:pe(new c(118,"wordWrapColumn",80,1,1073741824,{markdownDescription:g.localize(239,null)})),wordWrapOverride1:pe(new p(119,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:pe(new p(120,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:pe(new l(121,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],K,{enumDescriptions:[g.localize(240,null),g.localize(241,null),g.localize(242,null),g.localize(243,null)],description:g.localize(244,null)})),wrappingStrategy:pe(new p(122,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[g.localize(245,null),g.localize(246,null)],description:g.localize(247,null)})),editorClassName:pe(new v),pixelRatio:pe(new Y),tabFocusMode:pe(new te),layoutInfo:pe(new z),wrappingInfo:pe(new oe)}}),define(we[124],_e([19,20]),function(ee,e){return ee.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[125],_e([19,20]),function(ee,e){return ee.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[126],_e([19,20]),function(ee,e){return ee.create("vs/platform/files/common/files",e)}),define(we[127],_e([19,20]),function(ee,e){return ee.create("vs/platform/markers/common/markers",e)}),define(we[128],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[129],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[130],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostProgress",e)}),define(we[131],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[132],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[133],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[134],_e([19,20]),function(ee,e){return ee.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[135],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[136],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(we[137],_e([19,20]),function(ee,e){return ee.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[138],_e([19,20]),function(ee,e){return ee.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[139],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var g;(function(k){k[k.ACTIVATE=0]="ACTIVATE",k[k.RESTORE=1]="RESTORE",k[k.PRESERVE=2]="PRESERVE"})(g=e.EditorActivation||(e.EditorActivation={}));var T;(function(k){k[k.PICK=1]="PICK",k[k.DISABLED=2]="DISABLED"})(T=e.EditorOverride||(e.EditorOverride={}));var S;(function(k){k[k.API=0]="API",k[k.USER=1]="USER"})(S=e.EditorOpenContext||(e.EditorOpenContext={}));var E;(function(k){k[k.Center=0]="Center",k[k.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",k[k.NearTop=2]="NearTop",k[k.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(E=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(we[140],_e([0,1,125]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function E(o){return o=o.trim(),o==="*"||T.test(o)}e.isValidVersionStr=E;function k(o){if(!E(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let h=o.match(T);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=k;function D(o){if(!o)return null;let h=o.majorBase,c=o.majorMustEqual,d=o.minorBase,y=o.minorMustEqual,b=o.patchBase,p=o.patchMustEqual;o.hasCaret&&(h===0||(y=!1),p=!1);let l=0;if(o.preRelease){const f=S.exec(o.preRelease);if(f){const[,m,t,r]=f;l=Date.UTC(Number(m),Number(t)-1,Number(r))}}return{majorBase:h,majorMustEqual:c,minorBase:d,minorMustEqual:y,patchBase:b,patchMustEqual:p,isMinimum:o.hasGreaterEquals,notBefore:l}}e.normalizeVersion=D;function _(o,h,c){let d;typeof o=="string"?d=D(k(o)):d=o;let y;h instanceof Date?y=h.getTime():typeof h=="string"&&(y=new Date(h).getTime());let b;if(typeof c=="string"?b=D(k(c)):b=c,!d||!b)return!1;let p=d.majorBase,l=d.minorBase,f=d.patchBase,m=b.majorBase,t=b.minorBase,r=b.patchBase,s=b.notBefore,i=b.majorMustEqual,u=b.minorMustEqual,w=b.patchMustEqual;return b.isMinimum?p>m?!0:p<m?!1:l>t?!0:l<t||y&&y<s?!1:f>=r:(p===1&&m===0&&(!i||!u||!w)&&(m=1,t=0,r=0,i=!0,u=!1,w=!1),p<m?!1:p>m?!i:l<t?!1:l>t?!u:f<r?!1:f>r?!w:!(y&&y<s))}e.isValidVersion=_;function C(o,h,c,d){return c.isBuiltin||typeof c.main=="undefined"?!0:I(o,h,c.engines.vscode,d)}e.isValidExtensionVersion=C;function n(o,h,c){return o==="*"||I(h,c,o)}e.isEngineValid=n;function I(o,h,c,d=[]){let y=D(k(c));if(!y)return d.push(g.localize(0,null,c)),!1;if(y.majorBase===0){if(!y.majorMustEqual||!y.minorMustEqual)return d.push(g.localize(1,null,c)),!1}else if(!y.majorMustEqual)return d.push(g.localize(2,null,c)),!1;return _(o,h,y)?!0:(d.push(g.localize(3,null,o,c)),!1)}}),define(we[88],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class g{constructor(E,k=[],D=!1){this.ctor=E,this.staticArguments=k,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=g;const T=(S,...E)=>new g(S,E);e.createSyncDescriptor=T}),define(we[57],_e([0,1,88]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const T=[];function S(k,D,_){D instanceof g.SyncDescriptor||(D=new g.SyncDescriptor(D,[],_)),T.push([k,D])}e.registerSingleton=S;function E(){return T}e.getSingletonServiceDescriptors=E}),define(we[141],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class g{constructor(E){this.incoming=new Map,this.outgoing=new Map,this.data=E}}e.Node=g;class T{constructor(E){this._hashFn=E,this._nodes=new Map}roots(){const E=[];for(let k of this._nodes.values())k.outgoing.size===0&&E.push(k);return E}insertEdge(E,k){const D=this.lookupOrInsertNode(E),_=this.lookupOrInsertNode(k);D.outgoing.set(this._hashFn(k),_),_.incoming.set(this._hashFn(E),D)}removeNode(E){const k=this._hashFn(E);this._nodes.delete(k);for(let D of this._nodes.values())D.outgoing.delete(k),D.incoming.delete(k)}lookupOrInsertNode(E){const k=this._hashFn(E);let D=this._nodes.get(k);return D||(D=new g(E),this._nodes.set(k,D)),D}lookup(E){return this._nodes.get(this._hashFn(E))}isEmpty(){return this._nodes.size===0}toString(){let E=[];for(let[k,D]of this._nodes)E.push(`${k}, (incoming)[${[...D.incoming.keys()].join(", ")}], (outgoing)[${[...D.outgoing.keys()].join(",")}]`);return E.join(`
`)}findCycleSlow(){for(let[E,k]of this._nodes){const D=new Set([E]),_=this._findCycle(k,D);if(_)return _}}_findCycle(E,k){for(let[D,_]of E.outgoing){if(k.has(D))return[...k,D].join(" -> ");k.add(D);const C=this._findCycle(_,k);if(C)return C;k.delete(D)}}}e.Graph=T}),define(we[4],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var g;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function _(C){return C[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=_})(g=e._util||(e._util={})),e.IInstantiationService=S("instantiationService");function T(D,_,C,n){_[g.DI_TARGET]===_?_[g.DI_DEPENDENCIES].push({id:D,index:C,optional:n}):(_[g.DI_DEPENDENCIES]=[{id:D,index:C,optional:n}],_[g.DI_TARGET]=_)}function S(D){if(g.serviceIds.has(D))return g.serviceIds.get(D);const _=function(C,n,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");T(_,C,I,!1)};return _.toString=()=>D,g.serviceIds.set(D,_),_}e.createDecorator=S;function E(D){return D}e.refineServiceDecorator=E;function k(D){return function(_,C,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");T(D,_,n,!0)}}e.optional=k}),define(we[142],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=g.createDecorator("modelService");function T(S){return!S.isTooLargeForSyncing()&&!S.isForSimpleWidget}e.shouldSynchronizeModel=T}),define(we[143],_e([0,1,3,53,7,22,77,55,142]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function C(o){return typeof o=="string"?!1:Array.isArray(o)?o.every(C):!!o.exclusive}class n{constructor(){this._clock=0,this._entries=[],this._onDidChange=new g.Emitter}get onDidChange(){return this._onDidChange.event}register(h,c){let d={selector:h,provider:c,_score:-1,_time:this._clock++};return this._entries.push(d),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),S.toDisposable(()=>{if(d){let y=this._entries.indexOf(d);y>=0&&(this._entries.splice(y,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),d=void 0)}})}has(h){return this.all(h).length>0}all(h){if(!h)return[];this._updateScores(h);const c=[];for(let d of this._entries)d._score>0&&c.push(d.provider);return c}ordered(h){const c=[];return this._orderedForEach(h,d=>c.push(d.provider)),c}orderedGroups(h){const c=[];let d,y;return this._orderedForEach(h,b=>{d&&y===b._score?d.push(b.provider):(y=b._score,d=[b.provider],c.push(d))}),c}_orderedForEach(h,c){if(!!h){this._updateScores(h);for(const d of this._entries)d._score>0&&c(d)}}_updateScores(h){let c={uri:h.uri.toString(),language:h.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===c.language&&this._lastCandidate.uri===c.uri)){this._lastCandidate=c;for(let d of this._entries)if(d._score=D.score(d.selector,h.uri,h.getLanguageIdentifier().language,_.shouldSynchronizeModel(h)),C(d.selector)&&d._score>0){for(let y of this._entries)y._score=0;d._score=1e3;break}this._entries.sort(n._compareByScoreAndTime)}}static _compareByScoreAndTime(h,c){return h._score<c._score?1:h._score>c._score?-1:h._time<c._time?1:h._time>c._time?-1:0}}e.LanguageFeatureRegistry=n;class I{constructor(h,c,d=Number.MAX_SAFE_INTEGER){this._registry=h,this.min=c,this.max=d,this._cache=new E.LRUCache(50,.7)}_key(h){return h.id+T.hash(this._registry.all(h))}_clamp(h){return h===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(h*1.3)))}get(h){const c=this._key(h),d=this._cache.get(c);return this._clamp(d==null?void 0:d.value)}update(h,c){const d=this._key(h);let y=this._cache.get(d);return y||(y=new k.MovingAverage,this._cache.set(d,y)),y.update(c),this.get(h)}}e.LanguageFeatureRequestDelays=I}),define(we[58],_e([0,1,2,31,143,119,78]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var D;(function(a){a[a.Null=0]="Null",a[a.PlainText=1]="PlainText"})(D=e.LanguageId||(e.LanguageId={}));class _{constructor(R,L){this.language=R,this.id=L}}e.LanguageIdentifier=_;var C;(function(a){a[a.NotSet=-1]="NotSet",a[a.None=0]="None",a[a.Italic=1]="Italic",a[a.Bold=2]="Bold",a[a.Underline=4]="Underline"})(C=e.FontStyle||(e.FontStyle={}));var n;(function(a){a[a.None=0]="None",a[a.DefaultForeground=1]="DefaultForeground",a[a.DefaultBackground=2]="DefaultBackground"})(n=e.ColorId||(e.ColorId={}));var I;(function(a){a[a.Other=0]="Other",a[a.Comment=1]="Comment",a[a.String=2]="String",a[a.RegEx=4]="RegEx"})(I=e.StandardTokenType||(e.StandardTokenType={}));var o;(function(a){a[a.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",a[a.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",a[a.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",a[a.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",a[a.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",a[a.ITALIC_MASK=2048]="ITALIC_MASK",a[a.BOLD_MASK=4096]="BOLD_MASK",a[a.UNDERLINE_MASK=8192]="UNDERLINE_MASK",a[a.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",a[a.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",a[a.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",a[a.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",a[a.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",a[a.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",a[a.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",a[a.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",a[a.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",a[a.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(o=e.MetadataConsts||(e.MetadataConsts={}));class h{static getLanguageId(R){return(R&255)>>>0}static getTokenType(R){return(R&1792)>>>8}static getFontStyle(R){return(R&14336)>>>11}static getForeground(R){return(R&8372224)>>>14}static getBackground(R){return(R&4286578688)>>>23}static getClassNameFromMetadata(R){let L=this.getForeground(R),H="mtk"+L,ue=this.getFontStyle(R);return ue&1&&(H+=" mtki"),ue&2&&(H+=" mtkb"),ue&4&&(H+=" mtku"),H}static getInlineStyleFromMetadata(R,L){const H=this.getForeground(R),ue=this.getFontStyle(R);let me=`color: ${L[H]};`;return ue&1&&(me+="font-style: italic;"),ue&2&&(me+="font-weight: bold;"),ue&4&&(me+="text-decoration: underline;"),me}}e.TokenMetadata=h;var c;(function(a){a[a.Method=0]="Method",a[a.Function=1]="Function",a[a.Constructor=2]="Constructor",a[a.Field=3]="Field",a[a.Variable=4]="Variable",a[a.Class=5]="Class",a[a.Struct=6]="Struct",a[a.Interface=7]="Interface",a[a.Module=8]="Module",a[a.Property=9]="Property",a[a.Event=10]="Event",a[a.Operator=11]="Operator",a[a.Unit=12]="Unit",a[a.Value=13]="Value",a[a.Constant=14]="Constant",a[a.Enum=15]="Enum",a[a.EnumMember=16]="EnumMember",a[a.Keyword=17]="Keyword",a[a.Text=18]="Text",a[a.Color=19]="Color",a[a.File=20]="File",a[a.Reference=21]="Reference",a[a.Customcolor=22]="Customcolor",a[a.Folder=23]="Folder",a[a.TypeParameter=24]="TypeParameter",a[a.User=25]="User",a[a.Issue=26]="Issue",a[a.Snippet=27]="Snippet"})(c=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let a=Object.create(null);return a[0]="symbol-method",a[1]="symbol-function",a[2]="symbol-constructor",a[3]="symbol-field",a[4]="symbol-variable",a[5]="symbol-class",a[6]="symbol-struct",a[7]="symbol-interface",a[8]="symbol-module",a[9]="symbol-property",a[10]="symbol-event",a[11]="symbol-operator",a[12]="symbol-unit",a[13]="symbol-value",a[14]="symbol-constant",a[15]="symbol-enum",a[16]="symbol-enum-member",a[17]="symbol-keyword",a[27]="symbol-snippet",a[18]="symbol-text",a[19]="symbol-color",a[20]="symbol-file",a[21]="symbol-reference",a[22]="symbol-customcolor",a[23]="symbol-folder",a[24]="symbol-type-parameter",a[25]="account",a[26]="issues",function(R){const L=a[R];let H=L&&k.iconRegistry.get(L);return H||(console.info("No codicon found for CompletionItemKind "+R),H=k.Codicon.symbolProperty),H.classNames}}(),e.completionKindFromString=function(){let a=Object.create(null);return a.method=0,a.function=1,a.constructor=2,a.field=3,a.variable=4,a.class=5,a.struct=6,a.interface=7,a.module=8,a.property=9,a.event=10,a.operator=11,a.unit=12,a.value=13,a.constant=14,a.enum=15,a["enum-member"]=16,a.enumMember=16,a.keyword=17,a.snippet=27,a.text=18,a.color=19,a.file=20,a.reference=21,a.customcolor=22,a.folder=23,a["type-parameter"]=24,a.typeParameter=24,a.account=25,a.issue=26,function(R,L){let H=a[R];return typeof H=="undefined"&&!L&&(H=9),H}}();var d;(function(a){a[a.Deprecated=1]="Deprecated"})(d=e.CompletionItemTag||(e.CompletionItemTag={}));var y;(function(a){a[a.KeepWhitespace=1]="KeepWhitespace",a[a.InsertAsSnippet=4]="InsertAsSnippet"})(y=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var b;(function(a){a[a.Invoke=0]="Invoke",a[a.TriggerCharacter=1]="TriggerCharacter",a[a.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(b=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var p;(function(a){a[a.Automatic=0]="Automatic",a[a.Explicit=1]="Explicit"})(p=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var l;(function(a){a[a.Invoke=1]="Invoke",a[a.Auto=2]="Auto"})(l=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var f;(function(a){a[a.Invoke=1]="Invoke",a[a.TriggerCharacter=2]="TriggerCharacter",a[a.ContentChange=3]="ContentChange"})(f=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var m;(function(a){a[a.Text=0]="Text",a[a.Read=1]="Read",a[a.Write=2]="Write"})(m=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(a){return a&&g.URI.isUri(a.uri)&&T.Range.isIRange(a.range)&&(T.Range.isIRange(a.originSelectionRange)||T.Range.isIRange(a.targetSelectionRange))}e.isLocationLink=t;var r;(function(a){a[a.File=0]="File",a[a.Module=1]="Module",a[a.Namespace=2]="Namespace",a[a.Package=3]="Package",a[a.Class=4]="Class",a[a.Method=5]="Method",a[a.Property=6]="Property",a[a.Field=7]="Field",a[a.Constructor=8]="Constructor",a[a.Enum=9]="Enum",a[a.Interface=10]="Interface",a[a.Function=11]="Function",a[a.Variable=12]="Variable",a[a.Constant=13]="Constant",a[a.String=14]="String",a[a.Number=15]="Number",a[a.Boolean=16]="Boolean",a[a.Array=17]="Array",a[a.Object=18]="Object",a[a.Key=19]="Key",a[a.Null=20]="Null",a[a.EnumMember=21]="EnumMember",a[a.Struct=22]="Struct",a[a.Event=23]="Event",a[a.Operator=24]="Operator",a[a.TypeParameter=25]="TypeParameter"})(r=e.SymbolKind||(e.SymbolKind={}));var s;(function(a){a[a.Deprecated=1]="Deprecated"})(s=e.SymbolTag||(e.SymbolTag={}));var i;(function(a){const R=new Map;R.set("file",0),R.set("module",1),R.set("namespace",2),R.set("package",3),R.set("class",4),R.set("method",5),R.set("property",6),R.set("field",7),R.set("constructor",8),R.set("enum",9),R.set("interface",10),R.set("function",11),R.set("variable",12),R.set("constant",13),R.set("string",14),R.set("number",15),R.set("boolean",16),R.set("array",17),R.set("object",18),R.set("key",19),R.set("null",20),R.set("enum-member",21),R.set("struct",22),R.set("event",23),R.set("operator",24),R.set("type-parameter",25);const L=new Map;L.set(0,"file"),L.set(1,"module"),L.set(2,"namespace"),L.set(3,"package"),L.set(4,"class"),L.set(5,"method"),L.set(6,"property"),L.set(7,"field"),L.set(8,"constructor"),L.set(9,"enum"),L.set(10,"interface"),L.set(11,"function"),L.set(12,"variable"),L.set(13,"constant"),L.set(14,"string"),L.set(15,"number"),L.set(16,"boolean"),L.set(17,"array"),L.set(18,"object"),L.set(19,"key"),L.set(20,"null"),L.set(21,"enum-member"),L.set(22,"struct"),L.set(23,"event"),L.set(24,"operator"),L.set(25,"type-parameter");function H(J){return R.get(J)}a.fromString=H;function ue(J){return L.get(J)}a.toString=ue;function me(J,z){const Z=L.get(J);let M=Z&&k.iconRegistry.get("symbol-"+Z);return M||(console.info("No codicon found for SymbolKind "+J),M=k.Codicon.symbolProperty),`${z?"inline":"block"} ${M.classNames}`}a.toCssClassName=me})(i=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(R){this.value=R}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var w;(function(a){a[a.Collapsed=0]="Collapsed",a[a.Expanded=1]="Expanded"})(w=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var v;(function(a){a[a.Editing=0]="Editing",a[a.Preview=1]="Preview"})(v=e.CommentMode||(e.CommentMode={}));var P;(function(a){a[a.Other=0]="Other",a[a.Type=1]="Type",a[a.Parameter=2]="Parameter"})(P=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new S.LanguageFeatureRegistry,e.RenameProviderRegistry=new S.LanguageFeatureRegistry,e.CompletionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new S.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new S.LanguageFeatureRegistry,e.HoverProviderRegistry=new S.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new S.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new S.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new S.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new S.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new S.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new S.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new S.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new S.LanguageFeatureRegistry,e.LinkProviderRegistry=new S.LanguageFeatureRegistry,e.ColorProviderRegistry=new S.LanguageFeatureRegistry,e.SelectionRangeRegistry=new S.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new S.LanguageFeatureRegistry,e.TokenizationRegistry=new E.TokenizationRegistryImpl;var A;(function(a){a[a.None=0]="None",a[a.Option=1]="Option",a[a.Default=2]="Default",a[a.Preferred=3]="Preferred"})(A=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(we[89],_e([0,1,8,4,21]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let E=S.userAgent||"";const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",S.isMacintosh),k.set("isLinux",S.isLinux),k.set("isWindows",S.isWindows),k.set("isWeb",S.isWeb),k.set("isMacNative",S.isMacintosh&&!S.isWeb),k.set("isEdge",E.indexOf("Edg/")>=0),k.set("isFirefox",E.indexOf("Firefox")>=0),k.set("isChrome",E.indexOf("Chrome")>=0),k.set("isSafari",E.indexOf("Safari")>=0);const D=Object.prototype.hasOwnProperty;var _;(function(A){A[A.False=0]="False",A[A.True=1]="True",A[A.Defined=2]="Defined",A[A.Not=3]="Not",A[A.Equals=4]="Equals",A[A.NotEquals=5]="NotEquals",A[A.And=6]="And",A[A.Regex=7]="Regex",A[A.NotRegex=8]="NotRegex",A[A.Or=9]="Or",A[A.In=10]="In",A[A.NotIn=11]="NotIn",A[A.Greater=12]="Greater",A[A.GreaterEquals=13]="GreaterEquals",A[A.Smaller=14]="Smaller",A[A.SmallerEquals=15]="SmallerEquals"})(_=e.ContextKeyExprType||(e.ContextKeyExprType={}));class C{static false(){return I.INSTANCE}static true(){return o.INSTANCE}static has(a){return h.create(a)}static equals(a,R){return c.create(a,R)}static notEquals(a,R){return b.create(a,R)}static regex(a,R){return r.create(a,R)}static in(a,R){return d.create(a,R)}static not(a){return p.create(a)}static and(...a){return i.create(a)}static or(...a){return u.create(a)}static greater(a,R){return l.create(a,R)}static less(a,R){return m.create(a,R)}static deserialize(a,R=!1){if(!!a)return this._deserializeOrExpression(a,R)}static _deserializeOrExpression(a,R){let L=a.split("||");return u.create(L.map(H=>this._deserializeAndExpression(H,R)))}static _deserializeAndExpression(a,R){let L=a.split("&&");return i.create(L.map(H=>this._deserializeOne(H,R)))}static _deserializeOne(a,R){if(a=a.trim(),a.indexOf("!=")>=0){let L=a.split("!=");return b.create(L[0].trim(),this._deserializeValue(L[1],R))}if(a.indexOf("==")>=0){let L=a.split("==");return c.create(L[0].trim(),this._deserializeValue(L[1],R))}if(a.indexOf("=~")>=0){let L=a.split("=~");return r.create(L[0].trim(),this._deserializeRegexValue(L[1],R))}if(a.indexOf(" in ")>=0){let L=a.split(" in ");return d.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(a)){const L=a.split(">=");return f.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(a)){const L=a.split(">");return l.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(a)){const L=a.split("<=");return t.create(L[0].trim(),L[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(a)){const L=a.split("<");return m.create(L[0].trim(),L[1].trim())}return/^\!\s*/.test(a)?p.create(a.substr(1).trim()):h.create(a)}static _deserializeValue(a,R){if(a=a.trim(),a==="true")return!0;if(a==="false")return!1;let L=/^'([^']*)'$/.exec(a);return L?L[1].trim():a}static _deserializeRegexValue(a,R){if(g.isFalsyOrWhitespace(a)){if(R)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let L=a.indexOf("/"),H=a.lastIndexOf("/");if(L===H||L<0){if(R)throw new Error(`bad regexp-value '${a}', missing /-enclosure`);return console.warn(`bad regexp-value '${a}', missing /-enclosure`),null}let ue=a.slice(L+1,H),me=a[H+1]==="i"?"i":"";try{return new RegExp(ue,me)}catch(J){if(R)throw new Error(`bad regexp-value '${a}', parse error: ${J}`);return console.warn(`bad regexp-value '${a}', parse error: ${J}`),null}}}e.ContextKeyExpr=C;function n(A,a){return A.cmp(a)}class I{constructor(){this.type=0}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!1}serialize(){return"false"}keys(){return[]}map(a){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=I,I.INSTANCE=new I;class o{constructor(){this.type=1}cmp(a){return this.type-a.type}equals(a){return a.type===this.type}evaluate(a){return!0}serialize(){return"true"}keys(){return[]}map(a){return this}negate(){return I.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class h{constructor(a){this.key=a,this.type=2}static create(a){const R=k.get(a);return typeof R=="boolean"?R?o.INSTANCE:I.INSTANCE:new h(a)}cmp(a){return a.type!==this.type?this.type-a.type:v(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!!a.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(a){return a.mapDefined(this.key)}negate(){return p.create(this.key)}}e.ContextKeyDefinedExpr=h;class c{constructor(a,R){this.key=a,this.value=R,this.type=4}static create(a,R){if(typeof R=="boolean")return R?h.create(a):p.create(a);const L=k.get(a);return typeof L=="boolean"?R===(L?"true":"false")?o.INSTANCE:I.INSTANCE:new c(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(a){return a.mapEquals(this.key,this.value)}negate(){return b.create(this.key,this.value)}}e.ContextKeyEqualsExpr=c;class d{constructor(a,R){this.key=a,this.valueKey=R,this.type=10}static create(a,R){return new d(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.valueKey,a.key,a.valueKey)}equals(a){return a.type===this.type?this.key===a.key&&this.valueKey===a.valueKey:!1}evaluate(a){const R=a.getValue(this.valueKey),L=a.getValue(this.key);return Array.isArray(R)?R.indexOf(L)>=0:typeof L=="string"&&typeof R=="object"&&R!==null?D.call(R,L):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(a){return a.mapIn(this.key,this.valueKey)}negate(){return y.create(this)}}e.ContextKeyInExpr=d;class y{constructor(a){this._actual=a,this.type=11}static create(a){return new y(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new y(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotInExpr=y;class b{constructor(a,R){this.key=a,this.value=R,this.type=5}static create(a,R){if(typeof R=="boolean")return R?p.create(a):h.create(a);const L=k.get(a);return typeof L=="boolean"?R===(L?"true":"false")?I.INSTANCE:o.INSTANCE:new b(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return a.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(a){return a.mapNotEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=b;class p{constructor(a){this.key=a,this.type=3}static create(a){const R=k.get(a);return typeof R=="boolean"?R?I.INSTANCE:o.INSTANCE:new p(a)}cmp(a){return a.type!==this.type?this.type-a.type:v(this.key,a.key)}equals(a){return a.type===this.type?this.key===a.key:!1}evaluate(a){return!a.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(a){return a.mapNot(this.key)}negate(){return h.create(this.key)}}e.ContextKeyNotExpr=p;class l{constructor(a,R){this.key=a,this.value=R,this.type=12}static create(a,R){return new l(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=l;class f{constructor(a,R){this.key=a,this.value=R,this.type=13}static create(a,R){return new f(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(a){return a.mapGreaterEquals(this.key,this.value)}negate(){return m.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=f;class m{constructor(a,R){this.key=a,this.value=R,this.type=14}static create(a,R){return new m(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmaller(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeySmallerExpr=m;class t{constructor(a,R){this.key=a,this.value=R,this.type=15}static create(a,R){return new t(a,R)}cmp(a){return a.type!==this.type?this.type-a.type:P(this.key,this.value,a.key,a.value)}equals(a){return a.type===this.type?this.key===a.key&&this.value===a.value:!1}evaluate(a){return parseFloat(a.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(a){return a.mapSmallerEquals(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class r{constructor(a,R){this.key=a,this.regexp=R,this.type=7}static create(a,R){return new r(a,R)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.key<a.key)return-1;if(this.key>a.key)return 1;const R=this.regexp?this.regexp.source:"",L=a.regexp?a.regexp.source:"";return R<L?-1:R>L?1:0}equals(a){if(a.type===this.type){const R=this.regexp?this.regexp.source:"",L=a.regexp?a.regexp.source:"";return this.key===a.key&&R===L}return!1}evaluate(a){let R=a.getValue(this.key);return this.regexp?this.regexp.test(R):!1}serialize(){const a=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${a}`}keys(){return[this.key]}map(a){return a.mapRegex(this.key,this.regexp)}negate(){return s.create(this)}}e.ContextKeyRegexExpr=r;class s{constructor(a){this._actual=a,this.type=8}static create(a){return new s(a)}cmp(a){return a.type!==this.type?this.type-a.type:this._actual.cmp(a._actual)}equals(a){return a.type===this.type?this._actual.equals(a._actual):!1}evaluate(a){return!this._actual.evaluate(a)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(a){return new s(this._actual.map(a))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=s;class i{constructor(a){this.expr=a,this.type=6}static create(a){return i._normalizeArr(a)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const H=n(this.expr[R],a.expr[R]);if(H!==0)return H}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(a.expr[R]))return!1;return!0}return!1}evaluate(a){for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].evaluate(a))return!1;return!0}static _normalizeArr(a){const R=[];let L=!1;for(const H of a)if(!!H){if(H.type===1){L=!0;continue}if(H.type===0)return I.INSTANCE;if(H.type===6){R.push(...H.expr);continue}R.push(H)}if(R.length===0&&L)return o.INSTANCE;if(R.length!==0){if(R.length===1)return R[0];for(R.sort(n);R.length>1;){const H=R[R.length-1];if(H.type!==9)break;R.pop();const ue=R.pop(),me=u.create(H.expr.map(J=>i.create([J,ue])));me&&(R.push(me),R.sort(n))}return R.length===1?R[0]:new i(R)}}serialize(){return this.expr.map(a=>a.serialize()).join(" && ")}keys(){const a=[];for(let R of this.expr)a.push(...R.keys());return a}map(a){return new i(this.expr.map(R=>R.map(a)))}negate(){let a=[];for(let R of this.expr)a.push(R.negate());return u.create(a)}}e.ContextKeyAndExpr=i;class u{constructor(a){this.expr=a,this.type=9}static create(a){const R=u._normalizeArr(a);if(R.length!==0)return R.length===1?R[0]:new u(R)}cmp(a){if(a.type!==this.type)return this.type-a.type;if(this.expr.length<a.expr.length)return-1;if(this.expr.length>a.expr.length)return 1;for(let R=0,L=this.expr.length;R<L;R++){const H=n(this.expr[R],a.expr[R]);if(H!==0)return H}return 0}equals(a){if(a.type===this.type){if(this.expr.length!==a.expr.length)return!1;for(let R=0,L=this.expr.length;R<L;R++)if(!this.expr[R].equals(a.expr[R]))return!1;return!0}return!1}evaluate(a){for(let R=0,L=this.expr.length;R<L;R++)if(this.expr[R].evaluate(a))return!0;return!1}static _normalizeArr(a){let R=[],L=!1;if(a){for(let H=0,ue=a.length;H<ue;H++){const me=a[H];if(!!me){if(me.type===0){L=!0;continue}if(me.type===1)return[o.INSTANCE];if(me.type===9){R=R.concat(me.expr);continue}R.push(me)}}if(R.length===0&&L)return[I.INSTANCE];R.sort(n)}return R}serialize(){return this.expr.map(a=>a.serialize()).join(" || ")}keys(){const a=[];for(let R of this.expr)a.push(...R.keys());return a}map(a){return new u(this.expr.map(R=>R.map(a)))}negate(){let a=[];for(let L of this.expr)a.push(L.negate());const R=L=>L.type===9?L.expr:[L];for(;a.length>1;){const L=a.shift(),H=a.shift(),ue=[];for(const me of R(L))for(const J of R(H))ue.push(C.and(me,J));a.unshift(C.or(...ue))}return a[0]}}e.ContextKeyOrExpr=u;class w extends h{constructor(a,R,L){super(a);this._defaultValue=R,typeof L=="object"?w._info.push(Object.assign(Object.assign({},L),{key:a})):L!==!0&&w._info.push({key:a,description:L,type:R!=null?typeof R:void 0})}static all(){return w._info.values()}bindTo(a){return a.createKey(this.key,this._defaultValue)}getValue(a){return a.getContextKeyValue(this.key)}toNegated(){return C.not(this.key)}isEqualTo(a){return C.equals(this.key,a)}notEqualsTo(a){return C.notEquals(this.key,a)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=T.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(A,a){return A<a?-1:A>a?1:0}function P(A,a,R,L){return A<R?-1:A>R?1:a<L?-1:a>L?1:0}}),define(we[144],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=g.createDecorator("environmentService"),e.INativeEnvironmentService=g.refineServiceDecorator(e.IEnvironmentService)}),define(we[26],_e([0,1,8,4]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function S(n){if(typeof n=="object"&&n!==null&&n.supported!==!0)return n.description}e.getWorkpaceSupportTypeMessage=S;function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(!n.uuid||typeof n.uuid=="string")}e.isIExtensionIdentifier=E,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var k;(function(n){n[n.System=0]="System",n[n.User=1]="User"})(k=e.ExtensionType||(e.ExtensionType={}));class D{constructor(I){this.value=I,this._lower=I.toLowerCase()}static equals(I,o){if(typeof I=="undefined"||I===null)return typeof o=="undefined"||o===null;if(typeof o=="undefined"||o===null)return!1;if(typeof I=="string"||typeof o=="string"){let h=typeof I=="string"?I:I.value,c=typeof o=="string"?o:o.value;return g.equalsIgnoreCase(h,c)}return I._lower===o._lower}static toKey(I){return typeof I=="string"?I.toLowerCase():I._lower}}e.ExtensionIdentifier=D;function _(n){return n.contributes&&n.contributes.localizations?n.contributes.localizations.length>0:!1}e.isLanguagePackExtension=_;function C(n){return n.contributes&&n.contributes.authentication?n.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=C,e.IBuiltinExtensionsScannerService=T.createDecorator("IBuiltinExtensionsScannerService")}),define(we[145],_e([0,1,8,26]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function S(h,c){return h.uuid&&c.uuid?h.uuid===c.uuid:h.id===c.id?!0:g.compareIgnoreCase(h.id,c.id)===0}e.areSameExtensions=S;class E{constructor(c,d){this.version=d,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof E?S(this,c)&&this.version===c.version:!1}}e.ExtensionIdentifierWithVersion=E;function k(h,c){return`${h}.${c}`}e.getExtensionId=k;function D(h){return h.toLocaleLowerCase()}e.adoptToGalleryExtensionId=D;function _(h,c){return D(k(h,c))}e.getGalleryExtensionId=_;function C(h,c){const d=[],y=b=>{for(const p of d)if(p.some(l=>S(c(l),c(b))))return p;return null};for(const b of h){const p=y(b);p?p.push(b):d.push([b])}return d}e.groupByExtension=C;function n(h){return{id:h.identifier.id,name:h.manifest.name,galleryId:null,publisherId:h.publisherId,publisherName:h.manifest.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:h.manifest.extensionDependencies&&h.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function I(h){return Object.assign({id:h.identifier.id,name:h.name,galleryId:h.identifier.uuid,publisherId:h.publisherId,publisherName:h.publisher,publisherDisplayName:h.publisherDisplayName,dependencies:!!(h.properties.dependencies&&h.properties.dependencies.length>0)},h.telemetryData)}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new T.ExtensionIdentifier("pprice.better-merge");function o(h){const c=new Set;for(const d of h)d.malicious&&c.add(d.id.id);return c}e.getMaliciousExtensionsSet=o}),define(we[59],_e([0,1,126,14,2,4,8,10,22]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=E.createDecorator("fileService");function C(z){return z.create===!0}e.isFileOpenForWriteOptions=C;var n;(function(z){z[z.Unknown=0]="Unknown",z[z.File=1]="File",z[z.Directory=2]="Directory",z[z.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var I;(function(z){z[z.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var o;(function(z){z[z.FileReadWrite=2]="FileReadWrite",z[z.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",z[z.FileReadStream=16]="FileReadStream",z[z.FileFolderCopy=8]="FileFolderCopy",z[z.PathCaseSensitive=1024]="PathCaseSensitive",z[z.Readonly=2048]="Readonly",z[z.Trash=4096]="Trash",z[z.FileWriteUnlock=8192]="FileWriteUnlock"})(o=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function h(z){return!!(z.capabilities&2)}e.hasReadWriteCapability=h;function c(z){return!!(z.capabilities&8)}e.hasFileFolderCopyCapability=c;function d(z){return!!(z.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function y(z){return!!(z.capabilities&16)}e.hasFileReadStreamCapability=y;var b;(function(z){z.FileExists="EntryExists",z.FileNotFound="EntryNotFound",z.FileNotADirectory="EntryNotADirectory",z.FileIsADirectory="EntryIsADirectory",z.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",z.FileTooLarge="EntryTooLarge",z.FileWriteLocked="EntryWriteLocked",z.NoPermissions="NoPermissions",z.Unavailable="Unavailable",z.Unknown="Unknown"})(b=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(Z,M){super(Z);this.code=M}}e.FileSystemProviderError=p;function l(z,Z){const M=new p(z.toString(),Z);return m(M,Z),M}e.createFileSystemProviderError=l;function f(z){return z||l(g.localize(0,null),b.Unknown)}e.ensureFileSystemProviderError=f;function m(z,Z){return z.name=Z?`${Z} (FileSystemError)`:"FileSystemError",z}e.markAsFileSystemProviderError=m;function t(z){if(!z)return b.Unknown;if(z instanceof p)return z.code;const Z=/^(.+) \(FileSystemError\)$/.exec(z.name);if(!Z)return b.Unknown;switch(Z[1]){case b.FileExists:return b.FileExists;case b.FileIsADirectory:return b.FileIsADirectory;case b.FileNotADirectory:return b.FileNotADirectory;case b.FileNotFound:return b.FileNotFound;case b.FileExceedsMemoryLimit:return b.FileExceedsMemoryLimit;case b.FileTooLarge:return b.FileTooLarge;case b.FileWriteLocked:return b.FileWriteLocked;case b.NoPermissions:return b.NoPermissions;case b.Unavailable:return b.Unavailable}return b.Unknown}e.toFileSystemProviderErrorCode=t;function r(z){if(z instanceof P)return z.fileOperationResult;switch(t(z)){case b.FileNotFound:return 1;case b.FileIsADirectory:return 0;case b.FileNotADirectory:return 10;case b.FileWriteLocked:return 5;case b.NoPermissions:return 6;case b.FileExists:return 4;case b.FileExceedsMemoryLimit:return 9;case b.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=r;var s;(function(z){z[z.CREATE=0]="CREATE",z[z.DELETE=1]="DELETE",z[z.MOVE=2]="MOVE",z[z.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class i{constructor(Z,M,q){this.resource=Z,this.operation=M,this.target=q}isOperation(Z){return this.operation===Z}}e.FileOperationEvent=i;var u;(function(z){z[z.UPDATED=0]="UPDATED",z[z.ADDED=1]="ADDED",z[z.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class w{constructor(Z,M){this.changes=Z,this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const q of Z)switch(q.type){case 1:this.added||(this.added=_.TernarySearchTree.forUris(()=>M)),this.added.set(q.resource,q);break;case 0:this.updated||(this.updated=_.TernarySearchTree.forUris(()=>M)),this.updated.set(q.resource,q);break;case 2:this.deleted||(this.deleted=_.TernarySearchTree.forUris(()=>M)),this.deleted.set(q.resource,q);break}}contains(Z,...M){return this.doContains(Z,{includeChildren:!1},...M)}affects(Z,...M){return this.doContains(Z,{includeChildren:!0},...M)}doContains(Z,M,...q){var N,W,O,B,Y,he;if(!Z)return!1;const De=q.length>0;return!!((!De||q.includes(1))&&(((N=this.added)===null||N===void 0?void 0:N.get(Z))||M.includeChildren&&((W=this.added)===null||W===void 0?void 0:W.findSuperstr(Z)))||(!De||q.includes(0))&&(((O=this.updated)===null||O===void 0?void 0:O.get(Z))||M.includeChildren&&((B=this.updated)===null||B===void 0?void 0:B.findSuperstr(Z)))||(!De||q.includes(2))&&(((Y=this.deleted)===null||Y===void 0?void 0:Y.findSubstr(Z))||M.includeChildren&&((he=this.deleted)===null||he===void 0?void 0:he.findSuperstr(Z))))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get raw(){return this.changes}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=w;function v(z,Z,M){return!z||!Z||z===Z||Z.length>z.length?!1:(Z.charAt(Z.length-1)!==T.sep&&(Z+=T.sep),M?k.startsWithIgnoreCase(z,Z):z.indexOf(Z)===0)}e.isParent=v;class P extends Error{constructor(Z,M,q){super(Z);this.fileOperationResult=M,this.options=q}}e.FileOperationError=P;class A extends P{constructor(Z,M,q){super(Z,2,q);this.stat=M}}e.NotModifiedSinceFileOperationError=A;var a;(function(z){z[z.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",z[z.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",z[z.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",z[z.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",z[z.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",z[z.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",z[z.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",z[z.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",z[z.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",z[z.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",z[z.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",z[z.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(a=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var R;(function(z){z[z.FILE=0]="FILE",z[z.FOLDER=1]="FOLDER",z[z.ROOT_FOLDER=2]="ROOT_FOLDER"})(R=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L(z){if(!(typeof z.size!="number"||typeof z.mtime!="number"))return z.mtime.toString(29)+z.size.toString(31)}e.etag=L;async function H(z,Z){if(!Z.canHandleResource(S.URI.from({scheme:z.scheme})))return new Promise(M=>{const q=Z.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===z.scheme&&N.added&&(q.dispose(),M())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ue{static formatSize(Z){return D.isNumber(Z)||(Z=0),Z<ue.KB?g.localize(1,null,Z.toFixed(0)):Z<ue.MB?g.localize(2,null,(Z/ue.KB).toFixed(2)):Z<ue.GB?g.localize(3,null,(Z/ue.MB).toFixed(2)):Z<ue.TB?g.localize(4,null,(Z/ue.GB).toFixed(2)):g.localize(5,null,(Z/ue.TB).toFixed(2))}}e.ByteSize=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;var me;(function(z){z[z.IA32=0]="IA32",z[z.OTHER=1]="OTHER"})(me=e.Arch||(e.Arch={}));function J(z){return{maxFileSize:z===0?300*ue.MB:16*ue.GB,maxHeapSize:z===0?700*ue.MB:2*700*ue.MB}}e.getPlatformLimits=J}),define(we[60],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class g{constructor(...S){this._entries=new Map;for(let[E,k]of S)this.set(E,k)}set(S,E){const k=this._entries.get(S);return this._entries.set(S,E),k}has(S){return this._entries.has(S)}get(S){return this._entries.get(S)}}e.ServiceCollection=g}),define(we[146],_e([0,1,11,141,88,4,60,12]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const _=!1;class C extends Error{constructor(c){var d;super("cyclic dependency between services");this.message=(d=c.findCycleSlow())!==null&&d!==void 0?d:`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class n{constructor(c=new k.ServiceCollection,d=!1,y){this._activeInstantiations=new Set,this._services=c,this._strict=d,this._parent=y,this._services.set(E.IInstantiationService,this)}createChild(c){return new n(c,this._strict,this)}invokeFunction(c,...d){let y=o.traceInvocation(c),b=!1;try{return c({get:(l,f)=>{if(b)throw g.illegalState("service accessor is only valid during the invocation of its target method");const m=this._getOrCreateServiceInstance(l,y);if(!m&&f!==E.optional)throw new Error(`[invokeFunction] unknown service '${l}'`);return m}},...d)}finally{b=!0,y.stop()}}createInstance(c,...d){let y,b;return c instanceof S.SyncDescriptor?(y=o.traceCreation(c.ctor),b=this._createInstance(c.ctor,c.staticArguments.concat(d),y)):(y=o.traceCreation(c),b=this._createInstance(c,d,y)),y.stop(),b}_createInstance(c,d=[],y){let b=E._util.getServiceDependencies(c).sort((f,m)=>f.index-m.index),p=[];for(const f of b){let m=this._getOrCreateServiceInstance(f.id,y);if(!m&&this._strict&&!f.optional)throw new Error(`[createInstance] ${c.name} depends on UNKNOWN service ${f.id}.`);p.push(m)}let l=b.length>0?b[0].index:d.length;if(d.length!==l){console.warn(`[createInstance] First service dependency of ${c.name} at position ${l+1} conflicts with ${d.length} static arguments`);let f=l-d.length;f>0?d=d.concat(new Array(f)):d=d.slice(0,l)}return new c(...[...d,...p])}_setServiceInstance(c,d){if(this._services.get(c)instanceof S.SyncDescriptor)this._services.set(c,d);else if(this._parent)this._parent._setServiceInstance(c,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(c){let d=this._services.get(c);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(c):d}_getOrCreateServiceInstance(c,d){let y=this._getServiceInstanceOrDescriptor(c);return y instanceof S.SyncDescriptor?this._safeCreateAndCacheServiceInstance(c,y,d.branch(c,!0)):(d.branch(c,!1),y)}_safeCreateAndCacheServiceInstance(c,d,y){if(this._activeInstantiations.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this._activeInstantiations.add(c);try{return this._createAndCacheServiceInstance(c,d,y)}finally{this._activeInstantiations.delete(c)}}_createAndCacheServiceInstance(c,d,y){const b=new T.Graph(f=>f.id.toString());let p=0;const l=[{id:c,desc:d,_trace:y}];for(;l.length;){const f=l.pop();if(b.lookupOrInsertNode(f),p++>1e3)throw new C(b);for(let m of E._util.getServiceDependencies(f.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(m.id);if(!t&&!m.optional&&console.warn(`[createInstance] ${c} depends on ${m.id} which is NOT registered.`),t instanceof S.SyncDescriptor){const r={id:m.id,desc:t,_trace:f._trace.branch(m.id,!0)};b.insertEdge(f,r),l.push(r)}}}for(;;){const f=b.roots();if(f.length===0){if(!b.isEmpty())throw new C(b);break}for(const{data:m}of f){if(this._getServiceInstanceOrDescriptor(m.id)instanceof S.SyncDescriptor){const r=this._createServiceInstanceWithOwner(m.id,m.desc.ctor,m.desc.staticArguments,m.desc.supportsDelayedInstantiation,m._trace);this._setServiceInstance(m.id,r)}b.removeNode(m)}}return this._getServiceInstanceOrDescriptor(c)}_createServiceInstanceWithOwner(c,d,y=[],b,p){if(this._services.get(c)instanceof S.SyncDescriptor)return this._createServiceInstance(d,y,b,p);if(this._parent)return this._parent._createServiceInstanceWithOwner(c,d,y,b,p);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(c,d=[],y,b){if(y){const p=new D.IdleValue(()=>this._createInstance(c,d,b));return new Proxy(Object.create(null),{get(l,f){if(f in l)return l[f];let m=p.value,t=m[f];return typeof t!="function"||(t=t.bind(m),l[f]=t),t},set(l,f,m){return p.value[f]=m,!0}})}else return this._createInstance(c,d,b)}}e.InstantiationService=n;var I;(function(h){h[h.Creation=0]="Creation",h[h.Invocation=1]="Invocation",h[h.Branch=2]="Branch"})(I||(I={}));class o{constructor(c,d){this.type=c,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(c){return _?new o(1,c.name||c.toString().substring(0,42).replace(/\n/g,"")):o._None}static traceCreation(c){return _?new o(0,c.name):o._None}branch(c,d){let y=new o(2,c.toString());return this._dep.push([c,d,y]),y}stop(){let c=Date.now()-this._start;o._totals+=c;let d=!1;function y(p,l){let f=[],m=new Array(p+1).join("	");for(const[t,r,s]of l._dep)if(r&&s){d=!0,f.push(`${m}CREATES -> ${t}`);let i=y(p+1,s);i&&f.push(i)}else f.push(`${m}uses -> ${t}`);return f.join(`
`)}let b=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${o._totals.toFixed(2)}ms)`];(c>2||d)&&console.log(b.join(`
`))}}o._None=new class extends o{constructor(){super(-1,null)}stop(){}branch(){return this}},o._totals=0}),define(we[15],_e([0,1,4,7,21,3,56]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=g.createDecorator("logService"),e.ILoggerService=g.createDecorator("loggerService");function D(){return new Date().toISOString()}var _;(function(m){m[m.Trace=0]="Trace",m[m.Debug=1]="Debug",m[m.Info=2]="Info",m[m.Warning=3]="Warning",m[m.Error=4]="Error",m[m.Critical=5]="Critical",m[m.Off=6]="Off"})(_=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=_.Info;class C extends T.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new E.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=C;class n extends C{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...r){this.checkLogLevel(_.Trace)&&this.log(_.Trace,this.format([t,...r]))}debug(t,...r){this.checkLogLevel(_.Debug)&&this.log(_.Debug,this.format([t,...r]))}info(t,...r){this.checkLogLevel(_.Info)&&this.log(_.Info,this.format([t,...r]))}warn(t,...r){this.checkLogLevel(_.Warning)&&this.log(_.Warning,this.format([t,...r]))}error(t,...r){if(this.checkLogLevel(_.Error))if(t instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=t.stack,this.log(_.Error,this.format(s))}else this.log(_.Error,this.format([t,...r]))}critical(t,...r){this.checkLogLevel(_.Critical)&&this.log(_.Critical,this.format([t,...r]))}flush(){}format(t){let r="";for(let s=0;s<t.length;s++){let i=t[s];if(typeof i=="object")try{i=JSON.stringify(i)}catch(u){}r+=(s>0?" ":"")+i}return r}}e.AbstractMessageLogger=n;class I extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!S.isWindows}trace(t,...r){this.getLevel()<=_.Trace&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}debug(t,...r){this.getLevel()<=_.Debug&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}info(t,...r){this.getLevel()<=_.Info&&(this.useColors?console.log(`[90m[main ${D()}][0m`,t,...r):console.log(`[main ${D()}]`,t,...r))}warn(t,...r){this.getLevel()<=_.Warning&&(this.useColors?console.warn(`[93m[main ${D()}][0m`,t,...r):console.warn(`[main ${D()}]`,t,...r))}error(t,...r){this.getLevel()<=_.Error&&(this.useColors?console.error(`[91m[main ${D()}][0m`,t,...r):console.error(`[main ${D()}]`,t,...r))}critical(t,...r){this.getLevel()<=_.Critical&&(this.useColors?console.error(`[90m[main ${D()}][0m`,t,...r):console.error(`[main ${D()}]`,t,...r))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class o extends C{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...r){this.getLevel()<=_.Trace&&console.log("%cTRACE","color: #888",t,...r)}debug(t,...r){this.getLevel()<=_.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...r)}info(t,...r){this.getLevel()<=_.Info&&console.log("%c INFO","color: #33f",t,...r)}warn(t,...r){this.getLevel()<=_.Warning&&console.log("%c WARN","color: #993",t,...r)}error(t,...r){this.getLevel()<=_.Error&&console.log("%c  ERR","color: #f33",t,...r)}critical(t,...r){this.getLevel()<=_.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...r)}dispose(){}flush(){}}e.ConsoleLogger=o;class h extends C{constructor(t,r=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(r)}trace(t,...r){this.getLevel()<=_.Trace&&this.adapter.log(_.Trace,[this.extractMessage(t),...r])}debug(t,...r){this.getLevel()<=_.Debug&&this.adapter.log(_.Debug,[this.extractMessage(t),...r])}info(t,...r){this.getLevel()<=_.Info&&this.adapter.log(_.Info,[this.extractMessage(t),...r])}warn(t,...r){this.getLevel()<=_.Warning&&this.adapter.log(_.Warning,[this.extractMessage(t),...r])}error(t,...r){this.getLevel()<=_.Error&&this.adapter.log(_.Error,[this.extractMessage(t),...r])}critical(t,...r){this.getLevel()<=_.Critical&&this.adapter.log(_.Critical,[this.extractMessage(t),...r])}extractMessage(t){return typeof t=="string"?t:k.toErrorMessage(t,this.getLevel()<=_.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class c extends C{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const r of this.logServices)r.setLevel(t);super.setLevel(t)}trace(t,...r){for(const s of this.logServices)s.trace(t,...r)}debug(t,...r){for(const s of this.logServices)s.debug(t,...r)}info(t,...r){for(const s of this.logServices)s.info(t,...r)}warn(t,...r){for(const s of this.logServices)s.warn(t,...r)}error(t,...r){for(const s of this.logServices)s.error(t,...r)}critical(t,...r){for(const s of this.logServices)s.critical(t,...r)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=c;class d extends T.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...r){this.logger.trace(t,...r)}debug(t,...r){this.logger.debug(t,...r)}info(t,...r){this.logger.info(t,...r)}warn(t,...r){this.logger.warn(t,...r)}error(t,...r){this.logger.error(t,...r)}critical(t,...r){this.logger.critical(t,...r)}flush(){this.logger.flush()}}e.LogService=d;class y extends T.Disposable{constructor(t,r){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(i=>i.setLevel(s))}))}createLogger(t,r){let s=this.loggers.get(t.toString());return s||(s=this.doCreateLogger(t,(r==null?void 0:r.always)?_.Trace:this.logLevel,r),this.loggers.set(t.toString(),s),(r==null?void 0:r.always)||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class b{constructor(){this.onDidChangeLogLevel=new E.Emitter().event}setLevel(t){}getLevel(){return _.Info}trace(t,...r){}debug(t,...r){}info(t,...r){}warn(t,...r){}error(t,...r){}critical(t,...r){}dispose(){}flush(){}}e.NullLogService=b;function p(m){if(m.verbose)return _.Trace;if(typeof m.logLevel=="string"){const t=l(m.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function l(m){switch(m){case"trace":return _.Trace;case"debug":return _.Debug;case"info":return _.Info;case"warn":return _.Warning;case"error":return _.Error;case"critical":return _.Critical;case"off":return _.Off}}e.parseLogLevel=l;function f(m){switch(m){case _.Trace:return"trace";case _.Debug:return"debug";case _.Info:return"info";case _.Warning:return"warn";case _.Error:return"error";case _.Critical:return"critical";case _.Off:return"off"}}e.LogLevelToString=f}),define(we[90],_e([0,1,4,127,42]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var E;(function(_){_[_.Unnecessary=1]="Unnecessary",_[_.Deprecated=2]="Deprecated"})(E=e.MarkerTag||(e.MarkerTag={}));var k;(function(_){_[_.Hint=1]="Hint",_[_.Info=2]="Info",_[_.Warning=4]="Warning",_[_.Error=8]="Error"})(k=e.MarkerSeverity||(e.MarkerSeverity={})),function(_){function C(c,d){return d-c}_.compare=C;const n=Object.create(null);n[_.Error]=T.localize(0,null),n[_.Warning]=T.localize(1,null),n[_.Info]=T.localize(2,null);function I(c){return n[c]||""}_.toString=I;function o(c){switch(c){case S.default.Error:return _.Error;case S.default.Warning:return _.Warning;case S.default.Info:return _.Info;case S.default.Ignore:return _.Hint}}_.fromSeverity=o;function h(c){switch(c){case _.Error:return S.default.Error;case _.Warning:return S.default.Warning;case _.Info:return S.default.Info;case _.Hint:return S.default.Ignore}}_.toSeverity=h}(k=e.MarkerSeverity||(e.MarkerSeverity={}));var D;(function(_){const C="";function n(o){return I(o,!0)}_.makeKey=n;function I(o,h){let c=[C];return o.source?c.push(o.source.replace("\xA6","\\\xA6")):c.push(C),o.code?typeof o.code=="string"?c.push(o.code.replace("\xA6","\\\xA6")):c.push(o.code.value.replace("\xA6","\\\xA6")):c.push(C),o.severity!==void 0&&o.severity!==null?c.push(k.toString(o.severity)):c.push(C),o.message&&h?c.push(o.message.replace("\xA6","\\\xA6")):c.push(C),o.startLineNumber!==void 0&&o.startLineNumber!==null?c.push(o.startLineNumber.toString()):c.push(C),o.startColumn!==void 0&&o.startColumn!==null?c.push(o.startColumn.toString()):c.push(C),o.endLineNumber!==void 0&&o.endLineNumber!==null?c.push(o.endLineNumber.toString()):c.push(C),o.endColumn!==void 0&&o.endColumn!==null?c.push(o.endColumn.toString()):c.push(C),c.push(C),c.join("\xA6")}_.makeKeyOptionalMessage=I})(D=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=g.createDecorator("markerService")}),define(we[147],_e([0,1,42,4,3]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=g.default,e.INotificationService=T.createDecorator("notificationService");var E;(function(C){C[C.WORKSPACE=0]="WORKSPACE",C[C.GLOBAL=1]="GLOBAL"})(E=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var k;(function(C){C[C.OFF=0]="OFF",C[C.SILENT=1]="SILENT",C[C.ERROR=2]="ERROR"})(k=e.NotificationsFilter||(e.NotificationsFilter={}));class D{constructor(){this.progress=new _,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(n){}updateMessage(n){}updateActions(n){}close(){}}e.NoOpNotification=D;class _{infinite(){}done(){}total(n){}worked(n){}}e.NoOpProgress=_}),define(we[148],_e([0,1,7,8,2,4]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=E.createDecorator("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return g.Disposable.None},registerValidator(){return g.Disposable.None},registerExternalUriResolver(){return g.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return g.Disposable.None},async open(){return!1},async resolveExternalUri(D){return{resolved:D,dispose(){}}}});function k(D,_){return S.URI.isUri(D)?T.equalsIgnoreCase(D.scheme,_):T.startsWithIgnoreCase(D,_+":")}e.matchesScheme=k});var Ve=this&&this.__decorate||function(ee,e,g,T){var S=arguments.length,E=S<3?e:T===null?T=Object.getOwnPropertyDescriptor(e,g):T,k;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")E=Reflect.decorate(ee,e,g,T);else for(var D=ee.length-1;D>=0;D--)(k=ee[D])&&(E=(S<3?k(E):S>3?k(e,g,E):k(e,g))||E);return S>3&&E&&Object.defineProperty(e,g,E),E},ze=this&&this.__param||function(ee,e){return function(g,T){e(g,T,ee)}};define(we[149],_e([0,1,4,18,7,12]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=g.createDecorator("progressService");var k;(function(n){n[n.Explorer=1]="Explorer",n[n.Scm=3]="Scm",n[n.Extensions=5]="Extensions",n[n.Window=10]="Window",n[n.Notification=15]="Notification",n[n.Dialog=20]="Dialog"})(k=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class D{constructor(I){this.callback=I}get value(){return this._value}report(I){this._value=I,this.callback(this._value)}}e.Progress=D,D.None=Object.freeze({report(){}});let _=class extends S.Disposable{constructor(I,o){super();this.deferred=new E.DeferredPromise,o.withProgress(I,h=>(this.reporter=h,this.lastStep&&h.report(this.lastStep),this.deferred.p)),this._register(S.toDisposable(()=>this.deferred.complete()))}report(I){this.reporter?this.reporter.report(I):this.lastStep=I}};_=Ve([ze(1,e.IProgressService)],_),e.UnmanagedProgress=_;class C extends S.Disposable{constructor(I){super();this.progressIndicator=I,this.currentOperationId=0,this.currentOperationDisposables=this._register(new S.DisposableStore)}start(I){this.stop();const o=++this.currentOperationId,h=new T.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{o===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},I),this.currentOperationDisposables.add(S.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(S.toDisposable(()=>h.cancel())),this.currentOperationDisposables.add(S.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:o,token:h.token,stop:()=>this.doStop(o),isCurrent:()=>this.currentOperationId===o}}stop(){this.doStop(this.currentOperationId)}doStop(I){this.currentOperationId===I&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=C,e.IEditorProgressService=g.createDecorator("editorProgressService")}),define(we[44],_e([0,1,10,39]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class S{constructor(){this.data=new Map}add(k,D){T.ok(g.isString(k)),T.ok(g.isObject(D)),T.ok(!this.data.has(k),"There is already an extension with this id"),this.data.set(k,D)}knows(k){return this.data.has(k)}as(k){return this.data.get(k)||null}}e.Registry=new S}),define(we[150],_e([0,1,44,3]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function S(D){return D.length>0&&D.charAt(D.length-1)==="#"?D.substring(0,D.length-1):D}class E{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(_,C){this.schemasById[S(_)]=C,this._onDidChangeSchema.fire(_)}notifySchemaChanged(_){this._onDidChangeSchema.fire(_)}getSchemaContributions(){return{schemas:this.schemasById}}}const k=new E;g.Registry.add(e.Extensions.JSONContribution,k)}),define(we[61],_e([0,1,124,3,44,10,150]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var D;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(D=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const _=S.Registry.as(k.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new T.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new T.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:g.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,p=!0){this.registerConfigurations([b],p)}registerConfigurations(b,p=!0){const l=[];b.forEach(f=>{l.push(...this.validateAndRegisterProperties(f,p,f.extensionInfo)),this.configurationContributors.push(f),this.registerJSONConfiguration(f)}),_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterConfigurations(b){const p=[],l=f=>{if(f.properties)for(const m in f.properties)p.push(m),delete this.configurationProperties[m],this.removeFromSchema(m,f.properties[m]);f.allOf&&f.allOf.forEach(m=>l(m))};for(const f of b){l(f);const m=this.configurationContributors.indexOf(f);m!==-1&&this.configurationContributors.splice(m,1)}_.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}registerDefaultConfigurations(b){const p=[],l=[];for(const f of b)for(const m in f)if(p.push(m),e.OVERRIDE_PROPERTY_PATTERN.test(m)){this.defaultValues[m]=Object.assign(Object.assign({},this.defaultValues[m]||{}),f[m]);const t={type:"object",default:this.defaultValues[m],description:g.localize(1,null,m),$ref:e.resourceLanguageSettingsSchemaId};l.push(I(m)),this.configurationProperties[m]=t,this.defaultLanguageConfigurationOverridesNode.properties[m]=t}else{this.defaultValues[m]=f[m];const t=this.configurationProperties[m];t&&(this.updatePropertyDefaultValue(m,t),this.updateSchema(m,t))}this.registerOverrideIdentifiers(l),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}deregisterDefaultConfigurations(b){const p=[];for(const l of b)for(const f in l)if(p.push(f),delete this.defaultValues[f],e.OVERRIDE_PROPERTY_PATTERN.test(f))delete this.configurationProperties[f],delete this.defaultLanguageConfigurationOverridesNode.properties[f];else{const m=this.configurationProperties[f];m&&(this.updatePropertyDefaultValue(f,m),this.updateSchema(f,m))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(p)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const p of b)this.overrideIdentifiers.add(p);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,p=!0,l,f=3){var m;f=E.isUndefinedOrNull(b.scope)?f:b.scope;let t=[],r=b.properties;if(r)for(let i in r){if(p&&c(i)){delete r[i];continue}const u=r[i];if(this.updatePropertyDefaultValue(i,u),e.OVERRIDE_PROPERTY_PATTERN.test(i)?u.scope=void 0:(u.scope=E.isUndefinedOrNull(u.scope)?f:u.scope,u.restricted=E.isUndefinedOrNull(u.restricted)?!!((m=l==null?void 0:l.restrictedConfigurations)===null||m===void 0?void 0:m.includes(i)):u.restricted),r[i].hasOwnProperty("included")&&!r[i].included){this.excludedConfigurationProperties[i]=r[i],delete r[i];continue}else this.configurationProperties[i]=r[i];!r[i].deprecationMessage&&r[i].markdownDeprecationMessage&&(r[i].deprecationMessage=r[i].markdownDeprecationMessage),t.push(i)}let s=b.allOf;if(s)for(let i of s)t.push(...this.validateAndRegisterProperties(i,p,l,f));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const p=l=>{let f=l.properties;if(f)for(const t in f)this.updateSchema(t,f[t]);let m=l.allOf;m&&m.forEach(p)};p(b)}updateSchema(b,p){switch(e.allSettings.properties[b]=p,p.scope){case 1:e.applicationSettings.properties[b]=p;break;case 2:e.machineSettings.properties[b]=p;break;case 6:e.machineOverridableSettings.properties[b]=p;break;case 3:e.windowSettings.properties[b]=p;break;case 4:e.resourceSettings.properties[b]=p;break;case 5:e.resourceSettings.properties[b]=p,this.resourceLanguageSettingsSchema.properties[b]=p;break}}removeFromSchema(b,p){switch(delete e.allSettings.properties[b],p.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const p=`[${b}]`,l={type:"object",description:g.localize(2,null),errorMessage:g.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(p,l),e.allSettings.properties[p]=l,e.applicationSettings.properties[p]=l,e.machineSettings.properties[p]=l,e.machineOverridableSettings.properties[p]=l,e.windowSettings.properties[p]=l,e.resourceSettings.properties[p]=l}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,p){let l=this.defaultValues[b];E.isUndefined(l)&&(l=p.default),E.isUndefined(l)&&(l=o(p.type)),p.default=l}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function I(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=I;function o(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const h=new C;S.Registry.add(e.Extensions.Configuration,h);function c(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?g.localize(5,null,y):h.getConfigurationProperties()[y]!==void 0?g.localize(6,null,y):null:g.localize(4,null)}e.validateProperty=c;function d(){const y=[],b=h.getConfigurationProperties();for(const p of Object.keys(b))y.push([p,b[p].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=d}),define(we[91],_e([0,1,24,10,2,44,4,61]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=k.createDecorator("configurationService");function _(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof S.URI)}e.isConfigurationOverrides=_;var C;(function(r){r[r.USER=1]="USER",r[r.USER_LOCAL=2]="USER_LOCAL",r[r.USER_REMOTE=3]="USER_REMOTE",r[r.WORKSPACE=4]="WORKSPACE",r[r.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",r[r.DEFAULT=6]="DEFAULT",r[r.MEMORY=7]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(r){switch(r){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function I(r,s){const i=s?r?s.keys.filter(R=>r.keys.indexOf(R)===-1):[...s.keys]:[],u=r?s?r.keys.filter(R=>s.keys.indexOf(R)===-1):[...r.keys]:[],w=[];if(s&&r){for(const R of r.keys)if(s.keys.indexOf(R)!==-1){const L=b(r.contents,R),H=b(s.contents,R);g.equals(L,H)||w.push(R)}}const v=[],P=R=>{const L={};for(const H of R)for(const ue of H.identifiers)L[m(ue)]=H;return L},A=s?P(s.overrides):{},a=r?P(r.overrides):{};if(Object.keys(A).length)for(const R of i){const L=A[R];L&&v.push([D.overrideIdentifierFromKey(R),L.keys])}if(Object.keys(a).length)for(const R of u){const L=a[R];L&&v.push([D.overrideIdentifierFromKey(R),L.keys])}if(Object.keys(A).length&&Object.keys(a).length)for(const R of w){const L=a[R],H=A[R];if(L&&H){const ue=I({contents:L.contents,keys:L.keys,overrides:[]},{contents:H.contents,keys:H.keys,overrides:[]});v.push([D.overrideIdentifierFromKey(R),[...ue.added,...ue.removed,...ue.updated]])}}return{added:i,removed:u,updated:w,overrides:v}}e.compare=I;function o(r,s){const i=[];for(const u of Object.keys(r))if(D.OVERRIDE_PROPERTY_PATTERN.test(u)){const w={};for(const v in r[u])w[v]=r[u][v];i.push({identifiers:[D.overrideIdentifierFromKey(u).trim()],keys:Object.keys(w),contents:h(w,s)})}return i}e.toOverrides=o;function h(r,s){const i=Object.create(null);for(let u in r)c(i,u,r[u],s);return i}e.toValuesTree=h;function c(r,s,i,u){const w=s.split("."),v=w.pop();let P=r;for(let A=0;A<w.length;A++){let a=w[A],R=P[a];switch(typeof R){case"undefined":R=P[a]=Object.create(null);break;case"object":break;default:u(`Ignoring ${s} as ${w.slice(0,A+1).join(".")} is ${JSON.stringify(R)}`);return}P=R}if(typeof P=="object"&&P!==null)try{P[v]=i}catch(A){u(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(P)}`)}else u(`Ignoring ${s} as ${w.join(".")} is ${JSON.stringify(P)}`)}e.addToValueTree=c;function d(r,s){const i=s.split(".");y(r,i)}e.removeFromValueTree=d;function y(r,s){const i=s.shift();if(s.length===0){delete r[i];return}if(Object.keys(r).indexOf(i)!==-1){const u=r[i];typeof u=="object"&&!Array.isArray(u)&&(y(u,s),Object.keys(u).length===0&&delete r[i])}}function b(r,s,i){function u(P,A){let a=P;for(const R of A){if(typeof a!="object"||a===null)return;a=a[R]}return a}const w=s.split("."),v=u(r,w);return typeof v=="undefined"?i:v}e.getConfigurationValue=b;function p(r,s,i){Object.keys(s).forEach(u=>{u!=="__proto__"&&(u in r?T.isObject(r[u])&&T.isObject(s[u])?p(r[u],s[u],i):i&&(r[u]=s[u]):r[u]=s[u])})}e.merge=p;function l(){const r=E.Registry.as(D.Extensions.Configuration).getConfigurationProperties();return Object.keys(r)}e.getConfigurationKeys=l;function f(){const r=Object.create(null),s=E.Registry.as(D.Extensions.Configuration).getConfigurationProperties();for(let i in s){let u=s[i].default;c(r,i,u,w=>console.error(`Conflict in default settings: ${w}`))}return r}e.getDefaultValues=f;function m(r){return`[${r}]`}e.keyFromOverrideIdentifier=m;function t(r,s,i){const u=r.inspect(s),w=r.inspect(i);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof w.userValue!="undefined"||typeof w.workspaceValue!="undefined"||typeof w.workspaceFolderValue!="undefined"?w.value:u.defaultValue}e.getMigratedSettingValue=t}),define(we[151],_e([0,1,107,22,17,10,24,2,61,91,44,7,3]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class h{constructor(t={},r=[],s=[]){this._contents=t,this._keys=r,this._overrides=s,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?C.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,r){const s=this.getContentsForOverrideIdentifer(r);return s?t?C.getConfigurationValue(s,t):s:void 0}getKeysForOverrideIdentifier(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.keys;return[]}override(t){const r=this.getContentsForOverrideIdentifer(t);if(!r||typeof r!="object"||!Object.keys(r).length)return this;let s={};for(const i of S.distinct([...Object.keys(this.contents),...Object.keys(r)])){let u=this.contents[i],w=r[i];w&&(typeof u=="object"&&typeof w=="object"?(u=k.deepClone(u),this.mergeContents(u,w)):u=w),s[i]=u}return new h(s,this.keys,this.overrides)}merge(...t){const r=k.deepClone(this.contents),s=k.deepClone(this.overrides),i=[...this.keys];for(const u of t){this.mergeContents(r,u.contents);for(const w of u.overrides){const[v]=s.filter(P=>S.equals(P.identifiers,w.identifiers));v?this.mergeContents(v.contents,w.contents):s.push(k.deepClone(w))}for(const w of u.keys)i.indexOf(w)===-1&&i.push(w)}return new h(r,i,s)}freeze(){return this.isFrozen=!0,this}mergeContents(t,r){for(const s of Object.keys(r)){if(s in t&&E.isObject(t[s])&&E.isObject(r[s])){this.mergeContents(t[s],r[s]);continue}t[s]=k.deepClone(r[s])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?k.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const r of this.overrides)if(r.identifiers.indexOf(t)!==-1)return r.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,r){this.addKey(t),C.addToValueTree(this.contents,t,r,s=>{throw new Error(s)})}removeValue(t){this.removeKey(t)&&C.removeFromValueTree(this.contents,t)}addKey(t){let r=this.keys.length;for(let s=0;s<r;s++)t.indexOf(this.keys[s])===0&&(r=s);this.keys.splice(r,1,t)}removeKey(t){let r=this.keys.indexOf(t);return r!==-1?(this.keys.splice(r,1),!0):!1}}e.ConfigurationModel=h;class c extends h{constructor(){const t=C.getDefaultValues(),r=C.getConfigurationKeys(),s=[];for(const i of Object.keys(t))_.OVERRIDE_PROPERTY_PATTERN.test(i)&&s.push({identifiers:[_.overrideIdentifierFromKey(i).trim()],keys:Object.keys(t[i]),contents:C.toValuesTree(t[i],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,r,s)}}e.DefaultConfigurationModel=c;class d{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new h}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,r){if(!E.isUndefinedOrNull(t)){const s=this.doParseContent(t);this.parseRaw(s,r)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,r){this._raw=t;const{contents:s,keys:i,overrides:u,restricted:w}=this.doParseRaw(t,r);this._configurationModel=new h(s,i,u),this._restrictedConfigurations=w||[]}doParseContent(t){let r={},s=null,i=[],u=[],w=[];function v(A){Array.isArray(i)?i.push(A):s&&(i[s]=A)}let P={onObjectBegin:()=>{let A={};v(A),u.push(i),i=A,s=null},onObjectProperty:A=>{s=A},onObjectEnd:()=>{i=u.pop()},onArrayBegin:()=>{let A=[];v(A),u.push(i),i=A,s=null},onArrayEnd:()=>{i=u.pop()},onLiteralValue:v,onError:(A,a,R)=>{w.push({error:A,offset:a,length:R})}};if(t)try{g.visit(t,P),r=i[0]||{}}catch(A){console.error(`Error while parsing settings file ${this._name}: ${A}`),this._parseErrors=[A]}return r}doParseRaw(t,r){const s=n.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),i=this.filter(t,s,!0,r);t=i.raw;const u=C.toValuesTree(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`)),w=Object.keys(t),v=C.toOverrides(t,P=>console.error(`Conflict in settings file ${this._name}: ${P}`));return{contents:u,keys:w,overrides:v,restricted:i.restricted}}filter(t,r,s,i){if(!(i==null?void 0:i.scopes)&&!(i==null?void 0:i.skipRestricted))return{raw:t,restricted:[]};const u={},w=[];for(let v in t)if(_.OVERRIDE_PROPERTY_PATTERN.test(v)&&s){const P=this.filter(t[v],r,!1,i);u[v]=P.raw,w.push(...P.restricted)}else{const P=r[v],A=P?typeof P.scope!="undefined"?P.scope:3:void 0;(P==null?void 0:P.restricted)&&w.push(v),(A===void 0||i.scopes===void 0||i.scopes.includes(A))&&(i.skipRestricted&&(P==null?void 0:P.restricted)||(u[v]=t[v]))}return{raw:u,restricted:w}}}e.ConfigurationModelParser=d;class y extends I.Disposable{constructor(t,r,s,i){super();this.userSettingsResource=t,this.scopes=r,this.fileService=i,this._onDidChange=this._register(new o.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(o.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new h}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=y;class b{constructor(t,r,s=new h,i=new h,u=new T.ResourceMap,w=new h,v=new T.ResourceMap,P=!0){this._defaultConfiguration=t,this._localUserConfiguration=r,this._remoteUserConfiguration=s,this._workspaceConfiguration=i,this._folderConfigurations=u,this._memoryConfiguration=w,this._memoryConfigurationByResource=v,this._freeze=P,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new T.ResourceMap,this._userConfiguration=null}getValue(t,r,s){return this.getConsolidateConfigurationModel(r,s).getValue(t)}updateValue(t,r,s={}){let i;s.resource?(i=this._memoryConfigurationByResource.get(s.resource),i||(i=new h,this._memoryConfigurationByResource.set(s.resource,i))):i=this._memoryConfiguration,r===void 0?i.removeValue(t):i.setValue(t,r),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,r,s){const i=this.getConsolidateConfigurationModel(r,s),u=this.getFolderConfigurationModelForResource(r.resource,s),w=r.resource?this._memoryConfigurationByResource.get(r.resource)||this._memoryConfiguration:this._memoryConfiguration,v=r.overrideIdentifier?this._defaultConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),P=r.overrideIdentifier?this.userConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),A=r.overrideIdentifier?this.localUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),a=r.overrideIdentifier?this.remoteUserConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),R=s?r.overrideIdentifier?this._workspaceConfiguration.freeze().override(r.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,L=u?r.overrideIdentifier?u.freeze().override(r.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,H=r.overrideIdentifier?w.override(r.overrideIdentifier).getValue(t):w.getValue(t),ue=i.getValue(t),me=S.distinct(S.flatten(i.overrides.map(J=>J.identifiers))).filter(J=>i.getOverrideValue(t,J)!==void 0);return{defaultValue:v,userValue:P,userLocalValue:A,userRemoteValue:a,workspaceValue:R,workspaceFolderValue:L,memoryValue:H,value:ue,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,user:P!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userLocal:A!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,userRemote:a!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspace:R!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:r.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,workspaceFolder:L!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:r.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:w.getValue(t),override:r.overrideIdentifier?w.getOverrideValue(t,r.overrideIdentifier):void 0}:void 0,overrideIdentifiers:me.length?me:void 0}}keys(t){const r=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:r?r.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,r){this._folderConfigurations.set(t,r),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,r){const s=r.filter(i=>_.OVERRIDE_PROPERTY_PATTERN.test(i)).map(i=>{const u=_.overrideIdentifierFromKey(i),w=this._defaultConfiguration.getKeysForOverrideIdentifier(u),v=t.getKeysForOverrideIdentifier(u),P=[...v.filter(A=>w.indexOf(A)===-1),...w.filter(A=>v.indexOf(A)===-1),...w.filter(A=>!k.equals(this._defaultConfiguration.override(u).getValue(A),t.override(u).getValue(A)))];return[u,P]});return this.updateDefaultConfiguration(t),{keys:r,overrides:s}}compareAndUpdateLocalUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:u}=C.compare(this.localUserConfiguration,t),w=[...r,...s,...i];return w.length&&this.updateLocalUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:r,updated:s,removed:i,overrides:u}=C.compare(this.remoteUserConfiguration,t);let w=[...r,...s,...i];return w.length&&this.updateRemoteUserConfiguration(t),{keys:w,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:r,updated:s,removed:i,overrides:u}=C.compare(this.workspaceConfiguration,t);let w=[...r,...s,...i];return w.length&&this.updateWorkspaceConfiguration(t),{keys:w,overrides:u}}compareAndUpdateFolderConfiguration(t,r){const s=this.folderConfigurations.get(t),{added:i,updated:u,removed:w,overrides:v}=C.compare(s,r);let P=[...i,...u,...w];return(P.length||!s)&&this.updateFolderConfiguration(t,r),{keys:P,overrides:v}}compareAndDeleteFolderConfiguration(t){const r=this.folderConfigurations.get(t);if(!r)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:i,removed:u,overrides:w}=C.compare(r,void 0);return{keys:[...s,...i,...u],overrides:w}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,r){let s=this.getConsolidatedConfigurationModelForResource(t,r);return t.overrideIdentifier?s.override(t.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:t},r){let s=this.getWorkspaceConsolidatedConfiguration();if(r&&t){const i=r.getFolder(t);i&&(s=this.getFolderConsolidatedConfiguration(i.uri)||s);const u=this._memoryConfigurationByResource.get(t);u&&(s=s.merge(u))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let r=this._foldersConsolidatedConfigurations.get(t);if(!r){const s=this.getWorkspaceConsolidatedConfiguration(),i=this._folderConfigurations.get(t);i?(r=s.merge(i),this._freeze&&(r=r.freeze()),this._foldersConsolidatedConfigurations.set(t,r)):r=s}return r}getFolderConfigurationModelForResource(t,r){if(r&&t){const s=r.getFolder(t);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,r)=>{const{contents:s,overrides:i,keys:u}=this._folderConfigurations.get(r);return t.push([r,{contents:s,overrides:i,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(r=>t.add(r)),this.userConfiguration.freeze().keys.forEach(r=>t.add(r)),this._workspaceConfiguration.freeze().keys.forEach(r=>t.add(r)),this._folderConfigurations.forEach(r=>r.freeze().keys.forEach(s=>t.add(s))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const r=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>r.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(i=>r.add(i))),[...r.values()]}static parse(t){const r=this.parseConfigurationModel(t.defaults),s=this.parseConfigurationModel(t.user),i=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((w,v)=>(w.set(D.URI.revive(v[0]),this.parseConfigurationModel(v[1])),w),new T.ResourceMap);return new b(r,s,new h,i,u,new h,new T.ResourceMap,!1)}static parseConfigurationModel(t){return new h(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=b;function p(...m){if(m.length===0)return{keys:[],overrides:[]};if(m.length===1)return m[0];const t=new Set,r=new Map;for(const i of m)i.keys.forEach(u=>t.add(u)),i.overrides.forEach(([u,w])=>{const v=T.getOrSet(r,u,new Set);w.forEach(P=>v.add(P))});const s=[];return r.forEach((i,u)=>s.push([u,[...i.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=p;class l{constructor(t,r,s,i){this.change=t,this.previous=r,this.currentConfiguraiton=s,this.currentWorkspace=i,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(v=>u.add(v)),t.overrides.forEach(([,v])=>v.forEach(P=>u.add(P))),this.affectedKeys=[...u.values()];const w=new h;this.affectedKeys.forEach(v=>w.setValue(v,{})),this.affectedKeysTree=w.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=b.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,r){var s;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(r){const i=this.previousConfiguration?this.previousConfiguration.getValue(t,r,(s=this.previous)===null||s===void 0?void 0:s.workspace):void 0,u=this.currentConfiguraiton.getValue(t,r,this.currentWorkspace);return!k.equals(i,u)}return!0}return!1}doesAffectedKeysTreeContains(t,r){let s=C.toValuesTree({[r]:!0},()=>{}),i;for(;typeof s=="object"&&(i=Object.keys(s)[0]);){if(t=t[i],!t)return!1;s=s[i]}return!0}}e.ConfigurationChangeEvent=l;class f extends l{constructor(t,r,s,i){super({keys:t.allKeys(),overrides:[]},void 0,t,r);this.source=s,this.sourceConfig=i}}e.AllKeysConfigurationChangeEvent=f}),define(we[92],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=g.createDecorator("remoteAuthorityResolverService");var T;(function(E){E.Unknown="Unknown",E.NotAvailable="NotAvailable",E.TemporarilyNotAvailable="TemporarilyNotAvailable",E.NoResolverFound="NoResolverFound"})(T=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class S extends Error{constructor(k,D=T.Unknown,_){super(k);this._message=k,this._code=D,this._detail=_,this.isHandled=D===T.NotAvailable&&_===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,S.prototype)}static isTemporarilyNotAvailable(k){return k instanceof S&&k._code===T.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof S&&k._code===T.NoResolverFound}static isHandled(k){return k instanceof S&&k.isHandled}}e.RemoteAuthorityResolverError=S}),define(we[93],_e([0,1,16]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function T(C){return C.scheme===g.Schemas.vscodeRemote?C.authority:void 0}e.getRemoteAuthority=T;function S(C){if(!C)return;const n=C.indexOf("+");return n<0?C:C.substr(0,n)}e.getRemoteName=S;function E(C){return C.scheme!==g.Schemas.file&&C.scheme!==g.Schemas.vscodeRemote}e.isVirtualResource=E;function k(C){if(C.folders.length)return C.folders.every(n=>E(n.uri))?C.folders[0].uri:void 0;if(C.configuration&&E(C.configuration))return C.configuration}e.getVirtualWorkspaceLocation=k;function D(C){var n;return(n=k(C))===null||n===void 0?void 0:n.scheme}e.getVirtualWorkspaceScheme=D;function _(C){return k(C)!==void 0}e.isVirtualWorkspace=_}),define(we[152],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class g{constructor(S){this._callback=S,this._terminalBufferMap=new Map}dispose(){for(const S of this._terminalBufferMap.values())S.dispose()}startBuffering(S,E,k=5){let D;return D=E(_=>{const C=typeof _=="string"?_:_.data;let n=this._terminalBufferMap.get(S);if(n){n.data.push(C);return}const I=setTimeout(()=>this.flushBuffer(S),k);n={data:[C],timeoutId:I,dispose:()=>{clearTimeout(I),this.flushBuffer(S),D.dispose()}},this._terminalBufferMap.set(S,n)}),D}stopBuffering(S){const E=this._terminalBufferMap.get(S);E&&E.dispose()}flushBuffer(S){const E=this._terminalBufferMap.get(S);E&&(this._terminalBufferMap.delete(S),this._callback(S,E.data.join("")))}}e.TerminalDataBufferer=g}),define(we[45],_e([0,1,2,25,4,22]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=S.createDecorator("contextService");var k;(function(o){o[o.EMPTY=1]="EMPTY",o[o.FOLDER=2]="FOLDER",o[o.WORKSPACE=3]="WORKSPACE"})(k=e.WorkbenchState||(e.WorkbenchState={}));function D(o){const h=o;return!!(h&&typeof h=="object"&&typeof h.id=="string"&&Array.isArray(h.folders))}e.isWorkspace=D;function _(o){const h=o;return!!(h&&typeof h=="object"&&g.URI.isUri(h.uri)&&typeof h.name=="string"&&typeof h.toResource=="function")}e.isWorkspaceFolder=_;class C{constructor(h,c,d,y){this._id=h,this._configuration=d,this._ignorePathCasing=y,this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=c}update(h){this._id=h.id,this._configuration=h.configuration,this._ignorePathCasing=h._ignorePathCasing,this.folders=h.folders}get folders(){return this._folders}set folders(h){this._folders=h,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(h){this._configuration=h}getFolder(h){return h&&this._foldersMap.findSubstr(h.with({scheme:h.scheme,authority:h.authority,path:h.path}))||null}updateFoldersMap(){this._foldersMap=E.TernarySearchTree.forUris(this._ignorePathCasing);for(const h of this.folders)this._foldersMap.set(h.uri,h)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=C;class n{constructor(h,c){this.raw=c,this.uri=h.uri,this.index=h.index,this.name=h.name}toResource(h){return T.joinPath(this.uri,h)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=n;function I(o){return new n({uri:o,index:0,name:T.basenameOrAuthority(o)},{uri:o.toString()})}e.toWorkspaceFolder=I}),define(we[62],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class g{constructor(S){this.id=S,this._data=new Map,this._idPool=1}add(S){const E=this._idPool++;return this._data.set(E,S),this.logDebugInfo(),E}get(S,E){return this._data.has(S)?this._data.get(S)[E]:void 0}delete(S){this._data.delete(S),this.logDebugInfo()}logDebugInfo(){!g.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=g,g.enableDebugLogging=!1}),define(we[63],_e([0,1,2,3,4]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=S.createDecorator("IExtHostEditorTabs");class E{constructor(){this._onDidChangeTabs=new T.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(D){this._tabs=D.map(_=>({name:_.name,group:_.group,resource:g.URI.revive(_.resource),isActive:_.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=E}),define(we[46],_e([0,1,16,4]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class S{constructor(){this._systemSchemes=new Set(Object.keys(g.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(k,D){D===null?this._providerInfo.delete(k):this._providerInfo.set(k,D)}isFreeScheme(k){return!this._providerInfo.has(k)&&!this._systemSchemes.has(k)}getCapabilities(k){return this._providerInfo.get(k)}}e.ExtHostFileSystemInfo=S,e.IExtHostFileSystemInfo=T.createDecorator("IExtHostFileSystemInfo")}),define(we[28],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=g.createDecorator("IExtHostInitDataService")}),define(we[153],_e([0,1,12]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class T{constructor(k,D,_){this._deferredPromises=new Map,this._id=k,this._shared=D,this._storage=_,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(C=>(this._value=C,this)),this._storageListener=this._storage.onDidChangeStorage(C=>{C.shared===this._shared&&C.key===this._id&&(this._value=C.value)}),this._scheduler=new g.RunOnceScheduler(()=>{const C=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const n of C.values())n.complete()}catch(n){for(const I of C.values())I.error(n)}})()},0)}get keys(){var k;return Object.entries((k=this._value)!==null&&k!==void 0?k:{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(k,D){let _=this._value[k];return typeof _=="undefined"&&(_=D),_}update(k,D){this._value[k]=D;let _=this._deferredPromises.get(k);if(_!==void 0)return _.p;const C=new g.DeferredPromise;return this._deferredPromises.set(k,C),this._scheduler.isScheduled()||this._scheduler.schedule(),C.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=T;class S extends T{constructor(k,D){super(k.identifier.value,!0,D);this._extension=k}setKeysForSync(k){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},k)}}e.ExtensionGlobalMemento=S}),define(we[154],_e([0,1,3,2,15]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let E=class{constructor(D,_){this._logService=D,this._notebooksAndEditors=_,this._onDidChangeNotebookDocumentMetadata=new g.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new g.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(D,_,C){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D)).acceptModelChanged(_,C)}$acceptDirtyStateChanged(D,_){this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D)).acceptDirty(_)}$acceptModelSaved(D){const _=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D));this._onDidSaveNotebookDocument.fire(_.apiNotebook)}$acceptDocumentPropertiesChanged(D,_){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,_);const C=this._notebooksAndEditors.getNotebookDocument(T.URI.revive(D));C.acceptDocumentPropertiesChanged(_),_.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:C.apiNotebook})}};E=Ve([ze(0,S.ILogService)],E),e.ExtHostNotebookDocuments=E}),define(we[13],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=g.createDecorator("IExtHostRpcService");class T{constructor(E){this.getProxy=E.getProxy.bind(E),this.set=E.set.bind(E),this.assertRegistered=E.assertRegistered.bind(E),this.drain=E.drain.bind(E)}}e.ExtHostRpcService=T});var it=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[155],_e([0,1,26,3]),function(ee,e,g,T){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class E{constructor(D,_){S.set(this,void 0),this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._id=g.ExtensionIdentifier.toKey(D.identifier),it(this,S,_,"f"),Be(this,S,"f").onDidChangePassword(C=>{C.extensionId===this._id&&this._onDidChange.fire({key:C.key})})}get(D){return Be(this,S,"f").get(this._id,D)}store(D,_){return Be(this,S,"f").store(this._id,D,_)}delete(D){return Be(this,S,"f").delete(this._id,D)}}e.ExtensionSecrets=E,S=new WeakMap}),define(we[94],_e([0,1,4,3]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class S{constructor(){this._onDidChangeTelemetryEnabled=new T.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(k){this._enabled=k}$onDidChangeTelemetryEnabled(k){this._enabled=k,this._onDidChangeTelemetryEnabled.fire(k)}}e.ExtHostTelemetry=S,e.IExtHostTelemetry=g.createDecorator("IExtHostTelemetry")}),define(we[64],_e([0,1,3]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var T;(function(k){k[k.NewChild=0]="NewChild",k[k.Disposed=1]="Disposed",k[k.Invalidated=2]="Invalidated",k[k.SetProp=3]="SetProp"})(T=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const S=new WeakMap,E=k=>{let D=S.get(k);return D||(D={children:new Map,bus:new g.Emitter},S.set(k,D)),D};e.getPrivateApiFor=E}),define(we[65],_e([0,1,4,3,13]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var E;(function(D){function _(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public}}D.fromApiTunnel=_;function C(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.public}}D.fromServiceTunnel=C})(E=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=g.createDecorator("IExtHostTunnelService");let k=class{constructor(_){this.onDidChangeTunnels=new T.Emitter().event}async $applyCandidateFilter(_){return _}async openTunnel(_,C){}async getTunnels(){return[]}async setTunnelExtensionFunctions(_){return{dispose:()=>{}}}registerPortsAttributesProvider(_,C){return{dispose:()=>{}}}async $providePortAttributes(_,C,n,I,o){return[]}async $forwardPort(_,C){}async $closeTunnel(_){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};k=Ve([ze(0,S.IExtHostRpcService)],k),e.ExtHostTunnelService=k});var it=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[6],_e([0,1,17,11,80,22,82,10,2,34,59,92,64]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o){"use strict";var h,c,d,y,b,p,l,f,m,t,r,s,i,u,w,v,P,A;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function a(x){function F(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(F,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(F,x),Object.setPrototypeOf(F.prototype,x.prototype),F}let R=b=class{constructor(F){h.set(this,void 0),it(this,h,F,"f")}static from(...F){let ie=F;return new b(function(){if(ie){for(const Se of ie)Se&&typeof Se.dispose=="function"&&Se.dispose();ie=void 0}})}dispose(){typeof Be(this,h,"f")=="function"&&(Be(this,h,"f").call(this),it(this,h,void 0,"f"))}};h=new WeakMap,R=b=Ve([a],R),e.Disposable=R;let L=p=class{constructor(F,ie){if(F<0)throw T.illegalArgument("line must be non-negative");if(ie<0)throw T.illegalArgument("character must be non-negative");this._line=F,this._character=ie}static Min(...F){if(F.length===0)throw new TypeError;let ie=F[0];for(let Se=1;Se<F.length;Se++){const je=F[Se];je.isBefore(ie)&&(ie=je)}return ie}static Max(...F){if(F.length===0)throw new TypeError;let ie=F[0];for(let Se=1;Se<F.length;Se++){const je=F[Se];je.isAfter(ie)&&(ie=je)}return ie}static isPosition(F){if(!F)return!1;if(F instanceof p)return!0;let{line:ie,character:Se}=F;return typeof ie=="number"&&typeof Se=="number"}get line(){return this._line}get character(){return this._character}isBefore(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<F._character}isBeforeOrEqual(F){return this._line<F._line?!0:F._line<this._line?!1:this._character<=F._character}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this._line===F._line&&this._character===F._character}compareTo(F){return this._line<F._line?-1:this._line>F.line?1:this._character<F._character?-1:this._character>F._character?1:0}translate(F,ie=0){if(F===null||ie===null)throw T.illegalArgument();let Se;return typeof F=="undefined"?Se=0:typeof F=="number"?Se=F:(Se=typeof F.lineDelta=="number"?F.lineDelta:0,ie=typeof F.characterDelta=="number"?F.characterDelta:0),Se===0&&ie===0?this:new p(this.line+Se,this.character+ie)}with(F,ie=this.character){if(F===null||ie===null)throw T.illegalArgument();let Se;return typeof F=="undefined"?Se=this.line:typeof F=="number"?Se=F:(Se=typeof F.line=="number"?F.line:this.line,ie=typeof F.character=="number"?F.character:this.character),Se===this.line&&ie===this.character?this:new p(Se,ie)}toJSON(){return{line:this.line,character:this.character}}};L=p=Ve([a],L),e.Position=L;let H=l=class{constructor(F,ie,Se,je){let et,at;if(typeof F=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof je=="number"?(et=new L(F,ie),at=new L(Se,je)):F instanceof L&&ie instanceof L&&(et=F,at=ie),!et||!at)throw new Error("Invalid arguments");et.isBefore(at)?(this._start=et,this._end=at):(this._start=at,this._end=et)}static isRange(F){return F instanceof l?!0:F?L.isPosition(F.start)&&L.isPosition(F.end):!1}get start(){return this._start}get end(){return this._end}contains(F){return F instanceof l?this.contains(F._start)&&this.contains(F._end):F instanceof L?!(F.isBefore(this._start)||this._end.isBefore(F)):!1}isEqual(F){return this._start.isEqual(F._start)&&this._end.isEqual(F._end)}intersection(F){const ie=L.Max(F.start,this._start),Se=L.Min(F.end,this._end);if(!ie.isAfter(Se))return new l(ie,Se)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const ie=L.Min(F.start,this._start),Se=L.Max(F.end,this.end);return new l(ie,Se)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(F,ie=this.end){if(F===null||ie===null)throw T.illegalArgument();let Se;return F?L.isPosition(F)?Se=F:(Se=F.start||this.start,ie=F.end||this.end):Se=this.start,Se.isEqual(this._start)&&ie.isEqual(this.end)?this:new l(Se,ie)}toJSON(){return[this.start,this.end]}};H=l=Ve([a],H),e.Range=H;let ue=f=class extends H{constructor(F,ie,Se,je){let et,at;if(typeof F=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof je=="number"?(et=new L(F,ie),at=new L(Se,je)):F instanceof L&&ie instanceof L&&(et=F,at=ie),!et||!at)throw new Error("Invalid arguments");super(et,at);this._anchor=et,this._active=at}static isSelection(F){return F instanceof f?!0:F?H.isRange(F)&&L.isPosition(F.anchor)&&L.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ue=f=Ve([a],ue),e.Selection=ue;class me{constructor(F,ie,Se){if(typeof F!="string"||F.length===0)throw T.illegalArgument("host");if(typeof ie!="number"||ie===0||Math.round(ie)!==ie)throw T.illegalArgument("port");if(typeof Se!="undefined"&&(typeof Se!="string"||Se.length===0||!/^[0-9A-Za-z\-]+$/.test(Se)))throw T.illegalArgument("connectionToken");this.host=F,this.port=Math.round(ie),this.connectionToken=Se}}e.ResolvedAuthority=me;class J extends Error{constructor(F,ie=I.RemoteAuthorityResolverErrorCode.Unknown,Se){super(F);this._message=F,this._code=ie,this._detail=Se,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,J.prototype)}static NotAvailable(F,ie){return new J(F,I.RemoteAuthorityResolverErrorCode.NotAvailable,ie)}static TemporarilyNotAvailable(F){return new J(F,I.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=J;var z;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(z=e.EndOfLine||(e.EndOfLine={}));var Z;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(Z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let M=m=class{constructor(F,ie){this._range=F,this._newText=ie}static isTextEdit(F){return F instanceof m?!0:F?H.isRange(F)&&typeof F.newText=="string":!1}static replace(F,ie){return new m(F,ie)}static insert(F,ie){return m.replace(new H(F,F),ie)}static delete(F){return m.replace(F,"")}static setEndOfLine(F){const ie=new m(new H(new L(0,0),new L(0,0)),"");return ie.newEol=F,ie}get range(){return this._range}set range(F){if(F&&!H.isRange(F))throw T.illegalArgument("range");this._range=F}get newText(){return this._newText||""}set newText(F){if(F&&typeof F!="string")throw T.illegalArgument("newText");this._newText=F}get newEol(){return this._newEol}set newEol(F){if(F&&typeof F!="number")throw T.illegalArgument("newEol");this._newEol=F}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};M=m=Ve([a],M),e.TextEdit=M;var q;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace"})(q=e.FileEditType||(e.FileEditType={}));let N=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(F,ie,Se,je){this._edits.push({_type:1,from:F,to:ie,options:Se,metadata:je})}createFile(F,ie,Se){this._edits.push({_type:1,from:void 0,to:F,options:ie,metadata:Se})}deleteFile(F,ie,Se){this._edits.push({_type:1,from:F,to:void 0,options:ie,metadata:Se})}replaceNotebookMetadata(F,ie,Se){this._edits.push({_type:3,metadata:Se,uri:F,edit:{editType:5,metadata:ie},notebookMetadata:ie})}replaceNotebookCells(F,ie,Se,je,et){let at,lt,Dt=[],kt;if(Ht.isNotebookRange(ie)&&Nt.isNotebookCellDataArray(Se)&&!Nt.isNotebookCellDataArray(je)?(at=ie.start,lt=ie.end,Dt=Se,kt=je):typeof ie=="number"&&typeof Se=="number"&&Nt.isNotebookCellDataArray(je)&&(at=ie,lt=Se,Dt=je,kt=et),at===void 0||lt===void 0)throw new Error("Invalid arguments");(at!==lt||Dt.length>0)&&this._edits.push({_type:5,uri:F,index:at,count:lt-at,cells:Dt,metadata:kt})}replaceNotebookCellMetadata(F,ie,Se,je){this._edits.push({_type:3,metadata:je,uri:F,edit:{editType:8,index:ie,metadata:Se}})}replace(F,ie,Se,je){this._edits.push({_type:2,uri:F,edit:new M(ie,Se),metadata:je})}insert(F,ie,Se,je){this.replace(F,new H(ie,ie),Se,je)}delete(F,ie,Se){this.replace(F,ie,"",Se)}has(F){return this._edits.some(ie=>ie._type===2&&ie.uri.toString()===F.toString())}set(F,ie){if(ie)for(const Se of ie)Se&&this._edits.push({_type:2,uri:F,edit:Se});else{for(let Se=0;Se<this._edits.length;Se++){const je=this._edits[Se];je._type===2&&je.uri.toString()===F.toString()&&(this._edits[Se]=void 0)}g.coalesceInPlace(this._edits)}}get(F){const ie=[];for(let Se of this._edits)Se._type===2&&Se.uri.toString()===F.toString()&&ie.push(Se.edit);return ie}entries(){const F=new E.ResourceMap;for(let ie of this._edits)if(ie._type===2){let Se=F.get(ie.uri);Se||(Se=[ie.uri,[]],F.set(ie.uri,Se)),Se[1].push(ie.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};N=Ve([a],N),e.WorkspaceEdit=N;let W=t=class{constructor(F){this._tabstop=1,this.value=F||""}static isSnippetString(F){return F instanceof t?!0:F?typeof F.value=="string":!1}static _escape(F){return F.replace(/\$|}|\\/g,"\\$&")}appendText(F){return this.value+=t._escape(F),this}appendTabstop(F=this._tabstop++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,ie=this._tabstop++){if(typeof F=="function"){const Se=new t;Se._tabstop=this._tabstop,F(Se),this._tabstop=Se._tabstop,F=Se.value}else F=t._escape(F);return this.value+="${",this.value+=ie,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,ie=this._tabstop++){const Se=F.map(je=>je.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ie,this.value+="|",this.value+=Se,this.value+="|}",this}appendVariable(F,ie){if(typeof ie=="function"){const Se=new t;Se._tabstop=this._tabstop,ie(Se),this._tabstop=Se._tabstop,ie=Se.value}else typeof ie=="string"&&(ie=ie.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,ie&&(this.value+=":",this.value+=ie),this.value+="}",this}};W=t=Ve([a],W),e.SnippetString=W;var O;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(O=e.DiagnosticTag||(e.DiagnosticTag={}));var B;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(B=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Y=r=class{constructor(F,ie){if(this.uri=F,ie)if(ie instanceof H)this.range=ie;else if(ie instanceof L)this.range=new H(ie,ie);else throw new Error("Illegal argument")}static isLocation(F){return F instanceof r?!0:F?H.isRange(F.range)&&_.URI.isUri(F.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Y=r=Ve([a],Y),e.Location=Y;let he=class{constructor(F,ie){this.location=F,this.message=ie}static is(F){return F?typeof F.message=="string"&&F.location&&H.isRange(F.location.range)&&_.URI.isUri(F.location.uri):!1}static isEqual(F,ie){return F===ie?!0:!F||!ie?!1:F.message===ie.message&&F.location.range.isEqual(ie.location.range)&&F.location.uri.toString()===ie.location.uri.toString()}};he=Ve([a],he),e.DiagnosticRelatedInformation=he;let De=class{constructor(F,ie,Se=B.Error){if(!H.isRange(F))throw new TypeError("range must be set");if(!ie)throw new TypeError("message must be set");this.range=F,this.message=ie,this.severity=Se}toJSON(){return{severity:B[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,ie){return F===ie?!0:!F||!ie?!1:F.message===ie.message&&F.severity===ie.severity&&F.code===ie.code&&F.severity===ie.severity&&F.source===ie.source&&F.range.isEqual(ie.range)&&g.equals(F.tags,ie.tags)&&g.equals(F.relatedInformation,ie.relatedInformation,he.isEqual)}};De=Ve([a],De),e.Diagnostic=De;let Oe=class{constructor(F,ie){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:S.isMarkdownString(F)?this.contents=[F]:this.contents=[F],this.range=ie}};Oe=Ve([a],Oe),e.Hover=Oe;var Me;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Me=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let He=class{constructor(F,ie=Me.Text){this.range=F,this.kind=ie}toJSON(){return{range:this.range,kind:Me[this.kind]}}};He=Ve([a],He),e.DocumentHighlight=He;var Ye;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(Ye=e.SymbolKind||(e.SymbolKind={}));var qe;(function(x){x[x.Deprecated=1]="Deprecated"})(qe=e.SymbolTag||(e.SymbolTag={}));let Xe=s=class{constructor(F,ie,Se,je,et){this.name=F,this.kind=ie,this.containerName=et,typeof Se=="string"&&(this.containerName=Se),je instanceof Y?this.location=je:Se instanceof H&&(this.location=new Y(je,Se)),s.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Ye[this.kind],location:this.location,containerName:this.containerName}}};Xe=s=Ve([a],Xe),e.SymbolInformation=Xe;let $=i=class{constructor(F,ie,Se,je,et){this.name=F,this.detail=ie,this.kind=Se,this.range=je,this.selectionRange=et,this.children=[],i.validate(this)}static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children&&F.children.forEach(i.validate)}};$=i=Ve([a],$),e.DocumentSymbol=$;var G;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(G=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let te=class{constructor(F,ie){this.title=F,this.kind=ie}};te=Ve([a],te),e.CodeAction=te;let re=u=class{constructor(F){this.value=F}append(F){return new u(this.value?this.value+u.sep+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+u.sep)}};re.sep=".",re=u=Ve([a],re),e.CodeActionKind=re,re.Empty=new re(""),re.QuickFix=re.Empty.append("quickfix"),re.Refactor=re.Empty.append("refactor"),re.RefactorExtract=re.Refactor.append("extract"),re.RefactorInline=re.Refactor.append("inline"),re.RefactorRewrite=re.Refactor.append("rewrite"),re.Source=re.Empty.append("source"),re.SourceOrganizeImports=re.Source.append("organizeImports"),re.SourceFixAll=re.Source.append("fixAll");let K=class{constructor(F,ie){if(this.range=F,this.parent=ie,ie&&!ie.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};K=Ve([a],K),e.SelectionRange=K;class oe{constructor(F,ie,Se,je,et,at){this.kind=F,this.name=ie,this.detail=Se,this.uri=je,this.range=et,this.selectionRange=at}}e.CallHierarchyItem=oe;class fe{constructor(F,ie){this.fromRanges=ie,this.from=F}}e.CallHierarchyIncomingCall=fe;class Ae{constructor(F,ie){this.fromRanges=ie,this.to=F}}e.CallHierarchyOutgoingCall=Ae;let $e=class{constructor(F,ie){this.range=F,this.command=ie}get isResolved(){return!!this.command}};$e=Ve([a],$e),e.CodeLens=$e;let pe=w=class{constructor(F,ie=!1){c.set(this,void 0),it(this,c,new S.MarkdownString(F,{supportThemeIcons:ie}),"f")}static isMarkdownString(F){return F instanceof w?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}get value(){return Be(this,c,"f").value}set value(F){Be(this,c,"f").value=F}get isTrusted(){return Be(this,c,"f").isTrusted}set isTrusted(F){Be(this,c,"f").isTrusted=F}get supportThemeIcons(){return Be(this,c,"f").supportThemeIcons}appendText(F){return Be(this,c,"f").appendText(F),this}appendMarkdown(F){return Be(this,c,"f").appendMarkdown(F),this}appendCodeblock(F,ie){return Be(this,c,"f").appendCodeblock(ie??"",F),this}};c=new WeakMap,pe=w=Ve([a],pe),e.MarkdownString=pe;let Ge=class{constructor(F,ie){this.label=F,this.documentation=ie}};Ge=Ve([a],Ge),e.ParameterInformation=Ge;let j=class{constructor(F,ie){this.label=F,this.documentation=ie,this.parameters=[]}};j=Ve([a],j),e.SignatureInformation=j;let ne=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ne=Ve([a],ne),e.SignatureHelp=ne;var ge;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(ge=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Fe;(function(x){x[x.Other=0]="Other",x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(Fe=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(F,ie,Se){this.text=F,this.position=ie,this.kind=Se}};Ne=Ve([a],Ne),e.InlayHint=Ne;var Qe;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Qe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ee;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ee=e.CompletionItemKind||(e.CompletionItemKind={}));var be;(function(x){x[x.Deprecated=1]="Deprecated"})(be=e.CompletionItemTag||(e.CompletionItemTag={}));let Ce=class{constructor(F,ie){this.label=F,this.kind=ie}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&Ee[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ce=Ve([a],Ce),e.CompletionItem=Ce;let se=class{constructor(F=[],ie=!1){this.items=F,this.isIncomplete=ie}};se=Ve([a],se),e.CompletionList=se;let de=class{constructor(F,ie,Se){this.text=F,this.range=ie,this.command=Se}};de=Ve([a],de),e.InlineSuggestion=de;let U=class{constructor(F){this.items=F}};U=Ve([a],U),e.InlineSuggestions=U;var Q;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(Q=e.ViewColumn||(e.ViewColumn={}));var le;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(le=e.StatusBarAlignment||(e.StatusBarAlignment={}));var ke;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(ke=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ue;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Ue=e.TextEditorRevealType||(e.TextEditorRevealType={}));var We;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(We=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Ze;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Ze=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function F(ie){switch(ie){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=F}(We=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let rt=class{constructor(F,ie){if(ie&&!_.URI.isUri(ie))throw T.illegalArgument("target");if(!H.isRange(F)||F.isEmpty)throw T.illegalArgument("range");this.range=F,this.target=ie}};rt=Ve([a],rt),e.DocumentLink=rt;let Ke=class{constructor(F,ie,Se,je){this.red=F,this.green=ie,this.blue=Se,this.alpha=je}};Ke=Ve([a],Ke),e.Color=Ke;let Je=class{constructor(F,ie){if(ie&&!(ie instanceof Ke))throw T.illegalArgument("color");if(!H.isRange(F)||F.isEmpty)throw T.illegalArgument("range");this.range=F,this.color=ie}};Je=Ve([a],Je),e.ColorInformation=Je;let ft=class{constructor(F){if(!F||typeof F!="string")throw T.illegalArgument("label");this.label=F}};ft=Ve([a],ft),e.ColorPresentation=ft;var ve;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(ve=e.ColorFormat||(e.ColorFormat={}));var ye;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(ye=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class ae{constructor(F,ie,Se){if(this.startIndex=F,this.length=ie,this.tooltip=Se,typeof F!="number"||F<0)throw T.illegalArgument("startIndex");if(typeof ie!="number"||ie<1)throw T.illegalArgument("length");if(Se!==void 0&&typeof Se!="string")throw T.illegalArgument("tooltip")}}e.TerminalLink=ae;class V{constructor(F){this.options=F,typeof F!="object"&&T.illegalArgument("options")}}e.TerminalProfile=V;var xe;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(xe=e.TaskRevealKind||(e.TaskRevealKind={}));var Te;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Te=e.TaskPanelKind||(e.TaskPanelKind={}));let Re=v=class{constructor(F,ie){if(typeof F!="string"||typeof ie!="string")throw T.illegalArgument("name");this._id=F}static from(F){switch(F){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}get id(){return this._id}};Re.Clean=new v("clean","Clean"),Re.Build=new v("build","Build"),Re.Rebuild=new v("rebuild","Rebuild"),Re.Test=new v("test","Test"),Re=v=Ve([a],Re),e.TaskGroup=Re;function nt(x){let F="";for(let ie=0;ie<x.length;ie++)F+=x[ie].replace(/,/g,",,")+",";return F}let ot=class{constructor(F,ie,Se){if(typeof F!="string")throw T.illegalArgument("process");this._args=[],this._process=F,ie!==void 0&&(Array.isArray(ie)?(this._args=ie,this._options=Se):this._options=ie)}get process(){return this._process}set process(F){if(typeof F!="string")throw T.illegalArgument("process");this._process=F}get args(){return this._args}set args(F){Array.isArray(F)||(F=[]),this._args=F}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("process"),this._process!==void 0&&F.push(this._process),this._args&&this._args.length>0)for(let ie of this._args)F.push(ie);return nt(F)}};ot=Ve([a],ot),e.ProcessExecution=ot;let tt=class{constructor(F,ie,Se){if(this._args=[],Array.isArray(ie)){if(!F)throw T.illegalArgument("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw T.illegalArgument("command");this._command=F,this._args=ie,this._options=Se}else{if(typeof F!="string")throw T.illegalArgument("commandLine");this._commandLine=F,this._options=ie}}get commandLine(){return this._commandLine}set commandLine(F){if(typeof F!="string")throw T.illegalArgument("commandLine");this._commandLine=F}get command(){return this._command?this._command:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw T.illegalArgument("command");this._command=F}get args(){return this._args}set args(F){this._args=F||[]}get options(){return this._options}set options(F){this._options=F}computeId(){const F=[];if(F.push("shell"),this._commandLine!==void 0&&F.push(this._commandLine),this._command!==void 0&&F.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ie of this._args)F.push(typeof ie=="string"?ie:ie.value);return nt(F)}};tt=Ve([a],tt),e.ShellExecution=tt;var vt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(vt=e.ShellQuoting||(e.ShellQuoting={}));var gt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(gt=e.TaskScope||(e.TaskScope={}));class pt{constructor(F){this._callback=F}computeId(){return"customExecution"+C.generateUuid()}set callback(F){this._callback=F}get callback(){return this._callback}}e.CustomExecution=pt;let wt=P=class{constructor(F,ie,Se,je,et,at){this.__deprecated=!1,this._definition=this.definition=F;let lt;typeof ie=="string"?(this._name=this.name=ie,this._source=this.source=Se,this.execution=je,lt=et,this.__deprecated=!0):ie===gt.Global||ie===gt.Workspace?(this.target=ie,this._name=this.name=Se,this._source=this.source=je,this.execution=et,lt=at):(this.target=ie,this._name=this.name=Se,this._source=this.source=je,this.execution=et,lt=at),typeof lt=="string"?(this._problemMatchers=[lt],this._hasDefinedMatchers=!0):Array.isArray(lt)?(this._problemMatchers=lt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(F){this.__id=F}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof ot?this._definition={type:P.ProcessType,id:this._execution.computeId()}:this._execution instanceof tt?this._definition={type:P.ShellType,id:this._execution.computeId()}:this._execution instanceof pt?this._definition={type:P.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:P.EmptyType,id:C.generateUuid()}}get definition(){return this._definition}set definition(F){if(F==null)throw T.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=F}get scope(){return this._scope}set target(F){this.clear(),this._scope=F}get name(){return this._name}set name(F){if(typeof F!="string")throw T.illegalArgument("name");this.clear(),this._name=F}get execution(){return this._execution}set execution(F){F===null&&(F=void 0),this.clear(),this._execution=F;const ie=this._definition.type;(P.EmptyType===ie||P.ProcessType===ie||P.ShellType===ie||P.ExtensionCallbackType===ie)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(F){if(Array.isArray(F))this.clear(),this._problemMatchers=F,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.clear(),this._isBackground=F}get source(){return this._source}set source(F){if(typeof F!="string"||F.length===0)throw T.illegalArgument("source must be a string of length > 0");this.clear(),this._source=F}get group(){return this._group}set group(F){F===null&&(F=void 0),this.clear(),this._group=F}get detail(){return this._detail}set detail(F){F===null&&(F=void 0),this._detail=F}get presentationOptions(){return this._presentationOptions}set presentationOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._presentationOptions=F}get runOptions(){return this._runOptions}set runOptions(F){F==null&&(F=Object.create(null)),this.clear(),this._runOptions=F}};wt.ExtensionCallbackType="customExecution",wt.ProcessType="process",wt.ShellType="shell",wt.EmptyType="$empty",wt=P=Ve([a],wt),e.Task=wt;var Tt;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(Tt=e.ProgressLocation||(e.ProgressLocation={}));let Pt=class{constructor(F,ie=Et.None){this.collapsibleState=ie,_.URI.isUri(F)?this.resourceUri=F:this.label=F}};Pt=Ve([a],Pt),e.TreeItem=Pt;var Et;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(Et=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ut=class{constructor(F,ie){this.id=F,this.color=ie}};ut=Ve([a],ut),e.ThemeIcon=ut,ut.File=new ut("file"),ut.Folder=new ut("folder");let mt=class{constructor(F){this.id=F}};mt=Ve([a],mt),e.ThemeColor=mt;var _t;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(_t=e.ConfigurationTarget||(e.ConfigurationTarget={}));let Ft=class{constructor(F,ie){if(typeof F!="string"&&(!F||!_.URI.isUri(F)&&!_.URI.isUri(F.uri)))throw T.illegalArgument("base");if(typeof ie!="string")throw T.illegalArgument("pattern");typeof F=="string"?(this.baseFolder=_.URI.file(F),this.base=F):_.URI.isUri(F)?(this.baseFolder=F,this.base=F.fsPath):(this.baseFolder=F.uri,this.base=F.uri.fsPath),this.pattern=ie}};Ft=Ve([a],Ft),e.RelativePattern=Ft;let yt=class{constructor(F,ie,Se,je){this.enabled=typeof F=="boolean"?F:!0,typeof ie=="string"&&(this.condition=ie),typeof Se=="string"&&(this.hitCondition=Se),typeof je=="string"&&(this.logMessage=je)}get id(){return this._id||(this._id=C.generateUuid()),this._id}};yt=Ve([a],yt),e.Breakpoint=yt;let Zt=class extends yt{constructor(F,ie,Se,je,et){super(ie,Se,je,et);if(F===null)throw T.illegalArgument("location");this.location=F}};Zt=Ve([a],Zt),e.SourceBreakpoint=Zt;let qt=class extends yt{constructor(F,ie,Se,je,et){super(ie,Se,je,et);this.functionName=F}};qt=Ve([a],qt),e.FunctionBreakpoint=qt;let St=class extends yt{constructor(F,ie,Se,je,et,at,lt){super(je,et,at,lt);if(!ie)throw T.illegalArgument("dataId");this.label=F,this.dataId=ie,this.canPersist=Se}};St=Ve([a],St),e.DataBreakpoint=St;let en=class{constructor(F,ie,Se){this.command=F,this.args=ie||[],this.options=Se}};en=Ve([a],en),e.DebugAdapterExecutable=en;let tn=class{constructor(F,ie){this.port=F,this.host=ie}};tn=Ve([a],tn),e.DebugAdapterServer=tn;let ht=class{constructor(F){this.path=F}};ht=Ve([a],ht),e.DebugAdapterNamedPipeServer=ht;let Gt=class{constructor(F){this.implementation=F}};Gt=Ve([a],Gt),e.DebugAdapterInlineImplementation=Gt;let $t=class{constructor(F,ie){this.range=F,this.expression=ie}};$t=Ve([a],$t),e.EvaluatableExpression=$t;var Cn;(function(x){x[x.Automatic=0]="Automatic",x[x.Explicit=1]="Explicit"})(Cn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let nn=class{constructor(F,ie){this.range=F,this.text=ie}};nn=Ve([a],nn),e.InlineValueText=nn;let Ct=class{constructor(F,ie,Se=!0){this.range=F,this.variableName=ie,this.caseSensitiveLookup=Se}};Ct=Ve([a],Ct),e.InlineValueVariableLookup=Ct;let Kt=class{constructor(F,ie){this.range=F,this.expression=ie}};Kt=Ve([a],Kt),e.InlineValueEvaluatableExpression=Kt;let rn=class{constructor(F,ie){this.frameId=F,this.stoppedLocation=ie}};rn=Ve([a],rn),e.InlineValueContext=rn;var Qt;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Qt=e.FileChangeType||(e.FileChangeType={}));let ct=A=class extends Error{constructor(F,ie=n.FileSystemProviderErrorCode.Unknown,Se){var je;super(_.URI.isUri(F)?F.toString(!0):F);this.code=(je=Se==null?void 0:Se.name)!==null&&je!==void 0?je:"Unknown",n.markAsFileSystemProviderError(this,ie),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,A.prototype),typeof Error.captureStackTrace=="function"&&typeof Se=="function"&&Error.captureStackTrace(this,Se)}static FileExists(F){return new A(F,n.FileSystemProviderErrorCode.FileExists,A.FileExists)}static FileNotFound(F){return new A(F,n.FileSystemProviderErrorCode.FileNotFound,A.FileNotFound)}static FileNotADirectory(F){return new A(F,n.FileSystemProviderErrorCode.FileNotADirectory,A.FileNotADirectory)}static FileIsADirectory(F){return new A(F,n.FileSystemProviderErrorCode.FileIsADirectory,A.FileIsADirectory)}static NoPermissions(F){return new A(F,n.FileSystemProviderErrorCode.NoPermissions,A.NoPermissions)}static Unavailable(F){return new A(F,n.FileSystemProviderErrorCode.Unavailable,A.Unavailable)}};ct=A=Ve([a],ct),e.FileSystemError=ct;let sn=class{constructor(F,ie,Se){this.start=F,this.end=ie,this.kind=Se}};sn=Ve([a],sn),e.FoldingRange=sn;var Mt;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Mt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wt;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Wt=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var pn;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(pn=e.CommentMode||(e.CommentMode={}));class kn{constructor(F,ie=[]){this.tokenTypes=F,this.tokenModifiers=ie}}e.SemanticTokensLegend=kn;function vn(x){return typeof x=="undefined"||D.isStringArray(x)}class on{constructor(F){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,F){this._hasLegend=!0;for(let ie=0,Se=F.tokenTypes.length;ie<Se;ie++)this._tokenTypeStrToInt.set(F.tokenTypes[ie],ie);for(let ie=0,Se=F.tokenModifiers.length;ie<Se;ie++)this._tokenModifierStrToInt.set(F.tokenModifiers[ie],ie)}}push(F,ie,Se,je,et){if(typeof F=="number"&&typeof ie=="number"&&typeof Se=="number"&&typeof je=="number"&&(typeof et=="number"||typeof et=="undefined"))return typeof et=="undefined"&&(et=0),this._pushEncoded(F,ie,Se,je,et);if(H.isRange(F)&&typeof ie=="string"&&vn(Se))return this._push(F,ie,Se);throw T.illegalArgument()}_push(F,ie,Se){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ie))throw new Error("`tokenType` is not in the provided legend");const je=F.start.line,et=F.start.character,at=F.end.character-F.start.character,lt=this._tokenTypeStrToInt.get(ie);let Dt=0;if(Se)for(const kt of Se){if(!this._tokenModifierStrToInt.has(kt))throw new Error("`tokenModifier` is not in the provided legend");const At=this._tokenModifierStrToInt.get(kt);Dt|=1<<At>>>0}this._pushEncoded(je,et,at,lt,Dt)}_pushEncoded(F,ie,Se,je,et){if(this._dataIsSortedAndDeltaEncoded&&(F<this._prevLine||F===this._prevLine&&ie<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const Dt=this._data.length/5|0;let kt=0,At=0;for(let Rt=0;Rt<Dt;Rt++){let Ot=this._data[5*Rt],mn=this._data[5*Rt+1];Ot===0?(Ot=kt,mn+=At):Ot+=kt,this._data[5*Rt]=Ot,this._data[5*Rt+1]=mn,kt=Ot,At=mn}}let at=F,lt=ie;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(lt-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=lt,this._data[this._dataLen++]=Se,this._data[this._dataLen++]=je,this._data[this._dataLen++]=et,this._prevLine=F,this._prevChar=ie}static _sortAndDeltaEncode(F){let ie=[];const Se=F.length/5|0;for(let lt=0;lt<Se;lt++)ie[lt]=lt;ie.sort((lt,Dt)=>{const kt=F[5*lt],At=F[5*Dt];if(kt===At){const Rt=F[5*lt+1],Ot=F[5*Dt+1];return Rt-Ot}return kt-At});const je=new Uint32Array(F.length);let et=0,at=0;for(let lt=0;lt<Se;lt++){const Dt=5*ie[lt],kt=F[Dt+0],At=F[Dt+1],Rt=F[Dt+2],Ot=F[Dt+3],mn=F[Dt+4],On=kt-et,Wn=On===0?At-at:At,gn=5*lt;je[gn+0]=On,je[gn+1]=Wn,je[gn+2]=Rt,je[gn+3]=Ot,je[gn+4]=mn,et=kt,at=At}return je}build(F){return this._dataIsSortedAndDeltaEncoded?new Yt(new Uint32Array(this._data),F):new Yt(on._sortAndDeltaEncode(this._data),F)}}e.SemanticTokensBuilder=on;class Yt{constructor(F,ie){this.resultId=ie,this.data=F}}e.SemanticTokens=Yt;class xt{constructor(F,ie,Se){this.start=F,this.deleteCount=ie,this.data=Se}}e.SemanticTokensEdit=xt;class In{constructor(F,ie){this.resultId=ie,this.edits=F}}e.SemanticTokensEdits=In;var an;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(an=e.DebugConsoleMode||(e.DebugConsoleMode={}));var ln;(function(x){x[x.Initial=1]="Initial",x[x.Dynamic=2]="Dynamic"})(ln=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Jt=class{constructor(){}};Jt.Back={iconPath:new ut("arrow-left")},Jt=Ve([a],Jt),e.QuickInputButtons=Jt;var Pn;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Pn=e.ExtensionKind||(e.ExtensionKind={}));class Lt{constructor(F,ie,Se){this.badge=F,this.tooltip=ie,this.color=Se}static validate(F){if(F.badge&&F.badge.length!==1&&F.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Lt;let un=class{constructor(F){this.kind=F}};un=Ve([a],un),e.ColorTheme=un;var An;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast"})(An=e.ColorThemeKind||(e.ColorThemeKind={}));class Ht{constructor(F,ie){if(F<0)throw T.illegalArgument("start must be positive");if(ie<0)throw T.illegalArgument("end must be positive");F<=ie?(this._start=F,this._end=ie):(this._start=ie,this._end=F)}static isNotebookRange(F){return F instanceof Ht?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(F){let ie=this._start,Se=this._end;return F.start!==void 0&&(ie=F.start),F.end!==void 0&&(Se=F.end),ie===this._start&&Se===this._end?this:new Ht(ie,Se)}}e.NotebookRange=Ht;class Nt{constructor(F,ie,Se,je,et,at,lt){this.kind=F,this.value=ie,this.languageId=Se,this.mime=je,this.outputs=et??[],this.metadata=at,this.executionSummary=lt,Nt.validate(this)}static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(ie=>Nt.isNotebookCellData(ie))}static isNotebookCellData(F){return!0}}e.NotebookCellData=Nt;class cn{constructor(F){this.cells=F}}e.NotebookData=cn;class It{constructor(F,ie){this.data=F,this.mime=ie;const Se=k.normalizeMimeType(ie,!0);if(!Se)throw new Error("INVALID mime type, must not be empty or falsy: "+ie);this.mime=Se}static isNotebookCellOutputItem(F){return F instanceof It?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const ie={name:F.name,message:F.message,stack:F.stack};return It.json(ie,"application/vnd.code.notebook.error")}static stdout(F){return It.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return It.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,ie="application/octet-stream"){return new It(F,ie)}static text(F,ie=k.Mimes.text){const Se=Be(It,d,"f",y).encode(String(F));return new It(Se,ie)}static json(F,ie="application/json"){const Se=JSON.stringify(F,void 0,"	");return It.text(Se,ie)}}e.NotebookCellOutputItem=It,d=It,y={value:new TextEncoder};class zt{constructor(F,ie,Se){this.items=zt.ensureUniqueMimeTypes(F,!0),typeof ie=="string"?(this.id=ie,this.metadata=Se):(this.id=C.generateUuid(),this.metadata=ie??Se)}static isNotebookCellOutput(F){return F instanceof zt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&D.isArray(F.items)}static ensureUniqueMimeTypes(F,ie=!1){const Se=new Set,je=new Set;for(let et=0;et<F.length;et++){const at=F[et],lt=k.normalizeMimeType(at.mime);if(!Se.has(lt)){Se.add(lt);continue}je.add(et),ie&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return je.size===0?F:F.filter((et,at)=>!je.has(at))}}e.NotebookCellOutput=zt;var dn;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(dn=e.NotebookCellKind||(e.NotebookCellKind={}));var Le;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(Le=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var hn;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(hn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var bn;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(bn=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class dt{constructor(F,ie){this.text=F,this.alignment=ie}}e.NotebookCellStatusBarItem=dt;var Tn;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(Tn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Rn{constructor(F,ie=[]){this.uri=F,this.provides=g.asArray(ie)}}e.NotebookRendererScript=Rn;let Xt=class{constructor(F,ie){this.label=F,this.timestamp=ie}};Xt=Ve([a],Xt),e.TimelineItem=Xt;var wn;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(wn=e.ExtensionMode||(e.ExtensionMode={}));var fn;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(fn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Fn;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=4]="RegEx"})(Fn=e.StandardTokenType||(e.StandardTokenType={}));class Mn{constructor(F,ie){this.ranges=F,this.wordPattern=ie}}e.LinkedEditingRanges=Mn;class Ln{constructor(F,ie){this._port=F,this._autoForwardAction=ie}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ln;var _n;(function(x){x[x.Unset=0]="Unset",x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(_n=e.TestResultState||(e.TestResultState={}));var En;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information",x[x.Hint=3]="Hint"})(En=e.TestMessageSeverity||(e.TestMessageSeverity={}));var yn;(function(x){x[x.Pending=0]="Pending",x[x.Resolved=1]="Resolved"})(yn=e.TestItemStatus||(e.TestItemStatus={}));const Bt=(x,F,ie,Se)=>{let je=ie;return{enumerable:!0,configurable:!1,get(){return je},set(et){Se(je,et)||(je=et,x.bus.fire([3,F,et]))}}},Vt=(x,F)=>x===F,Nn=(x,F)=>x===F?!0:!x||!F?!1:x.isEqual(F);class X{constructor(F,ie,Se,je){this.label=ie,this.data=je;const et=o.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:F,enumerable:!0,writable:!1},uri:{value:Se,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>et.parent},children:{value:new E.ReadonlyMapView(et.children),enumerable:!0,writable:!1},range:Bt(et,"range",void 0,Nn),description:Bt(et,"description",void 0,Vt),runnable:Bt(et,"runnable",!0,Vt),debuggable:Bt(et,"debuggable",!1,Vt),status:Bt(et,"status",yn.Resolved,Vt),error:Bt(et,"error",void 0,Vt)})}invalidate(){o.getPrivateApiFor(this).bus.fire([2])}dispose(){const F=o.getPrivateApiFor(this);F.parent&&o.getPrivateApiFor(F.parent).children.delete(this.id),F.bus.fire([1])}addChild(F){if(!(F instanceof X))throw new Error("Test child must be created through vscode.test.createTestItem()");const ie=o.getPrivateApiFor(this);if(ie.children.has(F.id))throw new Error(`Attempted to insert a duplicate test item ID ${F.id}`);ie.children.set(F.id,F),o.getPrivateApiFor(F).parent=this,ie.bus.fire([0,F])}}e.TestItemImpl=X;class ce{constructor(F){this.message=F,this.severity=En.Error}static diff(F,ie,Se){const je=new ce(F);return je.expectedOutput=ie,je.actualOutput=Se,je}}e.TestMessage=ce;var Ie;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(Ie=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var st;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(st=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var bt;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore"})(bt=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(we[95],_e([0,1,39,16,8,120,85,6,17]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const C=new Map;function n(c,d){d?C.set(c,d):C.delete(c)}e.setWordDefinitionFor=n;function I(c){return C.get(c)}e.getWordDefinitionFor=I;class o extends E.MirrorTextModel{constructor(d,y,b,p,l,f,m,t){super(y,b,p,l);this._proxy=d,this._languageId=f,this._isDirty=m,this._notebook=t,this._isDisposed=!1}dispose(){g.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(d){return _.equals(this._lines,d)}get document(){if(!this._document){const d=this;this._document={get uri(){return d._uri},get fileName(){return d._uri.fsPath},get isUntitled(){return d._uri.scheme===T.Schemas.untitled},get languageId(){return d._languageId},get version(){return d._versionId},get isClosed(){return d._isDisposed},get isDirty(){return d._isDirty},get notebook(){return d._notebook},save(){return d._save()},getText(y){return y?d._getTextInRange(y):d.getText()},get eol(){return d._eol===`
`?D.EndOfLine.LF:D.EndOfLine.CRLF},get lineCount(){return d._lines.length},lineAt(y){return d._lineAt(y)},offsetAt(y){return d._offsetAt(y)},positionAt(y){return d._positionAt(y)},validateRange(y){return d._validateRange(y)},validatePosition(y){return d._validatePosition(y)},getWordRangeAtPosition(y,b){return d._getWordRangeAtPosition(y,b)}}}return Object.freeze(this._document)}_acceptLanguageId(d){g.ok(!this._isDisposed),this._languageId=d}_acceptIsDirty(d){g.ok(!this._isDisposed),this._isDirty=d}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(d){const y=this._validateRange(d);if(y.isEmpty)return"";if(y.isSingleLine)return this._lines[y.start.line].substring(y.start.character,y.end.character);const b=this._eol,p=y.start.line,l=y.end.line,f=[];f.push(this._lines[p].substring(y.start.character));for(let m=p+1;m<l;m++)f.push(this._lines[m]);return f.push(this._lines[l].substring(0,y.end.character)),f.join(b)}_lineAt(d){let y;if(d instanceof D.Position?y=d.line:typeof d=="number"&&(y=d),typeof y!="number"||y<0||y>=this._lines.length||Math.floor(y)!==y)throw new Error("Illegal value for `line`");return new h(y,this._lines[y],y===this._lines.length-1)}_offsetAt(d){return d=this._validatePosition(d),this._ensureLineStarts(),this._lineStarts.getPrefixSum(d.line-1)+d.character}_positionAt(d){d=Math.floor(d),d=Math.max(0,d),this._ensureLineStarts();const y=this._lineStarts.getIndexOf(d),b=this._lines[y.index].length;return new D.Position(y.index,Math.min(y.remainder,b))}_validateRange(d){if(!(d instanceof D.Range))throw new Error("Invalid argument");const y=this._validatePosition(d.start),b=this._validatePosition(d.end);return y===d.start&&b===d.end?d:new D.Range(y.line,y.character,b.line,b.character)}_validatePosition(d){if(!(d instanceof D.Position))throw new Error("Invalid argument");if(this._lines.length===0)return d.with(0,0);let{line:y,character:b}=d,p=!1;if(y<0)y=0,b=0,p=!0;else if(y>=this._lines.length)y=this._lines.length-1,b=this._lines[y].length,p=!0;else{const l=this._lines[y].length;b<0?(b=0,p=!0):b>l&&(b=l,p=!0)}return p?new D.Position(y,b):d}_getWordRangeAtPosition(d,y){const b=this._validatePosition(d);if(!y)y=I(this._languageId);else if(S.regExpLeadsToEndlessLoop(y))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${y.source}' because it matches the empty string.`);const p=k.getWordAtText(b.character+1,k.ensureValidWordDefinition(y),this._lines[b.line],0);if(p)return new D.Range(b.line,p.startColumn-1,b.line,p.endColumn-1)}}e.ExtHostDocumentData=o;class h{constructor(d,y,b){this._line=d,this._text=y,this._isLastLine=b}get lineNumber(){return this._line}get text(){return this._text}get range(){return new D.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new D.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=h}),define(we[156],_e([0,1,6,3,87,7,55,22,2,34]),function(ee,e,g,T,S,E,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class n{constructor(o,h,c,d){this._notebook=c,this._selector=d,this._disposables=new E.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this.uri=_.URI.from({scheme:"vscode-concat-doc",path:C.generateUuid()}),this._init(),this._disposables.add(h.onDidChangeDocument(b=>{const p=this._cellUris.get(b.document.uri);p!==void 0&&(this._cellLengths.changeValue(p,this._cells[p].document.getText().length+1),this._cellLines.changeValue(p,this._cells[p].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const y=b=>{b===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(o.onDidChangeNotebookCells(b=>y(b.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new D.ResourceMap;const o=[],h=[];for(const c of this._notebook.getCells())c.kind===g.NotebookCellKind.Code&&(!this._selector||k.score(this._selector,c.document.uri,c.document.languageId,!0))&&(this._cellUris.set(c.document.uri,this._cells.length),this._cells.push(c),o.push(c.document.getText().length+1),h.push(c.document.lineCount));this._cellLengths=new S.PrefixSumComputer(new Uint32Array(o)),this._cellLines=new S.PrefixSumComputer(new Uint32Array(h))}get version(){return this._versionId}getText(o){var h,c;if(!o){let l="";for(const f of this._cells)l+=f.document.getText()+`
`;return l=l.slice(0,-1),l}if(o.isEmpty)return"";const d=this.locationAt(o.start),y=this.locationAt(o.end),b=this._cells[(h=this._cellUris.get(d.uri))!==null&&h!==void 0?h:-1],p=this._cells[(c=this._cellUris.get(y.uri))!==null&&c!==void 0?c:-1];if(!b||!p)return"";if(b===p)return b.document.getText(new g.Range(d.range.start,y.range.end));{const l=b.document.getText(new g.Range(d.range.start,new g.Position(b.document.lineCount,0))),f=p.document.getText(new g.Range(new g.Position(0,0),y.range.end));return l+`
`+f}}offsetAt(o){const h=this._cellLines.getIndexOf(o.line),c=this._cellLengths.getPrefixSum(h.index-1),d=this._cells[h.index].document.offsetAt(o.with(h.remainder));return c+d}positionAt(o){if(typeof o=="number"){const c=this._cellLengths.getIndexOf(o),d=this._cellLines.getPrefixSum(c.index-1);return this._cells[c.index].document.positionAt(c.remainder).translate(d)}const h=this._cellUris.get(o.uri);if(h!==void 0){const c=this._cellLines.getPrefixSum(h-1);return new g.Position(c+o.range.start.line,o.range.start.character)}return new g.Position(0,0)}locationAt(o){g.Range.isRange(o)||(o=new g.Range(o,o));const h=this._cellLines.getIndexOf(o.start.line);let c=h;o.isEmpty||(c=this._cellLines.getIndexOf(o.end.line));const d=new g.Position(h.remainder,o.start.character),y=new g.Position(c.remainder,o.end.character),b=new g.Range(d,y),p=this._cells[h.index];return new g.Location(p.document.uri,p.document.validateRange(b))}contains(o){return this._cellUris.has(o)}validateRange(o){const h=this.validatePosition(o.start),c=this.validatePosition(o.end);return o.with(h,c)}validatePosition(o){const h=this._cellLines.getIndexOf(o.line),c=new g.Position(h.remainder,o.character),d=this._cells[h.index].document.validatePosition(c),y=this._cellLines.getPrefixSum(h.index-1);return new g.Position(y+d.line,d.character)}}e.ExtHostNotebookConcatDocument=n}),define(we[157],_e([0,1,6,13,3]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let E=class{constructor(D){this._actual=new g.ColorTheme(g.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new S.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(D){let _=D==="light"?g.ColorThemeKind.Light:D==="dark"?g.ColorThemeKind.Dark:g.ColorThemeKind.HighContrast;this._actual=new g.ColorTheme(_),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};E=Ve([ze(0,T.IExtHostRpcService)],E),e.ExtHostTheming=E}),define(we[66],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=g.createDecorator("IURITransformerService");class T{constructor(E){E?(this.transformIncoming=E.transformIncoming.bind(E),this.transformOutgoing=E.transformOutgoing.bind(E),this.transformOutgoingURI=E.transformOutgoingURI.bind(E),this.transformOutgoingScheme=E.transformOutgoingScheme.bind(E)):(this.transformIncoming=k=>k,this.transformOutgoing=k=>k,this.transformOutgoingURI=k=>k,this.transformOutgoingScheme=k=>k)}}e.URITransformerService=T}),define(we[158],_e([0,1,23]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class T{constructor(){this.buffers=[]}add(_){let C=this.buffers.indexOf(_);return C<0&&(C=this.buffers.length,this.buffers.push(_)),C}}function S(D,_){if(_.serializeBuffersForPostMessage){const C=new T,n=(h,c)=>{if(c instanceof ArrayBuffer){const d=C.add(c);return{$$vscode_array_buffer_reference$$:!0,index:d}}else if(ArrayBuffer.isView(c)){const d=E(c);if(d){const y=C.add(c.buffer);return{$$vscode_array_buffer_reference$$:!0,index:y,view:{type:d,byteLength:c.byteLength,byteOffset:c.byteOffset}}}}return c},I=JSON.stringify(D,n),o=C.buffers.map(h=>{const c=new Uint8Array(h);return g.VSBuffer.wrap(c)});return{message:I,buffers:o}}else return{message:JSON.stringify(D),buffers:[]}}e.serializeWebviewMessage=S;function E(D){switch(D.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function k(D,_){const C=_.map(o=>{const h=new ArrayBuffer(o.byteLength);return new Uint8Array(h).set(o.buffer),h}),n=_.length?(o,h)=>{if(typeof h=="object"&&h.$$vscode_array_buffer_reference$$){const c=h,{index:d}=c,y=C[d];if(c.view)switch(c.view.type){case 1:return new Int8Array(y,c.view.byteOffset,c.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(y,c.view.byteOffset,c.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(y,c.view.byteOffset,c.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(y,c.view.byteOffset,c.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(y,c.view.byteOffset,c.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(y,c.view.byteOffset,c.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(y,c.view.byteOffset,c.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(y,c.view.byteOffset,c.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(y,c.view.byteOffset,c.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(y,c.view.byteOffset,c.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(y,c.view.byteOffset,c.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return y}return h}:void 0;return{message:JSON.parse(D,n),arrayBuffers:C}}e.deserializeWebviewMessage=k}),define(we[67],_e([0,1,16,2]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function S(E,k){return E.scheme===g.Schemas.http||E.scheme===g.Schemas.https?E:(k&&k.authority&&k.isRemote&&E.scheme===g.Schemas.file&&(E=T.URI.from({scheme:g.Schemas.vscodeRemote,authority:k.authority,path:E.path})),T.URI.from({scheme:g.Schemas.https,authority:`${E.scheme}+${E.authority}.${e.webviewRootResourceAuthority}`,path:E.path,fragment:E.fragment,query:E.query}))}e.asWebviewUri=S}),define(we[159],_e([0,1,3,7,67]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class E{constructor(D,_,C){this._proxy=D,this._editors=_,this._initData=C,this._handlePool=0,this._disposables=new T.DisposableStore,this._insets=new Map,this._disposables.add(_.onDidChangeVisibleTextEditors(()=>{const n=_.getVisibleTextEditors();for(const I of this._insets.values())n.indexOf(I.editor)<0&&I.inset.dispose()}))}dispose(){this._insets.forEach(D=>D.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(D,_,C,n,I){let o;for(const l of this._editors.getVisibleTextEditors(!0))if(l.value===D){o=l;break}if(!o)throw new Error("not a visible editor");const h=this,c=this._handlePool++,d=new g.Emitter,y=new g.Emitter,b=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(l){return S.asWebviewUri(l,h._initData.remote)}get cspSource(){return S.webviewGenericCspSource}set options(l){this._options=l,h._proxy.$setOptions(c,l)}get options(){return this._options}set html(l){this._html=l,h._proxy.$setHtml(c,l)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(l){return h._proxy.$postMessage(c,l)}},p=new class{constructor(){this.editor=D,this.line=_,this.height=C,this.webview=b,this.onDidDispose=y.event}dispose(){h._insets.has(c)&&(h._insets.delete(c),h._proxy.$disposeEditorInset(c),y.fire(),y.dispose(),d.dispose())}};return this._proxy.$createEditorInset(c,o.id,o.value.document.uri,_+1,C,n||{},I.identifier,I.extensionLocation),this._insets.set(c,{editor:D,inset:p,onDidReceiveMessage:d}),p}$onDidDispose(D){const _=this._insets.get(D);_&&_.inset.dispose()}$onDidReceiveMessage(D,_){const C=this._insets.get(D);C&&C.onDidReceiveMessage.fire(_)}}e.ExtHostEditorInsets=E}),define(we[160],_e([0,1,3,12,135]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class E{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new g.Emitter,this._onExit=new g.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(D){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=D}onEvent(D){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=D}onRequest(D){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=D}sendResponse(D){D.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${D.command}`)):this.internalSend("response",D)}sendRequest(D,_,C,n){const I={command:D};if(_&&Object.keys(_).length>0&&(I.arguments=_),this.internalSend("request",I),typeof n=="number"){const o=setTimeout(()=>{clearTimeout(o);const h=this.pendingRequests.get(I.seq);if(h){this.pendingRequests.delete(I.seq);const c={type:"response",seq:0,request_seq:I.seq,success:!1,command:D,message:S.localize(0,null,n,D)};h(c)}},n)}return C&&this.pendingRequests.set(I.seq,C),I.seq}acceptMessage(D){this.messageCallback?this.messageCallback(D):(this.queue.push(D),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(D,_){return D.type!=="event"||_.type!=="event"}async processQueue(){let D;for(;this.queue.length;){if((!D||this.needsTaskBoundaryBetween(this.queue[0],D))&&await T.timeout(0),D=this.queue.shift(),!D)return;switch(D.type){case"event":this.eventCallback&&this.eventCallback(D);break;case"request":this.requestCallback&&this.requestCallback(D);break;case"response":const _=D,C=this.pendingRequests.get(_.request_seq);C&&(this.pendingRequests.delete(_.request_seq),C(_));break}}}internalSend(D,_){_.type=D,_.seq=this.sequence++,this.sendMessage(_)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const D=new Map;this.pendingRequests.forEach((_,C)=>D.set(C,_)),await T.timeout(500),D.forEach((_,C)=>{_({type:"response",seq:0,request_seq:C,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(C)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=E}),define(we[161],_e([0,1,8,2,14,24,16]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const D=/{([^}]+)}/g;function _(r,s,i){return r.replace(D,function(u,w){return s&&w.length>0&&w[0]!=="_"?u:i&&i.hasOwnProperty(w)?i[w]:u})}e.formatPII=_;function C(r){const s={};for(const i of Object.keys(r))i.startsWith("!")||(s[i]=r[i]);return s}e.filterExceptionsFromTelemetry=C;function n(r){return r.configuration.request==="attach"&&!I(r)&&(!r.parentSession||n(r.parentSession))}e.isSessionAttach=n;function I(r){let s=r.configuration.type;if(!!s)return s==="vslsShare"&&(s=r.configuration.adapterProxy.configuration.type),g.equalsIgnoreCase(s,"extensionhost")||g.equalsIgnoreCase(s,"pwa-extensionhost")?r:r.parentSession?I(r.parentSession):void 0}e.getExtensionHostDebugSession=I;function o(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=o;function h(r,s,i){let u,w=0,v=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=v.exec(r);){let A=P.index+1,a=A+P[0].length;if(A<=s&&a>=i){u=P[0],w=A;break}}if(u){let A=/\w+/g,a=null;for(;(a=A.exec(u))&&!(a.index+1+w+a[0].length>=i););a&&(u=u.substring(0,A.lastIndex))}return u?{start:w,end:w+u.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=h;const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function d(r){return!!(r&&r.match(c))}e.isUri=d;function y(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(d(r.path))return T.URI.parse(r.path);if(S.isAbsolute(r.path))return T.URI.file(r.path)}return r.path}function b(r){if(typeof r.path=="object"){const s=T.URI.revive(r.path);if(s)return s.scheme===k.Schemas.file?s.fsPath:s.toString()}return r.path}function p(r,s){const i=s?y:b,u=E.deepClone(r);return f(u,(w,v)=>{w&&v&&(v.path=i(v))}),u}e.convertToDAPaths=p;function l(r,s){const i=s?y:b,u=E.deepClone(r);return f(u,(w,v)=>{!w&&v&&(v.path=i(v))}),u}e.convertToVSCPaths=l;function f(r,s){switch(r.type){case"event":const i=r;switch(i.event){case"output":s(!1,i.body.source);break;case"loadedSource":s(!1,i.body.source);break;case"breakpoint":s(!1,i.body.breakpoint.source);break;default:break}break;case"request":const u=r;switch(u.command){case"setBreakpoints":s(!0,u.arguments.source);break;case"breakpointLocations":s(!0,u.arguments.source);break;case"source":s(!0,u.arguments.source);break;case"gotoTargets":s(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(v=>s(!1,v));break;default:break}break;case"response":const w=r;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(v=>s(!1,v.source));break;case"loadedSources":w.body.sources.forEach(v=>s(!1,v));break;case"scopes":w.body.scopes.forEach(v=>s(!1,v.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(v=>s(!1,v.source));break;case"setBreakpoints":w.body.breakpoints.forEach(v=>s(!1,v.source));break;default:break}break}}function m(r){return r.filter(s=>{var i;return!((i=s.presentation)===null||i===void 0?void 0:i.hidden)}).sort((s,i)=>s.presentation?i.presentation?s.presentation.group?i.presentation.group?s.presentation.group!==i.presentation.group?s.presentation.group.localeCompare(i.presentation.group):t(s.presentation.order,i.presentation.order):-1:i.presentation.group?1:t(s.presentation.order,i.presentation.order):-1:i.presentation?1:0)}e.getVisibleAndSorted=m;function t(r,s){return typeof r!="number"?typeof s!="number"?0:1:typeof s!="number"?-1:r-s}}),define(we[68],_e([0,1,27,82,16,14,21,89]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(a){a[a.Markup=1]="Markup",a[a.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",T.Mimes.markdown,"image/png","image/jpeg",T.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[T.Mimes.markdown,"application/json",T.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var C;(function(a){a[a.Running=1]="Running",a[a.Idle=2]="Idle"})(C=e.NotebookRunState||(e.NotebookRunState={}));var n;(function(a){a[a.Pending=2]="Pending",a[a.Executing=3]="Executing"})(n=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(a){a[a.WithHardKernelDependency=0]="WithHardKernelDependency",a[a.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",a[a.Pure=2]="Pure",a[a.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var o;(function(a){a.Always="always",a.Never="never",a.Optional="optional"})(o=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(a){a[a.ModelChange=1]="ModelChange",a[a.Move=2]="Move",a[a.ChangeLanguage=5]="ChangeLanguage",a[a.Initialize=6]="Initialize",a[a.ChangeCellMetadata=7]="ChangeCellMetadata",a[a.Output=8]="Output",a[a.OutputItem=9]="OutputItem",a[a.ChangeCellContent=10]="ChangeCellContent",a[a.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",a[a.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",a[a.ChangeCellMime=13]="ChangeCellMime",a[a.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(a){a[a.Handle=0]="Handle",a[a.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var d;(function(a){a[a.Replace=1]="Replace",a[a.Output=2]="Output",a[a.Metadata=3]="Metadata",a[a.CellLanguage=4]="CellLanguage",a[a.DocumentMetadata=5]="DocumentMetadata",a[a.Move=6]="Move",a[a.OutputItems=7]="OutputItems",a[a.PartialMetadata=8]="PartialMetadata",a[a.PartialInternalMetadata=9]="PartialInternalMetadata"})(d=e.CellEditType||(e.CellEditType={}));var y;(function(a){a.scheme=S.Schemas.vscodeNotebookCell;const R=/^ch(\d{7,})/;function L(z,Z){return z.with({scheme:a.scheme,fragment:`ch${Z.toString().padStart(7,"0")}${z.scheme!==S.Schemas.file?z.scheme:""}`})}a.generate=L;function H(z){if(z.scheme!==a.scheme)return;const Z=R.exec(z.fragment);return Z?{handle:Number(Z[1]),notebook:z.with({scheme:z.fragment.substr(Z[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parse=H;function ue(z){if(z.scheme!==S.Schemas.vscodeNotebookCellMetadata)return;const Z=R.exec(z.fragment);return Z?{handle:Number(Z[1]),notebook:z.with({scheme:z.fragment.substr(Z[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parseCellMetadataUri=ue;function me(z,Z,M){return z.with({scheme:M,fragment:`ch${Z.toString().padStart(7,"0")}${z.scheme!==S.Schemas.file?z.scheme:""}`})}a.generateCellUri=me;function J(z,Z){if(z.scheme!==Z)return;const M=R.exec(z.fragment);return M?{handle:Number(M[1]),notebook:z.with({scheme:z.fragment.substr(M[0].length)||S.Schemas.file,fragment:null})}:void 0}a.parseCellUri=J})(y=e.CellUri||(e.CellUri={}));const b=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[T.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[T.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function p(a){var R,L;return(L=(R=b.get(a))===null||R===void 0?void 0:R.alwaysSecure)!==null&&L!==void 0?L:!1}e.mimeTypeIsAlwaysSecure=p;function l(a){var R,L;return(L=(R=b.get(a))===null||R===void 0?void 0:R.supportedByCore)!==null&&L!==void 0?L:!1}e.mimeTypeSupportedByCore=l;function f(a){var R,L;return(L=(R=b.get(a))===null||R===void 0?void 0:R.mergeable)!==null&&L!==void 0?L:!1}e.mimeTypeIsMergeable=f;function m(a,R){return k.isWindows&&(a=a.replace(/\//g,"\\"),R=R.replace(/\//g,"\\")),g.match(a,R)}function t(a,R,L){let H=0;for(let ue=0;ue<R.length;ue++){if(m(R[ue],a))return H;H++}for(let ue=0;ue<L.length;ue++){if(m(L[ue],a))return H;H++}return H}function r(a,R,L){return a.sort((H,ue)=>t(H,R,L)-t(ue,R,L))}e.sortMimeTypes=r;function s(a,R,L,H=(ue,me)=>ue===me){const ue=[];function me(Z,M,q){if(M===0&&q.length===0)return;const N=ue[ue.length-1];N&&N.start+N.deleteCount===Z?(N.deleteCount+=M,N.toInsert.push(...q)):ue.push({start:Z,deleteCount:M,toInsert:q})}let J=0,z=0;for(;;){if(J===a.length){me(J,0,R.slice(z));break}if(z===R.length){me(J,a.length-J,[]);break}const Z=a[J],M=R[z];if(H(Z,M)){J+=1,z+=1;continue}L(M)?(me(J,1,[]),J+=1):(me(J,0,[M]),z+=1)}return ue}e.diff=s,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(a){a.default="default",a.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(a){const R=a;return!!((typeof R.include=="string"||g.isRelativePattern(R.include))&&(typeof R.exclude=="string"||g.isRelativePattern(R.exclude)))}e.isDocumentExcludePattern=u;function w(a,R,L){if(Array.isArray(a.viewType)&&a.viewType.indexOf(R)>=0||a.viewType===R)return!0;if(a.filenamePattern){let H=u(a.filenamePattern)?a.filenamePattern.include:a.filenamePattern,ue=u(a.filenamePattern)?a.filenamePattern.exclude:void 0;if(g.match(H,E.basename(L.fsPath).toLowerCase()))return!(ue&&g.match(ue,E.basename(L.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=w;class v{constructor(R){this.textModel=R}getElements(){const R=new Int32Array(this.textModel.cells.length);for(let L=0;L<this.textModel.cells.length;L++)R[L]=this.textModel.cells[L].getHashValue();return R}}e.CellSequence=v,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var P;(function(a){a[a.Left=1]="Left",a[a.Right=2]="Right"})(P=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class A{static create(R){return`${A._prefix}${R}`}static parse(R){if(R.startsWith(A._prefix))return R.substr(A._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=A,A._prefix="notebook/"}),define(we[162],_e([0,1,137,4,89]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new S.RawContextKey("customExecutionSupported",!0,g.localize(0,null)),e.ShellExecutionSupportedContext=new S.RawContextKey("shellExecutionSupported",!1,g.localize(1,null)),e.ProcessExecutionSupportedContext=new S.RawContextKey("processExecutionSupported",!1,g.localize(2,null)),e.ITaskService=T.createDecorator("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[163],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function g(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=g;function T(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=T}),define(we[96],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.getTestSubscriptionKey=e.TestDiffOpType=e.applyTestItemUpdate=e.TestItemExpandState=void 0;var g;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(g=e.TestItemExpandState||(e.TestItemExpandState={}));const T=(_,C)=>{C.expand!==void 0&&(_.expand=C.expand),C.item!==void 0&&(_.item=_.item?Object.assign(_.item,C.item):C.item)};e.applyTestItemUpdate=T;var S;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire"})(S=e.TestDiffOpType||(e.TestDiffOpType={}));const E=(_,C)=>`${_}:${C.toString()}`;e.getTestSubscriptionKey=E;class k{add(C){}update(C){}remove(C,n){}complete(){}}e.IncrementalChangeCollector=k;class D{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(C){const n=this.createChangeCollector();for(const I of C)switch(I[0]){case 0:{const o=I[1];if(o.parent){if(this.items.has(o.parent)){const h=this.items.get(o.parent);h.children.add(o.item.extId);const c=this.createItem(o,h);this.items.set(o.item.extId,c),n.add(c)}}else{this.roots.add(o.item.extId);const h=this.createItem(o);this.items.set(o.item.extId,h),n.add(h)}o.expand===2&&this.busyControllerCount++;break}case 1:{const o=I[1],h=this.items.get(o.extId);if(!h)break;o.expand!==void 0&&(h.expand===2&&this.busyControllerCount--,o.expand===2&&this.busyControllerCount++),e.applyTestItemUpdate(h,o),n.update(h);break}case 2:{const o=this.items.get(I[1]);if(!o)break;o.parent?this.items.get(o.parent).children.delete(o.item.extId):this.roots.delete(o.item.extId);const h=[[I[1]]];for(;h.length;)for(const c of h.pop()){const d=this.items.get(c);d&&(h.push(d.children),this.items.delete(c),n.remove(d,d!==o),d.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(I[1]);break;case 3:this.updatePendingRoots(I[1]);break}n.complete()}retireTest(C){}updatePendingRoots(C){this.pendingRootCount+=C}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=D}),define(we[164],_e([0,1,14,41,10,24,21,81,138]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class C{constructor(I,o,h){this._contributedVariables=new Map,this._context=I,this._labelService=o,h&&(this._envVariablesPromise=h.then(c=>this.prepareEnv(c)))}prepareEnv(I){if(k.isWindows){const o=Object.create(null);return Object.keys(I).forEach(h=>{o[h.toLowerCase()]=I[h]}),o}return I}resolveWithEnvironment(I,o,h){return this.recursiveResolve(this.prepareEnv(I),o?o.uri:void 0,h)}async resolveAsync(I,o){return this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,o)}async resolveAnyBase(I,o,h,c){const d=E.deepClone(o);return k.isWindows&&d.windows?Object.keys(d.windows).forEach(y=>d[y]=d.windows[y]):k.isMacintosh&&d.osx?Object.keys(d.osx).forEach(y=>d[y]=d.osx[y]):k.isLinux&&d.linux&&Object.keys(d.linux).forEach(y=>d[y]=d.linux[y]),delete d.windows,delete d.osx,delete d.linux,this.recursiveResolve(await this._envVariablesPromise,I?I.uri:void 0,d,h,c)}async resolveAnyAsync(I,o,h){return this.resolveAnyBase(I,o,h)}async resolveAnyMap(I,o,h){const c=new Map;return{newConfig:await this.resolveAnyBase(I,o,h,c),resolvedVariables:c}}resolveWithInteractionReplace(I,o,h,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(I,o,h,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(I,o){if(this._contributedVariables.has(I))throw new Error("Variable "+I+" is contributed twice.");this._contributedVariables.set(I,o)}recursiveResolve(I,o,h,c,d){if(S.isString(h))return this.resolveString(I,o,h,c,d);if(S.isArray(h))return h.map(y=>this.recursiveResolve(I,o,y,c,d));if(S.isObject(h)){let y=Object.create(null);return Object.keys(h).forEach(b=>{const p=this.resolveString(I,o,b,c,d);y[p]=this.recursiveResolve(I,o,h[b],c,d)}),y}return h}resolveString(I,o,h,c,d){return h.replace(C.VARIABLE_REGEXP,(b,p)=>{if(p.includes(C.VARIABLE_LHS))return b;let l=this.evaluateSingleVariable(I,b,p,o,c);return d&&d.set(p,l),l!==b&&S.isString(l)&&l.match(C.VARIABLE_REGEXP)&&(l=this.resolveString(I,o,l,c,d)),l})}fsPath(I){return this._labelService?this._labelService.getUriLabel(I,{noPrefix:!0}):I.fsPath}evaluateSingleVariable(I,o,h,c,d){let y;const b=h.split(":");b.length>1&&(h=b[0],y=b[1]);const p=()=>{const m=this._context.getFilePath();if(m)return m;throw new Error(_.localize(0,null,o))},l=()=>{const m=p();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(_.localize(1,null,o,g.basename(m)))},f=()=>{if(y){const m=this._context.getFolderUri(y);if(m)return m;throw new Error(_.localize(2,null,o,y))}if(c)return c;throw this._context.getWorkspaceFolderCount()>1?new Error(_.localize(3,null,o)):new Error(_.localize(4,null,o))};switch(h){case"env":if(y){if(I){const m=I[k.isWindows?y.toLowerCase():y];if(S.isString(m))return m}return""}throw new Error(_.localize(5,null,o));case"config":if(y){const m=this._context.getConfigurationValue(c,y);if(S.isUndefinedOrNull(m))throw new Error(_.localize(6,null,o,y));if(S.isObject(m))throw new Error(_.localize(7,null,o,y));return m}throw new Error(_.localize(8,null,o));case"command":return this.resolveFromMap(o,y,d,"command");case"input":return this.resolveFromMap(o,y,d,"input");default:switch(h){case"workspaceRoot":case"workspaceFolder":return D.normalizeDriveLetter(this.fsPath(f()));case"cwd":return c||y?D.normalizeDriveLetter(this.fsPath(f())):T.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return g.basename(this.fsPath(f()));case"lineNumber":const m=this._context.getLineNumber();if(m)return m;throw new Error(_.localize(9,null,o));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(_.localize(10,null,o));case"file":return p();case"fileWorkspaceFolder":return l();case"relativeFile":return c||y?g.relative(this.fsPath(f()),p()):p();case"relativeFileDirname":const r=g.dirname(p());if(c||y){const w=g.relative(this.fsPath(f()),r);return w.length===0?".":w}return r;case"fileDirname":return g.dirname(p());case"fileExtname":return g.extname(p());case"fileBasename":return g.basename(p());case"fileBasenameNoExtension":const s=g.basename(p());return s.slice(0,s.length-g.extname(s).length);case"fileDirnameBasename":return g.basename(g.dirname(p()));case"execPath":const i=this._context.getExecPath();return i||o;case"execInstallFolder":const u=this._context.getAppRoot();return u||o;case"pathSeparator":return g.sep;default:try{const w=y?`${h}:${y}`:h;return this.resolveFromMap(o,w,d,void 0)}catch(w){return o}}}}resolveFromMap(I,o,h,c){if(o&&h){const d=c===void 0?h[o]:h[c+":"+o];if(typeof d=="string")return d;throw new Error(_.localize(11,null,I))}return I}}e.AbstractVariableResolverService=C,C.VARIABLE_LHS="${",C.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[165],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=g.createDecorator("editorGroupsService");var T;(function(o){o[o.UP=0]="UP",o[o.DOWN=1]="DOWN",o[o.LEFT=2]="LEFT",o[o.RIGHT=3]="RIGHT"})(T=e.GroupDirection||(e.GroupDirection={}));var S;(function(o){o[o.HORIZONTAL=0]="HORIZONTAL",o[o.VERTICAL=1]="VERTICAL"})(S=e.GroupOrientation||(e.GroupOrientation={}));var E;(function(o){o[o.FIRST=0]="FIRST",o[o.LAST=1]="LAST",o[o.NEXT=2]="NEXT",o[o.PREVIOUS=3]="PREVIOUS"})(E=e.GroupLocation||(e.GroupLocation={}));var k;(function(o){o[o.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",o[o.EVEN=1]="EVEN",o[o.TOGGLE=2]="TOGGLE"})(k=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(o){o[o.COPY_EDITORS=0]="COPY_EDITORS",o[o.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));var _;(function(o){o[o.CREATION_TIME=0]="CREATION_TIME",o[o.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",o[o.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(_=e.GroupsOrder||(e.GroupsOrder={}));var C;(function(o){o[o.GROUP_ACTIVE=0]="GROUP_ACTIVE",o[o.GROUP_INDEX=1]="GROUP_INDEX",o[o.EDITOR_OPEN=2]="EDITOR_OPEN",o[o.EDITOR_CLOSE=3]="EDITOR_CLOSE",o[o.EDITOR_MOVE=4]="EDITOR_MOVE",o[o.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",o[o.EDITOR_LABEL=6]="EDITOR_LABEL",o[o.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",o[o.EDITOR_PIN=8]="EDITOR_PIN",o[o.EDITOR_STICKY=9]="EDITOR_STICKY",o[o.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(C=e.GroupChangeKind||(e.GroupChangeKind={}));var n;(function(o){o[o.NEW_EDITOR=1]="NEW_EDITOR",o[o.MOVE_EDITOR=2]="MOVE_EDITOR",o[o.COPY_EDITOR=3]="COPY_EDITOR"})(n=e.OpenEditorContext||(e.OpenEditorContext={}));function I(o){return o.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(we[166],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=g.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(we[9],_e([0,1,17,80,222,54,24,10,2,31,58,139,90,68,166,6]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var y;(function(ve){function ye(V){const{selectionStartLineNumber:xe,selectionStartColumn:Te,positionLineNumber:Re,positionColumn:nt}=V,ot=new d.Position(xe-1,Te-1),tt=new d.Position(Re-1,nt-1);return new d.Selection(ot,tt)}ve.to=ye;function ae(V){const{anchor:xe,active:Te}=V;return{selectionStartLineNumber:xe.line+1,selectionStartColumn:xe.character+1,positionLineNumber:Te.line+1,positionColumn:Te.character+1}}ve.from=ae})(y=e.Selection||(e.Selection={}));var b;(function(ve){function ye(V){if(!V)return;const{start:xe,end:Te}=V;return{startLineNumber:xe.line+1,startColumn:xe.character+1,endLineNumber:Te.line+1,endColumn:Te.character+1}}ve.from=ye;function ae(V){if(!V)return;const{startLineNumber:xe,startColumn:Te,endLineNumber:Re,endColumn:nt}=V;return new d.Range(xe-1,Te-1,Re-1,nt-1)}ve.to=ae})(b=e.Range||(e.Range={}));var p;(function(ve){function ye(ae){switch(ae){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 4:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}ve.to=ye})(p=e.TokenType||(e.TokenType={}));var l;(function(ve){function ye(V){return new d.Position(V.lineNumber-1,V.column-1)}ve.to=ye;function ae(V){return{lineNumber:V.line+1,column:V.character+1}}ve.from=ae})(l=e.Position||(e.Position={}));var f;(function(ve){function ye(V){switch(V){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}ve.from=ye;function ae(V){switch(V){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}ve.to=ae})(f=e.DiagnosticTag||(e.DiagnosticTag={}));var m;(function(ve){function ye(V){let xe;return V.code&&(D.isString(V.code)||D.isNumber(V.code)?xe=String(V.code):xe={value:String(V.code.value),target:V.code.target}),Object.assign(Object.assign({},b.from(V.range)),{message:V.message,source:V.source,code:xe,severity:r.from(V.severity),relatedInformation:V.relatedInformation&&V.relatedInformation.map(t.from),tags:Array.isArray(V.tags)?g.coalesce(V.tags.map(f.from)):void 0})}ve.from=ye;function ae(V){var xe;const Te=new d.Diagnostic(b.to(V),V.message,r.to(V.severity));return Te.source=V.source,Te.code=D.isString(V.code)?V.code:(xe=V.code)===null||xe===void 0?void 0:xe.value,Te.relatedInformation=V.relatedInformation&&V.relatedInformation.map(t.to),Te.tags=V.tags&&g.coalesce(V.tags.map(f.to)),Te}ve.to=ae})(m=e.Diagnostic||(e.Diagnostic={}));var t;(function(ve){function ye(V){return Object.assign(Object.assign({},b.from(V.location.range)),{message:V.message,resource:V.location.uri})}ve.from=ye;function ae(V){return new d.DiagnosticRelatedInformation(new d.Location(V.resource,b.to(V)),V.message)}ve.to=ae})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var r;(function(ve){function ye(V){switch(V){case d.DiagnosticSeverity.Error:return o.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return o.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return o.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return o.MarkerSeverity.Hint}return o.MarkerSeverity.Error}ve.from=ye;function ae(V){switch(V){case o.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case o.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case o.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case o.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}ve.to=ae})(r=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var s;(function(ve){function ye(V){return typeof V=="number"&&V>=d.ViewColumn.One?V-1:V===d.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP}ve.from=ye;function ae(V){if(typeof V=="number"&&V>=0)return V+1;throw new Error("invalid 'EditorGroupColumn'")}ve.to=ae})(s=e.ViewColumn||(e.ViewColumn={}));function i(ve){return typeof ve.range!="undefined"}function u(ve){return ve.length===0?!0:!!i(ve[0])}e.isDecorationOptionsArr=u;var w;(function(ve){function ye(nt){return nt.map(ve.from)}ve.fromMany=ye;function ae(nt){return nt&&typeof nt=="object"&&typeof nt.language=="string"&&typeof nt.value=="string"}function V(nt){let ot;if(ae(nt)){const{language:pt,value:wt}=nt;ot={value:"```"+pt+`
`+wt+"\n```\n"}}else d.MarkdownString.isMarkdownString(nt)?ot={value:nt.value,isTrusted:nt.isTrusted,supportThemeIcons:nt.supportThemeIcons}:typeof nt=="string"?ot={value:nt}:ot={value:""};const tt=Object.create(null);ot.uris=tt;const vt=pt=>{try{let wt=_.URI.parse(pt,!0);wt=wt.with({query:xe(wt.query,tt)}),tt[pt]=wt}catch(wt){}return""},gt=new S.Renderer;return gt.link=vt,gt.image=pt=>vt(T.parseHrefAndDimensions(pt).href),S(ot.value,{renderer:gt}),ot}ve.from=V;function xe(nt,ot){if(!nt)return nt;let tt;try{tt=E.parse(nt)}catch(gt){}if(!tt)return nt;let vt=!1;return tt=k.cloneAndChange(tt,gt=>{if(_.URI.isUri(gt)){const pt=`__uri_${Math.random().toString(16).slice(2,8)}`;return ot[pt]=gt,vt=!0,pt}else return}),vt?JSON.stringify(tt):nt}function Te(nt){const ot=new d.MarkdownString(nt.value,nt.supportThemeIcons);return ot.isTrusted=nt.isTrusted,ot}ve.to=Te;function Re(nt){if(!!nt)return typeof nt=="string"?nt:ve.from(nt)}ve.fromStrict=Re})(w=e.MarkdownString||(e.MarkdownString={}));function v(ve){return u(ve)?ve.map(ye=>({range:b.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?w.fromMany(ye.hoverMessage):ye.hoverMessage?w.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):ve.map(ye=>({range:b.from(ye)}))}e.fromRangeOrRangeWithMessage=v;function P(ve){return typeof ve=="undefined"?ve:typeof ve=="string"?_.URI.file(ve):ve}e.pathOrURIToURI=P;var A;(function(ve){function ye(ae){return typeof ae=="undefined"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?P(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}ve.from=ye})(A=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var a;(function(ve){function ye(ae){return typeof ae=="undefined"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?P(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?A.from(ae.before):void 0,after:ae.after?A.from(ae.after):void 0}}ve.from=ye})(a=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var R;(function(ve){function ye(ae){if(typeof ae=="undefined")return ae;switch(ae){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}ve.from=ye})(R=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var L;(function(ve){function ye(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?R.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?a.from(ae.light):void 0,dark:ae.dark?a.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?P(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?A.from(ae.before):void 0,after:ae.after?A.from(ae.after):void 0}}ve.from=ye})(L=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var H;(function(ve){function ye(V){return{text:V.newText,eol:V.newEol&&j.from(V.newEol),range:b.from(V.range)}}ve.from=ye;function ae(V){const xe=new d.TextEdit(b.to(V.range),V.text);return xe.newEol=typeof V.eol=="undefined"?void 0:j.to(V.eol),xe}ve.to=ae})(H=e.TextEdit||(e.TextEdit={}));var ue;(function(ve){function ye(V,xe,Te){var Re,nt;const ot={edits:[]};if(V instanceof d.WorkspaceEdit)for(let tt of V._allEntries())if(tt._type===1)ot.edits.push({_type:1,oldUri:tt.from,newUri:tt.to,options:tt.options,metadata:tt.metadata});else if(tt._type===2){const vt=xe==null?void 0:xe.getDocument(tt.uri);ot.edits.push({_type:2,resource:tt.uri,edit:H.from(tt.edit),modelVersionId:vt==null?void 0:vt.version,metadata:tt.metadata})}else tt._type===3?ot.edits.push({_type:3,metadata:tt.metadata,resource:tt.uri,edit:tt.edit,notebookMetadata:tt.notebookMetadata,notebookVersionId:(Re=Te==null?void 0:Te.getNotebookDocument(tt.uri,!0))===null||Re===void 0?void 0:Re.apiNotebook.version}):tt._type===5&&ot.edits.push({_type:3,metadata:tt.metadata,resource:tt.uri,notebookVersionId:(nt=Te==null?void 0:Te.getNotebookDocument(tt.uri,!0))===null||nt===void 0?void 0:nt.apiNotebook.version,edit:{editType:1,index:tt.index,count:tt.count,cells:tt.cells.map(U.from)}});return ot}ve.from=ye;function ae(V){const xe=new d.WorkspaceEdit;for(const Te of V.edits)Te.edit?xe.replace(_.URI.revive(Te.resource),b.to(Te.edit.range),Te.edit.text):xe.renameFile(_.URI.revive(Te.oldUri),_.URI.revive(Te.newUri),Te.options);return xe}ve.to=ae})(ue=e.WorkspaceEdit||(e.WorkspaceEdit={}));var me;(function(ve){const ye=Object.create(null);ye[d.SymbolKind.File]=0,ye[d.SymbolKind.Module]=1,ye[d.SymbolKind.Namespace]=2,ye[d.SymbolKind.Package]=3,ye[d.SymbolKind.Class]=4,ye[d.SymbolKind.Method]=5,ye[d.SymbolKind.Property]=6,ye[d.SymbolKind.Field]=7,ye[d.SymbolKind.Constructor]=8,ye[d.SymbolKind.Enum]=9,ye[d.SymbolKind.Interface]=10,ye[d.SymbolKind.Function]=11,ye[d.SymbolKind.Variable]=12,ye[d.SymbolKind.Constant]=13,ye[d.SymbolKind.String]=14,ye[d.SymbolKind.Number]=15,ye[d.SymbolKind.Boolean]=16,ye[d.SymbolKind.Array]=17,ye[d.SymbolKind.Object]=18,ye[d.SymbolKind.Key]=19,ye[d.SymbolKind.Null]=20,ye[d.SymbolKind.EnumMember]=21,ye[d.SymbolKind.Struct]=22,ye[d.SymbolKind.Event]=23,ye[d.SymbolKind.Operator]=24,ye[d.SymbolKind.TypeParameter]=25;function ae(xe){return typeof ye[xe]=="number"?ye[xe]:6}ve.from=ae;function V(xe){for(const Te in ye)if(ye[Te]===xe)return Number(Te);return d.SymbolKind.Property}ve.to=V})(me=e.SymbolKind||(e.SymbolKind={}));var J;(function(ve){function ye(V){switch(V){case d.SymbolTag.Deprecated:return 1}}ve.from=ye;function ae(V){switch(V){case 1:return d.SymbolTag.Deprecated}}ve.to=ae})(J=e.SymbolTag||(e.SymbolTag={}));var z;(function(ve){function ye(V){return{name:V.name,kind:me.from(V.kind),tags:V.tags&&V.tags.map(J.from),containerName:V.containerName,location:W.from(V.location)}}ve.from=ye;function ae(V){const xe=new d.SymbolInformation(V.name,me.to(V.kind),V.containerName,W.to(V.location));return xe.tags=V.tags&&V.tags.map(J.to),xe}ve.to=ae})(z=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Z;(function(ve){function ye(V){var xe,Te;const Re={name:V.name||"!!MISSING: name!!",detail:V.detail,range:b.from(V.range),selectionRange:b.from(V.selectionRange),kind:me.from(V.kind),tags:(Te=(xe=V.tags)===null||xe===void 0?void 0:xe.map(J.from))!==null&&Te!==void 0?Te:[]};return V.children&&(Re.children=V.children.map(ye)),Re}ve.from=ye;function ae(V){const xe=new d.DocumentSymbol(V.name,V.detail,me.to(V.kind),b.to(V.range),b.to(V.selectionRange));return g.isNonEmptyArray(V.tags)&&(xe.tags=V.tags.map(J.to)),V.children&&(xe.children=V.children.map(ae)),xe}ve.to=ae})(Z=e.DocumentSymbol||(e.DocumentSymbol={}));var M;(function(ve){function ye(ae){const V=new d.CallHierarchyItem(me.to(ae.kind),ae.name,ae.detail||"",_.URI.revive(ae.uri),b.to(ae.range),b.to(ae.selectionRange));return V._sessionId=ae._sessionId,V._itemId=ae._itemId,V}ve.to=ye})(M=e.CallHierarchyItem||(e.CallHierarchyItem={}));var q;(function(ve){function ye(ae){return new d.CallHierarchyIncomingCall(M.to(ae.from),ae.fromRanges.map(V=>b.to(V)))}ve.to=ye})(q=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var N;(function(ve){function ye(ae){return new d.CallHierarchyOutgoingCall(M.to(ae.to),ae.fromRanges.map(V=>b.to(V)))}ve.to=ye})(N=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var W;(function(ve){function ye(V){return{range:V.range&&b.from(V.range),uri:V.uri}}ve.from=ye;function ae(V){return new d.Location(_.URI.revive(V.uri),b.to(V.range))}ve.to=ae})(W=e.location||(e.location={}));var O;(function(ve){function ye(V){const xe=V,Te=V;return{originSelectionRange:xe.originSelectionRange?b.from(xe.originSelectionRange):void 0,uri:xe.targetUri?xe.targetUri:Te.uri,range:b.from(xe.targetRange?xe.targetRange:Te.range),targetSelectionRange:xe.targetSelectionRange?b.from(xe.targetSelectionRange):void 0}}ve.from=ye;function ae(V){return{targetUri:_.URI.revive(V.uri),targetRange:b.to(V.range),targetSelectionRange:V.targetSelectionRange?b.to(V.targetSelectionRange):void 0,originSelectionRange:V.originSelectionRange?b.to(V.originSelectionRange):void 0}}ve.to=ae})(O=e.DefinitionLink||(e.DefinitionLink={}));var B;(function(ve){function ye(V){return{range:b.from(V.range),contents:w.fromMany(V.contents)}}ve.from=ye;function ae(V){return new d.Hover(V.contents.map(w.to),b.to(V.range))}ve.to=ae})(B=e.Hover||(e.Hover={}));var Y;(function(ve){function ye(V){return{range:b.from(V.range),expression:V.expression}}ve.from=ye;function ae(V){return new d.EvaluatableExpression(b.to(V.range),V.expression)}ve.to=ae})(Y=e.EvaluatableExpression||(e.EvaluatableExpression={}));var he;(function(ve){function ye(V){if(V instanceof d.InlineValueText)return{type:"text",range:b.from(V.range),text:V.text};if(V instanceof d.InlineValueVariableLookup)return{type:"variable",range:b.from(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};if(V instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:b.from(V.range),expression:V.expression};throw new Error("Unknown 'InlineValue' type")}ve.from=ye;function ae(V){switch(V.type){case"text":return{range:b.to(V.range),text:V.text};case"variable":return{range:b.to(V.range),variableName:V.variableName,caseSensitiveLookup:V.caseSensitiveLookup};case"expression":return{range:b.to(V.range),expression:V.expression}}}ve.to=ae})(he=e.InlineValue||(e.InlineValue={}));var De;(function(ve){function ye(V){return{frameId:V.frameId,stoppedLocation:b.from(V.stoppedLocation)}}ve.from=ye;function ae(V){return new d.InlineValueContext(V.frameId,b.to(V.stoppedLocation))}ve.to=ae})(De=e.InlineValueContext||(e.InlineValueContext={}));var Oe;(function(ve){function ye(V){return{range:b.from(V.range),kind:V.kind}}ve.from=ye;function ae(V){return new d.DocumentHighlight(b.to(V.range),V.kind)}ve.to=ae})(Oe=e.DocumentHighlight||(e.DocumentHighlight={}));var Me;(function(ve){function ye(ae){switch(ae){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}ve.to=ye})(Me=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var He;(function(ve){function ye(ae){return{triggerKind:Me.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}ve.to=ye})(He=e.CompletionContext||(e.CompletionContext={}));var Ye;(function(ve){function ye(V){switch(V){case d.CompletionItemTag.Deprecated:return 1}}ve.from=ye;function ae(V){switch(V){case 1:return d.CompletionItemTag.Deprecated}}ve.to=ae})(Ye=e.CompletionItemTag||(e.CompletionItemTag={}));var qe;(function(ve){const ye=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function ae(Te){var Re;return(Re=ye.get(Te))!==null&&Re!==void 0?Re:9}ve.from=ae;const V=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function xe(Te){var Re;return(Re=V.get(Te))!==null&&Re!==void 0?Re:d.CompletionItemKind.Property}ve.to=xe})(qe=e.CompletionItemKind||(e.CompletionItemKind={}));var Xe;(function(ve){function ye(ae,V){var xe;const Te=new d.CompletionItem(typeof ae.label=="string"?ae.label:ae.label.name);return typeof ae.label!="string"&&(Te.label2=ae.label),Te.insertText=ae.insertText,Te.kind=qe.to(ae.kind),Te.tags=(xe=ae.tags)===null||xe===void 0?void 0:xe.map(Ye.to),Te.detail=ae.detail,Te.documentation=T.isMarkdownString(ae.documentation)?w.to(ae.documentation):ae.documentation,Te.sortText=ae.sortText,Te.filterText=ae.filterText,Te.preselect=ae.preselect,Te.commitCharacters=ae.commitCharacters,C.Range.isIRange(ae.range)?Te.range=b.to(ae.range):typeof ae.range=="object"&&(Te.range={inserting:b.to(ae.range.insert),replacing:b.to(ae.range.replace)}),Te.keepWhitespace=typeof ae.insertTextRules=="undefined"?!1:Boolean(ae.insertTextRules&1),typeof ae.insertTextRules!="undefined"&&ae.insertTextRules&4?Te.insertText=new d.SnippetString(ae.insertText):(Te.insertText=ae.insertText,Te.textEdit=Te.range instanceof d.Range?new d.TextEdit(Te.range,Te.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Te.additionalTextEdits=ae.additionalTextEdits.map(Re=>H.to(Re))),Te.command=V&&ae.command?V.fromInternal(ae.command):void 0,Te}ve.to=ye})(Xe=e.CompletionItem||(e.CompletionItem={}));var $;(function(ve){function ye(V){return{label:V.label,documentation:V.documentation?w.fromStrict(V.documentation):void 0}}ve.from=ye;function ae(V){return{label:V.label,documentation:T.isMarkdownString(V.documentation)?w.to(V.documentation):V.documentation}}ve.to=ae})($=e.ParameterInformation||(e.ParameterInformation={}));var G;(function(ve){function ye(V){return{label:V.label,documentation:V.documentation?w.fromStrict(V.documentation):void 0,parameters:Array.isArray(V.parameters)?V.parameters.map($.from):[],activeParameter:V.activeParameter}}ve.from=ye;function ae(V){return{label:V.label,documentation:T.isMarkdownString(V.documentation)?w.to(V.documentation):V.documentation,parameters:Array.isArray(V.parameters)?V.parameters.map($.to):[],activeParameter:V.activeParameter}}ve.to=ae})(G=e.SignatureInformation||(e.SignatureInformation={}));var te;(function(ve){function ye(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(G.from):[]}}ve.from=ye;function ae(V){return{activeSignature:V.activeSignature,activeParameter:V.activeParameter,signatures:Array.isArray(V.signatures)?V.signatures.map(G.to):[]}}ve.to=ae})(te=e.SignatureHelp||(e.SignatureHelp={}));var re;(function(ve){function ye(V){var xe;return{text:V.text,position:l.from(V.position),kind:K.from((xe=V.kind)!==null&&xe!==void 0?xe:d.InlayHintKind.Other),whitespaceBefore:V.whitespaceBefore,whitespaceAfter:V.whitespaceAfter}}ve.from=ye;function ae(V){const xe=new d.InlayHint(V.text,l.to(V.position),K.to(V.kind));return xe.whitespaceAfter=V.whitespaceAfter,xe.whitespaceBefore=V.whitespaceBefore,xe}ve.to=ae})(re=e.InlayHint||(e.InlayHint={}));var K;(function(ve){function ye(V){return V}ve.from=ye;function ae(V){return V}ve.to=ae})(K=e.InlayHintKind||(e.InlayHintKind={}));var oe;(function(ve){function ye(V){return{range:b.from(V.range),url:V.target,tooltip:V.tooltip}}ve.from=ye;function ae(V){let xe;if(V.url)try{xe=typeof V.url=="string"?_.URI.parse(V.url,!0):_.URI.revive(V.url)}catch(Te){}return new d.DocumentLink(b.to(V.range),xe)}ve.to=ae})(oe=e.DocumentLink||(e.DocumentLink={}));var fe;(function(ve){function ye(V){const xe=new d.ColorPresentation(V.label);return V.textEdit&&(xe.textEdit=H.to(V.textEdit)),V.additionalTextEdits&&(xe.additionalTextEdits=V.additionalTextEdits.map(Te=>H.to(Te))),xe}ve.to=ye;function ae(V){return{label:V.label,textEdit:V.textEdit?H.from(V.textEdit):void 0,additionalTextEdits:V.additionalTextEdits?V.additionalTextEdits.map(xe=>H.from(xe)):void 0}}ve.from=ae})(fe=e.ColorPresentation||(e.ColorPresentation={}));var Ae;(function(ve){function ye(V){return new d.Color(V[0],V[1],V[2],V[3])}ve.to=ye;function ae(V){return[V.red,V.green,V.blue,V.alpha]}ve.from=ae})(Ae=e.Color||(e.Color={}));var $e;(function(ve){function ye(V){return{range:b.from(V.range)}}ve.from=ye;function ae(V){return new d.SelectionRange(b.to(V.range))}ve.to=ae})($e=e.SelectionRange||(e.SelectionRange={}));var pe;(function(ve){function ye(ae){switch(ae){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}ve.to=ye})(pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ge;(function(ve){function ye(V){switch(V){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}ve.from=ye;function ae(V){switch(V){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}ve.to=ae})(Ge=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var j;(function(ve){function ye(V){if(V===d.EndOfLine.CRLF)return 1;if(V===d.EndOfLine.LF)return 0}ve.from=ye;function ae(V){if(V===1)return d.EndOfLine.CRLF;if(V===0)return d.EndOfLine.LF}ve.to=ae})(j=e.EndOfLine||(e.EndOfLine={}));var ne;(function(ve){function ye(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}ve.from=ye})(ne=e.ProgressLocation||(e.ProgressLocation={}));var ge;(function(ve){function ye(ae){const V={start:ae.start+1,end:ae.end+1};return ae.kind&&(V.kind=Fe.from(ae.kind)),V}ve.from=ye})(ge=e.FoldingRange||(e.FoldingRange={}));var Fe;(function(ve){function ye(ae){if(ae)switch(ae){case d.FoldingRangeKind.Comment:return n.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return n.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return n.FoldingRangeKind.Region}}ve.from=ye})(Fe=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ne;(function(ve){function ye(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?b.from(ae.selection):void 0,override:typeof ae.override=="boolean"?I.EditorOverride.DISABLED:void 0}}ve.from=ye})(Ne=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Qe;(function(ve){function ye(V){return V instanceof d.RelativePattern||typeof V=="string"?V:ae(V)?new d.RelativePattern(V.base,V.pattern):V}ve.from=ye;function ae(V){const xe=V;return xe&&typeof xe.base=="string"&&typeof xe.pattern=="string"}})(Qe=e.GlobPattern||(e.GlobPattern={}));var Ee;(function(ve){function ye(ae){if(ae){if(Array.isArray(ae))return ae.map(ye);if(typeof ae=="string")return ae;{const V=ae;return{language:V.language,scheme:V.scheme,pattern:typeof V.pattern=="undefined"?void 0:Qe.from(V.pattern),exclusive:V.exclusive}}}else return}ve.from=ye})(Ee=e.LanguageSelector||(e.LanguageSelector={}));var be;(function(ve){function ye(V){return{start:V.start,end:V.end}}ve.from=ye;function ae(V){return new d.NotebookRange(V.start,V.end)}ve.to=ae})(be=e.NotebookRange||(e.NotebookRange={}));var Ce;(function(ve){function ye(V){return{timing:typeof V.runStartTime=="number"&&typeof V.runEndTime=="number"?{startTime:V.runStartTime,endTime:V.runEndTime}:void 0,executionOrder:V.executionOrder,success:V.lastRunSuccess}}ve.to=ye;function ae(V){var xe,Te;return{lastRunSuccess:V.success,runStartTime:(xe=V.timing)===null||xe===void 0?void 0:xe.startTime,runEndTime:(Te=V.timing)===null||Te===void 0?void 0:Te.endTime,executionOrder:V.executionOrder}}ve.from=ae})(Ce=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var se;(function(ve){function ye(V){switch(V){case d.NotebookCellKind.Markup:return h.CellKind.Markup;case d.NotebookCellKind.Code:default:return h.CellKind.Code}}ve.from=ye;function ae(V){switch(V){case h.CellKind.Markup:return d.NotebookCellKind.Markup;case h.CellKind.Code:default:return d.NotebookCellKind.Code}}ve.to=ae})(se=e.NotebookCellKind||(e.NotebookCellKind={}));var de;(function(ve){function ye(V){var xe;const Te={metadata:(xe=V.metadata)!==null&&xe!==void 0?xe:Object.create(null),cells:[]};for(let Re of V.cells)d.NotebookCellData.validate(Re),Te.cells.push(U.from(Re));return Te}ve.from=ye;function ae(V){const xe=new d.NotebookData(V.cells.map(U.to));return D.isEmptyObject(V.metadata)||(xe.metadata=V.metadata),xe}ve.to=ae})(de=e.NotebookData||(e.NotebookData={}));var U;(function(ve){function ye(V){var xe;return{cellKind:se.from(V.kind),language:V.languageId,mime:V.mime,source:V.value,metadata:V.metadata,internalMetadata:Ce.from((xe=V.executionSummary)!==null&&xe!==void 0?xe:{}),outputs:V.outputs?V.outputs.map(le.from):[]}}ve.from=ye;function ae(V){return new d.NotebookCellData(se.to(V.cellKind),V.source,V.language,V.mime,V.outputs?V.outputs.map(le.to):void 0,V.metadata,V.internalMetadata?Ce.to(V.internalMetadata):void 0)}ve.to=ae})(U=e.NotebookCellData||(e.NotebookCellData={}));var Q;(function(ve){function ye(V){return{mime:V.mime,valueBytes:Array.from(V.data)}}ve.from=ye;function ae(V){return new d.NotebookCellOutputItem(new Uint8Array(V.valueBytes),V.mime)}ve.to=ae})(Q=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var le;(function(ve){function ye(V){return{outputId:V.id,items:V.items.map(Q.from),metadata:V.metadata}}ve.from=ye;function ae(V){const xe=V.items.map(Q.to);return new d.NotebookCellOutput(xe,V.outputId,V.metadata)}ve.to=ae})(le=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ke;(function(ve){function ye(Te){if(Te!=null){if(Te instanceof d.RelativePattern||typeof Te=="string")return Te;if(xe(Te))return new d.RelativePattern(Te.base,Te.pattern);if(V(Te))return{include:Qe.from(Te.include)||void 0,exclude:Qe.from(Te.exclude)||void 0}}}ve.from=ye;function ae(Te){return typeof Te=="string"?Te:xe(Te)?{base:Te.base,pattern:Te.pattern}:{include:Te.include,exclude:Te.exclude}}ve.to=ae;function V(Te){const Re=Te,nt=Qe.from(Re.include);if(!(nt&&nt instanceof d.RelativePattern||typeof nt=="string"))return!1;const ot=Qe.from(Re.exclude);return!!(ot&&ot instanceof d.RelativePattern||typeof ot=="string")}function xe(Te){const Re=Te;return Re&&typeof Re.base=="string"&&typeof Re.pattern=="string"}})(ke=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Pe;(function(ve){function ye(ae){return{backgroundColor:ae.backgroundColor,borderColor:ae.borderColor,top:ae.top?A.from(ae.top):void 0}}ve.from=ye})(Pe=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ue;(function(ve){function ye(ae,V,xe){const Te=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:V.toInternal(Te,xe),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}ve.from=ye})(Ue=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var We;(function(ve){function ye(ae){var V,xe,Te;return{transientOutputs:(V=ae==null?void 0:ae.transientOutputs)!==null&&V!==void 0?V:!1,transientCellMetadata:(xe=ae==null?void 0:ae.transientCellMetadata)!==null&&xe!==void 0?xe:{},transientDocumentMetadata:(Te=ae==null?void 0:ae.transientDocumentMetadata)!==null&&Te!==void 0?Te:{}}}ve.from=ye})(We=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ze;(function(ve){function ye(V){return{uri:V.uri,provides:V.provides}}ve.from=ye;function ae(V){return new d.NotebookRendererScript(_.URI.revive(V.uri),V.provides)}ve.to=ae})(Ze=e.NotebookRendererScript||(e.NotebookRendererScript={}));var rt;(function(ve){function ye(V){return{message:w.fromStrict(V.message)||"",severity:V.severity,expectedOutput:V.expectedOutput,actualOutput:V.actualOutput,location:V.location?W.from(V.location):void 0}}ve.from=ye;function ae(V){const xe=new d.TestMessage(typeof V.message=="string"?V.message:w.to(V.message));return xe.severity=V.severity,xe.actualOutput=V.actualOutput,xe.expectedOutput=V.expectedOutput,xe}ve.to=ae})(rt=e.TestMessage||(e.TestMessage={}));var Ke;(function(ve){function ye(Te){var Re,nt;return{extId:Te.id,label:Te.label,uri:Te.uri,range:b.from(Te.range)||null,debuggable:(Re=Te.debuggable)!==null&&Re!==void 0?Re:!1,description:Te.description||null,runnable:(nt=Te.runnable)!==null&&nt!==void 0?nt:!0,error:Te.error&&w.fromStrict(Te.error)||null}}ve.from=ye;function ae(Te){return{extId:Te.id,label:Te.label,uri:Te.uri,range:b.from(Te.range)||null,debuggable:!1,description:Te.description||null,error:null,runnable:!0}}ve.fromResultSnapshot=ae;function V(Te){return{id:Te.extId,label:Te.label,uri:_.URI.revive(Te.uri),range:b.to(Te.range||void 0),addChild:()=>{},dispose:()=>{},status:d.TestItemStatus.Pending,data:void 0,debuggable:Te.debuggable,description:Te.description||void 0,runnable:Te.runnable}}ve.toPlain=V;function xe(Te){const Re=new d.TestItemImpl(Te.extId,Te.label,_.URI.revive(Te.uri),void 0);return Re.range=b.to(Te.range||void 0),Re.debuggable=Te.debuggable,Re.description=Te.description||void 0,Re.runnable=Te.runnable,Re}ve.to=xe})(Ke=e.TestItem||(e.TestItem={}));var Je;(function(ve){const ye=(V,xe)=>Object.assign(Object.assign({},Ke.toPlain(V.item)),{taskStates:V.tasks.map(Te=>({state:Te.state,duration:Te.duration,messages:Te.messages.map(rt.to)})),children:V.children.map(Te=>xe.get(Te)).filter(D.isDefined).map(Te=>ye(Te,xe))});function ae(V){const xe=[],Te=new Map;for(const Re of V.items)Te.set(Re.item.extId,Re),Re.direct&&xe.push(Re);return{completedAt:V.completedAt,results:xe.map(Re=>ye(Re,Te))}}ve.to=ae})(Je=e.TestResults||(e.TestResults={}));var ft;(function(ve){function ye(ae){switch(ae){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}ve.to=ye})(ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(we[167],_e([0,1,2,11,6,9,51]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class D{constructor(C,n,I,o={timeout:1500,errors:3}){this._logService=C,this._documents=n,this._mainThreadBulkEdits=I,this._thresholds=o,this._callbacks=new k.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(C){return(n,I,o)=>{const c={dispose:this._callbacks.push([n,I,C])};return Array.isArray(o)&&o.push(c),c}}async $participateInSave(C,n){const I=g.URI.revive(C);let o=!1;const h=setTimeout(()=>o=!0,this._thresholds.timeout),c=[];try{for(let d of[...this._callbacks]){if(o)break;const y=this._documents.getDocument(I),b=await this._deliverEventAsyncAndBlameBadListeners(d,{document:y,reason:E.TextDocumentSaveReason.to(n)});c.push(b)}}finally{clearTimeout(h)}return c}_deliverEventAsyncAndBlameBadListeners([C,n,I],o){const h=this._badListeners.get(C);return typeof h=="number"&&h>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(I,C,n,o).then(()=>!0,c=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' threw ERROR`),this._logService.error(c),!(c instanceof Error)||c.message!=="concurrent_edits"){const d=this._badListeners.get(C);this._badListeners.set(C,d?d+1:1),typeof d=="number"&&d>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(C,n,I,o){const h=[],c=Date.now(),{document:d,reason:y}=o,{version:b}=d,p=Object.freeze({document:d,reason:y,waitUntil(l){if(Object.isFrozen(h))throw T.illegalState("waitUntil can not be called async");h.push(Promise.resolve(l))}});try{n.apply(I,[p])}catch(l){return Promise.reject(l)}return Object.freeze(h),new Promise((l,f)=>{const m=setTimeout(()=>f(new Error("timeout")),this._thresholds.timeout);return Promise.all(h).then(t=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${C.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(m),l(t)}).catch(t=>{clearTimeout(m),f(t)})}).then(l=>{const f={edits:[]};for(const m of l)if(Array.isArray(m)&&m.every(t=>t instanceof S.TextEdit))for(const{newText:t,newEol:r,range:s}of m)f.edits.push({_type:2,resource:d.uri,edit:{range:s&&E.Range.from(s),text:t,eol:r&&E.EndOfLine.from(r)}});if(f.edits.length!==0)return b===d.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(f):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=D}),define(we[168],_e([0,1,3,12,27,2,9,6]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class _{constructor(I,o,h,c,d){this._onDidCreate=new g.Emitter,this._onDidChange=new g.Emitter,this._onDidDelete=new g.Emitter,this._config=0,h&&(this._config+=1),c&&(this._config+=2),d&&(this._config+=4);const y=S.parse(o),b=I(p=>{if(!h)for(let l of p.created){const f=E.URI.revive(l);y(f.fsPath)&&this._onDidCreate.fire(f)}if(!c)for(let l of p.changed){const f=E.URI.revive(l);y(f.fsPath)&&this._onDidChange.fire(f)}if(!d)for(let l of p.deleted){const f=E.URI.revive(l);y(f.fsPath)&&this._onDidDelete.fire(f)}});this._disposable=D.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,b)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class C{constructor(I,o,h){this._logService=o,this._extHostDocumentsAndEditors=h,this._onFileSystemEvent=new g.Emitter,this._onDidRenameFile=new g.Emitter,this._onDidCreateFile=new g.Emitter,this._onDidDeleteFile=new g.Emitter,this._onWillRenameFile=new T.AsyncEmitter,this._onWillCreateFile=new T.AsyncEmitter,this._onWillDeleteFile=new T.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(I,o,h,c){return new _(this._onFileSystemEvent.event,I,o,h,c)}$onFileEvent(I){this._onFileSystemEvent.fire(I)}$onDidRunFileOperation(I,o){switch(I){case 2:this._onDidRenameFile.fire(Object.freeze({files:o.map(h=>({oldUri:E.URI.revive(h.source),newUri:E.URI.revive(h.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:o.map(h=>E.URI.revive(h.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:o.map(h=>E.URI.revive(h.target))}));break;default:}}getOnWillRenameFileEvent(I){return this._createWillExecuteEvent(I,this._onWillRenameFile)}getOnWillCreateFileEvent(I){return this._createWillExecuteEvent(I,this._onWillCreateFile)}getOnWillDeleteFileEvent(I){return this._createWillExecuteEvent(I,this._onWillDeleteFile)}_createWillExecuteEvent(I,o){return(h,c,d)=>{const y=function(p){h.call(c,p)};return y.extension=I,o.event(y,void 0,d)}}async $onWillRunFileOperation(I,o,h,c){switch(I){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:o.map(d=>({oldUri:E.URI.revive(d.source),newUri:E.URI.revive(d.target)}))},h,c);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:o.map(d=>E.URI.revive(d.target))},h,c);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:o.map(d=>E.URI.revive(d.target))},h,c)}}async _fireWillEvent(I,o,h,c){const d=new Set,y=[];if(await I.fireAsync(o,c,async(p,l)=>{var f;const m=Date.now(),t=await Promise.resolve(p);t instanceof D.WorkspaceEdit&&(y.push(t),d.add((f=l.extension.displayName)!==null&&f!==void 0?f:l.extension.identifier.value)),Date.now()-m>h&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),c.isCancellationRequested||y.length===0)return;const b={edits:[]};for(let p of y){let{edits:l}=k.WorkspaceEdit.from(p,this._extHostDocumentsAndEditors);b.edits=b.edits.concat(l)}return{edit:b,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=C}),define(we[169],_e([0,1,16,24,2,9,6,68]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class _{constructor(o,h,c,d){this.start=o,this.deletedCount=h,this.deletedItems=c,this.items=d}static asApiEvents(o){return o.map(h=>({start:h.start,deletedCount:h.deletedCount,deletedItems:h.deletedItems,items:h.items.map(c=>c.apiCell)}))}}class C{constructor(o,h,c){var d,y,b;this.notebook=o,this._extHostDocument=h,this._cellData=c,this.handle=c.handle,this.uri=S.URI.revive(c.uri),this.cellKind=c.cellKind,this._outputs=c.outputs.map(E.NotebookCellOutput.to),this._internalMetadata=(d=c.internalMetadata)!==null&&d!==void 0?d:{},this._metadata=(y=c.metadata)!==null&&y!==void 0?y:{},this._previousResult=E.NotebookCellExecutionSummary.to((b=c.internalMetadata)!==null&&b!==void 0?b:{})}static asModelAddData(o,h){return{EOL:h.eol,lines:h.source,modeId:h.language,uri:h.uri,isDirty:!1,versionId:1,notebook:o}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const o=this,h=this._extHostDocument.getDocument(this.uri);if(!h)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return o.notebook.getCellIndex(o)},notebook:o.notebook.apiNotebook,kind:E.NotebookCellKind.to(this._cellData.cellKind),document:h.document,get mime(){return o._mime},set mime(c){o._mime=c},get outputs(){return o._outputs.slice(0)},get metadata(){return o._metadata},get executionSummary(){return o._previousResult}})}return this._apiCell}setOutputs(o){this._outputs=o.map(E.NotebookCellOutput.to)}setOutputItems(o,h,c){const d=c.map(E.NotebookCellOutputItem.to),y=this._outputs.find(b=>b.id===o);y&&(h||(y.items.length=0),y.items.push(...d))}setMetadata(o){this._metadata=o}setInternalMetadata(o){this._internalMetadata=o,this._previousResult=E.NotebookCellExecutionSummary.to(o)}setMime(o){}}e.ExtHostCell=C;class n{constructor(o,h,c,d,y,b){var p;this._proxy=o,this._textDocumentsAndEditors=h,this._textDocuments=c,this._emitter=d,this.uri=y,this.handle=n._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=b.viewType,this._metadata=(p=b.metadata)!==null&&p!==void 0?p:Object.create(null),this._spliceNotebookCells([[0,0,b.cells]],!0),this._versionId=b.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const o=this;this._notebook={get uri(){return o.uri},get version(){return o._versionId},get notebookType(){return o._notebookType},get isDirty(){return o._isDirty},get isUntitled(){return o.uri.scheme===g.Schemas.untitled},get isClosed(){return o._disposed},get metadata(){return o._metadata},get cellCount(){return o._cells.length},cellAt(h){return h=o._validateIndex(h),o._cells[h].apiCell},getCells(h){return(h?o._getCells(h):o._cells).map(d=>d.apiCell)},save(){return o._save()}}}return this._notebook}updateBackup(o){var h;(h=this._backup)===null||h===void 0||h.delete(),this._backup=o}disposeBackup(){var o;(o=this._backup)===null||o===void 0||o.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(o){o.metadata&&(this._metadata=Object.assign(Object.assign({},this._metadata),o.metadata))}acceptDirty(o){this._isDirty=o}acceptModelChanged(o,h){this._versionId=o.versionId,this._isDirty=h;for(const c of o.rawEvents)c.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(c.changes,!1):c.kind===D.NotebookCellsChangeType.Move?this._moveCell(c.index,c.newIdx):c.kind===D.NotebookCellsChangeType.Output?this._setCellOutputs(c.index,c.outputs):c.kind===D.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(c.index,c.outputId,c.append,c.outputItems):c.kind===D.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(c.index,c.language):c.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(c.index,c.mime):c.kind===D.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(c.index,c.metadata):c.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(c.index,c.internalMetadata)}_validateIndex(o){return o=o|0,o<0?0:o>=this._cells.length?this._cells.length-1:o}_validateRange(o){let h=o.start|0,c=o.end|0;return h<0&&(h=0),c>this._cells.length&&(c=this._cells.length),o.with({start:h,end:c})}_getCells(o){o=this._validateRange(o);const h=[];for(let c=o.start;c<o.end;c++)h.push(this._cells[c]);return h}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(o,h){if(this._disposed)return;const c=[],d=[],y=[];o.reverse().forEach(b=>{const l=b[2].map(t=>{const r=new C(this,this._textDocumentsAndEditors,t);return h||d.push(C.asModelAddData(this.apiNotebook,t)),r}),f=new _(b[0],b[1],[],l),m=this._cells.splice(b[0],b[1],...l);for(const t of m)y.push(t.uri),f.deletedItems.push(t.apiCell);c.push(f)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:d,removedDocuments:y}),h||this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(c)}))}_moveCell(o,h){const c=this._cells.splice(o,1);this._cells.splice(h,0,...c);const d=[new _(o,1,c.map(y=>y.apiCell),[]),new _(h,0,[],c)];this._emitter.emitModelChange(T.deepFreeze({document:this.apiNotebook,changes:_.asApiEvents(d)}))}_setCellOutputs(o,h){const c=this._cells[o];c.setOutputs(h),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[c.apiCell]}))}_setCellOutputItems(o,h,c,d){const y=this._cells[o];y.setOutputItems(h,c,d),this._emitter.emitCellOutputsChange(T.deepFreeze({document:this.apiNotebook,cells:[y.apiCell]}))}_changeCellLanguage(o,h){const c=this._cells[o];c.apiCell.document.languageId!==h&&this._textDocuments.$acceptModelModeChanged(c.uri,h)}_changeCellMime(o,h){const c=this._cells[o];c.apiCell.mime=h}_changeCellMetadata(o,h){const c=this._cells[o],d=c.apiCell.metadata;c.setMetadata(h);const y=c.apiCell.metadata;T.equals(d,y)||this._emitter.emitCellMetadataChange(T.deepFreeze({document:this.apiNotebook,cell:c.apiCell}))}_changeCellInternalMetadata(o,h){var c;const d=this._cells[o],y=d.internalMetadata;if(d.setInternalMetadata(h),y.runState!==h.runState){const b=(c=h.runState)!==null&&c!==void 0?c:k.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange(T.deepFreeze({document:this.apiNotebook,cell:d.apiCell,state:b}))}}getCellFromApiCell(o){return this._cells.find(h=>h.apiCell===o)}getCellFromIndex(o){return this._cells[o]}getCell(o){return this._cells.find(h=>h.handle===o)}getCellIndex(o){return this._cells.indexOf(o)}}e.ExtHostNotebookDocument=n,n._handlePool=0}),define(we[97],_e([0,1,6,9,11]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class E{constructor(_){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=_}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(_){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:_})}replaceCellMetadata(_,C){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:_,metadata:C})}replaceCells(_,C,n){this._throwIfFinalized(),!(_===C&&n.length===0)&&this._collectedEdits.push({editType:1,index:_,count:C-_,cells:n.map(T.NotebookCellData.from)})}}class k{constructor(_,C,n,I,o,h){this.id=_,this._proxy=C,this.notebookData=n,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=o,this._visibleRanges=I,this._viewColumn=h}get apiEditor(){if(!this._editor){const _=this;this._editor={get document(){return _.notebookData.apiNotebook},get selections(){return _._selections},set selections(C){if(!Array.isArray(C)||!C.every(g.NotebookRange.isNotebookRange))throw S.illegalArgument("selections");_._selections=C,_._trySetSelections(C)},get visibleRanges(){return _._visibleRanges},revealRange(C,n){_._proxy.$tryRevealRange(_.id,T.NotebookRange.from(C),n??g.NotebookEditorRevealType.Default)},get viewColumn(){return _._viewColumn},edit(C){const n=new E(this.document.version);return C(n),_._applyEdit(n.finalize())},setDecorations(C,n){return _.setDecorations(C,n)}},k.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(_){this._visible=_}_acceptVisibleRanges(_){this._visibleRanges=_}_acceptSelections(_){this._selections=_}_trySetSelections(_){this._proxy.$trySetSelections(this.id,_.map(T.NotebookRange.from))}_acceptViewColumn(_){this._viewColumn=_}_applyEdit(_){if(_.cellEdits.length===0)return Promise.resolve(!0);const C=[];let n=-1;for(let I=0;I<_.cellEdits.length;I++){if(n<0){C.push(_.cellEdits[I]),n++;continue}const h=C[n],c=_.cellEdits[I];if(h.editType===1&&c.editType===1&&h.index===c.index){h.cells.push(..._.cellEdits[I].cells),h.count+=_.cellEdits[I].count;continue}C.push(_.cellEdits[I]),n++}return this._proxy.$tryApplyEdits(this.id,_.documentVersionId,C)}setDecorations(_,C){if(!(C.isEmpty&&!this._hasDecorationsForKey.has(_.key)))return C.isEmpty?this._hasDecorationsForKey.delete(_.key):this._hasDecorationsForKey.add(_.key),this._proxy.$trySetDecorations(this.id,T.NotebookRange.from(C),_.key)}}e.ExtHostNotebookEditor=k,k.apiEditorsToExtHost=new WeakMap}),define(we[170],_e([0,1,9,149,130,18,48]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(I){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=I}withProgress(I,o,h){const c=this._handles++,{title:d,location:y,cancellable:b}=o,p={label:S.localize(0,null,I.displayName||I.name),id:I.identifier.value};return this._proxy.$startProgress(c,{location:g.ProgressLocation.from(y),title:d,source:p,cancellable:b},I),this._withProgress(c,h,!!b)}_withProgress(I,o,h){let c;h&&(c=new E.CancellationTokenSource,this._mapHandleToCancellationSource.set(I,c));const d=b=>{this._proxy.$progressEnd(b),this._mapHandleToCancellationSource.delete(b),c&&c.dispose()};let y;try{y=o(new C(this._proxy,I),h&&c?c.token:E.CancellationToken.None)}catch(b){throw d(I),b}return y.then(b=>d(I),b=>d(I)),y}$acceptProgressCanceled(I){const o=this._mapHandleToCancellationSource.get(I);o&&(o.cancel(),this._mapHandleToCancellationSource.delete(I))}}e.ExtHostProgress=D;function _(n,I){return n.message=I.message,typeof I.increment=="number"&&(typeof n.increment=="number"?n.increment+=I.increment:n.increment=I.increment),n}class C extends T.Progress{constructor(I,o){super(h=>this.throttledReport(h));this._proxy=I,this._handle=o}throttledReport(I){this._proxy.$progressReport(this._handle,I)}}Ve([k.throttle(100,(n,I)=>_(n,I),()=>Object.create(null))],C.prototype,"throttledReport",null)}),define(we[98],_e([0,1,39,11,50,9,6]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class D{constructor(o,h,c){const d=D._Keys.nextId();o.$registerTextEditorDecorationType(h.identifier,d,E.DecorationRenderOptions.from(c)),this.value=Object.freeze({key:d,dispose(){o.$removeTextEditorDecorationType(d)}})}}e.TextEditorDecorationType=D,D._Keys=new S.IdGenerator("TextEditorDecorationType");class _{constructor(o,h){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=o,this._documentVersionId=o.version,this._undoStopBefore=h.undoStopBefore,this._undoStopAfter=h.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(o,h){this._throwIfFinalized();let c=null;if(o instanceof k.Position)c=new k.Range(o,o);else if(o instanceof k.Range)c=o;else throw new Error("Unrecognized location");this._pushEdit(c,h,!1)}insert(o,h){this._throwIfFinalized(),this._pushEdit(new k.Range(o,o),h,!0)}delete(o){this._throwIfFinalized();let h=null;if(o instanceof k.Range)h=o;else throw new Error("Unrecognized location");this._pushEdit(h,null,!0)}_pushEdit(o,h,c){const d=this._document.validateRange(o);this._collectedEdits.push({range:d,text:h,forceMoveMarkers:c})}setEndOfLine(o){if(this._throwIfFinalized(),o!==k.EndOfLine.LF&&o!==k.EndOfLine.CRLF)throw T.illegalArgument("endOfLine");this._setEndOfLine=o}}e.TextEditorEdit=_;class C{constructor(o,h,c,d){this._proxy=o,this._id=h,this._accept(c),this._logService=d;const y=this;this.value={get tabSize(){return y._tabSize},set tabSize(b){y._setTabSize(b)},get insertSpaces(){return y._insertSpaces},set insertSpaces(b){y._setInsertSpaces(b)},get cursorStyle(){return y._cursorStyle},set cursorStyle(b){y._setCursorStyle(b)},get lineNumbers(){return y._lineNumbers},set lineNumbers(b){y._setLineNumbers(b)}}}_accept(o){this._tabSize=o.tabSize,this._insertSpaces=o.insertSpaces,this._cursorStyle=o.cursorStyle,this._lineNumbers=E.TextEditorLineNumbersStyle.to(o.lineNumbers)}_validateTabSize(o){if(o==="auto")return"auto";if(typeof o=="number"){const h=Math.floor(o);return h>0?h:null}if(typeof o=="string"){const h=parseInt(o,10);return isNaN(h)?null:h>0?h:null}return null}_setTabSize(o){const h=this._validateTabSize(o);if(h!==null){if(typeof h=="number"){if(this._tabSize===h)return;this._tabSize=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:h}))}}_validateInsertSpaces(o){return o==="auto"?"auto":o==="false"?!1:Boolean(o)}_setInsertSpaces(o){const h=this._validateInsertSpaces(o);if(typeof h=="boolean"){if(this._insertSpaces===h)return;this._insertSpaces=h}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:h}))}_setCursorStyle(o){this._cursorStyle!==o&&(this._cursorStyle=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:o})))}_setLineNumbers(o){this._lineNumbers!==o&&(this._lineNumbers=o,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:E.TextEditorLineNumbersStyle.from(o)})))}assign(o){const h={};let c=!1;if(typeof o.tabSize!="undefined"){const d=this._validateTabSize(o.tabSize);d==="auto"?(c=!0,h.tabSize=d):typeof d=="number"&&this._tabSize!==d&&(this._tabSize=d,c=!0,h.tabSize=d)}if(typeof o.insertSpaces!="undefined"){const d=this._validateInsertSpaces(o.insertSpaces);d==="auto"?(c=!0,h.insertSpaces=d):this._insertSpaces!==d&&(this._insertSpaces=d,c=!0,h.insertSpaces=d)}typeof o.cursorStyle!="undefined"&&this._cursorStyle!==o.cursorStyle&&(this._cursorStyle=o.cursorStyle,c=!0,h.cursorStyle=o.cursorStyle),typeof o.lineNumbers!="undefined"&&this._lineNumbers!==o.lineNumbers&&(this._lineNumbers=o.lineNumbers,c=!0,h.lineNumbers=E.TextEditorLineNumbersStyle.from(o.lineNumbers)),c&&this._warnOnError(this._proxy.$trySetOptions(this._id,h))}_warnOnError(o){o.catch(h=>this._logService.warn(h))}}e.ExtHostTextEditorOptions=C;class n{constructor(o,h,c,d,y,b,p,l){this.id=o,this._proxy=h,this._logService=c,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=y,this._options=new C(this._proxy,this.id,b,c),this._visibleRanges=p,this._viewColumn=l;const f=this;this.value=Object.freeze({get document(){return d.getValue()},set document(m){throw T.readonly("document")},get selection(){return f._selections&&f._selections[0]},set selection(m){if(!(m instanceof k.Selection))throw T.illegalArgument("selection");f._selections=[m],f._trySetSelection()},get selections(){return f._selections},set selections(m){if(!Array.isArray(m)||m.some(t=>!(t instanceof k.Selection)))throw T.illegalArgument("selections");f._selections=m,f._trySetSelection()},get visibleRanges(){return f._visibleRanges},set visibleRanges(m){throw T.readonly("visibleRanges")},get options(){return f._options.value},set options(m){f._disposed||f._options.assign(m)},get viewColumn(){return f._viewColumn},set viewColumn(m){throw T.readonly("viewColumn")},edit(m,t={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const r=new _(d.getValue(),t);return m(r),f._applyEdit(r)},insertSnippet(m,t,r={undoStopBefore:!0,undoStopAfter:!0}){if(f._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=f._selections.map(i=>E.Range.from(i));else if(t instanceof k.Position){const{lineNumber:i,column:u}=E.Position.from(t);s=[{startLineNumber:i,startColumn:u,endLineNumber:i,endColumn:u}]}else if(t instanceof k.Range)s=[E.Range.from(t)];else{s=[];for(const i of t)if(i instanceof k.Range)s.push(E.Range.from(i));else{const{lineNumber:u,column:w}=E.Position.from(i);s.push({startLineNumber:u,startColumn:w,endLineNumber:u,endColumn:w})}}return h.$tryInsertSnippet(o,m.value,s,r)},setDecorations(m,t){const r=t.length===0;r&&!f._hasDecorationsForKey.has(m.key)||(r?f._hasDecorationsForKey.delete(m.key):f._hasDecorationsForKey.add(m.key),f._runOnProxy(()=>{if(E.isDecorationOptionsArr(t))return h.$trySetDecorations(o,m.key,E.fromRangeOrRangeWithMessage(t));{const s=new Array(4*t.length);for(let i=0,u=t.length;i<u;i++){const w=t[i];s[4*i]=w.start.line+1,s[4*i+1]=w.start.character+1,s[4*i+2]=w.end.line+1,s[4*i+3]=w.end.character+1}return h.$trySetDecorationsFast(o,m.key,s)}}))},revealRange(m,t){f._runOnProxy(()=>h.$tryRevealRange(o,E.Range.from(m),t||k.TextEditorRevealType.Default))},show(m){h.$tryShowEditor(o,E.ViewColumn.from(m))},hide(){h.$tryHideEditor(o)}})}dispose(){g.ok(!this._disposed),this._disposed=!0}_acceptOptions(o){g.ok(!this._disposed),this._options._accept(o)}_acceptVisibleRanges(o){g.ok(!this._disposed),this._visibleRanges=o}_acceptViewColumn(o){g.ok(!this._disposed),this._viewColumn=o}_acceptSelections(o){g.ok(!this._disposed),this._selections=o}async _trySetSelection(){const o=this._selections.map(E.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,o)),this.value}_applyEdit(o){const h=o.finalize();if(h.edits.length===0&&!h.setEndOfLine)return Promise.resolve(!0);const c=h.edits.map(y=>y.range);c.sort((y,b)=>y.end.line===b.end.line?y.end.character===b.end.character?y.start.line===b.start.line?y.start.character-b.start.character:y.start.line-b.start.line:y.end.character-b.end.character:y.end.line-b.end.line);for(let y=0,b=c.length-1;y<b;y++){const p=c[y].end;if(c[y+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const d=h.edits.map(y=>({range:E.Range.from(y.range),text:y.text,forceMoveMarkers:y.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,h.documentVersionId,d,{setEndOfLine:typeof h.setEndOfLine=="number"?E.EndOfLine.from(h.setEndOfLine):void 0,undoStopBefore:h.undoStopBefore,undoStopAfter:h.undoStopAfter})}_runOnProxy(o){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):o().then(()=>this,h=>(h instanceof Error&&h.name==="DISPOSED"||this._logService.warn(h),null))}}e.ExtHostTextEditor=n}),define(we[171],_e([0,1,133,25,2,3,7,12,6,10,17,9,18]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(y,b){if(C.isString(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let p;return Array.isArray(y.highlights)&&(p=y.highlights.filter(l=>l.length===2&&typeof l[0]=="number"&&typeof l[1]=="number"),p=p.length?p:void 0),{label:y.label,highlights:p}}}class c{constructor(b,p,l){this._proxy=b,this.commands=p,this.logService=l,this.treeViews=new Map;function f(m){return m&&m.$treeViewId&&m.$treeItemHandle}p.registerArgumentProcessor({processArgument:m=>f(m)?this.convertArgument(m):Array.isArray(m)&&m.length>0?m.map(t=>f(t)?this.convertArgument(t):t):m})}registerTreeDataProvider(b,p,l){const f=this.createTreeView(b,{treeDataProvider:p},l);return{dispose:()=>f.dispose()}}createTreeView(b,p,l){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const f=p.dragAndDropController!==void 0,m=this._proxy.$registerTreeViewDataProvider(b,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,canDragAndDrop:f}),t=this.createExtHostTreeView(b,p,l);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(r){t.message=r},get title(){return t.title},set title(r){t.title=r},get description(){return t.description},set description(r){t.description=r},reveal:(r,s)=>t.reveal(r,s),dispose:async()=>{await m,this.treeViews.delete(b),t.dispose()}}}$getChildren(b,p){const l=this.treeViews.get(b);return l?l.getChildren(p):Promise.reject(new Error(g.localize(0,null,b)))}$onDrop(b,p,l){const f=this.treeViews.get(b);return f?f.onDrop(p,l):Promise.reject(new Error(g.localize(1,null,b)))}async $hasResolve(b){const p=this.treeViews.get(b);if(!p)throw new Error(g.localize(2,null,b));return p.hasResolve}$resolve(b,p,l){const f=this.treeViews.get(b);if(!f)throw new Error(g.localize(3,null,b));return f.resolveTreeItem(p,l)}$setExpanded(b,p,l){const f=this.treeViews.get(b);if(!f)throw new Error(g.localize(4,null,b));f.setExpanded(p,l)}$setSelection(b,p){const l=this.treeViews.get(b);if(!l)throw new Error(g.localize(5,null,b));l.setSelection(p)}$setVisible(b,p){const l=this.treeViews.get(b);if(!l)throw new Error(g.localize(6,null,b));l.setVisible(p)}createExtHostTreeView(b,p,l){const f=new d(b,p,this._proxy,this.commands.converter,this.logService,l);return this.treeViews.set(b,f),f}convertArgument(b){const p=this.treeViews.get(b.$treeViewId);return p?p.getExtensionElement(b.$treeItemHandle):null}}e.ExtHostTreeViews=c;class d extends k.Disposable{constructor(b,p,l,f,m,t){super();if(this.viewId=b,this.proxy=l,this.commands=f,this.logService=m,this.extension=t,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new E.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new E.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new E.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new E.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new E.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new o.CancellationTokenSource,t.contributes&&t.contributes.views)for(const i in t.contributes.views)for(const u of t.contributes.views[i])u.id===b&&(this._title=u.name);this.dataProvider=p.treeDataProvider,this.dndController=p.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(i=>this._onDidChangeData.fire({message:!1,element:i})));let r,s;this._register(E.Event.debounce(this._onDidChangeData.event,(i,u)=>(i||(i={message:!1,elements:[]}),u.element!==!1&&(r||(r=new Promise(w=>s=w),this.refreshPromise=this.refreshPromise.then(()=>r)),i.elements.push(u.element)),u.message&&(i.message=!0),i),200,!0)(({message:i,elements:u})=>{u.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const w=s;return r=null,this.refresh(u).then(()=>w())})),i&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(b=>this.getExtensionElement(b)).filter(b=>!C.isUndefinedOrNull(b))}getChildren(b){const p=b?this.getExtensionElement(b):void 0;if(b&&!p)return this.logService.error(`No tree item with id '${b}' found.`),Promise.resolve([]);const l=this.getChildrenNodes(b);return(l?Promise.resolve(l):this.fetchChildrenNodes(p)).then(f=>f.map(m=>m.item))}getExtensionElement(b){return this.elements.get(b)}reveal(b,p){p=p||{select:!0,focus:!1};const l=C.isUndefinedOrNull(p.select)?!0:p.select,f=C.isUndefinedOrNull(p.focus)?!1:p.focus,m=C.isUndefinedOrNull(p.expand)?!1:p.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):b?this.refreshPromise.then(()=>this.resolveUnknownParentChain(b)).then(t=>this.resolveTreeNode(b,t[t.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:t.map(s=>s.item)},{select:l,focus:f,expand:m})),t=>this.logService.error(t)):this.proxy.$reveal(this.viewId,void 0,{select:l,focus:f,expand:m})}get message(){return this._message}set message(b){this._message=b,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(b){this._title=b,this.proxy.$setTitle(this.viewId,b,this._description)}get description(){return this._description}set description(b){this._description=b,this.proxy.$setTitle(this.viewId,this._title,b)}setExpanded(b,p){const l=this.getExtensionElement(b);l&&(p?this._onDidExpandElement.fire(Object.freeze({element:l})):this._onDidCollapseElement.fire(Object.freeze({element:l})))}setSelection(b){n.equals(this._selectedHandles,b)||(this._selectedHandles=b,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(b){b!==this._visible&&(this._visible=b,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}onDrop(b,p){const l=b.map(m=>this.getExtensionElement(m)).filter(m=>!C.isUndefinedOrNull(m)),f=this.getExtensionElement(p);return l&&f?D.asPromise(()=>{var m;return(m=this.dndController)===null||m===void 0?void 0:m.onDrop(l,f)}):Promise.resolve(void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(b,p){var l;if(!this.dataProvider.resolveTreeItem)return;const f=this.elements.get(b);if(f){const m=this.nodes.get(f);if(m){const t=(l=await this.dataProvider.resolveTreeItem(m.extensionItem,f,p))!==null&&l!==void 0?l:m.extensionItem;return m.item.tooltip=this.getTooltip(t.tooltip),m.item.command=this.getCommand(m.disposableStore,t.command),m.item}}}resolveUnknownParentChain(b){return this.resolveParent(b).then(p=>p?this.resolveUnknownParentChain(p).then(l=>this.resolveTreeNode(p,l[l.length-1]).then(f=>(l.push(f),l))):Promise.resolve([]))}resolveParent(b){const p=this.nodes.get(b);return p?Promise.resolve(p.parent?this.elements.get(p.parent.item.handle):void 0):D.asPromise(()=>this.dataProvider.getParent(b))}resolveTreeNode(b,p){const l=this.nodes.get(b);return l?Promise.resolve(l):D.asPromise(()=>this.dataProvider.getTreeItem(b)).then(f=>this.createHandle(b,f,p,!0)).then(f=>this.getChildren(p?p.item.handle:void 0).then(()=>{const m=this.getExtensionElement(f);if(m){const t=this.nodes.get(m);if(t)return Promise.resolve(t)}throw new Error(`Cannot resolve tree item for element ${f}`)}))}getChildrenNodes(b){if(b){let p;if(typeof b=="string"){const l=this.getExtensionElement(b);p=l?this.nodes.get(l):void 0}else p=b;return p&&p.children||null}return this.roots}async fetchChildrenNodes(b){this.clearChildren(b);const p=new o.CancellationTokenSource(this._refreshCancellationSource.token);try{const l=b?this.nodes.get(b):void 0,f=await this.dataProvider.getChildren(b);if(p.token.isCancellationRequested)return[];const m=await Promise.all(n.coalesce(f||[]).map(async t=>{const r=await this.dataProvider.getTreeItem(t);return r&&!p.token.isCancellationRequested?this.createAndRegisterTreeNode(t,r,l):null}));return p.token.isCancellationRequested?[]:n.coalesce(m)}finally{p.dispose()}}refresh(b){if(b.some(l=>!l))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new o.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const l=this.getHandlesToRefresh(b);if(l.length)return this.refreshHandles(l)}return Promise.resolve(void 0)}getHandlesToRefresh(b){const p=new Set,l=b.map(m=>this.nodes.get(m));for(const m of l)if(m&&!p.has(m.item.handle)){let t=m;for(;t&&t.parent&&l.findIndex(r=>t&&t.parent&&r&&r.item.handle===t.parent.item.handle)===-1;){const r=this.elements.get(t.parent.item.handle);t=r?this.nodes.get(r):void 0}t&&!t.parent&&p.add(m.item.handle)}const f=[];return p.forEach(m=>{const t=this.elements.get(m);if(t){const r=this.nodes.get(t);r&&(!r.parent||!p.has(r.parent.item.handle))&&f.push(m)}}),f}refreshHandles(b){const p={};return Promise.all(b.map(l=>this.refreshNode(l).then(f=>{f&&(p[l]=f.item)}))).then(()=>Object.keys(p).length?this.proxy.$refresh(this.viewId,p):void 0)}refreshNode(b){const p=this.getExtensionElement(b);if(p){const l=this.nodes.get(p);if(l)return this.clearChildren(p),D.asPromise(()=>this.dataProvider.getTreeItem(p)).then(f=>{if(f){const m=this.createTreeNode(p,f,l.parent);return this.updateNodeCache(p,m,l,l.parent),l.dispose(),m}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(b,p,l){const f=this.createTreeNode(b,p,l);if(p.id&&this.elements.has(f.item.handle))throw new Error(g.localize(7,null,p.id));return this.addNodeToCache(b,f),this.addNodeToParentCache(f,l),f}getTooltip(b){return _.MarkdownString.isMarkdownString(b)?I.MarkdownString.from(b):b}getCommand(b,p){return p?this.commands.toInternal(p,b):void 0}createTreeNode(b,p,l){const f=new k.DisposableStore,m=this.createHandle(b,p,l),t=this.getLightIconPath(p);return{item:{handle:m,parentHandle:l?l.item.handle:void 0,label:h(p.label,this.extension),description:p.description,resourceUri:p.resourceUri,tooltip:this.getTooltip(p.tooltip),command:this.getCommand(f,p.command),contextValue:p.contextValue,icon:t,iconDark:this.getDarkIconPath(p)||t,themeIcon:this.getThemeIcon(p),collapsibleState:C.isUndefinedOrNull(p.collapsibleState)?_.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation},extensionItem:p,parent:l,children:void 0,disposableStore:f,dispose(){f.dispose()}}}getThemeIcon(b){return b.iconPath instanceof _.ThemeIcon?b.iconPath:void 0}createHandle(b,{id:p,label:l,resourceUri:f},m,t){if(p)return`${d.ID_HANDLE_PREFIX}/${p}`;const r=h(l,this.extension),s=m?m.item.handle:d.LABEL_HANDLE_PREFIX;let i=r?r.label:f?T.basename(f):"";i=i.indexOf("/")!==-1?i.replace("/","//"):i;const u=this.nodes.has(b)?this.nodes.get(b).item.handle:void 0,w=this.getChildrenNodes(m)||[];let v,P=0;do{if(v=`${s}/${P}:${i}`,t||!this.elements.has(v)||u===v)break;P++}while(P<=w.length);return v}getLightIconPath(b){if(b.iconPath&&!(b.iconPath instanceof _.ThemeIcon))return typeof b.iconPath=="string"||S.URI.isUri(b.iconPath)?this.getIconPath(b.iconPath):this.getIconPath(b.iconPath.light)}getDarkIconPath(b){if(b.iconPath&&!(b.iconPath instanceof _.ThemeIcon)&&b.iconPath.dark)return this.getIconPath(b.iconPath.dark)}getIconPath(b){return S.URI.isUri(b)?b:S.URI.file(b)}addNodeToCache(b,p){this.elements.set(p.item.handle,b),this.nodes.set(b,p)}updateNodeCache(b,p,l,f){this.elements.delete(p.item.handle),this.nodes.delete(b),p.item.handle!==l.item.handle&&this.elements.delete(l.item.handle),this.addNodeToCache(b,p);const m=this.getChildrenNodes(f)||[],t=m.filter(r=>r.item.handle===l.item.handle)[0];t&&m.splice(m.indexOf(t),1,p)}addNodeToParentCache(b,p){p?(p.children||(p.children=[]),p.children.push(b)):(this.roots||(this.roots=[]),this.roots.push(b))}clearChildren(b){if(b){const p=this.nodes.get(b);if(p){if(p.children)for(const l of p.children){const f=this.elements.get(l.item.handle);f&&this.clear(f)}p.children=void 0}}else this.clearAll()}clear(b){const p=this.nodes.get(b);if(p){if(p.children)for(const l of p.children){const f=this.elements.get(l.item.handle);f&&this.clear(f)}this.nodes.delete(b),this.elements.delete(p.item.handle),p.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(b=>b.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}d.LABEL_HANDLE_PREFIX="0",d.ID_HANDLE_PREFIX="1"}),define(we[172],_e([0,1,17,12,18,3,40,10,64,9,6,96]),function(ee,e,g,T,S,E,k,D,_,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=e.TestTree=e.TestPosition=e.OwnedTestCollection=void 0;class o{constructor(){this.testIdsToInternal=new Map}getTestById(p,l){if(l!==void 0){const f=this.testIdsToInternal.get(l),m=f==null?void 0:f.get(p);if(m)return[f,m]}return g.mapFind(this.testIdsToInternal.values(),f=>{const m=f.get(p);return m&&[f,m]})}createForHierarchy(){return new y(this.createIdMap(c++))}createIdMap(p){const l=new d(p);return this.testIdsToInternal.set(l.id,l),{object:l,dispose:()=>this.testIdsToInternal.delete(l.id)}}}e.OwnedTestCollection=o;var h;(function(b){b[b.Disconnected=0]="Disconnected",b[b.IsChild=1]="IsChild",b[b.IsParent=2]="IsParent",b[b.IsSame=3]="IsSame"})(h=e.TestPosition||(e.TestPosition={}));let c=0;class d{constructor(p){this.id=p,this.map=new Map,this._roots=new Set,this.roots=this._roots}get size(){return this.map.size}add(p){if(this.map.has(p.item.extId))throw new Error(`Attempted to insert a duplicate test item ID ${p.item.extId}`);this.map.set(p.item.extId,p),p.parent||this._roots.add(p)}has(p){return this.map.has(p)}delete(p){const l=this.map.get(p);return l?(this.map.delete(p),this._roots.delete(l),!0):!1}get(p){return this.map.get(p)}comparePositions(p,l){const f=typeof p=="string"?this.map.get(p):p,m=typeof l=="string"?this.map.get(l):l;if(!f||!m)return 0;if(f===m)return 3;for(let t=this.map.get(m.parent);t;t=this.map.get(t.parent))if(t===f)return 1;for(let t=this.map.get(f.parent);t;t=this.map.get(t.parent))if(t===m)return 2;return 0}[Symbol.iterator](){return this.map.values()}}e.TestTree=d;class y{constructor(p){this.testIdToInternal=p,this.testItemToInternal=new Map,this.diff=[],this.debounceSendDiff=new T.RunOnceScheduler(()=>this.flushDiff(),200),this.diffOpEmitter=new E.Emitter,this.onDidGenerateDiff=this.diffOpEmitter.event}get treeId(){return this.testIdToInternal.object.id}get roots(){return k.Iterable.filter(this.testItemToInternal.values(),p=>p.parent===null)}addRoot(p,l){this.addItem(p,l,null)}getTestByReference(p){return this.testItemToInternal.get(p)}collectDiff(){const p=this.diff;return this.diff=[],p}pushDiff(p){const l=this.diff[this.diff.length-1];if(l&&p[0]===1){if(l[0]===1&&l[1].extId===p[1].extId){I.applyTestItemUpdate(l[1],p[1]);return}if(l[0]===0&&l[1].item.extId===p[1].extId){I.applyTestItemUpdate(l[1],p[1]);return}}this.diff.push(p),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(p,l){var f;const m=this.testIdToInternal.object.get(p);if(!!m){if((m.expandLevels===void 0||l>m.expandLevels)&&(m.expandLevels=l),m.expand===1){const t=this.refreshChildren(m);return t.isSettled?this.expandChildren(m,l-1):t.p.then(()=>this.expandChildren(m,l-1))}else if(m.expand===3)return((f=m.initialExpand)===null||f===void 0?void 0:f.isSettled)===!1?m.initialExpand.p.then(()=>this.expandChildren(m,l-1)):this.expandChildren(m,l-1)}}dispose(){var p;for(const l of this.testItemToInternal.values())(p=l.discoverCts)===null||p===void 0||p.dispose(!0),_.getPrivateApiFor(l.actual).bus.dispose();this.diff=[],this.testIdToInternal.dispose(),this.debounceSendDiff.dispose()}onTestItemEvent(p,l){const f=p==null?void 0:p.actual.id;switch(l[0]){case 2:this.pushDiff([4,f]);break;case 1:this.removeItem(p);break;case 0:this.addItem(l[1],p.src.controller,p);break;case 3:const[m,t,r]=l;switch(t){case"status":this.updateExpandability(p);break;case"range":this.pushDiff([1,{extId:f,item:{range:C.Range.from(r)}}]);break;case"error":this.pushDiff([1,{extId:f,item:{error:C.MarkdownString.fromStrict(r)||null}}]);break;default:this.pushDiff([1,{extId:f,item:{[t]:r??null}}]);break}break;default:D.assertNever(l[0])}}addItem(p,l,f){if(!(p instanceof n.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${p.id} did not`);if(this.testItemToInternal.has(p))throw new Error(`Attempted to add a single TestItem ${p.id} multiple times to the tree`);if(this.testIdToInternal.object.has(p.id))throw new Error(`Attempted to insert a duplicate test item ID ${p.id}`);const m=f?f.item.extId:null,t=p.resolveHandler?1:0,r=f?f.expandLevels:1,s={controller:l,tree:this.testIdToInternal.object.id},i={actual:p,parent:m,item:C.TestItem.from(p),expandLevels:r?r-1:void 0,expand:0,src:s};this.testIdToInternal.object.add(i),this.testItemToInternal.set(p,i),this.pushDiff([0,{parent:m,src:s,expand:t,item:i.item}]);const u=_.getPrivateApiFor(p);u.bus.event(this.onTestItemEvent.bind(this,i)),this.updateExpandability(i);for(const w of u.children.values())this.testItemToInternal.has(w)||this.addItem(w,l,i)}updateExpandability(p){var l;let f;p.actual.resolveHandler?p.actual.status===n.TestItemStatus.Pending?f=p.discoverCts?2:1:((l=p.initialExpand)===null||l===void 0||l.complete(),f=3):f=0,f!==p.expand&&(p.expand=f,this.pushDiff([1,{extId:p.actual.id,expand:f}]),f===1&&p.expandLevels!==void 0&&this.refreshChildren(p))}expandChildren(p,l){if(l<0)return;const f=[...p.actual.children.values()].map(m=>this.expand(m.id,l)).filter(T.isThenable);if(f.length)return Promise.all(f).then(()=>{})}refreshChildren(p){if(p.discoverCts&&p.discoverCts.dispose(!0),!p.actual.resolveHandler){const l=new T.DeferredPromise;return l.complete(),l}return p.expand=2,p.discoverCts=new S.CancellationTokenSource,this.pushExpandStateUpdate(p),p.initialExpand=new T.DeferredPromise,p.actual.resolveHandler(p.discoverCts.token),p.initialExpand}pushExpandStateUpdate(p){this.pushDiff([1,{extId:p.actual.id,expand:p.expand}])}removeItem(p){var l;this.pushDiff([2,p.actual.id]);const f=[p];for(;f.length;){const m=f.pop();if(!!m){(l=m.discoverCts)===null||l===void 0||l.dispose(!0),this.testIdToInternal.object.delete(m.item.extId),this.testItemToInternal.delete(m.actual);for(const t of m.actual.children.values())f.push(this.testIdToInternal.object.get(t.id))}}}flushDiff(){const p=this.collectDiff();p.length&&this.diffOpEmitter.fire(p)}reviveDiff(){this.flushDiff();const p=[];for(const{parent:l,src:f,expand:m,item:t}of this.testItemToInternal.values())p.push([0,{parent:l,src:f,expand:m,item:t}]);return p}}e.SingleUseTestCollection=y}),define(we[173],_e([0,1,4,144]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=g.refineServiceDecorator(T.IEnvironmentService)}),define(we[174],_e([0,1,26,3,14]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class E{constructor(n){this.removedDueToLooping=n}}e.DeltaExtensionsResult=E;class k{constructor(n){this._onDidChange=new T.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=n,this._initialize()}_initialize(){this._extensionDescriptions.sort(_),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const n of this._extensionDescriptions){if(this._extensionsMap.has(g.ExtensionIdentifier.toKey(n.identifier))){console.error("Extension `"+n.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(g.ExtensionIdentifier.toKey(n.identifier),n),this._extensionsArr.push(n),Array.isArray(n.activationEvents))for(let I of n.activationEvents)I==="onUri"&&(I=`onUri:${g.ExtensionIdentifier.toKey(n.identifier)}`),this._activationMap.has(I)||this._activationMap.set(I,[]),this._activationMap.get(I).push(n)}}keepOnly(n){const I=new Set;n.forEach(o=>I.add(g.ExtensionIdentifier.toKey(o))),this._extensionDescriptions=this._extensionDescriptions.filter(o=>I.has(g.ExtensionIdentifier.toKey(o.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(n,I){n.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(n));const o=k._findLoopingExtensions(this._extensionDescriptions);if(I=I.concat(o.map(h=>h.identifier)),I.length>0){const h=new Set;I.forEach(c=>h.add(g.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>!h.has(g.ExtensionIdentifier.toKey(c.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new E(o)}static _findLoopingExtensions(n){const I=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(y){this._nodesSet.has(y)||(this._nodesSet.add(y),this._nodesArr.push(y))}addArc(y,b){this.addNode(y),this.addNode(b),this._arcs.has(y)?this._arcs.get(y).push(b):this._arcs.set(y,[b])}getArcs(y){return this._arcs.has(y)?this._arcs.get(y):[]}hasOnlyGoodArcs(y,b){const p=I.getArcs(y);for(let l=0;l<p.length;l++)if(!b.has(p[l]))return!1;return!0}getNodes(){return this._nodesArr}};let o=new Map;for(let y of n){const b=g.ExtensionIdentifier.toKey(y.identifier);if(o.set(b,y),y.extensionDependencies)for(let p of y.extensionDependencies){const l=g.ExtensionIdentifier.toKey(p);I.addArc(b,l)}}let h=new Set;I.getNodes().filter(y=>I.getArcs(y).length===0).forEach(y=>h.add(y));let c=I.getNodes().filter(y=>!h.has(y)),d;do{d=!1;for(let y=0;y<c.length;y++){const b=c[y];I.hasOnlyGoodArcs(b,h)&&(c.splice(y,1),y--,h.add(b),d=!0)}}while(d);return c.map(y=>o.get(y))}containsActivationEvent(n){return this._activationMap.has(n)}containsExtension(n){return this._extensionsMap.has(g.ExtensionIdentifier.toKey(n))}getExtensionDescriptionsForActivationEvent(n){const I=this._activationMap.get(n);return I?I.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(n){const I=this._extensionsMap.get(g.ExtensionIdentifier.toKey(n));return I||void 0}}e.ExtensionDescriptionRegistry=k;var D;(function(C){C[C.Builtin=0]="Builtin",C[C.User=1]="User",C[C.Dev=2]="Dev"})(D||(D={}));function _(C,n){const I=C.isBuiltin?0:C.isUnderDevelopment?2:1,o=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(I!==o)return I-o;const h=S.posix.basename(C.extensionLocation.path),c=S.posix.basename(n.extensionLocation.path);return h<c?-1:h>c?1:0}}),define(we[175],_e([0,1,23]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var T;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(T=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var S;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(S=e.MessageType||(e.MessageType={}));function E(D){const _=g.VSBuffer.alloc(1);switch(D){case 0:_.writeUInt8(1,0);break;case 1:_.writeUInt8(2,0);break;case 2:_.writeUInt8(3,0);break}return _}e.createMessageOfType=E;function k(D,_){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return _===0;case 2:return _===1;case 3:return _===2;default:return!1}}e.isMessageOfType=k}),define(we[29],_e([0,1,3,2,4,26,145]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new E.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:T.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=S.createDecorator("extensionService");class D{constructor(p){this.dependency=p}}e.MissingExtensionDependency=D;var _;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(_=e.ExtensionHostKind||(e.ExtensionHostKind={}));class C{constructor(p,l,f,m){this.codeLoadingTime=p,this.activateCallTime=l,this.activateResolvedTime=f,this.activationReason=m}}e.ActivationTimes=C;class n{constructor(p,l){this.description=p,this.value=l}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var I;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(I=e.ActivationKind||(e.ActivationKind={}));function o(b){b.enableProposedApi||h(b)}e.checkProposedApiEnabled=o;function h(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=h;function c(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:k.getGalleryExtensionId(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=c;function d(b){return Object.assign(Object.assign({identifier:new E.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!1,extensionLocation:b.location},b.manifest),{uuid:b.identifier.uuid})}e.toExtensionDescription=d;class y{constructor(){this.onDidRegisterExtensions=g.Event.None,this.onDidChangeExtensionsStatus=g.Event.None,this.onDidChangeExtensions=g.Event.None,this.onWillActivateByEvent=g.Event.None,this.onDidChangeResponsiveChange=g.Event.None}activateByEvent(p){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(p){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(p){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(p){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(p,l){return Promise.resolve()}_onWillActivateExtension(p){}_onDidActivateExtension(p,l,f,m,t){}_onDidActivateExtensionError(p,l){}_onExtensionRuntimeError(p,l){}_onExtensionHostExit(p){}}e.NullExtensionService=y}),define(we[176],_e([0,1,26,29,15]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const E=Promise.resolve(void 0);class k{constructor(c,d,y,b){this.startup=c,this.codeLoadingTime=d,this.activateCallTime=y,this.activateResolvedTime=b}}e.ExtensionActivationTimes=k,k.NONE=new k(!1,-1,-1,-1);class D{constructor(c){this._startup=c,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(c,d){return c===-1||d===-1?-1:d-c}build(){return new k(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class _{constructor(c,d,y,b,p,l){this.activationFailed=c,this.activationFailedError=d,this.activationTimes=y,this.module=b,this.exports=p,this.subscriptions=l}}e.ActivatedExtension=_;class C extends _{constructor(c){super(!1,null,c,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=C;class n extends _{constructor(){super(!1,null,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=n;class I extends _{constructor(c){super(!0,c,k.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=I;let o=class{constructor(c,d,y,b,p){this._logService=p,this._registry=c,this._resolvedExtensionsSet=new Set,d.forEach(l=>this._resolvedExtensionsSet.add(g.ExtensionIdentifier.toKey(l))),this._hostExtensionsMap=new Map,y.forEach(l=>this._hostExtensionsMap.set(g.ExtensionIdentifier.toKey(l),l)),this._host=b,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(c){const d=g.ExtensionIdentifier.toKey(c);return this._activatedExtensions.has(d)}getActivatedExtension(c){const d=g.ExtensionIdentifier.toKey(c),y=this._activatedExtensions.get(d);if(!y)throw new Error("Extension `"+c.value+"` is not known or not activated");return y}activateByEvent(c,d){if(this._alreadyActivatedEvents[c])return E;const y=this._registry.getExtensionDescriptionsForActivationEvent(c);return this._activateExtensions(y.map(b=>({id:b.identifier,reason:{startup:d,extensionId:b.identifier,activationEvent:c}}))).then(()=>{this._alreadyActivatedEvents[c]=!0})}activateById(c,d){const y=this._registry.getExtensionDescription(c);if(!y)throw new Error("Extension `"+c+"` is not known");return this._activateExtensions([{id:y.identifier,reason:d}])}_handleActivateRequest(c,d,y){if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(c.id))){d[g.ExtensionIdentifier.toKey(c.id)]=c;return}const b=this._registry.getExtensionDescription(c.id);if(!b){const f=new Error(`Cannot activate unknown extension '${c.id.value}'`);this._host.onExtensionActivationError(c.id,f,new T.MissingExtensionDependency(c.id.value)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(c.id),new I(f));return}const p=typeof b.extensionDependencies=="undefined"?[]:b.extensionDependencies;let l=!0;for(let f=0,m=p.length;f<m;f++){const t=p[f];if(this._resolvedExtensionsSet.has(g.ExtensionIdentifier.toKey(t)))continue;const r=this._activatedExtensions.get(g.ExtensionIdentifier.toKey(t));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const w=b.displayName||b.identifier.value,v=this._registry.getExtensionDescription(t),P=v&&v.displayName||t,A=new Error(`Cannot activate the '${w}' extension because its dependency '${P}' failed to activate`);A.detail=r.activationFailedError,this._host.onExtensionActivationError(b.identifier,A,null),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new I(A));return}if(this._hostExtensionsMap.has(g.ExtensionIdentifier.toKey(t))){l=!1,d[g.ExtensionIdentifier.toKey(t)]={id:this._hostExtensionsMap.get(g.ExtensionIdentifier.toKey(t)),reason:c.reason};continue}const s=this._registry.getExtensionDescription(t);if(s){l=!1,d[g.ExtensionIdentifier.toKey(t)]={id:s.identifier,reason:c.reason};continue}const i=b.displayName||b.identifier.value,u=new Error(`Cannot activate the '${i}' extension because it depends on unknown extension '${t}'`);this._host.onExtensionActivationError(b.identifier,u,new T.MissingExtensionDependency(t)),this._activatedExtensions.set(g.ExtensionIdentifier.toKey(b.identifier),new I(u));return}l?d[g.ExtensionIdentifier.toKey(b.identifier)]=c:y.push(c)}_activateExtensions(c){if(c.length===0||(c=c.filter(p=>!this._activatedExtensions.has(g.ExtensionIdentifier.toKey(p.id))),c.length===0))return Promise.resolve(void 0);const d=Object.create(null),y=[];for(let p=0,l=c.length;p<l;p++)this._handleActivateRequest(c[p],d,y);for(let p=0,l=y.length;p<l;p++){const f=g.ExtensionIdentifier.toKey(y[p].id);d[f]&&delete d[f]}const b=Object.keys(d).map(p=>d[p]);return y.length===0?Promise.all(b.map(p=>this._activateExtension(p.id,p.reason))).then(p=>{}):this._activateExtensions(b).then(p=>this._activateExtensions(y))}_activateExtension(c,d){const y=g.ExtensionIdentifier.toKey(c);if(this._activatedExtensions.has(y))return Promise.resolve(void 0);const b=this._activatingExtensions.get(y);if(b)return b;const p=this._host.actualActivateExtension(c,d).then(void 0,l=>{const f=new Error;return l&&l.name&&(f.name=l.name),l&&l.message?f.message=`Activating extension '${c.value}' failed: ${l.message}.`:f.message=`Activating extension '${c.value}' failed: ${l}.`,l&&l.stack&&(f.stack=l.stack),this._host.onExtensionActivationError(c,f,null),this._logService.error(`Activating extension ${c.value} failed due to an error:`),this._logService.error(l),new I(l)}).then(l=>{this._activatedExtensions.set(y,l),this._activatingExtensions.delete(y)});return this._activatingExtensions.set(y,p),p}};o=Ve([ze(4,S.ILogService)],o),e.ExtensionsActivator=o}),define(we[177],_e([0,1,11]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class T{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((E,k)=>{this._actualOk=E,this._actualErr=k,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(E){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=E,this._actual&&this._actualOk(E))}resolveErr(E){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=E,this._actual?this._actualErr(E):g.onUnexpectedError(E))}then(E,k){return this._ensureActual().then(E,k)}catch(E){return this._ensureActual().then(void 0,E)}finally(E){return this._ensureActual().finally(E)}}e.LazyPromise=T}),define(we[99],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class g{constructor(_,C){this.isMain=_,this.sid=C,this.nid=++g.count}}e.ProxyIdentifier=g,g.count=0;const T=[];function S(D){const _=new g(!0,D);return T[_.nid]=_,_}e.createMainContextProxyIdentifier=S;function E(D){const _=new g(!1,D);return T[_.nid]=_,_}e.createExtHostContextProxyIdentifier=E;function k(D){return T[D].sid}e.getStringIdentifierForProxy=k}),define(we[5],_e([0,1,54,2,99]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var E;(function(l){l[l.Desktop=1]="Desktop",l[l.Web=2]="Web"})(E=e.UIKind||(e.UIKind={}));var k;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(k=e.TextEditorRevealType||(e.TextEditorRevealType={}));var D;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(D=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var _;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(_=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var C;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(C=e.CellOutputKind||(e.CellOutputKind={}));var n;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(n=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var I;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(I=e.CandidatePortSource||(e.CandidatePortSource={}));var o;(function(l){l.name="$ident";function f(t,r){return Object.defineProperty(t,l.name,{value:r,enumerable:!0}),t}l.mixin=f;function m(t){return t[l.name]}l.of=m})(o=e.ObjectIdentifier||(e.ObjectIdentifier={}));class h{static mixin(f){return f._id=h._n++,f}}e.IdObject=h,h._n=0;var c;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.command="m",l.kindModifier="n",l.label2="o"})(c=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var y;(function(l){l[l.File=1]="File",l[l.Text=2]="Text",l[l.Cell=3]="Cell"})(y=e.WorkspaceEditType||(e.WorkspaceEditType={}));function b(l){if(l&&l.edits)for(const f of l.edits)typeof f.resource=="object"?f.resource=T.URI.revive(f.resource):(f.newUri=T.URI.revive(f.newUri),f.oldUri=T.URI.revive(f.oldUri)),f.metadata&&f.metadata.iconPath&&(f.metadata=g.revive(f.metadata));return l}e.reviveWorkspaceEditDto=b;var p;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(p=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:S.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:S.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:S.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:S.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:S.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:S.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:S.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:S.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:S.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:S.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:S.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:S.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:S.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:S.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:S.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:S.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:S.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:S.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:S.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:S.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:S.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:S.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:S.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:S.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:S.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:S.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:S.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:S.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:S.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:S.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:S.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:S.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:S.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:S.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:S.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:S.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:S.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:S.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:S.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:S.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:S.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:S.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:S.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:S.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:S.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:S.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:S.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:S.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:S.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:S.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:S.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:S.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:S.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:S.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:S.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:S.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:S.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:S.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:S.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:S.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:S.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:S.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:S.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:S.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:S.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:S.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:S.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:S.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:S.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:S.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:S.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:S.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:S.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:S.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:S.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:S.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:S.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:S.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:S.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:S.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:S.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:S.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:S.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:S.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:S.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:S.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:S.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:S.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:S.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:S.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:S.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:S.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:S.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:S.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookDocuments:S.createMainContextProxyIdentifier("ExtHostNotebookDocuments"),ExtHostNotebookEditors:S.createMainContextProxyIdentifier("ExtHostNotebookEditors"),ExtHostNotebookKernels:S.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:S.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:S.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:S.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:S.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:S.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:S.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:S.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(we[69],_e([0,1,5,3,4]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class E{constructor(D){this._onDidChangePassword=new T.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=D.getProxy(g.MainContext.MainThreadSecretState)}async $onDidChangePassword(D){this._onDidChangePassword.fire(D)}get(D,_){return this._proxy.$getPassword(D,_)}store(D,_,C){return this._proxy.$setPassword(D,_,C)}delete(D,_){return this._proxy.$deletePassword(D,_)}}e.ExtHostSecretState=E,e.IExtHostSecretState=S.createDecorator("IExtHostSecretState")}),define(we[70],_e([0,1,4,15,5,13]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=g.createDecorator("IExtHostApiDeprecationService");let k=class{constructor(_,C){this._extHostLogService=C,this._reportedUsages=new Set,this._telemetryShape=_.getProxy(S.MainContext.MainThreadTelemetry)}report(_,C,n){const I=this.getUsageKey(_,C);this._reportedUsages.has(I)||(this._reportedUsages.add(I),C.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${_}' is deprecated. ${n}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:C.identifier.value,apiId:_}))}getUsageKey(_,C){return`${_}-${C.identifier.value}`}};k=Ve([ze(0,E.IExtHostRpcService),ze(1,T.ILogService)],k),e.ExtHostApiDeprecationService=k,e.NullApiDeprecationService=Object.freeze(new class{report(D,_,C){}})}),define(we[178],_e([0,1,3,5,6,26]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class k{constructor(_){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeAuthenticationProviders=new g.Emitter,this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new g.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=_.getProxy(T.MainContext.MainThreadAuthentication)}$setProviders(_){return this._providers=_,Promise.resolve()}get providers(){return Object.freeze(this._providers.slice())}async getSession(_,C,n,I={}){const o=E.ExtensionIdentifier.toKey(_.identifier),h=this._inFlightRequests.get(o)||[],c=[...n].sort().join(" ");let d=h.find(y=>y.scopes===c);if(d)return d.result;{const y=this._getSession(_,o,C,n,I);d={scopes:c,result:y},h.push(d),this._inFlightRequests.set(o,h);try{await y}finally{const b=h.findIndex(p=>p.scopes===c);b>-1&&(h.splice(b),this._inFlightRequests.set(o,h))}return y}}async _getSession(_,C,n,I,o={}){await this._proxy.$ensureProvider(n);const h=_.displayName||_.name;return this._proxy.$getSession(n,I,C,h,o)}async removeSession(_,C){const n=this._authenticationProviders.get(_);return n?n.provider.removeSession(C):this._proxy.$removeSession(_,C)}registerAuthenticationProvider(_,C,n,I){var o;if(this._authenticationProviders.get(_))throw new Error(`An authentication provider with id '${_}' is already registered.`);this._authenticationProviders.set(_,{label:C,provider:n,options:I??{supportsMultipleAccounts:!1}}),this._providers.find(c=>c.id===_)||this._providers.push({id:_,label:C});const h=n.onDidChangeSessions(c=>{var d,y,b;this._proxy.$sendDidChangeSessions(_,{added:(d=c.added)!==null&&d!==void 0?d:[],changed:(y=c.changed)!==null&&y!==void 0?y:[],removed:(b=c.removed)!==null&&b!==void 0?b:[]})});return this._proxy.$registerAuthenticationProvider(_,C,(o=I==null?void 0:I.supportsMultipleAccounts)!==null&&o!==void 0?o:!1),new S.Disposable(()=>{h.dispose(),this._authenticationProviders.delete(_);const c=this._providers.findIndex(d=>d.id===_);c>-1&&this._providers.splice(c),this._proxy.$unregisterAuthenticationProvider(_)})}$createSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.createSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$removeSession(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.removeSession(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$getSessions(_,C){const n=this._authenticationProviders.get(_);if(n)return Promise.resolve(n.provider.getSessions(C));throw new Error(`Unable to find authentication provider with handle: ${_}`)}$onDidChangeAuthenticationSessions(_,C){return this._onDidChangeSessions.fire({provider:{id:_,label:C}}),Promise.resolve()}$onDidChangeAuthenticationProviders(_,C){return _.forEach(n=>{this._providers.some(I=>I.id===n.id)||this._providers.push(n)}),C.forEach(n=>{const I=this._providers.findIndex(o=>o.id===n.id);I>-1&&this._providers.splice(I)}),this._onDidChangeAuthenticationProviders.fire({added:_,removed:C}),Promise.resolve()}}e.ExtHostAuthentication=k}),define(we[179],_e([0,1,5,13,9]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let E=class{constructor(D,_){this._extHostDocumentsAndEditors=_,this._proxy=D.getProxy(g.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(D){const _=S.WorkspaceEdit.from(D,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(_)}};E=Ve([ze(0,T.IExtHostRpcService)],E),e.ExtHostBulkEdits=E}),define(we[180],_e([0,1,5]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class T{constructor(E){const k=E.getProxy(g.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return k.$readText()},writeText(D){return k.$writeText(D)}})}}e.ExtHostClipboard=T}),define(we[71],_e([0,1,10,6,9,24,5,17,15,54,31,35,2,7,4,13]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let y=class{constructor(t,r){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(k.MainContext.MainThreadCommands),this._logService=r,this.converter=new b(this,s=>{const i=this._apiCommands.get(s);return(i==null?void 0:i.result)===l.Void?i:void 0},r),this._argumentProcessors=[{processArgument(s){return C.revive(s)}},{processArgument(s){return E.cloneAndChange(s,function(i){if(n.Range.isIRange(i))return S.Range.to(i);if(I.Position.isIPosition(i))return S.Position.to(i);if(n.Range.isIRange(i.range)&&o.URI.isUri(i.uri))return S.location.to(i);if(!Array.isArray(i))return i})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const r=this.registerCommand(!1,t.id,async(...s)=>{const i=t.args.map((w,v)=>{if(!w.validate(s[v]))throw new Error(`Invalid argument '${w.name}' when running '${t.id}', received: ${s[v]}`);return w.convert(s[v])}),u=await this.executeCommand(t.internalId,...i);return t.result.convert(u,s,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new T.Disposable(()=>{r.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,r,s,i,u){if(this._logService.trace("ExtHostCommands#registerCommand",r),!r.trim().length)throw new Error("invalid id");if(this._commands.has(r))throw new Error(`command '${r}' already exists`);return this._commands.set(r,{callback:s,thisArg:i,description:u}),t&&this._proxy.$registerCommand(r),new T.Disposable(()=>{this._commands.delete(r)&&t&&this._proxy.$unregisterCommand(r)})}executeCommand(t,...r){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,r,!0)}async _doExecuteCommand(t,r,s){if(this._commands.has(t))return this._executeContributedCommand(t,r);{const i=E.cloneAndChange(r,function(u){if(u instanceof T.Position)return S.Position.from(u);if(u instanceof T.Range)return S.Range.from(u);if(u instanceof T.Location)return S.location.from(u);if(T.NotebookRange.isNotebookRange(u))return S.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,i,s);return C.revive(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,r,!1);throw u}}}async _executeContributedCommand(t,r){const s=this._commands.get(t);if(!s)throw new Error("Unknown command");let{callback:i,thisArg:u,description:w}=s;if(w)for(let v=0;v<w.args.length;v++)try{g.validateConstraint(r[v],w.args[v].constraint)}catch(P){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${w.args[v].name}' - ${w.args[v].description}`)}try{return await i.apply(u,r)}catch(v){if(t===this.converter.delegatingCommandId){const P=this.converter.getActualCommand(...r);P&&(t=P.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...r){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(r=r.map(s=>this._argumentProcessors.reduce((i,u)=>u.processArgument(i),s)),this._executeContributedCommand(t,r)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(r=>(t&&(r=r.filter(s=>s[0]!=="_")),r))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[r,s]of this._commands){let{description:i}=s;i&&(t[r]=i)}return Promise.resolve(t)}};y=Ve([ze(0,d.IExtHostRpcService),ze(1,_.ILogService)],y),e.ExtHostCommands=y,e.IExtHostCommands=c.createDecorator("IExtHostCommands");class b{constructor(t,r,s){this._commands=t,this._lookupApiCommand=r,this._logService=s,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,r){if(!t)return;const s={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return s;const i=this._lookupApiCommand(t.command);if(i)s.id=i.internalId,s.arguments=i.args.map((u,w)=>u.convert(t.arguments&&t.arguments[w]));else if(D.isNonEmptyArray(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),r.add(h.toDisposable(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),s.$ident=u,s.id=this.delegatingCommandId,s.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return s}fromInternal(t){const r=k.ObjectIdentifier.of(t);return typeof r=="number"?this._cache.get(r):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const r=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],r?r.command:"MISSING"),r?this._commands.executeCommand(r.command,...r.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=b;class p{constructor(t,r,s,i){this.name=t,this.description=r,this.validate=s,this.convert=i}optional(){return new p(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,r){return new p(t??this.name,r??this.description,this.validate,this.convert)}}e.ApiCommandArgument=p,p.Uri=new p("uri","Uri of a text document",m=>o.URI.isUri(m),m=>m),p.Position=new p("position","A position in a text document",m=>T.Position.isPosition(m),S.Position.from),p.Range=new p("range","A range in a text document",m=>T.Range.isRange(m),S.Range.from),p.Selection=new p("selection","A selection in a text document",m=>T.Selection.isSelection(m),S.Selection.from),p.Number=new p("number","",m=>typeof m=="number",m=>m),p.String=new p("string","",m=>typeof m=="string",m=>m),p.CallHierarchyItem=new p("item","A call hierarchy item",m=>m instanceof T.CallHierarchyItem,S.CallHierarchyItem.to);class l{constructor(t,r){this.description=t,this.convert=r}}e.ApiCommandResult=l,l.Void=new l("no result",m=>m);class f{constructor(t,r,s,i,u){this.id=t,this.internalId=r,this.description=s,this.args=i,this.result=u}}e.ApiCommand=f}),define(we[181],_e([0,1,9,6,58,71,17,86]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const _=[new E.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",n(g.DocumentHighlight.to))),new E.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,h)=>{if(k.isFalsyOrEmpty(o))return;class c extends T.SymbolInformation{static to(y){const b=new c(y.name,g.SymbolKind.to(y.kind),y.containerName||"",new T.Location(h[0],g.Range.to(y.range)));return b.detail=y.detail,b.range=b.location.range,b.selectionRange=g.Range.to(y.selectionRange),b.children=y.children?y.children.map(c.to):[],b}}return o.map(c.to)})),new E.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range,new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,new E.ApiCommandArgument("ch","Trigger character",o=>typeof o=="string",o=>o),new E.ApiCommandArgument("options","Formatting options",o=>!0,o=>o)],new E.ApiCommandResult("A promise that resolves to an array of TextEdits.",n(g.TextEdit.to))),new E.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",I)),new E.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Location-instances.",n(g.location.to))),new E.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A promise that resolves to an array of Hover-instances.",n(g.Hover.to))),new E.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("position","A position in a text document",o=>Array.isArray(o)&&o.every(h=>T.Position.isPosition(h)),o=>o.map(g.Position.from))],new E.ApiCommandResult("A promise that resolves to an array of ranges.",o=>o.map(h=>{let c;for(const d of h.reverse())c=new T.SelectionRange(g.Range.to(d),c);return c}))),new E.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[E.ApiCommandArgument.String.with("query","Search string")],new E.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",o=>{const h=[];if(Array.isArray(o))for(let c of o)h.push(...c[1].map(g.WorkspaceSymbol.to));return h})),new E.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyItem.to))),new E.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyIncomingCall.to))),new E.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[E.ApiCommandArgument.CallHierarchyItem],new E.ApiCommandResult("A CallHierarchyItem or undefined",o=>o.map(g.CallHierarchyOutgoingCall.to))),new E.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("newName","The new symbol name")],new E.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",o=>{if(!!o){if(o.rejectReason)throw new Error(o.rejectReason);return g.WorkspaceEdit.to(o)}})),new E.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new E.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(g.DocumentLink.to))),new E.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const h=D.decodeSemanticTokensDto(o);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",o=>{if(!!o)return new T.SemanticTokensLegend(o.tokenTypes,o.tokenModifiers)})),new E.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const h=D.decodeSemanticTokensDto(o);if(h.type==="full")return new T.SemanticTokens(h.data,void 0)})),new E.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new E.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(o,h,c)=>{if(!o)return new T.CompletionList([]);const d=o.suggestions.map(y=>g.CompletionItem.to(y,c));return new T.CompletionList(d,o.incomplete)})),new E.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Position,E.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new E.ApiCommandResult("A promise that resolves to SignatureHelp.",o=>{if(o)return g.SignatureHelp.to(o)})),new E.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new E.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(o,h,c)=>n(d=>new T.CodeLens(g.Range.to(d.range),d.command&&c.fromInternal(d.command)))(o))),new E.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>T.Range.isRange(o),o=>T.Selection.isSelection(o)?g.Selection.from(o):g.Range.from(o)),E.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),E.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new E.ApiCommandResult("A promise that resolves to an array of Command-instances.",(o,h,c)=>n(d=>{if(d._isSynthetic){if(!d.command)throw new Error("Synthetic code actions must have a command");return c.fromInternal(d.command)}else{const y=new T.CodeAction(d.title,d.kind?new T.CodeActionKind(d.kind):void 0);return d.edit&&(y.edit=g.WorkspaceEdit.to(d.edit)),d.command&&(y.command=c.fromInternal(d.command)),y.isPreferred=d.isPreferred,y}})(o))),new E.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[E.ApiCommandArgument.Uri],new E.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(h=>new T.ColorInformation(g.Range.to(h.range),g.Color.to(h.color))):[])),new E.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new E.ApiCommandArgument("color","The color to show and insert",o=>o instanceof T.Color,g.Color.from),new E.ApiCommandArgument("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:g.Range.from(o.range)}))],new E.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(g.ColorPresentation.to):[])),new E.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of Inlay objects",o=>o.map(g.InlayHint.to))),new E.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new E.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",n(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(h=>g.NotebookExclusiveDocumentPattern.to(h))})))),new E.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[E.ApiCommandArgument.Uri,E.ApiCommandArgument.Range],new E.ApiCommandResult("A promise that resolves to an array of InlineValue objects",o=>o.map(g.InlineValue.to))),new E.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[E.ApiCommandArgument.Uri,new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)])).optional(),E.ApiCommandArgument.String.with("label","").optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[E.ApiCommandArgument.Uri.with("resource","Resource to open"),E.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[o,void 0]:[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)])).optional()],E.ApiCommandResult.Void),new E.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[E.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),E.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),E.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new E.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[g.ViewColumn.from(o.viewColumn),g.TextEditorOpenOptions.from(o)]).optional()],E.ApiCommandResult.Void)];class C{static register(h){_.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=C;function n(o){return h=>{if(Array.isArray(h))return h.map(o)}}function I(o){if(!Array.isArray(o))return;const h=[];for(const c of o)S.isLocationLink(c)?h.push(g.DefinitionLink.to(c)):h.push(g.location.to(c));return h}}),define(we[182],_e([0,1,12,48,3,7,2,58,26,9,6,5]),function(ee,e,g,T,S,E,k,D,_,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCommentThread=e.ExtHostComments=void 0;class o{constructor(f,m,t){this._documents=t,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=f.getProxy(I.MainContext.MainThreadComments),m.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===6){const s=this._commentControllers.get(r.handle);return s||r}else if(r&&r.$mid===7){const s=this._commentControllers.get(r.commentControlHandle);if(!s)return r;const i=s.getCommentThread(r.commentThreadHandle);return i||r}else if(r&&r.$mid===8){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const i=s.getCommentThread(r.thread.commentThreadHandle);return i?{thread:i,text:r.text}:r}else if(r&&r.$mid===9){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const i=s.getCommentThread(r.thread.commentThreadHandle);if(!i)return r;let u=r.commentUniqueId,w=i.getCommentByUniqueId(u);return w||r}else if(r&&r.$mid===10){const s=this._commentControllers.get(r.thread.commentControlHandle);if(!s)return r;const i=s.getCommentThread(r.thread.commentThreadHandle);if(!i)return r;let u=r.text,w=r.commentUniqueId,v=i.getCommentByUniqueId(w);return v?(v.body=u,v):r}return r}})}createCommentController(f,m,t){const r=o.handlePool++,s=new c(f,r,this._proxy,m,t);this._commentControllers.set(s.handle,s);const i=this._commentControllersByExtension.get(_.ExtensionIdentifier.toKey(f.identifier))||[];return i.push(s),this._commentControllersByExtension.set(_.ExtensionIdentifier.toKey(f.identifier),i),s}$createCommentThreadTemplate(f,m,t){const r=this._commentControllers.get(f);!r||r.$createCommentThreadTemplate(m,t)}async $updateCommentThreadTemplate(f,m,t){const r=this._commentControllers.get(f);!r||r.$updateCommentThreadTemplate(m,t)}$deleteCommentThread(f,m){const t=this._commentControllers.get(f);t&&t.$deleteCommentThread(m)}$provideCommentingRanges(f,m,t){const r=this._commentControllers.get(f);if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const s=this._documents.getDocument(k.URI.revive(m));return g.asPromise(()=>r.commentingRangeProvider.provideCommentingRanges(s,t)).then(i=>i?i.map(u=>C.Range.from(u)):void 0)}$toggleReaction(f,m,t,r,s){const i=this._commentControllers.get(f);return!i||!i.reactionHandler?Promise.resolve(void 0):g.asPromise(()=>{const u=i.getCommentThread(m);if(u){const w=u.getCommentByUniqueId(r.uniqueIdInThread);if(i!==void 0&&w&&i.reactionHandler)return i.reactionHandler(w,b(s))}return Promise.resolve(void 0)})}dispose(){}}e.ExtHostComments=o,o.handlePool=0;class h{constructor(f,m,t,r,s,i,u){this._proxy=f,this._commentController=m,this._id=t,this._uri=r,this._range=s,this._comments=i,this.handle=h._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new S.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputDisposables.value=new E.DisposableStore,this._id===void 0&&(this._id=`${m.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,C.Range.from(this._range),u),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=i}set threadId(f){this._id=f}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(f){f.isEqual(this._range)||(this._range=f,this.modifications.range=f,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(f){this._canReply!==f&&(this._canReply=f,this.modifications.canReply=f,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(f){this._label=f,this.modifications.label=f,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(f){this._contextValue=f,this.modifications.contextValue=f,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(f){this._comments=f,this.modifications.comments=f,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(f){this._collapseState=f,this.modifications.collapsibleState=f,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new E.DisposableStore);const f=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),m={};f("range")&&(m.range=C.Range.from(this._range)),f("label")&&(m.label=this.label),f("contextValue")&&(m.contextValue=this.contextValue),f("comments")&&(m.comments=this._comments.map(t=>d(this,this._commentController,t,this._commentsMap))),f("collapsibleState")&&(m.collapseState=p(this._collapseState)),f("canReply")&&(m.canReply=this.canReply),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,m)}getCommentByUniqueId(f){for(let m of this._commentsMap){let t=m[0],r=m[1];if(f===r)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(f=>f.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}h._handlePool=0,Ve([T.debounce(100)],h.prototype,"eventuallyUpdateCommentThread",null),e.ExtHostCommentThread=h;class c{constructor(f,m,t,r,s){this._extension=f,this._handle=m,this._proxy=t,this._id=r,this._label=s,this._threads=new Map,this._proxy.$registerCommentController(this.handle,r,s)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(f){this._reactionHandler=f,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!f})}get options(){return this._options}set options(f){this._options=f,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(f,m,t,r){if(typeof f=="string"){const s=new h(this._proxy,this,f,m,t,r,this._extension.identifier);return this._threads.set(s.handle,s),s}else{const s=new h(this._proxy,this,void 0,f,m,t,this._extension.identifier);return this._threads.set(s.handle,s),s}}$createCommentThreadTemplate(f,m){const t=new h(this._proxy,this,void 0,k.URI.revive(f),C.Range.to(m),[],this._extension.identifier);return t.collapsibleState=D.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(f,m){let t=this._threads.get(f);t&&(t.range=C.Range.to(m))}$deleteCommentThread(f){let m=this._threads.get(f);m&&m.dispose(),this._threads.delete(f)}getCommentThread(f){return this._threads.get(f)}dispose(){this._threads.forEach(f=>{f.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}function d(l,f,m,t){let r=t.get(m);r||(r=++l.commentHandle,t.set(m,r));const s=m.author&&m.author.iconPath?m.author.iconPath.toString():void 0;return{mode:m.mode,contextValue:m.contextValue,uniqueIdInThread:r,body:C.MarkdownString.from(m.body),userName:m.author.name,userIconPath:s,label:m.label,commentReactions:m.reactions?m.reactions.map(i=>y(i)):void 0}}function y(l){return{label:l.label,iconPath:l.iconPath?C.pathOrURIToURI(l.iconPath):void 0,count:l.count,hasReacted:l.authorHasReacted}}function b(l){return{label:l.label||"",count:l.count||0,iconPath:l.iconPath?k.URI.revive(l.iconPath):"",authorHasReacted:l.hasReacted||!1}}function p(l){if(l!==void 0)switch(l){case n.CommentThreadCollapsibleState.Expanded:return D.CommentThreadCollapsibleState.Expanded;case n.CommentThreadCollapsibleState.Collapsed:return D.CommentThreadCollapsibleState.Collapsed}return D.CommentThreadCollapsibleState.Collapsed}}),define(we[100],_e([0,1,2,5,6,4,13,15,17,8,14]),function(ee,e,g,T,S,E,k,D,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let I=class Sn{constructor(h,c){this._logService=c,this._provider=new Map,this._proxy=h.getProxy(T.MainContext.MainThreadDecorations)}registerFileDecorationProvider(h,c){const d=Sn._handlePool++;this._provider.set(d,{provider:h,extensionId:c}),this._proxy.$registerDecorationProvider(d,c.value);const y=h.onDidChangeFileDecorations&&h.onDidChangeFileDecorations(b=>{if(!b){this._proxy.$onDidChange(d,null);return}let p=_.asArray(b);if(p.length<=Sn._maxEventSize){this._proxy.$onDidChange(d,p);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",c.value,p.length);const l=p.map(t=>({uri:t,rank:C.count(t.path,"/")})),f=_.groupBy(l,(t,r)=>t.rank-r.rank||C.compare(t.uri.path,r.uri.path));let m=[];e:for(let t of f){let r;for(let s of t){let i=n.dirname(s.uri.path);if(r!==i&&(r=i,m.push(s.uri)>=Sn._maxEventSize))break e}}this._proxy.$onDidChange(d,m)});return new S.Disposable(()=>{y==null||y.dispose(),this._proxy.$unregisterDecorationProvider(d),this._provider.delete(d)})}async $provideDecorations(h,c,d){if(!this._provider.has(h))return Object.create(null);const y=Object.create(null),{provider:b,extensionId:p}=this._provider.get(h);return await Promise.all(c.map(async l=>{try{const{uri:f,id:m}=l,t=await Promise.resolve(b.provideFileDecoration(g.URI.revive(f),d));if(!t)return;try{S.FileDecoration.validate(t),y[m]=[t.propagate,t.tooltip,t.badge,t.color]}catch(r){this._logService.warn(`INVALID decoration from extension '${p.value}': ${r}`)}}catch(f){this._logService.error(f)}})),y}};I._handlePool=0,I._maxEventSize=250,I=Ve([ze(0,k.IExtHostRpcService),ze(1,D.ILogService)],I),e.ExtHostDecorations=I,e.IExtHostDecorations=E.createDecorator("IExtHostDecorations")}),define(we[183],_e([0,1,128,90,2,5,6,9,3,15,22]),function(ee,e,g,T,S,E,k,D,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class I{constructor(c,d,y,b,p){this._name=c,this._owner=d,this._maxDiagnosticsPerFile=y,this._proxy=b,this._onDidChangeDiagnostics=p,this._isDisposed=!1,this._data=new n.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(c,d){if(!c){this.clear();return}this._checkDisposed();let y=[];if(S.URI.isUri(c)){if(!d){this.delete(c);return}this._data.set(c,d.slice()),y=[c]}else if(Array.isArray(c)){y=[];let p;c=[...c].sort(I._compareIndexedTuplesByUri);for(const l of c){const[f,m]=l;if((!p||f.toString()!==p.toString())&&(p&&this._data.get(p).length===0&&this._data.delete(p),p=f,y.push(f),this._data.set(f,[])),m){const t=this._data.get(f);t&&t.push(...m)}else{const t=this._data.get(f);t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(y),!this._proxy)return;const b=[];for(let p of y){let l=[];const f=this._data.get(p);if(f)if(f.length>this._maxDiagnosticsPerFile){l=[];const m=[k.DiagnosticSeverity.Error,k.DiagnosticSeverity.Warning,k.DiagnosticSeverity.Information,k.DiagnosticSeverity.Hint];e:for(let t=0;t<4;t++)for(let r of f)if(r.severity===m[t]&&l.push(D.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e;l.push({severity:T.MarkerSeverity.Info,message:g.localize(0,null,f.length-this._maxDiagnosticsPerFile),startLineNumber:l[l.length-1].startLineNumber,startColumn:l[l.length-1].startColumn,endLineNumber:l[l.length-1].endLineNumber,endColumn:l[l.length-1].endColumn})}else l=f.map(m=>D.Diagnostic.from(m));b.push([p,l])}this._proxy.$changeMany(this._owner,b)}delete(c){this._checkDisposed(),this._onDidChangeDiagnostics.fire([c]),this._data.delete(c),this._proxy&&this._proxy.$changeMany(this._owner,[[c,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(c,d){this._checkDisposed();for(let y of this._data.keys())c.apply(d,[y,this.get(y),this])}get(c){this._checkDisposed();const d=this._data.get(c);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(c){return this._checkDisposed(),Array.isArray(this._data.get(c))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(c,d){return c[0].toString()<d[0].toString()?-1:c[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=I;let o=class jt{constructor(c,d){this._logService=d,this._collections=new Map,this._onDidChangeDiagnostics=new _.Emitter,this.onDidChangeDiagnostics=_.Event.map(_.Event.debounce(this._onDidChangeDiagnostics.event,jt._debouncer,50),jt._mapper),this._proxy=c.getProxy(E.MainContext.MainThreadDiagnostics)}static _debouncer(c,d){return c?c.concat(d):d}static _mapper(c){const d=new n.ResourceMap;for(const y of c)d.set(y,y);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(c,d){const{_collections:y,_proxy:b,_onDidChangeDiagnostics:p,_logService:l}=this,f=new class{$changeMany(r,s){b.$changeMany(r,s),l.trace("[DiagnosticCollection] change many (extension, owner, uris)",c.value,r,s.length===0?"CLEARING":s)}$clear(r){b.$clear(r),l.trace("[DiagnosticCollection] remove all (extension, owner)",c.value,r)}dispose(){b.dispose()}};let m;if(!d)d="_generated_diagnostic_collection_name_#"+jt._idPool++,m=d;else if(!y.has(d))m=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do m=d+jt._idPool++;while(y.has(m))}return new class extends I{constructor(){super(d,m,jt._maxDiagnosticsPerFile,f,p);y.set(m,this)}dispose(){super.dispose(),y.delete(m)}}}getDiagnostics(c){if(c)return this._getDiagnostics(c);{const d=new Map,y=[];for(const b of this._collections.values())b.forEach((p,l)=>{let f=d.get(p.toString());typeof f=="undefined"&&(f=y.length,d.set(p.toString(),f),y.push([p,[]])),y[f][1]=y[f][1].concat(...l)});return y}}_getDiagnostics(c){let d=[];for(let y of this._collections.values())y.has(c)&&(d=d.concat(y.get(c)));return d}$acceptMarkersChange(c){if(!this._mirrorCollection){const d="_generated_mirror",y=new I(d,d,jt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(d,y),this._mirrorCollection=y}for(const[d,y]of c)this._mirrorCollection.set(S.URI.revive(d),y.map(D.Diagnostic.to))}};o._idPool=0,o._maxDiagnosticsPerFile=1e3,o=Ve([ze(1,C.ILogService)],o),e.ExtHostDiagnostics=o}),define(we[184],_e([0,1,2,5]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class S{constructor(k){this._proxy=k.getProxy(T.MainContext.MainThreadDialogs)}showOpenDialog(k){return this._proxy.$showOpenDialog(k).then(D=>D?D.map(_=>g.URI.revive(_)):void 0)}showSaveDialog(k){return this._proxy.$showSaveDialog(k).then(D=>D?g.URI.revive(D):void 0)}}e.ExtHostDialogs=S}),define(we[185],_e([0,1,11,2,6,5,16,18,8]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class C{constructor(I,o,h){this._documentsAndEditors=o,this._logService=h,this._documentContentProviders=new Map,this._proxy=I.getProxy(E.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(I,o){if(Object.keys(k.Schemas).indexOf(I)>=0)throw new Error(`scheme '${I}' already registered`);const h=C._handlePool++;this._documentContentProviders.set(h,o),this._proxy.$registerTextContentProvider(h,I);let c;return typeof o.onDidChange=="function"&&(c=o.onDidChange(d=>{if(d.scheme!==I){this._logService.warn(`Provider for scheme '${I}' is firing event for schema '${d.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(d)&&this.$provideTextDocumentContent(h,d).then(y=>{if(!y&&typeof y!="string")return;const b=this._documentsAndEditors.getDocument(d);if(!b)return;const p=_.splitLines(y);if(!b.equalLines(p))return this._proxy.$onVirtualDocumentChange(d,y)},g.onUnexpectedError)})),new S.Disposable(()=>{this._documentContentProviders.delete(h)&&this._proxy.$unregisterTextContentProvider(h),c&&(c.dispose(),c=void 0)})}$provideTextDocumentContent(I,o){const h=this._documentContentProviders.get(I);return h?Promise.resolve(h.provideTextDocumentContent(T.URI.revive(o),D.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${o.scheme}`))}}e.ExtHostDocumentContentProvider=C,C._handlePool=0}),define(we[186],_e([0,1,3,7,2,5,95,9,10,24]),function(ee,e,g,T,S,E,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class n{constructor(o,h){this._onDidAddDocument=new g.Emitter,this._onDidRemoveDocument=new g.Emitter,this._onDidChangeDocument=new g.Emitter,this._onDidSaveDocument=new g.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new T.DisposableStore,this._documentLoader=new Map,this._proxy=o.getProxy(E.MainContext.MainThreadDocuments),this._documentsAndEditors=h,this._documentsAndEditors.onDidRemoveDocuments(c=>{for(const d of c)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(c=>{for(const d of c)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(o){if(!o)return;const h=this._documentsAndEditors.getDocument(o);if(h)return h}getDocument(o){const h=this.getDocumentData(o);if(!(h==null?void 0:h.document))throw new Error(`Unable to retrieve document from URI '${o}'`);return h.document}ensureDocumentData(o){const h=this._documentsAndEditors.getDocument(o);if(h)return Promise.resolve(h);let c=this._documentLoader.get(o.toString());return c||(c=this._proxy.$tryOpenDocument(o).then(d=>{this._documentLoader.delete(o.toString());const y=S.URI.revive(d);return _.assertIsDefined(this._documentsAndEditors.getDocument(y))},d=>(this._documentLoader.delete(o.toString()),Promise.reject(d))),this._documentLoader.set(o.toString(),c)),c}createDocumentData(o){return this._proxy.$tryCreateDocument(o).then(h=>S.URI.revive(h))}$acceptModelModeChanged(o,h){const c=S.URI.revive(o),d=this._documentsAndEditors.getDocument(c);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(h),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(o){const h=S.URI.revive(o),c=this._documentsAndEditors.getDocument(h);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(o,!1),this._onDidSaveDocument.fire(c.document)}$acceptDirtyStateChanged(o,h){const c=S.URI.revive(o),d=this._documentsAndEditors.getDocument(c);if(!d)throw new Error("unknown document");d._acceptIsDirty(h),this._onDidChangeDocument.fire({document:d.document,contentChanges:[]})}$acceptModelChanged(o,h,c){const d=S.URI.revive(o),y=this._documentsAndEditors.getDocument(d);if(!y)throw new Error("unknown document");y._acceptIsDirty(c),y.onEvents(h),this._onDidChangeDocument.fire(C.deepFreeze({document:y.document,contentChanges:h.changes.map(b=>({range:D.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text}))}))}setWordDefinitionFor(o,h){k.setWordDefinitionFor(o,h)}}e.ExtHostDocuments=n}),define(we[36],_e([0,1,39,3,7,2,4,5,95,13,98,9,15,22,16,40,108]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class b{constructor(f){this.value=f,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let p=class{constructor(f,m){this._extHostRpc=f,this._logService=m,this._activeEditorId=null,this._editors=new Map,this._documents=new h.ResourceMap,this._onDidAddDocuments=new T.Emitter,this._onDidRemoveDocuments=new T.Emitter,this._onDidChangeVisibleTextEditors=new T.Emitter,this._onDidChangeActiveTextEditor=new T.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(f){this.acceptDocumentsAndEditorsDelta(f)}acceptDocumentsAndEditorsDelta(f){const m=[],t=[],r=[];if(f.removedDocuments)for(const s of f.removedDocuments){const i=E.URI.revive(s),u=this._documents.get(i);(u==null?void 0:u.unref())&&(this._documents.delete(i),m.push(u.value))}if(f.addedDocuments)for(const s of f.addedDocuments){const i=E.URI.revive(s.uri);let u=this._documents.get(i);if(u&&i.scheme!==c.Schemas.vscodeNotebookCell)throw new Error(`document '${i} already exists!'`);u||(u=new b(new _.ExtHostDocumentData(this._extHostRpc.getProxy(D.MainContext.MainThreadDocuments),i,s.lines,s.EOL,s.versionId,s.modeId,s.isDirty,s.notebook)),this._documents.set(i,u),t.push(u.value)),u.ref()}if(f.removedEditors)for(const s of f.removedEditors){const i=this._editors.get(s);this._editors.delete(s),i&&r.push(i)}if(f.addedEditors)for(const s of f.addedEditors){const i=E.URI.revive(s.documentUri);g.ok(this._documents.has(i),`document '${i}' does not exist`),g.ok(!this._editors.has(s.id),`editor '${s.id}' already exists!`);const u=this._documents.get(i).value,w=new n.ExtHostTextEditor(s.id,this._extHostRpc.getProxy(D.MainContext.MainThreadTextEditors),this._logService,new y.Lazy(()=>u.document),s.selections.map(I.Selection.to),s.options,s.visibleRanges.map(v=>I.Range.to(v)),typeof s.editorPosition=="number"?I.ViewColumn.to(s.editorPosition):void 0);this._editors.set(s.id,w)}f.newActiveEditor!==void 0&&(g.ok(f.newActiveEditor===null||this._editors.has(f.newActiveEditor),`active editor '${f.newActiveEditor}' does not exist`),this._activeEditorId=f.newActiveEditor),S.dispose(m),S.dispose(r),f.removedDocuments&&this._onDidRemoveDocuments.fire(m),f.addedDocuments&&this._onDidAddDocuments.fire(t),(f.removedEditors||f.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(s=>s.value)),f.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(f){var m;return(m=this._documents.get(f))===null||m===void 0?void 0:m.value}allDocuments(){return d.Iterable.map(this._documents.values(),f=>f.value)}getEditor(f){return this._editors.get(f)}activeEditor(f){if(!this._activeEditorId)return;const m=this._editors.get(this._activeEditorId);return f?m:m==null?void 0:m.value}allEditors(){return[...this._editors.values()]}};p=Ve([ze(0,C.IExtHostRpcService),ze(1,o.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=k.createDecorator("IExtHostDocumentsAndEditors")}),define(we[187],_e([0,1,2,5,7,6,9,118,8,23]),function(ee,e,g,T,S,E,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class n{constructor(){this._schemes=[]}add(h){this._stateMachine=void 0,this._schemes.push(h)}delete(h){const c=this._schemes.indexOf(h);c>=0&&(this._schemes.splice(c,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const h=this._schemes.sort(),c=[];let d,y,b=14,p=14;for(const l of h){let f=d?_.commonPrefixLength(d,l):0;for(f===0?y=1:y=p;f<l.length;f++)f+1===l.length?(b=p,p=9):p+=1,c.push([y,l.toUpperCase().charCodeAt(f),p]),c.push([y,l.toLowerCase().charCodeAt(f),p]),y=p;d=l,p=b}c.push([9,58,10]),c.push([10,47,12]),this._stateMachine=new D.StateMachine(c)}}provideDocumentLinks(h){this._initStateMachine();const c=[],d=D.LinkComputer.computeLinks({getLineContent(y){return h.lineAt(y-1).text},getLineCount(){return h.lineCount}},this._stateMachine);for(const y of d){const b=k.DocumentLink.to(y);b.target&&c.push(b)}return c}}class I{constructor(h,c){this._extHostLanguageFeatures=c,this._linkProvider=new n,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=h.getProxy(T.MainContext.MainThreadFileSystem)}dispose(){var h;(h=this._linkProviderRegistration)===null||h===void 0||h.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(h,c,d,y={},b){if(this._registeredSchemes.has(c))throw new Error(`a provider for the scheme '${c}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const p=this._handlePool++;this._linkProvider.add(c),this._registeredSchemes.add(c),this._fsProvider.set(p,d),this._enableProposedApi.set(p,b??!1);let l=2;y.isCaseSensitive&&(l+=1024),y.isReadonly&&(l+=2048),typeof d.copy=="function"&&(l+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&(l+=4),this._proxy.$registerFileSystemProvider(p,c,l).catch(m=>{console.error(`FAILED to register filesystem provider of ${h.value}-extension for the scheme ${c}`),console.error(m)});const f=d.onDidChangeFile(m=>{const t=[];for(const r of m){let{uri:s,type:i}=r;if(s.scheme!==c)continue;let u;switch(i){case E.FileChangeType.Changed:u=0;break;case E.FileChangeType.Created:u=1;break;case E.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:s,type:u})}this._proxy.$onFileSystemChange(p,t)});return S.toDisposable(()=>{f.dispose(),this._linkProvider.delete(c),this._registeredSchemes.delete(c),this._fsProvider.delete(p),this._enableProposedApi.delete(p),this._proxy.$unregisterProvider(p)})}static _asIStat(h,c){const{type:d,ctime:y,mtime:b,size:p,permissions:l}=h;return c?{type:d,ctime:y,mtime:b,size:p,permissions:l}:{type:d,ctime:y,mtime:b,size:p}}$stat(h,c){return Promise.resolve(this._getFsProvider(h).stat(g.URI.revive(c))).then(d=>{var y;return I._asIStat(d,(y=this._enableProposedApi.get(h))!==null&&y!==void 0?y:!1)})}$readdir(h,c){return Promise.resolve(this._getFsProvider(h).readDirectory(g.URI.revive(c)))}$readFile(h,c){return Promise.resolve(this._getFsProvider(h).readFile(g.URI.revive(c))).then(d=>C.VSBuffer.wrap(d))}$writeFile(h,c,d,y){return Promise.resolve(this._getFsProvider(h).writeFile(g.URI.revive(c),d.buffer,y))}$delete(h,c,d){return Promise.resolve(this._getFsProvider(h).delete(g.URI.revive(c),d))}$rename(h,c,d,y){return Promise.resolve(this._getFsProvider(h).rename(g.URI.revive(c),g.URI.revive(d),y))}$copy(h,c,d,y){const b=this._getFsProvider(h);if(!b.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(b.copy(g.URI.revive(c),g.URI.revive(d),y))}$mkdir(h,c){return Promise.resolve(this._getFsProvider(h).createDirectory(g.URI.revive(c)))}$watch(h,c,d,y){const b=this._getFsProvider(h).watch(g.URI.revive(d),y);this._watches.set(c,b)}$unwatch(h,c){const d=this._watches.get(c);d&&(d.dispose(),this._watches.delete(c))}$open(h,c,d){const y=this._getFsProvider(h);if(!y.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(y.open(g.URI.revive(c),d))}$close(h,c){const d=this._getFsProvider(h);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(c))}$read(h,c,d,y){const b=this._getFsProvider(h);if(!b.read)throw new Error('FileSystemProvider does not implement "read"');const p=C.VSBuffer.alloc(y);return Promise.resolve(b.read(c,d,p.buffer,0,y)).then(l=>p.slice(0,l))}$write(h,c,d,y){const b=this._getFsProvider(h);if(!b.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(b.write(c,d,y.buffer,0,y.byteLength))}_getFsProvider(h){const c=this._fsProvider.get(h);if(!c){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return c}}e.ExtHostFileSystem=I}),define(we[72],_e([0,1,5,59,6,23,4,13,46]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let C=class Ut{constructor(I,o){const h=I.getProxy(g.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(c){return h.$stat(c).catch(Ut._handleError)},readDirectory(c){return h.$readdir(c).catch(Ut._handleError)},createDirectory(c){return h.$mkdir(c).catch(Ut._handleError)},async readFile(c){return h.$readFile(c).then(d=>d.buffer).catch(Ut._handleError)},writeFile(c,d){return h.$writeFile(c,E.VSBuffer.wrap(d)).catch(Ut._handleError)},delete(c,d){return h.$delete(c,Object.assign({recursive:!1,useTrash:!1},d)).catch(Ut._handleError)},rename(c,d,y){return h.$rename(c,d,Object.assign({overwrite:!1},y)).catch(Ut._handleError)},copy(c,d,y){return h.$copy(c,d,Object.assign({overwrite:!1},y)).catch(Ut._handleError)},isWritableFileSystem(c){const d=o.getCapabilities(c);if(typeof d=="number")return!(d&2048)}})}static _handleError(I){if(!(I instanceof Error))throw new S.FileSystemError(String(I));if(I.name==="ENOPRO")throw S.FileSystemError.Unavailable(I.message);switch(I.name){case T.FileSystemProviderErrorCode.FileExists:throw S.FileSystemError.FileExists(I.message);case T.FileSystemProviderErrorCode.FileNotFound:throw S.FileSystemError.FileNotFound(I.message);case T.FileSystemProviderErrorCode.FileNotADirectory:throw S.FileSystemError.FileNotADirectory(I.message);case T.FileSystemProviderErrorCode.FileIsADirectory:throw S.FileSystemError.FileIsADirectory(I.message);case T.FileSystemProviderErrorCode.NoPermissions:throw S.FileSystemError.NoPermissions(I.message);case T.FileSystemProviderErrorCode.Unavailable:throw S.FileSystemError.Unavailable(I.message);default:throw new S.FileSystemError(I.message,I.name)}}};C=Ve([ze(0,D.IExtHostRpcService),ze(1,_.IExtHostFileSystemInfo)],C),e.ExtHostConsumerFileSystem=C,e.IExtHostConsumerFileSystem=k.createDecorator("IExtHostConsumerFileSystem")}),define(we[188],_e([0,1,7,5]),function(ee,e,g,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class S{constructor(k){this._handlePool=0,this._proxy=k.getProxy(T.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(k){const D=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(D,k),g.toDisposable(()=>{this._proxy.$unregisterResourceLabelFormatter(D)})}}e.ExtHostLabelService=S}),define(we[189],_e([0,1,2,24,9,6,12,5,8,31,17,10,115,7,86,50,62,52,11,3]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y,b,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class f{constructor($,G){this._documents=$,this._provider=G}provideDocumentSymbols($,G){const te=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentSymbols(te,G)).then(re=>{if(!n.isFalsyOrEmpty(re))return re[0]instanceof E.DocumentSymbol?re.map(S.DocumentSymbol.from):f._asDocumentSymbolTree(re)})}static _asDocumentSymbolTree($){var G;$=$.slice(0).sort((K,oe)=>{let fe=K.location.range.start.compareTo(oe.location.range.start);return fe===0&&(fe=oe.location.range.end.compareTo(K.location.range.end)),fe});const te=[],re=[];for(const K of $){const oe={name:K.name||"!!MISSING: name!!",kind:S.SymbolKind.from(K.kind),tags:((G=K.tags)===null||G===void 0?void 0:G.map(S.SymbolTag.from))||[],detail:"",containerName:K.containerName,range:S.Range.from(K.location.range),selectionRange:S.Range.from(K.location.range),children:[]};for(;;){if(re.length===0){re.push(oe),te.push(oe);break}const fe=re[re.length-1];if(C.Range.containsRange(fe.range,oe.range)&&!C.Range.equalsRange(fe.range,oe.range)){fe.children&&fe.children.push(oe),re.push(oe);break}re.pop()}}return te}}class m{constructor($,G,te){this._documents=$,this._commands=G,this._provider=te,this._cache=new y.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses($,G){const te=this._documents.getDocument($),re=await this._provider.provideCodeLenses(te,G);if(!re||G.isCancellationRequested)return;const K=this._cache.add(re),oe=new h.DisposableStore;this._disposables.set(K,oe);const fe={cacheId:K,lenses:[]};for(let Ae=0;Ae<re.length;Ae++)fe.lenses.push({cacheId:[K,Ae],range:S.Range.from(re[Ae].range),command:this._commands.toInternal(re[Ae].command,oe)});return fe}async resolveCodeLens($,G){var te;const re=$.cacheId&&this._cache.get(...$.cacheId);if(!re)return;let K;if(typeof this._provider.resolveCodeLens!="function"||re.isResolved?K=re:K=await this._provider.resolveCodeLens(re,G),K||(K=re),G.isCancellationRequested)return;const oe=$.cacheId&&this._disposables.get($.cacheId[0]);if(!!oe)return $.command=this._commands.toInternal((te=K.command)!==null&&te!==void 0?te:m._badCmd,oe),$}releaseCodeLenses($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}}m._badCmd={command:"missing",title:"!!MISSING: command!!"};function t(Xe){return Array.isArray(Xe)?Xe.map(S.DefinitionLink.from):Xe?[S.DefinitionLink.from(Xe)]:[]}class r{constructor($,G){this._documents=$,this._provider=G}provideDefinition($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideDefinition(re,K,te)).then(t)}}class s{constructor($,G){this._documents=$,this._provider=G}provideDeclaration($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideDeclaration(re,K,te)).then(t)}}class i{constructor($,G){this._documents=$,this._provider=G}provideImplementation($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideImplementation(re,K,te)).then(t)}}class u{constructor($,G){this._documents=$,this._provider=G}provideTypeDefinition($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideTypeDefinition(re,K,te)).then(t)}}class w{constructor($,G){this._documents=$,this._provider=G}provideHover($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideHover(re,K,te)).then(oe=>{if(!(!oe||n.isFalsyOrEmpty(oe.contents)))return oe.range||(oe.range=re.getWordRangeAtPosition(K)),oe.range||(oe.range=new E.Range(K,K)),S.Hover.from(oe)})}}class v{constructor($,G){this._documents=$,this._provider=G}provideEvaluatableExpression($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideEvaluatableExpression(re,K,te)).then(oe=>{if(oe)return S.EvaluatableExpression.from(oe)})}}class P{constructor($,G){this._documents=$,this._provider=G}provideInlineValues($,G,te,re){const K=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideInlineValues(K,S.Range.to(G),S.InlineValueContext.to(te),re)).then(oe=>{if(Array.isArray(oe))return oe.map(fe=>S.InlineValue.from(fe))})}}class A{constructor($,G){this._documents=$,this._provider=G}provideDocumentHighlights($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideDocumentHighlights(re,K,te)).then(oe=>{if(Array.isArray(oe))return oe.map(S.DocumentHighlight.from)})}}class a{constructor($,G){this._documents=$,this._provider=G}provideLinkedEditingRanges($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.provideLinkedEditingRanges(re,K,te)).then(oe=>{if(oe&&Array.isArray(oe.ranges))return{ranges:n.coalesce(oe.ranges.map(S.Range.from)),wordPattern:oe.wordPattern}})}}class R{constructor($,G){this._documents=$,this._provider=G}provideReferences($,G,te,re){const K=this._documents.getDocument($),oe=S.Position.to(G);return k.asPromise(()=>this._provider.provideReferences(K,oe,te,re)).then(fe=>{if(Array.isArray(fe))return fe.map(S.location.from)})}}class L{constructor($,G,te,re,K,oe,fe){this._documents=$,this._commands=G,this._diagnostics=te,this._provider=re,this._logService=K,this._extension=oe,this._apiDeprecation=fe,this._cache=new y.Cache("CodeAction"),this._disposables=new Map}provideCodeActions($,G,te,re){const K=this._documents.getDocument($),oe=o.Selection.isISelection(G)?S.Selection.to(G):S.Range.to(G),fe=[];for(const $e of this._diagnostics.getDiagnostics($))if(oe.intersection($e.range)&&fe.push($e)>L._maxCodeActionsPerFile)break;const Ae={diagnostics:fe,only:te.only?new E.CodeActionKind(te.only):void 0,triggerKind:S.CodeActionTriggerKind.to(te.trigger)};return k.asPromise(()=>this._provider.provideCodeActions(K,oe,Ae,re)).then($e=>{var pe;if(!n.isNonEmptyArray($e)||re.isCancellationRequested)return;const Ge=this._cache.add($e),j=new h.DisposableStore;this._disposables.set(Ge,j);const ne=[];for(let ge=0;ge<$e.length;ge++){const Fe=$e[ge];!Fe||(L._isCommand(Fe)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ne.push({_isSynthetic:!0,title:Fe.title,command:this._commands.toInternal(Fe,j)})):(Ae.only&&(Fe.kind?Ae.only.contains(Fe.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action is of kind '${Fe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ae.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ne.push({cacheId:[Ge,ge],title:Fe.title,command:Fe.command&&this._commands.toInternal(Fe.command,j),diagnostics:Fe.diagnostics&&Fe.diagnostics.map(S.Diagnostic.from),edit:Fe.edit&&S.WorkspaceEdit.from(Fe.edit),kind:Fe.kind&&Fe.kind.value,isPreferred:Fe.isPreferred,disabled:(pe=Fe.disabled)===null||pe===void 0?void 0:pe.reason})))}return{cacheId:Ge,actions:ne}})}async resolveCodeAction($,G){var te;const[re,K]=$,oe=this._cache.get(re,K);if(!oe||L._isCommand(oe)||!this._provider.resolveCodeAction)return;const fe=(te=await this._provider.resolveCodeAction(oe,G))!==null&&te!==void 0?te:oe;return(fe==null?void 0:fe.edit)?S.WorkspaceEdit.from(fe.edit):void 0}releaseCodeActions($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}static _isCommand($){return typeof $.command=="string"&&typeof $.title=="string"}}L._maxCodeActionsPerFile=1e3;class H{constructor($,G){this._documents=$,this._provider=G}provideDocumentFormattingEdits($,G,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentFormattingEdits(re,G,te)).then(K=>{if(Array.isArray(K))return K.map(S.TextEdit.from)})}}class ue{constructor($,G){this._documents=$,this._provider=G}provideDocumentRangeFormattingEdits($,G,te,re){const K=this._documents.getDocument($),oe=S.Range.to(G);return k.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(K,oe,te,re)).then(fe=>{if(Array.isArray(fe))return fe.map(S.TextEdit.from)})}}class me{constructor($,G){this._documents=$,this._provider=G,this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits($,G,te,re,K){const oe=this._documents.getDocument($),fe=S.Position.to(G);return k.asPromise(()=>this._provider.provideOnTypeFormattingEdits(oe,fe,te,re,K)).then(Ae=>{if(Array.isArray(Ae))return Ae.map(S.TextEdit.from)})}}class J{constructor($,G){this._provider=$,this._logService=G,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols($,G){const te=D.IdObject.mixin({symbols:[]});return k.asPromise(()=>this._provider.provideWorkspaceSymbols($,G)).then(re=>{if(n.isNonEmptyArray(re))for(const K of re){if(!K)continue;if(!K.name){this._logService.warn("INVALID SymbolInformation, lacks name",K);continue}const oe=D.IdObject.mixin(S.WorkspaceSymbol.from(K));this._symbolCache.set(oe._id,K),te.symbols.push(oe)}}).then(()=>(te.symbols.length>0&&this._resultCache.set(te._id,[te.symbols[0]._id,te.symbols[te.symbols.length-1]._id]),te))}async resolveWorkspaceSymbol($,G){if(typeof this._provider.resolveWorkspaceSymbol!="function")return $;const te=this._symbolCache.get($._id);if(te){const re=await k.asPromise(()=>this._provider.resolveWorkspaceSymbol(te,G));return re&&T.mixin($,S.WorkspaceSymbol.from(re),!0)}}releaseWorkspaceSymbols($){const G=this._resultCache.get($);if(G){for(let[te,re]=G;te<=re;te++)this._symbolCache.delete(te);this._resultCache.delete($)}}}class z{constructor($,G,te){this._documents=$,this._provider=G,this._logService=te}static supportsResolving($){return typeof $.prepareRename=="function"}provideRenameEdits($,G,te,re){const K=this._documents.getDocument($),oe=S.Position.to(G);return k.asPromise(()=>this._provider.provideRenameEdits(K,oe,te,re)).then(fe=>{if(!!fe)return S.WorkspaceEdit.from(fe)},fe=>{const Ae=z._asMessage(fe);return Ae?{rejectReason:Ae,edits:void 0}:Promise.reject(fe)})}resolveRenameLocation($,G,te){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const re=this._documents.getDocument($),K=S.Position.to(G);return k.asPromise(()=>this._provider.prepareRename(re,K,te)).then(oe=>{let fe,Ae;if(E.Range.isRange(oe)?(fe=oe,Ae=re.getText(oe)):I.isObject(oe)&&(fe=oe.range,Ae=oe.placeholder),!!fe){if(fe.start.line>K.line||fe.end.line<K.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:S.Range.from(fe),text:Ae}}},oe=>{const fe=z._asMessage(oe);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(oe)})}static _asMessage($){return typeof $=="string"?$:$ instanceof Error&&typeof $.message=="string"?$.message:void 0}}class Z{constructor($,G){this.resultId=$,this.tokens=G}}class M{constructor($,G){this._documents=$,this._provider=G,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens($,G,te){const re=this._documents.getDocument($),K=G!==0?this._previousResults.get(G):null;return k.asPromise(()=>K&&typeof K.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?this._provider.provideDocumentSemanticTokensEdits(re,K.resultId,te):this._provider.provideDocumentSemanticTokens(re,te)).then(oe=>(K&&this._previousResults.delete(G),oe?(oe=M._fixProvidedSemanticTokens(oe),this._send(M._convertToEdits(K,oe),oe)):null))}async releaseDocumentSemanticColoring($){this._previousResults.delete($)}static _fixProvidedSemanticTokens($){return M._isSemanticTokens($)?M._isCorrectSemanticTokens($)?$:new E.SemanticTokens(new Uint32Array($.data),$.resultId):M._isSemanticTokensEdits($)?M._isCorrectSemanticTokensEdits($)?$:new E.SemanticTokensEdits($.edits.map(G=>new E.SemanticTokensEdit(G.start,G.deleteCount,G.data?new Uint32Array(G.data):G.data)),$.resultId):$}static _isSemanticTokens($){return $&&!!$.data}static _isCorrectSemanticTokens($){return $.data instanceof Uint32Array}static _isSemanticTokensEdits($){return $&&Array.isArray($.edits)}static _isCorrectSemanticTokensEdits($){for(const G of $.edits)if(!(G.data instanceof Uint32Array))return!1;return!0}static _convertToEdits($,G){if(!M._isSemanticTokens(G)||!$||!$.tokens)return G;const te=$.tokens,re=te.length,K=G.data,oe=K.length;let fe=0;const Ae=Math.min(re,oe);for(;fe<Ae&&te[fe]===K[fe];)fe++;if(fe===re&&fe===oe)return new E.SemanticTokensEdits([],G.resultId);let $e=0;const pe=Ae-fe;for(;$e<pe&&te[re-$e-1]===K[oe-$e-1];)$e++;return new E.SemanticTokensEdits([{start:fe,deleteCount:re-fe-$e,data:K.subarray(fe,oe-$e)}],G.resultId)}_send($,G){if(M._isSemanticTokens($)){const te=this._nextResultId++;return this._previousResults.set(te,new Z($.resultId,$.data)),c.encodeSemanticTokensDto({id:te,type:"full",data:$.data})}if(M._isSemanticTokensEdits($)){const te=this._nextResultId++;return M._isSemanticTokens(G)?this._previousResults.set(te,new Z(G.resultId,G.data)):this._previousResults.set(te,new Z($.resultId)),c.encodeSemanticTokensDto({id:te,type:"delta",deltas:($.edits||[]).map(re=>({start:re.start,deleteCount:re.deleteCount,data:re.data}))})}return null}}e.DocumentSemanticTokensAdapter=M;class q{constructor($,G){this._documents=$,this._provider=G}provideDocumentRangeSemanticTokens($,G,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(re,S.Range.to(G),te)).then(K=>K?this._send(K):null)}_send($){return c.encodeSemanticTokensDto({id:0,type:"full",data:$.data})}}e.DocumentRangeSemanticTokensAdapter=q;class N{constructor($,G,te,re,K){this._documents=$,this._commands=G,this._provider=te,this._apiDeprecation=re,this._extension=K,this._cache=new y.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving($){return typeof $.resolveCompletionItem=="function"}async provideCompletionItems($,G,te,re){const K=this._documents.getDocument($),oe=S.Position.to(G),fe=K.getWordRangeAtPosition(oe)||new E.Range(oe,oe),Ae=fe.with({end:oe}),$e=new b.StopWatch(!0),pe=await k.asPromise(()=>this._provider.provideCompletionItems(K,oe,re,S.CompletionContext.to(te)));if(!pe||re.isCancellationRequested)return;const Ge=Array.isArray(pe)?new E.CompletionList(pe):pe,j=N.supportsResolving(this._provider)?this._cache.add(Ge.items):this._cache.add([]),ne=new h.DisposableStore;this._disposables.set(j,ne);const ge=[],Fe={x:j,b:ge,a:{replace:S.Range.from(fe),insert:S.Range.from(Ae)},c:Ge.isIncomplete||void 0,d:$e.elapsed()};for(let Ne=0;Ne<Ge.items.length;Ne++){const Qe=Ge.items[Ne],Ee=this._convertCompletionItem(Qe,[j,Ne],Ae,fe);ge.push(Ee)}return Fe}async resolveCompletionItem($,G){if(typeof this._provider.resolveCompletionItem!="function")return;const te=this._cache.get(...$);if(!te)return;const re=await k.asPromise(()=>this._provider.resolveCompletionItem(te,G));if(!!re)return this._convertCompletionItem(re,$)}releaseCompletionItems($){var G;(G=this._disposables.get($))===null||G===void 0||G.dispose(),this._disposables.delete($),this._cache.delete($)}_convertCompletionItem($,G,te,re){var K;const oe=this._disposables.get(G[0]);if(!oe)throw Error("DisposableStore is missing...");const fe={x:G,a:(K=$.label)!==null&&K!==void 0?K:"",o:$.label2,b:$.kind!==void 0?S.CompletionItemKind.from($.kind):void 0,n:$.tags&&$.tags.map(S.CompletionItemTag.from),c:$.detail,d:typeof $.documentation=="undefined"?void 0:S.MarkdownString.fromStrict($.documentation),e:$.sortText!==$.label?$.sortText:void 0,f:$.filterText!==$.label?$.filterText:void 0,g:$.preselect||void 0,i:$.keepWhitespace?1:0,k:$.commitCharacters,l:$.additionalTextEdits&&$.additionalTextEdits.map(S.TextEdit.from),m:this._commands.toInternal($.command,oe)};$.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),fe.h=$.textEdit.newText):typeof $.insertText=="string"?fe.h=$.insertText:$.insertText instanceof E.SnippetString&&(fe.h=$.insertText.value,fe.i|=4);let Ae;return $.textEdit?Ae=$.textEdit.range:$.range&&(Ae=$.range),E.Range.isRange(Ae)?fe.j=S.Range.from(Ae):Ae&&(!(te==null?void 0:te.isEqual(Ae.inserting))||!(re==null?void 0:re.isEqual(Ae.replacing)))&&(fe.j={insert:S.Range.from(Ae.inserting),replace:S.Range.from(Ae.replacing)}),fe}}class W{constructor($,G,te){this._documents=$,this._provider=G,this._commands=te,this._cache=new y.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions($,G,te,re){const K=this._documents.getDocument($),oe=S.Position.to(G),fe=await k.asPromise(()=>this._provider.provideInlineCompletionItems(K,oe,te,re));if(!fe||re.isCancellationRequested)return;const Ae=I.isArray(fe)?{items:fe}:fe,$e=this._cache.add(Ae.items);let pe;return{pid:$e,items:Ae.items.map((Ge,j)=>{let ne;return Ge.command&&(pe||(pe=new h.DisposableStore,this._disposables.set($e,pe)),ne=this._commands.toInternal(Ge.command,pe)),{text:Ge.text,range:Ge.range?S.Range.from(Ge.range):void 0,command:ne,idx:j}})}}disposeCompletions($){this._cache.delete($);const G=this._disposables.get($);G&&G.clear(),this._disposables.delete($)}handleDidShowCompletionItem($,G){const te=this._cache.get($,G);te&&O.get(this._provider).fireOnDidShowCompletionItem({completionItem:te})}}class O{constructor(){this._onDidShowCompletionItemEmitter=new l.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get($){let G=O.map.get($);return G||(G=new O,O.map.set($,G)),G}fireOnDidShowCompletionItem($){this._onDidShowCompletionItemEmitter.fire($)}}e.InlineCompletionController=O,O.map=new WeakMap;class B{constructor($,G){this._documents=$,this._provider=G,this._cache=new y.Cache("SignatureHelp")}provideSignatureHelp($,G,te,re){const K=this._documents.getDocument($),oe=S.Position.to(G),fe=this.reviveContext(te);return k.asPromise(()=>this._provider.provideSignatureHelp(K,oe,re,fe)).then(Ae=>{if(Ae){const $e=this._cache.add([Ae]);return Object.assign(Object.assign({},S.SignatureHelp.from(Ae)),{id:$e})}})}reviveContext($){let G;if($.activeSignatureHelp){const te=S.SignatureHelp.to($.activeSignatureHelp),re=this._cache.get($.activeSignatureHelp.id,0);re?(G=re,G.activeSignature=te.activeSignature,G.activeParameter=te.activeParameter):G=te}return Object.assign(Object.assign({},$),{activeSignatureHelp:G})}releaseSignatureHelp($){this._cache.delete($)}}class Y{constructor($,G){this._documents=$,this._provider=G}provideInlayHints($,G,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideInlayHints(re,S.Range.to(G),te)).then(K=>K?{hints:K.map(S.InlayHint.from)}:void 0)}}class he{constructor($,G){this._documents=$,this._provider=G,this._cache=new y.Cache("DocumentLink")}async provideLinks($,G){const te=this._documents.getDocument($),re=await k.asPromise(()=>this._provider.provideDocumentLinks(te,G));if(!(!Array.isArray(re)||re.length===0)&&!G.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:re.filter(he._validateLink).map(S.DocumentLink.from)};{const K=this._cache.add(re),oe={links:[],id:K};for(let fe=0;fe<re.length;fe++){if(!he._validateLink(re[fe]))continue;const Ae=S.DocumentLink.from(re[fe]);Ae.cacheId=[K,fe],oe.links.push(Ae)}return oe}}}static _validateLink($){return $.target&&$.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink($,G){if(typeof this._provider.resolveDocumentLink!="function")return;const te=this._cache.get(...$);if(!te)return;const re=await k.asPromise(()=>this._provider.resolveDocumentLink(te,G));if(!(!re||!he._validateLink(re)))return S.DocumentLink.from(re)}releaseLinks($){this._cache.delete($)}}class De{constructor($,G){this._documents=$,this._provider=G}provideColors($,G){const te=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideDocumentColors(te,G)).then(re=>Array.isArray(re)?re.map(oe=>({color:S.Color.from(oe.color),range:S.Range.from(oe.range)})):[])}provideColorPresentations($,G,te){const re=this._documents.getDocument($),K=S.Range.to(G.range),oe=S.Color.to(G.color);return k.asPromise(()=>this._provider.provideColorPresentations(oe,{document:re,range:K},te)).then(fe=>{if(!!Array.isArray(fe))return fe.map(S.ColorPresentation.from)})}}class Oe{constructor($,G){this._documents=$,this._provider=G}provideFoldingRanges($,G,te){const re=this._documents.getDocument($);return k.asPromise(()=>this._provider.provideFoldingRanges(re,G,te)).then(K=>{if(!!Array.isArray(K))return K.map(S.FoldingRange.from)})}}class Me{constructor($,G,te){this._documents=$,this._provider=G,this._logService=te}provideSelectionRanges($,G,te){const re=this._documents.getDocument($),K=G.map(S.Position.to);return k.asPromise(()=>this._provider.provideSelectionRanges(re,K,te)).then(oe=>{if(!n.isNonEmptyArray(oe))return[];if(oe.length!==K.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Ae=0;Ae<K.length;Ae++){const $e=[];fe.push($e);let pe=K[Ae],Ge=oe[Ae];for(;;){if(!Ge.range.contains(pe))throw new Error("INVALID selection range, must contain the previous range");if($e.push(S.SelectionRange.from(Ge)),!Ge.parent)break;pe=Ge.range,Ge=Ge.parent}}return fe})}}class He{constructor($,G){this._documents=$,this._provider=G,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession($,G,te){const re=this._documents.getDocument($),K=S.Position.to(G),oe=await this._provider.prepareCallHierarchy(re,K,te);if(!oe)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(oe)?oe.map(Ae=>this._cacheAndConvertItem(fe,Ae)):[this._cacheAndConvertItem(fe,oe)]}async provideCallsTo($,G,te){const re=this._itemFromCache($,G);if(!re)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyIncomingCalls(re,te);if(!!K)return K.map(oe=>({from:this._cacheAndConvertItem($,oe.from),fromRanges:oe.fromRanges.map(fe=>S.Range.from(fe))}))}async provideCallsFrom($,G,te){const re=this._itemFromCache($,G);if(!re)throw new Error("missing call hierarchy item");const K=await this._provider.provideCallHierarchyOutgoingCalls(re,te);if(!!K)return K.map(oe=>({to:this._cacheAndConvertItem($,oe.to),fromRanges:oe.fromRanges.map(fe=>S.Range.from(fe))}))}releaseSession($){this._cache.delete($)}_cacheAndConvertItem($,G){var te;const re=this._cache.get($),K={_sessionId:$,_itemId:re.size.toString(36),name:G.name,detail:G.detail,kind:S.SymbolKind.from(G.kind),uri:G.uri,range:S.Range.from(G.range),selectionRange:S.Range.from(G.selectionRange),tags:(te=G.tags)===null||te===void 0?void 0:te.map(S.SymbolTag.from)};return re.set(K._itemId,G),K}_itemFromCache($,G){const te=this._cache.get($);return te==null?void 0:te.get(G)}}class Ye{constructor($,G){this.adapter=$,this.extension=G}}class qe{constructor($,G,te,re,K,oe,fe){this._adapter=new Map,this._uriTransformer=G,this._proxy=$.getProxy(D.MainContext.MainThreadLanguageFeatures),this._documents=te,this._commands=re,this._diagnostics=K,this._logService=oe,this._apiDeprecation=fe}_transformDocumentSelector($){return n.coalesce(n.asArray($).map(G=>this._doTransformDocumentSelector(G)))}_doTransformDocumentSelector($){if(typeof $=="string")return{$serialized:!0,language:$};if($)return{$serialized:!0,language:$.language,scheme:this._transformScheme($.scheme),pattern:typeof $.pattern=="undefined"?void 0:S.GlobPattern.from($.pattern),exclusive:$.exclusive}}_transformScheme($){return this._uriTransformer&&typeof $=="string"?this._uriTransformer.transformOutgoingScheme($):$}_createDisposable($){return new E.Disposable(()=>{this._adapter.delete($),this._proxy.$unregister($)})}_nextHandle(){return qe._handlePool++}_withAdapter($,G,te,re,K=!1){const oe=this._adapter.get($);if(!oe)return Promise.resolve(re);if(oe.adapter instanceof G){let fe;oe.extension&&(fe=Date.now(),this._logService.trace(`[${oe.extension.identifier.value}] INVOKE provider '${G.name}'`));const Ae=te(oe.adapter,oe.extension),$e=oe.extension;return $e&&Promise.resolve(Ae).then(()=>this._logService.trace(`[${$e.identifier.value}] provider DONE after ${Date.now()-fe}ms`),pe=>{K&&pe instanceof p.CancellationError||(this._logService.error(`[${$e.identifier.value}] provider FAILED`),this._logService.error(pe))}),Ae}return Promise.reject(new Error("no adapter found"))}_addNewAdapter($,G){const te=this._nextHandle();return this._adapter.set(te,new Ye($,G)),te}static _extLabel($){return $.displayName||$.name}registerDocumentSymbolProvider($,G,te,re){const K=this._addNewAdapter(new f(this._documents,te),$),oe=re&&re.label||qe._extLabel($);return this._proxy.$registerDocumentSymbolProvider(K,this._transformDocumentSelector(G),oe),this._createDisposable(K)}$provideDocumentSymbols($,G,te){return this._withAdapter($,f,re=>re.provideDocumentSymbols(g.URI.revive(G),te),void 0)}registerCodeLensProvider($,G,te){const re=this._nextHandle(),K=typeof te.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(re,new Ye(new m(this._documents,this._commands.converter,te),$)),this._proxy.$registerCodeLensSupport(re,this._transformDocumentSelector(G),K);let oe=this._createDisposable(re);if(K!==void 0){const fe=te.onDidChangeCodeLenses(Ae=>this._proxy.$emitCodeLensEvent(K));oe=E.Disposable.from(oe,fe)}return oe}$provideCodeLenses($,G,te){return this._withAdapter($,m,re=>re.provideCodeLenses(g.URI.revive(G),te),void 0)}$resolveCodeLens($,G,te){return this._withAdapter($,m,re=>re.resolveCodeLens(G,te),void 0)}$releaseCodeLenses($,G){this._withAdapter($,m,te=>Promise.resolve(te.releaseCodeLenses(G)),void 0)}registerDefinitionProvider($,G,te){const re=this._addNewAdapter(new r(this._documents,te),$);return this._proxy.$registerDefinitionSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDefinition($,G,te,re){return this._withAdapter($,r,K=>K.provideDefinition(g.URI.revive(G),te,re),[])}registerDeclarationProvider($,G,te){const re=this._addNewAdapter(new s(this._documents,te),$);return this._proxy.$registerDeclarationSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDeclaration($,G,te,re){return this._withAdapter($,s,K=>K.provideDeclaration(g.URI.revive(G),te,re),[])}registerImplementationProvider($,G,te){const re=this._addNewAdapter(new i(this._documents,te),$);return this._proxy.$registerImplementationSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideImplementation($,G,te,re){return this._withAdapter($,i,K=>K.provideImplementation(g.URI.revive(G),te,re),[])}registerTypeDefinitionProvider($,G,te){const re=this._addNewAdapter(new u(this._documents,te),$);return this._proxy.$registerTypeDefinitionSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideTypeDefinition($,G,te,re){return this._withAdapter($,u,K=>K.provideTypeDefinition(g.URI.revive(G),te,re),[])}registerHoverProvider($,G,te,re){const K=this._addNewAdapter(new w(this._documents,te),$);return this._proxy.$registerHoverProvider(K,this._transformDocumentSelector(G)),this._createDisposable(K)}$provideHover($,G,te,re){return this._withAdapter($,w,K=>K.provideHover(g.URI.revive(G),te,re),void 0)}registerEvaluatableExpressionProvider($,G,te,re){const K=this._addNewAdapter(new v(this._documents,te),$);return this._proxy.$registerEvaluatableExpressionProvider(K,this._transformDocumentSelector(G)),this._createDisposable(K)}$provideEvaluatableExpression($,G,te,re){return this._withAdapter($,v,K=>K.provideEvaluatableExpression(g.URI.revive(G),te,re),void 0)}registerInlineValuesProvider($,G,te,re){const K=typeof te.onDidChangeInlineValues=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new P(this._documents,te),$);this._proxy.$registerInlineValuesProvider(oe,this._transformDocumentSelector(G),K);let fe=this._createDisposable(oe);if(K!==void 0){const Ae=te.onDidChangeInlineValues($e=>this._proxy.$emitInlineValuesEvent(K));fe=E.Disposable.from(fe,Ae)}return fe}$provideInlineValues($,G,te,re,K){return this._withAdapter($,P,oe=>oe.provideInlineValues(g.URI.revive(G),te,re,K),void 0)}registerDocumentHighlightProvider($,G,te){const re=this._addNewAdapter(new A(this._documents,te),$);return this._proxy.$registerDocumentHighlightProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDocumentHighlights($,G,te,re){return this._withAdapter($,A,K=>K.provideDocumentHighlights(g.URI.revive(G),te,re),void 0)}registerLinkedEditingRangeProvider($,G,te){const re=this._addNewAdapter(new a(this._documents,te),$);return this._proxy.$registerLinkedEditingRangeProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideLinkedEditingRanges($,G,te,re){return this._withAdapter($,a,async K=>{const oe=await K.provideLinkedEditingRanges(g.URI.revive(G),te,re);if(oe)return{ranges:oe.ranges,wordPattern:oe.wordPattern?qe._serializeRegExp(oe.wordPattern):void 0}},void 0)}registerReferenceProvider($,G,te){const re=this._addNewAdapter(new R(this._documents,te),$);return this._proxy.$registerReferenceSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideReferences($,G,te,re,K){return this._withAdapter($,R,oe=>oe.provideReferences(g.URI.revive(G),te,re,K),void 0)}registerCodeActionProvider($,G,te,re){var K,oe;const fe=new h.DisposableStore,Ae=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,te,this._logService,$,this._apiDeprecation),$);return this._proxy.$registerQuickFixSupport(Ae,this._transformDocumentSelector(G),{providedKinds:(K=re==null?void 0:re.providedCodeActionKinds)===null||K===void 0?void 0:K.map($e=>$e.value),documentation:(oe=re==null?void 0:re.documentation)===null||oe===void 0?void 0:oe.map($e=>({kind:$e.kind.value,command:this._commands.converter.toInternal($e.command,fe)}))},qe._extLabel($),Boolean(te.resolveCodeAction)),fe.add(this._createDisposable(Ae)),fe}$provideCodeActions($,G,te,re,K){return this._withAdapter($,L,oe=>oe.provideCodeActions(g.URI.revive(G),te,re,K),void 0)}$resolveCodeAction($,G,te){return this._withAdapter($,L,re=>re.resolveCodeAction(G,te),void 0)}$releaseCodeActions($,G){this._withAdapter($,L,te=>Promise.resolve(te.releaseCodeActions(G)),void 0)}registerDocumentFormattingEditProvider($,G,te){const re=this._addNewAdapter(new H(this._documents,te),$);return this._proxy.$registerDocumentFormattingSupport(re,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(re)}$provideDocumentFormattingEdits($,G,te,re){return this._withAdapter($,H,K=>K.provideDocumentFormattingEdits(g.URI.revive(G),te,re),void 0)}registerDocumentRangeFormattingEditProvider($,G,te){const re=this._addNewAdapter(new ue(this._documents,te),$);return this._proxy.$registerRangeFormattingSupport(re,this._transformDocumentSelector(G),$.identifier,$.displayName||$.name),this._createDisposable(re)}$provideDocumentRangeFormattingEdits($,G,te,re,K){return this._withAdapter($,ue,oe=>oe.provideDocumentRangeFormattingEdits(g.URI.revive(G),te,re,K),void 0)}registerOnTypeFormattingEditProvider($,G,te,re){const K=this._addNewAdapter(new me(this._documents,te),$);return this._proxy.$registerOnTypeFormattingSupport(K,this._transformDocumentSelector(G),re,$.identifier),this._createDisposable(K)}$provideOnTypeFormattingEdits($,G,te,re,K,oe){return this._withAdapter($,me,fe=>fe.provideOnTypeFormattingEdits(g.URI.revive(G),te,re,K,oe),void 0)}registerWorkspaceSymbolProvider($,G){const te=this._addNewAdapter(new J(G,this._logService),$);return this._proxy.$registerNavigateTypeSupport(te),this._createDisposable(te)}$provideWorkspaceSymbols($,G,te){return this._withAdapter($,J,re=>re.provideWorkspaceSymbols(G,te),{symbols:[]})}$resolveWorkspaceSymbol($,G,te){return this._withAdapter($,J,re=>re.resolveWorkspaceSymbol(G,te),void 0)}$releaseWorkspaceSymbols($,G){this._withAdapter($,J,te=>te.releaseWorkspaceSymbols(G),void 0)}registerRenameProvider($,G,te){const re=this._addNewAdapter(new z(this._documents,te,this._logService),$);return this._proxy.$registerRenameSupport(re,this._transformDocumentSelector(G),z.supportsResolving(te)),this._createDisposable(re)}$provideRenameEdits($,G,te,re,K){return this._withAdapter($,z,oe=>oe.provideRenameEdits(g.URI.revive(G),te,re,K),void 0)}$resolveRenameLocation($,G,te,re){return this._withAdapter($,z,K=>K.resolveRenameLocation(g.URI.revive(G),te,re),void 0)}registerDocumentSemanticTokensProvider($,G,te,re){const K=this._nextHandle(),oe=typeof te.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(K,new Ye(new M(this._documents,te),$)),this._proxy.$registerDocumentSemanticTokensProvider(K,this._transformDocumentSelector(G),re,oe);let fe=this._createDisposable(K);if(oe){const Ae=te.onDidChangeSemanticTokens($e=>this._proxy.$emitDocumentSemanticTokensEvent(oe));fe=E.Disposable.from(fe,Ae)}return fe}$provideDocumentSemanticTokens($,G,te,re){return this._withAdapter($,M,K=>K.provideDocumentSemanticTokens(g.URI.revive(G),te,re),null,!0)}$releaseDocumentSemanticTokens($,G){this._withAdapter($,M,te=>te.releaseDocumentSemanticColoring(G),void 0)}registerDocumentRangeSemanticTokensProvider($,G,te,re){const K=this._addNewAdapter(new q(this._documents,te),$);return this._proxy.$registerDocumentRangeSemanticTokensProvider(K,this._transformDocumentSelector(G),re),this._createDisposable(K)}$provideDocumentRangeSemanticTokens($,G,te,re){return this._withAdapter($,q,K=>K.provideDocumentRangeSemanticTokens(g.URI.revive(G),te,re),null,!0)}registerCompletionItemProvider($,G,te,re){const K=this._addNewAdapter(new N(this._documents,this._commands.converter,te,this._apiDeprecation,$),$);return this._proxy.$registerSuggestSupport(K,this._transformDocumentSelector(G),re,N.supportsResolving(te),`${$.identifier.value}(${re.join("")})`),this._createDisposable(K)}$provideCompletionItems($,G,te,re,K){return this._withAdapter($,N,oe=>oe.provideCompletionItems(g.URI.revive(G),te,re,K),void 0)}$resolveCompletionItem($,G,te){return this._withAdapter($,N,re=>re.resolveCompletionItem(G,te),void 0)}$releaseCompletionItems($,G){this._withAdapter($,N,te=>te.releaseCompletionItems(G),void 0)}registerInlineCompletionsProvider($,G,te){const re=this._addNewAdapter(new W(this._documents,te,this._commands.converter),$);return this._proxy.$registerInlineCompletionsSupport(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideInlineCompletions($,G,te,re,K){return this._withAdapter($,W,oe=>oe.provideInlineCompletions(g.URI.revive(G),te,re,K),void 0)}$handleInlineCompletionDidShow($,G,te){this._withAdapter($,W,async re=>{re.handleDidShowCompletionItem(G,te)},void 0)}$freeInlineCompletionsList($,G){this._withAdapter($,W,async te=>{te.disposeCompletions(G)},void 0)}registerSignatureHelpProvider($,G,te,re){const K=Array.isArray(re)?{triggerCharacters:re,retriggerCharacters:[]}:re,oe=this._addNewAdapter(new B(this._documents,te),$);return this._proxy.$registerSignatureHelpProvider(oe,this._transformDocumentSelector(G),K),this._createDisposable(oe)}$provideSignatureHelp($,G,te,re,K){return this._withAdapter($,B,oe=>oe.provideSignatureHelp(g.URI.revive(G),te,re,K),void 0)}$releaseSignatureHelp($,G){this._withAdapter($,B,te=>te.releaseSignatureHelp(G),void 0)}registerInlayHintsProvider($,G,te){const re=typeof te.onDidChangeInlayHints=="function"?this._nextHandle():void 0,K=this._addNewAdapter(new Y(this._documents,te),$);this._proxy.$registerInlayHintsProvider(K,this._transformDocumentSelector(G),re);let oe=this._createDisposable(K);if(re!==void 0){const fe=te.onDidChangeInlayHints(Ae=>this._proxy.$emitInlayHintsEvent(re));oe=E.Disposable.from(oe,fe)}return oe}$provideInlayHints($,G,te,re){return this._withAdapter($,Y,K=>K.provideInlayHints(g.URI.revive(G),te,re),void 0)}registerDocumentLinkProvider($,G,te){const re=this._addNewAdapter(new he(this._documents,te),$);return this._proxy.$registerDocumentLinkProvider(re,this._transformDocumentSelector(G),typeof te.resolveDocumentLink=="function"),this._createDisposable(re)}$provideDocumentLinks($,G,te){return this._withAdapter($,he,re=>re.provideLinks(g.URI.revive(G),te),void 0)}$resolveDocumentLink($,G,te){return this._withAdapter($,he,re=>re.resolveLink(G,te),void 0)}$releaseDocumentLinks($,G){this._withAdapter($,he,te=>te.releaseLinks(G),void 0)}registerColorProvider($,G,te){const re=this._addNewAdapter(new De(this._documents,te),$);return this._proxy.$registerDocumentColorProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideDocumentColors($,G,te){return this._withAdapter($,De,re=>re.provideColors(g.URI.revive(G),te),[])}$provideColorPresentations($,G,te,re){return this._withAdapter($,De,K=>K.provideColorPresentations(g.URI.revive(G),te,re),void 0)}registerFoldingRangeProvider($,G,te){const re=this._nextHandle(),K=typeof te.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(re,new Ye(new Oe(this._documents,te),$)),this._proxy.$registerFoldingRangeProvider(re,this._transformDocumentSelector(G),K);let oe=this._createDisposable(re);if(K!==void 0){const fe=te.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(K));oe=E.Disposable.from(oe,fe)}return oe}$provideFoldingRanges($,G,te,re){return this._withAdapter($,Oe,K=>K.provideFoldingRanges(g.URI.revive(G),te,re),void 0)}registerSelectionRangeProvider($,G,te){const re=this._addNewAdapter(new Me(this._documents,te,this._logService),$);return this._proxy.$registerSelectionRangeProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$provideSelectionRanges($,G,te,re){return this._withAdapter($,Me,K=>K.provideSelectionRanges(g.URI.revive(G),te,re),[])}registerCallHierarchyProvider($,G,te){const re=this._addNewAdapter(new He(this._documents,te),$);return this._proxy.$registerCallHierarchyProvider(re,this._transformDocumentSelector(G)),this._createDisposable(re)}$prepareCallHierarchy($,G,te,re){return this._withAdapter($,He,K=>Promise.resolve(K.prepareSession(g.URI.revive(G),te,re)),void 0)}$provideCallHierarchyIncomingCalls($,G,te,re){return this._withAdapter($,He,K=>K.provideCallsTo(G,te,re),void 0)}$provideCallHierarchyOutgoingCalls($,G,te,re){return this._withAdapter($,He,K=>K.provideCallsFrom(G,te,re),void 0)}$releaseCallHierarchy($,G){this._withAdapter($,He,te=>Promise.resolve(te.releaseSession(G)),void 0)}static _serializeRegExp($){return{pattern:$.source,flags:_.regExpFlags($)}}static _serializeIndentationRule($){return{decreaseIndentPattern:qe._serializeRegExp($.decreaseIndentPattern),increaseIndentPattern:qe._serializeRegExp($.increaseIndentPattern),indentNextLinePattern:$.indentNextLinePattern?qe._serializeRegExp($.indentNextLinePattern):void 0,unIndentedLinePattern:$.unIndentedLinePattern?qe._serializeRegExp($.unIndentedLinePattern):void 0}}static _serializeOnEnterRule($){return{beforeText:qe._serializeRegExp($.beforeText),afterText:$.afterText?qe._serializeRegExp($.afterText):void 0,previousLineText:$.previousLineText?qe._serializeRegExp($.previousLineText):void 0,action:$.action}}static _serializeOnEnterRules($){return $.map(qe._serializeOnEnterRule)}setLanguageConfiguration($,G,te){let{wordPattern:re}=te;if(re&&_.regExpLeadsToEndlessLoop(re))throw new Error(`Invalid language configuration: wordPattern '${re}' is not allowed to match the empty string.`);re?this._documents.setWordDefinitionFor(G,re):this._documents.setWordDefinitionFor(G,void 0),te.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",$,"Do not use."),te.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",$,"Do not use.");const K=this._nextHandle(),oe={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?qe._serializeRegExp(te.wordPattern):void 0,indentationRules:te.indentationRules?qe._serializeIndentationRule(te.indentationRules):void 0,onEnterRules:te.onEnterRules?qe._serializeOnEnterRules(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport};return this._proxy.$setLanguageConfiguration(K,G,oe),this._createDisposable(K)}$setWordDefinitions($){for(const G of $)this._documents.setWordDefinitionFor(G.languageId,new RegExp(G.regexSource,G.regexFlags))}}e.ExtHostLanguageFeatures=qe,qe._handlePool=0}),define(we[190],_e([0,1,5,9,6]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(D,_){this._proxy=D.getProxy(g.MainContext.MainThreadLanguages),this._documents=_}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(D,_){await this._proxy.$changeLanguage(D,_);const C=this._documents.getDocumentData(D);if(!C)throw new Error(`document '${D.toString}' NOT found`);return C.document}async tokenAtPosition(D,_){var C;const n=D.version,I=T.Position.from(_),o=await this._proxy.$tokensAtPosition(D.uri,I),h={type:S.StandardTokenType.Other,range:(C=D.getWordRangeAtPosition(_))!==null&&C!==void 0?C:new S.Range(_.line,_.character,_.line,_.character)};if(!o)return h;const c={range:T.Range.to(o.range),type:T.TokenType.to(o.type)};return!c.range.contains(_)||n!==D.version?h:c}}e.ExtHostLanguages=E}),define(we[191],_e([0,1,5,15,29]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function E(D){return D&&D.title}let k=class{constructor(_,C){this._logService=C,this._proxy=_.getProxy(g.MainContext.MainThreadMessageService)}showMessage(_,C,n,I,o){const h={extension:_};let c;typeof I=="string"||E(I)?c=[I,...o]:(h.modal=I==null?void 0:I.modal,h.useCustom=I==null?void 0:I.useCustom,h.detail=I==null?void 0:I.detail,c=o),h.useCustom&&S.checkProposedApiEnabled(_);const d=[];for(let y=0;y<c.length;y++){const b=c[y];if(typeof b=="string")d.push({title:b,handle:y,isCloseAffordance:!1});else if(typeof b=="object"){let{title:p,isCloseAffordance:l}=b;d.push({title:p,isCloseAffordance:!!l,handle:y})}else this._logService.warn("Invalid message item:",b)}return this._proxy.$showMessage(C,n,h,d).then(y=>{if(typeof y=="number")return c[y]})}};k=Ve([ze(1,T.ILogService)],k),e.ExtHostMessageService=k}),define(we[192],_e([0,1,23,3,53,7,22,8,10,2,62,5,9,6,169,97]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class y{constructor(p,l,f,m,t){this._textDocumentsAndEditors=f,this._textDocuments=m,this._extensionStoragePaths=t,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new k.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new T.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new T.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new T.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new T.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new T.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new T.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new T.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new T.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new n.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=p.getProxy(I.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=p.getProxy(I.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=p.getProxy(I.MainContext.MainThreadNotebookEditors),this._commandsConverter=l.converter,l.registerArgumentProcessor({processArgument:r=>{var s;if(r&&r.$mid===12){const i=(s=r.notebookEditor)===null||s===void 0?void 0:s.notebookUri,u=r.cell.handle,w=this._documents.get(i),v=w==null?void 0:w.getCell(u);if(v)return v.apiCell}return r}})}get activeNotebookEditor(){var p;return(p=this._activeNotebookEditor)===null||p===void 0?void 0:p.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(p=>p.apiEditor)}getEditorById(p){const l=this._editors.get(p);if(!l)throw new Error(`unknown text editor: ${p}. known editors: ${[...this._editors.keys()]} `);return l}getIdByEditor(p){for(const[l,f]of this._editors)if(f.apiEditor===p)return l}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(p,l){const f=this._documents.get(p);if(!f&&!l)throw new Error(`NO notebook document for '${p}'`);return f}_getProviderData(p){const l=this._notebookContentProviders.get(p);if(!l)throw new Error(`NO provider for '${p}'`);return l}registerNotebookContentProvider(p,l,f,m,t){if(D.isFalsyOrWhitespace(l))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(l))throw new Error(`Notebook provider for '${l}' already registered`);this._notebookContentProviders.set(l,{extension:p,provider:f});let r;return f.onDidChangeNotebookContentOptions&&(r=f.onDidChangeNotebookContentOptions(()=>{const s=o.NotebookDocumentContentOptions.from(f.options);this._notebookProxy.$updateNotebookProviderOptions(l,s)})),this._notebookProxy.$registerNotebookProvider({id:p.identifier,location:p.extensionLocation},l,o.NotebookDocumentContentOptions.from(m),y._convertNotebookRegistrationData(p,t)),new h.Disposable(()=>{r==null||r.dispose(),this._notebookContentProviders.delete(l),this._notebookProxy.$unregisterNotebookProvider(l)})}static _convertNotebookRegistrationData(p,l){if(!l)return;const f=l.filenamePattern.map(m=>o.NotebookExclusiveDocumentPattern.from(m)).filter(m=>m!==void 0);if(l.filenamePattern&&!f){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:p.identifier,providerDisplayName:p.displayName||p.name,displayName:l.displayName,filenamePattern:f,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(p,l,f){const m=y._notebookStatusBarItemProviderHandlePool++,t=typeof f.onDidChangeCellStatusBarItems=="function"?y._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(m,f),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(m,t,l);let r;return t!==void 0&&(r=f.onDidChangeCellStatusBarItems(s=>this._notebookProxy.$emitCellStatusBarEvent(t))),new h.Disposable(()=>{this._notebookStatusBarItemProviders.delete(m),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(m,t),r&&r.dispose()})}async createNotebookDocument(p){const l=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:p.viewType,content:p.content&&o.NotebookData.from(p.content)});return C.URI.revive(l)}async openNotebookDocument(p){const l=this._documents.get(p);if(l)return l.apiNotebook;const f=await this._notebookDocumentsProxy.$tryOpenNotebook(p),m=this._documents.get(C.URI.revive(f));return _.assertIsDefined(m==null?void 0:m.apiNotebook)}async showNotebookDocument(p,l){var f;C.URI.isUri(p)&&(p=await this.openNotebookDocument(p));let m;typeof l=="object"?m={position:o.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(o.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:m={preserveFocus:!1};const t=await this._notebookEditorsProxy.$tryShowNotebookDocument(p.uri,p.notebookType,m),r=t&&((f=this._editors.get(t))===null||f===void 0?void 0:f.apiEditor);if(r)return r;throw t?new Error(`Could NOT open editor for "${p.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${p.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(p,l,f,m){const t=this._notebookStatusBarItemProviders.get(p),r=C.URI.revive(l),s=this._documents.get(r);if(!s||!t)return;const i=s.getCellFromIndex(f);if(!i)return;const u=await t.provideCellStatusBarItems(i.apiCell,m);if(!u)return;const w=new E.DisposableStore,v=this._statusBarCache.add([w]),A=(Array.isArray(u)?u:[u]).map(a=>o.NotebookStatusBarItem.from(a,this._commandsConverter,w));return{cacheId:v,items:A}}$releaseNotebookCellStatusBarItems(p){this._statusBarCache.delete(p)}registerNotebookSerializer(p,l,f,m,t){if(D.isFalsyOrWhitespace(l))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,f),this._notebookProxy.$registerNotebookSerializer(r,{id:p.identifier,location:p.extensionLocation},l,o.NotebookDocumentContentOptions.from(m),y._convertNotebookRegistrationData(p,t)),E.toDisposable(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(p,l,f){const m=this._notebookSerializer.get(p);if(!m)throw new Error("NO serializer found");const t=await m.deserializeNotebook(l.buffer,f);return o.NotebookData.from(t)}async $notebookToData(p,l,f){const m=this._notebookSerializer.get(p);if(!m)throw new Error("NO serializer found");const t=await m.serializeNotebook(o.NotebookData.to(l),f);return g.VSBuffer.wrap(t)}async $openNotebook(p,l,f,m,t){var r;const{provider:s}=this._getProviderData(p),i=await s.openNotebook(C.URI.revive(l),{backupId:f,untitledDocumentData:m==null?void 0:m.buffer},t);return{metadata:(r=i.metadata)!==null&&r!==void 0?r:Object.create(null),cells:i.cells.map(o.NotebookCellData.from)}}async $saveNotebook(p,l,f){const m=this.getNotebookDocument(C.URI.revive(l)),{provider:t}=this._getProviderData(p);return await t.saveNotebook(m.apiNotebook,f),!0}async $saveNotebookAs(p,l,f,m){const t=this.getNotebookDocument(C.URI.revive(l)),{provider:r}=this._getProviderData(p);return await r.saveNotebookAs(C.URI.revive(f),t.apiNotebook,m),!0}async $backupNotebook(p,l,f){var m;const t=this.getNotebookDocument(C.URI.revive(l)),r=this._getProviderData(p),s=(m=this._extensionStoragePaths.workspaceValue(r.extension))!==null&&m!==void 0?m:this._extensionStoragePaths.globalValue(r.extension),i=String(S.hash([t.uri.toString(),this._backupIdPool++])),u=C.URI.joinPath(s,i),w=await r.provider.backupNotebook(t.apiNotebook,{destination:u},f);return t.updateBackup(w),w.id}_createExtHostEditor(p,l,f){if(this._editors.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const m=new d.ExtHostNotebookEditor(l,this._notebookEditorsProxy,p,f.visibleRanges.map(o.NotebookRange.to),f.selections.map(o.NotebookRange.to),typeof f.viewColumn=="number"?o.ViewColumn.to(f.viewColumn):void 0);this._editors.set(l,m)}$acceptDocumentAndEditorsDelta(p){var l,f,m;if(p.removedDocuments)for(const r of p.removedDocuments){const s=C.URI.revive(r),i=this._documents.get(s);i&&(i.dispose(),this._documents.delete(s),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:i.apiNotebook.getCells().map(u=>u.document.uri)}),this._onDidCloseNotebookDocument.fire(i.apiNotebook));for(const u of this._editors.values())u.notebookData.uri.toString()===s.toString()&&this._editors.delete(u.id)}if(p.addedDocuments){const r=[];for(const s of p.addedDocuments){const i=C.URI.revive(s.uri);if(this._documents.has(i))throw new Error(`adding EXISTING notebook ${i} `);const u=this,w=new c.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(v){u._onDidChangeNotebookCells.fire(v)},emitCellOutputsChange(v){u._onDidChangeCellOutputs.fire(v)},emitCellMetadataChange(v){u._onDidChangeCellMetadata.fire(v)},emitCellExecutionStateChange(v){u._onDidChangeCellExecutionState.fire(v)}},i,s);r.push(...s.cells.map(v=>c.ExtHostCell.asModelAddData(w.apiNotebook,v))),(l=this._documents.get(i))===null||l===void 0||l.dispose(),this._documents.set(i,w),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:r}),this._onDidOpenNotebookDocument.fire(w.apiNotebook)}}if(p.addedEditors)for(const r of p.addedEditors){if(this._editors.has(r.id))return;const s=C.URI.revive(r.documentUri),i=this._documents.get(s);i&&this._createExtHostEditor(i,r.id,r)}const t=[];if(p.removedEditors)for(const r of p.removedEditors){const s=this._editors.get(r);s&&(this._editors.delete(r),((f=this._activeNotebookEditor)===null||f===void 0?void 0:f.id)===s.id&&(this._activeNotebookEditor=void 0),t.push(s))}if(p.visibleEditors){this._visibleNotebookEditors=p.visibleEditors.map(s=>this._editors.get(s)).filter(s=>!!s);const r=new Set;this._visibleNotebookEditors.forEach(s=>r.add(s.id));for(const s of this._editors.values()){const i=r.has(s.id);s._acceptVisibility(i)}this._visibleNotebookEditors=[...this._editors.values()].map(s=>s).filter(s=>s.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}p.newActiveEditor===null?this._activeNotebookEditor=void 0:p.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(p.newActiveEditor)),p.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire((m=this._activeNotebookEditor)===null||m===void 0?void 0:m.apiEditor)}}e.ExtHostNotebookController=y,y._notebookStatusBarItemProviderHandlePool=0}),define(we[193],_e([0,1,3,50,15,5,13,9]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class _{constructor(I,o){const h=_._Keys.nextId();I.$registerNotebookEditorDecorationType(h,D.NotebookDecorationRenderOptions.from(o)),this.value={key:h,dispose(){I.$removeNotebookEditorDecorationType(h)}}}}_._Keys=new T.IdGenerator("NotebookEditorDecorationType");let C=class{constructor(I,o,h){this._logService=I,this._extHostRpc=o,this._notebooksAndEditors=h,this._onDidChangeNotebookEditorSelection=new g.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new g.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(I){return new _(this._extHostRpc.getProxy(E.MainContext.MainThreadNotebookEditors),I).value}$acceptEditorPropertiesChanged(I,o){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",I,o);const h=this._notebooksAndEditors.getEditorById(I);o.visibleRanges&&h._acceptVisibleRanges(o.visibleRanges.ranges.map(D.NotebookRange.to)),o.selections&&h._acceptSelections(o.selections.selections.map(D.NotebookRange.to)),o.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:h.apiEditor,visibleRanges:h.apiEditor.visibleRanges}),o.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:h.apiEditor,selections:h.apiEditor.selections}))}$acceptEditorViewColumns(I){for(const o in I)this._notebooksAndEditors.getEditorById(o)._acceptViewColumn(D.ViewColumn.to(I[o]))}};C=Ve([ze(0,S.ILogService),ze(1,k.IExtHostRpcService)],C),e.ExtHostNotebookEditors=C}),define(we[194],_e([0,1,3,7,5,26,2,9,67,22,12,68,18,17,15,6,29]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(t,r,s,i){this._initData=r,this._extHostNotebook=s,this._logService=i,this._activeExecutions=new C.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=t.getProxy(S.MainContext.MainThreadNotebookKernels)}createNotebookController(t,r,s,i,u,w){for(let N of this._kernelData.values())if(N.controller.id===r&&E.ExtensionIdentifier.equals(t.identifier,N.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const v=this._handlePool++,P=this;this._logService.trace(`NotebookController[${v}], CREATED by ${t.identifier.value}, ${r}`);const A=()=>console.warn(`NO execute handler from notebook controller '${ue.id}' of extension: '${t.identifier}'`);let a=!1;const R=new T.DisposableStore,L=new g.Emitter,H=new g.Emitter,ue={id:`${t.identifier.value}/${r}`,notebookType:s,extensionId:t.identifier,extensionLocation:t.extensionLocation,label:i||t.identifier.value,preloads:w?w.map(D.NotebookRendererScript.from):[]};let me=u??A,J;this._proxy.$addKernel(v,ue).catch(N=>{console.log(N),a=!0});let z=0;const Z=()=>{if(a)return;const N=++z;Promise.resolve().then(()=>{N===z&&this._proxy.$updateKernel(v,ue)})},M=new C.ResourceMap,q={get id(){return r},get notebookType(){return ue.notebookType},onDidChangeSelectedNotebooks:L.event,get label(){return ue.label},set label(N){var W;ue.label=(W=N??t.displayName)!==null&&W!==void 0?W:t.name,Z()},get detail(){var N;return(N=ue.detail)!==null&&N!==void 0?N:""},set detail(N){ue.detail=N,Z()},get description(){var N;return(N=ue.description)!==null&&N!==void 0?N:""},set description(N){ue.description=N,Z()},get supportedLanguages(){return ue.supportedLanguages},set supportedLanguages(N){ue.supportedLanguages=N,Z()},get supportsExecutionOrder(){var N;return(N=ue.supportsExecutionOrder)!==null&&N!==void 0?N:!1},set supportsExecutionOrder(N){ue.supportsExecutionOrder=N,Z()},get rendererScripts(){return ue.preloads?ue.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return me},set executeHandler(N){me=N??A},get interruptHandler(){return J},set interruptHandler(N){J=N,ue.supportsInterrupt=Boolean(N),Z()},createNotebookCellExecution(N){if(a)throw new Error("notebook controller is DISPOSED");if(!M.has(N.notebook.uri))throw P._logService.trace(`NotebookController[${v}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(M.keys()).map(W=>W.toString())),new Error(`notebook controller is NOT associated to notebook: ${N.notebook.uri.toString()}`);return P._createNotebookCellExecution(N)},dispose:()=>{a||(this._logService.trace(`NotebookController[${v}], DISPOSED`),a=!0,this._kernelData.delete(v),R.dispose(),L.dispose(),H.dispose(),this._proxy.$removeKernel(v))},updateNotebookAffinity(N,W){P._proxy.$updateNotebookPriority(v,N.uri,W)},onDidReceiveMessage:H.event,postMessage(N,W){return y.checkProposedApiEnabled(t),P._proxy.$postMessage(v,W&&P._extHostNotebook.getIdByEditor(W),N)},asWebviewUri(N){return y.checkProposedApiEnabled(t),_.asWebviewUri(N,P._initData.remote)}};return this._kernelData.set(v,{extensionId:t.identifier,controller:q,onDidReceiveMessage:H,onDidChangeSelection:L,associatedNotebooks:M}),q}$acceptNotebookAssociation(t,r,s){const i=this._kernelData.get(t);if(i){const u=this._extHostNotebook.getNotebookDocument(k.URI.revive(r));s?i.associatedNotebooks.set(u.uri,!0):i.associatedNotebooks.delete(u.uri),this._logService.trace(`NotebookController[${t}] ASSOCIATE notebook`,u.uri.toString(),s),i.onDidChangeSelection.fire({selected:s,notebook:u.apiNotebook})}}async $executeCells(t,r,s){const i=this._kernelData.get(t);if(!i)return;const u=this._extHostNotebook.getNotebookDocument(k.URI.revive(r)),w=[];for(let v of s){const P=u.getCell(v);P&&w.push(P.apiCell)}try{this._logService.trace(`NotebookController[${t}] EXECUTE cells`,u.uri.toString(),w.length),await i.controller.executeHandler.call(i.controller,w,u.apiNotebook,i.controller)}catch(v){this._logService.error(`NotebookController[${t}] execute cells FAILED`,v),console.error(v)}}async $cancelCells(t,r,s){var i;const u=this._kernelData.get(t);if(!u)return;const w=this._extHostNotebook.getNotebookDocument(k.URI.revive(r));if(u.controller.interruptHandler)await u.controller.interruptHandler.call(u.controller,w.apiNotebook);else for(let v of s){const P=w.getCell(v);P&&((i=this._activeExecutions.get(P.uri))===null||i===void 0||i.cancel())}}$acceptKernelMessageFromRenderer(t,r,s){const i=this._kernelData.get(t);if(!i)return;const u=this._extHostNotebook.getEditorById(r);i.onDidReceiveMessage.fire(Object.freeze({editor:u.apiEditor,message:s}))}_createNotebookCellExecution(t){if(t.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const s=this._extHostNotebook.getNotebookDocument(t.notebook.uri).getCellFromApiCell(t);if(!s)throw new Error("invalid cell");if(this._activeExecutions.has(s.uri))throw new Error(`duplicate execution for ${s.uri}`);const i=new l(s.notebook,s,this._proxy);this._activeExecutions.set(s.uri,i);const u=i.onDidChangeState(()=>{i.state===p.Resolved&&(i.dispose(),u.dispose(),this._activeExecutions.delete(s.uri))});return i.asApiObject()}};b=Ve([ze(3,c.ILogService)],b),e.ExtHostNotebookKernels=b;var p;(function(m){m[m.Init=0]="Init",m[m.Started=1]="Started",m[m.Resolved=2]="Resolved"})(p||(p={}));class l extends T.Disposable{constructor(t,r,s){super();this._document=t,this._cell=r,this._proxy=s,this._onDidChangeState=new g.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new o.CancellationTokenSource),this._collector=new f(10,i=>this.applyEdits(i)),this._executionOrder=r.internalMetadata.executionOrder,this.mixinMetadata({runState:I.NotebookCellExecutionState.Pending,executionOrder:null})}get state(){return this._state}cancel(){this._tokenSource.cancel()}async applyEditSoon(t){await this._collector.addItem(t)}async applyEdits(t){return this._proxy.$applyExecutionEdits(this._document.uri,t)}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}mixinMetadata(t){this.applyEdits([{editType:9,handle:this._cell.handle,internalMetadata:t}])}cellIndexToHandle(t){let r=this._cell;if(t&&(r=this._document.getCellFromApiCell(t)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(t){return t.map(r=>{const s=d.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return s===r.items?D.NotebookCellOutput.from(r):D.NotebookCellOutput.from({items:s,id:r.id,metadata:r.metadata})})}async updateOutputs(t,r,s){const i=this.cellIndexToHandle(r),u=this.validateAndConvertOutputs(h.asArray(t));return this.applyEditSoon({editType:2,handle:i,append:s,outputs:u})}async updateOutputItems(t,r,s){return t=d.NotebookCellOutput.ensureUniqueMimeTypes(h.asArray(t),!0),this.applyEditSoon({editType:7,items:t.map(D.NotebookCellOutputItem.from),outputId:r.id,append:s})}asApiObject(){const t=this;return Object.freeze({get token(){return t._tokenSource.token},get cell(){return t._cell.apiCell},get executionOrder(){return t._executionOrder},set executionOrder(s){t._executionOrder=s,t.mixinMetadata({executionOrder:s})},start(s){if(t._state===p.Resolved||t._state===p.Started)throw new Error("Cannot call start again");t._state=p.Started,t._onDidChangeState.fire(),t.mixinMetadata({runState:I.NotebookCellExecutionState.Executing,runStartTime:s??null})},end(s,i){if(t._state===p.Resolved)throw new Error("Cannot call resolve twice");t._state=p.Resolved,t._onDidChangeState.fire(),t.mixinMetadata({runState:null,lastRunSuccess:s??null,runEndTime:i??null})},clearOutput(s){return t.verifyStateForOutput(),t.updateOutputs([],s,!1)},appendOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!0)},replaceOutput(s,i){return t.verifyStateForOutput(),t.updateOutputs(s,i,!1)},appendOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!0)},replaceOutputItems(s,i){return t.verifyStateForOutput(),t.updateOutputItems(s,i,!1)}})}}class f{constructor(t,r){this.delay=t,this.callback=r,this.batch=[]}addItem(t){return this.batch.push(t),this.waitPromise||(this.waitPromise=n.timeout(this.delay).then(()=>{this.waitPromise=void 0;const r=this.batch;return this.batch=[],this.callback(r)})),this.waitPromise}}}),define(we[195],_e([0,1,3,5,97]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class E{constructor(D,_){this._extHostNotebook=_,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(T.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,_,C){var n;const I=this._extHostNotebook.getEditorById(D);(n=this._rendererMessageEmitters.get(_))===null||n===void 0||n.fire({editor:I.apiEditor,message:C})}createRendererMessaging(D){return{onDidReceiveMessage:(...C)=>this.getOrCreateEmitterFor(D).event(...C),postMessage:(C,n)=>{const I=S.ExtHostNotebookEditor.apiEditorsToExtHost.get(C);if(!I)throw new Error("The first argument to postMessage() must be a NotebookEditor");this.proxy.$postMessage(I.id,D,n)}}}getOrCreateEmitterFor(D){let _=this._rendererMessageEmitters.get(D);return _||(_=new g.Emitter({onLastListenerRemove:()=>{_==null||_.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,_),_)}}e.ExtHostNotebookRenderers=E}),define(we[101],_e([0,1,5,3,7,23,4,13]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class _ extends S.Disposable{constructor(c,d,y,b){super();this._onDidAppend=this._register(new T.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=c,this._proxy=b,this._id=b.$register(this.name,d,y),this._disposed=!1,this._offset=0}get name(){return this._name}append(c){this.validate(),this._offset+=c?E.VSBuffer.fromString(c).byteLength:0}update(){this._id.then(c=>this._proxy.$update(c))}appendLine(c){this.validate(),this.append(c+`
`)}clear(){this.validate();const c=this._offset;this._id.then(d=>this._proxy.$clear(d,c))}show(c,d){this.validate(),this._id.then(y=>this._proxy.$reveal(y,!!(typeof c=="boolean"?c:d)))}hide(){this.validate(),this._id.then(c=>this._proxy.$close(c))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(c=>this._proxy.$dispose(c)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=_;class C extends _{constructor(c,d){super(c,!1,void 0,d)}append(c){super.append(c),this._id.then(d=>this._proxy.$append(d,c)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=C;class n extends _{constructor(c,d,y){super(c,!0,d,y)}append(c){throw new Error("Not supported")}}class I{constructor(c,d){this.name=c,this._channel=d}append(c){this._channel.then(d=>d.append(c))}appendLine(c){this._channel.then(d=>d.appendLine(c))}clear(){this._channel.then(c=>c.clear())}show(c,d){this._channel.then(y=>y.show(c,d))}hide(){this._channel.then(c=>c.hide())}dispose(){this._channel.then(c=>c.dispose())}}e.LazyOutputChannel=I;let o=class{constructor(c){this._proxy=c.getProxy(g.MainContext.MainThreadOutputService)}$setVisibleChannel(c){}createOutputChannel(c){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");return new C(c,this._proxy)}createOutputChannelFromLogFile(c,d){if(c=c.trim(),!c)throw new Error("illegal argument `name`. must not be falsy");if(!d)throw new Error("illegal argument `file`. must not be falsy");return new n(c,d,this._proxy)}};o=Ve([ze(0,D.IExtHostRpcService)],o),e.ExtHostOutputService=o,e.IExtHostOutputService=k.createDecorator("IExtHostOutputService")}),define(we[196],_e([0,1,12,18,3,7,5,2,6,11,17,42]),function(ee,e,g,T,S,E,k,D,_,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function o(h,c,d){const y=h.getProxy(k.MainContext.MainThreadQuickOpen);class b{constructor(i,u){this._sessions=new Map,this._instances=0,this._workspace=i,this._commands=u}showQuickPick(i,u,w,v=T.CancellationToken.None){this._onDidSelectItem=void 0;const P=Promise.resolve(i),A=++this._instances,a=y.$show(A,{title:w==null?void 0:w.title,placeHolder:w==null?void 0:w.placeHolder,matchOnDescription:w==null?void 0:w.matchOnDescription,matchOnDetail:w==null?void 0:w.matchOnDetail,ignoreFocusLost:w==null?void 0:w.ignoreFocusOut,canPickMany:w==null?void 0:w.canPickMany},v),R={},L=a.then(()=>R);return Promise.race([L,P]).then(H=>{if(H!==R)return P.then(ue=>{const me=[];for(let J=0;J<ue.length;J++){const z=ue[J];let Z,M,q,N,W;typeof z=="string"?Z=z:(Z=z.label,M=z.description,q=z.detail,N=z.picked,W=z.alwaysShow),me.push({label:Z,description:M,handle:J,detail:q,picked:N,alwaysShow:W})}return w&&typeof w.onDidSelectItem=="function"&&(this._onDidSelectItem=J=>{w.onDidSelectItem(ue[J])}),y.$setItems(A,me),a.then(J=>{if(typeof J=="number")return ue[J];if(Array.isArray(J))return J.map(z=>ue[z])})})}).then(void 0,H=>{if(!C.isPromiseCanceledError(H))return y.$setError(A,H),Promise.reject(H)})}$onItemSelected(i){this._onDidSelectItem&&this._onDidSelectItem(i)}showInput(i,u=T.CancellationToken.None){return this._validateInput=i?i.validateInput:void 0,y.$input(i,typeof this._validateInput=="function",u).then(void 0,w=>{if(!C.isPromiseCanceledError(w))return Promise.reject(w)})}$validateInput(i){return this._validateInput?g.asPromise(()=>this._validateInput(i)):Promise.resolve(void 0)}async showWorkspaceFolderPick(i,u=T.CancellationToken.None){const w=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[i]);if(!w)return;const v=await this._workspace.getWorkspaceFolders2();if(!!v)return v.find(P=>P.uri.toString()===w.uri.toString())}createQuickPick(i,u){const w=new t(i,u,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}createInputBox(i){const u=new r(i,()=>this._sessions.delete(u._id));return this._sessions.set(u._id,u),u}$onDidChangeValue(i,u){const w=this._sessions.get(i);w&&w._fireDidChangeValue(u)}$onDidAccept(i){const u=this._sessions.get(i);u&&u._fireDidAccept()}$onDidChangeActive(i,u){const w=this._sessions.get(i);w instanceof t&&w._fireDidChangeActive(u)}$onDidChangeSelection(i,u){const w=this._sessions.get(i);w instanceof t&&w._fireDidChangeSelection(u)}$onDidTriggerButton(i,u){const w=this._sessions.get(i);w&&w._fireDidTriggerButton(u)}$onDidHide(i){const u=this._sessions.get(i);u&&u._fireDidHide()}}class p{constructor(i,u){this._extensionId=i,this._onDidDispose=u,this._id=t._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new S.Emitter,this._onDidChangeValueEmitter=new S.Emitter,this._onDidTriggerButtonEmitter=new S.Emitter,this._onDidHideEmitter=new S.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(i){this._title=i,this.update({title:i})}get step(){return this._steps}set step(i){this._steps=i,this.update({step:i})}get totalSteps(){return this._totalSteps}set totalSteps(i){this._totalSteps=i,this.update({totalSteps:i})}get enabled(){return this._enabled}set enabled(i){this._enabled=i,this.update({enabled:i})}get busy(){return this._busy}set busy(i){this._busy=i,this.update({busy:i})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(i){this._ignoreFocusOut=i,this.update({ignoreFocusOut:i})}get value(){return this._value}set value(i){this._value=i,this.update({value:i})}get placeholder(){return this._placeholder}set placeholder(i){this._placeholder=i,this.update({placeholder:i})}get buttons(){return this._buttons}set buttons(i){this._buttons=i.slice(),this._handlesToButtons.clear(),i.forEach((u,w)=>{const v=u===_.QuickInputButtons.Back?-1:w;this._handlesToButtons.set(v,u)}),this.update({buttons:i.map((u,w)=>({iconPath:l(u.iconPath),tooltip:u.tooltip,handle:u===_.QuickInputButtons.Back?-1:w}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(i){this._value=i,this._onDidChangeValueEmitter.fire(i)}_fireDidTriggerButton(i){const u=this._handlesToButtons.get(i);u&&this._onDidTriggerButtonEmitter.fire(u)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=E.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),y.$dispose(this._id))}update(i){if(!this._disposed){for(const u of Object.keys(i)){const w=i[u];this._pendingUpdate[u]=w===void 0?null:w}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){y.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}p._nextId=1;function l(s){if(s instanceof _.ThemeIcon)return{id:s.id};const i=m(s),u=f(s);return{dark:typeof i=="string"?D.URI.file(i):i,light:typeof u=="string"?D.URI.file(u):u}}function f(s){return typeof s=="object"&&"light"in s?s.light:s}function m(s){return typeof s=="object"&&"dark"in s?s.dark:s}class t extends p{constructor(i,u,w){super(i,w);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new S.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new S.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(i){this._items=i.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),i.forEach((u,w)=>{this._handlesToItems.set(w,u),this._itemsToHandles.set(u,w)}),this.update({items:i.map((u,w)=>({label:u.label,description:u.description,handle:w,detail:u.detail,picked:u.picked,alwaysShow:u.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(i){this._canSelectMany=i,this.update({canSelectMany:i})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(i){this._matchOnDescription=i,this.update({matchOnDescription:i})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(i){this._matchOnDetail=i,this.update({matchOnDetail:i})}get sortByLabel(){return this._sortByLabel}set sortByLabel(i){this._sortByLabel=i,this.update({sortByLabel:i})}get activeItems(){return this._activeItems}set activeItems(i){this._activeItems=i.filter(u=>this._itemsToHandles.has(u)),this.update({activeItems:this._activeItems.map(u=>this._itemsToHandles.get(u))})}get selectedItems(){return this._selectedItems}set selectedItems(i){this._selectedItems=i.filter(u=>this._itemsToHandles.has(u)),this.update({selectedItems:this._selectedItems.map(u=>this._itemsToHandles.get(u))})}_fireDidChangeActive(i){const u=n.coalesce(i.map(w=>this._handlesToItems.get(w)));this._activeItems=u,this._onDidChangeActiveEmitter.fire(u)}_fireDidChangeSelection(i){const u=n.coalesce(i.map(w=>this._handlesToItems.get(w)));this._selectedItems=u,this._onDidChangeSelectionEmitter.fire(u)}}class r extends p{constructor(i,u){super(i,u);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(i){this._password=i,this.update({password:i})}get prompt(){return this._prompt}set prompt(i){this._prompt=i,this.update({prompt:i})}get validationMessage(){return this._validationMessage}set validationMessage(i){this._validationMessage=i,this.update({validationMessage:i,severity:i?I.default.Error:I.default.Ignore})}}return new b(c,d)}e.createExtHostQuickOpen=o}),define(we[197],_e([0,1,2,3,48,7,12,5,17,112,15,26,29]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(i){if(i)return typeof i.iconPath=="string"?g.URI.file(i.iconPath):i.iconPath}function c(i,u){if(!i.iconPath&&!u.iconPath)return 0;if(i.iconPath){if(!u.iconPath)return 1}else return-1;const w=typeof i.iconPath=="string"?i.iconPath:i.iconPath.fsPath,v=typeof u.iconPath=="string"?u.iconPath:u.iconPath.fsPath;return C.comparePaths(w,v)}function d(i,u){let w=0;if(i.strikeThrough!==u.strikeThrough)return i.strikeThrough?1:-1;if(i.faded!==u.faded)return i.faded?1:-1;if(i.tooltip!==u.tooltip)return(i.tooltip||"").localeCompare(u.tooltip||"");if(w=c(i,u),w!==0)return w;if(i.light&&u.light)w=c(i.light,u.light);else{if(i.light)return 1;if(u.light)return-1}if(w!==0)return w;if(i.dark&&u.dark)w=c(i.dark,u.dark);else{if(i.dark)return 1;if(u.dark)return-1}return w}function y(i,u){if(i.command!==u.command)return i.command<u.command?-1:1;if(i.title!==u.title)return i.title<u.title?-1:1;if(i.tooltip!==u.tooltip){if(i.tooltip!==void 0&&u.tooltip!==void 0)return i.tooltip<u.tooltip?-1:1;if(i.tooltip!==void 0)return 1;if(u.tooltip!==void 0)return-1}if(i.arguments===u.arguments)return 0;if(i.arguments)if(u.arguments){if(i.arguments.length!==u.arguments.length)return i.arguments.length-u.arguments.length}else return 1;else return-1;for(let w=0;w<i.arguments.length;w++){const v=i.arguments[w],P=u.arguments[w];if(v!==P)return v<P?-1:1}return 0}function b(i,u){let w=C.comparePaths(i.resourceUri.fsPath,u.resourceUri.fsPath,!0);if(w!==0)return w;if(i.command&&u.command)w=y(i.command,u.command);else{if(i.command)return 1;if(u.command)return-1}if(w!==0)return w;if(i.decorations&&u.decorations)w=d(i.decorations,u.decorations);else{if(i.decorations)return 1;if(u.decorations)return-1}return w}function p(i,u){for(let w=0;w<i.length;w++)if(i[w]!==u[w])return!1;return!0}function l(i,u){return i.command===u.command&&i.title===u.title&&i.tooltip===u.tooltip&&(i.arguments&&u.arguments?p(i.arguments,u.arguments):i.arguments===u.arguments)}function f(i,u){return _.equals(i,u,l)}class m{constructor(u,w,v){this._extension=u,this._proxy=w,this._sourceControlHandle=v,this._value="",this._onDidChange=new T.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(u){this._proxy.$setInputBoxValue(this._sourceControlHandle,u),this.updateValue(u)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(u){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,u),this._placeholder=u}get validateInput(){return o.checkProposedApiEnabled(this._extension),this._validateInput}set validateInput(u){if(o.checkProposedApiEnabled(this._extension),u&&typeof u!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=u,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!u)}get visible(){return this._visible}set visible(u){u=!!u,this._visible!==u&&(this._visible=u,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,u))}focus(){o.checkProposedApiEnabled(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(u,w){o.checkProposedApiEnabled(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,u,w)}$onInputBoxValueChange(u){this.updateValue(u)}updateValue(u){this._value=u,this._onDidChange.fire(u)}}e.ExtHostSCMInputBox=m;class t{constructor(u,w,v,P,A){this._proxy=u,this._commands=w,this._sourceControlHandle=v,this._id=P,this._label=A,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new T.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new T.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=t._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(u){this._label=u,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,u)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(u){this._hideWhenEmpty=u,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(u){this._resourceStates=[...u],this._onDidUpdateResourceStates.fire()}getResourceState(u){return this._resourceStatesMap.get(u)}$executeResourceCommand(u,w){const v=this._resourceStatesCommandsMap.get(u);return v?k.asPromise(()=>this._commands.executeCommand(v.command,...v.arguments||[],w)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){var u;const w=[...this._resourceStates].sort(b),P=_.sortedDiff(this._resourceSnapshot,w,b).map(R=>{const L=R.toInsert.map(H=>{const ue=this._resourceHandlePool++;this._resourceStatesMap.set(ue,H);const me=H.resourceUri,J=h(H.decorations),z=H.decorations&&h(H.decorations.light)||J,Z=H.decorations&&h(H.decorations.dark)||J,M=[];let q;if(H.command)if(H.command.command==="vscode.open"||H.command.command==="vscode.diff"){const he=new E.DisposableStore;q=this._commands.converter.toInternal(H.command,he),this._resourceStatesDisposablesMap.set(ue,he)}else this._resourceStatesCommandsMap.set(ue,H.command);z&&M.push(z),Z&&Z.toString()!==(z==null?void 0:z.toString())&&M.push(Z);const N=H.decorations&&H.decorations.tooltip||"",W=H.decorations&&!!H.decorations.strikeThrough,O=H.decorations&&!!H.decorations.faded,B=H.contextValue||"";return{rawResource:[ue,me,M,N,W,O,B,q],handle:ue}});return{start:R.start,deleteCount:R.deleteCount,toInsert:L}}),A=P.map(({start:R,deleteCount:L,toInsert:H})=>[R,L,H.map(ue=>ue.rawResource)]),a=P.reverse();for(const{start:R,deleteCount:L,toInsert:H}of a){const ue=H.map(J=>J.handle),me=this._handlesSnapshot.splice(R,L,...ue);for(const J of me)this._resourceStatesMap.delete(J),this._resourceStatesCommandsMap.delete(J),(u=this._resourceStatesDisposablesMap.get(J))===null||u===void 0||u.dispose(),this._resourceStatesDisposablesMap.delete(J)}return this._resourceSnapshot=w,A}dispose(){this._disposed=!0,this._onDidDispose.fire()}}t._handlePool=0;class r{constructor(u,w,v,P,A,a){this._proxy=w,this._commands=v,this._id=P,this._label=A,this._rootUri=a,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new E.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new E.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new T.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=r._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new m(u,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,P,A,a)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(u){this._count!==u&&(this._count=u,this._proxy.$updateSourceControl(this.handle,{count:u}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(u){this._quickDiffProvider=u,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!u})}get commitTemplate(){return this._commitTemplate}set commitTemplate(u){u!==this._commitTemplate&&(this._commitTemplate=u,this._proxy.$updateSourceControl(this.handle,{commitTemplate:u}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(u){this._acceptInputDisposables.value=new E.DisposableStore,this._acceptInputCommand=u;const w=this._commands.converter.toInternal(u,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:w})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(u){if(this._statusBarCommands&&u&&f(this._statusBarCommands,u))return;this._statusBarDisposables.value=new E.DisposableStore,this._statusBarCommands=u;const w=(u||[]).map(v=>this._commands.converter.toInternal(v,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:w})}get selected(){return this._selected}createResourceGroup(u,w){const v=new t(this._proxy,this._commands,this.handle,u,w),P=T.Event.once(v.onDidDispose)(()=>this.createdResourceGroups.delete(v));return this.createdResourceGroups.set(v,P),this.eventuallyAddResourceGroups(),v}eventuallyAddResourceGroups(){const u=[],w=[];for(const[v,P]of this.createdResourceGroups){P.dispose();const A=v.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(v),this.eventuallyUpdateResourceStates()});T.Event.once(v.onDidDispose)(()=>{this.updatedResourceGroups.delete(v),A.dispose(),this._groups.delete(v.handle),this._proxy.$unregisterGroup(this.handle,v.handle)}),u.push([v.handle,v.id,v.label,v.features]);const a=v._takeResourceStateSnapshot();a.length>0&&w.push([v.handle,a]),this._groups.set(v.handle,v)}this._proxy.$registerGroups(this.handle,u,w),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const u=[];this.updatedResourceGroups.forEach(w=>{const v=w._takeResourceStateSnapshot();v.length!==0&&u.push([w.handle,v])}),u.length>0&&this._proxy.$spliceResourceStates(this.handle,u),this.updatedResourceGroups.clear()}getResourceGroup(u){return this._groups.get(u)}setSelectionState(u){this._selected=u,this._onDidChangeSelection.fire(u)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(u=>u.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}r._handlePool=0,Ve([S.debounce(100)],r.prototype,"eventuallyAddResourceGroups",null),Ve([S.debounce(100)],r.prototype,"eventuallyUpdateResourceStates",null);let s=class Un{constructor(u,w,v){this._commands=w,this.logService=v,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new T.Emitter,this._proxy=u.getProxy(D.MainContext.MainThreadSCM),this._telemetry=u.getProxy(D.MainContext.MainThreadTelemetry),w.registerArgumentProcessor({processArgument:P=>{if(P&&P.$mid===3){const A=this._sourceControls.get(P.sourceControlHandle);if(!A)return P;const a=A.getResourceGroup(P.groupHandle);return a?a.getResourceState(P.handle):P}else if(P&&P.$mid===4){const A=this._sourceControls.get(P.sourceControlHandle);return A?A.getResourceGroup(P.groupHandle):P}else if(P&&P.$mid===5){const A=this._sourceControls.get(P.handle);return A||P}return P}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(u,w,v,P){this.logService.trace("ExtHostSCM#createSourceControl",u.identifier.value,w,v,P),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:u.identifier.value});const A=Un._handlePool++,a=new r(u,this._proxy,this._commands,w,v,P);this._sourceControls.set(A,a);const R=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier))||[];return R.push(a),this._sourceControlsByExtension.set(I.ExtensionIdentifier.toKey(u.identifier),R),a}getLastInputBox(u){this.logService.trace("ExtHostSCM#getLastInputBox",u.identifier.value);const w=this._sourceControlsByExtension.get(I.ExtensionIdentifier.toKey(u.identifier)),v=w&&w[w.length-1];return v&&v.inputBox}$provideOriginalResource(u,w,v){const P=g.URI.revive(w);this.logService.trace("ExtHostSCM#$provideOriginalResource",u,P.toString());const A=this._sourceControls.get(u);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):k.asPromise(()=>A.quickDiffProvider.provideOriginalResource(P,v)).then(a=>a||null)}$onInputBoxValueChange(u,w){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",u);const v=this._sourceControls.get(u);return v&&v.inputBox.$onInputBoxValueChange(w),Promise.resolve(void 0)}$executeResourceCommand(u,w,v,P){this.logService.trace("ExtHostSCM#$executeResourceCommand",u,w,v);const A=this._sourceControls.get(u);if(!A)return Promise.resolve(void 0);const a=A.getResourceGroup(w);return a?a.$executeResourceCommand(v,P):Promise.resolve(void 0)}$validateInput(u,w,v){this.logService.trace("ExtHostSCM#$validateInput",u);const P=this._sourceControls.get(u);return!P||!P.inputBox.validateInput?Promise.resolve(void 0):k.asPromise(()=>P.inputBox.validateInput(w,v)).then(A=>A?Promise.resolve([A.message,A.type]):Promise.resolve(void 0))}$setSelectedSourceControl(u){var w,v;return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",u),u!==void 0&&((w=this._sourceControls.get(u))===null||w===void 0||w.setSelectionState(!0)),this._selectedSourceControlHandle!==void 0&&((v=this._sourceControls.get(this._selectedSourceControlHandle))===null||v===void 0||v.setSelectionState(!1)),this._selectedSourceControlHandle=u,Promise.resolve(void 0)}};s._handlePool=0,s=Ve([ze(2,n.ILogService)],s),e.ExtHostSCM=s});var it=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[198],_e([0,1,6,5,131,7,9]),function(ee,e,g,T,S,E,k){"use strict";var D,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class C{constructor(h,c,d,y,b=g.StatusBarAlignment.Left,p){D.set(this,void 0),_.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new E.DisposableStore,it(this,D,h,"f"),it(this,_,c,"f"),this._entryId=C.ID_GEN++,this._extension=d,this._id=y,this._alignment=b,this._priority=p}get id(){var h;return(h=this._id)!==null&&h!==void 0?h:this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get tooltip2(){return this._tooltip2}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){var h;return(h=this._command)===null||h===void 0?void 0:h.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(h){this._text=h,this.update()}set name(h){this._name=h,this.update()}set tooltip(h){this._tooltip=h,this.update()}set tooltip2(h){this._tooltip2=h,this.update()}set color(h){this._color=h,this.update()}set backgroundColor(h){h&&!C.ALLOWED_BACKGROUND_COLORS.has(h.id)&&(h=void 0),this._backgroundColor=h,this.update()}set command(h){var c;((c=this._command)===null||c===void 0?void 0:c.fromApi)!==h&&(this._internalCommandRegistration.clear(),typeof h=="string"?this._command={fromApi:h,internal:Be(this,_,"f").toInternal({title:"",command:h},this._internalCommandRegistration)}:h?this._command={fromApi:h,internal:Be(this,_,"f").toInternal(h,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(h){this._accessibilityInformation=h,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Be(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var h;this._timeoutHandle=void 0;let c;this._extension?this._id?c=`${this._extension.identifier.value}.${this._id}`:c=this._extension.identifier.value:c=this._id;let d;this._name?d=this._name:d=S.localize(0,null,this._extension.displayName||this._extension.name);let y=this._color;this._backgroundColor&&(y=C.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const b=this._tooltip2!==void 0?k.MarkdownString.fromStrict(this._tooltip2):this.tooltip;Be(this,D,"f").$setEntry(this._entryId,c,d,this._text,b,(h=this._command)===null||h===void 0?void 0:h.internal,y,this._backgroundColor,this._alignment===g.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=C,D=new WeakMap,_=new WeakMap,C.ID_GEN=0,C.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new g.ThemeColor("statusBarItem.errorForeground")]]);class n{constructor(h){this._messages=[],this._item=h.createStatusBarEntry(void 0,"status.extensionMessage",g.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=S.localize(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(h){const c={message:h};return this._messages.unshift(c),this._update(),new g.Disposable(()=>{const d=this._messages.indexOf(c);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class I{constructor(h,c){this._proxy=h.getProxy(T.MainContext.MainThreadStatusBar),this._commands=c,this._statusMessage=new n(this)}createStatusBarEntry(h,c,d,y){return new C(this._proxy,this._commands,h,c,d,y)}setStatusBarMessage(h,c){const d=this._statusMessage.setMessage(h);let y;return typeof c=="number"?y=setTimeout(()=>d.dispose(),c):typeof c!="undefined"&&c.then(()=>d.dispose(),()=>d.dispose()),new g.Disposable(()=>{d.dispose(),clearTimeout(y)})}}e.ExtHostStatusBar=I}),define(we[73],_e([0,1,5,3,4]),function(ee,e,g,T,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class E{constructor(D){this._onDidChangeStorage=new T.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=D.getProxy(g.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(D,_){this._proxy.$registerExtensionStorageKeysToSync(D,_)}getValue(D,_,C){return this._proxy.$getValue(D,_).then(n=>n||C)}setValue(D,_,C){return this._proxy.$setValue(D,_,C)}$acceptValue(D,_,C){this._onDidChangeStorage.fire({shared:D,key:_,value:C})}}e.ExtHostStorage=E,e.IExtHostStorage=S.createDecorator("IExtHostStorage")}),define(we[74],_e([0,1,4,28,15,72,2]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=g.createDecorator("IExtensionStoragePaths");let D=class{constructor(C,n,I){var o;this._logService=n,this._extHostFileSystem=I,this._workspace=(o=C.workspace)!==null&&o!==void 0?o:void 0,this._environment=C.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(h=>this._value=h)}async _getOrCreateWorkspaceStoragePath(){var C;if(!this._workspace)return Promise.resolve(void 0);const n=this._workspace.id,I=k.URI.joinPath(this._environment.workspaceStorageHome,n);try{return await this._extHostFileSystem.value.stat(I),this._logService.trace("[ExtHostStorage] storage dir already exists",I),I}catch(o){}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",I),await this._extHostFileSystem.value.createDirectory(I),await this._extHostFileSystem.value.writeFile(k.URI.joinPath(I,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:(C=k.URI.revive(this._workspace.configuration))===null||C===void 0?void 0:C.toString(),name:this._workspace.name},void 0,2))),I}catch(o){this._logService.error("[ExtHostStorage]",o);return}}workspaceValue(C){if(this._value)return k.URI.joinPath(this._value,C.identifier.value)}globalValue(C){return k.URI.joinPath(this._environment.globalStorageHome,C.identifier.value.toLowerCase())}};D=Ve([ze(0,T.IExtHostInitDataService),ze(1,S.ILogService),ze(2,E.IExtHostConsumerFileSystem)],D),e.ExtensionStoragePaths=D}),define(we[37],_e([0,1,3,5,4,2,13,7,6,132,11,163,18,34,152,10]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=S.createDecorator("IExtHostTerminalService");class y{constructor(s,i,u,w){this._proxy=s,this._id=i,this._creationOptions=u,this._name=w,this._disposed=!1,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const v=this;this.value={get name(){return v._name||""},get processId(){return v._pidPromise},get creationOptions(){return v._creationOptions},get exitStatus(){return v._exitStatus},sendText(P,A=!0){v._checkDisposed(),v._proxy.$sendText(v._id,P,A)},show(P){v._checkDisposed(),v._proxy.$show(v._id,P)},hide(){v._checkDisposed(),v._proxy.$hide(v._id)},dispose(){v._disposed||(v._disposed=!0,v._proxy.$dispose(v._id))},get dimensions(){if(!(v._cols===void 0||v._rows===void 0))return{columns:v._cols,rows:v._rows}}}}async create(s,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:s.name,shellPath:d.withNullAsUndefined(s.shellPath),shellArgs:d.withNullAsUndefined(s.shellArgs),cwd:d.withNullAsUndefined(s.cwd),env:d.withNullAsUndefined(s.env),icon:d.withNullAsUndefined(t(s.iconPath)),initialText:d.withNullAsUndefined(s.message),strictEnv:d.withNullAsUndefined(s.strictEnv),hideFromUser:d.withNullAsUndefined(s.hideFromUser),isFeatureTerminal:d.withNullAsUndefined(i==null?void 0:i.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:d.withNullAsUndefined(i==null?void 0:i.useShellEnvironment),isSplitTerminal:d.withNullAsUndefined(i==null?void 0:i.isSplitTerminal)})}async createExtensionTerminal(s,i){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:i,isSplitTerminal:s}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(s){this._name=s}setExitCode(s){this._exitStatus=Object.freeze({code:s})}setDimensions(s,i){return s===this._cols&&i===this._rows||s===0||i===0?!1:(this._cols=s,this._rows=i,!0)}_setProcessId(s){this._pidPromiseComplete?(this._pidPromiseComplete(s),this._pidPromiseComplete=void 0):this._pidPromise.then(i=>{i!==s&&(this._pidPromise=Promise.resolve(s))})}}e.ExtHostTerminal=y;class b{constructor(s){this._pty=s,this.id=0,this.shouldPersist=!1,this._onProcessData=new g.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new g.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new g.Emitter,this._onProcessTitleChanged=new g.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new g.Emitter,this._onProcessShellTypeChanged=new g.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(s){this._pty.handleInput&&this._pty.handleInput(s)}resize(s,i){this._pty.setDimensions&&this._pty.setDimensions({columns:s,rows:i})}async processBinary(s){}acknowledgeDataEvent(s){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(s){this._pty.onDidWrite(i=>this._onProcessData.fire(i)),this._pty.onDidClose&&this._pty.onDidClose((i=void 0)=>{this._onProcessExit.fire(i===void 0?void 0:i)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i&&{cols:i.columns,rows:i.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(i=>this._onProcessTitleChanged.fire(i)),this._pty.open(s||void 0),this._pty.setDimensions&&s&&this._pty.setDimensions(s),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let p=1,l=class extends D.Disposable{constructor(s,i){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new g.Emitter,this._onDidOpenTerminal=new g.Emitter,this._onDidChangeActiveTerminal=new g.Emitter,this._onDidChangeTerminalDimensions=new g.Emitter,this._proxy=i.getProxy(T.MainContext.MainThreadTerminalService),this._bufferer=new c.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new g.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(s),this._register({dispose:()=>{for(const[u,w]of this._terminalProcesses)w.shutdown(!0)}})}get activeTerminal(){var s;return(s=this._activeTerminal)===null||s===void 0?void 0:s.value}get terminals(){return this._terminals.map(s=>s.value)}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}getDefaultShell(s){const i=s?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.path)||""}getDefaultShellArgs(s){const i=s?this._defaultAutomationProfile:this._defaultProfile;return(i==null?void 0:i.args)||[]}createExtensionTerminal(s,i){const u=new y(this._proxy,h.generateUuid(),s,s.name),w=new b(s.pty);return u.createExtensionTerminal(i==null?void 0:i.isSplitTerminal,t(s.iconPath)).then(v=>{const P=this._setupExtHostProcessListeners(v,w);this._terminalProcessDisposables[v]=P}),this._terminals.push(u),u.value}attachPtyToTerminal(s,i){if(!this._getTerminalById(s))throw new Error(`Cannot resolve terminal with id ${s} for virtual process`);const w=new b(i),v=this._setupExtHostProcessListeners(s,w);this._terminalProcessDisposables[s]=v}async $acceptActiveTerminalChanged(s){const i=this._activeTerminal;if(s===null){this._activeTerminal=void 0,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const u=this._getTerminalById(s);u&&(this._activeTerminal=u,i!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(s,i){const u=this._getTerminalById(s);u&&this._onDidWriteTerminalData.fire({terminal:u.value,data:i})}async $acceptTerminalDimensions(s,i,u){const w=this._getTerminalById(s);w&&w.setDimensions(i,u)&&this._onDidChangeTerminalDimensions.fire({terminal:w.value,dimensions:w.value.dimensions})}async $acceptTerminalMaximumDimensions(s,i,u){var w;(w=this._terminalProcesses.get(s))===null||w===void 0||w.resize(i,u)}async $acceptTerminalTitleChange(s,i){const u=this._getTerminalById(s);u&&(u.name=i)}async $acceptTerminalClosed(s,i){const u=this._getTerminalObjectIndexById(this._terminals,s);if(u!==null){const w=this._terminals.splice(u,1)[0];w.setExitCode(i),this._onDidCloseTerminal.fire(w.value)}}$acceptTerminalOpened(s,i,u,w){if(i){const A=this._getTerminalObjectIndexById(this._terminals,i);if(A!==null){this._terminals[A]._id=s,this._onDidOpenTerminal.fire(this.terminals[A]),this._terminals[A].isOpen=!0;return}}const v={name:w.name,shellPath:w.executable,shellArgs:w.args,cwd:typeof w.cwd=="string"?w.cwd:E.URI.revive(w.cwd),env:w.env,hideFromUser:w.hideFromUser},P=new y(this._proxy,s,v,u);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(s,i){const u=this._getTerminalById(s);u&&u._setProcessId(i)}async $startExtensionTerminal(s,i){const u=this._getTerminalById(s);if(!u)return{message:C.localize(0,null,s)};u.isOpen||await new Promise(v=>{const P=this.onDidOpenTerminal(async A=>{A===u.value&&(P.dispose(),v())})});const w=this._terminalProcesses.get(s);w?w.startSendingEvents(i):this._extensionTerminalAwaitingStart[s]={initialDimensions:i}}_setupExtHostProcessListeners(s,i){const u=new D.DisposableStore;u.add(i.onProcessReady(v=>this._proxy.$sendProcessReady(s,v.pid,v.cwd))),u.add(i.onProcessTitleChanged(v=>this._proxy.$sendProcessTitle(s,v))),this._bufferer.startBuffering(s,i.onProcessData),u.add(i.onProcessExit(v=>this._onProcessExit(s,v))),i.onProcessOverrideDimensions&&u.add(i.onProcessOverrideDimensions(v=>this._proxy.$sendOverrideDimensions(s,v))),this._terminalProcesses.set(s,i);const w=this._extensionTerminalAwaitingStart[s];return w&&i instanceof b&&(i.startSendingEvents(w.initialDimensions),delete this._extensionTerminalAwaitingStart[s]),u}$acceptProcessAckDataEvent(s,i){var u;(u=this._terminalProcesses.get(s))===null||u===void 0||u.acknowledgeDataEvent(i)}$acceptProcessInput(s,i){var u;(u=this._terminalProcesses.get(s))===null||u===void 0||u.input(i)}$acceptProcessResize(s,i,u){var w;try{(w=this._terminalProcesses.get(s))===null||w===void 0||w.resize(i,u)}catch(v){if(v.code!=="EPIPE"&&v.code!=="ERR_IPC_CHANNEL_CLOSED")throw v}}$acceptProcessShutdown(s,i){var u;(u=this._terminalProcesses.get(s))===null||u===void 0||u.shutdown(i)}$acceptProcessRequestInitialCwd(s){var i;(i=this._terminalProcesses.get(s))===null||i===void 0||i.getInitialCwd().then(u=>this._proxy.$sendProcessInitialCwd(s,u))}$acceptProcessRequestCwd(s){var i;(i=this._terminalProcesses.get(s))===null||i===void 0||i.getCwd().then(u=>this._proxy.$sendProcessCwd(s,u))}$acceptProcessRequestLatency(s){return s}registerLinkProvider(s){return this._linkProviders.add(s),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new _.Disposable(()=>{this._linkProviders.delete(s),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(s,i,u){if(this._profileProviders.has(i))throw new Error(`Terminal profile provider "${i}" already registered`);return this._profileProviders.set(i,u),this._proxy.$registerProfileProvider(i,s.identifier.value),new _.Disposable(()=>{this._profileProviders.delete(i),this._proxy.$unregisterProfileProvider(i)})}async $createContributedProfileTerminal(s,i){var u;const w=new o.CancellationTokenSource().token,v=await((u=this._profileProviders.get(s))===null||u===void 0?void 0:u.provideTerminalProfile(w));if(!w.isCancellationRequested){if(!v||!("options"in v))throw new Error(`No terminal profile options provided for id "${s}"`);if("pty"in v.options){this.createExtensionTerminal(v.options,{isSplitTerminal:i});return}this.createTerminalFromOptions(v.options,{isSplitTerminal:i})}}async $provideLinks(s,i){const u=this._getTerminalById(s);if(!u)return[];this._terminalLinkCache.delete(s);const w=this._terminalLinkCancellationSource.get(s);w&&w.dispose(!0);const v=new o.CancellationTokenSource;this._terminalLinkCancellationSource.set(s,v);const P=[],A={terminal:u.value,line:i},a=[];for(const H of this._linkProviders)a.push(new Promise(async ue=>{v.token.onCancellationRequested(()=>ue({provider:H,links:[]}));const me=await H.provideTerminalLinks(A,v.token)||[];v.token.isCancellationRequested||ue({provider:H,links:me})}));const R=await Promise.all(a);if(v.token.isCancellationRequested)return[];const L=new Map;for(const H of R)H&&H.links.length>0&&P.push(...H.links.map(ue=>{const me={id:p++,startIndex:ue.startIndex,length:ue.length,label:ue.tooltip};return L.set(me.id,{provider:H.provider,link:ue}),me}));return this._terminalLinkCache.set(s,L),P}$activateLink(s,i){var u;const w=(u=this._terminalLinkCache.get(s))===null||u===void 0?void 0:u.get(i);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(s,i){this._bufferer.stopBuffering(s),this._terminalProcesses.delete(s),delete this._extensionTerminalAwaitingStart[s];const u=this._terminalProcessDisposables[s];u&&(u.dispose(),delete this._terminalProcessDisposables[s]),this._proxy.$sendProcessExit(s,i)}_getTerminalById(s){return this._getTerminalObjectById(this._terminals,s)}_getTerminalObjectById(s,i){const u=this._getTerminalObjectIndexById(s,i);return u!==null?s[u]:null}_getTerminalObjectIndexById(s,i){let u=null;return s.some((w,v)=>w._id===i?(u=v,!0):!1),u}getEnvironmentVariableCollection(s){let i=this._environmentVariableCollections.get(s.identifier.value);return i||(i=new f,this._setEnvironmentVariableCollection(s.identifier.value,i)),i}_syncEnvironmentVariableCollection(s,i){const u=I.serializeEnvironmentVariableCollection(i.map);this._proxy.$setEnvironmentVariableCollection(s,i.persistent,u.length===0?void 0:u)}$initEnvironmentVariableCollections(s){s.forEach(i=>{const u=i[0],w=new f(i[1]);this._setEnvironmentVariableCollection(u,w)})}$acceptDefaultProfile(s,i){this._defaultProfile=s,this._defaultAutomationProfile=i}_setEnvironmentVariableCollection(s,i){this._environmentVariableCollections.set(s,i),i.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(s,i)})}};l=Ve([ze(1,k.IExtHostRpcService)],l),e.BaseExtHostTerminalService=l;class f{constructor(s){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new g.Emitter,this.map=new Map(s)}get persistent(){return this._persistent}set persistent(s){this._persistent=s,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(s,i){this._setIfDiffers(s,{value:i,type:_.EnvironmentVariableMutatorType.Replace})}append(s,i){this._setIfDiffers(s,{value:i,type:_.EnvironmentVariableMutatorType.Append})}prepend(s,i){this._setIfDiffers(s,{value:i,type:_.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(s,i){const u=this.map.get(s);(!u||u.value!==i.value||u.type!==i.type)&&(this.map.set(s,i),this._onDidChangeCollection.fire())}get(s){return this.map.get(s)}forEach(s,i){this.map.forEach((u,w)=>s.call(i,w,u,this))}delete(s){this.map.delete(s),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=f;let m=class extends l{constructor(s){super(!1,s)}createTerminal(s,i,u){throw new n.NotSupportedError}createTerminalFromOptions(s,i){throw new n.NotSupportedError}};m=Ve([ze(0,k.IExtHostRpcService)],m),e.WorkerExtHostTerminalService=m;function t(r){if(!!r)return"id"in r?{id:r.id,color:r.color}:r}}),define(we[199],_e([0,1,3,17,5,98,9,6]),function(ee,e,g,T,S,E,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class _{constructor(n,I){this._extHostDocumentsAndEditors=I,this._onDidChangeTextEditorSelection=new g.Emitter,this._onDidChangeTextEditorOptions=new g.Emitter,this._onDidChangeTextEditorVisibleRanges=new g.Emitter,this._onDidChangeTextEditorViewColumn=new g.Emitter,this._onDidChangeActiveTextEditor=new g.Emitter,this._onDidChangeVisibleTextEditors=new g.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=n.getProxy(S.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(o=>this._onDidChangeVisibleTextEditors.fire(o)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(o=>this._onDidChangeActiveTextEditor.fire(o))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(n){const I=this._extHostDocumentsAndEditors.allEditors();return n?I:I.map(o=>o.value)}async showTextDocument(n,I,o){let h;typeof I=="number"?h={position:k.ViewColumn.from(I),preserveFocus:o}:typeof I=="object"?h={position:k.ViewColumn.from(I.viewColumn),preserveFocus:I.preserveFocus,selection:typeof I.selection=="object"?k.Range.from(I.selection):void 0,pinned:typeof I.preview=="boolean"?!I.preview:void 0}:h={preserveFocus:!1};const c=await this._proxy.$tryShowTextDocument(n.uri,h),d=c&&this._extHostDocumentsAndEditors.getEditor(c);if(d)return d.value;throw c?new Error(`Could NOT open editor for "${n.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${n.uri.toString()}".`)}createTextEditorDecorationType(n,I){return new E.TextEditorDecorationType(this._proxy,n,I).value}$acceptEditorPropertiesChanged(n,I){const o=this._extHostDocumentsAndEditors.getEditor(n);if(!o)throw new Error("unknown text editor");if(I.options&&o._acceptOptions(I.options),I.selections){const h=I.selections.selections.map(k.Selection.to);o._acceptSelections(h)}if(I.visibleRanges){const h=T.coalesce(I.visibleRanges.map(k.Range.to));o._acceptVisibleRanges(h)}if(I.options&&this._onDidChangeTextEditorOptions.fire({textEditor:o.value,options:Object.assign(Object.assign({},I.options),{lineNumbers:k.TextEditorLineNumbersStyle.to(I.options.lineNumbers)})}),I.selections){const h=D.TextEditorSelectionChangeKind.fromValue(I.selections.source),c=I.selections.selections.map(k.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:o.value,selections:c,kind:h})}if(I.visibleRanges){const h=T.coalesce(I.visibleRanges.map(k.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:o.value,visibleRanges:h})}}$acceptEditorPositionData(n){for(const I in n){const o=this._extHostDocumentsAndEditors.getEditor(I);if(!o)throw new Error("Unknown text editor");const h=k.ViewColumn.to(n[I]);o.value.viewColumn!==h&&(o._acceptViewColumn(h),this._onDidChangeTextEditorViewColumn.fire({textEditor:o.value,viewColumn:h}))}}getDiffInformation(n){return Promise.resolve(this._proxy.$getDiffInformation(n))}}e.ExtHostEditors=_});var Dn=this&&this.__rest||function(ee,e){var g={};for(var T in ee)Object.prototype.hasOwnProperty.call(ee,T)&&e.indexOf(T)<0&&(g[T]=ee[T]);if(ee!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,T=Object.getOwnPropertySymbols(ee);S<T.length;S++)e.indexOf(T[S])<0&&Object.prototype.propertyIsEnumerable.call(ee,T[S])&&(g[T[S]]=ee[T[S]]);return g};define(we[200],_e([0,1,2,4,5,7,6]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=T.createDecorator("IExtHostTimeline");class D{constructor(n,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=n.getProxy(S.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:o=>{var h,c;if(o&&o.$mid===11){const d=o.uri===void 0?void 0:g.URI.revive(o.uri);return(c=(h=this._itemsBySourceAndUriMap.get(o.source))===null||h===void 0?void 0:h.get(_(d)))===null||c===void 0?void 0:c.get(o.handle)}return o}})}async $getTimeline(n,I,o,h,c){const d=this._providers.get(n);return d==null?void 0:d.provideTimeline(g.URI.revive(I),o,h,c)}registerTimelineProvider(n,I,o,h){const c=new E.DisposableStore,d=this.convertTimelineItem(I.id,h,c).bind(this);let y;I.onDidChange&&(y=I.onDidChange(p=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},p),{id:I.id})),this));const b=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},I),{scheme:n,onDidChange:void 0,async provideTimeline(p,l,f,m){var t;(m==null?void 0:m.resetCache)&&(c.clear(),(t=b.get(I.id))===null||t===void 0||t.clear());const r=await I.provideTimeline(p,l,f);if(r==null)return;const s=d(p,m);return Object.assign(Object.assign({},r),{source:I.id,items:r.items.map(s)})},dispose(){var p;for(const l of b.values())(p=l.get(I.id))===null||p===void 0||p.clear();y==null||y.dispose(),c.dispose()}}))}convertTimelineItem(n,I,o){return(h,c)=>{let d;if(c==null?void 0:c.cacheResults){let y=this._itemsBySourceAndUriMap.get(n);y===void 0&&(y=new Map,this._itemsBySourceAndUriMap.set(n,y));const b=_(h);d=y.get(b),d===void 0&&(d=new Map,y.set(b,d))}return y=>{var b,p;const{iconPath:l}=y,f=Dn(y,["iconPath"]),m=`${n}|${(b=y.id)!==null&&b!==void 0?b:y.timestamp}`;d==null||d.set(m,y);let t,r,s;return y.iconPath&&(l instanceof k.ThemeIcon?s={id:l.id}:g.URI.isUri(l)?(t=l,r=l):{light:t,dark:r}=l),Object.assign(Object.assign({},f),{id:(p=f.id)!==null&&p!==void 0?p:void 0,handle:m,source:n,command:y.command?I.toInternal(y.command,o):void 0,icon:t,iconDark:r,themeIcon:s,accessibilityInformation:y.accessibilityInformation})}}}registerTimelineProviderCore(n){if(this._providers.get(n.id))throw new Error(`Timeline Provider ${n.id} already exists.`);return this._proxy.$registerTimelineProvider({id:n.id,label:n.label,scheme:n.scheme}),this._providers.set(n.id,n),E.toDisposable(()=>{var o;for(const h of this._itemsBySourceAndUriMap.values())(o=h.get(n.id))===null||o===void 0||o.clear();this._providers.delete(n.id),this._proxy.$unregisterTimelineProvider(n.id),n.dispose()})}}e.ExtHostTimeline=D;function _(C){return C==null?void 0:C.toString()}}),define(we[201],_e([0,1,7,16,2,5]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class k{constructor(_){this._openers=new Map,this._proxy=_.getProxy(E.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(_,C,n,I){if(this._openers.has(C))throw new Error(`Opener with id '${C}' already registered`);const o=I.schemes.find(h=>!k.supportedSchemes.has(h));if(o)throw new Error(`Scheme '${o}' is not supported. Only http and https are currently supported.`);return this._openers.set(C,n),this._proxy.$registerUriOpener(C,I.schemes,_,I.label),g.toDisposable(()=>{this._openers.delete(C),this._proxy.$unregisterUriOpener(C)})}async $canOpenUri(_,C,n){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener with id: ${_}`);const o=S.URI.revive(C);return I.canOpenExternalUri(o,n)}async $openUri(_,C,n){const I=this._openers.get(_);if(!I)throw new Error(`Unknown opener id: '${_}'`);return I.openExternalUri(S.URI.revive(C.resolvedUri),{sourceUri:S.URI.revive(C.sourceUri)},n)}}e.ExtHostUriOpeners=k,k.supportedSchemes=new Set([T.Schemas.http,T.Schemas.https])}),define(we[202],_e([0,1,5,2,7,11,26]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class D{constructor(C){this.handles=new Set,this.handlers=new Map,this._proxy=C.getProxy(g.MainContext.MainThreadUrls)}registerUriHandler(C,n){if(this.handles.has(k.ExtensionIdentifier.toKey(C)))throw new Error(`Protocol handler already registered for extension ${C}`);const I=D.HandlePool++;return this.handles.add(k.ExtensionIdentifier.toKey(C)),this.handlers.set(I,n),this._proxy.$registerUriHandler(I,C),S.toDisposable(()=>{this.handles.delete(k.ExtensionIdentifier.toKey(C)),this.handlers.delete(I),this._proxy.$unregisterUriHandler(I)})}$handleExternalUri(C,n){const I=this.handlers.get(C);if(!I)return Promise.resolve(void 0);try{I.handleUri(T.URI.revive(n))}catch(o){E.onUnexpectedError(o)}return Promise.resolve(void 0)}async createAppUri(C){return T.URI.revive(await this._proxy.$createAppUri(C))}}e.ExtHostUrls=D,D.HandlePool=0});var it=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[47],_e([0,1,3,2,140,158,67,5]),function(ee,e,g,T,S,E,k,D){"use strict";var _,C,n,I,o,h,c,d,y,b,p,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class f{constructor(v,P,A,a,R,L,H){_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),I.set(this,void 0),o.set(this,void 0),h.set(this,void 0),c.set(this,""),d.set(this,void 0),y.set(this,!1),b.set(this,!1),p.set(this,!1),this._onMessageEmitter=new g.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new g.Emitter),this._onDidDispose=Be(this,l,"f").event,it(this,_,v,"f"),it(this,C,P,"f"),it(this,d,A,"f"),it(this,I,a,"f"),it(this,o,R,"f"),it(this,h,L,"f"),it(this,p,m(L),"f"),it(this,n,H,"f")}dispose(){it(this,y,!0,"f"),Be(this,l,"f").fire(),Be(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(v){return it(this,b,!0,"f"),k.asWebviewUri(v,Be(this,I,"f").remote)}get cspSource(){return k.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Be(this,c,"f")}set html(v){this.assertNotDisposed(),Be(this,c,"f")!==v&&(it(this,c,v,"f"),!Be(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(v)&&(it(this,b,!0,"f"),Be(this,n,"f").report("Webview vscode-resource: uris",Be(this,h,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,C,"f").$setHtml(Be(this,_,"f"),v))}get options(){return this.assertNotDisposed(),Be(this,d,"f")}set options(v){this.assertNotDisposed(),Be(this,C,"f").$setOptions(Be(this,_,"f"),s(Be(this,h,"f"),Be(this,o,"f"),v)),it(this,d,v,"f")}async postMessage(v){if(Be(this,y,"f"))return!1;const P=E.serializeWebviewMessage(v,{serializeBuffersForPostMessage:Be(this,p,"f")});return Be(this,C,"f").$postMessage(Be(this,_,"f"),P.message,...P.buffers)}assertNotDisposed(){if(Be(this,y,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=f,_=new WeakMap,C=new WeakMap,n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,c=new WeakMap,d=new WeakMap,y=new WeakMap,b=new WeakMap,p=new WeakMap,l=new WeakMap;function m(w){try{const v=S.normalizeVersion(S.parseVersion(w.engines.vscode));return!!v&&v.majorBase>=1&&v.minorBase>=57}catch(v){return!1}}e.shouldSerializeBuffersForPostMessage=m;class t{constructor(v,P,A,a,R){this.initData=P,this.workspace=A,this._logService=a,this._deprecationService=R,this._webviews=new Map,this._webviewProxy=v.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(v,P,...A){const a=this.getWebview(v);if(a){const{message:R}=E.deserializeWebviewMessage(P,A);a._onMessageEmitter.fire(R)}}$onMissingCsp(v,P){this._logService.warn(`${P} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(v,P,A){const a=new f(v,this._webviewProxy,i(P),this.initData,this.workspace,A,this._deprecationService);return this._webviews.set(v,a),a._onDidDispose(()=>{this._webviews.delete(v)}),a}deleteWebview(v){this._webviews.delete(v)}getWebview(v){return this._webviews.get(v)}}e.ExtHostWebviews=t;function r(w){return{id:w.identifier,location:w.extensionLocation}}e.toExtensionData=r;function s(w,v,P){return{enableCommandUris:P.enableCommandUris,enableScripts:P.enableScripts,portMapping:P.portMapping,localResourceRoots:P.localResourceRoots||u(w,v)}}e.serializeWebviewOptions=s;function i(w){var v;return{enableCommandUris:w.enableCommandUris,enableScripts:w.enableScripts,portMapping:w.portMapping,localResourceRoots:(v=w.localResourceRoots)===null||v===void 0?void 0:v.map(P=>T.URI.from(P))}}e.reviveOptions=i;function u(w,v){return[...((v==null?void 0:v.getWorkspaceFolders())||[]).map(P=>P.uri),w.extensionLocation]}}),define(we[203],_e([0,1,18,53,7,16,25,2,9,47,62,5,6]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class h{constructor(t,r){this.document=t,this._storagePath=r,this._backupCounter=1,this._edits=new n.Cache("custom documents")}addEdit(t){return this._edits.add([t])}async undo(t,r){await this.getEdit(t).undo(),r||this.disposeBackup()}async redo(t,r){await this.getEdit(t).redo(),r||this.disposeBackup()}disposeEdits(t){for(const r of t)this._edits.delete(r)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const t=f(this.document.uri)+this._backupCounter++;return k.joinPath(this._storagePath,t)}updateBackup(t){var r;(r=this._backup)===null||r===void 0||r.delete(),this._backup=t}disposeBackup(){var t;(t=this._backup)===null||t===void 0||t.delete(),this._backup=void 0}getEdit(t){const r=this._edits.get(t,0);if(!r)throw new Error("No edit found");return r}}class c{constructor(){this._documents=new Map}get(t,r){return this._documents.get(this.key(t,r))}add(t,r,s){const i=this.key(t,r.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${t} resource:${r.uri}`);const u=new h(r,s);return this._documents.set(i,u),u}delete(t,r){const s=this.key(t,r.uri);this._documents.delete(s)}key(t,r){return`${t}@@@${r}`}}var d;(function(m){m[m.Text=0]="Text",m[m.Custom=1]="Custom"})(d||(d={}));class y{constructor(){this._providers=new Map}addTextProvider(t,r,s){return this.add(0,t,r,s)}addCustomProvider(t,r,s){return this.add(1,t,r,s)}get(t){return this._providers.get(t)}add(t,r,s,i){if(this._providers.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this._providers.set(r,{type:t,extension:s,provider:i}),new o.Disposable(()=>this._providers.delete(r))}}class b{constructor(t,r,s,i,u){this._extHostDocuments=r,this._extensionStoragePaths=s,this._extHostWebview=i,this._extHostWebviewPanels=u,this._editorProviders=new y,this._documents=new c,this._proxy=t.getProxy(I.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(t,r,s,i){const u=new S.DisposableStore;return p(s)?(u.add(this._editorProviders.addTextProvider(r,t,s)),this._proxy.$registerTextEditorProvider(C.toExtensionData(t),r,i.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},C.shouldSerializeBuffersForPostMessage(t))):(u.add(this._editorProviders.addCustomProvider(r,t,s)),this.supportEditing(s)&&u.add(s.onDidChangeCustomDocument(w=>{const v=this.getCustomDocumentEntry(r,w.document.uri);if(l(w)){const P=v.addEdit(w);this._proxy.$onDidEdit(w.document.uri,r,P,w.label)}else this._proxy.$onContentChange(w.document.uri,r)})),this._proxy.$registerCustomEditorProvider(C.toExtensionData(t),r,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,C.shouldSerializeBuffersForPostMessage(t))),o.Disposable.from(u,new o.Disposable(()=>{this._proxy.$unregisterEditorProvider(r)}))}async $createCustomDocument(t,r,s,i,u){var w;const v=this._editorProviders.get(r);if(!v)throw new Error(`No provider found for '${r}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${r}'`);const P=D.URI.revive(t),A=await v.provider.openCustomDocument(P,{backupId:s,untitledDocumentData:i==null?void 0:i.buffer},u);let a;return this.supportEditing(v.provider)&&this._extensionStoragePaths&&(a=(w=this._extensionStoragePaths.workspaceValue(v.extension))!==null&&w!==void 0?w:this._extensionStoragePaths.globalValue(v.extension)),this._documents.add(r,A,a),{editable:this.supportEditing(v.provider)}}async $disposeCustomDocument(t,r){const s=this._editorProviders.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const i=D.URI.revive(t),{document:u}=this.getCustomDocumentEntry(r,i);this._documents.delete(r,u),u.dispose()}async $resolveWebviewEditor(t,r,s,i,u,w){const v=this._editorProviders.get(s);if(!v)throw new Error(`No provider found for '${s}'`);const P=_.ViewColumn.to(u),A=this._extHostWebview.createNewWebview(r,i.webviewOptions,v.extension),a=this._extHostWebviewPanels.createNewWebviewPanel(r,s,i.title,P,i.panelOptions,A),R=D.URI.revive(t);switch(v.type){case 1:{const{document:L}=this.getCustomDocumentEntry(s,R);return v.provider.resolveCustomEditor(L,a,w)}case 0:{const L=this._extHostDocuments.getDocument(R);return v.provider.resolveCustomTextEditor(L,a,w)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(t,r,s){this.getCustomDocumentEntry(r,t).disposeEdits(s)}async $onMoveCustomEditor(t,r,s){const i=this._editorProviders.get(s);if(!i)throw new Error(`No provider found for '${s}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const u=this._extHostWebviewPanels.getWebviewPanel(t);if(!u)throw new Error("No webview found");const w=D.URI.revive(r),v=this._extHostDocuments.getDocument(w);await i.provider.moveCustomTextEditor(v,u,g.CancellationToken.None)}async $undo(t,r,s,i){return this.getCustomDocumentEntry(r,t).undo(s,i)}async $redo(t,r,s,i){return this.getCustomDocumentEntry(r,t).redo(s,i)}async $revert(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).revertCustomDocument(i.document,s),i.disposeBackup()}async $onSave(t,r,s){const i=this.getCustomDocumentEntry(r,t);await this.getCustomEditorProvider(r).saveCustomDocument(i.document,s),i.disposeBackup()}async $onSaveAs(t,r,s,i){const u=this.getCustomDocumentEntry(r,t);return this.getCustomEditorProvider(r).saveCustomDocumentAs(u.document,D.URI.revive(s),i)}async $backup(t,r,s){const i=this.getCustomDocumentEntry(r,t),w=await this.getCustomEditorProvider(r).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},s);return i.updateBackup(w),w.id}getCustomDocumentEntry(t,r){const s=this._documents.get(t,D.URI.revive(r));if(!s)throw new Error("No custom document found");return s}getCustomEditorProvider(t){const r=this._editorProviders.get(t),s=r==null?void 0:r.provider;if(!s||!this.supportEditing(s))throw new Error("Custom document is not editable");return s}supportEditing(t){return!!t.onDidChangeCustomDocument}}e.ExtHostCustomEditors=b;function p(m){return typeof m.resolveCustomTextEditor=="function"}function l(m){return typeof m.undo=="function"&&typeof m.redo=="function"}function f(m){const t=m.scheme===E.Schemas.file||m.scheme===E.Schemas.untitled?m.fsPath:m.toString();return T.hash(t)+""}});var it=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[204],_e([0,1,3,7,2,34,9,47,5,6]),function(ee,e,g,T,S,E,k,D,_,C){"use strict";var n,I,o,h,c,d,y,b,p,l,f,m,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class r extends T.Disposable{constructor(w,v,P,A,a,R,L){super();n.set(this,void 0),I.set(this,void 0),o.set(this,void 0),h.set(this,void 0),c.set(this,void 0),d.set(this,void 0),y.set(this,void 0),b.set(this,void 0),p.set(this,!0),l.set(this,!0),f.set(this,!1),m.set(this,this._register(new g.Emitter)),this.onDidDispose=Be(this,m,"f").event,t.set(this,this._register(new g.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,it(this,n,w,"f"),it(this,I,v,"f"),it(this,o,P,"f"),it(this,c,R,"f"),it(this,b,a,"f"),it(this,d,A,"f"),it(this,h,L,"f")}dispose(){Be(this,f,"f")||(it(this,f,!0,"f"),Be(this,m,"f").fire(),Be(this,I,"f").$disposeWebview(Be(this,n,"f")),Be(this,h,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Be(this,h,"f")}get viewType(){return this.assertNotDisposed(),Be(this,o,"f")}get title(){return this.assertNotDisposed(),Be(this,d,"f")}set title(w){this.assertNotDisposed(),Be(this,d,"f")!==w&&(it(this,d,w,"f"),Be(this,I,"f").$setTitle(Be(this,n,"f"),w))}get iconPath(){return this.assertNotDisposed(),Be(this,y,"f")}set iconPath(w){this.assertNotDisposed(),Be(this,y,"f")!==w&&(it(this,y,w,"f"),Be(this,I,"f").$setIconPath(Be(this,n,"f"),S.URI.isUri(w)?{light:w,dark:w}:w))}get options(){return Be(this,c,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Be(this,b,"f")=="number"&&Be(this,b,"f")<0))return Be(this,b,"f")}get active(){return this.assertNotDisposed(),Be(this,l,"f")}get visible(){return this.assertNotDisposed(),Be(this,p,"f")}_updateViewState(w){Be(this,f,"f")||(this.active!==w.active||this.visible!==w.visible||this.viewColumn!==w.viewColumn)&&(it(this,l,w.active,"f"),it(this,p,w.visible,"f"),it(this,b,w.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(w,v){this.assertNotDisposed(),Be(this,I,"f").$reveal(Be(this,n,"f"),{viewColumn:w?k.ViewColumn.from(w):void 0,preserveFocus:!!v})}assertNotDisposed(){if(Be(this,f,"f"))throw new Error("Webview is disposed")}}n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,c=new WeakMap,d=new WeakMap,y=new WeakMap,b=new WeakMap,p=new WeakMap,l=new WeakMap,f=new WeakMap,m=new WeakMap,t=new WeakMap;class s{constructor(w,v,P){this.webviews=v,this.workspace=P,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=w.getProxy(_.MainContext.MainThreadWebviewPanels)}static newHandle(){return E.generateUuid()}createWebviewPanel(w,v,P,A,a={}){const R=typeof A=="object"?A.viewColumn:A,L={viewColumn:k.ViewColumn.from(R),preserveFocus:typeof A=="object"&&!!A.preserveFocus},H=D.shouldSerializeBuffersForPostMessage(w),ue=s.newHandle();this._proxy.$createWebviewPanel(D.toExtensionData(w),ue,v,{title:P,panelOptions:i(a),webviewOptions:D.serializeWebviewOptions(w,this.workspace,a),serializeBuffersForPostMessage:H},L);const me=this.webviews.createNewWebview(ue,a,w);return this.createNewWebviewPanel(ue,v,P,R,a,me)}$onDidChangeWebviewPanelViewStates(w){const v=Object.keys(w);v.sort((P,A)=>{const a=w[P],R=w[A];return a.active?1:R.active?-1:+a.visible-+R.visible});for(const P of v){const A=this.getWebviewPanel(P);if(!A)continue;const a=w[P];A._updateViewState({active:a.active,visible:a.visible,viewColumn:k.ViewColumn.to(a.position)})}}async $onDidDisposeWebviewPanel(w){const v=this.getWebviewPanel(w);v==null||v.dispose(),this._webviewPanels.delete(w),this.webviews.deleteWebview(w)}registerWebviewPanelSerializer(w,v,P){if(this._serializers.has(v))throw new Error(`Serializer for '${v}' already registered`);return this._serializers.set(v,{serializer:P,extension:w}),this._proxy.$registerSerializer(v,{serializeBuffersForPostMessage:D.shouldSerializeBuffersForPostMessage(w)}),new C.Disposable(()=>{this._serializers.delete(v),this._proxy.$unregisterSerializer(v)})}async $deserializeWebviewPanel(w,v,P,A){const a=this._serializers.get(v);if(!a)throw new Error(`No serializer found for '${v}'`);const{serializer:R,extension:L}=a,H=this.webviews.createNewWebview(w,P.webviewOptions,L),ue=this.createNewWebviewPanel(w,v,P.title,A,P.panelOptions,H);await R.deserializeWebviewPanel(ue,P.state)}createNewWebviewPanel(w,v,P,A,a,R){const L=new r(w,this._proxy,v,P,A,a,R);return this._webviewPanels.set(w,L),L}getWebviewPanel(w){return this._webviewPanels.get(w)}}e.ExtHostWebviewPanels=s;function i(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var it=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[205],_e([0,1,3,7,47,5,6]),function(ee,e,g,T,S,E,k){"use strict";var D,_,C,n,I,o,h,c,d,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends T.Disposable{constructor(f,m,t,r,s,i){super();D.set(this,void 0),_.set(this,void 0),C.set(this,void 0),n.set(this,void 0),I.set(this,!1),o.set(this,void 0),h.set(this,void 0),c.set(this,void 0),d.set(this,this._register(new g.Emitter)),this.onDidChangeVisibility=Be(this,d,"f").event,y.set(this,this._register(new g.Emitter)),this.onDidDispose=Be(this,y,"f").event,it(this,C,t,"f"),it(this,h,r,"f"),it(this,D,f,"f"),it(this,_,m,"f"),it(this,n,s,"f"),it(this,o,i,"f")}dispose(){Be(this,I,"f")||(it(this,I,!0,"f"),Be(this,y,"f").fire(),Be(this,n,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Be(this,h,"f")}set title(f){this.assertNotDisposed(),Be(this,h,"f")!==f&&(it(this,h,f,"f"),Be(this,_,"f").$setWebviewViewTitle(Be(this,D,"f"),f))}get description(){return this.assertNotDisposed(),Be(this,c,"f")}set description(f){this.assertNotDisposed(),Be(this,c,"f")!==f&&(it(this,c,f,"f"),Be(this,_,"f").$setWebviewViewDescription(Be(this,D,"f"),f))}get visible(){return Be(this,o,"f")}get webview(){return Be(this,n,"f")}get viewType(){return Be(this,C,"f")}_setVisible(f){f===Be(this,o,"f")||Be(this,I,"f")||(it(this,o,f,"f"),Be(this,d,"f").fire())}show(f){this.assertNotDisposed(),Be(this,_,"f").$show(Be(this,D,"f"),!!f)}assertNotDisposed(){if(Be(this,I,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,_=new WeakMap,C=new WeakMap,n=new WeakMap,I=new WeakMap,o=new WeakMap,h=new WeakMap,c=new WeakMap,d=new WeakMap,y=new WeakMap;class p{constructor(f,m){this._extHostWebview=m,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=f.getProxy(E.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(f,m,t,r){if(this._viewProviders.has(m))throw new Error(`View provider for '${m}' already registered`);return this._viewProviders.set(m,{provider:t,extension:f}),this._proxy.$registerWebviewViewProvider(S.toExtensionData(f),m,{retainContextWhenHidden:r==null?void 0:r.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new k.Disposable(()=>{this._viewProviders.delete(m),this._proxy.$unregisterWebviewViewProvider(m)})}async $resolveWebviewView(f,m,t,r,s){const i=this._viewProviders.get(m);if(!i)throw new Error(`No view provider found for '${m}'`);const{provider:u,extension:w}=i,v=this._extHostWebview.createNewWebview(f,{},w),P=new b(f,this._proxy,m,t,v,!0);this._webviewViews.set(f,P),await u.resolveWebviewView(P,{state:r},s)}async $onDidChangeWebviewViewVisibility(f,m){this.getWebviewView(f)._setVisible(m)}async $disposeWebviewView(f){const m=this.getWebviewView(f);this._webviewViews.delete(f),m.dispose(),this._extHostWebview.deleteWebview(f)}getWebviewView(f){const m=this._webviewViews.get(f);if(!m)throw new Error("No webview found");return m}}e.ExtHostWebviewViews=p}),define(we[102],_e([0,1,3,5,2,16,8,4,13]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let C=class xn{constructor(I){this._onDidChangeWindowState=new g.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=xn.InitialState,this._proxy=I.getProxy(T.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(o=>this.$onDidChangeWindowFocus(o))}get state(){return this._state}$onDidChangeWindowFocus(I){I!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:I}),this._onDidChangeWindowState.fire(this._state))}openUri(I,o){let h;if(typeof I=="string"){h=I;try{I=S.URI.parse(I)}catch(c){return Promise.reject(`Invalid uri - '${I}'`)}}return k.isFalsyOrWhitespace(I.scheme)?Promise.reject("Invalid scheme - cannot be empty"):I.scheme===E.Schemas.command?Promise.reject(`Invalid scheme '${I.scheme}'`):this._proxy.$openUri(I,h,o)}async asExternalUri(I,o){if(k.isFalsyOrWhitespace(I.scheme))return Promise.reject("Invalid scheme - cannot be empty");const h=await this._proxy.$asExternalUri(I,o);return S.URI.from(h)}};C.InitialState={focused:!0},C=Ve([ze(0,_.IExtHostRpcService)],C),e.ExtHostWindow=C,e.IExtHostWindow=D.createDecorator("IExtHostWindow")}),define(we[206],_e([0,1,15,5,28,13]),function(ee,e,g,T,S,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let k=class extends g.AbstractLogger{constructor(_,C){super();this._proxy=_.getProxy(T.MainContext.MainThreadLog),this._logFile=C.logFile.toJSON(),this.setLevel(C.logLevel)}$setLevel(_){this.setLevel(_)}trace(_,...C){this.getLevel()<=g.LogLevel.Trace&&this._proxy.$log(this._logFile,g.LogLevel.Trace,Array.from(arguments))}debug(_,...C){this.getLevel()<=g.LogLevel.Debug&&this._proxy.$log(this._logFile,g.LogLevel.Debug,Array.from(arguments))}info(_,...C){this.getLevel()<=g.LogLevel.Info&&this._proxy.$log(this._logFile,g.LogLevel.Info,Array.from(arguments))}warn(_,...C){this.getLevel()<=g.LogLevel.Warning&&this._proxy.$log(this._logFile,g.LogLevel.Warning,Array.from(arguments))}error(_,...C){this.getLevel()<=g.LogLevel.Error&&this._proxy.$log(this._logFile,g.LogLevel.Error,Array.from(arguments))}critical(_,...C){this.getLevel()<=g.LogLevel.Critical&&this._proxy.$log(this._logFile,g.LogLevel.Critical,Array.from(arguments))}flush(){}};k=Ve([ze(0,E.IExtHostRpcService),ze(1,S.IExtHostInitDataService)],k),e.ExtHostLogService=k}),define(we[207],_e([0,1,12,18,11,3,7,113,177,99,23]),function(ee,e,g,T,S,E,k,D,_,C,n){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=void 0;function o(i,u){try{return JSON.stringify(i,u)}catch(w){return"null"}}function h(i,u){return JSON.stringify(i,u)}function c(i){return i?(u,w)=>w&&w.$mid===1?i.transformOutgoing(w):w:null}var d;(function(i){i[i.LocalSide=0]="LocalSide",i[i.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));var y;(function(i){i[i.Responsive=0]="Responsive",i[i.Unresponsive=1]="Unresponsive"})(y=e.ResponsiveState||(e.ResponsiveState={}));const b=()=>{},p=Symbol.for("rpcProtocol"),l=Symbol.for("rpcProxy");class f extends k.Disposable{constructor(u,w=null,v=null){super();this[I]=!0,this._onDidChangeResponsiveState=this._register(new E.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=u,this._logger=w,this._uriTransformer=v,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let P=0,A=C.ProxyIdentifier.count;P<A;P++)this._locals[P]=null,this._proxies[P]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new g.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(P=>this._receiveOneMessage(P))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(u=>{this._pendingRPCReplies[u].resolveErr(S.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(u){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(u){this._unresponsiveTime=Date.now()+f.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(u){this._responsiveState!==u&&(this._responsiveState=u,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(u){return this._uriTransformer?D.transformIncomingURIs(u,this._uriTransformer):u}getProxy(u){const{nid:w,sid:v}=u;return this._proxies[w]||(this._proxies[w]=this._createProxy(w,v)),this._proxies[w]}_createProxy(u,w){let v={get:(P,A)=>(typeof A=="string"&&!P[A]&&A.charCodeAt(0)===36&&(P[A]=(...a)=>this._remoteCall(u,A,a)),A===l?w:P[A])};return new Proxy(Object.create(null),v)}set(u,w){return this._locals[u.nid]=w,w}assertRegistered(u){for(let w=0,v=u.length;w<v;w++){const P=u[w];if(!this._locals[P.nid])throw new Error(`Missing actor ${P.sid} (isMain: ${P.isMain})`)}}_receiveOneMessage(u){if(this._isDisposed)return;const w=u.byteLength,v=m.read(u,0),P=v.readUInt8(),A=v.readUInt32();switch(P){case 1:case 2:{let{rpcId:a,method:R,args:L}=t.deserializeRequestJSONArgs(v);this._uriTransformer&&(L=D.transformIncomingURIs(L,this._uriTransformer)),this._receiveRequest(w,A,a,R,L,P===2);break}case 3:case 4:{let{rpcId:a,method:R,args:L}=t.deserializeRequestMixedArgs(v);this._uriTransformer&&(L=D.transformIncomingURIs(L,this._uriTransformer)),this._receiveRequest(w,A,a,R,L,P===4);break}case 5:{this._logger&&this._logger.logIncoming(w,A,0,"ack"),this._onDidReceiveAcknowledge(A);break}case 6:{this._receiveCancel(w,A);break}case 7:{this._receiveReply(w,A,void 0);break}case 9:{let a=t.deserializeReplyOKJSON(v);this._uriTransformer&&(a=D.transformIncomingURIs(a,this._uriTransformer)),this._receiveReply(w,A,a);break}case 8:{let a=t.deserializeReplyOKVSBuffer(v);this._receiveReply(w,A,a);break}case 10:{let a=t.deserializeReplyErrError(v);this._uriTransformer&&(a=D.transformIncomingURIs(a,this._uriTransformer)),this._receiveReplyErr(w,A,a);break}case 11:{this._receiveReplyErr(w,A,void 0);break}default:console.error("received unexpected message"),console.error(u)}}_receiveRequest(u,w,v,P,A,a){this._logger&&this._logger.logIncoming(u,w,1,`receiveRequest ${C.getStringIdentifierForProxy(v)}.${P}(`,A);const R=String(w);let L,H;if(a){const me=new T.CancellationTokenSource;A.push(me.token),L=this._invokeHandler(v,P,A),H=()=>me.cancel()}else L=this._invokeHandler(v,P,A),H=b;this._cancelInvokedHandlers[R]=H;const ue=t.serializeAcknowledged(w);this._logger&&this._logger.logOutgoing(ue.byteLength,w,1,"ack"),this._protocol.send(ue),L.then(me=>{delete this._cancelInvokedHandlers[R];const J=t.serializeReplyOK(w,me,this._uriReplacer);this._logger&&this._logger.logOutgoing(J.byteLength,w,1,"reply:",me),this._protocol.send(J)},me=>{delete this._cancelInvokedHandlers[R];const J=t.serializeReplyErr(w,me);this._logger&&this._logger.logOutgoing(J.byteLength,w,1,"replyErr:",me),this._protocol.send(J)})}_receiveCancel(u,w){this._logger&&this._logger.logIncoming(u,w,1,"receiveCancel");const v=String(w);this._cancelInvokedHandlers[v]&&this._cancelInvokedHandlers[v]()}_receiveReply(u,w,v){this._logger&&this._logger.logIncoming(u,w,0,"receiveReply:",v);const P=String(w);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const A=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P],A.resolveOk(v)}_receiveReplyErr(u,w,v){this._logger&&this._logger.logIncoming(u,w,0,"receiveReplyErr:",v);const P=String(w);if(!this._pendingRPCReplies.hasOwnProperty(P))return;const A=this._pendingRPCReplies[P];delete this._pendingRPCReplies[P];let a;v&&(v.$isError?(a=new Error,a.name=v.name,a.message=v.message,a.stack=v.stack):a=v),A.resolveErr(a)}_invokeHandler(u,w,v){try{return Promise.resolve(this._doInvokeHandler(u,w,v))}catch(P){return Promise.reject(P)}}_doInvokeHandler(u,w,v){const P=this._locals[u];if(!P)throw new Error("Unknown actor "+C.getStringIdentifierForProxy(u));let A=P[w];if(typeof A!="function")throw new Error("Unknown method "+w+" on actor "+C.getStringIdentifierForProxy(u));return A.apply(P,v)}_remoteCall(u,w,v){if(this._isDisposed)return Promise.reject(S.canceled());let P=null;if(v.length>0&&T.CancellationToken.isCancellationToken(v[v.length-1])&&(P=v.pop()),P&&P.isCancellationRequested)return Promise.reject(S.canceled());const A=t.serializeRequestArguments(v,this._uriReplacer),a=++this._lastMessageId,R=String(a),L=new _.LazyPromise;P&&P.onCancellationRequested(()=>{const ue=t.serializeCancel(a);this._logger&&this._logger.logOutgoing(ue.byteLength,a,0,"cancel"),this._protocol.send(t.serializeCancel(a))}),this._pendingRPCReplies[R]=L,this._onWillSendRequest(a);const H=t.serializeRequest(a,u,w,A,!!P);return this._logger&&this._logger.logOutgoing(H.byteLength,a,0,`request: ${C.getStringIdentifierForProxy(u)}.${w}(`,v),this._protocol.send(H),L}}e.RPCProtocol=f,I=p,f.UNRESPONSIVE_TIME=3*1e3;class m{constructor(u,w){this._buff=u,this._offset=w}static alloc(u,w,v){let P=new m(n.VSBuffer.alloc(v+1+4),0);return P.writeUInt8(u),P.writeUInt32(w),P}static read(u,w){return new m(u,w)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(u){this._buff.writeUInt8(u,this._offset),this._offset+=1}readUInt8(){const u=this._buff.readUInt8(this._offset);return this._offset+=1,u}writeUInt32(u){this._buff.writeUInt32BE(u,this._offset),this._offset+=4}readUInt32(){const u=this._buff.readUInt32BE(this._offset);return this._offset+=4,u}static sizeShortString(u){return 1+u.byteLength}writeShortString(u){this._buff.writeUInt8(u.byteLength,this._offset),this._offset+=1,this._buff.set(u,this._offset),this._offset+=u.byteLength}readShortString(){const u=this._buff.readUInt8(this._offset);this._offset+=1;const v=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,v}static sizeLongString(u){return 4+u.byteLength}writeLongString(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readLongString(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const v=this._buff.slice(this._offset,this._offset+u).toString();return this._offset+=u,v}writeBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}static sizeVSBuffer(u){return 4+u.byteLength}writeVSBuffer(u){this._buff.writeUInt32BE(u.byteLength,this._offset),this._offset+=4,this._buff.set(u,this._offset),this._offset+=u.byteLength}readVSBuffer(){const u=this._buff.readUInt32BE(this._offset);this._offset+=4;const w=this._buff.slice(this._offset,this._offset+u);return this._offset+=u,w}static sizeMixedArray(u,w){let v=0;v+=1;for(let P=0,A=u.length;P<A;P++){const a=u[P],R=w[P];switch(v+=1,R){case 1:v+=this.sizeLongString(a);break;case 2:v+=this.sizeVSBuffer(a);break;case 3:break}}return v}writeMixedArray(u,w){this._buff.writeUInt8(u.length,this._offset),this._offset+=1;for(let v=0,P=u.length;v<P;v++){const A=u[v];switch(w[v]){case 1:this.writeUInt8(1),this.writeLongString(A);break;case 2:this.writeUInt8(2),this.writeVSBuffer(A);break;case 3:this.writeUInt8(3);break}}}readMixedArray(){const u=this._buff.readUInt8(this._offset);this._offset+=1;let w=new Array(u);for(let v=0;v<u;v++)switch(this.readUInt8()){case 1:w[v]=this.readLongString();break;case 2:w[v]=this.readVSBuffer();break;case 3:w[v]=void 0;break}return w}}class t{static _arrayContainsBufferOrUndefined(u){for(let w=0,v=u.length;w<v;w++)if(u[w]instanceof n.VSBuffer||typeof u[w]=="undefined")return!0;return!1}static serializeRequestArguments(u,w){if(this._arrayContainsBufferOrUndefined(u)){let v=[],P=[];for(let A=0,a=u.length;A<a;A++){const R=u[A];R instanceof n.VSBuffer?(v[A]=R,P[A]=2):typeof R=="undefined"?(v[A]=n.VSBuffer.alloc(0),P[A]=3):(v[A]=n.VSBuffer.fromString(h(R,w)),P[A]=1)}return{type:"mixed",args:v,argsType:P}}return{type:"simple",args:h(u,w)}}static serializeRequest(u,w,v,P,A){return P.type==="mixed"?this._requestMixedArgs(u,w,v,P.args,P.argsType,A):this._requestJSONArgs(u,w,v,P.args,A)}static _requestJSONArgs(u,w,v,P,A){const a=n.VSBuffer.fromString(v),R=n.VSBuffer.fromString(P);let L=0;L+=m.sizeUInt8(),L+=m.sizeShortString(a),L+=m.sizeLongString(R);let H=m.alloc(A?2:1,u,L);return H.writeUInt8(w),H.writeShortString(a),H.writeLongString(R),H.buffer}static deserializeRequestJSONArgs(u){const w=u.readUInt8(),v=u.readShortString(),P=u.readLongString();return{rpcId:w,method:v,args:JSON.parse(P)}}static _requestMixedArgs(u,w,v,P,A,a){const R=n.VSBuffer.fromString(v);let L=0;L+=m.sizeUInt8(),L+=m.sizeShortString(R),L+=m.sizeMixedArray(P,A);let H=m.alloc(a?4:3,u,L);return H.writeUInt8(w),H.writeShortString(R),H.writeMixedArray(P,A),H.buffer}static deserializeRequestMixedArgs(u){const w=u.readUInt8(),v=u.readShortString(),P=u.readMixedArray(),A=new Array(P.length);for(let a=0,R=P.length;a<R;a++){const L=P[a];typeof L=="string"?A[a]=JSON.parse(L):A[a]=L}return{rpcId:w,method:v,args:A}}static serializeAcknowledged(u){return m.alloc(5,u,0).buffer}static serializeCancel(u){return m.alloc(6,u,0).buffer}static serializeReplyOK(u,w,v){return typeof w=="undefined"?this._serializeReplyOKEmpty(u):w instanceof n.VSBuffer?this._serializeReplyOKVSBuffer(u,w):this._serializeReplyOKJSON(u,o(w,v))}static _serializeReplyOKEmpty(u){return m.alloc(7,u,0).buffer}static _serializeReplyOKVSBuffer(u,w){let v=0;v+=m.sizeVSBuffer(w);let P=m.alloc(8,u,v);return P.writeVSBuffer(w),P.buffer}static deserializeReplyOKVSBuffer(u){return u.readVSBuffer()}static _serializeReplyOKJSON(u,w){const v=n.VSBuffer.fromString(w);let P=0;P+=m.sizeLongString(v);let A=m.alloc(9,u,P);return A.writeLongString(v),A.buffer}static deserializeReplyOKJSON(u){const w=u.readLongString();return JSON.parse(w)}static serializeReplyErr(u,w){return w?this._serializeReplyErrEror(u,w):this._serializeReplyErrEmpty(u)}static _serializeReplyErrEror(u,w){const v=n.VSBuffer.fromString(o(S.transformErrorForSerialization(w),null));let P=0;P+=m.sizeLongString(v);let A=m.alloc(10,u,P);return A.writeLongString(v),A.buffer}static deserializeReplyErrError(u){const w=u.readLongString();return JSON.parse(w)}static _serializeReplyErrEmpty(u){return m.alloc(11,u,0).buffer}}var r;(function(i){i[i.RequestJSONArgs=1]="RequestJSONArgs",i[i.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",i[i.RequestMixedArgs=3]="RequestMixedArgs",i[i.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",i[i.Acknowledged=5]="Acknowledged",i[i.Cancel=6]="Cancel",i[i.ReplyOKEmpty=7]="ReplyOKEmpty",i[i.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",i[i.ReplyOKJSON=9]="ReplyOKJSON",i[i.ReplyErrError=10]="ReplyErrError",i[i.ReplyErrEmpty=11]="ReplyErrEmpty"})(r||(r={}));var s;(function(i){i[i.String=1]="String",i[i.VSBuffer=2]="VSBuffer",i[i.Undefined=3]="Undefined"})(s||(s={}))}),define(we[208],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const g=function(E){const k=D=>{self.removeEventListener("message",k);const _=D.data;Object.defineProperties(self,{postMessage:{value(C,n){_.postMessage(C,n)}},onmessage:{get(){return _.onmessage},set(C){_.onmessage=C}}}),_.addEventListener("message",C=>{self.dispatchEvent(new MessageEvent("message",{data:C.data}))}),_.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(E)};self.addEventListener("message",k)}.toString();class T extends EventTarget{constructor(E,k,D){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const _=`((${g})('${k}'))`,C=new Blob([_],{type:"application/javascript"}),n=URL.createObjectURL(C),I=new MessageChannel,o=n,h={type:"_newWorker",id:o,port:I.port2,url:n,options:D};E(h,[I.port2]),this.postMessage=I.port1.postMessage.bind(I.port1),this.terminate=()=>{const c={type:"_terminateWorker",id:o};I.port1.postMessage(c),URL.revokeObjectURL(n),I.port1.close(),I.port2.close()},Object.defineProperties(this,{onmessage:{get(){return I.port1.onmessage},set(c){I.port1.onmessage=c}},onmessageerror:{get(){return I.port1.onmessageerror},set(c){I.port1.onmessageerror=c}}}),I.port1.addEventListener("messageerror",c=>{const d=new MessageEvent("messageerror",{data:c.data});this.dispatchEvent(d)}),I.port1.addEventListener("message",c=>{const d=new MessageEvent("message",{data:c.data});this.dispatchEvent(d)}),I.port1.start()}}e.NestedWorker=T}),define(we[209],_e([0,1,4]),function(ee,e,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=g.createDecorator("remoteAgentService")}),define(we[210],_e([0,1,16,14,21,2,4,93,45,173,209]),function(ee,e,g,T,S,E,k,D,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=k.createDecorator("pathService");let I=class Bn{constructor(h,c,d,y){this.localUserHome=h,this.remoteAgentService=c,this.environmentService=d,this.contextService=y,this.resolveOS=(async()=>{const b=await this.remoteAgentService.getEnvironment();return(b==null?void 0:b.os)||S.OS})(),this.resolveUserHome=(async()=>{const b=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=(b==null?void 0:b.userHome)||h})()}get defaultUriScheme(){return Bn.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,c){if(h.remoteAuthority)return g.Schemas.vscodeRemote;const d=D.getVirtualWorkspaceScheme(c.getWorkspace());if(d)return d;const y=c.getWorkspace().folders[0];if(y)return y.uri.scheme;const b=c.getWorkspace().configuration;return b?b.scheme:g.Schemas.file}async userHome(h){return(h==null?void 0:h.preferLocal)?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?T.win32:T.posix)}async fileURI(h){let c="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const y=h.indexOf("/",2);y===-1?(c=h.substring(2),h="/"):(c=h.substring(2,y),h=h.substring(y)||"/")}return E.URI.from({scheme:g.Schemas.file,authority:c,path:h,query:"",fragment:""})}};I=Ve([ze(1,n.IRemoteAgentService),ze(2,C.IWorkbenchEnvironmentService),ze(3,_.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(we[103],_e([0,1]),function(ee,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class g{constructor(k,D){this.line=k,this.character=D}isBefore(k){return!1}isBeforeOrEqual(k){return!1}isAfter(k){return!1}isAfterOrEqual(k){return!1}isEqual(k){return!1}compareTo(k){return 0}translate(k,D){return new g(0,0)}with(k){return new g(0,0)}}e.Position=g;class T{constructor(k,D,_,C){this.isEmpty=!1,this.isSingleLine=!1,this.start=new g(k,D),this.end=new g(_,C)}contains(k){return!1}isEqual(k){return!1}intersection(k){}union(k){return new T(0,0,0,0)}with(k){return new T(0,0,0,0)}}e.Range=T;var S;(function(E){E[E.Information=1]="Information",E[E.Warning=2]="Warning"})(S=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[38],_e([0,1,17,27,24,43,8,4,14,11,103]),function(ee,e,g,T,S,E,k,D,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return n.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const I="\u27EA ",o=" characters skipped \u27EB",h=(I.length+o.length+5)*2;e.ISearchService=D.createDecorator("searchService");var c;(function(M){M[M.file=0]="file",M[M.text=1]="text"})(c=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(M){M[M.File=1]="File",M[M.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function y(M){return!!M.preview}e.resultIsMatch=y;function b(M){return!!M.resource}e.isFileMatch=b;function p(M){return!!M.message}e.isProgressMessage=p;var l;(function(M){M[M.Normal=0]="Normal",M[M.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class f{constructor(q){this.resource=q,this.results=[]}}e.FileMatch=f;class m{constructor(q,N,W){this.ranges=N;const O=Array.isArray(N)?N:[N];if(W&&W.matchLines===1&&t(O)){q=k.getNLines(q,W.matchLines);let B="",Y=0,he=0;const De=Math.floor(W.charsPerLine/5),Oe=[];for(const Me of O){const He=Math.max(Me.startColumn-De,0),Ye=Me.startColumn+W.charsPerLine;if(He>he+De+h){const qe=I+(He-he)+o;B+=qe+q.slice(He,Ye),Y+=He-(he+qe.length)}else B+=q.slice(he,Ye);Oe.push(new s(0,Me.startColumn-Y,Me.endColumn-Y)),he=Ye}this.preview={text:B,matches:Array.isArray(this.ranges)?Oe:Oe[0]}}else{const B=Array.isArray(N)?N[0].startLineNumber:N.startLineNumber;this.preview={text:q,matches:g.mapArrayOrNot(N,Y=>new r(Y.startLineNumber-B,Y.startColumn,Y.endLineNumber-B,Y.endColumn))}}}}e.TextSearchMatch=m;function t(M){const q=M[0].startLineNumber;for(const N of M)if(N.startLineNumber!==q||N.endLineNumber!==q)return!1;return!0}class r{constructor(q,N,W,O){this.startLineNumber=q,this.startColumn=N,this.endLineNumber=W,this.endColumn=O}}e.SearchRange=r;class s extends r{constructor(q,N,W){super(q,N,q,W)}}e.OneLineRange=s;var i;(function(M){M.Default="default",M.FileNames="fileNames",M.Type="type",M.Modified="modified",M.CountDescending="countDescending",M.CountAscending="countAscending"})(i=e.SearchSortOrder||(e.SearchSortOrder={}));function u(M,q=!0){const N=M&&M.files&&M.files.exclude,W=q&&M&&M.search&&M.search.exclude;if(!N&&!W)return;if(!N||!W)return N||W;let O=Object.create(null);return O=S.mixin(O,S.deepClone(N)),O=S.mixin(O,S.deepClone(W),!0),O}e.getExcludes=u;function w(M,q){return M.excludePattern&&T.match(M.excludePattern,q)?!1:M.includePattern||M.usingSearchPaths?M.includePattern&&T.match(M.includePattern,q)?!0:M.usingSearchPaths?!!M.folderQueries&&M.folderQueries.some(N=>{const W=N.folder.fsPath;if(E.isEqualOrParent(q,W)){const O=_.relative(W,q);return!N.includePattern||!!T.match(N.includePattern,O)}else return!1}):!1:!0}e.pathIncludedInQuery=w;var v;(function(M){M[M.unknownEncoding=1]="unknownEncoding",M[M.regexParseError=2]="regexParseError",M[M.globParseError=3]="globParseError",M[M.invalidLiteral=4]="invalidLiteral",M[M.rgProcessError=5]="rgProcessError",M[M.other=6]="other",M[M.canceled=7]="canceled"})(v=e.SearchErrorCode||(e.SearchErrorCode={}));class P extends Error{constructor(q,N){super(q);this.code=N}}e.SearchError=P;function A(M){const q=M.message;if(C.isPromiseCanceledError(M))return new P(q,v.canceled);try{const N=JSON.parse(q);return new P(N.message,N.code)}catch(N){return new P(q,v.other)}}e.deserializeSearchError=A;function a(M){const q={message:M.message,code:M.code};return new Error(JSON.stringify(q))}e.serializeSearchError=a;function R(M){return M.type==="error"?!0:M.type==="success"}e.isSerializedSearchComplete=R;function L(M){return M.type==="success"}e.isSerializedSearchSuccess=L;function H(M){return!!M.path}e.isSerializedFileMatch=H;function ue(M,q){const N=M.searchPath?M.searchPath:M.relativePath;return k.fuzzyContains(N,q)}e.isFilePatternMatch=ue;class me{constructor(q){this.path=q,this.results=[]}addMatch(q){this.results.push(q)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=me;function J(M,q){const N=Object.assign(Object.assign({},M||{}),q||{});return Object.keys(N).filter(W=>{const O=N[W];return typeof O=="boolean"&&O})}e.resolvePatternsForProvider=J;class z{constructor(q,N){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},q.excludePattern||{}),N.excludePattern||{}),this._parsedExcludeExpression=T.parse(this._excludeExpression);let W=q.includePattern;N.includePattern&&(W?W=Object.assign(Object.assign({},W),N.includePattern):W=N.includePattern),W&&(this._parsedIncludeExpression=T.parse(W))}includedInQuerySync(q,N,W){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(q,N,W)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(q,N,W))}includedInQuery(q,N,W){return Promise.resolve(this._parsedExcludeExpression(q,N,W)).then(B=>!!B).then(B=>B?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(q,N,W)).then(Y=>!!Y):Promise.resolve(!0)).then(B=>B)}hasSiblingExcludeClauses(){return Z(this._excludeExpression)}}e.QueryGlobTester=z;function Z(M){for(const q in M)if(typeof M[q]!="boolean")return!0;return!1}}),define(we[30],_e([0,1,17,12,18,3,22,16,77,25,8,10,2,134,4,15,147,45,46,28,13,6,38,5]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y,b,p,l,f,m,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function s(R,L,H){return new C.ExtUri(ue=>v(ue,H)).isEqual(R,L)}function i(R,L,H){return s(R.uri,L.uri,H)?0:n.compare(R.uri.toString(),L.uri.toString())}function u(R,L,H){return R.index!==L.index?R.index<L.index?-1:1:s(R.uri,L.uri,H)?n.compare(R.name,L.name):n.compare(R.uri.toString(),L.uri.toString())}function w(R,L,H,ue){const me=R.slice(0).sort((z,Z)=>H(z,Z,ue)),J=L.slice(0).sort((z,Z)=>H(z,Z,ue));return g.delta(me,J,(z,Z)=>H(z,Z,ue))}function v(R,L){const H=L.getCapabilities(R.scheme);return!(H&&H&1024)}class P extends b.Workspace{constructor(L,H,ue,me,J,z){super(L,ue.map(Z=>new b.WorkspaceFolder(Z)),me,z);this._name=H,this._isUntitled=J,this._workspaceFolders=[],this._structure=k.TernarySearchTree.forUris(z),ue.forEach(Z=>{this._workspaceFolders.push(Z),this._structure.set(Z.uri,Z)})}static toExtHostWorkspace(L,H,ue,me){if(!L)return{workspace:null,added:[],removed:[]};const{id:J,name:z,folders:Z,configuration:M,isUntitled:q}=L,N=[],W=H;H?Z.forEach((he,De)=>{const Oe=o.URI.revive(he.uri),Me=P._findFolder(ue||H,Oe,me);Me?(Me.name=he.name,Me.index=he.index,N.push(Me)):N.push({uri:Oe,name:he.name,index:De})}):N.push(...Z.map(({uri:he,name:De,index:Oe})=>({uri:o.URI.revive(he),name:De,index:Oe}))),N.sort((he,De)=>he.index<De.index?-1:1);const O=new P(J,z,N,M?o.URI.revive(M):null,!!q,he=>v(he,me)),{added:B,removed:Y}=w(W?W.workspaceFolders:[],O.workspaceFolders,i,me);return{workspace:O,added:B,removed:Y}}static _findFolder(L,H,ue){for(let me=0;me<L.folders.length;me++){const J=L.workspaceFolders[me];if(s(J.uri,H,ue))return J}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,H){return H&&this._structure.get(L)&&(L=C.dirname(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let A=class{constructor(L,H,ue,me){this._onDidChangeWorkspace=new E.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new E.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=me,this._extHostFileSystemInfo=ue,this._requestIdProvider=new _.Counter,this._barrier=new T.Barrier,this._proxy=L.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(r.MainContext.MainThreadMessageService);const J=H.workspace;this._confirmedWorkspace=J?new P(J.id,J.name,[],J.configuration?o.URI.revive(J.configuration):null,!!J.isUntitled,z=>v(z,ue)):void 0}$initializeWorkspace(L,H){this._trusted=H,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?o.URI.from({scheme:D.Schemas.untitled,path:C.basename(C.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,H,ue,...me){const J=[];if(Array.isArray(me)&&me.forEach(N=>{o.URI.isUri(N.uri)&&!J.some(W=>s(W.uri,N.uri,this._extHostFileSystemInfo))&&J.push({uri:N.uri,name:N.name||C.basenameOrAuthority(N.uri)})}),this._unconfirmedWorkspace||[H,ue].some(N=>typeof N!="number"||N<0)||ue===0&&J.length===0)return!1;const z=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(H+ue>z.length)return!1;const Z=z.slice(0);Z.splice(H,ue,...J.map(N=>({uri:N.uri,name:N.name||C.basenameOrAuthority(N.uri),index:void 0})));for(let N=0;N<Z.length;N++){const W=Z[N];if(Z.some((O,B)=>B!==N&&s(W.uri,O.uri,this._extHostFileSystemInfo)))return!1}Z.forEach((N,W)=>N.index=W);const{added:M,removed:q}=w(z,Z,u,this._extHostFileSystemInfo);if(M.length===0&&q.length===0)return!1;if(this._proxy){const N=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(N,H,ue,J).then(void 0,W=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(y.Severity.Error,h.localize(0,null,N,W.toString()),{extension:L},[])})}return this.trySetWorkspaceFolders(Z),!0}getWorkspaceFolder(L,H){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,H)}async getWorkspaceFolder2(L,H){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,H)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,H){let ue,me="";if(typeof L=="string"?(ue=o.URI.file(L),me=L):typeof L!="undefined"&&(ue=L,me=L.fsPath),!ue)return me;const J=this.getWorkspaceFolder(ue,!0);if(!J)return me;typeof H=="undefined"&&this._actualWorkspace&&(H=this._actualWorkspace.folders.length>1);let z=C.relativePath(J.uri,ue);return H&&J.name&&(z=`${J.name}/${z}`),z}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=P.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:H,added:ue,removed:me}=P.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=H||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:ue,removed:me}))}findFiles(L,H,ue,me,J=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${me.value}, entryPoint: findFiles`);let z;if(H===null?z=!1:H&&(typeof H=="string"?z=H:z=H.pattern),J&&J.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:M}=a(L);return this._proxy.$startFileSearch(I.withUndefinedAsNull(Z),I.withUndefinedAsNull(M),I.withUndefinedAsNull(z),I.withUndefinedAsNull(ue),J).then(q=>Array.isArray(q)?q.map(N=>o.URI.revive(N)):[])}async findTextInFiles(L,H,ue,me,J=S.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${me.value}, entryPoint: findTextInFiles`);const z=this._requestIdProvider.getNext(),Z=typeof H.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:H.previewOptions,{includePattern:M,folder:q}=a(H.include),N=typeof H.exclude=="string"?H.exclude:H.exclude?H.exclude.pattern:void 0,W={ignoreSymlinks:typeof H.followSymlinks=="boolean"?!H.followSymlinks:void 0,disregardIgnoreFiles:typeof H.useIgnoreFiles=="boolean"?!H.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof H.useGlobalIgnoreFiles=="boolean"?!H.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof H.useDefaultExcludes=="boolean"?!H.useDefaultExcludes:!0,fileEncoding:H.encoding,maxResults:H.maxResults,previewOptions:Z,afterContext:H.afterContext,beforeContext:H.beforeContext,includePattern:M,excludePattern:N},O=!1;if(this._activeSearchCallbacks[z]=B=>{if(O)return;const Y=o.URI.revive(B.resource);B.results.forEach(he=>{t.resultIsMatch(he)?ue({uri:Y,preview:{text:he.preview.text,matches:g.mapArrayOrNot(he.preview.matches,De=>new m.Range(De.startLineNumber,De.startColumn,De.endLineNumber,De.endColumn))},ranges:g.mapArrayOrNot(he.ranges,De=>new m.Range(De.startLineNumber,De.startColumn,De.endLineNumber,De.endColumn))}):ue({uri:Y,text:he.text,lineNumber:he.lineNumber})})},J.isCancellationRequested)return{};try{const B=await this._proxy.$startTextSearch(L,I.withUndefinedAsNull(q),W,z,J);return delete this._activeSearchCallbacks[z],B||{}}catch(B){throw delete this._activeSearchCallbacks[z],B}}$handleTextSearchResult(L,H){this._activeSearchCallbacks[H]&&this._activeSearchCallbacks[H](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};A=Ve([ze(0,f.IExtHostRpcService),ze(1,l.IExtHostInitDataService),ze(2,p.IExtHostFileSystemInfo),ze(3,d.ILogService)],A),e.ExtHostWorkspace=A,e.IExtHostWorkspace=c.createDecorator("IExtHostWorkspace");function a(R){let L,H;return R&&(typeof R=="string"?L=R:(L=R.pattern,H=R.baseFolder||o.URI.file(R.base))),{includePattern:L,folder:H}}}),define(we[32],_e([0,1,24,3,30,5,6,151,61,10,12,4,13,15,2]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function d(r,s){if(s){const i=s.split(".");let u=r;for(let w=0;u&&w<i.length;w++)u=u[i[w]];return u}}function y(r){return r instanceof c.URI}function b(r){return r&&r.uri instanceof c.URI&&r.languageId&&typeof r.languageId=="string"}function p(r){return r&&!r.uri&&r.languageId&&typeof r.languageId=="string"}function l(r){return r&&r.uri instanceof c.URI&&(!r.name||typeof r.name=="string")&&(!r.index||typeof r.index=="number")}function f(r){if(y(r))return{resource:r};if(b(r))return{resource:r.uri,overrideIdentifier:r.languageId};if(p(r))return{overrideIdentifier:r.languageId};if(l(r))return{resource:r.uri};if(r===null)return{resource:null}}let m=class{constructor(s,i,u){this._proxy=s.getProxy(E.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=u,this._barrier=new n.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(s=>this._actual)}$initializeConfiguration(s){this._actual=new t(this._proxy,this._extHostWorkspace,s,this._logService),this._barrier.open()}$acceptConfigurationChanged(s,i){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,i))}};m=Ve([ze(0,o.IExtHostRpcService),ze(1,S.IExtHostWorkspace),ze(2,h.ILogService)],m),e.ExtHostConfiguration=m;class t{constructor(s,i,u,w){this._onDidChangeConfiguration=new T.Emitter,this._proxy=s,this._logService=w,this._extHostWorkspace=i,this._configuration=D.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(s,i){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=D.Configuration.parse(s),this._configurationScopes=this._toMap(s.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,u))}getConfiguration(s,i,u){const w=f(i)||{},v=this._toReadonlyValue(s?d(this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace),s):this._configuration.getValue(void 0,w,this._extHostWorkspace.workspace));s&&this._validateConfigurationAccess(s,w,u==null?void 0:u.identifier);function P(a){if(a==null)return null;if(typeof a=="boolean")return a?1:4;switch(a){case k.ConfigurationTarget.Global:return 1;case k.ConfigurationTarget.Workspace:return 4;case k.ConfigurationTarget.WorkspaceFolder:return 5}}const A={has(a){return typeof d(v,a)!="undefined"},get:(a,R)=>{this._validateConfigurationAccess(s?`${s}.${a}`:a,w,u==null?void 0:u.identifier);let L=d(v,a);if(typeof L=="undefined")L=R;else{let H;const ue=(me,J)=>{let z;const Z=()=>{H=H||g.deepClone(v),z=z||d(H,J)};return C.isObject(me)?new Proxy(me,{get:(M,q)=>{if(typeof q=="string"&&q.toLowerCase()==="tojson")return Z(),()=>z;if(H)return z=z||d(H,J),z[q];const N=M[q];return typeof q=="string"?ue(N,`${J}.${q}`):N},set:(M,q,N)=>(Z(),z&&(z[q]=N),!0),deleteProperty:(M,q)=>(Z(),z&&delete z[q],!0),defineProperty:(M,q,N)=>(Z(),z&&Object.defineProperty(z,q,N),!0)}):me};L=ue(L,a)}return L},update:(a,R,L,H)=>{a=s?`${s}.${a}`:a;const ue=P(L);return R!==void 0?this._proxy.$updateConfigurationOption(ue,a,R,w,H):this._proxy.$removeConfigurationOption(ue,a,w,H)},inspect:a=>{var R,L,H,ue,me,J,z,Z;a=s?`${s}.${a}`:a;const M=g.deepClone(this._configuration.inspect(a,w,this._extHostWorkspace.workspace));if(M)return{key:a,defaultValue:(R=M.default)===null||R===void 0?void 0:R.value,globalValue:(L=M.user)===null||L===void 0?void 0:L.value,workspaceValue:(H=M.workspace)===null||H===void 0?void 0:H.value,workspaceFolderValue:(ue=M.workspaceFolder)===null||ue===void 0?void 0:ue.value,defaultLanguageValue:(me=M.default)===null||me===void 0?void 0:me.override,globalLanguageValue:(J=M.user)===null||J===void 0?void 0:J.override,workspaceLanguageValue:(z=M.workspace)===null||z===void 0?void 0:z.override,workspaceFolderLanguageValue:(Z=M.workspaceFolder)===null||Z===void 0?void 0:Z.override,languageIds:M.overrideIdentifiers}}};return typeof v=="object"&&g.mixin(A,v,!1),Object.freeze(A)}_toReadonlyValue(s){const i=u=>C.isObject(u)?new Proxy(u,{get:(w,v)=>i(w[v]),set:(w,v,P)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:(w,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:(w,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:w=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return i(s)}_validateConfigurationAccess(s,i,u){const w=_.OVERRIDE_PROPERTY_PATTERN.test(s)?4:this._configurationScopes.get(s),v=u?`[${u.value}] `:"";if(w===4){typeof(i==null?void 0:i.resource)=="undefined"&&this._logService.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(w===3){(i==null?void 0:i.resource)&&this._logService.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(s,i){const u=new D.ConfigurationChangeEvent(s,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(w,v)=>u.affectsConfiguration(w,f(v))})}_toMap(s){return s.reduce((i,u)=>(i.set(u[0],u[1]),i),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=I.createDecorator("IExtHostConfiguration")});var it=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[104],_e([0,1,2,12,3,5,6,30,36,32,18,37,13,28,4,16,21,15,70,162,11]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y,b,p,l,f){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var t;(function(me){function J(Z){if(Z!=null)return Z}me.from=J;function z(Z){if(Z!=null)return Z}me.to=z})(t=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var r;(function(me){function J(Z){if(Z!=null)return Z}me.from=J;function z(Z){if(Z!=null)return Z}me.to=z})(r=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var s;(function(me){function J(Z){if(Z!=null)return Z}me.from=J;function z(Z){if(Z!=null)return Z}me.to=z})(s=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(me){function J(M){if(M){const q=M;return q&&!!q.process}else return!1}me.is=J;function z(M){if(M==null)return;const q={process:M.process,args:M.args};return M.options&&(q.options=s.from(M.options)),q}me.from=z;function Z(M){if(M!=null)return new k.ProcessExecution(M.process,M.args,M.options)}me.to=Z})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(me){function J(Z){if(Z!=null)return Z}me.from=J;function z(Z){if(Z!=null)return Z}me.to=z})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var w;(function(me){function J(M){if(M){const q=M;return q&&(!!q.commandLine||!!q.command)}else return!1}me.is=J;function z(M){if(M==null)return;const q={};return M.commandLine!==void 0?q.commandLine=M.commandLine:(q.command=M.command,q.args=M.args),M.options&&(q.options=u.from(M.options)),q}me.from=z;function Z(M){if(!(M==null||M.command===void 0&&M.commandLine===void 0))return M.commandLine?new k.ShellExecution(M.commandLine,M.options):new k.ShellExecution(M.command,M.args?M.args:[],M.options)}me.to=Z})(w=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var v;(function(me){function J(M){if(M){let q=M;return q&&q.customExecution==="customExecution"}else return!1}me.is=J;function z(M){return{customExecution:"customExecution"}}me.from=z;function Z(M,q){return q.get(M)}me.to=Z})(v=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var P;(function(me){function J(z,Z){let M;return z.scope!==void 0&&typeof z.scope!="number"?M=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===k.TaskScope.Workspace&&Z&&Z.workspaceFile?M=Z.workspaceFile:M=l.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:M}}me.from=J})(P=e.TaskHandleDTO||(e.TaskHandleDTO={}));var A;(function(me){function J(M,q){if(M==null)return[];const N=[];for(let W of M){const O=z(W,q);O&&N.push(O)}return N}me.fromMany=J;function z(M,q){if(M==null)return;let N;M.execution instanceof k.ProcessExecution?N=i.from(M.execution):M.execution instanceof k.ShellExecution?N=w.from(M.execution):M.execution&&M.execution instanceof k.CustomExecution&&(N=v.from(M.execution));const W=t.from(M.definition);let O;if(M.scope?typeof M.scope=="number"?O=M.scope:O=M.scope.uri:O=k.TaskScope.Workspace,!W||!O)return;const B=M.group?M.group.id:void 0;return{_id:M._id,definition:W,name:M.name,source:{extensionId:q.identifier.value,label:M.source,scope:O},execution:N,isBackground:M.isBackground,group:B,presentationOptions:r.from(M.presentationOptions),problemMatchers:M.problemMatchers,hasDefinedMatchers:M.hasDefinedMatchers,runOptions:M.runOptions?M.runOptions:{reevaluateOnRerun:!0},detail:M.detail}}me.from=z;async function Z(M,q,N){if(M==null)return;let W;i.is(M.execution)?W=i.to(M.execution):w.is(M.execution)?W=w.to(M.execution):v.is(M.execution)&&(W=v.to(M._id,N));const O=t.to(M.definition);let B;if(M.source&&(M.source.scope!==void 0?typeof M.source.scope=="number"?B=M.source.scope:B=await q.resolveWorkspaceFolder(g.URI.revive(M.source.scope)):B=k.TaskScope.Workspace),!O||!B)return;const Y=new k.Task(O,B,M.name,M.source.label,W,M.problemMatchers);return M.isBackground!==void 0&&(Y.isBackground=M.isBackground),M.group!==void 0&&(Y.group=k.TaskGroup.from(M.group)),M.presentationOptions&&(Y.presentationOptions=r.to(M.presentationOptions)),M._id&&(Y._id=M._id),M.detail&&(Y.detail=M.detail),Y}me.to=Z})(A=e.TaskDTO||(e.TaskDTO={}));var a;(function(me){function J(Z){return Z}me.from=J;function z(Z){if(!!Z)return Object.assign(Object.create(null),Z)}me.to=z})(a=e.TaskFilterDTO||(e.TaskFilterDTO={}));class R{constructor(J,z,Z){this._id=z,this._task=Z,m.set(this,void 0),it(this,m,J,"f")}get task(){return this._task}terminate(){Be(this,m,"f").terminateTask(this)}fireDidStartProcess(J){}fireDidEndProcess(J){}}m=new WeakMap;var L;(function(me){function J(z){return{id:z._id,task:void 0}}me.from=J})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let H=class{constructor(J,z,Z,M,q,N,W,O){this._onDidExecuteTask=new S.Emitter,this._onDidTerminateTask=new S.Emitter,this._onDidTaskProcessStarted=new S.Emitter,this._onDidTaskProcessEnded=new S.Emitter,this._proxy=J.getProxy(E.MainContext.MainThreadTask),this._workspaceProvider=Z,this._editorService=M,this._configurationService=q,this._terminalService=N,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=W,this._deprecationService=O,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(J,z,Z){if(!Z)return new k.Disposable(()=>{});const M=this.nextHandle();return this._handlers.set(M,{type:z,provider:Z,extension:J}),this._proxy.$registerTaskProvider(M,z),new k.Disposable(()=>{this._handlers.delete(M),this._proxy.$unregisterTaskProvider(M)})}registerTaskSystem(J,z){this._proxy.$registerTaskSystem(J,z)}fetchTasks(J){return this._proxy.$fetchTasks(a.from(J)).then(async z=>{const Z=[];for(let M of z){const q=await A.to(M,this._workspaceProvider,this._providedCustomExecutions2);q&&Z.push(q)}return Z})}get taskExecutions(){const J=[];return this._taskExecutions.forEach(z=>J.push(z)),J}terminateTask(J){if(!(J instanceof R))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(J._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(J,z,Z){const M=this._providedCustomExecutions2.get(J.id);if(M){if(this._activeCustomExecutions2.get(J.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(J.id,M),this._terminalService.attachPtyToTerminal(z,await M.callback(Z))}this._lastStartedTask=J.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(J)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(J){const z=await this.getTaskExecution(J);this._taskExecutionPromises.delete(J.id),this._taskExecutions.delete(J.id),this.customExecutionComplete(J),this._onDidTerminateTask.fire({execution:z})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(J){const z=await this.getTaskExecution(J.id);this._onDidTaskProcessStarted.fire({execution:z,processId:J.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(J){const z=await this.getTaskExecution(J.id);this._onDidTaskProcessEnded.fire({execution:z,exitCode:J.exitCode})}$provideTasks(J,z){const Z=this._handlers.get(J);if(!Z)return Promise.reject(new Error("no handler found"));const M=[],q=T.asPromise(()=>Z.provider.provideTasks(n.CancellationToken.None)).then(N=>this.provideTasksInternal(z,M,Z,N));return new Promise(N=>{q.then(W=>{Promise.all(M).then(()=>{N(W)})})})}async $resolveTask(J,z){const Z=this._handlers.get(J);if(!Z)return Promise.reject(new Error("no handler found"));if(z.definition.type!==Z.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${Z.type}].`);const M=await A.to(z,this._workspaceProvider,this._providedCustomExecutions2);if(!M)throw new Error("Unexpected: Task cannot be resolved.");const q=await Z.provider.resolveTask(M,n.CancellationToken.None);if(!q)return;this.checkDeprecation(q,Z);const N=A.from(q,Z.extension);if(!N)throw new Error("Unexpected: Task cannot be resolved.");if(q.definition!==M.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return v.is(N.execution)&&await this.addCustomExecution(N,q,!0),await this.resolveTaskInternal(N)}nextHandle(){return this._handleCounter++}async addCustomExecution(J,z,Z){const M=await this._proxy.$createTaskId(J);!Z&&!this._providedCustomExecutions2.has(M)&&this._notProvidedCustomExecutions.add(M),this._providedCustomExecutions2.set(M,z.execution)}async getTaskExecution(J,z){if(typeof J=="string"){const q=this._taskExecutionPromises.get(J);if(!q)throw new Error("Unexpected: The specified task is missing an execution");return q}let Z=this._taskExecutionPromises.get(J.id);if(Z)return Z;const M=new Promise(async(q,N)=>{const W=z||await A.to(J.task,this._workspaceProvider,this._providedCustomExecutions2);W?q(new R(this,J.id,W)):N("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(J.id,M),M.then(q=>(this._taskExecutions.set(J.id,q),q),q=>Promise.reject(q))}checkDeprecation(J,z){J._deprecated&&this._deprecationService.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(J){this._activeCustomExecutions2.get(J.id)&&this._activeCustomExecutions2.delete(J.id),this._notProvidedCustomExecutions.has(J.id)&&this._lastStartedTask!==J.id&&(this._providedCustomExecutions2.delete(J.id),this._notProvidedCustomExecutions.delete(J.id));let Z=this._notProvidedCustomExecutions.values(),M=Z.next();for(;!M.done;)!this._activeCustomExecutions2.has(M.value)&&this._lastStartedTask!==M.value&&(this._providedCustomExecutions2.delete(M.value),this._notProvidedCustomExecutions.delete(M.value)),M=Z.next()}};H=Ve([ze(0,o.IExtHostRpcService),ze(1,h.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,b.ILogService),ze(7,p.IExtHostApiDeprecationService)],H),e.ExtHostTaskBase=H;let ue=class extends H{constructor(J,z,Z,M,q,N,W,O){super(J,z,Z,M,q,N,W,O);this.registerTaskSystem(d.Schemas.vscodeRemote,{scheme:d.Schemas.vscodeRemote,authority:"",platform:y.PlatformToString(0)})}async executeTask(J,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const Z=A.from(z,J);if(Z===void 0)throw new Error("Task is not valid");if(v.is(Z.execution))await this.addCustomExecution(Z,z,!1);else throw new f.NotSupportedError;const M=await this.getTaskExecution(await this._proxy.$getTaskExecution(Z),z);return this._proxy.$executeTask(Z).catch(q=>{throw new Error(q)}),M}provideTasksInternal(J,z,Z,M){const q=[];if(M)for(let N of M){this.checkDeprecation(N,Z),(!N.definition||!J[N.definition.type])&&this._logService.warn(`The task [${N.source}, ${N.name}] uses an undefined task type. The task will be ignored in the future.`);const W=A.from(N,Z.extension);W&&v.is(W.execution)?(q.push(W),z.push(this.addCustomExecution(W,N,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:q,extension:Z.extension}}async resolveTaskInternal(J){if(v.is(J.execution))return J;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(J,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(J,z,Z){}};ue=Ve([ze(0,o.IExtHostRpcService),ze(1,h.IExtHostInitDataService),ze(2,D.IExtHostWorkspace),ze(3,_.IExtHostDocumentsAndEditors),ze(4,C.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,b.ILogService),ze(7,p.IExtHostApiDeprecationService)],ue),e.WorkerExtHostTask=ue,e.IExtHostTask=c.createDecorator("IExtHostTask")});var it=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)},Dn=this&&this.__rest||function(ee,e){var g={};for(var T in ee)Object.prototype.hasOwnProperty.call(ee,T)&&e.indexOf(T)<0&&(g[T]=ee[T]);if(ee!=null&&typeof Object.getOwnPropertySymbols=="function")for(var S=0,T=Object.getOwnPropertySymbols(ee);S<T.length;S++)e.indexOf(T[S])<0&&Object.prototype.propertyIsEnumerable.call(ee,T[S])&&(g[T[S]]=ee[T[S]]);return g};define(we[211],_e([0,1,17,12,23,18,3,49,40,7,24,10,2,34,4,5,36,13,64,9,6,30,172,96]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y,b,p,l,f,m,t,r){"use strict";var s,i,u,w,v;Object.defineProperty(e,"__esModule",{value:!0}),e.MirroredTestCollection=e.TestItemFilteredWrapper=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let P=class{constructor(O,B,Y){this.resultsChangedEmitter=new k.Emitter,this.controllers=new q,this.ownedTests=new t.OwnedTestCollection,this.mainThreadSubscriptions=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=O.getProxy(d.MainContext.MainThreadTesting),this.subscriptions=B.createInstance(N,this.ownedTests,this.controllers),this.runTracker=new a(this.proxy),this.workspaceObservers=new z(this.proxy),this.textDocumentObservers=new Z(this.proxy,Y)}registerTestController(O,B){const Y=h.generateUuid(),he=this.controllers.register(Y,B);return this.proxy.$registerTestController(Y),C.toDisposable(()=>{he.dispose(),this.proxy.$unregisterTestController(Y)})}createTextDocumentTestObserver(O){return this.textDocumentObservers.checkout(O.uri)}createWorkspaceTestObserver(O){return this.workspaceObservers.checkout(O.uri)}async runTests(O,B=E.CancellationToken.None){const Y=he=>he.map(this.getInternalTestForReference,this).filter(I.isDefined).map(De=>({src:De.src,testId:De.item.extId}));await this.proxy.$runTests({exclude:O.exclude?Y(O.exclude).map(he=>he.testId):void 0,tests:Y(O.tests),debug:O.debug},B)}createTestRun(O,B,Y=!0){return this.runTracker.createTestRun(O,B,Y)}$publishTestResults(O){this.results=Object.freeze(O.map(B=>n.deepFreeze(l.TestResults.to(B))).concat(this.results).sort((B,Y)=>Y.completedAt-B.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $subscribeToTests(O,B){const Y=o.URI.revive(B),{disposable:he,info:De}=await this.subscriptions.subscribeToTests(O,Y);this.mainThreadSubscriptions.set(M(O,Y),he),De&&(this.proxy.$publishDiff(O,Y,De.collection.reviveDiff()),De.collection.onDidGenerateDiff(Oe=>this.proxy.$publishDiff(O,Y,Oe)),De.initialSubscribeP.then(()=>De.collection.pushDiff([3,-1])))}async $expandTest(O,B){const Y=this.subscriptions.getCollectionById(O.src.tree);Y&&(await Y.expand(O.testId,B<0?Infinity:B),Y.flushDiff())}$unsubscribeFromTests(O,B){var Y;const he=o.URI.revive(B),De=M(O,he);(Y=this.mainThreadSubscriptions.get(De))===null||Y===void 0||Y.dispose(),this.mainThreadSubscriptions.delete(De)}$acceptDiff(O,B,Y){O===1?this.textDocumentObservers.acceptDiff(o.URI.revive(B),Y):this.workspaceObservers.acceptDiff(o.URI.revive(B),Y)}async $runTestsForProvider(O,B){const Y=this.controllers.get(O.tests[0].src.controller);if(!Y)return;const he=O.tests.map(({testId:He,src:Ye})=>this.ownedTests.getTestById(He,Ye==null?void 0:Ye.tree)).filter(I.isDefined).map(([He,Ye])=>Ye),De=O.excludeExtIds.map(He=>this.ownedTests.getTestById(He)).filter(I.isDefined).filter(([He,Ye])=>he.some(qe=>He.comparePositions(qe,Ye)===1));if(!he.length)return;const Oe={tests:he.map(He=>H.unwrap(He.actual)),exclude:De.map(([,He])=>H.unwrap(He.actual)),debug:O.debug},Me=this.runTracker.prepareForMainThreadTestRun(Oe,R.fromInternal(O),B);try{await Y.runTests(Oe,B)}finally{Me.isRunning&&!B.isCancellationRequested&&await k.Event.toPromise(Me.onEnd),this.runTracker.cancelRunById(O.runId)}}$cancelExtensionTestRun(O){O===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(O)}$lookupTest(O){const B=this.ownedTests.getTestById(O.testId);if(!B)return Promise.resolve(void 0);const Y=B[1],{actual:he,discoverCts:De,expandLevels:Oe}=Y,Me=Dn(Y,["actual","discoverCts","expandLevels"]);return Promise.resolve(Me)}getInternalTestForReference(O){var B,Y;return(Y=(B=this.workspaceObservers.getMirroredTestDataByReference(O))!==null&&B!==void 0?B:this.subscriptions.getCollectionTestByReference(O))!==null&&Y!==void 0?Y:this.textDocumentObservers.getMirroredTestDataByReference(O)}};P=Ve([ze(0,b.IExtHostRpcService),ze(1,c.IInstantiationService),ze(2,y.IExtHostDocumentsAndEditors)],P),e.ExtHostTesting=P;class A extends C.Disposable{constructor(O,B,Y){super();this.dto=O,this.proxy=B,this.task=new Set,this.sharedTestIds=new Set,this.endEmitter=this._register(new k.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new E.CancellationTokenSource(Y)),this._register(this.cts.token.onCancellationRequested(()=>{for(const he of this.task)he.end()}))}get isRunning(){return this.task.size>0}get id(){return this.dto.id}createRun(O){const B=new L(O,this.cts.token,this.dto,this.sharedTestIds,this.proxy,()=>{this.task.delete(B),this.isRunning||this.dispose()});return this.task.add(B),B}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}}class a{constructor(O){this.proxy=O,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(O,B,Y){return this.getTracker(O,B,Y)}cancelRunById(O){for(const B of this.tracked.values())if(B.id===O){B.dispose();return}}cancelAllRuns(){for(const O of this.tracked.values())O.dispose()}createTestRun(O,B,Y){var he,De;const Oe=this.tracked.get(O);if(Oe)return Oe.createRun(B);const Me=R.fromPublic(O);this.proxy.$startedExtensionTestRun({debug:O.debug,exclude:(De=(he=O.exclude)===null||he===void 0?void 0:he.map(Ye=>Ye.id))!==null&&De!==void 0?De:[],id:Me.id,tests:O.tests.map(Ye=>Ye.id),persist:Y});const He=this.getTracker(O,Me);return He.onEnd(()=>this.proxy.$finishedExtensionTestRun(Me.id)),He.createRun(B)}getTracker(O,B,Y){const he=new A(B,this.proxy,Y);return this.tracked.set(O,he),he.onEnd(()=>this.tracked.delete(O)),he}}e.TestRunCoordinator=a;class R{constructor(O,B,Y){this.id=O,this.include=B,this.exclude=Y}static fromPublic(O){var B,Y;return new R(h.generateUuid(),new Set(O.tests.map(he=>he.id)),new Set((Y=(B=O.exclude)===null||B===void 0?void 0:B.map(he=>he.id))!==null&&Y!==void 0?Y:_.Iterable.empty()))}static fromInternal(O){return new R(O.runId,new Set(O.tests.map(B=>B.testId)),new Set(O.excludeExtIds))}isIncluded(O){for(let B=O;B;B=B.parent){if(this.include.has(B.id))return!0;if(this.exclude.has(B.id))return!1}return!0}}e.TestRunDto=R;class L{constructor(O,B,Y,he,De,Oe){this.name=O,this.token=B,s.set(this,void 0),i.set(this,void 0),u.set(this,void 0),w.set(this,void 0),v.set(this,!1),this.taskId=h.generateUuid(),it(this,w,Oe,"f"),it(this,s,De,"f"),it(this,i,Y,"f"),it(this,u,he,"f"),De.$startedTestRunTask(Y.id,{id:this.taskId,name:O,running:!0})}setState(O,B,Y){!Be(this,v,"f")&&Be(this,i,"f").isIncluded(O)&&(this.ensureTestIsKnown(O),Be(this,s,"f").$updateTestStateInRun(Be(this,i,"f").id,this.taskId,O.id,B,Y))}appendMessage(O,B){!Be(this,v,"f")&&Be(this,i,"f").isIncluded(O)&&(this.ensureTestIsKnown(O),Be(this,s,"f").$appendTestMessageInRun(Be(this,i,"f").id,this.taskId,O.id,l.TestMessage.from(B)))}appendOutput(O){Be(this,v,"f")||Be(this,s,"f").$appendOutputToRun(Be(this,i,"f").id,this.taskId,S.VSBuffer.fromString(O))}end(){Be(this,v,"f")||(it(this,v,!0,"f"),Be(this,s,"f").$finishedTestRunTask(Be(this,i,"f").id,this.taskId),Be(this,w,"f").call(this))}ensureTestIsKnown(O){const B=Be(this,u,"f");if(B.has(O.id))return;const Y=[];for(;Y.unshift(l.TestItem.from(O)),!(B.has(O.id)||(B.add(O.id),!O.parent));)O=O.parent;Be(this,s,"f").$addTestsToRun(Be(this,i,"f").id,Y)}}s=new WeakMap,i=new WeakMap,u=new WeakMap,w=new WeakMap,v=new WeakMap;class H extends f.TestItemImpl{constructor(O,B,Y){super(O.id,O.label,O.uri,void 0);if(this.actual=O,this.filterDocument=B,this.wrappedParent=Y,this.disposable=new C.DisposableStore,!(O instanceof f.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${O.id} did not`);this.debuggable=O.debuggable,this.runnable=O.runnable,this.description=O.description,this.error=O.error,this.status=O.status,this.range=O.range;const he=p.getPrivateApiFor(this),De=p.getPrivateApiFor(O);this.disposable.add(De.bus.event(Oe=>{switch(Oe[0]){case 3:this[Oe[1]]=Oe[2];break;case 0:const Me=H.getWrapperForTestItem(Oe[1],this.filterDocument,this);p.getPrivateApiFor(Me).parent=O,Me.refreshMatch();break;case 1:this.dispose();break;default:he.bus.fire(Oe)}}))}static removeFilter(O){this.wrapperMap.delete(O)}static getWrapperForTestItem(O,B,Y){let he=this.wrapperMap.get(B);if(he==null?void 0:he.has(O))return he.get(O);he||(he=new WeakMap,this.wrapperMap.set(B,he));const De=new H(O,B,Y);return he.set(O,De),De}static unwrap(O){return O instanceof H?O.actual:O}get hasNodeMatchingFilter(){return this._cachedMatchesFilter===void 0?this.refreshMatch():this._cachedMatchesFilter}refreshMatch(){var O,B;if(this.disposed)return!1;const Y=this._cachedMatchesFilter;for(const De of this.actual.children.values()){const Oe=H.getWrapperForTestItem(De,this.filterDocument,this);Oe.hasNodeMatchingFilter?this.children.has(Oe.id)||this.addChild(Oe):Oe.hide()}const he=this.children.size>0||((O=this.actual.uri)===null||O===void 0?void 0:O.toString())===this.filterDocument.uri.toString();return this._cachedMatchesFilter=he,he!==Y&&((B=this.wrappedParent)===null||B===void 0?void 0:B._cachedMatchesFilter)!==void 0&&this.wrappedParent.refreshMatch(),this._cachedMatchesFilter}hide(){this.wrappedParent&&p.getPrivateApiFor(this.wrappedParent).children.delete(this.id),p.getPrivateApiFor(this).bus.fire([1])}dispose(){var O;if(!this.disposed){this.disposed=!0,this.disposable.dispose(),this.hide(),(O=this.wrappedParent)===null||O===void 0||O.refreshMatch();for(const B of this.children.values())B.dispose()}}}e.TestItemFilteredWrapper=H,H.wrapperMap=new WeakMap;class ue extends r.IncrementalChangeCollector{constructor(O){super();this.emitter=O,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(O){this.added.add(O)}update(O){Object.assign(O.revived,l.TestItem.toPlain(O.item)),this.added.has(O)||this.updated.add(O)}remove(O){if(this.added.has(O)){this.added.delete(O);return}if(this.updated.delete(O),O.parent&&this.alreadyRemoved.has(O.parent)){this.alreadyRemoved.add(O.item.extId);return}this.removed.add(O)}getChangeEvent(){const{added:O,updated:B,removed:Y}=this;return{get added(){return[...O].map(he=>he.revived)},get updated(){return[...B].map(he=>he.revived)},get removed(){return[...Y].map(he=>he.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class me extends r.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new k.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTestItems(){return this.getAllAsTestItem([...this.roots])}getAllAsTestItem(O){let B=[];for(const Y of O){const he=this.items.get(Y);he&&B.push(he.revived)}return B}getMirroredTestDataById(O){return this.items.get(O)}getMirroredTestDataByReference(O){return this.items.get(O.id)}createItem(O,B){return Object.assign(Object.assign({},O),{revived:l.TestItem.toPlain(O.item),depth:B?B.depth+1:0,children:new Set})}createChangeCollector(){return new ue(this.changeEmitter)}}e.MirroredTestCollection=me;class J{constructor(){this.resources=new Map}checkout(O){var B,Y;const he=O.toString(),De=(B=this.resources.get(he))!==null&&B!==void 0?B:this.createObserverData(O);return(Y=De.pendingDeletion)===null||Y===void 0||Y.dispose(),De.observers++,{onDidChangeTest:De.tests.onDidChangeTests,onDidDiscoverInitialTests:new k.Emitter().event,get tests(){return De.tests.rootTestItems},dispose:D.once(()=>{--De.observers||(De.pendingDeletion=this.eventuallyDispose(O))})}}getMirroredTestDataByReference(O){for(const{tests:B}of this.resources.values()){const Y=B.getMirroredTestDataByReference(O);if(Y)return Y}}eventuallyDispose(O){return T.disposableTimeout(()=>this.unlisten(O),10*1e3)}createObserverData(O){const B=new me,Y=this.listen(O,De=>B.apply(De)),he={observers:0,tests:B,listener:Y};return this.resources.set(O.toString(),he),he}unlisten(O){var B;const Y=O.toString(),he=this.resources.get(Y);he&&(he.observers=-1,(B=he.pendingDeletion)===null||B===void 0||B.dispose(),he.listener.dispose(),this.resources.delete(Y))}}class z extends J{constructor(O){super();this.proxy=O,this.diffListeners=new Map}acceptDiff(O,B){var Y;(Y=this.diffListeners.get(O.toString()))===null||Y===void 0||Y(B)}listen(O,B){this.proxy.$subscribeToDiffs(0,O);const Y=O.toString();return this.diffListeners.set(Y,B),C.toDisposable(()=>{this.proxy.$unsubscribeFromDiffs(0,O),this.diffListeners.delete(Y)})}}class Z extends J{constructor(O,B){super();this.proxy=O,this.documents=B,this.diffListeners=new Map}acceptDiff(O,B){var Y;(Y=this.diffListeners.get(O.toString()))===null||Y===void 0||Y(B)}listen(O,B){if(!this.documents.getDocument(O))return C.toDisposable(()=>{});const he=O.toString();return this.diffListeners.set(he,B),this.proxy.$subscribeToDiffs(1,O),C.toDisposable(()=>{this.proxy.$unsubscribeFromDiffs(1,O),this.diffListeners.delete(he)})}}const M=(W,O)=>`${W}:${O.toString()}`;class q extends C.Disposable{constructor(){super(...arguments);this.registeredEmitter=this._register(new k.Emitter),this.unregisteredEmitter=this._register(new k.Emitter),this.value=new Map,this.onRegistered=this.registeredEmitter.event}register(O,B){return this.value.set(O,B),this.registeredEmitter.fire({controller:B,controllerId:O}),C.toDisposable(()=>{this.value.delete(O),this.unregisteredEmitter.fire({controller:B,controllerId:O})})}get(O){return this.value.get(O)}[Symbol.iterator](){return this.value[Symbol.iterator]()}}let N=class extends C.Disposable{constructor(O,B,Y,he){super();this.ownedTests=O,this.controllers=B,this.documents=Y,this.workspace=he,this.subs=new Map,this._register(B.onRegistered(({controller:De,controllerId:Oe})=>{const Me=[...this.subs.values()];setTimeout(()=>{for(const{subscribeFn:He}of Me)He(Oe,De)},0)}))}getCollectionById(O){return g.mapFind(this.subs.values(),B=>B.collection.treeId===O?B.collection:void 0)}getCollectionTestByReference(O){return g.mapFind(this.subs.values(),B=>B.collection.getTestByReference(O))}async createDefaultDocumentTestRoot(O,B,Y,he){if(!O)return;const{disposable:De,info:Oe}=await this.subscribeToTests(0,O.uri);if(!Oe)return;const Me=_.Iterable.find(Oe.collection.roots,Ye=>Ye.src.controller===Y);if(!Me)return;const He=H.getWrapperForTestItem(Me.actual,B);return Oe.collection.expand(Me.actual.id,Infinity),He.refreshMatch(),he.onCancellationRequested(()=>{H.removeFilter(B),He.dispose(),De.dispose()}),He}async subscribeToTests(O,B){const Y=M(O,B),he=this.subs.get(Y);if(he)return he.listeners++,{disposable:this.getUnsubscriber(Y),info:he};const De=new E.CancellationTokenSource;let Oe;if(O===1){let G=this.documents.getDocument(B);if(!G){const te=new C.DisposableStore;G=await new Promise(re=>{te.add(T.disposableTimeout(()=>re(void 0),5e3)),te.add(this.documents.onDidAddDocuments(K=>{const oe=K.find(fe=>fe.document.uri.toString()===B.toString());oe&&re(oe)}))}).finally(()=>te.dispose())}if(G){const te=await this.workspace.getWorkspaceFolder2(B,!1);Oe=(re,K)=>re.createDocumentTestRoot?re.createDocumentTestRoot(G.document,De.token):this.createDefaultDocumentTestRoot(te,G.document,K,De.token)}}else{const G=await this.workspace.getWorkspaceFolder2(B,!1);G&&(Oe=te=>te.createWorkspaceTestRoot(G,De.token))}if(!Oe)return{disposable:C.toDisposable(()=>{}),info:void 0};const Me=async(G,te)=>{try{const re=await Oe(te,G);re&&Ye.addRoot(re,G)}catch(re){console.error(re)}},He=new C.DisposableStore,Ye=He.add(this.ownedTests.createForHierarchy());He.add(C.toDisposable(()=>De.dispose(!0)));const qe=[];for(const[G,te]of this.controllers)qe.push(Me(G,te));const Xe=Promise.all(qe).then(()=>{}),$={store:He,listeners:1,initialSubscribeP:Xe,collection:Ye,subscribeFn:Me};return this.subs.set(Y,$),{disposable:this.getUnsubscriber(Y),info:$}}getUnsubscriber(O){return C.toDisposable(()=>{const B=this.subs.get(O);B&&--B.listeners==0&&(B.store.dispose(),this.subs.delete(O))})}};N=Ve([ze(2,y.IExtHostDocumentsAndEditors),ze(3,m.IExtHostWorkspace)],N)}),define(we[212],_e([0,1,17,76,27,81,22,16,14,25,8,10,2,116,136,91,45,165,210,38]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y,b,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let f=class{constructor(P,A,a,R){this.configurationService=P,this.workspaceContextService=A,this.editorGroupsService=a,this.pathService=R}text(P,A,a={}){P=this.getContentPattern(P,a);const R=this.configurationService.getValue(),L=A&&A.some(ue=>!this.configurationService.getValue({resource:ue}).search.useRipgrep),H=this.commonQuery(A==null?void 0:A.map(y.toWorkspaceFolder),a);return Object.assign(Object.assign({},H),{type:2,contentPattern:P,previewOptions:a.previewOptions,maxFileSize:a.maxFileSize,usePCRE2:R.search.usePCRE2||L||!1,beforeContext:a.beforeContext,afterContext:a.afterContext,userDisabledExcludesAndIgnoreFiles:a.disregardExcludeSettings&&a.disregardIgnoreFiles})}getContentPattern(P,A){const a=this.configurationService.getValue();P.isRegExp&&(P.pattern=P.pattern.replace(/\r?\n/g,"\\n"));const R=Object.assign(Object.assign({},P),{wordSeparators:a.editor.wordSeparators});return this.isCaseSensitive(P,A)&&(R.isCaseSensitive=!0),this.isMultiline(P)&&(R.isMultiline=!0),R}file(P,A={}){const a=this.commonQuery(P,A);return Object.assign(Object.assign({},a),{type:1,filePattern:A.filePattern?A.filePattern.trim():A.filePattern,exists:A.exists,sortByScore:A.sortByScore,cacheKey:A.cacheKey})}handleIncludeExclude(P,A){return P?(P=Array.isArray(P)?P.map(i):i(P),A?this.parseSearchPaths(P):{pattern:t(...Array.isArray(P)?P:[P])}):{}}commonQuery(P=[],A={}){const a=this.handleIncludeExclude(A.includePattern,A.expandPatterns),R=this.handleIncludeExclude(A.excludePattern,A.expandPatterns),L=P.length>1,H=(a.searchPaths&&a.searchPaths.length?a.searchPaths.map(J=>this.getFolderQueryForSearchPath(J,A,R)):P.map(J=>this.getFolderQueryForRoot(J,A,R,L))).filter(J=>!!J),ue={_reason:A._reason,folderQueries:H,usingSearchPaths:!!(a.searchPaths&&a.searchPaths.length),extraFileResources:A.extraFileResources,excludePattern:R.pattern,includePattern:a.pattern,onlyOpenEditors:A.onlyOpenEditors,maxResults:A.maxResults};if(A.onlyOpenEditors){const z=g.coalesce(g.flatten(this.editorGroupsService.groups.map(M=>M.editors.map(q=>q.resource)))).filter(M=>l.pathIncludedInQuery(ue,M.fsPath)),Z=this.commonQueryFromFileList(z);return Object.assign(Object.assign({},ue),Z)}const me=A.extraFileResources&&A.extraFileResources.filter(J=>l.pathIncludedInQuery(ue,J.fsPath));return ue.extraFileResources=me&&me.length?me:void 0,ue}commonQueryFromFileList(P){const A=[],a=new k.ResourceMap,R={};let L=!1;return P.forEach(H=>{var ue,me;if(H.scheme===D.Schemas.walkThrough)return;if(C.isAbsolutePath(H)){const z=(me=(ue=this.workspaceContextService.getWorkspaceFolder(H))===null||ue===void 0?void 0:ue.uri)!==null&&me!==void 0?me:H.with({path:_.dirname(H.fsPath)});let Z=a.get(z);Z||(L=!0,Z={folder:z,includePattern:{}},A.push(Z),a.set(z,Z));const M=_.relative(z.fsPath,H.fsPath);I.assertIsDefined(Z.includePattern)[M.replace(/\\/g,"/")]=!0}else H.fsPath&&(L=!0,R[H.fsPath]=!0)}),{folderQueries:A,includePattern:R,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(P,A){if(A.isSmartCase){if(P.isRegExp){if(n.containsUppercaseCharacter(P.pattern,!0))return!0}else if(n.containsUppercaseCharacter(P.pattern))return!0}return!!P.isCaseSensitive}isMultiline(P){return P.isMultiline||P.isRegExp&&h.isMultilineRegexSource(P.pattern)||P.pattern.indexOf(`
`)>=0?!0:!!P.isMultiline}parseSearchPaths(P){const A=Z=>_.isAbsolute(Z)||/^\.\.?([\/\\]|$)/.test(Z),R=(Array.isArray(P)?P:r(P)).map(Z=>{const M=this.pathService.resolvedUserHome;return M?E.untildify(Z,M.scheme===D.Schemas.file?M.fsPath:M.path):Z}),L=T.groupBy(R,Z=>A(Z)?"searchPaths":"exprSegments"),H=(L.exprSegments||[]).map(Z=>n.rtrim(Z,"/")).map(Z=>n.rtrim(Z,"\\")).map(Z=>(Z[0]==="."&&(Z="*"+Z),s(Z))),ue={},me=this.expandSearchPathPatterns(L.searchPaths||[]);me&&me.length&&(ue.searchPaths=me);const J=g.flatten(H),z=t(...J);return z&&(ue.pattern=z),ue}getExcludesForFolder(P,A){return A.disregardExcludeSettings?void 0:l.getExcludes(P,!A.disregardSearchExcludeSettings)}expandSearchPathPatterns(P){if(!P||!P.length)return[];const A=g.flatten(P.map(R=>{let{pathPortion:L,globPortion:H}=m(R);H&&(H=u(H));const ue=this.expandOneSearchPath(L);return g.flatten(ue.map(me=>this.resolveOneSearchPathPattern(me,H)))})),a=new Map;return A.forEach(R=>{const L=R.searchPath.toString(),H=a.get(L);H?R.pattern&&(H.pattern=H.pattern||{},H.pattern[R.pattern]=!0):a.set(L,{searchPath:R.searchPath,pattern:R.pattern?t(R.pattern):void 0})}),Array.from(a.values())}expandOneSearchPath(P){if(_.isAbsolute(P)){const A=this.workspaceContextService.getWorkspace().folders;return A[0]&&A[0].uri.scheme!==D.Schemas.file?[{searchPath:A[0].uri.with({path:P})}]:[{searchPath:o.URI.file(_.normalize(P))}]}if(this.workspaceContextService.getWorkbenchState()===2){const A=this.workspaceContextService.getWorkspace().folders[0].uri;if(P=i(P),P.startsWith("../")||P===".."){const R=_.posix.resolve(A.path,P);return[{searchPath:A.with({path:R})}]}const a=u(P);return[{searchPath:A,pattern:a}]}else{if(P==="./"||P===".\\")return[];{const A=P.replace(/^\.[\/\\]/,""),R=this.workspaceContextService.getWorkspace().folders.map(L=>{const H=A.match(new RegExp(`^${n.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return H?{match:H,folder:L}:null}).filter(I.isDefined);if(R.length)return R.map(L=>{const H=L.match[1];return{searchPath:L.folder.uri,pattern:H&&u(H)}});{const L=P.match(/\.[\/\\](.+)[\/\\]?/),H=L?L[1]:P,ue=c.localize(0,null,H);throw new Error(ue)}}}}resolveOneSearchPathPattern(P,A){const a=P.pattern&&A?`${P.pattern}/${A}`:P.pattern||A,R=[{searchPath:P.searchPath,pattern:a}];return a&&!a.endsWith("**")&&R.push({searchPath:P.searchPath,pattern:a+"/**"}),R}getFolderQueryForSearchPath(P,A,a){const R=this.getFolderQueryForRoot(y.toWorkspaceFolder(P.searchPath),A,a,!1);return R?Object.assign(Object.assign({},R),{includePattern:P.pattern}):null}getFolderQueryForRoot(P,A,a,R){let L;const H=o.URI.isUri(P)?P:P.uri;if(a.searchPaths){const Z=a.searchPaths.filter(M=>C.isEqual(M.searchPath,H))[0];if(Z&&!Z.pattern)return null;Z&&(L=Z.pattern)}const ue=this.configurationService.getValue({resource:H}),me=this.getExcludesForFolder(ue,A),J=Object.assign(Object.assign({},me||{}),L||{}),z=o.URI.isUri(P)?C.basename(P):P.name;return{folder:H,folderName:R?z:void 0,excludePattern:Object.keys(J).length>0?J:void 0,fileEncoding:ue.files&&ue.files.encoding,disregardIgnoreFiles:typeof A.disregardIgnoreFiles=="boolean"?A.disregardIgnoreFiles:!ue.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof A.disregardGlobalIgnoreFiles=="boolean"?A.disregardGlobalIgnoreFiles:!ue.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof A.ignoreSymlinks=="boolean"?A.ignoreSymlinks:!ue.search.followSymlinks}}};f=Ve([ze(0,d.IConfigurationService),ze(1,y.IWorkspaceContextService),ze(2,b.IEditorGroupsService),ze(3,p.IPathService)],f),e.QueryBuilder=f;function m(v){const P=v.match(/[\*\{\}\(\)\[\]\?]/);if(P){const A=P.index,a=v.substr(0,A).match(/[/|\\][^/\\]*$/);if(a){let R=v.substr(0,a.index);return R.match(/[/\\]/)||(R+="/"),{pathPortion:R,globPortion:v.substr((a.index||0)+1)}}}return{pathPortion:v}}function t(...v){return v.length?v.reduce((P,A)=>(P[A]=!0,P),Object.create(null)):void 0}function r(v){return S.splitGlobAware(v,",").map(P=>P.trim()).filter(P=>!!P.length)}function s(v){return[`**/${v}/**`,`**/${v}`].map(A=>A.replace(/\*\*\/\*\*/g,"**"))}function i(v){return v.replace(/\\/g,"/")}function u(v){return i(v).replace(/^\.\//,"").replace(/\/+$/g,"")}function w(v,P){v=g.distinct(v,R=>R.toString());const A=[],a=P.getWorkspace();return v&&v.forEach(R=>{let L;if(P.getWorkbenchState()===2)L=C.relativePath(a.folders[0].uri,R),L&&L!=="."&&(L="./"+L);else{const H=P.getWorkspaceFolder(R);if(H){const ue=H.name;if(a.folders.filter(J=>J.name===ue).length===1){const J=C.relativePath(H.uri,R);J===""?L=`./${H.name}`:L=`./${H.name}/${J}`}else L=R.fsPath}}L&&A.push(L)}),A}e.resolveResourcesForSearchIncludes=w}),define(we[213],_e([0,1,25,2,18,11,4,212,38,45]),function(ee,e,g,T,S,E,k,D,_,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const n=7e3;function I(d,y){const b=y.activationEvents;if(!b)return Promise.resolve(void 0);const p=[],l=[];for(const i of b)if(/^workspaceContains:/.test(i)){const u=i.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||d.forceUsingSearch?l.push(u):p.push(u)}if(p.length===0&&l.length===0)return Promise.resolve(void 0);let f;const m=new Promise((i,u)=>{f=i}),t=i=>f({activationEvent:i}),r=Promise.all(p.map(i=>o(d,i,t))).then(()=>{}),s=h(d,y.identifier,l,t);return Promise.all([r,s]).then(()=>{f(void 0)}),m}e.checkActivateWorkspaceContainsExtension=I;async function o(d,y,b){for(const p of d.folders)if(await d.exists(g.joinPath(T.URI.revive(p),y))){b(`workspaceContains:${y}`);return}}async function h(d,y,b,p){if(b.length===0)return Promise.resolve(void 0);const l=new S.CancellationTokenSource,f=d.checkExists(d.folders,b,l.token),m=setTimeout(async()=>{l.cancel(),p(`workspaceContainsTimeout:${b.join(",")}`)},n);let t=!1;try{t=await f}catch(r){E.isPromiseCanceledError(r)||E.onUnexpectedError(r)}l.dispose(),clearTimeout(m),t&&p(`workspaceContains:${b.join(",")}`)}function c(d,y,b,p){const l=d.get(k.IInstantiationService),f=d.get(_.ISearchService),t=l.createInstance(D.QueryBuilder).file(y.map(r=>C.toWorkspaceFolder(T.URI.revive(r))),{_reason:"checkExists",includePattern:b,exists:!0});return f.fileSearch(t,p).then(r=>!!r.limitHit,r=>E.isPromiseCanceledError(r)?!1:Promise.reject(r))}e.checkGlobFileExists=c});var it=this&&this.__classPrivateFieldSet||function(ee,e,g,T,S){if(T==="m")throw new TypeError("Private method is not writable");if(T==="a"&&!S)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ee!==e||!S:!e.has(ee))throw new TypeError("Cannot write private member to an object whose class did not declare it");return T==="a"?S.call(ee,g):S?S.value=g:e.set(ee,g),g},Be=this&&this.__classPrivateFieldGet||function(ee,e,g,T){if(g==="a"&&!T)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ee!==e||!T:!e.has(ee))throw new TypeError("Cannot read private member from an object whose class did not declare it");return g==="m"?T:g==="a"?T.call(ee):T?T.value:e.get(ee)};define(we[33],_e([0,1,129,14,75,25,12,7,22,2,15,5,32,176,73,30,29,174,11,26,23,153,6,92,4,28,74,13,60,65,37,3,213,69,155]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y,b,p,l,f,m,t,r,s,i,u,w,v,P,A,a,R,L,H){"use strict";var ue,me,J;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=s.createDecorator("IHostUtils");let z=class $n extends D.Disposable{constructor(N,W,O,B,Y,he,De,Oe,Me,He){super();this._onDidChangeRemoteConnectionData=this._register(new a.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=W,this._extHostContext=O,this._initData=De,this._extHostWorkspace=B,this._extHostConfiguration=Y,this._logService=he,this._extHostTunnelService=Me,this._extHostTerminalService=He,this._disposables=new D.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(I.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(I.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(I.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new k.Barrier,this._readyToStartExtensionHost=new k.Barrier,this._readyToRunExtensions=new k.Barrier,this._eagerExtensionsActivated=new k.Barrier,this._registry=new b.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new c.ExtHostStorage(this._extHostContext),this._secretState=new L.ExtHostSecretState(this._extHostContext),this._storagePath=Oe,this._instaService=N.createChild(new v.ServiceCollection([c.IExtHostStorage,this._storage],[L.IExtHostSecretState,this._secretState]));const Ye=new Set;this._initData.hostExtensions.forEach(qe=>Ye.add(l.ExtensionIdentifier.toKey(qe))),this._activator=new h.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(qe,Xe,$)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(qe,p.transformErrorForSerialization(Xe),$)},actualActivateExtension:async(qe,Xe)=>{if(Ye.has(l.ExtensionIdentifier.toKey(qe)))return await this._mainThreadExtensionsProxy.$activateExtension(qe,Xe),new h.HostExtension;const $=this._registry.getExtensionDescription(qe);return this._activateExtension($,Xe)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),S.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(N){p.onUnexpectedError(N)}}async deactivateAll(){let N=[];try{N=this._registry.getAllExtensionDescriptions().map(Y=>Y.identifier).filter(Y=>this.isActivated(Y)).map(Y=>this._deactivate(Y))}catch(W){}await Promise.all(N)}isActivated(N){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(N):!1}_activateByEvent(N,W){return this._activator.activateByEvent(N,W)}_activateById(N,W){return this._activator.activateById(N,W)}activateByIdWithErrors(N,W){return this._activateById(N,W).then(()=>{const O=this._activator.getActivatedExtension(N);if(O.activationFailed)return Promise.reject(O.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(N=>this._registry)}getExtensionExports(N){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(N).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const N=_.TernarySearchTree.forPaths(),W=this._registry.getAllExtensionDescriptions().map(O=>{if(!!this._getEntryPoint(O))return this._hostUtils.realpath(O.extensionLocation.fsPath).then(B=>N.set(C.URI.file(B).fsPath,O))});this._extensionPathIndex=Promise.all(W).then(()=>N)}return this._extensionPathIndex}_deactivate(N){let W=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(N))return W;const O=this._activator.getActivatedExtension(N);if(!O)return W;try{typeof O.module.deactivate=="function"&&(W=Promise.resolve(O.module.deactivate()).then(void 0,B=>(this._logService.error(B),Promise.resolve(void 0))))}catch(B){this._logService.error(B)}try{D.dispose(O.subscriptions)}catch(B){this._logService.error(B)}return W}async _activateExtension(N,W){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(N.identifier),this._doActivateExtension(N,W).then(O=>{const B=O.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(N.identifier,B.codeLoadingTime,B.activateCallTime,B.activateResolvedTime,W),this._logExtensionActivationTimes(N,W,"success",B),O},O=>{throw this._logExtensionActivationTimes(N,W,"failure"),O})}_logExtensionActivationTimes(N,W,O,B){const Y=Z(N,W);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},Y),B||{}),{outcome:O}))}_doActivateExtension(N,W){const O=Z(N,W);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",O);const B=this._getEntryPoint(N);if(!B)return Promise.resolve(new h.EmptyExtension(h.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${N.identifier.value} ${JSON.stringify(W)}`),this._logService.flush();const Y=new h.ExtensionActivationTimesBuilder(W.startup);return Promise.all([this._loadCommonJSModule(N.identifier,E.joinPath(N.extensionLocation,B),Y),this._loadExtensionContext(N)]).then(he=>(S.mark(`code/extHost/willActivateExtension/${N.identifier.value}`),$n._callActivate(this._logService,N.identifier,he[0],he[1],Y))).then(he=>(S.mark(`code/extHost/didActivateExtension/${N.identifier.value}`),he))}_loadExtensionContext(N){const W=new m.ExtensionGlobalMemento(N,this._storage),O=new m.ExtensionMemento(N.identifier.value,!1,this._storage),B=new H.ExtensionSecrets(N,this._secretState),Y=N.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,he=this._initData.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${N.identifier.value}`),Promise.all([W.whenReady,O.whenReady,this._storagePath.whenReady]).then(()=>{const De=this;let Oe;return Object.freeze({globalState:W,workspaceState:O,secrets:B,subscriptions:[],get extensionUri(){return N.extensionLocation},get extensionPath(){return N.extensionLocation.fsPath},asAbsolutePath(Me){return T.join(N.extensionLocation.fsPath,Me)},get storagePath(){var Me;return(Me=De._storagePath.workspaceValue(N))===null||Me===void 0?void 0:Me.fsPath},get globalStoragePath(){return De._storagePath.globalValue(N).fsPath},get logPath(){return T.join(De._initData.logsLocation.fsPath,N.identifier.value)},get logUri(){return C.URI.joinPath(De._initData.logsLocation,N.identifier.value)},get storageUri(){return De._storagePath.workspaceValue(N)},get globalStorageUri(){return De._storagePath.globalValue(N)},get extensionMode(){return Y},get extension(){return Oe===void 0&&(Oe=new M(De,N.identifier,N,he)),Oe},get extensionRuntime(){return y.checkProposedApiEnabled(N),De.extensionRuntime},get environmentVariableCollection(){return De._extHostTerminalService.getEnvironmentVariableCollection(N)}})})}static _callActivate(N,W,O,B,Y){return O=O||{activate:void 0,deactivate:void 0},this._callActivateOptional(N,W,O,B,Y).then(he=>new h.ActivatedExtension(!1,null,Y.build(),O,he,B.subscriptions))}static _callActivateOptional(N,W,O,B,Y){if(typeof O.activate=="function")try{Y.activateCallStart(),N.trace(`ExtensionService#_callActivateOptional ${W.value}`);const he=typeof global=="object"?global:self,De=O.activate.apply(he,[B]);return Y.activateCallStop(),Y.activateResolveStart(),Promise.resolve(De).then(Oe=>(Y.activateResolveStop(),Oe))}catch(he){return Promise.reject(he)}else return Promise.resolve(O)}_activateOneStartupFinished(N,W){this._activateById(N.identifier,{startup:!1,extensionId:N.identifier,activationEvent:W}).then(void 0,O=>{this._logService.error(O)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(S.getMarks());for(const N of this._registry.getAllExtensionDescriptions())if(N.activationEvents)for(const W of N.activationEvents)W==="onStartupFinished"&&this._activateOneStartupFinished(N,W)}_handleEagerExtensions(){const N=this._activateByEvent("*",!0).then(void 0,Y=>{this._logService.error(Y)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(Y=>this._handleWorkspaceContainsEagerExtensions(Y.added)));const W=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],O=this._handleWorkspaceContainsEagerExtensions(W),B=Promise.all([N,O]).then(()=>{});return Promise.race([B,k.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),B}_handleWorkspaceContainsEagerExtensions(N){return N.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(W=>this._handleWorkspaceContainsEagerExtension(N,W))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(N,W){if(this.isActivated(W.identifier))return;const O=!this._initData.remote.isRemote&&!!this._initData.remote.authority,B={folders:N.map(he=>he.uri),forceUsingSearch:O,exists:he=>this._hostUtils.exists(he.fsPath),checkExists:(he,De,Oe)=>this._mainThreadWorkspaceProxy.$checkExists(he,De,Oe)},Y=await R.checkActivateWorkspaceContainsExtension(B,W);if(!!Y)return this._activateById(W.identifier,{startup:!0,extensionId:W.identifier,activationEvent:Y.activationEvent}).then(void 0,he=>this._logService.error(he))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(N){throw console.error(N),N}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:N,extensionTestsLocationURI:W}=this._initData.environment;if(!N||!W)throw new Error(g.localize(0,null));const O=await this._loadCommonJSModule(null,W,new h.ExtensionActivationTimesBuilder(!1));if(!O||typeof O.run!="function")throw new Error(g.localize(1,null,W.toString()));return new Promise((B,Y)=>{const he=(Me,He)=>{Me?Y(Me):B(typeof He=="number"&&He>0?1:0)},De=E.originalFSPath(W),Oe=O.run(De,he);Oe&&Oe.then&&Oe.then(()=>{B(0)}).catch(Me=>{Y(Me.toString())})})}async $extensionTestsExit(N){this._logService.info(`extension host terminating: test runner requested exit with code ${N}`),this._logService.info(`exiting with code ${N}`),this._logService.flush(),this._hostUtils.exit(N)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(N,W){return this._resolvers[N]=W,D.toDisposable(()=>{delete this._resolvers[N]})}async _activateAndGetResolver(N){const W=N.indexOf("+");if(W===-1)throw new Error("Not an authority that can be resolved!");const O=N.substr(0,W);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${O}`,!1),{authorityPrefix:O,resolver:this._resolvers[O]}}async $resolveAuthority(N,W){const{authorityPrefix:O,resolver:B}=await this._activateAndGetResolver(N);if(!B)return{type:"error",error:{code:r.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${O}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(B)),S.mark(`code/extHost/willResolveAuthority/${O}`);const Y=await B.resolve(N,{resolveAttempt:W});S.mark(`code/extHost/didResolveAuthorityOK/${O}`);const he={authority:N,host:Y.host,port:Y.port,connectionToken:Y.connectionToken},De={extensionHostEnv:Y.extensionHostEnv,isTrusted:Y.isTrusted};return{type:"ok",value:{authority:he,options:De,tunnelInformation:{environmentTunnels:Y.environmentTunnels}}}}catch(Y){if(S.mark(`code/extHost/didResolveAuthorityError/${O}`),Y instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:Y._code,message:Y._message,detail:Y._detail}};throw Y}}async $getCanonicalURI(N,W){const{authorityPrefix:O,resolver:B}=await this._activateAndGetResolver(N);if(!B)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${O}`);const Y=C.URI.revive(W);if(typeof B.getCanonicalURI=="undefined")return Y;const he=await k.asPromise(()=>B.getCanonicalURI(Y));return he||Y}$startExtensionHost(N){return this._registry.keepOnly(N),this._startExtensionHost()}$activateByEvent(N,W){return W===1?this._activateByEvent(N,!1):this._readyToRunExtensions.wait().then(O=>this._activateByEvent(N,!1))}async $activate(N,W){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(N)?(await this._activateById(N,W),!0):!1}async $deltaExtensions(N,W){N.forEach(B=>B.extensionLocation=C.URI.revive(B.extensionLocation));const O=await this.getExtensionPathIndex();return await Promise.all(W.map(async B=>{const Y=this._registry.getExtensionDescription(B);if(!Y)return;const he=await this._hostUtils.realpath(Y.extensionLocation.fsPath);O.delete(C.URI.file(he).fsPath)})),await Promise.all(N.map(async B=>{const Y=await this._hostUtils.realpath(B.extensionLocation.fsPath);O.set(C.URI.file(Y).fsPath,B)})),this._registry.deltaExtensions(N,W),Promise.resolve(void 0)}async $test_latency(N){return N}async $test_up(N){return N.byteLength}async $test_down(N){let W=f.VSBuffer.alloc(N),O=Math.random()%256;for(let B=0;B<N;B++)W.writeUInt8(O,B);return W}async $updateRemoteConnectionData(N){this._remoteConnectionData=N,this._onDidChangeRemoteConnectionData.fire()}};z=Ve([ze(0,s.IInstantiationService),ze(1,e.IHostUtils),ze(2,w.IExtHostRpcService),ze(3,d.IExtHostWorkspace),ze(4,o.IExtHostConfiguration),ze(5,n.ILogService),ze(6,i.IExtHostInitDataService),ze(7,u.IExtensionStoragePaths),ze(8,P.IExtHostTunnelService),ze(9,A.IExtHostTerminalService)],z),e.AbstractExtHostExtensionService=z;function Z(q,N){return{id:q.identifier.value,name:q.name,extensionVersion:q.version,publisherDisplayName:q.publisher,activationEvents:q.activationEvents?q.activationEvents.join(","):null,isBuiltin:q.isBuiltin,reason:N.activationEvent,reasonId:N.extensionId.value}}e.IExtHostExtensionService=s.createDecorator("IExtHostExtensionService");class M{constructor(N,W,O,B){ue.set(this,void 0),me.set(this,void 0),J.set(this,void 0),it(this,ue,N,"f"),it(this,me,W,"f"),it(this,J,O.identifier,"f"),this.id=O.identifier.value,this.extensionUri=O.extensionLocation,this.extensionPath=T.normalize(E.originalFSPath(O.extensionLocation)),this.packageJSON=O,this.extensionKind=B}get isActive(){return Be(this,ue,"f").isActivated(Be(this,J,"f"))}get exports(){if(this.packageJSON.api!=="none")return Be(this,ue,"f").getExtensionExports(Be(this,J,"f"))}activate(){return Be(this,ue,"f").activateByIdWithErrors(Be(this,J,"f"),{startup:!1,extensionId:Be(this,me,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=M,ue=new WeakMap,me=new WeakMap,J=new WeakMap}),define(we[105],_e([0,1,14,2,3,12,5,6,160,30,33,36,164,32,161,13,4,10,41,63]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y,b,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=y.createDecorator("IExtHostDebugService");let f=class{constructor(v,P,A,a,R,L){this._workspaceService=P,this._extensionService=A,this._editorsService=a,this._configurationService=R,this._editorTabs=L,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new S.Emitter,this._onDidTerminateDebugSession=new S.Emitter,this._onDidChangeActiveDebugSession=new S.Emitter,this._onDidReceiveDebugSessionCustomEvent=new S.Emitter,this._debugServiceProxy=v.getProxy(k.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new S.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new t(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(H=>{H.onDidChange(ue=>{this.registerAllDebugTypes(H)}),this.registerAllDebugTypes(H)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(v,P){const A=v;if(typeof A.sourceReference=="number"&&A.sourceReference>0){let a=`debug:${encodeURIComponent(A.path||"")}`,R="?";return P&&(a+=`${R}session=${encodeURIComponent(P.id)}`,R="&"),a+=`${R}ref=${A.sourceReference}`,T.URI.parse(a)}else{if(A.path)return T.URI.file(A.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(v){const P=[];for(const A of v.getAllExtensionDescriptions())if(A.contributes){const a=A.contributes.debuggers;if(a&&a.length>0)for(const R of a)c.isDebuggerMainContribution(R)&&P.push(R.type)}this._debugServiceProxy.$registerDebugTypes(P)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const v=[];return this._breakpoints.forEach(P=>v.push(P)),v}addBreakpoints(v){this.startBreakpoints();const P=v.filter(R=>{const L=R.id;return this._breakpoints.has(L)?!1:(this._breakpoints.set(L,R),!0)});this.fireBreakpointChanges(P,[],[]);const A=[],a=new Map;for(const R of P)if(R instanceof D.SourceBreakpoint){let L=a.get(R.location.uri.toString());L||(L={type:"sourceMulti",uri:R.location.uri,lines:[]},a.set(R.location.uri.toString(),L),A.push(L)),L.lines.push({id:R.id,enabled:R.enabled,condition:R.condition,hitCondition:R.hitCondition,logMessage:R.logMessage,line:R.location.range.start.line,character:R.location.range.start.character})}else R instanceof D.FunctionBreakpoint&&A.push({type:"function",id:R.id,enabled:R.enabled,hitCondition:R.hitCondition,logMessage:R.logMessage,condition:R.condition,functionName:R.functionName});return this._debugServiceProxy.$registerBreakpoints(A)}removeBreakpoints(v){this.startBreakpoints();const P=v.filter(L=>this._breakpoints.delete(L.id));this.fireBreakpointChanges([],P,[]);const A=P.filter(L=>L instanceof D.SourceBreakpoint).map(L=>L.id),a=P.filter(L=>L instanceof D.FunctionBreakpoint).map(L=>L.id),R=P.filter(L=>L instanceof D.DataBreakpoint).map(L=>L.id);return this._debugServiceProxy.$unregisterBreakpoints(A,a,R)}startDebugging(v,P,A){return this._debugServiceProxy.$startDebugging(v?v.uri:void 0,P,{parentSessionID:A.parentSession?A.parentSession.id:void 0,repl:A.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:A.noDebug,compact:A.compact})}stopDebugging(v){return this._debugServiceProxy.$stopDebugging(v?v.id:void 0)}registerDebugConfigurationProvider(v,P,A){if(!P)return new D.Disposable(()=>{});const a=this._configProviderHandleCounter++;return this._configProviders.push({type:v,handle:a,provider:P}),this._debugServiceProxy.$registerDebugConfigurationProvider(v,A,!!P.provideDebugConfigurations,!!P.resolveDebugConfiguration,!!P.resolveDebugConfigurationWithSubstitutedVariables,a),new D.Disposable(()=>{this._configProviders=this._configProviders.filter(R=>R.provider!==P),this._debugServiceProxy.$unregisterDebugConfigurationProvider(a)})}registerDebugAdapterDescriptorFactory(v,P,A){if(!A)return new D.Disposable(()=>{});if(!this.definesDebugType(v,P))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${P}' debugger.`);if(this.getAdapterDescriptorFactoryByType(P))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const a=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:P,handle:a,factory:A}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(P,a),new D.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(R=>R.factory!==A),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(a)})}registerDebugAdapterTrackerFactory(v,P){if(!P)return new D.Disposable(()=>{});const A=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:v,handle:A,factory:P}),new D.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(a=>a.factory!==P)})}async $runInTerminal(v,P){return Promise.resolve(void 0)}async $substituteVariables(v,P){if(!this._variableResolver){const[R,L]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(R||[],this._editorsService,L)}let A;const a=await this.getFolder(v);return a&&(A={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(A,P)}createDebugAdapter(v,P){if(v.type==="implementation")return new i(v.implementation)}createSignService(){}async $startDASession(v,P){const A=this,a=await this.getSession(P);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(a.type),a).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}' (extension might have failed to activate)`);const L=this.convertToDto(R),H=this.createDebugAdapter(L,a);if(!H)throw new Error(`Couldn't create a debug adapter for type '${a.type}'.`);const ue=H;return this._debugAdapters.set(v,ue),this.getDebugAdapterTrackers(a).then(me=>(me&&this._debugAdaptersTrackers.set(v,me),ue.onMessage(async J=>{if(J.type==="request"&&J.command==="handshake"){const z=J,Z={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const M=await this._signService.sign(z.arguments.value);Z.body={signature:M},ue.sendResponse(Z)}else throw new Error("no signer")}catch(M){Z.success=!1,Z.message=M.message,ue.sendResponse(Z)}}else me&&me.onDidSendMessage&&me.onDidSendMessage(J),J=c.convertToVSCPaths(J,!0),A._debugServiceProxy.$acceptDAMessage(v,J)}),ue.onError(J=>{me&&me.onError&&me.onError(J),this._debugServiceProxy.$acceptDAError(v,J.name,J.message,J.stack)}),ue.onExit(J=>{me&&me.onExit&&me.onExit(b.withNullAsUndefined(J),void 0),this._debugServiceProxy.$acceptDAExit(v,b.withNullAsUndefined(J),void 0)}),me&&me.onWillStartSession&&me.onWillStartSession(),ue.startSession()))})}$sendDAMessage(v,P){P=c.convertToDAPaths(P,!1);const A=this._debugAdaptersTrackers.get(v);A&&A.onWillReceiveMessage&&A.onWillReceiveMessage(P);const a=this._debugAdapters.get(v);a&&a.sendMessage(P)}$stopDASession(v){const P=this._debugAdaptersTrackers.get(v);this._debugAdaptersTrackers.delete(v),P&&P.onWillStopSession&&P.onWillStopSession();const A=this._debugAdapters.get(v);return this._debugAdapters.delete(v),A?A.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(v){const P=[],A=[],a=[];if(v.added)for(const R of v.added){const L=R.id;if(L&&!this._breakpoints.has(L)){let H;if(R.type==="function")H=new D.FunctionBreakpoint(R.functionName,R.enabled,R.condition,R.hitCondition,R.logMessage);else if(R.type==="data")H=new D.DataBreakpoint(R.label,R.dataId,R.canPersist,R.enabled,R.hitCondition,R.condition,R.logMessage);else{const ue=T.URI.revive(R.uri);H=new D.SourceBreakpoint(new D.Location(ue,new D.Position(R.line,R.character)),R.enabled,R.condition,R.hitCondition,R.logMessage)}H._id=L,this._breakpoints.set(L,H),P.push(H)}}if(v.removed)for(const R of v.removed){const L=this._breakpoints.get(R);L&&(this._breakpoints.delete(R),A.push(L))}if(v.changed){for(const R of v.changed)if(R.id){const L=this._breakpoints.get(R.id);if(L){if(L instanceof D.FunctionBreakpoint&&R.type==="function"){const H=L;H.enabled=R.enabled,H.condition=R.condition,H.hitCondition=R.hitCondition,H.logMessage=R.logMessage,H.functionName=R.functionName}else if(L instanceof D.SourceBreakpoint&&R.type==="source"){const H=L;H.enabled=R.enabled,H.condition=R.condition,H.hitCondition=R.hitCondition,H.logMessage=R.logMessage,H.location=new D.Location(T.URI.revive(R.uri),new D.Position(R.line,R.character))}a.push(L)}}}this.fireBreakpointChanges(P,A,a)}$provideDebugConfigurations(v,P,A){return E.asPromise(async()=>{const a=this.getConfigProviderByHandle(v);if(!a)throw new Error("no DebugConfigurationProvider found");if(!a.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const R=await this.getFolder(P);return a.provideDebugConfigurations(R,A)}).then(a=>{if(!a)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return a})}$resolveDebugConfiguration(v,P,A,a){return E.asPromise(async()=>{const R=this.getConfigProviderByHandle(v);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const L=await this.getFolder(P);return R.resolveDebugConfiguration(L,A,a)})}$resolveDebugConfigurationWithSubstitutedVariables(v,P,A,a){return E.asPromise(async()=>{const R=this.getConfigProviderByHandle(v);if(!R)throw new Error("no DebugConfigurationProvider found");if(!R.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const L=await this.getFolder(P);return R.resolveDebugConfigurationWithSubstitutedVariables(L,A,a)})}async $provideDebugAdapter(v,P){const A=this.getAdapterDescriptorFactoryByHandle(v);if(!A)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const a=await this.getSession(P);return this.getAdapterDescriptor(A,a).then(R=>{if(!R)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${a.type}'`);return this.convertToDto(R)})}async $acceptDebugSessionStarted(v){const P=await this.getSession(v);this._onDidStartDebugSession.fire(P)}async $acceptDebugSessionTerminated(v){const P=await this.getSession(v);P&&(this._onDidTerminateDebugSession.fire(P),this._debugSessions.delete(P.id))}async $acceptDebugSessionActiveChanged(v){this._activeDebugSession=v?await this.getSession(v):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(v,P){const A=await this.getSession(v);A&&A._acceptNameChanged(P)}async $acceptDebugSessionCustomEvent(v,P){const a={session:await this.getSession(v),event:P.event,body:P.body};this._onDidReceiveDebugSessionCustomEvent.fire(a)}convertToDto(v){if(v instanceof D.DebugAdapterExecutable)return{type:"executable",command:v.command,args:v.args,options:v.options};if(v instanceof D.DebugAdapterServer)return{type:"server",port:v.port,host:v.host};if(v instanceof D.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:v.path};if(v instanceof D.DebugAdapterInlineImplementation)return{type:"implementation",implementation:v.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(v){const P=this._adapterFactories.filter(A=>A.type===v);if(P.length>0)return P[0].factory}getAdapterDescriptorFactoryByHandle(v){const P=this._adapterFactories.filter(A=>A.handle===v);if(P.length>0)return P[0].factory}getConfigProviderByHandle(v){const P=this._configProviders.filter(A=>A.handle===v);if(P.length>0)return P[0].provider}definesDebugType(v,P){if(v.contributes){const A=v.contributes.debuggers;if(A&&A.length>0){for(const a of A)if(a.label&&a.type&&a.type===P)return!0}}return!1}getDebugAdapterTrackers(v){const A=v.configuration.type,a=this._trackerFactories.filter(R=>R.type===A||R.type==="*").map(R=>E.asPromise(()=>R.factory.createDebugAdapterTracker(v)).then(L=>L,L=>null));return Promise.race([Promise.all(a).then(R=>{const L=R.filter(H=>!!H);if(L.length>0)return new s(L)}),new Promise((R,L)=>{const H=setTimeout(()=>{clearTimeout(H),L(new Error("timeout"))},1e3)})]).catch(R=>{})}async getAdapterDescriptor(v,P){const A=P.configuration.debugServer;if(typeof A=="number")return Promise.resolve(new D.DebugAdapterServer(A));if(v){const R=await this._extensionService.getExtensionRegistry();return E.asPromise(()=>v.createDebugAdapterDescriptor(P,this.daExecutableFromPackage(P,R))).then(L=>{if(L)return L})}const a=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(P,a))}daExecutableFromPackage(v,P){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(v,P,A){(v.length>0||P.length>0||A.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:v,removed:P,changed:A}))}async getSession(v){if(v)if(typeof v=="string"){const P=this._debugSessions.get(v);if(P)return P}else{let P=this._debugSessions.get(v.id);if(!P){const A=await this.getFolder(v.folderUri),a=v.parent?this._debugSessions.get(v.parent):void 0;P=new m(this._debugServiceProxy,v.id,v.type,v.name,A,v.configuration,a),this._debugSessions.set(P.id,P),this._debugServiceProxy.$sessionCached(P.id)}return P}throw new Error("cannot find session")}getFolder(v){if(v){const P=T.URI.revive(v);return this._workspaceService.resolveWorkspaceFolder(P)}return Promise.resolve(void 0)}};f=Ve([ze(0,d.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,n.IExtHostExtensionService),ze(3,I.IExtHostDocumentsAndEditors),ze(4,h.IExtHostConfiguration),ze(5,l.IExtHostEditorTabs)],f),e.ExtHostDebugServiceBase=f;class m{constructor(v,P,A,a,R,L,H){this._debugServiceProxy=v,this._id=P,this._type=A,this._name=a,this._workspaceFolder=R,this._configuration=L,this._parentSession=H}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(v){this._name=v,this._debugServiceProxy.$setDebugSessionName(this._id,v)}get parentSession(){return this._parentSession}_acceptNameChanged(v){this._name=v}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(v,P){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,v,P)}getDebugProtocolBreakpoint(v){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,v.id)}}e.ExtHostDebugSession=m;class t{constructor(v){this.value=Object.freeze({append(P){v.$appendDebugConsole(P)},appendLine(P){this.append(P+`
`)}})}}e.ExtHostDebugConsole=t;class r extends o.AbstractVariableResolverService{constructor(v,P,A,a,R){function L(){if(P){const H=P.activeEditor();if(H)return H.document.uri;const ue=a.tabs.filter(me=>me.isActive);if(ue.length>0)return ue[0].resource}}super({getFolderUri:H=>{const ue=v.filter(me=>me.name===H);if(ue&&ue.length>0)return ue[0].uri},getWorkspaceFolderCount:()=>v.length,getConfigurationValue:(H,ue)=>A.getConfiguration(void 0,H).get(ue),getAppRoot:()=>p.cwd(),getExecPath:()=>p.env.VSCODE_EXEC_PATH,getFilePath:()=>{const H=L();if(H)return g.normalize(H.fsPath)},getWorkspaceFolderPathForFile:()=>{if(R){const H=L();if(H){const ue=R.getWorkspaceFolder(H);if(ue)return g.normalize(ue.uri.fsPath)}}},getSelectedText:()=>{if(P){const H=P.activeEditor();if(H&&!H.selection.isEmpty)return H.document.getText(H.selection)}},getLineNumber:()=>{if(P){const H=P.activeEditor();if(H)return String(H.selection.end.line+1)}}},void 0,Promise.resolve(p.env))}}e.ExtHostVariableResolverService=r;class s{constructor(v){this.trackers=v}onWillStartSession(){this.trackers.forEach(v=>v.onWillStartSession?v.onWillStartSession():void 0)}onWillReceiveMessage(v){this.trackers.forEach(P=>P.onWillReceiveMessage?P.onWillReceiveMessage(v):void 0)}onDidSendMessage(v){this.trackers.forEach(P=>P.onDidSendMessage?P.onDidSendMessage(v):void 0)}onWillStopSession(){this.trackers.forEach(v=>v.onWillStopSession?v.onWillStopSession():void 0)}onError(v){this.trackers.forEach(P=>P.onError?P.onError(v):void 0)}onExit(v,P){this.trackers.forEach(A=>A.onExit?A.onExit(v,P):void 0)}}class i extends _.AbstractDebugAdapter{constructor(v){super();this.implementation=v,v.onDidSendMessage(P=>{this.acceptMessage(P)})}startSession(){return Promise.resolve(void 0)}sendMessage(v){this.implementation.handleMessage(v)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends f{constructor(v,P,A,a,R,L){super(v,P,A,a,R,L)}createVariableResolver(v,P,A){return new r(v,P,A,this._editorTabs)}};u=Ve([ze(0,d.IExtHostRpcService),ze(1,C.IExtHostWorkspace),ze(2,n.IExtHostExtensionService),ze(3,I.IExtHostDocumentsAndEditors),ze(4,h.IExtHostConfiguration),ze(5,l.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(we[214],_e([0,1,75,2,5,32,29,26,13,28,4,33,41,15]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let c=class{constructor(l,f,m,t,r,s,i){this._apiFactory=l,this._extensionRegistry=f,this._instaService=m,this._extHostConfiguration=t,this._extHostExtensionService=r,this._initData=s,this._logService=i,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),g.mark("code/extHost/willWaitForConfig");const l=await this._extHostConfiguration.getConfigProvider();g.mark("code/extHost/didWaitForConfig");const f=await this._extHostExtensionService.getExtensionPathIndex();this.register(new d(this._apiFactory,f,this._extensionRegistry,l,this._logService)),this.register(this._instaService.createInstance(y)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(b,f,this._initData.environment.appUriScheme))}register(l){if(Array.isArray(l.nodeModuleName))for(let f of l.nodeModuleName)this._factories.set(f,l);else this._factories.set(l.nodeModuleName,l);typeof l.alternativeModuleName=="function"&&this._alternatives.push(f=>l.alternativeModuleName(f))}};c=Ve([ze(2,n.IInstantiationService),ze(3,E.IExtHostConfiguration),ze(4,I.IExtHostExtensionService),ze(5,C.IExtHostInitDataService),ze(6,h.ILogService)],c),e.RequireInterceptor=c;class d{constructor(l,f,m,t,r){this._apiFactory=l,this._extensionPaths=f,this._extensionRegistry=m,this._configProvider=t,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(l,f){const m=this._extensionPaths.findSubstr(f.fsPath);if(m){let t=this._extApiImpl.get(D.ExtensionIdentifier.toKey(m.identifier));return t||(t=this._apiFactory(m,this._extensionRegistry,this._configProvider),this._extApiImpl.set(D.ExtensionIdentifier.toKey(m.identifier),t)),t}if(!this._defaultApiImpl){let t="";this._extensionPaths.forEach((r,s)=>t+=`	${s} -> ${r.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${f.fsPath}. These are the extension path mappings: 
${t}`),this._defaultApiImpl=this._apiFactory(k.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(l,f){this.nodeModuleName="keytar";const{environment:m}=f,t=l.getProxy(S.MainContext.MainThreadKeytar);if(m.appRoot){let r=m.appRoot.fsPath;o.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,s)=>t.$getPassword(r,s),setPassword:(r,s,i)=>t.$setPassword(r,s,i),deletePassword:(r,s)=>t.$deletePassword(r,s),findPassword:r=>t.$findPassword(r),findCredentials(r){return t.$findCredentials(r)}}}load(l,f){return this._impl}alternativeModuleName(l){const f=l.length;if(f<=7||!this.alternativeNames)return;const m=f-7;if((l.charAt(m)==="/"||l.charAt(m)==="\\")&&l.endsWith("keytar")&&(l=l.replace(/\\/g,"/"),this.alternativeNames.has(l)))return"keytar"}};y=Ve([ze(0,_.IExtHostRpcService),ze(1,C.IExtHostInitDataService)],y);let b=class{constructor(l,f,m){this._extensionPaths=l,this._appUriScheme=f,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=m.getProxy(S.MainContext.MainThreadTelemetry);const t=m.getProxy(S.MainContext.MainThreadWindow);this._impl=(r,s)=>{const i=T.URI.parse(r);return s?this.callOriginal(r,s):i.scheme==="http"||i.scheme==="https"?t.$openUri(i,r,{allowTunneling:!0}):i.scheme==="mailto"||i.scheme===this._appUriScheme?t.$openUri(i,r,{}):this.callOriginal(r,s)}}load(l,f,m){const t=this._extensionPaths.findSubstr(f.fsPath);return t&&(this._extensionId=t.identifier.value,this.sendShimmingTelemetry()),this._original=m(l),this._impl}callOriginal(l,f){return this.sendNoForwardTelemetry(),this._original(l,f)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};b=Ve([ze(2,_.IExtHostRpcService)],b)}),define(we[215],_e([0,1,12,11,75,7,2,5,207,15,57,60,28,146,13,66,33,37]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class p{constructor(f,m,t,r){this._disposables=new E.DisposableStore,this._isTerminating=!1,this._hostUtils=t,this._rpcProtocol=new _.RPCProtocol(f,null,r),m=p._transform(m,this._rpcProtocol);const s=new I.ServiceCollection(...n.getSingletonServiceDescriptors());s.set(o.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},m)),s.set(c.IExtHostRpcService,new c.ExtHostRpcService(this._rpcProtocol)),s.set(d.IURITransformerService,new d.URITransformerService(r)),s.set(y.IHostUtils,t);const i=new h.InstantiationService(s,!0),u=i.invokeFunction(A=>A.get(b.IExtHostTerminalService));this._disposables.add(u),this._logService=i.invokeFunction(A=>A.get(C.ILogService)),S.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",m),this._extensionService=i.invokeFunction(A=>A.get(y.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const w=new WeakMap;this._extensionService.getExtensionPathIndex().then(A=>{Error.prepareStackTrace=(a,R)=>{let L="",H,ue;for(const me of R)L+=`
	at ${me.toString()}`,ue=me.getFileName(),!H&&ue&&(H=A.findSubstr(ue));return w.set(a,H),`${a.name||"Error"}: ${a.message||""}${L}`}});const v=this._rpcProtocol.getProxy(D.MainContext.MainThreadExtensionService),P=this._rpcProtocol.getProxy(D.MainContext.MainThreadErrors);T.setUnexpectedErrorHandler(A=>{const a=T.transformErrorForSerialization(A),R=w.get(A);R?v.$onExtensionRuntimeError(R.identifier,a):P.$onUnexpectedError(a)})}terminate(f){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${f}`),this._logService.flush(),this._disposables.dispose(),T.setUnexpectedErrorHandler(t=>{this._logService.error(t)}),this._rpcProtocol.dispose();const m=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([g.timeout(4e3),m]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(f,m){f.extensions.forEach(r=>r.extensionLocation=k.URI.revive(m.transformIncomingURIs(r.extensionLocation))),f.environment.appRoot=k.URI.revive(m.transformIncomingURIs(f.environment.appRoot));const t=f.environment.extensionDevelopmentLocationURI;return t&&(f.environment.extensionDevelopmentLocationURI=t.map(r=>k.URI.revive(m.transformIncomingURIs(r)))),f.environment.extensionTestsLocationURI=k.URI.revive(m.transformIncomingURIs(f.environment.extensionTestsLocationURI)),f.environment.globalStorageHome=k.URI.revive(m.transformIncomingURIs(f.environment.globalStorageHome)),f.environment.workspaceStorageHome=k.URI.revive(m.transformIncomingURIs(f.environment.workspaceStorageHome)),f.logsLocation=k.URI.revive(m.transformIncomingURIs(f.logsLocation)),f.logFile=k.URI.revive(m.transformIncomingURIs(f.logFile)),f.workspace=m.transformIncomingURIs(f.workspace),f}}e.ExtensionHostMain=p}),define(we[216],_e([0,1,14,18,56,27,25,52,38]),function(ee,e,g,T,S,E,k,D,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class C{constructor(o,h,c){this.config=o,this.provider=h,this.sessionToken=c,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=o.filePattern,this.includePattern=o.includePattern&&E.parse(o.includePattern),this.maxResults=o.maxResults||void 0,this.exists=o.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=o.excludePattern&&E.parse(o.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(o=>o.cancel()),this.activeCancellationTokens=new Set}search(o){const h=this.config.folderQueries||[];return new Promise((c,d)=>{const y=b=>{this.resultCount++,o(b)};if(this.isCanceled)return c({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(b=>{const p=b.toString(),l=g.basename(p);this.globalExcludePattern&&this.globalExcludePattern(p,l)||this.matchFile(y,{base:b,basename:l})}),Promise.all(h.map(b=>this.searchInFolder(b,y))).then(b=>{c({limitHit:this.isLimitHit,stats:b[0]||void 0})},b=>{d(new Error(S.toErrorMessage(b)))})})}async searchInFolder(o,h){const c=new T.CancellationTokenSource,d=this.getSearchOptionsForFolder(o),y=this.initDirectoryTree(),b=new _.QueryGlobTester(this.config,o),p=!b.hasSiblingExcludeClauses();let l;try{this.activeCancellationTokens.add(c),l=D.StopWatch.create();const f=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},d,c.token),m=l.elapsed(),t=D.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(f&&f.forEach(r=>{const s=g.posix.relative(o.folder.path,r.path);if(p){const i=g.basename(r.path);this.matchFile(h,{base:o.folder,relativePath:s,basename:i});return}this.addDirectoryEntries(y,o.folder,s,h)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(y,b,h),{providerTime:m,postProcessTime:t.elapsed()})}finally{c.dispose(),this.activeCancellationTokens.delete(c)}}getSearchOptionsForFolder(o){const h=_.resolvePatternsForProvider(this.config.includePattern,o.includePattern),c=_.resolvePatternsForProvider(this.config.excludePattern,o.excludePattern);return{folder:o.folder,excludes:c,includes:h,useIgnoreFiles:!o.disregardIgnoreFiles,useGlobalIgnoreFiles:!o.disregardGlobalIgnoreFiles,followSymlinks:!o.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}addDirectoryEntries({pathToEntries:o},h,c,d){if(c===this.filePattern){const b=g.basename(this.filePattern);this.matchFile(d,{base:h,relativePath:this.filePattern,basename:b})}function y(b){const p=g.basename(b),l=g.dirname(b);let f=o[l];f||(f=o[l]=[],y(l)),f.push({base:h,relativePath:b,basename:p})}y(c)}matchDirectoryTree({rootEntries:o,pathToEntries:h},c,d){const y=this,b=this.filePattern;function p(l){const f=E.hasSiblingFn(()=>l.map(m=>m.basename));for(let m=0,t=l.length;m<t;m++){const r=l[m],{relativePath:s,basename:i}=r;if(!c.includedInQuerySync(s,i,b!==i?f:void 0))continue;const u=h[s];if(u)p(u);else{if(s===b)continue;y.matchFile(d,r)}if(y.isLimitHit)break}}p(o)}matchFile(o,h){(!this.includePattern||h.relativePath&&this.includePattern(h.relativePath,h.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||o(h))}}class n{constructor(){this.sessions=new Map}fileSearch(o,h,c,d){const y=this.getSessionTokenSource(o.cacheKey),b=new C(o,h,y&&y.token);let p=0;const l=f=>{p+=f.length,c(f.map(m=>this.rawMatchToSearchItem(m)))};return this.doSearch(b,n.BATCH_SIZE,l,d).then(f=>({limitHit:f.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:f.stats}}))}clearCache(o){const h=this.getSessionTokenSource(o);h&&h.cancel()}getSessionTokenSource(o){if(!!o)return this.sessions.has(o)||this.sessions.set(o,new T.CancellationTokenSource),this.sessions.get(o)}rawMatchToSearchItem(o){return o.relativePath?{resource:k.joinPath(o.base,o.relativePath)}:{resource:o.base}}doSearch(o,h,c,d){d.onCancellationRequested(()=>{o.cancel()});const y=p=>{p&&(b.push(p),h>0&&b.length>=h&&(c(b),b=[]))};let b=[];return o.search(y).then(p=>(b.length&&c(b),p),p=>(b.length&&c(b),Promise.reject(p)))}}e.FileSearchManager=n,n.BATCH_SIZE=512}),define(we[217],_e([0,1,14,17,18,56,25,27,2,38,16,10]),function(ee,e,g,T,S,E,k,D,_,C,n,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class o{constructor(l,f,m){this.query=l,this.provider=f,this.fileUtils=m,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(l,f){const m=this.query.folderQueries||[],t=new S.CancellationTokenSource;return f.onCancellationRequested(()=>t.cancel()),new Promise((r,s)=>{this.collector=new c(l);let i=!1;const u=(w,v)=>{if(!i&&!this.isLimitHit){const P=this.resultSize(w);y(w)&&typeof this.query.maxResults=="number"&&this.resultCount+P>this.query.maxResults&&(this.isLimitHit=!0,i=!0,t.cancel(),w=this.trimResultToSize(w,this.query.maxResults-this.resultCount));const A=this.resultSize(w);this.resultCount+=A,(A>0||!y(w))&&this.collector.add(w,v)}};Promise.all(m.map((w,v)=>this.searchInFolder(w,P=>u(P,v),t.token))).then(w=>{t.dispose(),this.collector.flush();const v=w.some(P=>!!P&&!!P.limitHit);r({limitHit:this.isLimitHit||v,messages:T.flatten(w.map(P=>(P==null?void 0:P.message)?I.isArray(P.message)?P.message:[P.message]:[])),stats:{type:"textSearchProvider"}})},w=>{t.dispose();const v=E.toErrorMessage(w);s(new Error(v))})})}resultSize(l){return y(l)?Array.isArray(l.ranges)?l.ranges.length:1:0}trimResultToSize(l,f){const m=Array.isArray(l.ranges)?l.ranges:[l.ranges],t=Array.isArray(l.preview.matches)?l.preview.matches:[l.preview.matches];return{ranges:m.slice(0,f),preview:{matches:t.slice(0,f),text:l.preview.text},uri:l.uri}}async searchInFolder(l,f,m){const t=new C.QueryGlobTester(this.query,l),r=[],s={report:w=>{if(!this.validateProviderResult(w))return;const v=l.folder.scheme===n.Schemas.file?D.hasSiblingPromiseFn(()=>this.fileUtils.readdir(k.dirname(w.uri))):void 0,P=k.relativePath(l.folder,w.uri);P&&r.push(t.includedInQuery(P,g.basename(P),v).then(A=>{A&&f(w)}))}},i=this.getSearchOptionsForFolder(l),u=await this.provider.provideTextSearchResults(h(this.query.contentPattern),i,s,m);return await Promise.all(r),u}validateProviderResult(l){if(y(l)){if(Array.isArray(l.ranges)){if(!Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(l.preview.matches.length!==l.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(l.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(l){const f=C.resolvePatternsForProvider(this.query.includePattern,l.includePattern),m=C.resolvePatternsForProvider(this.query.excludePattern,l.excludePattern),t={folder:_.URI.from(l.folder),excludes:m,includes:f,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,followSymlinks:!l.ignoreSymlinks,encoding:l.fileEncoding&&this.fileUtils.toCanonicalName(l.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return t.usePCRE2=this.query.usePCRE2,t}}e.TextSearchManager=o;function h(p){return{isCaseSensitive:p.isCaseSensitive||!1,isRegExp:p.isRegExp||!1,isWordMatch:p.isWordMatch||!1,isMultiline:p.isMultiline||!1,pattern:p.pattern}}class c{constructor(l){this._onResult=l,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new b(512,f=>this.sendItems(f))}add(l,f){this._currentFileMatch&&(this._currentFolderIdx!==f||!k.isEqual(this._currentUri,l.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=f,this._currentFileMatch={resource:l.uri,results:[]}),this._currentFileMatch.results.push(d(l))}pushToCollector(){const l=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,l)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(l){this._onResult(l)}}e.TextSearchResultsCollector=c;function d(p){return y(p)?{preview:{matches:T.mapArrayOrNot(p.preview.matches,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character})),text:p.preview.text},ranges:T.mapArrayOrNot(p.ranges,l=>({startLineNumber:l.start.line,startColumn:l.start.character,endLineNumber:l.end.line,endColumn:l.end.character}))}:{text:p.text,lineNumber:p.lineNumber}}function y(p){return!!p.preview}e.extensionResultIsMatch=y;class b{constructor(l,f){this.maxBatchSize=l,this.cb=f,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(l,f){!l||this.addItemToBatch(l,f)}addItems(l,f){!l||this.addItemsToBatch(l,f)}addItemToBatch(l,f){this.batch.push(l),this.batchSize+=f,this.onUpdate()}addItemsToBatch(l,f){this.batch=this.batch.concat(l),this.batchSize+=f,this.onUpdate()}onUpdate(){this.totalNumberCompleted<b.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},b.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=b,b.TIMEOUT=4e3,b.START_BATCH_AFTER_COUNT=50}),define(we[106],_e([0,1,7,5,4,216,13,66,15,2,217]),function(ee,e,g,T,S,E,k,D,_,C,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=S.createDecorator("IExtHostSearch");let I=class{constructor(d,y,b){this.extHostRpc=d,this._uriTransformer=y,this._logService=b,this._proxy=this.extHostRpc.getProxy(T.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new E.FileSearchManager}_transformScheme(d){return this._uriTransformer.transformOutgoingScheme(d)}registerTextSearchProvider(d,y){if(this._textSearchUsedSchemes.has(d))throw new Error(`a text search provider for the scheme '${d}' is already registered`);this._textSearchUsedSchemes.add(d);const b=this._handlePool++;return this._textSearchProvider.set(b,y),this._proxy.$registerTextSearchProvider(b,this._transformScheme(d)),g.toDisposable(()=>{this._textSearchUsedSchemes.delete(d),this._textSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}registerFileSearchProvider(d,y){if(this._fileSearchUsedSchemes.has(d))throw new Error(`a file search provider for the scheme '${d}' is already registered`);this._fileSearchUsedSchemes.add(d);const b=this._handlePool++;return this._fileSearchProvider.set(b,y),this._proxy.$registerFileSearchProvider(b,this._transformScheme(d)),g.toDisposable(()=>{this._fileSearchUsedSchemes.delete(d),this._fileSearchProvider.delete(b),this._proxy.$unregisterProvider(b)})}$provideFileSearchResults(d,y,b,p){const l=o(b),f=this._fileSearchProvider.get(d);if(f)return this._fileSearchManager.fileSearch(l,f,m=>{this._proxy.$handleFileMatch(d,y,m.map(t=>t.resource))},p);throw new Error("unknown provider: "+d)}$clearCache(d){return this._fileSearchManager.clearCache(d),Promise.resolve(void 0)}$provideTextSearchResults(d,y,b,p){const l=this._textSearchProvider.get(d);if(!l||!l.provideTextSearchResults)throw new Error(`Unknown provider ${d}`);const f=o(b);return this.createTextSearchManager(f,l).search(t=>this._proxy.$handleTextMatch(d,y,t),p)}createTextSearchManager(d,y){return new n.TextSearchManager(d,y,{readdir:b=>Promise.resolve([]),toCanonicalName:b=>b})}};I=Ve([ze(0,k.IExtHostRpcService),ze(1,D.IURITransformerService),ze(2,_.ILogService)],I),e.ExtHostSearch=I;function o(c){return Object.assign(Object.assign({},c),{folderQueries:c.folderQueries&&c.folderQueries.map(h),extraFileResources:c.extraFileResources&&c.extraFileResources.map(d=>C.URI.revive(d))})}e.reviveQuery=o;function h(c){return Object.assign(Object.assign({},c),{folder:C.URI.revive(c.folder)})}}),define(we[218],_e([0,1,18,11,3,42,2,123,84,117,55,59,5,181,180,71,182,32,183,184,185,167,186,36,33,187,168,189,190,191,101,170,196,197,198,73,37,199,171,9,6,202,47,102,30,29,76,159,188,93,4,100,104,105,106,15,66,13,28,192,157,65,70,178,200,156,74,72,205,203,204,179,46,211,201,69,63,94,194,103,195,16,148,193,154]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y,b,p,l,f,m,t,r,s,i,u,w,v,P,A,a,R,L,H,ue,me,J,z,Z,M,q,N,W,O,B,Y,he,De,Oe,Me,He,Ye,qe,Xe,$,G,te,re,K,oe,fe,Ae,$e,pe,Ge,j,ne,ge,Fe,Ne,Qe,Ee,be,Ce,se,de,U,Q,le,ke,Pe,Ue,We,Ze){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function rt(Ke){const Je=Ke.get(re.IExtHostInitDataService),ft=Ke.get(Ee.IExtHostFileSystemInfo),ve=Ke.get(ne.IExtHostConsumerFileSystem),ye=Ke.get(s.IExtHostExtensionService),ae=Ke.get(O.IExtHostWorkspace),V=Ke.get(U.IExtHostTelemetry),xe=Ke.get(b.IExtHostConfiguration),Te=Ke.get(G.IURITransformerService),Re=Ke.get(te.IExtHostRpcService),nt=Ke.get(ue.IExtHostStorage),ot=Ke.get(j.IExtensionStoragePaths),tt=Ke.get($.ILogService),vt=Ke.get(fe.IExtHostTunnelService),gt=Ke.get(Ae.IExtHostApiDeprecationService),pt=Ke.get(W.IExtHostWindow),wt=Ke.get(se.IExtHostSecretState),Tt=Ke.get(de.IExtHostEditorTabs);Re.set(o.ExtHostContext.ExtHostFileSystemInfo,ft),Re.set(o.ExtHostContext.ExtHostLogService,tt),Re.set(o.ExtHostContext.ExtHostWorkspace,ae),Re.set(o.ExtHostContext.ExtHostConfiguration,xe),Re.set(o.ExtHostContext.ExtHostExtensionService,ye),Re.set(o.ExtHostContext.ExtHostStorage,nt),Re.set(o.ExtHostContext.ExtHostTunnelService,vt),Re.set(o.ExtHostContext.ExtHostWindow,pt),Re.set(o.ExtHostContext.ExtHostSecretState,wt),Re.set(o.ExtHostContext.ExtHostTelemetry,V),Re.set(o.ExtHostContext.ExtHostEditorTabs,Tt);const Pt=Re.set(o.ExtHostContext.ExtHostDecorations,Ke.get(He.IExtHostDecorations)),Et=Re.set(o.ExtHostContext.ExtHostDocumentsAndEditors,Ke.get(r.IExtHostDocumentsAndEditors)),ut=Re.set(o.ExtHostContext.ExtHostCommands,Ke.get(d.IExtHostCommands)),mt=Re.set(o.ExtHostContext.ExtHostTerminalService,Ke.get(me.IExtHostTerminalService)),_t=Re.set(o.ExtHostContext.ExtHostDebugService,Ke.get(qe.IExtHostDebugService)),Ft=Re.set(o.ExtHostContext.ExtHostSearch,Ke.get(Xe.IExtHostSearch)),yt=Re.set(o.ExtHostContext.ExtHostTask,Ke.get(Ye.IExtHostTask)),Zt=Re.set(o.ExtHostContext.ExtHostOutputService,Ke.get(A.IExtHostOutputService)),qt=Re.set(o.ExtHostContext.ExtHostUrls,new q.ExtHostUrls(Re)),St=Re.set(o.ExtHostContext.ExtHostDocuments,new t.ExtHostDocuments(Re,Et)),en=Re.set(o.ExtHostContext.ExtHostDocumentContentProviders,new f.ExtHostDocumentContentProvider(Re,Et,tt)),tn=Re.set(o.ExtHostContext.ExtHostDocumentSaveParticipant,new m.ExtHostDocumentSaveParticipant(tt,St,Re.getProxy(o.MainContext.MainThreadBulkEdits))),ht=Re.set(o.ExtHostContext.ExtHostNotebook,new K.ExtHostNotebookController(Re,ut,Et,St,ot)),Gt=Re.set(o.ExtHostContext.ExtHostNotebookDocuments,new Ze.ExtHostNotebookDocuments(tt,ht)),$t=Re.set(o.ExtHostContext.ExtHostNotebookEditors,new We.ExtHostNotebookEditors(tt,Re,ht)),Cn=Re.set(o.ExtHostContext.ExtHostNotebookKernels,new Q.ExtHostNotebookKernels(Re,Je,ht,tt)),nn=Re.set(o.ExtHostContext.ExtHostNotebookRenderers,new ke.ExtHostNotebookRenderers(Re,ht)),Ct=Re.set(o.ExtHostContext.ExtHostEditors,new J.ExtHostEditors(Re,Et)),Kt=Re.set(o.ExtHostContext.ExtHostTreeViews,new z.ExtHostTreeViews(Re.getProxy(o.MainContext.MainThreadTreeViews),ut,tt)),rn=Re.set(o.ExtHostContext.ExtHostEditorInsets,new he.ExtHostEditorInsets(Re.getProxy(o.MainContext.MainThreadEditorInsets),Ct,Je)),Qt=Re.set(o.ExtHostContext.ExtHostDiagnostics,new p.ExtHostDiagnostics(Re,tt)),ct=Re.set(o.ExtHostContext.ExtHostLanguageFeatures,new w.ExtHostLanguageFeatures(Re,Te,St,ut,Qt,tt,gt)),sn=Re.set(o.ExtHostContext.ExtHostFileSystem,new i.ExtHostFileSystem(Re,ct)),Mt=Re.set(o.ExtHostContext.ExtHostFileSystemEventService,new u.ExtHostFileSystemEventService(Re,tt,Et)),Wt=Re.set(o.ExtHostContext.ExtHostQuickOpen,R.createExtHostQuickOpen(Re,ae,ut)),pn=Re.set(o.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(Re,ut,tt)),kn=Re.set(o.ExtHostContext.ExtHostComments,new y.ExtHostComments(Re,ut,St)),vn=Re.set(o.ExtHostContext.ExtHostProgress,new a.ExtHostProgress(Re.getProxy(o.MainContext.MainThreadProgress))),on=Re.set(o.ExtHostContext.ExtHosLabelService,new De.ExtHostLabelService(Re)),Yt=Re.set(o.ExtHostContext.ExtHostTheming,new oe.ExtHostTheming(Re)),xt=Re.set(o.ExtHostContext.ExtHostAuthentication,new $e.ExtHostAuthentication(Re)),In=Re.set(o.ExtHostContext.ExtHostTimeline,new pe.ExtHostTimeline(Re,ut)),an=Re.set(o.ExtHostContext.ExtHostWebviews,new N.ExtHostWebviews(Re,{remote:Je.remote},ae,tt,gt)),ln=Re.set(o.ExtHostContext.ExtHostWebviewPanels,new Ne.ExtHostWebviewPanels(Re,an,ae)),Jt=Re.set(o.ExtHostContext.ExtHostCustomEditors,new Fe.ExtHostCustomEditors(Re,St,ot,an,ln)),Pn=Re.set(o.ExtHostContext.ExtHostWebviewViews,new ge.ExtHostWebviewViews(Re,an)),Lt=Re.set(o.ExtHostContext.ExtHostTesting,new be.ExtHostTesting(Re,Ke.get(Me.IInstantiationService),Et)),un=Re.set(o.ExtHostContext.ExtHostUriOpeners,new Ce.ExtHostUriOpeners(Re)),An=Y.values(o.ExtHostContext);Re.assertRegistered(An);const Ht=new Qe.ExtHostBulkEdits(Re,Et),Nt=new c.ExtHostClipboard(Re),cn=new P.ExtHostMessageService(Re,tt),It=new l.ExtHostDialogs(Re),zt=new H.ExtHostStatusBar(Re,ut.converter),dn=new v.ExtHostLanguages(Re,St);return h.ExtHostApiCommands.register(ut),function(Le,hn,bn){const dt=function(){let X=!Le.isUnderDevelopment;function ce(Ie){X||(tt.info(`Extension '${Le.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),X=!0)}return function Ie(st){if(Array.isArray(st))st.forEach(Ie);else if(typeof st=="string")ce(st);else{const bt=st;typeof bt.scheme=="undefined"&&ce(st),!Le.enableProposedApi&&typeof bt.exclusive=="boolean"&&B.throwProposedApiError(Le)}return st}}(),Tn={getSession(X,ce,Ie){return xt.getSession(Le,X,ce,Ie)},get onDidChangeSessions(){return xt.onDidChangeSessions},registerAuthenticationProvider(X,ce,Ie,st){return xt.registerAuthenticationProvider(X,ce,Ie,st)},get onDidChangeAuthenticationProviders(){return B.checkProposedApiEnabled(Le),xt.onDidChangeAuthenticationProviders},get providers(){return B.checkProposedApiEnabled(Le),xt.providers},logout(X,ce){return B.checkProposedApiEnabled(Le),xt.removeSession(X,ce)}},Rn={registerCommand(X,ce,Ie){return ut.registerCommand(!0,X,ce,Ie)},registerTextEditorCommand(X,ce,Ie){return ut.registerCommand(!0,X,(...st)=>{const bt=Ct.getActiveTextEditor();if(!bt){tt.warn("Cannot execute "+X+" because there is no active text editor.");return}return bt.edit(x=>{ce.apply(Ie,[bt,x,...st])}).then(x=>{x||tt.warn("Edits from command "+X+" were not applied.")},x=>{tt.warn("An error occurred while running command "+X,x)})})},registerDiffInformationCommand:(X,ce,Ie)=>(B.checkProposedApiEnabled(Le),ut.registerCommand(!0,X,async(...st)=>{const bt=Et.activeEditor(!0);if(!bt){tt.warn("Cannot execute "+X+" because there is no active text editor.");return}const x=await Ct.getDiffInformation(bt.id);ce.apply(Ie,[x,...st])})),executeCommand(X,...ce){return ut.executeCommand(X,...ce)},getCommands(X=!1){return ut.getCommands(X)}},Xt={get machineId(){return Je.telemetryInfo.machineId},get sessionId(){return Je.telemetryInfo.sessionId},get language(){return Je.environment.appLanguage},get appName(){return Je.environment.appName},get appRoot(){var X,ce;return(ce=(X=Je.environment.appRoot)===null||X===void 0?void 0:X.fsPath)!==null&&ce!==void 0?ce:""},get uriScheme(){return Je.environment.appUriScheme},get clipboard(){return Nt.value},get shell(){return mt.getDefaultShell(!1)},get isTelemetryEnabled(){return V.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return V.onDidChangeTelemetryEnabled},get isNewAppInstall(){const X=Date.now()-new Date(Je.telemetryInfo.firstSessionDate).getTime();return isNaN(X)?!1:X<1e3*60*60*24},openExternal(X,ce){return pt.openUri(X,{allowTunneling:!!Je.remote.authority,allowContributedOpeners:ce==null?void 0:ce.allowContributedOpeners})},async asExternalUri(X){if(X.scheme===Je.environment.appUriScheme)return qt.createAppUri(X);const ce=Ue.matchesScheme(X,Pe.Schemas.http)||Ue.matchesScheme(X,Pe.Schemas.https);ce||B.checkProposedApiEnabled(Le);try{return await pt.asExternalUri(X,{allowTunneling:!!Je.remote.authority})}catch(Ie){if(ce)return X;throw Ie}},get remoteName(){return Oe.getRemoteName(Je.remote.authority)},get uiKind(){return Je.uiKind}};Je.environment.extensionTestsLocationURI||Object.freeze(Xt);const wn=Je.remote.isRemote?M.ExtensionKind.Workspace:M.ExtensionKind.UI,fn={registerTestController(X){return B.checkProposedApiEnabled(Le),Lt.registerTestController(Le.identifier.value,X)},createDocumentTestObserver(X){return B.checkProposedApiEnabled(Le),Lt.createTextDocumentTestObserver(X)},createWorkspaceTestObserver(X){return B.checkProposedApiEnabled(Le),Lt.createWorkspaceTestObserver(X)},runTests(X){return B.checkProposedApiEnabled(Le),Lt.runTests(X)},createTestItem(X,ce){return new M.TestItemImpl(X.id,X.label,X.uri,ce)},createTestRun(X,ce,Ie){return B.checkProposedApiEnabled(Le),Lt.createTestRun(X,ce,Ie)},get onDidChangeTestResults(){return B.checkProposedApiEnabled(Le),Lt.onResultsChanged},get testResults(){return B.checkProposedApiEnabled(Le),Lt.results}};fn.createTestRunTask=fn.createTestRun;const Fn={getExtension(X){const ce=hn.getExtensionDescription(X);if(ce)return new s.Extension(ye,Le.identifier,ce,wn)},get all(){return hn.getAllExtensionDescriptions().map(X=>new s.Extension(ye,Le.identifier,X,wn))},get onDidChange(){return hn.onDidChange}},Mn={createDiagnosticCollection(X){return Qt.createDiagnosticCollection(Le.identifier,X)},get onDidChangeDiagnostics(){return Qt.onDidChangeDiagnostics},getDiagnostics:X=>Qt.getDiagnostics(X),getLanguages(){return dn.getLanguages()},setTextDocumentLanguage(X,ce){return dn.changeLanguage(X.uri,ce)},match(X,ce){return n.score(Z.LanguageSelector.from(X),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(X,ce,Ie){return ct.registerCodeActionProvider(Le,dt(X),ce,Ie)},registerCodeLensProvider(X,ce){return ct.registerCodeLensProvider(Le,dt(X),ce)},registerDefinitionProvider(X,ce){return ct.registerDefinitionProvider(Le,dt(X),ce)},registerDeclarationProvider(X,ce){return ct.registerDeclarationProvider(Le,dt(X),ce)},registerImplementationProvider(X,ce){return ct.registerImplementationProvider(Le,dt(X),ce)},registerTypeDefinitionProvider(X,ce){return ct.registerTypeDefinitionProvider(Le,dt(X),ce)},registerHoverProvider(X,ce){return ct.registerHoverProvider(Le,dt(X),ce,Le.identifier)},registerEvaluatableExpressionProvider(X,ce){return ct.registerEvaluatableExpressionProvider(Le,dt(X),ce,Le.identifier)},registerInlineValuesProvider(X,ce){return ct.registerInlineValuesProvider(Le,dt(X),ce,Le.identifier)},registerDocumentHighlightProvider(X,ce){return ct.registerDocumentHighlightProvider(Le,dt(X),ce)},registerLinkedEditingRangeProvider(X,ce){return ct.registerLinkedEditingRangeProvider(Le,dt(X),ce)},registerReferenceProvider(X,ce){return ct.registerReferenceProvider(Le,dt(X),ce)},registerRenameProvider(X,ce){return ct.registerRenameProvider(Le,dt(X),ce)},registerDocumentSymbolProvider(X,ce,Ie){return ct.registerDocumentSymbolProvider(Le,dt(X),ce,Ie)},registerWorkspaceSymbolProvider(X){return ct.registerWorkspaceSymbolProvider(Le,X)},registerDocumentFormattingEditProvider(X,ce){return ct.registerDocumentFormattingEditProvider(Le,dt(X),ce)},registerDocumentRangeFormattingEditProvider(X,ce){return ct.registerDocumentRangeFormattingEditProvider(Le,dt(X),ce)},registerOnTypeFormattingEditProvider(X,ce,Ie,...st){return ct.registerOnTypeFormattingEditProvider(Le,dt(X),ce,[Ie].concat(st))},registerDocumentSemanticTokensProvider(X,ce,Ie){return ct.registerDocumentSemanticTokensProvider(Le,dt(X),ce,Ie)},registerDocumentRangeSemanticTokensProvider(X,ce,Ie){return ct.registerDocumentRangeSemanticTokensProvider(Le,dt(X),ce,Ie)},registerSignatureHelpProvider(X,ce,Ie,...st){return typeof Ie=="object"?ct.registerSignatureHelpProvider(Le,dt(X),ce,Ie):ct.registerSignatureHelpProvider(Le,dt(X),ce,typeof Ie=="undefined"?[]:[Ie,...st])},registerCompletionItemProvider(X,ce,...Ie){return ct.registerCompletionItemProvider(Le,dt(X),ce,Ie)},registerInlineCompletionItemProvider(X,ce){return B.checkProposedApiEnabled(Le),ct.registerInlineCompletionsProvider(Le,dt(X),ce)},registerDocumentLinkProvider(X,ce){return ct.registerDocumentLinkProvider(Le,dt(X),ce)},registerColorProvider(X,ce){return ct.registerColorProvider(Le,dt(X),ce)},registerFoldingRangeProvider(X,ce){return ct.registerFoldingRangeProvider(Le,dt(X),ce)},registerSelectionRangeProvider(X,ce){return ct.registerSelectionRangeProvider(Le,X,ce)},registerCallHierarchyProvider(X,ce){return ct.registerCallHierarchyProvider(Le,X,ce)},setLanguageConfiguration:(X,ce)=>ct.setLanguageConfiguration(Le,X,ce),getTokenInformationAtPosition(X,ce){return B.checkProposedApiEnabled(Le),dn.tokenAtPosition(X,ce)},registerInlayHintsProvider(X,ce){return B.checkProposedApiEnabled(Le),ct.registerInlayHintsProvider(Le,X,ce)}},Ln={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return mt.activeTerminal},get terminals(){return mt.terminals},async showTextDocument(X,ce,Ie){const st=await(k.URI.isUri(X)?Promise.resolve(_n.openTextDocument(X)):Promise.resolve(X));return Ct.showTextDocument(st,ce,Ie)},createTextEditorDecorationType(X){return Ct.createTextEditorDecorationType(Le,X)},onDidChangeActiveTextEditor(X,ce,Ie){return Ct.onDidChangeActiveTextEditor(X,ce,Ie)},onDidChangeVisibleTextEditors(X,ce,Ie){return Ct.onDidChangeVisibleTextEditors(X,ce,Ie)},onDidChangeTextEditorSelection(X,ce,Ie){return Ct.onDidChangeTextEditorSelection(X,ce,Ie)},onDidChangeTextEditorOptions(X,ce,Ie){return Ct.onDidChangeTextEditorOptions(X,ce,Ie)},onDidChangeTextEditorVisibleRanges(X,ce,Ie){return Ct.onDidChangeTextEditorVisibleRanges(X,ce,Ie)},onDidChangeTextEditorViewColumn(X,ce,Ie){return Ct.onDidChangeTextEditorViewColumn(X,ce,Ie)},onDidCloseTerminal(X,ce,Ie){return mt.onDidCloseTerminal(X,ce,Ie)},onDidOpenTerminal(X,ce,Ie){return mt.onDidOpenTerminal(X,ce,Ie)},onDidChangeActiveTerminal(X,ce,Ie){return mt.onDidChangeActiveTerminal(X,ce,Ie)},onDidChangeTerminalDimensions(X,ce,Ie){return B.checkProposedApiEnabled(Le),mt.onDidChangeTerminalDimensions(X,ce,Ie)},onDidWriteTerminalData(X,ce,Ie){return B.checkProposedApiEnabled(Le),mt.onDidWriteTerminalData(X,ce,Ie)},get state(){return pt.state},onDidChangeWindowState(X,ce,Ie){return pt.onDidChangeWindowState(X,ce,Ie)},showInformationMessage(X,...ce){return cn.showMessage(Le,E.default.Info,X,ce[0],ce.slice(1))},showWarningMessage(X,...ce){return cn.showMessage(Le,E.default.Warning,X,ce[0],ce.slice(1))},showErrorMessage(X,...ce){return cn.showMessage(Le,E.default.Error,X,ce[0],ce.slice(1))},showQuickPick(X,ce,Ie){return Wt.showQuickPick(X,!!Le.enableProposedApi,ce,Ie)},showWorkspaceFolderPick(X){return Wt.showWorkspaceFolderPick(X)},showInputBox(X,ce){return Wt.showInput(X,ce)},showOpenDialog(X){return It.showOpenDialog(X)},showSaveDialog(X){return It.showSaveDialog(X)},createStatusBarItem(X,ce,Ie){let st,bt,x;return typeof X=="string"?(st=X,bt=ce,x=Ie):(bt=X,x=ce),zt.createStatusBarEntry(Le,st,bt,x)},setStatusBarMessage(X,ce){return zt.setStatusBarMessage(X,ce)},withScmProgress(X){return gt.report("window.withScmProgress",Le,"Use 'withProgress' instead."),vn.withProgress(Le,{location:M.ProgressLocation.SourceControl},(ce,Ie)=>X({report(st){}}))},withProgress(X,ce){return vn.withProgress(Le,X,ce)},createOutputChannel(X){return Zt.createOutputChannel(X)},createWebviewPanel(X,ce,Ie,st){return ln.createWebviewPanel(Le,X,ce,Ie,st)},createWebviewTextEditorInset(X,ce,Ie,st){return B.checkProposedApiEnabled(Le),rn.createWebviewEditorInset(X,ce,Ie,st,Le)},createTerminal(X,ce,Ie){return typeof X=="object"?"pty"in X?mt.createExtensionTerminal(X):mt.createTerminalFromOptions(X):mt.createTerminal(X,ce,Ie)},registerTerminalLinkProvider(X){return mt.registerLinkProvider(X)},registerTerminalProfileProvider(X,ce){return mt.registerProfileProvider(Le,X,ce)},registerTreeDataProvider(X,ce){return Kt.registerTreeDataProvider(X,ce,Le)},createTreeView(X,ce){return Kt.createTreeView(X,ce,Le)},registerWebviewPanelSerializer:(X,ce)=>ln.registerWebviewPanelSerializer(Le,X,ce),registerCustomEditorProvider:(X,ce,Ie={})=>Jt.registerCustomEditorProvider(Le,X,ce,Ie),registerFileDecorationProvider(X){return Pt.registerFileDecorationProvider(X,Le.identifier)},registerUriHandler(X){return qt.registerUriHandler(Le.identifier,X)},createQuickPick(){return Wt.createQuickPick(Le.identifier,!!Le.enableProposedApi)},createInputBox(){return Wt.createInputBox(Le.identifier)},get activeColorTheme(){return Yt.activeColorTheme},onDidChangeActiveColorTheme(X,ce,Ie){return Yt.onDidChangeActiveColorTheme(X,ce,Ie)},registerWebviewViewProvider(X,ce,Ie){return Pn.registerWebviewViewProvider(Le,X,ce,Ie==null?void 0:Ie.webviewOptions)},get activeNotebookEditor(){return B.checkProposedApiEnabled(Le),ht.activeNotebookEditor},onDidChangeActiveNotebookEditor(X,ce,Ie){return B.checkProposedApiEnabled(Le),ht.onDidChangeActiveNotebookEditor(X,ce,Ie)},get visibleNotebookEditors(){return B.checkProposedApiEnabled(Le),ht.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return B.checkProposedApiEnabled(Le),ht.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(X,ce,Ie){return B.checkProposedApiEnabled(Le),$t.onDidChangeNotebookEditorSelection(X,ce,Ie)},onDidChangeNotebookEditorVisibleRanges(X,ce,Ie){return B.checkProposedApiEnabled(Le),$t.onDidChangeNotebookEditorVisibleRanges(X,ce,Ie)},showNotebookDocument(X,ce){return B.checkProposedApiEnabled(Le),ht.showNotebookDocument(X,ce)},registerExternalUriOpener(X,ce,Ie){return B.checkProposedApiEnabled(Le),un.registerExternalUriOpener(Le.identifier,X,ce,Ie)},get openEditors(){return B.checkProposedApiEnabled(Le),Tt.tabs},get onDidChangeOpenEditors(){return B.checkProposedApiEnabled(Le),Tt.onDidChangeTabs},getInlineCompletionItemController(X){return B.checkProposedApiEnabled(Le),w.InlineCompletionController.get(X)}},_n={get rootPath(){return gt.report("workspace.rootPath",Le,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ae.getPath()},set rootPath(X){throw T.readonly()},getWorkspaceFolder(X){return ae.getWorkspaceFolder(X)},get workspaceFolders(){return ae.getWorkspaceFolders()},get name(){return ae.name},set name(X){throw T.readonly()},get workspaceFile(){return ae.workspaceFile},set workspaceFile(X){throw T.readonly()},updateWorkspaceFolders:(X,ce,...Ie)=>ae.updateWorkspaceFolders(Le,X,ce||0,...Ie),onDidChangeWorkspaceFolders:function(X,ce,Ie){return ae.onDidChangeWorkspace(X,ce,Ie)},asRelativePath:(X,ce)=>ae.getRelativePath(X,ce),findFiles:(X,ce,Ie,st)=>ae.findFiles(Z.GlobPattern.from(X),Z.GlobPattern.from(ce),Ie,Le.identifier,st),findTextInFiles:(X,ce,Ie,st)=>{let bt,x;return typeof ce=="object"?(bt=ce,x=Ie):(bt={},x=ce,st=Ie),ae.findTextInFiles(X,bt||{},x,Le.identifier,st)},saveAll:X=>ae.saveAll(X),applyEdit(X){return Ht.applyWorkspaceEdit(X)},createFileSystemWatcher:(X,ce,Ie,st)=>Mt.createFileSystemWatcher(Z.GlobPattern.from(X),ce,Ie,st),get textDocuments(){return St.getAllDocumentData().map(X=>X.document)},set textDocuments(X){throw T.readonly()},openTextDocument(X){let ce;const Ie=X;if(typeof X=="string")ce=Promise.resolve(k.URI.file(X));else if(k.URI.isUri(X))ce=Promise.resolve(X);else if(!Ie||typeof Ie=="object")ce=St.createDocumentData(Ie);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(st=>St.ensureDocumentData(st).then(bt=>bt.document))},onDidOpenTextDocument:(X,ce,Ie)=>St.onDidAddDocument(X,ce,Ie),onDidCloseTextDocument:(X,ce,Ie)=>St.onDidRemoveDocument(X,ce,Ie),onDidChangeTextDocument:(X,ce,Ie)=>St.onDidChangeDocument(X,ce,Ie),onDidSaveTextDocument:(X,ce,Ie)=>St.onDidSaveDocument(X,ce,Ie),onWillSaveTextDocument:(X,ce,Ie)=>tn.getOnWillSaveTextDocumentEvent(Le)(X,ce,Ie),get notebookDocuments(){return ht.notebookDocuments.map(X=>X.apiNotebook)},async openNotebookDocument(X,ce){let Ie;if(k.URI.isUri(X))Ie=X,await ht.openNotebookDocument(X);else if(typeof X=="string")Ie=k.URI.revive(await ht.createNotebookDocument({viewType:X,content:ce}));else throw new Error("Invalid arguments");return ht.getNotebookDocument(Ie).apiNotebook},get onDidOpenNotebookDocument(){return ht.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return ht.onDidCloseNotebookDocument},registerNotebookSerializer(X,ce,Ie,st){return ht.registerNotebookSerializer(Le,X,ce,Ie,Le.enableProposedApi?st:void 0)},registerNotebookContentProvider:(X,ce,Ie,st)=>(B.checkProposedApiEnabled(Le),ht.registerNotebookContentProvider(Le,X,ce,Ie,Le.enableProposedApi?st:void 0)),onDidChangeConfiguration:(X,ce,Ie)=>bn.onDidChangeConfiguration(X,ce,Ie),getConfiguration(X,ce){return ce=arguments.length===1?void 0:ce,bn.getConfiguration(X,ce,Le)},registerTextDocumentContentProvider(X,ce){return en.registerTextDocumentContentProvider(X,ce)},registerTaskProvider:(X,ce)=>(gt.report("window.registerTaskProvider",Le,"Use the corresponding function on the 'tasks' namespace instead"),yt.registerTaskProvider(Le,X,ce)),registerFileSystemProvider(X,ce,Ie){return sn.registerFileSystemProvider(Le.identifier,X,ce,Ie,Le.enableProposedApi)},get fs(){return ve.value},registerFileSearchProvider:(X,ce)=>(B.checkProposedApiEnabled(Le),Ft.registerFileSearchProvider(X,ce)),registerTextSearchProvider:(X,ce)=>(B.checkProposedApiEnabled(Le),Ft.registerTextSearchProvider(X,ce)),registerRemoteAuthorityResolver:(X,ce)=>(B.checkProposedApiEnabled(Le),ye.registerRemoteAuthorityResolver(X,ce)),registerResourceLabelFormatter:X=>(B.checkProposedApiEnabled(Le),on.$registerResourceLabelFormatter(X)),onDidCreateFiles:(X,ce,Ie)=>Mt.onDidCreateFile(X,ce,Ie),onDidDeleteFiles:(X,ce,Ie)=>Mt.onDidDeleteFile(X,ce,Ie),onDidRenameFiles:(X,ce,Ie)=>Mt.onDidRenameFile(X,ce,Ie),onWillCreateFiles:(X,ce,Ie)=>Mt.getOnWillCreateFileEvent(Le)(X,ce,Ie),onWillDeleteFiles:(X,ce,Ie)=>Mt.getOnWillDeleteFileEvent(Le)(X,ce,Ie),onWillRenameFiles:(X,ce,Ie)=>Mt.getOnWillRenameFileEvent(Le)(X,ce,Ie),openTunnel:X=>(B.checkProposedApiEnabled(Le),vt.openTunnel(Le,X).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return B.checkProposedApiEnabled(Le),vt.getTunnels()},onDidChangeTunnels:(X,ce,Ie)=>(B.checkProposedApiEnabled(Le),vt.onDidChangeTunnels(X,ce,Ie)),registerPortAttributesProvider:(X,ce)=>(B.checkProposedApiEnabled(Le),vt.registerPortsAttributesProvider(X,ce)),registerTimelineProvider:(X,ce)=>(B.checkProposedApiEnabled(Le),In.registerTimelineProvider(X,ce,Le.identifier,ut.converter)),get isTrusted(){return ae.trusted},requestWorkspaceTrust:X=>(B.checkProposedApiEnabled(Le),ae.requestWorkspaceTrust(X)),onDidGrantWorkspaceTrust:(X,ce,Ie)=>ae.onDidGrantWorkspaceTrust(X,ce,Ie)},En={get inputBox(){return gt.report("scm.inputBox",Le,"Use 'SourceControl.inputBox' instead"),pn.getLastInputBox(Le)},createSourceControl(X,ce,Ie){return pn.createSourceControl(Le,X,ce,Ie)}},yn={createCommentController(X,ce){return kn.createCommentController(Le,X,ce)}},Bt={get activeDebugSession(){return _t.activeDebugSession},get activeDebugConsole(){return _t.activeDebugConsole},get breakpoints(){return _t.breakpoints},onDidStartDebugSession(X,ce,Ie){return _t.onDidStartDebugSession(X,ce,Ie)},onDidTerminateDebugSession(X,ce,Ie){return _t.onDidTerminateDebugSession(X,ce,Ie)},onDidChangeActiveDebugSession(X,ce,Ie){return _t.onDidChangeActiveDebugSession(X,ce,Ie)},onDidReceiveDebugSessionCustomEvent(X,ce,Ie){return _t.onDidReceiveDebugSessionCustomEvent(X,ce,Ie)},onDidChangeBreakpoints(X,ce,Ie){return _t.onDidChangeBreakpoints(X,ce,Ie)},registerDebugConfigurationProvider(X,ce,Ie){return _t.registerDebugConfigurationProvider(X,ce,Ie||M.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(X,ce){return _t.registerDebugAdapterDescriptorFactory(Le,X,ce)},registerDebugAdapterTrackerFactory(X,ce){return _t.registerDebugAdapterTrackerFactory(X,ce)},startDebugging(X,ce,Ie){return!Ie||typeof Ie=="object"&&"configuration"in Ie?_t.startDebugging(X,ce,{parentSession:Ie}):_t.startDebugging(X,ce,Ie||{})},stopDebugging(X){return _t.stopDebugging(X)},addBreakpoints(X){return _t.addBreakpoints(X)},removeBreakpoints(X){return _t.removeBreakpoints(X)},asDebugSourceUri(X,ce){return _t.asDebugSourceUri(X,ce)}},Vt={registerTaskProvider:(X,ce)=>yt.registerTaskProvider(Le,X,ce),fetchTasks:X=>yt.fetchTasks(X),executeTask:X=>yt.executeTask(Le,X),get taskExecutions(){return yt.taskExecutions},onDidStartTask:(X,ce,Ie)=>yt.onDidStartTask(X,ce,Ie),onDidEndTask:(X,ce,Ie)=>yt.onDidEndTask(X,ce,Ie),onDidStartTaskProcess:(X,ce,Ie)=>yt.onDidStartTaskProcess(X,ce,Ie),onDidEndTaskProcess:(X,ce,Ie)=>yt.onDidEndTaskProcess(X,ce,Ie)},Nn={createNotebookController(X,ce,Ie,st,bt){return Cn.createNotebookController(Le,X,ce,Ie,st,Le.enableProposedApi?bt:void 0)},registerNotebookCellStatusBarItemProvider:(X,ce)=>ht.registerNotebookCellStatusBarItemProvider(Le,X,ce),get onDidSaveNotebookDocument(){return B.checkProposedApiEnabled(Le),Gt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(X){return B.checkProposedApiEnabled(Le),$t.createNotebookEditorDecorationType(X)},createRendererMessaging(X){return B.checkProposedApiEnabled(Le),nn.createRendererMessaging(X)},onDidChangeNotebookDocumentMetadata(X,ce,Ie){return B.checkProposedApiEnabled(Le),Gt.onDidChangeNotebookDocumentMetadata(X,ce,Ie)},onDidChangeNotebookCells(X,ce,Ie){return B.checkProposedApiEnabled(Le),ht.onDidChangeNotebookCells(X,ce,Ie)},onDidChangeNotebookCellExecutionState(X,ce,Ie){return B.checkProposedApiEnabled(Le),ht.onDidChangeNotebookCellExecutionState(X,ce,Ie)},onDidChangeCellOutputs(X,ce,Ie){return B.checkProposedApiEnabled(Le),ht.onDidChangeCellOutputs(X,ce,Ie)},onDidChangeCellMetadata(X,ce,Ie){return B.checkProposedApiEnabled(Le),ht.onDidChangeCellMetadata(X,ce,Ie)},createConcatTextDocument(X,ce){return B.checkProposedApiEnabled(Le),new Ge.ExtHostNotebookConcatDocument(ht,St,X,ce)}};return{version:Je.version,authentication:Tn,commands:Rn,comments:yn,debug:Bt,env:Xt,extensions:Fn,languages:Mn,notebooks:Nn,scm:En,tasks:Vt,test:fn,window:Ln,workspace:_n,Breakpoint:M.Breakpoint,CallHierarchyIncomingCall:M.CallHierarchyIncomingCall,CallHierarchyItem:M.CallHierarchyItem,CallHierarchyOutgoingCall:M.CallHierarchyOutgoingCall,CancellationError:T.CancellationError,CancellationTokenSource:g.CancellationTokenSource,CandidatePortSource:o.CandidatePortSource,CodeAction:M.CodeAction,CodeActionKind:M.CodeActionKind,CodeActionTriggerKind:M.CodeActionTriggerKind,CodeLens:M.CodeLens,Color:M.Color,ColorInformation:M.ColorInformation,ColorPresentation:M.ColorPresentation,ColorThemeKind:M.ColorThemeKind,CommentMode:M.CommentMode,CommentThreadCollapsibleState:M.CommentThreadCollapsibleState,CompletionItem:M.CompletionItem,CompletionItemKind:M.CompletionItemKind,CompletionItemTag:M.CompletionItemTag,CompletionList:M.CompletionList,CompletionTriggerKind:M.CompletionTriggerKind,ConfigurationTarget:M.ConfigurationTarget,CustomExecution:M.CustomExecution,DebugAdapterExecutable:M.DebugAdapterExecutable,DebugAdapterInlineImplementation:M.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:M.DebugAdapterNamedPipeServer,DebugAdapterServer:M.DebugAdapterServer,DebugConfigurationProviderTriggerKind:M.DebugConfigurationProviderTriggerKind,DebugConsoleMode:M.DebugConsoleMode,DecorationRangeBehavior:M.DecorationRangeBehavior,Diagnostic:M.Diagnostic,DiagnosticRelatedInformation:M.DiagnosticRelatedInformation,DiagnosticSeverity:M.DiagnosticSeverity,DiagnosticTag:M.DiagnosticTag,Disposable:M.Disposable,DocumentHighlight:M.DocumentHighlight,DocumentHighlightKind:M.DocumentHighlightKind,DocumentLink:M.DocumentLink,DocumentSymbol:M.DocumentSymbol,EndOfLine:M.EndOfLine,EnvironmentVariableMutatorType:M.EnvironmentVariableMutatorType,EvaluatableExpression:M.EvaluatableExpression,InlineValueText:M.InlineValueText,InlineValueVariableLookup:M.InlineValueVariableLookup,InlineValueEvaluatableExpression:M.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:M.InlineCompletionTriggerKind,EventEmitter:S.Emitter,ExtensionKind:M.ExtensionKind,ExtensionMode:M.ExtensionMode,ExternalUriOpenerPriority:M.ExternalUriOpenerPriority,FileChangeType:M.FileChangeType,FileDecoration:M.FileDecoration,FileSystemError:M.FileSystemError,FileType:I.FileType,FilePermission:I.FilePermission,FoldingRange:M.FoldingRange,FoldingRangeKind:M.FoldingRangeKind,FunctionBreakpoint:M.FunctionBreakpoint,InlineCompletionItem:M.InlineSuggestion,InlineCompletionList:M.InlineSuggestions,Hover:M.Hover,IndentAction:C.IndentAction,Location:M.Location,MarkdownString:M.MarkdownString,OverviewRulerLane:_.OverviewRulerLane,ParameterInformation:M.ParameterInformation,PortAutoForwardAction:M.PortAutoForwardAction,Position:M.Position,ProcessExecution:M.ProcessExecution,ProgressLocation:M.ProgressLocation,QuickInputButtons:M.QuickInputButtons,Range:M.Range,RelativePattern:M.RelativePattern,Selection:M.Selection,SelectionRange:M.SelectionRange,SemanticTokens:M.SemanticTokens,SemanticTokensBuilder:M.SemanticTokensBuilder,SemanticTokensEdit:M.SemanticTokensEdit,SemanticTokensEdits:M.SemanticTokensEdits,SemanticTokensLegend:M.SemanticTokensLegend,ShellExecution:M.ShellExecution,ShellQuoting:M.ShellQuoting,SignatureHelp:M.SignatureHelp,SignatureHelpTriggerKind:M.SignatureHelpTriggerKind,SignatureInformation:M.SignatureInformation,SnippetString:M.SnippetString,SourceBreakpoint:M.SourceBreakpoint,StandardTokenType:M.StandardTokenType,StatusBarAlignment:M.StatusBarAlignment,SymbolInformation:M.SymbolInformation,SymbolKind:M.SymbolKind,SymbolTag:M.SymbolTag,Task:M.Task,TaskGroup:M.TaskGroup,TaskPanelKind:M.TaskPanelKind,TaskRevealKind:M.TaskRevealKind,TaskScope:M.TaskScope,TerminalLink:M.TerminalLink,TerminalProfile:M.TerminalProfile,TextDocumentSaveReason:M.TextDocumentSaveReason,TextEdit:M.TextEdit,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:M.TextEditorLineNumbersStyle,TextEditorRevealType:M.TextEditorRevealType,TextEditorSelectionChangeKind:M.TextEditorSelectionChangeKind,ThemeColor:M.ThemeColor,ThemeIcon:M.ThemeIcon,TreeItem:M.TreeItem,TreeItemCollapsibleState:M.TreeItemCollapsibleState,UIKind:o.UIKind,Uri:k.URI,ViewColumn:M.ViewColumn,WorkspaceEdit:M.WorkspaceEdit,InlayHint:M.InlayHint,InlayHintKind:M.InlayHintKind,RemoteAuthorityResolverError:M.RemoteAuthorityResolverError,ResolvedAuthority:M.ResolvedAuthority,SourceControlInputBoxValidationType:M.SourceControlInputBoxValidationType,ExtensionRuntime:M.ExtensionRuntime,TimelineItem:M.TimelineItem,NotebookRange:M.NotebookRange,NotebookCellKind:M.NotebookCellKind,NotebookCellExecutionState:M.NotebookCellExecutionState,NotebookCellData:M.NotebookCellData,NotebookData:M.NotebookData,NotebookRendererScript:M.NotebookRendererScript,NotebookCellStatusBarAlignment:M.NotebookCellStatusBarAlignment,NotebookEditorRevealType:M.NotebookEditorRevealType,NotebookCellOutput:M.NotebookCellOutput,NotebookCellOutputItem:M.NotebookCellOutputItem,NotebookCellStatusBarItem:M.NotebookCellStatusBarItem,NotebookControllerAffinity:M.NotebookControllerAffinity,PortAttributes:M.PortAttributes,LinkedEditingRanges:M.LinkedEditingRanges,TestItemStatus:M.TestItemStatus,TestResultState:M.TestResultState,TestMessage:M.TestMessage,TextSearchCompleteMessageType:le.TextSearchCompleteMessageType,TestMessageSeverity:M.TestMessageSeverity,WorkspaceTrustState:M.WorkspaceTrustState}}}e.createApiFactoryAndRegisterActors=rt}),define(we[219],_e([0,1,57,101,30,100,32,71,36,37,104,105,106,74,73,65,70,102,72,46,69,94,63]),function(ee,e,g,T,S,E,k,D,_,C,n,I,o,h,c,d,y,b,p,l,f,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),g.registerSingleton(h.IExtensionStoragePaths,h.ExtensionStoragePaths),g.registerSingleton(y.IExtHostApiDeprecationService,y.ExtHostApiDeprecationService),g.registerSingleton(D.IExtHostCommands,D.ExtHostCommands),g.registerSingleton(k.IExtHostConfiguration,k.ExtHostConfiguration),g.registerSingleton(p.IExtHostConsumerFileSystem,p.ExtHostConsumerFileSystem),g.registerSingleton(I.IExtHostDebugService,I.WorkerExtHostDebugService),g.registerSingleton(E.IExtHostDecorations,E.ExtHostDecorations),g.registerSingleton(_.IExtHostDocumentsAndEditors,_.ExtHostDocumentsAndEditors),g.registerSingleton(l.IExtHostFileSystemInfo,l.ExtHostFileSystemInfo),g.registerSingleton(T.IExtHostOutputService,T.ExtHostOutputService),g.registerSingleton(o.IExtHostSearch,o.ExtHostSearch),g.registerSingleton(c.IExtHostStorage,c.ExtHostStorage),g.registerSingleton(n.IExtHostTask,n.WorkerExtHostTask),g.registerSingleton(C.IExtHostTerminalService,C.WorkerExtHostTerminalService),g.registerSingleton(d.IExtHostTunnelService,d.ExtHostTunnelService),g.registerSingleton(b.IExtHostWindow,b.ExtHostWindow),g.registerSingleton(S.IExtHostWorkspace,S.ExtHostWorkspace),g.registerSingleton(f.IExtHostSecretState,f.ExtHostSecretState),g.registerSingleton(m.IExtHostTelemetry,m.ExtHostTelemetry),g.registerSingleton(t.IExtHostEditorTabs,t.ExtHostEditorTabs)}),define(we[220],_e([0,1,218,33,214,6,12,5]),function(ee,e,g,T,S,E,k,D){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var C;(function(c){var d;const y=(d=self.trustedTypes)===null||d===void 0?void 0:d.createPolicy("TrustedFunctionWorkaround",{createScript:(p,...l)=>{l.forEach(r=>{var s;if(!((s=self.trustedTypes)===null||s===void 0?void 0:s.isScript(r)))throw new Error("TrustedScripts only, please")});const f=l.slice(0,-1).join(","),m=l.pop().toString();return`(function anonymous(${f}) {
${m}
})`}});function b(...p){return y?self.eval(y.createScript("",...p)):new Function(...p)}c.create=b})(C||(C={}));class n extends S.RequireInterceptor{_installInterceptor(){}getModule(d,y){for(let b of this._alternatives){let p=b(d);if(p){d=p;break}}if(this._factories.has(d))return this._factories.get(d).load(d,y,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class I extends T.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=E.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const d=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);h(d,this._initData.environment.isExtensionDevelopmentDebug);const y=this._instaService.invokeFunction(g.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(n,y,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(d){return d.browser}async _loadCommonJSModule(d,y,b){var p,l,f,m,t,r,s,i;y=y.with({path:o(y.path,".js")}),d&&performance.mark(`code/extHost/willFetchExtensionCode/${d.value}`);const u=await fetch(y.toString(!0));if(d&&performance.mark(`code/extHost/didFetchExtensionCode/${d.value}`),u.status!==200)throw new Error(u.statusText);const w=await u.text(),v=`${y.toString(!0)}#vscode-extension`,P=`${w}
//# sourceURL=${v}`;let A;try{A=C.create((l=(p=I._ttpExtensionScripts)===null||p===void 0?void 0:p.createScript("module"))!==null&&l!==void 0?l:"module",(m=(f=I._ttpExtensionScripts)===null||f===void 0?void 0:f.createScript("exports"))!==null&&m!==void 0?m:"exports",(r=(t=I._ttpExtensionScripts)===null||t===void 0?void 0:t.createScript("require"))!==null&&r!==void 0?r:"require",(i=(s=I._ttpExtensionScripts)===null||s===void 0?void 0:s.createScript(P))!==null&&i!==void 0?i:P)}catch(H){throw console.error(d?`Loading code for extension ${d.value} failed: ${H.message}`:`Loading code failed: ${H.message}`),console.error(`${y.toString(!0)}${typeof H.line=="number"?` line ${H.line}`:""}${typeof H.column=="number"?` column ${H.column}`:""}`),console.error(H),H}const a={},R={exports:a},L=H=>{const ue=this._fakeModules.getModule(H,y);if(ue===void 0)throw new Error(`Cannot load module '${H}'`);return ue};try{return b.codeLoadingStart(),d&&performance.mark(`code/extHost/willLoadExtensionCode/${d.value}`),A(R,a,L),R.exports!==a?R.exports:a}finally{d&&performance.mark(`code/extHost/didLoadExtensionCode/${d.value}`),b.codeLoadingStop()}}async $setRemoteEnvironment(d){throw new Error("Not supported")}async _waitForDebuggerAttachment(d=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const y=Date.now()+d;for(;Date.now()<y&&!("__jsDebugIsReady"in globalThis);)await k.timeout(10)}}e.ExtHostExtensionService=I,I._ttpExtensionScripts=(_=self.trustedTypes)===null||_===void 0?void 0:_.createPolicy("ExtensionScripts",{createScript:c=>c});function o(c,d){return c.endsWith(d)?c:c+d}function h(c,d){y("info","log"),y("log","log"),y("warn","warn"),y("error","error");function y(l,f){const m=console[l];console[l]=function(){c.$logExtensionHostMessage({type:"__$console",severity:f,arguments:p(arguments)}),d&&m.apply(console,arguments)}}const b=1e5;function p(l){const f=[],m=[];if(l.length)for(let t=0;t<l.length;t++){if(typeof l[t]=="undefined")l[t]="undefined";else if(l[t]instanceof Error){const r=l[t];r.stack?l[t]=r.stack:l[t]=r.toString()}m.push(l[t])}try{const t=JSON.stringify(m,function(r,s){if(s&&typeof s=="object"){if(f.indexOf(s)!==-1)return"[Circular]";f.push(s)}return s});return t.length>b?"Output omitted for a large object that exceeds the limits":t}catch(t){return`Output omitted for an object that cannot be inspected ('${t.toString()}')`}}}}),define(we[221],_e([0,1,57,15,33,220,206]),function(ee,e,g,T,S,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),g.registerSingleton(S.IExtHostExtensionService,E.ExtHostExtensionService),g.registerSingleton(T.ILogService,k.ExtHostLogService)}),define(we[223],_e([0,1,23,3,175,215,208,14,75,219,221]),function(ee,e,g,T,S,E,k,D,_){"use strict";var C;Object.defineProperty(e,"__esModule",{value:!0});const n=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const I=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const y=(C=self.trustedTypes)===null||C===void 0?void 0:C.createPolicy("extensionHostWorker",{createScriptURL:p=>p}),b=self.Worker;Worker=function(p,l){const f=`importScripts('${p}');`;l=l||{},l.name=l.name||D.basename(p.toString());const m=new Blob([f],{type:"application/javascript"}),t=URL.createObjectURL(m);return new b(y?y.createScriptURL(t):t,l)}}else self.Worker=class extends k.NestedWorker{constructor(y,b){super(I,y,Object.assign({name:D.basename(y.toString())},b))}};const o=new class{exit(y){n()}async exists(y){return!0}async realpath(y){return y}};class h{constructor(){const b=new MessageChannel,p=new T.Emitter;let l=!1;I(b.port2,[b.port2]),b.port1.onmessage=f=>{const{data:m}=f;if(!(m instanceof ArrayBuffer)){console.warn("UNKNOWN data received",m);return}const t=g.VSBuffer.wrap(new Uint8Array(m,0,m.byteLength));if(S.isMessageOfType(t,2)){l=!0,d("received terminate message from renderer");return}p.fire(t)},this.protocol={onMessage:p.event,send:f=>{if(!l){const m=f.buffer.buffer.slice(f.buffer.byteOffset,f.buffer.byteOffset+f.buffer.byteLength);b.port1.postMessage(m,[m])}}}}}function c(y){return new Promise(b=>{const p=y.onMessage(l=>{p.dispose();const f=JSON.parse(l.toString());y.send(S.createMessageOfType(0)),b({protocol:y,initData:f})});y.send(S.createMessageOfType(1))})}let d=y=>n();(function(){const b=new h;_.mark("code/extHost/willConnectToRenderer"),c(b.protocol).then(p=>{_.mark("code/extHost/didWaitForInitData");const l=new E.ExtensionHostMain(p.protocol,p.initData,o,null);d=f=>l.terminate(f)})})()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/3e0c442a8ee9fdc037d627d70fe291f72af04cfd/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
